import request from '@/utils/request'
import { systemPrefix } from '@/settings'

/**
 * 分页查询
 * @param {*} data 
 * @returns 
 */
export function queryPage (data) {

  return request({
    url: `${systemPrefix}/sys/ruledef/queryPageList`,
    method: 'post',
    data: data,
    requestType: 'json',
  })
}

/**
 * 根据no 查询规则信息
 * @param {} data 
 * @returns 
 */
export function queryRuleByNo (data) {
  return request({
    url: `${systemPrefix}/sys/ruledef/queryRuleByNo`,
    method: 'post',
    data: data
  })
}

/**
 * 规则删除处理
 * @param {*} data 
 */
export function removeRule (data) {

  return request({
    url: `${systemPrefix}/sys/ruledef/deleteByNo`,
    method: 'post',
    data: data
  })
}

/**
 * 更新规则信息
 * @param {*} data 
 */
export function updateRuleDef (data) {

  return request({
    url: `${systemPrefix}/sys/ruledef/update`,
    method: 'post',
    data: data,
    requestType: 'json',
  })
}

/**
 * 添加规则信息
 * @param {*} data 
 */
export function addRuleDef (data) {

  return request({
    url: `${systemPrefix}/sys/ruledef/insert`,
    method: 'post',
    data: data,
    requestType: 'json',
  })
}