import { BasicLayout, RouteView } from '@/layouts'
import { Router } from './types'

export const example: Router = {
    path: '/zp',
    name: 'index',
    component: BasicLayout,
    meta: { title: 'menu.home' },
    children: [
        {   //系统
            path: '/zp/automake/system',
            name: 'system',
            meta: { title: 'menu.system.title' },
            children: [
                {   //用户管理
                    path: '/zp/automake/system/loginedlog',
                    name: 'systemloginedlog',
                    meta: { title: 'menu.system.loginedlog.title' },
                    children: [
                        {   //用户日志查询
                            path: '/zp/automake/system/loginedlog/userOptLog1',
                            name: 'userOptLog1',
                            component: () => import('@/views/test/index.vue'),
                            meta: { title: 'menu.system.loginedlog.userOptLog1.title' },
                        },
                        {
                            // 在线用户查询
                            path: '/zp/automake/system/loginedlog/onlineUser',
                            name: 'onlineUser',
                            component: () => import('@/views/onlineUser/onlineUserView.vue'),
                            meta: { title: 'menu.system.loginedlog.onlineUser.title' },
                        }
                    ]
                },
                {   //参数管理
                    path: '/zp/automake/system/zzmanage',
                    name: 'systemzzmanage',
                    meta: { title: 'menu.system.zzmanage.title' },
                    children: [
                        {   //机构层级管理
                            path: '/zp/automake/system/zzmanage/departLevel',
                            name: 'departLevel',
                            component: () => import('@/views/depart/departLevel.vue'),
                            meta: { title: 'menu.system.zzmanage.departLevel.title' },
                        },
                        {   //机构层级管理2
                            path: '/zp/automake/system/zzmanage/DepartLevelDef',
                            name: 'departLevelDef',
                            component: () => import('@/views/depart/departLevel/DepartLevelDef.vue'),
                            meta: { title: 'menu.system.zzmanage.departLevelDef.title' },
                        },
                        {   //测试
                            path: '/zp/automake/system/zzmanage/Test',
                            name: 'testVue',
                            component: () => import('@/views/depart/departLevel/Test.vue'),
                            meta: { title: 'menu.system.zzmanage.testVue.title' },
                        },
                        // {   //业务状况表
                        //     path: '/zp/automake/system/zzmanage/YwzkbReport',
                        //     name: 'testVue',
                        //     component: () => import('@/views/depart/departLevel/YwzkbReport.vue'),
                        //     meta: { title: 'menu.system.zzmanage.ywzkbReport.title' },
                        // },
                        // {   //测试下拉树组件
                        //     path: '/zp/automake/system/zzmanage/TestProSelectTree',
                        //     name: 'testVue',
                        //     component: () => import('@/views/depart/departLevel/TestProSelectTree.vue'),
                        //     meta: { title: 'menu.system.zzmanage.testProSelectTree.title' },
                        // },
                        // {   //测试树组件
                        //     path: '/zp/automake/system/zzmanage/TestProTree3',
                        //     name: 'testVue',
                        //     component: () => import('@/views/depart/departLevel/TestProTree3.vue'),
                        //     meta: { title: 'menu.system.zzmanage.testProTree3.title' },
                        // },
                        {   //测试下拉树组件
                            path: '/zp/automake/system/zzmanage/TestProSelectTree3',
                            name: 'testProSelectTree3',
                            component: () => import('@/views/depart/departLevel/TestProSelectTree3.vue'),
                            meta: { title: 'menu.system.zzmanage.testProSelectTree3.title' },
                        }
                        // {   //币种维护
                        //     path: '/zp/automake/system/zzmanage/CurrencyManager',
                        //     name: 'currencyManager',
                        //     component: () => import('@/views/currencyManager/CurrencyManagerView.vue'),
                        //     meta: { title: 'menu.system.zzmanage.currencyManager.title' },
                        // }
                    ]
                }

            ]
        },
        {   //流程管理
            path: '/zp/workflow',
            name: 'workflow',
            meta: { title: 'menu.workflow.title' },
            children: [
                {   //分支流程管理
                    path: '/zp/workflow/page/mole',
                    name: 'mole',
                    meta: { title: 'menu.workflow.mole.title' },
                    children: [
                        {   //分支节点设置
                            path: '/zp/workflow/page/mole/node/moleNodeMain',
                            name: 'node',
                            // component: () => import('@/views/test/index.vue'),
                            meta: { title: 'menu.workflow.mole.moleNodeMain.title' },
                        }
                    ]
                },
            ]
        },
        {   //常用业务
            path: '/zp/automake/zzmanage',
            name: 'zzmanage',
            component: RouteView,
            meta: { title: 'menu.zzmanage.title' },
            children: [
                {   //科目管理
                    path: '/zp/automake/zzmanage/comitem_manager',
                    name: 'comitem_manager',
                    component: RouteView,
                    meta: { title: 'menu.zzmanage.comitem_manager.title' },
                    children: [
                        {   //科目维护
                            path: '/zp/automake/zzmanage/comitem_manager/comItemList',
                            name: 'comItemList',
                            // component: () => import('@/views/test/index.vue'),
                            meta: { title: 'menu.zzmanage.comitem_manager.comItemList.title' },
                        }
                    ]
                },
            ]
        },
        {   //报表合并
            path: '/zp/automake/bbhb',
            name: 'bbhb',
            component: RouteView,
            meta: { title: 'menu.bbhb.title' },
            children: [
                {   //报表合并参数维护
                    path: '/zp/automake/bbhb/bbhbcswh',
                    name: 'bbhbcswh',
                    component: RouteView,
                    meta: { title: 'menu.bbhb.bbhbcswh.title' },
                    children: [
                        {   //法人信息
                            path: '/zp/automake/bbhb/bbhbcswh/bbhb_01_01_01',
                            name: 'bbhb_01_01_01',
                            // component: () => import('@/views/test/index.vue'),
                            meta: { title: 'menu.bbhb.bbhbcswh.bbhb_01_01_01.title' },
                        }
                    ]
                },
                {   //报表查询
                    path: '/zp/automake/bbhb/bbcx',
                    name: 'bbcx',
                    component: RouteView,
                    meta: { title: 'menu.bbhb.bbcx.title' },
                    children: [
                        {   //报表查询
                            path: '/zp/automake/bbhb/bbcx/bbhb_03_01',
                            name: 'bbhb_03_01',
                            // component: () => import('@/views/test/index.vue'),
                            meta: { title: 'menu.bbhb.bbcx.bbhb_03_01.title' },
                        }
                    ]
                },
            ]
        },
        {   //组件测试
            path: '/zp/example',
            name: 'example',
            component: RouteView,
            meta: { title: 'menu.example.title' },
            children: [
                {   //日期选择器
                    path: '/zp/example/ProDatePickerExample',
                    name: 'proDatePickerExample',
                    component: () => import('@/views/example/ProDatePickerExample.vue'),
                    meta: { title: 'menu.example.proDatePickerExample.title' },
                }
            ]
        }
        ,
        {   //柜面
            path: '/zp/T2000',
            name: 't2000',
            component: RouteView,
            meta: { title: 'menu.t2000.title' },
            children: [
                {   //对私开户
                    path: '/zp/t2000/T2000',
                    name: 't2000',
                    component: () => import('@/views/front/t2000/T2000.vue'),
                    meta: { title: 'menu.t2000.t2000.title' },
                },
                {   //子账户开户
                    path: '/zp/t2001/T2001',
                    name: 't2001',
                    component: () => import('@/views/front/t2001/T2001.vue'),
                    meta: { title: 'menu.t2001.t2001.title' },
                }
                ,
                {   //授权查询
                    path: '/zp/t9042/T9042',
                    name: 't9042',
                    component: () => import('@/views/front/T9042/T9042.vue'),
                    meta: { title: 'menu.t9042.t9042.title' },
                }
            ]
        }
    ]
}
