// 文件编号生成前缀
export const FileTracePrefix = 'FT'
// 页面流水号
export const PageTraceNoPrefix = "PG"
//工作流常量标识
export const FlowConstant = {
    ADD_TASK_PREFIX: 'UserTaskAdd_',
    TASK_TYPE: {
        startEvent: 'startEvent',
        sequenceFlow: 'sequenceFlow',
        userTask: 'userTask',
    },
    IsInput: {//工作流 节点标识
        APPLY: 1,//申请
        REVISE: 2,//修改
        APPROVE: 3,//审批
        ACCOUNT: 4,//记账
    },
    FLOWABLE_SUBMITTYPE: {//处理方案
        DEAL: "1" //办理
    },
    FLOWABLE_COMMENTS: {
        AGREE: "0",//同意
        DISAGREE: "1",//不同意
        RETURN_INITIATOR: "3"//退回发起人
    },
    FLOWABLE_COMMENTS_OPTIONS: [
        { label: "同意", value: "0" },
        { label: "不同意", value: "1" },
        { label: "退回到发起人", value: "3" }
    ],
    WORK_PLATFORM: {
        PATH: '/flowable/workbench',
        NAME: 'workbench',
        IS_TO_WORKPLATFORM: true,
        META: { title: '工作台', affix: true, order: 2, workflowPanel: true },
        ORDER: 2,
    },
    YwApplyRegSts: {
        UNFINISHED: { label: '未办结', value: 'unfinish' },
        APPOVEPASS: { label: '已终止', value: '!' },
        DELETE: { label: "已作废", value: "**" },
        DROP: { label: "已撤销", value: "*" },
        // END: {label: "已终止", value: "!!" },
        FINISHED: { label: "已办结", value: "%" }
    },
    FLOWABLE_APPROVE_TYPE: {
        TYPE_PASS: { value: 1, comment: '0', name: '通过' },
        TYPE_NOT_PASS: { vlaue: 1, comment: '1', name: '不通过' },
        TYPE_ASSIGN: { value: 2, name: '转办' },
        TYPE_special: { value: 3, name: '特事特办' },
        TYPE_LASTNODE_ROLLBACK: { value: 4, comment: '2', name: '退回上一节点' },
        TYPE_STARTNODE_ROLLBACK: { value: 4, comment: '3', name: '退回到发起人' },
        TYPE_APPOINT_ROLLBACK: { value: 4, comment: '4', name: ' 退回到指定节点' },
        TYPE_SKIP_APPOINT_ROLLBACK: { value: 4, comment: '5', name: '跳转到指定节点' },
        TYPE_INVALID: { value: 5, name: '作废' },
        TYPE_ADD_MULITINSTANCE: { value: 6, name: '加签' },
        TYPE_DELETE_MULITINSTANCE: { value: 7, name: '减签' },
        TYPE_VOTE: { value: 8, name: '否决', },
    },
    TASK_STATUS: {
        '1': '正在执行',
        '2': '已执行',
        '0': '未执行',
    },
    NEED_OPTION: {
        // 是否需要前一节点操作 - 需要-多分支上一节点选择线
        NEED_TYPE_D1: 1,
        // 是否需要前一节点操作 - 需要-无分配人上一节点选择人
        NEED_TYPE_D2: 2,
        // 是否需要前一节点操作 - 需要-有分配人上一节点选择人
        NEED_TYPE_D3: 3,
    },
    APPROVAL_TYPE: {
        APPROVAL_TYPE_FINISH: '1',
        //退回上一节点
        APPROVAL_TYPE_ROLLBACK: '2',
        // 退回发起人
        APPROVAL_TYPE_TO_FIRST: '3',
        // 退回指定节点
        APPROVAL_TYPE_BACK_NODE: '4',
        //跳转到指定节点
        APPROVAL_TYPE_TO_NODE: '5',
        // 自动完成
        APPROVAL_TYPE_AUTO_FINISH: '6',
        APPROVAL_TYPE_AUTO_JUMP: '7',
        APPROVAL_TYPE_VETO: '8',
        APPROVAL_TYPE_GREEN_FINISH: '9',
        APPROVAL_TYPE_REFUSE: '10',
        APPROVAL_TYPE_CANCEL: '11',
        // 加签
        APPROVAL_TYPE_ADDSIGN: '12',
        // 补单
        APPROVAL_TYPE_REPLENISH: '13',
        // 撤回
        APPROVAL_TYPE_REVOKE: '14'
    },
    WORKFLOW_TYPE:[{
        text : '工作流',
        value: 'workflow'
    },{
        text: '审批流',
        value: 'approval'
    },{
        text: '子流程',
        value: 'approvePart'
    }]
}

export const ComConstant = {

    Y: 'Y',
    N: 'N',
    SUCCESS_CODE: '0000',
    RETURN_CODE_KEY: 'return_code',
    RETURN_MSG_KEY: 'return_msg',
    SYS_CODE: 'stkm',
    PAGE_SIZE: '15',
    HOME_PAGE_COUNT: '5',
    DEFAULT_CODE: 'UTF-8',
    TREE_ROOT_NO: 'AAAAAA',
    DEFAULT_RELATION_NO: 'AAAAAA',
    DEFAULT_UP_BR_NO: 'AAAAAA',
    MENU_ROOT_NO: 'CW00000',
    PATH: 'dhcc',
    TELLER: 'teller',
    CORE_TELLER: 'coreTeller',
    IMITATION_FLAG: 'Y',
    RURAL_BANK: 'BANK_05_04',

    InputType: {
        TEB: '1',
        DATE_TYPE: '2',
        SYSTEM_BOX: '3',
        CURRENCY: '4',
        CDDB: '6',
        CCTCDD: '7',
        DEPARTMENT_TYPE: '8',
        DEPARTMENT_TYPE1: '9',
        DEPARTMENT_TYPE2: '10'
    },
    StockPeople: {
        FIRST: '1', //质权人类型为自然人
        TWO:'2'//法人
    },
    STOCKSpecType: {
        TYPE: '3',
        //已质押完成状态 1
        TRANSTS: '1'
    },
    FuncType: {
        DATE_TYPE: '1',
        CURRENCY: '2',
        PRODUCT: '3',
        NDI: '4',
        FPT: '5',
        CHARACTER_STRING: '6',
        DEPTNO: '7',
        AS_A_LEGAL_PERSON: '8',
        FQS: '10'
    },

    IdType: {
        SFZ: '101', //居民身份证
        LSSFZ: '102', //临时居民身份证
        DLWLTWTXZ: '103', //大陆居民往来台湾通行证
        DLWLGATXZ: '104', //大陆居民往来港澳通行证
        CMWYHZM: '105', //村民委员会证明
        JSZ: '106', //驾驶证
        DYDSFZ: '107', //第一代居民身份证
        HKB: '110', //户口簿
        JRSFZ: '120', //军人身份证件
        JFJSBZ: '121', //解放军士兵证
        JUNGZ: '122', //军官证
        JFJWZGBZ: '123', //解放军文职干部证
        JSYXXYZ: '124', //军事院校学员证
        JGTXZ: '125', //军官退休证
        WZGBTXZ: '126', //文职干部退休证
        LZFBRYZ: '127', //离休干部荣誉证
        WJSFZ: '130', //武警身份证件
        WJSBZ: '131', //武警士兵证
        JINGGZ: '132', //警官证
        WJWZGBZ: '133', //武警文职干部证
        WJJGTXZ: '134', //武警军官退休证
        WJWZGBTXZ: '135', //武警文职干部退休证
        ZGHZ: '141', //中国护照
        WGHZ: '142', //外国护照
        GAWANDTXZ: '150', //港澳居民来往内地通行证
        TWWLDLTXZ: '151', //台湾居民来往大陆通行证
        WGBMCRJTXZ: '152', //外国边民出入境通行证
        WGRYJJLSFZ: '153', //外国人永久居留身份证
        GATSFZ: '154', //港澳台身份证
        GAJMJZZ: '155', //港澳居民居住证
        TWJMJZZ: '156', //台湾居民居住证
        GZZ: '160', //工作证
        GJGDZ: '161', //股金过渡证件
        XSZ: '162', //学生证
        LXZ: '163', //中华人民共和国旅行证
        GRWZ: '10X', //个人未知
        GRQT: '10Z', //其他个人证件识别标识
        YYZZ: '201', //营业执照
        SWDJZ: '202', //税务登记证
        ZZJGDMZ: '203', //组织机构代码证
        SHTTDJZ: '204', //社会团体登记证书号码
        SYDWFRDJZ: '205', //事业单位法人登记证
        JRXKZ: '206', //金融许可证号码
        ZGBMPW: '207', //主管部门的批文或证明
        YXHZTZS: '208', //预先核准通知书
        WHJYXKZ: '209', //外汇经营许可证
        TZJYXKZ: '210', //特种经营许可证
        WGGZZCZM: '211', //外国公司注册证明
        ZZM: '235', //中征码
        FRWZ: '20X', //法人未知
        FRQT: '20Z', //其它机构证件识别标识
        PERSON: ['101', '102', '103', '104', '105', '106', '107', '110', '120', '121', '122', '123', '124', '125', '126', '127', '130', '131', '132', '133', '134', '135', '141', '142', '150', '151', '152', '153', '154', '155', '156', '160', '161', '162', '163', '10X', '10Z'],
        LEGAL: ['201', '202', '203', '204', '205', '206', '207', '208', '209', '210', '211', '235', '20X', '20Z']
    },

    Align: {
        CENTER: '01',
        LEFT: '02',
        RIGHT: '03'
    },

    Sign: {
        DOUBLE_COLON: '::',
        COLON: ':',
        POINT: '.',
        LEFT_PARENTHESES: '(',
        RIGHT_PARENTHESES: ')',
        COMMA: ',',
        doubleAt: '@@',
        UNDER_LINE: '_',
        SHORT_LINE: '-'
    },

    TxCode: {
        STOCK_HLD_INFO: 'stkm_01103', //股东信息新增
        STOCK_HLD_UPDATE: 'stkm_01105', //股东信息修改
        CASH_INTR_INFO: 'stkm_03503', //现金分红
        CASH_DEAL_INFO: 'stkm_03506', //现金挂账处理
        BUY_BACK_INFO: 'stkm_03802', //股权回购
        QUIT_INFO: 'stkm_02203', //股权退股
        TRANSFER_INFO: 'stkm_03112', //库存股激励/转让
        BUY_SHARE_INFO: 'stkm_02704', //入股认购申请
    }
}
export const SysConstant = {

    HAS_LEVEL_KEY: 'hasDataLevel',
    HIGHER_LEVEL: 'higher_level',
    LOWER_LEVEL: 'lower_level',

    MenuType: {
        DIRECTORY: 'D',
        MENU: 'M',
        INTERFACE: 'I',
        BUTTON: 'B',
        API: 'A'
    },

    ShowType: {
        CROSSWISE: '1',
        LENGTHWAYS: '2'
    },

    UserSts: {
        NORMAL: '1',
        DELETE: '*'
    },

    CopeType: {
        GLOBAL: '1',
        LEGAL_PERSON: '2'
    },

    UnlockMode: {
        MU: '2'
    },

    LoginMode: {
        PASSWORD: '1',
        FINGERPRINT: '2',
        PASSWORD_AND_FINGERPRINT: '3',
        TELLER_CARD: '4',
        PATC: '5',
        FATC: '6',
        PAFATC: '7'
    },

    DataLevel: {
        SELF: '1',
        SELF_DEP: '2',
        CUSTOM_DEP: '3',
        SELF_LEGAL: '4'
    },

    RoleType: {
        ADMINISTRATORS: '1',
        GBS: '3',
        ADMIN: '2',
        BUSINESS_UPERVISOR: '4',
        OT: '5'
    },
    //预警页面用到的角色类型
    RoleType1: {
        RCU: '1',           //省联社 province_cooperative_union
    },

    NoticeSts: {
        UNPUBLISHED: '00', //未发布
        HAVE_RELEASED: '01', //已发布
        HAVE_BEEN_CANCELLED: '02', //失效
        LOSE_EFFICACY: '03' //已作废
    },

    NoticeLvl: {
        HIGH: '1',
        MIDDLE: '2',
        LOW: '3'
    },

    PageTxType: {
        APPLY: '1',
        REVIEW: '2',
        AUDIT: '3',
        APPROVAL: '4',
        BOOKKEEPING: '5',
        INVESTIGATE: '6',
        AFFIRM: '7',
        REACH: '8',
        ACCEPTANCE: '9',
        QUERY: '10',
        BATCH: '11'
    },

    InterfaceLvl: {
        SYSTEM: '1',
        NORMAL: '2'
    },

    InterfaceType: {
        DIRECTORY: 'D',
        MENU: 'M',
        INTERFACE: 'I',
        BUTTON: 'B'
    },

    SecondHowdo: {
        EDIT_PAGE_COMMIT_TRIGGER: '1'
    },

    OptType: {
        ENTITY_OPERATIONAL: '1',
        SUMMARY_OPERATIONAL: '2',
        ENTITY_PLUS_SUMMARY: '3'
    },

    WrkSts: {
        NORMAL_SIGNED_BACK: '0'
    },

    DepUseSts: {
        DISABLE: '0',
        ENABLE: '1'
    },

    LossInd: {
        NOT_STATISTICS: '3',
        NOT_LOSS: '1',
        LOSS: '2'
    },

    DepSts: {
        NORMAL: '1',
        BE_REMOVAL: '2',
        DELETE: '*'
    },

    CostProfitInd: {
        DOC: '1',
        PROFIT_DEPARTMENT: '2'
    },

    TriggeType: {
        EDIT_PAGE_COMMIT_TRIGGER: '1',
        RPCT: '2'
    },

    PassWord: {
        DEFAULT: '111111',
        USE_DAYS: 180,
        ERR_CNT: 5
    },

    SysSts: {
        NORMAL: '0',
        IS_THE_BATCH: '1',
        BACK_COMPLETE: '2'
    }
}
export const StockConstant = {

    STOCK_PAR_VAL: '1.0',
    ONE_HUNDRED: '100',
    YEAR_DAYS: '365',
    JZ_BRF_LENGTH: '120',
    POINT_DIGITS: '4',
    LEGAL: '1',
    NATURE: '2',
    INTERNAL_SENIOR: 'nbr_',
    G07_TYPE_TO_THROUGH_TYPE: '{11=14, 1=, 2=3, 3=4, 4=5, 5=6, 6=7, 7=, 8=11, 9=12, 10=13}',

    RuleScope: {
        PUBLIC_RULES: '1',
        TRADING_RULES: '2'
    },

    RuleHandlerType: {
        LRP: '1',
        TIMING_RULE_PROCESSOR: '2',
        CRH: '99'
    },

    OldStockSts: {
        DISPOSAL_REGISTRATION: '0',
        MERGE_STATUS: '1',
        HAVE_CANCEL_AFTER_VERIFICATION: '2',
        ALREADY_RECEIVED: '3'
    },

    RunupAcc: {
        DPTBT: '1',
        OTHER_PAYABLES: '2'
    },

    OfferingsSts: {
        NOT_STARTE: '0',
        IN_ISSUE: '1',
        COMPLETE: '2',
        TERMINATE: '3',
        REVOKE: '4',
        DELETE: '*',
        END: ['3', '*']
    },

    OfferingsPattern: {
        FREEZE: '1',
        REAL_TIME: '2'
    },

    RateType: {
        FDY: '1',
        FDR: '2'
    },

    InvestEquityType: {
        LISTED_STOCK: '1',
        PE: '2',
        OEI: '3'
    },

    TransactionDirection: {
        PURCHASE: '1',
        SELL_OUT: '2'
    },

    TransType: {
        OUT: '1',
        IN: '2',
        FREEZE: 'freeze', //冻结数据过渡
        PLEDGE: 'pledge', //质押数据过渡
    },

    ForceTransType: {
        SFDJZR: '1',
        ZYZR: '2',
        ZJQZZR: '3',
        YWDJZR: '4'
    },

    ReportFlag: {
        NOT_GENERATE: '0',
        THE_GENERATED: '1',
        THE_GENERATED_REPEAT: '2',
        DELETE: '*'
    },

    SubReportType: {
        ROUTINE_REPORTING: '1',
        BODHFWARTTPABD: '2',
        RTSDACTPA: '3',
        RTTPDOUR: '4'
    },

    UnPledgeType: {
        PLEDGE_REMOVE: '1',
        PLEDGE_CANCEL: '2'
    },

    PledgeType: {
        PART_PLEDGE: '30',
        ALL_PLEDGES: '31',
        PLEDGE_TO_LIFT: '33'
    },

    FrozType: {
        SFDJ: '1',
        YWDJ: '2',
    },

    FrozTxType: {
        DJ: '1',
        XD: '2',
    },

    FrozTimeType: {
        DJDQR: '1',
        DJQX: '2',
    },

    FrozTarget: {
        GQHQBZX: '1',
        GQHGLZX: '2',
        GQHXJZX: '3',
        GQ: '4',
    },

    CalcHstSts: {
        UN_ACCOUNT: '1',
        HAV_ACCOUNT: '2'
    },

    IntrMode: {
        EFO10SPD: '1',
        ATTANOSD: '2'
    },

    BookType: {
        RUGU: '1',
        KUOGU: '2',
        TUIGU: '9',
        TRANSFER_OUT: '3',
        TRANSFER_IN: '4',
        INHERIT_OUT: '5',
        INHERIT_IN: '6',
        GRANT_OUT: '7',
        GRANT_IN: '8'
    },

    BookSts: {
        REGISTER: '1',
        PROCESSED: '2'
    },

    RuleType: {
        SHAREHOLDER_CREDIT_PROBLEM: '1',
        SHAREHOLDER_BEHAVIOR_PROBLEM: '2',
        REL_TX_PROBLEM: '3',
        EQUITY_MANAGEMENT_PROBLEM: '4',
        EQUITY_PLEDGE_PROBLEM: '5'
    },

    DelSts: {
        Y: 'Y',
        N: 'N'
    },

    ControlLevel: {
        MBC: '1',
        STC: '2'
    },

    BlacklistType: {
        BLACKLIST: '1',
        GREY_LIST: '2',
        WHITE_LIST: '3'
    },

    PartiHoldFlog: {
        PARTI_STS: '2',
        NOT_PARTI_STS: '1'
    },

    CapitalSupply: {
        PREFERRED: '1',
        DEBT: '2',
        SPECIALBONDS: '3',
        CHANGEBONDS: '4',
        RENEWBONDS: '5',
        OTHERBONDS: '6',
        SUPPLECAPITAL: '7'
    },

    EffectSts: {
        EFF_STS: '1',
        NOT_EFF_STS: '2',
        LOSE_STS: '3'
    },

    IsTrusteeship: {
        HAS_MANAGED: '1',
        UNMANAGED: '2'
    },

    RightSts: {
        NOT_SYNC: '1',
        SYNC: '2'
    },

    FinType: {
        CUNINNER_FIN_TYPE: '1',
        OTHERINNER_FIN_TYPE: '2',
        OUT_FIN_TYPE: '3'
    },

    Country: {
        CHINA: 'CHN',
        HONGKONG: 'HKG',
        MACAO: 'MAC',
        TAIWAN: 'TWN',
    },

    NoteSts: {
        NORMAL: '0',
        LOSS: '1',
        LOSS_REPAIR: '2',
        NORMAL_REPAIR: '3',
        DESTROY: '*'
    },

    PrintFlag: {
        UNPRINT: '0',
        PRINT: '1'
    },

    ApplySts: {
        APPLY: '1',
        PASS: '5',
        UNPASS: '6',
        USED: '8'
    },

    ShortMessage: {
        Y: '1',
        N: '2'
    },

    DataType: {
        DATE_DATA: '1',
        REAL_DATA: '2',
        MONTH_DATA: '3',
    },

    TrialType: {
        FHSG_CALC: '1',
        GJJZZ_CALC: '2',
        PG_CALC: '3',
        ZG_CALC: '4',
        GQJL_CALC: '5'
    },

    SharePlan: {
        INSERT: '1',
        MODIFY: '2',
        DELETE: '3'
    },

    IntrType: {
        XJFH: '1',
        FHSG: '3',
        ZBGJ: '5',
        PAY_TAX: ['1'],
    },

    ApType: {
        RUGU: '1', //入股
        SG: '10', //送股
        YYGJ: '11', //盈余公积—转增
        ZBGJ: '12', //资本公积—转增
        TUIGU: '13', //退股
        ZWJGBG: '14', //账务机构变更
        CHAIFEN: '15', //拆分
        HEBING: '16', //合并
        HUIGOU: '17', //股权回购
        YXGZPTG: '18', //优先股转普通股
        GQJL: '19', //库存股激励
        KUOGU: '2', //配股
        KCGZX: '20', //库存股注销
        GZZC: '21', //现金分红挂账处理
        KCGZR: '22', //库存股转让
        PGRG: '23', //配股认购
        YFKX: '24', //募股缴款
        YFGL: '25', //库存股转让缴款
        KCGJLJK: '26', //库存股激励缴款
        PGJK: '27', //配股缴款
        GBZZBGJJ: '28', //股本转资本公积金
        CZBJ: '29', //冲正补记
        ZCZR: '3', //转让
        CHEXIAO: '30', //记账撤销
        SFDJZR: '31', //司法冻结转让
        ZLBG: '32', //种类变更
        XZZH: '33', //性质转换
        ZZGB: '34', //转增股本
        XJZZGB: '35', //现金+转增股本
        LGQCZ: '36', //处置
        LGQHX: '37', //核销
        LGQLQ: '38', //领取
        GJYY: '39', //股金预约
        JCZR: '4', //继承
        ZFFY: '40', //股权支付费用计提
        ZHIYA: '41', //质押
        JZY: '42', //解质押
        JDJ: '43', //解冻结
        LGQGX: '44', //老股权股息
        TGGX: '45', //退股股息
        ZRGX: '46', //转让股息
        MGJKTG: '47', //募股缴款退款
        ZYZR: '48', //质押转让
        GRCHEXIAO: '49', //直接强制转让
        ZENGYU: '5', //赠予
        YWDJZR: '50', //业务冻结转让
        DONGJIE: '51', //冻结
        XGPLRZ: '54', //新股批量入账
        ZYWH: '55', //质押维护
        PGTK: '56', //配股退款
        SGGZZC: '59', //送股股本挂账处理
        FGZR: '6', //分割
        ZZGBGZZC: '60', //转增股本挂账处理
        GBZX: '62', //库存股注销冲销
        GDHZ: '7', //股东证更换
        XJ: '8', //现金
        XJSG: '9', //送股+分红
        NEW_ADD: ['1', '2', '23'],
        ZR: ['3', '4', '5', '16'],
        CANCEL: ['1', '2', '3', '4', '5', '10', '11', '12']
    },
    curStockNum: {
        length: 9999999999999,
    },
    FreezeType: {
        FREEZE: '1',
        AGAIN_FREEZE: '2'
    },

    TxFlag: {
    },

    OptType: {
    },

    ReserveLevel: {
        NOT_CONTROL: '1',
        RAR: '2',
        HTR: '3'
    },

    ManageType: {
        CENTRAL_MANAGE: '1',
        DECENTRALIZED_MANAGE: '2'
    },

    DividType: {
        FDY: '1',
        FDR: '2'
    },

    TxType: {
        LOSS: '1',
        UNLOSS: '2',
        FREEZE: '3',
        PLEDGE: '4',
        UNFREEZE: '5',
        UNPLEDGE: '6',

        PINGJIA: '1', //平价
        YIJIA: '2', //溢价
        ZHEJIA: '3', //折价
    },

    NoteType: {
        XBGJJ: '773',
    },

    SpecSubType: {
        LOSS: '10',
        UNLOSS: '11',
        PART_FREEZE: '20',
        ALL_FREEZE: '21',
        UNFREEZE: '23',
        ALL_PLEDGE: '31',
        PART_PLEDGE: '32',
        UNPLEDGE: '33'
    },

    SpecType: {
        LOSS: '1',
        FREEZE: '2',
        PLEDGE: '3'
    },

    RelType: {
        NATURE_NATURE: '1',
        NATURE_LEGAL: '2',
        LEGAL_LEGAL: '3',
        LEGAL_NATURE: '4'
    },

    RelFlag: {
        NATURE: '1',
        LEGAL: '2'
    },

    RelMainType: {
        NATURE: '1',
        LEGAL: '2'
    },

    SubTypeF: {
        BRANCH: '3',
        COAS: '4'
    },

    SubType: {
        INDIVIDUAL_SHAREHOLDER: '1',
        NSOLS: '2',
        BRANCH: '3',
        COAS: '4'
    },

    CtrlType: {
        UNDER_CONTROL: '1',
        CONTROL: '2'
    },

    SupRating: {
        ONE_LEVEL: '1',
        SECOND_LEVEL: '2'
    },

    ShrfundSource: {
        EQUITY_FUND: '1',
        TRUST_FUNDS: '2',
        DEBT_FUNDS: '3',
        OBS: '4'
    },

    Sex: {
        MAN: '1',
        WOMAN: '2'
    },

    PartiHoldFlag: {
        PARTICIPATION: '1',
        HOLDING: '2',
        NOTHING: '3'
    },

    IsRestriction: {
        IR: '1',
        DNR: '2'
    },

    IsConfire: {
        Y: 'Y',
        C: 'C',
        N: 'N'
    },

    InvestType: {
        LEGAL: '1',
        PERSON: '2'
    },

    DirectorsType: {
        DIRECTOR: '1',
        SUPERVISOR: '2',
        NOTHING: '3'
    },

    CustomerType: {
        PERSONAL: '1',
        FOR_CORPORATE: '2',
        PEER: '3'
    },

    CompanyState: {
        IN_BUSINESS: '2',
        REVOCATION: '3',
        CANCELLATION: '4',
        IMMIGRATION: '5',
        EMIGRATION: '6',
        CLOSURE: '7',
        LIQUIDATION: '8'
    },

    Check: {
        PAY: 'Y',
        BALANCE: 'Y',
        IMITATION_FLAG: 'Y',
        IDCARD: 'Y'
    },

    VouConfig: {
        PAGE_SIZE: '20',
        TOTAL_PAGE: '40',
        FULL_PAGE: 'Y'
    },

    VouKind: {
        CERT: '773',
        NOTE: '402'
    },

    BadInformation: {
        HBLATRDOTBJDO: '1',
        TISEOBDB: '2',
        PFMOMFS: '3',
        TBRFTFOCBOMVOLAR: '4',
        TROHTCOILOFCOSATL: '5',
        BIAPBFRAORGDDTVOLARCAE: '6',
        OSTMAATOAMOCB: '7'
    },

    ActcontrolUn: {
        SOASAASOTSC: '1',
        LOCAL_SASAC: '2',
        OTHER: '3'
    },

    Limit: {
        YEAR: '3'
    },

    TradeType: {
        FLAT: '1',
        OVER: '2',
        DISCOUNT: '3'
    },

    StockTag: {
        MAIN_HOLD: 'Y',
        INITIATE: 'Y',
        MANAGER: '3',
        MANAGER_AND_INITIATE: '4',
        DIFF_TYPE_DIRECTOR: '1',
        DIFF_TYPE_SUPERVISOR: '2'
    },

    StaffSts: {
        WORK: '1',
        QUIT: '2'
    },

    StockKind: {
        MEMBER: '1',
        LEGAL: '2',
        STAFF: '3',
        NATURAL: '4'
    },

    TailType: {
        BIG_FIRST: '1', //大尾数优先
        ROUND: '2', //四舍五入
        WIPE_ZERO: '3', //舍去
    },

    StockSts: {
        PRE_OPEN: 'P000',
        NORMAL: '0000',
        CANCEL: '*000',
        LOSS: '0100',
        LOSS_AND_FREZ: '0101',
        PLD_AND_LOSS: '0111',
        PLD_AND_FREZ: '0011',
        PLEDGE: '0010',
        FREEZE: '0001'
    },

    StockType: {
        QUALITY: '0',
        INVEST: '1', //正常投资股
        NORMAL: '2',
        YXG: '3',
        KCG: '4', //库存股/回购股
        GZG: '5', //挂账股
        DCL: '6', //待处理股
        ALL: '99'
    },

    StockMode: {
        FRG: '1',
        NBZG: '2',
        WBZRR: '3',
        ALL: ['1', '2', '3']
    },

    StockModeCalc: {
        GJG: '1', //国家股
        JTG: '2', //集体股
        GYFRG: '3', //法人股-国有法人股
        FGYFRG: '4', //法人股-非国有法人股
        ZGG: '5', //个人股-职工股
        FZGZRRG: '6', //个人股-非职工自然人股
        WSGZRR: '7', //外商股（自然人）
        WSGFR: '8', //外商股（法人）
        HGG: '9', //回购股
    },

    OwnerShip: {
        GWYGZWJGQY: '1',
        GDFGZWJGQY: '2',
        SYQY: '3',
        GATWZQY: '4',
        QT: '5'
    },

    ClientTypeS42: {
        ZYZF: '1',
        DFZF: '2',
        JNYHYJRJG: '3',
        JNFYHYJRJG: '4',
        GYQY: '5',
        JNFGYQY: '6',
        NBZG: '7',
        SHZRR: '8',
        JWTZZ: '9',
        PERSON: ['7', '8', '9'],
        LEGAL: ['1', '2', '3', '4', '5', '6', '9']
    },

    ClientTypeG07: {
        JRQY: '1',
        FJRQY: '2',
        JG: '3',
        SYDW: '4',
        SHTT: '5',
        ZRR: '6',
        ZYHJ: '7',
        DFZFRZPT: '8',
        ZFTZJJ: '9',
        TDMDZT: '10',
        QT: '11'
    },

    ClientTypeJg: {
        YHYJRQY: '1',
        FYHYJRQY: '2',
        FJRQY: '3',
        JG: '4',
        SYDW: '5',
        SHTT: '6',
        ZRR: '7',
        ZYHJ: '8',
        DFZFRZPT: '9',
        ZFTZJJ: '10',
        TDMDZT: '11',
        QT: '12'
    },

    ClientType: {
        FR: '1',
        NBZG: '2',
        WBZRR: '3',
        PERSON: ['2', '3'],
        LEGAL: ['1']
    },
    //非法人股东类型
    CurClientType: {
        ZRR: '7',
        QT: '14',
    },

    SharesType: {
        GYQY: '2',
        FGYQY: '1'
    },

    DepositYn: {
        HAS_MANAGED: "1",
        UNMANAGED: "2",
    },

    CapitalType: {
        PREFERRED: "1",
        DEBT: "2",
        SPECIALBONDS: "3",
        CHANGEBONDS: "4",
        RENEWBONDS: "5",
        OTHERBONDS: "6",
        SUPPLECAPITAL: "7",
    },

    TxDirection: {
        PURCHASE: "1",
        SELL_OUT: "2",
        OTHER_ADD: "3",
        OTHER_SUBTRACT: "4",
    },

    PosSts: {
        IN_OFFICE: "1",
        LEAVE_OFFICE: "2",
    },

    // 新股批量入账缴款信息列表查询标志
    //      标识:1-申请查询接口;2-修改审批记账查询接口
    QryPayListFlag: {
        APPLY: "1",
        OTHER: "2",
    },

    NatureOwner: {
        GYGD: '1', // 国有股东
        MYGD: '2', // 民营股东
        GATJWZGD: '3', // 港澳台及外资股东
        QT: '4' //其他
    },

    // 股金证挂失/撤挂台账，挂失状态两个不展示的正常状态隐藏
    lostSts: {
        NORMAL1: '0',
        GS: '1',
        CG: '2',
        GSBF: '3',
        GSGM: '4'
    },

    // 核心接口调用返回是否测试环境
    isTestEnv: {
        Y: 'Y',
        N: 'N'
    },

    // 募股计划状态 *-已删除 0-未开始 1-发行中 2-已完成 3-已终止 4-已撤销
    issueDetailSts: {
        DELETE: '*',
        NOTSTART: '0',
        RELEASE: '1',
        COMPLETED: '2',
        TERMINATED: '3',
        CANCELED: '4'
    },
    //stock_trans_reg表状态，1-待交易 2-已交易 3-已撤销 4-已过期
    TransRegSts: {
        PRETRAN: '1',
        ISTRAN: '2',
        CANCELED: '3',
        ISOVERDUE: '4'
    },

    //对方科目（翻译表里没有，只在前台进行展示）
    OppositeAccount: {
        LRFP: '1', //利润分配-转作股本的股利
        ZBYJ: '2', //资本溢价
        YFGQ: '3', //应付股权入股验资户
        HGG: '4', //回购股
    }
}
export const ParamConstant = {

    OTHER_CAPITAL: 's_capital',
    BLACKLIST_YEAR_CTL: 's_blacklist_year_ctl',
    PREFIX: 's_%'
}

/**
 * 表单校验提示
 */
export const VaildMessageConstant = {
    required: "${label}不能为空!",
    max: "${label}长度不能超过${max}位!",
    number_max: "${label}的值应小于等于${max}!",
    min: "${label}长度不能低于${min}位!",
    number_min: "${label}的值应大于等于${min}!",
    range: "${label}长度应在${min}-${max}之间!",
    number_range: "${label}的值应在${min}-${max}之间!",
}

// 通用异常提示语
export const COMMON_ERROR_MESSAGE = '系统未知错误'

//凭证打印的 交易识别码
export const TRANSACTION_IDENTIFICATION_CODE = {
    "STOCK_39":"8113001",
    "STOCK_54":"8113002",
    "STOCK_40":"8113003",
    "STOCK_41":"8113004",
    "STOCK_42_2":"8113005",
    "STOCK_42_1":"8113006",
    "STOCK_42_3":"8113007",
    "STOCK_60":"8113008",
}
export const BUSSINESS_VOUCHERS_TX_CODE = [
    "STOCK_39",
    "STOCK_54",
    "STOCK_40",
    "STOCK_41",
    "STOCK_42",
    "STOCK_60",
]
//预警页面相关的常量
export const EarlyWarningConstant= {
    patternMode:{
        NON: 'NON',
        All: 'All',
        INCLUDE: 'INCLUDE',
        EXCLUDE: 'EXCLUDE',
    }
}
