export default{
    //字母校验
    alphabets:/^[A-Za-z]+$/,

    //小写字母校验
    lowerCase:/^[a-z]+$/,

    //大写字母校验
    UpperCase:/^[A-Z]+$/,

    //是否以https?:|mailto:|tal: 开头的
    external:/^(https?:|mailto:|tel:)/,

    //网址校验
    url:/^(https?|ftp):\/\/([a-zA-Z0-9.-]+(:[a-zA-Z0-9.&%$-]+)*@)*((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]?)(\.(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9]?[0-9])){3}|([a-zA-Z0-9-]+\.)*[a-zA-Z0-9-]+\.(com|edu|gov|int|mil|net|org|biz|arpa|info|name|pro|aero|coop|museum|[a-zA-Z]{2}))(:[0-9]+)*(\/($|[a-zA-Z0-9.,?'\\+&%$#=~_-]+))*$/,
    
    //身份证号校验
    iDNumber:/^[1-9][0-9]{5}(19|20)[0-9]{2}((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|[1-2][0-9]))[0-9]{3}([0-9]|x|X)$/,
   
    //邮箱校验
    email:/^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/,
    
    //电话号码验证
    phone:/(^(0[0-9]{2,4})\-[0-9]{6,8}$)|^((1[0-9]{1})+\d{9})$/,

    //护照校验
    passport:/(^[EeKkGgDdSsPpHh]\d{8}$)|(^(([Ee][a-fA-F])|([DdSsPp][Ee])|([Kk][Jj])|([Mm][Aa])|(1[45]))\d{7}$)/,

    //IP4地址判断
    patrnIp4:/(?=(\b|\D))(((\d{1,2})|(1\d{1,2})|(2[0-4]\d)|(25[0-5]))\.){3}((\d{1,2})|(1\d{1,2})|(2[0-4]\d)|(25[0-5]))(?=(\b|\D))/,

    //IP6地址判断
    patrnIp6:/^([\\da-fA-F]{1,4}:){7}([\\da-fA-F]{1,4})$/,

    //非负浮点数
    regPos:/^\d+(\.\d+)?$/,

    //负浮点数
    regNeg:/^(-(([0-9]+\.[0-9]*[1-9][0-9]*)|([0-9]*[1-9][0-9]*\.[0-9]+)|([0-9]*[1-9][0-9]*)))$/,

    //数字+字母+特殊字符
    chenese:/^[\da-zA-Z!！@#$%^&*(),，。、；;:：、’//`~{}【】\[\]|"“‘'<>《》=\+-_\——·]+$/,

}