// 模拟 ConfigManager 类和 ConfigType 枚举
enum ConfigType {
    System
}

class ConfigManager {
    private static instance: ConfigManager;
    private constructor() { }

    static GetInstance(): ConfigManager {
        if (!this.instance) {
            this.instance = new ConfigManager();
        }
        return this.instance;
    }

    GetConfigValue(key: string, type: ConfigType): string {
        // 这里应该实现实际的配置读取逻辑
        // 目前只是返回一个默认值
        return "defaultKey";
    }
}

export default class CommonSettings {
    /**
     * 通讯采用的加密方式
     */
    static get KeyStr(): string {
        return ConfigManager.GetInstance().GetConfigValue("KeyStr", ConfigType.System);
    }
}
