/*----------------------------------------------------------------------------------------------
 
       Copyright (C) DHCC Ȩ

       ϵͳ:
         :  SocketManager
         Ҫ: 
       :  Hu Ha
       :  01/18/2010 13:59:23
         :    No.                   Ver.No        ޸             																																																																										

------------------------------------------------------------------------------------------------*/

using System;
using System.Collections.Generic;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using Platform.Common.LogSystem;

namespace TellerSystem.Communication.SocketListener
{
    public delegate TResult Func<TResult>();

    /// <summary>
    /// ṩ׽ֹ
    /// </summary>
    public class SocketManager : IDisposable
    {
        //˿ֵ
        private Dictionary<int, Socket> m_ListenningSockets;

        private static object Locker = new object();
        private BufferManager m_BufferManager;
        //ֵ
        private int m_ThresholdValue = 102400;

        #region Զ

        private bool m_SuspendAllSend;

        /// <summary>
        /// ͣݷ
        /// </summary>
        public bool SuspendAllSend
        {
            get { return m_SuspendAllSend; }
            set
            {
                //Ϊtrue,֪̼ͨ߳ȴ
                if (value)
                    this.m_SendControl.Reset();
                else//з̼߳
                    this.m_SendControl.Set();

                m_SuspendAllSend = value;
            }
        }

        private bool m_StopAllSend;

        /// <summary>
        /// ֹͣݷ
        /// </summary>
        public bool StopAllSend
        {
            get { return m_StopAllSend; }
            set
            {
                if (value && this.SuspendAllSend)
                {
                    //֪̼ͨ߳
                    this.SuspendAllSend = false;
                }
                m_StopAllSend = value;
            }
        }

        private int m_MaxListenningRequest;

        private ManualResetEvent m_SendControl;

        /// <summary>
        /// ȡ
        /// </summary>
        public int MaxListenningRequest
        {
            get { return m_MaxListenningRequest; }
        }

        private int m_SendBufferSize;

        /// <summary>
        /// ȡ÷ͻС
        /// </summary>
        public int SendBufferSize
        {
            get { return m_SendBufferSize; }
            set { m_SendBufferSize = value; }
        }
        private int m_ReceiveBufferSize;

        /// <summary>
        /// ȡýջС
        /// </summary>
        public int ReceiveBufferSize
        {
            get { return m_ReceiveBufferSize; }
            set { m_ReceiveBufferSize = value; }
        }
        private int m_SendTimeOut;

        /// <summary>
        /// ȡ÷ͳʱʱ
        /// </summary>
        public int SendTimeOut
        {
            get { return m_SendTimeOut; }
            set { m_SendTimeOut = value; }
        }
        private int m_ReceiveTimeOut;

        /// <summary>
        /// ȡýճʱʱ
        /// </summary>
        public int ReceiveTimeOut
        {
            get { return m_ReceiveTimeOut; }
            set { m_ReceiveTimeOut = value; }
        }

        /// <summary>
        /// ȡֵûдﵽֵ˴socketỰյݻ
        /// һԵĴݸ¼յ˽bufferСʹһ¼
        /// ֵڻڽbufferĴС
        /// </summary>
        public int ThresholdValue
        {
            get { return m_ThresholdValue; }
        }

        #endregion

        #region ¼

        /// <summary>
        /// ʼʱ
        /// </summary>
        public event EventHandler<ServerPortEventArgs> ServerStart;

        /// <summary>
        /// ֹͣʱ
        /// </summary>
        public event EventHandler<ServerPortEventArgs> ServerStop;

        /// <summary>
        /// ʼʱ
        /// </summary>
        public event EventHandler SendStart;

        /// <summary>
        /// ɺ
        /// </summary>
        public event EventHandler SendCompleted;

        /// <summary>
        /// ڽݷ
        /// </summary>
        public event EventHandler<DataReceivedEventArgs> DataReceived;

        /// <summary>
        /// ڷʱ
        /// </summary>
        public event EventHandler<DataSendEventArgs> Sending;

        /// <summary>
        /// Socketʱ
        /// </summary>
        public event EventHandler<SocketErrorEventArgs> ErrorHappened;

        #endregion

        public SocketManager()
            : this(200, 12400, 0, 0, 0)
        {

        }

        /// <summary>
        /// ϢʼSocketManager
        /// </summary>
        /// <param name="maxClientCount"></param>
        /// <param name="receiveBufferSize">ջС</param>
        /// <param name="sendBufferSize">ͻС</param>
        /// <param name="receiveTimeOut">ճʱʱ(λΪ,0Ϊʱ)</param>
        /// <param name="sendTimeOut">ͳʱʱ(λΪ,0Ϊʱ)</param>
        public SocketManager(int maxClientCount, int receiveBufferSize, int sendBufferSize, int receiveTimeOut, int sendTimeOut)
        {
            this.m_MaxListenningRequest = maxClientCount;
            this.m_SendBufferSize = sendBufferSize;
            this.m_ReceiveBufferSize = receiveBufferSize;
            this.m_SendTimeOut = sendTimeOut;
            this.m_ReceiveTimeOut = receiveTimeOut;
            this.m_BufferManager = new BufferManager(maxClientCount, receiveBufferSize, sendBufferSize);
            this.m_SendControl = new ManualResetEvent(true);
            this.m_ListenningSockets = new Dictionary<int, Socket>();
        }

        #region 

        /// <summary>
        /// ָ˿ں
        /// </summary>
        /// <param name="port">˿ں</param>
        /// <returns>Ƿɹ</returns>
        public bool StartListenning(int port)
        {
            return this.StartListenning(port, true);
        }

        /// <summary>
        /// ָ˿ں
        /// </summary>
        /// <param name="port">˿ں</param>
        /// <param name="async">Ƿ첽:trueΪ첽falseΪͬ</param>
        /// <returns>Ƿɹ</returns>
        public bool StartListenning(int port, bool async)
        {
            Socket socket = this.GetSocket(0, 0);

            try
            {
                if (!socket.IsBound)
                {
                    lock (Locker)
                    {
                        //double  check
                        if (!socket.IsBound)
                        {
                            //uint IOC_IN = 0x80000000;
                            //uint IOC_VENDOR = 0x18000000;
                            //uint SIO_UDP_CONNRESET = IOC_IN | IOC_VENDOR | 12;
                            //socket.IOControl((int)SIO_UDP_CONNRESET, new byte[] { Convert.ToByte(false) }, new byte[4]);
                            // socket.SetSocketOption(SocketOptionLevel.IPv6, (SocketOptionName)27, false);
                            //socket.Bind(new IPEndPoint(Dns.GetHostAddresses(Environment.MachineName)[0], port));
                            socket.Bind(GetIpv4EndPoint(port));
                            socket.Listen(this.m_MaxListenningRequest);
                            this.m_ListenningSockets.Add(port, socket);
                            this.OnServerStart(port);
                            this.StartReceive(socket, async);
                        }
                    }
                }
            }
            catch (SocketException se)
            {
                socket.Close();
                this.OnErrorHappened(se, SocketOperation.Bind);
                return false;
            }

            return true;
        }

        /// <summary>
        /// ˿ں
        /// </summary>
        /// <param name="ports">˿ڼ</param>
        public void StartListenningBatch(int[] ports)
        {
            foreach (int port in ports)
            {
                this.StartListenning(port);
            }
        }

        /// <summary>
        /// ֹͣ
        /// </summary>
        public void StopListenning(bool onlyCloseSocket)
        {
            Dictionary<int, Socket> dic = new Dictionary<int, Socket>(this.m_ListenningSockets);

            this.m_ListenningSockets.Clear();

            foreach (KeyValuePair<int, Socket> kvp in dic)
            {
                kvp.Value.Close();
                this.OnServerStop(kvp.Key);
            }

            if (!onlyCloseSocket)
            {
                this.m_BufferManager.Clear();
                this.m_SendControl.Close();
            }
        }

        #endregion

        #region 

        /// <summary>
        /// ݵָ˿
        /// </summary>
        /// <param name="hostNameOrAddress">IPַ</param>
        /// <param name="port">Է˿ں</param>
        /// <param name="data"></param>
        public void Send(string hostNameOrAddress, int port, byte[] data)
        {
            this.Send(hostNameOrAddress, port, data, true);
        }

        /// <summary>
        /// ݵָ˿
        /// </summary>
        /// <param name="hostNameOrAddress">IPַ</param>
        /// <param name="port">Է˿ں</param>
        /// <param name="data"></param>
        /// <param name="async">Ƿ첽:trueΪ첽falseΪͬ</param>
        public void Send(string hostNameOrAddress, int port, byte[] data, bool async)
        {
            if (data == null)
            {
                throw new ArgumentNullException("ݲΪ");
            }

            //EndPoint endPoint = this.GetEndPoint(hostNameOrAddress, port);
            EndPoint endPoint = GetIpv4EndPoint(hostNameOrAddress, port);

            this.Send(endPoint, data, async);
        }

        /// <summary>
        /// Sends the specified data.
        /// </summary>
        /// <param name="data">The data.</param>
        /// <param name="endPoint">The end point.</param>
        /// <param name="async">if set to <c>true</c> [async].</param>
        public void Send(EndPoint endPoint, byte[] data, bool async)
        {
            if (data == null)
            {
                throw new ArgumentNullException("ݲΪ");
            }

            Socket socket = this.GetSocket(this.m_SendTimeOut, 0);

            try
            {
                this.OnSendStart();

                if (async)
                {
                    SendAsync(socket, endPoint, data);
                }
                else
                {
                    SendSynchronize(socket, endPoint, data);
                }

            }
            catch (SocketException se)
            {
                socket.Close();
                this.OnErrorHappened(se, SocketOperation.Connect);
            }
        }

        /// <summary>
        /// ͬ
        /// </summary>
        /// <param name="socket">socket</param>
        /// <param name="endPoint">Զս</param>
        /// <param name="data"></param>
        private void SendSynchronize(Socket socket, EndPoint endPoint, byte[] data)
        {
            socket.Connect(endPoint);

            SendDataInternal(socket, data);
        }

        /// <summary>
        /// ʼ
        /// </summary>
        /// <param name="socket"></param>
        /// <param name="data"></param>
        private void SendDataInternal(Socket socket, byte[] data)
        {
            SocketError socketError;

            socket.Send(data, 0, data.Length, SocketFlags.None, out socketError);

            try
            {
                socket.Shutdown(SocketShutdown.Both);
            }
            catch (SocketException ex)
            {
                socketError = ex.SocketErrorCode;
            }

            socket.Close();

            this.FireSendEvents(socketError);
        }

        /// <summary>
        /// 첽
        /// </summary>
        /// <param name="socket">socket</param>
        /// <param name="endPoint">Զս<</param>
        /// <param name="data"><</param>
        private void SendAsync(Socket socket, EndPoint endPoint, byte[] data)
        {
            socket.BeginConnect(endPoint, delegate(IAsyncResult ar)
            {
                try
                {
                    socket.EndConnect(ar);
                }
                catch (SocketException se)
                {
                    socket.Close();
                    this.OnErrorHappened(se, SocketOperation.Connect);
                    return;
                }

                this.SendDataInternal(socket, data);

            }, null);
        }

        /// <summary>
        ///  
        /// </summary>
        /// <param name="hostNameOrAddress">IPַ</param>
        /// <param name="port">Է˿ں</param>
        /// <param name="dataGetterFunc">ݻȡ</param>
        /// <remarks>
        ///    Ϊʹݶ׼,ǿΪ첽
        /// </remarks>
        public void Send(string hostNameOrAddress, int port, Func<byte[]> dataGetterFunc)
        {
            if (dataGetterFunc == null) return;

            //EndPoint endPoint = this.GetEndPoint(hostNameOrAddress, port);

            EndPoint endPoint = GetIpv4EndPoint(hostNameOrAddress, port);

            this.Send(endPoint, dataGetterFunc);
        }

        /// <summary>
        /// Sends the specified end point.
        /// </summary>
        /// <param name="endPoint">The end point.</param>
        /// <param name="dataGetterFunc">The data getter func.</param>
        public void Send(EndPoint endPoint, Func<byte[]> dataGetterFunc)
        {
            if (endPoint == null)
            {
                throw new ArgumentNullException("Զս㲻Ϊ");
            }

            Socket sendSocket = this.GetSocket(this.SendTimeOut, 0);

            this.OnSendStart();

            try
            {
                //ʼ첽Զ
                sendSocket.BeginConnect(endPoint, delegate(IAsyncResult ar)
                {
                    try
                    {
                        sendSocket.EndConnect(ar);
                    }
                    catch (SocketException se)
                    {
                        this.OnErrorHappened(se, SocketOperation.Connect);
                        sendSocket.Close();
                        return;
                    }

                    AsyncCallback callback = this.GetSendCallback(sendSocket, dataGetterFunc);

                    this.SendDataInternal(sendSocket, callback, dataGetterFunc);

                }, null);
            }
            catch (SocketException se)
            {
                sendSocket.Close();
                this.OnErrorHappened(se, SocketOperation.Connect);
            }

        }

        /// <summary>
        /// ȡ첽ͻص
        /// </summary>
        /// <param name="sendSocket">׽</param>
        /// <param name="dataGetterFunc">ݻȡ</param>
        /// <returns>첽ͻص</returns>
        private AsyncCallback GetSendCallback(Socket sendSocket, Func<byte[]> dataGetterFunc)
        {
            AsyncCallback callback = null;

            callback = delegate(IAsyncResult receiveResult)
            {
                SocketError socketError;

                int sendLength = sendSocket.EndSend(receiveResult, out socketError);

                if (socketError == SocketError.Success)
                {
                    this.OnSending(sendLength);

                    //
                    this.SendDataInternal(sendSocket, callback, dataGetterFunc);
                }
                else
                {
                    this.FireSendEvents(socketError);
                    sendSocket.Shutdown(SocketShutdown.Both);
                    sendSocket.Close();
                }
            };

            return callback;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sendSocket">׽</param>
        /// <param name="callback">첽ͻص</param>
        /// <param name="dataGetterFunc">ݻȡ</param>
        private void SendDataInternal(Socket sendSocket, AsyncCallback callback, Func<byte[]> dataGetterFunc)
        {
            if (m_SuspendAllSend)
            {
                this.m_SendControl.WaitOne();
            }

            //ݻȡлȡ
            byte[] data = dataGetterFunc();

            if (this.m_StopAllSend)
            {
                sendSocket.Close();
                return;
            }

            SocketError socketError = SocketError.Success;
            //ΪݻȡѾȡȫݣԴ
            if (data == null || data.Length == 0)
            {
                this.FireSendEvents(socketError);
                sendSocket.Close();
                return;
            }

            //ʼ
            sendSocket.BeginSend(data, 0, data.Length, SocketFlags.None, out socketError, callback, null);

            if (socketError != SocketError.Success)
            {
                this.FireSendEvents(socketError);
                sendSocket.Close();
            }
        }

        /// <summary>
        /// SocketErrorӦ¼
        /// </summary>
        /// <param name="socketError">socket</param>
        private void FireSendEvents(SocketError socketError)
        {
            if (socketError == SocketError.Success)
            {
                this.OnSendCompleted();
            }
            else
            {
                this.OnErrorHappened(new SocketException((int)socketError), SocketOperation.Send);
            }
        }

        #endregion

        #region 

        /// <summary>
        /// ʼ
        /// </summary>
        /// <param name="listenningSocket">׽</param>
        /// <param name="async">Ƿ첽:trueΪ첽falseΪͬ</param>
        private void StartReceive(Socket listenningSocket, bool async)
        {
            try
            {
                if (async)
                {
                    this.ReceiveAsync(listenningSocket);
                }
                else
                {
                    this.ReceiveSynchronize(listenningSocket);
                }
            }
            catch (SocketException se)
            {
                this.OnErrorHappened(se, SocketOperation.Receive);
            }
        }

        /// <summary>
        /// ָͬ˿
        /// </summary>
        /// <param name="socket"></param>
        private void ReceiveSynchronize(Socket socket)
        {
            Socket receiveSocket = socket.Accept();

            this.ReceiveDataInternal(receiveSocket, false);

            //
            this.ReceiveSynchronize(socket);
        }

        /// <summary>
        /// ͬ
        /// </summary>
        /// <param name="receiveSocket">׽</param>
        /// <param name="bufferBlockIndex">ǰջջ</param>
        /// <param name="receiveBufferOffset">ǰջջƫ</param>
        /// <param name="id">Ψһʶ˴ν</param>
        private void ReceiveSynchronize(Socket receiveSocket, byte[] buffer, int bufferBlockIndex, int receiveBufferOffset, string guid, bool conditionCompleted)
        {
            SocketError socketError;

            //ʼͬ
            int receiveLength = receiveSocket.Receive(this.m_BufferManager.ReceiveBuffer,
                                                      receiveBufferOffset,
                                                      this.m_BufferManager.ReceiveBufferSize,
                                                      SocketFlags.None, out socketError);

            if (socketError == SocketError.Success)
            {
                if (receiveLength > 0)
                {
                    conditionCompleted = this.ProcessReceivedData(ref buffer, receiveLength,
                        receiveBufferOffset, conditionCompleted, guid, receiveSocket.RemoteEndPoint);

                    this.ReceiveSynchronize(receiveSocket, buffer, bufferBlockIndex, receiveBufferOffset, guid, conditionCompleted);
                }
                else
                {
                    this.OnReceived(buffer, guid, receiveSocket.RemoteEndPoint, true);
                    this.ClearReceiveInfo(receiveSocket, bufferBlockIndex);
                }
            }
            else
            {
                this.ClearReceiveInfo(receiveSocket, bufferBlockIndex);
                this.OnErrorHappened(new SocketException((int)socketError), SocketOperation.Receive);
            }
        }

        /// <summary>
        /// 첽ָ˿
        /// </summary>
        /// <param name="socket">The socket.</param>
        private void ReceiveAsync(Socket socket)
        {
            AsyncCallback callback = GetAcceptCallback(socket);

            this.BeginAccept(socket, callback);
        }

        /// <summary>
        /// ʼsocket
        /// </summary>
        /// <param name="socket">socketsocket</param>
        /// <param name="callback">ص</param>
        private void BeginAccept(Socket socket, AsyncCallback callback)
        {
            try
            {
                //ʼ
                socket.BeginAccept(callback, null);
            }
            catch (SocketException se)
            {
                this.OnErrorHappened(se, SocketOperation.Accept);
            }
        }

        /// <summary>
        /// ȡܻص
        /// </summary>
        /// <param name="socket"></param>
        /// <returns></returns>
        private AsyncCallback GetAcceptCallback(Socket socket)
        {
            AsyncCallback callback = null;

            callback = delegate(IAsyncResult ar)
            {
                if (this.m_ListenningSockets.Count == 0)
                    return;

                Socket receiveSocket = null;

                try
                {
                    receiveSocket = socket.EndAccept(ar);
                    receiveSocket.ReceiveTimeout = this.m_ReceiveTimeOut;
                }
                catch (SocketException se)
                {
                    this.OnErrorHappened(se, SocketOperation.Accept);
                    if (se.SocketErrorCode == SocketError.ConnectionReset)
                    {
                        this.BeginAccept(socket, callback);
                    }
                }

                if (receiveSocket != null)
                {
                    this.ReceiveDataInternal(receiveSocket, true);
                    this.BeginAccept(socket, callback);
                }
            };

            return callback;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="receiveSocket">׽</param>
        /// <param name="async">Ƿ첽:trueΪ첽falseΪͬ</param>
        private void ReceiveDataInternal(Socket receiveSocket, bool async)
        {
            //ȡǰջջ
            int bufferBlockIndex = this.m_BufferManager.GetBufferBlockIndex();

            //ȡǰջջƫ
            int receiveBufferOffset = this.m_BufferManager.GetReceiveBufferOffset(bufferBlockIndex);

            string guid = Guid.NewGuid().ToString();

            if (async)
            {
                this.ReceiveAsync(receiveSocket, bufferBlockIndex, receiveBufferOffset, guid);
            }
            else
            {
                this.ReceiveSynchronize(receiveSocket, new byte[0], bufferBlockIndex, receiveBufferOffset, guid, false);
            }
        }

        /// <summary>
        /// 첽
        /// </summary>
        /// <param name="receiveSocket">׽</param>
        /// <param name="bufferBlockIndex">ǰջջ</param>
        /// <param name="receiveBufferOffset">ǰջջƫ</param>
        /// <param name="guid">Ψһʶ˴ν</param>
        private void ReceiveAsync(Socket receiveSocket, int bufferBlockIndex, int receiveBufferOffset, string guid)
        {
            AsyncCallback receiveCallback = GetReceiveCallback(receiveSocket, bufferBlockIndex, receiveBufferOffset, guid);

            SocketError socketError;

            //ʼ첽
            receiveSocket.BeginReceive(this.m_BufferManager.ReceiveBuffer,
                                       receiveBufferOffset,
                                       this.m_BufferManager.ReceiveBufferSize,
                                       SocketFlags.None, out socketError, receiveCallback, null);

            if (socketError != SocketError.Success)
            {
                //Դ
                this.ClearReceiveInfo(receiveSocket, bufferBlockIndex);
                //֪ͨ
                this.OnErrorHappened(new SocketException((int)socketError), SocketOperation.Receive);
            }
        }

        /// <summary>
        /// ȡջص
        /// </summary>
        /// <param name="receiveSocket">׽</param>
        /// <param name="bufferBlockIndex">ǰջջ</param>
        /// <param name="receiveBufferOffset">ǰջջƫ</param>
        /// <param name="guid">Ψһʶ˴ν</param>
        /// <returns>ջص</returns>
        private AsyncCallback GetReceiveCallback(Socket receiveSocket, int bufferBlockIndex, int receiveBufferOffset, string guid)
        {
            AsyncCallback receiveCallback = null;
            byte[] buffer = new byte[0];
            bool conditionCompleted = false;

            receiveCallback = delegate(IAsyncResult ar)
            {
                SocketError socketCallbackError;

                int receiveLength = receiveSocket.EndReceive(ar, out socketCallbackError);

                if (socketCallbackError == SocketError.Success)
                {
                    if (receiveLength > 0)
                    {
                        conditionCompleted = ProcessReceivedData(ref buffer, receiveLength,
                                            receiveBufferOffset, conditionCompleted, guid, receiveSocket.RemoteEndPoint);

                        //
                        receiveSocket.BeginReceive(this.m_BufferManager.ReceiveBuffer,
                                                   receiveBufferOffset,
                                                   this.m_BufferManager.ReceiveBufferSize,
                                                   SocketFlags.None, out socketCallbackError, receiveCallback, null);
                    }
                    else
                    {
                        this.OnReceived(buffer, guid, receiveSocket.RemoteEndPoint, true);
                        //Դ
                        this.ClearReceiveInfo(receiveSocket, bufferBlockIndex);
                    }
                }
                else
                {
                    //Դ
                    this.ClearReceiveInfo(receiveSocket, bufferBlockIndex);
                    //֪ͨ
                    this.OnErrorHappened(new SocketException((int)socketCallbackError), SocketOperation.Receive);
                }
            };

            return receiveCallback;
        }

        private bool ProcessReceivedData(ref byte[] buffer, int receiveLength, int receiveBufferOffset, bool conditionCompleted, string guid, EndPoint remoteEndPoint)
        {
            //յûдﵽĳһֵʱһʱbuffer
            //յݣӶսʱƵĴ
            //ݽ¼ҲԱ¼ĶΪٵݶάһ
            //ݽṹ
            buffer = this.CopyDataToBuffer(buffer, receiveLength, receiveBufferOffset);

            if (!conditionCompleted)
            {
                return buffer.Length > this.ThresholdValue;
            }

            FireDataReceivedEvent(buffer, receiveLength, receiveBufferOffset, guid, remoteEndPoint);

            //ﵽbuffer*******
            if (buffer.Length > 0)
                buffer = new byte[0];

            return true;
        }

        /// <summary>
        /// ݻݸƵָ
        /// </summary>
        /// <param name="buffer"></param>
        /// <param name="receiveLength"></param>
        /// <param name="receiveBufferOffset"></param>
        /// <returns></returns>
        private byte[] CopyDataToBuffer(byte[] buffer, int receiveLength, int receiveBufferOffset)
        {
            int index = buffer.Length;
            Array.Resize(ref buffer, buffer.Length + receiveLength);
            Array.Copy(this.m_BufferManager.ReceiveBuffer, receiveBufferOffset, buffer, index, receiveLength);
            return buffer;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="buffer"></param>
        /// <param name="receiveLength"></param>
        /// <param name="receiveBufferOffset"></param>
        /// <param name="guid"></param>
        /// <param name="remoteEndPoint"></param>
        private void FireDataReceivedEvent(byte[] buffer, int receiveLength, int receiveBufferOffset, string guid, EndPoint remoteEndPoint)
        {
            if (buffer.Length > 0)
            {
                this.OnReceived(buffer, guid, remoteEndPoint, false);
            }
            else
            {
                //½յݽƵ(ǷظԼڴƬ)
                byte[] data = new byte[receiveLength];

                //ƻݵ
                Array.Copy(this.m_BufferManager.ReceiveBuffer, receiveBufferOffset, data, 0, receiveLength);

                //ݸ
                this.OnReceived(data, guid, remoteEndPoint, false);
            }
        }

        /// <summary>
        /// ݺϢ
        /// </summary>
        /// <param name="receiveSocket">׽</param>
        /// <param name="bufferBlockIndex">׽Ľ</param>
        private void ClearReceiveInfo(Socket receiveSocket, int bufferBlockIndex)
        {
            //ͷŻ
            this.m_BufferManager.FreeBufferBlockIndex(bufferBlockIndex);

            receiveSocket.Shutdown(SocketShutdown.Both);
            receiveSocket.Close();
        }

        #endregion

        /// <summary>
        /// ȡTCP׽
        /// </summary>
        /// <param name="sendTimeOut">ͳʱʱ</param>
        /// <param name="receiveTimeOut">ճʱʱ</param>
        /// <returns>TCP׽</returns>
        private Socket GetSocket(int sendTimeOut, int receiveTimeOut)
        {
            Socket socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

            socket.SendTimeout = sendTimeOut;
            socket.ReceiveTimeout = receiveTimeOut;

            return socket;
        }

        #region ȡս
        private static string[] _ips;

        /// <summary>
        /// ȡIPб
        /// </summary>
        /// <returns></returns>
        public static string[] GetLocalIpAddressList()
        {
            try
            {
                if (_ips == null)
                {
                    string strIp = "";
                    string[] ipList = null;
                    IPAddress[] addressList = Dns.GetHostByName(Dns.GetHostName()).AddressList;
                    if (addressList != null && addressList.Length > 0)
                    {
                        for (int i = 0; i < addressList.Length; i++)
                        {
                            strIp += addressList[i].ToString() + ",";
                        }
                    }
                    if (!string.IsNullOrEmpty(strIp))
                    {
                        var str = strIp.Remove(strIp.Length - 1, 1);
                        ipList = str.Split(',');
                        _ips = ipList;
                    }
                }
                return _ips;
            }
            catch (Exception ex)
            {
                PlatformLogger.SystemErrorInfo("GetLocalIpAddressList:error!", ex);
                return new string[] { "127.0.0.1" };
            }
        }
        /// <summary>
        /// ȡIP
        /// </summary>
        /// <returns></returns>
        public static string GetLocalIpv4Address()
        {
            IPAddress ipAddress = GetIpv4Address();

            if (ipAddress != null)
                return ipAddress.ToString();

            return null;
        }

        /// <summary>
        /// ȡIP
        /// </summary>
        /// <returns></returns>
        public static IPAddress GetIpv4Address()
        {
            return GetIpv4Address(Environment.MachineName);
        }
        /// <summary>
        /// ȡָIP
        /// </summary>
        /// <param name="hostNameOrAddress">IPַ</param>
        /// <returns></returns>
        public static IPAddress GetIpv4Address(string hostNameOrAddress)
        {
            try
            {
                IPAddress[] addresses = Dns.GetHostAddresses(hostNameOrAddress);

                foreach (IPAddress address in addresses)
                {
                    if (address.AddressFamily == AddressFamily.InterNetwork)
                    {
                        return address;
                    }
                }

                return null;
            }
            catch (Exception ex)
            {
                PlatformLogger.SystemErrorInfo("GetLocalIpAddressList:error!", ex);
                return IPAddress.Parse("127.0.0.1");
            }
        }

        /// <summary>
        /// ȡս
        /// </summary>
        /// <param name="port">˿ں</param>
        /// <returns>ս</returns>
        private static EndPoint GetIpv4EndPoint(int port)
        {
            return GetIpv4EndPoint(Environment.MachineName, port);
        }

        /// <summary>
        /// ȡԶս
        /// </summary>
        /// <param name="hostNameOrAddress">IPַ</param>
        /// <param name="port">˿ں</param>
        /// <returns>Զս</returns>
        private static EndPoint GetIpv4EndPoint(string hostNameOrAddress, int port)
        {
            IPAddress ipAddress = GetIpv4Address(hostNameOrAddress);

            if (ipAddress != null)
            {
                return new IPEndPoint(ipAddress, port);
            }

            throw new Exception("޷ȡָIPͶ˿ڵս");
        }

        #endregion

        /// <summary>
        /// Դ
        /// </summary>
        public void Dispose()
        {
            this.StopListenning(true);
        }

        #region ¼

        /// <summary>
        /// ¼
        /// </summary>
        private void OnServerStart(int port)
        {
            if (this.ServerStart != null)
            {
                this.ServerStart(this, new ServerPortEventArgs(port));
            }
        }

        /// <summary>
        /// ֹͣ¼
        /// </summary>
        private void OnServerStop(int port)
        {
            if (this.ServerStop != null)
            {
                this.ServerStop(this, new ServerPortEventArgs(port));
            }
        }

        /// <summary>
        /// ʼ¼
        /// </summary>
        private void OnSendStart()
        {
            if (this.SendStart != null)
            {
                this.SendStart(this, EventArgs.Empty);
            }
        }

        /// <summary>
        /// ڷ¼
        /// </summary>
        /// <param name="length">˴η͵ĳ</param>
        private void OnSending(int length)
        {
            if (this.Sending != null)
            {
                this.Sending(this, new DataSendEventArgs(length));
            }
        }

        /// <summary>
        /// ¼
        /// </summary>
        private void OnSendCompleted()
        {
            if (this.SendCompleted != null)
            {
                this.SendCompleted(this, EventArgs.Empty);
            }
        }

        private void OnReceived(byte[] data, string guid, EndPoint remoteEndPoint, bool isCompleted)
        {
            if (this.DataReceived != null)
            {
                this.DataReceived(this, new DataReceivedEventArgs(data, remoteEndPoint, guid, isCompleted));
            }
        }

        /// <summary>
        /// socket¼
        /// </summary>
        /// <param name="socketException"></param>
        private void OnErrorHappened(SocketException socketException, SocketOperation errorOperation)
        {
            if (this.ErrorHappened != null)
            {
                this.ErrorHappened(this, new SocketErrorEventArgs(socketException, errorOperation));
            }
        }

        #endregion
    }

    public enum SocketOperation
    {
        // ժҪ:
        //     û׽ֲ
        None = 0,
        //
        // ժҪ:
        //     һ׽ Accept 
        Accept = 1,
        //
        // ժҪ:
        //     һ׽ Connect 
        Connect = 2,
        //
        // ժҪ:
        //     һ׽ Disconnect 
        Disconnect = 3,
        //
        // ժҪ:
        //     һ׽ Receive 
        Receive = 4,
        //
        // ժҪ:
        //     һ׽ ReceiveFrom 
        ReceiveFrom = 5,
        //
        // ժҪ:
        //     һ׽ ReceiveMessageFrom 
        ReceiveMessageFrom = 6,
        //
        // ժҪ:
        //     һ׽ Send 
        Send = 7,
        //
        // ժҪ:
        //     һ׽ SendPackets 
        SendPackets = 8,
        //
        // ժҪ:
        //     һ׽ SendTo 
        SendTo = 9,

        Bind
    }

    public class ServerPortEventArgs : EventArgs
    {
        private int m_Port;

        public int Port
        {
            get { return m_Port; }
        }

        public ServerPortEventArgs(int port)
        {
            this.m_Port = port;
        }
    }

    public class DataReceivedEventArgs : EventArgs
    {
        private byte[] m_Data;
        /// <summary>
        /// յ
        /// </summary>
        public byte[] Data
        {
            get { return this.m_Data; }
        }

        private EndPoint m_RemoteEndPoint;
        /// <summary>
        /// Զս
        /// </summary>
        public EndPoint RemoteEndPoint
        {
            get { return m_RemoteEndPoint; }
        }

        private string m_Guid;
        /// <summary>
        /// Ψһʶһν
        /// </summary>
        public string Guid
        {
            get { return m_Guid; }
        }

        private bool m_IsCompleted;

        /// <summary>
        /// Ƿ
        /// </summary>
        public bool IsCompleted
        {
            get { return m_IsCompleted; }
        }

        public DataReceivedEventArgs(byte[] data, EndPoint remotePoint, string guid, bool isCompleted)
        {
            this.m_Data = data;
            this.m_RemoteEndPoint = remotePoint;
            this.m_Guid = guid;
            this.m_IsCompleted = isCompleted;
        }
    }

    public class SocketErrorEventArgs : EventArgs
    {
        private SocketException m_SocketException;

        public SocketException SocketException
        {
            get { return this.m_SocketException; }
        }

        private SocketOperation m_ErrorOperation;

        public SocketOperation ErrorOperation
        {
            get { return m_ErrorOperation; }
        }

        public SocketErrorEventArgs(SocketException socketException, SocketOperation errorOperation)
        {
            this.m_SocketException = socketException;
            this.m_ErrorOperation = errorOperation;
        }
    }

    public class DataSendEventArgs : EventArgs
    {
        private int m_Length;

        public int Length
        {
            get { return m_Length; }
        }

        public DataSendEventArgs(int length)
        {
            this.m_Length = length;
        }
    }
}