import Message from "@/views/front/develop/Communication/Message";
import type { SubmitEntry } from './SubmitEntry'

/**
 * 提交契约接口
 */
export interface ISubmitContract {
    /**
     * 提交准备
     * @param message 输出参数，返回生成的报文
     * @returns 准备是否成功
     */
    PreviewSubmitting(message: { value: Message | null }): boolean

    /**
     * 提交入口
     */
    readonly SubmitEntry: SubmitEntry
}

// Vue组合式API封装
export const useSubmitContract = () => {
    return {
        ISubmitContract
    }
}
