import { EntryBase } from '../ContractBase/EntryBase'
import type { PrintContainer } from '../../Platform/Print/PrintContainer'

/**
 * 打印数据入口(抽象类)
 */
export abstract class PrintEntry extends EntryBase {
    /**
     * 批量打印标志
     */
    public IsBatchPrint: boolean = false

    /**
     * 批量打印清单
     */
    public BatchList: PrintContainer[] = []
}

// Vue组合式API封装
export const usePrintEntry = () => {
    return {
        PrintEntry
    }
}