import { reactive } from 'vue'
import type { Message } from '../Communication/Message'
import { AICapacity } from '../ServiceProxy/Ext/ServiceHelper/AICapacity'
import { LoginUserInfo } from '../Models/UserInfo'
import { SystemFunction } from '../Library/Ext/Function/SystemFunction'
import { TFInput } from '../Library/Ext/TradeExtension/TFInput'

/**
 * 对账管理类
 */
export class Reconciles {
    private static _instance: Reconciles
    private readonly _separator = "^|"
    private readonly _netBankcomList: string[] = [
        "账号", "账户序号", "对账期次", "核心余额", 
        "核心余额日期", "用户余额", "用户余额备注", 
        "对账时间", "完结时间", "对账方式", 
        "对账状态", "对账结果", "客户经理"
    ]

    // 字典定义
    private readonly _ID_TYPE_ = new Map<string, string>([
        ["1", "身份证"], ["2", "户口簿"], ["3", "护照"],
        ["4", "军人证"], ["5", "回乡证"], ["6", "士兵证"],
        ["7", "港澳居民来往通行证"], ["8", "企业代码证"],
        ["9", "经营许可证"], ["A", "营业执照"],
        ["B