using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace TellerSystem.Contract.Function
{
    /// <summary>
    /// 查询ATM管理员信息
    /// 通过ATM柜员号查询ATM管理员信息
    /// </summary>
    public class QueryATMGLYXX : TFOutput
    {
        #region Output
        /// <summary>
        /// ATM管理员 0920
        /// 
        /// </summary>
        public string ATMM { get; internal set; }


        #endregion

        #region Input
		/// <summary>
        /// 参数清单
        /// </summary>
        public class Input : TFInput
        {
            /// <summary>
            /// ATM柜员号 0640
            ///  
            /// </summary>
            public string ATM { get; set; }


            /// <summary>                 
            /// 定义业务逻辑              
            /// </summary>                
            /// <returns></returns>  
            public override TFOutput Raise()
            {
                //拉取数据                                  
                var output = new QueryATMGLYXX();
                PageData.TradeAPIs.InitFd(MessageData);
                PageData.TradeAPIs.CommSend(MessageData);
				MessageData.Fd126_5 = MainCode;
                MessageData.Fd16 = "K071";
                MessageData.Fd64 = ATM;

                PageData.TradeAPIs.CallServer(MessageData);
                if (MessageData.Fd12 != "0000")
                {
                    output.IsFailed = true;
                    output.FailureCause = PageData.TradeAPIs.GetError(MessageData);
                }                
                output.ATMM = (MessageData.Fd92);

                return output;
            }
        }
        #endregion
    }
}
