using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace TellerSystem.Contract.Function
{
    /// <summary>
    /// 查询账户详细信息
    /// 查询账户详细信息
    /// </summary>
    public class QueryAccountMoreInfo : TFOutput
    {
        #region Output
        /// <summary>
        /// 内容列表
        /// 活期：INFO账号|开户行|客户号|户名|开户日期|产品名称|账户类型|有无介质|计息类型|介质状态|上笔日期|账户状态|冻结状态|止付状态|利息基数|介质种类|凭证号|是否凭密|证件类型||证件号码|销户行|销户日期|通存通兑|主副标志|主卡卡号|到期日期|冻结金额|止付金额|控制金额|自动转存|结算类型|是否允许提现|，定期：INFO账号|开户行|客户号|户名|开户日期|产品名称|账户类型|有无介质|计息类型|介质状态|上笔日期|账户状态|冻结状态|止付状态|利息基数|介质种类|凭证号|是否凭密|证件类型|利率|证件号码|销户行|销户日期|通存通兑|主副标志|主卡卡号|到期日期|冻结金额|止付金额|控制金额|， 内部帐：INFO账号|户名|产品名称|余额|账户类型|，贷款：账号|开户行|户名|产品名称|开户日期|计息类型|账户状态|上笔日期|到期日期|昨日余额|冻结余额|余额|透支标志|利率|存期|逾期利率|
        /// </summary>
        public string NRLB { get; internal set; }


        #endregion

        #region Input
		/// <summary>
        /// 参数清单
        /// </summary>
        public class Input : TFInput
        {
            /// <summary>
            /// 账号 0380
            ///  
            /// </summary>
            public string ZH { get; set; }

            /// <summary>
            /// 账户序号 0510
            ///  
            /// </summary>
            public string ZHXH { get; set; }

            /// <summary>
            /// 查询标志 0660
            /// 1活期2定期9内部 
            /// </summary>
            public string CXBZ { get; set; }


            /// <summary>                 
            /// 定义业务逻辑              
            /// </summary>                
            /// <returns></returns>  
            public override TFOutput Raise()
            {
                //拉取数据                                  
                var output = new QueryAccountMoreInfo();
                PageData.TradeAPIs.InitFd(MessageData);
                PageData.TradeAPIs.CommSend(MessageData);
				MessageData.Fd126_5 = MainCode;
                MessageData.Fd16 = "CXCL";
                MessageData.Fd38 = ZH;
                MessageData.Fd51 = ZHXH;
                MessageData.Fd66 = CXBZ;
                MessageData.Fd128 = "0072";

                PageData.TradeAPIs.CallServer(MessageData);
                if (MessageData.Fd12 != "0000")
                {
                    output.IsFailed = true;
                    output.FailureCause = PageData.TradeAPIs.GetError(MessageData);
                }                
                output.NRLB = MessageData.FileData;

                return output;
            }
        }
        #endregion
    }
}
