using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace TellerSystem.Contract.Function
{
    /// <summary>
    /// 9598查询-880201-查询活期明细
    /// 880201-查询活期明细
    /// </summary>
    public class QueryCurrentDetail : TFOutput
    {
        #region Output
        /// <summary>
        /// 查询结果
        /// 文件格式:交易金额
        /// </summary>
        public string CXJG { get; internal set; }


        #endregion

        #region Input
		/// <summary>
        /// 参数清单
        /// </summary>
        public class Input : TFInput
        {
            /// <summary>
            /// 查询条件 1230
            /// 1,880201,账户id,账户序号,交易日期,流水号,交易金额, 
            /// </summary>
            public string CXTJ { get; set; }


            /// <summary>                 
            /// 定义业务逻辑              
            /// </summary>                
            /// <returns></returns>  
            public override TFOutput Raise()
            {
                //拉取数据                                  
                var output = new QueryCurrentDetail();
                PageData.TradeAPIs.InitFd(MessageData);
                PageData.TradeAPIs.CommSend(MessageData);
				MessageData.Fd126_5 = MainCode;
                MessageData.Fd16 = "9598";
                MessageData.Fd123 = CXTJ;

                PageData.TradeAPIs.CallServer(MessageData);
                if (MessageData.Fd12 != "0000")
                {
                    output.IsFailed = true;
                    output.FailureCause = PageData.TradeAPIs.GetError(MessageData);
                }                
                output.CXJG = MessageData.FileData;

                return output;
            }
        }
        #endregion
    }
}
