using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace TellerSystem.Contract.Function
{
    /// <summary>
    /// 查询假币收缴信息
    /// 通过收缴凭证编号查询假币收缴信息
    /// </summary>
    public class QueryJBSJXX : TFOutput
    {
        #region Output
        /// <summary>
        /// 收缴编号使用标志 0670
        /// Y-收缴凭证编号已存在 N-未使用
        /// </summary>
        public string SJBHSYBZ { get; internal set; }


        #endregion

        #region Input
		/// <summary>
        /// 参数清单
        /// </summary>
        public class Input : TFInput
        {
            /// <summary>
            /// 收缴凭证编号 0380
            ///  
            /// </summary>
            public string SJPZBH { get; set; }


            /// <summary>                 
            /// 定义业务逻辑              
            /// </summary>                
            /// <returns></returns>  
            public override TFOutput Raise()
            {
                //拉取数据                                  
                var output = new QueryJBSJXX();
                PageData.TradeAPIs.InitFd(MessageData);
                PageData.TradeAPIs.CommSend(MessageData);
				MessageData.Fd126_5 = MainCode;
                MessageData.Fd16 = "K070";
                MessageData.Fd38 = SJPZBH;

                PageData.TradeAPIs.CallServer(MessageData);
                if (MessageData.Fd12 != "0000")
                {
                    output.IsFailed = true;
                    output.FailureCause = PageData.TradeAPIs.GetError(MessageData);
                }                
                output.SJBHSYBZ = (MessageData.Fd67);

                return output;
            }
        }
        #endregion
    }
}
