using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace TellerSystem.Contract.Function
{
    /// <summary>
    /// 9598查询-540001-查询小额支付交易主表
    /// 小额往帐拒绝、往帐扎差
    /// </summary>
    public class QueryMicroPaymentList : TFOutput
    {
        #region Output
        /// <summary>
        /// 查询结果
        /// 文件格式:交易状态
        /// </summary>
        public string CXJG { get; internal set; }

        /// <summary>
        /// 查询结果
        /// 文件格式:交易状态
        /// </summary>
        public List<E_CXJG> CXJGData { get; internal set; }

        /// <summary>
        /// 查询结果
        /// 文件格式:交易状态
        /// </summary>
        public class E_CXJG
        {
            /// <summary>
            /// 交易状态
            /// </summary>
            public string JYZT { get; set; }

        }

        #endregion

        #region Input
		/// <summary>
        /// 参数清单
        /// </summary>
        public class Input : TFInput
        {
            /// <summary>
            /// 查询条件 
            /// 委托日期
            /// </summary>
            public string WTRQ { get; set; }

            /// <summary>
            /// 查询条件 
            /// 支付交易序号
            /// </summary>
            public string ZFJYXH { get; set; }


            /// <summary>                 
            /// 定义业务逻辑              
            /// </summary>                
            /// <returns></returns>  
            public override TFOutput Raise()
            {
                //拉取数据                                  
                var output = new QueryMicroPaymentList();
                PageData.TradeAPIs.InitFd(MessageData);
                PageData.TradeAPIs.CommSend(MessageData);
				MessageData.Fd126_5 = MainCode;
                MessageData.Fd16 = "9598";
                MessageData.Fd123 = string.Format("1,540001,{0},{1},",WTRQ,ZFJYXH);

                PageData.TradeAPIs.CallServer(MessageData);
                if (MessageData.Fd12 != "0000")
                {
                    output.IsFailed = true;
                    output.FailureCause = PageData.TradeAPIs.GetError(MessageData);
                }                
                output.CXJGData = AnilyzeFileData<E_CXJG>(MessageData.FileData,
                                            "交易状态|",
                                            x =>
                                            {
                                                return new E_CXJG
                                                {
                                                    JYZT = x["交易状态"]
                                                };
                                            });
                output.CXJG = MessageData.FileData;

                return output;
            }
        }
        #endregion
    }
}
