using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace TellerSystem.Contract.Function
{
    /// <summary>
    /// 客户短信发送明细查询
    /// 客户短信发送明细查询
    /// </summary>
    public class QuerySMSSendRecords : TFOutput
    {
        #region Output
        /// <summary>
        /// 文件
        /// 交易码|账号|户名|客户号|操作员|流水号|交易日期|交易时间|交易地点|交易金额|账面余额|渠道类型|业务类型|短信签约类型|操作码|手机号码|信息内容|定时发送标志|定时日期|定时时间|发送次数|发送日期|发送时间|本次应收费|处理标志|柜员流水号|
        /// </summary>
        public string WJ { get; internal set; }

        /// <summary>
        /// 文件
        /// 交易码|账号|户名|客户号|操作员|流水号|交易日期|交易时间|交易地点|交易金额|账面余额|渠道类型|业务类型|短信签约类型|操作码|手机号码|信息内容|定时发送标志|定时日期|定时时间|发送次数|发送日期|发送时间|本次应收费|处理标志|柜员流水号|
        /// </summary>
        public List<E_WJ> WJData { get; internal set; }

        /// <summary>
        /// 文件
        /// 交易码|账号|户名|客户号|操作员|流水号|交易日期|交易时间|交易地点|交易金额|账面余额|渠道类型|业务类型|短信签约类型|操作码|手机号码|信息内容|定时发送标志|定时日期|定时时间|发送次数|发送日期|发送时间|本次应收费|处理标志|柜员流水号|
        /// </summary>
        public class E_WJ
        {
            /// <summary>
            /// 交易码
            /// </summary>
            public string JYM { get; set; }

            /// <summary>
            /// 账号
            /// </summary>
            public string ZH { get; set; }

            /// <summary>
            /// 户名
            /// </summary>
            public string HM { get; set; }

            /// <summary>
            /// 客户号
            /// </summary>
            public string KHH { get; set; }

            /// <summary>
            /// 操作员
            /// </summary>
            public string CZY { get; set; }

            /// <summary>
            /// 流水号
            /// </summary>
            public string LSH { get; set; }

            /// <summary>
            /// 交易日期
            /// </summary>
            public string JYRQ { get; set; }

            /// <summary>
            /// 交易时间
            /// </summary>
            public string JYSJ { get; set; }

            /// <summary>
            /// 交易地点
            /// </summary>
            public string JYDD { get; set; }

            /// <summary>
            /// 交易金额
            /// </summary>
            public string JYJE { get; set; }

            /// <summary>
            /// 账面余额
            /// </summary>
            public string ZMYE { get; set; }

            /// <summary>
            /// 渠道类型
            /// </summary>
            public string QDLX { get; set; }

            /// <summary>
            /// 业务类型
            /// </summary>
            public string YWLX { get; set; }

            /// <summary>
            /// 短信签约类型
            /// </summary>
            public string DXQYLX { get; set; }

            /// <summary>
            /// 操作码
            /// </summary>
            public string CZM { get; set; }

            /// <summary>
            /// 手机号码
            /// </summary>
            public string SJHM { get; set; }

            /// <summary>
            /// 信息内容
            /// </summary>
            public string XXNR { get; set; }

            /// <summary>
            /// 定时发送标志
            /// </summary>
            public string DSFSBZ { get; set; }

            /// <summary>
            /// 定时日期
            /// </summary>
            public string DSRQ { get; set; }

            /// <summary>
            /// 定时时间
            /// </summary>
            public string DSSJ { get; set; }

            /// <summary>
            /// 发送次数
            /// </summary>
            public string FSCS { get; set; }

            /// <summary>
            /// 发送日期
            /// </summary>
            public string FSRQ { get; set; }

            /// <summary>
            /// 发送时间
            /// </summary>
            public string FSSJ { get; set; }

            /// <summary>
            /// 本次应收费
            /// </summary>
            public string BCYSF { get; set; }

            /// <summary>
            /// 处理标志
            /// </summary>
            public string CLBZ { get; set; }

            /// <summary>
            /// 柜员流水号
            /// </summary>
            public string GYLSH { get; set; }

        }

        #endregion

        #region Input
		/// <summary>
        /// 参数清单
        /// </summary>
        public class Input : TFInput
        {
            /// <summary>
            /// 账号 0300
            ///  
            /// </summary>
            public string ZH { get; set; }

            /// <summary>
            /// 交易日期起 0440
            ///  
            /// </summary>
            public string JYRQQ { get; set; }

            /// <summary>
            /// 交易日期止 0450
            ///  
            /// </summary>
            public string JYRQZ { get; set; }

            /// <summary>
            /// 手机号码 0620
            ///  
            /// </summary>
            public string SJHM { get; set; }

            /// <summary>
            /// 交易代码 0640
            ///  
            /// </summary>
            public string JYDM { get; set; }


            /// <summary>                 
            /// 定义业务逻辑              
            /// </summary>                
            /// <returns></returns>  
            public override TFOutput Raise()
            {
                //拉取数据                                  
                var output = new QuerySMSSendRecords();
                PageData.TradeAPIs.InitFd(MessageData);
                PageData.TradeAPIs.CommSend(MessageData);
				MessageData.Fd126_5 = MainCode;
                MessageData.Fd16 = "CXCL";
                MessageData.Fd30 = ZH;
                MessageData.Fd44 = JYRQQ;
                MessageData.Fd45 = JYRQZ;
                MessageData.Fd62 = SJHM;
                MessageData.Fd64 = JYDM;
                MessageData.Fd128 = "0059";

                PageData.TradeAPIs.CallServer(MessageData);
                if (MessageData.Fd12 != "0000")
                {
                    output.IsFailed = true;
                    output.FailureCause = PageData.TradeAPIs.GetError(MessageData);
                }                
                output.WJData = AnilyzeFileData<E_WJ>(MessageData.FileData,
                                            "交易码|账号|户名|客户号|操作员|流水号|交易日期|交易时间|交易地点|交易金额|账面余额|渠道类型|业务类型|短信签约类型|操作码|手机号码|信息内容|定时发送标志|定时日期|定时时间|发送次数|发送日期|发送时间|本次应收费|处理标志|柜员流水号|",
                                            x =>
                                            {
                                                return new E_WJ
                                                {
                                                    JYM = x["交易码"],
                                                    ZH = x["账号"],
                                                    HM = x["户名"],
                                                    KHH = x["客户号"],
                                                    CZY = x["操作员"],
                                                    LSH = x["流水号"],
                                                    JYRQ = x["交易日期"],
                                                    JYSJ = x["交易时间"],
                                                    JYDD = x["交易地点"],
                                                    JYJE = x["交易金额"],
                                                    ZMYE = x["账面余额"],
                                                    QDLX = x["渠道类型"],
                                                    YWLX = x["业务类型"],
                                                    DXQYLX = x["短信签约类型"],
                                                    CZM = x["操作码"],
                                                    SJHM = x["手机号码"],
                                                    XXNR = x["信息内容"],
                                                    DSFSBZ = x["定时发送标志"],
                                                    DSRQ = x["定时日期"],
                                                    DSSJ = x["定时时间"],
                                                    FSCS = x["发送次数"],
                                                    FSRQ = x["发送日期"],
                                                    FSSJ = x["发送时间"],
                                                    BCYSF = x["本次应收费"],
                                                    CLBZ = x["处理标志"],
                                                    GYLSH = x["柜员流水号"]
                                                };
                                            });
                output.WJ = MessageData.FileData;

                return output;
            }
        }
        #endregion
    }
}
