import { reactive, ref } from 'vue'

import { CheckConditionElements } from './CheckConditionElements'
import { PageBase } from "@/views/front/develop/Constract/ContractBase/PageBase"
import { TradeBusData } from "@/views/front/develop/Library.Ext/TradeExtension/TradeInfo/TradeBusData"
import { TradeInfoData } from "@/views/front/develop/Library.Ext/TradeExtension/TradeInfo/TradeInfoData"
// import { CheckDataHelper } from './CheckDataHelper'
import { CheckElements } from './CheckElements'
import LoginUserInfo from "@/views/front/platfrom/common/RunningParameters/LoginUserInfo";
import Message from "@/views/front/develop/Communication/Message"
// import { TradeHandle } from '../../Library/Ext/TradeExtension/TradeHandle'

/**
 * 复核和授权结果类型
 */
export enum AsksuperResultType {
    Success = 0,
    Failed = 1,
    Undo = 2
}

/**
 * 复核对象，交易中使用此对象来提交一个复核请求
 */
export class CheckManager {
    private static _instance: CheckManager
    private _systemSerialNumber: string = ''

    public static get Instance(): CheckManager {
        if (!CheckManager._instance) {
            CheckManager._instance = new CheckManager()
        }
        return CheckManager._instance
    }

    get SystemSerialNumber(): string {
        return this._systemSerialNumber
    }
    set SystemSerialNumber(value: string) {
        this._systemSerialNumber = value
    }

    // 复核有结果时触发的事件
    public onAsksuperResult: ((result: AsksuperResultType, busData: TradeBusData) => void) | null = null

    /**
     * 检查是否符合复核条件并提交申请复核
     */
    public async DoSuper(
        target: PageBase,
        element: CheckConditionElements,
        msg: Message,
        funcnum: string,
        accountno: string,
        amount: number,
        custname: string,
        des: string
    ): Promise<boolean> {
        const t = await this.CheckSuper(target, element, msg, "", funcnum)//hulei-r这里需要重构获取交易码现有的逻辑是通过tradeinfodata中的数据获取到的 这里暂时用空代替
        //TradeInfoData.GetTradeInfo(target).TradeBus

        if (t) {
            const tradedata = ""////hulei-r这里需要重构获取交易码现有的逻辑是通过tradeinfodata中的数据获取到的全局的数据 同上 暂时也用空代替 TradeInfoData.GetTradeInfo(target).TradeBus
            tradedata["MSG"] = target.Serialize(msg)//hulei-r序列化与反序列化实现
            return this.AskSuper(target, this.GetIPageElements(target), accountno, amount, custname, des)
        }
        return true
    }

    /**
     * 得到tradepage中的需要复核回显和复核的数据项
     */
    private GetIPageElements(page: PageBase): CheckElements {
        const elements = this.CollectElements(page)
        const checkElements = new CheckElements()

        elements.forEach(element => {
            // 处理不同类型控件的转换逻辑
            // ...
        })

        return checkElements
    }

    /**
     * 收集需要复核的元素
     */
    private CollectElements(page: PageBase): any[] {
        const elements: any[] = []
        // 实现元素收集逻辑
        // ...
        return elements
    }

    /**
     * 检查复核
     */
    private async CheckSuper(
        target: PageBase,
        element: CheckConditionElements,
        msg: Message,
        tradeNo: string,
        funcnum: string
    ): Promise<boolean> {
        // 实现复核检查逻辑
        // ...
        return false
    }

    /**
     * 申请复核
     */
    private async AskSuper(
        target: PageBase,
        superdata: CheckElements,
        accountno: string,
        amount: number,
        custname: string,
        des: string
    ): Promise<boolean> {
        // 实现复核申请逻辑
        // ...
        return false
    }

    /**
     * 整合核心返回要素值与前台要素值
     */
    private MergeElement(element: CheckConditionElements, msg: Message): string {
        return JSON.stringify({
            Message: msg.SerializeForAuth(),//hulei-r SerializeForAuth方法没有 需要具体实现
            Element: element.JsonValue
        })
    }
}

// Vue组合式API封装
export const useCheckManager = () => {
    const checkManager = reactive(CheckManager.Instance)
    return {
        checkManager,
        AsksuperResultType
    }
}
