using System;                                                 
using System.Collections.Generic;                             
using System.Linq;                                            
using System.Text;                                            
using TellerSystem.Contract.ContractBase;                     
                                                              
namespace TellerSystem.Contract.Function                      
{                                                             
    /*###############################                         
     * 所加接口请添加详细的备注信息                           
     * 接口命名规则                                           
     * TF_Deposit_AccountInfo (前缀+存款+实体)                
     *                                                        
     * #########################*/                            
    /// <summary>                                             
    /// 交易对外封装的接口                                    
    /// </summary>                                            
    public static class TradeFunction                         
    {                                                         
        #region Customer  客户
        /// <summary>                                                                                                             
        /// 查询客户账户信息
        /// 通过证件信息查询该客户所有账户
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryAccountInfoByCustomer TF_Customer_QueryAccountInfoByCustomer(this TradeAPIsHelper target, QueryAccountInfoByCustomer.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryAccountInfoByCustomer>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 客户信息查询
        /// 根据客户号、账号、证件类型及号码查询并返回客户信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCustomerInformation TF_Customer_QueryCustomerInformation(this TradeAPIsHelper target, QueryCustomerInformation.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCustomerInformation>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 客户查询
        /// 根据证件类型证件号查询已开立的客户
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCustomer TF_Customer_QueryCustomer(this TradeAPIsHelper target, QueryCustomer.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCustomer>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 对公关联证件查询
        /// 查询该客户已关联的证件信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryEnterpriseRelationID TF_Customer_QueryEnterpriseRelationID(this TradeAPIsHelper target, QueryEnterpriseRelationID.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryEnterpriseRelationID>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 客户信息查询-文件
        /// 根据客户号查询客户信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCustomerInfoByCode TF_Customer_QueryCustomerInfoByCode(this TradeAPIsHelper target, QueryCustomerInfoByCode.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCustomerInfoByCode>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 黑名单信息信息
        /// 通过证件信息查询黑名单信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryBlackList TF_Customer_QueryBlackList(this TradeAPIsHelper target, QueryBlackList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryBlackList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 收费黑白名单查询
        /// 收费黑白名单查询
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryFeeBlackList TF_Customer_QueryFeeBlackList(this TradeAPIsHelper target, QueryFeeBlackList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryFeeBlackList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 客户经理客户账户关联关系查询
        /// 客户经理客户账户关联关系查询
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCM2CARef TF_Customer_QueryCM2CARef(this TradeAPIsHelper target, QueryCM2CARef.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCM2CARef>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 对公客户信息查询
        /// 根据对公户名查询客户信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryEnterpriseCustomerInfo TF_Customer_QueryEnterpriseCustomerInfo(this TradeAPIsHelper target, QueryEnterpriseCustomerInfo.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryEnterpriseCustomerInfo>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 客户综合签约
        /// 客户综合签约
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static MessageComprehensive TF_Customer_MessageComprehensive(this TradeAPIsHelper target, MessageComprehensive.Input input)                    
        {                                                                                                                         
            return input.DoAction<MessageComprehensive>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 客户综合签约
        /// 电话签约
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static PhoneComprehensive TF_Customer_PhoneComprehensive(this TradeAPIsHelper target, PhoneComprehensive.Input input)                    
        {                                                                                                                         
            return input.DoAction<PhoneComprehensive>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 短信明细信息查询
        /// 短信明细信息查询
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QuerySMSList TF_Customer_QuerySMSList(this TradeAPIsHelper target, QuerySMSList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QuerySMSList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 短信业务信息查询
        /// 短信业务信息查询
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QuerySMSInfo TF_Customer_QuerySMSInfo(this TradeAPIsHelper target, QuerySMSInfo.Input input)                    
        {                                                                                                                         
            return input.DoAction<QuerySMSInfo>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 客户经理信息查询
        /// 客户经理信息查询
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCustomerManagerInfo TF_Customer_QueryCustomerManagerInfo(this TradeAPIsHelper target, QueryCustomerManagerInfo.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCustomerManagerInfo>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 客户短信发送明细查询
        /// 客户短信发送明细查询
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QuerySMSSendRecords TF_Customer_QuerySMSSendRecords(this TradeAPIsHelper target, QuerySMSSendRecords.Input input)                    
        {                                                                                                                         
            return input.DoAction<QuerySMSSendRecords>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询电话银行
        /// 通过卡号或存折号查询详细信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryDHYH TF_Customer_QueryDHYH(this TradeAPIsHelper target, QueryDHYH.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryDHYH>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 综合签约查询
        /// 通过账号查询签约信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryZHQY TF_Customer_QueryZHQY(this TradeAPIsHelper target, QueryZHQY.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryZHQY>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 客户存款量查询
        /// 根据证件类型证件号码查询客户存款量
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryKHCKL TF_Customer_QueryKHCKL(this TradeAPIsHelper target, QueryKHCKL.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryKHCKL>(target.Page);                                                                      
        }                                                                                                                        

        #endregion
        #region Deposit  存取款
        /// <summary>                                                                                                             
        /// 查询卡申请登记簿(文件)
        /// 通过输入申请编号查询卡申请登记簿相关信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCardApplyRecord TF_Deposit_QueryCardApplyRecord(this TradeAPIsHelper target, QueryCardApplyRecord.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCardApplyRecord>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询账户计划扣划信息
        /// 通过账号查询账户计划扣划信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryAccountDeductInfo TF_Deposit_QueryAccountDeductInfo(this TradeAPIsHelper target, QueryAccountDeductInfo.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryAccountDeductInfo>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询子账户信息
        /// 通过账号查询子账户信息列表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryChildAccountList TF_Deposit_QueryChildAccountList(this TradeAPIsHelper target, QueryChildAccountList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryChildAccountList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 产品与产品关系表查询-产品二
        /// 根据委托存款类型查询并返回存款列表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryProductRelations_Pro2 TF_Deposit_QueryProductRelations_Pro2(this TradeAPIsHelper target, QueryProductRelations_Pro2.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryProductRelations_Pro2>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 产品与产品关系表查询-产品一
        /// 根据委托存款类型查询并返回存款列表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryProductRelations_Pro1 TF_Deposit_QueryProductRelations_Pro1(this TradeAPIsHelper target, QueryProductRelations_Pro1.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryProductRelations_Pro1>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 指定一级科目下的活期产品
        /// 根据一级科目号、介质代码查询产品列表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static ProductUnderLevelSubjects TF_Deposit_ProductUnderLevelSubjects(this TradeAPIsHelper target, ProductUnderLevelSubjects.Input input)                    
        {                                                                                                                         
            return input.DoAction<ProductUnderLevelSubjects>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 获取利率
        /// 根据输入的币种、计息类型获取利率
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static GetRates TF_Deposit_GetRates(this TradeAPIsHelper target, GetRates.Input input)                    
        {                                                                                                                         
            return input.DoAction<GetRates>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 证件号码验证
        /// 证件合法性验证
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static IDNumberVerification TF_Deposit_IDNumberVerification(this TradeAPIsHelper target, IDNumberVerification.Input input)                    
        {                                                                                                                         
            return input.DoAction<IDNumberVerification>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 密码验证
        /// 对传入的柜员密码或是凭证密码单或是账号密码进行验证
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static PasswordAuthentication TF_Deposit_PasswordAuthentication(this TradeAPIsHelper target, PasswordAuthentication.Input input)                    
        {                                                                                                                         
            return input.DoAction<PasswordAuthentication>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询存款账户信息
        /// 通过账号查询账户信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryDepositAccount TF_Deposit_QueryDepositAccount(this TradeAPIsHelper target, QueryDepositAccount.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryDepositAccount>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询黑名单信息
        /// 通过账号/证件类型/客户号查询黑名单信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>
        public static CheckBlackList TF_Deposit_CheckBlackList(this TradeAPIsHelper target, CheckBlackList.Input input)                    
        {
            return input.DoAction<CheckBlackList>(target.Page);                                                                      
        }

        /// <summary>                                                                                                             
        /// 查询道琼斯黑名单信息
        /// 通过账号/证件类型/客户号查询黑名单信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>
        public static CheckBlackList_DQS TF_Deposit_CheckBlackList_DQS(this TradeAPIsHelper target, CheckBlackList_DQS.Input input)
        {
            return input.DoAction<CheckBlackList_DQS>(target.Page);
        }

        /// <summary>                                                                                                             
        /// 查询灰名单信息
        /// 通过账号/证件类型、证件号/客户号/单位编号查询灰名单信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>
        public static CheckGreyList TF_Deposit_CheckGreyList(this TradeAPIsHelper target, CheckGreyList.Input input)
        {
            return input.DoAction<CheckGreyList>(target.Page);
        }                                          

        /// <summary>                                                                                                             
        /// 具体账户利息测算
        /// 通过账号计算账户利息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static AccountInterestCalculation TF_Deposit_AccountInterestCalculation(this TradeAPIsHelper target, AccountInterestCalculation.Input input)                    
        {                                                                                                                         
            return input.DoAction<AccountInterestCalculation>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询挂失信息
        /// 通过账号查询挂失相关信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryReportLossInformation TF_Deposit_QueryReportLossInformation(this TradeAPIsHelper target, QueryReportLossInformation.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryReportLossInformation>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询账户冻结信息
        /// 通过账号查询账户冻结信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryFreezeAccountInformation TF_Deposit_QueryFreezeAccountInformation(this TradeAPIsHelper target, QueryFreezeAccountInformation.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryFreezeAccountInformation>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询公共参数表
        /// 通过参数代码查询公共产品参数表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryPublicParameter TF_Deposit_QueryPublicParameter(this TradeAPIsHelper target, QueryPublicParameter.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryPublicParameter>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 统计单一客户或账户当天交易额
        /// 以客户级或账户级为单位统计当天交易额
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static StatisticsSingleCustomerOraccountDayturnover TF_Deposit_StatisticsSingleCustomerOraccountDayturnover(this TradeAPIsHelper target, StatisticsSingleCustomerOraccountDayturnover.Input input)                    
        {                                                                                                                         
            return input.DoAction<StatisticsSingleCustomerOraccountDayturnover>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询科目信息
        /// 通过科目号查询科目信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QuerySubjectsInformation TF_Deposit_QuerySubjectsInformation(this TradeAPIsHelper target, QuerySubjectsInformation.Input input)                    
        {                                                                                                                         
            return input.DoAction<QuerySubjectsInformation>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询产品信息
        /// 通过产品代码查询产品信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryProductInformation TF_Deposit_QueryProductInformation(this TradeAPIsHelper target, QueryProductInformation.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryProductInformation>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询账户开户信息
        /// 通过账号查询账户开户信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryAccountOpeningInformation TF_Deposit_QueryAccountOpeningInformation(this TradeAPIsHelper target, QueryAccountOpeningInformation.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryAccountOpeningInformation>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 检查客户凭证
        /// 客户凭证查询
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static CheckCustomerCertificate TF_Deposit_CheckCustomerCertificate(this TradeAPIsHelper target, CheckCustomerCertificate.Input input)                    
        {                                                                                                                         
            return input.DoAction<CheckCustomerCertificate>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询账户扣划利息
        /// 通过账号查询账户扣划未提取利息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static CheckAccountDeducInterest TF_Deposit_CheckAccountDeducInterest(this TradeAPIsHelper target, CheckAccountDeducInterest.Input input)                    
        {                                                                                                                         
            return input.DoAction<CheckAccountDeducInterest>(target.Page);                                                                      
        }

        /// <summary>                                                                                                             
        /// 与平台通讯，查询账户黑白名单状态
        /// 黑名单-阻断，灰名单-提示，白名单-通过
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static CheckAccountStat TF_Deposit_CheckAccountStat(this TradeAPIsHelper target, CheckAccountStat.Input input)
        {
            return input.DoAction<CheckAccountStat>(target.Page);
        } 

        /// <summary>                                                                                                             
        /// 查询介质属性信息
        /// 通过介质代码查询介质属性
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryMediaAttributeInformation TF_Deposit_QueryMediaAttributeInformation(this TradeAPIsHelper target, QueryMediaAttributeInformation.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryMediaAttributeInformation>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询卡申请登记簿信息
        /// 通过申请序号或卡号或证件信息查询卡申请登记簿
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCardApplicationRregister TF_Deposit_QueryCardApplicationRregister(this TradeAPIsHelper target, QueryCardApplicationRregister.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCardApplicationRregister>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 根据存款类型、存期查询定期产品信息
        /// 根据存款类型、存期查询定期产品信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryFixedDepositProduct TF_Deposit_QueryFixedDepositProduct(this TradeAPIsHelper target, QueryFixedDepositProduct.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryFixedDepositProduct>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 交易规则检查
        /// 交易规则检查,账户序号检查，根据交易代码,账号,交易金额检查是否超出限额
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static CheckTradeRule TF_Deposit_CheckTradeRule(this TradeAPIsHelper target, CheckTradeRule.Input input)                    
        {                                                                                                                         
            return input.DoAction<CheckTradeRule>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询客户允许的介质列表
        /// 根据客户级别和客户种类返回活期和定期的介质列表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCustomerDielectric TF_Deposit_QueryCustomerDielectric(this TradeAPIsHelper target, QueryCustomerDielectric.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCustomerDielectric>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询交易规则要素列表
        /// 通过列表类型查询list_code_rel
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryListCodeRel TF_Deposit_QueryListCodeRel(this TradeAPIsHelper target, QueryListCodeRel.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryListCodeRel>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询dic_data表
        /// 通过项目编号查询dic_data表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryDicData TF_Deposit_QueryDicData(this TradeAPIsHelper target, QueryDicData.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryDicData>(target.Page);                                                                      
        }

        /// <summary>                                                                                                             
        /// 查询定期存期类型
        /// 根据介质代码查询支持的定期产品存期类型
        /// </summary>                                                                                                         
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryFixedDepositDateType TF_Deposit_QueryFixedDepositDateType(this TradeAPIsHelper target, QueryFixedDepositDateType.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryFixedDepositDateType>(target.Page);                                                                      
        }

        /// <summary>                                                                                                             
        /// 查询职业列表
        /// 根据查询类型  职业编码查询职业列表
        /// </summary>   
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryJobTypeList TF_Deposit_QueryJobTypeList(this TradeAPIsHelper target, QueryJobTypeList.Input input)
        {
            return input.DoAction<QueryJobTypeList>(target.Page);
        }                                                                                                        

        /// <summary>                                                                                                             
        /// 查询介质代码支持的产品列表
        /// 通过介质种类查询该介质支持的产品代码及产品名称
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryProductListByDielectric TF_Deposit_QueryProductListByDielectric(this TradeAPIsHelper target, QueryProductListByDielectric.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryProductListByDielectric>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 模糊查询dic_data表
        /// 通过项目编号模糊查询dic_data表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryDicDataVague TF_Deposit_QueryDicDataVague(this TradeAPIsHelper target, QueryDicDataVague.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryDicDataVague>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 受托支付支取额度查询
        /// 根据账号查询受托支付支取额度
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryFixedPay TF_Deposit_QueryFixedPay(this TradeAPIsHelper target, QueryFixedPay.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryFixedPay>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询产品存期
        /// 通过定期产品类型查询产品存期
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryProductPeriod TF_Deposit_QueryProductPeriod(this TradeAPIsHelper target, QueryProductPeriod.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryProductPeriod>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 收费业务费用编号查询
        /// 收费业务费用编号查询
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryFeeNumberList TF_Deposit_QueryFeeNumberList(this TradeAPIsHelper target, QueryFeeNumberList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryFeeNumberList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询交易流水信息
        /// 通过流水号、交易日期、柜员号、账号、账户序号查询交易流水信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryTradeSerialInfo TF_Deposit_QueryTradeSerialInfo(this TradeAPIsHelper target, QueryTradeSerialInfo.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryTradeSerialInfo>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 冻结登记簿查询
        /// 根据账号、序号查询冻结登记簿
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryFreezeList TF_Deposit_QueryFreezeList(this TradeAPIsHelper target, QueryFreezeList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryFreezeList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 计划扣划信息查询
        /// 查询计划扣划登记簿
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryDeductPlanInfo TF_Deposit_QueryDeductPlanInfo(this TradeAPIsHelper target, QueryDeductPlanInfo.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryDeductPlanInfo>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 冻结止付扣划预判
        /// 冻结止付扣划预判
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static AnticipationFreezeStoppaymentDeduct TF_Deposit_AnticipationFreezeStoppaymentDeduct(this TradeAPIsHelper target, AnticipationFreezeStoppaymentDeduct.Input input)                    
        {                                                                                                                         
            return input.DoAction<AnticipationFreezeStoppaymentDeduct>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询卡号段列表
        /// 根据介质代码查询卡号段列表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCardNoPartList TF_Deposit_QueryCardNoPartList(this TradeAPIsHelper target, QueryCardNoPartList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCardNoPartList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询卡面列表
        /// 根据介质代码查询卡面列表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCardSurfaceList TF_Deposit_QueryCardSurfaceList(this TradeAPIsHelper target, QueryCardSurfaceList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCardSurfaceList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询客户允许的卡介质列表
        /// 根据客户级别和卡种类返回卡介质列表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCardListOfCustomer TF_Deposit_QueryCardListOfCustomer(this TradeAPIsHelper target, QueryCardListOfCustomer.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCardListOfCustomer>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 制卡申请预判
        /// 记名卡申请、非记名卡批量制卡申请预判
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryMakeCardApplyJudge TF_Deposit_QueryMakeCardApplyJudge(this TradeAPIsHelper target, QueryMakeCardApplyJudge.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryMakeCardApplyJudge>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询挂失登记簿列表
        /// 通过账号查询挂失登记簿列表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryLostRecords TF_Deposit_QueryLostRecords(this TradeAPIsHelper target, QueryLostRecords.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryLostRecords>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询划款协议登记明细表
        /// 根据账号查询划款协议登记明细表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryPaymentAgreementRecords TF_Deposit_QueryPaymentAgreementRecords(this TradeAPIsHelper target, QueryPaymentAgreementRecords.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryPaymentAgreementRecords>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 巧得利签约查询
        /// 通过账号查询签约信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QuerySignContractQDL TF_Deposit_QuerySignContractQDL(this TradeAPIsHelper target, QuerySignContractQDL.Input input)                    
        {                                                                                                                         
            return input.DoAction<QuerySignContractQDL>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询划款协议账号关系表
        /// 根据账号查询划款协议关系表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryPaymentAgreementAccountRelation TF_Deposit_QueryPaymentAgreementAccountRelation(this TradeAPIsHelper target, QueryPaymentAgreementAccountRelation.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryPaymentAgreementAccountRelation>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询代理单位信息
        /// 根据输入代理单位编号查询信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryUnitInformation TF_Deposit_QueryUnitInformation(this TradeAPIsHelper target, QueryUnitInformation.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryUnitInformation>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 返回印鉴卡号的关联情况
        /// 返回印鉴卡号的关联情况
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QuerySealCardLinkInfo TF_Deposit_QuerySealCardLinkInfo(this TradeAPIsHelper target, QuerySealCardLinkInfo.Input input)                    
        {                                                                                                                         
            return input.DoAction<QuerySealCardLinkInfo>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询转开对公定期账户
        /// 查询指定账号转开的定期账户列表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryEnterprisePeriodicalAccount TF_Deposit_QueryEnterprisePeriodicalAccount(this TradeAPIsHelper target, QueryEnterprisePeriodicalAccount.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryEnterprisePeriodicalAccount>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 根据账号查询分户信息
        /// 根据账号查询分户信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryAccountFHList TF_Deposit_QueryAccountFHList(this TradeAPIsHelper target, QueryAccountFHList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryAccountFHList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询划款协议主账号签约信息
        /// 查询划款协议主账号签约信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryHKXYMainAccountLinkInfo TF_Deposit_QueryHKXYMainAccountLinkInfo(this TradeAPIsHelper target, QueryHKXYMainAccountLinkInfo.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryHKXYMainAccountLinkInfo>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询存款证明明细表
        /// 根据止付日期和止付流水查询存款证明明细表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryDepositRecordList TF_Deposit_QueryDepositRecordList(this TradeAPIsHelper target, QueryDepositRecordList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryDepositRecordList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询账户明细
        /// 查询账户明细
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryAccountDetail TF_Deposit_QueryAccountDetail(this TradeAPIsHelper target, QueryAccountDetail.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryAccountDetail>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询账户详细信息
        /// 查询账户详细信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryAccountMoreInfo TF_Deposit_QueryAccountMoreInfo(this TradeAPIsHelper target, QueryAccountMoreInfo.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryAccountMoreInfo>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 根据户名、证件、状态查询分户信息
        /// 根据户名、证件、状态查询分户信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryIndividualInfo TF_Deposit_QueryIndividualInfo(this TradeAPIsHelper target, QueryIndividualInfo.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryIndividualInfo>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 账户通存通兑信息查询
        /// 账户通存通兑信息查询
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryAccountTCTD TF_Deposit_QueryAccountTCTD(this TradeAPIsHelper target, QueryAccountTCTD.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryAccountTCTD>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 特殊信息查询
        /// 获取某些信息的记录是否存在，状态是否正常等
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QuerySpecialInfo TF_Deposit_QuerySpecialInfo(this TradeAPIsHelper target, QuerySpecialInfo.Input input)                    
        {                                                                                                                         
            return input.DoAction<QuerySpecialInfo>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 根据协议号查询委托协议登记簿
        /// 根据协议号查询委托协议登记簿
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryWTXYDJB TF_Deposit_QueryWTXYDJB(this TradeAPIsHelper target, QueryWTXYDJB.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryWTXYDJB>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 现金付出/接收调剂记录查询根据新旧卡号和换证日期查询换证登记簿
        /// 根据新旧卡号和换证日期查询换证登记簿
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryHZDJB TF_Deposit_QueryHZDJB(this TradeAPIsHelper target, QueryHZDJB.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryHZDJB>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询单位IC卡信息(文件)
        /// 通过卡号及账户状态查询单位IC详细信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryDWICKXX TF_Deposit_QueryDWICKXX(this TradeAPIsHelper target, QueryDWICKXX.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryDWICKXX>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询卡折一体信息(文件)
        /// 通过卡号或存折号查询详细信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryKZYTXX TF_Deposit_QueryKZYTXX(this TradeAPIsHelper target, QueryKZYTXX.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryKZYTXX>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询主子卡信息(文件)
        /// 通过主卡号或子卡号查询单位IC详细信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryZZKXX TF_Deposit_QueryZZKXX(this TradeAPIsHelper target, QueryZZKXX.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryZZKXX>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 对公活期销户条件查询
        /// 根据对公活期账户查询关联支票数量是否符合销户条件并返回转开账户数量
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryDGHQXHTJ TF_Deposit_QueryDGHQXHTJ(this TradeAPIsHelper target, QueryDGHQXHTJ.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryDGHQXHTJ>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 机构信用代码证查询(文件)
        /// 通过账号或机构信用代码证查询账户信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryJGXYDMZ TF_Deposit_QueryJGXYDMZ(this TradeAPIsHelper target, QueryJGXYDMZ.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryJGXYDMZ>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询揽存登记簿
        /// 查询揽存登记簿
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryLCDJB TF_Deposit_QueryLCDJB(this TradeAPIsHelper target, QueryLCDJB.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryLCDJB>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 印鉴卡/支付密码器查询关联明细查询
        /// 根据帐户或印鉴卡/支付密码器查询关联明细信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryYJKZFMMQGLMX TF_Deposit_QueryYJKZFMMQGLMX(this TradeAPIsHelper target, QueryYJKZFMMQGLMX.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryYJKZFMMQGLMX>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 对公通存通兑签约查询
        /// 对公通存通兑签约查询
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryDGTCTDQY TF_Deposit_QueryDGTCTDQY(this TradeAPIsHelper target, QueryDGTCTDQY.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryDGTCTDQY>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询到期证件
        /// 查询到期证件
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryDQZJ TF_Deposit_QueryDQZJ(this TradeAPIsHelper target, QueryDQZJ.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryDQZJ>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 学子卡信息查询
        /// 学子卡信息查询
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryXZKXX TF_Deposit_QueryXZKXX(this TradeAPIsHelper target, QueryXZKXX.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryXZKXX>(target.Page);                                                                      
        }                                                                                                                        

        #endregion
        #region Loan  贷款
        /// <summary>                                                                                                             
        /// 查询贷款产品信息
        /// 根据贷款类别加载产品列表数据
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryLoanProductInfo TF_Loan_QueryLoanProductInfo(this TradeAPIsHelper target, QueryLoanProductInfo.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryLoanProductInfo>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询委托协议登记信息
        /// 通过委托编号查询委托协议信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryDelegateRegistration TF_Loan_QueryDelegateRegistration(this TradeAPIsHelper target, QueryDelegateRegistration.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryDelegateRegistration>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 综合授信卡信息查询
        /// 通过授信卡号查询授信信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryIntegratedCreditCard TF_Loan_QueryIntegratedCreditCard(this TradeAPIsHelper target, QueryIntegratedCreditCard.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryIntegratedCreditCard>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询贷款账号信息
        /// 通过贷款账号查询账户信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryLoanAccount TF_Loan_QueryLoanAccount(this TradeAPIsHelper target, QueryLoanAccount.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryLoanAccount>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询审批信息
        /// 通过借据号查询借据信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryApprovalInformation TF_Loan_QueryApprovalInformation(this TradeAPIsHelper target, QueryApprovalInformation.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryApprovalInformation>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询委托贷款关系及可用余额
        /// 查询委托贷款基金户与收息户关系及基金户可用余额
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryRelationEntrustedLoanAndavailableBalance TF_Loan_QueryRelationEntrustedLoanAndavailableBalance(this TradeAPIsHelper target, QueryRelationEntrustedLoanAndavailableBalance.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryRelationEntrustedLoanAndavailableBalance>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询贷款信息列表
        /// 根据贷款账号返回相关列表信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryLoanList TF_Loan_QueryLoanList(this TradeAPIsHelper target, QueryLoanList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryLoanList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询按揭欠款表
        /// 根据贷款账号返回按揭贷款欠款信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryLoanArrearList TF_Loan_QueryLoanArrearList(this TradeAPIsHelper target, QueryLoanArrearList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryLoanArrearList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询通知登记薄
        /// 通过贷款账号查询通知登记薄
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryNotifyRecords TF_Loan_QueryNotifyRecords(this TradeAPIsHelper target, QueryNotifyRecords.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryNotifyRecords>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询贷款信息
        /// 根据贷款账号返回相关信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryLoanInfo TF_Loan_QueryLoanInfo(this TradeAPIsHelper target, QueryLoanInfo.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryLoanInfo>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询还款顺序表
        /// 查询贷款还款顺序表返回相关列表信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryRevertLoanList TF_Loan_QueryRevertLoanList(this TradeAPIsHelper target, QueryRevertLoanList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryRevertLoanList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询还款账号信息表
        /// 根据贷款账号返回还款账号信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryRevertLoanAccount TF_Loan_QueryRevertLoanAccount(this TradeAPIsHelper target, QueryRevertLoanAccount.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryRevertLoanAccount>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询还款计划审批信息
        /// 通过借据号查询还款计划审批表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryRepaymentPlanApproval TF_Loan_QueryRepaymentPlanApproval(this TradeAPIsHelper target, QueryRepaymentPlanApproval.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryRepaymentPlanApproval>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询抵质押品信息(文件)
        /// 通过合同号查询抵质押品信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCollateralInformationOfFile TF_Loan_QueryCollateralInformationOfFile(this TradeAPIsHelper target, QueryCollateralInformationOfFile.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCollateralInformationOfFile>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 按揭当前与欠款查询
        /// 按揭当前与欠款查询
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryMortgageDebt TF_Loan_QueryMortgageDebt(this TradeAPIsHelper target, QueryMortgageDebt.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryMortgageDebt>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 利率变更查询(文件)
        /// 通过输入账号等查询利率变更相关信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryRateChangeRecord TF_Loan_QueryRateChangeRecord(this TradeAPIsHelper target, QueryRateChangeRecord.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryRateChangeRecord>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 抵质押物库存查询(文件)
        /// 根据相关要素，返回符合条件的库存抵质押品列表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCollateralStock TF_Loan_QueryCollateralStock(this TradeAPIsHelper target, QueryCollateralStock.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCollateralStock>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询抵质押品更改信息(文件)
        /// 通过合同号查询抵质押品更改信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCollateralInformationChangedOfFile TF_Loan_QueryCollateralInformationChangedOfFile(this TradeAPIsHelper target, QueryCollateralInformationChangedOfFile.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCollateralInformationChangedOfFile>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询抵质押关联信息(文件)
        /// 通过合同号查询抵质押关联信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCollateralInformationLinkOfFile TF_Loan_QueryCollateralInformationLinkOfFile(this TradeAPIsHelper target, QueryCollateralInformationLinkOfFile.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCollateralInformationLinkOfFile>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 根据抵质押编号查询抵质押品信息
        /// 通过抵质押编号查询抵质押品信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCollateralInformationByCode TF_Loan_QueryCollateralInformationByCode(this TradeAPIsHelper target, QueryCollateralInformationByCode.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCollateralInformationByCode>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询抵质押明细信息(文件)
        /// 通过抵质押查询抵质押明细信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCollateralDetail TF_Loan_QueryCollateralDetail(this TradeAPIsHelper target, QueryCollateralDetail.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCollateralDetail>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询抵质押品入库信息(文件)
        /// 通过抵质押品编号|抵质押品序号|抵质押品名称|抵质押类型|质押单号|当前状态查询抵质押信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCollateralInInfo TF_Loan_QueryCollateralInInfo(this TradeAPIsHelper target, QueryCollateralInInfo.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCollateralInInfo>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 合同号查询抵质押信息
        /// 合同号查询抵质押信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCollateralInformationByHTCode TF_Loan_QueryCollateralInformationByHTCode(this TradeAPIsHelper target, QueryCollateralInformationByHTCode.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCollateralInformationByHTCode>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 借据号查询受托支付审批信息(文件)
        /// 借据号查询受托支付审批信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QuerySTZFSPXX TF_Loan_QuerySTZFSPXX(this TradeAPIsHelper target, QuerySTZFSPXX.Input input)                    
        {                                                                                                                         
            return input.DoAction<QuerySTZFSPXX>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 根据支取协议号查询协议相关信息
        /// 根据支取协议号查询协议相关信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryZQXYXX TF_Loan_QueryZQXYXX(this TradeAPIsHelper target, QueryZQXYXX.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryZQXYXX>(target.Page);                                                                      
        }                                                                                                                        

        #endregion
        #region Fund  资金
        /// <summary>                                                                                                             
        /// 根据打包合同号查询录入或已审核的贴现信息
        /// 根据合同号查询所有的录入或已审核的贴现信息，返回文件
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryAccordPackingNum TF_Fund_QueryAccordPackingNum(this TradeAPIsHelper target, QueryAccordPackingNum.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryAccordPackingNum>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 根据承兑汇票协议编号查询协议信息
        /// 根据承兑汇票协议编号查询承兑汇票协议详细信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryAcceptanceAgreementNum TF_Fund_QueryAcceptanceAgreementNum(this TradeAPIsHelper target, QueryAcceptanceAgreementNum.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryAcceptanceAgreementNum>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询承兑汇票票据信息
        /// 根据输入的承兑汇票号码查询该票据信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryAcceptanceInformation TF_Fund_QueryAcceptanceInformation(this TradeAPIsHelper target, QueryAcceptanceInformation.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryAcceptanceInformation>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询委托收款汇票信息
        /// 根据输入的外行票据号码查询已登记的外行委托收款票据信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryDelegateBillInfomation TF_Fund_QueryDelegateBillInfomation(this TradeAPIsHelper target, QueryDelegateBillInfomation.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryDelegateBillInfomation>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 根据保函协议编号查询协议信息
        /// 根据保函协议编号查询保函登记簿的详细信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryGuaranteeInfomationByNum TF_Fund_QueryGuaranteeInfomationByNum(this TradeAPIsHelper target, QueryGuaranteeInfomationByNum.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryGuaranteeInfomationByNum>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询保证金利率信息
        /// 根据协议编号和协议类型查询保证金利率登记簿的详细信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryDepositInterest TF_Fund_QueryDepositInterest(this TradeAPIsHelper target, QueryDepositInterest.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryDepositInterest>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询贴现信息
        /// 根据协议编号和查询标志或票据号和票据类型或贴现账号查询贴现登记簿信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryDiscounting TF_Fund_QueryDiscounting(this TradeAPIsHelper target, QueryDiscounting.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryDiscounting>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 计算贴现利息
        /// 根据输入的要素计算贴现利息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static CountedInterest TF_Fund_CountedInterest(this TradeAPIsHelper target, CountedInterest.Input input)                    
        {                                                                                                                         
            return input.DoAction<CountedInterest>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 大额查复报文查询
        /// 根据支付行号、委托日期、序号查询大额查复报文信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryLargePackets TF_Fund_QueryLargePackets(this TradeAPIsHelper target, QueryLargePackets.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryLargePackets>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询支付行号信息
        /// 根据输入的支付行号查询行名等信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryPayLineNumber TF_Fund_QueryPayLineNumber(this TradeAPIsHelper target, QueryPayLineNumber.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryPayLineNumber>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 根据质押总编号查询关联总金额和总数量
        /// 根据质押总编号查询关联总金额和总数量
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static CheckStatusPledge TF_Fund_CheckStatusPledge(this TradeAPIsHelper target, CheckStatusPledge.Input input)                    
        {                                                                                                                         
            return input.DoAction<CheckStatusPledge>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 承兑保函查询抵质押品信息
        /// 承兑保函查询抵质押品信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCDBHDZYP TF_Fund_QueryCDBHDZYP(this TradeAPIsHelper target, QueryCDBHDZYP.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCDBHDZYP>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 借据号查询承兑汇票信息(文件)
        /// 借据号查询承兑汇票信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCDHPXX TF_Fund_QueryCDHPXX(this TradeAPIsHelper target, QueryCDHPXX.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCDHPXX>(target.Page);                                                                      
        }                                                                                                                        

        #endregion
        #region Manage  管理
        /// <summary>                                                                                                             
        /// 待入库卡凭证查询
        /// 根据凭证类别-卡和制卡批次回显卡凭证信息列表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryStoragingCard TF_Manage_QueryStoragingCard(this TradeAPIsHelper target, QueryStoragingCard.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryStoragingCard>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 柜员/ATM长短款处理信息查询
        /// 根据相关要素，返回相应长短款处理状态信息列表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCountTellerATMLength TF_Manage_QueryCountTellerATMLength(this TradeAPIsHelper target, QueryCountTellerATMLength.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCountTellerATMLength>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 凭证付出/收入及信息记录查询
        /// 根据对方柜员和发生日期，返回相应的该柜员付出调剂在途信息列表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCertificatePayIncome TF_Manage_QueryCertificatePayIncome(this TradeAPIsHelper target, QueryCertificatePayIncome.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCertificatePayIncome>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 凭证审批下发/收缴、收入/上缴申请等信息记录查询
        /// 根据相关要素，返回相应的等待该柜员审批的下发申请记录列表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCertificateIssuedIncome TF_Manage_QueryCertificateIssuedIncome(this TradeAPIsHelper target, QueryCertificateIssuedIncome.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCertificateIssuedIncome>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 现金付出/接收调剂记录查询
        /// 根据相关要素，返回该柜员做过的现金付出调剂在途等待对方接收的调剂记录
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCashPayReceiveRecords TF_Manage_QueryCashPayReceiveRecords(this TradeAPIsHelper target, QueryCashPayReceiveRecords.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCashPayReceiveRecords>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 现金下发/收缴、领入/上缴申请或审批等记录查询
        /// 根据相关要素，返回相应的该柜员已申请在途的现金信息列表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCashIssuedIncomeRecords TF_Manage_QueryCashIssuedIncomeRecords(this TradeAPIsHelper target, QueryCashIssuedIncomeRecords.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCashIssuedIncomeRecords>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 柜员信息查询
        /// 柜员信息查询
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryTellerInformation TF_Manage_QueryTellerInformation(this TradeAPIsHelper target, QueryTellerInformation.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryTellerInformation>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 柜员交接验证
        /// 验证柜员能否交接并回显现金凭证信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static TellerTransitionVerification TF_Manage_TellerTransitionVerification(this TradeAPIsHelper target, TellerTransitionVerification.Input input)                    
        {                                                                                                                         
            return input.DoAction<TellerTransitionVerification>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 机构信息查询
        /// 根据输入机构编号查询机构信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryDepartmentInformation TF_Manage_QueryDepartmentInformation(this TradeAPIsHelper target, QueryDepartmentInformation.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryDepartmentInformation>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 单笔查询吞卡登记簿
        /// 通过输入卡号查询吞卡信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QuerySingleTunkaRegister TF_Manage_QuerySingleTunkaRegister(this TradeAPIsHelper target, QuerySingleTunkaRegister.Input input)                    
        {                                                                                                                         
            return input.DoAction<QuerySingleTunkaRegister>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询ATM收回金额
        /// 根据相关要素，返回ATM可收回现金金额
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryAmountsRecoveredATM TF_Manage_QueryAmountsRecoveredATM(this TradeAPIsHelper target, QueryAmountsRecoveredATM.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryAmountsRecoveredATM>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// ATM待清机金额
        /// 根据相关要素，返回ATM清机现金金额
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static ATMAmountClearing TF_Manage_ATMAmountClearing(this TradeAPIsHelper target, ATMAmountClearing.Input input)                    
        {                                                                                                                         
            return input.DoAction<ATMAmountClearing>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询ATM账户信息
        /// 根据相关要素，返回ATM机帐户各种现金金额
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryATMAccountInformation TF_Manage_QueryATMAccountInformation(this TradeAPIsHelper target, QueryATMAccountInformation.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryATMAccountInformation>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 检查柜员凭证最小号
        /// 根据相关要素，检查柜员凭证最小号
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static ChecksTellerSmallestCertificate TF_Manage_ChecksTellerSmallestCertificate(this TradeAPIsHelper target, ChecksTellerSmallestCertificate.Input input)                    
        {                                                                                                                         
            return input.DoAction<ChecksTellerSmallestCertificate>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 根据凭证类别查询凭证类型
        /// 查询介质属性表返回相关信息列表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryVoucherTypeByClass TF_Manage_QueryVoucherTypeByClass(this TradeAPIsHelper target, QueryVoucherTypeByClass.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryVoucherTypeByClass>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 柜员凭证信息查询
        /// 通过柜员号查询柜员凭证台账
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryNormalCertificate TF_Manage_QueryNormalCertificate(this TradeAPIsHelper target, QueryNormalCertificate.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryNormalCertificate>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询柜员待领入/待收缴凭证信息
        /// 通过柜员号查询该柜员待领入/待收缴凭证信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCollarintoCertificate TF_Manage_QueryCollarintoCertificate(this TradeAPIsHelper target, QueryCollarintoCertificate.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCollarintoCertificate>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 客户凭证汇总查询
        /// 根据帐号或证件，返回客户所有的凭证信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCustomerCertificateList TF_Manage_QueryCustomerCertificateList(this TradeAPIsHelper target, QueryCustomerCertificateList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCustomerCertificateList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 现金调拨查询
        /// 通过现金管理员查询申请调拨的信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCashAllocate TF_Manage_QueryCashAllocate(this TradeAPIsHelper target, QueryCashAllocate.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCashAllocate>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 根据帐户或印鉴卡/支付密码器查询关联信息
        /// 根据帐户或印鉴卡/支付密码器查询关联信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryAccountPaymentPwdConnection TF_Manage_QueryAccountPaymentPwdConnection(this TradeAPIsHelper target, QueryAccountPaymentPwdConnection.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryAccountPaymentPwdConnection>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 批量查询柜员状态
        /// 批量查询柜员状态
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryTellerStatusBatch TF_Manage_QueryTellerStatusBatch(this TradeAPIsHelper target, QueryTellerStatusBatch.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryTellerStatusBatch>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 账户支付密码器关联查询
        /// 账户支付密码器关联查询
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryAccountPayment TF_Manage_QueryAccountPayment(this TradeAPIsHelper target, QueryAccountPayment.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryAccountPayment>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 错误码同步
        /// 错误码同步
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryErrorCodeInfo TF_Manage_QueryErrorCodeInfo(this TradeAPIsHelper target, QueryErrorCodeInfo.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryErrorCodeInfo>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询mo_fake表返回没收记录(文件)
        /// 查询mo_fake表返回没收记录
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryMoFakeRecord TF_Manage_QueryMoFakeRecord(this TradeAPIsHelper target, QueryMoFakeRecord.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryMoFakeRecord>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 假币没收多笔查询(文件)
        /// 查询没收假币的详细信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryJBMSDBJL TF_Manage_QueryJBMSDBJL(this TradeAPIsHelper target, QueryJBMSDBJL.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryJBMSDBJL>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询假币收缴信息
        /// 通过收缴凭证编号查询假币收缴信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryJBSJXX TF_Manage_QueryJBSJXX(this TradeAPIsHelper target, QueryJBSJXX.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryJBSJXX>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询ATM管理员信息
        /// 通过ATM柜员号查询ATM管理员信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryATMGLYXX TF_Manage_QueryATMGLYXX(this TradeAPIsHelper target, QueryATMGLYXX.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryATMGLYXX>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 机构现金库存查询
        /// 根据机构号查询现金库存
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryDQJGXX TF_Manage_QueryDQJGXX(this TradeAPIsHelper target, QueryDQJGXX.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryDQJGXX>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 密码器验证-临时为特殊用户使用
        /// 密码器验证-临时为特殊用户使用
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static YZMMQ TF_Manage_YZMMQ(this TradeAPIsHelper target, YZMMQ.Input input)                    
        {                                                                                                                         
            return input.DoAction<YZMMQ>(target.Page);                                                                      
        }                                                                                                                        

        #endregion
        #region Public  公共
        /// <summary>                                                                                                             
        /// 柜员钱箱信息查询
        /// 根据相关要素，返回相应机构下所有柜员钱箱信息列表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryTellerCashBox TF_Public_QueryTellerCashBox(this TradeAPIsHelper target, QueryTellerCashBox.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryTellerCashBox>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// LIST下拉菜单列表下载
        /// 下载LIST菜单
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryComboBoxData TF_Public_QueryComboBoxData(this TradeAPIsHelper target, QueryComboBoxData.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryComboBoxData>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 9598查询-210201-查询存款证明登记簿
        /// 210201-查询存款证明登记簿
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryDepositProveList_210201 TF_Public_QueryDepositProveList_210201(this TradeAPIsHelper target, QueryDepositProveList_210201.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryDepositProveList_210201>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 9598查询-210202-查询存款证明登记簿
        /// 210202-查询存款证明登记簿
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryDepositProveList_210202 TF_Public_QueryDepositProveList_210202(this TradeAPIsHelper target, QueryDepositProveList_210202.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryDepositProveList_210202>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 9598查询-210203-查询客户基本信息
        /// 210203-查询客户基本信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCustomerBaseInfoList TF_Public_QueryCustomerBaseInfoList(this TradeAPIsHelper target, QueryCustomerBaseInfoList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCustomerBaseInfoList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 9598查询-211201-查询批量开户明细表
        /// 211201-查询批量开户明细表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryBatchOpenAccountList TF_Public_QueryBatchOpenAccountList(this TradeAPIsHelper target, QueryBatchOpenAccountList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryBatchOpenAccountList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 9598查询-221001-查询公共参数表
        /// 221001-查询公共参数表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryPublicArgumentList TF_Public_QueryPublicArgumentList(this TradeAPIsHelper target, QueryPublicArgumentList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryPublicArgumentList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 9598查询-282901-特殊协定利息计算登记簿
        /// 282901-特殊协定利息计算登记簿
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QuerySpecialAgreedRateList TF_Public_QuerySpecialAgreedRateList(this TradeAPIsHelper target, QuerySpecialAgreedRateList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QuerySpecialAgreedRateList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 9598查询-501801-查询大额支付表
        /// 501801-查询大额支付表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryLargePaymentList TF_Public_QueryLargePaymentList(this TradeAPIsHelper target, QueryLargePaymentList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryLargePaymentList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 9598查询-540001-查询小额支付交易主表
        /// 小额往帐拒绝、往帐扎差
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryMicroPaymentList TF_Public_QueryMicroPaymentList(this TradeAPIsHelper target, QueryMicroPaymentList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryMicroPaymentList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 9598查询-540201-查询小额附加域主表
        /// 540201-查询小额附加域主表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryMicroPaymentAttachList TF_Public_QueryMicroPaymentAttachList(this TradeAPIsHelper target, QueryMicroPaymentAttachList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryMicroPaymentAttachList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 9598查询-700101-查询凭证柜员权限表
        /// 700101-查询凭证柜员权限表
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCertificateTellerPowerList TF_Public_QueryCertificateTellerPowerList(this TradeAPIsHelper target, QueryCertificateTellerPowerList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCertificateTellerPowerList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 9598查询-710001-查询现金审批表
        /// 提出申请
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCashApproveList_710001 TF_Public_QueryCashApproveList_710001(this TradeAPIsHelper target, QueryCashApproveList_710001.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCashApproveList_710001>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 9598查询-710003-查询现金审批表
        /// 网点提现的审批 拒绝申请 
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCashApproveList_710003 TF_Public_QueryCashApproveList_710003(this TradeAPIsHelper target, QueryCashApproveList_710003.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCashApproveList_710003>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 9598查询-710201-查询现金审批表
        /// 批准申请、上缴待收入
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCashApproveList_710201 TF_Public_QueryCashApproveList_710201(this TradeAPIsHelper target, QueryCashApproveList_710201.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCashApproveList_710201>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 9598查询-710202-查询现金审批表
        /// 批准申请、下发待领入
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCashApproveList_710202 TF_Public_QueryCashApproveList_710202(this TradeAPIsHelper target, QueryCashApproveList_710202.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCashApproveList_710202>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 利率查询(前台首页)
        /// 查询存贷款产品对应的利率值
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryRateList TF_Public_QueryRateList(this TradeAPIsHelper target, QueryRateList.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryRateList>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 9598查询-880201-查询活期明细
        /// 880201-查询活期明细
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCurrentDetail TF_Public_QueryCurrentDetail(this TradeAPIsHelper target, QueryCurrentDetail.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCurrentDetail>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 查询社保信息
        /// 根据输入协议编号查询社保信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QuerySocialInsuranceInfo TF_Public_QuerySocialInsuranceInfo(this TradeAPIsHelper target, QuerySocialInsuranceInfo.Input input)                    
        {                                                                                                                         
            return input.DoAction<QuerySocialInsuranceInfo>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 卡折校验磁道信息
        /// 卡折校验磁道信息
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryCardMsrInfo TF_Public_QueryCardMsrInfo(this TradeAPIsHelper target, QueryCardMsrInfo.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryCardMsrInfo>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 收费查询
        /// 根据交易代码、账号、业务类型等预算收费
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryFeePaymentInfo TF_Public_QueryFeePaymentInfo(this TradeAPIsHelper target, QueryFeePaymentInfo.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryFeePaymentInfo>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 9598查询-880202-批量结果查询
        /// 880202-批量结果查询
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryBatchResult TF_Public_QueryBatchResult(this TradeAPIsHelper target, QueryBatchResult.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryBatchResult>(target.Page);                                                                      
        }                                                                                                                        

        /// <summary>                                                                                                             
        /// 9598查询-799701-查询凭证密码是否打印
        /// 799701-查询活期明细
        /// </summary>                                                                                                            
        /// <param name="target">对业务API的访问服务类进行扩展</param>                                                            
        /// <param name="input">传入参数</param>                                                                                  
        /// <returns>返回数据实体</returns>                                                                                   
        public static QueryPZMMDY TF_Public_QueryPZMMDY(this TradeAPIsHelper target, QueryPZMMDY.Input input)                    
        {                                                                                                                         
            return input.DoAction<QueryPZMMDY>(target.Page);                                                                      
        }                                                                                                                        

        #endregion
    }                                                         
}
