﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.Specialized;
using Platform.ServiceProxy.ServiceFunction.Entitys;
using System.Collections.ObjectModel;
using System.Windows.Forms;
using System.IO;

namespace TellerSystem.Controls.Ext.Controls
{
    public partial class CaptureViewer
    {
        private ObservableCollection<attachImage> _ImageCollection = null;

        public CaptureViewer()
        {
            
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            //openFileDialog.InitialDirectory = "";
            openFileDialog.Filter = "图片文件|*.jpg";
            openFileDialog.RestoreDirectory = true;
            openFileDialog.FilterIndex = 1;
            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                string[] files = openFileDialog.FileNames;

                for (int i = 0; i < files.Length; i++)
                {
                    attachImage img = new attachImage();
                    FileStream stream = new FileInfo(files[i]).OpenRead();
                    img.Bytes = new Byte[stream.Length];
                    stream.Read(img.Bytes, 0, Convert.ToInt32(stream.Length));

                    this._ImageCollection.Add(img);
                }
            }
        }

        internal ObservableCollection<attachImage> ImageCollection
        {
            get
            {
                if (this._ImageCollection == null)
                    this._ImageCollection = new ObservableCollection<attachImage>();

                return this._ImageCollection;
            }
        }

        internal class attachImage : DependencyObject
        {
            public byte[] Bytes
            {
                get { return (byte[])GetValue(BytesProperty); }
                set { SetValue(BytesProperty, value); }
            }

            // Using a DependencyProperty as the backing store for Bytes.  This enables animation, styling, binding, etc...
            public static readonly DependencyProperty BytesProperty =
                DependencyProperty.Register("Bytes", typeof(byte[]), typeof(attachImage), new UIPropertyMetadata(new byte[0]));
        }
    }
}

////using System;
////using System.Collections.Generic;
////using System.Linq;
////using System.Text;
////using System.Windows;
////using System.Windows.Controls;
////using System.Windows.Data;
////using System.Windows.Documents;
////using System.Windows.Input;
////using System.Windows.Media;
////using System.Windows.Media.Imaging;
////using System.Windows.Navigation;
////using System.Windows.Shapes;
////using System.Collections.Specialized;
////using Platform.ServiceProxy.ServiceFunction.Entitys;

////namespace TellerSystem.Controls.Ext.Controls
////{
////    /// <summary>
////    /// CaptureViewer.xaml 的交互逻辑
////    /// </summary>
////    public partial class CaptureViewer
////    {
////        #region 交易内部变量
////        public Dictionary<BitmapSource, Dictionary<string, object>> _imagesDict;

////        /// <summary>
////        /// 捕获的图像数据
////        /// </summary>
////        public List<string> CaptureImageList
////        {
////            get;
////            set;
////        }

////        private AttchedFiles[] _imageList;
////        public AttchedFiles[] ImageList
////        {
////            get { return _imageList; }
////            set
////            {
////                _imageList = value;
////                this.NotifyPropertyChanged("ImageList");
////            }
////        }

////        #region 交易变量定义
////        /* 定义变量 */

////        #endregion
////        #endregion

////        #region 逻辑代码
////        public CaptureViewer()
////        {
////            CaptureImageList = new List<string>();
////            InitializeComponent();
////            imageCapture.SelectedImages.Clear();
////            imageCapture.SelectedImages.CollectionChanged += new NotifyCollectionChangedEventHandler(SelectedImages_CollectionChanged);
////            imageCapture.ImageClick += new RoutedEventHandler(ImageClick);
////        }

////        /// <summary>
////        /// 缩略图点击事件
////        /// </summary>
////        /// <param name="sender"></param>
////        /// <param name="e"></param>
////        private void ImageClick(object sender, RoutedEventArgs e)
////        {
////            Comments.Text = string.Empty;

////            var selectedBi = imageCapture.SelectedBitmapSource;
////            if (_imagesDict.ContainsKey(selectedBi))
////            {
////                object comments;
////                if (_imagesDict[selectedBi].TryGetValue("Comments", out comments))
////                {
////                    Comments.Text = (string)comments;
////                }
////                return;
////            }

////        }
////        /// <summary>
////        /// 图像集合改变事件
////        /// </summary>
////        /// <param name="sender"></param>
////        /// <param name="e"></param>
////        void SelectedImages_CollectionChanged(object sender, NotifyCollectionChangedEventArgs e)
////        {
////            Comments.Text = string.Empty;
////            if (e.Action == NotifyCollectionChangedAction.Add)
////            {
////                _imagesDict.Add((BitmapSource)e.NewItems[0], new Dictionary<string, object>() { { "Comments", Comments.Text } });
////            }
////            else if (e.Action == NotifyCollectionChangedAction.Remove)
////            {
////                if (_imagesDict.ContainsKey((BitmapSource)e.OldItems[0]))
////                {
////                    _imagesDict.Remove((BitmapSource)e.OldItems[0]);
////                }
////            }
////        }

////        /// <summary>
////        /// 图片信息保存按钮
////        /// </summary>
////        /// <param name="sender"></param>
////        /// <param name="e"></param>
////        private void SaveInfoButton_Click(object sender, RoutedEventArgs e)
////        {
////            var selectedBi = imageCapture.SelectedBitmapSource;
////            //更新或添加
////            if (selectedBi != null)
////            {
////                if (_imagesDict.ContainsKey(selectedBi))
////                {
////                    object comments;
////                    if (_imagesDict[selectedBi].TryGetValue("Comments", out comments))
////                    {
////                        if (Comments.Text != (string)comments)
////                        {
////                            _imagesDict[selectedBi]["Comments"] = Comments.Text;
////                        }
////                    }
////                    else
////                    {
////                        _imagesDict[selectedBi].Add("Comments", Comments.Text);
////                    }
////                }
////                else
////                {
////                    _imagesDict.Add(selectedBi, new Dictionary<string, object>() { { "Comments", Comments.Text } });
////                }
////            }

////        }

////        /// <summary>
////        /// 初始化逻辑
////        /// </summary>
////        protected override void OnTradePageLoaded()
////        {
////            base.OnTradePageLoaded();

////            //初始化页面
////            InitPage();

////        }

////        /// <summary>
////        /// 初始化页面元素
////        /// </summary>
////        private void InitPage()
////        {
////            _imagesDict = new Dictionary<BitmapSource, Dictionary<string, object>>();
////        }


////        #endregion

////        private void SubmitButton_Click(object sender, RoutedEventArgs e)
////        {

////            TransDictToImageList(_imagesDict);
////            var ids = PutAttachedFiles(ImageList);

////            //this.OwnerContainer.CloseTradePage(this, "ImageList");
////            CaptureImageList.AddRange(ids);
////            imageCapture.DisposeImageCap();
////            this.Close();
////        }

////        private void CancelButton_Click(object sender, RoutedEventArgs e)
////        {
////            this.Close();

////        }

////        private void CameraButton_Click(object sender, RoutedEventArgs e)
////        {
////            imageCapture.DisposeImageCap();
////        }

////        private void TransDictToImageList(Dictionary<BitmapSource, Dictionary<string, object>> imagesDict)
////        {
////            ImageList = new AttchedFiles[imagesDict.Count];
////            int i = 0;
////            int j = 0;
////            foreach (var image in imagesDict)
////            {
////                var propsKv = new MyKV[image.Value.Count];
////                foreach (var prop in image.Value)
////                {
////                    propsKv[j] = new MyKV() { kVal = prop.Key, vVal = prop.Value };
////                    if (j == image.Value.Count - 1) break;
////                    j++;
////                }
////                var img = new AttchedFiles()
////                              {
////                                  filedata = TradePageExtension.BitmapSourceToByte(image.Key),
////                                  fileinfo = propsKv
////                              };Platform.Presentation.PageFunctions.TradePage
////                ImageList[i] = img;
////                i++;
////            }
////        }

////        private void TradePage_Closed(object sender, Client.Presentation.PageClosedEventArgs e)
////        {
////            imageCapture.DisposeImageCap();
////        }
////    }
////}
