﻿using System;
using System.Windows;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.IO;
using Platform.Controls.ControlsHelper;
using Platform.Library;
using Platform.Common.BasicFunctions;
using TellerSystem.Communication;
using TellerSystem.Library.Ext.Function;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;
using System.Collections.Generic;
using Platform.Common.RunningParameters;
using System.Diagnostics;
using Microsoft.Win32;
using Newtonsoft.Json;
using System.Reflection;
using TellerSystem.Contract.Function;
using TellerSystem.Library.Ext.TradeExtension;
using TellerSystem.PrintTemplate.Extension;

namespace TellerSystem.Controls.Ext.Controls
{
    /// <summary>
    /// CheckSealVerification_ZK.xaml 的交互逻辑
    /// 中科金财的验印处理
    /// </summary>
    public partial class CheckSealVerification_ZK
    {
        public CheckSealVerification_ZK()
        {
            InitializeComponent();
            Record = new YYCheckerResult();
            Record.IsOnline = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("Is_CheckYY") == "true";
        }
        string flag = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        string devicesTagStr = null;
        private string imageDir = AppDomain.CurrentDomain.BaseDirectory;
        string outImgPath = string.Empty;
        string saveImgPath = string.Empty;
        public string _zh = string.Empty;
        public string path = string.Empty;
        /// <summary>
        /// 授权柜员编号
        /// </summary>
        private string _sqgybh;
        /// <summary>
        /// 验印结果
        /// </summary>
        public YYCheckerResult Record { get; private set; }

        private void TakePic_Click(object sender, RoutedEventArgs e)
        {
            var source = openCamPlaye("PZ");
            if (source != null)
            {
                imgPhoto.Source = source;
            }
        }

        private void btnView_Click(object sender, RoutedEventArgs e)
        {
            view detail = new view();
            detail.img.Source = imgPhoto.Source;
            if (detail.img.Source != null)
            {
                this.ShowPage(detail, "详细凭证");
            }
            else
            {
                this.TradeAPIs.ShowInfoMessageBox("暂无图像，无法查看！");
                this.TradeAPIs.SetFocus();
            }
        }

        private void btnCheck_Click(object sender, RoutedEventArgs e)
        {
            //检查图片是否为空
            if (imgPhoto.Source == null)
            {
                this.TradeAPIs.ShowInfoMessageBox("选择验印影像信息，选择本地或拍摄");
                return;
            }
            var BILLNO = tb_PZNO.Text == string.Empty ? "0" : tb_PZNO.Text;
            var BILLTYPE = tb_PZTYPE.Text == string.Empty ? "其他" : tb_PZTYPE.Text;
            var AMOUNT = tb_JE.Text == string.Empty ? "0" : (Convert.ToInt64(tb_JE.Text.ToDecimal() * 100).ToString());
            var BILLDATE = tb_CPRQ.Text == string.Empty ? LoginUserInfo.TradeDate : tb_CPRQ.Text;

            var dicResult = SealVerification(this.TradeInfo.TradeCode, LoginUserInfo.TellerNo + DateTime.Now.ToString("yyyyMMddHHmmsss"), "0", tb_YWLX.GetSelectedValue(), tb_JYGZ.GetSelectedValue(), tb_ZH.Text, BILLNO, BILLTYPE, AMOUNT, BILLDATE, saveImgPath, "200");

            if (dicResult != null)
            {
                if (dicResult.BILLRESULT == "0")
                {
                    if (flag == "V5" && dicResult.CHECKMODE == "2")
                    {
                        if (AuthAction(new Message() { Fd122_J = "fd122j" }))
                        {
                            if (!string.IsNullOrEmpty(_sqgybh))
                                Record.YYFlag = checkModeMaping(dicResult.CHECKMODE) + billResultMaping(dicResult.BILLRESULT) + " 授权" + _sqgybh + "\n" + "验印流水\n" + dicResult.CHECKID;
                            else
                                Record.YYFlag = checkModeMaping(dicResult.CHECKMODE) + billResultMaping(dicResult.BILLRESULT) + "\n验印流水\n" + dicResult.CHECKID;
                           
                        }
                        else
                            return;
                    }
                    else
                        Record.YYFlag = checkModeMaping(dicResult.CHECKMODE) + billResultMaping(dicResult.BILLRESULT) + "\n验印流水\n" + dicResult.CHECKID;
                    this.TradeAPIs.ShowInfoMessageBox("验印成功，请继续交易");                   
                    Record.IsComplated = true;
                    this.Close();
                }
                else if (dicResult.BILLRESULT == "2")
                {
                    this.TradeAPIs.ShowInfoMessageBox("验印未成功，原因：未验印，请检查！" + dicResult.RETINFO);
                    Record.IsComplated = false;
                    return;
                }
                else
                {
                    if (dicResult.BILLRESULT == "1" && dicResult.BILLRESULT != "0000")
                    {
                        this.TradeAPIs.ShowInfoMessageBox("验印失败:" + checkModeMaping(dicResult.CHECKMODE) +" "+ billResultMaping(dicResult.BILLRESULT) + dicResult.RETINFO + "请检查");
                    
                        Record.IsComplated = false;
                        return;
                    }
                    else
                    {
                        this.TradeAPIs.ShowInfoMessageBox("验印失败，原因：校验未通过,请检查！");
                        Record.IsComplated = false;
                        return;
                    }

                }
            }
            else
            {
                this.TradeAPIs.ShowInfoMessageBox("返回结果格式不对,或安装目录没找到");
                Record.IsComplated = false;
                return;
            }
        }
        /// <summary>
        /// 授权方法
        /// </summary>
        /// <param name="msg"></param>
        /// <returns></returns>
        private bool AuthAction(Message msg)
        {
            // 组织授权检查要素
            TellerSystem.ServiceProxy.Ext.ServiceEntitys.PageData[] page = new TellerSystem.ServiceProxy.Ext.ServiceEntitys.PageData[1];
            page[0] = new TellerSystem.ServiceProxy.Ext.ServiceEntitys.PageData() { index = 1, datas = this.SaveTradePage((FrameworkElement)this.Content) };
            AuthConditionElement element = new AuthConditionElement();

            AuthManager c = new AuthManager();
            c.AsksuperResultMessage += new AuthManager.AsksuperResultHandle(AsksuperResultMessage);
            return c.DoAuth(this, element, msg, page, "0", "", "", "", "", "人脸比对", "");
        }

        private void AsksuperResultMessage(AsksuperResultType result, TradeBusData busData)
        {
            _sqgybh = "";
            switch (result)
            {
                case AsksuperResultType.Success:
                    this.ShowMessageBox("授权已经通过。");
                    if (busData!=null&&busData.ContainsKey("AuthTeller")) 
                    {
                         _sqgybh = busData["AuthTeller"];
                    }
                    break;
                case AsksuperResultType.Failed:
                    this.ShowMessageBox("授权没有通过。");
                    break;
                case AsksuperResultType.Undo:
                    this.ShowMessageBox("授权已撤销。");
                    break;
                default:
                    break;
            }
        }
        private void TradePage_Loaded(object sender, RoutedEventArgs e)
        {
            tb_ZH.Text = _zh;
            Record.IsComplated = false;
            tb_YWLX.SetItems(new Dictionary<string, string> { { "支付", "1" }, { "对账", "2" } });
            //删除图像目录  保留当天的图像 by hulei 20210310

            //因可能客户电脑客户端没有images文件夹，导致下面方法get目录时异常，先创建images文件夹；
            var dirimages = System.IO.Path.Combine(AppDomain.CurrentDomain.BaseDirectory, @"images");
            createFolder(dirimages);
            var dirs = getDirectoryInfo(System.IO.Path.Combine(imageDir, @"images"));
            foreach (var item in dirs)
            {
                if (item.Name.ToString() != LoginUserInfo.TradeDate)
                {
                    deleteFolder(System.IO.Path.Combine(imageDir, @"images", item.Name));
                }
            }
        }

        private void tb_YWLX_LostFocus(object sender, RoutedEventArgs e)
        {
            if (tb_YWLX.GetSelectedValue() == "1")
            {
                tb_JYGZ.SetItems(new Dictionary<string, string> { { "验预留印鉴", "1" }, { "验公章", "2" }, { "验所有章", "3" } });
            }
            else
            {
                tb_JYGZ.SetItems(new Dictionary<string, string> { { "验预留印鉴或公章", "4" } });
            }
        }

        BitmapSource openCamPlaye(string device)
        {
            Process[] processes = Process.GetProcessesByName("CameraPlayer");
            if (processes.Length > 0)
            {
                foreach (Process process in processes)
                {
                    if (!process.HasExited)
                        process.Kill();
                }
            }
            if (devicesTagStr == null)
            {
                if (ConfigManager.GetInstance().GetConfigValue("CameraEnabled", ConfigType.User).ToLower() == "true")
                {
                    string pz = String.Format("PZ|{0}|{1};", ConfigManager.GetInstance().GetConfigValue("PZVid", ConfigType.User), ConfigManager.GetInstance().GetConfigValue("PZPid", ConfigType.User));
                    string kh = String.Format("KH|{0}|{1};", ConfigManager.GetInstance().GetConfigValue("KHVid", ConfigType.User), ConfigManager.GetInstance().GetConfigValue("KHPid", ConfigType.User));
                    string gy = String.Format("GY|{0}|{1};", ConfigManager.GetInstance().GetConfigValue("GYVid", ConfigType.User), ConfigManager.GetInstance().GetConfigValue("GYPid", ConfigType.User));
                    devicesTagStr = pz + kh + gy;
                }
                else
                {
                    devicesTagStr = "null";
                }
            }

            string saveImgDir = string.Empty;
            string fileName = string.Empty;

            saveImgDir = System.IO.Path.Combine(AppDomain.CurrentDomain.BaseDirectory, @"images", LoginUserInfo.TradeDate);
            createFolder(saveImgDir);
            fileName = Guid.NewGuid().ToString("N") + ".png";
            //固定路径
            outImgPath = System.IO.Path.Combine(System.IO.Path.GetTempPath(), "gdview\\tmp\\01.jpg");

            Process printProcess = new Process();
            printProcess.StartInfo.FileName = System.IO.Path.Combine(@"C:/Windows/twain_32/ggtwain/gdview.exe");
            printProcess.StartInfo.Arguments = flag + " " + device + " " + devicesTagStr + " \"" + outImgPath + "\"";
            printProcess.Start();
            printProcess.WaitForExit();
            printProcess.Close();
          
            saveImgPath = System.IO.Path.Combine(outImgPath);
            if (File.Exists(saveImgPath))
            {
                BitmapImage bitmapImage = new BitmapImage();
                bitmapImage.BeginInit();
                bitmapImage.CreateOptions = BitmapCreateOptions.IgnoreImageCache;
                bitmapImage.CacheOption = BitmapCacheOption.OnLoad;
                bitmapImage.UriSource = new Uri(saveImgPath);//szPath为图片的全路径
                bitmapImage.EndInit();
                bitmapImage.Freeze();
                return bitmapImage;
            }
            else
            {
                return null;
            }
        }
        DirectoryInfo createFolder(string filefullpath)
        {
            DirectoryInfo dir = null;
            if (!File.Exists(filefullpath))
            {
                string[] pathes = filefullpath.Split('\\');
                if (pathes.Length > 1)
                {
                    string path = pathes[0];
                    for (int i = 1; i < pathes.Length; i++)
                    {
                        path += "\\" + pathes[i];
                        if (!Directory.Exists(path))
                        {
                            dir = Directory.CreateDirectory(path);
                        }
                    }
                }
            }
            return dir;
        }
        private DirectoryInfo[] getDirectoryInfo(string path)
        {
            DirectoryInfo Dir = new DirectoryInfo(path);
            var dirs = Dir.GetDirectories();
            return dirs;
        }
        void deleteFolder(string file)
        {
            //判断文件夹是否还存在
            if (Directory.Exists(file))
            {
                //去除文件夹和子文件的只读属性
                System.IO.DirectoryInfo fileInfo = new DirectoryInfo(file);
                fileInfo.Attributes = FileAttributes.Normal & FileAttributes.Directory;
                System.IO.File.SetAttributes(file, System.IO.FileAttributes.Normal);
                foreach (string f in Directory.GetFileSystemEntries(file))
                {
                    if (File.Exists(f))
                    {
                        //如果有子文件删除文件
                        File.Delete(f);
                    }
                    else
                    {
                        //循环递归删除子文件夹
                        deleteFolder(f);
                    }
                }
                //删除空文件夹
                Directory.Delete(file);
            }
        }

        private void btnBack_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        private void bt_XZ_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog openfiledialog = new OpenFileDialog
            {
                Filter = "图像文件|*.jpg;*.png;*.jpeg;*.bmp;*.gif|所有文件|*.*"
            };

            if ((bool)openfiledialog.ShowDialog())
            {
                saveImgPath = openfiledialog.FileName;
                imgPhoto.Source = new BitmapImage(new Uri(openfiledialog.FileName));
            }
        }
        /// <summary>
        /// 验印模式
        /// </summary>
        /// <param name="result"></param>
        /// <returns></returns>
        private string checkModeMaping(string checkModeResult)
        {
            string checkMode = string.Empty;
            switch (checkModeResult)
            {
                case "0":
                    checkMode = "自动";
                    break;
                case "1":
                    checkMode = "辅助";
                    break;
                case "2":
                    checkMode = "人工";
                    break;
                default:
                    break;
            }


            return checkMode;
        }

        /// <summary>
        /// 整票结果映射
        /// </summary>
        /// <param name="result"></param>
        /// <returns></returns>
        private string billResultMaping(string result)
        {
            string billResult = string.Empty;
            switch (result)
            {
                case "0":
                    billResult = "通过";
                    break;
                case "1":
                    billResult = "不通过";
                    break;
                case "2":
                    billResult = "未验";
                    break;
                default:
                    break;
            }


            return billResult;
        }
        #region 验印相关
        class SealVerificationResult
        {
            /// <summary>
            /// 整票结果 0:通过 1:不通过 2:未验
            /// </summary>
            public string BILLRESULT { get; set; }
            /// <summary>
            /// 验印模式 0:自动 1:辅助 2:人工
            /// </summary>
            public string CHECKMODE { get; set; }
            /// <summary>
            /// 返回代码 0000为成功，其他失败
            /// </summary>
            public string RETCODE { get; set; }
            /// <summary>
            /// 返回信息成功返回空，否则返回错误信息
            /// </summary>
            public string RETINFO { get; set; }
            /// <summary>
            /// 验印结果标识 标识验印记录的唯一流水号
            /// </summary>
            public string CHECKID { get; set; }
        }

        /// <summary>
        /// 验印接口
        /// </summary>
        /// <param name="helper"></param>
        /// <param name="textbox"></param>
        /// <returns></returns>
        private SealVerificationResult SealVerification(string nodeCode, string TASKID, string TASKTYPE, string XITLX, string CHECKTYPE, string ACCNO, string BILLNO, string BILLTYPE, string AMOUNT, string BILLDATE, string IMAGENAME, string DPI)
        {
            Type _OCXType = null;
            object _ocxObject = null;
            SealVerificationResult SealVerificationResult = null;
            System.Windows.Forms.Control _OCXCtr = null;
            //获取验印配置url 配置在配置文件中  建议 是url+QL+机构号
            string url = ConfigManager.GetInstance().GetConfigValue("SEALAPPURL", ConfigType.Client);

            //获取动态库配置路径

            //组json
            Dictionary<string, string> dic = new Dictionary<string, string>() { { "SEALAPPURL", url }, { "SYSCODE", "GMXT" }, { "NODECODE", nodeCode }, { "TASKID", "GMXT" }, { "TASKTYPE", "0" },
            {"XITLX",XITLX},{"CHECKTYPE",CHECKTYPE},{"TELLNO",LoginUserInfo.TellerNo},{"TELLORGNO",LoginUserInfo.KinbrNo},{"ACCNO",ACCNO} ,{"BILLNO",BILLNO},{"BILLTYPE",BILLTYPE},{"AMOUNT",AMOUNT},{"BILLDATE",BILLDATE},{"IMAGENAME",IMAGENAME},{"DPI","200"}};
            var strjson = JsonConvert.SerializeObject(dic);
            //调用接口
            if (_OCXCtr == null || _OCXCtr.IsDisposed)
            {
                //注意这里控件的安装目录不要安装到C:\Program Files (x86)下，否则需要管理员身份运行或者额外进行授权处理。
                //验印控件安装的目录中的SealCheckCom.dll
                Microsoft.Win32.RegistryKey regsvrCloudCmdSign = Microsoft.Win32.Registry.ClassesRoot.OpenSubKey("CLSID\\{9D2CA12E-A504-4574-A9D4-0940B371C0A4}\\InprocServer32\\");
                string ocxDllPath = string.Empty;//Path.Combine(@"D:\software\zhongke", "SealCheckCom.dll");
                if (regsvrCloudCmdSign == null)
                {
                    //this.TradeAPIs.ShowInfoMessageBox("没有找到程序安装目录，请确认是否安装插件");
                    //return null;
                    ocxDllPath = Path.Combine(@"D:\Program Files\Sinodata\ISealCheckSetup", "SealCheckCom.dll");
                }
                else
                {
                    var sealpath = regsvrCloudCmdSign.GetValue("CodeBase", "0");
                    if (sealpath != "0")
                    {
                        ocxDllPath = sealpath.ToString();
                    }
                    else
                    {
                        this.TradeAPIs.ShowInfoMessageBox("没有找到程序安装目录，请确认是否安装插件");
                        return null;

                    }
                }

                Assembly ass = Assembly.LoadFrom(ocxDllPath);
                _OCXType = ass.GetType("Sinodata.SealCheckCom.AssitantCheckSeal");

                _ocxObject = Activator.CreateInstance(_OCXType);
                _OCXCtr = _ocxObject as System.Windows.Forms.Control;

            }
            try
            {
                //调用Check方法
                Type[] params_type = new Type[1] { typeof(string) };
                MethodInfo check = _OCXType.GetMethod("Check", params_type);
                object[] parameters = new object[] { strjson };

                object result = check.Invoke(_ocxObject, parameters);
                if (result == null)
                {

                }
                else
                {

                    // JsonConvert.DeserializeObject<Dictionary<string, string>>(result.ToString());
                    //解析配置项
                    SealVerificationResult = JsonConvert.DeserializeObject<SealVerificationResult>(result.ToString());// JsonHelper.ParseJson2List(json);

                    return SealVerificationResult;
                }
                _OCXCtr.Dispose();
                _OCXCtr = null;
            }
            catch (Exception ex)
            {
                string er = "验印异常：" + ex.Message + "," + ex.StackTrace;
                MessageBox.Show(er);
                if (ex.InnerException != null)
                    er = ex.InnerException.Message + "," + ex.InnerException.StackTrace;
                MessageBox.Show(er);
            }
            //处理结果
            return SealVerificationResult;
        }
        #endregion


        public class YYCheckerResult
        {
            /// <summary>
            /// 是否验印
            /// </summary>
            public bool IsOnline { get; internal set; }

            /// <summary>
            /// 是否完成验印 
            /// </summary>
            public bool IsComplated { get; internal set; }

            /// <summary>
            /// 账号
            /// </summary>
            public string ZH { get; internal set; }

            /// <summary>
            /// 金额
            /// </summary>
            public string JE { get; internal set; }

            /// <summary>
            /// 凭证种类
            /// </summary>
            public string Type { get; internal set; }

            /// <summary>
            /// 凭证号码
            /// </summary>
            public string PZNO { get; internal set; }

            /// <summary>
            /// 出票日期
            /// </summary>
            public string CPRQ { get; internal set; }

            /// <summary>
            /// 验印流水
            /// </summary>
            public string YYLS { get; internal set; }
            /// <summary>
            /// 验印结果
            /// </summary>
            public string YYFlag { get; internal set; }
        }
    }
}