﻿using System.Windows;
using System.Windows.Input;
using Platform.Library;
using System.Data;
using Platform.Presentation.Interfaces;
using Platform.Presentation.PageFunctions;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Library.Ext.TradeExtension;
using Platform.Controls.ControlsHelper;
using System.Windows.Controls;
namespace TellerSystem.Controls.Ext.Controls
{
    /// <summary>
    /// DataBoxViewer.xaml 的交互逻辑
    /// </summary>
    public partial class DataBoxViewer
    {
        private double _winWidth;
        private double _winHeight;
        private bool _multiRows = false;
        public DataBoxViewer()
        {
            InitializeComponent();
            _winHeight = this.Height;
            _winWidth = this.Width;
        }

        public double WinWidth
        {
            get { return _winWidth; }
            set { _winWidth = value; }
        }

        public double WinHeight
        {
            get { return _winHeight; }
            set { _winHeight = value; }
        }

        public bool MultiRows
        {
            get { return _multiRows; }
            set { _multiRows = value; }
        }
        public void LoadPageSize(double width, double height)
        {
            if (width > 0 && height > 0)
            {
                this.Width = width;
                this.Height = height;
                this.DataBox1.Width += width - WinWidth;
                this.DataBox1.Height += height - WinHeight;
                this.Grid1.Width += width - WinWidth;
                this.Grid1.Height += height - WinHeight;
            }
        }

        private void TradePage_Loaded(object sender, RoutedEventArgs e)
        {
            this.SetFocus(DataBox1.DataBoxHost);
        }

        public bool LoadData(string sequence, string[] headerList)
        {
            this.DataBox1.IsMultiSelected = _multiRows;
            this.DataBox1.DataBinding(sequence, headerList);
            return true;
        }
        public bool LoadData(DataTable table)
        {
            this.DataBox1.IsMultiSelected = _multiRows;
            this.DataBox1.DataBinding(table);
            return true;
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void submit_Click(object sender, RoutedEventArgs e)
        {
            if (!MultiRows)
            {
                var selectedData = this.DataBox1.GetSelectSingleRow();
                if (selectedData == null)
                {
                    this.ShowMessageBox("没有可选信息!", "警告");
                    return;
                }
                this.Tag = selectedData;
                
            }
            else
            {
                var selectedData = this.DataBox1.GetSelectMultiRows();
                if (selectedData == null)
                {
                    this.ShowMessageBox("没有可选信息!", "警告");
                    this.SetFocus(DataBox1.DataBoxHost);
                    return;
                }
                this.Tag = selectedData;
            }

            this.Close();
        }

        private void DataBox1_KeyDown(object sender, System.Windows.Input.KeyEventArgs e)
        {
            if (e.Key == Key.Escape)
            {
                this.Tag = null;
                this.Close();
            }

        }



    }

}
