// 定义 Tx_Node 类，代表流程节点
export class Tx_Node {
    // 定义私有字段，用于存储节点的各种属性
    private m_Code: string;
    private m_Sub_Code: string;
    private m_Name: string;
    private m_Condition: string;
    private m_Content: string | null;
    private m_stat: string;
    private m_errinfo: string;
    private m_desc: string;
    private m_X: number;
    private m_Y: number;

    // 定义属性，提供对私有字段的访问和修改
    public get Code(): string {
        return this.m_Code;
    }

    public set Code(value: string) {
        this.m_Code = value;
    }

    public get Sub_Code(): string {
        return this.m_Sub_Code;
    }

    public set Sub_Code(value: string) {
        this.m_Sub_Code = value;
    }

    public get Name(): string {
        return this.m_Name;
    }

    public set Name(value: string) {
        this.m_Name = value;
    }

    public get Conditions(): string {
        return this.m_Condition;
    }

    public set Conditions(value: string) {
        this.m_Condition = value;
    }

    public get Desc(): string {
        return this.m_desc;
    }

    public set Desc(value: string) {
        this.m_desc = value;
    }

    public get Content(): string | null {
        return this.m_Content;
    }

    public set Content(value: string | null) {
        this.m_Content = value;
    }

    public get Stat(): string {
        return this.m_stat;
    }

    public set Stat(value: string) {
        this.m_stat = value;
    }

    public get ErrInfo(): string {
        return this.m_errinfo;
    }

    public set ErrInfo(value: string) {
        this.m_errinfo = value;
    }

    public get X(): number {
        return this.m_X;
    }

    public set X(value: number) {
        this.m_X = value;
    }

    public get Y(): number {
        return this.m_Y;
    }

    public set Y(value: number) {
        this.m_Y = value;
    }

    // 无参构造函数
    constructor() {
        this.m_Code = '';
        this.m_Sub_Code = '';
        this.m_Name = '';
        this.m_Condition = '';
        this.m_Content = null;
        this.m_stat = '';
        this.m_errinfo = '';
        this.m_desc = '';
        this.m_X = 0;
        this.m_Y = 0;
    }

    // 有参构造函数，用于初始化节点对象
    constructor(code: string, subtxCode: string, name: string, condition: string = '', desc: string = '', content: string = '', stat: string = '', errinfo: string = '') {
        this.m_Code = code;
        this.m_Sub_Code = subtxCode;
        this.m_Name = name;
        this.m_Condition = condition;
        this.m_Content = content;
        this.m_stat = stat;
        this.m_errinfo = errinfo;
        this.m_desc = desc;
        this.m_X = 0;
        this.m_Y = 0;
    }
}