﻿ using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Platform.Common.LogSystem;
using Platform.Common.RunningParameters;

/******************************平台Dll*****************************/

using Platform.Controls.ControlsHelper;
using Platform.Library;
using Platform.Presentation.FocusManagers;
using Platform.Presentation.Interfaces;
using Platform.Presentation.PageFunctions;
using TellerSystem.Communication;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Library.Ext.TradeExtension;
using TellerSystem.Library.Ext.Variables;
using TellerSystem.Controls.Ext.ControlsHelper;
using TellerSystem.Contract.Function;
using TellerSystem.Contract.ContractBase;
using System.IO;
using TellerSystem.Controls.Ext.PrintsHelper;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;
using TellerSystem.Controls.Ext.ControlEntity;

namespace TellerSystem.Controls.Ext.Controls
{
    /// <summary>
    /// FeeViewer.xaml 的交互逻辑
    /// </summary>
    public partial class FeeViewer
    {
        #region 交易内部变量

        /* 定义变量 */

        /// <summary>
        /// 是否是网银
        /// </summary>
        private bool _is_Wy;
        public bool Is_Wy
        {
            get { return _is_Wy; }
            set { _is_Wy = value; }
        }

        public bool _is_Cunkuan = false;
        /// <summary>
        /// 是否二代支付
        /// </summary>
        private bool _is_Canps2 = false;

        public bool Is_Canps2
        {
            get { return _is_Canps2; }
            set { _is_Canps2 = value; }
        }

        /// <summary>
        /// 是否打印客户收费凭条
        /// </summary>
        public static bool _is_print = true;

        /// <summary>
        /// 主交易消息对象
        /// </summary>
        private Message _message;

        //shangyongchao 20120710 增加黑名单标志
        /// <summary>
        /// 黑名单标志 1表示该账户列入黑名单
        /// </summary>
        private string BlackFlag = string.Empty;

        //shangyongchao 20120809 增加后台返回的允许的收费方式
        /// <summary>
        ///   后台返回的允许的收费方式
        /// </summary>
        private string ModeChrg = string.Empty;

        /// <summary>
        /// 扣费账号户名 商永超 20120810
        /// </summary>
        private string FeeAcName = string.Empty;

        private decimal TOTAMT;

        /// <summary>
        /// 转账时的收费账号 商永超20120813
        /// </summary>
        private string TmpAcNo = string.Empty;

        /// <summary>
        /// 标识是否完成收费操作
        /// </summary>
        public bool IsFinishFee
        {
            get;
            set;
        }

        /// <summary>
        /// 收费凭条打印对象
        /// </summary>
        public Print_Fee PrintFee { get; private set; }
        /// <summary>
        ///收费凭条客户回单
        /// </summary>
        public Print_FeeGuest PrintFeeGuest { get; private set; }

        /// <summary>
        /// 二磁道信息
        /// </summary>
        private string _msr2bak = "";

        /// <summary>
        /// 三磁道信息
        /// </summary>
        private string _msr3bak = "";

        /// <summary>
        /// 扣费账户户名
        /// </summary>
        private string kfzhhm = string.Empty;

        /// <summary>
        /// 户名
        /// </summary>
        private string hm = string.Empty;
        /// <summary>
        /// 证件类型
        /// </summary>
        private string zjlx = string.Empty;

        /// <summary>
        /// 证件号码
        /// </summary>
        private string zjhm = string.Empty;

        /// <summary>
        /// 版本控制标志
        /// </summary>
        private string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");

        /// <summary>
        /// 收费项目
        /// </summary>
        public string sfxm = string.Empty;

        /// <summary>
        /// 账户名称
        /// </summary>
        public string zhmc = string.Empty;

        /// <summary>
        /// 验印流水-中牟
        /// </summary>
        string _yyls = string.Empty;

        #endregion 交易内部变量

        internal FeeViewer(Message msg)
        {
            InitializeComponent();
            _message = msg;

            ////初始化金额控件，处理外币开户的情况
            //if (_message.Fd16 == "2100")
            //{
            //    T1.ChangeMoneySymbol(_message.Fd103_3);
            //    T2.ChangeMoneySymbol(_message.Fd103_3);
            //    T3.ChangeMoneySymbol(_message.Fd103_3);
            //    SF_VAL1.ChangeMoneySymbol(_message.Fd103_3);
            //    SF_VAL2.ChangeMoneySymbol(_message.Fd103_3);
            //    SF_VAL3.ChangeMoneySymbol(_message.Fd103_3);
            //    TTotal.ChangeMoneySymbol(_message.Fd103_3);
            //}
        }

        #region 逻辑代码

        /// <summary>
        /// 初始化页面元素
        /// </summary>
        public override bool InitPage()
        {
            TOTAMT = 0;
            if (string.IsNullOrEmpty(_message.FileData))
            {
                this.ShowErrorMessageBox("传入的收费内容为空");
                IsFinishFee = false;
                SubmitButton.Visibility = Visibility.Hidden;
                return false;
            }
            else
            {
                //解析数据
                var reader = new StringReader(_message.FileData);
                //控制行  [收费方式|黑名单标志|主账号]
                var line = reader.ReadLine();
                var tmp = line.Split('|');
                if (tmp.Count() < 3 || tmp[0].Length != 4)
                {
                    this.ShowErrorMessageBox("收费模式配置错误！");
                    IsFinishFee = false;
                    SubmitButton.Visibility = Visibility.Hidden;
                    return false;
                }
                //收费方式
                ModeChrg = tmp[0];
                //黑名单标志
                BlackFlag = tmp[1];
                //收费项目
                TmpAcNo = tmp[2];
                var ac = this.TradeAPIs.TF_Deposit_QueryDepositAccount(new QueryDepositAccount.Input()
                {
                    ZH = TmpAcNo
                });
                if (!ac.IsFailed)
                    hm = ac.HM;
                //收费明细
                line = reader.ReadLine();
                var data = new StringBuilder();
                data.AppendLine("~收费条目|应收金额|实收金额|");
                while (!string.IsNullOrEmpty(line))
                {
                    tmp = line.Split('|');
                    if (tmp.Count() < 3) continue;
                    data.AppendLine(string.Format("{0}|{1}|{2}|", tmp[0], tmp[1], tmp[2]));
                    sfxm += tmp[0] + "  ";
                    //累计
                    TOTAMT += decimal.Parse(tmp[2]);
                    line = reader.ReadLine();
                }
                DB_FeeList.DataBinding(data.ToString());
                TTotal.Text = TOTAMT.ToString();
                if (Is_Wy)
                {
                    //网银全部不收费
                    FEEFLAG.SetItems(new Dictionary<string, string> { { "不收", "4" } });
                    FEEFLAG.SetSelectedValue("4");
                }
                if (_is_Cunkuan)
                {
                    FEEFLAG.SetItems(new Dictionary<string, string> { { "现金", "1" }, { "输入账号", "3" }, { "不收", "4" } });
                    FEEFLAG.SetSelectedValue("1");
                }
                if (_is_Canps2)
                {
                    FEEFLAG.SetItems(new Dictionary<string, string> { { "现金", "1" }, { "转账", "2" }, { "输入账号", "3" }, { "不收", "4" } });
                    FEEFLAG.SetSelectedValue("2");
                }
                else
                {
                    FEEFLAG.SetItems(UserVariable.GetFeeFlag(ModeChrg, BlackFlag));
                    //默认收费方式
                    FEEFLAG.SelectedValue = _message.Fd9_3;
                    //if (FEEFLAG.SelectedIndex == -1)
                    //    FEEFLAG.SelectedIndex = 0;
                    if (FEEFLAG.SelectedIndex == -1)
                    {
                        if (_message.Fd16 == "2405" && FLAG == "V6" && (_message.Fd66.Equals("1") || _message.Fd66.Equals("2")))//淇县  挂失：“默认收费”改为“默认不收”
                        {
                            FEEFLAG.SelectedIndex = 1;
                        }
                        else
                        {
                            FEEFLAG.SelectedIndex = 0;
                        }
                    }
                    //if (BlackFlag == "0")
                    //{
                    //    this.ShowMessageBox("该账号/客户在收费白名单内，费用全免！");

                    //    FEEFLAG.SetSelectedValue("5"); //收费方式 默认设置为5-费用全免
                    //    FEEFLAG.IsEnabled = false;
                    //}
                    //else if (BlackFlag == "1")
                    //{
                    //    this.ShowMessageBox("该账号/客户在收费黑名单内，按标准收费，无优惠！");
                    //}
                }
                if (FLAG == "V11" && _message.Fd16 == "2105")//2300交易 对公活期开户
                {
                    zhmc = _message.Fd103_8;
                }
                if (FLAG == "V0" && this.TradeModel.Code.Trim() == "2998" && _message.Fd16 == "2410")//更换介质
                {
                    DeviceManager.SetSwipeCardReaderTracksReader(FEEACNO, SwipeCardReaderType.ReadCardOrInput);
                }
                this.SetFocus(FEEFLAG);
                return true;
            }
            /* 初始化界面逻辑，页面加载后执行*/
        }

        private void SubmitButton_Click(object sender, RoutedEventArgs e)
        {
            _message.Fd9_3 = (string)FEEFLAG.SelectedValue;
            string tmp = TTotal.Text;
            if (_message.Fd122_F == "1")
            {
                _message.Fd122_1 = string.Empty;
                _message.Fd122_2 = string.Empty;
                _message.Fd122_3 = string.Empty;
                _message.Fd122_4 = string.Empty;
                _message.Fd122_5 = string.Empty;
                _message.Fd122_6 = string.Empty;
                _message.Fd122_7 = string.Empty;
                _message.Fd122_8 = string.Empty;
                _message.Fd122_9 = tmp;
                _message.Fd122_A = string.Empty;
                _message.Fd122_B = string.Empty;
                _message.Fd122_C = string.Empty;
                _message.Fd122_D = FEEACNO.Text;
                _message.Fd122_E = FeeAcName;
                _message.Fd122_F = "1";
                _message.Fd122_G = string.IsNullOrEmpty(ACSEQN.Text) ? string.Empty : ACSEQN.Text;
                //_message.Fd122_H = GDPWD.Password;//增加密码的赋值 商永超20120810
                //国密改造
                if (TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("EncrypteGM") == "true")
                {
                    _message.Fd122_K = GDPWD.Password;//增加密码的赋值
                }
                else
                {
                    _message.Fd122_H = GDPWD.Password;//增加密码的赋值 商永超20120810
                }
            }
            else
            {
                _message.Fd122_1 = string.Empty;
                _message.Fd122_2 = string.Empty;
                _message.Fd122_3 = string.Empty;
                _message.Fd122_4 = string.Empty;
                _message.Fd122_5 = string.Empty;
                _message.Fd122_6 = string.Empty;
                _message.Fd122_7 = string.Empty;
                _message.Fd122_8 = string.Empty;
                _message.Fd122_9 = tmp;
                _message.Fd122_A = string.Empty;
                _message.Fd122_B = string.Empty;
                _message.Fd122_C = string.Empty;
                _message.Fd122_D = FEEACNO.Text;
                _message.Fd122_E = FeeAcName;//增加扣费账号户名 商永超20120810
                _message.Fd122_F = string.Empty;
                _message.Fd122_G = string.IsNullOrEmpty(ACSEQN.Text) ? string.Empty : ACSEQN.Text;
                //_message.Fd122_H = GDPWD.Password;//增加密码的赋值 商永超20120810
                //国密改造
                if (TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("EncrypteGM") == "true")
                {
                    _message.Fd122_K = GDPWD.Password;//增加密码的赋值
                }
                else
                {
                    _message.Fd122_H = GDPWD.Password;//增加密码的赋值 商永超20120810
                }
				
            }
            //传输磁道信息：
            _message.Fd122_J = _msr2bak;
            //国密改造
            if (TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("EncrypteGM") != "true")
            {
                _message.Fd122_K = _msr3bak;
            }

            IsFinishFee = true;
            //将收费信息上传到总线
            //收费方式标识
            this.TradeBus.F000 = this.FEEFLAG.GetSelectedValue();
            //收费方式
            this.TradeBus.F001 = this.FEEFLAG.GetSelectedKey();
            this.TradeBus.F002 = this.DB_FeeList.GetDataForString();
            this.TradeBus.F003 = this.TTotal.Text;
            this.TradeBus.F004 = this.FEEACNO.Text;
            this.TradeBus.F005 = this.ACSEQN.Text;
            this.TradeBus.F006 = sfxm;
            if (FLAG == "V0")
            {
                this.TradeBus.F007 = kfzhhm;
            }
            if (FLAG == "V11" && _message.Fd16 == "2105")
            {
                this.TradeBus.T343 = _message.Fd16;//Fd16
            }
            if (FLAG == "V11" && _message.Fd16 == "5155")//大石桥2375 不收费也打印收费凭条
            {
                if (this.FEEFLAG.GetSelectedValue() == "4")
                {
                    this.TTotal.Text = "";
                }
                //创建收费凭条
                this.PrintFee = new Print_Fee(new Print_Fee.Print_FeeEntry
                {
                    HM = hm,
                    ZH = TmpAcNo,
                    XZH = "",
                    SFXM = sfxm,
                    SFFS = this.TradeBus.F001,
                    SFJE = this.TTotal.Text,
                    KFZH = this.FEEACNO.Text,
                    KFZHHM = kfzhhm,
                    ZHMC = zhmc,
                    JYM = this.TradeBus.T343,
                    yyls = _yyls
                });
                this.PrintFeeGuest = new Print_FeeGuest(new Print_FeeGuest.Print_FeeGuestEntry
                {
                    HM = hm,
                    ZH = TmpAcNo,
                    XZH = "",
                    SFXM = sfxm,
                    SFFS = this.TradeBus.F001,
                    SFJE = this.TTotal.Text,
                    KFZH = this.FEEACNO.Text,
                    KFZHHM = kfzhhm,
                    ZHMC = zhmc,
                    JYM = this.TradeBus.T343,
                    yyls = _yyls
                });
            }
            else
            {
                //创建收费凭条
                if (this.FEEFLAG.GetSelectedValue() != "4")
                    this.PrintFee = new Print_Fee(new Print_Fee.Print_FeeEntry
                    {
                        HM = hm,
                        ZH = TmpAcNo,
                        XZH = "",
                        SFXM = sfxm,
                        SFFS = this.TradeBus.F001,
                        SFJE = this.TTotal.Text,
                        KFZH = this.FEEACNO.Text,
                        KFZHHM = kfzhhm,
                        ZHMC = zhmc,
                        JYM = this.TradeBus.T343
                    });
                if (_is_print && this.FEEFLAG.GetSelectedValue() != "4")
                {
                    this.PrintFeeGuest = new Print_FeeGuest(new Print_FeeGuest.Print_FeeGuestEntry
                    {
                        HM = hm,
                        ZH = TmpAcNo,
                        XZH = "",
                        SFXM = sfxm,
                        SFFS = this.TradeBus.F001,
                        SFJE = this.TTotal.Text,
                        KFZH = this.FEEACNO.Text,
                        KFZHHM = kfzhhm,
                        ZHMC = zhmc,
                        JYM = this.TradeBus.T343
                    });
                }
            }
            _is_print = true;
            this.Close();
        }

        #endregion 逻辑代码

        private void FEEFLAG_LostFocus(object sender, RoutedEventArgs e)
        {
            FEEACNO.Text = "";//重新选择清空已经输入的账号 商永超20120711
            //选择输入账号
            if ((string)FEEFLAG.SelectedValue == "3")
            {
                AcInfoCanvas.Visibility = Visibility.Visible;
            }
            else
            {
                FEEACNO.Text = string.Empty;
                GDPWD.Password = string.Empty;
                AcInfoCanvas.Visibility = Visibility.Collapsed;
            }

            var cash = this.SubStr(ModeChrg, 0, 1);  //现金
            var tran = this.SubStr(ModeChrg, 1, 1);  //转账
            var other = this.SubStr(ModeChrg, 2, 1); //其他账号
            var nofee = this.SubStr(ModeChrg, 3, 1); //不收
            //增加现转标志的判断和黑名单的处理 商永超 20120710
            if (cash == "0" && FEEFLAG.SelectedValue.ToString() == "1")
            {
                this.ShowMessageBox("本交易费用不能收取现金！");
                this.SetFocus(FEEFLAG);
                //FEEFLAG.KeepFocus();
                return;
            }
            if (tran == "0" && FEEFLAG.SelectedValue.ToString() == "2")
            {
                this.ShowMessageBox("本交易费用不能转账收取！");
                this.SetFocus(FEEFLAG);
                //FEEFLAG.KeepFocus();
                return;
            }
            if (other == "0" && FEEFLAG.SelectedValue.ToString() == "3")
            {
                this.ShowMessageBox("本交易费用不能从第三账号收取！");
                this.SetFocus(FEEFLAG);
                //FEEFLAG.KeepFocus();
                return;
            }
            if (nofee == "0" && FEEFLAG.SelectedValue.ToString() == "4" && TTotal.Text.ToDecimal() != 0m)
            {
                this.ShowMessageBox("本交易费用必须收取！");
                this.SetFocus(FEEFLAG);
                //FEEFLAG.KeepFocus();
                return;
            }
            if (BlackFlag == "1" && FEEFLAG.SelectedValue.ToString() == "4")
            {
                this.ShowMessageBox("该客户被列入收费黑名单，必须收费！");
                this.SetFocus(FEEFLAG);
                //FEEFLAG.KeepFocus();
                return;
            }
            if (FEEFLAG.SelectedValue.ToString() != "4" && TTotal.Text.ToDecimal() == 0m)
            {
                this.ShowMessageBox("没有收费，请选择不收！");
                this.SetFocus(FEEFLAG);
                //FEEFLAG.KeepFocus();
                return;
            }

            //7997 5801 5834 2364 交易码
            string tradecodes1 = "5105|2405";//7997 2364
            string tradecodes2 = "6233|6234";//5801 5834 对公户且转账

            if (FEEFLAG.GetSelectedValue() == "2")
            {
                if ((tradecodes2.Contains(_message.Fd16) && this.TradeBus.T340 == "1") || tradecodes1.Contains(_message.Fd16))//T340 对公1 个人2
                {
                    _yyls = string.Empty;
                    //var yyCheck = this.TradeAPIs.YYCheck();
                    //if (!yyCheck.IsComplated)
                    //{
                    //    this.TradeAPIs.ShowInfoMessageBox("验印未通过，请继续进行验印！");
                    //    this.TradeAPIs.SetFocus();
                    //    return;
                    //}
                    DzyyEntity dzyyentity = new TellerSystem.Controls.Ext.ControlEntity.DzyyEntity { AccNo = FEEACNO.Text, Amt = TTotal.Text, Voucher = "", VoucherNo = "", VoucherDate = "" };
                    if (this.TradeAPIs.YYCheck(dzyyentity) == false)
                    {
                        this.TradeAPIs.ShowInfoMessageBox(dzyyentity.Message);
                        this.SetFocus();
                        return;
                    }
                    string FeeZH = string.Empty;
                    string FeeJE = string.Empty;

                    _yyls = dzyyentity.SerialNo;
                    switch (_message.Fd16)
                    {
                        case "5105"://7997
                            FeeZH = this.TradeBus.T344.Trim();
                            this.TradeBus.T222 = _yyls;//7997 收费不打印凭证，需要把验印流水打印在通用凭证上
                            break;
                        case "2405"://2364
                            FeeZH = this.TradeBus.T131.Trim();
                            this.TradeBus.T222 = _yyls;//2364 收费打印凭证，需要把验印流水打印在通用凭证上
                            break;
                        case "6233"://5801 5834
                        case "6234"://5801 5834
                            FeeZH = this.TradeBus.T339.Trim();
                            this.TradeBus.T222 = _yyls;//5801 5834 收费不打印凭证，需要把验印流水打印在通用凭证上
                            break;
                    }
                    //string zh = yyCheck.ZH == FeeZH ? string.Empty : "账号,";
                    //string je = yyCheck.JE == TTotal.Text ? string.Empty : "金额,";
                    //string type = yyCheck.Type == "收费凭证" ? string.Empty : "收费凭证";
                    //string _zh = yyCheck.ZH == FeeZH ? string.Empty : yyCheck.ZH + ",";
                    //string _je = yyCheck.JE == TTotal.Text ? string.Empty : yyCheck.JE + ",";
                    //string _type = yyCheck.Type == "收费凭证" ? string.Empty : yyCheck.Type;
                    //if (yyCheck.IsOnline)
                    //{
                    //    if (FeeZH != yyCheck.ZH || TTotal.Text != yyCheck.JE || "收费凭证" != yyCheck.Type)
                    //    {
                    //        this.TradeAPIs.ShowInfoMessageBox("当前" + zh + je + type + "与验印结果:" + _zh + _je + _type + "不一致，请确认！");
                    //        this.TradeAPIs.SetFocus();
                    //        return;
                    //    }
                    //}
                }
            }
        }

        /// <summary>
        /// 扣费账号
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void FEEACNO_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!(FLAG == "V0" && this.TradeModel.Code.Trim() == "2998" && _message.Fd16 == "2410"))//更换介质
            {
                if (this.Delspace(TmpAcNo) == this.Delspace(FEEACNO.Text))
                {
                    this.ShowMessageBox("其他账号不能是交易主账号！");
                    this.SetFocus(FEEFLAG);
                    //FEEACNO.KeepFocus();
                    return;
                }
            }
            ////读取磁道信息
            //if (TellerSystem.Devices.Config.DeviceConfig.SwipeCardEnabled)
            //{
            //    try
            //    {
            //        _msr2bak = DeviceManager.GetSwipeCardData(FEEACNO).Data.TracksTwo;
            //        _msr3bak = DeviceManager.GetSwipeCardData(FEEACNO).Data.TracksThree;
            //    }
            //    catch
            //    {
            //        this.ShowMessageBox("刷卡错误,请重试!");
            //        this.SetFocus(FEEACNO);
            //        return;
            //    }
            //}
            //update by ZhangYongheng @2014年4月25日
            //在后台查询活期帐户,检查账号，返回子账户列表
            var acinfo = this.TradeAPIs.TF_Deposit_QueryChildAccountList(new QueryChildAccountList.Input()
                {
                    ZH = FEEACNO.Text.Trim()
                }
            );
            if (acinfo.IsFailed)
            {
                FEEACNO.Text = string.Empty;
                this.TradeAPIs.ShowTip(acinfo.FailureCause);
                this.TradeAPIs.SetFocus();
                return;
            }
            if (acinfo.ZZHXXData.Count > 0)
            {
                //账户序号|开户日期|产品名称|账户余额|账户状态|冻结状态|止付状态|
                var selectedData = this.ShowDataBoxViewer(acinfo.ZZHXX, new string[] { "账户序号", "开户日期", "产品名称", "账户余额", "账户状态" });
                if (selectedData == null)
                {
                    ACSEQN.Text = string.Empty;
                    this.TradeAPIs.ShowTip(this.TradeAPIs.GetNotifyMessage(NotifyMessage.N039));
                    this.TradeAPIs.SetFocus();
                    return;
                }
                ACSEQN.Text = selectedData["账户序号"].ToString();
            }
            else
            {
                this.TradeAPIs.ShowTip("没有可选账号信息");
                this.SetFocus();
                return;
            }

            //查询账号信息
            var acInfos = this.TradeAPIs.TF_Deposit_QueryDepositAccount(new QueryDepositAccount.Input()
            {
                ZH = FEEACNO.Text.Trim(),
                XH = ACSEQN.Text.Trim()
            });
            if (acInfos.IsFailed)
            {
                this.TradeAPIs.ShowTip(acInfos.FailureCause);
                this.TradeAPIs.SetFocus();
                return;
            }
            kfzhhm = acInfos.HM;
            zjlx = acInfos.ZJLX;//获取证件类型，供校验
            zjhm = acInfos.ZJHM;//获取证件号码，供校验
            if (_message.Fd103_3 != acInfos.BZ && _message.Fd16 == "2100")
            {
                this.ShowMessageBox("该账号的币种与收费币种不一致！");
                this.SetFocus(FEEFLAG);
                return;
            }
            if (acInfos.KHLX != "1" && acInfos.KHLX != "5")
            {
                //对公账户
                //判断账号是否允许通存通兑
                var zyhshortTrade = this.TradeAPIs.TF_Deposit_QueryAccountTCTD(
                    new QueryAccountTCTD.Input()
                    {
                        ZH = acInfos.ZH
                    }
                    );
                if (zyhshortTrade.IsFailed)
                {
                    this.TradeAPIs.ShowTip(zyhshortTrade.FailureCause);
                    this.TradeAPIs.SetFocus();
                    return;
                }
                //如果不允许通兑
                if (zyhshortTrade.SFTD == "N")
                {
                    if (acInfos.KHJG != LoginUserInfo.KinbrNo)
                    {
                        this.TradeAPIs.ShowTip("该账号不允许通兑:" + this.TradeAPIs.GetNotifyMessage(NotifyMessage.N017));
                        this.TradeAPIs.SetFocus();
                        return;
                    }
                }
                //对公不验密，手动验印
                LPASSWORD.Visibility = Visibility.Collapsed;
                GDPWD.Visibility = Visibility.Collapsed;
            }
            else
            {
                if (acInfos.SFPM == "N")  /*无密户*/
                {
                    //AcSeqCanvas.Visibility = Visibility.Collapsed;
                    LPASSWORD.Visibility = Visibility.Collapsed;
                    GDPWD.Visibility = Visibility.Collapsed;
                }
                else
                {
                    //AcSeqCanvas.Visibility = Visibility.Visible;
                    LPASSWORD.Visibility = Visibility.Visible;
                    GDPWD.Visibility = Visibility.Visible;
                }
                #region 凭证支取校验
                switch(FLAG)
                {
                    case"V2"://鄢陵要求，账号凭证支取，需校验证件号码 addby wangheng
                        DRAWFLAG.Visibility=Visibility.Visible;
                        WITHDRAW.Visibility=Visibility.Visible;
                        if (acInfos.SFPZJZQ =="Y")  /*证件支取*/
                        {
                            DRAWFLAG.SetItems(new Dictionary<string, string> { { "证件支付", "1" } });
                            DRAWFLAG.SelectedIndex = 0;
                            ACIDTYPE.SetItems(UserVariable.GetIdType()); 
                            ACIDTYPE.SetSelectedValue(acInfos.ZJLX);
                            ACIDTYPE.IsEnabled=false;
                            ACIDTYPE.Visibility=Visibility.Visible;
                            IDTYPE.Visibility=Visibility.Visible;
                            ACIDNO.Visibility=Visibility.Visible;
                            IDNO.Visibility=Visibility.Visible;
                        }
                        else if(acInfos.SFPM == "Y")//凭密支取
                        {
                            DRAWFLAG.SetItems(new Dictionary<string, string> { { "密码支付", "1" } });
                            DRAWFLAG.SelectedIndex = 0;
                            ACIDTYPE.Visibility=Visibility.Collapsed;
                            IDTYPE.Visibility=Visibility.Collapsed;
                            ACIDNO.Visibility=Visibility.Collapsed;
                            IDNO.Visibility=Visibility.Collapsed;
                        }
                        else //不凭证也不凭密
                        {
                            ACIDTYPE.Visibility=Visibility.Collapsed;
                            IDTYPE.Visibility=Visibility.Collapsed;
                            ACIDNO.Visibility=Visibility.Collapsed;
                            IDNO.Visibility=Visibility.Collapsed;
                            WITHDRAW.Visibility=Visibility.Collapsed;
                            DRAWFLAG.Visibility=Visibility.Collapsed;
                            LPASSWORD.Visibility=Visibility.Collapsed;
                            GDPWD.Visibility=Visibility.Collapsed;
                        }
                        break;
                    default: //中牟郏县无要求
                        break;
                }
                #endregion 凭证支取校验
                
            }
            
        }

        /// <summary>
        /// 校验密码
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void GDPWD_LostFocus(object sender, RoutedEventArgs e)
        {
            //密码验证
            var mmcheck = this.TradeAPIs.TF_Deposit_PasswordAuthentication(new PasswordAuthentication.Input()
            {
                MM = GDPWD.Password,
                ZH = FEEACNO.Text.Trim()
            });
            if (mmcheck.IsFailed)
            {
                GDPWD.Password = string.Empty;
                this.TradeAPIs.ShowTip(mmcheck.FailureCause);
                this.TradeAPIs.SetFocus();
                return;
            }
        }

        /// <summary>
        /// 凭证支取时校验证件号码
        /// </summary>
        private void ACIDNO_LostFocus(object sender, RoutedEventArgs e)
        {
            //证件号码校验
            if (ACIDNO.Text.Trim()!=zjhm)
            {
                ACIDNO.Text = string.Empty;
                this.TradeAPIs.ShowTip("证件号码不正确");
                this.TradeAPIs.SetFocus();
                return;
            }
        }

        //private void ACIDTYPE_LostFocus(object sender, RoutedEventArgs e)
        //{
        //    //证件类型校验
        //    if (ACIDTYPE.GetSelectedValue() != zjlx)
        //    {
        //        this.TradeAPIs.ShowTip("证件类型不符");
        //        this.TradeAPIs.SetFocus();
        //        return;
        //    }

        //}
    }
}