﻿using System.Collections.Generic;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.IO;
using System.ComponentModel;
using Platform.ServiceProxy.ServiceFunction.Entitys;
using Platform.ServiceProxy.ServiceHelper;
using Platform.Library;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Library.Ext.TradeExtension;

namespace TellerSystem.Controls.Ext.Controls
{
    /// <summary>
    /// Imageshow.xaml 的交互逻辑
    /// </summary>
    [DesignTimeVisible(false)]
    public partial class Imageshow 
    {
        public Imageshow(string[] Imgid)
        {
            InitializeComponent();
            //点击缩略图事件绑定
            CommandBindings.Add(new CommandBinding(Commands.ClickImage,
                new ExecutedRoutedEventHandler(ClickImage_Executed)));
            AttchedFiles[] imagedata = FilesHandle.GetAttachedFiles(Imgid);
            itemscontrol.ItemsSource = InitialImg(imagedata);
            bitmapsor = InitialImg(imagedata);
            if (bitmapsor!=null)
            {
                mainimg.Source = bitmapsor[0];
            }
            
        }
        #region 变量
        List<BitmapSource> bitmapsor = new List<BitmapSource>();
        #endregion
        #region 方法
            
        public static BitmapImage ByteArrayToBitmapImage(byte[] byteArray)
        {
            BitmapImage bmp = null;

            try
            {
                bmp = new BitmapImage();
                bmp.BeginInit();
                bmp.StreamSource = new MemoryStream(byteArray);
                bmp.EndInit();
            }
            catch
            {
                bmp = null;
            }

            return bmp;
        }

        public List<BitmapSource> InitialImg(AttchedFiles[] imagedata)
        {
            List<BitmapSource> bitmg = new List<System.Windows.Media.Imaging.BitmapSource>();
            for (int i = 0; i < imagedata.Length;i++ )
            {
                BitmapSource bitsource = ByteArrayToBitmapImage(imagedata[i].Filedata);
                bitmg.Add(bitsource);
            }
            return bitmg;
        }
#endregion
        #region  ClickImageCommand
        /// <summary>
        /// Click Image brcapture will get source
        /// </summary>
        private void ClickImage_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            Button b = (Button)e.OriginalSource;
            mainimg.Source = b.Tag
                as ImageSource;
        }

        #endregion

        private void imgItem_MouseDown(object sender, MouseButtonEventArgs e)
        {
           
        }
    }
}
