﻿using Platform.Controls.ComponentContainer;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Excel = Microsoft.Office.Interop.Excel;
using System.Xml;
using System.Windows.Controls.Primitives;

namespace TellerSystem.Controls.Ext.Controls.ListviewPager
{
    /// <summary>
    /// Listview.xaml 的交互逻辑
    /// </summary>
    public partial class Listviewpg : UserControl, INotifyPropertyChanged
    {
        Point startPoint;
        ListBoxItem contact;
        XmlElement Destelement;
        XmlElement Startelement;
        private int _total;
        public delegate void HyperlinkClicked(string primarykey, string value, string tablename);
        public HyperlinkClicked Hyperlinkclick;
        public delegate void SetButtonIsNoEnable();
        public delegate void ListviewDoublueClick();
        public ListviewDoublueClick ListviewClick;
        public SetButtonIsNoEnable SetEnable;
        public SetButtonIsNoEnable SetDisable;
        private string FilterString = string.Empty;
        public event PropertyChangedEventHandler PropertyChanged;
        public event EventHandler SelectionChange;
        private string s_ToolTip = string.Empty;
        /// <summary>
        /// 设置要选中的值
        /// </summary>
        //public bool EnableDrag
        //{
        //    get { return (bool)GetValue(EnableDragProperty); }
        //    set { SetValue(EnableDragProperty, value); }
        //}

        //public static readonly DependencyProperty EnableDragProperty =
        //    DependencyProperty.Register("EnableDrag", typeof(bool), typeof(DateSpanControl), new UIPropertyMetadata(-1));
        public static readonly RoutedEvent ListviewLostFocus = EventManager.RegisterRoutedEvent("ListviewLostFocus", RoutingStrategy.Bubble, typeof(RoutedEventHandler), typeof(TBC_Curreny));
        public event RoutedEventHandler ListviewLostFocusEvent
        {
            add { base.AddHandler(ListviewLostFocus, value); }

            remove { base.RemoveHandler(ListviewLostFocus, value); }

        }
        public string ToolTips
        {
            get { return s_ToolTip; }
            set { s_ToolTip = value; }
        }

        private Dictionary<string, List<string>> dc_table;
        public Listviewpg()
        {
            //EnableDrag = false;
            InitializeComponent();
            dc_table = new Dictionary<string, List<string>>();
            dataPager.SetBinding(DataPager.TotalProperty, new Binding("Total") { Source = this });

        }
        public double height
        {
            get
            {
                return this.gourpbox.Height;
            }
            set
            {
                this.gourpbox.Height = value;
            }
        }
        public double width
        {
            get
            {
                return this.gourpbox.Width;
            }
            set
            {
                this.gourpbox.Width = value;
            }
        }
        private XmlDataProvider _xdp;
        public int Total
        {
            get { return _total; }
            private set
            {
                _total = value;


                RaisePropertyChanged("Total");
            }
        }
        public IList SelectedItems
        {
            get
            {
                return this.listview1.SelectedItems;
            }
        }

        public XmlDataProvider Xdp
        {
            get
            {
                return _xdp;
            }
            set
            {
                _xdp = value;
            }
        }
        //  public void add(Dictionary<string> )
        public void Bind(XmlDataProvider xdp)
        {

            _xdp = xdp;
            if (xdp != null)
            {
                _xdp.XPath = @"//Result";
                this.listview1.DataContext = _xdp;
                this.listview1.SetBinding(ListView.ItemsSourceProperty, new Binding());

                Total = _xdp.Document.SelectNodes(@"//Result").Count;

                dataPager.RaisePageChanged();
                dataPager.PageIndex = 1;
                dataPager_PageChanged(null, new PageChangedEventArgs(null, dataPager.PageSize, dataPager.PageIndex));
                dataPager.RaisePageChanged();
                dataPager.IsEnabled = true;
                
            }
            else
            {
                this.listview1.DataContext = _xdp;
                this.listview1.SetBinding(ListView.ItemsSourceProperty, new Binding());
                Total = 0;
                dataPager.RaisePageChanged();
                dataPager.PageIndex = 1;

            }
            
        }
        /// <summary>
        /// 设置列宽
        /// </summary>
        /// <param name="index">索引</param>
        /// <param name="value">列宽值</param>
        public void SetColumnsWidth(int index, double value)
        {
            if (gridView != null && gridView.Columns.Count > index)
                gridView.Columns[index].Width = value;
        }
        public void Setfilter(Dictionary<string, string> dc)
        {
            if (dc == null)
            {
                FilterString = string.Empty;
            }
            else
            {

                foreach (KeyValuePair<string, string> kv in dc)
                {
                    FilterString = "@" + kv.Key + "=\"" + kv.Value + "\" and ";
                }

            }
            dataPager.RaisePageChanged();
        }
        private void dataPager_PageChanged(object sender, Platform.Controls.ComponentContainer.PageChangedEventArgs args)
        {
            //_xdp.XPath=@"//Result[prdt_no=]";
            if (_xdp != null)
            {
                //if (EnableDrag == false)
                //{

                    _xdp.XPath = @"//Result[" + (args.PageIndex - 1) * args.PageSize + "<position() and position()<" + (args.PageIndex * args.PageSize + 1) + "]";
                    autosetcolumnwidth(args.PageIndex, args.PageSize);
                //}
            }
        }
        //初始化界面元素 titile：goupbox的标题；dc：listview的列名跟绑定对应值的字典
        public void Initialize(string title, Dictionary<string, string> dc_data, Dictionary<string, List<string>> dc_linkview = null)
        {
            listview1.AddHandler(System.Windows.Controls.Primitives.ButtonBase.MouseEnterEvent, new RoutedEventHandler(HandleEnter));
            if (dc_linkview != null)
            {
                dc_table = dc_linkview;
            }
            this.gourpbox.Header = title;

            GridView gv = this.listview1.View as GridView;
            gv.Columns.Clear();
            foreach (KeyValuePair<string, string> kvp in dc_data)
            {
                //增加column

                GridViewColumn gvc = new GridViewColumn();

                gvc.Header = kvp.Key;
                gvc.Width = kvp.Key.Length * 20;

                Binding b = new Binding();
                b.XPath = kvp.Value;


                //
                if ((dc_linkview != null) && (dc_linkview.Keys.Contains(kvp.Value)))
                {

                    DataTemplate dataTempControl = new DataTemplate();
                    FrameworkElementFactory tbContent = new FrameworkElementFactory(typeof(TextBlock));
                    //FrameworkElementFactory hl = new FrameworkElementFactory(typeof(Hyperlink));
                    tbContent.SetValue(TextBlock.NameProperty, kvp.Value);

                    tbContent.SetBinding(TextBlock.TextProperty, b);
                    //hl.AppendChild(tbContent);
                    //FrameworkElementFactory tb = new FrameworkElementFactory(typeof(TextBlock));
                    tbContent.AddHandler(TextBlock.MouseLeftButtonUpEvent, new MouseButtonEventHandler(hyperlink_click));
                    tbContent.SetValue(TextBlock.CursorProperty, Cursors.Hand);
                    tbContent.SetValue(TextBlock.ForegroundProperty, Brushes.Red);
                    //tb.AppendChild(hl);

                    dataTempControl.VisualTree = tbContent;
                    dataTempControl.VisualTree.Name = kvp.Value;
                    gvc.CellTemplate = dataTempControl;


                }
                else
                {
                    gvc.DisplayMemberBinding = b;
                }

                //
                gv.Columns.Add(gvc);
            }
            this.listview1.Height = gourpbox.Height - 70;
        }

        public void RaisePropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged.Invoke(this, new PropertyChangedEventArgs(propertyName));
            }

        }

        private void listview1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (this.listview1.SelectedItems.Count == 0)
                SetDisable();
            else
                SetEnable();
        }
        private void autosetcolumnwidth(int pageindex, int pagesize)
        {
            GridView gv = this.listview1.View as GridView;
            int columncount = gv.Columns.Count;
            int datalen=0;
            int maxlen=0;
            XmlNodeList xnl = _xdp.Document.SelectNodes("//Result");
            if (columncount > 10)
            {
                return;
            }
            for (int columnindex = 0; columnindex < columncount; columnindex++)
            {
                for (int i = (pageindex - 1) * pagesize; (i < (pageindex * pagesize + 1)) && (i < xnl.Count); i++)
                {
                    try
                    {
                        datalen = System.Text.Encoding.Default.GetByteCount(xnl[i].SelectSingleNode((gv.Columns[columnindex].DisplayMemberBinding as Binding).XPath).InnerText);
                    }
                    catch (Exception ex)
                    {
                        datalen = System.Text.Encoding.Default.GetByteCount(xnl[i].SelectSingleNode(gv.Columns[columnindex].CellTemplate.VisualTree.Name).InnerText);
                    }
                    maxlen = datalen > maxlen ? datalen : maxlen; 
                }
                gridView.Columns[columnindex].Width = gridView.Columns[columnindex].Width > maxlen * 10 ? gridView.Columns[columnindex].Width : maxlen * 10;
                maxlen=0;

            }
           
        }
        /**这个方法只能生成listview里面显示的列的内容的excel，感觉意义不大**/
        public void GenerateExcel(string SheetName)
        {
            //
            int rowcount = Total;     /*行数等于查询到的记录总条数*/
            if (rowcount == 0)
            {
                return;
            }
            string SavedPath = string.Empty;                         //Excel文件保存路径
            //string CurPath = System.Environment.CurrentDirectory;    //程序运行的当前目录
            //if (!System.IO.Directory.Exists(CurPath + @"\Excel"))    //判断目录是否存在
            //{
            //    System.IO.Directory.CreateDirectory(CurPath + @"\Excel");
            //}
            //SavedPath = String.Format(@"{0}\Excel\{1}.xlsx", CurPath, SheetName);
            System.Windows.Forms.SaveFileDialog dlg = new System.Windows.Forms.SaveFileDialog();
            dlg.Title = "请选择保存位置";
            dlg.Filter = "xls文件(*.xls)|*.txt|xlsx文件(*.xlsx)|*.xlsx";
            dlg.FileName = SheetName + ".xlsx";
            if (dlg.ShowDialog() == System.Windows.Forms.DialogResult.Cancel)
            {
                return;
            }
            SavedPath = dlg.FileName;//获取选择的文件路径和文件名

            //open excel application
            Excel.Application Excel_APP = new Excel.Application();
            Excel_APP.Visible = false;
            Excel_APP.DisplayAlerts = false;
            //create excel workbook
            Excel.Workbook excelWorkbook = Excel_APP.Workbooks.Add();
            //get excel worksheet
            Excel.Worksheet excelWorksheet = excelWorkbook.ActiveSheet;
            excelWorksheet.Name = SheetName;


            GridView gv = this.listview1.View as GridView;/*将listview里的内容以网格布局显示*/

            int columncount = gv.Columns.Count;      /*列数为listview中显示的列*/
            int rowindex = 0;
            int columnindex = 0;

            for (; columnindex < columncount; columnindex++)/*生成execl表头*/
            {
                excelWorksheet.Cells[1, columnindex + 1] = gv.Columns[columnindex].Header;
            }

            XmlNodeList xnl_td = _xdp.Document.SelectNodes(@"//Result");
            for (; rowindex < rowcount; rowindex++)/*逐行打印*/
            {
                XmlNode xn_td = xnl_td.Item(rowindex);
                for (columnindex = 0; columnindex < columncount; columnindex++)/*打印单行每个列的数据*/
                {
                    try
                    {
                        excelWorksheet.Cells[2 + rowindex, columnindex + 1] = "\'" + xn_td.SelectSingleNode((gv.Columns[columnindex].DisplayMemberBinding as Binding).XPath).InnerText;
                    }
                    catch (Exception ex)
                    {
                        excelWorksheet.Cells[2 + rowindex, columnindex + 1] = "\'" + xn_td.SelectSingleNode(gv.Columns[columnindex].CellTemplate.VisualTree.Name).InnerText;
                    }
                }
            }
            excelWorkbook.SaveAs(SavedPath);
            excelWorkbook.Close();
            Excel_APP.Quit();
            //

        }

        private void hyperlink_click(object sender, RoutedEventArgs e)
        {
            TextBlock selectedElement = sender as TextBlock;
            selectedElement.SetValue(TextBlock.ForegroundProperty, Brushes.PaleVioletRed);
            Hyperlinkclick(dc_table[selectedElement.Name][0], selectedElement.Text, dc_table[selectedElement.Name][1]);
        }

        private void Export_Click(object sender, RoutedEventArgs e)
        {
            this.GenerateExcel(gourpbox.Header.ToString());
        }

        private void HanderDoubleClick(object sender, MouseButtonEventArgs e)
        {
            ListviewClick();
        }
        private void HandleEnter(object sender, RoutedEventArgs e)
        {
            if (s_ToolTip != "")
            {
                ToolTip tooltip = new ToolTip();
                tooltip.StaysOpen = true;
                
                tooltip.Placement = PlacementMode.Right;
                tooltip.PlacementRectangle = new Rect(50, 0, 0, 0);
                tooltip.Content = s_ToolTip;
                tooltip.HorizontalOffset = 730;
                tooltip.VerticalOffset = 20;
                gourpbox.ToolTip = tooltip;
                
            }
        }


     
        private void gourpbox_LostFocus(object sender, RoutedEventArgs e)
        {
            RaiseEvent(new RoutedEventArgs(Listviewpg.ListviewLostFocus, this));
        }

        private void listview1_DragEnter(object sender, DragEventArgs e)
        {
            
        }

        private void listview1_Drop(object sender, DragEventArgs e)
        {
           
           // MessageBox.Show(Destelement.ChildNodes[0].InnerText);
            //XmlDocument xd = ((XmlDataProvider)listview1.DataContext).Document;
            Destelement = (XmlElement)Element_undercursor;
            
            Destelement.ParentNode.InsertBefore(Startelement, Destelement);
            
            ;

        }

        private void listview1_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            startPoint = e.GetPosition(null);
            Startelement =(XmlElement) Element_undercursor;
        }
        private static T FindAnchestor<T>(DependencyObject current) where T : DependencyObject
        {
            do
            {
                if (current is T)
                {
                    return (T)current;
                }
                current = VisualTreeHelper.GetParent(current);
            }
            while (current != null);

            return null;
        }

        private void listview1_PreviewMouseMove(object sender, MouseEventArgs e)
        {
            Point mousPos = e.GetPosition(null);
            Vector diff = startPoint - mousPos;

            if ((e.LeftButton == MouseButtonState.Pressed) && (Math.Abs(diff.X) > SystemParameters.MinimumHorizontalDragDistance) && (Math.Abs(diff.Y) > SystemParameters.MinimumVerticalDragDistance))
            {
                ListView listView = sender as ListView;
                ListViewItem listViewItem = FindAnchestor<ListViewItem>((DependencyObject)e.OriginalSource);
                if (listViewItem == null) { return; }
                
                DataObject dataObject = new DataObject("MyFormat", listViewItem);
                DragDrop.DoDragDrop(listViewItem, dataObject, DragDropEffects.Move);
            }
        }
        bool IsMouseOver(Visual target)
        {
            // We need to use MouseUtilities to figure out the cursor
            // coordinates because, during a drag-drop operation, the WPF
            // mechanisms for getting the coordinates behave strangely.

            Rect bounds = VisualTreeHelper.GetDescendantBounds(target);
            Point mousePos = MouseUtilities.GetMousePosition(target);
            return bounds.Contains(mousePos);
        }
        public XmlElement Element_undercursor 
        {
            get 
            {
                XmlElement ret = null;
                if (listview1.Items.Count == 0)
                {
                    return ret;
                }
                ret=(XmlElement)listview1.Items[0];
                for (int i = 0; i < this.listview1.Items.Count; ++i)
                {
                    ListViewItem item = this.listview1.ItemContainerGenerator.ContainerFromIndex(i) as ListViewItem;
                    if (this.IsMouseOver(item))
                    {
                        ret=(XmlElement)listview1.Items[i];
                        break;
                    }
                }
                
                return ret;
            }
        } 
        private void listview1_DragOver(object sender, DragEventArgs e)
        {
            
            
        }

        private void listview1_PreviewMouseRightButtonUp(object sender, MouseButtonEventArgs e)
        {
            
        }


    }
}
