﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TellerSystem.Controls.Ext.Controls
{
    /// <summary>
    /// MoneyGrid.xaml 的交互逻辑
    /// </summary>
    public partial class MoneyGrid : UserControl
    {
        public MoneyGrid()
        {
            InitializeComponent();
        }

        public bool SetText(string text)
        {
            decimal d;
            if (decimal.TryParse(text.Replace(",", "").Replace("，", ""), out d))
            {
                Val = d;
                return true;
            }
            return false;
        }

        public string Text
        {
            set
            {
                decimal d;
                if (decimal.TryParse(value.Replace(",", "").Replace("，", ""), out d))
                {
                    Val = d;
                }
            }
        }

        private decimal _val;
        /// <summary>
        /// 显示金额
        /// </summary>
        public decimal Val
        {
            get { return _val; }
            set
            {
                _val = value;
                Refresh();
            }
        }

        private void Refresh()
        {
            //扩大100倍，舍弃多余部分
            //TODO:四舍五入
            var value = decimal.Truncate(Val * 100).ToString();
            //超出亿位
            if (value.Length > 11)
            {
                value = "数据错误，无法正常显示";
            }
            else if (value.Length < 11)
            {
                value = ("¥" + value).PadLeft(11, ' ');
            }
            foreach (var item in value)
            {
                UG_DataHost.Children.Add(new TextBlock { Text = item.ToString(), TextAlignment = TextAlignment.Center, VerticalAlignment = System.Windows.VerticalAlignment.Center });
            }
        }
    }
}
