﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TellerSystem.Controls.Ext.Controls
{
	/// <summary>
	/// PairStateSign.xaml 的交互逻辑
	/// </summary>
	public partial class PairStateSign : UserControl
	{
		public PairStateSign()
		{
			this.InitializeComponent();
		}

        private int _currentState = 0;

        /// <summary>
        /// 当前状态，可以使用0,1,2,3...9标识，如果完成使用-1
        /// </summary>
        public int CurrentState
        {
            get { return _currentState; }
            set 
            {
                if (value == -1)
                {
                    tb.Text = "√";
                    _currentState = value;
                    fore.Fill = new SolidColorBrush(Color.FromRgb(255, 138, 0));
                    forePath.Visibility = System.Windows.Visibility.Collapsed;
                }
                else if (value >= 0 && value <= 9)
                {
                    tb.Text = value.ToString();
                    _currentState = value;
                    fore.Fill = new SolidColorBrush(Color.FromRgb(187, 187, 187));
                    forePath.Visibility = System.Windows.Visibility.Collapsed;
                }
                else
                {
                    throw new ArgumentException("只能是-1 - 9之间的整数", "CurrentState");
                }
            }
        }
	}
}