﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TellerSystem.Controls.Ext.ControlEntity;

namespace TellerSystem.Controls.Ext.Controls
{
    /// <summary>
    /// Interaction logic for PropGuide.xaml
    /// </summary>
    public partial class PropGuide : UserControl
    {
        PropGuideEntity[] _source;

        public PropGuide()
        {
            InitializeComponent();
        }

        public int ColumnCount { get; set; }

        public void SetDataSource(IEnumerable<PropGuideEntity> source)
        {
            _source = source.ToArray();

            BindData();
        }

        private void BindData()
        {
            if (_source == null || _source.Length == 0) return;

            TP_Host.Children.Clear();
            foreach (var item in _source)
            {
                if (item.Children == null || item.Children.Count == 0)
                    continue;
                foreach (var property in item.Children)
                {
                    TP_Host.Children.Add(new TextBlock { Text = property.Key });
                    TP_Host.Children.Add(new TextBox { Text = property.Value, IsEnabled = false });
                }
            }
        }
    }
}
