﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TellerSystem.Controls.Ext.Controls
{
    /// <summary>
    /// ZoomSlider.xaml 的交互逻辑
    /// </summary>
    public partial class ZoomSlider : UserControl
    {
        public ZoomSlider()
        {
            InitializeComponent();
            this.DataContext = ZoomSliderModel.GetInstances();


            ZoomOutButton.AddHandler(Button.MouseLeftButtonDownEvent, new MouseButtonEventHandler(ZoomOutButton_MouseLeftButtonDown), true);
            ZoomInButton.AddHandler(Button.MouseLeftButtonDownEvent, new MouseButtonEventHandler(ZoomInButton_MouseLeftButtonDown), true);
        }

        /// <summary>
        /// 放大容器
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ZoomOutButton_MouseLeftButtonDown(object sender, RoutedEventArgs e)
        {
            ZSilder.Value += 0.05;
        }

        /// <summary>
        /// 缩小容器 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ZoomInButton_MouseLeftButtonDown(object sender, RoutedEventArgs e)
        {
            ZSilder.Value -= 0.05;
        }

        private void ZSilder_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            ZoomSliderModel sliderModel = ZoomSliderModel.GetInstances();

            sliderModel.Tick = ZSilder.Value;
        }


    }
}
