﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace TellerSystem.Controls.Ext.Controls
{
    public class ZoomSliderModel : INotifyPropertyChanged
    {
        private double tick = 1.0d;
        private static ZoomSliderModel sliderModel = null;


        public double Tick
        {
            get 
            {
                return tick; 
            }
            set
            {
                tick = value;
                RaisePropertyChanged("Tick");
            }
        }


        /// <summary>
        /// 获取实例对象
        /// </summary>
        /// <returns></returns>
        public static ZoomSliderModel GetInstances() 
        {
            if (sliderModel == null)
            {
                sliderModel = new ZoomSliderModel();
            }

            return sliderModel;
        }

        #region INotifyPropertyChanged 成员

        public event PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        #endregion
    }
}
