﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using TellerSystem.Contract.Function;
using TellerSystem.Library.Ext.TradeExtension;

namespace TellerSystem.Controls.Ext.Controls
{
    public partial class SealVerSys : Form
    {
        private Point mouseOffset; //记录鼠标指针的坐标 
        private bool isMouseDown = false; //记录鼠标按键是否按下 

        public string zh = string.Empty;
        public string pzh = string.Empty;
        public string je = string.Empty;
        public string cprq = string.Empty;
        public string gyh = string.Empty;
        public string jgh = string.Empty;
        public string pzzl = string.Empty;
        public string pzhm = string.Empty;
        public string shengpi = string.Empty;
        public string result = string.Empty;

        public SealVerSys()
        {
            InitializeComponent();
        }

        private void Submit_Click(object sender, EventArgs e)
        {
            result = axsids_soi_ocx1.getResult();
            shengpi = axsids_soi_ocx1.getResultEx();
            this.Close();
        }

        private void SealVerSys_MouseDown(object sender, MouseEventArgs e)
        {
            int xOffset;
            int yOffset;
            if (e.Button == MouseButtons.Left)
            {
                xOffset = -e.X - SystemInformation.FrameBorderSize.Width;
                yOffset = -e.Y - SystemInformation.CaptionHeight -
                SystemInformation.FrameBorderSize.Height;
                mouseOffset = new Point(xOffset, yOffset);
                isMouseDown = true;
            }
        }

        private void SealVerSys_MouseMove(object sender, MouseEventArgs e)
        {
            if (isMouseDown)
            {
                Point mousePos = Control.MousePosition;
                mousePos.Offset(mouseOffset.X, mouseOffset.Y);
                Location = mousePos;
            }
        }

        private void SealVerSys_MouseUp(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                isMouseDown = false;
            }
        }

        private void SealVerSys_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Escape)
            {
                if (MessageBox.Show("是否关闭页面？", "提示", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1) == DialogResult.Yes)
                {
                    this.Close();
                }
            }
            return;
        }

        private void axsids_soi_ocx1_PreviewKeyDown(object sender, PreviewKeyDownEventArgs e)
        {
            if (e.KeyData == Keys.Escape)
            {
                if (MessageBox.Show("是否关闭页面？", "提示", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1) == DialogResult.Yes)
                {
                    this.Close();
                }
            }
            return;
        }

        private void SealVerSys_Load(object sender, EventArgs e)
        {
            string result = "<?xml version='1.0' encoding='gb2312'?><input><accno>" + zh + "</accno>(账号)<vchno>" + pzh + "</vchno>（凭证号）<amount>" + je + "</amount>(金额)<vchdate>" + cprq + "</vchdate>（出票日期）<bankname>DXCD</bankname><vchtype><vt id='" + pzhm + "'>" + pzzl + "</vt>（id为凭证代码，值为凭证名称）</vchtype><clkno>" + gyh + "</clkno>（柜员号）<depno>" + jgh + "</depno>（机构号）<color>0</color><bottom>550</bottom><interfaceUrl>http://10.1.62.103:8080/jybankservice/services/StampServiceIf</interfaceUrl> (此地址由验印系统给定)<left>0</left><bank>DXCD</bank><dpi>300</dpi><priv>3</priv><right>750</right><top>0</top></input>";
            axsids_soi_ocx1.setSoidentify(result);
        }
    }
}
