﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TellerSystem.Controls.Ext.Controls
{
    /// <summary>
    /// TradeLinkList.xaml 的交互逻辑
    /// </summary>
    public partial class TradeLinkList : UserControl
    {
        public delegate void ClickHandle(TradeLinkVM vm);
        public event ClickHandle Click;

        public TradeLinkList()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            TradeLinkVM vm = (TradeLinkVM)(sender as FrameworkElement).Tag;
            if (vm.Unlink) return;

            IEnumerable<TradeLinkVM> list = (IEnumerable<TradeLinkVM>)this.DataContext;

            foreach (var item in list)
                item.IsSelected = false;

            vm.IsSelected = true;

            vm.Unlink = true;
            if (this.Click != null)
                this.Click(vm);
            //去掉设置可用add hcy
            //vm.Unlink = false;
            e.Handled = true;
        }
    }

    internal class BooleanToVisibility : IValueConverter
    {

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if ((bool)value)
                return Visibility.Visible;
            else
                return Visibility.Collapsed;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
