﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TellerSystem.Controls.Ext.Controls
{
    public class TradeLinkVM : Platform.Common.BasicFunctions.NotificationObject
    {
        private string _code;
        /// <summary>
        /// 交易号
        /// </summary>
        public string Code
        {
            get { return _code; }
            set
            {
                _code = value;
                RaisePropertyChanged("Code");
            }
        }

        private string _name;
        /// <summary>
        /// 交易名称
        /// </summary>
        public string Name
        {
            get { return _name; }
            set
            {
                _name = value;
                RaisePropertyChanged("Name");
            }
        }

        private bool _isSelected;
        /// <summary>
        /// 是否选中
        /// </summary>
        public bool IsSelected
        {
            get { return _isSelected; }
            set
            {
                _isSelected = value;
                RaisePropertyChanged("IsSelected");
            }
        }

        private bool _unlink;

        /// <summary>
        /// 是否可用
        /// </summary>
        public bool Unlink
        {
            get { return _unlink; }
            set
            {
                _unlink = value;
                RaisePropertyChanged("Unlink");
            }
        }
        private string _hotKey;

        /// <summary>
        /// 是否可用
        /// </summary>
        public string HotKey
        {
            get { return _hotKey; }
            set
            {
                _hotKey = value;
                RaisePropertyChanged("HotKey");
            }
        }

        private static List<TradeLinkVM> _testData;
        /// <summary>
        /// 设计时数据
        /// </summary>
        public static List<TradeLinkVM> TestData
        {
            get
            {
                if (_testData == null)
                {
                    _testData = new List<TradeLinkVM>();
                    _testData.Add(new TradeLinkVM { Code = "1000", Name = "交易1000" });
                    _testData.Add(new TradeLinkVM { Code = "1001", Name = "交易1001" });
                    _testData.Add(new TradeLinkVM { Code = "1002", Name = "交易1002" });
                    _testData.Add(new TradeLinkVM { Code = "1003", Name = "交易1003" });
                    _testData.Add(new TradeLinkVM { Code = "1004", Name = "交易1004" });
                    _testData.Add(new TradeLinkVM { Code = "1005", Name = "交易1005" });
                    _testData.Add(new TradeLinkVM { Code = "1006", Name = "交易1006" });
                    _testData.Add(new TradeLinkVM { Code = "1007", Name = "交易1007" });
                    _testData.Add(new TradeLinkVM { Code = "1008", Name = "交易1008" });
                    _testData.Add(new TradeLinkVM { Code = "1009", Name = "交易1009" });
                    _testData.Add(new TradeLinkVM { Code = "1010", Name = "交易1010" });
                    _testData.Add(new TradeLinkVM { Code = "1011", Name = "交易1011" });
                }
                return _testData;
            }

        }

    }
}
