﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;

namespace TellerSystem.Controls.Ext.Controls
{
   public class DataGridTreeViewColumn
   {   
      /// <summary>
      /// TreeViewList快捷指定列
      /// </summary>
      public DataGridTreeViewColumn()
      {

      }

      /// <summary>
      /// TreeViewList快捷指定列
      /// </summary>
      public DataGridTreeViewColumn(string header, string bindPropertyName, double width = 100, TextAlignment textAlignment = TextAlignment.Left)
      {
         this.Header = header;
         this.BindPropertyName = bindPropertyName;
         this.Width = width;
         this.TextAlignment = textAlignment;
      }
      /// <summary>
      /// 获取或设置宽度
      /// </summary>
      public double Width { get; set; }
      /// <summary>
      /// 获取或设置标题
      /// </summary>
      public string Header { get; set; }
      /// <summary>
      /// 获取或设置绑定的属性名
      /// </summary>
      public string BindPropertyName { get; set; }
      /// <summary>
      /// 获取或设置文本对齐方式
      /// </summary>
      public TextAlignment TextAlignment { get; set; }
   }
}
