﻿using System;
using System.Globalization;
using System.Windows;
using System.Windows.Data;
namespace TellerSystem.Controls.Ext.Controls
{
   public class LevelToIndentConverter : IValueConverter
   {
      private static double _indentSize = 10.0;

      /// <summary>
      /// 获取或设置缩进
      /// </summary>
      public static double IndentSize
      {
         get { return LevelToIndentConverter._indentSize; }
         set { LevelToIndentConverter._indentSize = value; }
      }

      public object Convert(object o, Type type, object parameter, CultureInfo culture)
      {
         return new Thickness((int)o * _indentSize, 0, 0, 0);
      }

      public object ConvertBack(object o, Type type, object parameter, CultureInfo culture)
      {
         throw new NotSupportedException();
      }
   }
}
