﻿using System.Collections.Generic;
using System.Windows.Controls;
using System.Windows.Media;
using System.ComponentModel;

namespace TellerSystem.Controls.Ext.Controls
{
    /// <summary>
    /// attchImge.xaml 的交互逻辑
    /// </summary>
    [DesignTimeVisible(false)]
    public partial class attchImge : UserControl
    {
        public attchImge()
        {
            InitializeComponent();
        }
        
        private void imageListBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Attachment attachment = (Attachment)imageListBox.SelectedItem;
            imageBig.Source = attachment.Source;
            textDescription.Text = attachment.Description;
            bigLable.ToolTip = new Image() { Source = attachment.Source, MaxWidth = 700, MaxHeight = 600 };
        }
       
        public  void  InitData(List<Attachment> list)
        {
            imageListBox.ItemsSource = list;
            imageListBox.Items.Refresh();
            if (list != null && list.Count > 0)
            {
                textName.Text = "本交易附件数量：" + list.Count + " 个";
            }
            else { textName.Text = "本交易没有附件"; }
        }
        public void InitData(List<Attachment> list,string title)
        {
            imageListBox.ItemsSource = list;
            imageListBox.Items.Refresh();
            textName.Text = title;
        }
    }
    public class Attachment
    {
        public Attachment()
        {

        }
        public Attachment(ImageSource source, string description, string imageName)
        {
            this.Description = description;
            this.Source = source;
            this.ImageName = imageName;
        }
        public Attachment(ImageSource source, string description, double imageWidth, double imageHeight)
        {
            this.Description = description;
            this.Source = source;
            this.ImageWidth = imageWidth;
            this.ImageHeight = imageHeight;
        }
        private double imageWidth = 133;
        public double ImageWidth
        {
            get { return imageWidth; }
            set { imageWidth = value; }
        }
        private double imageHeight = 70;
        public double ImageHeight
        {
            get { return imageHeight; }
            set { imageHeight = value; }
        }
        private string description = "截图说明";
        public string Description
        {
            get { return description; }
            set { description = value; }
        }
        private string imageName = "截图展示";
        public string ImageName
        {
            get { return imageName; }
            set { imageName = value; }
        }
        private ImageSource source ;
        public ImageSource Source
        {
            get { return source; }
            set { source = value; }
        }
    }
}
