// Enum与Source转换
export class EnumToSourceConverter {
    public convert(value: HandleType): string {
        let bgSource = '';
        if (value === HandleType.Handled) { // 已处理
            bgSource = 'pack://application:,,,/TellerSystem.Controls.Ext;component/ControlsExt/Resources/led_red.png';
        } else if (value === HandleType.UnHandled) { // 未处理
            bgSource = 'pack://application:,,,/TellerSystem.Controls.Ext;component/ControlsExt/Resources/led_green.png';
        } else {
            bgSource = 'pack://application:,,,/TellerSystem.Controls.Ext;component/ControlsExt/Resources/led_yellow.png';
        }
        return bgSource;
    }

    public convertBack(value: string): HandleType {
        return HandleType.UnHandled;
    }
}

// Enum与Visibility转换
export class EnumToVisibilityConverter {
    public convert(value: HandleType): 'visible' | 'hidden' {
        if (value === HandleType.Handled) { // 已处理
            return 'hidden';
        } else if (value === HandleType.UnHandled) { // 未处理
            return 'hidden';
        } else {
            return 'visible';
        }
    }

    public convertBack(value: 'visible' | 'hidden'): HandleType {
        return value === 'visible' ? HandleType.Handleding : HandleType.UnHandled;
    }
}

// Bool与Visibility转换
export class BooleanToVisibilityConverter {
    public convert(value: boolean): 'visible' | 'hidden' {
        return value ? 'visible' : 'hidden';
    }

    public convertBack(value: 'visible' | 'hidden'): boolean {
        return value === 'visible';
    }
}