﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using Platform.Common.RunningParameters;
using Platform.Print;
using TellerSystem.Communication;
using TellerSystem.Library.Ext.Function;
using TellerSystem.PrintTemplate.Bankbook;
using TellerSystem.Library.Ext.Variables;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;

namespace TellerSystem.Controls.Ext.PrintsHelper
{

    /// <summary>
    /// 存折打印辅助类
    /// </summary>
    public class BankBookHelper
    {
        public static string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");

        #region 活期存折

        /// <summary>
        /// 打印储蓄存折首页
        /// </summary>
        /// <param name="msg">报文</param>
        /// <returns></returns>
        public static List<PrintContainer> PrintCXCZFirstPage(Message msg)
        {
            if (FLAG == "V7")//都匀
            {
                var aCxczBankbook = CXCZBankbookDY.GetInstance();
                AnalyzeCXCZDataDY(aCxczBankbook, msg, "FirstPage");
                return aCxczBankbook.PrintBankBookPage();
            }
            else if (FLAG == "V10" || FLAG == "V13" || FLAG == "V14" || FLAG == "V16" || FLAG == "V17" || FLAG == "V18" || FLAG == "V19" || FLAG == "V21" || FLAG == "V22")
            {
                var aCxczBankbook = CXCZBankbookQF.GetInstance();
                AnalyzeCXCZDataQF(aCxczBankbook, msg, "FirstPage");
                return aCxczBankbook.PrintBankBookPage();
            }
            else if (FLAG == "V23" || FLAG == "V24")
            {
                var aCxczBankbook = CXCZBankbookXX.GetInstance();
                AnalyzeCXCZDataXX(aCxczBankbook, msg, "FirstPage");
                return aCxczBankbook.PrintBankBookPage();
            }
            else
            {
                var aCxczBankbook = CXCZBankbook.GetInstance();
                AnalyzeCXCZData(aCxczBankbook, msg, "FirstPage");
                return aCxczBankbook.PrintBankBookPage();


            }
        }

        /// <summary>
        /// 打印更换存折
        /// </summary>
        public static List<PrintContainer> PrintGHJZFirstPage(Message msg)
        {
            if (FLAG == "V7")//都匀
            {
                var aCxczBankbook = CXCZBankbookDY.GetInstance();
                AnalyzeCXCZDataDY(aCxczBankbook, msg, "GHJZ");
                return aCxczBankbook.PrintBankBookPage();
            }
            else if (FLAG == "V10" || FLAG == "V13" || FLAG == "V14" || FLAG == "V16" || FLAG == "V17" || FLAG == "V18" || FLAG == "V19" || FLAG == "V21" || FLAG == "V22")
            {
                var aCxczBankbook = CXCZBankbookQF.GetInstance();
                AnalyzeCXCZDataQF(aCxczBankbook, msg, "GHJZ");
                return aCxczBankbook.PrintBankBookPage();
            }
            else if (FLAG == "V23" || FLAG == "V24")
            {
                var aCxczBankbook = CXCZBankbookXX.GetInstance();
                AnalyzeCXCZDataXX(aCxczBankbook, msg, "GHJZ");
                return aCxczBankbook.PrintBankBookPage();
            }
            else
            {
                var aCxczBankbook = CXCZBankbook.GetInstance();
                AnalyzeCXCZData(aCxczBankbook, msg, "GHJZ");
                return aCxczBankbook.PrintBankBookPage();
            }
        }

        /// <summary>
        /// 打印储蓄存折数据页
        /// </summary>
        /// <param name="msg">报文</param>
        /// <returns></returns>
        public static List<PrintContainer> PrintCXCZPage(Message msg)
        {
            if (FLAG == "V7")//都匀
            {
                var aCxczBankbook = CXCZBankbookDY.GetInstance();

                AnalyzeCXCZDataDY(aCxczBankbook, msg, "Page");
                return aCxczBankbook.PrintBankBookPage();
            }
            else if (FLAG == "V10" || FLAG == "V13" || FLAG == "V14" || FLAG == "V16" || FLAG == "V17" || FLAG == "V18" || FLAG == "V19" || FLAG == "V21" || FLAG == "V22")
            {
                var aCxczBankbook = CXCZBankbookQF.GetInstance();
                AnalyzeCXCZDataQF(aCxczBankbook, msg, "Page");
                return aCxczBankbook.PrintBankBookPage();
            }
            else if (FLAG == "V23" || FLAG == "V24")
            {
                var aCxczBankbook = CXCZBankbookXX.GetInstance();
                AnalyzeCXCZDataXX(aCxczBankbook, msg, "Page");
                return aCxczBankbook.PrintBankBookPage();
            }
            else
            {
                var aCxczBankbook = CXCZBankbook.GetInstance();
                AnalyzeCXCZData(aCxczBankbook, msg, "Page");
                //return aCxczBankbook.PrintPage();
                return aCxczBankbook.PrintBankBookPage();
            }
        }

        /// <summary>
        /// 一本通子账户开户打印存折内容
        /// </summary>
        /// <param name="msg">报文</param>
        /// <returns></returns>
        public static List<PrintContainer> PrintYBTZZHPage(Message msg)
        {
            if (FLAG == "V7")//都匀
            {

                var aCxczBankbook = CXCZBankbookDY.GetInstance();
                AnalyzeCXCZDataDY(aCxczBankbook, msg, "YBTZZH");
                return aCxczBankbook.PrintBankBookPage();
            }
            else if (FLAG == "V10" || FLAG == "V13" || FLAG == "V14" || FLAG == "V16" || FLAG == "V17" || FLAG == "V18" || FLAG == "V19" || FLAG == "V21" || FLAG == "V22")
            {
                var aCxczBankbook = CXCZBankbookQF.GetInstance();
                AnalyzeCXCZDataQF(aCxczBankbook, msg, "YBTZZH");
                return aCxczBankbook.PrintBankBookPage();
            }
            else if (FLAG == "V23" || FLAG == "V24")
            {
                var aCxczBankbook = CXCZBankbookXX.GetInstance();
                AnalyzeCXCZDataXX(aCxczBankbook, msg, "YBTZZH");
                return aCxczBankbook.PrintBankBookPage();
            }
            else
            {
                var aCxczBankbook = CXCZBankbook.GetInstance();
                AnalyzeCXCZData(aCxczBankbook, msg, "YBTZZH");
                //return aCxczBankbook.PrintPage();
                return aCxczBankbook.PrintBankBookPage();
            }
        }

        /// <summary>
        /// 储蓄存折数据解析
        /// </summary>
        /// <param name="cxcz">储蓄存折</param>
        /// <param name="msg">报文</param>
        /// <returns></returns>
        private static bool AnalyzeCXCZData(CXCZBankbook cxcz, Message msg, string flag)
        {
            //开户首页数 据OPNA|@ac_no|@name|@tx_amt1|@title|@opn_date|@opn_br_no|@cif_no|@end_date|@term|@term_type|@rate|@tx_amt1|@email|@zy|@deac_type|@cur_name|@tx_code|@memo|@ac_no1||@ct_name|@ac_seqn|@ic_date|@prt_line|@prdt_no||@brf|@tmp_ac_no|@tmp_tx_name|@tel|@id_name|@id_no|@br_name|@br_tele|@note_no||||@mbfebkno|@card_flag|@tx_br_name|@nxybrno
            //储蓄存折数据CXCZ|@txday|@dscpt|@txamt|@dbflag|@avbal|@tlrno||@brno|@tty|@lineno|||@term|@rate|@ac_seqn|@srate|@sterm|@zc_flag
            //存折数据初始化
            cxcz.FirstPageData = null;
            cxcz.EndPageData = null;
            cxcz.PageData = new List<CXCZPageEntity>();
            if (flag == "FirstPage")
            {
                //首页数据
                var opna = msg.AnilyzePrintFile("OPNA|@ac_no|@name|@tx_amt1|@title|@opn_date|@opn_br_no|@cif_no|@end_date|@term|@term_type|@rate|@tx_amt|@email|@zy|@deac_type|@cur_name|@tx_code|@memo|@ac_no1||@ct_name|@ac_seqn|@ic_date|@prt_line|@prdt_no||@brf|@tmp_ac_no|@tmp_tx_name|@tel|@id_name|@id_no|@br_name|@br_tele|@note_no||||@mbfebkno|@card_flag|@tx_br_name|@nxybrno|@tctd|@cpfl|@sbh");
                if (opna.Count != 0)
                {
                    var draw = string.Empty;
                    var firstPageData = new CXCZFirstPageEntity();
                    firstPageData.AcNo = opna[0]["@ac_no"];
                    firstPageData.AcName = opna[0]["@name"];
                    firstPageData.CZNum = opna[0]["@note_no"];
                    firstPageData.CurNo = opna[0]["@cur_name"];
                    firstPageData.DrawMode = opna[0]["@zy"];
                    firstPageData.OpnBrname = opna[0]["@br_name"];
                    firstPageData.OpnDate = opna[0]["@opn_date"];
                    firstPageData.PaySysCode = opna[0]["@mbfebkno"];
                    firstPageData.DepositType = opna[0]["@term"] + opna[0]["@term_type"];
                    firstPageData.OpnBrname = opna[0]["@br_name"];
                    if (FLAG == "V1" && opna[0]["@cpfl"] == "新通知存款")
                        firstPageData.Interestrate = "";
                    else
                        firstPageData.Interestrate = opna[0]["@rate"];
                    cxcz.FirstPageData = firstPageData;
                    if (opna[0]["@prdt_no"].Substring(0, 1).Equals("1"))
                    {
                        //1活期，2定期 Type
                        //定期是部分个人结算户/储蓄户的，应该把这个去掉，但是不要把活期的去掉
                        firstPageData.Type = opna[0]["@deac_type"];
                        //打印定期产品名称，活期的改成一本通  山东多法人加对公折 @term值为1、 一本通 2、对公折
                        if (opna[0]["@term"] == "2")
                        {
                            firstPageData.Species = "对公折";
                        }
                        else
                        {
                            firstPageData.Species = "一本通";
                            if (FLAG == "V19")
                            {
                                firstPageData.Species = "储蓄存折";
                            }
                        }
                    }
                    else if (opna[0]["@prdt_no"].Substring(0, 1).Equals("2"))
                    {
                        firstPageData.Species = opna[0]["@title"];
                    }


                    //TODO:数据组装
                    var pageData = new CXCZPageEntity();
                    pageData.Balance = opna[0]["@tx_amt1"].ToDecimal().ToString("N2").PadLeft(12);
                    pageData.DateInfo = opna[0]["@opn_date"];
                    pageData.DepWinhType = ("+" + decimal.Parse(pageData.Balance).ToString()).PadLeft(14);
                    pageData.Description = opna[0]["@memo"];
                    pageData.IsVisibility = Visibility.Visible;
                    pageData.Line = 0;
                    pageData.TellerNo = opna[0]["@tel"];
                    //承德银行该项打柜员号
                    pageData.BankOperate = opna[0]["@tel"];
                    //笔序号
                    //pageData.Number = opna[0]["@prt_line"];
                    pageData.Number = opna[0]["@ac_seqn"];
                    //利率
                    if (FLAG == "V1" && opna[0]["@cpfl"] == "新通知存款")
                        pageData.Interestrate = "";
                    else
                        pageData.Interestrate = opna[0]["@rate"];
                    cxcz.PageData.Add(pageData);
                    return true;
                }
            }
            else if (flag == "Page")
            {
                //普通页数据
                var comPage = msg.AnilyzePrintFile("CXCZ|@txday|@dscpt|@txamt|@dbflag|@avbal|@tlrno|@valuflag|@brno|@tty|@lineno||@txcode|@term|@rate|@ac_seqn|@srate|@sterm|@zc_flag");
                if (comPage.Count != 0)
                {
                    CXCZPageEntity tmpPageData = null;
                    string ytxamt = string.Empty;
                    string avbal = string.Empty;
                    int curLine = 0;
                    string valuflag = string.Empty;//定义变量，解决对公存折打印异常问题
                    foreach (var alineData in comPage)
                    {
                        tmpPageData = new CXCZPageEntity();
                        tmpPageData.DateInfo = alineData["@txday"];
                        tmpPageData.Description = alineData["@dscpt"];
                        if (alineData["@dbflag"].Equals("0"))
                        {
                            //ytxamt = alineData["@txamt"].ToDecimal().ToString("N2").PadLeft(12);
                            //tmpPageData.DepWinhType = "-" + ytxamt;
                            tmpPageData.DepWinhType = ("-" + alineData["@txamt"].ToDecimal().ToString("N2")).PadLeft(14);
                        }
                        else
                        {
                            //ytxamt = alineData["@txamt"].ToDecimal().ToString("N2").PadLeft(12);
                            //tmpPageData.DepWinhType = "+" + ytxamt;
                            tmpPageData.DepWinhType = ("+" + alineData["@txamt"].ToDecimal().ToString("N2")).PadLeft(14);
                        }
                        avbal = alineData["@avbal"].ToDecimal().ToString("N2").PadLeft(12);
                        tmpPageData.Balance = avbal;
                        tmpPageData.TellerNo = alineData["@tlrno"];
                        //承德银行该项打柜员号
                        tmpPageData.BankOperate = alineData["@tlrno"];
                        //笔序号
                        // tmpPageData.Number = alineData["@lineno"];
                        tmpPageData.Number = alineData["@ac_seqn"];
                        tmpPageData.Deadline = alineData["@sterm"];
                        //利率
                        tmpPageData.Interestrate = alineData["@srate"];
                        valuflag = alineData["@valuflag"];//未解析变量，解决打印异常
                        if (!int.TryParse(alineData["@lineno"], out curLine))
                        {
                            throw new Exception("储蓄存折打印数据有问题！");
                        }
                        tmpPageData.Line = curLine;
                        tmpPageData.IsVisibility = Visibility.Visible;
                        cxcz.PageData.Add(tmpPageData);
                    }
                    return true;
                }

            }
            else if (flag == "GHJZ")
            {
                var czfy = msg.AnilyzePrintFile("CZFY|@ac_no|@name|@tx_amt1|@title|@opn_date|@opn_br_no|@cif_no|@end_date|@term|@term_type|@rate|@tx_amt1||@zy1|@deac_type|@cur_name|@tx_code||@ac_no1|||@ac_seqn|@ic_date|@prt_line|@prdt_no|@page_no|@brf|@tmp_ac_no|@tmp_tx_name||||@br_name|@br_tele|@note_no||@accno|@zy|@mbfebkno||@shebaono|@tctd_flag|@txbrname||@tctd|@cpfl");
                if (czfy.Count != 0)
                {
                    var draw = string.Empty;
                    var depositType = string.Empty;
                    var firstPageData = new CXCZFirstPageEntity();
                    firstPageData.AcNo = czfy[0]["@ac_no"];
                    firstPageData.AcName = czfy[0]["@name"];
                    firstPageData.CZNum = czfy[0]["@note_no"];
                    firstPageData.CurNo = czfy[0]["@cur_name"];
                    firstPageData.DrawMode = czfy[0]["@zy"];
                    firstPageData.OpnBrname = czfy[0]["@br_name"];
                    firstPageData.OpnDate = czfy[0]["@opn_date"];
                    firstPageData.PaySysCode = czfy[0]["@mbfebkno"];
                    //firstPageData.Type = czfy[0]["@cpfl"];
                    firstPageData.Type = czfy[0]["@deac_type"];
                    firstPageData.DepositType = czfy[0]["@term"] + czfy[0]["@term_type"];
                    firstPageData.OpnBrname = czfy[0]["@br_name"];
                    if (FLAG == "V1" && czfy[0]["@cpfl"] == "新通知存款")
                        firstPageData.Interestrate = "";
                    else
                        firstPageData.Interestrate = czfy[0]["@rate"];
                    // firstPageData.PaySysCode = GlobalVariable.Zfxthh;
                    if (czfy[0]["@prdt_no"].Substring(0, 1).Equals("1"))
                    {
                        //1活期，2定期 Type
                        //定期是部分个人结算户/储蓄户的，应该把这个去掉，但是不要把活期的去掉
                        //firstPageData.Type = czfy[0]["@deac_type"];
                        //打印定期产品名称，活期的改成一本通
                        //firstPageData.Species = "一本通";
                        //打印定期产品名称，活期的改成一本通  山东多法人加对公折 @term值为1、 一本通 2、对公折
                        if (czfy[0]["@term"] == "2")
                        {
                            firstPageData.Species = "对公折";
                        }
                        else
                        {
                            firstPageData.Species = "一本通";
                            if (FLAG == "V19")
                            {
                                firstPageData.Species = "储蓄存折";
                            }
                        }
                    }
                    else if (czfy[0]["@prdt_no"].Substring(0, 1).Equals("2"))
                    {
                        firstPageData.Species = czfy[0]["@title"];
                    }
                    cxcz.FirstPageData = firstPageData;
                }

                //普通页数据
                var comPage = msg.AnilyzePrintFile("CXCZ|@txday|@dscpt|@txamt|@dbflag|@avbal|@tlrno||@brno|@tty|@lineno||@txcode|@term|@rate|@ac_seqn|@srate|@sterm|@zc_flag");
                if (comPage.Count != 0)
                {
                    CXCZPageEntity tmpPageData = null;
                    string ytxamt = string.Empty;
                    string avbal = string.Empty;
                    int curLine = 0;
                    foreach (var alineData in comPage)
                    {
                        tmpPageData = new CXCZPageEntity();
                        tmpPageData.DateInfo = alineData["@txday"];
                        tmpPageData.Description = alineData["@dscpt"];
                        if (alineData["@dbflag"].Equals("0"))
                        {
                            ytxamt = alineData["@txamt"].ToDecimal().ToString("N2").PadLeft(12);
                            tmpPageData.DepWinhType = "-" + ytxamt;
                        }
                        else
                        {
                            ytxamt = alineData["@txamt"].ToDecimal().ToString("N2").PadLeft(12);
                            if (FLAG == "V11" && ytxamt.Equals("        0.00"))
                            {
                                tmpPageData.DepWinhType = ytxamt;
                            }
                            else
                            {
                                tmpPageData.DepWinhType = "+" + ytxamt;
                            }
                        }
                        avbal = avbal = alineData["@avbal"].ToDecimal().ToString("N2").PadLeft(12);
                        tmpPageData.Balance = avbal;
                        tmpPageData.TellerNo = alineData["@tlrno"];
                        //承德银行该项打柜员号
                        tmpPageData.BankOperate = alineData["@tlrno"];
                        //笔序号
                        //tmpPageData.Number = alineData["@lineno"];

                        tmpPageData.Number = alineData["@ac_seqn"];
                        //利率
                        //tmpPageData.Interestrate = alineData["@rate"];
                        tmpPageData.Deadline = alineData["@sterm"];
                        tmpPageData.Interestrate = alineData["@srate"];
                        if (!int.TryParse(alineData["@lineno"], out curLine))
                        {
                            throw new Exception("储蓄存折打印数据有问题！");
                        }
                        tmpPageData.Line = curLine;
                        tmpPageData.IsVisibility = Visibility.Visible;
                        cxcz.PageData.Add(tmpPageData);
                    }
                    return true;
                }
            }
            else if (flag == "YBTZZH")
            {
                var list_open = new List<CXCZPageEntity>();
                var list_cxcz = new List<CXCZPageEntity>();
                //一本通开子账户返回open开头的文件但是打印数据行
                var file_open_ybt =
                    msg.AnilyzePrintFile(
                        "OPNA|@ac_no|@name|@tx_amt1|@title|@opn_date|@opn_br_no|@cif_no|@end_date|@term|@term_type|@rate|@tx_amt|@email|@zy|@deac_type|@cur_name|@tx_code|@memo|@ac_no1||@ct_name|@ac_seqn|@ic_date|@prt_line|@prdt_no||@brf|@tmp_ac_no|@tmp_tx_name|@tel|@id_name|@id_no|@br_name|@br_tele|@note_no||||@mbfebkno|@card_flag|@tx_br_name|@nxybrno|@tctd|@cpfl|@sbh");
                if (file_open_ybt.Count == 1 && file_open_ybt[0]["@prt_line"] != "0")
                {
                    CXCZPageEntity tmpPageData = null;
                    string ytxamt = string.Empty;
                    string avbal = string.Empty;
                    int curLine = 0;
                    foreach (var alineData in file_open_ybt)
                    {
                        tmpPageData = new CXCZPageEntity();
                        tmpPageData.DateInfo = alineData["@opn_date"];
                        tmpPageData.Description = alineData["@memo"];
                        tmpPageData.DepWinhType =
                            ("+" + alineData["@tx_amt1"].ToDecimal().ToString("N2")).PadLeft(14);
                        //}
                        avbal = alineData["@tx_amt1"].ToDecimal().ToString("N2").PadLeft(12);
                        tmpPageData.Balance = avbal;
                        tmpPageData.TellerNo = alineData["@tel"];
                        //承德银行该项打柜员号
                        tmpPageData.BankOperate = alineData["@tel"];
                        //笔序号
                        // tmpPageData.Number = alineData["@prt_line"];
                        tmpPageData.Deadline = alineData["@term"] + alineData["@term_type"];
                        tmpPageData.Number = alineData["@ac_seqn"];
                        //利率
                        if (FLAG == "V1" && alineData["@cpfl"] == "新通知存款")
                            tmpPageData.Interestrate = "";
                        else
                            tmpPageData.Interestrate = alineData["@rate"];
                        if (!int.TryParse(alineData["@prt_line"], out curLine))
                        {
                            throw new Exception("储蓄存折打印数据有问题！");
                        }
                        tmpPageData.Line = curLine;
                        tmpPageData.IsVisibility = Visibility.Visible;
                        //cxcz.PageData.Add(tmpPageData);
                        list_open.Add(tmpPageData);
                    }
                }

                //普通页数据
                var comPage =
                    msg.AnilyzePrintFile(
                        "CXCZ|@txday|@dscpt|@txamt|@dbflag|@avbal|@tlrno||@brno|@tty|@lineno||@txcode|@term|@rate|@ac_seqn|@srate|@sterm|@zc_flag");
                if (comPage.Count != 0)
                {
                    CXCZPageEntity tmpPageData = null;
                    string ytxamt = string.Empty;
                    string avbal = string.Empty;
                    int curLine = 0;
                    foreach (var alineData in comPage)
                    {
                        tmpPageData = new CXCZPageEntity();
                        tmpPageData.DateInfo = alineData["@txday"];
                        tmpPageData.Description = alineData["@dscpt"];
                        if (alineData["@dbflag"].Equals("0"))
                        {
                            //ytxamt = alineData["@txamt"].ToDecimal().ToString("N2").PadLeft(12);
                            //tmpPageData.DepWinhType = "-" + ytxamt;
                            tmpPageData.DepWinhType = ("-" + alineData["@txamt"].ToDecimal().ToString("N2")).PadLeft(14);
                        }
                        else
                        {
                            //ytxamt = alineData["@txamt"].ToDecimal().ToString("N2").PadLeft(12);
                            //tmpPageData.DepWinhType = "+" + ytxamt;
                            tmpPageData.DepWinhType = ("+" + alineData["@txamt"].ToDecimal().ToString("N2")).PadLeft(14);
                        }
                        avbal = alineData["@avbal"].ToDecimal().ToString("N2").PadLeft(12);
                        tmpPageData.Balance = avbal;
                        tmpPageData.TellerNo = alineData["@tlrno"];
                        //承德银行该项打柜员号
                        tmpPageData.BankOperate = alineData["@tlrno"];
                        //笔序号
                        // tmpPageData.Number = alineData["@lineno"];
                        tmpPageData.Number = alineData["@ac_seqn"];
                        tmpPageData.Deadline = alineData["@sterm"];
                        //利率
                        tmpPageData.Interestrate = alineData["@srate"];
                        if (!int.TryParse(alineData["@lineno"], out curLine))
                        {
                            throw new Exception("储蓄存折打印数据有问题！");
                        }
                        tmpPageData.Line = curLine;
                        tmpPageData.IsVisibility = Visibility.Visible;
                        //cxcz.PageData.Add(tmpPageData);
                        list_cxcz.Add(tmpPageData);
                    }
                }
                if (FLAG == "V1")//郏县 原打印顺序“OPNA”“CXCZ”  改成“CXCZ”“OPNA”
                {
                    cxcz.PageData.AddRange(list_cxcz);
                    cxcz.PageData.AddRange(list_open);
                }
                else
                {
                    cxcz.PageData.AddRange(list_open);
                    cxcz.PageData.AddRange(list_cxcz);
                }
                return true;
            }


            //解析数据错误
            if (cxcz.FirstPageData == null
                && cxcz.EndPageData == null
                && cxcz.PageData.Count == 0)
            {
                return false;
            }

            return true;
        }

        /// <summary>
        /// 储蓄存折数据解析都匀
        /// </summary>
        /// <param name="cxcz">储蓄存折</param>
        /// <param name="msg">报文</param>
        /// <returns></returns>
        private static bool AnalyzeCXCZDataDY(CXCZBankbookDY cxcz, Message msg, string flag)
        {
            //开户首页数 据OPNA|@ac_no|@name|@tx_amt1|@title|@opn_date|@opn_br_no|@cif_no|@end_date|@term|@term_type|@rate|@tx_amt1|@email|@zy|@deac_type|@cur_name|@tx_code|@memo|@ac_no1||@ct_name|@ac_seqn|@ic_date|@prt_line|@prdt_no||@brf|@tmp_ac_no|@tmp_tx_name|@tel|@id_name|@id_no|@br_name|@br_tele|@note_no||||@mbfebkno|@card_flag|@tx_br_name|@nxybrno
            //储蓄存折数据CXCZ|@txday|@dscpt|@txamt|@dbflag|@avbal|@tlrno||@brno|@tty|@lineno|||@term|@rate|@ac_seqn|@srate|@sterm|@zc_flag
            //存折数据初始化
            cxcz.FirstPageData = null;
            cxcz.EndPageData = null;
            cxcz.PageData = new List<CXCZPageDYEntity>();
            if (flag == "FirstPage")
            {
                //首页数据
                var opna = msg.AnilyzePrintFile("OPNA|@ac_no|@name|@tx_amt1|@title|@opn_date|@opn_br_no|@cif_no|@end_date|@term|@term_type|@rate|@tx_amt|@email|@zy|@deac_type|@cur_name|@tx_code|@memo|@ac_no1||@ct_name|@ac_seqn|@ic_date|@prt_line|@prdt_no||@brf|@tmp_ac_no|@tmp_tx_name|@tel|@id_name|@id_no|@br_name|@br_tele|@note_no||||@mbfebkno|@card_flag|@tx_br_name|@nxybrno|@tctd|@cpfl|@sbh");
                if (opna.Count != 0)
                {
                    var draw = string.Empty;
                    var firstPageData = new CXCZFirstPageDYEntity();
                    firstPageData.AcNo = opna[0]["@ac_no"];
                    firstPageData.AcName = opna[0]["@name"];
                    firstPageData.CZNum = opna[0]["@note_no"];
                    firstPageData.CurNo = opna[0]["@cur_name"];
                    firstPageData.DrawMode = opna[0]["@zy"];
                    firstPageData.OpnBrno = opna[0]["@br_name"];
                    firstPageData.OpnDate = opna[0]["@opn_date"];
                    firstPageData.PaySysCode = opna[0]["@mbfebkno"];
                    firstPageData.DepositType = opna[0]["@term"] + opna[0]["@term_type"];
                    firstPageData.Interestrate = opna[0]["@rate"];
                    cxcz.FirstPageData = firstPageData;
                    if (opna[0]["@prdt_no"].Substring(0, 1).Equals("1"))
                    {
                        //1活期，2定期 Type
                        //定期是部分个人结算户/储蓄户的，应该把这个去掉，但是不要把活期的去掉
                        firstPageData.Type = opna[0]["@deac_type"];
                        //打印定期产品名称，活期的改成一本通  山东多法人加对公折 @term值为1、 一本通 2、对公折
                        if (opna[0]["@term"] == "2")
                        {
                            firstPageData.Species = "对公折";
                        }
                        else
                        {
                            firstPageData.Species = "一本通";
                        }
                    }
                    else if (opna[0]["@prdt_no"].Substring(0, 1).Equals("2"))
                    {
                        firstPageData.Species = opna[0]["@title"];
                    }


                    //TODO:数据组装
                    var pageData = new CXCZPageDYEntity();
                    pageData.Balance = opna[0]["@tx_amt1"].ToDecimal().ToString("N2").PadLeft(12);
                    pageData.DateInfo = opna[0]["@opn_date"];
                    pageData.DepWinhType = ("+" + decimal.Parse(pageData.Balance).ToString()).PadLeft(14);
                    pageData.Description = opna[0]["@memo"];
                    pageData.IsVisibility = Visibility.Visible;
                    pageData.Line = 0;
                    pageData.TellerNo = opna[0]["@tel"];
                    //承德银行该项打柜员号
                    pageData.BankOperate = opna[0]["@tel"];
                    //笔序号
                    //pageData.Number = opna[0]["@prt_line"];
                    pageData.Number = opna[0]["@ac_seqn"];
                    //利率
                    pageData.Interestrate = opna[0]["@rate"];
                    cxcz.PageData.Add(pageData);
                    return true;
                }
            }
            else if (flag == "Page")
            {
                //普通页数据
                var comPage = msg.AnilyzePrintFile("CXCZ|@txday|@dscpt|@txamt|@dbflag|@avbal|@tlrno|@valuflag|@brno|@tty|@lineno||@txcode|@term|@rate|@ac_seqn|@srate|@sterm|@zc_flag");
                if (comPage.Count != 0)
                {
                    CXCZPageDYEntity tmpPageData = null;
                    string ytxamt = string.Empty;
                    string avbal = string.Empty;
                    int curLine = 0;
                    string valuflag = string.Empty;//定义变量，解决对公存折打印异常问题
                    foreach (var alineData in comPage)
                    {
                        tmpPageData = new CXCZPageDYEntity();
                        tmpPageData.DateInfo = alineData["@txday"];
                        tmpPageData.Description = alineData["@dscpt"];
                        if (alineData["@dbflag"].Equals("0"))
                        {
                            //ytxamt = alineData["@txamt"].ToDecimal().ToString("N2").PadLeft(12);
                            //tmpPageData.DepWinhType = "-" + ytxamt;
                            tmpPageData.DepWinhType = ("-" + alineData["@txamt"].ToDecimal().ToString("N2")).PadLeft(14);
                        }
                        else
                        {
                            //ytxamt = alineData["@txamt"].ToDecimal().ToString("N2").PadLeft(12);
                            //tmpPageData.DepWinhType = "+" + ytxamt;
                            tmpPageData.DepWinhType = ("+" + alineData["@txamt"].ToDecimal().ToString("N2")).PadLeft(14);
                        }
                        avbal = alineData["@avbal"].ToDecimal().ToString("N2").PadLeft(12);
                        tmpPageData.Balance = avbal;
                        tmpPageData.TellerNo = alineData["@tlrno"];
                        //承德银行该项打柜员号
                        tmpPageData.BankOperate = alineData["@tlrno"];
                        //笔序号
                        // tmpPageData.Number = alineData["@lineno"];
                        tmpPageData.Number = alineData["@ac_seqn"];
                        tmpPageData.Deadline = alineData["@sterm"];
                        //利率
                        tmpPageData.Interestrate = alineData["@srate"];
                        valuflag = alineData["@valuflag"];//未解析变量，解决打印异常
                        if (!int.TryParse(alineData["@lineno"], out curLine))
                        {
                            throw new Exception("储蓄存折打印数据有问题！");
                        }
                        tmpPageData.Line = curLine;
                        tmpPageData.IsVisibility = Visibility.Visible;
                        cxcz.PageData.Add(tmpPageData);
                    }
                    return true;
                }

            }
            else if (flag == "GHJZ")
            {
                var czfy = msg.AnilyzePrintFile("CZFY|@ac_no|@name|@tx_amt1|@title|@opn_date|@opn_br_no|@cif_no|@end_date|@term|@term_type|@rate|@tx_amt1||@zy1|@deac_type|@cur_name|@tx_code||@ac_no1|||@ac_seqn|@ic_date|@prt_line|@prdt_no|@page_no|@brf|@tmp_ac_no|@tmp_tx_name||||@br_name|@br_tele|@note_no||@accno|@zy|@mbfebkno||@shebaono|@tctd_flag|@txbrname||@tctd|@cpfl");
                if (czfy.Count != 0)
                {
                    var draw = string.Empty;
                    var depositType = string.Empty;
                    var firstPageData = new CXCZFirstPageDYEntity();
                    firstPageData.AcNo = czfy[0]["@ac_no"];
                    firstPageData.AcName = czfy[0]["@name"];
                    firstPageData.CZNum = czfy[0]["@note_no"];
                    firstPageData.CurNo = czfy[0]["@cur_name"];
                    firstPageData.DrawMode = czfy[0]["@zy"];
                    firstPageData.OpnBrno = czfy[0]["@br_name"];
                    firstPageData.OpnDate = czfy[0]["@opn_date"];
                    firstPageData.PaySysCode = czfy[0]["@mbfebkno"];
                    //firstPageData.Type = czfy[0]["@cpfl"];
                    firstPageData.Type = czfy[0]["@deac_type"];
                    firstPageData.DepositType = czfy[0]["@term"] + czfy[0]["@term_type"];
                    firstPageData.Interestrate = czfy[0]["@rate"];
                    // firstPageData.PaySysCode = GlobalVariable.Zfxthh;
                    if (czfy[0]["@prdt_no"].Substring(0, 1).Equals("1"))
                    {
                        //1活期，2定期 Type
                        //定期是部分个人结算户/储蓄户的，应该把这个去掉，但是不要把活期的去掉
                        //firstPageData.Type = czfy[0]["@deac_type"];
                        //打印定期产品名称，活期的改成一本通
                        //firstPageData.Species = "一本通";
                        //打印定期产品名称，活期的改成一本通  山东多法人加对公折 @term值为1、 一本通 2、对公折
                        if (czfy[0]["@term"] == "2")
                        {
                            firstPageData.Species = "对公折";
                        }
                        else
                        {
                            firstPageData.Species = "一本通";
                        }
                    }
                    else if (czfy[0]["@prdt_no"].Substring(0, 1).Equals("2"))
                    {
                        firstPageData.Species = czfy[0]["@title"];
                    }
                    cxcz.FirstPageData = firstPageData;
                }

                //普通页数据
                var comPage = msg.AnilyzePrintFile("CXCZ|@txday|@dscpt|@txamt|@dbflag|@avbal|@tlrno||@brno|@tty|@lineno||@txcode|@term|@rate|@ac_seqn|@srate|@sterm|@zc_flag");
                if (comPage.Count != 0)
                {
                    CXCZPageDYEntity tmpPageData = null;
                    string ytxamt = string.Empty;
                    string avbal = string.Empty;
                    int curLine = 0;
                    foreach (var alineData in comPage)
                    {
                        tmpPageData = new CXCZPageDYEntity();
                        tmpPageData.DateInfo = alineData["@txday"];
                        tmpPageData.Description = alineData["@dscpt"];
                        if (alineData["@dbflag"].Equals("0"))
                        {
                            ytxamt = alineData["@txamt"].ToDecimal().ToString("N2").PadLeft(12);
                            tmpPageData.DepWinhType = "-" + ytxamt;
                        }
                        else
                        {
                            ytxamt = alineData["@txamt"].ToDecimal().ToString("N2").PadLeft(12);
                            tmpPageData.DepWinhType = "+" + ytxamt;
                        }
                        avbal = avbal = alineData["@avbal"].ToDecimal().ToString("N2").PadLeft(12);
                        tmpPageData.Balance = avbal;
                        tmpPageData.TellerNo = alineData["@tlrno"];
                        //承德银行该项打柜员号
                        tmpPageData.BankOperate = alineData["@tlrno"];
                        //笔序号
                        //tmpPageData.Number = alineData["@lineno"];

                        tmpPageData.Number = alineData["@ac_seqn"];
                        //利率
                        //tmpPageData.Interestrate = alineData["@rate"];
                        tmpPageData.Deadline = alineData["@sterm"];
                        tmpPageData.Interestrate = alineData["@srate"];
                        if (!int.TryParse(alineData["@lineno"], out curLine))
                        {
                            throw new Exception("储蓄存折打印数据有问题！");
                        }
                        tmpPageData.Line = curLine;
                        tmpPageData.IsVisibility = Visibility.Visible;
                        cxcz.PageData.Add(tmpPageData);
                    }
                    return true;
                }
            }
            else if (flag == "YBTZZH")
            {
                //一本通开子账户返回open开头的文件但是打印数据行
                var file_open_ybt =
                    msg.AnilyzePrintFile(
                        "OPNA|@ac_no|@name|@tx_amt1|@title|@opn_date|@opn_br_no|@cif_no|@end_date|@term|@term_type|@rate|@tx_amt|@email|@zy|@deac_type|@cur_name|@tx_code|@memo|@ac_no1||@ct_name|@ac_seqn|@ic_date|@prt_line|@prdt_no||@brf|@tmp_ac_no|@tmp_tx_name|@tel|@id_name|@id_no|@br_name|@br_tele|@note_no||||@mbfebkno|@card_flag|@tx_br_name|@nxybrno|@tctd|@cpfl|@sbh");
                if (file_open_ybt.Count == 1 && file_open_ybt[0]["@prt_line"] != "0")
                {
                    CXCZPageDYEntity tmpPageData = null;
                    string ytxamt = string.Empty;
                    string avbal = string.Empty;
                    int curLine = 0;
                    foreach (var alineData in file_open_ybt)
                    {
                        tmpPageData = new CXCZPageDYEntity();
                        tmpPageData.DateInfo = alineData["@opn_date"];
                        tmpPageData.Description = alineData["@memo"];
                        tmpPageData.DepWinhType =
                            ("+" + alineData["@tx_amt1"].ToDecimal().ToString("N2")).PadLeft(14);
                        //}
                        avbal = alineData["@tx_amt1"].ToDecimal().ToString("N2").PadLeft(12);
                        tmpPageData.Balance = avbal;
                        tmpPageData.TellerNo = alineData["@tel"];
                        //承德银行该项打柜员号
                        tmpPageData.BankOperate = alineData["@tel"];
                        //笔序号
                        // tmpPageData.Number = alineData["@prt_line"];
                        tmpPageData.Deadline = alineData["@term"] + alineData["@term_type"];
                        tmpPageData.Number = alineData["@ac_seqn"];
                        //利率
                        tmpPageData.Interestrate = alineData["@rate"];
                        if (!int.TryParse(alineData["@prt_line"], out curLine))
                        {
                            throw new Exception("储蓄存折打印数据有问题！");
                        }
                        tmpPageData.Line = curLine;
                        tmpPageData.IsVisibility = Visibility.Visible;
                        cxcz.PageData.Add(tmpPageData);
                    }
                }

                //普通页数据
                var comPage =
                    msg.AnilyzePrintFile(
                        "CXCZ|@txday|@dscpt|@txamt|@dbflag|@avbal|@tlrno||@brno|@tty|@lineno||@txcode|@term|@rate|@ac_seqn|@srate|@sterm|@zc_flag");
                if (comPage.Count != 0)
                {
                    CXCZPageDYEntity tmpPageData = null;
                    string ytxamt = string.Empty;
                    string avbal = string.Empty;
                    int curLine = 0;
                    foreach (var alineData in comPage)
                    {
                        tmpPageData = new CXCZPageDYEntity();
                        tmpPageData.DateInfo = alineData["@txday"];
                        tmpPageData.Description = alineData["@dscpt"];
                        if (alineData["@dbflag"].Equals("0"))
                        {
                            //ytxamt = alineData["@txamt"].ToDecimal().ToString("N2").PadLeft(12);
                            //tmpPageData.DepWinhType = "-" + ytxamt;
                            tmpPageData.DepWinhType = ("-" + alineData["@txamt"].ToDecimal().ToString("N2")).PadLeft(14);
                        }
                        else
                        {
                            //ytxamt = alineData["@txamt"].ToDecimal().ToString("N2").PadLeft(12);
                            //tmpPageData.DepWinhType = "+" + ytxamt;
                            tmpPageData.DepWinhType = ("+" + alineData["@txamt"].ToDecimal().ToString("N2")).PadLeft(14);
                        }
                        avbal = alineData["@avbal"].ToDecimal().ToString("N2").PadLeft(12);
                        tmpPageData.Balance = avbal;
                        tmpPageData.TellerNo = alineData["@tlrno"];
                        //承德银行该项打柜员号
                        tmpPageData.BankOperate = alineData["@tlrno"];
                        //笔序号
                        // tmpPageData.Number = alineData["@lineno"];
                        tmpPageData.Number = alineData["@ac_seqn"];
                        tmpPageData.Deadline = alineData["@sterm"];
                        //利率
                        tmpPageData.Interestrate = alineData["@srate"];
                        if (!int.TryParse(alineData["@lineno"], out curLine))
                        {
                            throw new Exception("储蓄存折打印数据有问题！");
                        }
                        tmpPageData.Line = curLine;
                        tmpPageData.IsVisibility = Visibility.Visible;
                        cxcz.PageData.Add(tmpPageData);
                    }
                }
                return true;
            }


            //解析数据错误
            if (cxcz.FirstPageData == null
                && cxcz.EndPageData == null
                && cxcz.PageData.Count == 0)
            {
                return false;
            }

            return true;
        }

        /// <summary>
        /// 储蓄存折数据解析齐丰
        /// </summary>
        /// <param name="cxcz">储蓄存折</param>
        /// <param name="msg">报文</param>
        /// <returns></returns>
        private static bool AnalyzeCXCZDataQF(CXCZBankbookQF cxcz, Message msg, string flag)
        {
            //开户首页数 据OPNA|@ac_no|@name|@tx_amt1|@title|@opn_date|@opn_br_no|@cif_no|@end_date|@term|@term_type|@rate|@tx_amt1|@email|@zy|@deac_type|@cur_name|@tx_code|@memo|@ac_no1||@ct_name|@ac_seqn|@ic_date|@prt_line|@prdt_no||@brf|@tmp_ac_no|@tmp_tx_name|@tel|@id_name|@id_no|@br_name|@br_tele|@note_no||||@mbfebkno|@card_flag|@tx_br_name|@nxybrno
            //储蓄存折数据CXCZ|@txday|@dscpt|@txamt|@dbflag|@avbal|@tlrno||@brno|@tty|@lineno|||@term|@rate|@ac_seqn|@srate|@sterm|@zc_flag
            //存折数据初始化
            cxcz.FirstPageData = null;
            cxcz.EndPageData = null;
            cxcz.PageData = new List<CXCZPageQFEntity>();
            if (flag == "FirstPage")
            {
                //首页数据
                var opna = msg.AnilyzePrintFile("OPNA|@ac_no|@name|@tx_amt1|@title|@opn_date|@opn_br_no|@cif_no|@end_date|@term|@term_type|@rate|@tx_amt|@email|@zy|@deac_type|@cur_name|@tx_code|@memo|@ac_no1||@ct_name|@ac_seqn|@ic_date|@prt_line|@prdt_no||@brf|@tmp_ac_no|@tmp_tx_name|@tel|@id_name|@id_no|@br_name|@br_tele|@note_no||||@mbfebkno|@card_flag|@tx_br_name|@nxybrno|@tctd|@cpfl|@sbh");
                if (opna.Count != 0)
                {
                    var draw = string.Empty;
                    var firstPageData = new CXCZFirstPageQFEntity();
                    firstPageData.AcNo = opna[0]["@ac_no"];
                    firstPageData.AcName = opna[0]["@name"];
                    firstPageData.CZNum = opna[0]["@note_no"];
                    firstPageData.CurNo = opna[0]["@cur_name"];
                    firstPageData.DrawMode = opna[0]["@zy"];
                    firstPageData.OpnBrname = opna[0]["@br_name"];
                    firstPageData.OpnDate = opna[0]["@opn_date"];
                    firstPageData.PaySysCode = opna[0]["@mbfebkno"];
                    firstPageData.DepositType = opna[0]["@term"] + opna[0]["@term_type"];
                    firstPageData.OpnBrname = opna[0]["@br_name"];
                    firstPageData.Interestrate = opna[0]["@rate"];
                    cxcz.FirstPageData = firstPageData;
                    if (opna[0]["@prdt_no"].Substring(0, 1).Equals("1"))
                    {
                        //1活期，2定期 Type
                        //定期是部分个人结算户/储蓄户的，应该把这个去掉，但是不要把活期的去掉
                        firstPageData.Type = opna[0]["@deac_type"];
                        //打印定期产品名称，活期的改成一本通  山东多法人加对公折 @term值为1、 一本通 2、对公折
                        if (opna[0]["@term"] == "2")
                        {
                            firstPageData.Species = "对公折";
                        }
                        else
                        {
                            firstPageData.Species = "一本通";
                            if (FLAG == "V19")
                            {
                                firstPageData.Species = "储蓄存折";
                            }
                        }
                    }
                    else if (opna[0]["@prdt_no"].Substring(0, 1).Equals("2"))
                    {
                        firstPageData.Species = opna[0]["@title"];
                    }
                    if (FLAG == "V21")
                    {
                        if (opna[0]["@tctd"].Equals("是"))
                        {
                            firstPageData.TCTD = "通存通兑";
                        }
                        else if (opna[0]["@tctd"].Equals("否"))
                        {
                            firstPageData.TCTD = "不通存不通兑";
                        }
                        else
                        {
                            firstPageData.TCTD = opna[0]["@tctd"];
                        }
                    }


                    //TODO:数据组装
                    var pageData = new CXCZPageQFEntity();
                    pageData.Balance = opna[0]["@tx_amt1"].ToDecimal().ToString("N2").PadLeft(12);
                    pageData.DateInfo = opna[0]["@opn_date"];
                    pageData.DepWinhType = ("+" + decimal.Parse(pageData.Balance).ToString()).PadLeft(14);
                    pageData.Description = opna[0]["@memo"];
                    pageData.IsVisibility = Visibility.Visible;
                    pageData.Line = 0;
                    pageData.TellerNo = opna[0]["@tel"];
                    //承德银行该项打柜员号
                    pageData.BankOperate = opna[0]["@tel"];
                    //笔序号
                    //pageData.Number = opna[0]["@prt_line"];
                    pageData.Number = opna[0]["@ac_seqn"];
                    //利率
                    pageData.Interestrate = opna[0]["@rate"];
                    cxcz.PageData.Add(pageData);
                    return true;
                }
            }
            else if (flag == "Page")
            {
                //普通页数据
                var comPage = msg.AnilyzePrintFile("CXCZ|@txday|@dscpt|@txamt|@dbflag|@avbal|@tlrno|@valuflag|@brno|@tty|@lineno||@txcode|@term|@rate|@ac_seqn|@srate|@sterm|@zc_flag");
                if (comPage.Count != 0)
                {
                    CXCZPageQFEntity tmpPageData = null;
                    string ytxamt = string.Empty;
                    string avbal = string.Empty;
                    int curLine = 0;
                    string valuflag = string.Empty;//定义变量，解决对公存折打印异常问题
                    foreach (var alineData in comPage)
                    {
                        tmpPageData = new CXCZPageQFEntity();
                        tmpPageData.DateInfo = alineData["@txday"];
                        tmpPageData.Description = alineData["@dscpt"];
                        if (alineData["@dbflag"].Equals("0"))
                        {
                            //ytxamt = alineData["@txamt"].ToDecimal().ToString("N2").PadLeft(12);
                            //tmpPageData.DepWinhType = "-" + ytxamt;
                            tmpPageData.DepWinhType = ("-" + alineData["@txamt"].ToDecimal().ToString("N2")).PadLeft(14);
                        }
                        else
                        {
                            //ytxamt = alineData["@txamt"].ToDecimal().ToString("N2").PadLeft(12);
                            //tmpPageData.DepWinhType = "+" + ytxamt;
                            tmpPageData.DepWinhType = ("+" + alineData["@txamt"].ToDecimal().ToString("N2")).PadLeft(14);
                        }
                        avbal = alineData["@avbal"].ToDecimal().ToString("N2").PadLeft(12);
                        tmpPageData.Balance = avbal;
                        tmpPageData.TellerNo = alineData["@tlrno"];
                        //承德银行该项打柜员号
                        tmpPageData.BankOperate = alineData["@tlrno"];
                        //笔序号
                        // tmpPageData.Number = alineData["@lineno"];
                        tmpPageData.Number = alineData["@ac_seqn"];
                        tmpPageData.Deadline = alineData["@sterm"];
                        //利率
                        tmpPageData.Interestrate = alineData["@srate"];
                        valuflag = alineData["@valuflag"];//未解析变量，解决打印异常
                        if (!int.TryParse(alineData["@lineno"], out curLine))
                        {
                            throw new Exception("储蓄存折打印数据有问题！");
                        }
                        tmpPageData.Line = curLine;
                        tmpPageData.IsVisibility = Visibility.Visible;
                        cxcz.PageData.Add(tmpPageData);
                    }
                    return true;
                }

            }
            else if (flag == "GHJZ")
            {
                var czfy = msg.AnilyzePrintFile("CZFY|@ac_no|@name|@tx_amt1|@title|@opn_date|@opn_br_no|@cif_no|@end_date|@term|@term_type|@rate|@tx_amt1||@zy1|@deac_type|@cur_name|@tx_code||@ac_no1|||@ac_seqn|@ic_date|@prt_line|@prdt_no|@page_no|@brf|@tmp_ac_no|@tmp_tx_name||||@br_name|@br_tele|@note_no||@accno|@zy|@mbfebkno||@shebaono|@tctd_flag|@txbrname||@tctd|@cpfl");
                if (czfy.Count != 0)
                {
                    var draw = string.Empty;
                    var depositType = string.Empty;
                    var firstPageData = new CXCZFirstPageQFEntity();
                    firstPageData.AcNo = czfy[0]["@ac_no"];
                    firstPageData.AcName = czfy[0]["@name"];
                    firstPageData.CZNum = czfy[0]["@note_no"];
                    firstPageData.CurNo = czfy[0]["@cur_name"];
                    firstPageData.DrawMode = czfy[0]["@zy"];
                    firstPageData.OpnBrname = czfy[0]["@br_name"];
                    firstPageData.OpnDate = czfy[0]["@opn_date"];
                    firstPageData.PaySysCode = czfy[0]["@mbfebkno"];
                    //firstPageData.Type = czfy[0]["@cpfl"];
                    firstPageData.Type = czfy[0]["@deac_type"];
                    firstPageData.DepositType = czfy[0]["@term"] + czfy[0]["@term_type"];
                    firstPageData.OpnBrname = czfy[0]["@br_name"];
                    firstPageData.Interestrate = czfy[0]["@rate"];
                    // firstPageData.PaySysCode = GlobalVariable.Zfxthh;
                    if (czfy[0]["@prdt_no"].Substring(0, 1).Equals("1"))
                    {
                        //1活期，2定期 Type
                        //定期是部分个人结算户/储蓄户的，应该把这个去掉，但是不要把活期的去掉
                        //firstPageData.Type = czfy[0]["@deac_type"];
                        //打印定期产品名称，活期的改成一本通
                        //firstPageData.Species = "一本通";
                        //打印定期产品名称，活期的改成一本通  山东多法人加对公折 @term值为1、 一本通 2、对公折
                        if (czfy[0]["@term"] == "2")
                        {
                            firstPageData.Species = "对公折";
                        }
                        else
                        {
                            firstPageData.Species = "一本通";
                            if (FLAG == "V19")
                            {
                                firstPageData.Species = "储蓄存折";
                            }
                        }
                    }
                    else if (czfy[0]["@prdt_no"].Substring(0, 1).Equals("2"))
                    {
                        firstPageData.Species = czfy[0]["@title"];
                    }
                    if (FLAG == "V21")
                    {
                        if (czfy[0]["@tctd"].Equals("是"))
                        {
                            firstPageData.TCTD = "通存通兑";
                        }
                        else if (czfy[0]["@tctd"].Equals("否"))
                        {
                            firstPageData.TCTD = "不通存不通兑";
                        }
                        else
                        {
                            firstPageData.TCTD = czfy[0]["@tctd"];
                        }
                    }
                    cxcz.FirstPageData = firstPageData;
                }

                //普通页数据
                var comPage = msg.AnilyzePrintFile("CXCZ|@txday|@dscpt|@txamt|@dbflag|@avbal|@tlrno||@brno|@tty|@lineno||@txcode|@term|@rate|@ac_seqn|@srate|@sterm|@zc_flag");
                if (comPage.Count != 0)
                {
                    CXCZPageQFEntity tmpPageData = null;
                    string ytxamt = string.Empty;
                    string avbal = string.Empty;
                    int curLine = 0;
                    foreach (var alineData in comPage)
                    {
                        tmpPageData = new CXCZPageQFEntity();
                        tmpPageData.DateInfo = alineData["@txday"];
                        tmpPageData.Description = alineData["@dscpt"];
                        if (alineData["@dbflag"].Equals("0"))
                        {
                            ytxamt = alineData["@txamt"].ToDecimal().ToString("N2").PadLeft(12);
                            tmpPageData.DepWinhType = "-" + ytxamt;
                        }
                        else
                        {
                            ytxamt = alineData["@txamt"].ToDecimal().ToString("N2").PadLeft(12);
                            tmpPageData.DepWinhType = "+" + ytxamt;
                        }
                        avbal = avbal = alineData["@avbal"].ToDecimal().ToString("N2").PadLeft(12);
                        tmpPageData.Balance = avbal;
                        tmpPageData.TellerNo = alineData["@tlrno"];
                        //承德银行该项打柜员号
                        tmpPageData.BankOperate = alineData["@tlrno"];
                        //笔序号
                        //tmpPageData.Number = alineData["@lineno"];

                        tmpPageData.Number = alineData["@ac_seqn"];
                        //利率
                        //tmpPageData.Interestrate = alineData["@rate"];
                        tmpPageData.Deadline = alineData["@sterm"];
                        tmpPageData.Interestrate = alineData["@srate"];
                        if (!int.TryParse(alineData["@lineno"], out curLine))
                        {
                            throw new Exception("储蓄存折打印数据有问题！");
                        }
                        tmpPageData.Line = curLine;
                        tmpPageData.IsVisibility = Visibility.Visible;
                        cxcz.PageData.Add(tmpPageData);
                    }
                    return true;
                }
            }
            else if (flag == "YBTZZH")
            {
                //一本通开子账户返回open开头的文件但是打印数据行
                var file_open_ybt =
                    msg.AnilyzePrintFile(
                        "OPNA|@ac_no|@name|@tx_amt1|@title|@opn_date|@opn_br_no|@cif_no|@end_date|@term|@term_type|@rate|@tx_amt|@email|@zy|@deac_type|@cur_name|@tx_code|@memo|@ac_no1||@ct_name|@ac_seqn|@ic_date|@prt_line|@prdt_no||@brf|@tmp_ac_no|@tmp_tx_name|@tel|@id_name|@id_no|@br_name|@br_tele|@note_no||||@mbfebkno|@card_flag|@tx_br_name|@nxybrno|@tctd|@cpfl|@sbh");
                if (file_open_ybt.Count == 1 && file_open_ybt[0]["@prt_line"] != "0")
                {
                    CXCZPageQFEntity tmpPageData = null;
                    string ytxamt = string.Empty;
                    string avbal = string.Empty;
                    int curLine = 0;
                    foreach (var alineData in file_open_ybt)
                    {
                        tmpPageData = new CXCZPageQFEntity();
                        tmpPageData.DateInfo = alineData["@opn_date"];
                        tmpPageData.Description = alineData["@memo"];
                        tmpPageData.DepWinhType =
                            ("+" + alineData["@tx_amt1"].ToDecimal().ToString("N2")).PadLeft(14);
                        //}
                        avbal = alineData["@tx_amt1"].ToDecimal().ToString("N2").PadLeft(12);
                        tmpPageData.Balance = avbal;
                        tmpPageData.TellerNo = alineData["@tel"];
                        //承德银行该项打柜员号
                        tmpPageData.BankOperate = alineData["@tel"];
                        //笔序号
                        // tmpPageData.Number = alineData["@prt_line"];
                        tmpPageData.Deadline = alineData["@term"] + alineData["@term_type"];
                        tmpPageData.Number = alineData["@ac_seqn"];
                        //利率
                        tmpPageData.Interestrate = alineData["@rate"];
                        if (!int.TryParse(alineData["@prt_line"], out curLine))
                        {
                            throw new Exception("储蓄存折打印数据有问题！");
                        }
                        tmpPageData.Line = curLine;
                        tmpPageData.IsVisibility = Visibility.Visible;
                        cxcz.PageData.Add(tmpPageData);
                    }
                }

                //普通页数据
                var comPage =
                    msg.AnilyzePrintFile(
                        "CXCZ|@txday|@dscpt|@txamt|@dbflag|@avbal|@tlrno||@brno|@tty|@lineno||@txcode|@term|@rate|@ac_seqn|@srate|@sterm|@zc_flag");
                if (comPage.Count != 0)
                {
                    CXCZPageQFEntity tmpPageData = null;
                    string ytxamt = string.Empty;
                    string avbal = string.Empty;
                    int curLine = 0;
                    foreach (var alineData in comPage)
                    {
                        tmpPageData = new CXCZPageQFEntity();
                        tmpPageData.DateInfo = alineData["@txday"];
                        tmpPageData.Description = alineData["@dscpt"];
                        if (alineData["@dbflag"].Equals("0"))
                        {
                            //ytxamt = alineData["@txamt"].ToDecimal().ToString("N2").PadLeft(12);
                            //tmpPageData.DepWinhType = "-" + ytxamt;
                            tmpPageData.DepWinhType = ("-" + alineData["@txamt"].ToDecimal().ToString("N2")).PadLeft(14);
                        }
                        else
                        {
                            //ytxamt = alineData["@txamt"].ToDecimal().ToString("N2").PadLeft(12);
                            //tmpPageData.DepWinhType = "+" + ytxamt;
                            tmpPageData.DepWinhType = ("+" + alineData["@txamt"].ToDecimal().ToString("N2")).PadLeft(14);
                        }
                        avbal = alineData["@avbal"].ToDecimal().ToString("N2").PadLeft(12);
                        tmpPageData.Balance = avbal;
                        tmpPageData.TellerNo = alineData["@tlrno"];
                        //承德银行该项打柜员号
                        tmpPageData.BankOperate = alineData["@tlrno"];
                        //笔序号
                        // tmpPageData.Number = alineData["@lineno"];
                        tmpPageData.Number = alineData["@ac_seqn"];
                        tmpPageData.Deadline = alineData["@sterm"];
                        //利率
                        tmpPageData.Interestrate = alineData["@srate"];
                        if (!int.TryParse(alineData["@lineno"], out curLine))
                        {
                            throw new Exception("储蓄存折打印数据有问题！");
                        }
                        tmpPageData.Line = curLine;
                        tmpPageData.IsVisibility = Visibility.Visible;
                        cxcz.PageData.Add(tmpPageData);
                    }
                }
                return true;
            }


            //解析数据错误
            if (cxcz.FirstPageData == null
                && cxcz.EndPageData == null
                && cxcz.PageData.Count == 0)
            {
                return false;
            }

            return true;
        }

        /// <summary>
        /// 储蓄存折数据解析浚县
        /// </summary>
        /// <param name="cxcz">储蓄存折</param>
        /// <param name="msg">报文</param>
        /// <returns></returns>
        private static bool AnalyzeCXCZDataXX(CXCZBankbookXX cxcz, Message msg, string flag)
        {
            //开户首页数 据OPNA|@ac_no|@name|@tx_amt1|@title|@opn_date|@opn_br_no|@cif_no|@end_date|@term|@term_type|@rate|@tx_amt1|@email|@zy|@deac_type|@cur_name|@tx_code|@memo|@ac_no1||@ct_name|@ac_seqn|@ic_date|@prt_line|@prdt_no||@brf|@tmp_ac_no|@tmp_tx_name|@tel|@id_name|@id_no|@br_name|@br_tele|@note_no||||@mbfebkno|@card_flag|@tx_br_name|@nxybrno
            //储蓄存折数据CXCZ|@txday|@dscpt|@txamt|@dbflag|@avbal|@tlrno||@brno|@tty|@lineno|||@term|@rate|@ac_seqn|@srate|@sterm|@zc_flag
            //存折数据初始化
            cxcz.FirstPageData = null;
            cxcz.EndPageData = null;
            cxcz.PageData = new List<CXCZPageXXEntity>();
            if (flag == "FirstPage")
            {
                //首页数据
                var opna = msg.AnilyzePrintFile("OPNA|@ac_no|@name|@tx_amt1|@title|@opn_date|@opn_br_no|@cif_no|@end_date|@term|@term_type|@rate|@tx_amt|@email|@zy|@deac_type|@cur_name|@tx_code|@memo|@ac_no1||@ct_name|@ac_seqn|@ic_date|@prt_line|@prdt_no||@brf|@tmp_ac_no|@tmp_tx_name|@tel|@id_name|@id_no|@br_name|@br_tele|@note_no||||@mbfebkno|@card_flag|@tx_br_name|@nxybrno|@tctd|@cpfl|@sbh");
                if (opna.Count != 0)
                {
                    var draw = string.Empty;
                    var firstPageData = new CXCZFirstPageXXEntity();
                    firstPageData.AccountNo = opna[0]["@ac_no"];//账户
                    firstPageData.AccountName = opna[0]["@name"];//户名
                    firstPageData.CPMC = opna[0]["@title"];//产品名称
                    firstPageData.Currency = opna[0]["@cur_name"];//币种
                    firstPageData.ZFTJ = opna[0]["@zy"];//支付条件
                    firstPageData.QXRQ = opna[0]["@opn_date"];//起息日期
                    firstPageData.DQRQ = "";// opna[0]["@end_date"];//到期日期
                    firstPageData.SignDate = opna[0]["@opn_date"];//签发日期
                    firstPageData.CQ = "";// opna[0]["@term"] + opna[0]["@term_type"];//存期
                    firstPageData.OpenBrno = opna[0]["@br_name"];//开户行
                    firstPageData.Interestrate = opna[0]["@rate"];//利率
                    firstPageData.TCTD = opna[0]["@tctd"];//通存通兑
                    cxcz.FirstPageData = firstPageData;

                    //TODO:数据组装
                    var pageData = new CXCZPageXXEntity();
                    pageData.Balance = opna[0]["@tx_amt1"].ToDecimal().ToString("N2").PadLeft(12);//余额
                    pageData.DateInfo = opna[0]["@opn_date"];//日期
                    pageData.Description = opna[0]["@memo"];//摘要
                    pageData.IsVisibility = Visibility.Visible;
                    pageData.Line = 0;
                    pageData.TellerNo = opna[0]["@tel"];//柜员号
                    pageData.Kinbr = opna[0]["@opn_br_no"];//机构号
                    pageData.Number = opna[0]["@ac_seqn"];//笔序号
                    pageData.Interestrate = opna[0]["@rate"];//利率
                    pageData.Withdrawal = "--";//支出
                    pageData.Deposit = decimal.Parse(pageData.Balance).ToString();//存入
                    cxcz.PageData.Add(pageData);
                    return true;
                }
            }
            else if (flag == "Page")
            {
                //普通页数据
                var comPage = msg.AnilyzePrintFile("CXCZ|@txday|@dscpt|@txamt|@dbflag|@avbal|@tlrno|@valuflag|@brno|@tty|@lineno||@txcode|@term|@rate|@ac_seqn|@srate|@sterm|@zc_flag");
                if (comPage.Count != 0)
                {
                    CXCZPageXXEntity tmpPageData = null;
                    string ytxamt = string.Empty;
                    string avbal = string.Empty;
                    int curLine = 0;
                    string valuflag = string.Empty;//定义变量，解决对公存折打印异常问题
                    foreach (var alineData in comPage)
                    {
                        tmpPageData = new CXCZPageXXEntity();
                        tmpPageData.DateInfo = alineData["@txday"];
                        tmpPageData.Description = alineData["@dscpt"];
                        if (alineData["@dbflag"].Equals("0"))
                        {
                            tmpPageData.Withdrawal = ("-" + alineData["@txamt"].ToDecimal().ToString("N2")).PadLeft(14);
                        }
                        else
                        {
                            tmpPageData.Deposit = ("+" + alineData["@txamt"].ToDecimal().ToString("N2")).PadLeft(14);
                        }

                        avbal = alineData["@avbal"].ToDecimal().ToString("N2").PadLeft(12);
                        tmpPageData.Balance = avbal;
                        tmpPageData.TellerNo = alineData["@tlrno"];
                        tmpPageData.Kinbr = alineData["@brno"];
                        tmpPageData.Number = alineData["@ac_seqn"];//笔序号
                        tmpPageData.Interestrate = alineData["@srate"];//利率
                        valuflag = alineData["@valuflag"];//未解析变量，解决打印异常
                        if (!int.TryParse(alineData["@lineno"], out curLine))
                        {
                            throw new Exception("储蓄存折打印数据有问题！");
                        }
                        tmpPageData.Line = curLine;
                        tmpPageData.IsVisibility = Visibility.Visible;
                        cxcz.PageData.Add(tmpPageData);
                    }
                    return true;
                }

            }
            else if (flag == "GHJZ")
            {
                var czfy = msg.AnilyzePrintFile("CZFY|@ac_no|@name|@tx_amt1|@title|@opn_date|@opn_br_no|@cif_no|@end_date|@term|@term_type|@rate|@tx_amt1||@zy1|@deac_type|@cur_name|@tx_code||@ac_no1|||@ac_seqn|@ic_date|@prt_line|@prdt_no|@page_no|@brf|@tmp_ac_no|@tmp_tx_name||||@br_name|@br_tele|@note_no||@accno|@zy|@mbfebkno||@shebaono|@tctd_flag|@txbrname||@tctd|@cpfl");
                if (czfy.Count != 0)
                {
                    var draw = string.Empty;
                    var depositType = string.Empty;
                    var firstPageData = new CXCZFirstPageXXEntity();
                    firstPageData.AccountNo = czfy[0]["@ac_no"];//账户
                    firstPageData.AccountName = czfy[0]["@name"];//户名
                    firstPageData.CPMC = czfy[0]["@title"];//产品名称
                    firstPageData.Currency = czfy[0]["@cur_name"];//币种
                    firstPageData.ZFTJ = czfy[0]["@zy"];//支付条件
                    firstPageData.QXRQ = czfy[0]["@opn_date"];//起息日期
                    firstPageData.DQRQ = czfy[0]["@end_date"];//到期日期
                    firstPageData.SignDate = czfy[0]["@opn_date"];//签发日期
                    firstPageData.CQ = "";// czfy[0]["@term"] + czfy[0]["@term_type"];//存期
                    firstPageData.OpenBrno = czfy[0]["@br_name"];//开户行
                    firstPageData.Interestrate = czfy[0]["@rate"];//利率
                    firstPageData.TCTD = czfy[0]["@tctd"];//通存通兑
                    cxcz.FirstPageData = firstPageData;
                }

                //普通页数据
                var comPage = msg.AnilyzePrintFile("CXCZ|@txday|@dscpt|@txamt|@dbflag|@avbal|@tlrno||@brno|@tty|@lineno||@txcode|@term|@rate|@ac_seqn|@srate|@sterm|@zc_flag");
                if (comPage.Count != 0)
                {
                    CXCZPageXXEntity tmpPageData = null;
                    string ytxamt = string.Empty;
                    string avbal = string.Empty;
                    int curLine = 0;
                    foreach (var alineData in comPage)
                    {
                        tmpPageData = new CXCZPageXXEntity();
                        tmpPageData.DateInfo = alineData["@txday"];
                        tmpPageData.Description = alineData["@dscpt"];
                        if (alineData["@dbflag"].Equals("0"))
                        {
                            ytxamt = alineData["@txamt"].ToDecimal().ToString("N2").PadLeft(12);
                            tmpPageData.Withdrawal = "-" + ytxamt;
                        }
                        else
                        {
                            ytxamt = alineData["@txamt"].ToDecimal().ToString("N2").PadLeft(12);
                            tmpPageData.Deposit = "+" + ytxamt;
                        }
                        avbal = avbal = alineData["@avbal"].ToDecimal().ToString("N2").PadLeft(12);
                        tmpPageData.Balance = avbal;
                        tmpPageData.TellerNo = alineData["@tlrno"];
                        tmpPageData.Kinbr = alineData["@brno"];
                        tmpPageData.Number = alineData["@ac_seqn"];//笔序号
                        tmpPageData.Interestrate = alineData["@srate"];//利率
                        if (!int.TryParse(alineData["@lineno"], out curLine))
                        {
                            throw new Exception("储蓄存折打印数据有问题！");
                        }
                        tmpPageData.Line = curLine;
                        tmpPageData.IsVisibility = Visibility.Visible;
                        cxcz.PageData.Add(tmpPageData);
                    }
                    return true;
                }
            }
            else if (flag == "YBTZZH")
            {
                //一本通开子账户返回open开头的文件但是打印数据行
                var file_open_ybt =
                    msg.AnilyzePrintFile(
                        "OPNA|@ac_no|@name|@tx_amt1|@title|@opn_date|@opn_br_no|@cif_no|@end_date|@term|@term_type|@rate|@tx_amt|@email|@zy|@deac_type|@cur_name|@tx_code|@memo|@ac_no1||@ct_name|@ac_seqn|@ic_date|@prt_line|@prdt_no||@brf|@tmp_ac_no|@tmp_tx_name|@tel|@id_name|@id_no|@br_name|@br_tele|@note_no||||@mbfebkno|@card_flag|@tx_br_name|@nxybrno|@tctd|@cpfl|@sbh");
                if (file_open_ybt.Count == 1 && file_open_ybt[0]["@prt_line"] != "0")
                {
                    CXCZPageXXEntity tmpPageData = null;
                    string ytxamt = string.Empty;
                    string avbal = string.Empty;
                    int curLine = 0;
                    foreach (var alineData in file_open_ybt)
                    {
                        tmpPageData = new CXCZPageXXEntity();
                        tmpPageData.DateInfo = alineData["@opn_date"];
                        tmpPageData.Description = alineData["@memo"];
                        tmpPageData.Withdrawal = "--";
                        tmpPageData.Deposit = alineData["@tx_amt1"].ToDecimal().ToString("N2");
                        avbal = alineData["@tx_amt1"].ToDecimal().ToString("N2").PadLeft(12);
                        tmpPageData.Balance = avbal;
                        tmpPageData.TellerNo = alineData["@tel"];
                        tmpPageData.Kinbr = alineData["@opn_br_no"];
                        tmpPageData.Number = alineData["@ac_seqn"];//笔序号
                        tmpPageData.Interestrate = alineData["@rate"];//利率
                        if (!int.TryParse(alineData["@prt_line"], out curLine))
                        {
                            throw new Exception("储蓄存折打印数据有问题！");
                        }
                        tmpPageData.Line = curLine;
                        tmpPageData.IsVisibility = Visibility.Visible;
                        cxcz.PageData.Add(tmpPageData);
                    }
                }

                //普通页数据
                var comPage =
                    msg.AnilyzePrintFile(
                        "CXCZ|@txday|@dscpt|@txamt|@dbflag|@avbal|@tlrno||@brno|@tty|@lineno||@txcode|@term|@rate|@ac_seqn|@srate|@sterm|@zc_flag");
                if (comPage.Count != 0)
                {
                    CXCZPageXXEntity tmpPageData = null;
                    string ytxamt = string.Empty;
                    string avbal = string.Empty;
                    int curLine = 0;
                    foreach (var alineData in comPage)
                    {
                        tmpPageData = new CXCZPageXXEntity();
                        tmpPageData.DateInfo = alineData["@txday"];
                        tmpPageData.Description = alineData["@dscpt"];
                        if (alineData["@dbflag"].Equals("0"))
                        {
                            tmpPageData.Withdrawal = ("-" + alineData["@txamt"].ToDecimal().ToString("N2")).PadLeft(14);
                        }
                        else
                        {
                            tmpPageData.Deposit = ("+" + alineData["@txamt"].ToDecimal().ToString("N2")).PadLeft(14);
                        }
                        avbal = alineData["@avbal"].ToDecimal().ToString("N2").PadLeft(12);
                        tmpPageData.Balance = avbal;
                        tmpPageData.TellerNo = alineData["@tlrno"];
                        tmpPageData.Kinbr = alineData["@brno"];
                        tmpPageData.Number = alineData["@ac_seqn"];//笔序号
                        tmpPageData.Interestrate = alineData["@srate"];//利率
                        if (!int.TryParse(alineData["@lineno"], out curLine))
                        {
                            throw new Exception("储蓄存折打印数据有问题！");
                        }
                        tmpPageData.Line = curLine;
                        tmpPageData.IsVisibility = Visibility.Visible;
                        cxcz.PageData.Add(tmpPageData);
                    }
                }
                return true;
            }
            //解析数据错误
            if (cxcz.FirstPageData == null
                && cxcz.EndPageData == null
                && cxcz.PageData.Count == 0)
            {
                return false;
            }

            return true;
        }

        #endregion 活期存折

        /// <summary>
        /// 按照指定方式产生存折打印对象
        /// </summary>
        /// <param name="meaasge"></param>
        /// <param name="type"></param>
        /// <returns></returns>
        public static List<PrintContainer> PrintBankBook(Message message, BankBookType type)
        {
            var printList = new List<PrintContainer>();
            switch (type)
            {
                case BankBookType.CXCZ:
                    break;
                case BankBookType.YBTCZ:
                    BB_YBTCZ bb = new BB_YBTCZ(message);
                    return bb.PrintList;
                case BankBookType.YBTCZ_QF:
                    SDQF_YBTCZ QF = new SDQF_YBTCZ(message);
                    return QF.PrintList;
                case BankBookType.YBTCZ_XX:
                    SDXX_YBTCZ XX = new SDXX_YBTCZ(message);
                    return XX.PrintList;
                case BankBookType.KDZZ:
                    var kdzzList = message.AnilyzePrintFile("KDZZ|账号|行内交易行号|客户号|社保号|储种|户名|币种|存期|签发日期|备注|");
                    if (kdzzList.Count > 0)
                    {
                        //开立对账折
                        //printList.Add(new PBB_KDZZ_FirstPage(new PBB_KDZZ_FirstPage.PBB_KDZZ_FirstPageEntry
                        //{
                        //    ZH = kdzzList[0]["账号"],
                        //    HM = kdzzList[0]["户名"],
                        //    BZ = kdzzList[0]["币种"],
                        //    ZFHH = kdzzList[0]["行内交易行号"],
                        //    KHH = kdzzList[0]["客户号"],
                        //    SBH = kdzzList[0]["社保号"],
                        //    CZ = kdzzList[0]["储种"],
                        //    QFRQ = kdzzList[0]["签发日期"],
                        //    BZ1 = kdzzList[0]["备注"]
                        //}));
                    }
                    else
                    {
                        var aCxczBankbook = CXCZBankbook.GetInstance();
                        aCxczBankbook.SumNum = 252;
                        AnalyzeCXCZData(aCxczBankbook, message, "Page");
                        printList.AddRange(aCxczBankbook.PrintBankBookPage());
                    }
                    break;
                default:
                    break;
            }
            return printList;
        }

        public enum BankBookType
        {
            /// <summary>
            /// 储蓄存折
            /// </summary>
            CXCZ,
            /// <summary>
            /// 一本通存折
            /// </summary>
            YBTCZ,
            /// <summary>
            /// 一本通存折齐丰
            /// </summary>
            YBTCZ_QF,
            /// <summary>
            /// 卡对账折
            /// </summary>
            KDZZ,
            /// <summary>
            /// 一本通存折浚县
            /// </summary>
            YBTCZ_XX,
        }
    }
}