﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// 储蓄存折首页实体
    /// </summary>
    public class CXCZFirstPageDYEntity
    {
        /// <summary>
        /// 账号
        /// </summary>
        public string AcNo { get; set; }

        /// <summary>
        /// 存折编号
        /// </summary>
        public string CZNum { get; set; }

        /// <summary>
        /// 户名
        /// </summary>
        public string AcName { get; set; }

        /// <summary>
        /// 储种
        /// </summary>
        public string Type { get; set; }

        /// <summary>
        /// 存款种类
        /// </summary>
        public string DepositType { get; set; }

        /// <summary>
        /// 币种
        /// </summary>
        public string CurNo { get; set; }

        /// <summary>
        /// 支取方式
        /// </summary>
        public string DrawMode { get; set; }

        /// <summary>
        /// 开户日期
        /// </summary>
        public string OpnDate { get; set; }

        /// <summary>
        /// 开户网点
        /// </summary>
        public string OpnBrno { get; set; }

        /// <summary>
        /// 支付系统行号
        /// </summary>
        public string PaySysCode { get; set; }

        /// <summary>
        /// 种类
        /// </summary>
        public string Species { get; set; }
        /// <summary>
        /// 利率
        /// </summary>
        public string Interestrate { get; set; }
    }

    /// <summary>
    /// 储蓄存折数据实体
    /// </summary>
    public class CXCZPageDYEntity
    {
        /// <summary>
        /// 日期
        /// </summary>
        public string DateInfo { get; set; }

        /// <summary>
        /// 摘要
        /// </summary>
        public string Description { get; set; }
        /// <summary>
        /// 笔序号
        /// </summary>
        public string Number { get; set; }
        /// <summary>
        /// 存期
        /// </summary>
        public string Deadline { get; set; }
        /// <summary>
        /// 利率
        /// </summary>
        public string Interestrate { get; set; }
        /// <summary>
        ///  贷方（存入用"+")
        ///  借方（支出用"-")
        /// </summary>
        public string DepWinhType { get; set; }
        ///// <summary>
        ///// 借方（-支出）
        ///// </summary>
        //public string Withdrawal { get; set; }

        ///// <summary>
        ///// 贷方（存入)
        ///// </summary>
        //public string Deposit { get; set; }

        /// <summary>
        /// 余额
        /// </summary>
        public string Balance { get; set; }

        /// <summary>
        /// 操作
        /// </summary>
        public string TellerNo { get; set; }

        /// <summary>
        /// 银行备考
        /// </summary>
        public string BankOperate { get; set; }

        /// <summary>
        /// 行号
        /// </summary>
        public int Line { get; set; }

        /// <summary>
        /// 是否显示
        /// </summary>
        public Visibility IsVisibility { get; set; }
    }

    /// <summary>
    /// 储蓄存折尾页实体
    /// </summary>
    public class CXCZEndPageDYEntity
    {
        /// <summary>
        /// 账号
        /// </summary>
        public string AcNo { get; set; }

        /// <summary>
        /// 户名
        /// </summary>
        public string AcName { get; set; }

        /// <summary>
        /// 销户日期
        /// </summary>
        public string XHDate { get; set; }

        /// <summary>
        /// 本金
        /// </summary>
        public string BenJin { get; set; }

        /// <summary>
        /// 利息
        /// </summary>
        public string LiXi { get; set; }

        /// <summary>
        /// 税金
        /// </summary>
        public string ShuiJin { get; set; }

        /// <summary>
        /// 本息合计
        /// </summary>
        public string BenXiHeJi { get; set; }

        /// <summary>
        /// 操作员
        /// </summary>
        public string Teller { get; set; }
    }
}
