﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml;
using Platform.Common.LogSystem;
using Platform.Common.RunningParameters;
using TellerSystem.PrintTemplate.PrintTemplateData;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// 活期存折首页都匀
    /// </summary>
    public partial class PrintBankBook_活期首页都匀 : IPrintContract
    {
        public PrintBankBook_活期首页都匀(PrintBankBook_活期首页都匀Entry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }
        public Contract.Entry.PrintEntry PrintData
        {
            get;
            set;
        }

        public void LoadPrintData()
        {
            var entry = PrintData as PrintBankBook_活期首页都匀Entry;
            if (entry == null || string.IsNullOrEmpty(entry.AccountName)) return;
            TB_AccountName.Text = entry.AccountName;
            TB_Currency.Text = entry.Currency;
            TB_AccountNo.Text = entry.AccountNo;
            var date = entry.SignDate.ToDateTime();
            TB_Date_Year.Text = date.Year.ToString()+"年";
            TB_Date_Month.Text = date.Month.ToString()+"月";
            TB_Date_Day.Text = date.Day.ToString()+"日";
            TB_TCTD.Text = entry.Tctd;
            TB_PasswordOrSeal.Text = entry.PasswordOrSeal.ToString();
            //TB_Species.Text = "活期存折";
            TB_OpenBrno.Text = entry.OpenBrno.ToString();
        }

        public class PrintBankBook_活期首页都匀Entry : PrintEntry
        {
            /**********************************
             * 定义实体属性
             * 1.打印逻辑用到的要素
             * *******************************/
            #region 打印属性
            /// <summary>
            /// 户名
            /// </summary>
            public string AccountName { get; set; }
            /// <summary>
            /// 币种
            /// </summary>
            public string Currency { get; set; }
            /// <summary>
            /// 账号
            /// </summary>
            public string AccountNo { get; set; }
            /// <summary>
            /// 印密
            /// </summary>
            public string PasswordOrSeal { get; set; }
            /// <summary>
            /// 通存通兑
            /// </summary>
            public string Tctd { get; set; }
            /// <summary>
            /// 签发日期
            /// </summary>
            public string SignDate { get; set; }
            /// <summary>
            /// 开户行
            /// </summary>
            public string OpenBrno { get; set; }
            #endregion
        }


        public List<CXCZPageDYEntity> PageData { get; set; }

        public void Setvalue()
        {
            if (PageData == null) return;
            if (PageData.Count == 0) return;
            BBP_Bottom.LoadOldData(PageData);
        }
    }
}
