﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml;
using Platform.Common.LogSystem;
using Platform.Common.RunningParameters;
using TellerSystem.PrintTemplate.PrintTemplateData;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// 活期存折首页
    /// </summary>
    public partial class PrintBankBook_活期尾页 : IPrintContract
    {
        public PrintBankBook_活期尾页(PrintBankBook_活期尾页Entry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }
        public Contract.Entry.PrintEntry PrintData
        {
            get;
            set;
        }


        public class PrintBankBook_活期尾页Entry : PrintEntry
        {
            /**********************************
             * 定义实体属性
             * 1.打印逻辑用到的要素
             * *******************************/


        }

        public void LoadPrintData()
        {

        }

        public List<CXCZPageEntity> PageData3 { get; set; }

        public void SetValue()
        {
            if (PageData3 == null) return;
            if (PageData3.Count == 0) return;
            //郏县、新密需求 存折打印偏上，需调整
            var FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            switch (FLAG)
            {
                case "V1"://郏县
                    BBP_Top.SetValue(Canvas.TopProperty, 45.0);
                    break;
                case "V3"://新密
                    BBP_Top.SetValue(Canvas.TopProperty, 45.0);
                    break;
                case "V5"://山东
                    BBP_Top.SetValue(Canvas.TopProperty, 35.0);
                    break;
                case "V6"://淇县、濮阳
                    BBP_Top.SetValue(Canvas.TopProperty, 20.0);
                    break;
                case "V8"://阳光
                case "V12"://长春融丰
                case "V11"://大石桥隆丰
                    BBP_Top.SetValue(Canvas.TopProperty, 20.0);
                    break;
                case "V21":
                case "V22":
                case "V13"://芝罘齐丰
                case "V10"://莱山齐丰
                case "V14"://泗水齐丰
                case "V16"://冠县齐丰
                case "V17"://蒙阴齐丰
                case "V18"://新泰齐丰
                case "V19"://哈密天山
                    BBP_Top.SetValue(Canvas.TopProperty, 43.0);
                    break;
                default:
                    break;
            }
            BBP_Top.LoadOldData(PageData3);
        }
    }
}