﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml;
using Platform.Common.LogSystem;
using Platform.Common.RunningParameters;
using TellerSystem.PrintTemplate.PrintTemplateData;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// 活期存折首页
    /// </summary>
    public partial class PrintBankBook_活期首页QF : IPrintContract
    {
        public PrintBankBook_活期首页QF(PrintBankBook_活期首页QFEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }
        public Contract.Entry.PrintEntry PrintData
        {
            get;
            set;
        }

        public void LoadPrintData()
        {
            var entry = PrintData as PrintBankBook_活期首页QFEntry;
            if (entry == null || string.IsNullOrEmpty(entry.AccountName)) return;
            TB_AccountName.Text = entry.AccountName;
            TB_Currency.Text = entry.Currency;
            TB_AccountNo.Text = entry.AccountNo;
            TB_CZ.Text = entry.Type;
            //var date = DateTime.ParseExact(LoginUserInfo.TradeDate, "yyyyMMdd", null);
            var date = entry.SignDate.ToDateTime();
            TB_Date_Year.Text = date.Year.ToString();
            TB_Date_Month.Text = date.Month.ToString();
            TB_Date_Day.Text = date.Day.ToString();

            TB_PasswordOrSeal.Text = entry.PasswordOrSeal;
            //TB_Species.Text = "活期存折";
            TB_Species.Text = entry.Species;
            TB_Interestrate.Text = decimal.Parse(entry.Interestrate).ToString() + "%";
            TB_OpenBrno.Text = entry.OpenBrno;
            TB_BankNo.Text = "支付行号：" + entry.PaySysCode;
            TB_BankNo.Text = entry.PaySysCode;
            TB_NoteNO.Text = entry.NoteNo;
            if (LoginUserInfo.KinbrNo.Substring(0, 3) == "803" || LoginUserInfo.KinbrNo.Substring(0, 3) == "806")//新泰、蒙阴
            {
                this.E_Seal_Location = new Point(294, 100);
            }
            else if (LoginUserInfo.KinbrNo.Substring(0, 3) != "108" && LoginUserInfo.KinbrNo.Substring(0, 3) != "118")
            {
                this.E_Seal_Location = new Point(319, 100);
            }
            if (LoginUserInfo.KinbrNo.Substring(0, 3) == "108" && entry.Species.Contains("零存整取"))
            {
                TB_TCTD.Visibility = Visibility.Visible;//通存通兑
                TB_TCTD.Text = entry.TCTD;
            }
            else
            {
                TB_TCTD.Visibility = Visibility.Collapsed;
            }
            string Flag = TellerSystem.ServiceProxy.Ext.ServiceHelper.TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            if (Flag == "V10" || Flag == "V17")
            {
                BZ.Visibility = Visibility.Visible;
            }
        }

        public class PrintBankBook_活期首页QFEntry : PrintEntry
        {
            /**********************************
             * 定义实体属性
             * 1.打印逻辑用到的要素
             * *******************************/
            #region 打印属性
            /// <summary>
            /// 户名
            /// </summary>
            public string AccountName { get; set; }

            /// <summary>
            /// 币种
            /// </summary>
            public string Currency { get; set; }

            /// <summary>
            /// 账号
            /// </summary>
            public string AccountNo { get; set; }

            /// <summary>
            /// 类型
            /// </summary>
            public string Type { get; set; }

            /// <summary>
            /// 存款类别
            /// </summary>
            public string DepositType { get; set; }

            /// <summary>
            /// 印密
            /// </summary>
            public string PasswordOrSeal { get; set; }

            /// <summary>
            /// 种类
            /// </summary>
            public string Species { get; set; }

            /// <summary>
            /// 利率
            /// </summary>
            public string Interestrate { get; set; }
            /// <summary>
            /// 支付行号
            /// </summary>
            public string PaySysCode { get; set; }

            /// <summary>
            /// 签发日期
            /// </summary>
            public string SignDate { get; set; }
            /// <summary>
            /// 开户行
            /// </summary>
            public string OpenBrno { get; set; }
            /// <summary>
            /// 凭证号
            /// </summary>
            public string NoteNo { get; set; }
            /// <summary>
            /// 通存通兑
            /// </summary>
            public string TCTD { get; set; }
            #endregion
        }


        public List<CXCZPageQFEntity> PageData { get; set; }

        public void Setvalue()
        {
            if (PageData == null) return;
            if (PageData.Count == 0) return;
            TB_Interestrate.Visibility = Visibility.Collapsed;
            TB_NoteNO.Visibility = Visibility.Collapsed;
            BBP_Bottom.LoadOldData(PageData);
        }
    }
}