﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// 储蓄存折首页实体
    /// </summary>
    public class CXCZFirstPageXXEntity
    {
        /// <summary>
        /// 开户行
        /// </summary>
        public string OpenBrno { get; set; }

        /// <summary>
        /// 产品名称
        /// </summary>
        public string CPMC { get; set; }

        /// <summary>
        /// 户名
        /// </summary>
        public string AccountName { get; set; }

        /// <summary>
        /// 账户
        /// </summary>
        public string AccountNo { get; set; }

        /// <summary>
        /// 币种
        /// </summary>
        public string Currency { get; set; }

        /// <summary>
        /// 利率
        /// </summary>
        public string Interestrate { get; set; }

        /// <summary>
        /// 存期
        /// </summary>
        public string CQ { get; set; }

        /// <summary>
        /// 起息日期
        /// </summary>
        public string QXRQ { get; set; }

        /// <summary>
        /// 到期日期
        /// </summary>
        public string DQRQ { get; set; }

        /// <summary>
        /// 签发日期
        /// </summary>
        public string SignDate { get; set; }

        /// <summary>
        /// 通存通兑
        /// </summary>
        public string TCTD { get; set; }

        /// <summary>
        /// 支付条件
        /// </summary>
        public string ZFTJ { get; set; }
    }

    /// <summary>
    /// 储蓄存折数据实体
    /// </summary>
    public class CXCZPageXXEntity
    {
        /// <summary>
        /// 日期
        /// </summary>
        public string DateInfo { get; set; }

        /// <summary>
        /// 摘要
        /// </summary>
        public string Description { get; set; }

        /// <summary>
        /// 笔序号
        /// </summary>
        public string Number { get; set; }

        /// <summary>
        /// 利率
        /// </summary>
        public string Interestrate { get; set; }

        /// <summary>
        ///  贷方（存入用"+")
        ///  借方（支出用"-")
        /// </summary>
        //public string DepWinhType { get; set; }

        /// <summary>
        /// 借方（-支出）
        /// </summary>
        public string Withdrawal { get; set; }

        /// <summary>
        /// 贷方（存入)
        /// </summary>
        public string Deposit { get; set; }

        /// <summary>
        /// 余额
        /// </summary>
        public string Balance { get; set; }

        /// <summary>
        /// 柜员号
        /// </summary>
        public string TellerNo { get; set; }

        /// <summary>
        /// 机构号
        /// </summary>
        public string Kinbr { get; set; }

        /// <summary>
        /// 行号
        /// </summary>
        public int Line { get; set; }

        /// <summary>
        /// 是否显示
        /// </summary>
        public Visibility IsVisibility { get; set; }
    }

    /// <summary>
    /// 储蓄存折尾页实体
    /// </summary>
    public class CXCZEndPageXXEntity
    {
        /// <summary>
        /// 账号
        /// </summary>
        public string AcNo { get; set; }

        /// <summary>
        /// 户名
        /// </summary>
        public string AcName { get; set; }

        /// <summary>
        /// 销户日期
        /// </summary>
        public string XHDate { get; set; }

        /// <summary>
        /// 本金
        /// </summary>
        public string BenJin { get; set; }

        /// <summary>
        /// 利息
        /// </summary>
        public string LiXi { get; set; }

        /// <summary>
        /// 税金
        /// </summary>
        public string ShuiJin { get; set; }

        /// <summary>
        /// 本息合计
        /// </summary>
        public string BenXiHeJi { get; set; }

        /// <summary>
        /// 操作员
        /// </summary>
        public string Teller { get; set; }
    }
}
