﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml;
using Platform.Common.LogSystem;
using Platform.Common.RunningParameters;
using TellerSystem.PrintTemplate.PrintTemplateData;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// 活期存折首页
    /// </summary>
    public partial class PrintBankBook_活期首页XX : IPrintContract
    {
        public PrintBankBook_活期首页XX(PrintBankBook_活期首页XXEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }
        public Contract.Entry.PrintEntry PrintData
        {
            get;
            set;
        }

        public void LoadPrintData()
        {
            var entry = PrintData as PrintBankBook_活期首页XXEntry;
            if (entry == null || string.IsNullOrEmpty(entry.AccountName)) return;
            TB_OpenBrno.Text = entry.OpenBrno;
            TB_CPMC.Text = entry.CPMC;
            TB_AccountName.Text = entry.AccountName;
            TB_AccountNo.Text = entry.AccountNo;
            TB_Currency.Text = "人民币";
            TB_Interestrate.Text = decimal.Parse(entry.Interestrate).ToString() + "%";
            TB_CQ.Text = entry.CQ;
            TB_QXRQ.Text = entry.QXRQ;
            TB_DQRQ.Text = entry.DQRQ;
            TB_QFRQ.Text = entry.SignDate;
            TB_TCTD.Text = entry.TCTD;
            TB_ZFTJ.Text = entry.ZFTJ;
        }

        public class PrintBankBook_活期首页XXEntry : PrintEntry
        {
            /**********************************
             * 定义实体属性
             * 1.打印逻辑用到的要素
             * *******************************/
            #region 打印属性

            /// <summary>
            /// 开户行
            /// </summary>
            public string OpenBrno { get; set; }

            /// <summary>
            /// 产品名称
            /// </summary>
            public string CPMC { get; set; }

            /// <summary>
            /// 户名
            /// </summary>
            public string AccountName { get; set; }

            /// <summary>
            /// 账号
            /// </summary>
            public string AccountNo { get; set; }

            /// <summary>
            /// 币种
            /// </summary>
            public string Currency { get; set; }

            /// <summary>
            /// 利率
            /// </summary>
            public string Interestrate { get; set; }

            /// <summary>
            /// 存期
            /// </summary>
            public string CQ { get; set; }

            /// <summary>
            /// 起息日
            /// </summary>
            public string QXRQ { get; set; }

            /// <summary>
            /// 到期日
            /// </summary>
            public string DQRQ { get; set; }

            /// <summary>
            /// 签发日期
            /// </summary>
            public string SignDate { get; set; }

            /// <summary>
            /// 通存通兑
            /// </summary>
            public string TCTD { get; set; }

            /// <summary>
            /// 支付条件
            /// </summary>
            public string ZFTJ { get; set; }

            #endregion
        }


        public List<CXCZPageXXEntity> PageData { get; set; }

        public void Setvalue()
        {
            if (PageData == null) return;
            if (PageData.Count == 0) return;
            TB_Interestrate.Visibility = Visibility.Collapsed;
            BBP_Bottom.LoadOldData(PageData);
        }
    }
}