﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml;
using Platform.Common.LogSystem;
using Platform.Common.RunningParameters;
using TellerSystem.PrintTemplate.PrintTemplateData;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// 活期存折首页
    /// </summary>
    public partial class PBB_KDZZ_FirstPage : IPrintContract
    {
        public PBB_KDZZ_FirstPage(PBB_KDZZ_FirstPageEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public class PBB_KDZZ_FirstPageEntry : PrintEntry
        {
            /**********************************
             * 定义实体属性
             * 1.打印逻辑用到的要素
             * *******************************/
            /// <summary>
            /// 户名
            /// </summary>
            public string HM { get; set; }
            /// <summary>
            /// 币种
            /// </summary>
            public string BZ { get; set; }
            /// <summary>
            /// 账号
            /// </summary>
            public string ZH { get; set; }
            /// <summary>
            /// 备注
            /// </summary>
            public string BZ1 { get; set; }
            /// <summary>
            /// 签发日期
            /// </summary>
            public string QFRQ { get; set; }
            /// <summary>
            /// 储种
            /// </summary>
            public string CZ { get; set; }
            /// <summary>
            /// 支付行号
            /// </summary>
            public string ZFHH { get; set; }
            /// <summary>
            /// 社保号
            /// </summary>
            public string SBH { get; set; }
            /// <summary>
            /// 客户号
            /// </summary>
            public string KHH { get; set; }
        }

        public Contract.Entry.PrintEntry PrintData
        {
            get;
            set;
        }

        public void LoadPrintData()
        {
            var entry = PrintData as PBB_KDZZ_FirstPageEntry;
            if (entry == null || string.IsNullOrEmpty(entry.HM)) return;
            TB_AccountName.Text = entry.HM;
            TB_Currency.Text = entry.BZ;
            TB_AccountNo.Text = entry.ZH;
            var date = DateTime.ParseExact(entry.QFRQ, "yyyyMMdd", null);
            TB_AccountDate.Text = date.ToString("yyyy/MM/dd");
            TB_Summary.Text = entry.BZ1;
            TB_CZ.Text = entry.CZ;
            TB_ZFHH.Text = entry.ZFHH;
            TB_KHH.Text = entry.KHH;
            TB_SBH.Text = string.Format("{0}：{1}", entry.SBH.Length == 8 ? "机关事业养老保险" : "社保号", entry.SBH);
        }
    }
}