﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using Platform.Common.RunningParameters;
using Platform.Print;
using TellerSystem.Communication;
using TellerSystem.Library.Ext.Function;
using TellerSystem.PrintTemplate.Bankbook;
using TellerSystem.Library.Ext.Variables;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// 贷款证打印辅助类
    /// </summary>
    public class SDBankBookHelper
    {
        #region 贷款证打印

      /// <summary>
      /// 打印贷款证数据页
      /// </summary>
      /// <param name="msg"></param>
      /// <param name="fales">打印还本</param>
      /// <returns></returns>
        public static List<PrintContainer> PrintSDDKZPage(Message msg,bool fales = false)
        {
            var aCxczBankbook = SDDKZBankbook.GetInstance();
            AnalyzeSDDKZData(aCxczBankbook, msg, fales);
            return aCxczBankbook.PrintBankBookPage();
        }
        /// <summary>
        /// 储蓄存折数据解析
        /// </summary>
        /// <param name="cxcz">储蓄存折</param>
        /// <param name="msg">报文</param>
        /// <returns></returns>
        private static bool AnalyzeSDDKZData(SDDKZBankbook cxcz, Message msg, bool fales)
        {
              //储蓄存折数据CXCZ|@txday|@dscpt|@txamt|@dbflag|@avbal|@tlrno||@brno|@tty|@lineno|||@term|@rate|@ac_seqn|@srate|@sterm|@zc_flag
            //存折数据初始化
            cxcz.EndPageData = new List<SDDKEndPageEntity>();

                //普通页数据  *打印行数|交易日期|贷款账号|摘要|到期日期|交易金额|执行利率|剩余授信额度*
               /*SXHB打印行数|交易日期|贷款账号|摘要|到期日期|交易金额|执行利率|剩余授信额度*/
            var comPage = msg.FileData.Split('|');
            //还本的数据在文件最后一行
            if (fales)
            {
                var st = msg.FileData.Split('\n');
                foreach (var item in st)
                {
                    if (item.StartsWith("SXHB"))
                    {
                        comPage = item.Substring(4).Split('|');
                        break;
                    } 
                }
            } 
                if (comPage.Count() != 0)
                {
                    SDDKEndPageEntity tmpPageData = null;
                    string ytxamt = string.Empty;
                    string avbal = string.Empty;
                    int curLine = 0;
                   
                        tmpPageData = new SDDKEndPageEntity();
                        //交易日期
                        tmpPageData.Date = comPage[1];
                        //还本 放款 还息
                        tmpPageData.XH = comPage[3];
                         //账号
                        tmpPageData.AccountLoanNo = comPage[2];
                        //交易余额
                        tmpPageData.Summary = comPage[5];
                        //到期日
                        tmpPageData.EndDate = comPage[4];
                        //利率
                        tmpPageData.LV = comPage[6];
                       // 授信余额
                     tmpPageData.Balance = comPage[7];
                    //行号
                     tmpPageData.Line =int.Parse(comPage[0]);
                     tmpPageData.IsVisibility = Visibility.Visible;
                        cxcz.EndPageData.Add(tmpPageData);
                    return true;
                }
            //解析数据错误
            if ( cxcz.EndPageData.Count == 0)
            {
                return false;
            }

            return true;
        }

        #endregion 活期存折
    }
}