﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml;
using Platform.Common.LogSystem;
using Platform.Common.RunningParameters;
using TellerSystem.PrintTemplate.PrintTemplateData;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;
using TellerSystem.PrintTemplate.ElecSeal;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// 活期存折首页
    /// </summary>
    public partial class LoanCardBook_贷款首页 : IPrintContract
    {
        public LoanCardBook_贷款首页(LoanCardBook_贷款首页Entry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }
        public Contract.Entry.PrintEntry PrintData
        {
            get;
            set;
        }

        public void LoadPrintData()
        {
            var entry = PrintData as LoanCardBook_贷款首页Entry;
            if (entry == null || string.IsNullOrEmpty(entry.AccountName)) return;
           
            TB_KHH.Text = entry.AccountName;
           
            //var date = DateTime.ParseExact(LoginUserInfo.TradeDate, "yyyyMMdd", null);
            var date = entry.SignDate.ToDateTime();
            TB_Date_Year.Text = date.Year.ToString();
            TB_Date_Month.Text = date.Month.ToString();
            TB_Date_Day.Text = date.Day.ToString();

            TB_SQHTH.Text = entry.Currency;
            //TB_Species.Text = "活期存折";
            TB_JKR.Text = entry.LoanName;
            TB_OpenBrno.Text = entry.OpenBrno;
            TB_ZJHM.Text = entry.IDNO;
            TB_ADRESS.Text =entry.Adress;
            TB_NoteNO.Text = entry.NoteNo.PadLeft(9,'0');
            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            //青隆电子签章
            if (FLAG == "V5")
            {
                TB_Date_Day.SetValue(Canvas.TopProperty, 223.00);
                TB_Date_Month.SetValue(Canvas.TopProperty, 223.00);
                TB_Date_Year.SetValue(Canvas.TopProperty, 223.00);

                TB_KHH.SetValue(Canvas.TopProperty, 49.00);
                TB_SQHTH.SetValue(Canvas.TopProperty, 51.00);
                TB_JKR.SetValue(Canvas.TopProperty, 80.00);
                TB_ZJHM.SetValue(Canvas.TopProperty, 83.00);
                TB_ADRESS.SetValue(Canvas.TopProperty, 116.00);

                this.ElecSealHelper.Sign2Point(new Point(314, 140), SealKind.Biz);
            }     
        }

        public class LoanCardBook_贷款首页Entry : PrintEntry
        {
            /**********************************
             * 定义实体属性
             * 1.打印逻辑用到的要素
             * *******************************/
            #region 打印属性
            /// <summary>
            /// 客户号
            /// </summary>
            public string AccountName { get; set; }

            /// <summary>
            /// 授权合同号
            /// </summary>
            public string Currency { get; set; }

            /// <summary>
            /// 借款人
            /// </summary>
            public string LoanName { get; set; }

            /// <summary>
            /// 证件号码
            /// </summary>
            public string IDNO { get; set; }

            /// <summary>
            /// 地址
            /// </summary>
            public string Adress { get; set; }

            /// <summary>
            /// 签发日期
            /// </summary>
            public string SignDate { get; set; }
            /// <summary>
            /// 开户行
            /// </summary>
            public string OpenBrno { get; set; }
            /// <summary>
            /// 凭证号
            /// </summary>
            public string NoteNo { get; set; }

            
            #endregion
        }
    }
}