﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml;
using Platform.Common.LogSystem;
using Platform.Common.RunningParameters;
using TellerSystem.PrintTemplate.PrintTemplateData;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// 活期存折首页
    /// </summary>
    public partial class LoanCardBook_贷款首页中间页 : IPrintContract
    {
        public LoanCardBook_贷款首页中间页(LoanCardBook_贷款首页中间页Entry entry)
        {
            InitializeComponent();
            PrintData = entry;

        }
        public Contract.Entry.PrintEntry PrintData
        {
            get;
            set;
        }
        public void LoadPrintData()
        {
            var entry = PrintData as LoanCardBook_贷款首页中间页Entry;
            if (entry == null || string.IsNullOrEmpty(entry.AccountJE)) return;
            TB_JEX.Text = entry.AccountJE.ToDecimal().ToString("N2");
            TB_JEDX.Text = entry.PageData.TradeAPIs.ChangeToCNY(entry.AccountJE.ToDecimal());
            TB_DBFS.Text = entry.LoanType;
            TB_QZRQ.Text = entry.StartAndEedDate;
            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            if (FLAG == "V5")
            {
                TB_JEX.SetValue(Canvas.TopProperty, 294.00);
                TB_JEDX.SetValue(Canvas.TopProperty, 312.00);
                TB_DBFS.SetValue(Canvas.TopProperty, 329.00);
                TB_QZRQ.SetValue(Canvas.TopProperty, 347.00);
            }
        }

        public class LoanCardBook_贷款首页中间页Entry : PrintEntry
        {
            /**********************************
             * 定义实体属性
             * 1.打印逻辑用到的要素
             * *******************************/
            #region 打印属性
            /// <summary>
            /// 金额小写
            /// </summary>
            public string AccountJE { get; set; }

            /// <summary>
            /// 金额大写
            /// </summary>
            public string AccountJEUP { get; set; }

            /// <summary>
            /// 担保方式
            /// </summary>
            public string LoanType { get; set; }

            /// <summary>
            /// 起止日期
            /// </summary>
            public string StartAndEedDate { get; set; }
            #endregion
        }
    }
}