﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// 贷款证首页实体
    /// </summary>
    public class SDDKFirstPageEntity
    {
        /// <summary>
        /// 客户号
        /// </summary>
        public string Cust { get; set; }

        /// <summary>
        /// 授权合同号
        /// </summary>
        public string CZNum { get; set; }

        /// <summary>
        /// 借款人
        /// </summary>
        public string AcName { get; set; }

        /// <summary>
        /// 证件号
        /// </summary>
        public string IDNO { get; set; }

        /// <summary>
        /// 地址
        /// </summary>
        public string Address { get; set; }
        /// <summary>
        /// 开户网点
        /// </summary>
        public string OpnBrname { get; set; }
        /// <summary>
        /// 开户日期
        /// </summary>
        public string OpnDate { get; set; }
    }

    /// <summary>
    /// 贷款正中间页
    /// </summary>
    public class SDDKPageEntity
    {
        /// <summary>
        /// 起止日期日期
        /// </summary>
        public string DateInfo { get; set; }

        /// <summary>
        /// 担保方式
        /// </summary>
        public string Description { get; set; }


        /// <summary>
        /// 金额大写
        /// </summary>
        public string BalanceUP { get; set; }

        /// <summary>
        /// 金额小写
        /// </summary>
        public string Balancedown { get; set; }

    }

    /// <summary>
    /// 贷款证尾页实体
    /// </summary>
    public class SDDKEndPageEntity
    {
        /// <summary>
        /// 发生日期
        /// </summary>
        public string Date { get; set; }
        /// <summary>
        /// 贷款账号
        /// </summary>
        public string AccountLoanNo { get; set; }
        /// <summary>   
        /// 方式
        /// </summary>
        public string XH { get; set; }
        /// <summary>
        /// 到期日
        /// </summary>
        public string EndDate { get; set; }
        /// <summary>
        /// 交易金额
        /// </summary>
        public string Summary { get; set; }
        /// <summary>
        /// 利率
        /// </summary>
        public string LV { get; set; }

        /// <summary>
        /// 授信余额
        /// </summary>
        public string Balance { get; set; }

        /// <summary>
        /// 行号
        /// </summary>
        public int Line { get; set; }
        /// <summary>
        /// 是否显示
        /// </summary>
        public Visibility IsVisibility { get; set; }

    }
}
