﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml;
using Platform.Common.LogSystem;
using Platform.Common.RunningParameters;
using TellerSystem.PrintTemplate.PrintTemplateData;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// 活期存折首页
    /// </summary>
    public partial class PBB_YBZCZ_FirstPage : IPrintContract
    {
        public PBB_YBZCZ_FirstPage(PBB_YBZCZ_FirstPageEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public class PBB_YBZCZ_FirstPageEntry : PrintEntry
        {
            /**********************************
             * 定义实体属性
             * 1.打印逻辑用到的要素
             * *******************************/
            public string HM { get; set; }
            public string BZ { get; set; }
            public string ZH { get; set; }
            public string Kinbro { get; set; }
            public string QFRQ { get; set; }
            public string YM { get; set; }
        }

        public Contract.Entry.PrintEntry PrintData
        {
            get;
            set;
        }

        public void LoadPrintData()
        {
            var entry = PrintData as PBB_YBZCZ_FirstPageEntry;
            if (entry == null || string.IsNullOrEmpty(entry.HM)) return;
            TB_Title.Visibility = Visibility.Collapsed;
            TB_AccountName.Text = entry.HM;
            TB_Currency.Text = entry.BZ;
            TB_AccountNo.Text = entry.ZH;
            TB_AccountDate.Text = entry.QFRQ;
            TB_PasswordOrSeal.Text = entry.YM;
            TB_Kinbro.Text = entry.Kinbro;
        }

        public void SetLines(List<BBP_YBZCZ.BankBookPageLine> lines)
        {
            BBP_Bottom.LoadData(lines);
        }
    }
}