﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml;
using Platform.Common.LogSystem;
using Platform.Common.RunningParameters;
using TellerSystem.PrintTemplate.PrintTemplateData;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// 活期存折首页
    /// </summary>
    public partial class QF_YBZCZ_FirstPage : IPrintContract
    {
        public QF_YBZCZ_FirstPage(QF_YBZCZ_FirstPageEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }
        public static string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        public class QF_YBZCZ_FirstPageEntry : PrintEntry
        {
            /**********************************
             * 定义实体属性
             * 1.打印逻辑用到的要素
             * *******************************/
            public string HM { get; set; }
            public string BZ { get; set; }
            public string ZH { get; set; }
            public string Kinbro { get; set; }
            public string QFRQ { get; set; }
            public string YM { get; set; }
            public string NoteNo { get; set; }
            public string PayNo { get; set; }
        }

        public Contract.Entry.PrintEntry PrintData
        {
            get;
            set;
        }

        public void LoadPrintData()
        {
            var entry = PrintData as QF_YBZCZ_FirstPageEntry;
            if (entry == null || string.IsNullOrEmpty(entry.HM)) return;
            TB_AccountName.Text = entry.HM;
            TB_Currency.Text = entry.BZ;
            TB_AccountNo.Text = entry.ZH;
            var date = entry.QFRQ.ToDateTime();
            TB_AccountDate_year.Text = date.Year.ToString();
            TB_AccountDate_month.Text = date.Month.ToString();
            TB_AccountDate_day.Text = date.Day.ToString();
            TB_PasswordOrSeal.Text = entry.YM;
            TB_Kinbro.Text = entry.Kinbro;
            TB_NoteNo.Text = entry.NoteNo;
            TB_PayNo.Text = entry.PayNo;
            TB_Title.Text = "定期一本通";
            if (FLAG == "V19")//天山打印一本通存折
            {
                TB_Title.Text = "一本通存折";
            }
            if (LoginUserInfo.KinbrNo.Substring(0, 3) == "803" || LoginUserInfo.KinbrNo.Substring(0, 3) == "806")
            {
                this.E_Seal_Location = new Point(294, 100);
            }
            else if (LoginUserInfo.KinbrNo.Substring(0, 3) != "108" && LoginUserInfo.KinbrNo.Substring(0, 3) != "118")
            {
                this.E_Seal_Location = new Point(319, 100);
            }
            if (FLAG == "V10" || FLAG == "V17")
            {
                BZ.Visibility = Visibility.Visible;
            }
        }

        public void SetLines(List<QF_YBTCZ.BankBookPageLine> lines)
        {
            TB_NoteNo.Visibility = Visibility.Collapsed;
            BBP_Bottom.LoadData(lines);
        }
    }
}