﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TellerSystem.Contract.Entry;
using TellerSystem.Communication;
using TellerSystem.Library.Ext.Function;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// BranchLogin.xaml 的交互逻辑
    /// </summary>
    public partial class BranchLogin_print : IPrintContract
    {

           #region 预设逻辑
        public BranchLogin_print(BranchLogin_printEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        /// <summary>
        /// 打印实体
        /// </summary>
        public PrintEntry PrintData
        {
            get;
            set;
        }
        #endregion

        #region 打印逻辑
        /// <summary>
        /// 凭证的打印数据实体定义
        /// </summary>
        public class BranchLogin_printEntry : PrintEntry
        {
            /**********************************
             * 定义实体属性
             * 1.打印逻辑用到的要素
             * *******************************/
            public string ThirdNo { get; set; }
            public string firstTeller { get; set; }
            public string SecondTeller { get; set; }
            public string SerialNo { get; set; }
        }
        /// <summary>
        /// 加载打印数据
        /// </summary>
        public void LoadPrintData()
        {
            /**********************************
            * 加载数据到打印界面
            * 1.数据来源，PrintData.MessageData、PrintData.PageBase
            * *******************************/
            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            var entry = PrintData as BranchLogin_printEntry;
            var time = DateTime.ParseExact(LoginUserInfo.GetUserInfo("TradeTime"), "HHmmss", null);
            branchName.SetPrintTextBlock(LoginUserInfo.KinbrName);
            TradeName.SetPrintTextBlock("机构签到");
            if (FLAG == "V0")
            {
                ThirdNo.SetPrintTextBlock(" " + entry.ThirdNo);
                SerialNo.SetPrintTextBlock(" " + entry.SerialNo);
                fristTeller.Text = "柜    员:" + entry.firstTeller;
                secondTeller.Visibility = Visibility.Collapsed;
                fristTeller.SetValue(Canvas.TopProperty, 171.00);
            }
            else
            {
                ThirdNo.SetPrintTextBlock(entry.ThirdNo);
                SerialNo.SetPrintTextBlock(entry.SerialNo);
            }
            fristTeller.SetPrintTextBlock(entry.firstTeller);
            secondTeller.SetPrintTextBlock(entry.SecondTeller);
            loginDate.SetPrintTextBlock(LoginUserInfo.TradeDate);
            LoginTime.SetPrintTextBlock(time.ToString("HH:mm:ss"));
            if (FLAG == "V5" && LoginUserInfo.KinbrNo.Substring(0, 3) == "302")
            {
                LoginUser.SetPrintTextBlock(LoginUserInfo.TellerNo + "(" + LoginUserInfo.TellerName + ")");
            }
            else
            {
                LoginUser.SetPrintTextBlock(LoginUserInfo.TellerNo);
            }
            //SerialNo.SetPrintTextBlock(entry.SerialNo);
            #region

            #endregion
        }
        #endregion
    }
}
