﻿using System;
using System.Windows;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using System.ComponentModel;
using System.Data.SqlTypes;
using TellerSystem.Library.Ext.TradeExtension;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Print_AccountApplication.xaml 的交互逻辑
    /// </summary>
    public partial class Print_AccountApplicationInternetSD : IPrintContract
    {
        public Print_AccountApplicationInternetSD(Print_AccountApplicationInternetEntrySD entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        /// <summary>
        /// 打印实体
        /// </summary>
        public PrintEntry PrintData { get; set; }

        /// <summary>
        /// 凭证的打印数据实体定义
        /// </summary>
        public class Print_AccountApplicationInternetEntrySD : PrintEntry
        {
            /**********************************
             * 定义实体属性
             * 1.打印逻辑用到的要素
             * *******************************/
            /// <summary>
            /// 账号
            /// </summary>
            public string tb_Ac_no { get; set; }
            /// <summary>
            /// 户名
            /// </summary>
            public string tb_Acname { get; set; }
            /// <summary>
            /// 交易类型
            /// </summary>
            public string tb_tradeType { get; set; }
            /// <summary>
            /// 客户编号
            /// </summary>
            public string tb_khbh { get; set; }

            /// <summary>
            /// 证件类型
            /// </summary>
            public string tb_IDtype { get; set; }
            /// <summary>
            /// 证件号码
            /// </summary>
            public string tb_IDNum { get; set; }
            /// <summary>
            /// 平台
            /// </summary>
            public string tb_ptrq { get; set; }
            /// <summary>
            /// 交易时间
            /// </summary>
            public string tb_jytime { get; set; }
            /// <summary>
            /// 代理人名称
            /// </summary>
            public string tb_ProxyName { get; set; }
            /// <summary>
            /// 代理人证件类型
            /// </summary>
            public string tb_ProxyIDType { get; set; }
            /// <summary>
            /// 代理人证件号码
            /// </summary>
            public string tb_ProxyIDNum { get; set; }
            /// <summary>
            /// 授权柜员
            /// </summary>
            public string SQGY { get; set; }
            /// <summary>
            /// 经办人
            /// </summary>
            public string JBR { get; set; }
            /// <summary>
            /// 会计分录
            /// </summary>
            public string KJFL { get; set; }
            /// <summary>
            /// 机构名称
            /// </summary>
            public string tb_jgmc { get; set; }
            /// <summary>
            /// 代码
            /// </summary>
            public string tb_dm { get; set; }
            /// <summary>
            /// 交易
            /// </summary>
            public string tb_jy { get; set; }
           
            /// <summary>
            /// 柜员
            /// </summary>
            public string tb_gy { get; set; }
            /// <summary>
            /// 平台流水号
            /// </summary>
            public string tb_ptlsh { get; set; }
            /// <summary>
            /// 柜员流水
            /// </summary>
            public string tb_gyls { get; set; }

            /// <summary>
            /// 备注 /代理人显示
            /// </summary>
            public string tb_bz { get; set; }

            public string isHasProxy { get; set; }
        }


        //<summary>
        //加载打印数据
        //</summary>
        public void LoadPrintData()
        {
            /**********************************
            * 加载数据到打印界面
            * 1.数据来源，PrintData.MessageData、PrintData.PageBase
            * *******************************/

            var entry = PrintData as Print_AccountApplicationInternetEntrySD;

         
          
            tb_Ac_no.SetPrintTextBlock(entry.tb_Ac_no);//账号
            tb_Acname.SetPrintTextBlock(entry.tb_Acname);//姓名
          
            //tb_Amt.SetPrintTextBlock(SystemFunction.Delspace(SystemFunction.Comma(entry.OpnAmt, 16)));
         
            tb_IDtype.SetPrintTextBlock(entry.tb_IDtype);// 证件类型
            tb_IDNum.SetPrintTextBlock(entry.tb_IDNum);//证件号码
            tb_KHNum.SetPrintTextBlock(entry.tb_khbh); //客户编号
            tb_jy.SetPrintTextBlock(this.PrintAttribute.TradeModel.Name + "(" + this.PrintAttribute.TradeModel.Code + ")");//交易名称
            SQGY.Text = this.PrintAttribute.Authentic;//授权柜员
            tb_gyls.SetPrintTextBlock(this.PrintAttribute.SerialNumber);//柜员流水号 
            tb_jgmc.SetPrintTextBlock(LoginUserInfo.KinbrName);//机构名称
            tb_JGDM.SetPrintTextBlock(LoginUserInfo.KinbrNo);//机构号
            var time = DateTime.ParseExact(LoginUserInfo.GetUserInfo("TradeTime"), "HHmmss", null);

            tb_PTRQ.SetPrintTextBlock(LoginUserInfo.TradeDate);//平台日期
            tb_dm.SetPrintTextBlock(entry.tb_dm);//代码
            tb_tradeTime.SetPrintTextBlock(time.ToString("HH:mm:ss"));//交易时间
            tb_GYH.SetPrintTextBlock(LoginUserInfo.TellerNo);//柜员号
            tb_PTLSH.SetPrintTextBlock(this.PrintAttribute.BusinessTransaction);//平台流水号
            FHGY.Text = this.PrintAttribute.Review;//复核人
            JBR.Text = LoginUserInfo.TellerName;//经办人
        }
    }
}
