﻿using System;
using System.Windows;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using System.ComponentModel;
using System.Data.SqlTypes;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Print_AccountApplication.xaml 的交互逻辑
    /// </summary>
    public partial class Print_AccountApplicationTS : IPrintContract
    {
        public Print_AccountApplicationTS(Print_AccountApplicationTSEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        /// <summary>
        /// 打印实体
        /// </summary>
        public PrintEntry PrintData { get; set; }

        /// <summary>
        /// 凭证的打印数据实体定义
        /// </summary>
        public class Print_AccountApplicationTSEntry : PrintEntry
        {
            /**********************************
             * 定义实体属性
             * 1.打印逻辑用到的要素
             * *******************************/
            /// <summary>
            /// 账号
            /// </summary>
            public string tb_Ac_no { get; set; }
            /// <summary>
            /// 户名
            /// </summary>
            public string tb_Acname { get; set; }
            /// <summary>
            /// 性别
            /// </summary>
            public string tb_gender { get; set; }
            /// <summary>
            /// 证件类型
            /// </summary>
            public string tb_IDtype { get; set; }
            /// <summary>
            /// 证件号码
            /// </summary>
            public string tb_IDNum { get; set; }
            /// <summary>
            /// 证件有效期
            /// </summary>
            public string tb_IDExpiration_date { get; set; }
            /// <summary>
            /// 家庭电话
            /// </summary>
            public string tb_home_phone { get; set; }
            /// <summary>
            /// 移动电话
            /// </summary>
            public string tb_Phone { get; set; }
            /// <summary>
            /// 工作单位
            /// </summary>
            public string tb_employer { get; set; }
            /// <summary>
            /// 地址
            /// </summary>
            public string tb_Address { get; set; }
            /// <summary>
            /// 邮编
            /// </summary>
            public string tb_Postcode { get; set; }
            /// <summary>
            /// 办公电话
            /// </summary>
            public string tb_Office_Phone { get; set; }
            /// <summary>
            /// 开户行
            /// </summary>
            public string tb_Bank { get; set; }
            /// <summary>
            /// 开户行名
            /// </summary>
            public string tb_BankName { get; set; }
            /// <summary>
            /// 国籍
            /// </summary>
            public string tb_GJ { get; set; }
            /// <summary>
            /// 职业
            /// </summary>
            public string tb_ZY { get; set; }
            /// <summary>
            /// 柜员
            /// </summary>
            public string tb_gy { get; set; }
        }
        

         //<summary>
         //加载打印数据
         //</summary>
        public void LoadPrintData()
        {
            /**********************************
            * 加载数据到打印界面
            * 1.数据来源，PrintData.MessageData、PrintData.PageBase
            * *******************************/

            var entry = PrintData as Print_AccountApplicationTSEntry;
            tb_Ac_no.SetPrintTextBlock(entry.tb_Ac_no);
            tb_Acname.SetPrintTextBlock(entry.tb_Acname);
            tb_gender.SetPrintTextBlock(entry.tb_gender);
            tb_IDtype.SetPrintTextBlock(entry.tb_IDtype);
            tb_IDNum.SetPrintTextBlock(entry.tb_IDNum);
            tb_IDExpiration_date.SetPrintTextBlock(entry.tb_IDExpiration_date);
            //tb_Amt.SetPrintTextBlock(SystemFunction.Delspace(SystemFunction.Comma(entry.OpnAmt, 16)));
            tb_home_phone.SetPrintTextBlock(entry.tb_home_phone);
            tb_Phone.SetPrintTextBlock(entry.tb_Phone);
            tb_employer.SetPrintTextBlock(entry.tb_employer);
            tb_Address.SetPrintTextBlock(entry.tb_Address);
            tb_Postcode.SetPrintTextBlock(entry.tb_Postcode);
            tb_Office_Phone.SetPrintTextBlock(entry.tb_Office_Phone);
            tb_Bank.SetPrintTextBlock(entry.tb_Bank);
            tb_BankName.SetPrintTextBlock(entry.tb_BankName);
            tb_GJ.SetPrintTextBlock(entry.tb_GJ);
            tb_ZY.SetPrintTextBlock(entry.tb_ZY);
            tb_gy.SetPrintTextBlock(LoginUserInfo.TellerName);//柜员
        }
    }
}
