﻿using System;
using System.Windows;
using System.Windows.Controls;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using TellerSystem.PrintTemplate.Base;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Page1.xaml 的交互逻辑
    /// </summary>
    public partial class Print_BusinessVoucher_Draw : IPrintContract
    {
        public Print_BusinessVoucher_Draw(Print_BusinessVoucher_Draw_Entry entry)
        {
            InitializeComponent();
            PrintData = entry;
            LoadPrintData();
        }

        public Contract.Entry.PrintEntry PrintData { get; private set; }
        public class Print_BusinessVoucher_Draw_Entry : PrintEntry
        {
            /// <summary>
            /// 标题
            /// </summary>
            public string Title { get; set; }
            /// <summary>
            /// 银行留存联账号
            /// </summary>
            public string Acno { get; set; }
            /// <summary>
            /// 客户回单账号
            /// </summary>
            public string Acno1 { get; set; }
            /// <summary>
            /// 账户户名
            /// </summary>
            public string ZHHM { get; set; }

            /// <summary>
            /// 开户行名
            /// </summary>
            public string OpnBrno { get; set; }

            /// <summary>
            /// 储种
            /// </summary>
            public string PrdtName { get; set; }

            /// <summary>
            /// 利率
            /// </summary>
            public string Rate { get; set; }

            /// <summary>
            /// 存期
            /// </summary>
            //public string Term { get; set; }

            /// <summary>
            /// 交易金额
            /// </summary>
            public decimal TxAmt { get; set; }
            /// <summary>
            /// 账户余额
            /// </summary>
            public string tbAccount { get; set; }

            /// <summary>
            /// 凭证号码
            /// </summary>
            public string NoteNo { get; set; }

            /// <summary>
            /// 账户类型
            /// </summary>
            public string Zhlx { get; set; }

            /// <summary>
            /// 交易类型
            /// </summary>
            public string TradeType { get; set; }

            /// <summary>
            /// 现转标志
            /// </summary>
            public string CtInd { get; set; }

            /// <summary>
            /// 自动转存
            /// </summary>
            public string ZDZC { get; set; }


            /// <summary>
            /// 对方户名
            /// </summary>
            public string DfAcname { get; set; }


            /// <summary>
            /// 账户介质
            /// </summary>
            public string ZHJZ { get; set; }

            /// <summary>
            /// 银行留存联对方账号
            /// </summary>
            public string DfAcno { get; set; }
            /// <summary>
            /// 客户回单对方账号
            /// </summary>
            public string DfAcno1 { get; set; }
            /// <summary>
            /// 利息
            /// </summary>
            public string Lx { get; set; }
            /// <summary>
            /// 利息税
            /// </summary>
            public string Lxs { get; set; }
            /// <summary>
            /// 实付利息
            /// </summary>
            public string Sflx { get; set; }
            /// <summary>
            /// 实付本息
            /// </summary>
            public string Sfbx { get; set; }

            //结算类型
            public string jslx { get; set; }

            /// <summary>
            /// 通存通兑标志
            /// </summary>
            public string TCBZ { get; set; }
            /// <summary>
            /// 前置利息
            /// </summary>
            public string QZLX { get; set; }
            ///// 余额
            ///// </summary>
            //public decimal Bal { get; set; }


            /// <summary>
            /// 账户序号
            /// </summary>
            public string ZHXH { get; set; }
            /// <summary>
            /// 子账户开户日期
            /// </summary>
            public string ZZH_Opndate { get; set; }
            /*
             * 
            /// <summary>
            /// 余额
            /// </summary>
            public decimal Bal { get; set; }

            /// <summary>
            /// 新凭证号
            /// </summary>
            public string NewNoteNo { get; set; }

            /// <summary>
            /// 科目
            /// </summary>
            public string Subject { get; set; }
             * 
             * */
            /// <summary>
            /// 是否代理
            /// </summary>
            public string SFDL { get; set; }
            /// <summary>
            /// 代理人名称
            /// </summary>
            public string DLRMC { get; set; }
            /// <summary>
            /// 代理人号码
            /// </summary>
            public string DLRHM { get; set; }
            /// <summary>
            /// 代理人手机号
            /// </summary>
            public string DLRSJH { get; set; }
            /// <summary>
            /// 代理人证件类型
            /// </summary>
            public string DLRZJLX { get; set; }
            /// <summary>  //天山
            /// 证件类型  
            /// </summary>
            public string ZJLX { get; set; }
            /// <summary>
            /// 大写金额
            /// </summary>
            public string DXJE { get; set; }
            /// <summary>
            /// 存款保险条例
            /// </summary>
            public string BZ1 { get; set; }
        }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_BusinessVoucher_Draw_Entry;
            if (entry == null)
                return;
            TB_title.Text = entry.Title;
            TB_Prdt1.Text = "储    种:{0}";


            switch (entry.TCBZ[4].ToString().Trim())
            {
                case "0":
                    TB_TCBZ.SetPrintTextBlock("非通存通兑");
                    break;
                case "1":
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
                case "2":
                    TB_TCBZ.SetPrintTextBlock("通存非通兑");
                    break;
                default:
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
            }
            TB_ZHXH.SetPrintTextBlock(entry.ZHXH);

            TB_Acno1.SetPrintTextBlock(entry.Acno);

            TB_HM1.SetPrintTextBlock(entry.ZHHM);


            TB_OPNbrno.SetPrintTextBlock(entry.OpnBrno);
            TB_Prdt1.SetPrintTextBlock(entry.PrdtName);

            if (!string.IsNullOrEmpty(entry.Rate))
            {
                TB_Rate1.SetPrintTextBlock(string.Format("{0:N6}%", entry.Rate));
            }
            else
            {
                TB_Rate1.SetPrintTextBlock(string.Empty);
            }
            //定期部提需要打印介质种类
            if (!string.IsNullOrEmpty(entry.ZHJZ))
            {
                TB_ZHJZ.Visibility = Visibility.Visible;
                TB_ZHJZ.SetPrintTextBlock(entry.ZHJZ);
            }


            //TB_Term1.SetPrintTextBlock(entry.Term);
            var type = UserFunction.ChangeMoneySymbol("01");
            TB_TxAmt1.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));

            if (entry.tbAccount != null)
            {
                tb_Account.Visibility = Visibility.Visible;
                tb_Account.SetPrintTextBlock(type + entry.tbAccount.ToDecimal().ToString("N2"));
            }


            TB_data.SetPrintTextBlock(LoginUserInfo.TradeDate);
            TB_Note1.SetPrintTextBlock(entry.NoteNo.PadLeft(TellerSystem.Library.Ext.Variables.UserVariable.Len_VoucherNo, '0'));

            //TB_Czy.SetPrintTextBlock(LoginUserInfo.TellerNo);
            //TB_Czy.SetPrintTextBlock("(" + LoginUserInfo.TellerName + ")" + LoginUserInfo.TellerNo);

            //天山新增证件类型,证件号码
            zjlx.SetPrintTextBlock(entry.ZJLX);
            zjhm.SetPrintTextBlock(entry.NoteNo.PadLeft(TellerSystem.Library.Ext.Variables.UserVariable.Len_VoucherNo, '0'));



            if (!string.IsNullOrEmpty(entry.Zhlx))
            {
                TB_Zhlx.Visibility = Visibility.Visible;
                TB_Zhlx.SetPrintTextBlock(entry.Zhlx);
            }

            TB_TradeType.SetPrintTextBlock(entry.TradeType);

            TB_CtInd1.SetPrintTextBlock(entry.CtInd);

            TB_jyh.SetPrintTextBlock(LoginUserInfo.KinbrNo);
            if (!string.IsNullOrEmpty(entry.ZDZC))
            {
                TB_ZDZC.Visibility = Visibility.Visible;
                TB_ZDZC.SetPrintTextBlock(entry.ZDZC);
            }
            if (string.IsNullOrEmpty(entry.DfAcno))
            {
                TB_DfAcno1.Visibility = Visibility.Hidden;

            }
            else
            {
                TB_DfAcno1.SetPrintTextBlock(entry.DfAcno);


            }
            if (string.IsNullOrEmpty(entry.DfAcname))
            {
                TB_DfAcname1.Visibility = Visibility.Hidden;

            }
            else
            {
                TB_DfAcname1.SetPrintTextBlock(entry.DfAcname);

            }

            //if (string.IsNullOrEmpty(entry.Lxs))
            //{
            //    TB_Lxs.Visibility = Visibility.Hidden;
            //}
            //else
            //{
            //    TB_Lxs.Visibility = Visibility.Visible;
            //    TB_Lxs.SetPrintTextBlock("¥" + entry.Lxs);
            //}
            if (string.IsNullOrEmpty(entry.Sflx))
            {
                TB_Sflx.Visibility = Visibility.Hidden;

            }
            else
            {
                TB_Sflx.Visibility = Visibility.Visible;
                TB_Sflx.SetPrintTextBlock("¥" + entry.Sflx);

            }
            if (!string.IsNullOrEmpty(entry.QZLX))
            {
                tbkQZLX.SetPrintTextBlock("¥" + entry.QZLX);

                tbkQZLX.Visibility = Visibility.Visible;
            }
            else
            {
                tbkQZLX.Visibility = Visibility.Collapsed;
            }
            if (string.IsNullOrEmpty(entry.Sfbx))
            {
                TB_SfBx.Visibility = Visibility.Hidden;

            }
            else
            {
                TB_SfBx.Visibility = Visibility.Visible;
                TB_SfBx.SetPrintTextBlock("¥" + entry.Sfbx);

            }

            //代理人信息
            if (entry.SFDL == "Y")
            {
                if (!string.IsNullOrWhiteSpace(entry.DLRZJLX))
                {
                    TB_DLRZJLX.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrWhiteSpace(entry.DLRHM))
                {
                    TB_DLRHM.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrWhiteSpace(entry.DLRMC))
                {
                    TB_DLRMC.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrWhiteSpace(entry.DLRSJH))
                {
                    TB_DLRSJH.Visibility = Visibility.Visible;
                }
                TB_DLRZJLX.SetPrintTextBlock(entry.DLRZJLX);
                TB_DLRHM.SetPrintTextBlock(entry.DLRHM);
                TB_DLRMC.SetPrintTextBlock(entry.DLRMC);
                TB_DLRSJH.SetPrintTextBlock(entry.DLRSJH);
            }
            TB_Rate1.SetValue(Canvas.LeftProperty, 290.00);
            TB_Note1.SetValue(Canvas.LeftProperty, 290.00);
            TB_Zhlx.SetValue(Canvas.LeftProperty, 290.00);
            TB_DfAcno1.SetValue(Canvas.LeftProperty, 290.00);
            TB_DfAcname1.SetValue(Canvas.LeftProperty, 290.00);
            TB_SfBx.SetValue(Canvas.LeftProperty, 290.00);
            TB_DLRSJH.SetValue(Canvas.LeftProperty, 290.00);
            TB_DLRHM.SetValue(Canvas.LeftProperty, 290.00);
            TB_OPNbrno.SetValue(Canvas.LeftProperty, 500.00);
            TB_jyh.SetValue(Canvas.LeftProperty, 500.00);
            TB_data.SetValue(Canvas.LeftProperty, 500.00);
            TB_ZDZC.SetValue(Canvas.LeftProperty, 500.00);
            TB_Sflx.SetValue(Canvas.LeftProperty, 500.00);
            TB_ZHJZ.SetValue(Canvas.LeftProperty, 500.00);
            tb_Account.SetValue(Canvas.LeftProperty, 500.00);
            //授权柜员号
            //柜员流水、业务流水、TB_title一行
            TB_title.SetValue(Canvas.LeftProperty, 394.00);




        }
    }
}


