﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using TellerSystem.PrintTemplate;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// 
    /// </summary>
    public partial class Print_CashCheckInfo : IPrintContract
    {
        public Print_CashCheckInfo(Print_CashCheckInfoentry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public Contract.Entry.PrintEntry PrintData
        {
            get;
            private set;
        }

        /// <summary>
        /// 
        /// </summary>
        public class Print_CashCheckInfoentry: PrintEntry
        {
            /// <summary>
            /// 交易号
            /// </summary>
            public string jyh { get; set; }
            /// <summary>
            /// 日期
            /// </summary>
            public string rq { get; set; }
            /// <summary>
            /// 账号
            /// </summary>
            public string zh { get; set; }
            /// <summary>
            /// 凭证号
            /// </summary>
            public string pzh { get; set; }
            /// <summary>
            /// 金额
            /// </summary>
            public string je { get; set; }
            /// <summary>
            /// 柜员
            /// </summary>
            public string gy { get; set; }
            /// <summary>
            /// 流水
            /// </summary>
            public string ls { get; set; }
        }

        public void LoadPrintData()
        {
            string FLAG = TellerSystem.ServiceProxy.Ext.ServiceHelper.TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            var entry = PrintData as Print_CashCheckInfoentry;
            if (entry == null)
                return;
            tb_jyh.SetPrintTextBlock(this.PrintAttribute.TradeModel.Code);
            tb_rq.SetPrintTextBlock(LoginUserInfo.TradeDate);
            tb_zh.SetPrintTextBlock(entry.zh);
            tb_pzh.SetPrintTextBlock(entry.pzh);
            tb_je.SetPrintTextBlock("¥"+entry.je);
            tb_gy.SetPrintTextBlock(LoginUserInfo.TellerNo);
            tb_ls.SetPrintTextBlock(this.PrintAttribute.BusinessTransaction);
            tb_ls1.SetPrintTextBlock(this.PrintAttribute.SerialNumber);

            if (FLAG == "V9"||FLAG=="V11")//汇通,隆丰打印靠下，调整打印位置
            {
                tb_jyh.SetValue(Canvas.TopProperty,175.0);
                tb_rq.SetValue(Canvas.TopProperty, 175.0);
                tb_zh.SetValue(Canvas.TopProperty, 175.0);
                tb_pzh.SetValue(Canvas.TopProperty, 175.0);
                tb_je.SetValue(Canvas.TopProperty, 196.0);
                tb_gy.SetValue(Canvas.TopProperty, 196.0);
                tb_ls.SetValue(Canvas.TopProperty, 196.0);
                tb_ls1.SetValue(Canvas.TopProperty, 196.0);
                if (FLAG == "V9")
                {
                    BZ1.Visibility = Visibility.Visible;
                }
            }
            if (FLAG == "V19")//天山 现金支票打印数据打印在现金支票背面上部
            {
                tb_jyh.SetValue(Canvas.TopProperty, 21.0);
                tb_rq.SetValue(Canvas.TopProperty, 21.0);
                tb_zh.SetValue(Canvas.TopProperty, 21.0);
                tb_pzh.SetValue(Canvas.TopProperty, 21.0);
                tb_je.SetValue(Canvas.TopProperty, 43.0);
                tb_gy.SetValue(Canvas.TopProperty, 43.0);
                tb_ls.SetValue(Canvas.TopProperty, 43.0);
                tb_ls1.SetValue(Canvas.TopProperty, 43.0);
            }
            //融丰现金支票 增加电子印章
            if (FLAG == "V12" || FLAG == "V22")
            {
                this.E_Seal_Location = new Point(390, 95);
            }
            if (FLAG == "V11")
            {
                this.E_Seal_Location = new Point(246, 50);
            }
            if (FLAG == "V21")
            {
                this.E_Seal_Location = new Point(390, 130);
            }
        }
    }
}
