﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TellerSystem.Contract.Entry;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Library.Ext.Function;
namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Print_CashPaymentNote.xaml 的交互逻辑
    /// </summary>
    public partial class Print_CashPaymentNote : IPrintContract
    {
        public Print_CashPaymentNote(Print_CashPaymentNoteEntry entry)
        {
            InitializeComponent();
            PrintData = entry;

        }
        public Contract.Entry.PrintEntry PrintData
        {
            get;
            private set;
        }

        string Flag = TellerSystem.ServiceProxy.Ext.ServiceHelper.TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");

        public class Print_CashPaymentNoteEntry : PrintEntry
        {
            /// <summary>
            /// 收款人开户行
            /// </summary>
            public string PayeeBrNo { get; set; }
            /// <summary>
            /// 收款人账号
            /// </summary>
            public string PayeeAccount { get; set; }
            /// <summary>
            /// 收款人全称
            /// </summary>
            public string PayeeName { get; set; }
            /// <summary>
            /// 交易金额
            /// </summary>
            public decimal Amount { get; set; }
            /// <summary>
            /// 备注
            /// </summary>
            public string Remarks { get; set; }
            /// <summary>
            /// 币种
            /// </summary>
            public string Bz { get; set; }
            /// <summary>
            /// 保证金存款打印
            /// </summary>
            public bool IsCunkuan = false;
        }
        public void LoadPrintData()
        {

            //解析日期
            var date = DateTime.ParseExact(LoginUserInfo.TradeDate, "yyyyMMdd", null);
            var time = DateTime.ParseExact(LoginUserInfo.GetUserInfo("TradeTime"), "HHmmss", null);
            var entry = PrintData as Print_CashPaymentNoteEntry;
            TB_PAYEE_BR_NAME.SetPrintTextBlock(entry.PayeeBrNo);// 收款人开户行
            TB_ACCOUNT_NO.SetPrintTextBlock(entry.PayeeAccount);// 收款人账号
            TB_ACCOUNT_NAME.Text = entry.PayeeName;// 收款人全称
            var type = UserFunction.ChangeMoneySymbol(entry.Bz);
            TB_AMOUNT.SetPrintTextBlock(type + entry.Amount.ToString("N2"));// 交易金额 
            TB_REMARKS.SetPrintTextBlock(entry.Remarks);//备注
            if (entry.IsCunkuan)
            {
                XZBZ.Visibility = Visibility.Visible;
            }
            else
            {
                XZBZ.Visibility = Visibility.Hidden;
            }
            XZBZ.SetPrintTextBlock("现金");
            //公共信息
            TB_BR_NAME.SetPrintTextBlock(LoginUserInfo.KinbrName);//机构名称
            TB_TRADE_NAME.SetPrintTextBlock(this.PrintAttribute.TradeModel.Name + "(" + this.PrintAttribute.TradeModel.Code + ")");//交易名称
            TB_TRADE_DATE.Text = (string.Format("{0} {1}", date.ToString("yyyy-MM-dd"), time.ToString("HH:mm:ss")));//交易日期
            //TBL_year.Text = date.ToString("yyyy");
            //TBL_month.Text = date.ToString("MM");
            //TBL_date.Text = date.ToString("dd");
            TB_YWLS.SetPrintTextBlock(this.PrintAttribute.BusinessTransaction);//业务流水    
            TB_SQGY.SetPrintTextBlock(this.PrintAttribute.Authentic);//授权柜员号    
            TB_FHGY.SetPrintTextBlock(this.PrintAttribute.Review);//复核柜员号    
            TB_TELLER_NO.SetPrintTextBlock(string.Format("{0}({1})", LoginUserInfo.TellerName, LoginUserInfo.TellerNo));//经办柜员号    
            TB_SERIAL.SetPrintTextBlock(this.PrintAttribute.SerialNumber);//流水号   
            if (Flag == "V18" || Flag == "V17")
            {
                this.E_Seal_Location = new Point(540, 333);
            }
        }
    }
}
