﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TellerSystem.Contract.Entry;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Library.Ext.Function;
namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Print_CashPaymentNoteFund.xaml 的交互逻辑
    /// </summary>
    public partial class Print_CashPaymentNoteFund : IPrintContract
    {
        public Print_CashPaymentNoteFund(Print_CashPaymentNoteFundEntry entry)
        {
            InitializeComponent();
            PrintData = entry;

        }
        public Contract.Entry.PrintEntry PrintData
        {
            get;
            private set;
        }
        public class Print_CashPaymentNoteFundEntry : PrintEntry
        {   
           /// <summary>
           /// 交易代码
           /// </summary>
            public string JYDM { get; set; }
            /// <summary>
            /// 交易名称
            /// </summary>
            public string JYMC { get; set; }
            /// <summary>
            /// 业务宗号
            /// </summary>
            public string YWZH { get; set; }
            /// <summary>
            /// 专户账号
            /// </summary>
            public string ZHZH { get; set; }
            /// <summary>
            /// 缴存金额
            /// </summary>
            public string JCJE { get; set; }
            /// <summary>
            /// 收款户名
            /// </summary>
            public string SKHM { get; set; }
            /// <summary>
            /// 平台流水
            /// </summary>
            public string PTLS { get; set; } 
            /// <summary>
            /// 核心流水
            /// </summary>
            public string HXLS { get; set; }
            /// <summary>
            /// 分录
            /// </summary>
            public string ACDTL { get; set; }
        }
        public void LoadPrintData()
        {
             
            var entry = PrintData as Print_CashPaymentNoteFundEntry;

            JGMC.SetPrintTextBlock(LoginUserInfo.KinbrName);
            JYDM.SetPrintTextBlock(entry.JYDM);
            JYMC.SetPrintTextBlock(entry.JYMC);
            YWZH.SetPrintTextBlock(entry.YWZH);
            ZHZH.SetPrintTextBlock(entry.ZHZH);
            JCJE.SetPrintTextBlock(entry.JCJE);
            SKHM.SetPrintTextBlock(entry.SKHM);
            PTLS.SetPrintTextBlock(entry.PTLS);
            JZRY.SetPrintTextBlock(LoginUserInfo.TellerNo);
            HXLS.SetPrintTextBlock(entry.HXLS);
            JYRQ.SetPrintTextBlock(LoginUserInfo.TradeDate);
            ACDTL.Text = entry.ACDTL;
            TB_SQGY.SetPrintTextBlock(this.PrintAttribute.Authentic);//授权柜员号    
            TB_FHGY.SetPrintTextBlock(this.PrintAttribute.Review);//复核柜员号    
            TB_TELLER_NO.SetPrintTextBlock(string.Format("{0}({1})", LoginUserInfo.TellerName, LoginUserInfo.TellerNo));//经办柜员号    

        }
    }
}
