﻿/*****************************************************************************************
系统名     综合业务系统2.0
2016年12月1日新增淇县鹤银村镇银行现金缴款单打印模版
add by wangheng 
*****************************************************************************************/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TellerSystem.Contract.Entry;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Library.Ext.Function;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Print_CashPaymentNoteQX.xaml 的交互逻辑
    /// </summary>
    public partial class Print_CashPaymentNoteQX : IPrintContract
    {
        public Print_CashPaymentNoteQX(Print_CashPaymentNoteQXEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }
        public Contract.Entry.PrintEntry PrintData
        {
            get;
            private set;
        }
        public class Print_CashPaymentNoteQXEntry : PrintEntry
        {
            /// <summary>
            /// 收款账号
            /// </summary>
            public string PayeeAccount { get; set; }
            /// <summary>
            /// 收款户名
            /// </summary>
            public string PayeeName { get; set; }
            /// <summary>
            /// 交易金额
            /// </summary>
            public string Amount { get; set; }
            /// <summary>
            /// 收款人开户行
            /// </summary>
            public string branchNo { get; set; }
            /// <summary>
            /// 摘    要
            /// </summary>
            public string Digest { get; set; }
            /// <summary>
            /// 证件类型
            /// </summary>
            public string zjlx { get; set; }
            /// <summary>
            /// 证件号码
            /// </summary>
            public string zjhm { get; set; }
            /// <summary>
            /// 姓    名
            /// </summary>
            public string hm { get; set; }
            /// <summary>
            /// 账户类型
            /// </summary>
            public string zhlx { get; set; }
        }
        public void LoadPrintData()
        {
            var entry = PrintData as Print_CashPaymentNoteQXEntry;    
            tbSKZH.SetPrintTextBlock(entry.PayeeAccount);// 收款账号
            tbSKHM.SetPrintTextBlock(entry.PayeeName);// 收款户名
            tbJYJE.SetPrintTextBlock(entry.Amount);// 交易金额
            ////公共信息
            #region 公共信息
            //解析日期
            var date = LoginUserInfo.TradeDate;
            Year.Text = date.Substring(0, 4);
            Month.Text = date.Substring(4, 2);
            Day.Text = date.Substring(6, 2);
            tbJYJG.SetPrintTextBlock(LoginUserInfo.KinbrName);//机构名称
            tbJYMC.SetPrintTextBlock(this.PrintAttribute.TradeModel.Name);//交易名称
            tbJYDM.SetPrintTextBlock(this.PrintAttribute.TradeModel.Code);//交易代码
            tbGYLS.SetPrintTextBlock(this.PrintAttribute.SerialNumber);//柜员流水
            tbYWLS.SetPrintTextBlock(this.PrintAttribute.BusinessTransaction);//业务流水
            if (!string.IsNullOrEmpty(this.PrintAttribute.Authentic))
            {
                tbSQGY.Text = (this.PrintAttribute.Authentic);//授权柜员号  
            }
            else
            {
                tbSQGY.Text = "";
            }
            //TB_FHGY.SetPrintTextBlock(this.PrintAttribute.Review);//复核柜员号    
            tbJBGY.Text = (string.Format("{0}({1})", LoginUserInfo.TellerName, LoginUserInfo.TellerNo));//经办柜员号
            #endregion 公共信息

            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            if (FLAG == "V21")
            {
                AcbranchNo.Visibility = tb_Digest.Visibility = tb_zhlx.Visibility = TB_QZ.Visibility = Visibility.Visible;
                AcbranchNo.SetPrintTextBlock(entry.branchNo);//收款人开户行
                tb_Digest.SetPrintTextBlock(entry.Digest);//摘    要
                tb_zjlx.SetPrintTextBlock(entry.zjlx);//证件类型
                tb_zjhm.SetPrintTextBlock(entry.zjhm);//证件号码
                tb_hm.SetPrintTextBlock(entry.hm);//姓    名
                tb_zhlx.SetPrintTextBlock(entry.zhlx);//账户类型
                if (!string.IsNullOrEmpty(entry.zjhm))
                {
                    tb_zjlx.Visibility = tb_zjhm.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrEmpty(entry.hm))
                {
                    tb_hm.Visibility = Visibility.Visible;
                }
                foreach (var item in PYL.Children)
                {
                    TextBlock t = item as TextBlock;
                    if (t == null)
                    {
                        break;
                    }
                    var top = Canvas.GetTop(t);
                    var left = Canvas.GetLeft(t);
                    t.SetValue(Canvas.TopProperty, top - 110);
                    t.SetValue(Canvas.LeftProperty, left - 40);
                }
                tbJBGY.SetValue(Canvas.TopProperty, 370.00);//经办
                tbSQGY.SetValue(Canvas.TopProperty, 370.00);//授权
                Year.SetValue(Canvas.TopProperty, 47.00);
                Month.SetValue(Canvas.TopProperty, 47.00);
                Day.SetValue(Canvas.TopProperty, 47.00);
                Year.SetValue(Canvas.LeftProperty, 320.00);
                Month.SetValue(Canvas.LeftProperty, 373.00);
                Day.SetValue(Canvas.LeftProperty, 412.00);

                AcbranchNo.SetValue(Canvas.TopProperty, 98.00);//开户行
                tbJYJG.SetValue(Canvas.TopProperty, 70.00);
                tbJYDM.SetValue(Canvas.TopProperty, 70.00);
                tbJYMC.SetValue(Canvas.TopProperty, 70.00);

                this.E_Seal_Location = new Point(520, 120);
            }
            else if (FLAG == "V22")
            {
                foreach (var item in PYL.Children)
                {
                    TextBlock t = item as TextBlock;
                    if (t == null)
                    {
                        break;
                    }
                    var top = Canvas.GetTop(t);
                    t.SetValue(Canvas.TopProperty, top - 15);
                }

                this.E_Seal_Location = new Point(520, 160);
                BZ.Visibility = Visibility.Visible;
            }
            if (FLAG == "V21" || FLAG == "V22")
            {
                DocumentName = "现金缴款单";
            }
        }
    }
}
