﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TellerSystem.Contract.Entry;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Library.Ext.Function;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Print_CashPaymentNoteSlipSlip.xaml 的交互逻辑
    /// </summary>
    public partial class Print_CashPaymentNoteSlipTwo : IPrintContract
    {
        public Print_CashPaymentNoteSlipTwo(Print_CashPaymentNoteSlipTwoEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }
        public Contract.Entry.PrintEntry PrintData
        {
            get;
            private set;
        }
        public class Print_CashPaymentNoteSlipTwoEntry : PrintEntry
        {
            /// <summary>
            ///交易代码
            /// </summary>
            //   public string TradeNo { get; set; }
            /// <summary>
            /// 存入账号
            /// </summary>
            public string PayeeAccount { get; set; }
            /// <summary>
            /// 户名
            /// </summary>
            public string PayeeName { get; set; }
            /// <summary>
            /// 金额
            /// </summary>
            public decimal Amount { get; set; }
            /// <summary>
            /// 柜员
            /// </summary>
            //       public string Teller { get; set; }
            /// <summary>
            /// 柜员流水
            /// </summary>
            //       public string SerialNo { get; set; }
        }
        public void LoadPrintData()
        {

            //解析日期
            //var date = DateTime.ParseExact(LoginUserInfo.TradeDate, "yyyyMMdd", null);
            //var time = DateTime.ParseExact(LoginUserInfo.GetUserInfo("TradeTime"), "HHmmss", null);
            var entry = PrintData as Print_CashPaymentNoteSlipTwoEntry;
            TB_TRADE_CODE.SetPrintTextBlock(this.PrintAttribute.TradeModel.Code);// 交易代码     
            TB_ACCOUNT_NO.SetPrintTextBlock(entry.PayeeAccount);// 存入账号
            TB_ACCOUNT_NAME.SetPrintTextBlock(entry.PayeeName);// 存入账号
            TB_BR_NAME.SetPrintTextBlock(LoginUserInfo.TellerNo);// 存入账号
           // TB_ACCOUNT_NAME.Text = entry.PayeeName;// 户名
            //TB_BR_NAME.Text = LoginUserInfo.TellerNo;
            //var type = UserFunction.ChangeMoneySymbol(entry.Bz);
            TB_AMOUNT.SetPrintTextBlock(entry.Amount.ToString("N2"));// 交易金额 
            TB_SERIAL.SetPrintTextBlock(this.PrintAttribute.SerialNumber);//流水号  
            TB_DATE.SetPrintTextBlock(LoginUserInfo.TradeDate);
            ////公共信息
            //TB_BR_NAME.SetPrintTextBlock(LoginUserInfo.KinbrName);//机构名称
            //TB_TRADE_NAME.SetPrintTextBlock(this.PrintAttribute.TradeModel.Name + "(" + this.PrintAttribute.TradeModel.Code + ")");//交易名称
            //TB_TRADE_DATE.Text = (string.Format("{0} {1}", date.ToString("yyyy-MM-dd"), time.ToString("HH:mm:dd")));//交易日期
            ////TBL_year.Text = date.ToString("yyyy");
            ////TBL_month.Text = date.ToString("MM");
            ////TBL_date.Text = date.ToString("dd");
            //TB_YWLS.SetPrintTextBlock(this.PrintAttribute.BusinessTransaction);//业务流水    
            //TB_SQGY.SetPrintTextBlock(this.PrintAttribute.Authentic);//授权柜员号    
            //TB_FHGY.SetPrintTextBlock(this.PrintAttribute.Review);//复核柜员号    
            //TB_TELLER_NO.SetPrintTextBlock(string.Format("{0}({1})", LoginUserInfo.TellerName, LoginUserInfo.TellerNo));//经办柜员号    

        }
    }
}
