﻿using System;
using System.Globalization;
using System.Windows;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using System.Windows.Media.Imaging;
using TellerSystem.Communication;
using TellerSystem.Communication.MessageHelper;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;
using TellerSystem.PrintTemplate.ElecSeal;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    ///本票
    /// </summary>
    public partial class Print_CounterfeitMoneyVoucher : IPrintContract
    {
        public Print_CounterfeitMoneyVoucher(Print_CounterfeitMoneyVoucherEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public Contract.Entry.PrintEntry PrintData
        {
            get;
            private set;
        }

        public class Print_CounterfeitMoneyVoucherEntry : PrintEntry
        {
            /// <summary>
            /// 年
            /// </summary>
            public string TB_Date_Year;
            /// <summary>
            /// 月
            /// </summary>
            public string Month;
            /// <summary>
            /// 日
            /// </summary>
            public string Day;
            /// <summary>
            /// 卷别
            /// </summary>
            public string JB;
            /// <summary>
            /// 版别
            /// </summary>
            public string BB;
            /// <summary>
            /// 列表
            /// </summary>
            public string tb_list;
            /// <summary>
            /// 数量
            /// </summary>
            public string SL;
            /// <summary>
            /// 面额
            /// </summary>
            public string ME;
            /// <summary>
            /// 备注
            /// </summary>
            public string BZ;
            /// <summary>
            /// 持有人姓名
            /// </summary>
            public string HM;
            /// <summary>
            /// 证件号码
            /// </summary>
            public string ZJHM;
            /// <summary>
            /// 经办员
            /// </summary>
            public string JBY;
            /// <summary>
            /// 复核
            /// </summary>
            public string FH;
            /// <summary>
            /// 编号
            /// </summary>
            public string BH;
            /// <summary>
            /// 假币来源
            /// </summary>
            public string JBLY;
            /// <summary>
            /// 伪造方法
            /// </summary>
            public string WZFF;

            /// <summary>
            /// 复核柜员名称
            /// </summary>
            public string FHName;

        }
    
        public void LoadPrintData()
        {
            var date = LoginUserInfo.TradeDate.ToDateTime();
         
            var entry = PrintData as Print_CounterfeitMoneyVoucherEntry;
            TB_Date_Year.Text = date.Year.ToString();
            Month.Text = date.Month.ToString();
            Day.Text = date.Day.ToString();
            this.JB.Text = entry.JB;
            this.BB.Text = entry.BB;
            this.tb_list.Text = entry.tb_list;
            this.SL.Text = entry.SL;
            this.ME.Text = entry.ME;
            this.ZJHM.Text = entry.ZJHM;
            this.JBY.Text = string.Format("{1}({0})",LoginUserInfo.TellerNo,LoginUserInfo.TellerName);
            this.FH.Text = string.IsNullOrEmpty(entry.FH) ? "" : string.Format("{1}({0})", entry.FH,entry.FHName);
            this.CYR.Text = entry.HM;
            this.BH.Text = entry.BH;
            this.BZ.SetPrintTextBlock(entry.JBLY);
            this.ZZFF.SetPrintTextBlock(entry.WZFF);
            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            //青隆电子签章
            if (FLAG == "V5")
            {
                this.ElecSealHelper.Sign2Point(new Point(102, 40), SealKind.Biz);
            }
            else
            {
                //电子印章
                this.E_Seal_Location = new Point(102, 40);
            }

        }
    }
}