﻿using System;
using System.Globalization;
using System.Windows;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using System.Windows.Media.Imaging;
using System.Windows.Controls;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Print_CounterfeitMoneyVoucher_New.xaml 的交互逻辑
    /// </summary>
    public partial class Print_CounterfeitMoneyVoucher_New : IPrintContract
    {
        public Print_CounterfeitMoneyVoucher_New(Print_CounterfeitMoneyVoucher_NewEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }
        public Contract.Entry.PrintEntry PrintData
        {
            get;
            private set;
        }

        public class Print_CounterfeitMoneyVoucher_NewEntry : PrintEntry
        {
            /// <summary>
            /// 年
            /// </summary>
            public string TB_Date_Year;
            /// <summary>
            /// 月
            /// </summary>
            public string Month;
            /// <summary>
            /// 日
            /// </summary>
            public string Day;
            /// <summary>
            /// 列表
            /// </summary>
            public string tb_list;
            /// <summary>
            /// 数量
            /// </summary>
            public string SL;
            /// <summary>
            /// 面额
            /// </summary>
            public string ME;
            /// <summary>
            /// 经办员
            /// </summary>
            public string JBY;
            /// <summary>
            /// 复核
            /// </summary>
            public string FH;
            /// <summary>
            /// 编号
            /// </summary>
            public string BH;
            /// <summary>
            /// 复核柜员名称
            /// </summary>
            public string FHName;

            public string KHLX;//个人1 对公2
            public string NAME_GR;
            public string TELNO1;
            public string ZJLX_GR;
            public string ZJHM_GR;

            public string DWName;
            public string dwjbrName;
            public string TELNO2;
            public string ZJLX_DG;
            public string ZJHM_DG;
            
        }

        public void LoadPrintData()
        {
            string flag = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            var date = LoginUserInfo.TradeDate.ToDateTime();

            var entry = PrintData as Print_CounterfeitMoneyVoucher_NewEntry;
            TB_Date_Year.Text = date.Year.ToString();
            Month.Text = date.Month.ToString();
            Day.Text = date.Day.ToString();

            if (entry.KHLX == "1")//个人
            {
                GR_Name.Text = entry.NAME_GR;
                TEL1.Text = entry.TELNO1;
                ZJLX1.Text = entry.ZJLX_GR;
                ZJHM1.Text = entry.ZJHM_GR;
                CYR2_Name.Visibility = DQJBRName.Visibility = TEL2.Visibility = ZJLX2.Visibility = ZJHM2.Visibility = Visibility.Collapsed;
            }
            else //对公
            {
                CYR2_Name.Text = entry.DWName;
                DQJBRName.Text = entry.dwjbrName;
                TEL2.Text = entry.TELNO2;
                ZJLX2.Text = entry.ZJLX_DG;
                ZJHM2.Text = entry.ZJHM_DG;
                GR_Name.Visibility = TEL1.Visibility = ZJLX1.Visibility = ZJHM1.Visibility = Visibility.Collapsed;
            }

            this.tb_list.Text = entry.tb_list;
            this.SL.Text = entry.SL;
            this.ME.Text = entry.ME;
            this.JBY.Text = string.Format("{1}({0})", LoginUserInfo.TellerNo, LoginUserInfo.TellerName);
            this.FH.Text = string.IsNullOrEmpty(entry.FH) ? "" : string.Format("{1}({0})", entry.FH, entry.FHName);
            this.BH.Text = entry.BH;
            this.DATE.Text = LoginUserInfo.TradeDate;

            if (flag == "V10") //莱山
            {
                TB_Date_Year.SetValue(Canvas.TopProperty, 79.00);
                TB_Date_Year.SetValue(Canvas.LeftProperty, 288.00);
                Month.SetValue(Canvas.TopProperty, 79.00);
                Month.SetValue(Canvas.LeftProperty, 358.00);
                Day.SetValue(Canvas.TopProperty, 79.00);
                Day.SetValue(Canvas.LeftProperty, 397.00);
                BH.SetValue(Canvas.TopProperty, 79.00);
                BH.SetValue(Canvas.LeftProperty, 577.00);

                GR_Name.SetValue(Canvas.TopProperty, 154.00);
                GR_Name.SetValue(Canvas.LeftProperty, 205.00);
                TEL1.SetValue(Canvas.TopProperty, 154.00);
                ZJLX1.SetValue(Canvas.TopProperty, 191.00);
                ZJLX1.SetValue(Canvas.LeftProperty, 241.00);
                ZJHM1.SetValue(Canvas.TopProperty, 191.00);

                CYR2_Name.SetValue(Canvas.TopProperty, 231.00);
                DQJBRName.SetValue(Canvas.TopProperty, 265.00);
                TEL2.SetValue(Canvas.TopProperty, 265.00);
                ZJLX2.SetValue(Canvas.TopProperty, 302.00);
                ZJHM2.SetValue(Canvas.TopProperty, 302.00);

                tb_list.SetValue(Canvas.TopProperty, 427.00);
                DATE.SetValue(Canvas.TopProperty, 700.00);
                JBY.SetValue(Canvas.TopProperty, 750.00);
                FH.SetValue(Canvas.TopProperty, 750.00);
            }
            if (flag == "V13")//芝罘
            {
                TB_Date_Year.SetValue(Canvas.TopProperty, 99.00);
                TB_Date_Year.SetValue(Canvas.LeftProperty, 288.00);
                Month.SetValue(Canvas.TopProperty, 99.00);
                Month.SetValue(Canvas.LeftProperty, 358.00);
                Day.SetValue(Canvas.TopProperty, 99.00);
                Day.SetValue(Canvas.LeftProperty, 397.00);
                BH.SetValue(Canvas.TopProperty, 99.00);
                BH.SetValue(Canvas.LeftProperty, 590.00);

                GR_Name.SetValue(Canvas.TopProperty, 174.00);
                GR_Name.SetValue(Canvas.LeftProperty, 205.00);
                TEL1.SetValue(Canvas.TopProperty, 174.00);
                ZJLX1.SetValue(Canvas.TopProperty, 211.00);
                ZJLX1.SetValue(Canvas.LeftProperty, 241.00);
                ZJHM1.SetValue(Canvas.TopProperty, 211.00);

                CYR2_Name.SetValue(Canvas.TopProperty, 251.00);
                DQJBRName.SetValue(Canvas.TopProperty, 285.00);
                TEL2.SetValue(Canvas.TopProperty, 285.00);
                ZJLX2.SetValue(Canvas.TopProperty, 322.00);
                ZJHM2.SetValue(Canvas.TopProperty, 322.00);

                tb_list.SetValue(Canvas.TopProperty, 447.00);
                DATE.SetValue(Canvas.TopProperty, 720.00);
                JBY.SetValue(Canvas.TopProperty, 760.00);
                FH.SetValue(Canvas.TopProperty, 760.00);
            }
            if (flag == "V5")//青隆
            {
                TB_Date_Year.SetValue(Canvas.TopProperty, 181.00);
                Month.SetValue(Canvas.TopProperty, 181.00);
                Day.SetValue(Canvas.TopProperty, 181.00);
                BH.SetValue(Canvas.TopProperty, 181.00);
            }
            if (flag == "V8")
            {
                TB_Date_Year.SetValue(Canvas.TopProperty, 110.00);
                Month.SetValue(Canvas.TopProperty, 110.00);
                Day.SetValue(Canvas.TopProperty, 110.00);
                BH.SetValue(Canvas.TopProperty, 110.00);
                GR_Name.SetValue(Canvas.TopProperty, 170.00);
                TEL1.SetValue(Canvas.TopProperty, 170.00);
                ZJLX1.SetValue(Canvas.TopProperty, 215.00);
                ZJHM1.SetValue(Canvas.TopProperty, 215.00);
                CYR2_Name.SetValue(Canvas.TopProperty, 255.00);
                DQJBRName.SetValue(Canvas.TopProperty, 285.00);
                TEL2.SetValue(Canvas.TopProperty, 285.00);
                ZJLX2.SetValue(Canvas.TopProperty, 320.00);
                ZJHM2.SetValue(Canvas.TopProperty, 320.00);
                tb_list.SetValue(Canvas.TopProperty, 435.00);
                SL.SetValue(Canvas.TopProperty, 605.00);
                ME.SetValue(Canvas.TopProperty, 605.00);
            }
        }
    }
}