﻿using System;
using System.Globalization;
using System.Windows;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using System.Windows.Controls.Primitives;
using System.Data;
using System.Linq;
using System.Collections;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    ///本票
    /// </summary>
    public partial class Print_DataTable : IPrintContract
    {
        private const int _maxCount = 10;

        public Print_DataTable(Print_DataTableEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public Contract.Entry.PrintEntry PrintData
        {
            get;
            private set;
        }

        public class Print_DataTableEntry : PrintEntry
        {
            /// <summary>
            /// 表头区域
            /// </summary>
            public string Header { get; set; }

            /// <summary>
            /// 列表数据
            /// </summary>
            public DataTable Table { get; set; }

            /// <summary>
            /// 表尾区域
            /// </summary>
            public string Footer { get; set; }
        }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_DataTableEntry;
            if (entry == null || entry.Table == null) return;
            entry.IsBatchPrint = true;
            entry.BatchList = new System.Collections.Generic.List<Platform.Print.PrintContainer>();
            //拆解数据
            DataTable table = entry.Table.Clone();
            table.Rows.Clear();
            for (int i = 0; i < entry.Table.Rows.Count; i++)
            {
                table.Rows.Add(entry.Table.Rows[i].ItemArray);
                if (i % _maxCount == _maxCount - 1)
                {
                    var print = new Print_DataTable(entry);
                    print.TB_Header.Text = entry.Header;
                    print.TB_Footer.Text = entry.Footer;
                    print.DG_Table.ItemsSource = table.DefaultView;
                    entry.BatchList.Add(print);
                    table = entry.Table.Clone();
                    table.Rows.Clear();
                }
            }
            if (table.Rows.Count > 0)
            {
                var print = new Print_DataTable(entry);
                print.TB_Header.Text = entry.Header;
                print.TB_Footer.Text = entry.Footer;
                print.DG_Table.ItemsSource = table.DefaultView;
                entry.BatchList.Add(print);
            }
        }
    }
}