﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Contract.Function;
using TellerSystem.Communication;
using TellerSystem.Communication.MessageHelper;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Interaction logic for Print_PersonalAccountingVoucher_Deposit.xaml
    /// </summary>
    public partial class Print_DepositMoney_YG : IPrintContract
    {

        public Print_DepositMoney_YG(Print_PersonalAccountingVoucher_DepositEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }
        string Flag = TellerSystem.ServiceProxy.Ext.ServiceHelper.TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        public class Print_PersonalAccountingVoucher_DepositEntry : PrintEntry
        {
            public Print_PersonalAccountingVoucher_DepositEntry()
            {
                //默认带有介质
                HasJZ = true;
                //默认显示"是否带介质"
                DisplayHasJZ = true;
            }

            /// <summary>
            /// 银行留存联账号
            /// </summary>
            public string Acno { get; set; }
            /// <summary>
            /// 客户回单账户
            /// </summary>
            public string Acno1 { get; set; }

            /// <summary>
            /// 账户序号
            /// </summary>
            public string ZHXH { get; set; }

            /// <summary>
            /// 开户行名
            /// </summary>
            public string OpnName { get; set; }

            /// <summary>
            /// 账户户名
            /// </summary>
            public string ZHHM { get; set; }

            /// <summary>
            /// 交易金额
            /// </summary>
            public decimal TxAmt { get; set; }

            /// <summary>
            /// 账户余额
            /// </summary>
            public string tbAccount { get; set; }

            /// <summary>
            /// 余额
            /// </summary>
            public decimal Bal { get; set; }
            /// <summary>
            /// 利率
            /// </summary>
            public string Rate { get; set; }

            /// <summary>
            /// 储种
            /// </summary>
            public string PrdtName { get; set; }

            /// <summary>
            /// 存期
            /// </summary>
            // public string Term { get; set; }

            /// <summary>
            /// 凭证号码
            /// </summary>
            public string NoteNo { get; set; }

            /// <summary>
            /// 科目
            /// </summary>
            public string Subject { get; set; }

            /// <summary>
            /// 是否带介质
            /// </summary>
            public bool HasJZ { get; set; }

            /// <summary>
            /// 是否显示"是否带介质"
            /// </summary>
            public bool DisplayHasJZ { get; set; }

            /// <summary>
            /// 现转标志
            /// </summary>
            public string CtInd { get; set; }

            /// <summary>
            /// 交易类型
            /// </summary>
            public string TradeType { get; set; }

            /// <summary>
            /// 对方账号
            /// </summary>
            public string DfAcno { get; set; }

            /// <summary>
            /// 对方户名
            /// </summary>
            public string DfAcname { get; set; }

            /// <summary>
            /// 币种
            /// </summary>
            public string BZ { get; set; }
            /// <summary>
            /// 流水号
            /// </summary>
            public string LSH { get; set; }
            /// <summary>
            /// 表头
            /// </summary>
            public string Title { get; set; }
            /// <summary>
            /// 留密户
            /// </summary>
            public string Lmh { get; set; }
            /// <summary>
            ///自动转存
            /// </summary>
            public string ZDZC { get; set; }
            /// <summary>
            /// 通存标志
            /// </summary>
            public string TCBZ { get; set; }
            /// <summary>
            /// 账户类型
            /// </summary>
            public string PZHLX { get; set; }

        }

        #region IPrintContract Members

        public Contract.Entry.PrintEntry PrintData { get; private set; }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_PersonalAccountingVoucher_DepositEntry;
            if (entry == null)
                return;
            TB_title.Text = entry.Title;
            switch (entry.TCBZ[4].ToString().Trim())
            {
                case "0":
                    TB_TCBZ.SetPrintTextBlock("非通存通兑");
                    break;
                case "1":
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
                case "2":
                    TB_TCBZ.SetPrintTextBlock("通存非通兑");
                    break;
                default:
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
            }
            TB_OPNNAME.SetPrintTextBlock(entry.OpnName);
            TB_Acno1.SetPrintTextBlock(entry.Acno);
            //TB_Acno2.SetPrintTextBlock(entry.Acno);
            if (entry.Acno1 != null)
            {
                if (Flag == "V12" )
                {
                    if (entry.Acno1.Length >= 8)
                    {
                        string acno = entry.Acno1.Trim();
                        string acnoTemp = acno.Substring(0, acno.Length - 8) + "****" + acno.Substring(acno.Length - 4);
                        TB_Acno2.SetPrintTextBlock(acnoTemp);
                    }
                }
                else
                {
                    TB_Acno2.SetPrintTextBlock(entry.Acno1);
                }
            }
            else
            {
                if (Flag == "V12")
                {
                    if (entry.Acno != null && entry.Acno.Length >= 8)
                    {
                        string acno = entry.Acno.Trim();
                        string acnoTemp = acno.Substring(0, acno.Length - 8) + "****" + acno.Substring(acno.Length - 4);
                        TB_Acno2.SetPrintTextBlock(acnoTemp);
                    }
                }
                else
                {
                    TB_Acno2.SetPrintTextBlock(entry.Acno);
                }
            }

            // TB_ZHXH.SetPrintTextBlock(entry.ZHXH);
            TB_HM1.SetPrintTextBlock(entry.ZHHM);
            TB_HM2.SetPrintTextBlock(entry.ZHHM);
            TB_Note1.SetPrintTextBlock(entry.NoteNo.PadLeft(TellerSystem.Library.Ext.Variables.UserVariable.Len_VoucherNo, '0'));
            var type = UserFunction.ChangeMoneySymbol(entry.BZ);
            TB_TxAmt1.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            TB_TxAmt2.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            if (entry.tbAccount != null)
            {
                tb_Account.Visibility = Visibility.Visible;
                tb_Account.SetPrintTextBlock(type + entry.tbAccount);
            }
            //融丰要求打印存取款凭条左右都有余额显示
            if (Flag == "V12" && entry.tbAccount != null && (!string.IsNullOrEmpty(entry.tbAccount)))
            {
                tb_bal.Visibility = tb_bal2.Visibility = Visibility.Visible;
                tb_bal.SetPrintTextBlock(type + entry.tbAccount);
                tb_bal2.SetPrintTextBlock(type + entry.tbAccount);
            }
            if (entry.PZHLX != null)
            {
                ZHLX.Visibility = Visibility.Visible;
                ZHLX.SetPrintTextBlock(entry.PZHLX);
            }
            if (entry.HasJZ)
            {
                TB_HasMdm1.SetPrintTextBlock("是");
            }
            else
            {
                TB_HasMdm1.SetPrintTextBlock("否");
            }
            TB_HasMdm1.Visibility = entry.DisplayHasJZ ? Visibility.Visible : Visibility.Hidden;

            TB_Prdt1.SetPrintTextBlock(entry.PrdtName);
            TB_Prdt2.SetPrintTextBlock(entry.PrdtName);
            //业务流水
            TB_lsh.SetPrintTextBlock(this.PrintAttribute.SerialNumber);
            //核心流水
            tb_ls.SetPrintTextBlock(this.PrintAttribute.BusinessTransaction);
            //TB_sqy.SetPrintTextBlock(this.PrintAttribute.Authentic);//授权柜员号 
            TB_rq.SetPrintTextBlock(LoginUserInfo.TradeDate);
            //TB_sqy.SetPrintTextBlock(this.PrintAttribute.Authno);//授权柜员号 
            TB_sqy.Text = this.PrintAttribute.Authno;
            //TB_czy.SetPrintTextBlock(LoginUserInfo.TellerNo);
            TB_czy.Text = LoginUserInfo.TellerNo;
            //TB_czy.SetPrintTextBlock("(" + LoginUserInfo.TellerName + ")" + LoginUserInfo.TellerNo);
            TB_jyh.SetPrintTextBlock(LoginUserInfo.KinbrNo);
            //if (string.IsNullOrEmpty(entry.Term))
            //{
            //    TB_Term1.Visibility = Visibility.Hidden;
            //}
            //else
            //{
            //    TB_Term1.SetPrintTextBlock(entry.Term);
            //}
            TB_TradeType1.SetPrintTextBlock(entry.TradeType);
            TB_jylx.SetPrintTextBlock(entry.TradeType);
            TB_CtInd1.SetPrintTextBlock(entry.CtInd);
            // TB_CtInd2.SetPrintTextBlock(entry.CtInd);
            if (string.IsNullOrEmpty(entry.DfAcno))
            {
                TB_DfAcno1.Visibility = Visibility.Hidden;
                TB_DfAcno2.Visibility = Visibility.Hidden;
                TBL_DfAcno2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_DfAcno1.SetPrintTextBlock(entry.DfAcno);
                //融丰要求：客户回单上出现的账号都要倒数5-8位使用*隐藏
                if (Flag == "V12")
                {
                    if (entry.DfAcno.Length >= 8)
                    {
                        string dfacno = entry.DfAcno.Trim();
                        string acnoTemp = dfacno.Substring(0, dfacno.Length - 8) + "****" + dfacno.Substring(dfacno.Length - 4);
                        TB_DfAcno2.SetPrintTextBlock(acnoTemp);
                    }
                }
                else
                {
                    TB_DfAcno2.SetPrintTextBlock(entry.DfAcno);
                }
            }
            if (string.IsNullOrEmpty(entry.DfAcname))
            {
                TB_DfAcname1.Visibility = Visibility.Hidden;
                TB_DfAcname2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_DfAcname1.SetPrintTextBlock(entry.DfAcname);
                TB_DfAcname2.SetPrintTextBlock(entry.DfAcname);
            }
            TB_SFLM.SetPrintTextBlock(entry.Lmh);
            if (!string.IsNullOrEmpty(entry.ZDZC))
            {
                TB_ZDZC.Visibility = TB_ZDZC1.Visibility = Visibility.Visible;
                TB_ZDZC.SetPrintTextBlock(entry.ZDZC);
                TB_ZDZC1.SetPrintTextBlock(entry.ZDZC);
            }
            //公共要素
            var tradedate = LoginUserInfo.TradeDate.ToDateTime();
            TB_Teller2.SetPrintTextBlock(LoginUserInfo.TellerNo);
            TB_Jyra.SetPrintTextBlock(LoginUserInfo.TradeDate);
            if (!string.IsNullOrEmpty(entry.Rate))
            {
                TB_Rate1.SetPrintTextBlock(string.Format("{0:N6}%", entry.Rate));
                TB_Rate2.SetPrintTextBlock(string.Format("{0:N6}%", entry.Rate));
            }
            else
            {
                TB_Rate1.SetPrintTextBlock(string.Empty);
                TB_Rate2.SetPrintTextBlock(string.Empty);
            }
            this.E_Seal_Location = new Point(439,269);
            //阳光打印内容整体向上偏移
            if (Flag == "V8") 
            {
                TB_title.SetValue(Canvas.TopProperty, 58.00);
                TB_Acno1.SetValue(Canvas.TopProperty, 80.00);
                TB_HM1.SetValue(Canvas.TopProperty, 80.00);
                TB_OPNNAME.SetValue(Canvas.TopProperty, 84.00);
                TB_Prdt1.SetValue(Canvas.TopProperty, 96.00);
                TB_Rate1.SetValue(Canvas.TopProperty, 96.00);
                TB_jyh.SetValue(Canvas.TopProperty, 100.00);
                TB_TxAmt1.SetValue(Canvas.TopProperty, 116.00);
                TB_rq.SetValue(Canvas.TopProperty, 116.00);
                TB_TradeType1.SetValue(Canvas.TopProperty, 120.00);
                TB_Note1.SetValue(Canvas.TopProperty, 137.00);
                TB_SFLM.SetValue(Canvas.TopProperty, 137.00);
                TB_ZDZC.SetValue(Canvas.TopProperty, 141.00);
                TB_CtInd1.SetValue(Canvas.TopProperty, 160.00);
                TB_DfAcno1.SetValue(Canvas.TopProperty, 160.00);
                TB_HasMdm1.SetValue(Canvas.TopProperty, 162.00);
                TB_TCBZ.SetValue(Canvas.TopProperty, 179.00);
                TB_DfAcname1.SetValue(Canvas.TopProperty, 179.00);
                tb_bal.SetValue(Canvas.TopProperty, 179.00);
                ZHLX.SetValue(Canvas.TopProperty, 197.00);
                tb_Account.SetValue(Canvas.TopProperty, 220.00);
                tb_ls.SetValue(Canvas.TopProperty, 273.00);
                TB_lsh.SetValue(Canvas.TopProperty, 273.00);
                this.E_Seal_Location = new Point(439, 242);
                //imgSignet.SetValue(Canvas.TopProperty, 242);

                BZ.Visibility = BZ1.Visibility = Visibility.Visible;
            }
            if (Flag == "V12") 
            {
                this.E_Seal2Copy(new Point(665, 364));
            }
        }
        #endregion
    }
}
