﻿using System;
using System.Windows;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using System.Windows.Media.Imaging;
using System.Windows.Controls;
using TellerSystem.Communication;
using TellerSystem.Communication.MessageHelper;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Interaction logic for Print_PersonalAccountingVoucher_Draw.xaml
    /// </summary>
    public partial class Print_DrawMoney_YG : IPrintContract
    {
        public Print_DrawMoney_YG(Print_PersonalAccountingVoucher_DrawEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
            //this.BusinessType = "取款";
        }
        string Flag = TellerSystem.ServiceProxy.Ext.ServiceHelper.TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");

        public class Print_PersonalAccountingVoucher_DrawEntry : PrintEntry
        {

            /// <summary>
            /// 标题
            /// </summary>
            public string Title { get; set; }
            /// <summary>
            /// 银行留存联账号
            /// </summary>
            public string Acno { get; set; }
            /// <summary>
            /// 客户回单账号
            /// </summary>
            public string Acno1 { get; set; }
            /// <summary>
            /// 账户户名
            /// </summary>
            public string ZHHM { get; set; }

            /// <summary>
            /// 开户行名
            /// </summary>
            public string OpnBrno { get; set; }

            /// <summary>
            /// 储种
            /// </summary>
            public string PrdtName { get; set; }

            /// <summary>
            /// 利率
            /// </summary>
            public string Rate { get; set; }

            /// <summary>
            /// 存期
            /// </summary>
            //public string Term { get; set; }

            /// <summary>
            /// 交易金额
            /// </summary>
            public decimal TxAmt { get; set; }
            /// <summary>
            /// 账户余额
            /// </summary>
            public string tbAccount { get; set; }

            /// <summary>
            /// 凭证号码
            /// </summary>
            public string NoteNo { get; set; }

            /// <summary>
            /// 账户类型
            /// </summary>
            public string Zhlx { get; set; }

            /// <summary>
            /// 交易类型
            /// </summary>
            public string TradeType { get; set; }

            /// <summary>
            /// 现转标志
            /// </summary>
            public string CtInd { get; set; }

            /// <summary>
            /// 自动转存
            /// </summary>
            public string ZDZC { get; set; }


            /// <summary>
            /// 对方户名
            /// </summary>
            public string DfAcname { get; set; }


            /// <summary>
            /// 账户介质
            /// </summary>
            public string ZHJZ { get; set; }

            /// <summary>
            /// 银行留存联对方账号
            /// </summary>
            public string DfAcno { get; set; }
            /// <summary>
            /// 客户回单对方账号
            /// </summary>
            public string DfAcno1 { get; set; }
            /// <summary>
            /// 利息
            /// </summary>
            public string Lx { get; set; }
            /// <summary>
            /// 利息税
            /// </summary>
            public string Lxs { get; set; }
            /// <summary>
            /// 实付利息
            /// </summary>
            public string Sflx { get; set; }
            /// <summary>
            /// 实付本息
            /// </summary>
            public string Sfbx { get; set; }

            //结算类型
            public string jslx { get; set; }

            /// <summary>
            /// 通存通兑标志
            /// </summary>
            public string TCBZ { get; set; }
            ///// 余额
            ///// </summary>
            //public decimal Bal { get; set; }

            /*
             *  
             /// <summary>
             /// 账户序号
             /// </summary>
            public string ZHXH { get; set; }
             *   /// <summary>
            /// 余额
            /// </summary>
            public decimal Bal { get; set; }

            /// <summary>
            /// 新凭证号
            /// </summary>
            public string NewNoteNo { get; set; }

            /// <summary>
            /// 科目
            /// </summary>
            public string Subject { get; set; }
             * 
             * */

        }

        #region IPrintContract Members
        public Contract.Entry.PrintEntry PrintData { get; private set; }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_PersonalAccountingVoucher_DrawEntry;
            if (entry == null)
                return;
            TB_title.Text = entry.Title;
            switch (entry.TCBZ[4].ToString().Trim())
            {
                case "0":
                    TB_TCBZ.SetPrintTextBlock("非通存通兑");
                    break;
                case "1":
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
                case "2":
                    TB_TCBZ.SetPrintTextBlock("通存非通兑");
                    break;
                default:
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
            }
            TB_Acno1.SetPrintTextBlock(entry.Acno);
            //TB_Acno2.SetPrintTextBlock(entry.Acno);
            if (entry.Acno1 != null)
            {
                //融丰要求：客户回单上出现的账号都要倒数5-8位使用*隐藏
                if (Flag == "V12")
                {
                    if (entry.Acno1.Length >= 8)
                    {
                        string acno = entry.Acno1.Trim();
                        string acnoTemp = acno.Substring(0, acno.Length - 8) + "****" + acno.Substring(acno.Length - 4);
                        TB_Acno2.SetPrintTextBlock(acnoTemp);
                    }
                }
                else
                {
                    TB_Acno2.SetPrintTextBlock(entry.Acno1);
                }
            }
            else
            {
                if (Flag == "V12")
                {
                    if (entry.Acno != null && entry.Acno.Length >= 8)
                    {
                        string acno = entry.Acno.Trim();
                        string acnoTemp = acno.Substring(0, acno.Length - 8) + "****" + acno.Substring(acno.Length - 4);
                        TB_Acno2.SetPrintTextBlock(acnoTemp);
                    }
                }
                else
                {
                    TB_Acno2.SetPrintTextBlock(entry.Acno);
                }
            }
            TB_HM1.SetPrintTextBlock(entry.ZHHM);
            TB_HM2.SetPrintTextBlock(entry.ZHHM);
            TB_OPNbrno.SetPrintTextBlock(entry.OpnBrno);
            TB_Prdt1.SetPrintTextBlock(entry.PrdtName);
            TB_Prdt2.SetPrintTextBlock(entry.PrdtName);
            if (!string.IsNullOrEmpty(entry.Rate))
            {
                TB_Rate1.SetPrintTextBlock(string.Format("{0:N6}%", entry.Rate));
            }
            else
            {
                TB_Rate1.SetPrintTextBlock(string.Empty);
            }
            //定期部提需要打印介质种类
            if (!string.IsNullOrEmpty(entry.ZHJZ))
            {
                TB_ZHJZ.Visibility = Visibility.Visible;
                TB_ZHJZ.SetPrintTextBlock(entry.ZHJZ);
            }

            TB_lsh.SetPrintTextBlock(this.PrintAttribute.SerialNumber);
            //TB_Term1.SetPrintTextBlock(entry.Term);
            var type = UserFunction.ChangeMoneySymbol("01");
            TB_TxAmt1.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            TB_TxAmt2.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            if (entry.tbAccount != null)
            {
                tb_Account.Visibility = Visibility.Visible;
                tb_Account.SetPrintTextBlock(type + entry.tbAccount);
                if (Flag == "V12")
                {
                    TB_Bal2.Visibility = Visibility.Visible;
                    TB_Bal2.SetPrintTextBlock(type + entry.tbAccount);
                }
            }

            TB_Jyrq.SetPrintTextBlock(LoginUserInfo.TradeDate);
            TB_data.SetPrintTextBlock(LoginUserInfo.TradeDate);
            TB_Note1.SetPrintTextBlock(entry.NoteNo.PadLeft(TellerSystem.Library.Ext.Variables.UserVariable.Len_VoucherNo, '0'));
            TB_Teller2.SetPrintTextBlock(LoginUserInfo.TellerNo);
            TB_Czy.SetPrintTextBlock(LoginUserInfo.TellerNo);
            //TB_Czy.SetPrintTextBlock("(" + LoginUserInfo.TellerName + ")" + LoginUserInfo.TellerNo);
            //TB_Czy.Text = LoginUserInfo.TellerNo;
            if (!string.IsNullOrEmpty(entry.Zhlx))
            {
                TB_Zhlx.Visibility = Visibility.Visible;
                TB_Zhlx.SetPrintTextBlock(entry.Zhlx);
            }
            TB_TradeType.SetPrintTextBlock(entry.TradeType);
            TB_jylx.SetPrintTextBlock(entry.TradeType);
            TB_CtInd1.SetPrintTextBlock(entry.CtInd);
            TB_xzbz.SetPrintTextBlock(entry.CtInd);
            TB_jyh.SetPrintTextBlock(LoginUserInfo.KinbrNo);
            if (!string.IsNullOrEmpty(entry.ZDZC))
            {
                TB_ZDZC.Visibility = Visibility.Visible;
                TB_ZDZC.SetPrintTextBlock(entry.ZDZC);
            }
            if (string.IsNullOrEmpty(entry.DfAcno))
            {
                TB_DfAcno1.Visibility = Visibility.Hidden;
                TBL_DfAcno2.Visibility = Visibility.Hidden;
                TB_DfAcno2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_DfAcno1.SetPrintTextBlock(entry.DfAcno);
                //TB_DfAcno2.SetPrintTextBlock(entry.DfAcno);
                if (entry.DfAcno1 != null)
                {
                    //融丰要求：客户回单上出现的账号都要倒数5-8位使用*隐藏
                    if (Flag == "V12")
                    {
                        if (entry.DfAcno1.Length >= 8)
                        {
                            string dfacno1 = entry.DfAcno1.Trim();
                            string acnoTemp = dfacno1.Substring(0, dfacno1.Length - 8) + "****" + dfacno1.Substring(dfacno1.Length - 4);
                            TB_DfAcno2.SetPrintTextBlock(acnoTemp);
                        }
                    }
                    else
                    {
                        TB_DfAcno2.SetPrintTextBlock(entry.DfAcno1);
                    }
                }
                else
                {
                    if (Flag == "V12")
                    {
                        if (entry.DfAcno.Length >= 8)
                        {
                            string dfacno = entry.DfAcno.Trim();
                            string acnoTemp = dfacno.Substring(0, dfacno.Length - 8) + "****" + dfacno.Substring(dfacno.Length - 4);
                            TB_DfAcno2.SetPrintTextBlock(acnoTemp);
                        }
                    }
                    else
                    {
                        TB_DfAcno2.SetPrintTextBlock(entry.DfAcno);
                    }
                }

            }
            if (string.IsNullOrEmpty(entry.DfAcname))
            {
                TB_DfAcname1.Visibility = Visibility.Hidden;
                TB_DfAcname2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_DfAcname1.SetPrintTextBlock(entry.DfAcname);
                TB_DfAcname2.SetPrintTextBlock(entry.DfAcname);
            }
            if (string.IsNullOrEmpty(entry.Lx))
            {
                TB_Lx.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_Lx.Visibility = Visibility.Visible;
                TB_Lx.SetPrintTextBlock("¥" + entry.Lx);
            }
            //if (string.IsNullOrEmpty(entry.Lxs))
            //{
            //    TB_Lxs.Visibility = Visibility.Hidden;
            //}
            //else
            //{
            //    TB_Lxs.Visibility = Visibility.Visible;
            //    TB_Lxs.SetPrintTextBlock("¥" + entry.Lxs);
            //}
            if (string.IsNullOrEmpty(entry.Sflx))
            {
                TB_Sflx.Visibility = Visibility.Hidden;
                TB_Sflx2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_Sflx.Visibility = Visibility.Visible;
                TB_Sflx.SetPrintTextBlock("¥" + entry.Sflx);
                TB_Sflx2.Visibility = Visibility.Visible;
                TB_Sflx2.SetPrintTextBlock("¥" + entry.Sflx);
            }
            if (string.IsNullOrEmpty(entry.Sfbx))
            {
                TB_SfBx.Visibility = Visibility.Hidden;
                TB_SfBx2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_SfBx.Visibility = Visibility.Visible;
                TB_SfBx.SetPrintTextBlock("¥" + entry.Sfbx);
                TB_SfBx2.Visibility = Visibility.Visible;
                TB_SfBx2.SetPrintTextBlock("¥" + entry.Sfbx);
            }
            //电子印章
            this.E_Seal_Location = new Point(437,285);

            //业务流水
            TB_lsh.SetPrintTextBlock(this.PrintAttribute.SerialNumber);
            //核心流水
            tb_ls.SetPrintTextBlock(this.PrintAttribute.BusinessTransaction);
            //TB_sqy.SetPrintTextBlock(this.PrintAttribute.Authno);//授权柜员号
            TB_sqy.Text = this.PrintAttribute.Authno;
            ////定活两便的利率和自动转存默认是空
            //if (entry.PrdtName.Contains("定活两便"))
            //{
            //    TB_Rate1.SetPrintTextBlock(string.Empty);
            //    TB_ZDZC.SetPrintTextBlock(string.Empty);
            //}

            //if(string.IsNullOrEmpty(entry.TradeType))
            //{
            //    TB_NewNote1.Visibility = Visibility.Hidden;
            //}
            //else
            //{
            //    TB_NewNote1.SetPrintTextBlock(entry.NewNoteNo);
            //}

            // TB_Bal1.SetPrintTextBlock(type + entry.Bal.ToString("N2"));
            //TB_Bal2.SetPrintTextBlock(type + entry.Bal.ToString("N2"));

            // TB_Rate2.SetPrintTextBlock(string.Format("{0:N6}%", entry.Rate));

            //TB_Subject.Text = entry.Subject;
            //if (string.IsNullOrEmpty(entry.Term))
            //{
            //    TB_Term1.Visibility = Visibility.Hidden;
            //    TB_Term2.Visibility = Visibility.Hidden;
            //}
            //else
            //{

            //    TB_Term2.SetPrintTextBlock(entry.Term);
            //}


            //TB_CtInd1.SetPrintTextBlock(entry.CtInd);
            //TB_CtInd2.SetPrintTextBlock(entry.CtInd);

            //  TB_ZHXH.SetPrintTextBlock(entry.ZHXH);
            //公共要素
            //var tradedate = LoginUserInfo.TradeDate.ToDateTime();          
            //TB_Teller2.SetPrintTextBlock(LoginUserInfo.TellerNo);

            //TB_Jyrq.SetPrintTextBlock(LoginUserInfo.TradeDate);
            //阳光打印内容整体向上偏移
            if (Flag == "V8")
            {
                TB_title.SetValue(Canvas.TopProperty, 58.00);
                TB_Acno1.SetValue(Canvas.TopProperty, 79.00);
                TB_HM1.SetValue(Canvas.TopProperty, 79.00);
                TB_OPNbrno.SetValue(Canvas.TopProperty, 79.00);
                TB_Prdt1.SetValue(Canvas.TopProperty, 100.00);
                TB_Rate1.SetValue(Canvas.TopProperty, 100.00);
                TB_jyh.SetValue(Canvas.TopProperty, 103.00);
                TB_TxAmt1.SetValue(Canvas.TopProperty, 121.00);
                TB_Note1.SetValue(Canvas.TopProperty, 121.00);
                TB_data.SetValue(Canvas.TopProperty, 121.00);
                TB_TradeType.SetValue(Canvas.TopProperty, 142.00);
                TB_Zhlx.SetValue(Canvas.TopProperty, 142.00);
                TB_ZDZC.SetValue(Canvas.TopProperty, 142.00);
                TB_CtInd1.SetValue(Canvas.TopProperty, 163.00);
                TB_DfAcno1.SetValue(Canvas.TopProperty, 163.00);
                TB_Sflx.SetValue(Canvas.TopProperty, 163.00);
                TB_TCBZ.SetValue(Canvas.TopProperty, 184.00);
                TB_DfAcname1.SetValue(Canvas.TopProperty, 184.00);
                TB_Lx.SetValue(Canvas.TopProperty, 205.00);
                TB_SfBx.SetValue(Canvas.TopProperty, 205.00);
                TB_ZHJZ.SetValue(Canvas.TopProperty, 205.00);
                tb_Account.SetValue(Canvas.TopProperty, 242.00);
                tb_ls.SetValue(Canvas.TopProperty, 273.00);
                TB_lsh.SetValue(Canvas.TopProperty, 273.00);
                //imgSignet.SetValue(Canvas.TopProperty, 285.00);

                BZ.Visibility = BZ1.Visibility = Visibility.Visible;
            }
            if (Flag == "V12")
            {
                this.E_Seal2Copy(new Point(665, 364));
            }
        }
        
        #endregion
    }
}
