﻿using System;
using System.Collections.Generic;
using System;
using System.Windows;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using System.ComponentModel;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Print_DuiGong_KHSQS_QF.xaml 的交互逻辑
    /// </summary>
    public partial class Print_DuiGong_KHSQS_QF : IPrintContract
    {
        public Print_DuiGong_KHSQS_QF(Print_DuiGong_KHSQS_QFEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public PrintEntry PrintData { get; set; }
        /// <summary>
        /// 凭证的打印数据实体定义
        /// </summary>
        public class Print_DuiGong_KHSQS_QFEntry : PrintEntry
        {
            /**********************************
             * 定义实体属性
             * 1.打印逻辑用到的要素
             * *******************************/
            /// <summary>
            /// 存款人名称
            /// </summary>
            public string CKRMC { get; set; }
            /// <summary>
            /// 存款人电话
            /// </summary>
            public string CKRDH { get; set; }
            /// <summary>
            /// 注册地址
            /// </summary>
            public string ZCDZ { get; set; }
            /// <summary>
            /// 注册地址邮编
            /// </summary>
            public string ZCDZYB { get; set; }

            /// <summary>
            /// 通讯地址
            /// </summary>
            public string TXDZ { get; set; }
            /// <summary>
            /// 通讯地址邮编
            /// </summary>
            public string TXDZYB { get; set; }
            /// <summary>
            /// 存款人类别
            /// </summary>
            public string CKRLB { get; set; }
            /// <summary>
            /// 组织机构代码
            /// </summary>
            public string ZZJGDMZH { get; set; }
            /// <summary>
            /// 组织机构代码证到期日
            /// </summary>
            public string ZZJGDMZDQR { get; set; }
            /// <summary>
            /// 法定代表人
            /// </summary>
            public string FDDBR { get; set; }
            /// <summary>
            /// 单位负责人
            /// </summary>
            public string DWFZR { get; set; }
            /// <summary>
            /// 负责人姓名
            /// </summary>
            public string FZRXM { get; set; }
            /// <summary>
            /// 负责人证件种类
            /// </summary>
            public string FZRZJZL { get; set; }
            /// <summary>
            /// 负责人证件号码
            /// </summary>
            public string FZRZJHM { get; set; }
            /// <summary>
            /// 负责人证件到期日
            /// </summary>
            public string FZRZJDQR { get; set; }
            /// <summary>
            /// 行业分类A
            /// </summary>
            public string HYFLA { get; set; }
            /// <summary>
            /// 行业分类B
            /// </summary>
            public string HYFLB { get; set; }
            /// <summary>
            /// 行业分类C
            /// </summary>
            public string HYFLC { get; set; }
            /// <summary>
            /// 行业分类D
            /// </summary>
            public string HYFLD { get; set; }
            /// <summary>
            /// 行业分类E
            /// </summary>
            public string HYFLE { get; set; }
            /// <summary>
            /// 行业分类F
            /// </summary>
            public string HYFLF { get; set; }
            /// <summary>
            /// 行业分类G
            /// </summary>
            public string HYFLG { get; set; }
            /// <summary>
            /// 行业分类H
            /// </summary>
            public string HYFLH { get; set; }
            /// <summary>
            /// 行业分类I
            /// </summary>
            public string HYFLI { get; set; }
            /// <summary>
            /// 行业分类J
            /// </summary>
            public string HYFLJ { get; set; }
            /// <summary>
            /// 行业分类K
            /// </summary>
            public string HYFLK { get; set; }
            /// <summary>
            /// 行业分类L
            /// </summary>
            public string HYFLL { get; set; }
            /// <summary>
            /// 行业分类M
            /// </summary>
            public string HYFLM { get; set; }
            /// <summary>
            /// 行业分类N
            /// </summary>
            public string HYFLN { get; set; }
            /// <summary>
            /// 行业分类O
            /// </summary>
            public string HYFLO { get; set; }
            /// <summary>
            /// 行业分类P
            /// </summary>
            public string HYFLP { get; set; }
            /// <summary>
            /// 行业分类Q
            /// </summary>
            public string HYFLQ { get; set; }
            /// <summary>
            /// 行业分类R
            /// </summary>
            public string HYFLR { get; set; }
            /// <summary>
            /// 行业分类S
            /// </summary>
            public string HYFLS { get; set; }
            /// <summary>
            /// 行业分类T
            /// </summary>
            public string HYFLT { get; set; }

            /// <summary>
            /// 注册币种
            /// </summary>
            public string ZCBZ { get; set; }
            /// <summary>
            /// 注册金额
            /// </summary>
            public string ZCJE { get; set; }
            /// <summary>
            /// 注册地区代码
            /// </summary>
            public string ZCDQDM { get; set; }
            /// <summary>
            /// 经营范围
            /// </summary>
            public string JYFW { get; set; }
            /// <summary>
            /// 证明文件种类
            /// </summary>
            public string ZMWJZL { get; set; }
            /// <summary>
            /// 证明文件编号
            /// </summary>
            public string ZMWJBH { get; set; }
            /// <summary>
            /// 证明文件到期日
            /// </summary>
            public string ZMWJDQR { get; set; }
            /// <summary>
            /// 地税登记号码
            /// </summary>
            public string DSDJHM { get; set; }
            /// <summary>
            /// 国税登记号码
            /// </summary>
            public string GSDJHM { get; set; }
            /// <summary>
            /// 账户属性基本
            /// </summary>
            public string ZHXZJB { get; set; }
            /// <summary>
            /// 账户属性一般
            /// </summary>
            public string ZHXZYB { get; set; }
            /// <summary>
            /// 账户属性专用
            /// </summary>
            public string ZHXZZY { get; set; }
            /// <summary>
            /// 账户属性临时
            /// </summary>
            public string ZHXZLS { get; set; }
            /// <summary>
            /// 资金性质
            /// </summary>
            public string ZJXZ { get; set; }
            /// <summary>
            /// 有效期至
            /// </summary>
            public string YXQ { get; set; }
            /// <summary>
            /// 上级名称
            /// </summary>
            public string SJFZRMC { get; set; }
            /// <summary>
            /// 开户许可证核准号
            /// </summary>
            public string KHXKZHZH { get; set; }
            /// <summary>
            /// 上级组织机构代码
            /// </summary>
            public string SJZZJGDM { get; set; }

            /// <summary>
            /// 上级法定代表人
            /// </summary>
            public string SJFDDBR { get; set; }
            /// <summary>
            /// 上级单位负责人
            /// </summary>
            public string SJDWFZR { get; set; }
            /// <summary>
            /// 上级负责人证件到期日
            /// </summary>
            public string SJFZRZJDQR { get; set; }
            /// <summary>
            /// 上级单位负责人姓名
            /// </summary>
            public string SJFZRXM { get; set; }
            /// <summary>
            /// 上级负责人证件种类
            /// </summary>
            public string SJFZRZJZL { get; set; }
            /// <summary>
            /// 上级单位负责人证件号码
            /// </summary>
            public string SJFZRZJHM { get; set; }
            /// <summary>
            /// 负责人类型
            /// </summary>
            public string FZRLX { get; set; }
            /// <summary>
            /// 上级 责人类型
            /// </summary>
            public string SJFZRLX { get; set; }
            /// <summary>
            /// 账户性质
            /// </summary>
            public string ZHXZ { get; set; }
        }
        public void LoadPrintData()
        {
            /**********************************
            * 加载数据到打印界面
            * 1.数据来源，PrintData.MessageData、PrintData.PageBase
            * *******************************/
            var entry = PrintData as Print_DuiGong_KHSQS_QFEntry;

            CKRMC.Text = entry.CKRMC;
            CKRDH.Text = entry.CKRDH;
            ZCDZ.Text = entry.ZCDZ;
            ZCDZYB.Text = entry.ZCDZYB;
            TXDZ.Text = entry.TXDZ;
            TXDZYB.Text = entry.TXDZYB;
            CKRLB.Text = entry.CKRLB;
            ZZJGDMZH.Text = entry.ZZJGDMZH;
            ZZJGDMZDQR.Text = entry.ZZJGDMZDQR;
            //FDDBR.Text = entry.FDDBR);
            //DWFZR.Text = entry.DWFZR);
            FZRXM.Text = entry.FZRXM;
            FZRZJZL.Text = entry.FZRZJZL;
            FZRZJHM.Text = entry.FZRZJHM;
            FZRZJDQR.Text = entry.FZRZJDQR;
            //HYFLA.Text = entry.HYFLA);
            //HYFLB.Text = entry.HYFLB);
            //HYFLC.Text = entry.HYFLC);
            //HYFLD.Text = entry.HYFLD);
            //HYFLE.Text = entry.HYFLE);
            //HYFLF.Text = entry.HYFLF);
            //HYFLG.Text = entry.HYFLG);
            //HYFLH.Text = entry.HYFLH);
            //HYFLI.Text = entry.HYFLI);
            //HYFLJ.Text = entry.HYFLJ);
            //HYFLK.Text = entry.HYFLK);
            //HYFLL.Text = entry.HYFLL);
            //HYFLM.Text = entry.HYFLM);
            //HYFLN.Text = entry.HYFLN);
            //HYFLO.Text = entry.HYFLO);
            //HYFLP.Text = entry.HYFLP);
            //HYFLQ.Text = entry.HYFLQ);
            //HYFLR.Text = entry.HYFLR);
            //HYFLS.Text = entry.HYFLS);
            //HYFLT.Text = entry.HYFLT);
            ZCBZ.Text = entry.ZCBZ;
            ZCJE.Text = entry.ZCJE;
            ZCDQDM.Text = entry.ZCDQDM;
            JYFW.Text = entry.JYFW;
            ZMWJZL.Text = entry.ZMWJZL;
            ZMWJBH.Text = entry.ZMWJBH;
            ZMWJDQR.Text = entry.ZMWJDQR;
            DSDJHM.Text = entry.DSDJHM;
            GSDJHM.Text = entry.GSDJHM;
            //ZHXZJB.Text = entry.ZHXZJB);
            //ZHXZYB.Text = entry.ZHXZYB);
            //ZHXZZY.Text = entry.ZHXZZY);
            //ZHXZLS.Text = entry.ZHXZLS);
            ZJXZ.Text = entry.ZJXZ;
            YXQ.Text = entry.YXQ;
            SJFZRMC.Text = entry.SJFZRMC;
            KHXKZHZH.Text = entry.KHXKZHZH;
            SJZZJGDM.Text = entry.SJZZJGDM;
            //SJFDDBR.Text = entry.SJFDDBR);
            //SJDWFZR.Text = entry.SJDWFZR);
            SJFZRZJDQR.Text = entry.SJFZRZJDQR;
            SJFZRXM.Text = entry.SJFZRXM;
            SJFZRZJZL.Text = entry.SJFZRZJZL;
            SJFZRZJHM.Text = entry.SJFZRZJHM;
            //行业分类 赋值
            if (entry.HYFLA == "A") {
                HYFLA.Text = "√";
            }
            if (entry.HYFLA == "B")
            {
                HYFLB.Text = "√";
            }
            if (entry.HYFLA == "C")
            {
                HYFLC.Text = "√";
            }
            if (entry.HYFLA == "D")
            {
                HYFLD.Text = "√";
            }
            if (entry.HYFLA == "E") {
                HYFLE.Text = "√";
            }
            if (entry.HYFLA == "F")
            {
                HYFLF.Text = "√";
            }
            if (entry.HYFLA == "G")
            {
                HYFLG.Text = "√";
            }
            if (entry.HYFLA == "H")
            {
                HYFLH.Text = "√";
            }
            if (entry.HYFLA == "I")
            {
                HYFLI.Text = "√";
            }
            if (entry.HYFLA == "J")
            {
                HYFLJ.Text = "√";
            }
            if (entry.HYFLA == "K")
            {
                HYFLK.Text = "√";
            }
            if (entry.HYFLA == "L")
            {
                HYFLL.Text = "√";
            }
            if (entry.HYFLA == "M")
            {
                HYFLM.Text = "√";
            }
            if (entry.HYFLA == "N")
            {
                HYFLN.Text = "√";
            }
            if (entry.HYFLA == "O")
            {
                HYFLO.Text = "√";
            }
            if (entry.HYFLA == "P")
            {
                HYFLP.Text = "√";
            }
            if (entry.HYFLA == "Q")
            {
                HYFLQ.Text = "√";
            }
            if (entry.HYFLA == "R")
            {
                HYFLR.Text = "√";
            }
            if (entry.HYFLA == "S")
            {
                HYFLS.Text = "√";
            }
            if (entry.HYFLA == "T")
            {
                HYFLT.Text = "√";
            }
            //负责人赋值
            if (entry.FZRLX.Equals("1"))
            {
                FDDBR.Text = "√";
            }
            else {
                DWFZR.Text = "√";
            }
            FZRXM.Text = entry.FZRXM;
            FZRZJZL.Text = entry.FZRZJZL;
            FZRZJHM.Text = entry.FZRZJHM;
            FZRZJDQR.Text = entry.FZRZJDQR;
            //上级负责人赋值
            if (entry.SJFZRLX.Equals("1"))
            {
                SJFDDBR.Text = "√";
            }
            else {
                SJDWFZR.Text = "√";
            }
            SJFZRXM.Text = entry.SJFZRXM;
            SJFZRZJDQR.Text = entry.SJFZRZJDQR;
            SJFZRZJZL.Text = entry.SJFZRZJZL;
            SJFZRZJHM.Text = entry.SJFZRZJHM;
            if (entry.ZHXZ.Equals("基本账户")) {
                ZHXZJB.Text = "√";
            }
            if (entry.ZHXZ.Equals("一般账户"))
            {
                ZHXZYB.Text = "√";
            }
            if (entry.ZHXZ.Equals("专用账户"))
            {
                ZHXZZY.Text = "√";
            }
            if (entry.ZHXZ.Equals("临时账户"))
            {
                ZHXZLS.Text = "√";
            }          
        }
    }
}
