﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;
namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// 单位单位定期存单
    /// </summary>
    public partial class Print_EnterpriseRegularlyCDs_TJ : IPrintContract
    {
        string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");

        public Print_EnterpriseRegularlyCDs_TJ(Print_EnterpriseRegularlyCDs_TJEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }


        public Contract.Entry.PrintEntry PrintData
        {
            get;
            private set;
        }

        public class Print_EnterpriseRegularlyCDs_TJEntry : PrintEntry
        {
            /// <summary>
            /// 户名
            /// </summary>
            public string AccountName { get; set; }
            /// <summary>
            /// 账号
            /// </summary>
            public string Account { get; set; }
            /// <summary>
            /// 证实书号
            /// </summary>
            public string ConfirmationNo { get; set; }
            /// <summary>
            /// 金额
            /// </summary>
            public decimal Amount { get; set; }
            /// <summary>
            /// 存期
            /// </summary>
            public string Months { get; set; }
            /// <summary>
            /// 利率
            /// </summary>
            public decimal InterestRate { get; set; }
            /// <summary>
            /// 到期日期
            /// </summary>
            public DateTime? DateEnd { get; set; }
            /// <summary>
            /// 起息日期
            /// </summary>
            public DateTime? DateStart { get; set; }
        }

        public void LoadPrintData()
        {
            string flag = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            var entry = PrintData as Print_EnterpriseRegularlyCDs_TJEntry;

            TB_TicketDateYear1.Text = LoginUserInfo.TradeDate.Substring(0, 4);
            TB_Months2.Text = LoginUserInfo.TradeDate.Substring(4, 2);
            TB_Days2.Text = LoginUserInfo.TradeDate.Substring(6, 2);

            TB_Account.Text = entry.Account;
            TB_AccountName.Text = entry.AccountName;
            TB_AmountMax.Text = "人民币" + entry.PageData.TradeAPIs.ChangeToCNY(entry.Amount);
            if (flag == "V22")
            {
                TB_AmountMin.Text = UserFunction.ChangeMoneySymbol("01") + entry.Amount;
                TB_AmountMin.Visibility = Visibility.Visible;
            }
            TB_ConfirmationNo.Text = entry.ConfirmationNo;

            if (entry.DateStart != null)
            {
                TB_TicketDate.Text = entry.DateStart.Value.ToString("yyyy/MM/dd");
            }
            else
            {
                TB_TicketDate.Text = "---";
            }
            TB_Months.Text = entry.Months.ToString();
            TB_InterestRate.Text = string.Format("{0:N6}%", entry.InterestRate);
            if (entry.DateEnd != null)
            {
                TB_DateEnd.Text = entry.DateEnd.Value.ToString("yyyy/MM/dd");
            }
            else
            {
                TB_DateEnd.Text = "---";
            }
            TB_Recheck.Text = PrintAttribute.Authentic;
            TB_Handling.Text = LoginUserInfo.TellerNo + "(" + LoginUserInfo.TellerName + ")";
            this.E_Seal_Location = new Point(550, 207);
            if (flag == "V21")
            {
                canvas_main.Margin = new Thickness(0, -20, 0, 0);
            }
        }
    }
}
