﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;
using Platform.Common.RunningParameters;
using TellerSystem.Communication;
using TellerSystem.Communication.MessageHelper;
using TellerSystem.Library.Ext.Function;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Pint_Gssqs.xaml 的交互逻辑
    /// </summary>
    public partial class Print_Gssqs : IPrintContract
    {

        public Print_Gssqs(Print_GssqsEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }


        public PrintEntry PrintData
        {
            get;
            private set;
        }



        public class Print_GssqsEntry : PrintEntry
        {
            public string gsSQSBH { get; set; }
            public string gsType { get; set; }
            public string gsName { get; set; }
            public string gsNo { get; set; }
            public string gsKinbr { get; set; }
            public string gsPzType { get; set; }
            public string gsPzNo { get; set; }
            public string gsDate { get; set; }
            public string gsZj { get; set; }
            public string gsZjNo { get; set; }
            public string gsGYLS { get; set; }
            public string gsYWLS { get; set; }

            public string jgRq { get; set; }
            public string jgJySj { get; set; }
            public string jgYwLb { get; set; }
            public string jgSuRe { get; set; }
            public string jgXpz { get; set; }
            public string jgJqJe { get; set; }
            public string jgJb { get; set; }
            public string jgSq { get; set; }
            public string jgZjLx { get; set; }
            public string jgZjHm { get; set; }


        }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_GssqsEntry;
            if (entry == null) return;
            GSSQSBH.Text = entry.gsSQSBH;
            GSTYPE.Text = entry.gsType;
            GSNAME.Text = entry.gsName;
            GSNO.Text = entry.gsNo;
            GSKINBR.Text = entry.gsKinbr;
            GSPZTYPE.Text = entry.gsPzType;
            GSPZNO.Text = entry.gsPzNo;
            GSDATE.Text = entry.gsDate;
            GSZJ.Text = entry.gsZj;
            GSZJNO.Text = entry.gsZjNo;
            JGRQ.Text = entry.jgRq;
            JGJYSJ.Text = entry.jgJySj;
            JGYWLB.Text = entry.jgYwLb;
            JGSURE.Text = entry.jgSuRe;
            JGXPZ.Text = entry.jgXpz;
            //JGJQJE.Text ="¥"+ entry.jgJqJe;
            JGJB.Text = entry.jgJb;
            JGSQ.Text = entry.jgSq;
            JGZJLX.Text = entry.jgZjLx;
            JGZJHM.Text = entry.jgZjHm;
            GYLS.Text = entry.gsGYLS;
            YWLS.Text = entry.gsYWLS;
            //为空时结清金额为空
            if (string.IsNullOrEmpty(entry.jgSuRe))
            {
                JGJQJE.Text = "";
            }
            else if (entry.jgSuRe == "否")
            {
                JGJQJE.Text = "无";
            }
            else
            {
                JGJQJE.Text = string.Format("¥{0:N2}", entry.jgJqJe);
            }
            //打印偏移调整
            var FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            switch (FLAG)
            {
                case "V8"://阳光向上偏移20
                case "V12"://长春融丰
                    GSSQSBH.SetValue(Canvas.TopProperty, 60.00);
                    GSTYPE.SetValue(Canvas.TopProperty, 442.00);
                    GSNAME.SetValue(Canvas.TopProperty, 442.00);
                    GSNO.SetValue(Canvas.TopProperty, 442.00);
                    GSKINBR.SetValue(Canvas.TopProperty, 473.00);
                    GSPZTYPE.SetValue(Canvas.TopProperty, 473.00);
                    GSPZNO.SetValue(Canvas.TopProperty, 473.00);
                    GSDATE.SetValue(Canvas.TopProperty, 506.00);
                    GSZJ.SetValue(Canvas.TopProperty, 506.00);
                    GSZJNO.SetValue(Canvas.TopProperty, 506.00);
                    JGRQ.SetValue(Canvas.TopProperty, 537.00);
                    JGJYSJ.SetValue(Canvas.TopProperty, 537.00);
                    JGYWLB.SetValue(Canvas.TopProperty, 537.00);
                    JGSURE.SetValue(Canvas.TopProperty, 537.00);
                    JGXPZ.SetValue(Canvas.TopProperty, 572.00);
                    JGJQJE.SetValue(Canvas.TopProperty, 572.00);
                    JGJB.SetValue(Canvas.TopProperty, 572.00);
                    JGSQ.SetValue(Canvas.TopProperty, 572.00);
                    JGZJLX.SetValue(Canvas.TopProperty, 606.00);
                    JGZJHM.SetValue(Canvas.TopProperty, 606.00);
                    if (string.IsNullOrEmpty(entry.jgYwLb) && string.IsNullOrEmpty(entry.jgYwLb))
                    {
                        this.E_Seal_Location = new Point(512, 295);
                    }
                    break;
                case "V9"://
                    GYLS.Visibility = Visibility.Visible;
                    YWLS.Visibility = Visibility.Visible;
                    tb_GYLS.Visibility = Visibility.Visible;
                    tb_YWLS.Visibility = Visibility.Visible;
                    break;
                case "V0"://中牟打印要求增加 打印受理时间
                    if (string.IsNullOrEmpty(JGRQ.Text))
                    {
                        DYSLDate.Visibility = Visibility.Visible;
                        var time = LoginUserInfo.GetUserInfo("TradeTime");
                        //获取服务端时间 
                        //   StringBuilder ServerTime = new StringBuilder(TradeHandle.GetServerTime());
                        //  string timeS = ServerTime.Remove(0, 11).ToString();
                        //  string timeH = ServerTime.Remove(6, 2).ToString();
                        DYSLDate.Text = time.ToString().Substring(0, 2).ToString() + "    " + time.ToString().Substring(2, 2).ToString();
                        DYSLDate.SetValue(Canvas.TopProperty, 403.0);
                    }
                    break;
                default:
                    break;
            }
        }
    }
}
