﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using Platform.Common.RunningParameters;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Print_GssqsDY.xaml 的交互逻辑
    /// </summary>
    public partial class Print_GssqsDY : IPrintContract
    {

        public Print_GssqsDY(Print_GssqsDYEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }


        public PrintEntry PrintData
        {
            get;
            private set;
        }



        public class Print_GssqsDYEntry : PrintEntry
        {
            public string gsSQSBH { get; set; }
            public string gsType { get; set; }
            public string gsName { get; set; }
            public string gsNo { get; set; }
            public string gsKinbr { get; set; }
            public string gsPzType { get; set; }
            public string gsPzNo { get; set; }
            public string gsDate { get; set; }
            public string gsZj { get; set; }
            public string gsZjNo { get; set; }

            public string jgRq { get; set; }
            public string jgJySj { get; set; }
            public string jgYwLb { get; set; }
            public string jgSuRe { get; set; }
            public string jgXpz { get; set; }
            public string jgJqJe { get; set; }
            public string jgJb { get; set; }
            public string jgSq { get; set; }
            public string jgZjLx { get; set; }
            public string jgZjHm { get; set; }


        }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_GssqsDYEntry;
            if (entry == null) return;
            GSSQSBH.Text = entry.gsSQSBH;
            GSTYPE.Text = entry.gsType;
            GSNAME.Text = entry.gsName;
            GSNO.Text = entry.gsNo;
            Year.Text = entry.gsDate.Substring(0,4);
            Month.Text = entry.gsDate.Substring(4, 2);
            Day.Text = entry.gsDate.Substring(6, 2);
            GSNAME.Text = entry.gsName;
            this.tbkJBGY.Text = LoginUserInfo.TellerNo;
            this.tbkGYLS.Text = this.PrintAttribute.SerialNumber;
        }
    }
}
