﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Pint_Gssqs.xaml 的交互逻辑
    /// </summary>
    public partial class Print_GssqsQX : IPrintContract
    {

        public Print_GssqsQX(Print_GssqsEntryQX entry)
        {
            InitializeComponent();
            PrintData = entry;
        }


        public PrintEntry PrintData
        {
            get;
            private set;
        }



        public class Print_GssqsEntryQX : PrintEntry
        {
            public string gsSQSBH { get; set; }
            public string gsType { get; set; }
            public string gsName { get; set; }
            public string gsNo { get; set; }
            public string gsKinbr { get; set; }
            public string gsPzType { get; set; }
            public string gsPzNo { get; set; }
            public string gsDate { get; set; }
            public string gsZj { get; set; }
            public string gsZjNo { get; set; }

            public string jgRq { get; set; }
            public string IsGHPZ { get; set; }
            //是否撤销挂失
            public string IsCXGS { get; set; }
            /// <summary>
            /// 是否已经重置密码
            /// </summary>
            public string jgSuRe { get; set; }
            public string jgXpz { get; set; }
            /// <summary>
            /// 是否更换印鉴
            /// </summary>
            public string ISGHYJ { get; set; }
            public string jgJb { get; set; }
            public string jgSq { get; set; }
            public string jgZjLx { get; set; }
            public string jgZjHm { get; set; }


        }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_GssqsEntryQX;
            if (entry == null) return;
            GSSQSBH.Text = entry.gsSQSBH;
            GSTYPE.Text = entry.gsType;
            GSNAME.Text = entry.gsName;
            GSNO.Text = entry.gsNo;
            GSKINBR.Text = entry.gsKinbr;
            GSPZTYPE.Text = entry.gsPzType;
            GSPZNO.Text = entry.gsPzNo;
            GSDATE.Text = entry.gsDate;
            GSZJ.Text = entry.gsZj;
            GSZJNO.Text = entry.gsZjNo;
            GSNAME.Text = entry.gsName;
            JGRQ.Text = entry.jgRq;
            FHGY.Text = this.PrintAttribute.Review;
            JGXPZ.Text = entry.jgXpz;
            //JGJQJE.Text ="¥"+ entry.jgJqJe;
            JGJB.Text = entry.jgJb;
            JGSQ.Text = entry.jgSq;
            if (!string.IsNullOrEmpty(entry.gsPzNo))
            {
                PzhmBlock.Visibility = Visibility.Visible;
            }
            else
            {
                PzhmBlock.Visibility = Visibility.Hidden;
            }
            if (string.IsNullOrEmpty(entry.IsGHPZ))
            {
                JGXPZ.Visibility = Visibility.Visible;
            }
            else
            {
                JGXPZ.Visibility = Visibility.Hidden;
            }

        }
    }
}
