﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using Platform.Common.RunningParameters;
using TellerSystem.Library.Ext.Function;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Pint_Gssqs.xaml 的交互逻辑
    /// </summary>
    public partial class Print_GssqsSD : IPrintContract
    {
        string FLAG = TellerSystem.ServiceProxy.Ext.ServiceHelper.TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        public Print_GssqsSD(Print_GssqsEntrySD entry)
        {
            InitializeComponent();
            PrintData = entry;
        }


        public PrintEntry PrintData
        {
            get;
            private set;
        }



        public class Print_GssqsEntrySD : PrintEntry
        {
            public string gsSQSBH { get; set; }
            public string gsType { get; set; }
            public string gsName { get; set; }
            public string gsNo { get; set; }
            public string gsKinbr { get; set; }
            public string gsPzType { get; set; }
            public string gsPzNo { get; set; }
            public string gsDate { get; set; }
            public string gsZj { get; set; }
            public string gsZjNo { get; set; }

            public string jgRq { get; set; }
            public string IsGHPZ { get; set; }
            //是否撤销挂失
            public string IsCXGS { get; set; }
            /// <summary>
            /// 是否已经重置密码
            /// </summary>
            public string jgSuRe { get; set; }
            public string jgXpz { get; set; }
            /// <summary>
            /// 是否更换印鉴
            /// </summary>
            public string ISGHYJ { get; set; }
            public string jgJb { get; set; }
            public string jgSq { get; set; }
            public string jgZjLx { get; set; }
            public string jgZjHm { get; set; }
            public string yyFlag { get; set; }
            /// <summary>
            /// 联网核查结果
            /// </summary>
            public string LWHCJG = string.Empty;


        }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_GssqsEntrySD;
            if (entry == null) return;
            GSSQSBH.Text = entry.gsSQSBH;
            GSTYPE.Text = entry.gsType;
            GSNAME.Text = entry.gsName;
            GSNO.Text = entry.gsNo;
            GSKINBR.Text = entry.gsKinbr;
            GSPZTYPE.Text = entry.gsPzType;
            GSPZNO.Text = entry.gsPzNo;
            GSDATE.Text = entry.gsDate;
            GSZJ.Text = entry.gsZj;
            GSZJNO.Text = entry.gsZjNo;
            GSNAME.Text = entry.gsName;
            JGRQ.Text = entry.jgRq;
            FHGY.Text = this.PrintAttribute.Review;
            JGXPZ.Text = entry.jgXpz;
            //JGJQJE.Text ="¥"+ entry.jgJqJe;
            JGJB.Text = entry.jgJb;
            JGSQ.Text = entry.jgSq;
            if (!string.IsNullOrEmpty(entry.gsPzNo))
            {
                PzhmBlock.Visibility = Visibility.Visible;
            }
            else
            {
                PzhmBlock.Visibility = Visibility.Hidden;
            }
            if (string.IsNullOrEmpty(entry.IsGHPZ))
            {
                JGXPZ.Visibility = Visibility.Visible;
            }
            else
            {
                JGXPZ.Visibility = Visibility.Hidden;
            }
            if (!string.IsNullOrEmpty(entry.yyFlag))
            {
                YYflag.Text = entry.yyFlag;
                GSSQSBH.SetValue(Canvas.TopProperty, 100.00);
			}
            if (FLAG == "V5")
            {
                this.ElecSealHelper.Sign2Point(new Point(450, 500), TellerSystem.PrintTemplate.ElecSeal.SealKind.Biz);
                if (LoginUserInfo.KinbrNo.Substring(0, 3) == "302")//黄骅
                {
                    if (!string.IsNullOrEmpty(entry.LWHCJG))
                    {
                        B_LWHC.Visibility = Visibility.Visible;
                        TB_HCJG.SetPrintTextBlock(entry.LWHCJG);
                    }
                }
            }
      
        }
    }
}
