﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using Platform.Common.RunningParameters;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Print_GssqsTS.xaml 的交互逻辑
    /// </summary>
    public partial class Print_GssqsdgTS : IPrintContract
    {

        public Print_GssqsdgTS(Print_GssqsEntryTS entry)
        {
            InitializeComponent();
            PrintData = entry;
        }


        public PrintEntry PrintData
        {
            get;
            private set;
        }



        public class Print_GssqsEntryTS : PrintEntry
        {
            public string gsSQSBH { get; set; }
            public string gsType { get; set; }
            public string gsName { get; set; }
            public string gsNo { get; set; }
            public string gsKinbr { get; set; }
            public string gsPzType { get; set; }
            public string gsPzNo { get; set; }
            public string gsDate { get; set; }
            public string gsZj { get; set; }
            public string gsZjNo { get; set; }

            public string jgRq { get; set; }
            public string jgJySj { get; set; }
            public string jgYwLb { get; set; }
            public string jgSuRe { get; set; }
            public string jgXpz { get; set; }
            public string jgJqJe { get; set; }
            public string jgJb { get; set; }
            public string jgSq { get; set; }
            public string jgZjLx { get; set; }
            public string jgZjHm { get; set; }
            public string jgZhye { get; set; }
            public string jgXActNo { get; set; }
            public string tb_xActNo { get; set; }

            public string dlrmc { get; set; }
            public string dlrzjlx { get; set; }
            public string dlrzjhm { get; set; }
            public string sfdl { get; set; }
        }

        public void LoadPrintData()
        {
            var FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            if (FLAG == "V19")//xaml界面该要素有问题应该置为显示，此处只调整天山
            {
                canvas1.Visibility = Visibility.Visible;
                tb_gstype.SetValue(Canvas.TopProperty, 212.0);
                GSTYPE.SetValue(Canvas.TopProperty, 212.0);
                tb_gsno.SetValue(Canvas.TopProperty, 212.0);
                GSNO.SetValue(Canvas.TopProperty, 212.0);
                tb_gsname.SetValue(Canvas.TopProperty, 233.0);
                GSNAME.SetValue(Canvas.TopProperty, 233.0);
                tbkZHYE.SetValue(Canvas.TopProperty, 233.0);
                GSZHYE.SetValue(Canvas.TopProperty, 233.0);
                tb_gskinbr.SetValue(Canvas.TopProperty, 254.0);
                GSKINBR.SetValue(Canvas.TopProperty, 254.0);
                tb_gspztype.SetValue(Canvas.TopProperty, 254.0);
                GSPZTYPE.SetValue(Canvas.TopProperty, 254.0);
                PzhmBlock.SetValue(Canvas.TopProperty, 254.0);
                GSPZNO.SetValue(Canvas.TopProperty, 254.0);
                tb_gsdate.SetValue(Canvas.TopProperty, 275.0);
                GSDATE.SetValue(Canvas.TopProperty, 275.0);
                tb_gszj.SetValue(Canvas.TopProperty, 275.0);
                GSZJ.SetValue(Canvas.TopProperty, 275.0);
                tb_gszjno.SetValue(Canvas.TopProperty, 275.0);
                GSZJNO.SetValue(Canvas.TopProperty, 275.0);
                dbr.SetValue(Canvas.TopProperty, 295.0);
                DLRMC.SetValue(Canvas.TopProperty, 295.0);
                dbrzjlx.SetValue(Canvas.TopProperty, 295.0);
                DLRZJLX.SetValue(Canvas.TopProperty, 295.0);
                dbrzjhm.SetValue(Canvas.TopProperty, 295.0);
                DLRZJHM.SetValue(Canvas.TopProperty, 295.0);
                tbkSQGY1.SetValue(Canvas.TopProperty, 313.0);
                SQGY1.SetValue(Canvas.TopProperty, 313.0);
                tb_jbgy1.SetValue(Canvas.TopProperty, 313.0);
                JBGY1.SetValue(Canvas.TopProperty, 313.0);
            }
            var entry = PrintData as Print_GssqsEntryTS;
            if (entry == null) return;
            GSSQSBH.Text = entry.gsSQSBH;
            GSTYPE.Text = entry.gsType;
            GSNAME.Text = entry.gsName;
            GSNO.Text = entry.gsNo;
            GSKINBR.Text = entry.gsKinbr;
            GSPZTYPE.Text = entry.gsPzType;
            GSPZNO.Text = entry.gsPzNo;
            GSDATE.Text = entry.gsDate;
            GSZJ.Text = entry.gsZj;
            GSZJNO.Text = entry.gsZjNo;
            GSNAME.Text = entry.gsName;
            JGRQ.Text = entry.jgRq;
            JGJYSJ.Text = entry.jgJySj;
            JGYWLB.Text = entry.jgYwLb;
            JGZJLX.Text = entry.jgZjLx;
            JGZJHM.Text = entry.jgZjHm;
            GSZHYE.Text = entry.jgZhye;
            JBZHYE.Text = entry.jgZhye;
            JGXActNo.Text = entry.jgXActNo;//新卡号或者新凭证号
            tbXActNo.Text = entry.tb_xActNo;//新卡号或者新凭证号
            if (entry.sfdl == "Y")
            {
                DLRMC.Text = entry.dlrmc;
                DLRZJLX.Text = entry.dlrzjlx;
                DLRZJHM.Text = entry.dlrzjhm;
                dbr.Visibility = Visibility.Visible;
                dbrzjlx.Visibility = Visibility.Visible;
                dbrzjhm.Visibility = Visibility.Visible;
                DLRMC.Visibility = Visibility.Visible;
                DLRZJLX.Visibility = Visibility.Visible;
                DLRZJHM.Visibility = Visibility.Visible;
            }
            else
            {
                dbr.Visibility = Visibility.Collapsed;
                dbrzjlx.Visibility = Visibility.Collapsed;
                dbrzjhm.Visibility = Visibility.Collapsed;
                DLRMC.Visibility = Visibility.Collapsed;
                DLRZJLX.Visibility = Visibility.Collapsed;
                DLRZJHM.Visibility = Visibility.Collapsed;
            }
            if (!string.IsNullOrEmpty(entry.gsType))
            {
                canvas1.Visibility = Visibility.Visible;
                canvas2.Visibility = Visibility.Collapsed;                
                if(FLAG=="V11")
                {
                    tbkZHYE.Visibility=GSZHYE.Visibility = Visibility.Visible;              
                }
                if (FLAG != "V9")
                {
                    JBGY1.Text = LoginUserInfo.TellerName + "(" + LoginUserInfo.TellerNo + ")";
                    SQGY1.Text = this.PrintAttribute.Authentic;
                }
                else
                {
                    JBGY1.Text = LoginUserInfo.TellerNo;
                    SQGY1.Text = this.PrintAttribute.Authno;
                }
                if (FLAG == "V10")
                {
                    this.E_Seal_Location = new Point(270, 265);
                }
                else
                {
                    this.E_Seal_Location = new Point(166, 265);
                }
            }
            else
            {
                canvas1.Visibility = Visibility.Collapsed;
                canvas2.Visibility = Visibility.Visible;
                if (FLAG == "V11")
                {
                    tbZHYE.Visibility = JBZHYE.Visibility = Visibility.Visible;
                    tbXActNo.Visibility = JGXActNo.Visibility = Visibility.Visible;
                }
                if (FLAG != "V9")
                {
                    JBGY2.Text = LoginUserInfo.TellerName + "(" + LoginUserInfo.TellerNo + ")";
                    SQGY2.Text = this.PrintAttribute.Authentic;
                }
                else
                {
                    JBGY2.Text = LoginUserInfo.TellerNo;
                    SQGY2.Text = this.PrintAttribute.Authno;

                }
                if (FLAG == "V10")
                {
                    this.E_Seal_Location = new Point(270, 422);
                }
                else if (FLAG == "V18")
                {
                    this.E_Seal_Location = new Point(166, 412);
                }
                else
                {
                    this.E_Seal_Location = new Point(166, 422);
                }
            }
            //授权柜员为空判断
            if (string.IsNullOrEmpty(this.PrintAttribute.Authno))
            {
                SQGY1.Visibility = SQGY2.Visibility = tbkSQGY1.Visibility = tbkSQGY2.Visibility = Visibility.Collapsed;
            }
            else
            {
                SQGY1.Visibility = SQGY2.Visibility = tbkSQGY1.Visibility = tbkSQGY2.Visibility = Visibility.Visible;
            }


        }
    }
}
