﻿using System;
using System.Globalization;
using System.Windows;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using System.Windows.Media;
using System.IO;
using System.Windows.Media.Imaging;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;
using System.Windows.Controls;
using TellerSystem.Devices.Config;
using TellerSystem.PrintTemplate.Base;
using TellerSystem.Library.Ext.TradeExtension;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    ///本票
    /// </summary>
    public partial class Print_IdChecker : IPrintContract
    {
        public Print_IdChecker(Print_IdCheckerEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public Contract.Entry.PrintEntry PrintData
        {
            get;
            private set;
        }

        public class Print_IdCheckerEntry : PrintEntry
        {
            public string Number { get; set; }
            public string Name { get; set; }
            public string Type { get; set; }
            public string Reason { get; set; }
            public string Result { get; set; }
            public string Branch { get; set; }
            public string Photo { get; set; }
            public string frontPhoto { get; set; }
            public string BackPhoto { get; set; }
            public string Grade { get; set; }

            public string Sex { get; set; }
            public string Address { get; set; }
            public DateTime BirthDay { get; set; }
            public DateTime StartDate { get; set; }
            public DateTime EndDate { get; set; }
            public string IssuingAuthority { get; set; }
            public string Nationality { get; set; }
        }

        private static Brush _brushZM = Brushes.Transparent;
        private static Brush _brushFM = Brushes.Transparent;

        public void LoadPrintData()
        {
            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            if (FLAG == "V13" || FLAG == "V14" || FLAG == "V21" || FLAG == "V22")
            { 
                //BBP_Bottom.SetValue(Canvas.TopProperty, 312.0);
                lwhc.SetValue(Canvas.TopProperty, 36.0);
                tb_type.SetValue(Canvas.TopProperty, 74.0);
                TB_Type.SetValue(Canvas.TopProperty, 74.0);

                TB_Number.SetValue(Canvas.TopProperty, 114.0);
                tb_number.SetValue(Canvas.TopProperty, 114.0);

                TB_Name.SetValue(Canvas.TopProperty, 154.0);
                tb_name.SetValue(Canvas.TopProperty, 154.0);

                TB_Reason.SetValue(Canvas.TopProperty, 194.0);
                tb_reason.SetValue(Canvas.TopProperty, 194.0);

                TB_Result.SetValue(Canvas.TopProperty, 229.0);
                tb_result.SetValue(Canvas.TopProperty, 229.0);

                TB_Branch.SetValue(Canvas.TopProperty, 269.0);
                tx_branch.SetValue(Canvas.TopProperty, 269.0);

                I_Photo.SetValue(Canvas.TopProperty, 64.0);
                i_photo.SetValue(Canvas.TopProperty, 64.0);

                b1.SetValue(Canvas.TopProperty, 290.0);
                front_Photo.SetValue(Canvas.TopProperty, 290.0);

                b2.SetValue(Canvas.TopProperty, 290.0);
                Back_Photo.SetValue(Canvas.TopProperty, 290.0);
                LWHC.Visibility = YJHD.Visibility = Visibility.Visible;
            }
            if (FLAG == "V10")
            {
                LWHC.Visibility = YJHD.Visibility = Visibility.Visible;
                lwhc.SetValue(Canvas.TopProperty, 16.0);
                tb_type.SetValue(Canvas.TopProperty, 54.0);
                TB_Type.SetValue(Canvas.TopProperty, 54.0);

                TB_Number.SetValue(Canvas.TopProperty, 94.0);
                tb_number.SetValue(Canvas.TopProperty, 94.0);

                TB_Name.SetValue(Canvas.TopProperty, 134.0);
                tb_name.SetValue(Canvas.TopProperty, 134.0);

                TB_Reason.SetValue(Canvas.TopProperty, 174.0);
                tb_reason.SetValue(Canvas.TopProperty, 174.0);

                TB_Result.SetValue(Canvas.TopProperty, 209.0);
                tb_result.SetValue(Canvas.TopProperty, 209.0);

                TB_Branch.SetValue(Canvas.TopProperty, 249.0);
                tx_branch.SetValue(Canvas.TopProperty, 249.0);

                tb_rlbd.SetValue(Canvas.TopProperty, 249.0);
                TB_rlbd.SetValue(Canvas.TopProperty, 249.0);

                I_Photo.SetValue(Canvas.TopProperty, 44.0);
                i_photo.SetValue(Canvas.TopProperty, 44.0);

                b1.SetValue(Canvas.TopProperty, 260.0);
                front_Photo.SetValue(Canvas.TopProperty, 260.0);

                b2.SetValue(Canvas.TopProperty, 260.0);
                Back_Photo.SetValue(Canvas.TopProperty, 260.0);
                ZFM.Margin = new Thickness(0, -30, 0, 30);
            }
            var entry = PrintData as Print_IdCheckerEntry;
            if (entry == null) return;
            TB_Number.Text = entry.Number;
            TB_Name.Text = entry.Name;
            TB_Type.Text = entry.Type;
            TB_Reason.Text = entry.Reason;
            TB_Result.Text = entry.Result;
            TB_Branch.Text = entry.Branch;
            I_Photo.Source = CreateImage(entry.Photo);
            //b1.Visibility = b2.Visibility = front_Photo.Visibility = Back_Photo.Visibility = FLAG == "V10" ? Visibility.Visible : Visibility.Collapsed;//齐丰的显示
            //b1.Visibility = b2.Visibility = front_Photo.Visibility = Back_Photo.Visibility = FLAG == "V13" ? Visibility.Visible : Visibility.Collapsed;//z芝罘齐丰
            //b1.Visibility = b2.Visibility = front_Photo.Visibility = Back_Photo.Visibility = FLAG == "V14" ? Visibility.Visible : Visibility.Collapsed;//z泗水齐丰
            if (FLAG == "V13" || FLAG == "V14" || FLAG == "V16" || FLAG == "V17" || FLAG == "V18" || FLAG == "V23" || FLAG == "V24")//齐丰、芝罘、泗水
            {
                front_Photo.Source = CreateImage(entry.frontPhoto);
                Back_Photo.Source = CreateImage(entry.BackPhoto);
                b1.Visibility = b2.Visibility = front_Photo.Visibility = Back_Photo.Visibility = Visibility.Visible;//z泗水
            }
            else if (FLAG == "V21" || FLAG == "V22")
            {
                b1.Visibility = b2.Visibility = Visibility.Visible;
                if (!string.IsNullOrEmpty(entry.Nationality) || !string.IsNullOrEmpty(entry.Address) || !string.IsNullOrEmpty(entry.Sex) || !string.IsNullOrEmpty(entry.IssuingAuthority))
                {
                    tb_Name.Visibility = tb_Sex.Visibility = tb_Nationality.Visibility = tb_Year.Visibility = tb_Month.Visibility = tb_Day.Visibility = tb_Address.Visibility = tb_IdNumber.Visibility = tb_IssuingAuthority.Visibility = tb_Date.Visibility = Visibility.Visible;
                    i_photoZM.Visibility = I_PhotoZM.Visibility = Visibility.Visible;
                    if (FLAG == "V21")
                    {
                        _brushZM = RES.GetBrush("RES/V21/正面.png");
                    }
                    else if (FLAG == "V22")
                    {
                        _brushZM = RES.GetBrush("RES/V22/正面.png");
                    }
                    b1.Background = _brushZM;
                    tb_Name.Text = entry.Name;
                    tb_Sex.Text = entry.Sex;
                    tb_Nationality.Text = entry.Nationality;
                    tb_Year.Text = entry.BirthDay.Year.ToString();
                    tb_Month.Text = entry.BirthDay.Month.ToString();
                    tb_Day.Text = entry.BirthDay.Day.ToString();
                    tb_Address.Text = entry.Address;
                    tb_IdNumber.Text = entry.Number;
                    I_PhotoZM.Source = CreateImage(entry.Photo);
                    if (FLAG == "V21")
                    {
                        _brushFM = RES.GetBrush("RES/V21/反面.png");
                    }
                    else if (FLAG == "V22")
                    {
                        _brushFM = RES.GetBrush("RES/V22/反面.png");
                    }
                    b2.Background = _brushFM;
                    tb_IssuingAuthority.Text = entry.IssuingAuthority;
                    if (entry.EndDate.ToString("yyyyMMdd") == "99991231")
                    {
                        tb_Date.Text = entry.StartDate.ToString("yyyy.MM.dd") + " - 长期"; 
                    }
                    else
                    {
                        tb_Date.Text = entry.StartDate.ToString("yyyy.MM.dd") + "-" + entry.EndDate.ToString("yyyy.MM.dd");
                    }
                }
                if (FLAG == "V21")
                {
                    tb_jyrq.Visibility = Visibility.Visible;
                    tb_jyrq.SetValue(Canvas.TopProperty, 36.0);
                    tb_jyrq.SetValue(Canvas.LeftProperty, 486.0);
                    System.Text.StringBuilder ServerTime = new System.Text.StringBuilder(TradeHandle.GetServerTime());
                    tb_jyrq.Text = "交易日期:" + ServerTime.ToString().Replace("-", "");
                }
            }
            else if (FLAG == "V10")
            {
                if (DeviceConfig.IdentityCardKind.Equals("IdentityCard_ShenSi"))//神思品牌  有返回身份证正反面，其余品牌需组装
                {
                    front_Photo.Source = CreateImage(entry.frontPhoto);
                    Back_Photo.Source = CreateImage(entry.BackPhoto);
                    b1.Visibility = b2.Visibility = front_Photo.Visibility = Back_Photo.Visibility = Visibility.Visible;
                }
                else
                {
                    b1.Visibility = b2.Visibility = Visibility.Visible;
                    if (!string.IsNullOrEmpty(entry.Nationality) || !string.IsNullOrEmpty(entry.Address) || !string.IsNullOrEmpty(entry.Sex) || !string.IsNullOrEmpty(entry.IssuingAuthority))
                    {
                        tb_Name.Visibility = tb_Sex.Visibility = tb_Nationality.Visibility = tb_Year.Visibility = tb_Month.Visibility = tb_Day.Visibility = tb_Address.Visibility = tb_IdNumber.Visibility = tb_IssuingAuthority.Visibility = tb_Date.Visibility = Visibility.Visible;
                        i_photoZM.Visibility = I_PhotoZM.Visibility = Visibility.Visible;
                        _brushZM = RES.GetBrush("RES/V10/正面.png");
                        b1.Background = _brushZM;
                        tb_Name.Text = entry.Name;
                        tb_Sex.Text = entry.Sex;
                        tb_Nationality.Text = entry.Nationality;
                        tb_Year.Text = entry.BirthDay.Year.ToString();
                        tb_Month.Text = entry.BirthDay.Month.ToString();
                        tb_Day.Text = entry.BirthDay.Day.ToString();
                        tb_Address.Text = entry.Address;
                        tb_IdNumber.Text = entry.Number;
                        I_PhotoZM.Source = CreateImage(entry.Photo);
                        _brushFM = RES.GetBrush("RES/V10/反面.png");
                        b2.Background = _brushFM;
                        tb_IssuingAuthority.Text = entry.IssuingAuthority;
                        if (entry.EndDate.ToString("yyyyMMdd") == "99991231")
                        {
                            tb_Date.Text = entry.StartDate.ToString("yyyy.MM.dd") + " - 长期";
                        }
                        else
                        {
                            tb_Date.Text = entry.StartDate.ToString("yyyy.MM.dd") + "-" + entry.EndDate.ToString("yyyy.MM.dd");
                        }
                    }
                }
            }
            else
            {
                b1.Visibility = b2.Visibility = front_Photo.Visibility = Back_Photo.Visibility = Visibility.Collapsed;//z泗水
            }
            if (FLAG == "V5") 
            {
                tb_jg.Visibility = tb_dm.Visibility = tb_jy.Visibility = tb_jyrq.Visibility = tb_gy.Visibility = tb_ywls.Visibility = tb_bz.Visibility = tb_gyls.Visibility = Visibility.Visible;
                tb_jg.Text = "机构名称:" + LoginUserInfo.KinbrName;
                tb_dm.Text = "代码:" + PrintAttribute.TradeModel.Code;
                tb_jy.Text = "交易:" + PrintAttribute.TradeModel.Name;
                System.Text.StringBuilder ServerTime = new System.Text.StringBuilder(TradeHandle.GetServerTime());
                tb_jyrq.Text = "交易日期:" + ServerTime.ToString().Replace("-", "");
                tb_gy.Text = "柜员:" + LoginUserInfo.TellerNo;
                if (!string.IsNullOrEmpty(this.PrintAttribute.Authentic))
                {
                    tb_sqy.Text = "授权员:" + this.PrintAttribute.Authentic;
                    tb_sqy.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrEmpty(entry.Grade))
                {
                    tb_rlbd.Visibility = TB_rlbd.Visibility = Visibility.Visible;
                    TB_rlbd.Text = entry.Grade;
                }
                
            }
            if (FLAG != "V5" && AICapacity.GetInstence().IsOpen)
            {
                tb_jg.Visibility = tb_dm.Visibility = tb_jy.Visibility = tb_jyrq.Visibility = tb_gy.Visibility = Visibility.Visible;
                tb_jg.Text = "机构名称:" + LoginUserInfo.KinbrName;
                tb_dm.Text = "代码:" + PrintAttribute.TradeModel.Code;
                tb_jy.Text = "交易:" + PrintAttribute.TradeModel.Name;
                System.Text.StringBuilder ServerTime = new System.Text.StringBuilder(TradeHandle.GetServerTime());
                tb_jyrq.Text = "交易日期:" + ServerTime.ToString().Replace("-", "");
                tb_gy.Text = "柜员:" + LoginUserInfo.TellerNo;
                if (!string.IsNullOrEmpty(this.PrintAttribute.Authentic))
                {
                    tb_sqy.Text = "授权员:" + this.PrintAttribute.Authentic;
                    tb_sqy.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrEmpty(entry.Grade))
                {
                    tb_rlbd.Visibility = TB_rlbd.Visibility = Visibility.Visible;
                    TB_rlbd.Text = entry.Grade;
                }
            }

        }

        private ImageSource CreateImage(String imageStream)
        {
            ImageSource ret = null;
            try
            {
                if (!string.IsNullOrEmpty(imageStream))
                {
                    //把BASE64转码字符串，转成byte数组
                    byte[] arr = Convert.FromBase64String(imageStream);
                    //定义流
                    MemoryStream ms = new MemoryStream(arr);
                    var bitImg = new BitmapImage();
                    bitImg.BeginInit();
                    //ms.Seek(0, SeekOrigin.Begin);
                    bitImg.StreamSource = ms;
                    bitImg.EndInit();
                    ret = bitImg;
                }
            }
            catch (Exception e)
            {
                //this.ShowWarnMessageBox("加载身份照片数据出错！");//.ShowMessageBox("转换照片出错");
            }
            return ret;
        }
    }
}