﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.IO;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;
using TellerSystem.Contract.Entry;
using TellerSystem.Contract.Contracts;


namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Print_IdChecker_QFXT.xaml 的交互逻辑 新泰的要求
    /// </summary>
    public partial class Print_IdChecker_QFXT : IPrintContract
    {
        public Print_IdChecker_QFXT(Print_IdChecker_QFXTEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }
        public Contract.Entry.PrintEntry PrintData
        {
            get;
            private set;
        }
        public class Print_IdChecker_QFXTEntry : PrintEntry
        {
            public string Number { get; set; }
            public string Name { get; set; }
            public string Type { get; set; }
            public string Reason { get; set; }
            public string Result { get; set; }
            public string Branch { get; set; }
            public string Photo { get; set; }
            public string frontPhoto { get; set; }
            public string BackPhoto { get; set; }
        }
        public void LoadPrintData()
        {
            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            var entry = PrintData as Print_IdChecker_QFXTEntry;
            if (entry == null) return;
            TB_Number.Text = entry.Number;
            TB_Name.Text = entry.Name;
            TB_Type.Text = entry.Type;
            TB_Reason.Text = entry.Reason;
            TB_Result.Text = entry.Result;
            TB_Branch.Text = entry.Branch;
            I_Photo.Source = CreateImage(entry.Photo);
            front_Photo.Source = CreateImage(entry.frontPhoto);
            Back_Photo.Source = CreateImage(entry.BackPhoto);
            b1.Visibility = b2.Visibility = front_Photo.Visibility = Back_Photo.Visibility = Visibility.Visible;
        }

        private ImageSource CreateImage(String imageStream)
        {
            ImageSource ret = null;
            try
            {
                if (!string.IsNullOrEmpty(imageStream))
                {
                    //把BASE64转码字符串，转成byte数组
                    byte[] arr = Convert.FromBase64String(imageStream);
                    //定义流
                    MemoryStream ms = new MemoryStream(arr);
                    var bitImg = new BitmapImage();
                    bitImg.BeginInit();
                    //ms.Seek(0, SeekOrigin.Begin);
                    bitImg.StreamSource = ms;
                    bitImg.EndInit();
                    ret = bitImg;
                }
            }
            catch (Exception e)
            {
                //this.ShowWarnMessageBox("加载身份照片数据出错！");//.ShowMessageBox("转换照片出错");
            }
            return ret;
        }
   

    }
}
