﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using Platform.Common.RunningParameters;
using TellerSystem.Library.Ext.Function;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Print_JBDYQD.xaml 的交互逻辑
    /// </summary>
    public partial class Print_JBDYQD : IPrintContract
    {
        public Print_JBDYQD(Print_JBDYQDEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public Contract.Entry.PrintEntry PrintData
        {
            get;
            private set;
        }
        public class Print_JBDYQDEntry : PrintEntry
        {
            /// <summary>
            /// 日期
            /// </summary>
            public string RQ;
            /// <summary>
            /// 编号
            /// </summary>
            public string BH;
            /// <summary>
            /// 调入单位
            /// </summary>
            public string DRDW;
            /// <summary>
            /// 总量清单
            /// </summary>
            public string ZLQD;
            /// <summary>
            /// 数量合计小写
            /// </summary>
            public string SLHJXX;
            /// <summary>
            /// 关注类假币明细
            /// </summary>
            public string GZLJBMX;
            /// <summary>
            /// 调运人
            /// </summary>
            public string DYR;
        }
        public void LoadPrintData()
        {
            var entry = PrintData as Print_JBDYQDEntry;
            this.tb_RQ.Text = entry.RQ;
            this.tb_BH.Text = entry.BH;
            this.tb_DRDW.Text = entry.DRDW;
            this.tb_ZLQD.Text = entry.ZLQD;
            this.tb_SLHJXX.Text = entry.SLHJXX;
            this.tb_SLHJDX.Text = SystemFunction.NumToChinese(entry.SLHJXX);
            this.tb_GZLJBMX.Text = entry.GZLJBMX;
            this.tb_JB.Text = string.Format("{1}({0})", LoginUserInfo.TellerNo, LoginUserInfo.TellerName);
            this.tb_FH.Text = string.Format("{1}({0})", PrintAttribute.Authno, this.PrintAttribute.Authentic);
            this.tb_DYR.Text = entry.DYR;
        }
    }
}
