﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using Platform.Common.RunningParameters;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Print_JBJDCKQD.xaml 的交互逻辑
    /// </summary>
    public partial class Print_JBJDCKQD : IPrintContract
    {
        public Print_JBJDCKQD(Print_JBJDCKQDEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public Contract.Entry.PrintEntry PrintData
        {
            get;
            private set;
        }
        public class Print_JBJDCKQDEntry : PrintEntry
        {
            /// <summary>
            /// 日期
            /// </summary>
            public string RQ;
            /// <summary>
            /// 编号
            /// </summary>
            public string BH;
            /// <summary>
            /// 鉴定单位
            /// </summary>
            public string JDDW;
            /// <summary>
            /// 总量清单
            /// </summary>
            public string ZLQD;
            /// <summary>
            /// 假币信息
            /// </summary>
            public string JBXX;
            /// <summary>
            /// 主管
            /// </summary>
            public string ZG;
            /// <summary>
            /// 调运人
            /// </summary>
            public string DYR;
            /// <summary>
            /// 备注说明
            /// </summary>
            public string BZSM;
        }
        public void LoadPrintData()
        {
            var entry = PrintData as Print_JBJDCKQDEntry;
            this.tb_RQ.Text = entry.RQ;
            this.tb_BH.Text = entry.BH;
            this.tb_JDDW.Text = entry.JDDW;
            this.tb_JBXX.Text = entry.JBXX;
            this.tb_JB.Text = string.Format("{1}({0})", LoginUserInfo.TellerNo, LoginUserInfo.TellerName);
            this.tb_FH.Text = string.Format("{1}({0})", PrintAttribute.Authno, this.PrintAttribute.Authentic);
            this.tb_ZG.Text = entry.ZG;
            this.tb_DYR.Text = entry.DYR;
            this.tb_BZSM.Text = entry.BZSM;
        }
    }
}
