﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Print_JBSJPZ_1.xaml 的交互逻辑
    /// </summary>
    public partial class Print_JBSJPZ_1 : IPrintContract
    {
        public Print_JBSJPZ_1(Print_JBSJPZ_1Entry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public PrintEntry PrintData
        {
            get;
            private set;
        }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_JBSJPZ_1Entry;
            this.tb_RQ.Text = entry.RQ;
            this.tb_BH.Text = entry.BH;
            this.tb_JKDWMC.Text = entry.JKDWMC;
            this.tb_JBRXM.Text = entry.JBRXM;
            this.tb_JBRZJLX.Text = entry.JBRZJLX;
            this.tb_JBRZJHM.Text = entry.JBRZJHM;
            this.tb_JBXX.Text = entry.JBXX;
            this.tb_HJSL.Text = entry.HJSL;
            this.tb_HJSLDX.Text = SystemFunction.NumToChinese(entry.HJSL);
        }
        public class Print_JBSJPZ_1Entry : PrintEntry
        {
            /// <summary>
            /// 日期
            /// </summary>
            public string RQ;
            /// <summary>
            /// 编号
            /// </summary>
            public string BH;
            /// <summary>
            /// 交款单位名称
            /// </summary>
            public string JKDWMC;
            /// <summary>
            /// 经办人姓名
            /// </summary>
            public string JBRXM;
            /// <summary>
            /// 经办人证件类型
            /// </summary>
            public string JBRZJLX;
            /// <summary>
            /// 经办人证件号码
            /// </summary>
            public string JBRZJHM;
            /// <summary>
            /// 假币信息
            /// </summary>
            public string JBXX;
            /// <summary>
            /// 合计数量
            /// </summary>
            public string HJSL;
        }
    }
}
