﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using Platform.Common.RunningParameters;
using TellerSystem.Library.Ext.Function;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Print_JBJJQD.xaml 的交互逻辑
    /// </summary>
    public partial class Print_JRMBMSSJ_DW_1 : IPrintContract
    {
        public Print_JRMBMSSJ_DW_1(Print_JRMBMSSJ_DW_1Entry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public Contract.Entry.PrintEntry PrintData
        {
            get;
            private set;
        }
        public class Print_JRMBMSSJ_DW_1Entry : PrintEntry
        {
            /// <summary>
            /// 日期
            /// </summary>
            public string RQ;
            /// <summary>
            /// 编号
            /// </summary>
            public string BH;
            /// <summary>
            /// 交款单位名称
            /// </summary>
            public string JKDWMC;
            /// <summary>
            /// 经办人姓名
            /// </summary>
            public string JBRXM;
            /// <summary>
            /// 经办人证件类型
            /// </summary>
            public string JBRZJLX;
            /// <summary>
            /// 经办人证件号码
            /// </summary>
            public string JBRZJHM;
            /// <summary>
            /// 假币信息
            /// </summary>
            public string JBXX;
            /// <summary>
            /// 数量合计小写
            /// </summary>
            public string SLHJXX;
            /// <summary>
            /// 鉴定单位
            /// </summary>
            public string JDDW;
            /// <summary>
            /// 鉴定日期
            /// </summary>
            public string JDRQ;
            /// <summary>
            /// 鉴定证书编号
            /// </summary>
            public string JDZSBH;
        }
        public void LoadPrintData()
        {
            var entry = PrintData as Print_JRMBMSSJ_DW_1Entry;
            this.tb_RQ.Text = entry.RQ;
            this.tb_BH.Text = entry.BH;
            this.tb_JKDWMC.Text = entry.JKDWMC;
            this.tb_JBRXM.Text = entry.JBRXM;
            this.tb_JBRZJLX.Text = entry.JBRZJLX;
            this.tb_JBRZJHM.Text = entry.JBRZJHM;
            this.tb_JBXX.Text = entry.JBXX;
            this.tb_SLHJXX.Text = entry.SLHJXX;
            this.tb_SLHJDX.Text = SystemFunction.NumToChinese(entry.SLHJXX);
            this.tb_JDDW.Text = entry.JDDW;
            this.tb_JDRQ.Text = entry.JDRQ;
            this.tb_JDBH.Text = entry.JDZSBH;
        }
    }
}
