﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Contract.Function;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Interaction logic for Print_LoanRecovery.xaml
    /// </summary>
    public partial class Print_LoanRecovery : IPrintContract
    {
        string FLAG = TellerSystem.ServiceProxy.Ext.ServiceHelper.TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        public Print_LoanRecovery(Print_LoanRecoveryEntry entry)
        {
            InitializeComponent();
            PrintData=entry;
        }

        public class Print_LoanRecoveryEntry : PrintEntry
        {
            public Print_LoanRecoveryEntry()
            {
                //默认带有介质
                HasJZ = true;
                //默认显示"是否带介质"
                DisplayHasJZ = true;
            }

            /// <summary>
            /// 是否带介质
            /// </summary>
            public bool HasJZ { get; set; }
            /// <summary>
            /// 是否显示"是否带介质"
            /// </summary>
            public bool DisplayHasJZ { get; set; }
            /// <summary>
            /// 借款单位
            /// </summary>
            public string JKDW { get; set; }
            /// <summary>
            /// 交易类型
            /// </summary>
            public string JYLX { get; set; }
            /// <summary>
            /// 借款账号
            /// </summary>
            public string JKZH { get; set; }
            /// <summary>
            /// 利率
            /// </summary>
            public string LL { get; set; }
            /// <summary>
            /// 还款单位
            /// </summary>
            public string HKDW { get; set; }
            /// <summary>
            /// 起息日期
            /// </summary>
            public string JXRQ { get; set; }
            /// <summary>
            /// 还款账号
            /// </summary>
            public string HKZH { get; set; }
            /// <summary>
            /// 止息日期
            /// </summary>
            public string ZXRQ { get; set; }
            public string Year { get; set; }
            public string Month { get; set; }
            public string Day { get; set; }
            /// <summary>
            /// 柜员
            /// </summary>
            public string GY { get; set; }
            #region 3101还本
            /// <summary>
            /// 产品名称
            /// </summary>
            public string tbCPMC { get; set; }
            /// <summary>
            /// 还款方式
            /// </summary>
            //public string tbXZBZ { get; set; }
            /// <summary>
            /// 贷款本金
            /// </summary>
            public string tbDKBJ { get; set; }
            /// <summary>
            /// 违 约 金
            /// </summary>
            public string tbBCHX { get; set; }
            /// <summary>
            /// 本次还息
            /// </summary>
            public string tblx { get; set; }
            /// <summary>
            /// 本次还本
            /// </summary>
            public string tbBCHB { get; set; }
            /// <summary>
            /// 本次合计
            /// </summary>
            public string tbBCHJ { get; set; }
            /// <summary>
            /// 累计还本
            /// </summary>
            public string tbLJHB { get; set; }
            /// <summary>
            /// 尚欠本金
            /// </summary>
            public string tbSQBJ { get; set; }
            #endregion
            /// <summary>
            /// 到期日期
            /// </summary>
            public string tbDqrq { get; set; }
            /// <summary>
            /// 操作类型
            /// </summary>
            public string tbCZLX { get; set; }
            #region 3102还息
            /// <summary>
            /// 计息方式
            /// </summary>
            public string tbJXFS { get; set; }
            /// <summary>
            /// 贷款余额
            /// </summary>
            public string tbDKYE { get; set; }
            /// <summary>
            /// 表内利息
            /// </summary>
            public string tbBNLX { get; set; }
            /// <summary>
            /// 表外利息
            /// </summary>
            public string tbBWLX { get; set; }
            /// <summary>
            /// 复利利息
            /// </summary>
            public string tbFLLX { get; set; }
            /// <summary>
            /// 当期利息
            /// </summary>
            public string tbDQLX { get; set; }
            /// <summary>
            /// 本次还息
            /// </summary>
            public string tbBCLX { get; set; }
            /// <summary>
            /// 尚未还息
            /// </summary>
            public string tbWHQX { get; set; }
            #endregion
            #region 3104
            /// <summary>
            /// 偿还本金
            /// </summary>
            public string tbCHBJ { get; set; }
            /// <summary>
            /// 偿还利息
            /// </summary>
            public string tbCHLX { get; set; }
            /// <summary>
            /// 本次偿还
            /// </summary>
            public string tbBCHC { get; set; }
            #endregion
            #region 3105
            /// <summary>
            /// 利    息
            /// </summary>
            public string tbLX { get; set; }
            /// <summary>
            /// 加收利息
            /// </summary>
            public string tbJSLX { get; set; }
            #endregion
        }

        #region IPrintContract Members

        public Contract.Entry.PrintEntry PrintData { get; private set; }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_LoanRecoveryEntry;
            if (entry == null)
                return;


            TB_lsh.SetPrintTextBlock(this.PrintAttribute.SerialNumber);//柜员流水
            tb_ls.SetPrintTextBlock(this.PrintAttribute.BusinessTransaction);//核心流水

            this.TB_JKDW.Text = entry.JKDW;//借款单位
            this.TB_JYLX.Text = entry.JYLX;//交易类型
            this.TB_JKZH.Text = entry.JKZH;//借款账号
            this.TB_LL.Text = entry.LL.TrimStart('0');//利率
            this.TB_HKDW.Text = entry.HKDW;//还款单位
            this.TB_JXRQ.Text = entry.JXRQ;//起息日期
            this.TB_HKZH.Text = entry.HKZH;//还款账号
            this.TB_ZXRQ.Text = entry.ZXRQ;//止息日期
            this.Year.Text = entry.Year;
            this.Month.Text = entry.Month;
            this.Day.Text = entry.Day;
            TB_GY.SetPrintTextBlock(entry.GY);//柜员
            #region 3101
            CPMC.SetPrintTextBlock(entry.tbCPMC);//产品名称
            //XZBZ.SetPrintTextBlock(entry.tbXZBZ);//还款方式
            DKBJ.SetPrintTextBlock(UserFunction.ChangeMoneySymbol("01") + entry.tbDKBJ.ToDecimal().ToString("N2"));//贷款本金
            BCHX.SetPrintTextBlock(UserFunction.ChangeMoneySymbol("01") + entry.tbBCHX.ToDecimal().ToString("N2"));//违 约 金
            lx.SetPrintTextBlock(UserFunction.ChangeMoneySymbol("01") + entry.tblx.ToDecimal().ToString("N2"));//本次还息
            BCHB.SetPrintTextBlock(UserFunction.ChangeMoneySymbol("01") + entry.tbBCHB.ToDecimal().ToString("N2"));//本次还本
            BCHJ.SetPrintTextBlock(UserFunction.ChangeMoneySymbol("01") + entry.tbBCHJ.ToDecimal().ToString("N2"));//本次合计
            LJHB.SetPrintTextBlock(UserFunction.ChangeMoneySymbol("01") + entry.tbLJHB.ToDecimal().ToString("N2"));//累计还本
            SQBJ.SetPrintTextBlock(UserFunction.ChangeMoneySymbol("01") + entry.tbSQBJ.ToDecimal().ToString("N2"));//尚欠本金
            if (FLAG == "V21")
            {
                WHQX.Visibility = Visibility.Visible;//尚未还息
            }
            #endregion
            Dqrq.SetPrintTextBlock(entry.tbDqrq);//到期日期
            CZLX.SetPrintTextBlock(entry.tbCZLX);//操作类型
            #region 3102
            JXFS.SetPrintTextBlock(entry.tbJXFS);//计息方式
            DKYE.SetPrintTextBlock(UserFunction.ChangeMoneySymbol("01") + entry.tbDKYE.ToDecimal().ToString("N2"));//贷款余额
            BNLX.SetPrintTextBlock(UserFunction.ChangeMoneySymbol("01") + entry.tbBNLX.ToDecimal().ToString("N2"));//表内利息
            BWLX.SetPrintTextBlock(UserFunction.ChangeMoneySymbol("01") + entry.tbBWLX.ToDecimal().ToString("N2"));//表外利息
            FLLX.SetPrintTextBlock(UserFunction.ChangeMoneySymbol("01") + entry.tbFLLX.ToDecimal().ToString("N2"));//复利利息
            DQLX.SetPrintTextBlock(UserFunction.ChangeMoneySymbol("01") + entry.tbDQLX.ToDecimal().ToString("N2"));//当期利息
            BCLX.SetPrintTextBlock(UserFunction.ChangeMoneySymbol("01") + entry.tbBCLX.ToDecimal().ToString("N2"));//本次还息
            WHQX.SetPrintTextBlock(UserFunction.ChangeMoneySymbol("01") + entry.tbWHQX.ToDecimal().ToString("N2"));//尚未还息
            if (entry.tbCZLX.Equals("贷款还息"))
            {
                CPMC.Visibility = DKBJ.Visibility = BCHX.Visibility = lx.Visibility = BCHB.Visibility = BCHJ.Visibility = LJHB.Visibility = SQBJ.Visibility = Visibility.Collapsed;
                JXFS.Visibility = DKYE.Visibility = BNLX.Visibility = BWLX.Visibility = FLLX.Visibility = DQLX.Visibility = BCLX.Visibility = WHQX.Visibility = Visibility.Visible;
            }
            if (FLAG == "V21")
            {
                SQBJ.Visibility = Visibility.Visible;//尚欠本金
                SQBJ.SetValue(Canvas.TopProperty, 313.00);
            }
            #endregion
            #region 3104
            CHBJ.SetPrintTextBlock(UserFunction.ChangeMoneySymbol("01") + entry.tbCHBJ.ToDecimal().ToString("N2"));//偿还本金
            CHLX.SetPrintTextBlock(UserFunction.ChangeMoneySymbol("01") + entry.tbCHLX.ToDecimal().ToString("N2"));//偿还利息
            BCHC.SetPrintTextBlock(UserFunction.ChangeMoneySymbol("01") + entry.tbBCHC.ToDecimal().ToString("N2"));//本次偿还
            if (entry.tbCZLX.Equals("按揭贷款还款"))
            {
                BCHX.Visibility = lx.Visibility = BCHB.Visibility = BCHJ.Visibility = Dqrq.Visibility = WHQX.Visibility = Visibility.Collapsed;
                CHBJ.Visibility = CHLX.Visibility = BCHC.Visibility = Visibility.Visible;
            }
            #endregion
            #region 3105
            LX.SetPrintTextBlock(UserFunction.ChangeMoneySymbol("01") + entry.tbLX.ToDecimal().ToString("N2"));//利    息
            JSLX.SetPrintTextBlock(UserFunction.ChangeMoneySymbol("01") + entry.tbJSLX.ToDecimal().ToString("N2"));//加收利息
            if (entry.tbCZLX.Equals("按揭贷款提前还本"))
            {
                CPMC.Visibility = DKBJ.Visibility = BCHX.Visibility = lx.Visibility = Dqrq.Visibility = WHQX.Visibility = BCHJ.Visibility = SQBJ.Visibility = Visibility.Collapsed;
                LX.Visibility = JSLX.Visibility = DKYE.Visibility = Visibility.Visible;
            }
            #endregion

            if (FLAG == "V22")
            {
                this.E_Seal_Location = new Point(533, 234);
            }
            if (FLAG == "V21")
            {
                this.E_Seal_Location = new Point(533, 234);
                canvas_main.Margin = new Thickness(0, -15, 0, 0);
                Year.SetValue(Canvas.LeftProperty, 304.00);
                Month.SetValue(Canvas.LeftProperty, 352.00);
                Day.SetValue(Canvas.LeftProperty, 390.00);
            }
        }
        #endregion
    }
}
