﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Print_LossesAccount.xaml 的交互逻辑
    /// </summary>
    public partial class Print_LossesAccount : IPrintContract
    {
        public Print_LossesAccount(Print_LossesAccountEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public Contract.Entry.PrintEntry PrintData
        {
            get;
            private set;
        }

        public class Print_LossesAccountEntry : PrintEntry
        {
            /// <summary>
            /// 标题
            /// </summary>
            public string title { get; set; }
            
            /// <summary>
            /// 挂账账号
            /// </summary>
            public string GZZH { get; set; }

            /// <summary>
            /// 币种
            /// </summary>
            public string BZ { get; set; }

            /// <summary>
            /// 销账日期
            /// </summary>
            public string XZH { get; set; }

            
            /// <summary>
            /// 日期
            /// </summary>
            public string RQ { get; set; }

            
            /// <summary>
            /// 打印次数
            /// </summary>
            public string DYCS { get; set; }

            
            /// <summary>
            /// 销账日期
            /// </summary>
            public string XZRQ { get; set; }

            
            /// <summary>
            /// 销账机构
            /// </summary>
            public string XZJG { get; set; }

            
            /// <summary>
            /// 销账笔序号
            /// </summary>
            public string XZBXH { get; set; }

            
            /// <summary>
            /// 对方账号
            /// </summary>
            public string DFZH { get; set; }

            
            /// <summary>
            /// 销账经办
            /// </summary>
            public string XZJB { get; set; }

            
            /// <summary>
            /// 销账复核
            /// </summary>
            public string XZFH { get; set; }

           
            /// <summary>
            /// 销账授权
            /// </summary>
            public string XZSQ { get; set; }

           
            /// <summary>
            /// 挂账日期
            /// </summary>
            public string GZRQ { get; set; }

            
            /// <summary>
            /// 挂账机构
            /// </summary>
            public string GZJG { get; set; }

            
            /// <summary>
            /// 收报机构
            /// </summary>
            public string SBJG { get; set; }

            
            /// <summary>
            /// 原对方账号
            /// </summary>
            public string YDFZH { get; set; }

            
            /// <summary>
            /// 挂账经办
            /// </summary>
            public string GZJB { get; set; }

            
            /// <summary>
            /// 挂账复核
            /// </summary>
            public string GZFH { get; set; }

            
            /// <summary>
            /// 挂账授权
            /// </summary>
            public string GZSQ { get; set; }

            /// <summary>
            /// 打印柜员
            /// </summary>
            public string DYGY { get; set; }

            /// <summary>
            /// 主管
            /// </summary>
            public string ZG { get; set; }

            
            /// <summary>
            /// 授权
            /// </summary>
            public string SQ { get; set; }

            
            /// <summary>
            /// 摘要
            /// </summary>
            public string ZY { get; set; }

            /// <summary>
            /// 销账金额
            /// </summary>
            public string XZJE { get; set; }

            /// <summary>
            /// 销账流水
            /// </summary>
            public string XZLS { get; set; }


            /// <summary>
            /// 挂账金额
            /// </summary>
            public string GZJE { get; set; }


            /// <summary>
            /// 挂账流水
            /// </summary>
            public string GZLS { get; set; }

        }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_LossesAccountEntry;
            RQ.Text = entry.RQ;
            DYCS.Text = entry.DYCS;
            GZZH.Text = entry.GZZH;
            BZ.Text = entry.BZ;
            XZH.Text = entry.XZH;
            XZRQ.Text = entry.XZRQ;
            XZJG.Text = entry.XZJG;
            XZBXH.Text = entry.XZBXH;
            DFZH.Text = entry.DFZH;
            XZJB.Text = entry.XZJB;
            XZFH.Text = entry.XZFH;
            XZSQ.Text = entry.XZSQ;
            GZRQ.Text = entry.GZRQ;
            GZJG.Text = entry.GZJG;
            SBJG.Text = entry.SBJG;
            YDFZH.Text = entry.YDFZH;
            GZJB.Text = entry.GZJB;
            GZFH.Text = entry.GZFH;
            GZSQ.Text = entry.GZSQ;
            ZY.Text = entry.ZY;
            DYGY.Text = entry.DYGY;
            ZG.Text = entry.ZG;
            SQ.Text = entry.SQ;
            title.Text = entry.title;
            XZJE.Text = entry.XZJE;
            XZLS.Text = entry.XZLS;
            GZJE.Text = entry.GZJE;
            GZLS.Text = entry.GZLS;
        }

        
    }
}
