﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Contract.Function;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Interaction logic for Print_NXYTCTD_RF.xaml
    /// </summary>
    public partial class Print_NXYTCTD_RF : IPrintContract
    {

        public Print_NXYTCTD_RF(Print_NXYTCTD_RFEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }
        string Flag = TellerSystem.ServiceProxy.Ext.ServiceHelper.TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        public class Print_NXYTCTD_RFEntry : PrintEntry
        {
            /// <summary>
            /// 通兑方式
            /// </summary>
            public string TDFS { get; set; }

            /// <summary>
            /// 交易金额
            /// </summary>
            public string JYJE { get; set; }

            /// <summary>
            /// 付款人账号
            /// </summary>
            public string FKRZH { get; set; }

            /// <summary>
            /// 付款行行号
            /// </summary>
            public string FKHHH { get; set; }

            /// <summary>
            /// 付款行行名
            /// </summary>
            public string FKHHM { get; set; }

            /// <summary>
            /// 付款账户介质
            /// </summary>
            public string FKZHJZ { get; set; }

            /// <summary>
            /// 收款人账号
            /// </summary>
            public string SKRZH { get; set; }

            /// <summary>
            /// 手续费标志
            /// </summary>
            public string SXFBZ { get; set; }

            /// <summary>
            /// 手续费
            /// </summary>
            public string SXF { get; set; }

            /// <summary>
            /// 核心流水
            /// </summary>
            public string HXLS { get; set; }

            /// <summary>
            /// 币种
            /// </summary>
            public string BZ1 { get; set; }

            /// <summary>
            /// 付款人名称
            /// </summary>
            public string FKRMC { get; set; }

            /// <summary>
            /// 收款人名称
            /// </summary>
            public string SKRMC { get; set; }

            /// <summary>
            /// 平台日期
            /// </summary>
            public string PTRQ { get; set; }

            /// <summary>
            /// 收款行行号
            /// </summary>
            public string SKHHH { get; set; }

            /// <summary>
            /// 收款行行名
            /// </summary>
            public string SKHHM { get; set; }

            /// <summary>
            /// 收款账户介质
            /// </summary>
            public string SKZHJZ { get; set; }

            /********************  农信银客户回单打印要素  ********************/
            /// <summary>
            /// 交易日期
            /// </summary>
            public string JYRQ { get; set; }

            /// <summary>
            /// 交易名称
            /// </summary>
            public string JYMC { get; set; }

            /// <summary>
            /// 币种
            /// </summary>
            public string BZ2 { get; set; }

            /// <summary>
            /// 付款人账号
            /// </summary>
            public string FKRZH1 { get; set; }

            /// <summary>
            /// 付款人名称
            /// </summary>
            public string FKRMC1 { get; set; }

            /// <summary>
            /// 收款人账号
            /// </summary>
            public string SKRZH1 { get; set; }

            /// <summary>
            /// 收款人名称
            /// </summary>
            public string SKRMC1 { get; set; }

            /// <summary>
            /// 交易金额
            /// </summary>
            public string JYJE1 { get; set; }

            /// <summary>
            /// 经办人
            /// </summary>
            public string JBR { get; set; }

            /// <summary>
            /// 通存通兑标志
            /// </summary>
            public string TCORTD { get; set; }

        }


        public Contract.Entry.PrintEntry PrintData { get; private set; }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_NXYTCTD_RFEntry;
            if (entry == null)
                return;
            TDFS.SetPrintTextBlock(entry.TDFS);
            if (entry.TCORTD == "通存")
            {
                //通存打印收款相关信息
                SKINFO.Visibility = Visibility.Visible;
                SKRZH.SetPrintTextBlock(entry.SKRZH);
                SKRMC.SetPrintTextBlock(entry.SKRMC);
                SKHHH.SetPrintTextBlock(entry.SKHHH);
                SKHHM.SetPrintTextBlock(entry.SKHHM);
                SKZHJZ.SetPrintTextBlock(entry.SKZHJZ);
                //通存现金只打印：收款方账号和名称
                if (entry.TDFS == "转账")
                {
                    tbl_FKRZH1.Visibility = Visibility.Visible;
                    FKRZH1.Visibility = Visibility.Visible;
                    if (entry.FKRZH1.Length >= 8)
                    {
                        string acno = entry.FKRZH1.Trim();
                        string acnoTemp = acno.Substring(0, acno.Length - 8) + "****" + acno.Substring(acno.Length - 4);
                        FKRZH1.SetPrintTextBlock(acnoTemp);
                    }

                    tbl_FKRMC1.Visibility = Visibility.Visible;
                    FKRMC1.Visibility = Visibility.Visible;
                    FKRMC1.SetPrintTextBlock(entry.FKRMC1);//付款人名称(回单)
                }
                tbl_SKRZH1.Visibility = Visibility.Visible;
                SKRZH1.Visibility = Visibility.Visible;
                if (entry.SKRZH1.Length >= 8)
                {
                    string acno = entry.SKRZH1.Trim();
                    string acnoTemp = acno.Substring(0, acno.Length - 8) + "****" + acno.Substring(acno.Length - 4);
                    SKRZH1.SetPrintTextBlock(acnoTemp);
                }

                tbl_SKRMC1.Visibility = Visibility.Visible;
                SKRMC1.Visibility = Visibility.Visible;
                SKRMC1.SetPrintTextBlock(entry.SKRMC1);//收款人名称(回单)
            } 
            else
            {
                //通兑打印付款相关信息
                FKINFO.Visibility = Visibility.Visible;
                FKRZH.SetPrintTextBlock(entry.FKRZH);
                FKRMC.SetPrintTextBlock(entry.FKRMC);
                FKHHH.SetPrintTextBlock(entry.FKHHH);
                FKHHM.SetPrintTextBlock(entry.FKHHM);
                FKZHJZ.SetPrintTextBlock(entry.FKZHJZ);
                if (entry.TDFS == "转账")
                {
                    tbl_SKRZH1.Visibility = Visibility.Visible;
                    SKRZH1.Visibility = Visibility.Visible;
                    if (entry.SKRZH1.Length >= 8)
                    {
                        string acno = entry.SKRZH1.Trim();
                        string acnoTemp = acno.Substring(0, acno.Length - 8) + "****" + acno.Substring(acno.Length - 4);
                        SKRZH1.SetPrintTextBlock(acnoTemp);
                    }

                    tbl_SKRMC1.Visibility = Visibility.Visible;
                    SKRMC1.Visibility = Visibility.Visible;
                    SKRMC1.SetPrintTextBlock(entry.SKRMC1);//收款人名称(回单)
                }
                tbl_FKRZH1.Visibility = Visibility.Visible;
                FKRZH1.Visibility = Visibility.Visible;
                if (entry.FKRZH1.Length >= 8)
                {
                    string acno = entry.FKRZH1.Trim();
                    string acnoTemp = acno.Substring(0, acno.Length - 8) + "****" + acno.Substring(acno.Length - 4);
                    FKRZH1.SetPrintTextBlock(acnoTemp);
                }

                tbl_FKRMC1.Visibility = Visibility.Visible;
                FKRMC1.Visibility = Visibility.Visible;
                FKRMC1.SetPrintTextBlock(entry.FKRMC1);//付款人名称(回单)
            }
            SXFBZ.SetPrintTextBlock(entry.SXFBZ);
            SXF.SetPrintTextBlock(entry.SXF);
            HXLS.SetPrintTextBlock(entry.HXLS);
            BZ1.SetPrintTextBlock(entry.BZ1);
            PTRQ.SetPrintTextBlock(entry.PTRQ);
            JYRQ.SetPrintTextBlock(entry.JYRQ);
            JYMC.SetPrintTextBlock(entry.JYMC);
            JYJE.SetPrintTextBlock(entry.JYJE);
            BZ2.SetPrintTextBlock(entry.BZ2);
            JYJE1.SetPrintTextBlock(entry.JYJE1);
            JBR.SetPrintTextBlock(entry.JBR);
            //业务流水
            TB_lsh.SetPrintTextBlock(this.PrintAttribute.SerialNumber);
            //核心流水
            tb_ls.SetPrintTextBlock(this.PrintAttribute.BusinessTransaction);
            TB_czy.Text = LoginUserInfo.TellerNo;//柜员号
            //加载电子印章，是否显示的控制机制在内部处理
            this.E_Seal_Location = new Point(439, 269);
            //加载电子印章，是否显示的控制机制在内部处理
            
            if (Flag == "V12")
            {
                this.E_Seal2Copy(new Point(665, 364));
            }

        }
    }
}
