﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using Platform.Common.RunningParameters;
using System.Data;
using TellerSystem.Library.Ext.Function;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// 交存凭证
    /// </summary>
    public partial class Print_PayRecordsSD : IPrintContract
    {
        public Print_PayRecordsSD(Print_PayRecordsSDEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public Contract.Entry.PrintEntry PrintData { get; private set; }

        /// <summary>
        /// 凭证的打印数据实体定义
        /// </summary>
        public class Print_PayRecordsSDEntry : PrintEntry
        {
            /**********************************
             * 定义实体属性
             * 1.打印逻辑用到的要素
             * *******************************/
            /// <summary>
            /// 承办银行
            /// </summary>
            public string CBYH { get; set; }
            /// <summary>
            /// 申请编号
            /// </summary>
            public string SQBH { get; set; }
            /// <summary>
            /// 业主姓名
            /// </summary>
            public string YZXM { get; set; }
            /// <summary>
            /// 交存标准
            /// </summary>
            public string JCBZ { get; set; }
            /// <summary>
            /// 房屋地址
            /// </summary>
            public string FWDZ { get; set; }
            /// <summary>
            /// 房屋面积
            /// </summary>
            public string FWMJ { get; set; }
            /// <summary>
            /// 交存金额（大写）
            /// </summary>
            public string JCJEDX { get; set; }
            /// <summary>
            /// 交存金额（小写）
            /// </summary>
            public string JCJEXX { get; set; }

        }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_PayRecordsSDEntry;
            //传入要素 
            this.Year.Text = LoginUserInfo.TradeDate.Substring(0,4);
            this.Month.Text = LoginUserInfo.TradeDate.Substring(4, 2);
            this.Day.Text = LoginUserInfo.TradeDate.Substring(6, 2);
            this.GYXM.Text = LoginUserInfo.TellerName;
            this.CBYH.Text = entry.CBYH.Trim();
            this.CBYH.Visibility = string.IsNullOrEmpty(entry.CBYH.Trim()) ? Visibility.Collapsed : Visibility.Visible;
            this.SQBH.Text = entry.SQBH.Trim();
            this.SQBH.Visibility = string.IsNullOrEmpty(entry.SQBH.Trim())?Visibility.Collapsed:Visibility.Visible;
            this.YZXM.Text = entry.YZXM.Trim();
            this.YZXM.Visibility = string.IsNullOrEmpty(entry.YZXM.Trim()) ? Visibility.Collapsed : Visibility.Visible;
            this.JCBZ.Text = entry.JCBZ.Trim();
            this.JCBZ.Visibility = string.IsNullOrEmpty(entry.JCBZ.Trim()) ? Visibility.Collapsed : Visibility.Visible;
            this.FWDZ.Text = entry.FWDZ.Trim();
            this.FWDZ.Visibility = string.IsNullOrEmpty(entry.FWDZ.Trim()) ? Visibility.Collapsed : Visibility.Visible;
            this.FWMJ.Text = entry.FWMJ.Trim();
            this.FWMJ.Visibility = string.IsNullOrEmpty(entry.FWMJ.Trim()) ? Visibility.Collapsed : Visibility.Visible;
            this.FWMJ1.Text = entry.FWMJ.Trim();
            this.FWMJ1.Visibility = string.IsNullOrEmpty(entry.FWMJ.Trim()) ? Visibility.Collapsed : Visibility.Visible;
            this.JCJEDX.Text = entry.JCJEDX.Trim();
            this.JCJEDX.Visibility = string.IsNullOrEmpty(entry.JCJEDX.Trim()) ? Visibility.Collapsed : Visibility.Collapsed;
            this.JCJEXX.Text = entry.JCJEXX.Trim();
            this.JCJEXX.Visibility = string.IsNullOrEmpty(entry.JCJEXX.Trim()) ? Visibility.Collapsed : Visibility.Visible;
            this.JCJEDX_1.Text = ChangeToCNY((entry.JCJEXX).ToDecimal());
        }

        private string ChangeToCNY(decimal NUM)
        {
            string str1 = "零壹贰叁肆伍陆柒捌玖";
            string STR =  Convert.ToInt32(NUM*100).ToString().PadLeft(10, '0');
            string NUMBER = string.Empty;
            for (int i = 0; i < 10; i++)
            {
                int tmp = Int32.Parse(STR.Substring(i, 1));
                NUMBER += str1.Substring(tmp, 1);
                NUMBER += i % 2 == 0 ? "     " : "    ";
            }
            return NUMBER;
        }
    }
}

