﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Contract.Function;
using TellerSystem.PrintTemplate.Base;
using TellerSystem.PrintTemplate.Extension;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Interaction logic for Print_PersonalAccountingVoucher_Deposit.xaml
    /// </summary>
    public partial class Print_PersonalAccountingVoucher_Deposit : IPrintContract
    {
        string FLAG = TellerSystem.ServiceProxy.Ext.ServiceHelper.TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        public Print_PersonalAccountingVoucher_Deposit(Print_PersonalAccountingVoucher_DepositEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public class Print_PersonalAccountingVoucher_DepositEntry : PrintEntry
        {
            public Print_PersonalAccountingVoucher_DepositEntry()
            {
                //默认带有介质
                HasJZ = true;
                //默认显示"是否带介质"
                DisplayHasJZ = true;
            }

            /// <summary>
            /// 银行留存联账号
            /// </summary>
            public string Acno { get; set; }
            /// <summary>
            /// 客户回单账户
            /// </summary>
            public string Acno1 { get; set; }

            /// <summary>
            /// 账户序号
            /// </summary>
            public string ZHXH { get; set; }

            /// <summary>
            /// 开户行名
            /// </summary>
            public string OpnName { get; set; }

            /// <summary>
            /// 账户户名
            /// </summary>
            public string ZHHM { get; set; }

            /// <summary>
            /// 交易金额
            /// </summary>
            public decimal TxAmt { get; set; }

            /// <summary>
            /// 账户余额
            /// </summary>
            public string tbAccount { get; set; }

            /// <summary>
            /// 余额
            /// </summary>
            public decimal Bal { get; set; }
            /// <summary>
            /// 利率
            /// </summary>
            public string Rate { get; set; }

            /// <summary>
            /// 储种
            /// </summary>
            public string PrdtName { get; set; }

            /// <summary>
            /// 存期
            /// </summary>
            // public string Term { get; set; }

            /// <summary>
            /// 凭证号码
            /// </summary>
            public string NoteNo { get; set; }

            /// <summary>
            /// 科目
            /// </summary>
            public string Subject { get; set; }

            /// <summary>
            /// 是否带介质
            /// </summary>
            public bool HasJZ { get; set; }

            /// <summary>
            /// 是否显示"是否带介质"
            /// </summary>
            public bool DisplayHasJZ { get; set; }

            /// <summary>
            /// 现转标志
            /// </summary>
            public string CtInd { get; set; }

            /// <summary>
            /// 交易类型
            /// </summary>
            public string TradeType { get; set; }

            /// <summary>
            /// 对方账号
            /// </summary>
            public string DfAcno { get; set; }

            /// <summary>
            /// 对方户名
            /// </summary>
            public string DfAcname { get; set; }

            /// <summary>
            /// 币种
            /// </summary>
            public string BZ { get; set; }
            /// <summary>
            /// 流水号
            /// </summary>
            public string LSH { get; set; }
            /// <summary>
            /// 表头
            /// </summary>
            public string Title { get; set; }
            /// <summary>
            /// 留密户
            /// </summary>
            public string Lmh { get; set; }
            /// <summary>
            ///自动转存
            /// </summary>
            public string ZDZC { get; set; }
            /// <summary>
            /// 通存标志
            /// </summary>
            public string TCBZ { get; set; }
            /// <summary>
            /// 账户类型
            /// </summary>
            public string PZHLX { get; set; }
            /// <summary>
            /// 证件类型
            /// </summary>
            public string zjlx { get; set; }
            /// <summary>
            /// 证件号码
            /// </summary>
            public string zjhm { get; set; }

            public string DLRBZ { get; set; }
            public string DLRMC { get; set; }
            public string DLRHM { get; set; }
            public string DLRSJH { get; set; }
            public string DLRZJLX { get; set; }
            public string FLBS { get; set; }
            /// <summary>
            /// 存款保险条例
            /// </summary>
            public string BZ1 { get; set; }
            /// <summary>
            /// 代理人证件有效期
            /// </summary>
            public string DLRYXQ { get; set; }

            /// <summary>
            /// 联网核查结果
            /// </summary>
            public string LWHCJG = string.Empty;
        }

        #region IPrintContract Members

        public Contract.Entry.PrintEntry PrintData { get; private set; }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_PersonalAccountingVoucher_DepositEntry;
            if (entry == null)
                return;
            //采用无纸化方案时，重新定向到业务凭条版本
            if (this.ElecSealHelper.Mode == PrintTemplate.ElecSeal.SealMode.Paperless)
            {
                entry.IsBatchPrint = true;
                entry.BatchList = new System.Collections.Generic.List<Platform.Print.PrintContainer>
                {
                    new Print_BusinessVoucher_Deposit(new Print_BusinessVoucher_Deposit.Print_BusinessVoucher_Deposit_Entry()
                    {
                        Acno = entry.Acno,
                        ZHXH = entry.ZHXH,
                        OpnName = entry.OpnName,
                        ZHHM = entry.ZHHM,
                        TxAmt = entry.TxAmt,
                        tbAccount = entry.tbAccount,
                        Bal = entry.Bal,
                        Rate = entry.Rate,
                        PrdtName = entry.PrdtName,
                        NoteNo = entry.NoteNo,
                        Subject = entry.Subject,
                        HasJZ = entry.HasJZ,
                        DisplayHasJZ = entry.DisplayHasJZ,
                        CtInd = entry.CtInd,
                        TradeType = entry.TradeType,
                        DfAcno = entry.DfAcno,
                        DfAcname = entry.DfAcname,
                        BZ = entry.BZ,
                        LSH = entry.LSH,
                        Title = entry.Title,
                        Lmh = entry.Lmh,
                        ZDZC = entry.ZDZC,
                        TCBZ = entry.TCBZ,
                        PZHLX = entry.PZHLX,
                        zjlx = entry.zjlx,
                        zjhm = entry.zjhm,
                        DLRBZ = entry.DLRBZ,
                        DLRMC = entry.DLRMC,
                        DLRHM = entry.DLRHM,
                        DLRSJH = entry.DLRSJH,
                        DLRZJLX = entry.DLRZJLX,
                        FLBS = entry.FLBS,
                        BZ1 = entry.BZ1,
                    })
                };
                return;
            }
            TB_title.Text = entry.Title;
            TB_Prdt2.Text = "储    种:{0}";
            if (FLAG == "V0")
            {
                TB_Acno2.Text = "账号:{0}";
                TB_Prdt1.Text = "储种:{0}";
                TB_Prdt2.Text = "储种:{0}";
                TB_HM2.Text = "户名:{0}";
            }
            switch (entry.TCBZ[4].ToString().Trim())
            {
                case "0":
                    TB_TCBZ.SetPrintTextBlock("非通存通兑");
                    break;
                case "1":
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
                case "2":
                    TB_TCBZ.SetPrintTextBlock("通存非通兑");
                    break;
                default:
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
            }

            TB_OPNNAME.SetPrintTextBlock(entry.OpnName);
            TB_Acno1.SetPrintTextBlock(entry.Acno);
            TB_Acno2.SetPrintTextBlock(entry.Acno.Substring(0, 6) + "****" + entry.Acno.Substring(entry.Acno.Length - 2, 2));

            TB_ZHXH.SetPrintTextBlock(entry.ZHXH);
            TB_ZHXH2.SetPrintTextBlock(entry.Acno.Substring(0, 6) + "****" + entry.Acno.Substring(entry.Acno.Length - 4, 4) + "-" + entry.ZHXH);
            TB_HM1.SetPrintTextBlock(entry.ZHHM);
            //辰州存款凭条客户姓名隐藏脱密
            if (FLAG == "V9")
            {
                TB_HM2.SetPrintTextBlock(entry.ZHHM.Substring(0, 1) + "**");
            }
            else
            {
                TB_HM2.SetPrintTextBlock(entry.ZHHM);
            }
            TB_Note1.SetPrintTextBlock(entry.NoteNo.PadLeft(TellerSystem.Library.Ext.Variables.UserVariable.Len_VoucherNo, '0'));
            var type = UserFunction.ChangeMoneySymbol(entry.BZ);
            TB_TxAmt1.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            TB_TxAmt2.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            //天山新增证件类型,证件号码
            ZJLX.SetPrintTextBlock(entry.zjlx);
            ZJHM.SetPrintTextBlock(entry.zjhm);
            if (entry.tbAccount != null)
            {
                tb_Account.Visibility = Visibility.Visible;
                tb_Account.SetPrintTextBlock(type + entry.tbAccount.ToDecimal().ToString("N2"));
            }
            if (entry.PZHLX != null)
            {
                ZHLX.Visibility = Visibility.Visible;
                ZHLX.SetPrintTextBlock(entry.PZHLX);
            }
            if (entry.FLBS == "true")
            {
                FLBS.Visibility = Visibility.Visible;
            }
            if (entry.HasJZ)
            {
                TB_HasMdm1.SetPrintTextBlock("是");
            }
            else
            {
                TB_HasMdm1.SetPrintTextBlock("否");
            }
            TB_HasMdm1.Visibility = entry.DisplayHasJZ ? Visibility.Visible : Visibility.Hidden;

            TB_Prdt1.SetPrintTextBlock(entry.PrdtName);
            TB_Prdt2.SetPrintTextBlock(entry.PrdtName);
            //业务流水
            TB_lsh.SetPrintTextBlock(this.PrintAttribute.SerialNumber);
            //核心流水
            tb_ls.SetPrintTextBlock(this.PrintAttribute.BusinessTransaction);
            //TB_sqy.SetPrintTextBlock(this.PrintAttribute.Authentic);//授权柜员号 
            TB_rq.SetPrintTextBlock(LoginUserInfo.TradeDate);
            //TB_czy.SetPrintTextBlock("("+LoginUserInfo.TellerName+")"+LoginUserInfo.TellerNo);
            //TB_sqy.SetPrintTextBlock(this.PrintAttribute.Authno);//授权柜员号 
            TB_sqy.Text = this.PrintAttribute.Authno;
            // TB_czy.SetPrintTextBlock(LoginUserInfo.TellerNo);
            TB_czy.Text = LoginUserInfo.TellerNo;
            TB_jyh.SetPrintTextBlock(LoginUserInfo.KinbrNo);
            //if (string.IsNullOrEmpty(entry.Term))
            //{
            //    TB_Term1.Visibility = Visibility.Hidden;
            //}
            //else
            //{
            //    TB_Term1.SetPrintTextBlock(entry.Term);
            //}
            TB_TradeType1.SetPrintTextBlock(entry.TradeType);
            TB_jylx.SetPrintTextBlock(entry.TradeType);
            TB_CtInd1.SetPrintTextBlock(entry.CtInd);
            // TB_CtInd2.SetPrintTextBlock(entry.CtInd);
            if (string.IsNullOrEmpty(entry.DfAcno))
            {
                TB_DfAcno1.Visibility = Visibility.Hidden;
                TB_DfAcno2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_DfAcno1.SetPrintTextBlock(entry.DfAcno);
                TB_DfAcno2.SetPrintTextBlock(entry.DfAcno.Substring(0, 6) + "****" + entry.DfAcno.Substring(entry.DfAcno.Length - 2, 2));
            }
            if (string.IsNullOrEmpty(entry.DfAcname))
            {
                TB_DfAcname1.Visibility = Visibility.Hidden;
                TB_DfAcname2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_DfAcname1.SetPrintTextBlock(entry.DfAcname);
                TB_DfAcname2.SetPrintTextBlock(entry.DfAcname);
            }
            TB_SFLM.SetPrintTextBlock(entry.Lmh);
            if (!string.IsNullOrEmpty(entry.ZDZC))
            {
                TB_ZDZC.Visibility = TB_ZDZC1.Visibility = Visibility.Visible;
                TB_ZDZC.SetPrintTextBlock(entry.ZDZC);
                TB_ZDZC1.SetPrintTextBlock(entry.ZDZC);
            }
            //公共要素
            var tradedate = LoginUserInfo.TradeDate.ToDateTime();
            TB_Teller2.SetPrintTextBlock(LoginUserInfo.TellerNo);
            TB_Jyra.SetPrintTextBlock(LoginUserInfo.TradeDate);
            if (!string.IsNullOrEmpty(entry.Rate))
            {
                TB_Rate1.SetPrintTextBlock(string.Format("{0:N6}%", entry.Rate));
                TB_Rate2.SetPrintTextBlock(string.Format("{0:N6}%", entry.Rate));
            }
            else
            {
                TB_Rate1.SetPrintTextBlock(string.Empty);
                TB_Rate2.SetPrintTextBlock(string.Empty);
            }
            //代理人信息
            if (entry.DLRBZ == "Y")
            {
                if (!string.IsNullOrWhiteSpace(entry.DLRZJLX))
                {
                    TB_DLRZJLX.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrWhiteSpace(entry.DLRHM))
                {
                    TB_DLRHM.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrWhiteSpace(entry.DLRMC))
                {
                    TB_DLRMC.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrWhiteSpace(entry.DLRSJH))
                {
                    TB_DLRSJH.Visibility = Visibility.Visible;
                }
                TB_DLRZJLX.SetPrintTextBlock(entry.DLRZJLX);
                TB_DLRHM.SetPrintTextBlock(entry.DLRHM);
                TB_DLRMC.SetPrintTextBlock(entry.DLRMC);
                TB_DLRSJH.SetPrintTextBlock(entry.DLRSJH);
                if (FLAG == "V11")
                {
                    if (!string.IsNullOrWhiteSpace(entry.DLRYXQ))
                    {
                        TB_DLRYXQ.Visibility = Visibility.Visible;
                    }
                    TB_DLRYXQ.SetPrintTextBlock(entry.DLRYXQ);
                }
            }
            if (FLAG == "V19")  //天山-大写金额
            {
                DXJE.Visibility = Visibility.Visible;
                DXJE.SetPrintTextBlock(SystemFunction.ChangeToCNY(entry.TxAmt));
            }
            if (FLAG == "V4")
            {
                TB_czy.Visibility = Visibility.Collapsed;
                TB_sqy.Visibility = Visibility.Collapsed;
            }
            if (FLAG == "V6")
            {
                if (LoginUserInfo.KinbrNo.Contains("103"))
                {
                    TB_czy.Visibility = Visibility.Collapsed;
                    TB_sqy.Visibility = Visibility.Collapsed;
                }
                else if (LoginUserInfo.KinbrNo.Contains("106"))
                {
                    TB_czy.SetValue(Canvas.TopProperty, 297.00);
                    TB_sqy.SetValue(Canvas.TopProperty, 297.00);
                }
            }
            if (FLAG == "V0")
            {
                //中牟需求 存款凭条柜员号打印位置上移2毫米
                TB_czy.SetValue(Canvas.TopProperty, 303.00);
                TB_sqy.SetValue(Canvas.TopProperty, 303.00);

                //中牟需求 新储种过长 右侧整体向右偏移两个字节
                TB_HM1.SetValue(Canvas.LeftProperty, 298.00);
                TB_Rate1.SetValue(Canvas.LeftProperty, 298.00);
                TB_rq.SetValue(Canvas.LeftProperty, 298.00);
                TB_DfAcno1.SetValue(Canvas.LeftProperty, 298.00);
                TB_SFLM.SetValue(Canvas.LeftProperty, 298.00);
                TB_DfAcname1.SetValue(Canvas.LeftProperty, 298.00);
                TB_DLRHM.SetValue(Canvas.LeftProperty, 298.00);
                TB_DLRSJH.SetValue(Canvas.LeftProperty, 298.00);

                TB_OPNNAME.SetValue(Canvas.LeftProperty, 455.00);
                TB_jyh.SetValue(Canvas.LeftProperty, 455.00);
                TB_TradeType1.SetValue(Canvas.LeftProperty, 455.00);
                TB_HasMdm1.SetValue(Canvas.LeftProperty, 455.00);
                TB_ZDZC.SetValue(Canvas.LeftProperty, 455.00);
                tb_Account.SetValue(Canvas.LeftProperty, 455.00);
                TB_HasMdm1.SetValue(Canvas.TopProperty, 192.00);
                tb_Account.SetValue(Canvas.TopProperty, 248.00);
                //交易复核人 
                if (!string.IsNullOrWhiteSpace(PrintAttribute.Review))
                {
                    var review = PrintAttribute.Review;
                    TB_sqy.Text = review.Substring(review.IndexOf("(") + 1, 6);
                }
                else
                {
                    TB_sqy.Visibility = Visibility.Collapsed;
                }
                //授权柜员号
                TB_Super.SetPrintTextBlock(PrintAttribute.Authno);
                TB_Super.Visibility = !string.IsNullOrWhiteSpace(PrintAttribute.Authno) ? Visibility.Visible : Visibility.Collapsed;
                //柜员流水、业务流水、TB_title一行
                TB_title.SetValue(Canvas.LeftProperty, 394.00);
                tb_ls.SetValue(Canvas.TopProperty, 72.00);
                TB_lsh.SetValue(Canvas.TopProperty, 72.00);
                //账户余额不显示
                tb_Account.Visibility = Visibility.Collapsed;
            }
            if (FLAG == "V5")
            {
                //山东需求 存款凭条柜员号打印位置上移14毫米
                TB_czy.SetValue(Canvas.TopProperty, 293.00);
                TB_sqy.SetValue(Canvas.TopProperty, 293.00);
                if (string.IsNullOrEmpty(entry.Rate))
                {
                    TB_Rate1.Visibility = Visibility.Collapsed;
                    TB_Rate2.Visibility = Visibility.Collapsed;
                }
                //山东储蓄类型过长利率需要进行往右移
                TB_Rate1.SetValue(Canvas.LeftProperty, 310.00);
                //暂未发 先注释20210105 回单章
                this.ElecSealHelper.Sign2Point(new Point(620, 180), TellerSystem.PrintTemplate.ElecSeal.SealKind.Receipt);//客户联印章

                //交易日期和交易类型互换位置
                TB_Jyra.SetValue(Canvas.TopProperty, 136.00);
                TB_Jyra.SetValue(Canvas.LeftProperty, 629.00);
                TB_jylx.SetValue(Canvas.TopProperty, 196.00);
                TB_jylx.SetValue(Canvas.LeftProperty, 629.00);

                if (LoginUserInfo.KinbrNo.Substring(0, 3) == "302")//黄骅
                {
                    TB_czy.SetValue(Canvas.TopProperty, 300.00);//300->290->300  NZYB
                    TB_czy.SetValue(Canvas.LeftProperty, 420.00);
                    TB_czy.Text = LoginUserInfo.TellerNo + "(" + LoginUserInfo.TellerName + ")";
                    if (!string.IsNullOrEmpty(entry.LWHCJG))
                    {
                        B_LWHC.Visibility = Visibility.Visible;
                        TB_HCJG.SetPrintTextBlock(entry.LWHCJG);
                    }
                    this.E_Seal_Location = new Point(420, 180);
                }

                if (LoginUserInfo.KinbrNo.Substring(0, 3) == "306")//青县
                {
                    TB_czy.SetValue(Canvas.TopProperty, 288.00);
                }
                BZ1.SetValue(Canvas.TopProperty, 265.00);
                //PrintContainerExt.SetIsTextNoWrap2Scale(TB_Prdt2,true);
                //PrintContainerExt.SetIsTextNoWrap2Scale(BZ1, true);
                TB_Prdt2.Text = "储    种";
                TB_Prdt.Visibility = Visibility.Visible;
                TB_Prdt.SetPrintTextBlock(entry.PrdtName);
                if (LoginUserInfo.KinbrNo.Substring(0, 3) == "301")//邹平 整存整取 多档缩放
                {
                    PrintContainerExt.SetIsTextNoWrap2Scale(TB_Prdt, true);
                }
                else
                {
                    PrintContainerExt.SetIsTextNoWrap2Scale(TB_Prdt, false);
                }
                BZ1.Visibility = Visibility.Visible;
            }
            if (FLAG == "V9")
            {
                TB_czy.Visibility = Visibility.Collapsed;
                TB_sqy.SetValue(Canvas.LeftProperty, 380.0);

                if (!string.IsNullOrEmpty(entry.BZ1))
                {
                    BZ1.Visibility = BZ2.Visibility = Visibility.Visible;
                    BZ1.SetValue(Canvas.TopProperty, 435.00);
                    BZ1.SetValue(Canvas.LeftProperty, 650.00);
                    BZ2.SetValue(Canvas.TopProperty, 435.00);
                }

                this.PrintType = PrintTypes.SavePage_CZ;
            }
            if (FLAG == "V11")//隆丰打印位置调整
            {
                canvas_main.Margin = new Thickness(0, 30, 0, 0);//暂未发 先注释20210105
                TB_ZHXH.Visibility = Visibility.Visible;
                TB_ZHXH2.Visibility = Visibility.Visible;
                TB_Acno2.Visibility = Visibility.Collapsed;

                tb_Account.SetValue(Canvas.TopProperty, 192.00);//账户余额

                //暂未发 先注释20210105
                this.E_Seal_Location = new Point(405, 320);
                this.E_Seal2Copy(new Point(620, 320));//客户联印章

                this.PrintType = PrintTypes.SavePage_LF;
                //柜员
                this.TB_czy.SetValue(Canvas.TopProperty, 423.00);
                this.TB_czy.SetValue(Canvas.LeftProperty, 345.00);
                //授权
                this.TB_sqy.SetValue(Canvas.TopProperty, 423.00);
                this.TB_sqy.SetValue(Canvas.LeftProperty, 115.00);
                //this.E_Seal_Location = new Point(405, 185);
                //this.E_Seal2Copy(new Point(665, 185));//客户联印章
                BZ.Visibility = BZ1.Visibility = Visibility.Visible;
            }

            //天山
            if (FLAG == "V19" && !string.IsNullOrWhiteSpace(entry.zjlx))
            {
                ZJLX.Visibility = Visibility.Visible;
                ZJHM.Visibility = Visibility.Visible;
            }
            if (FLAG == "V7") //都匀只回单打印保险提示语
            {
                BZ3.Visibility = Visibility.Visible;
            }
            //中牟分机构上线老版存取款凭条 不要代理人 新版的要代理人
            //if (FLAG == "V0")
            //{
            //    TB_DLRSJH.Visibility = TB_DLRZJLX.Visibility = TB_DLRHM.Visibility = TB_DLRYXQ.Visibility = TB_DLRMC.Visibility = Visibility.Collapsed;
            //}
        }
        #endregion
    }
}
