﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Contract.Function;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Interaction logic for Print_PersonalAccountingVoucher_Deposit.xaml
    /// </summary>
    public partial class Print_PersonalAccountingVoucher_DepositQF : IPrintContract
    {
        public Print_PersonalAccountingVoucher_DepositQF(Print_PersonalAccountingVoucher_DepositQFEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }
        string Flag = TellerSystem.ServiceProxy.Ext.ServiceHelper.TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        public class Print_PersonalAccountingVoucher_DepositQFEntry : PrintEntry
        {
            public Print_PersonalAccountingVoucher_DepositQFEntry()
            {
                //默认带有介质
                HasJZ = true;
                //默认显示"是否带介质"
                DisplayHasJZ = true;
            }

            /// <summary>
            /// 银行留存联账号
            /// </summary>
            public string Acno { get; set; }
            /// <summary>
            /// 客户回单账户
            /// </summary>
            public string Acno1 { get; set; }

            /// <summary>
            /// 账户序号
            /// </summary>
            public string ZHXH { get; set; }

            /// <summary>
            /// 开户行名
            /// </summary>
            public string OpnName { get; set; }

            /// <summary>
            /// 账户户名
            /// </summary>
            public string ZHHM { get; set; }

            /// <summary>
            /// 交易金额
            /// </summary>
            public decimal TxAmt { get; set; }

            /// <summary>
            /// 账户余额
            /// </summary>
            public string tbAccount { get; set; }

            /// <summary>
            /// 余额
            /// </summary>
            public decimal Bal { get; set; }
            /// <summary>
            /// 利率
            /// </summary>
            public string Rate { get; set; }

            /// <summary>
            /// 储种
            /// </summary>
            public string PrdtName { get; set; }

            /// <summary>
            /// 存期
            /// </summary>
            public string Term { get; set; }

            /// <summary>
            /// 凭证号码
            /// </summary>
            public string NoteNo { get; set; }

            /// <summary>
            /// 科目
            /// </summary>
            public string Subject { get; set; }

            /// <summary>
            /// 是否带介质
            /// </summary>
            public bool HasJZ { get; set; }

            /// <summary>
            /// 是否显示"是否带介质"
            /// </summary>
            public bool DisplayHasJZ { get; set; }

            /// <summary>
            /// 现转标志
            /// </summary>
            public string CtInd { get; set; }

            /// <summary>
            /// 交易类型
            /// </summary>
            public string TradeType { get; set; }

            /// <summary>
            /// 对方账号
            /// </summary>
            public string DfAcno { get; set; }

            /// <summary>
            /// 对方户名
            /// </summary>
            public string DfAcname { get; set; }

            /// <summary>
            /// 币种
            /// </summary>
            public string BZ { get; set; }
            /// <summary>
            /// 流水号
            /// </summary>
            public string LSH { get; set; }
            /// <summary>
            /// 表头
            /// </summary>
            public string Title { get; set; }
            /// <summary>
            /// 留密户
            /// </summary>
            public string Lmh { get; set; }
            /// <summary>
            ///自动转存
            /// </summary>
            public string ZDZC { get; set; }
            /// <summary>
            /// 通存标志
            /// </summary>
            public string TCBZ { get; set; }
            /// <summary>
            /// 账户类型
            /// </summary>
            public string PZHLX { get; set; }

            public string DLRBZ { get; set; }
            public string DLRMC { get; set; }
            public string DLRHM { get; set; }
            public string DLRSJH { get; set; }
            public string DLRZJLX { get; set; }
            public string FLBS { get; set; }
            /// <summary>
            /// 证件类型
            /// </summary>
            public string ZJLX { get; set; }
            /// <summary>
            /// 证件号码
            /// </summary>
            public string ZJHM { get; set; }
            /// <summary>
            /// 收息账号
            /// </summary>
            public string SXZH { get; set; }
            /// <summary>
            /// 客户证件号码
            /// </summary>
            public string AccountId { get; set; }
            /// <summary>
            /// 授权
            /// </summary>
            public string tbsq { get; set; }
            /// <summary>
            /// 起息日
            /// </summary>
            public string QXRQ { get; set; }
            /// <summary>
            /// 到期日
            /// </summary>
            public string DQRQ { get; set; }
            /// <summary>
            /// 代理人有效期
            /// </summary>
            public string DLRYXQ { get; set; }
        }

        #region IPrintContract Members

        public Contract.Entry.PrintEntry PrintData { get; private set; }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_PersonalAccountingVoucher_DepositQFEntry;
            if (entry == null)
                return;
            //TB_title.Text = entry.Title;
            switch (entry.TCBZ[4].ToString().Trim())
            {
                case "0":
                    TB_TCBZ.SetPrintTextBlock("非通存通兑");
                    break;
                case "1":
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
                case "2":
                    TB_TCBZ.SetPrintTextBlock("通存非通兑");
                    break;
                default:
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
            }
            //芝罘Itil 9172  要求将 经办人和复核人往上调一个字节 modify by hulei  20190708 begin
            if (Flag == "V13")
            {
                TB_czy.SetValue(Canvas.TopProperty, 285.0);
                TB_sqy.SetValue(Canvas.TopProperty, 285.0);
            }
            //芝罘Itil 9172  要求将 经办人和复核人往上调一个字节 modify by hulei  20190708 end
            //TB_OPNNAME.SetPrintTextBlock(entry.OpnName);
            TB_Acno1.SetPrintTextBlock(entry.Acno);
            TB_Acno2.SetPrintTextBlock(entry.Acno.Substring(0, 6) + "****" + entry.Acno.Substring(entry.Acno.Length - 2, 2));
            TB_HM1.SetPrintTextBlock(entry.ZHHM);
            TB_HM2.SetPrintTextBlock(entry.ZHHM);
            //TB_Note1.SetPrintTextBlock(entry.NoteNo.PadLeft(TellerSystem.Library.Ext.Variables.UserVariable.Len_VoucherNo, '0'));
            var type = UserFunction.ChangeMoneySymbol(entry.BZ);
            TB_TxAmt1.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            TB_TxAmt2.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            //if (entry.tbAccount != null)
            //{
            //    tb_Account.Visibility = Visibility.Visible;
            //    tb_Account.SetPrintTextBlock(type + entry.tbAccount);
            //}
            if (entry.PZHLX != null)
            {
                ZHLX.Visibility = Visibility.Visible;
                ZHLX.SetPrintTextBlock(entry.PZHLX);
            }
            //if (entry.FLBS == "true")
            //{
            //    FLBS.Visibility = Visibility.Visible;
            //}
            if (entry.HasJZ)
            {
                TB_HasMdm1.SetPrintTextBlock("是");
            }
            else
            {
                TB_HasMdm1.SetPrintTextBlock("否");
            }
            TB_HasMdm1.Visibility = entry.DisplayHasJZ ? Visibility.Visible : Visibility.Hidden;

            TB_Prdt1.SetPrintTextBlock(entry.PrdtName);
            TB_Prdt2.SetPrintTextBlock(entry.PrdtName);
            //业务流水
            TB_lsh.SetPrintTextBlock(this.PrintAttribute.SerialNumber);
            //核心流水
            tb_ls.SetPrintTextBlock(this.PrintAttribute.BusinessTransaction);
            var tradetime = DateTime.ParseExact(LoginUserInfo.GetUserInfo("TradeTime"), "HHmmss", null);
            if (Flag == "V21" || Flag == "V22")
            {
                TB_rq.SetPrintTextBlock(LoginUserInfo.TradeDate + " " + tradetime.ToString("HH:mm:ss"));
            }
            else
            {
                TB_rq.SetPrintTextBlock(LoginUserInfo.TradeDate);
            }
            TB_czy.Text = LoginUserInfo.TellerName + "(" + LoginUserInfo.TellerNo + ")";
            TB_sqy.Text = this.PrintAttribute.Authentic;
            //TB_jyh.SetPrintTextBlock(LoginUserInfo.KinbrNo);
            if (Flag == "V21")//现金标志改为交易类别：现取/现存/转取/转存/现开/现销/转开/转销
            {
                TB_CtInd1.Visibility = Visibility.Collapsed;
                if (entry.CtInd.Equals("现金"))
                {
                    if (entry.TradeType.Contains("存款"))
                    {
                        TB_TradeType1.Text = TB_jylx.Text = "交易类别:现存";
                    }
                    else if (entry.TradeType.Contains("开户"))
                    {
                        TB_TradeType1.Text = TB_jylx.Text = "交易类别:现开";
                    }
                }
                else if (entry.CtInd.Equals("转账"))
                {
                    if (entry.TradeType.Contains("存款"))
                    {
                        TB_TradeType1.Text = TB_jylx.Text = "交易类别:转存";
                    }
                    else if (entry.TradeType.Contains("开户"))
                    {
                        TB_TradeType1.Text = TB_jylx.Text = "交易类别:转开";
                    }
                }
            }
            else
            {
                TB_TradeType1.SetPrintTextBlock(entry.TradeType);
            }
            TB_jylx.SetPrintTextBlock(entry.TradeType);
            TB_CtInd1.SetPrintTextBlock(entry.CtInd);
            if (string.IsNullOrEmpty(entry.DfAcno))
            {
                TB_DfAcno1.Visibility = Visibility.Hidden;
                TB_DfAcno2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_DfAcno1.SetPrintTextBlock(entry.DfAcno);
                TB_DfAcno2.SetPrintTextBlock(entry.DfAcno.Substring(0, 6) + "****" + entry.DfAcno.Substring(entry.DfAcno.Length - 2, 2));
            }
            if (string.IsNullOrEmpty(entry.DfAcname))
            {
                TB_DfAcname1.Visibility = Visibility.Hidden;
                TB_DfAcname2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_DfAcname1.SetPrintTextBlock(entry.DfAcname);
                TB_DfAcname2.SetPrintTextBlock(entry.DfAcname);
            }
            TB_SFLM.SetPrintTextBlock(entry.Lmh);
            if (!string.IsNullOrEmpty(entry.ZDZC))
            {
                TB_ZDZC.Visibility = TB_ZDZC1.Visibility = Visibility.Visible;
                TB_ZDZC.SetPrintTextBlock(entry.ZDZC);
                TB_ZDZC1.SetPrintTextBlock(entry.ZDZC);
            }
            //公共要素
            var tradedate = LoginUserInfo.TradeDate.ToDateTime();
            TB_Teller2.SetPrintTextBlock(LoginUserInfo.TellerNo);
            if (Flag == "V21" || Flag == "V22")
            {
                //交易日期
                TB_Jyra.SetPrintTextBlock(LoginUserInfo.TradeDate + " " + tradetime.ToString("HH:mm:ss"));
            }
            else
            {
                TB_Jyra.SetPrintTextBlock(LoginUserInfo.TradeDate);
            }
            if (!string.IsNullOrEmpty(entry.Rate))
            {
                TB_Rate1.SetPrintTextBlock(string.Format("{0:N6}%", entry.Rate));
                TB_Rate2.SetPrintTextBlock(string.Format("{0:N6}%", entry.Rate));
            }
            else
            {
                TB_Rate1.SetPrintTextBlock(string.Empty);
                TB_Rate2.SetPrintTextBlock(string.Empty);
            }
            if (Flag == "V21")
            {
                TB_DLRZJLX.Visibility = TB_DLRHM.Visibility = TB_DLRMC.Visibility = TB_DLRSJH.Visibility = Visibility.Visible;
                TB_DLRZJLX.SetPrintTextBlock(entry.DLRZJLX);
                TB_DLRHM.SetPrintTextBlock(entry.DLRHM);
                TB_DLRMC.SetPrintTextBlock(entry.DLRMC);
                TB_DLRSJH.SetPrintTextBlock(entry.DLRSJH);

                TB_DLRYXQ.Visibility = Visibility.Visible;
                TB_DLRYXQ.SetPrintTextBlock(entry.DLRYXQ);
                //代理人有效期
                TB_DLRYXQ.SetValue(Canvas.TopProperty, 204.0);
                TB_DLRYXQ.SetValue(Canvas.LeftProperty, 88.0);
            }
            else
            {
                if (entry.DLRBZ == "Y")
                {
                    if (!string.IsNullOrWhiteSpace(entry.DLRZJLX))
                    {
                        TB_DLRZJLX.Visibility = Visibility.Visible;
                    }
                    if (!string.IsNullOrWhiteSpace(entry.DLRHM))
                    {
                        TB_DLRHM.Visibility = Visibility.Visible;
                    }
                    if (!string.IsNullOrWhiteSpace(entry.DLRMC))
                    {
                        TB_DLRMC.Visibility = Visibility.Visible;
                    }
                    if (!string.IsNullOrWhiteSpace(entry.DLRSJH))
                    {
                        TB_DLRSJH.Visibility = Visibility.Visible;
                    }
                    TB_DLRZJLX.SetPrintTextBlock(entry.DLRZJLX);
                    TB_DLRHM.SetPrintTextBlock(entry.DLRHM);
                    TB_DLRMC.SetPrintTextBlock(entry.DLRMC);
                    TB_DLRSJH.SetPrintTextBlock(entry.DLRSJH);

                    if (!string.IsNullOrWhiteSpace(entry.DLRYXQ))
                    {
                        TB_DLRYXQ.Visibility = Visibility.Visible;
                    }
                    TB_DLRYXQ.SetPrintTextBlock(entry.DLRYXQ);
                }
            }
                     
            #region 天山要求存款凭条上打印 证件类型、证件号码、账户余额、收息账号和 交易金额大写 @2019-12-27 by zyh
            if (Flag == "V19")
            {
                BRZJLX.SetPrintTextBlock(entry.ZJLX);
                BRZJHM.SetPrintTextBlock(entry.ZJHM);
                ZHYE.SetPrintTextBlock(type + entry.tbAccount.ToDecimal().ToString("N2"));
                SXZH.Text = "提息账号:{0}";
                SXZH.SetPrintTextBlock(entry.SXZH);
                DXJE.SetPrintTextBlock(SystemFunction.ChangeToCNY(entry.TxAmt));
                DXJE.SetValue(Canvas.TopProperty, 242.0);//大写交易金额
                DXJE.SetValue(Canvas.LeftProperty, 281.0);//大写交易金额
                TB_TxAmt1.SetValue(Canvas.TopProperty, 242.0);//交易金额
                TB_TxAmt1.SetValue(Canvas.LeftProperty, 88.0);//交易金额
                BRZJLX.SetValue(Canvas.TopProperty, 224.0);//证件类型
                BRZJLX.SetValue(Canvas.LeftProperty, 88.0);//证件类型
                BRZJHM.SetValue(Canvas.TopProperty, 224.0);//证件号码
                BRZJHM.SetValue(Canvas.LeftProperty, 281.0);//证件号码

                TB_DLRYXQ.SetValue(Canvas.TopProperty, 206.0);//代理人有效期
                TB_DLRYXQ.SetValue(Canvas.LeftProperty, 88.0);//代理人有效期

                TB_czy.SetValue(Canvas.TopProperty, 360.0);//经办人
                TB_sqy.SetValue(Canvas.TopProperty, 360.0);//复核
                //整体调整位移
                PYL.Margin = new Thickness(-13, 5, 0, 0);
                BRZJLX.Visibility = (entry.ZJLX == null || string.IsNullOrEmpty(entry.ZJLX.Trim()))? Visibility.Collapsed : Visibility.Visible;
                BRZJHM.Visibility = (entry.ZJHM == null || string.IsNullOrEmpty(entry.ZJHM.Trim())) ? Visibility.Collapsed : Visibility.Visible;
                ZHYE.Visibility = (entry.tbAccount == null || string.IsNullOrEmpty(entry.tbAccount.Trim())) ? Visibility.Collapsed : Visibility.Visible;
                SXZH.Visibility = (entry.SXZH == null || string.IsNullOrEmpty(entry.SXZH.Trim())) ? Visibility.Collapsed : Visibility.Visible;
                DXJE.Visibility = (entry.TxAmt == null || string.IsNullOrEmpty(entry.TxAmt.ToString().Trim())) ? Visibility.Collapsed : Visibility.Visible;
            }
            else 
            {
                BRZJLX.Visibility = BRZJHM.Visibility = ZHYE.Visibility = SXZH.Visibility = DXJE.Visibility = Visibility.Collapsed;
            }
            #endregion

            if (Flag == "V18")
            {
                this.E_Seal_Location = new Point(425, 177);
                this.E_Seal2Copy(new Point(685, 177));//客户联印章
                TB_czy.SetValue(Canvas.TopProperty, 292.0);//经办人
                TB_sqy.SetValue(Canvas.TopProperty, 292.0);//复核
            }
            else if (Flag == "V21")
            {
                this.E_Seal_Location = new Point(240, 100);
                this.E_Seal2Copy(new Point(685, 197));
            }
            else if (Flag == "V22")
            {
                this.E_Seal_Location = new Point(240, 167);
                this.E_Seal2Copy(new Point(685, 167));
            }
            else
            {
                this.E_Seal_Location = new Point(425, 197);
                this.E_Seal2Copy(new Point(685, 197));//客户联印章
            }
            if (Flag == "V21" || Flag == "V22")//tianjiao
            {
                TB_BZ.Visibility = TB_Note1.Visibility = Visibility.Visible;
                TB_BZ.SetPrintTextBlock("人民币");//币种
                tb_Account.SetPrintTextBlock(type + entry.tbAccount.ToDecimal().ToString("N2"));//账户余额
                tb_Account1.SetPrintTextBlock(type + entry.tbAccount.ToDecimal().ToString("N2"));//账户余额
                tb_Account.Visibility = tb_Account1.Visibility = entry.HasJZ ? Visibility.Visible : Visibility.Collapsed;
                TB_Note1.SetPrintTextBlock(entry.NoteNo.TrimStart('0'));//凭证号
                tb_AccountId.SetPrintTextBlock(entry.AccountId);//客户证件号码
                //有授权显示
                //TB_sq.SetPrintTextBlock(PrintAttribute.Authno);
                //TB_sq.Visibility = !string.IsNullOrWhiteSpace(PrintAttribute.Authno) ? Visibility.Visible : Visibility.Collapsed;
                TB_QXRQ.SetPrintTextBlock(entry.QXRQ);//起息日
                TB_DQRQ.SetPrintTextBlock(entry.DQRQ);//到期日
                tb_AccountId.Visibility = TB_QXRQ.Visibility = TB_DQRQ.Visibility = Visibility.Visible;
                if (entry.TradeType.Contains("定期"))
                {
                    TB_Term.Visibility = Visibility.Visible;
                }
                if (entry.TradeType.Contains("活期开户"))//活期开户 不显示
                {
                    TB_DQRQ.Visibility = Visibility.Collapsed;
                }
                TB_Term.SetPrintTextBlock(entry.Term);//存期

                TB_Rate2.SetValue(Canvas.TopProperty, 176.00);//回单  利率
                TB_Jyra.SetValue(Canvas.TopProperty, 193.00);//回单  交易日期
                TB_Teller2.SetValue(Canvas.TopProperty, 211.00);//回单  经办
                TB_ZDZC1.SetValue(Canvas.TopProperty, 232.00);//回单  自动转存
                TB_DfAcno2.SetValue(Canvas.TopProperty, 253.00);//回单  对方账号
                TB_DfAcname2.SetValue(Canvas.TopProperty, 273.00);//回单  对方户名

                TB_ZDZC.Visibility = Visibility.Collapsed;

                TB_rq.SetValue(Canvas.LeftProperty, 445.00);//交易日期

                if (Flag == "V21")
                {
                    tb_AccountId.SetValue(Canvas.TopProperty, 116.00);//证件号码移动到现转标志处
                    //左边不显示余额
                    tb_Account.Visibility = Visibility.Collapsed;
                    if (!string.IsNullOrEmpty(entry.ZDZC))
                    {
                        TB_ZDZC.Visibility = Visibility.Visible;
                    }
                }

                if (Flag == "V22")
                {
                    tb_AccountId.SetValue(Canvas.TopProperty, 218.0);
                    //代理人有效期
                    TB_DLRYXQ.SetValue(Canvas.TopProperty, 204.0);
                    TB_DLRYXQ.SetValue(Canvas.LeftProperty, 88.0); 
                }
            }
            if (Flag == "V10" || Flag == "V17" || Flag == "V22")
            {
                BZ.Visibility = BZ1.Visibility = Visibility.Visible;
                BZ1.SetValue(Canvas.TopProperty, 268.00);
                if (Flag == "V22")
                {
                    BZ.SetValue(Canvas.LeftProperty, 384.00);
                    BZ.Width = 200;
                    BZ.TextWrapping = TextWrapping.Wrap;
                }
            }
            if (Flag == "V14")
            {
                BY.Visibility = Visibility.Visible;
            }
            if (Flag == "V16")
            {
                BZ2.Visibility = Visibility.Visible;
            }
        }
        #endregion
    }
}
