﻿using System;
using System.Windows;
using System.Windows.Controls;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Library.Ext.TradeExtension;
using TellerSystem.PrintTemplate.Base;
using TellerSystem.PrintTemplate.ElecSeal;
namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Interaction logic for Print_PersonalAccountingVoucher_Draw.xaml
    /// </summary>
    public partial class Print_PersonalAccountingVoucher_Draw : IPrintContract
    {
        string FLAG = TellerSystem.ServiceProxy.Ext.ServiceHelper.TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        public Print_PersonalAccountingVoucher_Draw(Print_PersonalAccountingVoucher_DrawEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
            //this.BusinessType = "取款";
        }

        public class Print_PersonalAccountingVoucher_DrawEntry : PrintEntry
        {

            /// <summary>
            /// 标题
            /// </summary>
            public string Title { get; set; }
            /// <summary>
            /// 银行留存联账号
            /// </summary>
            public string Acno { get; set; }
            /// <summary>
            /// 客户回单账号
            /// </summary>
            public string Acno1 { get; set; }
            /// <summary>
            /// 账户户名
            /// </summary>
            public string ZHHM { get; set; }

            /// <summary>
            /// 开户行名
            /// </summary>
            public string OpnBrno { get; set; }

            /// <summary>
            /// 储种
            /// </summary>
            public string PrdtName { get; set; }

            /// <summary>
            /// 利率
            /// </summary>
            public string Rate { get; set; }

            /// <summary>
            /// 存期
            /// </summary>
            //public string Term { get; set; }

            /// <summary>
            /// 交易金额
            /// </summary>
            public decimal TxAmt { get; set; }
            /// <summary>
            /// 账户余额
            /// </summary>
            public string tbAccount { get; set; }

            /// <summary>
            /// 凭证号码
            /// </summary>
            public string NoteNo { get; set; }

            /// <summary>
            /// 账户类型
            /// </summary>
            public string Zhlx { get; set; }

            /// <summary>
            /// 交易类型
            /// </summary>
            public string TradeType { get; set; }

            /// <summary>
            /// 现转标志
            /// </summary>
            public string CtInd { get; set; }

            /// <summary>
            /// 自动转存
            /// </summary>
            public string ZDZC { get; set; }


            /// <summary>
            /// 对方户名
            /// </summary>
            public string DfAcname { get; set; }


            /// <summary>
            /// 账户介质
            /// </summary>
            public string ZHJZ { get; set; }

            /// <summary>
            /// 银行留存联对方账号
            /// </summary>
            public string DfAcno { get; set; }
            /// <summary>
            /// 客户回单对方账号
            /// </summary>
            public string DfAcno1 { get; set; }
            /// <summary>
            /// 利息
            /// </summary>
            public string Lx { get; set; }
            /// <summary>
            /// 利息税
            /// </summary>
            public string Lxs { get; set; }
            /// <summary>
            /// 实付利息
            /// </summary>
            public string Sflx { get; set; }
            /// <summary>
            /// 实付本息
            /// </summary>
            public string Sfbx { get; set; }

            //结算类型
            public string jslx { get; set; }

            /// <summary>
            /// 通存通兑标志
            /// </summary>
            public string TCBZ { get; set; }
            /// <summary>
            /// 前置利息
            /// </summary>
            public string QZLX { get; set; }
            ///// 余额
            ///// </summary>
            //public decimal Bal { get; set; }


            /// <summary>
            /// 账户序号
            /// </summary>
            public string ZHXH { get; set; }
            /// <summary>
            /// 子账户开户日期
            /// </summary>
            public string ZZH_Opndate { get; set; }
            /*
             * 
            /// <summary>
            /// 余额
            /// </summary>
            public decimal Bal { get; set; }

            /// <summary>
            /// 新凭证号
            /// </summary>
            public string NewNoteNo { get; set; }

            /// <summary>
            /// 科目
            /// </summary>
            public string Subject { get; set; }
             * 
             * */
            /// <summary>
            /// 是否代理
            /// </summary>
            public string SFDL { get; set; }
            /// <summary>
            /// 代理人名称
            /// </summary>
            public string DLRMC { get; set; }
            /// <summary>
            /// 代理人号码
            /// </summary>
            public string DLRHM { get; set; }
            /// <summary>
            /// 代理人手机号
            /// </summary>
            public string DLRSJH { get; set; }
            /// <summary>
            /// 代理人证件类型
            /// </summary>
            public string DLRZJLX { get; set; }
            /// <summary>  //天山
            /// 证件类型  
            /// </summary>
            public string ZJLX { get; set; }
            /// <summary>
            /// 大写金额
            /// </summary>
            public string DXJE { get; set; }
            /// <summary>
            /// 存款保险条例
            /// </summary>
            public string BZ1 { get; set; }
            /// <summary>
            /// 代理人证件有效期
            /// </summary>
            public string DLRYXQ { get; set; }
            /// <summary>
            /// 联网核查结果
            /// </summary>
            public string LWHCJG = string.Empty;

        }

        #region IPrintContract Members

        public Contract.Entry.PrintEntry PrintData { get; private set; }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_PersonalAccountingVoucher_DrawEntry;
            if (entry == null)
                return;
            //采用无纸化方案时，重新定向到业务凭条版本
            if (this.ElecSealHelper.Mode == SealMode.Paperless)
            {
                entry.IsBatchPrint = true;
                entry.BatchList = new System.Collections.Generic.List<Platform.Print.PrintContainer>
                {
                    new Print_BusinessVoucher_Draw(new Print_BusinessVoucher_Draw.Print_BusinessVoucher_Draw_Entry()
                    {
                        Title = entry.Title,
                        Acno = entry.Acno,
                        ZHHM = entry.ZHHM,
                        OpnBrno = entry.OpnBrno,
                        PrdtName = entry.PrdtName,
                        Rate = entry.Rate,
                        TxAmt = entry.TxAmt,
                        tbAccount = entry.tbAccount,
                        NoteNo = entry.NoteNo,
                        Zhlx = entry.Zhlx,
                        TradeType = entry.TradeType,
                        CtInd = entry.CtInd,
                        ZDZC = entry.ZDZC,
                        DfAcname = entry.DfAcname,
                        ZHJZ = entry.ZHJZ,
                        DfAcno = entry.DfAcno,
                        DfAcno1 = entry.DfAcno1,
                        Lx = entry.Lx,
                        Lxs = entry.Lxs,
                        Sflx = entry.Sflx,
                        Sfbx = entry.Sfbx,
                        jslx = entry.jslx,
                        TCBZ = entry.TCBZ,
                        QZLX = entry.QZLX,
                        ZHXH = entry.ZHXH,
                        ZZH_Opndate = entry.ZZH_Opndate,
                        SFDL = entry.SFDL,
                        DLRMC = entry.DLRMC,
                        DLRHM = entry.DLRHM,
                        DLRSJH = entry.DLRSJH,
                        DLRZJLX = entry.DLRZJLX,
                        ZJLX = entry.ZJLX,
                        DXJE = entry.DXJE,
                        BZ1 = entry.BZ1
                    })
                };
                return;
            }
            TB_title.Text = entry.Title;
            if (FLAG == "V0")
            {
                TB_Prdt1.Text = "储种:{0}";
                TB_Prdt2.Text = "储种:{0}";
                TB_HM2.Text = "户名:{0}";
            }
            switch (entry.TCBZ[4].ToString().Trim())
            {
                case "0":
                    TB_TCBZ.SetPrintTextBlock("非通存通兑");
                    break;
                case "1":
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
                case "2":
                    TB_TCBZ.SetPrintTextBlock("通存非通兑");
                    break;
                default:
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
            }
            TB_ZHXH.SetPrintTextBlock(entry.ZHXH);
            TB_ZHXH2.SetPrintTextBlock(entry.Acno.Substring(0, 6) + "****" + entry.Acno.Substring(entry.Acno.Length - 4, 4) + "-" + entry.ZHXH);
            TB_Acno1.SetPrintTextBlock(entry.Acno);
            TB_Acno2.SetPrintTextBlock(entry.Acno.Substring(0, 6) + "****" + entry.Acno.Substring(entry.Acno.Length - 2, 2));
            TB_HM1.SetPrintTextBlock(entry.ZHHM);

            if (FLAG == "V9")
            {
                TB_HM2.SetPrintTextBlock(entry.ZHHM.Substring(0, 1) + "**");
            }
            else
            {
                TB_HM2.SetPrintTextBlock(entry.ZHHM);
            }
            TB_OPNbrno.SetPrintTextBlock(entry.OpnBrno);
            TB_Prdt1.SetPrintTextBlock(entry.PrdtName);
            TB_Prdt2.SetPrintTextBlock(entry.PrdtName);
            if (!string.IsNullOrEmpty(entry.Rate))
            {
                TB_Rate1.SetPrintTextBlock(string.Format("{0:N6}%", entry.Rate));
            }
            else
            {
                TB_Rate1.SetPrintTextBlock(string.Empty);
            }
            //定期部提需要打印介质种类
            if (!string.IsNullOrEmpty(entry.ZHJZ))
            {
                TB_ZHJZ.Visibility = Visibility.Visible;
                TB_ZHJZ.SetPrintTextBlock(entry.ZHJZ);
            }

            TB_lsh.SetPrintTextBlock(this.PrintAttribute.SerialNumber);
            //TB_Term1.SetPrintTextBlock(entry.Term);
            var type = UserFunction.ChangeMoneySymbol("01");
            TB_TxAmt1.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            TB_TxAmt2.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            if (entry.tbAccount != null)
            {
                tb_Account.Visibility = Visibility.Visible;
                tb_Account.SetPrintTextBlock(type + entry.tbAccount.ToDecimal().ToString("N2"));
            }

            TB_Jyrq.SetPrintTextBlock(LoginUserInfo.TradeDate);
            TB_data.SetPrintTextBlock(LoginUserInfo.TradeDate);
            TB_Note1.SetPrintTextBlock(entry.NoteNo.PadLeft(TellerSystem.Library.Ext.Variables.UserVariable.Len_VoucherNo, '0'));
            TB_Teller2.SetPrintTextBlock(LoginUserInfo.TellerNo);
            //TB_Czy.SetPrintTextBlock(LoginUserInfo.TellerNo);
            //TB_Czy.SetPrintTextBlock("(" + LoginUserInfo.TellerName + ")" + LoginUserInfo.TellerNo);

            //天山新增证件类型,证件号码
            zjlx.SetPrintTextBlock(entry.ZJLX);
            zjhm.SetPrintTextBlock(entry.NoteNo.PadLeft(TellerSystem.Library.Ext.Variables.UserVariable.Len_VoucherNo, '0'));
            if (FLAG == "V19" && !string.IsNullOrWhiteSpace(entry.ZJLX))
            {
                zjlx.Visibility = zjhm.Visibility = Visibility.Visible;
            }

            TB_Czy.Text = LoginUserInfo.TellerNo;
            if (!string.IsNullOrEmpty(entry.Zhlx))
            {
                TB_Zhlx.Visibility = Visibility.Visible;
                TB_Zhlx.SetPrintTextBlock(entry.Zhlx);
            }

            TB_TradeType.SetPrintTextBlock(entry.TradeType);
            TB_jylx.SetPrintTextBlock(entry.TradeType);
            TB_CtInd1.SetPrintTextBlock(entry.CtInd);
            TB_xzbz.SetPrintTextBlock(entry.CtInd);
            TB_jyh.SetPrintTextBlock(LoginUserInfo.KinbrNo);
            if (!string.IsNullOrEmpty(entry.ZDZC))
            {
                TB_ZDZC.Visibility = Visibility.Visible;
                TB_ZDZC.SetPrintTextBlock(entry.ZDZC);
            }
            if (string.IsNullOrEmpty(entry.DfAcno))
            {
                TB_DfAcno1.Visibility = Visibility.Hidden;
                TB_DfAcno2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_DfAcno1.SetPrintTextBlock(entry.DfAcno);
                TB_DfAcno2.SetPrintTextBlock(entry.DfAcno.Substring(0, 6) + "****" + entry.DfAcno.Substring(entry.DfAcno.Length - 2, 2));

            }
            if (string.IsNullOrEmpty(entry.DfAcname))
            {
                TB_DfAcname1.Visibility = Visibility.Hidden;
                TB_DfAcname2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_DfAcname1.SetPrintTextBlock(entry.DfAcname);
                TB_DfAcname2.SetPrintTextBlock(entry.DfAcname);
            }
            if (string.IsNullOrEmpty(entry.Lx))
            {
                TB_Lx.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_Lx.Visibility = Visibility.Visible;
                TB_Lx.SetPrintTextBlock("¥" + entry.Lx);
            }
            //if (string.IsNullOrEmpty(entry.Lxs))
            //{
            //    TB_Lxs.Visibility = Visibility.Hidden;
            //}
            //else
            //{
            //    TB_Lxs.Visibility = Visibility.Visible;
            //    TB_Lxs.SetPrintTextBlock("¥" + entry.Lxs);
            //}
            if (string.IsNullOrEmpty(entry.Sflx))
            {
                TB_Sflx.Visibility = Visibility.Hidden;
                TB_Sflx2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_Sflx.Visibility = Visibility.Visible;
                TB_Sflx.SetPrintTextBlock("¥" + entry.Sflx);
                TB_Sflx2.Visibility = Visibility.Visible;
                TB_Sflx2.SetPrintTextBlock("¥" + entry.Sflx);
            }
            if (!string.IsNullOrEmpty(entry.QZLX))
            {
                tbkQZLX.SetPrintTextBlock("¥" + entry.QZLX);
                tbkQZLX_1.SetPrintTextBlock("¥" + entry.QZLX);
                tbkQZLX.Visibility = tbkQZLX_1.Visibility = Visibility.Visible;
            }
            else
            {
                tbkQZLX.Visibility = tbkQZLX_1.Visibility = Visibility.Collapsed;
            }
            if (string.IsNullOrEmpty(entry.Sfbx))
            {
                TB_SfBx.Visibility = Visibility.Hidden;
                TB_SfBx2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_SfBx.Visibility = Visibility.Visible;
                TB_SfBx.SetPrintTextBlock("¥" + entry.Sfbx);
                TB_SfBx2.Visibility = Visibility.Visible;
                TB_SfBx2.SetPrintTextBlock("¥" + entry.Sfbx);
            }

            //业务流水
            TB_lsh.SetPrintTextBlock(this.PrintAttribute.SerialNumber);
            //核心流水
            tb_ls.SetPrintTextBlock(this.PrintAttribute.BusinessTransaction);
            //TB_sqy.SetPrintTextBlock(this.PrintAttribute.Authno);//授权柜员号
            TB_sqy.Text = this.PrintAttribute.Authno;

            //代理人信息
            if (entry.SFDL == "Y")
            {
                if (!string.IsNullOrWhiteSpace(entry.DLRZJLX))
                {
                    TB_DLRZJLX.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrWhiteSpace(entry.DLRHM))
                {
                    TB_DLRHM.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrWhiteSpace(entry.DLRMC))
                {
                    TB_DLRMC.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrWhiteSpace(entry.DLRSJH))
                {
                    TB_DLRSJH.Visibility = Visibility.Visible;
                }
                TB_DLRZJLX.SetPrintTextBlock(entry.DLRZJLX);
                TB_DLRHM.SetPrintTextBlock(entry.DLRHM);
                TB_DLRMC.SetPrintTextBlock(entry.DLRMC);
                TB_DLRSJH.SetPrintTextBlock(entry.DLRSJH);
                if (FLAG == "V11")
                {
                    if (!string.IsNullOrWhiteSpace(entry.DLRYXQ))
                    {
                        TB_DLRYXQ.Visibility = Visibility.Visible;
                    }
                    TB_DLRYXQ.SetPrintTextBlock(entry.DLRYXQ);
                }
            }
            if (FLAG == "V19")  //天山-大写金额
            {
                dxje.Visibility = Visibility.Visible;
                dxje.SetPrintTextBlock(SystemFunction.ChangeToCNY(entry.TxAmt));
            }
            if (FLAG == "V4")
            {
                TB_Czy.Visibility = Visibility.Collapsed;
                TB_sqy.Visibility = Visibility.Collapsed;
            }
            if (FLAG == "V6")
            {
                if (LoginUserInfo.KinbrNo.Contains("103"))
                {
                    TB_Czy.Visibility = Visibility.Collapsed;
                    TB_sqy.Visibility = Visibility.Collapsed;
                }
                else if (LoginUserInfo.KinbrNo.Contains("106"))
                {
                    TB_Czy.SetValue(Canvas.TopProperty, 293.00);
                    TB_sqy.SetValue(Canvas.TopProperty, 293.00);
                }
            }
            if (FLAG == "V5")
            {
                //交易日期
                TB_Jyrq.SetValue(Canvas.TopProperty, 55.00);
                TB_Acno2.SetValue(Canvas.TopProperty, 71.00);
                TB_HM2.SetValue(Canvas.TopProperty, 87.00);
                TB_Prdt2.SetValue(Canvas.TopProperty, 104.00);

                //山东需求 存款凭条柜员号打印位置上移14毫米
                TB_Czy.SetValue(Canvas.TopProperty, 293.00);
                TB_sqy.SetValue(Canvas.TopProperty, 293.00);
                //this.E_Seal_Location = new Point(405, 320);
                TB_TxAmt2.SetValue(Canvas.TopProperty, 120.00);
                TB_Sflx2.SetValue(Canvas.TopProperty, 135.00);
                TB_SfBx2.SetValue(Canvas.TopProperty, 152.00);
                TB_jylx.SetValue(Canvas.TopProperty, 169.00);
                TB_xzbz.SetValue(Canvas.TopProperty, 186.00);
                TB_Teller2.SetValue(Canvas.TopProperty, 205.00);
                TB_DfAcno2.SetValue(Canvas.TopProperty, 222.00);
                TB_DfAcname2.SetValue(Canvas.TopProperty, 237.00);
                tbkQZLX_1.SetValue(Canvas.TopProperty, 254.00);
                //调整打印顺序
                this.ElecSealHelper.Sign2Point(new Point(650, 170), SealKind.Receipt);//客户联印章
                
                if (LoginUserInfo.KinbrNo.Substring(0, 3) == "302")//黄骅
                {
                    TB_Czy.SetValue(Canvas.TopProperty, 300.00);//300->290->300  NZYB
                    TB_Czy.SetValue(Canvas.LeftProperty, 398.00);
                    TB_Czy.Text = LoginUserInfo.TellerNo + "(" + LoginUserInfo.TellerName + ")";
                    if (!string.IsNullOrEmpty(entry.LWHCJG))
                    {
                        B_LWHC.Visibility = Visibility.Visible;
                        TB_HCJG.SetPrintTextBlock(entry.LWHCJG);
                    }
                    this.E_Seal_Location = new Point(420, 170);
                }
                if(LoginUserInfo.KinbrNo.Substring(0, 3) == "306")//青县
                {
                    TB_Czy.SetValue(Canvas.TopProperty, 288.00);
                }
                BZ1.SetValue(Canvas.TopProperty, 265.00);
                BZ1.Visibility = Visibility.Visible;
            }
            if (FLAG == "V0")
            {
                TB_HM1.SetValue(Canvas.LeftProperty, 290.00);
                TB_Rate1.SetValue(Canvas.LeftProperty, 290.00);
                TB_Note1.SetValue(Canvas.LeftProperty, 290.00);
                TB_Zhlx.SetValue(Canvas.LeftProperty, 290.00);
                TB_DfAcno1.SetValue(Canvas.LeftProperty, 290.00);
                TB_DfAcname1.SetValue(Canvas.LeftProperty, 290.00);
                TB_SfBx.SetValue(Canvas.LeftProperty, 290.00);
                TB_DLRSJH.SetValue(Canvas.LeftProperty, 290.00);
                TB_DLRHM.SetValue(Canvas.LeftProperty, 290.00);
                TB_OPNbrno.SetValue(Canvas.LeftProperty, 470.00);
                TB_jyh.SetValue(Canvas.LeftProperty, 470.00);
                TB_data.SetValue(Canvas.LeftProperty, 470.00);
                TB_ZDZC.SetValue(Canvas.LeftProperty, 470.00);
                TB_Sflx.SetValue(Canvas.LeftProperty, 470.00);
                TB_ZHJZ.SetValue(Canvas.LeftProperty, 470.00);
                tb_Account.SetValue(Canvas.LeftProperty, 470.00);
                //交易复核人 
                if (!string.IsNullOrWhiteSpace(PrintAttribute.Review))
                {
                    var review = PrintAttribute.Review;
                    TB_sqy.Text = review.Substring(review.IndexOf("(") + 1, 6);
                }
                else
                {
                    TB_sqy.Visibility = Visibility.Collapsed;
                }
                //授权柜员号
                TB_Super.SetPrintTextBlock(PrintAttribute.Authno);
                TB_Super.Visibility = !string.IsNullOrWhiteSpace(PrintAttribute.Authno) ? Visibility.Visible : Visibility.Collapsed;
                //柜员流水、业务流水、TB_title一行
                TB_title.SetValue(Canvas.LeftProperty, 394.00);
                tb_ls.SetValue(Canvas.TopProperty, 77.00);
                TB_lsh.SetValue(Canvas.TopProperty, 77.00);
            }
            if (FLAG == "V9")
            {
                TB_Czy.Visibility = Visibility.Collapsed;
                TB_sqy.SetValue(Canvas.LeftProperty, 380.0);

                if (!string.IsNullOrEmpty(entry.BZ1))
                {
                    BZ1.Visibility = BZ2.Visibility = Visibility.Visible;
                    BZ1.SetValue(Canvas.TopProperty, 435.00);
                    BZ1.SetValue(Canvas.LeftProperty, 650.00);
                    BZ2.SetValue(Canvas.TopProperty, 435.00);
                }

                this.PrintType = PrintTypes.TakeMoneyFront_CZ;
            }
            if (FLAG == "V11")//隆丰打印位置调整
            {
                canvas_main.Margin = new Thickness(0, 30, 0, 0);//暂未发 先注释20210105
                //canvas_main.Margin = new Thickness(10, -15, 0, 0);
                TB_ZHXH.Visibility = Visibility.Visible;
                TB_ZHXH2.Visibility = Visibility.Visible;
                TB_Acno2.Visibility = Visibility.Collapsed;
                TB_ZZH_Opndate.Visibility = Visibility.Visible;
                TB_ZZH_Opndate.SetPrintTextBlock(entry.ZZH_Opndate);

                tb_Account.SetValue(Canvas.TopProperty, 196.00);//账户余额
                //暂未发 先注释20210105
                this.E_Seal_Location = new Point(405, 320);
                this.E_Seal2Copy(new Point(620, 320));//客户联印章

                this.PrintType = PrintTypes.TakeMoneyFront_LF;
                //柜员
                this.TB_Czy.SetValue(Canvas.TopProperty, 418.00);
                this.TB_Czy.SetValue(Canvas.LeftProperty, 345.00);
                //授权
                this.TB_sqy.SetValue(Canvas.TopProperty, 418.00);
                this.TB_sqy.SetValue(Canvas.LeftProperty, 230.00);
                //this.E_Seal_Location = new Point(405, 187);
                //this.E_Seal2Copy(new Point(665, 187));//客户联印章
                BZ.Visibility = BZ1.Visibility = Visibility.Visible;
            }
            //阳光子账户与定期存单置换时，需要将核心流水和柜员流水放到下面
            if (FLAG == "V8" && entry.Title.Contains("定期存单提"))
            {
                tb_ls.SetValue(Canvas.TopProperty, 242.00);
                TB_lsh.SetValue(Canvas.TopProperty, 242.00);
            }
            if (FLAG == "V7") //都匀只回单打印保险提示语
            {
                BZ3.Visibility = Visibility.Visible;
            }
            //中牟分机构上线老版存取款凭条 不要代理人 新版的要代理人
            //if (FLAG == "V0")
            //{
            //    TB_DLRSJH.Visibility = TB_DLRZJLX.Visibility = TB_DLRHM.Visibility = TB_DLRYXQ.Visibility = TB_DLRMC.Visibility = Visibility.Collapsed;
            //}
            if (FLAG == "V3" && !entry.ZHXH.Trim().PadLeft(6, '0').Equals("000001"))
            {
                TB_ZHXH.Visibility = Visibility.Visible;
                TB_ZHXH2.Visibility = Visibility.Visible;
                TB_Acno2.Visibility = Visibility.Collapsed;
            }
        }

        #endregion
    }
}
