﻿using System;
using System.Windows;
using System.Windows.Controls;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Library.Ext.TradeExtension;
namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Interaction logic for Print_PersonalAccountingVoucher_Draw.xaml
    /// </summary>
    public partial class Print_PersonalAccountingVoucher_DrawQF : IPrintContract
    {
        public Print_PersonalAccountingVoucher_DrawQF(Print_PersonalAccountingVoucher_DrawQFEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
            //this.BusinessType = "取款";

        }
        string Flag = TellerSystem.ServiceProxy.Ext.ServiceHelper.TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        public class Print_PersonalAccountingVoucher_DrawQFEntry : PrintEntry
        {

            /// <summary>
            /// 标题
            /// </summary>
            public string Title { get; set; }
            /// <summary>
            /// 银行留存联账号
            /// </summary>
            public string Acno { get; set; }
            /// <summary>
            /// 客户回单账号
            /// </summary>
            public string Acno1 { get; set; }
            /// <summary>
            /// 账户户名
            /// </summary>
            public string ZHHM { get; set; }

            /// <summary>
            /// 开户行名
            /// </summary>
            public string OpnBrno { get; set; }

            /// <summary>
            /// 储种
            /// </summary>
            public string PrdtName { get; set; }

            /// <summary>
            /// 利率
            /// </summary>
            public string Rate { get; set; }

            /// <summary>
            /// 存期
            /// </summary>
            //public string Term { get; set; }

            /// <summary>
            /// 交易金额
            /// </summary>
            public decimal TxAmt { get; set; }
            /// <summary>
            /// 账户余额
            /// </summary>
            public string tbAccount { get; set; }

            /// <summary>
            /// 凭证号码
            /// </summary>
            public string NoteNo { get; set; }

            /// <summary>
            /// 账户类型
            /// </summary>
            public string Zhlx { get; set; }

            /// <summary>
            /// 交易类型
            /// </summary>
            public string TradeType { get; set; }

            /// <summary>
            /// 现转标志
            /// </summary>
            public string CtInd { get; set; }

            /// <summary>
            /// 自动转存
            /// </summary>
            public string ZDZC { get; set; }


            /// <summary>
            /// 对方户名
            /// </summary>
            public string DfAcname { get; set; }


            /// <summary>
            /// 账户介质
            /// </summary>
            public string ZHJZ { get; set; }

            /// <summary>
            /// 银行留存联对方账号
            /// </summary>
            public string DfAcno { get; set; }
            /// <summary>
            /// 客户回单对方账号
            /// </summary>
            public string DfAcno1 { get; set; }
            /// <summary>
            /// 利息
            /// </summary>
            public string Lx { get; set; }
            /// <summary>
            /// 利息税
            /// </summary>
            public string Lxs { get; set; }
            /// <summary>
            /// 实付利息
            /// </summary>
            public string Sflx { get; set; }
            /// <summary>
            /// 实付本息
            /// </summary>
            public string Sfbx { get; set; }

            //结算类型
            public string jslx { get; set; }

            /// <summary>
            /// 通存通兑标志
            /// </summary>
            public string TCBZ { get; set; }
            /// <summary>
            /// 前置利息
            /// </summary>
            public string QZLX { get; set; }
            ///// 余额
            ///// </summary>
            //public decimal Bal { get; set; }

            /*
             *  
             /// <summary>
             /// 账户序号
             /// </summary>
            public string ZHXH { get; set; }
             *   /// <summary>
            /// 余额
            /// </summary>
            public decimal Bal { get; set; }

            /// <summary>
            /// 新凭证号
            /// </summary>
            public string NewNoteNo { get; set; }

            /// <summary>
            /// 科目
            /// </summary>
            public string Subject { get; set; }
             * 
             * */
            /// <summary>
            /// 是否代理
            /// </summary>
            public string SFDL { get; set; }
            /// <summary>
            /// 代理人名称
            /// </summary>
            public string DLRMC { get; set; }
            /// <summary>
            /// 代理人号码
            /// </summary>
            public string DLRHM { get; set; }
            /// <summary>
            /// 代理人手机号
            /// </summary>
            public string DLRSJH { get; set; }
            /// <summary>
            /// 代理人证件类型
            /// </summary>
            public string DLRZJLX { get; set; }

            /// <summary>
            /// 证件类型
            /// </summary>
            public string ZJLX { get; set; }
            /// <summary>
            /// 证件号码
            /// </summary>
            public string ZJHM { get; set; }
            /// <summary>
            /// 本金   乳山天骄
            /// </summary>
            public string BJ { get; set; }
            /// <summary>
            /// 转出账户证件号码
            /// </summary>
            public string ZCZJHM { get; set; }
            /// <summary>
            /// 转入账户证件号码
            /// </summary>
            public string ZRZJHM { get; set; }
            /// <summary>
            /// 转入账号是否为对公账户
            /// </summary>
            public string isZDG { get; set; }
            /// <summary>
            /// 代理人有效期
            /// </summary>
            public string DLRYXQ { get; set; }
        }

        #region IPrintContract Members

        public Contract.Entry.PrintEntry PrintData { get; private set; }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_PersonalAccountingVoucher_DrawQFEntry;
            if (entry == null)
                return;
            //TB_title.Text = entry.Title;
            switch (entry.TCBZ[4].ToString().Trim())
            {
                case "0":
                    TB_TCBZ.SetPrintTextBlock("非通存通兑");
                    break;
                case "1":
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
                case "2":
                    TB_TCBZ.SetPrintTextBlock("通存非通兑");
                    break;
                default:
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
            }
            TB_Acno1.SetPrintTextBlock(entry.Acno);
            TB_Acno2.SetPrintTextBlock(entry.Acno.Substring(0, 6) + "****" + entry.Acno.Substring(entry.Acno.Length - 2, 2));
            TB_HM1.SetPrintTextBlock(entry.ZHHM);
            TB_HM2.SetPrintTextBlock(entry.ZHHM);
            //TB_OPNbrno.SetPrintTextBlock(entry.OpnBrno);
            TB_Prdt1.SetPrintTextBlock(entry.PrdtName);
            TB_Prdt2.SetPrintTextBlock(entry.PrdtName);
            if (!string.IsNullOrEmpty(entry.Rate))
            {
                TB_Rate1.SetPrintTextBlock(string.Format("{0:N6}%", entry.Rate));
            }
            else
            {
                TB_Rate1.SetPrintTextBlock(string.Empty);
            }
            //定期部提需要打印介质种类
            //if (!string.IsNullOrEmpty(entry.ZHJZ))
            //{
            //    TB_ZHJZ.Visibility = Visibility.Visible;
            //    TB_ZHJZ.SetPrintTextBlock(entry.ZHJZ);
            //}

            TB_lsh.SetPrintTextBlock(this.PrintAttribute.SerialNumber);
            //TB_Term1.SetPrintTextBlock(entry.Term);
            var type = UserFunction.ChangeMoneySymbol("01");
            TB_TxAmt1.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            TB_TxAmt2.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            //if (entry.tbAccount != null)
            //{
            //    tb_Account.Visibility = Visibility.Visible;
            //    tb_Account.SetPrintTextBlock(type + entry.tbAccount);
            //}
            if (Flag == "V21" || Flag == "V22")
            {
                //交易日期
                var tradetime = DateTime.ParseExact(LoginUserInfo.GetUserInfo("TradeTime"), "HHmmss", null);
                TB_Jyrq.SetPrintTextBlock(LoginUserInfo.TradeDate + " " + tradetime.ToString("HH:mm:ss"));
                TB_data.SetPrintTextBlock(LoginUserInfo.TradeDate + " " + tradetime.ToString("HH:mm:ss"));
                if (Flag == "V21")
                {
                    TB_data.SetValue(Canvas.LeftProperty, 438.00);
                }
            }
            else
            {
                TB_Jyrq.SetPrintTextBlock(LoginUserInfo.TradeDate);
                TB_data.SetPrintTextBlock(LoginUserInfo.TradeDate);
            }
            //TB_Note1.SetPrintTextBlock(entry.NoteNo.PadLeft(TellerSystem.Library.Ext.Variables.UserVariable.Len_VoucherNo, '0'));
            TB_Teller2.SetPrintTextBlock(LoginUserInfo.TellerNo);
            TB_Czy.Text = LoginUserInfo.TellerName +"("+ LoginUserInfo.TellerNo + ")";
            TB_sqy.Text = this.PrintAttribute.Authentic;
            //业务流水
            TB_lsh.SetPrintTextBlock(this.PrintAttribute.SerialNumber);
            //核心流水
            tb_ls.SetPrintTextBlock(this.PrintAttribute.BusinessTransaction);
            if (!string.IsNullOrEmpty(entry.Zhlx))
            {
                TB_Zhlx.Visibility = Visibility.Visible;
                TB_Zhlx.SetPrintTextBlock(entry.Zhlx);
            }

            TB_TradeType.SetPrintTextBlock(entry.TradeType);
            TB_jylx.SetPrintTextBlock(entry.TradeType);
            if (Flag == "V21")//现金标志改为交易类别：现取/现存/转取/转存/现开/现销/转开/转销
            {
                TB_TradeType.Visibility = TB_jylx.Visibility = Visibility.Collapsed;
                if (entry.CtInd.Equals("现金"))
                {
                    //if (entry.TradeType.Contains("取款"))
                    //{
                        TB_CtInd1.Text = TB_xzbz.Text = "交易类别:现取";
                    //}
                }
                else if (entry.CtInd.Equals("转账"))
                {
                    //if (entry.TradeType.Contains("取款"))
                    //{
                        TB_CtInd1.Text = TB_xzbz.Text = "交易类别:转取";
                    //}
                }
            }
            else
            {
                TB_CtInd1.SetPrintTextBlock(entry.CtInd);
            }
            TB_xzbz.SetPrintTextBlock(entry.CtInd);
            //TB_jyh.SetPrintTextBlock(LoginUserInfo.KinbrNo);
            if (!string.IsNullOrEmpty(entry.ZDZC))
            {
                TB_ZDZC.Visibility = Visibility.Visible;
                TB_ZDZC.SetPrintTextBlock(entry.ZDZC);
            }
            if (string.IsNullOrEmpty(entry.DfAcno))
            {
                TB_DfAcno1.Visibility = Visibility.Hidden;
                TB_DfAcno2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_DfAcno1.SetPrintTextBlock(entry.DfAcno);
                if (Flag == "V21" || Flag == "V22")//天骄，对方账号不***隐藏
                {
                    TB_DfAcno2.SetPrintTextBlock(entry.DfAcno);
                }
                else
                {
                    TB_DfAcno2.SetPrintTextBlock(entry.DfAcno.Substring(0, 6) + "****" + entry.DfAcno.Substring(entry.DfAcno.Length - 2, 2));
                }
            }
            if (string.IsNullOrEmpty(entry.DfAcname))
            {
                TB_DfAcname1.Visibility = Visibility.Hidden;
                TB_DfAcname2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_DfAcname1.SetPrintTextBlock(entry.DfAcname);
                TB_DfAcname2.SetPrintTextBlock(entry.DfAcname);
            }
            if (string.IsNullOrEmpty(entry.Lx))
            {
                TB_Lx.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_Lx.Visibility = Visibility.Visible;
                TB_Lx.SetPrintTextBlock("¥" + entry.Lx);
            }
            //if (string.IsNullOrEmpty(entry.Sflx))
            //{
            //    TB_Sflx.Visibility = Visibility.Hidden;
            //    TB_Sflx2.Visibility = Visibility.Hidden;
            //}
            //else
            //{
            //    TB_Sflx.Visibility = Visibility.Visible;
            //    TB_Sflx.SetPrintTextBlock("¥" + entry.Sflx);
            //    TB_Sflx2.Visibility = Visibility.Visible;
            //    TB_Sflx2.SetPrintTextBlock("¥" + entry.Sflx);
            //}
            //if (!string.IsNullOrEmpty(entry.QZLX))
            //{
            //    tbkQZLX.SetPrintTextBlock("¥" + entry.QZLX);
            //    tbkQZLX_1.SetPrintTextBlock("¥" + entry.QZLX);
            //    tbkQZLX.Visibility = tbkQZLX_1.Visibility = Visibility.Visible;
            //}
            //else
            //{
            //    tbkQZLX.Visibility = tbkQZLX_1.Visibility = Visibility.Collapsed;
            //}
            if (string.IsNullOrEmpty(entry.Sfbx))
            {
                TB_SfBx.Visibility = Visibility.Hidden;
                TB_SfBx2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_SfBx.Visibility = Visibility.Visible;
                TB_SfBx.SetPrintTextBlock("¥" + entry.Sfbx);
                TB_SfBx2.Visibility = Visibility.Visible;
                TB_SfBx2.SetPrintTextBlock("¥" + entry.Sfbx);
            }
            if (entry.SFDL == "Y")
            {
                if (!string.IsNullOrWhiteSpace(entry.DLRZJLX))
                {
                    TB_DLRZJLX.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrWhiteSpace(entry.DLRHM))
                {
                    TB_DLRHM.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrWhiteSpace(entry.DLRMC))
                {
                    TB_DLRMC.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrWhiteSpace(entry.DLRSJH))
                {
                    TB_DLRSJH.Visibility = Visibility.Visible;
                }
                TB_DLRZJLX.SetPrintTextBlock(entry.DLRZJLX);
                TB_DLRHM.SetPrintTextBlock(entry.DLRHM);
                TB_DLRMC.SetPrintTextBlock(entry.DLRMC);
                TB_DLRSJH.SetPrintTextBlock(entry.DLRSJH);

                if (!string.IsNullOrWhiteSpace(entry.DLRYXQ))
                {
                    TB_DLRYXQ.Visibility = Visibility.Visible;
                }
                TB_DLRYXQ.SetPrintTextBlock(entry.DLRYXQ);
            }
            //蒙阴要求调整经办柜员和复核柜员的位置 
            if(Flag=="V17"){
                TB_Czy.SetValue(Canvas.TopProperty, 290.0);
                TB_sqy.SetValue(Canvas.TopProperty, 290.0);
            }
            //新泰要求调整经办柜员和复核柜员的位置 
            if (Flag == "V18")
            {
                TB_Czy.SetValue(Canvas.TopProperty, 286.0);
                TB_sqy.SetValue(Canvas.TopProperty, 286.0);

                //对方户名换行
                TB_DfAcname2.SetValue(Canvas.WidthProperty, 206.00);
                TB_DfAcname2.TextWrapping = TextWrapping.Wrap;

                this.E_Seal_Location = new Point(425, 179);
                this.E_Seal2Copy(new Point(690, 179));
            }
            else if (Flag == "V21")
            {
                this.E_Seal_Location = new Point(285, 190);
                this.E_Seal2Copy(new Point(690, 190));
            }
            else if (Flag == "V22")
            {
                this.E_Seal_Location = new Point(425, 160);
                this.E_Seal2Copy(new Point(690, 190));
            }
            else
            {
                this.E_Seal_Location = new Point(425, 190);
                this.E_Seal2Copy(new Point(690, 190));
            }
            #region 天山要求存款凭条上打印 证件类型、证件号码、账户余额、交易金额大写 @2019-12-28 by zyh
            if (Flag == "V19")
            {
                BRZJLX.SetPrintTextBlock(entry.ZJLX);
                BRZJHM.SetPrintTextBlock(entry.ZJHM);
                ZHYE.SetPrintTextBlock(type + entry.tbAccount.ToDecimal().ToString("N2"));
                DXJE.SetPrintTextBlock(SystemFunction.ChangeToCNY(entry.TxAmt));
                DXJE.SetValue(Canvas.TopProperty, 242.0);//大写交易金额
                DXJE.SetValue(Canvas.LeftProperty, 273.0);//大写交易金额
                TB_TxAmt1.SetValue(Canvas.TopProperty, 242.0);//交易金额
                TB_TxAmt1.SetValue(Canvas.LeftProperty, 88.0);//交易金额
                BRZJLX.SetValue(Canvas.TopProperty, 224.0);//证件类型
                BRZJLX.SetValue(Canvas.LeftProperty, 88.0);//证件类型
                BRZJHM.SetValue(Canvas.TopProperty, 224.0);//证件号码
                BRZJHM.SetValue(Canvas.LeftProperty, 273.0);//证件号码

                TB_DLRYXQ.SetValue(Canvas.TopProperty, 206.0);//代理人有效期
                TB_DLRYXQ.SetValue(Canvas.LeftProperty, 88.0);//代理人有效期

                TB_Czy.SetValue(Canvas.TopProperty, 360.0);//经办人
                TB_sqy.SetValue(Canvas.TopProperty, 360.0);//复核
                //整体调整位移
                PYL.Margin = new Thickness(-10, 5, 0, 0);
                BRZJLX.Visibility = (entry.ZJLX == null || string.IsNullOrEmpty(entry.ZJLX.Trim())) ? Visibility.Collapsed : Visibility.Visible;
                BRZJHM.Visibility = (entry.ZJHM == null || string.IsNullOrEmpty(entry.ZJHM.Trim())) ? Visibility.Collapsed : Visibility.Visible;
                ZHYE.Visibility = (entry.tbAccount == null || string.IsNullOrEmpty(entry.tbAccount.Trim())) ? Visibility.Collapsed : Visibility.Visible;
                DXJE.Visibility = (entry.TxAmt == null || string.IsNullOrEmpty(entry.TxAmt.ToString().Trim())) ? Visibility.Collapsed : Visibility.Visible;
            }
            else
            {
                BRZJLX.Visibility = BRZJHM.Visibility = ZHYE.Visibility = DXJE.Visibility = Visibility.Collapsed;
            }
            #endregion
            if (Flag == "V21" || Flag == "V22")//tianjiao
            {
                //显示账户余额
                tb_Account.Visibility = tb_Account1.Visibility = Visibility.Visible;
                tb_Account1.SetPrintTextBlock(entry.tbAccount);
                tb_Account.SetPrintTextBlock(entry.tbAccount);

                //this.E_Seal_Location = new Point(180, 97);

                if (Flag == "V22")
                {
                    tb_BJ.SetPrintTextBlock(entry.BJ);//本金

                    BZ.Visibility = BZ1.Visibility = Visibility.Visible;
                    BZ.SetValue(Canvas.LeftProperty, 384.00);
                    BZ.Width = 200;
                    BZ.TextWrapping = TextWrapping.Wrap;
                    //代理人有效期
                    TB_DLRYXQ.SetValue(Canvas.TopProperty, 204.0);
                    TB_DLRYXQ.SetValue(Canvas.LeftProperty, 88.0);
                }

                tb_Account1.SetValue(Canvas.TopProperty, 182.00);//回单  账户余额
                tb_BJ.SetValue(Canvas.TopProperty, 200.00);//回单  本金
                TB_SfBx2.SetValue(Canvas.TopProperty, 218.00);//回单  实付本息
                TB_Teller2.SetValue(Canvas.TopProperty, 234.00);//回单  经办
                TB_DfAcno2.SetValue(Canvas.TopProperty, 248.00);//回单  对方账号
                TB_DfAcname2.SetValue(Canvas.TopProperty, 263.00);//回单  对方户名

                if (Flag == "V21")
                {
                    if (entry.CtInd.Equals("转账"))
                    {
                        this.PrintType = TellerSystem.PrintTemplate.Base.PrintTypes.TakeMoneyFront_LSQFZZ;
                        this.DocumentName = "转账凭条";
                        TB_Czy.SetValue(Canvas.TopProperty, 318.00);//经办
                        TB_sqy.SetValue(Canvas.TopProperty, 318.00);
                        ZCZJHM.Visibility = Visibility.Visible;
                        ZCZJHM.SetPrintTextBlock(entry.ZCZJHM);//转出账号证件号码
                        ZRZJHM.SetPrintTextBlock(entry.ZRZJHM);//转入账号证件号码
                        //个人转对公，对公户不用显示证件号码
                        if (entry.isZDG.Equals("False"))
                        {
                            ZRZJHM.Visibility = Visibility.Visible;
                        }
                        else
                        {
                            //对方户名换行
                            TB_DfAcname2.Width = 203.00;
                            TB_DfAcname2.Height = 28.00;
                            TB_DfAcname2.TextWrapping = TextWrapping.Wrap;
                        }
                    }
                    //左边不显示余额
                    tb_Account.Visibility = Visibility.Collapsed;

                    //代理人有效期
                    TB_DLRYXQ.SetValue(Canvas.TopProperty, 204.0);
                    TB_DLRYXQ.SetValue(Canvas.LeftProperty, 88.0);
                }
            }
            if (Flag == "V14")
            {
                BY.Visibility = Visibility.Visible;
            }
            if (Flag == "V10" || Flag == "V17")
            {
                BZ.Visibility = BZ1.Visibility = Visibility.Visible;
                BZ1.SetValue(Canvas.TopProperty, 268.00);
            }
            if (Flag == "V16")
            {
                BZ2.Visibility = Visibility.Visible;
            }
        }

        #endregion
    }
}
