﻿using System;
using System.Windows;
using System.Windows.Controls;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using TellerSystem.PrintTemplate.Base;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Interaction logic for Print_PersonalAccountingVoucher_Draw.xaml
    /// </summary>
    public partial class Print_PersonalAccountingVoucher_Drawxh : IPrintContract
    {
        string FLAG = TellerSystem.ServiceProxy.Ext.ServiceHelper.TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        public Print_PersonalAccountingVoucher_Drawxh(Print_PersonalAccountingVoucher_DrawxhEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
            //this.BusinessType = "取款";
            
            if (FLAG == "V4")
            {
                TB_czy.Visibility = Visibility.Collapsed;
                TB_sqy.Visibility = Visibility.Collapsed;
            }
        }

        public class Print_PersonalAccountingVoucher_DrawxhEntry : PrintEntry
        {
            /// <summary>
            /// 标题
            /// </summary>
            public string Title { get; set; }

            /// <summary>
            /// 结算类型
            /// </summary>
            public string JSLX { get; set; }

            /// <summary>
            /// 账户类型
            /// </summary>
            public string ZHLX { get; set; }

            /// <summary>
            /// 账号
            /// </summary>
            public string Acno { get; set; }

            /// <summary>
            /// 账户序号
            /// </summary>
            public string ZHXH { get; set; }

            /// <summary>
            /// 账户户名
            /// </summary>
            public string ZHHM { get; set; }
            /// <summary>
            /// 开户日
            /// </summary>
            public string Opndata { get; set; }
            /// <summary>
            /// 到期日
            /// </summary>
            public string DataEnd { get; set; }

            /// <summary>
            /// 开户行名
            /// </summary>
            // public string OpnName { get; set; }

            /// <summary>
            /// 储种
            /// </summary>
            public string PrdtName { get; set; }

            /// <summary>
            /// 利率
            /// </summary>
            public string Rate { get; set; }

            /// <summary>
            /// 交易类型
            /// </summary>
            public string TradeType { get; set; }

            /// <summary>
            /// 交易金额
            /// </summary>
            public decimal TxAmt { get; set; }



            /// <summary>
            /// 流水号
            /// </summary>
            // public string Lsh { get; set; }

            /// <summary>
            /// 利息
            /// </summary>
            public decimal Lx { get; set; }

            /// <summary>
            /// 利息税
            /// </summary>
            public decimal Lxs { get; set; }

            /// <summary>
            /// 自动转存
            /// </summary>
            public string Zdzc { get; set; }

            /// <summary>
            /// 实付利息
            /// </summary>
            public decimal Sflx { get; set; }

            /// <summary>
            /// 备注信息1
            /// </summary>
            public string Bzinfo1 { get; set; }
            /// <summary>
            /// 开户机构10
            /// </summary>
            public string Khjg { get; set; }
            /// <summary>
            /// 实付本息税
            /// </summary>
            public decimal Sfbxs { get; set; }

            /// <summary>
            /// 备注信息2
            /// </summary>
            public string Bzinfo2 { get; set; }

            /// <summary>
            /// 对方账号
            /// </summary>
            public string DfAcno { get; set; }

            /// <summary>
            /// 对方户名
            /// </summary>
            public string DfAcname { get; set; }
            /// <summary>
            /// 通存标志
            /// </summary>
            public string TCBZ { get; set; }
            /// <summary>
            /// 前置利息
            /// </summary>
            public string QZLX { get; set; }
            ///// <summary>
            ///// 存期
            ///// </summary>
            //public string Term { get; set; }

            ///// <summary>
            ///// 凭证号码
            ///// </summary>
            //public string NoteNo { get; set; }

            ///// <summary>
            ///// 新凭证号
            ///// </summary>
            //public string NewNoteNo { get; set; }

            ///// <summary>
            ///// 科目
            ///// </summary>
            //public string Subject { get; set; }

            ///// <summary>
            ///// 现转标志
            ///// </summary>
            //public string CtInd { get; set; }

            ///// <summary>
            ///// 币种
            ///// </summary>
            //public string Bz { get; set; }
            /// <summary>
            /// 余额
            /// </summary>
            //public decimal Bal { get; set; }
            /// <summary>
            /// 是否代理
            /// </summary>
            public string SFDL { get; set; }
            /// <summary>
            /// 代理人名称
            /// </summary>
            public string DLRMC { get; set; }
            /// <summary>
            /// 代理人号码
            /// </summary>
            public string DLRHM { get; set; }
            /// <summary>
            /// 代理人手机号
            /// </summary>
            public string DLRSJH { get; set; }
            /// <summary>
            /// 代理人证件类型
            /// </summary>
            public string DLRZJLX { get; set; }
            /// <summary>
            /// 备注信息3
            /// </summary>
            public string Bzinfo3 { get; set; }

            /// <summary>
            /// 利息转入方式
            /// </summary>
            public string LXZRFS { get; set; }

            /// <summary>
            /// 利息转入账号
            /// </summary>
            public string LXZRZH { get; set; }
            /// <summary>
            /// 联网核查结果
            /// </summary>
            public string LWHCJG = string.Empty;
            /// <summary>
            /// 凭证号
            /// </summary>
            public string PZH { get; set; }
        }

        #region IPrintContract Members

        public Contract.Entry.PrintEntry PrintData { get; private set; }

        public void LoadPrintData()
        {

            var entry = PrintData as Print_PersonalAccountingVoucher_DrawxhEntry;
            if (entry == null)
                return;
            //采用无纸化方案时，重新定向到业务凭条版本
            if (this.ElecSealHelper.Mode == PrintTemplate.ElecSeal.SealMode.Paperless)
            {
                entry.IsBatchPrint = true;
                entry.BatchList = new System.Collections.Generic.List<Platform.Print.PrintContainer> { 
                    new Print_BusinessVoucher_Drawxh(new Print_BusinessVoucher_Drawxh.Print_BusinessVoucher_Drawxh_Entry()
                    {
                        Title = entry.Title,
                        JSLX = entry.JSLX,
                        ZHLX = entry.ZHLX,
                        Acno = entry.Acno,
                        ZHXH = entry.ZHXH,
                        ZHHM = entry.ZHHM,
                        Opndata = entry.Opndata,
                        DataEnd = entry.DataEnd,
                        PrdtName = entry.PrdtName,
                        Rate = entry.Rate,
                        TradeType = entry.TradeType,
                        TxAmt = entry.TxAmt,
                        Lx = entry.Lx,
                        Lxs = entry.Lxs,
                        Zdzc = entry.Zdzc,
                        Sflx = entry.Sflx,
                        Bzinfo1 = entry.Bzinfo1,
                        Khjg = entry.Khjg,
                        Sfbxs = entry.Sfbxs,
                        Bzinfo2 = entry.Bzinfo2,
                        DfAcno = entry.DfAcno,
                        DfAcname = entry.DfAcname,
                        TCBZ = entry.TCBZ,
                        QZLX = entry.QZLX,
                        SFDL = entry.SFDL,
                        DLRMC = entry.DLRMC,
                        DLRHM = entry.DLRHM,
                        DLRSJH = entry.DLRSJH,
                        DLRZJLX = entry.DLRZJLX,
                        Bzinfo3 = entry.Bzinfo3,
                        PZH=entry.PZH.PadLeft(16, '0')
                    })
                };
                return;
            }
            TB_title.Text = entry.Title;
            if (FLAG == "V0")
            {
                TB_HM2.Text = "户名:{0}";
                TB_Prdt1.Text = "储种:{0}";
                TB_Prdt2.Text = "储种:{0}";
            }
            switch (entry.TCBZ[4].ToString().Trim())
            {
                case "0":
                    TB_TCBZ.SetPrintTextBlock("非通存通兑");
                    break;
                case "1":
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
                case "2":
                    TB_TCBZ.SetPrintTextBlock("通存非通兑");
                    break;
                default:
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
            }
            TB_ZHXH.SetPrintTextBlock(entry.ZHXH);
            TB_ZHXH2.SetPrintTextBlock(entry.Acno.Substring(0, 6) + "****" + entry.Acno.Substring(entry.Acno.Length - 4, 4) + "-" + entry.ZHXH);
            TB_Acno1.SetPrintTextBlock(entry.Acno);
            //TB_Acno2.SetPrintTextBlock(entry.Acno);
            TB_Acno2.SetPrintTextBlock(entry.Acno.Substring(0, 6) + "****" + entry.Acno.Substring(entry.Acno.Length - 2, 2));
            TB_HM1.SetPrintTextBlock(entry.ZHHM);
            if (FLAG == "V9")
            {
                TB_HM2.SetPrintTextBlock(entry.ZHHM.Substring(0, 1) + "**");
            }
            else
            {
                TB_HM2.SetPrintTextBlock(entry.ZHHM);
            }
            TB_OPNData.SetPrintTextBlock(entry.Opndata);
            TB_OPNData2.SetPrintTextBlock(entry.Opndata);
            TB_Prdt1.SetPrintTextBlock(entry.PrdtName);
            TB_Prdt2.SetPrintTextBlock(entry.PrdtName);
            if (entry.ZHLX.Equals("2"))
            {
                TB_JSLX.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_JSLX.SetPrintTextBlock(entry.JSLX);
            }
            if (!string.IsNullOrEmpty(entry.Rate))
            {
                TB_Rate1.SetPrintTextBlock(string.Format("{0:N6}%", entry.Rate));
                TB_Rate2.SetPrintTextBlock(string.Format("{0:N6}%", entry.Rate));
            }
            else
            {
                TB_Rate1.SetPrintTextBlock(string.Empty);
                TB_Rate2.SetPrintTextBlock(string.Empty);

            }
            TB_Jyrq.SetPrintTextBlock(LoginUserInfo.TradeDate);
            TB_Data.SetPrintTextBlock(LoginUserInfo.TradeDate);
            TB_TradeType.SetPrintTextBlock(entry.TradeType);
            TB_TradeType1.SetPrintTextBlock(entry.TradeType);

            //var type = UserFunction.ChangeMoneySymbol(entry.Bz);
            var type = UserFunction.ChangeMoneySymbol("01");
            TB_TxAmt1.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            TB_TxAmt2.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            TB_lsh.SetPrintTextBlock(this.PrintAttribute.SerialNumber);
            TB_lx.SetPrintTextBlock(type + entry.Lx.ToString("N2"));
            TB_lx1.SetPrintTextBlock(type + entry.Lx.ToString("N2"));
            TB_lxs.SetPrintTextBlock(type + entry.Lxs.ToString("N2"));
            TB_lxs1.SetPrintTextBlock(type + entry.Lxs.ToString("N2"));
            //TB_czy.SetPrintTextBlock(LoginUserInfo.TellerNo); 
            //TB_czy.SetPrintTextBlock("(" + LoginUserInfo.TellerName + ")" + LoginUserInfo.TellerNo);
            TB_czy.Text = LoginUserInfo.TellerNo;
            TB_Teller2.SetPrintTextBlock(LoginUserInfo.TellerNo);
            if (!string.IsNullOrEmpty(entry.Zdzc))
            {
                TB_zdzc.Visibility = Visibility.Visible;
                TB_zdzc.SetPrintTextBlock(entry.Zdzc);
            }
            else
            {
                TB_zdzc.Visibility = Visibility.Hidden;
            }
            if (!string.IsNullOrEmpty(entry.QZLX))
            {
                if (LoginUserInfo.TradeDate.ToDecimal() < entry.DataEnd.ToDecimal())
                {
                    tbkQZLX3.SetPrintTextBlock("¥" + entry.QZLX);
                    tbkQZLX_3.SetPrintTextBlock("¥" + entry.QZLX);
                    tbkQZLX3.Visibility = tbkQZLX_3.Visibility = Visibility.Visible;
                    tbkQZLX.Visibility = tbkQZLX_1.Visibility = Visibility.Collapsed;
                    tbkQZLX2.Visibility = tbkQZLX_2.Visibility = Visibility.Collapsed;
                }
                else if (LoginUserInfo.TradeDate.ToDecimal() == entry.DataEnd.ToDecimal())
                {
                    tbkQZLX.SetPrintTextBlock("¥" + entry.QZLX);
                    tbkQZLX_1.SetPrintTextBlock("¥" + entry.QZLX);
                    tbkQZLX.Visibility = tbkQZLX_1.Visibility = Visibility.Visible;
                    tbkQZLX3.Visibility = tbkQZLX_3.Visibility = Visibility.Collapsed;
                    tbkQZLX2.Visibility = tbkQZLX_2.Visibility = Visibility.Collapsed;
                }
                else
                {
                    tbkQZLX2.SetPrintTextBlock("¥" + entry.QZLX);
                    tbkQZLX_2.SetPrintTextBlock("¥" + entry.QZLX);
                    tbkQZLX2.Visibility = tbkQZLX_2.Visibility = Visibility.Visible;
                    tbkQZLX.Visibility = tbkQZLX_1.Visibility = Visibility.Collapsed;
                    tbkQZLX3.Visibility = tbkQZLX_3.Visibility = Visibility.Collapsed;
                }
            }
            else
            {
                tbkQZLX.Visibility = tbkQZLX_1.Visibility = Visibility.Collapsed;
            }
            TB_sflx.SetPrintTextBlock(type + entry.Sflx.ToString("N2"));
            TB_sflx1.SetPrintTextBlock(type + entry.Sflx.ToString("N2"));
            TB_info1.Text = entry.Bzinfo1;
            // TB_dqlxs.SetPrintTextBlock(type + entry.Dqlxs.ToString("N2"));
            TB_khjg.SetPrintTextBlock(entry.Khjg);
            TB_jyjg.SetPrintTextBlock(LoginUserInfo.KinbrNo);
            TB_sfbx.SetPrintTextBlock(type + entry.Sfbxs.ToString("N2"));
            TB_sfbx1.SetPrintTextBlock(type + entry.Sfbxs.ToString("N2"));
            TB_info2.Text = entry.Bzinfo2;
            TB_info3.Text = entry.Bzinfo3;
            TB_LXZRFS.SetPrintTextBlock(entry.LXZRFS);
            TB_LXZRZH.SetPrintTextBlock(entry.LXZRZH);
            //业务流水
            TB_lsh.SetPrintTextBlock(this.PrintAttribute.SerialNumber);
            //核心流水
            tb_ls.SetPrintTextBlock(this.PrintAttribute.BusinessTransaction);
            // TB_sqy.SetPrintTextBlock(this.PrintAttribute.Authentic);//授权柜员号
            TB_sqy.Text = this.PrintAttribute.Authno;
            if (string.IsNullOrEmpty(entry.DfAcno))
            {
                TB_DfAcno1.Visibility = Visibility.Hidden;
                TB_DfAcno2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_DfAcno1.SetPrintTextBlock(entry.DfAcno);
                TB_DfAcno2.SetPrintTextBlock(entry.DfAcno.Substring(0, 6) + "****" + entry.DfAcno.Substring(entry.DfAcno.Length - 2, 2));
            }
            if (string.IsNullOrEmpty(entry.DfAcname))
            {
                TB_DfAcname1.Visibility = Visibility.Hidden;
                TB_DfAcname2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_DfAcname1.SetPrintTextBlock(entry.DfAcname);
                TB_DfAcname2.SetPrintTextBlock(entry.DfAcname);
            }
            if (FLAG == "V11")
            {
                if (entry.LXZRFS == "转账")
                {
                    TB_LXZRFS.Visibility = Visibility.Visible;
                    TB_LXZRZH.Visibility = Visibility.Visible;
                }
                else if (entry.LXZRFS == null)
                {
                    TB_LXZRFS.Visibility = Visibility.Collapsed;
                    TB_LXZRZH.Visibility = Visibility.Collapsed;
                }
                else
                {
                    TB_LXZRFS.Visibility = Visibility.Visible;
                    TB_LXZRZH.Visibility = Visibility.Collapsed;
                }
                TB_LXZRFS.SetValue(Canvas.TopProperty, 252.00);
                TB_LXZRZH.SetValue(Canvas.TopProperty, 252.00);
            }
            //代理人信息
            if (entry.SFDL == "Y")
            {
                if (!string.IsNullOrWhiteSpace(entry.DLRZJLX))
                {
                    TB_DLRZJLX.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrWhiteSpace(entry.DLRHM))
                {
                    TB_DLRHM.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrWhiteSpace(entry.DLRMC))
                {
                    TB_DLRMC.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrWhiteSpace(entry.DLRSJH))
                {
                    TB_DLRSJH.Visibility = Visibility.Visible;
                }
                TB_DLRZJLX.SetPrintTextBlock(entry.DLRZJLX);
                TB_DLRHM.SetPrintTextBlock(entry.DLRHM);
                TB_DLRMC.SetPrintTextBlock(entry.DLRMC);
                TB_DLRSJH.SetPrintTextBlock(entry.DLRSJH);
            }
            if (FLAG == "V5")
            {
                //山东需求 存款凭条柜员号打印位置上移14毫米
                TB_czy.SetValue(Canvas.TopProperty, 293.00);
                TB_sqy.SetValue(Canvas.TopProperty, 293.00);

                TB_Jyrq.SetValue(Canvas.TopProperty, 55.00);
                TB_Acno2.SetValue(Canvas.TopProperty, 71.00);
                TB_HM2.SetValue(Canvas.TopProperty, 87.00);

                TB_TxAmt2.SetValue(Canvas.TopProperty, 104.00);
                TB_lx1.SetValue(Canvas.TopProperty, 120.00);
                TB_lxs1.SetValue(Canvas.TopProperty, 135.00);
                TB_sflx1.SetValue(Canvas.TopProperty, 152.00);
                TB_sfbx1.SetValue(Canvas.TopProperty, 169.00);
                TB_TradeType1.SetValue(Canvas.TopProperty, 186.00);
                TB_OPNData2.SetValue(Canvas.TopProperty, 205.00);
                TB_Rate2.SetValue(Canvas.TopProperty, 222.00);
                TB_Prdt2.SetValue(Canvas.TopProperty, 238.00);
                TB_Teller2.SetValue(Canvas.TopProperty, 254.00);
                TB_DfAcno2.SetValue(Canvas.TopProperty, 271.00);
                TB_DfAcname2.SetValue(Canvas.TopProperty, 287.00);

                tbkQZLX_1.SetValue(Canvas.TopProperty, 301.00);
                tbkQZLX_2.SetValue(Canvas.TopProperty, 301.00);
                tbkQZLX3.SetValue(Canvas.TopProperty, 301.00);
                this.ElecSealHelper.Sign2Point(new Point(630, 175), TellerSystem.PrintTemplate.ElecSeal.SealKind.Receipt);//客户联印章
                
                if (LoginUserInfo.KinbrNo.Substring(0, 3) == "302")//黄骅
                {
                    TB_czy.SetValue(Canvas.TopProperty, 300.00);//300->290->300  NZYB
                    TB_czy.SetValue(Canvas.LeftProperty, 400.00);
                    TB_czy.Text = LoginUserInfo.TellerNo + "(" + LoginUserInfo.TellerName + ")";
                    if (!string.IsNullOrEmpty(entry.LWHCJG))
                    {
                        B_LWHC.Visibility = Visibility.Visible;
                        TB_HCJG.SetPrintTextBlock(entry.LWHCJG);
                    }
                    this.E_Seal_Location = new Point(276, 175);
                }
                if (LoginUserInfo.KinbrNo.Substring(0, 3) == "306")//青县
                {
                    TB_czy.SetValue(Canvas.TopProperty, 288.00);
                }
                BZ1.SetValue(Canvas.TopProperty, 265.00);
                BZ1.Visibility = Visibility.Visible;
            }
            if (FLAG == "V6")
            {
                if (LoginUserInfo.KinbrNo.Contains("103"))
                {
                    TB_czy.Visibility = Visibility.Collapsed;
                    TB_sqy.Visibility = Visibility.Collapsed;
                }
                else if (LoginUserInfo.KinbrNo.Contains("106"))
                {
                    TB_czy.SetValue(Canvas.TopProperty, 293.00);
                    TB_sqy.SetValue(Canvas.TopProperty, 293.00);
                }
            }
            if (FLAG == "V0")
            {
                TB_HM1.SetValue(Canvas.LeftProperty, 295.00);
                TB_Rate1.SetValue(Canvas.LeftProperty, 295.00);
                TB_TxAmt1.SetValue(Canvas.LeftProperty, 295.00);
                TB_lxs.SetValue(Canvas.LeftProperty, 295.00);
                TB_jyjg.SetValue(Canvas.LeftProperty, 295.00);
                TB_DfAcname1.SetValue(Canvas.LeftProperty, 295.00);
                TB_JSLX.SetValue(Canvas.LeftProperty, 295.00);
                TB_DLRSJH.SetValue(Canvas.LeftProperty, 295.00);
                TB_DLRHM.SetValue(Canvas.LeftProperty, 295.00);
                //交易复核人 
                if (!string.IsNullOrWhiteSpace(PrintAttribute.Review))
                {
                    var review = PrintAttribute.Review;
                    TB_sqy.Text = review.Substring(review.IndexOf("(") + 1, 6);
                }
                else
                {
                    TB_sqy.Visibility = Visibility.Collapsed;
                }
                //授权柜员号
                TB_Super.SetPrintTextBlock(PrintAttribute.Authno);
                TB_Super.Visibility = !string.IsNullOrWhiteSpace(PrintAttribute.Authno) ? Visibility.Visible : Visibility.Collapsed;
                //柜员流水、业务流水、TB_title一行
                TB_title.SetValue(Canvas.LeftProperty, 364.00);
                tb_ls.SetValue(Canvas.TopProperty, 72.00);
                TB_lsh.SetValue(Canvas.TopProperty, 72.00);
                TB_Note1.Visibility = Visibility.Visible;
                TB_Note1.SetValue(Canvas.LeftProperty, 77.00);
                TB_Note1.SetValue(Canvas.TopProperty, 250.00);
                TB_Note1.SetPrintTextBlock(entry.PZH.PadLeft(16, '0'));
            }
            if (FLAG == "V9")
            {
                TB_czy.Visibility = Visibility.Collapsed;
                TB_sqy.SetValue(Canvas.LeftProperty, 380.0);
            }
            //if (FLAG == "V0")
            //{
            //    TB_DLRSJH.Visibility = TB_DLRZJLX.Visibility = TB_DLRHM.Visibility = TB_DLRMC.Visibility = Visibility.Collapsed;
            //}
            if (FLAG == "V11")//隆丰打印位置调整
            {
                canvas_main.Margin = new Thickness(0, 30, 0, 0);
                TB_ZHXH.Visibility = Visibility.Visible;
                TB_ZHXH2.Visibility = Visibility.Visible;
                TB_Acno2.Visibility = Visibility.Collapsed;
                TB_info3.Visibility = Visibility.Visible;

                this.E_Seal_Location = new Point(405, 320);
                this.E_Seal2Copy(new Point(620, 320));//客户联印章

                this.PrintType = PrintTypes.TakeMoneyFront_LF;
                //柜员
                this.TB_czy.SetValue(Canvas.TopProperty, 425.00);
                this.TB_czy.SetValue(Canvas.LeftProperty, 345.00);
                //授权
                this.TB_sqy.SetValue(Canvas.TopProperty, 425.00);
                this.TB_sqy.SetValue(Canvas.LeftProperty, 230.00);
                BZ.Visibility = BZ1.Visibility = Visibility.Visible;
            }
            if (FLAG == "V7") //都匀只回单打印保险提示语
            {
                BZ3.Visibility = Visibility.Visible;
            }
            if ((FLAG == "V4" || FLAG =="V3") && !entry.ZHXH.Trim().PadLeft(6, '0').Equals("000001"))
            {
                TB_ZHXH.Visibility = Visibility.Visible;
                TB_ZHXH2.Visibility = Visibility.Visible;
                TB_Acno2.Visibility = Visibility.Collapsed;
            }
        }

        #endregion
    }
}
