﻿using System;
using System.Windows;
using System.Windows.Controls;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Interaction logic for Print_PersonalAccountingVoucher_Draw.xaml
    /// </summary>
    public partial class Print_PersonalAccountingVoucher_DrawxhQF : IPrintContract
    {
        
        public Print_PersonalAccountingVoucher_DrawxhQF(Print_PersonalAccountingVoucher_DrawxhQFEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public class Print_PersonalAccountingVoucher_DrawxhQFEntry : PrintEntry
        {
            /// <summary>
            /// 标题
            /// </summary>
            public string Title { get; set; }

            /// <summary>
            /// 结算类型
            /// </summary>
            public string JSLX { get; set; }

            /// <summary>
            /// 账户类型
            /// </summary>
            public string ZHLX { get; set; }

            /// <summary>
            /// 账号
            /// </summary>
            public string Acno { get; set; }

            /// <summary>
            /// 账户序号
            /// </summary>
            //  public string ZHXH { get; set; }

            /// <summary>
            /// 账户户名
            /// </summary>
            public string ZHHM { get; set; }
            /// <summary>
            /// 开户日
            /// </summary>
            public string Opndata { get; set; }
            /// <summary>
            /// 到期日
            /// </summary>
            public string DataEnd { get; set; }

            /// <summary>
            /// 开户行名
            /// </summary>
            // public string OpnName { get; set; }

            /// <summary>
            /// 储种
            /// </summary>
            public string PrdtName { get; set; }

            /// <summary>
            /// 利率
            /// </summary>
            public string Rate { get; set; }

            /// <summary>
            /// 交易类型
            /// </summary>
            public string TradeType { get; set; }

            /// <summary>
            /// 交易金额
            /// </summary>
            public decimal TxAmt { get; set; }



            /// <summary>
            /// 流水号
            /// </summary>
            // public string Lsh { get; set; }

            /// <summary>
            /// 利息
            /// </summary>
            public decimal Lx { get; set; }

            /// <summary>
            /// 利息税
            /// </summary>
            public decimal Lxs { get; set; }

            /// <summary>
            /// 自动转存
            /// </summary>
            public string Zdzc { get; set; }

            /// <summary>
            /// 实付利息
            /// </summary>
            public decimal Sflx { get; set; }

            /// <summary>
            /// 备注信息1
            /// </summary>
            public string Bzinfo1 { get; set; }
            /// <summary>
            /// 开户机构10
            /// </summary>
            public string Khjg { get; set; }
            /// <summary>
            /// 实付本息税
            /// </summary>
            public decimal Sfbxs { get; set; }

            /// <summary>
            /// 备注信息2
            /// </summary>
            public string Bzinfo2 { get; set; }

            /// <summary>
            /// 对方账号
            /// </summary>
            public string DfAcno { get; set; }

            /// <summary>
            /// 对方户名
            /// </summary>
            public string DfAcname { get; set; }
            /// <summary>
            /// 通存标志
            /// </summary>
            public string TCBZ { get; set; }
            /// <summary>
            /// 前置利息
            /// </summary>
            public string QZLX { get; set; }
            /// <summary>
            /// 余额
            /// </summary>
            //public decimal Bal { get; set; }
            /// <summary>
            /// 是否代理
            /// </summary>
            public string SFDL { get; set; }
            /// <summary>
            /// 代理人名称
            /// </summary>
            public string DLRMC { get; set; }
            /// <summary>
            /// 代理人号码
            /// </summary>
            public string DLRHM { get; set; }
            /// <summary>
            /// 代理人手机号
            /// </summary>
            public string DLRSJH { get; set; }
            /// <summary>
            /// 代理人证件类型
            /// </summary>
            public string DLRZJLX { get; set; }
            /// <summary>
            /// 代理人有效期
            /// </summary>
            public string DLRYXQ { get; set; }

        }

        #region IPrintContract Members

        public Contract.Entry.PrintEntry PrintData { get; private set; }

        public void LoadPrintData()
        {
            string Flag = TellerSystem.ServiceProxy.Ext.ServiceHelper.TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            var entry = PrintData as Print_PersonalAccountingVoucher_DrawxhQFEntry;
            if (entry == null)
                return;
            //TB_title.Text = entry.Title;
            switch (entry.TCBZ[4].ToString().Trim())
            {
                case "0":
                    TB_TCBZ.SetPrintTextBlock("非通存通兑");
                    break;
                case "1":
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
                case "2":
                    TB_TCBZ.SetPrintTextBlock("通存非通兑");
                    break;
                default:
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
            }
            TB_Acno1.SetPrintTextBlock(entry.Acno);
            TB_Acno2.SetPrintTextBlock(entry.Acno.Substring(0, 6) + "****" + entry.Acno.Substring(entry.Acno.Length - 2, 2));
            TB_HM1.SetPrintTextBlock(entry.ZHHM);
            TB_HM2.SetPrintTextBlock(entry.ZHHM);
            TB_OPNData.SetPrintTextBlock(entry.Opndata);
            TB_OPNData2.SetPrintTextBlock(entry.Opndata);
            TB_Prdt1.SetPrintTextBlock(entry.PrdtName);
            TB_Prdt2.SetPrintTextBlock(entry.PrdtName);
            if (entry.ZHLX.Equals("2"))
            {
                TB_JSLX.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_JSLX.SetPrintTextBlock(entry.JSLX);
            }
            if (!string.IsNullOrEmpty(entry.Rate))
            {
                TB_Rate1.SetPrintTextBlock(string.Format("{0:N6}%", entry.Rate));
                TB_Rate2.SetPrintTextBlock(string.Format("{0:N6}%", entry.Rate));
            }
            else
            {
                TB_Rate1.SetPrintTextBlock(string.Empty);
                TB_Rate2.SetPrintTextBlock(string.Empty);

            }
            if (Flag == "V21" || Flag == "V22")
            {
                //交易日期+时间
                var tradetime = DateTime.ParseExact(LoginUserInfo.GetUserInfo("TradeTime"), "HHmmss", null);
                TB_Jyrq.SetPrintTextBlock(LoginUserInfo.TradeDate + " " + tradetime.ToString("HH:mm:ss"));
                TB_Data.SetPrintTextBlock(LoginUserInfo.TradeDate + " " + tradetime.ToString("HH:mm:ss"));
            }
            else
            {
                TB_Jyrq.SetPrintTextBlock(LoginUserInfo.TradeDate);
                TB_Data.SetPrintTextBlock(LoginUserInfo.TradeDate);
            }
            TB_TradeType.SetPrintTextBlock(entry.TradeType);
            TB_TradeType1.SetPrintTextBlock(entry.TradeType);

            //var type = UserFunction.ChangeMoneySymbol(entry.Bz);
            var type = UserFunction.ChangeMoneySymbol("01");
            TB_TxAmt1.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            TB_TxAmt2.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            TB_lsh.SetPrintTextBlock(this.PrintAttribute.SerialNumber);
            TB_lx.SetPrintTextBlock(type + entry.Lx.ToString("N2"));
            TB_lx1.SetPrintTextBlock(type + entry.Lx.ToString("N2"));
            TB_lxs.SetPrintTextBlock(type + entry.Lxs.ToString("N2"));
            TB_lxs1.SetPrintTextBlock(type + entry.Lxs.ToString("N2"));
            //业务流水
            TB_lsh.SetPrintTextBlock(this.PrintAttribute.SerialNumber);
            //核心流水
            tb_ls.SetPrintTextBlock(this.PrintAttribute.BusinessTransaction);
            TB_sqy.Text = this.PrintAttribute.Authentic;
            TB_czy.Text = LoginUserInfo.TellerName + "(" + LoginUserInfo.TellerNo + ")";
            TB_Teller2.SetPrintTextBlock(LoginUserInfo.TellerNo);
            if (!string.IsNullOrEmpty(entry.Zdzc))
            {
                TB_zdzc.Visibility = Visibility.Visible;
                TB_zdzc.SetPrintTextBlock(entry.Zdzc);
            }
            else
            {
                TB_zdzc.Visibility = Visibility.Hidden;
            }
            //if (!string.IsNullOrEmpty(entry.QZLX))
            //{
            //    if (LoginUserInfo.TradeDate.ToDecimal() < entry.DataEnd.ToDecimal())
            //    {
            //        tbkQZLX3.SetPrintTextBlock("¥" + entry.QZLX);
            //        tbkQZLX_3.SetPrintTextBlock("¥" + entry.QZLX);
            //        tbkQZLX3.Visibility = tbkQZLX_3.Visibility = Visibility.Visible;
            //        tbkQZLX.Visibility = tbkQZLX_1.Visibility = Visibility.Collapsed;
            //        tbkQZLX2.Visibility = tbkQZLX_2.Visibility = Visibility.Collapsed;
            //    }
            //    else if (LoginUserInfo.TradeDate.ToDecimal() == entry.DataEnd.ToDecimal())
            //    {
            //        tbkQZLX.SetPrintTextBlock("¥" + entry.QZLX);
            //        tbkQZLX_1.SetPrintTextBlock("¥" + entry.QZLX);
            //        tbkQZLX.Visibility = tbkQZLX_1.Visibility = Visibility.Visible;
            //        tbkQZLX3.Visibility = tbkQZLX_3.Visibility = Visibility.Collapsed;
            //        tbkQZLX2.Visibility = tbkQZLX_2.Visibility = Visibility.Collapsed;
            //    }
            //    else
            //    {
            //        tbkQZLX2.SetPrintTextBlock("¥" + entry.QZLX);
            //        tbkQZLX_2.SetPrintTextBlock("¥" + entry.QZLX);
            //        tbkQZLX2.Visibility = tbkQZLX_2.Visibility = Visibility.Visible;
            //        tbkQZLX.Visibility = tbkQZLX_1.Visibility = Visibility.Collapsed;
            //        tbkQZLX3.Visibility = tbkQZLX_3.Visibility = Visibility.Collapsed;
            //    }
            //}
            //else
            //{
            //    tbkQZLX.Visibility = tbkQZLX_1.Visibility = Visibility.Collapsed;
            //}
            //TB_sflx.SetPrintTextBlock(type + entry.Sflx.ToString("N2"));
            //TB_sflx1.SetPrintTextBlock(type + entry.Sflx.ToString("N2"));
            TB_info1.Text = entry.Bzinfo1;
            // TB_dqlxs.SetPrintTextBlock(type + entry.Dqlxs.ToString("N2"));
            //TB_khjg.SetPrintTextBlock(entry.Khjg);
            //TB_jyjg.SetPrintTextBlock(LoginUserInfo.KinbrNo);
            TB_sfbx.SetPrintTextBlock(type + entry.Sfbxs.ToString("N2"));
            TB_sfbx1.SetPrintTextBlock(type + entry.Sfbxs.ToString("N2"));
            TB_info2.Text = entry.Bzinfo2;
            if (string.IsNullOrEmpty(entry.DfAcno))
            {
                TB_DfAcno1.Visibility = Visibility.Hidden;
                TB_DfAcno2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_DfAcno1.SetPrintTextBlock(entry.DfAcno);
                TB_DfAcno2.SetPrintTextBlock(entry.DfAcno.Substring(0, 6) + "****" + entry.DfAcno.Substring(entry.DfAcno.Length - 2, 2));
            }
            if (string.IsNullOrEmpty(entry.DfAcname))
            {
                TB_DfAcname1.Visibility = Visibility.Hidden;
                TB_DfAcname2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_DfAcname1.SetPrintTextBlock(entry.DfAcname);
                TB_DfAcname2.SetPrintTextBlock(entry.DfAcname);
            }
            if (entry.SFDL == "Y")
            {
                if (!string.IsNullOrWhiteSpace(entry.DLRZJLX))
                {
                    TB_DLRZJLX.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrWhiteSpace(entry.DLRHM))
                {
                    TB_DLRHM.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrWhiteSpace(entry.DLRMC))
                {
                    TB_DLRMC.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrWhiteSpace(entry.DLRSJH))
                {
                    TB_DLRSJH.Visibility = Visibility.Visible;
                }
                TB_DLRZJLX.SetPrintTextBlock(entry.DLRZJLX);
                TB_DLRHM.SetPrintTextBlock(entry.DLRHM);
                TB_DLRMC.SetPrintTextBlock(entry.DLRMC);
                TB_DLRSJH.SetPrintTextBlock(entry.DLRSJH);

                if (!string.IsNullOrWhiteSpace(entry.DLRYXQ))
                {
                    TB_DLRYXQ.Visibility = Visibility.Visible;
                }
                TB_DLRYXQ.SetPrintTextBlock(entry.DLRYXQ);
            }
            //新泰要求调整经办柜员和复核柜员的位置 
            if (Flag == "V18")
            {
                TB_sqy.SetValue(Canvas.TopProperty, 286.0);
                TB_czy.SetValue(Canvas.TopProperty, 286.0);

                this.E_Seal_Location = new Point(434, 177);
                this.E_Seal2Copy(new Point(690, 177));//客户联印章
            }
            else if (Flag == "V21")
            {
                this.E_Seal_Location = new Point(285, 207);
                this.E_Seal2Copy(new Point(690, 207));
            }
            else if (Flag == "V22")
            {
                this.E_Seal_Location = new Point(285, 187);
                this.E_Seal2Copy(new Point(690, 187));
            }
            else if (Flag == "V17")
            {
                this.E_Seal_Location = new Point(425, 187);
                this.E_Seal2Copy(new Point(685, 187));//客户联印章
            }
            else
            {
                this.E_Seal_Location = new Point(434, 207);
                this.E_Seal2Copy(new Point(690, 207));
            }
            if (Flag == "V19")
            {
                TB_czy.SetValue(Canvas.TopProperty, 360.0);//经办人
                TB_sqy.SetValue(Canvas.TopProperty, 360.0);//复核
                
                //代理人有效期
                TB_DLRYXQ.SetValue(Canvas.TopProperty, 224.0);
                TB_DLRYXQ.SetValue(Canvas.LeftProperty, 90.0);

                //整体调整位移
                PYL.Margin = new Thickness(-10, 5, 0, 0);
            }
            if (Flag == "V14")
            {
                BY.Visibility = Visibility.Visible;
            }
            if (Flag == "V10" || Flag == "V17" || Flag == "V22")
            {
                BZ.Visibility = BZ1.Visibility = Visibility.Visible;
                BZ1.FontSize = 12;
                if (Flag == "V22")
                {
                    BZ.Width = 200;
                    BZ.TextWrapping = TextWrapping.Wrap;
                    BZ.SetValue(Canvas.LeftProperty, 384.00);
                }
            }
            if (Flag == "V16")
            {
                BZ2.Visibility = Visibility.Visible;
            }
            if (Flag == "V22")
            {
                //代理人有效期
                TB_DLRYXQ.SetValue(Canvas.TopProperty, 218.0);
                TB_DLRYXQ.SetValue(Canvas.LeftProperty, 88.0);
            }
            if (Flag == "V21")
            {
                //代理人有效期
                TB_DLRYXQ.SetValue(Canvas.TopProperty, 224.0);
                TB_DLRYXQ.SetValue(Canvas.LeftProperty, 88.0);
            }
        }

        #endregion
    }
}
