﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Interaction logic for Print_PersonalAccountingVoucher_Transfer.xaml
    /// </summary>
    public partial class Print_PersonalAccountingVoucher_Transfer : IPrintContract
    {
        public Print_PersonalAccountingVoucher_Transfer(Print_PersonalAccountingVoucher_TransferEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
            this.BusinessType = "转账";
        }

        public class Print_PersonalAccountingVoucher_TransferEntry : PrintEntry
        {
            /// <summary>
            /// 付款账号
            /// </summary>
            public string PayerAcno { get; set; }

            /// <summary>
            /// 付款账户户名
            /// </summary>
            public string PayerZHHM { get; set; }

            /// <summary>
            /// 付款开户行
            /// </summary>
            public string PayerOpnname { get; set; }

            /// <summary>
            /// 付款序号
            /// </summary>
            public string PayerAcseqn { get; set; }

            /// <summary>
            /// 转出金额
            /// </summary>
            public decimal TxAmt { get; set; }

            /// <summary>
            /// 付款账户余额
            /// </summary>
            public decimal Bal { get; set; }

            /// <summary>
            /// 付款账户利率
            /// </summary>
            public decimal PayerRate { get; set; }

            /// <summary>
            /// 付款账户储种
            /// </summary>
            public string PayerPrdtName { get; set; }

            /// <summary>
            /// 科目
            /// </summary>
            public string Subject { get; set; }

            /// <summary>
            /// 收款账号
            /// </summary>
            public string PayeeAcno { get; set; }

            /// <summary>
            /// 收款人户名
            /// </summary>
            public string PayeeZHHM { get; set; }

            /// <summary>
            /// 转入银行名称
            /// </summary>
            public string PayeeBrName { get; set; }

            /// <summary>
            /// 转账用途
            /// </summary>
            public string TransferUsage { get; set; }

            /// <summary>
            /// 交易类型
            /// </summary>
            public string TradeType { get; set; }

            /// <summary>
            /// 现转标志
            /// </summary>
            public string CtInd { get; set; }
            /// <summary>
            /// 币种
            /// </summary>
            public string BZ { get; set; }
        }

        #region IPrintContract Members

        public Contract.Entry.PrintEntry PrintData { get; private set; }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_PersonalAccountingVoucher_TransferEntry;
            if (entry == null)
                return;
            TB_PayerAcseqn1.SetPrintTextBlock(entry.PayerAcseqn);
            TB_PayerAcno1.SetPrintTextBlock(entry.PayerAcno);
            TB_PayerAcno2.SetPrintTextBlock(entry.PayerAcno);
            TB_PayerHM1.SetPrintTextBlock(entry.PayerZHHM);
            TB_PayerHM2.SetPrintTextBlock(entry.PayerZHHM);
            TB_PayeeAcno1.SetPrintTextBlock(entry.PayeeAcno);
            TB_PayeeAcno2.SetPrintTextBlock(entry.PayeeAcno);
            TB_PayeeHM1.SetPrintTextBlock(entry.PayeeZHHM);
            TB_PayeeHM2.SetPrintTextBlock(entry.PayeeZHHM);
            TB_PayeeBrname1.SetPrintTextBlock(entry.PayeeBrName);
            TB_PayeeBrname2.SetPrintTextBlock(entry.PayeeBrName);
            TB_Usage1.SetPrintTextBlock(entry.TransferUsage);
            TB_Usage2.SetPrintTextBlock(entry.TransferUsage);
            var type = UserFunction.ChangeMoneySymbol(entry.BZ);
            TB_TxAmt1.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            TB_TxAmt2.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            TB_Prdt1.SetPrintTextBlock(entry.PayerPrdtName);
            TB_Prdt2.SetPrintTextBlock(entry.PayerPrdtName);
            TB_TradeType1.SetPrintTextBlock(entry.TradeType);
            TB_TradeType2.SetPrintTextBlock(entry.TradeType);
            TB_CtInd1.SetPrintTextBlock(entry.CtInd);
            TB_CtInd2.SetPrintTextBlock(entry.CtInd);
            TB_PayerOpnname1.SetPrintTextBlock(entry.PayerOpnname);
            //TB_Subject.Text = entry.Subject;

            //公共要素
            var tradedate = LoginUserInfo.TradeDate.ToDateTime();
            //交易日期          
            TB_Teller2.SetPrintTextBlock(LoginUserInfo.TellerNo);
        }

        #endregion
    }
}
