﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Interaction logic for Print_PwdEnvelope.xaml
    /// </summary>
    public partial class Print_PwdEnvelope : IPrintContract
    {
        public Print_PwdEnvelope(Print_PwdEnvelopeEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }


        #region IPrintContract Members

        public Contract.Entry.PrintEntry PrintData { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public void LoadPrintData()
        {
            var entry = PrintData as Print_PwdEnvelopeEntry;
            //TB_INFO.Text = entry.PrintInfo;
            if (entry.PZList == null) return;
            entry.IsBatchPrint = true;
            entry.BatchList = new System.Collections.Generic.List<Platform.Print.PrintContainer>();
            var list = entry.PZList.GroupBy(x => entry.PZList.IndexOf(x) / 30);
            foreach (var item in list)
            {
                var p = new Print_PwdEnvelope(entry);
                p.TB_INFO.Text = string.Format("账号:{0}      凭证类型:{1}", entry.Account, entry.PZLX);
                p.TB_List.ItemsSource = item.ToList();
                entry.BatchList.Add(p);
            }
        }

        #endregion

        public class Print_PwdEnvelopeEntry : PrintEntry
        {
            /// <summary>
            /// 账号
            /// </summary>
            public string Account { get; set; }

            /// <summary>
            /// 凭证类型
            /// </summary>
            public string PZLX { get; set; }

            /// <summary>
            /// 密码清单
            /// </summary>
            public List<Tuple<string, string>> PZList { get; set; }
        }
    }
}
