﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Contract.Function;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Interaction logic for Print_PersonalAccountingVoucher_Deposit.xaml
    /// </summary>
    public partial class Print_SavePage_YL : IPrintContract
    {

        public Print_SavePage_YL(Print_PersonalAccountingVoucher_DepositEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public class Print_PersonalAccountingVoucher_DepositEntry : PrintEntry
        {
            public Print_PersonalAccountingVoucher_DepositEntry()
            {
                //默认带有介质
                HasJZ = true;
                //默认显示"是否带介质"
                DisplayHasJZ = true;
            }

            /// <summary>
            /// 银行留存联账号
            /// </summary>
            public string Acno { get; set; }
            /// <summary>
            /// 客户回单账户
            /// </summary>
            public string Acno1 { get; set; }

            /// <summary>
            /// 账户序号
            /// </summary>
            public string ZHXH { get; set; }

            /// <summary>
            /// 开户行名
            /// </summary>
            public string OpnName { get; set; }

            /// <summary>
            /// 账户户名
            /// </summary>
            public string ZHHM { get; set; }

            /// <summary>
            /// 交易金额
            /// </summary>
            public decimal TxAmt { get; set; }

            /// <summary>
            /// 账户余额
            /// </summary>
            public string tbAccount { get; set; }

            /// <summary>
            /// 余额
            /// </summary>
            public decimal Bal { get; set; }
            /// <summary>
            /// 利率
            /// </summary>
            public string Rate { get; set; }

            /// <summary>
            /// 储种
            /// </summary>
            public string PrdtName { get; set; }

            /// <summary>
            /// 存期
            /// </summary>
            // public string Term { get; set; }

            /// <summary>
            /// 凭证号码
            /// </summary>
            public string NoteNo { get; set; }

            /// <summary>
            /// 科目
            /// </summary>
            public string Subject { get; set; }

            /// <summary>
            /// 是否带介质
            /// </summary>
            public bool HasJZ { get; set; }

            /// <summary>
            /// 是否显示"是否带介质"
            /// </summary>
            public bool DisplayHasJZ { get; set; }

            /// <summary>
            /// 现转标志
            /// </summary>
            public string CtInd { get; set; }

            /// <summary>
            /// 交易类型
            /// </summary>
            public string TradeType { get; set; }

            /// <summary>
            /// 对方账号
            /// </summary>
            public string DfAcno { get; set; }

            /// <summary>
            /// 对方户名
            /// </summary>
            public string DfAcname { get; set; }

            /// <summary>
            /// 币种
            /// </summary>
            public string BZ { get; set; }
            /// <summary>
            /// 流水号
            /// </summary>
            public string LSH { get; set; }
            /// <summary>
            /// 表头
            /// </summary>
            public string Title { get; set; }
            /// <summary>
            /// 留密户
            /// </summary>
            public string Lmh { get; set; }
            /// <summary>
            ///自动转存
            /// </summary>
            public string ZDZC { get; set; }
            /// <summary>
            /// 通存标志
            /// </summary>
            public string TCBZ { get; set; }
            /// <summary>
            /// 账户类型
            /// </summary>
            public string PZHLX { get; set; }
            /// <summary>
            /// 提息账户
            /// </summary>
            public string TXZH { get; set; }
            /// <summary>
            /// 提息户名
            /// </summary>
            public string TXHM { get; set; }
            /// <summary>
            /// 代理人姓名
            /// </summary>
            public string DLRXM { get; set; }
            /// <summary>
            /// 代理人证件类型
            /// </summary>
            public string DLRZJLX { get; set; }
            /// <summary>
            /// 代理人证件号码
            /// </summary>
            public string DLRZJHM { get; set; }
            /// <summary>
            /// 代理人手机号
            /// </summary>
            public string DLRSJH { get; set; }
            /// <summary>
            /// 代理人证件有效期
            /// </summary>
            public string DLRYXQ { get; set; }
            /// <summary>
            /// 账户分级
            /// </summary>
            public string cbAccountFJ { get; set; }
        }

        #region IPrintContract Members

        public Contract.Entry.PrintEntry PrintData { get; private set; }

        public void LoadPrintData()
        {
            string flag = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            var entry = PrintData as Print_PersonalAccountingVoucher_DepositEntry;
            if (entry == null)
                return;
            TB_title.Text = entry.Title;
            switch (entry.TCBZ[4].ToString().Trim())
            {
                case "0":
                    TB_TCBZ.SetPrintTextBlock("非通存通兑");
                    break;
                case "1":
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
                case "2":
                    TB_TCBZ.SetPrintTextBlock("通存非通兑");
                    break;
                default:
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
            }
            TB_OPNNAME.SetPrintTextBlock(entry.OpnName);
            TB_Acno1.SetPrintTextBlock(entry.Acno);
            //TB_Acno2.SetPrintTextBlock(entry.Acno);
            if (flag == "V23" || flag == "V24")
            {
                TB_Acno2.SetPrintTextBlock(entry.Acno.Substring(0, 6) + "****" + entry.Acno.Substring(entry.Acno.Length - 2, 2));
            }
            else
            {
                if (entry.Acno1 != null)
                {
                    TB_Acno2.SetPrintTextBlock(entry.Acno1);

                }
                else
                {
                    TB_Acno2.SetPrintTextBlock(entry.Acno);
                }
            }
           

            // TB_ZHXH.SetPrintTextBlock(entry.ZHXH);
          
            TB_HM1.SetPrintTextBlock(entry.ZHHM);
            if (flag == "V23" || flag == "V24")
            {
                TB_HM2.SetPrintTextBlock(entry.ZHHM.Substring(0, 1) + "**");
            }
            else { 
            TB_HM2.SetPrintTextBlock(entry.ZHHM);
            }
            TB_Note1.SetPrintTextBlock(entry.NoteNo.PadLeft(TellerSystem.Library.Ext.Variables.UserVariable.Len_VoucherNo, '0'));
            var type = UserFunction.ChangeMoneySymbol(entry.BZ);
            TB_TxAmt1.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            TB_TxAmt2.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            if (entry.tbAccount != null)
            {
                tb_Account.Visibility = Visibility.Visible;
                tb_Account.SetPrintTextBlock(type + entry.tbAccount);
            }
            if (entry.PZHLX != null)
            {
                ZHLX.Visibility = Visibility.Visible;
                ZHLX.SetPrintTextBlock(entry.PZHLX);
            }
            if (entry.HasJZ)
            {
                TB_HasMdm1.SetPrintTextBlock("是");
            }
            else
            {
                TB_HasMdm1.SetPrintTextBlock("否");
            }
            TB_HasMdm1.Visibility = entry.DisplayHasJZ ? Visibility.Visible : Visibility.Hidden;

            TB_Prdt1.SetPrintTextBlock(entry.PrdtName);
            TB_Prdt2.SetPrintTextBlock(entry.PrdtName);
            //业务流水
            TB_lsh.SetPrintTextBlock(this.PrintAttribute.SerialNumber);
            //核心流水
            tb_ls.SetPrintTextBlock(this.PrintAttribute.BusinessTransaction);
            //TB_sqy.SetPrintTextBlock(this.PrintAttribute.Authentic);//授权柜员号 
            TB_rq.SetPrintTextBlock(LoginUserInfo.TradeDate);
            //TB_czy.SetPrintTextBlock("("+LoginUserInfo.TellerName+")"+LoginUserInfo.TellerNo);
            //TB_sqy.SetPrintTextBlock(this.PrintAttribute.Authno);//授权柜员号 
            TB_sqy.Text = this.PrintAttribute.Authno;
            // TB_czy.SetPrintTextBlock(LoginUserInfo.TellerNo);
            TB_czy.Text = LoginUserInfo.TellerNo;
            TB_jyh.SetPrintTextBlock(LoginUserInfo.KinbrNo);
            //if (string.IsNullOrEmpty(entry.Term))
            //{
            //    TB_Term1.Visibility = Visibility.Hidden;
            //}
            //else
            //{
            //    TB_Term1.SetPrintTextBlock(entry.Term);
            //}
            TB_TradeType1.SetPrintTextBlock(entry.TradeType);
            TB_jylx.SetPrintTextBlock(entry.TradeType);
            TB_CtInd1.SetPrintTextBlock(entry.CtInd);
            // TB_CtInd2.SetPrintTextBlock(entry.CtInd);
            if (string.IsNullOrEmpty(entry.DfAcno))
            {
                TB_DfAcno1.Visibility = Visibility.Hidden;
                TB_DfAcno2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_DfAcno1.SetPrintTextBlock(entry.DfAcno);
                if (flag == "V23" || flag == "V24")
                {
                    TB_DfAcno2.SetPrintTextBlock(entry.DfAcno.Substring(0, 6) + "****" + entry.DfAcno.Substring(entry.DfAcno.Length - 2, 2));
                }
                else {
                    TB_DfAcno2.SetPrintTextBlock(entry.DfAcno);
                }
            }
            if (string.IsNullOrEmpty(entry.DfAcname))
            {
                TB_DfAcname1.Visibility = Visibility.Hidden;
                TB_DfAcname2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_DfAcname1.SetPrintTextBlock(entry.DfAcname);
                if (flag == "V23" || flag == "V24")
                {
                    TB_DfAcname2.SetPrintTextBlock(entry.DfAcname.Substring(0, 1) + "**");
                }
                else
                {
                    TB_DfAcname2.SetPrintTextBlock(entry.DfAcname);
                }
            }
            TB_SFLM.SetPrintTextBlock(entry.Lmh);
            if (!string.IsNullOrEmpty(entry.ZDZC))
            {
                TB_ZDZC.Visibility = TB_ZDZC1.Visibility = Visibility.Visible;
                TB_ZDZC.SetPrintTextBlock(entry.ZDZC);
                TB_ZDZC1.SetPrintTextBlock(entry.ZDZC);
            }
            if (flag == "V2" && !string.IsNullOrEmpty(entry.TXZH))
            {
                TXZH.Visibility = TxHM.Visibility = Visibility.Visible;
                TXZH.SetPrintTextBlock(entry.TXZH);
                TxHM.SetPrintTextBlock(entry.TXHM);
            }
            //公共要素
            var tradedate = LoginUserInfo.TradeDate.ToDateTime();
            TB_Teller2.SetPrintTextBlock(LoginUserInfo.TellerNo);
            TB_Jyra.SetPrintTextBlock(LoginUserInfo.TradeDate);
            if (!string.IsNullOrEmpty(entry.Rate))
            {
                TB_Rate1.SetPrintTextBlock(string.Format("{0:N6}%", entry.Rate));
                TB_Rate2.SetPrintTextBlock(string.Format("{0:N6}%", entry.Rate));
            }
            else
            {
                TB_Rate1.SetPrintTextBlock(string.Empty);
                TB_Rate2.SetPrintTextBlock(string.Empty);
            }
            //新郑要求 存款凭条 往上挪动
            if ((flag == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152"))
            {
                TB_czy.SetValue(Canvas.TopProperty, 476.00);
                TB_sqy.SetValue(Canvas.TopProperty, 476.00);
                SM.Visibility = SM1.Visibility = Visibility.Visible;
            }
            //新郑要求 存款凭条 往上挪动
            if (flag == "V23" || flag == "V24")
            {
                TB_czy.SetValue(Canvas.TopProperty, 426.00);
                TB_sqy.SetValue(Canvas.TopProperty, 426.00);
            }
            if (flag == "V24")
            {
                if (entry.PrdtName.StartsWith("旭日鑫三号"))
                {
                    TB_Rate1.SetValue(Canvas.LeftProperty, 282.00);//利率
                }
                if (entry.PrdtName.Equals("定活通存款"))//不显示利率
                {
                    TB_Rate1.Text = "";
                    TB_Rate2.Text = "";
                }
            }
            //浚县增加代理人信息
            if (flag == "V23")
            {
                if (!string.IsNullOrEmpty(entry.DLRXM))
                {
                    DLRXM.SetPrintTextBlock(entry.DLRXM);
                    DLRXM.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrEmpty(entry.DLRZJLX))
                {
                    DLRZJLX.SetPrintTextBlock(entry.DLRZJLX);
                    DLRZJLX.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrEmpty(entry.DLRZJHM))
                {
                    DLRZJHM.SetPrintTextBlock(entry.DLRZJHM);
                    DLRZJHM.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrEmpty(entry.DLRSJH))
                {
                    DLRSJH.SetPrintTextBlock(entry.DLRSJH);
                    DLRSJH.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrEmpty(entry.DLRYXQ))
                {
                    DLRZJYXQ.SetPrintTextBlock(entry.DLRYXQ);
                    DLRZJYXQ.Visibility = Visibility.Visible;
                }
                tb_Account.SetValue(Canvas.TopProperty, 192.00);//账户余额放置于对方户名后面
                if (entry.PZHLX != null)//账户类型不为空时，代表活期，把账户类型放置于自动转存处
                {
                    ZHLX.SetValue(Canvas.TopProperty, 150.00);
                    ZHLX.SetValue(Canvas.LeftProperty, 444.00);
                }
            }

            if (flag == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152" && !string.IsNullOrEmpty(entry.cbAccountFJ))
            {
                tb_cbAccountFJ.Visibility = Visibility.Visible;
                tb_cbAccountFJ.SetPrintTextBlock(entry.cbAccountFJ);
            }
        }
        #endregion
    }
}
