﻿using System;
using System.Windows;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Interaction logic for Print_SignatureCard.xaml
    /// </summary>
    public partial class Print_SignatureCard : IPrintContract
    {
        public Print_SignatureCard(Print_SignatureCardEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public class Print_SignatureCardEntry : PrintEntry
        {
            /// <summary>
            /// 编号
            /// </summary>
            public string BH { get; set; }
            /// <summary>
            /// 户名
            /// </summary>
            public string HM { get; set; }
            /// <summary>
            /// 账号
            /// </summary>
            public string ZH { get; set; }
            /// <summary>
            /// 账户类型
            /// </summary>
            public string ZHLX{ get; set; }
            /// <summary>
            /// 科目号
            /// </summary>
            public string KMH{ get; set; }
            /// <summary>
            /// 启用日期：年
            /// </summary>
            public string Year1 { get; set; }
            /// <summary>
            /// 启用日期：月
            /// </summary>
            public string Month1 { get; set; }
            /// <summary>
            /// 启用日期：日
            /// </summary>
            public string Day1 { get; set; }
            /// <summary>
            /// 销户日期：年
            /// </summary>
            public string Year2 { get; set; }
            ///  <summary>
            /// 销户日期：月
            /// </summary>
            public string Month2 { get; set; }
            /// <summary>
            /// 销户日期：日
            /// </summary>
            public string Day2 { get; set; }
            /// <summary>
            /// 联系人1
            /// </summary>
            public string Man1 { get; set; }
            /// <summary>
            /// 联系人电话1
            /// </summary>
            public string Phone1 { get; set; }
            /// <summary>
            /// 联系人2
            /// </summary>
            public string Man2 { get; set; }
            /// <summary>
            /// 联系人电话2
            /// </summary>
            public string Phone2 { get; set; }
            

        }

        #region IPrintContract Members

        public Contract.Entry.PrintEntry PrintData { get; private set; }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_SignatureCardEntry;
            if (entry == null)
                return;
            BH.Text = ((string.IsNullOrEmpty(entry.BH)) ? "" : entry.BH);//编号
            HM.Text = ((string.IsNullOrEmpty(entry.HM)) ? "" : entry.HM);//户名
            ZH.Text = ((string.IsNullOrEmpty(entry.ZH)) ? "" : entry.ZH);//账号
            ZHLX.Text = ((string.IsNullOrEmpty(entry.ZHLX)) ? "" : entry.ZHLX);//账号类型
            KMH.Text = ((string.IsNullOrEmpty(entry.KMH)) ? "" : entry.KMH);//科目号
            Year1.Text = ((string.IsNullOrEmpty(entry.Year1)) ? "" : entry.Year1);//启用日期：年
            Month1.Text = ((string.IsNullOrEmpty(entry.Month1)) ? "" : entry.Month1);//启用日期：月
            Day1.Text = ((string.IsNullOrEmpty(entry.Day1)) ? "" : entry.Day1);//启用日期：日
            Year2.Text = ((string.IsNullOrEmpty(entry.Year2)) ? "" : entry.Year2);//销户日期：年
            Month2.Text = ((string.IsNullOrEmpty(entry.Month2)) ? "" : entry.Month2);//销户日期：月
            Day2.Text = ((string.IsNullOrEmpty(entry.Day2)) ? "" : entry.Day2);//销户日期：日
            Man1.Text = ((string.IsNullOrEmpty(entry.Man1)) ? "" : entry.Man1);//联系人1
            Phone1.Text = ((string.IsNullOrEmpty(entry.Phone1)) ? "" : entry.Phone1);//联系人电话1
            Man2.Text = ((string.IsNullOrEmpty(entry.Man2)) ? "" : entry.Man2);//联系人2
            Phone2.Text = ((string.IsNullOrEmpty(entry.Phone2)) ? "" : entry.Phone2);//联系人电话2

        }

        #endregion
    }
}
