﻿using System;
using System.Globalization;
using System.Windows;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using System.Windows.Media.Imaging;
using TellerSystem.PrintTemplate.Base;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;
using System.Windows.Controls;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Print_SignatureCard1_CCRF.xaml 的交互逻辑
    /// </summary>
    public partial class Print_SignatureCard1_CCRF : IPrintContract
    {
        public Print_SignatureCard1_CCRF(Print_SignatureCard1_CCRFEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }
        public Contract.Entry.PrintEntry PrintData
        {
            get;
            private set;
        }

        public class Print_SignatureCard1_CCRFEntry : PrintEntry
        {
            /// <summary>
            /// 户名
            /// </summary>
            public string HM;
            /// <summary>
            /// 账号
            /// </summary>
            public string ZH;
            /// <summary>
            /// 开户机构
            /// </summary>
            public string KHJG;
            /// <summary>
            /// 账户性质
            /// </summary>
            public string ZHXZ;
            /// <summary>
            /// 启用日期
            /// </summary>
            public string QYRQ;
            /// <summary>
            /// 证件类型
            /// </summary>
            public string ZHLX;
            /// <summary>
            /// 证件号码
            /// </summary>
            public string ZJHM;
            /// <summary>
            /// 财务主管
            /// </summary>
            public string CWZG;
            /// <summary>
            /// 财务主管电话号码
            /// </summary>
            public string LXDH1;
            /// <summary>
            /// 法定代表人
            /// </summary>
            public string FDDBR;
            /// <summary>
            /// 法定代表人电话号码
            /// </summary>
            public string LXDH2;
            /// <summary>
            /// 预留印鉴1
            /// </summary>
            public string YLYJ1;
            /// <summary>
            /// 预留印鉴2
            /// </summary>
            public string YLYJ2;
            /// <summary>
            /// 印鉴个数
            /// </summary>
            public string YJGS;
            /// <summary>
            /// 负责人签字
            /// </summary>
            public string FZRQZ;
            /// <summary>
            /// 经办
            /// </summary>
            public string JB;
            /// <summary>
            /// 复核
            /// </summary>
            public string FH;
            /// <summary>
            /// 授权
            /// </summary>
            public string SQ;
            /// <summary>
            /// 建印
            /// </summary>
            public string JY;
            /// <summary>
            /// 建印复核
            /// </summary>
            public string JYFH;
            /// <summary>
            /// 注销字样   天骄增加
            /// </summary>
            public string ZX;
        }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_SignatureCard1_CCRFEntry;
            this.HM.Text = entry.HM;
            this.ZH.Text = entry.ZH;
            this.KHJG.Text = entry.KHJG;
            this.ZHXZ.Text = entry.ZHXZ;
            this.QYRQ.Text = entry.QYRQ;
            this.ZHLX.Text = entry.ZHLX;
            this.ZJHM.Text = entry.ZJHM;
            this.CWZG.Text = entry.CWZG;
            this.LXDH1.Text = entry.LXDH1;
            this.FDDBR.Text = entry.FDDBR;
            this.LXDH2.Text = entry.LXDH2;
            this.YJGS.Text = entry.YJGS;
            this.FZRQZ.Text = entry.FZRQZ;
            this.JB.Text = LoginUserInfo.TellerNo;
            this.FH.Text = entry.FH;
            this.SQ.Text = entry.SQ;
            this.JY.Text = entry.JY;
            this.JYFH.Text = entry.JYFH;

            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            if (FLAG == "V22")//乳山天骄，更换底层预览
            {
                this.PrintType = PrintTypes.SignatureCard1_CCRF_TJ;
                this.DocumentName = "预留印鉴卡";
            }
            if (FLAG == "V8")//阳光
            {
                this.PrintType = PrintTypes.SignatureCard1_CCRF;
                this.DocumentName = "预留印鉴卡";
                HM.SetValue(Canvas.TopProperty, 73.00);//56
                HM.SetValue(Canvas.LeftProperty, 110.00);//110

                ZH.SetValue(Canvas.TopProperty, 95.00);//88
                ZH.SetValue(Canvas.LeftProperty, 110.00);//110

                KHJG.SetValue(Canvas.TopProperty, 95.00);//88
                KHJG.SetValue(Canvas.LeftProperty, 430.00);//430

                ZHXZ.SetValue(Canvas.TopProperty, 120.00);//119
                ZHXZ.SetValue(Canvas.LeftProperty, 110.00);//110 

                QYRQ.SetValue(Canvas.TopProperty, 120.00);//119
                QYRQ.SetValue(Canvas.LeftProperty, 430.00);//430

                ZHLX.SetValue(Canvas.TopProperty, 143.00);//148
                ZHLX.SetValue(Canvas.LeftProperty, 110.00);//110

                ZJHM.SetValue(Canvas.TopProperty, 143.00);//148
                ZJHM.SetValue(Canvas.LeftProperty, 430.00);//430

                CWZG.SetValue(Canvas.TopProperty, 169.00);//179
                CWZG.SetValue(Canvas.LeftProperty, 110.00);//110

                LXDH1.SetValue(Canvas.TopProperty, 169.00);//179
                LXDH1.SetValue(Canvas.LeftProperty, 275.00);//270

                FDDBR.SetValue(Canvas.TopProperty, 169.00);//179
                FDDBR.SetValue(Canvas.LeftProperty, 430.00);//425

                LXDH2.SetValue(Canvas.TopProperty, 169.00);//179
                LXDH2.SetValue(Canvas.LeftProperty, 580.00);//580

                JB.SetValue(Canvas.TopProperty, 467.00);//487
                JB.SetValue(Canvas.LeftProperty, 141.00);//101

                SQ.SetValue(Canvas.TopProperty, 467.00);//487
                SQ.SetValue(Canvas.LeftProperty, 540.00);//340
            }
            else if (FLAG == "V21")
            {
                this.DocumentName = "预留印鉴卡";
            }
            if (FLAG == "V21" || FLAG == "V22")//天骄 对公销户后增加打印注销印鉴卡
            {
                if (entry.ZX.Equals("注销"))
                {
                    TB_ZX.Visibility = Visibility.Visible;
                    ZX.Text = LoginUserInfo.TradeDate.Substring(0, 4) + "年" + LoginUserInfo.TradeDate.Substring(4, 2) + "月" + LoginUserInfo.TradeDate.Substring(6, 2) + "日注销";
                }
            }
        }
    }
}