﻿using System;
using System.Windows;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using System.Windows.Controls;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Interaction logic for Print_SignatureCard.xaml
    /// </summary>
    public partial class Print_SignatureCardQF : IPrintContract
    {
        /// <summary>
        /// 版本控制
        /// </summary>
        string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");

        public Print_SignatureCardQF(Print_SignatureCardQFEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public class Print_SignatureCardQFEntry : PrintEntry
        {
            /// <summary>
            /// 邮编
            /// </summary>
            public string YB { get; set; }
            /// <summary>
            /// 户名
            /// </summary>
            public string HM { get; set; }
            /// <summary>
            /// 账号
            /// </summary>
            public string ZH { get; set; }
            ///// <summary>
            ///// 账户类型
            ///// </summary>
            //public string ZHLB{ get; set; }
            ///// <summary>
            ///// 编号
            ///// </summary>
            //public string BH { get; set; }
            /// <summary>
            /// 客户号
            /// </summary>
            public string KHH { get; set; }
            ///// <summary>
            ///// 财务负责人
            ///// </summary>
            //public string FZR{ get; set; }
            /// <summary>
            /// 启用日期：年
            /// </summary>
            public string Year { get; set; }
            /// <summary>
            /// 启用日期：月
            /// </summary>
            public string Month { get; set; }
            /// <summary>
            /// 启用日期：日
            /// </summary>
            public string Day { get; set; }
            ///// <summary>
            ///// 经办人员
            ///// </summary>
            //public string JBRY { get; set; }
            ///  <summary>
            /// 地址
            /// </summary>
            public string Address { get; set; }
            /// <summary>
            /// 销户日期：日
            /// </summary>
            public string Day2 { get; set; }
            /// <summary>
            /// 联系人
            /// </summary>
            public string Man { get; set; }
            /// <summary>
            /// 联系人电话
            /// </summary>
            public string Phone { get; set; }
            ///// <summary>
            ///// 联系人2
            ///// </summary>
            //public string Man2 { get; set; }
            ///// <summary>
            ///// 联系人电话2
            ///// </summary>
            //public string Phone2 { get; set; }
            

        }

        #region IPrintContract Members

        public Contract.Entry.PrintEntry PrintData { get; private set; }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_SignatureCardQFEntry;
            if (entry == null)
                return;
            //BH.Text = ((string.IsNullOrEmpty(entry.BH)) ? "" : entry.BH);//编号
            YB.Text = ((string.IsNullOrEmpty(entry.YB)) ? "" : entry.YB);//邮编
            HM.Text = ((string.IsNullOrEmpty(entry.HM)) ? "" : entry.HM);//户名
            ZH.Text = ((string.IsNullOrEmpty(entry.ZH)) ? "" : entry.ZH);//账号
            KHH.Text = ((string.IsNullOrEmpty(entry.KHH)) ? "" : entry.KHH);//客户号
            Year.Text = ((string.IsNullOrEmpty(entry.Year)) ? "" : entry.Year);//启用日期：年
            Month.Text = ((string.IsNullOrEmpty(entry.Month)) ? "" : entry.Month);//启用日期：月
            Day.Text = ((string.IsNullOrEmpty(entry.Day)) ? "" : entry.Day);//启用日期：日
            //FZR.Text = ((string.IsNullOrEmpty(entry.FZR)) ? "" : entry.FZR);//财务负责人
            //JBRY.Text = ((string.IsNullOrEmpty(entry.JBRY)) ? "" : entry.JBRY);//经办人员
            Address.Text = ((string.IsNullOrEmpty(entry.Address)) ? "" : entry.Address);//地址
            Man.Text = ((string.IsNullOrEmpty(entry.Man)) ? "" : entry.Man);//联系人1
            Phone.Text = ((string.IsNullOrEmpty(entry.Phone)) ? "" : entry.Phone);//联系人电话1
            //Man2.Text = ((string.IsNullOrEmpty(entry.Man2)) ? "" : entry.Man2);//联系人2
            //Phone2.Text = ((string.IsNullOrEmpty(entry.Phone2)) ? "" : entry.Phone2);//联系人电话2

            if (FLAG == "V18" || FLAG == "V17" || FLAG == "V16" || FLAG == "V19")
            {
                ZH.SetValue(Canvas.TopProperty, 45.0);
                HM.SetValue(Canvas.TopProperty, 66.0);
                Man.SetValue(Canvas.TopProperty, 90.0);
                KHH.SetValue(Canvas.TopProperty, 66.0);
                Phone.SetValue(Canvas.TopProperty, 90.0);
                Address.SetValue(Canvas.TopProperty, 114.0);
            }
        }

        #endregion
    }
}
