﻿using System;
using System.Windows;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Interaction logic for Print_SignatureCard.xaml
    /// </summary>
    public partial class Print_SignatureCardXM : IPrintContract
    {
        public Print_SignatureCardXM(Print_SignatureCardXMEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public class Print_SignatureCardXMEntry : PrintEntry
        {
            /// <summary>
            /// 币种
            /// </summary>
            public string BZ { get; set; }
            /// <summary>
            /// 户名
            /// </summary>
            public string HM { get; set; }
            /// <summary>
            /// 账号
            /// </summary>
            public string ZH { get; set; }
            /// <summary>
            /// 账户类型
            /// </summary>
            public string ZHLB{ get; set; }
            /// <summary>
            /// 财务负责人
            /// </summary>
            public string FZR{ get; set; }
            /// <summary>
            /// 启用日期：年
            /// </summary>
            public string Year { get; set; }
            /// <summary>
            /// 启用日期：月
            /// </summary>
            public string Month { get; set; }
            /// <summary>
            /// 启用日期：日
            /// </summary>
            public string Day { get; set; }
            /// <summary>
            /// 经办人员
            /// </summary>
            public string JBRY { get; set; }
            ///  <summary>
            /// 地址
            /// </summary>
            public string Address { get; set; }
            /// <summary>
            /// 销户日期：日
            /// </summary>
            public string Day2 { get; set; }
            ///// <summary>
            ///// 联系人1
            ///// </summary>
            //public string Man1 { get; set; }
            /// <summary>
            /// 联系人电话1
            /// </summary>
            public string Phone1 { get; set; }
            ///// <summary>
            ///// 联系人2
            ///// </summary>
            //public string Man2 { get; set; }
            /// <summary>
            /// 联系人电话2
            /// </summary>
            public string Phone2 { get; set; }
            

        }

        #region IPrintContract Members

        public Contract.Entry.PrintEntry PrintData { get; private set; }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_SignatureCardXMEntry;
            if (entry == null)
                return;
            BZ.Text = "人民币";//币种
            HM.Text = ((string.IsNullOrEmpty(entry.HM)) ? "" : entry.HM);//户名
            ZH.Text = ((string.IsNullOrEmpty(entry.ZH)) ? "" : entry.ZH);//账号
            ZHLB.Text = ((string.IsNullOrEmpty(entry.ZHLB)) ? "" : entry.ZHLB);//账号类型
            Year.Text = ((string.IsNullOrEmpty(entry.Year)) ? "" : entry.Year);//启用日期：年
            Month.Text = ((string.IsNullOrEmpty(entry.Month)) ? "" : entry.Month);//启用日期：月
            Day.Text = ((string.IsNullOrEmpty(entry.Day)) ? "" : entry.Day);//启用日期：日
            FZR.Text = ((string.IsNullOrEmpty(entry.FZR)) ? "" : entry.FZR);//财务负责人
            JBRY.Text = ((string.IsNullOrEmpty(entry.JBRY)) ? "" : entry.JBRY);//经办人员
            Address.Text = ((string.IsNullOrEmpty(entry.Address)) ? "" : entry.Address);//地址
            //Man1.Text = ((string.IsNullOrEmpty(entry.Man1)) ? "" : entry.Man1);//联系人1
            Phone1.Text = ((string.IsNullOrEmpty(entry.Phone1)) ? "" : entry.Phone1);//联系人电话1
            //Man2.Text = ((string.IsNullOrEmpty(entry.Man2)) ? "" : entry.Man2);//联系人2
            Phone2.Text = ((string.IsNullOrEmpty(entry.Phone2)) ? "" : entry.Phone2);//联系人电话2

        }

        #endregion
    }
}
