﻿using System;
using System.Windows;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Interaction logic for Print_SignatureCard.xaml
    /// </summary>
    public partial class Print_SignatureCardXM2 : IPrintContract
    {
        public Print_SignatureCardXM2(Print_SignatureCardXM2Entry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public class Print_SignatureCardXM2Entry : PrintEntry
        {
            /// <summary>
            /// 启用日期：年
            /// </summary>
            public string Year { get; set; }
            /// <summary>
            /// 启用日期：月
            /// </summary>
            public string Month { get; set; }
            /// <summary>
            /// 启用日期：日
            /// </summary>
            public string Day { get; set; }
            /// <summary>
            /// 更换日期
            /// </summary>
            public string ChangeDate { get; set; }
            public string OldYJK { get; set; }

        }

        #region IPrintContract Members

        public Contract.Entry.PrintEntry PrintData { get; private set; }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_SignatureCardXM2Entry;
            if (entry == null)
                return;
            Year.Text = ((string.IsNullOrEmpty(entry.Year)) ? "" : entry.Year);//启用日期：年
            Month.Text = ((string.IsNullOrEmpty(entry.Month)) ? "" : entry.Month);//启用日期：月
            Day.Text = ((string.IsNullOrEmpty(entry.Day)) ? "" : entry.Day);//启用日期：日
            GHRQ.Text = entry.ChangeDate;
            XHRQ.Text = entry.ChangeDate;
            JYJH.SetPrintTextBlock(entry.OldYJK);
        }

        #endregion
    }
}
