﻿using System;
using System.Windows;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using System.Windows.Controls;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Interaction logic for Print_SignatureCardXX.xaml
    /// </summary>
    public partial class Print_SignatureCardXX : IPrintContract
    {
        public Print_SignatureCardXX(Print_SignatureCardXXEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public class Print_SignatureCardXXEntry : PrintEntry
        {
            /// <summary>
            /// 户名
            /// </summary>
            public string HM { get; set; }
            /// <summary>
            /// 账号
            /// </summary>
            public string ZH { get; set; }
            /// <summary>
            /// 账户类别
            /// </summary>
            public string ZHLB { get; set; }
            /// <summary>
            /// 币种
            /// </summary>
            public string BZ { get; set; }
            /// <summary>
            /// 启用日期：年
            /// </summary>
            public string Year { get; set; }
            /// <summary>
            /// 启用日期：月
            /// </summary>
            public string Month { get; set; }
            /// <summary>
            /// 启用日期：日
            /// </summary>
            public string Day { get; set; }
            /// <summary>
            /// 财务负责人
            /// </summary>
            public string Man { get; set; }
            /// <summary>
            /// 财务负责人联系电话
            /// </summary>
            public string Phone { get; set; }
            /// <summary>
            /// 经办人
            /// </summary>
            public string Man1 { get; set; }
            /// <summary>
            /// 经办人联系电话
            /// </summary>
            public string Phone1 { get; set; }
        }

        #region IPrintContract Members

        public Contract.Entry.PrintEntry PrintData { get; private set; }

        public void LoadPrintData()
        {
            var entry = PrintData as Print_SignatureCardXXEntry;
            if (entry == null)
                return;
            HM.Text = ((string.IsNullOrEmpty(entry.HM)) ? "" : entry.HM);//户名
            ZH.Text = ((string.IsNullOrEmpty(entry.ZH)) ? "" : entry.ZH);//账号
            ZHLB.Text = ((string.IsNullOrEmpty(entry.ZHLB)) ? "" : entry.ZHLB);//账户类别
            BZ.Text = ((string.IsNullOrEmpty(entry.BZ)) ? "" : entry.BZ);//币种
            Year.Text = ((string.IsNullOrEmpty(entry.Year)) ? "" : entry.Year);//启用日期：年
            Month.Text = ((string.IsNullOrEmpty(entry.Month)) ? "" : entry.Month);//启用日期：月
            Day.Text = ((string.IsNullOrEmpty(entry.Day)) ? "" : entry.Day);//启用日期：日
            Man.Text = ((string.IsNullOrEmpty(entry.Man)) ? "" : entry.Man);//财务负责人
            Phone.Text = ((string.IsNullOrEmpty(entry.Phone)) ? "" : entry.Phone);//财务负责人联系电话
            Man1.Text = ((string.IsNullOrEmpty(entry.Man1)) ? "" : entry.Man1);//经办人
            Phone1.Text = ((string.IsNullOrEmpty(entry.Phone1)) ? "" : entry.Phone1);//经办人联系电话
        }

        #endregion
    }
}
