﻿using System;
using System.Windows;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;
using System.Windows.Controls;
using TellerSystem.PrintTemplate.Base;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Interaction logic for Print_SignatureCard.xaml
    /// </summary>
    public partial class Print_SignatureCardXZ : IPrintContract
    {
        public Print_SignatureCardXZ(Print_SignatureCardXZEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public class Print_SignatureCardXZEntry : PrintEntry
        {
            /// <summary>
            /// 编号
            /// </summary>
            public string YB { get; set; }
            /// <summary>
            /// 户名
            /// </summary>
            public string HM { get; set; }
            /// <summary>
            /// 账号
            /// </summary>
            public string ZH { get; set; }
            /// <summary>
            /// 账户类型
            /// </summary>
            public string ZHLB{ get; set; }
            /// <summary>
            /// 财务负责人
            /// </summary>
            public string FZR{ get; set; }
            /// <summary>
            /// 启用日期：年
            /// </summary>
            public string Year { get; set; }
            /// <summary>
            /// 启用日期：月
            /// </summary>
            public string Month { get; set; }
            /// <summary>
            /// 启用日期：日
            /// </summary>
            public string Day { get; set; }
            /// <summary>
            /// 经办人员
            /// </summary>
            public string JBRY { get; set; }
            ///  <summary>
            /// 地址
            /// </summary>
            public string Address { get; set; }
            /// <summary>
            /// 销户日期：日
            /// </summary>
            public string Day2 { get; set; }
            ///// <summary>
            ///// 联系人1
            ///// </summary>
            //public string Man1 { get; set; }
            /// <summary>
            /// 联系人电话1
            /// </summary>
            public string Phone1 { get; set; }
            ///// <summary>
            ///// 联系人2
            ///// </summary>
            //public string Man2 { get; set; }
            /// <summary>
            /// 联系人电话2
            /// </summary>
            public string Phone2 { get; set; }

            /// <summary>
            /// 经办人电话
            /// </summary>
            public string Tel1 { get; set; }
            /// <summary>
            /// 财务负责人电话
            /// </summary>
            public string Tel2 { get; set; }
        }

        #region IPrintContract Members

        public Contract.Entry.PrintEntry PrintData { get; private set; }

        public void LoadPrintData()
        {
             string flag = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            var entry = PrintData as Print_SignatureCardXZEntry;
            if (entry == null)
                return;
            YB.Text = ((string.IsNullOrEmpty(entry.YB)) ? "" : entry.YB);//邮编
            HM.Text = ((string.IsNullOrEmpty(entry.HM)) ? "" : entry.HM);//户名
            ZH.Text = ((string.IsNullOrEmpty(entry.ZH)) ? "" : entry.ZH);//账号
            ZHLB.Text = ((string.IsNullOrEmpty(entry.ZHLB)) ? "" : entry.ZHLB);//账号类型
            Year.Text = ((string.IsNullOrEmpty(entry.Year)) ? "" : entry.Year);//启用日期：年
            Month.Text = ((string.IsNullOrEmpty(entry.Month)) ? "" : entry.Month);//启用日期：月
            Day.Text = ((string.IsNullOrEmpty(entry.Day)) ? "" : entry.Day);//启用日期：日
            FZR.Text = ((string.IsNullOrEmpty(entry.FZR)) ? "" : entry.FZR);//财务负责人
            JBRY.Text = ((string.IsNullOrEmpty(entry.JBRY)) ? "" : entry.JBRY);//经办人员
            Address.Text = ((string.IsNullOrEmpty(entry.Address)) ? "" : entry.Address);//地址
            //Man1.Text = ((string.IsNullOrEmpty(entry.Man1)) ? "" : entry.Man1);//联系人1
            Phone1.Text = ((string.IsNullOrEmpty(entry.Phone1)) ? "" : entry.Phone1);//联系人电话1
            //Man2.Text = ((string.IsNullOrEmpty(entry.Man2)) ? "" : entry.Man2);//联系人2
            Phone2.Text = ((string.IsNullOrEmpty(entry.Phone2)) ? "" : entry.Phone2);//联系人电话2
            Tel1.Text = ((string.IsNullOrEmpty(entry.Tel1)) ? "" : entry.Tel1);//经办人电话
            Tel2.Text = ((string.IsNullOrEmpty(entry.Tel2)) ? "" : entry.Tel2);//财务负责人电话
            if (flag == "V24")
            {
                HM.SetValue(Canvas.TopProperty, 64.00);
                HM.SetValue(Canvas.LeftProperty, 50.00);

                ZH.SetValue(Canvas.TopProperty, 90.00);
                ZH.SetValue(Canvas.LeftProperty, 50.00);

                ZHLB.SetValue(Canvas.TopProperty, 115.00);
                ZHLB.SetValue(Canvas.LeftProperty, 60.00);

                YB.SetValue(Canvas.TopProperty, 64.00);
                YB.SetValue(Canvas.LeftProperty, 452.00);

                Phone1.SetValue(Canvas.TopProperty, 90.00);
                Phone1.SetValue(Canvas.LeftProperty, 392.00);

                Phone2.SetValue(Canvas.TopProperty, 115.00);
                Phone2.SetValue(Canvas.LeftProperty, 392.00);

                Address.SetValue(Canvas.TopProperty, 144.00);
                Address.SetValue(Canvas.LeftProperty, 56.00);

                Year.SetValue(Canvas.TopProperty, 153.00);
                Year.SetValue(Canvas.LeftProperty, 406.00);

                Month.SetValue(Canvas.TopProperty, 153.00);
                Month.SetValue(Canvas.LeftProperty, 450.00);

                Day.SetValue(Canvas.TopProperty, 153.00);
                Day.SetValue(Canvas.LeftProperty, 491.00);

                 JBRY.SetValue(Canvas.TopProperty, 90.00);
                JBRY.SetValue(Canvas.LeftProperty, 265.00);

                FZR.SetValue(Canvas.TopProperty, 115.00);
                FZR.SetValue(Canvas.LeftProperty, 257.00);                                                
            }
            if (flag == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152")
            {
                HM.SetValue(Canvas.TopProperty, 70.00);
                HM.SetValue(Canvas.LeftProperty, 74.00);

                ZH.SetValue(Canvas.TopProperty, 95.00);
                ZH.SetValue(Canvas.LeftProperty, 74.00);

                ZHLB.SetValue(Canvas.TopProperty, 120.00);
                ZHLB.SetValue(Canvas.LeftProperty, 94.00);

                YB.SetValue(Canvas.TopProperty, 70.00);
                YB.SetValue(Canvas.LeftProperty, 470.00);

                Phone1.SetValue(Canvas.TopProperty, 95.00);
                Phone1.SetValue(Canvas.LeftProperty, 410.00);

                Phone2.SetValue(Canvas.TopProperty, 120.00);
                Phone2.SetValue(Canvas.LeftProperty, 410.00);

                Address.SetValue(Canvas.TopProperty, 145.00);
                Address.SetValue(Canvas.LeftProperty, 70.00);

                Year.SetValue(Canvas.TopProperty, 145.00);
                Year.SetValue(Canvas.LeftProperty, 440.00);

                Month.SetValue(Canvas.TopProperty, 145.00);
                Month.SetValue(Canvas.LeftProperty, 490.00);

                Day.SetValue(Canvas.TopProperty, 145.00);
                Day.SetValue(Canvas.LeftProperty, 525.00);

                JBRY.SetValue(Canvas.TopProperty, 95.00);
                JBRY.SetValue(Canvas.LeftProperty, 294.00);

                FZR.SetValue(Canvas.TopProperty, 120.00);
                FZR.SetValue(Canvas.LeftProperty, 305.00);
            }
            if (flag == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "122")
            {
                HM.SetValue(Canvas.TopProperty, 73.00);
                HM.SetValue(Canvas.LeftProperty, 72.00);

                ZH.SetValue(Canvas.TopProperty, 96.00);
                ZH.SetValue(Canvas.LeftProperty, 74.00);

                ZHLB.SetValue(Canvas.TopProperty, 118.00);
                ZHLB.SetValue(Canvas.LeftProperty, 94.00);

                YB.SetValue(Canvas.TopProperty, 70.00);
                YB.SetValue(Canvas.LeftProperty, 450.00);

                Phone1.SetValue(Canvas.TopProperty, 96.00);
                Phone1.SetValue(Canvas.LeftProperty, 485.00);

                Phone2.SetValue(Canvas.TopProperty, 118.00);
                Phone2.SetValue(Canvas.LeftProperty, 485.00);

                Address.SetValue(Canvas.TopProperty, 140.00);
                Address.SetValue(Canvas.LeftProperty, 70.00);

                Year.SetValue(Canvas.TopProperty, 140.00);
                Year.SetValue(Canvas.LeftProperty, 395.00);

                Month.SetValue(Canvas.TopProperty, 140.00);
                Month.SetValue(Canvas.LeftProperty, 445.00);

                Day.SetValue(Canvas.TopProperty, 140.00);
                Day.SetValue(Canvas.LeftProperty, 480.00);

                JBRY.SetValue(Canvas.TopProperty, 96.00);
                JBRY.SetValue(Canvas.LeftProperty, 274.00);

                FZR.SetValue(Canvas.TopProperty, 118.00);
                FZR.SetValue(Canvas.LeftProperty, 285.00);

                Tel1.SetValue(Canvas.TopProperty, 96.00);
                Tel1.SetValue(Canvas.LeftProperty, 360.00);

                Tel2.SetValue(Canvas.TopProperty, 118.00);
                Tel2.SetValue(Canvas.LeftProperty, 360.00);

                this.PrintType = PrintTypes.SignatureCardYL;
                Tel1.Visibility = Tel2.Visibility = Visibility.Visible;
            }
        }

        #endregion
    }
}
