﻿using System;
using System.Windows;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;
using System.Windows.Controls;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Interaction logic for Print_PersonalAccountingVoucher_Draw.xaml
    /// </summary>
    public partial class Print_TakeMoneyFront_YL : IPrintContract
    {
        public Print_TakeMoneyFront_YL(Print_PersonalAccountingVoucher_DrawEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
            //this.BusinessType = "取款";
        }

        public class Print_PersonalAccountingVoucher_DrawEntry : PrintEntry
        {

            /// <summary>
            /// 标题
            /// </summary>
            public string Title { get; set; }
            /// <summary>
            /// 银行留存联账号
            /// </summary>
            public string Acno { get; set; }
            /// <summary>
            /// 客户回单账号
            /// </summary>
            public string Acno1 { get; set; }
            /// <summary>
            /// 账户户名
            /// </summary>
            public string ZHHM { get; set; }

            /// <summary>
            /// 开户行名
            /// </summary>
            public string OpnBrno { get; set; }

            /// <summary>
            /// 储种
            /// </summary>
            public string PrdtName { get; set; }

            /// <summary>
            /// 利率
            /// </summary>
            public string Rate { get; set; }

            /// <summary>
            /// 存期
            /// </summary>
            //public string Term { get; set; }

            /// <summary>
            /// 交易金额
            /// </summary>
            public decimal TxAmt { get; set; }
            /// <summary>
            /// 账户余额
            /// </summary>
            public string tbAccount { get; set; }

            /// <summary>
            /// 凭证号码
            /// </summary>
            public string NoteNo { get; set; }

            /// <summary>
            /// 账户类型
            /// </summary>
            public string Zhlx { get; set; }

            /// <summary>
            /// 交易类型
            /// </summary>
            public string TradeType { get; set; }

            /// <summary>
            /// 现转标志
            /// </summary>
            public string CtInd { get; set; }

            /// <summary>
            /// 自动转存
            /// </summary>
            public string ZDZC { get; set; }


            /// <summary>
            /// 对方户名
            /// </summary>
            public string DfAcname { get; set; }


            /// <summary>
            /// 账户介质
            /// </summary>
            public string ZHJZ { get; set; }

            /// <summary>
            /// 银行留存联对方账号
            /// </summary>
            public string DfAcno { get; set; }
            /// <summary>
            /// 客户回单对方账号
            /// </summary>
            public string DfAcno1 { get; set; }
            /// <summary>
            /// 利息
            /// </summary>
            public string Lx { get; set; }
            /// <summary>
            /// 利息税
            /// </summary>
            public string Lxs { get; set; }
            /// <summary>
            /// 实付利息
            /// </summary>
            public string Sflx { get; set; }
            /// <summary>
            /// 实付本息
            /// </summary>
            public string Sfbx { get; set; }

            //结算类型
            public string jslx { get; set; }

            /// <summary>
            /// 通存通兑标志
            /// </summary>
            public string TCBZ { get; set; }
            ///// 余额
            ///// </summary>
            //public decimal Bal { get; set; }

            /// <summary>
            /// 代理人姓名
            /// </summary>
            public string DLRXM { get; set; }
            /// <summary>
            /// 代理人证件类型
            /// </summary>
            public string DLRZJLX { get; set; }
            /// <summary>
            /// 代理人证件号码
            /// </summary>
            public string DLRZJHM { get; set; }
            /// <summary>
            /// 代理人手机号
            /// </summary>
            public string DLRSJH { get; set; }
            /// <summary>
            /// 代理人证件有效期
            /// </summary>
            public string DLRYXQ { get; set; }
            /// <summary>
            /// 用途
            /// </summary>
            public string YT { get; set; }

            /*
             *  
             /// <summary>
             /// 账户序号
             /// </summary>
            public string ZHXH { get; set; }
             *   /// <summary>
            /// 余额
            /// </summary>
            public decimal Bal { get; set; }

            /// <summary>
            /// 新凭证号
            /// </summary>
            public string NewNoteNo { get; set; }

            /// <summary>
            /// 科目
            /// </summary>
            public string Subject { get; set; }
             * 
             * */

        }

        #region IPrintContract Members

        public Contract.Entry.PrintEntry PrintData { get; private set; }

        public void LoadPrintData()
        {
            string flag = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            var entry = PrintData as Print_PersonalAccountingVoucher_DrawEntry;
            if (entry == null)
                return;
            TB_title.Text = entry.Title;
            switch (entry.TCBZ[4].ToString().Trim())
            {
                case "0":
                    TB_TCBZ.SetPrintTextBlock("非通存通兑");
                    break;
                case "1":
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
                case "2":
                    TB_TCBZ.SetPrintTextBlock("通存非通兑");
                    break;
                default:
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
            }
            TB_Acno1.SetPrintTextBlock(entry.Acno);
            if (flag == "V23" || flag == "V24")
            {
                TB_Acno2.SetPrintTextBlock(entry.Acno.Substring(0, 6) + "****" + entry.Acno.Substring(entry.Acno.Length - 2, 2));
            }
            else
            {
                //TB_Acno2.SetPrintTextBlock(entry.Acno);
                if (entry.Acno1 != null)
                {
                    TB_Acno2.SetPrintTextBlock(entry.Acno1);

                }
                else
                {
                    TB_Acno2.SetPrintTextBlock(entry.Acno);
                }
            }

            TB_HM1.SetPrintTextBlock(entry.ZHHM);
            if (flag == "V23" || flag == "V24")
            {
                TB_HM2.SetPrintTextBlock(entry.ZHHM.Substring(0, 1) + "**");
            }
            else
            {
                TB_HM2.SetPrintTextBlock(entry.ZHHM);
            }
            TB_OPNbrno.SetPrintTextBlock(entry.OpnBrno);
            TB_Prdt1.SetPrintTextBlock(entry.PrdtName);
            TB_Prdt2.SetPrintTextBlock(entry.PrdtName);
            if (!string.IsNullOrEmpty(entry.Rate))
            {
                TB_Rate1.SetPrintTextBlock(string.Format("{0:N6}%", entry.Rate));
            }
            else
            {
                TB_Rate1.SetPrintTextBlock(string.Empty);
            }
            //定期部提需要打印介质种类
            if (!string.IsNullOrEmpty(entry.ZHJZ))
            {
                TB_ZHJZ.Visibility = Visibility.Visible;
                TB_ZHJZ.SetPrintTextBlock(entry.ZHJZ);
            }

            TB_lsh.SetPrintTextBlock(this.PrintAttribute.SerialNumber);
            //TB_Term1.SetPrintTextBlock(entry.Term);
            var type = UserFunction.ChangeMoneySymbol("01");
            TB_TxAmt1.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            TB_TxAmt2.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            if (entry.tbAccount != null)
            {
                tb_Account.Visibility = Visibility.Visible;
                tb_Account.SetPrintTextBlock(type + entry.tbAccount);
            }

            TB_Jyrq.SetPrintTextBlock(LoginUserInfo.TradeDate);
            TB_data.SetPrintTextBlock(LoginUserInfo.TradeDate);
            TB_Note1.SetPrintTextBlock(entry.NoteNo.PadLeft(TellerSystem.Library.Ext.Variables.UserVariable.Len_VoucherNo, '0'));
            TB_Teller2.SetPrintTextBlock(LoginUserInfo.TellerNo);
            //TB_Czy.SetPrintTextBlock(LoginUserInfo.TellerNo);
            //TB_Czy.SetPrintTextBlock("(" + LoginUserInfo.TellerName + ")" + LoginUserInfo.TellerNo);
            TB_Czy.Text = LoginUserInfo.TellerNo;
            if (!string.IsNullOrEmpty(entry.Zhlx))
            {
                TB_Zhlx.Visibility = Visibility.Visible;
                TB_Zhlx.SetPrintTextBlock(entry.Zhlx);
            }
            TB_TradeType.SetPrintTextBlock(entry.TradeType);
            TB_jylx.SetPrintTextBlock(entry.TradeType);
            TB_CtInd1.SetPrintTextBlock(entry.CtInd);
            TB_xzbz.SetPrintTextBlock(entry.CtInd);
            TB_jyh.SetPrintTextBlock(LoginUserInfo.KinbrNo);
            if (!string.IsNullOrEmpty(entry.ZDZC))
            {
                TB_ZDZC.Visibility = Visibility.Visible;
                TB_ZDZC.SetPrintTextBlock(entry.ZDZC);
            }
            if (string.IsNullOrEmpty(entry.DfAcno))
            {
                TB_DfAcno1.Visibility = Visibility.Hidden;
                TB_DfAcno2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_DfAcno1.SetPrintTextBlock(entry.DfAcno);
                //TB_DfAcno2.SetPrintTextBlock(entry.DfAcno);
                if (flag == "V23" || flag == "V24")
                {
                    TB_DfAcno2.SetPrintTextBlock(entry.DfAcno.Substring(0, 6) + "****" + entry.DfAcno.Substring(entry.DfAcno.Length - 2, 2));

                }
                else
                {
                    if (entry.DfAcno1 != null)
                    {
                        TB_DfAcno2.SetPrintTextBlock(entry.DfAcno1);

                    }
                    else
                    {
                        TB_DfAcno2.SetPrintTextBlock(entry.DfAcno);
                    }
                }


            }
            if (string.IsNullOrEmpty(entry.DfAcname))
            {
                TB_DfAcname1.Visibility = Visibility.Hidden;
                TB_DfAcname2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_DfAcname1.SetPrintTextBlock(entry.DfAcname);
                if (flag == "V23" || flag == "V24")
                {
                    TB_DfAcname2.SetPrintTextBlock(entry.DfAcname.Substring(0, 1) + "**");
                }
                else
                {
                    TB_DfAcname2.SetPrintTextBlock(entry.DfAcname);
                }
            }
            if (string.IsNullOrEmpty(entry.Lx))
            {
                TB_Lx.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_Lx.Visibility = Visibility.Visible;
                TB_Lx.SetPrintTextBlock("¥" + entry.Lx);
            }
            //if (string.IsNullOrEmpty(entry.Lxs))
            //{
            //    TB_Lxs.Visibility = Visibility.Hidden;
            //}
            //else
            //{
            //    TB_Lxs.Visibility = Visibility.Visible;
            //    TB_Lxs.SetPrintTextBlock("¥" + entry.Lxs);
            //}
            if (string.IsNullOrEmpty(entry.Sflx))
            {
                TB_Sflx.Visibility = Visibility.Hidden;
                TB_Sflx2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_Sflx.Visibility = Visibility.Visible;
                TB_Sflx.SetPrintTextBlock("¥" + entry.Sflx);
                TB_Sflx2.Visibility = Visibility.Visible;
                TB_Sflx2.SetPrintTextBlock("¥" + entry.Sflx);
            }
            if (string.IsNullOrEmpty(entry.Sfbx))
            {
                TB_SfBx.Visibility = Visibility.Hidden;
                TB_SfBx2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_SfBx.Visibility = Visibility.Visible;
                TB_SfBx.SetPrintTextBlock("¥" + entry.Sfbx);
                TB_SfBx2.Visibility = Visibility.Visible;
                TB_SfBx2.SetPrintTextBlock("¥" + entry.Sfbx);
            }



            //业务流水
            TB_lsh.SetPrintTextBlock(this.PrintAttribute.SerialNumber);
            //核心流水
            tb_ls.SetPrintTextBlock(this.PrintAttribute.BusinessTransaction);
            //TB_sqy.SetPrintTextBlock(this.PrintAttribute.Authno);//授权柜员号
            TB_sqy.Text = this.PrintAttribute.Authno;
            ////定活两便的利率和自动转存默认是空
            //if (entry.PrdtName.Contains("定活两便"))
            //{
            //    TB_Rate1.SetPrintTextBlock(string.Empty);
            //    TB_ZDZC.SetPrintTextBlock(string.Empty);
            //}

            //if(string.IsNullOrEmpty(entry.TradeType))
            //{
            //    TB_NewNote1.Visibility = Visibility.Hidden;
            //}
            //else
            //{
            //    TB_NewNote1.SetPrintTextBlock(entry.NewNoteNo);
            //}

            // TB_Bal1.SetPrintTextBlock(type + entry.Bal.ToString("N2"));
            //TB_Bal2.SetPrintTextBlock(type + entry.Bal.ToString("N2"));

            // TB_Rate2.SetPrintTextBlock(string.Format("{0:N6}%", entry.Rate));

            //TB_Subject.Text = entry.Subject;
            //if (string.IsNullOrEmpty(entry.Term))
            //{
            //    TB_Term1.Visibility = Visibility.Hidden;
            //    TB_Term2.Visibility = Visibility.Hidden;
            //}
            //else
            //{

            //    TB_Term2.SetPrintTextBlock(entry.Term);
            //}


            //TB_CtInd1.SetPrintTextBlock(entry.CtInd);
            //TB_CtInd2.SetPrintTextBlock(entry.CtInd);

            //  TB_ZHXH.SetPrintTextBlock(entry.ZHXH);
            //公共要素
            //var tradedate = LoginUserInfo.TradeDate.ToDateTime();          
            //TB_Teller2.SetPrintTextBlock(LoginUserInfo.TellerNo);

            //TB_Jyrq.SetPrintTextBlock(LoginUserInfo.TradeDate);
            //新郑要求 存款凭条 往上挪动
            if (flag == "V23" || flag == "V24")
            {
                if (flag == "V23")
                {
                    TB_Czy.SetValue(Canvas.TopProperty, 446.00);
                    TB_sqy.SetValue(Canvas.TopProperty, 446.00);
                }
                else
                {
                    TB_Czy.SetValue(Canvas.TopProperty, 426.00);
                    TB_sqy.SetValue(Canvas.TopProperty, 426.00);
                }

                TB_Jyrq.SetValue(Canvas.LeftProperty, 640.00);
                TB_Acno2.SetValue(Canvas.LeftProperty, 640.00);
                TB_Prdt2.SetValue(Canvas.LeftProperty, 640.00);
                TB_HM2.SetValue(Canvas.LeftProperty, 640.00);
                TB_jylx.SetValue(Canvas.LeftProperty, 640.00);
                TB_xzbz.SetValue(Canvas.LeftProperty, 640.00);
                TB_TxAmt2.SetValue(Canvas.LeftProperty, 640.00);
                TB_Sflx2.SetValue(Canvas.LeftProperty, 640.00);
                TB_SfBx2.SetValue(Canvas.LeftProperty, 640.00);
                TB_Teller2.SetValue(Canvas.LeftProperty, 640.00);
                TB_DfAcno2.SetValue(Canvas.LeftProperty, 640.00);
                TB_DfAcname2.SetValue(Canvas.LeftProperty, 640.00);


            }
            if ((flag == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152"))
            {
                SM.Visibility = SM1.Visibility = Visibility.Visible;
            }
            if (flag == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "122")
            {
                SM1.Visibility = Visibility.Visible;
            }
            if (flag == "V24")
            {
                if (entry.PrdtName.StartsWith("旭日鑫三号"))
                {
                    TB_Rate1.SetValue(Canvas.LeftProperty, 270.00);//利率
                }
            }
            //浚县增加代理人信息
            if (flag == "V23")
            {
                if (!string.IsNullOrEmpty(entry.DLRXM))
                {
                    DLRXM.SetPrintTextBlock(entry.DLRXM);
                    DLRXM.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrEmpty(entry.DLRZJLX))
                {
                    DLRZJLX.SetPrintTextBlock(entry.DLRZJLX);
                    DLRZJLX.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrEmpty(entry.DLRZJHM))
                {
                    DLRZJHM.SetPrintTextBlock(entry.DLRZJHM);
                    DLRZJHM.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrEmpty(entry.DLRSJH))
                {
                    DLRSJH.SetPrintTextBlock(entry.DLRSJH);
                    DLRSJH.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrEmpty(entry.DLRYXQ))
                {
                    DLRZJYXQ.SetPrintTextBlock(entry.DLRYXQ);
                    DLRZJYXQ.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrEmpty(entry.YT))
                {
                    YT.SetPrintTextBlock(entry.YT);
                    YT2.SetPrintTextBlock(entry.YT);
                    YT.Visibility = YT2.Visibility = Visibility.Visible;

                    TB_Lx.SetValue(Canvas.TopProperty, 210.00);
                    YT.SetValue(Canvas.TopProperty, 230.00);
                    DLRXM.SetValue(Canvas.TopProperty, 247.00);
                    DLRZJLX.SetValue(Canvas.TopProperty, 247.00);
                    DLRZJHM.SetValue(Canvas.TopProperty, 247.00);
                    DLRSJH.SetValue(Canvas.TopProperty, 264.00);
                    DLRZJYXQ.SetValue(Canvas.TopProperty, 264.00);

                    YT2.SetValue(Canvas.TopProperty, 195.00);
                    TB_TxAmt2.SetValue(Canvas.TopProperty, 235.00);
                    TB_Sflx2.SetValue(Canvas.TopProperty, 255.00);
                    TB_SfBx2.SetValue(Canvas.TopProperty, 275.00);
                    TB_Teller2.SetValue(Canvas.TopProperty, 295.00);
                    TB_DfAcno2.SetValue(Canvas.TopProperty, 315.00);
                    TB_DfAcname2.SetValue(Canvas.TopProperty, 335.00);
                }
                foreach (var item in PYL.Children)
                {
                    TextBlock t = item as TextBlock;
                    if (t == null)
                    {
                        break;
                    }
                    var top = Canvas.GetTop(t);
                    t.SetValue(Canvas.TopProperty, top - 20);
                }
            }
        }

        #endregion
    }
}
