﻿using System;
using System.Windows;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using System.Windows.Controls;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Interaction logic for Print_PersonalAccountingVoucher_Draw.xaml
    /// </summary>
    public partial class Print_TakeMoneyFront_YLxh : IPrintContract
    {
        public Print_TakeMoneyFront_YLxh(Print_PersonalAccountingVoucher_DrawxhEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
            //this.BusinessType = "取款";
        }

        public class Print_PersonalAccountingVoucher_DrawxhEntry : PrintEntry
        {
            /// <summary>
            /// 标题
            /// </summary>
            public string Title { get; set; }

            /// <summary>
            /// 结算类型
            /// </summary>
            public string JSLX { get; set; }

            /// <summary>
            /// 账户类型
            /// </summary>
            public string ZHLX { get; set; }

            /// <summary>
            /// 账号
            /// </summary>
            public string Acno { get; set; }

            /// <summary>
            /// 账户序号
            /// </summary>
            //  public string ZHXH { get; set; }

            /// <summary>
            /// 账户户名
            /// </summary>
            public string ZHHM { get; set; }
            /// <summary>
            /// 开户日
            /// </summary>
            public string Opndata { get; set; }

            /// <summary>
            /// 开户行名
            /// </summary>
            // public string OpnName { get; set; }

            /// <summary>
            /// 储种
            /// </summary>
            public string PrdtName { get; set; }

            /// <summary>
            /// 利率
            /// </summary>
            public string Rate { get; set; }

            /// <summary>
            /// 交易类型
            /// </summary>
            public string TradeType { get; set; }

            /// <summary>
            /// 交易金额
            /// </summary>
            public decimal TxAmt { get; set; }



            /// <summary>
            /// 流水号
            /// </summary>
            // public string Lsh { get; set; }

            /// <summary>
            /// 利息
            /// </summary>
            public decimal Lx { get; set; }

            /// <summary>
            /// 利息税
            /// </summary>
            public decimal Lxs { get; set; }

            /// <summary>
            /// 自动转存
            /// </summary>
            public string Zdzc { get; set; }

            /// <summary>
            /// 实付利息
            /// </summary>
            public decimal Sflx { get; set; }

            /// <summary>
            /// 备注信息1
            /// </summary>
            public string Bzinfo1 { get; set; }
            /// <summary>
            /// 开户机构10
            /// </summary>
            public string Khjg { get; set; }
            /// <summary>
            /// 实付本息税
            /// </summary>
            public decimal Sfbxs { get; set; }

            /// <summary>
            /// 备注信息2
            /// </summary>
            public string Bzinfo2 { get; set; }

            /// <summary>
            /// 对方账号
            /// </summary>
            public string DfAcno { get; set; }

            /// <summary>
            /// 对方户名
            /// </summary>
            public string DfAcname { get; set; }
            /// <summary>
            /// 通存标志
            /// </summary>
            public string TCBZ { get; set; }
            ///// <summary>
            ///// 存期
            ///// </summary>
            //public string Term { get; set; }

            ///// <summary>
            ///// 凭证号码
            ///// </summary>
            //public string NoteNo { get; set; }

            ///// <summary>
            ///// 新凭证号
            ///// </summary>
            //public string NewNoteNo { get; set; }

            ///// <summary>
            ///// 科目
            ///// </summary>
            //public string Subject { get; set; }

            ///// <summary>
            ///// 现转标志
            ///// </summary>
            //public string CtInd { get; set; }

            ///// <summary>
            ///// 币种
            ///// </summary>
            //public string Bz { get; set; }
            /// <summary>
            /// 余额
            /// </summary>
            //public decimal Bal { get; set; }

            /// <summary>
            /// 代理人姓名
            /// </summary>
            public string DLRXM { get; set; }
            /// <summary>
            /// 代理人证件类型
            /// </summary>
            public string DLRZJLX { get; set; }
            /// <summary>
            /// 代理人证件号码
            /// </summary>
            public string DLRZJHM { get; set; }
            /// <summary>
            /// 代理人手机号
            /// </summary>
            public string DLRSJH { get; set; }
            /// <summary>
            /// 代理人证件有效期
            /// </summary>
            public string DLRYXQ { get; set; }
        }

        #region IPrintContract Members

        public Contract.Entry.PrintEntry PrintData { get; private set; }

        public void LoadPrintData()
        {
            string flag = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            var entry = PrintData as Print_PersonalAccountingVoucher_DrawxhEntry;
            if (entry == null)
                return;
            TB_title.Text = entry.Title;
            switch (entry.TCBZ[4].ToString().Trim())
            {
                case "0":
                    TB_TCBZ.SetPrintTextBlock("非通存通兑");
                    break;
                case "1":
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
                case "2":
                    TB_TCBZ.SetPrintTextBlock("通存非通兑");
                    break;
                default:
                    TB_TCBZ.SetPrintTextBlock("通存通兑");
                    break;
            }
            TB_Acno1.SetPrintTextBlock(entry.Acno);
            if (flag == "V23" || flag == "V24")
            {
                TB_Acno2.SetPrintTextBlock(entry.Acno.Substring(0, 6) + "****" + entry.Acno.Substring(entry.Acno.Length - 2, 2));
            }
            else {
                TB_Acno2.SetPrintTextBlock(entry.Acno);
            }
            TB_HM1.SetPrintTextBlock(entry.ZHHM);
            if (flag == "V23" || flag == "V24")
            {
                TB_HM2.SetPrintTextBlock(entry.ZHHM.Substring(0, 1) + "**");
            }
            else {
                TB_HM2.SetPrintTextBlock(entry.ZHHM);
            }
          
            TB_OPNData.SetPrintTextBlock(entry.Opndata);
            TB_OPNData2.SetPrintTextBlock(entry.Opndata);
            TB_Prdt1.SetPrintTextBlock(entry.PrdtName);
            TB_Prdt2.SetPrintTextBlock(entry.PrdtName);
            if (entry.ZHLX.Equals("2"))
            {
                TB_JSLX.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_JSLX.SetPrintTextBlock(entry.JSLX);
            }
            if (!string.IsNullOrEmpty(entry.Rate))
            {
                TB_Rate1.SetPrintTextBlock(string.Format("{0:N6}%", entry.Rate));
                TB_Rate2.SetPrintTextBlock(string.Format("{0:N6}%", entry.Rate));
            }
            else
            {
                TB_Rate1.SetPrintTextBlock(string.Empty);
                TB_Rate2.SetPrintTextBlock(string.Empty);

            }

            TB_Jyrq.SetPrintTextBlock(LoginUserInfo.TradeDate);
            TB_Data.SetPrintTextBlock(LoginUserInfo.TradeDate);
            TB_TradeType.SetPrintTextBlock(entry.TradeType);
            TB_TradeType1.SetPrintTextBlock(entry.TradeType);

            //var type = UserFunction.ChangeMoneySymbol(entry.Bz);
            var type = UserFunction.ChangeMoneySymbol("01");
            TB_TxAmt1.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            TB_TxAmt2.SetPrintTextBlock(type + entry.TxAmt.ToString("N2"));
            TB_lsh.SetPrintTextBlock(this.PrintAttribute.SerialNumber);
            TB_lx.SetPrintTextBlock(type + entry.Lx.ToString("N2"));
            TB_lx1.SetPrintTextBlock(type + entry.Lx.ToString("N2"));
            TB_lxs.SetPrintTextBlock(type + entry.Lxs.ToString("N2"));
            TB_lxs1.SetPrintTextBlock(type + entry.Lxs.ToString("N2"));
            //TB_czy.SetPrintTextBlock(LoginUserInfo.TellerNo); 
            //TB_czy.SetPrintTextBlock("(" + LoginUserInfo.TellerName + ")" + LoginUserInfo.TellerNo);
            TB_czy.Text = LoginUserInfo.TellerNo;
            TB_Teller2.SetPrintTextBlock(LoginUserInfo.TellerNo);
            if (!string.IsNullOrEmpty(entry.Zdzc))
            {
                TB_zdzc.Visibility = Visibility.Visible;
                TB_zdzc.SetPrintTextBlock(entry.Zdzc);
            }
            else
            {
                TB_zdzc.Visibility = Visibility.Hidden;
            }
            TB_sflx.SetPrintTextBlock(type + entry.Sflx.ToString("N2"));
            TB_sflx1.SetPrintTextBlock(type + entry.Sflx.ToString("N2"));
            TB_info1.Text = entry.Bzinfo1;
            // TB_dqlxs.SetPrintTextBlock(type + entry.Dqlxs.ToString("N2"));
            TB_khjg.SetPrintTextBlock(entry.Khjg);
            TB_jyjg.SetPrintTextBlock(LoginUserInfo.KinbrNo);
            TB_sfbx.SetPrintTextBlock(type + entry.Sfbxs.ToString("N2"));
            TB_sfbx1.SetPrintTextBlock(type + entry.Sfbxs.ToString("N2"));
            TB_info2.Text = entry.Bzinfo2;
            //业务流水
            TB_lsh.SetPrintTextBlock(this.PrintAttribute.SerialNumber);
            //核心流水
            tb_ls.SetPrintTextBlock(this.PrintAttribute.BusinessTransaction);
            // TB_sqy.SetPrintTextBlock(this.PrintAttribute.Authentic);//授权柜员号
            TB_sqy.Text = this.PrintAttribute.Authno;
            if (string.IsNullOrEmpty(entry.DfAcno))
            {
                TB_DfAcno1.Visibility = Visibility.Hidden;
                TB_DfAcno2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_DfAcno1.SetPrintTextBlock(entry.DfAcno);
                if (flag == "V23" || flag == "V24")
                {
                    TB_DfAcno2.SetPrintTextBlock(entry.DfAcno.Substring(0, 6) + "****" + entry.DfAcno.Substring(entry.DfAcno.Length - 2, 2));
                }
                else
                {
                    TB_DfAcno2.SetPrintTextBlock(entry.DfAcno);
                }
            }
            if (string.IsNullOrEmpty(entry.DfAcname))
            {
                TB_DfAcname1.Visibility = Visibility.Hidden;
                TB_DfAcname2.Visibility = Visibility.Hidden;
            }
            else
            {
                TB_DfAcname1.SetPrintTextBlock(entry.DfAcname);
                if (flag == "V23" || flag == "V24")
                {
                    TB_DfAcname2.SetPrintTextBlock(entry.DfAcname.Substring(0, 1) + "**");
                }
                else
                {
                    TB_DfAcname2.SetPrintTextBlock(entry.DfAcname);
                }
            }

            // TB_Bal1.SetPrintTextBlock(type + entry.Bal.ToString("N2"));
            //TB_Bal2.SetPrintTextBlock(type + entry.Bal.ToString("N2"));


            //TB_Subject.Text = entry.Subject;
            //if (string.IsNullOrEmpty(entry.Term))
            //{
            //    TB_Term1.Visibility = Visibility.Hidden;
            //    TB_Term2.Visibility = Visibility.Hidden;
            //}
            //else
            //{
            //    TB_Term1.SetPrintTextBlock(entry.Term);
            //    TB_Term2.SetPrintTextBlock(entry.Term);
            //}

            //TB_TradeType.SetPrintTextBlock(entry.TradeType);
            //TB_CtInd1.SetPrintTextBlock(entry.CtInd);
            //TB_CtInd2.SetPrintTextBlock(entry.CtInd);


            //公共要素
            //var tradedate = LoginUserInfo.TradeDate.ToDateTime();          

            //TB_lsh.SetPrintTextBlock(this.PrintAttribute.SerialNumber);
            if (flag == "V23" || flag == "V24")
            {
                if (flag == "V23")
                {
                    TB_czy.SetValue(Canvas.TopProperty, 446.00);
                    TB_sqy.SetValue(Canvas.TopProperty, 446.00);
                }
                else
                {
                    TB_czy.SetValue(Canvas.TopProperty, 426.00);
                    TB_sqy.SetValue(Canvas.TopProperty, 426.00);
                }

                TB_Jyrq.SetValue(Canvas.LeftProperty, 640.00);
                TB_Acno2.SetValue(Canvas.LeftProperty, 640.00);
                TB_OPNData2.SetValue(Canvas.LeftProperty, 640.00);
                TB_HM2.SetValue(Canvas.LeftProperty, 640.00);
                TB_lxs1.SetValue(Canvas.LeftProperty, 640.00);
                TB_TradeType1.SetValue(Canvas.LeftProperty, 640.00);
                
                TB_lx1.SetValue(Canvas.LeftProperty, 640.00);
                TB_TxAmt2.SetValue(Canvas.LeftProperty, 640.00);
                TB_sflx1.SetValue(Canvas.LeftProperty, 640.00);
                TB_sfbx1.SetValue(Canvas.LeftProperty, 640.00);
                TB_Prdt2.SetValue(Canvas.LeftProperty, 640.00);
                TB_Rate2.SetValue(Canvas.LeftProperty, 640.00);
                TB_Teller2.SetValue(Canvas.LeftProperty, 640.00);
                TB_DfAcno2.SetValue(Canvas.LeftProperty, 640.00);
                TB_DfAcname2.SetValue(Canvas.LeftProperty, 640.00);
            }
            if ((flag == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152"))
            {
                SM.Visibility = SM1.Visibility = Visibility.Visible;
            }
            if (flag == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "122")
            {
                SM1.Visibility = Visibility.Visible;
            }
            if (flag == "V24")
            {
                if (entry.PrdtName.StartsWith("旭日鑫三号"))
                {
                    TB_Rate1.SetValue(Canvas.LeftProperty, 290.00);//利率
                }
            }
            //浚县增加代理人信息
            if (flag == "V23")
            {
                if (!string.IsNullOrEmpty(entry.DLRXM))
                {
                    DLRXM.SetPrintTextBlock(entry.DLRXM);
                    DLRXM.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrEmpty(entry.DLRZJLX))
                {
                    DLRZJLX.SetPrintTextBlock(entry.DLRZJLX);
                    DLRZJLX.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrEmpty(entry.DLRZJHM))
                {
                    DLRZJHM.SetPrintTextBlock(entry.DLRZJHM);
                    DLRZJHM.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrEmpty(entry.DLRSJH))
                {
                    DLRSJH.SetPrintTextBlock(entry.DLRSJH);
                    DLRSJH.Visibility = Visibility.Visible;
                }
                if (!string.IsNullOrEmpty(entry.DLRYXQ))
                {
                    DLRZJYXQ.SetPrintTextBlock(entry.DLRYXQ);
                    DLRZJYXQ.Visibility = Visibility.Visible;
                }
                foreach (var item in PYL.Children)
                {
                    TextBlock t = item as TextBlock;
                    if (t == null)
                    {
                        break;
                    }
                    var top = Canvas.GetTop(t);
                    t.SetValue(Canvas.TopProperty, top - 20);
                }
            }
        }

        #endregion
    }
}
