﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using Platform.Common.RunningParameters;
using TellerSystem.Library.Ext.Function;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Print_ZBWSCCD.xaml 的交互逻辑
    /// </summary>
    public partial class Print_ZBWSCCD : IPrintContract
    {
        public Print_ZBWSCCD(Print_ZBWSCCDEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public Contract.Entry.PrintEntry PrintData
        {
            get;
            private set;
        }
        public class Print_ZBWSCCDEntry : PrintEntry
        {
            /// <summary>
            /// 日期
            /// </summary>
            public string RQ;
            /// <summary>
            /// 编号
            /// </summary>
            public string BH;
            /// <summary>
            /// 差错单位
            /// </summary>
            public string CCDW;
            /// <summary>
            /// 数量合计小写
            /// </summary>
            public string SLHJXX;
            /// <summary>
            /// 假币信息
            /// </summary>
            public string JBXX;
            /// <summary>
            /// 备注说明
            /// </summary>
            public string BZSM;
        }
        public void LoadPrintData()
        {
            var entry = PrintData as Print_ZBWSCCDEntry;
            this.tb_RQ.Text = entry.RQ;
            this.tb_BH.Text = entry.BH;
            this.tb_CCDW.Text = entry.CCDW;
            this.tb_SLHJXX.Text = entry.SLHJXX;
            this.tb_SLHJDX.Text = SystemFunction.NumToChinese(entry.SLHJXX);
            this.tb_JBXX.Text = entry.JBXX;
            this.tb_JB.Text = string.Format("{1}({0})", LoginUserInfo.TellerNo, LoginUserInfo.TellerName);
            this.tb_FH.Text = string.Format("{1}({0})", PrintAttribute.Authno, this.PrintAttribute.Authentic);
            this.tb_BZSM.Text = entry.BZSM;
        }
    }
}
