﻿using System;
using System.Globalization;
using System.Windows;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using System.Windows.Controls;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// 
    /// </summary>
    public partial class Print_FeeGuest : IPrintContract, IPrintFeeContract
    {
        private string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        public Print_FeeGuest(Print_FeeGuestEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        public Contract.Entry.PrintEntry PrintData
        {
            get;
            set;
        }

        public class Print_FeeGuestEntry : PrintEntry
        {
            /// <summary>
            /// 户名
            /// </summary>
            public string HM { get; set; }
            /// <summary>
            /// 账号
            /// </summary>
            public string ZH { get; set; }
            /// <summary>
            /// 新账号-非空则打印新账号
            /// </summary>
            public string XZH { get; set; }
            /// <summary>
            /// 收费项目
            /// </summary>
            public string SFXM { get; set; }
            /// <summary>
            /// 收费方式
            /// </summary>
            public string SFFS { get; set; }
            /// <summary>
            /// 收费金额
            /// </summary>
            public string SFJE { get; set; }
            /// <summary>
            /// 扣费账户-非空则打印扣费情况
            /// </summary>
            public string KFZH { get; set; }
            /// <summary>
            /// 扣费账户户名
            /// </summary>
            public string KFZHHM { get; set; }
            /// <summary>
            /// 摘要
            /// </summary>
            public string ZY { get; set; }
            /// <summary>
            /// 帐户名称
            /// </summary>
            public string ZHMC { get; set; }
            /// <summary>
            /// Fd16
            /// </summary>
            public string JYM { get; set; }
            /// <summary>
            /// 验印流水
            /// </summary>
            public string yyls { get; set; }
        }

        public void LoadPrintData()
        {

            var entry = PrintData as Print_FeeGuestEntry;
            if (FLAG == "V11" && entry.JYM == "2105")
            {
                TB_ZHMC.Visibility = Visibility.Visible;
                TB_ZHMC.SetPrintTextBlock(entry.ZHMC);
            }
            if (!string.IsNullOrEmpty(entry.ZH))
            {
                TB_HM.Visibility = Visibility;
                TB_ZH.Visibility = Visibility;
                TB_HM.SetPrintTextBlock(entry.HM);
                if (!string.IsNullOrEmpty(entry.XZH))
                {
                    TB_ZH.Text = "旧 账 号:{0}";
                    TB_XZH.Visibility = Visibility;
                    TB_XZH.SetPrintTextBlock(entry.XZH);
                }
                TB_ZH.SetPrintTextBlock(entry.ZH);
            }
            TB_SFXM.SetPrintTextBlock(entry.SFXM);
            TB_SFFS.SetPrintTextBlock(entry.SFFS);
            TB_SFZJE.SetPrintTextBlock(string.Format("¥{0}", entry.SFJE));

            if (!string.IsNullOrEmpty(entry.KFZH))
            {
                TB_KFZH.Visibility = Visibility.Visible;
                TB_KFZH.SetPrintTextBlock(entry.KFZH);

            }
            if (!string.IsNullOrEmpty(entry.KFZHHM))
            {
                TB_KFZHHM.Visibility = Visibility.Visible;
                TB_KFZHHM.SetPrintTextBlock(entry.KFZHHM);
            }
            //添加摘要打印
            if (!string.IsNullOrEmpty(entry.ZY))
            {

                ZY.Visibility = Visibility.Visible;
                ZY.SetPrintTextBlock(entry.ZY.Trim());
                //ZY.Text = entry.ZY;
            }
            if (FLAG == "V21")//tianjiao
            {
                TB_QZ.Visibility = Visibility.Visible;
            }
            if (FLAG == "V0")
            {
                if (!string.IsNullOrEmpty(entry.yyls))
                {
                    yyls.Visibility = Visibility.Visible;
                    yyls.SetPrintTextBlock(entry.yyls);
                }

                //标题上移
                title.SetValue(Canvas.TopProperty, 118.00);
            }
        }

        public bool CheckFee(PaymentFeeArguments args, out bool isPaymentFee)
        {
            throw new NotImplementedException();
        }

        public bool RaisePaymentFee(PaymentFeeArguments args)
        {
            throw new NotImplementedException();
        }


        public void LoadPrint(string kjfl)
        {
            KJFL.LoadData(kjfl);
            var entry = PrintData as Print_FeeGuestEntry;
            if (FLAG == "V11" && entry.JYM == "2105")
            {
                TB_ZHMC.Visibility = Visibility.Visible;
                TB_ZHMC.SetPrintTextBlock(entry.ZHMC);
            }
            if (!string.IsNullOrEmpty(entry.ZH))
            {
                TB_HM.Visibility = Visibility;
                TB_ZH.Visibility = Visibility;
                TB_HM.SetPrintTextBlock(entry.HM);
                if (!string.IsNullOrEmpty(entry.XZH))
                {
                    TB_ZH.Text = "旧 账 号:{0}";
                    TB_XZH.Visibility = Visibility;
                    TB_XZH.SetPrintTextBlock(entry.XZH);
                }
                TB_ZH.SetPrintTextBlock(entry.ZH);
            }
            TB_SFXM.SetPrintTextBlock(entry.SFXM);
            TB_SFFS.SetPrintTextBlock(entry.SFFS);
            TB_SFZJE.SetPrintTextBlock(string.Format("¥{0}", entry.SFJE));

            if (!string.IsNullOrEmpty(entry.KFZH))
            {
                TB_KFZH.Visibility = Visibility;
                TB_KFZH.SetPrintTextBlock(entry.KFZH);

            }
            if (!string.IsNullOrEmpty(entry.KFZHHM))
            {
                TB_KFZHHM.Visibility = Visibility;
                TB_KFZHHM.SetPrintTextBlock(entry.KFZHHM);
            }
            //添加摘要打印
            if (!string.IsNullOrEmpty(entry.ZY))
            {

                ZY.Visibility = Visibility.Visible;
                ZY.SetPrintTextBlock(entry.ZY.Trim());
                //ZY.Text = entry.ZY;
            }
            if (FLAG == "V21" || FLAG == "V22")//tianjiao
            {
                TB_QZ.Visibility = Visibility.Visible;
            }
            if (FLAG == "V0")
            {
                //标题上移
                title.SetValue(Canvas.TopProperty, 118.00);
            }
        }
    }
}