﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TellerSystem.Contract.Entry;
using TellerSystem.Communication;
using TellerSystem.Library.Ext.Function;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// BranchLogin.xaml 的交互逻辑
    /// </summary>
    public partial class TellerLogin_print : IPrintContract
    {

        #region 预设逻辑
        public TellerLogin_print(TellerLogin_printEntry entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        /// <summary>
        /// 打印实体
        /// </summary>
        public PrintEntry PrintData
        {
            get;
            set;
        }
        #endregion

        #region 打印逻辑
        /// <summary>
        /// 凭证的打印数据实体定义
        /// </summary>
        public class TellerLogin_printEntry : PrintEntry
        {
            /**********************************
             * 定义实体属性
             * 1.打印逻辑用到的要素
             * *******************************/
            public string ThirdNo { get; set; }
            public string SerialNo { get; set; }
            public string AuthTeller { get; set; }
            public string YesBal { get; set; }
            public string Bal { get; set; }
        }
        /// <summary>
        /// 加载打印数据78
        /// </summary>
        public void LoadPrintData()
        {
            /**********************************
            * 加载数据到打印界面
            * 1.数据来源，PrintData.MessageData、PrintData.PageBase
            * *******************************/
            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            var entry = PrintData as TellerLogin_printEntry; 
            var time = DateTime.ParseExact(LoginUserInfo.GetUserInfo("TradeTime"), "HHmmss", null);
            branchName.SetPrintTextBlock(LoginUserInfo.KinbrName);
            TradeName.SetPrintTextBlock("柜员签到");
            if (FLAG == "V0")
            {
                ThirdNo.SetPrintTextBlock(" " + entry.ThirdNo);
                SerialNo.SetPrintTextBlock(" " + entry.SerialNo);
            }
            else
            {
                ThirdNo.SetPrintTextBlock(entry.ThirdNo);
                SerialNo.SetPrintTextBlock(entry.SerialNo);
            }
            Teller.SetPrintTextBlock(LoginUserInfo.TellerNo);
            loginDate.SetPrintTextBlock(LoginUserInfo.TradeDate);
            LoginTime.SetPrintTextBlock(time.ToString("HH:mm:ss"));
            UserName.SetPrintTextBlock(LoginUserInfo.TellerName);
            //SerialNo.SetPrintTextBlock(entry.SerialNo);
            if (string.IsNullOrEmpty(entry.YesBal))
            {
                YesBal.Visibility = Visibility.Collapsed;
            }
            else
            {
                YesBal.Visibility = Visibility.Visible;
                YesBal.SetPrintTextBlock(entry.YesBal);//昨日余额
            }
            if (string.IsNullOrEmpty(entry.YesBal))
            {
                Bal.Visibility = Visibility.Collapsed;
            }
            else
            {
                Bal.Visibility = Visibility.Visible;
                Bal.SetPrintTextBlock(entry.Bal);//余额
            }
            Bal.SetPrintTextBlock(entry.Bal);//钱箱余额
            AuthTeller.Visibility = Visibility.Collapsed;
            if (entry.AuthTeller.Trim() != "" && entry.AuthTeller != null)
            {
                AuthTeller.SetPrintTextBlock(entry.AuthTeller);
                AuthTeller.Visibility = Visibility.Visible;		
            }    
            #region

            #endregion
        }
        #endregion
    }
}
