﻿using System;
using System.Windows;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using System.ComponentModel;
using System.Data.SqlTypes;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Print_AccountApplication.xaml 的交互逻辑
    /// </summary>
    public partial class print_ContraryApplicationSD : IPrintContract
    {
        public print_ContraryApplicationSD(print_ContraryApplicationEntrySD entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        /// <summary>
        /// 打印实体
        /// </summary>
        public PrintEntry PrintData { get; set; }

        /// <summary>
        /// 凭证的打印数据实体定义
        /// </summary>
        public class print_ContraryApplicationEntrySD : PrintEntry
        {
            /**********************************
             * 定义实体属性
             * 1.打印逻辑用到的要素
             * *******************************/
            /// <summary>
            /// 账号
            /// </summary>
            public string tb_Ac_no { get; set; }
            /// <summary>
            /// 户名
            /// </summary>
            public string tb_Acname { get; set; }
            /// <summary>
            /// 证件类型
            /// </summary>
            public string tb_IDtype { get; set; }
            /// <summary>
            /// 证件号码
            /// </summary>
            public string tb_IDNum { get; set; }
            /// <summary>
            /// 客户号
            /// </summary>
            public string tb_khh { get; set; }

            /// <summary>
            /// 单笔限额
            /// </summary>
            public string tb_dbxe { get; set; }
            /// <summary>
            /// 当日累计限额
            /// </summary>
            public string tb_drljxe { get; set; }
           
            /// <summary>
            /// 记事经办人姓名
            /// </summary>
            public string tb_jsjbrxm { get; set; }
            /// <summary>
            /// 记事经办人代码
            /// </summary>
            public string tb_jsjbrdm { get; set; }
            /// <summary>
            /// 记事经办人密码
            /// </summary>
            public string tb_jsjbrmm { get; set; }
            /// <summary>
            /// 记事经办人账号
            /// </summary>
            public string tb_jsjbrzh { get; set; }
            /// <summary>
            /// 复核经办人姓名
            /// </summary>
            public string tb_fhjbrxm { get; set; }
            /// <summary>
            /// 复核经办人代码
            /// </summary>
            public string tb_fhjbrdm { get; set; }
            /// <summary>
            /// 复核经办人密码
            /// </summary>
            public string tb_fhjbrmm { get; set; }
            /// <summary>
            /// 复核经办人账号
            /// </summary>
            public string tb_fhjbrzh { get; set; }

            /// <summary>
            /// 代理人名称
            /// </summary>
            public string tb_ProxyName { get; set; }
            /// <summary>
            /// 代理人证件类型
            /// </summary>
            public string tb_ProxyIDType { get; set; }
            /// <summary>
            /// 代理人证件号码
            /// </summary>
            public string tb_ProxyIDNum { get; set; }
            /// <summary>
            /// 授权柜员
            /// </summary>
            public string SQGY { get; set; }
            /// <summary>
            /// 经办人
            /// </summary>
            public string JBR { get; set; }
            /// <summary>
            /// 会计分录
            /// </summary>
            public string KJFL { get; set; }
            /// <summary>
            /// 机构名称
            /// </summary>
            public string tb_jgmc { get; set; }
            /// <summary>
            /// 代码
            /// </summary>
            public string tb_dm { get; set; }
       
       
          
         
            /// <summary>
            /// 柜员流水
            /// </summary>
            public string tb_gyls { get; set; }

            /// <summary>
            /// 平台日期
            /// </summary>
            public string tb_ptrq { get; set; }
            /// <summary>
            /// 交易时间
            /// </summary>
            public string tb_jytime { get; set; }

            /// <summary>
            /// 平台流水号
            /// </summary>
            public string tb_ptlsh { get; set; }

        }


        //<summary>
        //加载打印数据
        //</summary>
        public void LoadPrintData()
        {
            /**********************************
            * 加载数据到打印界面
            * 1.数据来源，PrintData.MessageData、PrintData.PageBase
            * *******************************/

            var entry = PrintData as print_ContraryApplicationEntrySD;

         
           
            tb_Ac_no.SetPrintTextBlock(entry.tb_Ac_no);
            tb_Acname.SetPrintTextBlock(entry.tb_Acname);
           
            //tb_Amt.SetPrintTextBlock(SystemFunction.Delspace(SystemFunction.Comma(entry.OpnAmt, 16)));
          
            tb_IDtype.SetPrintTextBlock(entry.tb_IDtype);//证件类型
            tb_IDNum.SetPrintTextBlock(entry.tb_IDNum);//证件号码
         
            tb_jy.SetPrintTextBlock(this.PrintAttribute.TradeModel.Name + "(" + this.PrintAttribute.TradeModel.Code + ")");//交易名称
            tb_jgmc.SetPrintTextBlock(LoginUserInfo.KinbrName);//机构名称
            tb_dm.SetPrintTextBlock(entry.tb_dm);//代码
            JBR.Text = LoginUserInfo.TellerName;//经办人
            tb_KHH.SetPrintTextBlock(entry.tb_khh);//客户号

            //限额
            tb_DBXE.SetPrintTextBlock(entry.tb_dbxe);
            tb_RLJXE.SetPrintTextBlock(entry.tb_drljxe);

            //记事人信息
            tb_JSJBRXM.SetPrintTextBlock(entry.tb_jsjbrxm);
            tb_JSJBRDM.SetPrintTextBlock(entry.tb_jsjbrdm);
            tb_JSJBRMM.SetPrintTextBlock(entry.tb_jsjbrmm);
            tb_JSJBRZH.SetPrintTextBlock(entry.tb_jsjbrzh);
            //复核人信息
            tb_FHJBRXM.SetPrintTextBlock(entry.tb_fhjbrxm);
            tb_FHJBRDM.SetPrintTextBlock(entry.tb_fhjbrdm);
            tb_FHJBRMM.SetPrintTextBlock(entry.tb_fhjbrmm);
            tb_FHJBRZH.SetPrintTextBlock(entry.tb_fhjbrzh);

            var time = DateTime.ParseExact(LoginUserInfo.GetUserInfo("TradeTime"), "HHmmss", null);

            tb_JGDM.SetPrintTextBlock(LoginUserInfo.KinbrNo);//机构代码
            tb_PTRQ.SetPrintTextBlock(LoginUserInfo.TradeDate);//平台日期
            tb_JYSJ.SetPrintTextBlock(time.ToString("HH:mm:ss"));//交易时间
            tb_GYH.SetPrintTextBlock(LoginUserInfo.TellerNo);//柜员号
            tb_PTLSH.SetPrintTextBlock(this.PrintAttribute.BusinessTransaction);//平台流水号
            SQGY.SetPrintTextBlock(this.PrintAttribute.Authentic);//授权柜员
            tb_gyls.SetPrintTextBlock(this.PrintAttribute.SerialNumber);//柜员流水号 
            //复核柜员
            FHGY.Text = this.PrintAttribute.Review;
        }
    }
}
