﻿using System;
using System.Windows;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using TellerSystem.Library.Ext.Function;
using System.ComponentModel;
using System.Data.SqlTypes;
using TellerSystem.PrintTemplate.ElecSeal;

namespace TellerSystem.Controls.Ext.PrintsHelper
{
    /// <summary>
    /// Print_AccountApplication.xaml 的交互逻辑
    /// </summary>
    public partial class Print_SettlementdepositsSD : IPrintContract
    {
        public Print_SettlementdepositsSD(Print_SettlementdepositsEntrySD entry)
        {
            InitializeComponent();
            PrintData = entry;
        }

        /// <summary>
        /// 打印实体
        /// </summary>
        public PrintEntry PrintData { get; set; }

        /// <summary>
        /// 凭证的打印数据实体定义
        /// </summary>
        public class Print_SettlementdepositsEntrySD : PrintEntry
        {
            /**********************************
             * 定义实体属性
             * 1.打印逻辑用到的要素
             * *******************************/
            /// <summary>
            /// 账号
            /// </summary>
            public string tb_Ac_no { get; set; }
            /// <summary>
            /// 户名
            /// </summary>
            public string tb_Acname { get; set; }

            /// <summary>
            /// 凭证种类
            /// </summary>
            public string tb_PZZL { get; set; }

            /// <summary>
            /// 凭证号码
            /// </summary>
            public string tb_PZNum { get; set; }

            /// <summary>
            /// 验印流水号
            /// </summary>
            public string tb_yyls { get; set; }

            /// <summary>
            /// 开户行
            /// </summary>
            public string tb_KHH { get; set; }
            /// <summary>
            /// 余额
            /// </summary>
            public string tb_YE { get; set; }

            /// <summary>
            /// 出票日期
            /// </summary>
            public string tb_CPRQ { get; set; }

            /// <summary>
            /// 支付密码
            /// </summary>
            public string tb_ZFMM { get; set; }

            /// <summary>
            /// 转入账号
            /// </summary>
            public string tb_ZRZH { get; set; }


            /// <summary>
            /// 转入户名
            /// </summary>
            public string tb_ZRHUM { get; set; }

            /// <summary>
            /// 转入行名
            /// </summary>
            public string tb_ZRHANGM { get; set; }
            /// <summary>
            /// 验印通过标志
            /// </summary>
            public string YYflag { get; set; }
        }


        //<summary>
        //加载打印数据
        //</summary>
        public void LoadPrintData()
        {
            /**********************************
            * 加载数据到打印界面
            * 1.数据来源，PrintData.MessageData、PrintData.PageBase
            * *******************************/

            var entry = PrintData as Print_SettlementdepositsEntrySD;

            YearBlock.Text = LoginUserInfo.TradeDate.Substring(0,4).ToString(); //年
            MothBlock.Text = LoginUserInfo.TradeDate.Substring(4,2).ToString();//月
            DayBlock.Text = LoginUserInfo.TradeDate.Substring(6, 2).ToString();//日

;
            tb_Ac_no.SetPrintTextBlock(entry.tb_Ac_no);//账号
            tb_Acname.SetPrintTextBlock(entry.tb_Acname);//户名
            tb_IDtype.SetPrintTextBlock(entry.tb_PZZL);//凭证类型
            this.tb_PZNum.SetPrintTextBlock(entry.tb_PZNum.PadLeft(TellerSystem.Library.Ext.Variables.UserVariable.Len_VoucherNo, '0'));//凭证号码

            if (string.IsNullOrEmpty(entry.tb_CPRQ.Trim()))
            {
                tb_CPRQ.Visibility = Visibility.Hidden;
            }
            else
            {
                tb_CPRQ.SetPrintTextBlock(entry.tb_CPRQ);
            }
            if (string.IsNullOrEmpty(entry.tb_ZFMM.Trim()))
            {
                tb_ZFMM.Visibility = Visibility.Hidden;
            }
            else
            {
                tb_ZFMM.SetPrintTextBlock(entry.tb_ZFMM);
            }
            if (string.IsNullOrEmpty(entry.tb_yyls.Trim()))
            {
                tb_YYLS.Visibility = Visibility.Hidden;
            }
            else
            {
                tb_YYLS.SetPrintTextBlock(entry.tb_yyls);
            }
            tb_ZRZH.SetPrintTextBlock(entry.tb_ZRZH);//转入账号
            tb_ZRHangM.SetPrintTextBlock(entry.tb_ZRHANGM);//转入行名
            tb_ZRHM.SetPrintTextBlock(entry.tb_ZRHUM);//转入户名
            tb_AcNum.SetPrintTextBlock(entry.tb_YE); //余额
            tb_KHH.SetPrintTextBlock(entry.tb_KHH); //开户行

            tb_ywls.SetPrintTextBlock(this.PrintAttribute.BusinessTransaction);//业务流水
            FHGY.Text = this.PrintAttribute.Review;//复核柜员
            tb_gyls.SetPrintTextBlock(this.PrintAttribute.SerialNumber);//柜员流水号 
            JBR.Text = LoginUserInfo.TellerName;//经办人
            SQGY.Text = @this.PrintAttribute.Authentic;//授权人
            string FLAG = TellerSystem.ServiceProxy.Ext.ServiceHelper.TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            if (FLAG == "V5")
            {
                if (LoginUserInfo.KinbrNo.Substring(0, 3) == "302" )
                {
                    this.ElecSealHelper.Sign2Point(new Point(535, 300), SealKind.Biz);
                }
                if (entry.YYflag != "")
                {
                    YYflag.Text = entry.YYflag;
                }
            }
        }
    }
}
