﻿using Platform.Presentation.PageFunctions;
using TellerSystem.Library.Ext.TradeExtension;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Contract.ContractBase;
using System.Windows;
using System.Windows.Controls;
using System.ComponentModel;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using System.Collections.Generic;
using TellerSystem.Communication;
using TellerSystem.Contract.Function;
using System;

namespace TellerSystem.Controls.Ext.TradePageBase
{
    /// <summary>
    /// 空白模板
    /// </summary>
    public class BlankTradePage : WorkflowPage
    {
        static BlankTradePage()
        {
            DefaultStyleKeyProperty.OverrideMetadata(typeof(BlankTradePage), new FrameworkPropertyMetadata(typeof(BlankTradePage)));
        }

        public BlankTradePage()
        {
            TradeInfoData.SetTradeInfo(this, new Library.Ext.TradeExtension.TradeInfoData());
        }

        /// <summary>
        ///
        /// </summary>
        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();

            //控件滚动条定位
            var scrollViewer = GetTemplateChild("TradeScrollViewer") as ScrollViewer;
            if (scrollViewer != null && !DesignerProperties.GetIsInDesignMode(this))
            {
                ((FrameworkElement)scrollViewer.Content).HorizontalAlignment = System.Windows.HorizontalAlignment.Left;
                scrollViewer.RequestBringIntoView += (sender, e) =>
                {
                    var scroll = sender as ScrollViewer;
                    if (scroll != null)
                    {
                        if (!double.IsInfinity(e.TargetRect.Y) && e.TargetRect.Y > scroll.ActualHeight * 2 / 3)
                        {
                            scroll.ScrollToVerticalOffset(scroll.VerticalOffset + e.TargetRect.Y - scroll.ActualHeight * 2 / 3);
                        }
                    }
                };
            }
        }
    }
}
