﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TellerSystem.Library.Ext.TradeExtension;
using TellerSystem.Library.Ext.Function;

namespace TellerSystem.Controls.Ext.TradePageBase
{
    /// <summary>
    /// 管理类交易基类
    /// </summary>
    public class ManagerTradePage : WorkflowPage
    {
        public ManagerTradePage()
        {
            this.SetViewStateData(new Dictionary<string, object>());
        }

        #region 公共属性

        /// <summary>
        /// 交易视图信息集合
        /// </summary>
        public TradeInfoData TradeInfo
        {
            get
            {
                return this.GetTradeInfoData();
            }
        }

        /// <summary>
        /// 前台流水号
        /// </summary>
        public string SerialNo
        {
            get { return TradeInfo.SerialNumber; }
            set
            {
                //set无效
            }
        }

        /// <summary>
        /// 前台交易号
        /// </summary>
        public string TradeNo
        {
            get { return this.TradeModel.Code; }
            set
            {
                //set无效
            }
        }

        /// <summary>
        /// 弹出框是否按ESC关闭窗体2013-8-10 翟国栋（提供交易处理交易中途退出交易问题）
        /// True:ESC退出对话框，交易中断,return 
        /// False:正常退出，交易继续
        /// </summary>
        public bool IsDialogEscKeyClose
        {
            get { return Platform.Controls.TradeExtension.PageDialog.flagEsc; }
        }
        #endregion
    }
}
