﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Platform.Controls.NumericContainer;
using TellerSystem.Contract.Function;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Library.Ext.Variables;
using TellerSystem.Contract.ContractBase;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;
namespace TellerSystem.Controls.Ext.TradePageComponent
{
    /// <summary>
    /// 账户基本信息组件
    /// </summary>
    public partial class TBC_AcBasicInfo : TBC_ComponentBase<TBC_AcBasicInfoInput, TBC_AcBasicInfoOutput>
    {
        public TBC_AcBasicInfo()
        {
            InitializeComponent();
        }

        public string PZH { get; set; }
        
        #region 对外方法
        private void tb_Noteno_lostFocus(object sender, RoutedEventArgs e)
        {
            if (PZH.TrimStart('0')!= tb_Noteno.Text.TrimStart('0'))
            {
                this.Page.TradeAPIs.ShowTip("输入凭证号有误，请检查是否做过换证");
                this.Page.TradeAPIs.SetFocus(tb_Noteno);
                return;
            }
            tb_Noteno.Text = PZH;
        }
        /// <summary>
        /// 初始化账户基本信息
        /// </summary>
        /// <param name="acInfo"></param>
        public void InitBasicInfo(QueryDepositAccount acInfo)
        {
            //tb_bal.Visibility = Visibility.Collapsed;
            //ce_Bal.Visibility = Visibility.Collapsed;
            ComponentOutput.AccountInfo = acInfo;
            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            if (acInfo == null)
            {
                //清空操作
                tb_Acname.Text = tb_Noteno.Text = tb_Prdtname.Text = string.Empty;
                ce_Bal.Text = string.Empty;
                cmb_Curno.Items.Clear();
                cmb_Notetype.Items.Clear();
                return;
            }
            if (acInfo.GGSX == "9999")
            {
                tb_Noteno.IsEnabled = true;
                if (FLAG == "V18")
                {
                    tb_Noteno.Text = acInfo.PZH.PadLeft(UserVariable.Len_VoucherNo, '0');
                }
                else
                {
                    tb_Noteno.Text = "";
                }
                PZH = acInfo.PZH.PadLeft(UserVariable.Len_VoucherNo, '0');

            }
            else
            {
                tb_Noteno.IsEnabled = false;
                tb_Noteno.Text = acInfo.PZH.PadLeft(UserVariable.Len_VoucherNo, '0');
                PZH = acInfo.PZH.PadLeft(UserVariable.Len_VoucherNo, '0');
            }
            //显示基本信息
            if(FLAG=="V19")
            {
                tb_Noteno.IsEnabled = false;
                tb_Noteno.Text = acInfo.PZH.PadLeft(UserVariable.Len_VoucherNo, '0');
                PZH = acInfo.PZH.PadLeft(UserVariable.Len_VoucherNo, '0');
            }
            tb_Acname.Text = acInfo.HM;
            this.Page.TradeAPIs.SetItems(cmb_Notetype,new Dictionary<string,string>(){{acInfo.JZMC.Trim(),acInfo.JZZL.Trim()}});
            this.Page.TradeAPIs.SetSelectedValue(cmb_Notetype, acInfo.JZZL.Trim());
            this.Page.TradeAPIs.SetItems(cmb_Curno, UserVariable.GetCurNo().Where(x => x.Value.Equals(acInfo.BZ.Trim())));
            this.Page.TradeAPIs.SetSelectedValue(cmb_Curno, acInfo.BZ.Trim());
            if (acInfo.ZHDJZT == "1")
             {
                tb_ZHZT.Text = "完全冻结";
                tb_ZHZT.Foreground = new SolidColorBrush((Color)System.Windows.Media.ColorConverter.ConvertFromString("red"));
            }
            else if (acInfo.ZHDJZT == "2")
            {
                tb_ZHZT.Text = "只进不出";
                tb_ZHZT.Foreground = new SolidColorBrush((Color)System.Windows.Media.ColorConverter.ConvertFromString("red"));
            }
            else if (acInfo.ZHDJZT == "3")
            {
                tb_ZHZT.Text = "部分冻结";
                tb_ZHZT.Foreground = new SolidColorBrush((Color)System.Windows.Media.ColorConverter.ConvertFromString("red"));
            }
            else
            {
                tb_ZHZT.Text = "正常";
                tb_ZHZT.Foreground = new SolidColorBrush((Color)System.Windows.Media.ColorConverter.ConvertFromString("gray"));
            }

            if (acInfo.ZHZFZT == "1")
            {
                tb_ZHZT.Text = "全部止付";
                tb_ZHZT.Foreground = new SolidColorBrush((Color)System.Windows.Media.ColorConverter.ConvertFromString("red"));
            }
            else if (acInfo.ZHZFZT == "2")
            {
                tb_ZHZT.Text = "只进不出";
                tb_ZHZT.Foreground = new SolidColorBrush((Color)System.Windows.Media.ColorConverter.ConvertFromString("red"));
            }
            else if (acInfo.ZHZFZT == "3")
            {
                if (acInfo.ZHDJZT == "3")
                {
                    tb_ZHZT.Text = "部分冻结/部分止付";
                    tb_ZHZT.Foreground = new SolidColorBrush((Color)System.Windows.Media.ColorConverter.ConvertFromString("red"));
                }
                else
                {
                    tb_ZHZT.Text = "部分止付";
                    tb_ZHZT.Foreground = new SolidColorBrush((Color)System.Windows.Media.ColorConverter.ConvertFromString("red"));
                }
            }
            else if (acInfo.ZHDJZT == "0")
            {
                tb_ZHZT.Text = "正常";
                tb_ZHZT.Foreground = new SolidColorBrush((Color)System.Windows.Media.ColorConverter.ConvertFromString("gray"));
            }

            tb_Prdtname.Text = acInfo.CPMC;
            //当为无密户时显示余额
            //if (acInfo.SFPM.Trim().Equals("N"))
            //{
            //    ce_Bal.Text = this.Page.Delspace(acInfo.YE);
            //}
            ce_Bal.Text = this.Page.Delspace(acInfo.YE);
            if (FLAG == "V19")
            {
                ce_kyye.Text = this.Page.Delspace(acInfo.KYYE);
                tradepanel.Height = 180;//调整高度，留出位置
                ce_kyye.Visibility = tb_kyye.Visibility = Visibility.Visible;
            }
        }

        /// <summary>
        /// 显示余额
        /// </summary>
        public void DisplayBal()
        {
            //tb_bal.Visibility = Visibility.Visible;
            //ce_Bal.Visibility = Visibility.Visible;

            //if (ComponentOutput.AccountInfo != null)
            //{
            //    ce_Bal.Text = this.Page.TradeAPIs.Val(ComponentOutput.AccountInfo.YE, 1).ToString();
            //}
            //else
            //{
            //    ce_Bal.Text = string.Empty;
            //}
            ce_Bal.Text = this.Page.TradeAPIs.Val(ComponentOutput.AccountInfo.YE, 1).ToString();
        }
        
        /// <summary>
        /// 设置凭证号的可见性，如2003交易中存单部提需要隐藏旧的凭证号
        /// </summary>
        public void SetNoteVisibility(Visibility vb)
        {
            tb_Noteno.Visibility = vb;
        }

        #endregion

        #region 属性

        /// <summary>
        /// 标题信息
        /// </summary>
        public string Header
        {
            get { return (string)GetValue(HeaderProperty); }
            set { SetValue(HeaderProperty, value); }
        }

        public static readonly DependencyProperty HeaderProperty =
            DependencyProperty.Register("Header", typeof(string), typeof(TBC_AcBasicInfo), new FrameworkPropertyMetadata("账户基本信息", new PropertyChangedCallback((sender, e) =>
            {
                var tmpcontrol = sender as TBC_AcBasicInfo;
                if (tmpcontrol == null)
                    return;
                tmpcontrol.tradepanel.Header = e.NewValue.ToString();
            })));
        #endregion
    }

    #region 数据限定
    /// <summary>
    /// 组件数据交互类
    /// </summary>
    public class TBC_AcBasicInfoInput : TBC_ComponentInput
    {
        #region 构造

        #endregion

        #region 控制属性

        #endregion

        #region 交互方法

        #endregion
    }

    /// <summary>
    /// 组件数据输出类
    /// </summary>
    public class TBC_AcBasicInfoOutput : TBC_ComponentOutput
    {
        /// <summary>
        /// 输出账户信息
        /// </summary>
        public QueryDepositAccount AccountInfo { get; internal set; }
    }
    #endregion
}
