﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TellerSystem.Controls.Ext.TradePageComponent
{
    /// <summary>
    /// AccountOrCertificateInfo.xaml 的交互逻辑
    /// </summary>
    public partial class TBC_AccountOrCertificateInfo : TBC_ComponentBase
    {
        public TBC_AccountOrCertificateInfo()
        {
            InitializeComponent();

            this.rdo_Account.Checked += new RoutedEventHandler(rdo_Account_Checked);
            this.rdo_Certificate.Checked += new RoutedEventHandler(rdo_Certificate_Checked);

            this.Controls = new AccountOrCertificateInfoArgs();
            this.Controls.Account = this.txt_Account;
            this.Controls.RdoAccount = this.rdo_Account;
            this.Controls.RdoCertificate = this.rdo_Certificate;
        }

        void rdo_Certificate_Checked(object sender, RoutedEventArgs e)
        {
            this.lb_Title.Text = "证件：";
        }

        void rdo_Account_Checked(object sender, RoutedEventArgs e)
        {
            this.lb_Title.Text = "账号：";
        }

        private void TextBox_LostFocus(object sender, RoutedEventArgs e)
        {
            this.OnComponentIsLostFocused();
        }

        private void RadioButton_GotFocus(object sender, RoutedEventArgs e)
        {
            this.OnComponentIsGotFocused();
        }

        public AccountOrCertificateInfoArgs Controls
        {
            get;
            internal set;
        }

        public class AccountOrCertificateInfoArgs
        {
            public TextBox Account { get; internal set; }
            public RadioButton RdoAccount { get; internal set; }
            public RadioButton RdoCertificate { get; internal set; }
        }
    }
}
