﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Platform.Common.RunningParameters;
using Platform.Controls.ControlsHelper;
using Platform.Controls.NumericContainer;
using Platform.Library;
using TellerSystem.Contract.Function;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Library.Ext.Variables;
using Platform.Presentation.PageFunctions;
using TellerSystem.Controls.Ext.Controls;
using TellerSystem.Contract.ContractBase;
using TellerSystem.Controls.Ext.ControlsHelper;
namespace TellerSystem.Controls.Ext.TradePageComponent
{
    /// <summary>
    /// 存款账户控制组件
    /// </summary>
    public partial class TBC_CkAcControl : TBC_ComponentBase<TBC_CkAcControlInput, TBC_CkAcControlOutput>
    {
        public TBC_CkAcControl()
        {
            InitializeComponent();
            //20140513 业务要求存入时不显示校验证件号码
            tbl_Idtype.Visibility = Visibility.Collapsed;
            cmb_Idtype.Visibility = Visibility.Collapsed;
            tbl_Idno.Visibility = Visibility.Collapsed;
            tb_Idno.Visibility = Visibility.Collapsed;
        }

        #region 对外方法

        /// <summary>
        /// 初始化存款账户控制组件
        /// </summary>
        /// <param name="acInfo"></param>
        public void InitCkAcControl(QueryDepositAccount acinfo)
        {
            ComponentOutput.AccountInfo = acinfo;
            if (acinfo == null)
            {
                //清空显示
                tb_Amt.Text = tb_Idno.Text = tb_Opnamt.Text = tb_LastDate.Text = string.Empty;
                cmb_Idtype.Items.Clear();
                return;
            }
            tb_Amt.IsEnabled = true;
            //209 零存整取一年期
            //20A 零存整取三年期
            //20B 零存整取五年期
            //211 教育储蓄一年期
            //212 教育储蓄三年期
            //213 教育储蓄六年期
            //零整或教育储蓄
            //if (this.Page.Delspace(acinfo.CPH) == "211" ||
            //    this.Page.Delspace(acinfo.CPH) == "212" ||
            //    this.Page.Delspace(acinfo.CPH) == "213" ||
            //    this.Page.Delspace(acinfo.CPH) == "209" ||
            //    this.Page.Delspace(acinfo.CPH) == "20A" ||
            //    this.Page.Delspace(acinfo.CPH) == "20B")
            if (acinfo.DQCKLX.Equals("1") || acinfo.DQCKLX.Equals("7"))
            {
                //显示零整或教育储蓄信息
                tp_AcOtherInfo.Visibility = Visibility.Visible;
                tb_LastDate.Text = acinfo.ZHYBFSRQ;//上笔交易日期

                ////未存月数

                //var last_rq = acinfo.ZHYBFSRQ.ToDateTime();
                //var today = LoginUserInfo.TradeDate.ToDateTime();
                //var months=today.Subtract(last_rq).
                //var months = ((LoginUserInfo.TradeDate.Substring(0, 4).ToDecimal() - acinfo.ZHYBFSRQ.Substring(0, 4).ToDecimal()) * 12 + LoginUserInfo.TradeDate.Substring(4, 2).ToDecimal() - acinfo.ZHYBFSRQ.Substring(4, 2).ToDecimal());
                /*
                 * update @2014年6月27日11:39:52
                 * 本月已做存款，不允许再做
                 * 已超过两个月未存款，不能续存，请销户
                 * 一个月未存，正常存款
                 * 两个月未存（即漏存一个月），存2倍
                 */
                //存量数据不能根据最后一笔发生日期（acinfo.ZHYBFSRQ）来判断
                //改用发生次数，重新计算 20140812 修正
                var months = ((LoginUserInfo.TradeDate.Substring(0, 4).ToDecimal() - acinfo.KHRQ.Substring(0, 4).ToDecimal()) * 12 + LoginUserInfo.TradeDate.Substring(4, 2).ToDecimal() - acinfo.KHRQ.Substring(4, 2).ToDecimal()) + 1;
                months = months - acinfo.YFSCS.ToDecimal();

                if (months < 1)
                {
                    this.Page.TradeAPIs.ShowTip("本月已做存款，不允许再做！");
                    this.Page.SetFocus();
                    return;
                }
                else if (months > 2)
                {
                    this.Page.TradeAPIs.ShowTip("已超过两个月未存款，不能续存，请销户！");
                    this.Page.SetFocus();
                    return;
                }
                else if (months == 2 && LoginUserInfo.TradeDate.Substring(0, 6).ToDecimal() < acinfo.DQRQ.Substring(0, 6).ToDecimal())
                {
                    this.Page.TradeAPIs.ShowInfoMessageBox("上月漏存，本月需要一次存两期！");
                    tb_Amt.Text = (acinfo.TSDQJYJE.ToDecimal() * 2).ToString();
                }
                else if (months == 2 && LoginUserInfo.TradeDate.Substring(0, 6).ToDecimal() == acinfo.DQRQ.Substring(0, 6).ToDecimal())
                {
                    this.Page.TradeAPIs.ShowInfoMessageBox("上月漏存，本月到期，需要补存上一期！");
                    tb_Amt.Text = acinfo.TSDQJYJE;
                }

                if (months == 1)
                {
                    tb_Amt.Text = acinfo.TSDQJYJE;
                }

                tb_Opnamt.Text = acinfo.TSDQJYJE;//零整或教育储蓄的开户金额
                tb_Amt.IsReadOnly = true;
            }
            else
            {
                //不显示零整或教育储蓄信息
                tp_AcOtherInfo.Visibility = Visibility.Collapsed;
                tb_Amt.IsReadOnly = false;
            }

            //设置证件类型
            cmb_Idtype.SetItems(UserVariable.GetPerIdType().Where(x => x.Value.Equals(acinfo.ZJLX.Trim())));
        }

        /// <summary>
        /// 设置交易金额
        /// </summary>
        /// <param name="amt">金额</param>
        /// <param name="isReadonly">是否只读</param>
        /// <param name="isEnabled">是否enable</param>
        public void SetTxAmt(string amt, bool isReadonly, bool isEnabled = true)
        {
            tb_Amt.Text = amt;
            tb_Amt.IsReadOnly = isReadonly;
            tb_Amt.IsEnabled = isEnabled;
            //更新输出金额
            ComponentOutput.TxAmt = amt;
            if (!string.IsNullOrEmpty(amt))
            {
                tb_AmtD.Text = this.Page.TradeAPIs.ChangeToCNY(tb_Amt.Text.ToDecimal());
            } 
        }
        /// <summary>
        /// 设置币种类型
        /// </summary>
        /// <param name="val">币种类型</param>
        public void SetAmtSymbol(string val)
        {
            tb_Amt.ChangeMoneySymbol(val);
        }

        #endregion 对外方法

        #region 内部逻辑

        private void tb_Amt_GotFocus(object sender, RoutedEventArgs e)
        {
            if (tb_Amt.IsReadOnly == false)
            {
                tb_Amt.IsEnabled = true;
            }
            else
            {
                tb_Amt.IsEnabled = false;
                ComponentOutput.TxAmt = tb_Amt.Text;
            }
        }

        /// <summary>
        /// 交易金额检查
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void tb_Amt_LostFocus(object sender, RoutedEventArgs e)
        {

            if (tb_Amt.Text.ToDecimal() < 0)
            {
                this.Page.TradeAPIs.ShowTip(this.Page.TradeAPIs.GetNotifyMessage(NotifyMessage.N021));
                this.Page.SetFocus(tb_Amt);
                return;
            }
            tb_AmtD.Text = this.Page.TradeAPIs.ChangeToCNY(tb_Amt.Text.ToDecimal());
            //20140513 业务要求存入时不需要校验证件号码
            //tb_Idno.Text = string.Empty;
            //交易额大于5W教育证件号码
            //if (tb_Amt.Text.ToDecimal() >= 50000)
            //{
            //    tb_Idno.IsEnabled = true;
            //}
            //else
            //{
            //    tb_Idno.IsEnabled = false;
            //}

            if (ComponentHelper.AmtSpecialControling != null)
            {
                if (!ComponentHelper.AmtSpecialControling(tb_Amt.Text.Trim()))
                {
                    //验证不通过
                    this.Page.SetFocus();
                    return;
                }
            }
            if (tb_Amt.IsReadOnly == false)
            {
                bool IsCheckAmt = false;
                bool.TryParse(ConfigManager.GetInstance().GetConfigValue("IsCheckAmt", ConfigType.System), out IsCheckAmt);
                if (IsCheckAmt)
                {
                    CheckMoney check = new CheckMoney(tb_Amt.Text);
                    this.Page.ShowPage(check);
                    if (!check.jieguo)
                    {
                        this.Page.TradeAPIs.ShowTip("请校验金额!");
                        this.Page.SetFocus(tb_Amt);
                        return;
                    }
                }
            }
            //账户交易统计信息
            var tjinfo = this.Page.TradeAPIs.TF_Deposit_StatisticsSingleCustomerOraccountDayturnover(new StatisticsSingleCustomerOraccountDayturnover.Input()
            {
                ZH = ComponentOutput.AccountInfo.CLJZH.Trim(),
                ZQLX = "1",
                ZQZ = "1",
                CXLX = "0",
                TJLX = "1",
                //统计当天取现及转账总发生额
                JYLX = "3100",
                QDLXLBDM = "0010"

            });
            if (tjinfo.IsFailed)
            {
                tb_Amt.ShowTip(tjinfo.FailureCause);
                this.Page.SetFocus(tb_Amt);
                return;
            }

            //判断该账户当日累计取款/转账超5W,需验证开户证件
            this.ComponentOutput.LjAmt = tjinfo.DRJYZE.ToDecimal();
            //输出交易金额
            this.ComponentOutput.TxAmt = tb_Amt.Text;
            ////信息交互
            //if (TellerSystem.Devices.Config.DeviceConfig.TransInfoEnabled)
            //{
            //    string text = "交易类型：存款\n账号：" + ComponentOutput.AccountInfo.ZH + "\n户名：" + ComponentOutput.AccountInfo.HM + "\n金额：" + SystemFunction.Delspace(SystemFunction.Comma(tb_Amt.Val, 16));
            //    var result = TellerSystem.Devices.DeviceHelper.PrintTransInfo(text);
            //    if (result.HasError)
            //    {
            //        tb_Amt.ShowTip("信息交互操作有误，请重新调用");
            //        this.Page.SetFocus(tb_Amt);
            //        return;
            //    }
            //}
        }

        /// <summary>
        /// 控制证件号输入方式
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void cmb_Idtype_LostFocus(object sender, RoutedEventArgs e)
        {
            //todo：控制证件号输入方式
        }

        /// <summary>
        /// 校验证件号码
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void tb_Idno_LostFocus(object sender, RoutedEventArgs e)
        {
            if (this.Page.TradeAPIs.Delspace(ComponentOutput.AccountInfo.ZJHM) != this.Page.TradeAPIs.Delspace(tb_Idno.Text) ||
                    cmb_Idtype.GetSelectedValue() != ComponentOutput.AccountInfo.ZJLX.Trim())
            {
                tb_Idno.ShowTip("与开户时证件信息不符");
                this.Page.TradeAPIs.SetFocus();
                return;
            }
            if (cmb_Idtype.GetSelectedValue() == "1") {
              var result = this.Page.TradeAPIs.IdCheck(tb_Idno);
                if (!result.IsComplated)
                {
                    if (result.IsOnline && this.Page.TradeAPIs.ShowQuestionMessageBox("联网身份核查未通过，是否继续？") == MessageBoxResult.No)
                    {
                        this.Page.TradeAPIs.SetFocus(tb_Idno);
                        return;
                    }
                }
            }
        }

        #endregion 内部逻辑

        #region 属性

        /// <summary>
        /// 标题信息
        /// </summary>
        public string Header
        {
            get { return (string)GetValue(HeaderProperty); }
            set { SetValue(HeaderProperty, value); }
        }

        public static readonly DependencyProperty HeaderProperty =
            DependencyProperty.Register("Header", typeof(string), typeof(TBC_CkAcControl), new FrameworkPropertyMetadata("账户验证信息", new PropertyChangedCallback((sender, e) =>
            {
                var tmpcontrol = sender as TBC_CkAcControl;
                if (tmpcontrol == null)
                    return;
                tmpcontrol.tradepanel.Header = e.NewValue.ToString();
            })));

        #endregion 属性
    }

    #region 数据限定

    /// <summary>
    /// 组件数据交互类
    /// </summary>
    public class TBC_CkAcControlInput : TBC_ComponentInput
    {
        #region 构造

        #endregion 构造

        #region 控制属性

        /// <summary>
        /// 交易金额特别控制
        /// </summary>
        public Predicate<string> AmtSpecialControling { get; set; }

        #endregion 控制属性

        #region 交互方法

        #endregion 交互方法
    }

    /// <summary>
    /// 组件数据输出类
    /// </summary>
    public class TBC_CkAcControlOutput : TBC_ComponentOutput
    {
        /// <summary>
        /// 输出账户信息
        /// </summary>
        public QueryDepositAccount AccountInfo { get; internal set; }

        /// <summary>
        /// 交易金额
        /// </summary>
        public string TxAmt { get; internal set; }
        /// <summary>
        /// 交易金额
        /// </summary>
        public decimal LjAmt { get; internal set; }
    }

    #endregion 数据限定
}