﻿using System;
using System.Windows;
using System.Windows.Controls;
using Platform.Common.RunningParameters;
using Platform.Controls.ControlsHelper;
using TellerSystem.Contract.Function;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Library.Ext.Variables;
using TellerSystem.Library.Ext.TradeExtension;
using TellerSystem.Controls.Ext.Controls;
using TellerSystem.Communication;
using TellerSystem.Contract.ContractBase;
using TellerSystem.Controls.Ext.ControlsHelper;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;
using TellerSystem.Controls.Ext.ControlEntity;

namespace TellerSystem.Controls.Ext.TradePageComponent
{
    /// <summary>
    /// 取款账户控制信息
    /// </summary>
    public partial class TBC_DGYZ : TBC_ComponentBase<TBC_DGYZInput, TBC_DGYZOutput>
    {
        public TBC_DGYZ()
        {
            InitializeComponent();
        }

        #region 变量
        public string tellno = string.Empty;
        public string info = string.Empty;
        public DzyyEntity dzyyentity = null;
        public PageBase ParentPage { get; private set; }
        /// <summary>
        /// 验印开关
        /// </summary>
        public bool _isYY;
        /// <summary>
        /// 版本控制标志
        /// </summary>
        private string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        /// <summary>
        /// 验印是否通过
        /// </summary>
        public bool _isComplated;
        /// <summary>
        /// 验印结果-账号
        /// </summary>
        public string _zh;
        /// <summary>
        /// 验印结果-金额
        /// </summary>
        public string _je;
        /// <summary>
        /// 验印结果-凭证类型
        /// </summary>
        public string _pzlx;
        /// <summary>
        /// 验印结果-凭证号
        /// </summary>
        public string _pzh;
        /// <summary>
        /// 验印结果-出票日期
        /// </summary>
        public string _cpdate;
        /// <summary>
        /// 验印流水
        /// </summary>
        public string _yyls;
        /// <summary>
        /// 验资户标志 145 中牟验资户不掉起验印
        /// </summary>
        public string _yzhflag;

        #endregion

        #region  内部逻辑

        protected override void InitComponent()
        {
            base.InitComponent();
            ParentPage = (Platform.Common.BasicFunctions.DependencyObjectExtensions.FindVisualTreeAncestor(this, (x) => { return x is PageBase; })) as PageBase;
            if (ParentPage == null)
                return;
        }

        private void Date_CP_LostFocus(object sender, RoutedEventArgs e)
        {
            //if (_isYY && _isComplated)
            //{
            //    if (Date_CP.Text != _cpdate)
            //    {
            //        this.ParentPage.TradeAPIs.ShowInfoMessageBox("当前输入的出票日期与验印结果:" + _cpdate + "不一致，请确认！");
            //        this.ParentPage.SetFocus();
            //        return;
            //    }
            //}
            string codes = "2303|2304|2405|4402|2351|2352|5801|5834|8170";
            if (FLAG == "V5")
                codes = "2303|2304|2405|4402|2351|2352|5801|5834|8170|2367";
            if (codes.Contains(ParentPage.TradeModel.Code) && _yzhflag != "145")
            {
                dzyyentity = new TellerSystem.Controls.Ext.ControlEntity.DzyyEntity { AccNo = _zh, Amt = _je, Voucher = CBB_PZLX.GetSelectedKey(), VoucherNo = TB_PZHM.Text, VoucherDate = Date_CP.Text };
                if (ParentPage.TradeAPIs.YYCheck(dzyyentity) == false)
                {
                    this.ParentPage.TradeAPIs.ShowInfoMessageBox(dzyyentity.Message);
                    this.ParentPage.SetFocus();
                    return;
                }
                else 
                {
                    _yyls = string.Empty;
                    _yyls = dzyyentity.SerialNo;
                }
            }

            if (!string.IsNullOrEmpty(Date_CP.Text))
            {
                if (DateTime.Compare(Date_CP.Text.ToDateTime(), LoginUserInfo.TradeDate.ToDateTime()) > 0)
                {
                    //Tcp_date.ShowTip("出票时间大于当前日期!");
                    Page.TradeAPIs.ShowTip(Date_CP, Page.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                    Page.SetFocus(Date_CP);
                    return;
                }
                var days = LoginUserInfo.TradeDate.ToDateTime() - this.Date_CP.Text.ToDateTime();
                //DateTime dt = this.Date_CP.Text.ToDateTime().AddDays(10);
                //if (DateTime.Compare(LoginUserInfo.TradeDate.ToDateTime(), dt) > 0)
                //如果是承兑汇票跳过验证
                if (CBB_PZLX.GetSelectedValue() != "111")
                {
                    if (ComponentHelper.MinDays != 0 && days.Days >= ComponentHelper.MinDays)
                    {
                        Page.TradeAPIs.ShowTip(string.Format("出票日期不能小于当前日期{0}天！", ComponentHelper.MinDays));
                        Page.SetFocus(Date_CP);
                        return;
                    }
                }
            }
            if (Devices.Config.DeviceConfig.ScannerEnabled)
            {
                ServiceReference1.StampServiceIfPortTypeClient str = new ServiceReference1.StampServiceIfPortTypeClient();
                SealVerSys sys = new SealVerSys();
                sys.zh = ComponentHelper.Account.Trim();
                sys.pzh = TB_PZHM.Text.Trim();
                sys.je = ComponentHelper.Amt;
                sys.cprq = Date_CP.Text.Trim();
                sys.pzzl = CBB_PZLX.GetSelectedKey();
                sys.pzhm = CBB_PZLX.GetSelectedValue();
                sys.jgh = LoginUserInfo.KinbrNo;
                sys.gyh = LoginUserInfo.TellerNo;
                string jgh = LoginUserInfo.KinbrNo;
                if (ComponentHelper.Amt.ToDecimal() >= 500000)
                {
                    int num = str.getCnt(ComponentHelper.Account.Trim(), TB_PZHM.Text.Trim(), jgh);
                    if (num < 2)
                    {
                        sys.ShowDialog();
                        string tag = sys.result;
                        if (!string.IsNullOrWhiteSpace(tag))
                        {
                            char manres = tag[tag.IndexOf("<manidres>") + 10];
                            string svaestr = str.saveLogs(sys.result);
                            if (svaestr[svaestr.IndexOf("<code>") + 6] == '1')
                            {
                                if (manres == '1' || manres == '2')
                                {
                                    CheckYY(ComponentHelper.Account.Trim(), TB_PZHM.Text.Trim(), jgh, "人工干预", str);
                                }
                                else if (svaestr[svaestr.IndexOf("<lose>") + 6] != '0')
                                {
                                    CheckYY(ComponentHelper.Account.Trim(), TB_PZHM.Text.Trim(), jgh, "挂失", str);
                                }
                                else if (manres == '-')
                                {
                                    if (Convert.ToInt32(svaestr[svaestr.IndexOf("<count>") + 7].ToString()) < 2)
                                    {
                                        CheckYY(ComponentHelper.Account.Trim(), TB_PZHM.Text.Trim(), jgh, "大于金额", str);
                                    }
                                }
                                else
                                {
                                    Page.TradeAPIs.ShowInfoMessageBox("验印流水失败，请重新验印!");
                                    Page.TradeAPIs.SetFocus();
                                    return;
                                }
                            }
                            else if (svaestr[svaestr.IndexOf("<code>") + 6] == '6')
                            {
                                Page.TradeAPIs.ShowInfoMessageBox("同一柜员不能验印两次，请换柜员登录!");
                                Page.TradeAPIs.SetFocus();
                                return;
                            }
                            else
                            {
                                Page.TradeAPIs.ShowInfoMessageBox("验印流水失败，请重新验印!");
                                Page.TradeAPIs.SetFocus();
                                return;
                            }
                        }
                        else
                        {
                            this.Page.TradeAPIs.ShowInfoMessageBox("验印流水失败，请重新验印!");
                            Page.TradeAPIs.SetFocus();
                            return;
                        }
                    }
                }
                else
                {
                    sys.ShowDialog();
                    string tag = sys.result;
                    if (!string.IsNullOrWhiteSpace(tag))
                    {
                        char manres = tag[tag.IndexOf("<manidres>") + 10];
                        string svaestr = str.saveLogs(sys.result);
                        if (svaestr[svaestr.IndexOf("<code>") + 6] == '1')
                        {
                            if (manres == '1' || manres == '2' || svaestr[svaestr.IndexOf("<lose>") + 6] != '0')
                            {
                                if (Convert.ToInt32(svaestr[svaestr.IndexOf("<count>") + 7].ToString()) < 2)
                                {
                                    CheckYY(ComponentHelper.Account.Trim(), TB_PZHM.Text.Trim(), jgh, "人工干预", str);
                                }
                            }
                            else if (svaestr[svaestr.IndexOf("<lose>") + 6] != '0')
                            {
                                CheckYY(ComponentHelper.Account.Trim(), TB_PZHM.Text.Trim(), jgh, "挂失", str);
                            }
                            else if (manres == '-')
                            {
                                return;
                            }
                            else
                            {
                                Page.TradeAPIs.ShowInfoMessageBox("验印流水失败，请重新验印!");
                                Page.TradeAPIs.SetFocus();
                                return;
                            }
                        }
                        else if (svaestr[svaestr.IndexOf("<code>") + 6] == '6')
                        {
                            Page.TradeAPIs.ShowInfoMessageBox("同一柜员不能验印两次，请换柜员登录!");
                            Page.TradeAPIs.SetFocus();
                            return;
                        }
                        else
                        {
                            Page.TradeAPIs.ShowInfoMessageBox("验印流水失败，请重新验印!");
                            Page.TradeAPIs.SetFocus();
                            return;
                        }
                    }
                    else
                    {
                        this.Page.TradeAPIs.ShowInfoMessageBox("验印流水失败，请重新验印!");
                        Page.TradeAPIs.SetFocus();
                        return;
                    }
                }
            }
            //sys.ShowDialog();
            //string tag = sys.shengpi;
            //char sysres = tag[tag.IndexOf("<sysidres>") + 10];
            //char manres = tag[tag.IndexOf("<manidres>") + 10];
            //Message msg = new Message();
            //this.Page.TradeAPIs.InitFd(msg);
            //if (sysres != '1' && manres == '1')
            //{
            //    if (!AuthAction(new Message() { Fd96_W = "fd96w" }))
            //    {
            //        this.Page.TradeAPIs.SetFocus();
            //        return;
            //    }
            //}
            //if (manres == '1')
            //{
            //    Page.TradeAPIs.ShowInfoMessageBox("验印流水成功!");
            //    ServiceReference1.StampServiceIfPortTypeClient str = new ServiceReference1.StampServiceIfPortTypeClient();
            //    int isSucceed = (int)str.saveLogs(sys.result, tellno);
            //    if (isSucceed != 1)
            //    {
            //        Page.TradeAPIs.ShowInfoMessageBox("验印流水失败，请重新验印!");
            //        Page.TradeAPIs.SetFocus();
            //        return;
            //    }
            //}
            //else
            //{
            //    Page.TradeAPIs.ShowInfoMessageBox("验印流水失败，请重新验印!");
            //    Page.TradeAPIs.SetFocus();
            //    return;
            //}
        }

        //   private void TB_ZFMM_LostFocus(object sender, RoutedEventArgs e)
        //   {
        //       if (!Page.TradeAPIs.CheckPayPassword(ComponentHelper.Account, Date_CP.Text, ComponentHelper.Amt,
        //CBB_PZLX.GetSelectedValue(), TB_PZHM.Text, TB_ZFMM.Text))
        //       {
        //           Page.TradeAPIs.SetFocus();
        //           return;
        //       }
        //   }

        private void CheckYY(string accno, string pzno, string jgh, string content, ServiceReference1.StampServiceIfPortTypeClient str)
        {
            while (true)
            {
                if (content == "人工干预")
                {
                    this.Page.TradeAPIs.ShowInfoMessageBox("人工干预,需要两次验印,请登录验印系统验印!");
                }
                else if (content == "挂失")
                {
                    this.Page.TradeAPIs.ShowInfoMessageBox("账户已挂失，但出票日期在挂失之前，请登录验印系统验印");
                }
                else if (content == "大于金额")
                {
                    this.Page.TradeAPIs.ShowInfoMessageBox("金额大于50万，请登录验印系统验印!");
                }
                if (str.getCnt(accno, pzno, jgh) >= 2)
                {
                    return;
                }
            }
        }

        private void TB_YYLS_LostFocus(object sender, RoutedEventArgs e)
        {
            //if (!Page.TradeAPIs.CheckYanYinWater(ComponentHelper.Account, TB_PZHM.Text, ComponentHelper.Amt, Date_CP.Text, CBB_PZLX.GetSelectedValue(), TB_YYLS.Text))
            //{
            //    Page.TradeAPIs.SetFocus();
            //    return;
            //}
        }

        private void CBB_PZLX_LostFocus(object sender, RoutedEventArgs e)
        {
            //其它凭证的情况下，无需进行凭证号/出票日期的必输验证
            if (CBB_PZLX.GetSelectedValue() == "299")
            {
                Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(TB_PZHM, false);
                Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(Date_CP, false);
            }
            else
            {
                Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(TB_PZHM, true);
                Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(Date_CP, true);
            }

            //_zh = string.Empty;
            //_je = string.Empty;
            //_pzlx = string.Empty;
            //_pzh = string.Empty;
            //_cpdate = string.Empty;
            //_isComplated = false;
            ////中牟验印 凭证发起验印的交易清单
            //string codes = "2303|2304|2405|4402|2351|2352|5801|5834";
            //if (codes.Contains(ParentPage.TradeModel.Code))
            //{



            //        var yyCheck = ParentPage.TradeAPIs.YYCheck();
            //        if (!yyCheck.IsComplated)
            //        {
            //            this.ParentPage.TradeAPIs.ShowInfoMessageBox("验印未通过，请继续进行验印！");
            //            this.ParentPage.SetFocus();
            //            return;
            //        }
            //        _isYY = yyCheck.IsOnline;
            //        _zh = yyCheck.ZH;
            //        _je = yyCheck.JE;
            //        _pzlx = yyCheck.Type;
            //        _pzh = yyCheck.PZNO;
            //        _cpdate = yyCheck.CPRQ;
            //        _yyls = yyCheck.YYLS;
            //        _isComplated = yyCheck.IsComplated;

            //        if (_isYY && CBB_PZLX.GetSelectedKey() != _pzlx)
            //        {
            //            this.ParentPage.TradeAPIs.ShowInfoMessageBox("当前凭证类型与验印结果：" + _pzlx + "不一致，请确认！");
            //            this.ParentPage.SetFocus();
            //            return;
            //        }
            //    }

            //}

            //}

            if (ComponentHelper.PZLXControl != null)
            {
                if (!ComponentHelper.PZLXControl(CBB_PZLX.Text.Trim()))
                {
                    //验证不通过
                    this.Page.SetFocus();
                    return;
                }
            }
        }

        private void TB_PZHM_LostFocus(object sender, RoutedEventArgs e)
        {
            if (_isYY && _isComplated && CBB_PZLX.GetSelectedKey() != "收费凭证")//收费凭证不校验凭证号
            {
                if (TB_PZHM.Text != _pzh)
                {
                    this.ParentPage.TradeAPIs.ShowInfoMessageBox("当前凭证号码与验印结果：" + _pzh + "不一致，请确认！");
                    this.ParentPage.SetFocus();
                    return;
                }
            }
            //需要进行检查的凭证集合：现金支票、转账支票、委托付款凭证、银行汇票申请书、银行本票申请书  "001", "002", "167", "168", "189"
            var dict = SelectionManager.Instance.PullSelection("PZ05");

            if (dict.ContainsValue(Page.TradeAPIs.GetSelectedValue(CBB_PZLX)))
            {
                //验证凭证状态
                var result = Page.TradeAPIs.TF_Deposit_CheckCustomerCertificate(new CheckCustomerCertificate.Input()
                {
                    ZH = ComponentHelper.Account,
                    PZHM = TB_PZHM.Text,
                    PZLX = CBB_PZLX.GetSelectedValue(),
                }
                );
                if (result.IsFailed)
                {
                    Page.TradeAPIs.ShowTip(TB_PZHM, result.FailureCause);
                    Page.SetFocus(TB_PZHM);
                    return;
                }
                if (result.PZZT != "1")
                {
                    Page.TradeAPIs.ShowTip(TB_PZHM, "该凭证号码无法使用！");
                    Page.SetFocus(TB_PZHM);
                    return;
                }
                //需要进行支付密码验证 验印流水验证
                //ChangeState(true);
            }
            else
            {
                //ChangeState(false);
            }
            string codes = "2303|2304|2405|4402|2351|2352|5801|5834|8170";
            if (codes.Contains(ParentPage.TradeModel.Code))
            {
                if (CBB_PZLX.GetSelectedKey() == "对公折" && FLAG == "V5")
                {
                    dzyyentity = new TellerSystem.Controls.Ext.ControlEntity.DzyyEntity { AccNo = _zh, Amt = _je, Voucher = CBB_PZLX.GetSelectedKey(), VoucherNo = TB_PZHM.Text, VoucherDate = Date_CP.Text };
                    if (ParentPage.TradeAPIs.YYCheck(dzyyentity) == false)
                    {
                        this.ParentPage.TradeAPIs.ShowInfoMessageBox(dzyyentity.Message);
                        this.ParentPage.SetFocus();
                        return;
                    }
                }
            }

        }

        /// <summary>
        /// 是否验印流水和支付密码验证
        /// </summary>
        /// <param name="flag"></param>
        //private void ChangeState(bool flag)
        //{
        //    tradepanel.RaiseGroupAction("YZ", x => { x.Visibility = flag ? Visibility.Visible : Visibility.Collapsed; });
        //    tradepanel.Height = flag ? 100 : 70;
        //}
        #endregion



        #region 授权
        /// <summary>
        /// 授权方法
        /// </summary>
        /// <param name="msg"></param>
        /// <returns></returns>
        private bool AuthAction(Message msg)
        {
            // 组织授权检查要素
            TellerSystem.ServiceProxy.Ext.ServiceEntitys.PageData[] page = new TellerSystem.ServiceProxy.Ext.ServiceEntitys.PageData[1];
            page[0] = new TellerSystem.ServiceProxy.Ext.ServiceEntitys.PageData() { index = 1, datas = this.Page.SaveTradePage((FrameworkElement)this.Content) };
            AuthConditionElement element = new AuthConditionElement();
            AuthManager c = new AuthManager();
            c.AsksuperResultMessage += new AuthManager.AsksuperResultHandle(AskauthResultMessage);
            return c.DoAuth(this.Page, element, msg, page, "0", "", "", "", "", "验印流水授权", "");
        }

        private void AskauthResultMessage(AsksuperResultType result, TradeBusData busData)
        {
            switch (result)
            {
                case AsksuperResultType.Success:
                    this.Page.TradeAPIs.ShowInfoMessageBox("授权已经通过。");
                    break;
                case AsksuperResultType.Failed:
                    this.Page.TradeAPIs.ShowInfoMessageBox("授权没有通过。");
                    break;
                case AsksuperResultType.Undo:
                    this.Page.TradeAPIs.ShowInfoMessageBox("授权已撤销。");
                    break;
                default:
                    break;
            }
            tellno = busData["AuthTeller"];
        }
        #endregion
    }

    #region 数据限定
    /// <summary>
    /// 组件数据交互类
    /// </summary>
    public class TBC_DGYZInput : TBC_ComponentInput
    {
        #region 构造
        public TBC_DGYZInput()
        {
            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            MinDays = FLAG == "V9" ? 11 : 10;
        }
        #endregion

        #region 控制属性
        public string Account { get; set; }

        public string Amt { get; set; }

        public string KindNo { get; set; }

        public string TellNo { get; set; }
        /// <summary>
        /// 超出天数限制,默认为10
        /// 设置为0时，表示不做限制
        /// </summary>
        public int MinDays { get; set; }

        /// <summary>
        /// 凭证类型特别控制
        /// </summary>
        public Predicate<string> PZLXControl { get; set; }
        #endregion
    }

    /// <summary>
    /// 组件数据输出类
    /// </summary>
    public class TBC_DGYZOutput : TBC_ComponentOutput
    {
    }
    #endregion




}
