﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TellerSystem.Contract.ContractBase;
using TellerSystem.Library.Ext.Variables;
using TellerSystem.Communication;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using Platform.Controls.ControlsHelper;
using Platform.Library;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Library.Ext.TradeExtension;
using TellerSystem.Controls.Ext.ControlsHelper;
using Platform.Common.RunningParameters;
using TellerSystem.Devices.Interface;
using TellerSystem.Contract.Function;
using Platform.Presentation.FocusManagers;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;
using TellerSystem.Controls.Ext.ControlsExt;
using TellerSystem.ServiceProxy.Ext;
using System.Text.RegularExpressions;
using System.Data;

namespace TellerSystem.Controls.Ext.TradePageComponent
{
    /// <summary>
    /// 代理人业务组件
    /// </summary>
    public partial class TBC_EnterpriseCustomerInfo : TBC_ComponentBase<TBC_ECustomerInfoInput, TBC_ECustomerInfoOutput>
    {
        private EnterpriseCustomerInfoArgs enterpriseCustomerInfoArgs = null;
        Message _msg = new Message();
        int count = 0;
        string zjhm1 = string.Empty;
        string zzjhm = string.Empty;

        /// <summary>
        /// 证件号码 信息交互用
        /// </summary>
        string PrintInfoIDNo = string.Empty;
        public string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        #region 属性
        public PageBase ParentPage { get; private set; }
        /// <summary>
        /// 客户类型-企业用户
        /// </summary>
        string CIF_TYPE = "2";

        public bool IsUpdate { get; set; }

        #region 记录原对公证件类型
        public string OldOrganization = string.Empty;

        public string OldFile = string.Empty;

        public string OldBusinessCard = string.Empty;

        public string OldOther = string.Empty;

        public string OldCreditCard = string.Empty;

        #endregion
        #endregion

        public TBC_EnterpriseCustomerInfo()
        {
            InitializeComponent();

            this.enterpriseCustomerInfoArgs = new EnterpriseCustomerInfoArgs();

            if (FLAG == "V19" || FLAG == "V8" || FLAG == "V5" || FLAG == "V7" || FLAG == "V10" || FLAG == "V13" || FLAG == "V14" || FLAG == "V16" || FLAG == "V17" || FLAG == "V18" || FLAG == "V23" || FLAG == "V24" || FLAG == "V4" || (FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") || FLAG == "V11" || FLAG == "V12" || FLAG == "V9" || FLAG == "V3" || FLAG == "V2" || FLAG == "V1" || FLAG == "V0")
            {
                if (FLAG == "V19")
                {
                    JGXYDMZ.Visibility = ZJHM8.Visibility = Sdate8.Visibility = yxq8.Visibility = Visibility.Visible;
                    SYRXX2.Visibility = SYRXX3.Visibility = SYRXX4.Visibility = Visibility.Collapsed;
                    FocusManagerExt.SetAssertNotEmpty(FZR_type, true);
                    FocusManagerExt.SetAssertNotEmpty(cb_dwgs, true); 
                }
                FocusManagerExt.SetAssertNotEmpty(FR_Beg_date, true);
                FocusManagerExt.SetAssertNotEmpty(FR_End_date, true);
                yxq.AllowLongTerm = true;
                SDate1.AllowLongTerm = true;
                SDate2.AllowLongTerm = true;
                SDate5.AllowLongTerm = true;
                SDate6.AllowLongTerm = true;
                SDate7.AllowLongTerm = true;
                yxq8.AllowLongTerm = true;
                yxq2.AllowLongTerm = true;
                yxq5.AllowLongTerm = true;
                yxq1.AllowLongTerm = true;
                syxq2.AllowLongTerm = true;
                yxq3.AllowLongTerm = true;
                yxq4.AllowLongTerm = true;

            }
            /// <summary>
            /// 公司类型
            /// </summary>
            this.enterpriseCustomerInfoArgs.GSLX = this.QY_TYPE;
            /// <summary>
            /// 客户等级
            /// </summary>
            this.enterpriseCustomerInfoArgs.KHDJ = this.CIF_LVL1;
            /// <summary>
            /// 注册资本
            /// </summary>
            this.enterpriseCustomerInfoArgs.ZCZB = this.ZCZB;
            /// <summary>
            /// 贡 献 度
            /// </summary>
            this.enterpriseCustomerInfoArgs.GXD = this.CIF_CTB1;
            /// <summary>
            /// 证件类型
            /// </summary>
            this.enterpriseCustomerInfoArgs.ZJLX = this.MID_TYPE;
            /// <summary>
            /// 证件号码
            /// </summary>
            this.enterpriseCustomerInfoArgs.ZJHM = this.ZJHM3;
            /// <summary>
            /// 客户名称
            /// </summary>
            this.enterpriseCustomerInfoArgs.KHMC = this.KHXM1;
            /// <summary>
            /// 组织机构代码证
            /// </summary>
            this.enterpriseCustomerInfoArgs.ZJJGDMZ = this.ZJHM1;
            /// <summary>
            /// 组织机构代码证有效期开始
            /// </summary>
            this.enterpriseCustomerInfoArgs.YXQKS2 = this.Beg_date1;
            /// <summary>
            /// 组织机构代码证有效期结束
            /// </summary>
            this.enterpriseCustomerInfoArgs.YXQJS2 = this.End_date1;
            /// <summary>
            /// 营业执照
            /// </summary>
            this.enterpriseCustomerInfoArgs.YYZZ = this.ZJHM5;
            /// <summary>
            /// 营业执照有效期开始
            /// </summary>
            this.enterpriseCustomerInfoArgs.YXQKS3 = this.Beg_date5;
            /// <summary>
            /// 营业执照有效期结束
            /// </summary>
            this.enterpriseCustomerInfoArgs.YXQJS3 = this.End_date5;
            /// <summary>
            /// 其他证件号
            /// </summary>
            this.enterpriseCustomerInfoArgs.QTZJ = this.ZJHM6;
            /// <summary>
            /// 其他证件号有效期开始
            /// </summary>
            this.enterpriseCustomerInfoArgs.YXQKS4 = this.Beg_date6;
            /// <summary>
            /// 其他证件号有效期结束
            /// </summary>
            this.enterpriseCustomerInfoArgs.YXQJS4 = this.End_date6;
            /// <summary>
            /// 统一社会信用代码证
            /// </summary>
            this.enterpriseCustomerInfoArgs.JGXYDMZ = this.ZJHM7;
            /// <summary>
            /// 统一社会信用代码证有效期开始
            /// </summary>
            this.enterpriseCustomerInfoArgs.YXQKS5 = this.Beg_date7;
            /// <summary>
            /// 统一社会信用代码证有效期结束
            /// </summary>
            this.enterpriseCustomerInfoArgs.YXQJS5 = this.End_date7;
            /// <summary>
            /// 国税登记号
            /// </summary>
            this.enterpriseCustomerInfoArgs.GSDJH = this.GSDZH;
            /// <summary>
            /// 地税登记号
            /// </summary>
            this.enterpriseCustomerInfoArgs.DSDJH = this.DSDZH;
            /// <summary>
            /// 企业联系人
            /// </summary>
            this.enterpriseCustomerInfoArgs.QYLXR = this.QY_NAME;
            /// <summary>
            /// 企业联系人电话
            /// </summary>
            this.enterpriseCustomerInfoArgs.LXDH = this.TEL1;
            /// <summary>
            /// 传    真
            /// </summary>
            this.enterpriseCustomerInfoArgs.CZ = this.FAX1;

            /// <summary>
            /// 企业邮编
            /// </summary>
            this.enterpriseCustomerInfoArgs.QYYB = this.QYYB;
            /// <summary>
            /// 行业分类大类
            /// </summary>
            this.enterpriseCustomerInfoArgs.HYFL1 = this.HYFLD;
            /// <summary>
            /// 行业分类小类
            /// </summary>
            this.enterpriseCustomerInfoArgs.HYFL2 = this.HYFL;
            /// <summary>
            /// 国民经济部门
            /// </summary>
            this.enterpriseCustomerInfoArgs.GMJJBM = this.JJBM1;
            /// <summary>
            /// 地    区1
            /// </summary>
            this.enterpriseCustomerInfoArgs.DQ1 = this.diqu1;
            /// <summary>
            /// 地    区2
            /// </summary>
            this.enterpriseCustomerInfoArgs.DQ2 = this.diqu2;
            /// <summary>
            /// 出资人经济成分
            /// </summary>
            this.enterpriseCustomerInfoArgs.CZRJJCF = this.JJCF;
            /// <summary>
            /// 企业规模
            /// </summary>
            this.enterpriseCustomerInfoArgs.QYGM = this.QYGM;
            /// <summary>
            /// 公司联系地址
            /// </summary>
            this.enterpriseCustomerInfoArgs.GSLXDZ = this.ADDR1;
            /// <summary>
            /// 法人证件类型
            /// </summary>
            this.enterpriseCustomerInfoArgs.FRZJLX = this.FDDB_ID_TYPE;
            /// <summary>
            /// 法人证件号码
            /// </summary>
            this.enterpriseCustomerInfoArgs.FRZJH = this.FDSF;
            /// <summary>
            /// 法定代表人
            /// </summary>
            this.enterpriseCustomerInfoArgs.FDDBR = this.FDDB;
            /// <summary>
            /// 发证机关-法定代表人
            /// </summary>
            this.enterpriseCustomerInfoArgs.FZJG = this.FZJG1;
            /// <summary>
            /// 核查结果-法定代表人
            /// </summary>
            this.enterpriseCustomerInfoArgs.HCJG = this.HCJG1;
            /// <summary>
            /// 联网标志-法定代表人
            /// </summary>
            this.enterpriseCustomerInfoArgs.LWBZ = this.LW_FLG1;
            /// <summary>
            /// 佐证证件-法定代表人
            /// </summary>
            this.enterpriseCustomerInfoArgs.ZZZJ = this.ZZZZ1;
            /// <summary>
            /// 代理人证件类型
            /// </summary>
            this.enterpriseCustomerInfoArgs.DLRZJLX = this.AGENT_ID_TYPE;
            /// <summary>
            /// 代理人证件号码
            /// </summary>
            this.enterpriseCustomerInfoArgs.DLRZJHM = this.AGENT_ID_NO;
            /// <summary>
            /// 代理人发证机关
            /// </summary>
            this.enterpriseCustomerInfoArgs.FZJG1 = this.FZJG2;
            /// <summary>
            /// 代理人核查结果
            /// </summary>
            this.enterpriseCustomerInfoArgs.HCJG1 = this.HCJG2;
            /// <summary>
            /// 代理人联网标志
            /// </summary>
            this.enterpriseCustomerInfoArgs.LWBZ1 = this.LW_FLG2;
            /// <summary>
            /// 代理人佐证证件
            /// </summary>
            this.enterpriseCustomerInfoArgs.ZZZJ1 = this.ZZZZ2;
            /// <summary>
            /// 代理人姓名
            /// </summary>
            this.enterpriseCustomerInfoArgs.DLRXM = this.AGENT_NAME;
            /// <summary>
            /// 代理人联系方式
            /// </summary>
            this.enterpriseCustomerInfoArgs.DLRLXFS = this.AGENT_PHONE;
            /// <summary>
            /// 主证件类型
            /// </summary>
            this.enterpriseCustomerInfoArgs.ZZJLX = this.zzj_type;
            /// <summary>
            /// tb主证件类型
            /// </summary>
            this.enterpriseCustomerInfoArgs.tb_zzj_type = this.tb_zzj_type;
            /// <summary>
            /// 英文名称
            /// </summary>
            this.enterpriseCustomerInfoArgs.tb_ywname = this.YW_NAME;
            /// <summary>
            ///  税收居民身份标识
            /// </summary>
            this.enterpriseCustomerInfoArgs.CMB_SSBS = this.cmb_ssjmsfbs;
            /// <summary>
            ///  经济类型
            /// </summary>
            this.enterpriseCustomerInfoArgs.JJLX = this.JJLX;
            /// <summary>
            /// 本币基本账户开户行
            /// </summary>
            this.enterpriseCustomerInfoArgs.tb_bbkhh = this.BBKHH;
            if (FLAG == "V11" && !IsUpdate)//大石桥想要默认发证机关
            {
                FZJG1.Text = "大石桥市公安局";
            }
        }

        public void Init_TBC_CustomerInfo()
        {
            if (System.ComponentModel.DesignerProperties.GetIsInDesignMode(this)) return;
            ParentPage = (Platform.Common.BasicFunctions.DependencyObjectExtensions.FindVisualTreeAncestor(this, (x) => { return x is PageBase; })) as PageBase;
            if (ParentPage == null)
                return;
            this.ComponentHelper.isCheckId = false;
            //对公时，选择的客户等级
            //CIF_LVL1.SetItems(UserVariable.GetCustomerLvl());
            Page.TradeAPIs.CallComboBoxData(CIF_LVL1, "C021");
            CIF_LVL1.SelectedIndex = 0;

            CIF_CTB1.SetItems(new Dictionary<string, string> { { "低", "1" }, { "中", "2" }, { "高", "3" } });
            CIF_CTB1.SelectedIndex = 0;
            FZR_type.SetItems(new Dictionary<string, string> { { "法定代表人", "1" }, { "单位负责人", "2" } });
            FZR_type.SelectedIndex = 0;

            Sel_flag.SetItems(UserVariable.GetYorN());
            Sel_flag.SetSelectedValue("N");

            //核查结果
            //HCJG1.SetItems(UserVariable.GetHcjgType());
            //Page.TradeAPIs.CallComboBoxData(HCJG1, "C031");
            HCJG1.SetItems(new Dictionary<string, string> { { "公民身份号码与姓名一致，且存在照片", "0" }, { "公民身份号码与姓名一致，但不存在照片", "1" }, { "公民身份号码存在，但与姓名不匹配", "2" }, { "公民身份号码不存在", "3" }, { "其他错误", "4" }, { "输入的参数错误", "5" } });
            HCJG1.SelectedIndex = 0;

            //联网标志
            //LW_FLG1.SetItems(UserVariable.GetLwFlgType());
            //Page.TradeAPIs.CallComboBoxData(LW_FLG1, "C032");
            LW_FLG1.SetItems(new Dictionary<string, string> { { "待核实", "0" }, { "已核实", "1" }, { "出具证明", "2" } });
            LW_FLG1.SelectedIndex = 0;

            //佐证证件
            //ZZZZ1.SetItems(UserVariable.GetZzzzType());
            //Page.TradeAPIs.CallComboBoxData(ZZZZ1, "C033");
            ZZZZ1.SetItems(new Dictionary<string, string> { { "无", "0" }, { "户口簿", "1" }, { "驾驶证", "2" }, { "公安回执证明", "3" }, { "其他", "4" } });
            ZZZZ1.SelectedIndex = 0;

            //核查结果
            //HCJG2.SetItems(UserVariable.GetHcjgType());
            //Page.TradeAPIs.CallComboBoxData(HCJG2, "C031");
            HCJG2.SetItems(new Dictionary<string, string> { { "公民身份号码与姓名一致，且存在照片", "0" }, { "公民身份号码与姓名一致，但不存在照片", "1" }, { "公民身份号码存在，但与姓名不匹配", "2" }, { "公民身份号码不存在", "3" }, { "其他错误", "4" }, { "输入的参数错误", "5" } });
            HCJG2.SelectedIndex = 0;

            //联网标志
            //LW_FLG2.SetItems(UserVariable.GetLwFlgType());
            //Page.TradeAPIs.CallComboBoxData(LW_FLG2, "C032");
            LW_FLG2.SetItems(new Dictionary<string, string> { { "待核实", "0" }, { "已核实", "1" }, { "出具证明", "2" } });
            LW_FLG2.SelectedIndex = 0;

            //佐证证件
            //ZZZZ2.SetItems(UserVariable.GetZzzzType());
            //Page.TradeAPIs.CallComboBoxData(ZZZZ2, "C033");
            ZZZZ1.SetItems(new Dictionary<string, string> { { "无", "0" }, { "户口簿", "1" }, { "驾驶证", "2" }, { "公安回执证明", "3" }, { "其他", "4" } });
            ZZZZ2.SelectedIndex = 0;

            //国民经济部门对公
            //JJBM1.SetItems(UserVariable.GetJJBMType());
            //Page.TradeAPIs.CallComboBoxData(JJBM1, "C026");
            JJBM1.SetItems(new Dictionary<string, string> { { "政府部门", "A" }, { "中央政府", "A01" }, { "地方政府", "A02" }, { "社会保障基金", "A03" },
            { "金融机构部门", "B" }, { "货币当局", "B01" }, { "鉴定当局", "B02" }, { "银行业存款类金融机构", "B03" }, { "银行业非存款类金融机构", "B04" },
           { "证券业金融机构", "B05" }, { "保险业金融机构", "B06" }, { "交易及结算类金融机构", "B07" }, { "金融控股公司", "B08" }, { "特定目的载体", "B09" },
           { "其他", "B99" },  { "非金融企业部门", "C" }, { "公司", "C01" },{ "非公司企业", "C02" }, { "其他非金融企业部门", "C99" }, { "住户部门", "D" },
           { "住户", "D01" },{ "为住户服务的非营利机构", "D02" },{ "非居民部门", "E" },{ "国际组织", "E01" },{ "外国政府", "E02" },{ "国外金融机构", "E03" },
           { "国外非金融企业", "E04" },{ "外国居民", "E05" }});
            JJBM1.SelectedIndex = 0;

            //企业规模QYGM
            //QYGM.SetItems(UserVariable.GetQygmType());
            if (FLAG == "V11")
            {
                QYGM.SetItems(new Dictionary<string, string> { { "大型企业", "2" }, { "中型企业", "3" }, { "小型企业", "4" }, { "微型企业", "5" } });
            }
            else
            {
                QYGM.SetItems(new Dictionary<string, string> { { "大型企业", "2" }, { "中型企业", "3" }, { "小型企业", "4" }, { "微型企业", "5" }, { "其他", "9" } });
            }
            QYGM.SelectedIndex = 0;

            //经济成分JJCF
            JJCF.SetItems(UserVariable.GetJjcfType());
            JJCF.SelectedIndex = 0;

            //地区
            diqu1.SetItems(UserVariable.GetAreaType());
            diqu1.SelectedIndex = 0;

            //FDDB_ID_TYPE.SetItems(UserVariable.GetPerIdType());
            //Page.TradeAPIs.CallComboBoxData(FDDB_ID_TYPE, "C004");
            FDDB_ID_TYPE.SetItems(new Dictionary<string, string> { { "身份证", "1" }, { "户口簿", "2" }, { "护照", "3" }, { "军人证", "4" },
            { "非中国籍港澳内地通行证", "5" }, { "士兵证", "6" }, { "港澳居民来往内地通行证", "7" },{"港澳台居民居住证","W"}, { "外国人永久居留身份证", "F" }, { "警官证", "G" },
           { "其他证件（对私）", "H" }, { "台湾居民来往大陆通行证", "I" }, { "军官证", "J" }, { "文职干部证", "K" }, { "军官退休证", "L" },
           { "文职干部退休证", "M" },  { "武警身份证", "N" }, { "武警士兵证", "O" },{ "武警文职干部证", "P" }, { "武警军官退休证", "Q" }, 
            { "武警文职干部退休证", "R" }});
            //AGENT_ID_TYPE.SetItems(UserVariable.GetPerIdType());
            //Page.TradeAPIs.CallComboBoxData(AGENT_ID_TYPE, "C004");
            AGENT_ID_TYPE.SetItems(new Dictionary<string, string> { { "身份证", "1" }, { "户口簿", "2" }, { "护照", "3" }, { "军人证", "4" },
            { "非中国籍港澳内地通行证", "5" }, { "士兵证", "6" }, { "港澳居民来往内地通行证", "7" },{"港澳台居民居住证","W"}, { "外国人永久居留身份证", "F" }, { "警官证", "G" },
           { "其他证件（对私）", "H" }, { "台湾居民来往大陆通行证", "I" }, { "军官证", "J" }, { "文职干部证", "K" }, { "军官退休证", "L" },
           { "文职干部退休证", "M" },  { "武警身份证", "N" }, { "武警士兵证", "O" },{ "武警文职干部证", "P" }, { "武警军官退休证", "Q" }, 
            { "武警文职干部退休证", "R" }});

            //天山新增受益人
            SYRZJLX1.SetItems(new Dictionary<string, string> { { "身份证", "1" }, { "户口簿", "2" }, { "护照", "3" }, { "军人证", "4" },
            { "非中国籍港澳内地通行证", "5" }, { "士兵证", "6" }, { "港澳居民来往内地通行证", "7" },{"港澳台居民居住证","W"}, { "外国人永久居留身份证", "F" }, { "警官证", "G" },
           { "其他证件（对私）", "H" }, { "台湾居民来往大陆通行证", "I" }, { "军官证", "J" }, { "文职干部证", "K" }, { "军官退休证", "L" },
           { "文职干部退休证", "M" },  { "武警身份证", "N" }, { "武警士兵证", "O" },{ "武警文职干部证", "P" }, { "武警军官退休证", "Q" }, 
            { "武警文职干部退休证", "R" }});

            SYRZJLX2.SetItems(new Dictionary<string, string> { { "身份证", "1" }, { "户口簿", "2" }, { "护照", "3" }, { "军人证", "4" },
            { "非中国籍港澳内地通行证", "5" }, { "士兵证", "6" }, { "港澳居民来往内地通行证", "7" },{"港澳台居民居住证","W"}, { "外国人永久居留身份证", "F" }, { "警官证", "G" },
           { "其他证件（对私）", "H" }, { "台湾居民来往大陆通行证", "I" }, { "军官证", "J" }, { "文职干部证", "K" }, { "军官退休证", "L" },
           { "文职干部退休证", "M" },  { "武警身份证", "N" }, { "武警士兵证", "O" },{ "武警文职干部证", "P" }, { "武警军官退休证", "Q" }, 
            { "武警文职干部退休证", "R" }});

            SYRZJLX3.SetItems(new Dictionary<string, string> { { "身份证", "1" }, { "户口簿", "2" }, { "护照", "3" }, { "军人证", "4" },
            { "非中国籍港澳内地通行证", "5" }, { "士兵证", "6" }, { "港澳居民来往内地通行证", "7" },{"港澳台居民居住证","W"}, { "外国人永久居留身份证", "F" }, { "警官证", "G" },
           { "其他证件（对私）", "H" }, { "台湾居民来往大陆通行证", "I" }, { "军官证", "J" }, { "文职干部证", "K" }, { "军官退休证", "L" },
           { "文职干部退休证", "M" },  { "武警身份证", "N" }, { "武警士兵证", "O" },{ "武警文职干部证", "P" }, { "武警军官退休证", "Q" }, 
            { "武警文职干部退休证", "R" }});

            SYRZJLX4.SetItems(new Dictionary<string, string> { { "身份证", "1" }, { "户口簿", "2" }, { "护照", "3" }, { "军人证", "4" },
            { "非中国籍港澳内地通行证", "5" }, { "士兵证", "6" }, { "港澳居民来往内地通行证", "7" },{"港澳台居民居住证","W"}, { "外国人永久居留身份证", "F" }, { "警官证", "G" },
           { "其他证件（对私）", "H" }, { "台湾居民来往大陆通行证", "I" }, { "军官证", "J" }, { "文职干部证", "K" }, { "军官退休证", "L" },
           { "文职干部退休证", "M" },  { "武警身份证", "N" }, { "武警士兵证", "O" },{ "武警文职干部证", "P" }, { "武警军官退休证", "Q" }, 
            { "武警文职干部退休证", "R" }});

            cb_dwgs.SetItems(new Dictionary<string, string> { { "是", "Y" }, { "否", "N" } });
            cb_dwgs.SelectedIndex = 0;

            // cb_ssbt.SetItems(new Dictionary<string, string> { { "兵团直属|第一师", "01" }, { "兵团直属|第二师", "02" }, { "兵团直属|第三师", "03" }, { "兵团直属|第四师", "04" },
            // { "兵团直属|第五师", "05" }, { "兵团直属|第六师", "06" }, { "兵团直属|第七师", "07" }, { "兵团直属|第八师", "08" }, { "兵团直属|第九师", "09" },
            //{ "兵团直属|第十师", "10" }, { "兵团直属|第十一师", "11" }, { "兵团直属|第十二师", "12" }, { "兵团直属|第十三师", "13" }, { "兵团直属|第十四师", "14" }});
            Page.TradeAPIs.CallComboBoxData(cb_ssbt, "BTSB");
            cb_ssbt.SelectedIndex = 0;

            //HYFLD.SetItems(UserVariable.GetHyflDType());
            //Page.TradeAPIs.CallComboBoxData(HYFLD, "C024");
            HYFLD.SetItems(new Dictionary<string, string> {{"农、林、牧、渔业","A"},{"采矿业","B"},{"制造业","C"},{"电力、热力、燃气及水生产和供应业","D"},{"建筑业","E"},{"批发和零售业","F"},{"交通运输、仓储和邮政业","G"},{"住宿和餐饮业","H"},{"信息传输、软件和信息技术服务业","I"},
            {"金融业","J"},{"房地产业","K"},{"租赁和商务服务业","L"},{"科学研究和技术服务业","M"},{"水利、环境和公共设施管理业","N"},{"居民服务、修理和其他服务业","O"},{"教育","P"},{"卫生和社会工作","Q"},{"文化、体育和娱乐业","R"},{"公共管理、社会保障和社会组织","S"},{"国际组织","T"}});
            HYFLD.SelectedIndex = 0;

            //HYFL.SetItems(UserVariable.GetHyflTypeA());

            Page.TradeAPIs.CallComboBoxData(HYFL, "C025",
                               new Dictionary<string, string> { { "HYFL", HYFLD.GetSelectedValue() } });
            HYFL.SelectedIndex = 0;

            //设置企业类型          
            //var output = ParentPage.TradeAPIs.TF_Public_QueryComboBoxData(new QueryComboBoxData.Input { LBBM = "0006" });
            //if (output.IsFailed)
            //{
            //    ParentPage.TradeAPIs.ShowErrorMessageBox(output.FailureCause);
            //    return;
            //}
            //QY_TYPE.SetItems(output.CDXXData.Select(x => new KeyValuePair<string, string>(x.MS, x.LXZ)));
            Page.TradeAPIs.CallComboBoxData(QY_TYPE, "C023");
            QY_TYPE.SelectedIndex = 0;
            // QY_TYPE_YZ.SelectedIndex = 0;

            MID_TYPE.SetItems(new Dictionary<string, string> { { "组织机构代码证", "8" }, { "营业执照", "A" }, { "文件", "V" }, { "其他证件（对公）", "D" }, { "统一社会信用代码证", "S" } });
            //Page.TradeAPIs.CallComboBoxData(MID_TYPE, "C003");
            MID_TYPE.SelectedIndex = FLAG == "V8" ? 4 : 0;

            //设置代理人证件类型
            //AGENT_ID_TYPE.SetItems(UserVariable.GetPerIdType());
            //Page.TradeAPIs.CallComboBoxData(AGENT_ID_TYPE, "C004");
            AGENT_ID_TYPE.SetItems(new Dictionary<string, string> { { "身份证", "1" }, { "户口簿", "2" }, { "护照", "3" }, { "军人证", "4" },
            { "非中国籍港澳内地通行证", "5" }, { "士兵证", "6" }, { "港澳台来往居民通行证", "7" }, { "外国人永久居留身份证", "F" }, { "警官证", "G" },
           { "其他证件（对私）", "H" }, { "台湾同胞来往通行证", "I" }, { "军官证", "J" }, { "文职干部证", "K" }, { "军官退休证", "L" },
           { "文职干部退休证", "M" },  { "武警身份证", "N" }, { "武警士兵证", "O" },{ "武警文职干部证", "P" }, { "武警军官退休证", "Q" }, 
            { "武警文职干部退休证", "R" }});
            AGENT_ID_TYPE.SelectedIndex = 0;
            FZR_type.SelectedIndex = 0;  //默认负责人类型是企业法人

            if (FLAG == "V23")
            {
                FDDB_ID_TYPE.AddItems(new Dictionary<string, string> { { "临时身份证", "E" } });
                AGENT_ID_TYPE.AddItems(new Dictionary<string, string> { { "临时身份证", "E" } });
                SYRZJLX1.AddItems(new Dictionary<string, string> { { "临时身份证", "E" } });
                SYRZJLX2.AddItems(new Dictionary<string, string> { { "临时身份证", "E" } });
                SYRZJLX3.AddItems(new Dictionary<string, string> { { "临时身份证", "E" } });
                SYRZJLX4.AddItems(new Dictionary<string, string> { { "临时身份证", "E" } });
            }

            //增加主证件类型选项用于判定主证件
            zzj_type.SetItems(new Dictionary<string, string> { { "组织机构代码证", "8" }, { "文件", "V" }, { "营业执照", "A" }, { "其他证件", "D" }, { "统一社会信用代码证）", "S" } });
            zzj_type.SelectedIndex = 0;
            if (FLAG == "V0") //中牟，经营项目修改为经营范围
            {
                SFDLR.Visibility = Sel_flag.Visibility = Visibility.Visible;
                TB_JYXM.Text = "经营范围";
                var index = GSXX.Children.IndexOf(ZZJG);
                GSXX.Children.Remove(ZZJG);
                GSXX.Children.Remove(ZJHM1);
                GSXX.Children.Remove(Sdate1);
                GSXX.Children.Remove(SDate1);
                GSXX.Children.Remove(WJ);
                GSXX.Children.Remove(ZJHM2);
                GSXX.Children.Remove(Sdate2);
                GSXX.Children.Remove(SDate2);
                GSXX.Children.Remove(YYZZ);
                GSXX.Children.Remove(ZJHM5);
                GSXX.Children.Remove(Sdate5);
                GSXX.Children.Remove(SDate5);
                GSXX.Children.Remove(OTHER);
                GSXX.Children.Remove(ZJHM6);
                GSXX.Children.Remove(Sdate6);
                GSXX.Children.Remove(SDate6);
                GSXX.Children.Remove(JJXYDBZ);
                GSXX.Children.Remove(ZJHM7);
                GSXX.Children.Remove(Sdate7);
                GSXX.Children.Remove(SDate7);
                GSXX.Children.Insert(index, YYZZ);
                GSXX.Children.Insert(index + 1, ZJHM5);
                GSXX.Children.Insert(index + 2, Sdate5);
                GSXX.Children.Insert(index + 3, SDate5);
                GSXX.Children.Insert(index + 4, ZZJG);
                GSXX.Children.Insert(index + 5, ZJHM1);
                GSXX.Children.Insert(index + 6, Sdate1);
                GSXX.Children.Insert(index + 7, SDate1);
                GSXX.Children.Insert(index + 8, WJ);
                GSXX.Children.Insert(index + 9, ZJHM2);
                GSXX.Children.Insert(index + 10, Sdate2);
                GSXX.Children.Insert(index + 11, SDate2);
                GSXX.Children.Insert(index + 12, JJXYDBZ);
                GSXX.Children.Insert(index + 13, ZJHM7);
                GSXX.Children.Insert(index + 14, Sdate7);
                GSXX.Children.Insert(index + 15, SDate7);
                GSXX.Children.Insert(index + 16, OTHER);
                GSXX.Children.Insert(index + 17, ZJHM6);
                GSXX.Children.Insert(index + 18, Sdate6);
                GSXX.Children.Insert(index + 19, SDate6);

                Platform.Presentation.FocusManagers.FocusManager.GetManagerInstance(this).Refresh();
            }
            //中牟,经营项目,地址扩增字段任务
            //if (FLAG == "V0")
            //{
            //    TradePanel.SetColumnSpan(JJBM1, 3);
            //    TradePanel.SetColumnSpan(JYXM, 3);
            //    this.JYXM.MaxLength = 600;
            //    this.JYXM.Width = 585;

            //    this.ZCDZ.MaxLength = 120;

            //    this.ADDR1.MaxLength = 120;
            //}
            //大石桥,经营项目,地址扩增字段任务 
            //阳光,经营项目,地址扩增字段任务   --20190821  李棚
            if (FLAG == "V11" || FLAG == "V9" || FLAG == "V8" || FLAG == "V5" || FLAG == "V0" || FLAG == "V1" || FLAG == "V6" || FLAG == "V7" || (FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") || FLAG == "V2" || FLAG == "V12" || FLAG == "V3" || FLAG == "V19" || FLAG == "V21" || FLAG == "V22" || FLAG == "V23" || FLAG == "V24" || FLAG == "V10" || FLAG == "V13" || FLAG == "V14" || FLAG == "V16" || FLAG == "V17" || FLAG == "V18" || FLAG == "V4" || ServiceSettings.GetConfig("Temp_CustomerAddressLength", false))  //辰州,经营项目,地址扩增字段任务   --20190814  李棚
            {
                TradePanel.SetColumnSpan(JJBM1, 3);
                TradePanel.SetColumnSpan(JYXM, 3);
                this.JYXM.MaxLength = 2000;
                this.JYXM.Width = 585;

                this.ZCDZ.MaxLength = 120;

                this.ADDR1.MaxLength = 120;
            }

            //天山环境,新增受益人
            if (FLAG == "V19" || FLAG == "V8" || FLAG == "V5" || FLAG == "V7" || FLAG == "V10" || FLAG == "V13" || FLAG == "V14" || FLAG == "V16" || FLAG == "V17" || FLAG == "V18" || FLAG == "V23" || FLAG == "V24" || FLAG == "V4" || (FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") || FLAG == "V11" || FLAG == "V12" || FLAG == "V9" || FLAG == "V3" || FLAG == "V2" | FLAG == "V1" || FLAG == "V0")//行内又要求代理人信息非必输
            {
                SYRXX1.Visibility = SYRXX2.Visibility = SYRXX3.Visibility = SYRXX4.Visibility = Visibility.Visible;
                //Page.TradeAPIs.SetAssertNotEmpty(AGENT_ID_NO, true);
                //Page.TradeAPIs.SetAssertNotEmpty(ksrq7, true);
                //Page.TradeAPIs.SetAssertNotEmpty(jsrq7, true);
                //Page.TradeAPIs.SetAssertNotEmpty(AGENT_Beg_date, true);
                //Page.TradeAPIs.SetAssertNotEmpty(AGENT_End_date, true);
                //Page.TradeAPIs.SetAssertNotEmpty(AGENT_NAME, true);
            }
            if (FLAG == "V23" || FLAG == "V24")
            {
                //法人证件有效期必输
                FocusManagerExt.SetAssertNotEmpty(FR_Beg_date, true);
                FocusManagerExt.SetAssertNotEmpty(FR_End_date, true);
            }
            if (FLAG == "V1")
            {
                FocusManagerExt.SetAssertNotEmpty(FZJG1, true);
                FocusManagerExt.SetAssertNotEmpty(JYXM, true);
            }
            //新密去掉证件类型、证件号码、企业邮箱、传真 并新增法人手机号
            switch (FLAG)
            {
                case "V3":
                    FocusManagerExt.SetAssertNotEmpty(FDDB, false);//新密的法人可空
                    //lb_IDType.Visibility = Visibility.Collapsed;
                    //MID_TYPE.Visibility = Visibility.Collapsed;
                    //DMZ.Visibility = Visibility.Collapsed;
                    //ZJHM3.Visibility = Visibility.Collapsed;
                    FAX.Visibility = Visibility.Collapsed;
                    FAX1.Visibility = Visibility.Collapsed;
                    QYYB.Visibility = Visibility.Collapsed;
                    QYYB1.Visibility = Visibility.Collapsed;
                    //FZJG.Visibility = Visibility.Collapsed;
                    //FZJG1.Visibility = Visibility.Collapsed;
                    FRSJH.Visibility = Visibility.Visible;
                    FRSJHBOX.Visibility = Visibility.Visible;
                    //TradePanel.SetColumnSpan(FRSJHBOX, 3);
                    FocusManagerExt.SetAssertNotEmpty(FR_Beg_date, true);//法人有效日期
                    FocusManagerExt.SetAssertNotEmpty(FR_End_date, true);//法人有效日期 
                    ADDR1.MaxLength = ZCDZ.MaxLength = 120;//地址扩增至120字符任务 
                    break;
                case "V11"://大石桥隆丰
                    JJBM1.SetSelectedValue("B99");//国民经济部门默认为‘其他’
                    QYGM.SetSelectedValue("5");//企业规模默认为‘微型企业’
                    FocusManagerExt.SetAssertNotEmpty(QYYB, true);//邮编必输
                    FocusManagerExt.SetAssertNotEmpty(FRSJHBOX, true);//法人手机号码必输
                    ADDR1.MaxLength = ZCDZ.MaxLength = 120;//地址扩增至120字符任务  
                    FocusManagerExt.SetAssertNotEmpty(GSDZH, true);//国税必输
                    FocusManagerExt.SetAssertNotEmpty(DSDZH, true);//地税必输
                    JYXM.Height = 200;
                    JYXM.TextWrapping = TextWrapping.Wrap;
                    FocusManagerExt.SetAssertNotEmpty(JYXM, true);//
                    break;
                case "V9":
                case "V19":
                    ADDR1.MaxLength = ZCDZ.MaxLength = 120;//地址扩增至120字符任务   
                    break;
                case "V8"://阳光环境,经营项目,法定代表人有效日期为必输项  --20190822  李棚
                    FocusManagerExt.SetAssertNotEmpty(JYXM, true);
                    FocusManagerExt.SetAssertNotEmpty(FR_Beg_date, true);
                    FocusManagerExt.SetAssertNotEmpty(FR_End_date, true);
                    ADDR1.MaxLength = ZCDZ.MaxLength = 120;//地址扩增至120字符任务
                    break;
                case "V14"://泗水 经营项目必输
                    FocusManagerExt.SetAssertNotEmpty(JYXM, true);
                    FocusManagerExt.SetAssertNotEmpty(FZJG1, true); //发证机关必输
                    ADDR1.MaxLength = ZCDZ.MaxLength = 120;//地址扩增至120字符任务  
                    break;
                case "V0":// 中牟法人证件有效日期必输
                    FocusManagerExt.SetAssertNotEmpty(FR_Beg_date, true);//法人有效日期
                    FocusManagerExt.SetAssertNotEmpty(FR_End_date, true);//法人有效日期
                    KHXM1.MaxLength = 120;
                    break;
                case "V1":// 郏县法人证件有效日期必输                
                case "V6"://河南法人证件有效期日期必输
                case "V7"://都匀法人证件有效期日期必输
                    FocusManagerExt.SetAssertNotEmpty(FR_Beg_date, true);//法人有效日期
                    FocusManagerExt.SetAssertNotEmpty(FR_End_date, true);//法人有效日期 
                    ADDR1.MaxLength = ZCDZ.MaxLength = 120;//地址扩增至120字符任务
                    break;
                case "V18"://新泰邮编必输
                    FocusManagerExt.SetAssertNotEmpty(diqu2, true);//地区编码
                    FocusManagerExt.SetAssertNotEmpty(QYYB, true);//企业邮编   
                    ADDR1.MaxLength = ZCDZ.MaxLength = 120;//地址扩增至120字符任务  
                    break;
                case "V2"://新郑、鄢陵法人证件有效期日期必输
                    FocusManagerExt.SetAssertNotEmpty(FR_Beg_date, true);//法人有效日期
                    FocusManagerExt.SetAssertNotEmpty(FR_End_date, true);//法人有效日期
                    ADDR1.MaxLength = ZCDZ.MaxLength = 120;//地址扩增至120字符任务
                    //新郑 对公建立客户姓名 扩充为120
                    if (LoginUserInfo.KinbrNo.Substring(0, 3) == "152")
                    {
                        KHXM1.MaxLength = 120;
                    }
                    if (LoginUserInfo.KinbrNo.Substring(0, 3) == "122")
                    {
                        FocusManagerExt.SetAssertNotEmpty(QYYB, true);//企业邮编   
                    }
                    break;
                case "V12"://融丰需要客户姓名加长输入
                    KHXM1.MaxLength = 120;
                    ADDR1.MaxLength = ZCDZ.MaxLength = 120;
                    break;
                case "V5"://青隆
                    ADDR1.MaxLength = ZCDZ.MaxLength = 120;//地址扩增至120字符任务   
                    break;
                case "V4":
                    JYXM.MaxLength = 2000;//核心经营项目只有120字符，需要柜面先限制住，后面随核心再改
                    ADDR1.MaxLength = ZCDZ.MaxLength = 120;//地址扩增至120字节任务 
                    break;
                case "V16"://郏县
                case "V10":
                case "V13":
                case "V17":
                case "V23":
                case "V24":
                    ADDR1.MaxLength = ZCDZ.MaxLength = 120;//地址扩增至120字符任务   
                    if (FLAG == "V24")
                    {
                        KHXM1.MaxLength = 100;//确山 ECIF和核心仅支持100个字符
                    }
                    break;
                default:
                    break;
            }
            if (FLAG == "V21" || FLAG == "V22")
            {

                TB_YWNAME.Visibility = YW_NAME.Visibility = Visibility.Visible;
                CMB_ssjmsfbs.Visibility = cmb_ssjmsfbs.Visibility = Visibility.Visible;
                CMB_JJLX.Visibility = JJLX.Visibility = Visibility.Visible;
                TB_KHH.Visibility = BBKHH.Visibility = Visibility.Visible;

                cmb_ssjmsfbs.SetItems(new Dictionary<string, string> { { "仅为中国税收居民", "01" }, { "仅为非居民", "02" }, { "既是中国税收居民又是其他国家(地区)税收居民", "03" } });
                cmb_ssjmsfbs.SelectedIndex = 0;

                JJLX.SetItems(new Dictionary<string, string> { { "国有全资", "110" }, { "集体全资", "120" }, { "股份合作", "130" }, { "国有联营", "141" }, { "集体联营", "142" }, { "国有与集体联营", "143" }, { "其他联营", "149" }, 
                { "有限责任(公司)", "150" }, { "其他有限责任(公司)", "159" }, { "股份有限(公司)", "160" }, { "私有独资", "171" }, { "私有合伙(公司)", "172" }, { "私营有限责任(公司)", "173" }, { "私营股份有限(公司)", "174" }, { "个体经营", "175" }, { "其他私有", "179" },
                { "其他内资", "190" },{ "港、澳、台投资", "200" }, { "内地和港、澳或台合资", "210" }, { "内地和港、澳或台合作", "220" }, { "港、澳或台独资", "230" },{ "港、澳或台投资股份有限(公司)", "240" }, { "其他港澳台投资", "290" }, 
                { "国外投资", "300" }, { "中外合资", "310" }, { "中外合作", "320" }, { "外资", "330" }, { "国外投资股份有限(公司)", "340" }, { "其他国外投资", "390" }, { "其 他", "900" }});
                JJLX.SelectedIndex = 0;
                this.JYXM.MaxLength = 2000;
                CIF_LB.SetItems(new Dictionary<string, string> { { "机构客户", "01" }, { "同业客户", "02" }, { "集团客户", "03" }, { "小微企业客户", "04" }, { "其他企业客户", "99" } });
                CIF_LB.SelectedIndex = 0;
                CIF_LB_txt.Visibility = CIF_LB.Visibility = Visibility.Visible;
                textblock2.Visibility = textblock1.Visibility = Visibility.Visible;
                //法人国籍、联系地址、手机号码
                ParentPage.TradeAPIs.CallComboBoxData(FR_GJ, "C029");
                FR_GJ.SelectedIndex = 0;
                FRGJ.Visibility = FR_GJ.Visibility = FRLXDZ.Visibility = FR_LXDZ.Visibility = FRSJH.Visibility = FRSJHBOX.Visibility = Visibility.Visible;
                //代理人国籍、联系地址
                ParentPage.TradeAPIs.CallComboBoxData(DLR_GJ, "C029");
                DLR_GJ.SelectedIndex = 0;
                DLR_GJ.Visibility = DLR_LXDZ.Visibility = DLRGJ.Visibility = DLRLXDZ.Visibility = Visibility.Visible;
                //法人证件有效期必输
                FocusManagerExt.SetAssertNotEmpty(FR_Beg_date, true);
                FocusManagerExt.SetAssertNotEmpty(FR_End_date, true);
                FocusManagerExt.SetAssertNotEmpty(FRSJHBOX, true);

                if (FLAG == "V22")
                {
                    //对公证件类型顺序调换
                    var index = GSXX.Children.IndexOf(ZZJG);
                    GSXX.Children.Remove(ZZJG);
                    GSXX.Children.Remove(ZJHM1);
                    GSXX.Children.Remove(Sdate1);
                    GSXX.Children.Remove(SDate1);
                    GSXX.Children.Remove(WJ);
                    GSXX.Children.Remove(ZJHM2);
                    GSXX.Children.Remove(Sdate2);
                    GSXX.Children.Remove(SDate2);
                    GSXX.Children.Remove(YYZZ);
                    GSXX.Children.Remove(ZJHM5);
                    GSXX.Children.Remove(Sdate5);
                    GSXX.Children.Remove(SDate5);
                    GSXX.Children.Remove(OTHER);
                    GSXX.Children.Remove(ZJHM6);
                    GSXX.Children.Remove(Sdate6);
                    GSXX.Children.Remove(SDate6);
                    GSXX.Children.Remove(JJXYDBZ);
                    GSXX.Children.Remove(ZJHM7);
                    GSXX.Children.Remove(Sdate7);
                    GSXX.Children.Remove(SDate7);

                    GSXX.Children.Insert(index, YYZZ);
                    GSXX.Children.Insert(index + 1, ZJHM5);
                    GSXX.Children.Insert(index + 2, Sdate5);
                    GSXX.Children.Insert(index + 3, SDate5);

                    GSXX.Children.Insert(index + 4, OTHER);
                    GSXX.Children.Insert(index + 5, ZJHM6);
                    GSXX.Children.Insert(index + 6, Sdate6);
                    GSXX.Children.Insert(index + 7, SDate6);

                    GSXX.Children.Insert(index + 8, JJXYDBZ);
                    GSXX.Children.Insert(index + 9, ZJHM7);
                    GSXX.Children.Insert(index + 10, Sdate7);
                    GSXX.Children.Insert(index + 11, SDate7);

                    GSXX.Children.Insert(index + 12, WJ);
                    GSXX.Children.Insert(index + 13, ZJHM2);
                    GSXX.Children.Insert(index + 14, Sdate2);
                    GSXX.Children.Insert(index + 15, SDate2);

                    GSXX.Children.Insert(index + 16, ZZJG);
                    GSXX.Children.Insert(index + 17, ZJHM1);
                    GSXX.Children.Insert(index + 18, Sdate1);
                    GSXX.Children.Insert(index + 19, SDate1);

                    Platform.Presentation.FocusManagers.FocusManager.GetManagerInstance(this).Refresh();
                }
            }
            if (FLAG == "V19")
            {
                TB_JYDQDM.Visibility = JYDQDM.Visibility = textblock3.Visibility = textblock4.Visibility = cb_dwgs.Visibility = tb_dwgs.Visibility = Visibility.Visible;
            }
            if (FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152")
            {
                tb_SYRZJDZ1.Text = "受益人地址";
                tb_SYRZJDZ2.Text = "受益人地址";
                tb_SYRZJDZ3.Text = "受益人地址";
                tb_SYRZJDZ4.Text = "受益人地址";
            }
            if ((FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") || FLAG == "V8")
            {
                CZBL1.Visibility = tb_CZBL1.Visibility = CZJE1.Visibility = tb_CZJE1.Visibility =
                    CZBL2.Visibility = tb_CZBL2.Visibility = CZJE2.Visibility = tb_CZJE2.Visibility =
                    CZBL3.Visibility = tb_CZBL3.Visibility = CZJE3.Visibility = tb_CZJE3.Visibility =
                    CZBL4.Visibility = tb_CZBL4.Visibility = CZJE4.Visibility = tb_CZJE4.Visibility = Visibility.Visible;
                SYRXX1.Height = SYRXX2.Height = SYRXX3.Height = SYRXX4.Height = 145;
            }
        }

        private void AGENT_ID_TYPE_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!ParentPage.SetInputOfIdCard(AGENT_ID_NO, (AGENT_ID_TYPE.GetSelectedValue() == "1")))
            {
                ParentPage.SetFocus(AGENT_ID_TYPE);
                return;
            }
            else
            {
                ParentPage.SetInputOfIdCard(AGENT_ID_NO, (AGENT_ID_TYPE.GetSelectedValue() == "1"));
            }
            if (FLAG == "V23" && AGENT_ID_TYPE.GetSelectedKey().Contains("身份证"))
            {
                if (ParentPage.TradeAPIs.ShowQuestionMessageBox("是否确认输入代理人证件号码？") == MessageBoxResult.Yes)
                {
                    FocusManagerExt.SetAssertNotEmpty(AGENT_ID_NO, true);
                    FocusManagerExt.SetAssertNotEmpty(AGENT_NAME, true);
                    FocusManagerExt.SetAssertNotEmpty(AGENT_Beg_date, true);
                    FocusManagerExt.SetAssertNotEmpty(AGENT_End_date, true);
                }
                else
                {
                    FocusManagerExt.SetAssertNotEmpty(AGENT_ID_NO, false);
                    FocusManagerExt.SetAssertNotEmpty(AGENT_NAME, false);
                    FocusManagerExt.SetAssertNotEmpty(AGENT_Beg_date, false);
                    FocusManagerExt.SetAssertNotEmpty(AGENT_End_date, false);
                }
            }
            if (FLAG == "V8")
            {
                if (ParentPage.TradeAPIs.ShowQuestionMessageBox("是否确认输入代理人证件号码？") == MessageBoxResult.Yes)
                {
                    FocusManagerExt.SetAssertNotEmpty(AGENT_ID_NO, true);
                    FocusManagerExt.SetAssertNotEmpty(AGENT_NAME, true);
                    FocusManagerExt.SetAssertNotEmpty(AGENT_PHONE, true);
                    FocusManagerExt.SetAssertNotEmpty(AGENT_Beg_date, true);
                    FocusManagerExt.SetAssertNotEmpty(AGENT_End_date, true);
                }
                else
                {
                    FocusManagerExt.SetAssertNotEmpty(AGENT_ID_NO, false);
                    FocusManagerExt.SetAssertNotEmpty(AGENT_NAME, false);
                    FocusManagerExt.SetAssertNotEmpty(AGENT_PHONE, false);
                    FocusManagerExt.SetAssertNotEmpty(AGENT_Beg_date, false);
                    FocusManagerExt.SetAssertNotEmpty(AGENT_End_date, false);
                }
            }
            if (AGENT_ID_TYPE.GetSelectedKey().Contains("身份证"))
                DeviceManager.SetIdentityCardReader(AGENT_ID_NO, IdentityCardReaderType.ReadCardOrInput);
            else
                DeviceManager.SetIdentityCardReader(AGENT_ID_NO, IdentityCardReaderType.Input);
        }

        private void AGENT_ID_NO_LostFocus(object sender, RoutedEventArgs e)
        {
            //初始化
            Page.TradeAPIs.IsProxyStatus(false);
            //郏县存在代理人时，代理人证件有效日期必输
            if (FLAG == "V1" || FLAG == "V6" || FLAG == "V7" || FLAG == "V0" || (FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") || FLAG == "V2" || FLAG == "V11" || FLAG == "V9" || FLAG == "V8" || FLAG == "V5" || FLAG == "V12" || FLAG == "V3" || FLAG == "V19" || FLAG == "V23" || FLAG == "V24" || FLAG == "V10" || FLAG == "V13" || FLAG == "V14" || FLAG == "V16" || FLAG == "V17" || FLAG == "V18" || FLAG == "V4" || ServiceSettings.GetConfig("Temp_CustomerAddressLength", false))
            {
                if (AGENT_ID_NO.Text.Trim() != "")
                {
                    FocusManagerExt.SetAssertNotEmpty(AGENT_Beg_date, true);//代理人有效期
                    FocusManagerExt.SetAssertNotEmpty(AGENT_End_date, true);//代理人有效期
                }
                else
                {
                    FocusManagerExt.SetAssertNotEmpty(AGENT_Beg_date, false);//代理人有效期
                    FocusManagerExt.SetAssertNotEmpty(AGENT_End_date, false);//代理人有效期
                }
            }
            if (FLAG == "V0") //中牟，如果有代理人信息时，代理人所有信息都改为必输项
            {
                if (AGENT_ID_NO.Text.Trim() != "")
                {
                    FocusManagerExt.SetAssertNotEmpty(AGENT_NAME, true);
                    FocusManagerExt.SetAssertNotEmpty(AGENT_PHONE, true);
                }
                else
                {
                    FocusManagerExt.SetAssertNotEmpty(AGENT_NAME, false);
                    FocusManagerExt.SetAssertNotEmpty(AGENT_PHONE, false);
                }
            }
            //泗水 若存在代理人信息，则手机号必输
            if (FLAG == "V14")
            {
                if (AGENT_ID_NO.Text.Trim() != "")
                {
                    FocusManagerExt.SetAssertNotEmpty(AGENT_PHONE, true);
                }
                else
                {
                    FocusManagerExt.SetAssertNotEmpty(AGENT_PHONE, false);
                }
            }
            //新增加将证件号码字母自动转为大写
            string id_no = AGENT_ID_NO.Text.Trim().ToUpper();
            AGENT_ID_NO.Text = id_no;

            //初始化控件
            HCJG2.IsEnabled = false;
            LW_FLG2.IsEnabled = false;
            AGENT_NAME.IsReadOnly = false;

            if (AGENT_ID_NO.Text.Trim() != "")
            {
                if (AGENT_ID_TYPE.GetSelectedValue() == "1")
                {
                    var IdData = DeviceManager.GetIdentityCardData(AGENT_ID_NO);
                    if (IdData.Data.IdNumber != null)
                    {
                        AGENT_ID_NO.Text = IdData.Data.IdNumber;
                    }
                    if (IdData.Data.Name != null)
                    {
                        AGENT_NAME.Text = IdData.Data.Name;
                    }
                    if (IdData.Data.ValidDateStart.ToString("yyyyMMdd").Trim() != "00010101")
                    {
                        AGENT_Beg_date.Text = IdData.Data.ValidDateStart.ToString("yyyyMMdd");
                    }
                    if (IdData.Data.ValidDateEnd.ToString("yyyyMMdd").Trim() != "00010101")
                    {
                        AGENT_End_date.Text = IdData.Data.ValidDateEnd.ToString("yyyyMMdd").Trim();
                    }
                    //检查长度，务必保证18位
                    if (ParentPage.Len(AGENT_ID_NO.Text) != 18)
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N003));
                        ParentPage.SetFocus(AGENT_ID_NO);
                        return;
                    }
                    //调用sp8015.c对输入身份证进行验证080315
                    var output = ParentPage.TradeAPIs.TF_Deposit_IDNumberVerification(new IDNumberVerification.Input
                    {
                        ZJLX = "1",
                        ZJHM = AGENT_ID_NO.Text
                    });
                    if (output.IsFailed)
                    {
                        ParentPage.TradeAPIs.ShowTip(output.FailureCause);
                        ParentPage.SetFocus(AGENT_ID_NO);
                        return;
                    }
                    if (output.YZTGBZ[0] != '1')
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
                        ParentPage.SetFocus(AGENT_ID_NO);
                        return;
                    }
                    AGENT_ID_NO.Text = ParentPage.TradeAPIs.Delspace(output.ZJHM);
                    //执行核查
                    if (FLAG == "V1") //郏县 想柜员可选联网标志
                    {
                        LW_FLG2.IsEnabled = true;
                    }
                    else
                    {
                        LW_FLG2.IsEnabled = false;
                    }
                    string flag = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
                    if (flag == "V8" || (flag == "V19" && this.ComponentHelper.isCheckId) || (flag == "V5" && LoginUserInfo.KinbrNo.Substring(0, 3) == "301"))//保留阳光配置、青隆只邹平机构需要嵌入式联网核查
                    {
                        var result = ParentPage.TradeAPIs.IdCheck(AGENT_ID_NO);
                        if (result.IsOnline && result.IsComplated)
                        {
                            if (result.Result == "00")
                            {
                                HCJG2.SetSelectedValue("0");
                            }
                            else
                            {
                                //核查通过
                                HCJG2.SetSelectedValue(result.Result.TrimStart('0'));
                            }
                            LW_FLG2.SetSelectedValue("1");
                            AGENT_NAME.Text = result.Name;
                            // AGENT_NAME.IsReadOnly = true;
                        }
                        else
                        {
                            //未核查或失败
                            if (result.IsOnline && ParentPage.ShowQuestionMessageBox("联网身份核查未通过，是否继续？") == MessageBoxResult.No)
                            {
                                ParentPage.SetFocus(AGENT_ID_NO);
                                return;
                            }
                            HCJG2.IsEnabled = true;
                            LW_FLG2.SetSelectedValue("0");
                        }
                    }
                }
                if (AGENT_ID_TYPE.GetSelectedValue() == FDDB_ID_TYPE.GetSelectedValue() && AGENT_ID_NO.Text.Trim() == FDSF.Text.Trim() && !(FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0,3) == "152"))
                {
                    ParentPage.TradeAPIs.ShowWarnMessageBox("代理人与" + FZR_type.GetSelectedKey() + "信息一致请确认！");
                    ParentPage.SetFocus(AGENT_ID_NO);
                    return;
                }
                //设置代理人标识
                Page.TradeAPIs.IsProxyStatus(true);
            }
            if (TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("Is_CheckDQSBlackList") == "true" && !string.IsNullOrEmpty(AGENT_ID_NO.Text))//校验黑名单
            {
                //调用8854接口校验灰名单
                var blacklist = ParentPage.TradeAPIs.TF_Deposit_CheckBlackList(new CheckBlackList.Input()
                {
                    CXLX = "2",
                    ZJLX = AGENT_ID_TYPE.GetSelectedValue(),
                    ZJHM = AGENT_ID_NO.Text,
                    SFHNKHBCBZ = "6255"
                });
                if (blacklist.IsFailed)
                {
                    ParentPage.TradeAPIs.ShowWarnMessageBox(blacklist.FailureCause);
                    ParentPage.SetFocus();
                    return;
                }
                //不涉及到账务转出的：全渠道
                if (blacklist.allrestrict > 0)
                {
                    ParentPage.TradeAPIs.ShowWarnMessageBox(blacklist.info);
                    ParentPage.SetFocus();
                    return;
                }
            }
        }

        private void TEL1_LostFocus(object sender, RoutedEventArgs e)
        {
            string tel = string.Empty;
            if (ParentPage.Len(TEL1.Text) < 7)
            {
                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N008));
                //ParentPage.SetFocus(                //TEL1);
                ParentPage.SetFocus(TEL1);
                return;
            }

            RaiseLostFocus();
            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            if (FLAG == "V7")//都匀  代理人信息不为空时 发证机关必输
            {
                if (!string.IsNullOrEmpty(AGENT_ID_NO.Text) || !string.IsNullOrEmpty(AGENT_NAME.Text) || !string.IsNullOrEmpty(AGENT_PHONE.Text) || !string.IsNullOrEmpty(AGENT_Beg_date.Text) || !string.IsNullOrEmpty(AGENT_End_date.Text))
                {
                    FocusManagerExt.SetAssertNotEmpty(FZJG2, true);
                }
                else
                {
                    FocusManagerExt.SetAssertNotEmpty(FZJG2, false);
                }
            }
            if (FLAG == "V23" && !string.IsNullOrEmpty(AGENT_PHONE.Text))
            {
                RegexRuleExtension.SetInputType(AGENT_PHONE, InputRules.TelephoneOrMobilePhone);
            }
        }

        private void QY_TYPE_LostFocus(object sender, RoutedEventArgs e)
        {
            //update by zyh @2014年5月15日16:15:033 经WZX确认暂时注掉******
            //if (QY_TYPE.GetSelectedValue() == "D" || QY_TYPE.GetSelectedValue() == "E")
            //{
            //    MID_TYPE.SetSelectedValue("U");
            //    MID_TYPE.IsEnabled = false;
            //}
            //else
            //{
            //    MID_TYPE.IsEnabled = true;
            //    MID_TYPE.SelectedIndex = 0;
            //}
            //*************************************************************
            //if (QY_TYPE.GetSelectedValue() == "D" || QY_TYPE.GetSelectedValue() == "E")
            //{
            //    tb_zzj_type.Visibility = zzj_type.Visibility = Visibility.Visible;
            //    //FocusManagerExt.SetAssertNotEmpty(ZJHM1, false);
            //    //FocusManagerExt.SetAssertNotEmpty(Beg_date1, false);
            //    //FocusManagerExt.SetAssertNotEmpty(End_date1, false);
            //    //FocusManagerExt.SetAssertNotEmpty(ZJHM5, true);
            //    //FocusManagerExt.SetAssertNotEmpty(Beg_date5, true);
            //    //FocusManagerExt.SetAssertNotEmpty(End_date5, true);
            //    //TextBoxHelper.SetIsRepeatInput(ZJHM1, false);
            //    //TextBoxHelper.SetIsRepeatInput(ZJHM5, true);
            //}
            //else
            //{
            //tb_zzj_type.Visibility = zzj_type.Visibility = Visibility.Hidden;
            //FocusManagerExt.SetAssertNotEmpty(ZJHM1, true);
            ////FocusManagerExt.SetAssertNotEmpty(Beg_date1, true);
            ////FocusManagerExt.SetAssertNotEmpty(End_date1, true);
            //FocusManagerExt.SetAssertNotEmpty(ZJHM5, false);
            ////FocusManagerExt.SetAssertNotEmpty(Beg_date5, false);
            ////FocusManagerExt.SetAssertNotEmpty(End_date5, false);
            //TextBoxHelper.SetIsRepeatInput(ZJHM1, true);
            //TextBoxHelper.SetIsRepeatInput(ZJHM5, false);
            //Set_empty();
            //}
            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            if (FLAG == "V0") //中牟，公司类型为“企业法人、有字号的个体工商户、非法人企业、民办非企业”时，经营范围改为必输项，剩余则为选输项
            {
                if (QY_TYPE.GetSelectedValue() == "1" || QY_TYPE.GetSelectedValue() == "2" || QY_TYPE.GetSelectedValue() == "D" || QY_TYPE.GetSelectedValue() == "A")
                {
                    FocusManagerExt.SetAssertNotEmpty(JYXM, true);
                }
                else
                {
                    FocusManagerExt.SetAssertNotEmpty(JYXM, false);
                }
            }
        }
        private void zzj_type_GotFocus(object sender, RoutedEventArgs e)
        {
            //Set_empty();

        }

        private void zzj_type_LostFocus(object sender, RoutedEventArgs e)
        {
            //{ "组织机构代码证", "8" }, { "文件", "V" }, { "营业执照", "A" }, { "其他证件", "D" }
            //if (zzj_type.GetSelectedValue() == "8")
            //{
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM1, true);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM1, true);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM2, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM2, false);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM5, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM5, false);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM6, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM6, false);
            //}
            //else if (zzj_type.GetSelectedValue() == "V")
            //{
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM1, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM1, false);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM2, true);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM2, true);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM5, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM5, false);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM6, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM6, false);
            //}
            //else if (zzj_type.GetSelectedValue() == "A")
            //{
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM1, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM1, false);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM2, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM2, false);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM5, true);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM5, true);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM6, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM6, false);
            //}
            //else if (zzj_type.GetSelectedValue() == "D")
            //{
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM1, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM1, false);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM2, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM2, false);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM5, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM5, false);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM6, true);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM6, true);
            //}
            //Set_empty();
            zzjhm = Page.TradeAPIs.GetSelectedValue(zzj_type);
        }



        private void MID_TYPE_LostFocus(object sender, RoutedEventArgs e)
        {
            //ParentPage.SetInputOfIdCard(ZJHM3, (MID_TYPE.GetSelectedValue() == "1"));

            //ZJHM1.IsEnabled = true;
            //Beg_date1.IsEnabled = true;
            //End_date1.IsEnabled = true;

            //ZJHM5.IsEnabled = true;
            //Beg_date5.IsEnabled = true;
            //End_date5.IsEnabled = true;

            //if (MID_TYPE.GetSelectedValue() == "8")
            //{
            //    ZJHM1.IsEnabled = false;
            //    Beg_date1.IsEnabled = false;
            //    End_date1.IsEnabled = false;
            //}
            //if (MID_TYPE.GetSelectedValue() == "U")
            //{
            //    ZJHM5.IsEnabled = false;
            //    Beg_date5.IsEnabled = false;
            //    End_date5.IsEnabled = false;
            //}
            //选择机构代码证时，有效日期为必输，其它证件非必输
            if (MID_TYPE.GetSelectedValue() == "8")
            {
                FocusManagerExt.SetAssertNotEmpty(Beg_date, true);
                FocusManagerExt.SetAssertNotEmpty(End_date, true);
            }
            else
            {
                FocusManagerExt.SetAssertNotEmpty(Beg_date, false);
                FocusManagerExt.SetAssertNotEmpty(End_date, false);
            }
            if (FLAG == "V19")
            {
                ZJHM1.IsReadOnly = MID_TYPE.GetSelectedValue() == "8";
                ZJHM2.IsReadOnly = MID_TYPE.GetSelectedValue() == "V";
                ZJHM5.IsReadOnly = MID_TYPE.GetSelectedValue() == "A";
                ZJHM6.IsReadOnly = MID_TYPE.GetSelectedValue() == "D";
                ZJHM7.IsReadOnly = MID_TYPE.GetSelectedValue() == "S";
            }
        }

        private void ZJHM3_LostFocus(object sender, RoutedEventArgs e)
        {
            //新增加将证件号码字母自动转为大写
            string id_no = ZJHM3.Text.Trim().ToUpper();
            ZJHM3.Text = id_no;
            if (MID_TYPE.GetSelectedValue() == "8")//组织机构代码证
            {
                CheckOrganizationCode(ZJHM3.Text.Trim());
            }
            if (MID_TYPE.GetSelectedValue() == "A")//营业执照
            {
                CheckBusinessCode(ZJHM3.Text.Trim());
            }
            if (MID_TYPE.GetSelectedValue() == "S")//统一社会信用代码
            {
                CheckUniformSocialCode(ZJHM3.Text.Trim());
            }
            //if (MID_TYPE.GetSelectedValue() == "8")
            //{
            //    //增加对组织机构代码的验证
            //    var output = ParentPage.TradeAPIs.TF_Deposit_IDNumberVerification(new IDNumberVerification.Input
            //    {
            //        ZJLX = "8",
            //        ZJHM = ZJHM3.Text,
            //        MainCode = "2105"
            //    });

            //    if (output.IsFailed)
            //    {
            //        ParentPage.TradeAPIs.ShowTip(output.FailureCause);
            //        ParentPage.SetFocus(ZJHM3);
            //        return;
            //    }
            //    if (output.YZTGBZ[0] != '3')
            //    {
            //        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
            //        ParentPage.SetFocus(ZJHM3);
            //        return;
            //    }
            //}
            if (!IsUpdate)
            {
                //根据证件类型和号码查询客户是否已登记
                var output1 = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input
                {
                    ZJLX = MID_TYPE.GetSelectedValue(),
                    ZJHM = ZJHM3.Text.ToString()
                });
                if (output1.IsFailed)
                {
                    ParentPage.TradeAPIs.ShowTip(output1.FailureCause);
                    ParentPage.SetFocus(ZJHM3);
                    return;
                }

                var data = output1.WJ;
                if (output1.WJData.Count == 0)
                {
                    data = "客户未建立客户信息";
                }
                #region /*V9：客户信息不存在时，系统同样弹出对话框，但无任何记录，因此无需弹窗提示*/
                if (output1.WJData.Count != 0 && FLAG == "V9")
                {
                    var selectedData = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, data, new string[] { "客户编号", "客户名称", "证件号码" }, 500, 200);
                    if (selectedData == null)
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N042));
                        ParentPage.SetFocus(ZJHM3);
                        return;
                    }

                    if (selectedData["客户编号"].ToString() != "客户未建立客户信息")
                    {
                        ParentPage.TradeAPIs.ShowTip("该证件已建立客户信息");
                        ParentPage.SetFocus(ZJHM3);
                        return;
                    }
                }
                else if (FLAG != "V9")
                {
                    var selectedData = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, data, new string[] { "客户编号", "客户名称", "证件号码" }, 500, 200);
                    if (selectedData == null)
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N042));
                        ParentPage.SetFocus(ZJHM3);
                        return;
                    }

                    if (selectedData["客户编号"].ToString() != "客户未建立客户信息")
                    {
                        ParentPage.TradeAPIs.ShowTip("该证件已建立客户信息");
                        ParentPage.SetFocus(ZJHM3);
                        return;
                    }
                }
                #endregion


            }

            if ((FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") || FLAG == "V8" || FLAG == "V10" || FLAG == "V4" || FLAG == "V19")
            {
                if (MID_TYPE.GetSelectedValue() == "8")
                {
                    ZJHM1.Text = ZJHM3.Text.Trim();
                }
                else if (MID_TYPE.GetSelectedValue() == "V")
                {
                    ZJHM2.Text = ZJHM3.Text.Trim();
                }
                else if (MID_TYPE.GetSelectedValue() == "A")
                {
                    ZJHM5.Text = ZJHM3.Text.Trim();
                }
                else if (MID_TYPE.GetSelectedValue() == "D")
                {
                    ZJHM6.Text = ZJHM3.Text.Trim();
                }
                else if (MID_TYPE.GetSelectedValue() == "S")
                {
                    ZJHM7.Text = ZJHM3.Text.Trim();
                }
            }
        }

        private void KHXM1_LostFocus(object sender, RoutedEventArgs e)
        {
            //版本控制定义
            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            //新增加将姓名转换为全角处理080301
            if (ParentPage.Len(KHXM1.Text.ToString()) < 6)
            {
                ParentPage.TradeAPIs.ShowTip("客户名称小于6个字符，请确认");
                //ParentPage.SetFocus(                //ParentPage.KHXM1);
                ParentPage.SetFocus(KHXM1);
                return;
            }
            if (FLAG == "V21" || FLAG == "V22")
            {
                YW_NAME.Text = NPinyin.Pinyin.GetPinyin(KHXM1.Text).ToLower();
            }
            //根据证件类型和号码查询客户是否已登记
            //var output1 = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input
            //{
            //    KHMC = KHXM1.Text.ToString()
            //});
            //if (output1.IsFailed)
            //{
            //    ParentPage.TradeAPIs.ShowTip(output1.FailureCause);
            //    ParentPage.SetFocus(KHXM1);
            //    return;
            //}
            //if (output1.WJData.Count != 0)
            //{
            //    if (ParentPage.ShowQuestionMessageBox("该客户已建立客户信息,是否继续建立") == MessageBoxResult.Yes)
            //    {
            //        return;
            //    }
            //    else
            //    {
            //        ParentPage.SetFocus(KHXM1);
            //        return;
            //    }

            //}

            /**
            if (ParentPage.Mod(ParentPage.Len(KHXM1.Text), 2) != 0)
            {
                ParentPage.ShowMessageBox("汉字字符请退偶数格，请检查！");
                //ParentPage.SetFocus(                //KHXM1);
                ParentPage.SetFocus(KHXM1);
                return;
            }**/
            if (FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "122")
            {
                if (ZJHM5.Text.Trim() != "" || ZJHM7.Text.Trim() != "")
                {
                    FocusManagerExt.SetAssertNotEmpty(SYRXM1, true);
                    FocusManagerExt.SetAssertNotEmpty(SYRZJHM1, true);
                    FocusManagerExt.SetAssertNotEmpty(SYR_Beg_date1, true);
                    FocusManagerExt.SetAssertNotEmpty(SYR_End_date1, true);
                    FocusManagerExt.SetAssertNotEmpty(SYRZJDZ1, true);
                }
                else
                {
                    FocusManagerExt.SetAssertNotEmpty(SYRXM1, false);
                    FocusManagerExt.SetAssertNotEmpty(SYRZJHM1, false);
                    FocusManagerExt.SetAssertNotEmpty(SYR_Beg_date1, false);
                    FocusManagerExt.SetAssertNotEmpty(SYR_End_date1, false);
                    FocusManagerExt.SetAssertNotEmpty(SYRZJDZ1, false);
                }
            }
        }

        private void ZJHM1_LostFocus(object sender, RoutedEventArgs e)
        {
            count++;
            //版本控制定义 
            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            //证件不能全部为空
            if (ZJHM6.Text.Trim() == "" && ZJHM5.Text.Trim() == "" &&
                ZJHM1.Text.Trim() == "" && ZJHM2.Text.Trim() == "" && ZJHM7.Text.Trim() == "" && FLAG == "V22")
            {
                ParentPage.ShowTip("证件号码不能全部为空！");
                ParentPage.SetFocus(ZJHM1);
                return;
            }
            if (ZJHM1.Text.Trim() != "")
            {
                CheckOrganizationCode(ZJHM1.Text.Trim());
                //主证件类型以第一个录入的证件号为准
                if (FLAG == "V22")
                {
                    if (ZJHM1.Text.Trim() != "")
                    {
                        this.Page.TradeAPIs.SetSelectedValue(zzj_type, "8");
                        PrintInfoIDNo = ZJHM1.Text;
                    }
                    if (ZJHM2.Text.Trim() != "")
                    {
                        this.Page.TradeAPIs.SetSelectedValue(zzj_type, "V");
                        PrintInfoIDNo = ZJHM2.Text;
                    }
                    if (ZJHM7.Text.Trim() != "")
                    {
                        this.Page.TradeAPIs.SetSelectedValue(zzj_type, "S");
                        PrintInfoIDNo = ZJHM7.Text;
                    }
                    if (ZJHM6.Text.Trim() != "")
                    {
                        this.Page.TradeAPIs.SetSelectedValue(zzj_type, "D");
                        PrintInfoIDNo = ZJHM6.Text;
                    }
                    if (ZJHM5.Text.Trim() != "")
                    {
                        this.Page.TradeAPIs.SetSelectedValue(zzj_type, "A");
                        PrintInfoIDNo = ZJHM5.Text;
                    }
                }
                else
                {
                    Page.TradeAPIs.SetSelectedValue(zzj_type, "8");
                }

                //新增 证件号码与主证件号码一致 20160706 add by WH
                if (MID_TYPE.GetSelectedValue() == "8")
                {
                    if (!string.IsNullOrEmpty(ZJHM3.Text.Trim()))
                    {
                        if (ZJHM3.Text.Trim() != ZJHM1.Text.Trim())
                        {
                            ParentPage.TradeAPIs.ShowTip("证件号码不一致，请检查！");
                            ParentPage.SetFocus(ZJHM1);
                        }
                    }
                }
                if (count == 1)
                {
                    //新增加将证件号码字母自动转为大写
                    string id_no = ZJHM1.Text.Trim().ToUpper();
                    ZJHM1.Text = id_no;

                    ////增加对组织机构代码的验证
                    //var output = ParentPage.TradeAPIs.TF_Deposit_IDNumberVerification(new IDNumberVerification.Input { ZJLX = "8", ZJHM = ZJHM1.Text });
                    //if (output.IsFailed)
                    //{
                    //    ParentPage.TradeAPIs.ShowTip(output.FailureCause);
                    //    ParentPage.SetFocus(ZJHM1);
                    //    count = 0;
                    //    return;
                    //}
                    //if (output.YZTGBZ[0] != '3')
                    //{
                    //    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
                    //    ParentPage.SetFocus(ZJHM1);
                    //    count = 0;
                    //    return;
                    //}

                    if (!IsUpdate)
                    {
                        //CUSID1.Text = "";
                        //根据证件类型和号码查询客户是否已登记
                        var output1 = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { ZJLX = "8", ZJHM = ZJHM1.Text });
                        if (output1.IsFailed)
                        {
                            ParentPage.TradeAPIs.ShowTip(output1.FailureCause);
                            //ParentPage.SetFocus(                //ZJHM1);
                            ParentPage.SetFocus(ZJHM1);
                            count = 0;
                            return;
                        }

                        var data = output1.WJ;
                        if (output1.WJData.Count == 0)
                        {
                            data = "客户未建立客户信息";
                        }
                        #region /*客户信息不存在时，系统同样弹出对话框，但无任何记录，因此无需弹窗提示*/
                        if (output1.WJData.Count != 0)
                        {
                            var selectedData = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, data, new string[] { "客户编号", "客户名称", "证件号码" }, 500, 200);
                            if (selectedData == null)
                            {
                                count = 0;
                                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N042));
                                ParentPage.SetFocus(ZJHM1);
                                return;
                            }

                            if (selectedData["客户编号"].ToString() != "客户未建立客户信息")
                            {
                                ParentPage.TradeAPIs.ShowTip("该证件已建立客户信息");
                                ParentPage.SetFocus(ZJHM1);
                                count = 0;
                                return;
                            }
                        }
                        #endregion
                    }
                    else
                    {
                        var output1 = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { ZJLX = "8", ZJHM = ZJHM1.Text });
                        if (output1.IsFailed)
                        {
                            ParentPage.TradeAPIs.ShowTip(output1.FailureCause);
                            ParentPage.SetFocus(ZJHM1);
                            count = 0;
                            return;
                        }
                        if (OldOrganization.Trim() != ZJHM1.Text.Trim() && !string.IsNullOrEmpty(output1.WJ))
                        {
                            ParentPage.TradeAPIs.ShowTip("该证件已经被使用");
                            ParentPage.SetFocus(ZJHM1);
                            count = 0;
                            return;
                        }
                    }
                    Beg_date1.IsEnabled = true;
                    End_date1.IsEnabled = true;
                    FocusManagerExt.SetAssertNotEmpty(Beg_date1, true);
                    FocusManagerExt.SetAssertNotEmpty(End_date1, false);
                    if (FLAG == "V0")
                    {
                        FocusManagerExt.SetAssertNotEmpty(End_date1, true);
                    }
                    if (End_date1.Text == "")
                    {
                        End_date1.Text = "99991231";
                    }

                }
                #region /*update @ 2014年12月9日10:56:49*/
                if ((bool)ZJHM1.GetValue(TextBoxHelper.IsRepeatInputProperty) == false)
                {
                    if (count >= 2)
                    {
                        if (ZJHM1.Text.Trim().Equals(zjhm1))
                        {
                            count = 0;
                            zjhm1 = string.Empty;
                            return;
                        }
                        else
                        {
                            count = 0;
                            zjhm1 = string.Empty;
                            ZJHM1.Text = string.Empty;
                            ParentPage.TradeAPIs.SetFocus();
                            ParentPage.TradeAPIs.ShowTip("两次输入不一致！");
                            return;
                        }
                    }
                    else
                    {

                        zjhm1 = ZJHM1.Text.Trim();
                        ZJHM1.Text = string.Empty;
                        ParentPage.TradeAPIs.SetFocus();
                        ParentPage.TradeAPIs.ShowTip("请再输入一次！");
                        return;
                    }
                }
                #endregion/*update @ 2014年12月9日10:56:49*/
            }
            else
            {
                Beg_date1.IsEnabled = false;
                End_date1.IsEnabled = false;
                Beg_date1.Clear();
                End_date1.Clear();
                count = 0;
                Page.TradeAPIs.SetSelectedValue(zzj_type, zzjhm);
                return;
            }
        }
        private void Beg_date_LostFocus(object sender, RoutedEventArgs e)
        {
            if (Beg_date.Text.Trim() != "")
            {
                if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(Beg_date1.Text))
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                    ParentPage.SetFocus(Beg_date1);
                    return;
                }
            }
        }

        private void End_date_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ZJHM3.Text.Trim() == "" && (End_date.Text.Trim() != "" || Beg_date.Text.Trim() != ""))
            {
                ParentPage.TradeAPIs.ShowTip("证件号码为空时，有效期必须为空");
                ParentPage.SetFocus(Beg_date1);
                return;
            }

            if (ZJHM3.Text.Trim() != "")
            {
                if (End_date.Text.Trim() != "" && Beg_date.Text.Trim() != "")
                {
                    if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(End_date.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                        ParentPage.SetFocus(End_date);
                        return;
                    }
                    if (ParentPage.Atoi(End_date.Text) < ParentPage.Atoi(Beg_date.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                        //ParentPage.SetFocus(                //End_date);
                        ParentPage.SetFocus(End_date);
                        return;
                    }
                }
                else if ((End_date.Text.Trim() == "" && Beg_date.Text.Trim() != "") || (End_date.Text.Trim() != "" && Beg_date.Text.Trim() == ""))
                {
                    ParentPage.TradeAPIs.ShowTip("请输入完整的有效期");
                    ParentPage.SetFocus(End_date);
                    return;
                }
            }
        }
        private void Beg_date1_LostFocus(object sender, RoutedEventArgs e)
        {
            if (Beg_date1.Text.Trim() != "")
            {
                if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(Beg_date1.Text))
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                    ParentPage.SetFocus(Beg_date1);
                    return;
                }
            }
        }

        private void End_date1_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ZJHM1.Text.Trim() == "" && (End_date1.Text.Trim() != "" || Beg_date1.Text.Trim() != ""))
            {
                ParentPage.TradeAPIs.ShowTip("组织机构代码证为空时，有效期必须为空");
                ParentPage.SetFocus(Beg_date1);
                return;
            }
            if (End_date1.Text == "" || End_date1.Text == "99999999")
            {
                End_date1.Text = "99991231";
            }
            if (ZJHM1.Text.Trim() != "")
            {
                if (End_date1.Text.Trim() != "" && Beg_date1.Text.Trim() != "")
                {
                    if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(End_date1.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                        ParentPage.SetFocus(End_date1);
                        return;
                    }
                    if (ParentPage.Atoi(End_date1.Text) < ParentPage.Atoi(Beg_date1.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                        //ParentPage.SetFocus(                //End_date);
                        ParentPage.SetFocus(End_date1);
                        return;
                    }
                }
                else if (End_date1.Text.Trim() == "" || Beg_date1.Text.Trim() == "")
                {
                    ParentPage.TradeAPIs.ShowTip("请输入有效期");
                    ParentPage.SetFocus(Beg_date1);
                    return;
                }
            }
        }

        private void ZJHM5_LostFocus(object sender, RoutedEventArgs e)
        {
            //根据证件类型和号码查询客户是否已登记
            if (ZJHM5.Text.Trim() != "")
            {
                // 营业执照 不检查 不会重复吗？？？    20150115   diaosq   
                //if (string.IsNullOrWhiteSpace(ZJHM1.Text)) //对公开户只以组织机构代码验证是否开客户号，输入营业执照时不再验证也不再提示  modify by lnp 20141125
                //新增加将证件号码字母自动转为大写
                string id_no = ZJHM5.Text.Trim().ToUpper();
                ZJHM5.Text = id_no;
                CheckBusinessCode(ZJHM5.Text);
                //新增 证件号码与主证件号码一致 20160706 add by WH
                if (MID_TYPE.GetSelectedValue() == "A")
                {
                    if (!string.IsNullOrEmpty(ZJHM3.Text.Trim()))
                    {
                        if (ZJHM3.Text.Trim() != ZJHM5.Text.Trim())
                        {
                            ParentPage.TradeAPIs.ShowTip("证件号码不一致，请检查！");
                            ParentPage.SetFocus(ZJHM5);
                        }
                    }
                }
                if (!IsUpdate)
                {
                    var output = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { ZJLX = "A", ZJHM = ZJHM5.Text.ToString() });
                    if (output.IsFailed)
                    {
                        ParentPage.TradeAPIs.ShowTip(output.FailureCause);
                        //ParentPage.SetFocus(                //ZJHM2);
                        ParentPage.SetFocus(ZJHM5);
                        return;
                    }

                    var data = output.WJ;
                    if (output.WJData.Count == 0)
                    {
                        data = "客户未建立客户信息";
                    }
                    #region /*客户信息不存在时，系统同样弹出对话框，但无任何记录，因此无需弹窗提示*/
                    if (output.WJData.Count != 0)
                    {
                        var selectedData = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, data, new string[] { "客户编号", "客户名称", "证件号码" }, 500, 200);
                        if (selectedData == null)
                        {
                            count = 0;
                            ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N042));
                            ParentPage.SetFocus(ZJHM5);
                            return;
                        }

                        if (selectedData["客户编号"].ToString() != "客户未建立客户信息")
                        {
                            ParentPage.TradeAPIs.ShowTip("该证件已建立客户信息");
                            ParentPage.SetFocus(ZJHM5);
                            count = 0;
                            return;
                        }
                    }
                    #endregion
                }
                else
                {
                    var output1 = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { ZJLX = "A", ZJHM = ZJHM5.Text });
                    if (output1.IsFailed)
                    {
                        ParentPage.TradeAPIs.ShowTip(output1.FailureCause);
                        ParentPage.SetFocus(ZJHM5);
                        return;
                    }
                    if (OldBusinessCard.Trim() != ZJHM5.Text.Trim() && !string.IsNullOrEmpty(output1.WJ))
                    {
                        ParentPage.TradeAPIs.ShowTip("该证件已经被使用");
                        ParentPage.SetFocus(ZJHM5);
                        return;
                    }
                }
                FocusManagerExt.SetAssertNotEmpty(Beg_date5, true);
                FocusManagerExt.SetAssertNotEmpty(End_date5, false);
                if (FLAG == "V0")
                {
                    FocusManagerExt.SetAssertNotEmpty(End_date5, true);
                }
                Beg_date5.IsEnabled = true;
                End_date5.IsEnabled = true;
                if (End_date5.Text == "")
                {
                    End_date5.Text = "99991231";
                }
                //if (FLAG == "V21")
                //{
                //    if (ZJHM5.Text.Length > 15)
                //    {
                //        ParentPage.TradeAPIs.ShowInfoMessageBox("证件号码长度超15位请在统一社会信用代码证中输入！");
                //        ParentPage.SetFocus(ZJHM7);
                //        ZJHM7.Text = ZJHM5.Text;
                //        ZJHM5.Text = string.Empty;
                //        Beg_date5.IsEnabled = End_date5.IsEnabled = false;
                //        Beg_date6.IsEnabled = End_date6.IsEnabled = false;
                //        Beg_date5.Clear();
                //        End_date5.Clear();
                //        return;
                //    }
                //}
            }
            else
            {
                Beg_date5.IsEnabled = false;
                End_date5.IsEnabled = false;
                Beg_date5.Clear();
                End_date5.Clear();
            }
        }
        private void Beg_date5_LostFocus(object sender, RoutedEventArgs e)
        {
            if (Beg_date5.Text.Trim() != "")
            {
                if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(Beg_date5.Text))
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                    ParentPage.SetFocus(Beg_date5);
                    return;
                }
            }
        }

        private void End_date5_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ZJHM5.Text.Trim() == "" && (End_date5.Text.Trim() != "" || Beg_date5.Text.Trim() != ""))
            {
                ParentPage.TradeAPIs.ShowTip("营业执照为空时，有效期必须为空");
                ParentPage.SetFocus(Beg_date5);
                return;
            }
            if (End_date5.Text == "" || End_date5.Text == "99999999")
            {
                End_date5.Text = "99991231";
            }
            if (ZJHM5.Text.Trim() != "")
            {
                if (End_date5.Text.Trim() != "" && Beg_date5.Text.Trim() != "")
                {
                    if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(End_date5.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                        ParentPage.SetFocus(End_date5);
                        return;
                    }

                    if (ParentPage.Atoi(End_date5.Text) < ParentPage.Atoi(Beg_date5.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                        ParentPage.SetFocus(End_date5);
                        return;
                    }
                }
                else if (End_date5.Text.Trim() == "" || Beg_date5.Text.Trim() == "")
                {
                    ParentPage.TradeAPIs.ShowTip("请输入有效期");
                    ParentPage.SetFocus(Beg_date5);
                    return;
                }
            }
        }

        private void ZJHM6_LostFocus(object sender, RoutedEventArgs e)
        {
            if (FLAG == "V0")
            {
                //证件不能全部为空
                if (ZJHM6.Text.Trim() == "" && ZJHM5.Text.Trim() == "" &&
                    ZJHM1.Text.Trim() == "" && ZJHM2.Text.Trim() == "" && ZJHM7.Text.Trim() == "")
                {
                    ParentPage.ShowTip("证件号码不能全部为空！");
                    ParentPage.SetFocus(ZJHM6);
                    return;
                }
                else
                {
                    //新增 证件号码与主证件号码一致 20160706 add by WH
                    if (MID_TYPE.GetSelectedValue() == "S")
                    {
                        if (!string.IsNullOrEmpty(ZJHM3.Text.Trim()))
                        {
                            if (ZJHM3.Text.Trim() != ZJHM7.Text.Trim())
                            {
                                ParentPage.TradeAPIs.ShowTip("证件号码不一致，请检查！");
                                ParentPage.SetFocus(ZJHM7);
                            }
                        }
                    }
                    if (ZJHM7.Text.Trim() != "")
                    {
                        this.Page.TradeAPIs.SetSelectedValue(zzj_type, "S");
                        PrintInfoIDNo = ZJHM7.Text;
                    }
                    if (ZJHM6.Text.Trim() != "")
                    {
                        this.Page.TradeAPIs.SetSelectedValue(zzj_type, "D");
                        PrintInfoIDNo = ZJHM6.Text;
                    }
                    if (ZJHM2.Text.Trim() != "")
                    {
                        this.Page.TradeAPIs.SetSelectedValue(zzj_type, "V");
                        PrintInfoIDNo = ZJHM2.Text;
                    }
                    if (ZJHM5.Text.Trim() != "")
                    {
                        this.Page.TradeAPIs.SetSelectedValue(zzj_type, "A");
                        PrintInfoIDNo = ZJHM5.Text;
                    }
                    if (ZJHM1.Text.Trim() != "")
                    {
                        this.Page.TradeAPIs.SetSelectedValue(zzj_type, "8");
                        PrintInfoIDNo = ZJHM1.Text;
                    }
                }
            }
            //根据证件类型和号码查询客户是否已登记
            //if (ZJHM5.Text.Trim() == "" && ZJHM6.Text.Trim() == "")
            //{
            //    ParentPage.ShowMessageBox("营业执照为空时，其他证件号为必输项");
            //    ParentPage.SetFocus(ZJHM6);
            //    return;
            //}

            if (ZJHM6.Text.Trim() != "")
            {
                //新增加将证件号码字母自动转为大写
                string id_no = ZJHM6.Text.Trim().ToUpper();
                ZJHM6.Text = id_no;
                //新增 证件号码与主证件号码一致 20160706 add by WH
                if (MID_TYPE.GetSelectedValue() == "D")
                {
                    if (!string.IsNullOrEmpty(ZJHM3.Text.Trim()))
                    {
                        if (ZJHM3.Text.Trim() != ZJHM6.Text.Trim())
                        {
                            ParentPage.TradeAPIs.ShowTip("证件号码不一致，请检查！");
                            ParentPage.SetFocus(ZJHM6);
                        }
                    }
                }

                if (!IsUpdate)
                {
                    var output = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { ZJHM = ZJHM6.Text, ZJLX = "D" });
                    if (output.IsFailed)
                    {
                        ParentPage.TradeAPIs.ShowTip(output.FailureCause);
                        ParentPage.SetFocus(ZJHM6);
                        return;
                    }

                    var data = output.WJ;
                    if (output.WJData.Count == 0)
                    {
                        data = "客户未建立客户信息";
                    }
                    #region /*客户信息不存在时，系统同样弹出对话框，但无任何记录，因此无需弹窗提示*/
                    if (output.WJData.Count != 0)
                    {
                        var selectedData = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, data, new string[] { "客户编号", "客户名称", "证件号码" }, 500, 200);
                        if (selectedData == null)
                        {
                            ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N042));
                            ParentPage.SetFocus(ZJHM6);
                            return;
                        }
                        if (selectedData["客户编号"].ToString() != "客户未建立客户信息")
                        {
                            ParentPage.TradeAPIs.ShowTip("该证件已建立客户信息");
                            ParentPage.SetFocus(ZJHM6);
                            return;
                        }
                    }
                    #endregion
                }
                else
                {
                    var output1 = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { ZJLX = "D", ZJHM = ZJHM6.Text });
                    if (output1.IsFailed)
                    {
                        ParentPage.TradeAPIs.ShowTip(output1.FailureCause);
                        ParentPage.SetFocus(ZJHM6);
                        return;
                    }
                    if (OldOther.Trim() != ZJHM6.Text.Trim() && !string.IsNullOrEmpty(output1.WJ))
                    {
                        ParentPage.TradeAPIs.ShowTip("该证件已经被使用");
                        ParentPage.SetFocus(ZJHM6);
                        return;
                    }
                }
                FocusManagerExt.SetAssertNotEmpty(Beg_date6, true);
                FocusManagerExt.SetAssertNotEmpty(End_date6, false);
                if (FLAG == "V0")
                {
                    FocusManagerExt.SetAssertNotEmpty(End_date6, true);
                }
                Beg_date6.IsEnabled = true;
                End_date6.IsEnabled = true;
                if (End_date6.Text == "")
                {
                    End_date6.Text = "99991231";
                }
            }
            else
            {
                Beg_date6.IsEnabled = false;
                End_date6.IsEnabled = false;
                Beg_date6.Clear();
                End_date6.Clear(); ;
            }
        }

        private void Beg_date6_LostFocus(object sender, RoutedEventArgs e)
        {
            if (Beg_date6.Text.Trim() != "")
            {
                if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(Beg_date6.Text))
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                    ParentPage.SetFocus(Beg_date6);
                    return;
                }
            }
        }

        private void End_date6_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ZJHM6.Text.Trim() == "" && (End_date6.Text.Trim() != "" || Beg_date6.Text.Trim() != ""))
            {
                ParentPage.TradeAPIs.ShowTip("其他证件为空时，有效期必须为空");
                ParentPage.SetFocus(Beg_date6);
                return;
            }
            if (End_date6.Text == "" || End_date6.Text == "99999999")
            {
                End_date6.Text = "99991231";
            }
            if (ZJHM6.Text.Trim() != "")
            {
                if (End_date6.Text.Trim() != "" && Beg_date6.Text.Trim() != "")
                {
                    if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(End_date6.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                        ParentPage.SetFocus(End_date6);
                        return;
                    }

                    if (ParentPage.Atoi(End_date6.Text) < ParentPage.Atoi(Beg_date6.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                        //ParentPage.SetFocus(                //End_date);
                        ParentPage.SetFocus(End_date6);
                        return;
                    }
                }
                else if (End_date6.Text.Trim() == "" || Beg_date6.Text.Trim() == "")
                {
                    ParentPage.TradeAPIs.ShowTip("请输入有效期");
                    ParentPage.SetFocus(Beg_date6);
                    return;
                }
            }
        }

        private void ZJHM7_LostFocus(object sender, RoutedEventArgs e)
        {
            if (FLAG != "V0")
            {
                //证件不能全部为空
                //if (ZJHM6.Text.Trim() == "" && ZJHM5.Text.Trim() == "" &&
                //    ZJHM1.Text.Trim() == "" && ZJHM2.Text.Trim() == "" && ZJHM7.Text.Trim() == "" && FLAG != "V22")
                //{
                //    ParentPage.ShowTip("证件号码不能全部为空！");
                //    ParentPage.SetFocus(ZJHM7);
                //    return;
                //}
                //else
                //{
                if (FLAG != "V22")
                {
                    //证件不能全部为空
                    if (ZJHM6.Text.Trim() == "" && ZJHM5.Text.Trim() == "" &&
                        ZJHM1.Text.Trim() == "" && ZJHM2.Text.Trim() == "" && ZJHM7.Text.Trim() == "")
                    {
                        ParentPage.ShowTip("证件号码不能全部为空！");
                        ParentPage.SetFocus(ZJHM7);
                        return;
                    }
                }
                //新增 证件号码与主证件号码一致 20160706 add by WH
                if (MID_TYPE.GetSelectedValue() == "S")
                {
                    if (!string.IsNullOrEmpty(ZJHM3.Text.Trim()))
                    {
                        if (ZJHM3.Text.Trim() != ZJHM7.Text.Trim())
                        {
                            ParentPage.TradeAPIs.ShowTip("证件号码不一致，请检查！");
                            ParentPage.SetFocus(ZJHM7);
                        }
                    }
                }
                if (ZJHM7.Text.Trim() != "")
                {
                    this.Page.TradeAPIs.SetSelectedValue(zzj_type, "S");
                    PrintInfoIDNo = ZJHM7.Text;
                }
                if (ZJHM6.Text.Trim() != "")
                {
                    this.Page.TradeAPIs.SetSelectedValue(zzj_type, "D");
                    PrintInfoIDNo = ZJHM6.Text;
                }
                if (ZJHM2.Text.Trim() != "")
                {
                    this.Page.TradeAPIs.SetSelectedValue(zzj_type, "V");
                    PrintInfoIDNo = ZJHM2.Text;
                }
                if (ZJHM5.Text.Trim() != "")
                {
                    this.Page.TradeAPIs.SetSelectedValue(zzj_type, "A");
                    PrintInfoIDNo = ZJHM5.Text;
                }
                if (ZJHM1.Text.Trim() != "")
                {
                    this.Page.TradeAPIs.SetSelectedValue(zzj_type, "8");
                    PrintInfoIDNo = ZJHM1.Text;
                }
                if ((FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") || FLAG == "V8" || FLAG == "V10" || FLAG == "V4")
                {
                    this.Page.TradeAPIs.SetSelectedValue(zzj_type, MID_TYPE.GetSelectedValue());
                    PrintInfoIDNo = ZJHM3.Text;
                }
                //}
            }
            //根据证件类型和号码查询客户是否已登记
            if (ZJHM7.Text.Trim() != "")
            {
                //新增加将证件号码字母自动转为大写
                string id_no = ZJHM7.Text.Trim().ToUpper();
                ZJHM7.Text = id_no;
                CheckUniformSocialCode(ZJHM7.Text);
                if (!IsUpdate)
                {
                    var output = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { ZJLX = "S", ZJHM = ZJHM7.Text });
                    if (output.IsFailed)
                    {
                        ParentPage.TradeAPIs.ShowTip(output.FailureCause);
                        ParentPage.SetFocus(ZJHM7);
                        return;
                    }
                    var data = output.WJ;
                    if (output.WJData.Count == 0)
                    {
                        data = "客户未建立客户信息";
                        if (FLAG == "V19" && ZJHM5.Text.Trim() != "")
                        {
                            var output2 = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { ZJHM = ZJHM5.Text, ZJLX = "A" });
                            if (output2.IsFailed)
                            {
                                ParentPage.TradeAPIs.ShowTip(output2.FailureCause);
                                ParentPage.SetFocus(ZJHM5);
                                return;
                            }
                            if (output2.WJData.Count != 0)
                            {
                                ParentPage.ShowMessageBox("客户已用营业执照建立客户信息，请查询");
                                ParentPage.SetFocus(ZJHM5);
                                return;
                            }
                        }
                    }
                    #region /*客户信息不存在时，系统同样弹出对话框，但无任何记录，因此无需弹窗提示*/
                    if (output.WJData.Count != 0)
                    {
                        var selectedData = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, data, new string[] { "客户编号", "客户名称", "证件号码" }, 500, 200);
                        if (selectedData == null)
                        {
                            ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N042));
                            ParentPage.SetFocus(ZJHM7);
                            return;
                        }

                        if (selectedData["客户编号"].ToString() != "客户未建立客户信息")
                        {
                            ParentPage.TradeAPIs.ShowTip("该证件已建立客户信息");
                            ParentPage.SetFocus(ZJHM7);
                            return;
                        }
                    }
                    #endregion
                }
                else
                {
                    var output1 = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { ZJLX = "S", ZJHM = ZJHM7.Text });
                    if (output1.IsFailed)
                    {
                        ParentPage.TradeAPIs.ShowTip(output1.FailureCause);
                        ParentPage.SetFocus(ZJHM7);
                        return;
                    }
                    if (OldCreditCard.Trim() != ZJHM7.Text.Trim() && !string.IsNullOrEmpty(output1.WJ))
                    {
                        ParentPage.TradeAPIs.ShowTip("该证件已经被使用");
                        ParentPage.SetFocus(ZJHM7);
                        return;
                    }
                }
                FocusManagerExt.SetAssertNotEmpty(Beg_date7, true);
                FocusManagerExt.SetAssertNotEmpty(End_date7, true);
                Beg_date7.IsEnabled = true;
                End_date7.IsEnabled = true;
            }
            else
            {
                Beg_date7.IsEnabled = false;
                End_date7.IsEnabled = false;
                Beg_date7.Clear();
                End_date7.Clear();
            }

        }

        private void Beg_date7_LostFocus(object sender, RoutedEventArgs e)
        {
            if (Beg_date7.Text.Trim() != "")
            {
                if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(Beg_date7.Text))
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                    ParentPage.SetFocus(Beg_date7);
                    return;
                }
            }
        }

        private void End_date7_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ZJHM7.Text.Trim() == "" && (End_date7.Text.Trim() != "" || Beg_date7.Text.Trim() != ""))
            {
                ParentPage.TradeAPIs.ShowTip("统一社会信用代码证为空时，有效期必须为空");
                ParentPage.SetFocus(Beg_date7);
                return;
            }
            if (End_date7.Text == "" || End_date7.Text == "99999999")
            {
                End_date7.Text = "99991231";
            }
            if (ZJHM7.Text.Trim() != "")
            {
                if (End_date7.Text.Trim() != "" && Beg_date7.Text.Trim() != "")
                {
                    if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(End_date7.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                        ParentPage.SetFocus(End_date7);
                        return;
                    }
                    if (ParentPage.Atoi(End_date7.Text) < ParentPage.Atoi(Beg_date7.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                        //ParentPage.SetFocus(                //End_date);
                        ParentPage.SetFocus(End_date7);
                        return;
                    }
                }
                else if (End_date7.Text.Trim() == "" || Beg_date7.Text.Trim() == "")
                {
                    ParentPage.TradeAPIs.ShowTip("请输入有效期");
                    ParentPage.SetFocus(Beg_date7);
                    return;
                }
            }
        }

        private void diqu1_LostFocus(object sender, RoutedEventArgs e)
        {
            diqu2.Text = null;
            if (diqu1.GetSelectedValue() == "01")
            {
                diqu2.IsEnabled = true;
            }
            else
            {

                diqu2.IsEnabled = false;
            }
        }

        private void diqu2_LostFocus(object sender, RoutedEventArgs e)
        {
            if (diqu2.Text.Length != 6)
            {
                diqu2.ShowTip("请输入6位地区码");
                ParentPage.SetFocus(diqu2);
                return;
            }
        }

        private void FDDB_ID_TYPE_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!ParentPage.SetInputOfIdCard(FDSF, (FDDB_ID_TYPE.GetSelectedValue() == "1")))
            {
                ParentPage.SetFocus(FDDB_ID_TYPE);
                return;
            }
            else
            {
                ParentPage.SetInputOfIdCard(FDSF, (FDDB_ID_TYPE.GetSelectedValue() == "1"));
            }
            //天山 要求 1000交易 身份证只刷卡
            if (FDDB_ID_TYPE.GetSelectedValue() == "1")
            {
                if (FLAG == "V19" && ParentPage.TradeModel.Code == "1000")
                {
                    DeviceManager.SetIdentityCardReader(FDSF, IdentityCardReaderType.ReadCard);
                }
                else
                {
                    DeviceManager.SetIdentityCardReader(FDSF, IdentityCardReaderType.ReadCardOrInput);
                }
            }
            else
            {
                DeviceManager.SetIdentityCardReader(FDSF, IdentityCardReaderType.Input);
            }
        }

        private void FDSF_LostFocus(object sender, RoutedEventArgs e)
        {
            //新增加将证件号码字母自动转为大写
            string id_no = FDSF.Text.Trim().ToUpper();
            FDSF.Text = id_no;

            //控件初始化
            HCJG1.IsEnabled = false;
            LW_FLG1.IsEnabled = false;
            FDDB.IsReadOnly = false;

            if (FDDB_ID_TYPE.GetSelectedValue() == "1")
            {
                var IdData = DeviceManager.GetIdentityCardData(FDSF);
                if (!string.IsNullOrEmpty(IdData.Data.IdNumber))
                {
                    FDSF.Text = IdData.Data.IdNumber;
                }
                if (!string.IsNullOrEmpty(IdData.Data.Name))
                {
                    FDDB.Text = IdData.Data.Name;
                }
                //检查长度，务必保证18位
                if (ParentPage.Len(FDSF.Text) != 18)
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N003));
                    ParentPage.SetFocus(FDSF);
                    return;
                }
                //数据验证
                //调用sp8015.c对输入身份证进行验证080315
                var output = ParentPage.TradeAPIs.TF_Deposit_IDNumberVerification(new IDNumberVerification.Input { ZJLX = "1", ZJHM = FDSF.Text });
                if (output.IsFailed)
                {
                    ParentPage.TradeAPIs.ShowTip(output.FailureCause);
                    ParentPage.SetFocus(FDSF);
                    return;
                }
                if (output.YZTGBZ[0] != '1')
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
                    ParentPage.SetFocus(FDSF);
                    return;
                }
                FDSF.Text = ParentPage.TradeAPIs.Delspace(output.ZJHM);

                //执行核查
                string flag = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
                if (flag == "V1") //郏县 想柜员可选联网标志
                {
                    LW_FLG1.IsEnabled = true;
                }
                else
                {
                    LW_FLG1.IsEnabled = false;
                }
                if (flag == "V8" || (flag == "V19" && this.ComponentHelper.isCheckId) || (flag == "V5" && LoginUserInfo.KinbrNo.Substring(0, 3) == "301"))//保留阳光配置、青隆只邹平机构需要嵌入式联网核查
                {
                    var result = ParentPage.TradeAPIs.IdCheck(FDSF);
                    if (result.IsOnline && result.IsComplated)
                    {
                        //核查通过
                        if (result.Result == "00")
                        {
                            HCJG1.SetSelectedValue("0");
                        }
                        else
                        {
                            HCJG1.SetSelectedValue(result.Result.TrimStart('0'));
                        }
                        LW_FLG1.SetSelectedValue("1");
                        FDDB.Text = result.Name;
                        FDDB.IsReadOnly = true;
                    }
                    else
                    {
                        //未核查或失败
                        if (result.IsOnline && ParentPage.ShowQuestionMessageBox("联网身份核查未通过，是否继续？") == MessageBoxResult.No)
                        {
                            ParentPage.SetFocus(FDSF);
                            return;
                        }
                        //自行手工选择核查结果，联网标志置为未核查
                        HCJG1.IsEnabled = true;
                        LW_FLG1.SetSelectedValue("0");
                    }
                }
            }
            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            if (FLAG == "V21" || FLAG == "V22")
            {
                //根据证件类型、证件号查询客户信息 返回同一证件多个户名的情况
                //客户号|客户名称|证件号码
                var khinfo = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input()
                {
                    ZJHM = FDSF.Text.Trim(),
                    ZJLX = FDDB_ID_TYPE.GetSelectedValue(),
                    KHLX = "1"
                });
                if (khinfo.IsFailed)
                {
                    ParentPage.TradeAPIs.ShowTip(khinfo.FailureCause);
                    ParentPage.SetFocus(FDSF);
                    return;
                }
                if (khinfo.WJData.Count == 0)
                {
                    ParentPage.TradeAPIs.ShowTip("该客户未建立客户号，请先建立客户号！");
                    ParentPage.SetFocus(FDSF);
                    return;
                }
                string[] wjdata = khinfo.WJ.Split('\n');
                string KHH = wjdata[1].Split('|')[0];
                //回显法人信息
                Message msg = new Message();
                ParentPage.InitFd(msg);
                ParentPage.CommSend(msg);
                msg.Fd16 = "K054";
                msg.Fd28 = KHH;//客户号
                msg.Fd127 = "1";//客户类型
                ParentPage.CallServer(msg);
                if (msg.Fd12 != "0000")
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.GetError(msg));
                    ParentPage.SetFocus();
                    return;
                }
                else
                {
                    string[] data = msg.FileData.Split('\n');
                    FDDB.Text = data[1].Split('|')[4];//法人姓名
                    FRSJHBOX.Text = data[1].Split('|')[19];//法人手机号码
                    FR_Beg_date.Text = data[1].Split('|')[7];//有效期
                    FR_End_date.Text = data[1].Split('|')[8];//有效期
                    FR_LXDZ.Text = data[1].Split('|')[21];//法人联系地址
                    FZJG1.Text = data[1].Split('|')[9];//发证机关
                    FR_GJ.SetSelectedValue(data[1].Split('|')[15]);//法人国籍
                }
            }
            if (FLAG == "V1")
            {
                //调用8854接口(按账号查询)
                //Message message = new Message();
                //ParentPage.InitFd(message);
                //ParentPage.CommSend(message);
                //message.Fd16 = "8855";
                //message.Fd116_4 = FDDB_ID_TYPE.GetSelectedValue();
                //message.Fd116_5 = FDSF.Text;
                //ParentPage.CallServer(message);
                //if (message.Fd12 != "0000")
                //{
                //    ParentPage.TradeAPIs.ShowTip(ParentPage.GetError(message));
                //    ParentPage.SetFocus();
                //    return;
                //}
                //if (message.Fd70.Substring(0, 1) == "1")//1黑名单  0 不是黑名单
                //{
                //    ParentPage.TradeAPIs.ShowTip("该客户为黑名单！");
                //    ParentPage.TradeAPIs.SetFocus();
                //    return;
                //}
            }
            if (TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("Is_CheckDQSBlackList") == "true")//校验黑名单
            {
                //调用8854接口校验灰名单
                var blacklist = ParentPage.TradeAPIs.TF_Deposit_CheckBlackList(new CheckBlackList.Input()
                {
                    CXLX = "2",
                    ZJLX = FDDB_ID_TYPE.GetSelectedValue(),
                    ZJHM = FDSF.Text,
                    SFHNKHBCBZ = "6255"
                });
                if (blacklist.IsFailed)
                {
                    ParentPage.TradeAPIs.ShowWarnMessageBox(blacklist.FailureCause);
                    ParentPage.SetFocus();
                    return;
                }
                //不涉及到账务转出的：全渠道
                if (blacklist.allrestrict > 0)
                {
                    ParentPage.TradeAPIs.ShowWarnMessageBox(blacklist.info);
                    ParentPage.SetFocus();
                    return;
                }
            }
            if (FLAG == "V5" && LoginUserInfo.KinbrNo.Substring(0, 3) == "302" && ParentPage.TradeModel.Code == "1000")
            {
                //根据证件类型、证件号查询客户信息 返回同一证件多个户名的情况
                //客户号|客户名称|证件号码
                var khinfo = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input()
                {
                    ZJHM = FDSF.Text.Trim(),
                    ZJLX = FDDB_ID_TYPE.GetSelectedValue(),
                    KHLX = "1"
                });
                if (khinfo.IsFailed)
                {
                    ParentPage.TradeAPIs.ShowTip(khinfo.FailureCause);
                    ParentPage.SetFocus(FDSF);
                    return;
                }
                if (khinfo.WJData.Count == 0)
                {
                    if (ParentPage.TradeAPIs.ShowQuestionMessageBox("该客户未建立客户号，是否跳转建立客户号！") == MessageBoxResult.Yes)
                    {
                        ParentPage.OpenTradePage("Trade.CustomerManager.T1000", TradePageExtension.OpenOptions.NewPage,
                                         new Dictionary<string, object>()
                                       {
                                           {"_open_path", "T1000"},
                                           {"_ID_TYPE", FDDB_ID_TYPE.GetSelectedValue()},
                                           {"_ID_NO", FDSF.Text}
                                       });
                    }
                    else
                    {
                        ParentPage.SetFocus(FDSF);
                    }
                    return;
                }
            }
           
        }

        private void FDDB_LostFocus(object sender, RoutedEventArgs e)
        {
            //信息交互
            if (TellerSystem.Devices.Config.DeviceConfig.TransInfoEnabled)
            {
                string text = "客户名称：" + KHXM1.Text +
                            "\n注册资本:" + SystemFunction.Delspace(SystemFunction.Comma(ZCZB.Text, 16)) +
                            "\n证件类型：" + zzj_type.GetSelectedKey() +
                            "\n证件号码：" + PrintInfoIDNo +
                            "\n企业联系人:" + QY_NAME.Text +
                            "\n联系电话:" + TEL1.Text +
                            "\n注册地址:" + ZCDZ.Text +
                            "\n法人代表:" + FDDB.Text +
                            "\n法人证件类型：" + FDDB_ID_TYPE.GetSelectedKey() +
                            "\n法人证件号码:" + FDSF.Text;
                var result = TellerSystem.Devices.DeviceHelper.PrintTransInfo(text);
                if (result.HasError)
                {
                    FDDB.ShowTip("信息交互操作有误，请重新调用");
                    this.Page.SetFocus(FDDB);
                    return;
                }
            }
        }

        private void HYFLD_LostFocus(object sender, RoutedEventArgs e)
        {
            string hyfld = null;
            hyfld = HYFLD.GetSelectedValue();
            //数据源与核心保持一致
            //HYFL.SetItems(UserVariable.GetHyflType(hyfld));
            Page.TradeAPIs.CallComboBoxData(HYFL, "C025",
                             new Dictionary<string, string> { { "HYFL", hyfld } });
        }
        private void FRSJHBOX_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!string.IsNullOrEmpty(FRSJHBOX.Text) && FRSJHBOX.Text.Length != 11)
            {
                ParentPage.TradeAPIs.ShowTip("手机号位数不正确");
                ParentPage.SetFocus(FRSJHBOX);
                return;
            }
        }

        private void QYYB_LostFocus(object sender, RoutedEventArgs e)
        {
            if (QYYB.Text.Trim() != string.Empty)
            {
                if (ParentPage.Len(QYYB.Text.Trim()) != 6)
                {
                    ParentPage.TradeAPIs.ShowTip("邮编号码无效，请检查");
                    //ParentPage.SetFocus(                //QYYB);
                    ParentPage.SetFocus(QYYB);
                    return;
                }
            }
        }

        public EnterpriseCustomerInfoArgs Controls
        {
            get
            {
                return this.enterpriseCustomerInfoArgs;
            }
        }

        public class EnterpriseCustomerInfoArgs
        {
            /// <summary>
            /// 公司类型
            /// </summary>
            public ComboBox GSLX { get; internal set; }
            /// <summary>
            /// 客户等级
            /// </summary>
            public ComboBox KHDJ { get; internal set; }
            /// <summary>
            /// 注册资本
            /// </summary>
            public TextBox ZCZB { get; internal set; }
            /// <summary>
            /// 贡 献 度
            /// </summary>
            public ComboBox GXD { get; internal set; }
            /// <summary>
            /// 证件类型
            /// </summary>
            public ComboBox ZJLX { get; internal set; }
            /// <summary>
            /// 证件号码
            /// </summary>
            public TextBox ZJHM { get; internal set; }
            /// <summary>
            /// 客户名称
            /// </summary>
            public TextBox KHMC { get; internal set; }
            /// <summary>
            /// 组织机构代码证
            /// </summary>
            public TextBox ZJJGDMZ { get; internal set; }
            /// <summary>
            /// 组织机构代码证有效期开始
            /// </summary>
            public TextBox YXQKS2 { get; internal set; }
            /// <summary>
            /// 组织机构代码证有效期结束
            /// </summary>
            public TextBox YXQJS2 { get; internal set; }
            /// <summary>
            /// 营业执照
            /// </summary>
            public TextBox YYZZ { get; internal set; }
            /// <summary>
            /// 营业执照有效期开始
            /// </summary>
            public TextBox YXQKS3 { get; internal set; }
            /// <summary>
            /// 营业执照有效期结束
            /// </summary>
            public TextBox YXQJS3 { get; internal set; }
            /// <summary>
            /// 其他证件号
            /// </summary>
            public TextBox QTZJ { get; internal set; }
            /// <summary>
            /// 其他证件号有效期开始
            /// </summary>
            public TextBox YXQKS4 { get; internal set; }
            /// <summary>
            /// 其他证件号有效期结束
            /// </summary>
            public TextBox YXQJS4 { get; internal set; }
            /// <summary>
            /// 统一社会信用代码证
            /// </summary>
            public TextBox JGXYDMZ { get; internal set; }
            /// <summary>
            /// 统一社会信用代码证有效期开始
            /// </summary>
            public TextBox YXQKS5 { get; internal set; }
            /// <summary>
            /// 统一社会信用代码证有效期结束
            /// </summary>
            public TextBox YXQJS5 { get; internal set; }
            /// <summary>
            /// 国税登记号
            /// </summary>
            public TextBox GSDJH { get; internal set; }
            /// <summary>
            /// 地税登记号
            /// </summary>
            public TextBox DSDJH { get; internal set; }
            /// <summary>
            /// 企业联系人
            /// </summary>
            public TextBox QYLXR { get; internal set; }
            /// <summary>
            /// 企业联系人电话
            /// </summary>
            public TextBox LXDH { get; internal set; }
            /// <summary>
            /// 传    真
            /// </summary>
            public TextBox CZ { get; internal set; }
            /// <summary>
            /// 企业邮编
            /// </summary>
            public TextBox QYYB { get; internal set; }
            /// <summary>
            /// 行业分类大类
            /// </summary>
            public ComboBox HYFL1 { get; internal set; }
            /// <summary>
            /// 行业分类小类
            /// </summary>
            public ComboBox HYFL2 { get; internal set; }
            /// <summary>
            /// 国民经济部门
            /// </summary>
            public ComboBox GMJJBM { get; internal set; }
            /// <summary>
            /// 地    区1
            /// </summary>
            public ComboBox DQ1 { get; internal set; }
            /// <summary>
            /// 地    区2
            /// </summary>
            public TextBox DQ2 { get; internal set; }
            /// <summary>
            /// 出资人经济成分
            /// </summary>
            public ComboBox CZRJJCF { get; internal set; }
            /// <summary>
            /// 企业规模
            /// </summary>
            public ComboBox QYGM { get; internal set; }
            /// <summary>
            /// 公司联系地址
            /// </summary>
            public TextBox GSLXDZ { get; internal set; }
            /// <summary>
            /// 法人证件类型
            /// </summary>
            public ComboBox FRZJLX { get; internal set; }
            /// <summary>
            /// 法人证件号码
            /// </summary>
            public TextBox FRZJH { get; internal set; }
            /// <summary>
            /// 法定代表人
            /// </summary>
            public TextBox FDDBR { get; internal set; }
            /// <summary>
            /// 发证机关-法定代表人
            /// </summary>
            public TextBox FZJG { get; internal set; }
            /// <summary>
            /// 核查结果-法定代表人
            /// </summary>
            public ComboBox HCJG { get; internal set; }
            /// <summary>
            /// 联网标志-法定代表人
            /// </summary>
            public ComboBox LWBZ { get; internal set; }
            /// <summary>
            /// 佐证证件-法定代表人
            /// </summary>
            public ComboBox ZZZJ { get; internal set; }
            /// <summary>
            /// 代理人证件类型
            /// </summary>
            public ComboBox DLRZJLX { get; internal set; }
            /// <summary>
            /// 代理人证件号码
            /// </summary>
            public TextBox DLRZJHM { get; internal set; }
            /// <summary>
            /// 代理人发证机关
            /// </summary>
            public TextBox FZJG1 { get; internal set; }
            /// <summary>
            /// 代理人核查结果
            /// </summary>
            public ComboBox HCJG1 { get; internal set; }
            /// <summary>
            /// 代理人联网标志
            /// </summary>
            public ComboBox LWBZ1 { get; internal set; }
            /// <summary>
            /// 代理人佐证证件
            /// </summary>
            public ComboBox ZZZJ1 { get; internal set; }
            /// <summary>
            /// 代理人姓名
            /// </summary>
            public TextBox DLRXM { get; internal set; }
            /// <summary>
            /// 代理人联系方式
            /// </summary>
            public TextBox DLRLXFS { get; internal set; }
            /// <summary>
            /// 主证件类型
            /// </summary>
            public ComboBox ZZJLX { get; internal set; }
            /// <summary>
            /// tb主证件类型
            /// </summary>
            public TextBlock tb_zzj_type { get; internal set; }
            /// <summary>
            /// 英文名称
            /// </summary>
            public TextBox tb_ywname { get; internal set; }
            /// <summary>
            /// 税收身份标识
            /// </summary>
            public ComboBox CMB_SSBS { get; internal set; }
            /// <summary>
            /// 经济类型
            /// </summary>
            public ComboBox JJLX { get; internal set; }
            /// <summary>
            /// 本币基本账户开户行
            /// </summary>
            public TextBox tb_bbkhh { get; internal set; }
        }

        private void QY_TYPE_GotFocus(object sender, RoutedEventArgs e)
        {
            RaiseGotFocus();
            //Set_empty();

        }

        private void Set_empty()
        {
            ZCZB.Text = string.Empty;
            ZJHM3.Text = string.Empty;
            Beg_date.Text = string.Empty;
            End_date.Text = string.Empty;
            diqu2.Text = string.Empty;
            ZJHM1.Text = string.Empty;
            Beg_date1.Text = string.Empty;
            End_date1.Text = string.Empty;
            ZJHM2.Text = string.Empty;
            Beg_date2.Text = string.Empty;
            End_date2.Text = string.Empty;
            ZJHM5.Text = string.Empty;
            Beg_date5.Text = string.Empty;
            End_date5.Text = string.Empty;
            ZJHM6.Text = string.Empty;
            Beg_date6.Text = string.Empty;
            End_date6.Text = string.Empty;
            ZJHM7.Text = string.Empty;
            Beg_date7.Text = string.Empty;
            End_date7.Text = string.Empty;
            KHXM1.Text = string.Empty;
            GSDZH.Text = string.Empty;
            DSDZH.Text = string.Empty;
            QY_NAME.Text = string.Empty;
            TEL1.Text = string.Empty;
            FAX1.Text = string.Empty;
            FRSJHBOX.Text = string.Empty;
            QYYB.Text = string.Empty;
            JYXM.Text = string.Empty;
            ZCDZ.Text = string.Empty;
            ADDR1.Text = string.Empty;
            FDSF.Text = string.Empty;
            FDDB.Text = string.Empty;
            FZJG1.Text = string.Empty;
            AGENT_ID_NO.Text = string.Empty;
            FZJG2.Text = string.Empty;
            AGENT_NAME.Text = string.Empty;
            AGENT_PHONE.Text = string.Empty;
            FocusManagerExt.SetAssertNotEmpty(Beg_date1, false);
            FocusManagerExt.SetAssertNotEmpty(End_date1, false);
            FocusManagerExt.SetAssertNotEmpty(Beg_date2, false);
            FocusManagerExt.SetAssertNotEmpty(End_date2, false);
            FocusManagerExt.SetAssertNotEmpty(Beg_date5, false);
            FocusManagerExt.SetAssertNotEmpty(End_date5, false);
            FocusManagerExt.SetAssertNotEmpty(Beg_date6, false);
            FocusManagerExt.SetAssertNotEmpty(End_date6, false);
        }
        private void FZR_type_LostFocus(object sender, RoutedEventArgs e)
        {
            if (FZR_type.SelectedIndex == 0)
            {
                fzr.Text = "代表人证件类型";
                title_FDSF.Text = "代表人证件号码";
                title_FDDB.Text = "法定代表人";
            }
            else
            {
                fzr.Text = "负责人证件类型";
                title_FDSF.Text = "负责人证件号码";
                title_FDDB.Text = "单位负责人";
            }
        }
        private void ZJHM2_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ZJHM2.Text.Trim() != "")
            {
                //新增加将证件号码字母自动转为大写
                string id_no = ZJHM2.Text.Trim().ToUpper();
                ZJHM2.Text = id_no;
                //新增 证件号码与主证件号码一致 20160706 add by WH
                if (MID_TYPE.GetSelectedValue() == "V")
                {
                    if (!string.IsNullOrEmpty(ZJHM3.Text.Trim()))
                    {
                        if (ZJHM3.Text.Trim() != ZJHM2.Text.Trim())
                        {
                            ParentPage.TradeAPIs.ShowTip("证件号码不一致，请检查！");
                            ParentPage.SetFocus(ZJHM2);
                        }
                    }
                }
                if (!IsUpdate)
                {
                    var output = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { ZJHM = ZJHM2.Text, ZJLX = "V" });
                    if (output.IsFailed)
                    {
                        ParentPage.TradeAPIs.ShowTip(output.FailureCause);
                        ParentPage.SetFocus(ZJHM2);
                        return;
                    }

                    var data = output.WJ;
                    if (output.WJData.Count == 0)
                    {
                        data = "客户未建立客户信息";
                    }
                    #region /*客户信息不存在时，系统同样弹出对话框，但无任何记录，因此无需弹窗提示*/
                    if (output.WJData.Count != 0)
                    {
                        var selectedData = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, data, new string[] { "客户编号", "客户名称", "证件号码" }, 500, 200);
                        if (selectedData == null)
                        {
                            ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N042));
                            ParentPage.SetFocus(ZJHM2);
                            return;
                        }
                        if (selectedData["客户编号"].ToString() != "客户未建立客户信息")
                        {
                            ParentPage.TradeAPIs.ShowTip("该证件已建立客户信息");
                            ParentPage.SetFocus(ZJHM2);
                            return;
                        }
                    }
                    #endregion
                }
                else
                {
                    var output1 = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { ZJLX = "V", ZJHM = ZJHM2.Text });
                    if (output1.IsFailed)
                    {
                        ParentPage.TradeAPIs.ShowTip(output1.FailureCause);
                        ParentPage.SetFocus(ZJHM2);
                        return;
                    }
                    if (OldFile.Trim() != ZJHM2.Text.Trim() && !string.IsNullOrEmpty(output1.WJ))
                    {
                        ParentPage.TradeAPIs.ShowTip("该证件已经被使用");
                        ParentPage.SetFocus(ZJHM2);
                        return;
                    }
                }
                FocusManagerExt.SetAssertNotEmpty(Beg_date2, true);
                FocusManagerExt.SetAssertNotEmpty(End_date2, false);
                if (FLAG == "V0")
                {
                    FocusManagerExt.SetAssertNotEmpty(End_date2, true);
                }
                Beg_date2.IsEnabled = true;
                End_date2.IsEnabled = true;
                if (End_date2.Text == "")
                {
                    End_date2.Text = "99991231";
                }
            }
            else
            {
                Beg_date2.IsEnabled = false;
                End_date2.IsEnabled = false;
                Beg_date2.Clear();
                End_date2.Clear();
            }
        }

        private void Beg_date2_LostFocus(object sender, RoutedEventArgs e)
        {
            if (Beg_date2.Text.Trim() != "")
            {
                if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(Beg_date2.Text))
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                    ParentPage.SetFocus(Beg_date2);
                    return;
                }
            }
        }

        private void End_date2_LostFocus(object sender, RoutedEventArgs e)
        {
            if (End_date2.Text == "" || End_date2.Text == "99999999")
            {
                End_date2.Text = "99991231";
            }
            if (End_date2.Text.Trim() != "")
            {
                if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(End_date2.Text))
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                    ParentPage.SetFocus(End_date2);
                    return;
                }
                if (ParentPage.Atoi(End_date2.Text) < ParentPage.Atoi(Beg_date2.Text))
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                    ParentPage.SetFocus(End_date2);
                    return;
                }
            }
        }

        private void ZJHM5_GotFocus(object sender, RoutedEventArgs e)
        {
            if (FLAG == "V0" || FLAG == "V11" || FLAG == "V21")
            {
                ZJHM5.MaxLength = 20;
            }
            else
            {
                ZJHM5.MaxLength = 18;
            }
        }

        private void FR_Beg_date_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(FR_Beg_date.Text))
            {
                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                ParentPage.SetFocus(FR_Beg_date);
                return;
            }
        }

        private void AGENT_Beg_date_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(AGENT_Beg_date.Text))
            {
                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                ParentPage.SetFocus(AGENT_Beg_date);
                return;
            }
        }

        private void FR_End_date_LostFocus(object sender, RoutedEventArgs e)
        {
            if (FR_End_date.Text.Trim() == "99999999")
            {
                FR_End_date.Text = "99991231";
                return;
            }
            if (FDSF.Text.Trim() == "" && (FR_Beg_date.Text.Trim() != "" || FR_End_date.Text.Trim() != ""))
            {
                ParentPage.TradeAPIs.ShowTip("证件号码为空时，有效期必须为空");
                ParentPage.SetFocus(FR_Beg_date);
                return;
            }
            if (FDSF.Text.Trim() != "")
            {
                if (FR_Beg_date.Text.Trim() != "" && FR_End_date.Text.Trim() != "")
                {
                    if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(FR_End_date.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                        ParentPage.SetFocus(FR_End_date);
                        return;
                    }
                    if (ParentPage.Atoi(FR_End_date.Text) < ParentPage.Atoi(FR_Beg_date.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                        ParentPage.SetFocus(FR_End_date);
                        return;
                    }
                }
                else if ((FR_End_date.Text.Trim() == "" && FR_Beg_date.Text.Trim() != "") || (FR_End_date.Text.Trim() != "" && FR_Beg_date.Text.Trim() == ""))
                {
                    ParentPage.TradeAPIs.ShowTip("请输入完整的有效期");
                    ParentPage.SetFocus(FR_End_date);
                    return;
                }
            }
        }

        private void AGENT_End_date_LostFocus(object sender, RoutedEventArgs e)
        {
            if (AGENT_End_date.Text.Trim() == "99999999")
            {
                AGENT_End_date.Text = "99991231";
                return;
            }
            if (AGENT_ID_NO.Text.Trim() == "" && (AGENT_Beg_date.Text.Trim() != "" || AGENT_End_date.Text.Trim() != ""))
            {
                ParentPage.TradeAPIs.ShowTip("证件号码为空时，有效期必须为空");
                ParentPage.SetFocus(FR_Beg_date);
                return;
            }
            if (AGENT_ID_NO.Text.Trim() != "")
            {
                if (AGENT_Beg_date.Text.Trim() != "" && AGENT_End_date.Text.Trim() != "")
                {
                    if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(AGENT_End_date.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                        ParentPage.SetFocus(AGENT_End_date);
                        return;
                    }
                    if (ParentPage.Atoi(AGENT_End_date.Text) < ParentPage.Atoi(AGENT_Beg_date.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                        ParentPage.SetFocus(AGENT_End_date);
                        return;
                    }
                }
                else if ((AGENT_End_date.Text.Trim() == "" && AGENT_Beg_date.Text.Trim() != "") || (AGENT_End_date.Text.Trim() != "" && AGENT_Beg_date.Text.Trim() == ""))
                {
                    ParentPage.TradeAPIs.ShowTip("请输入完整的有效期");
                    ParentPage.SetFocus(AGENT_End_date);
                    return;
                }
            }

        }

        //天山受益人事件
        private void SYR_Beg_date1_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(SYR_Beg_date1.Text))
            {
                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                ParentPage.SetFocus(SYR_Beg_date1);
                return;
            }
        }
        //天山受益人事件
        private void SYR_End_date1_LostFocus(object sender, RoutedEventArgs e)
        {
            if (SYR_End_date1.Text.Trim() == "99999999")
            {
                SYR_End_date1.Text = "99991231";
                return;
            }
            if (SYRZJHM1.Text.Trim() == "" && (SYR_Beg_date1.Text.Trim() != "" || SYR_End_date1.Text.Trim() != ""))
            {
                ParentPage.TradeAPIs.ShowTip("证件号码为空时，有效期必须为空");
                ParentPage.SetFocus(SYR_Beg_date1);
                return;
            }
            if (SYRZJHM1.Text.Trim() != "")
            {
                if (SYR_Beg_date1.Text.Trim() != "" && SYR_End_date1.Text.Trim() != "")
                {
                    if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(SYR_End_date1.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                        ParentPage.SetFocus(SYR_End_date1);
                        return;
                    }
                    if (ParentPage.Atoi(SYR_End_date1.Text) < ParentPage.Atoi(SYR_Beg_date1.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                        ParentPage.SetFocus(SYR_End_date1);
                        return;
                    }
                }
                else if ((SYR_End_date1.Text.Trim() == "" && SYR_Beg_date1.Text.Trim() != "") || (SYR_End_date1.Text.Trim() != "" && SYR_Beg_date1.Text.Trim() == ""))
                {
                    ParentPage.TradeAPIs.ShowTip("请输入完整的有效期");
                    ParentPage.SetFocus(SYR_End_date1);
                    return;
                }
            }
        }

        private void SYR_Beg_date2_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(SYR_Beg_date2.Text))
            {
                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                ParentPage.SetFocus(SYR_Beg_date2);
                return;
            }
        }

        private void SYR_End_date2_LostFocus(object sender, RoutedEventArgs e)
        {
            if (SYR_End_date2.Text.Trim() == "99999999")
            {
                SYR_End_date2.Text = "99991231";
                return;
            }
            if (SYRZJHM2.Text.Trim() == "" && (SYR_Beg_date2.Text.Trim() != "" || SYR_End_date2.Text.Trim() != ""))
            {
                ParentPage.TradeAPIs.ShowTip("证件号码为空时，有效期必须为空");
                ParentPage.SetFocus(SYR_Beg_date2);
                return;
            }
            if (SYRZJHM2.Text.Trim() != "")
            {
                if (SYR_Beg_date2.Text.Trim() != "" && SYR_End_date2.Text.Trim() != "")
                {
                    if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(SYR_End_date2.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                        ParentPage.SetFocus(SYR_End_date2);
                        return;
                    }
                    if (ParentPage.Atoi(SYR_End_date2.Text) < ParentPage.Atoi(SYR_Beg_date2.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                        ParentPage.SetFocus(SYR_End_date2);
                        return;
                    }
                }
                else if ((SYR_End_date2.Text.Trim() == "" && SYR_Beg_date2.Text.Trim() != "") || (SYR_End_date2.Text.Trim() != "" && SYR_Beg_date2.Text.Trim() == ""))
                {
                    ParentPage.TradeAPIs.ShowTip("请输入完整的有效期");
                    ParentPage.SetFocus(SYR_End_date2);
                    return;
                }
            }
        }

        private void SYR_Beg_date3_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(SYR_Beg_date3.Text))
            {
                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                ParentPage.SetFocus(SYR_Beg_date3);
                return;
            }
        }

        private void SYR_End_date3_LostFocus(object sender, RoutedEventArgs e)
        {
            if (SYR_End_date3.Text.Trim() == "99999999")
            {
                SYR_End_date3.Text = "99991231";
                return;
            }
            if (SYRZJHM3.Text.Trim() == "" && (SYR_Beg_date3.Text.Trim() != "" || SYR_End_date3.Text.Trim() != ""))
            {
                ParentPage.TradeAPIs.ShowTip("证件号码为空时，有效期必须为空");
                ParentPage.SetFocus(SYR_Beg_date3);
                return;
            }
            if (SYRZJHM3.Text.Trim() != "")
            {
                if (SYR_Beg_date3.Text.Trim() != "" && SYR_End_date3.Text.Trim() != "")
                {
                    if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(SYR_End_date3.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                        ParentPage.SetFocus(SYR_End_date3);
                        return;
                    }
                    if (ParentPage.Atoi(SYR_End_date3.Text) < ParentPage.Atoi(SYR_Beg_date3.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                        ParentPage.SetFocus(SYR_End_date3);
                        return;
                    }
                }
                else if ((SYR_End_date3.Text.Trim() == "" && SYR_Beg_date3.Text.Trim() != "") || (SYR_End_date3.Text.Trim() != "" && SYR_Beg_date3.Text.Trim() == ""))
                {
                    ParentPage.TradeAPIs.ShowTip("请输入完整的有效期");
                    ParentPage.SetFocus(SYR_End_date3);
                    return;
                }
            }
        }

        private void SYR_Beg_date4_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(SYR_Beg_date4.Text))
            {
                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                ParentPage.SetFocus(SYR_Beg_date4);
                return;
            }
        }

        private void SYR_End_date4_LostFocus(object sender, RoutedEventArgs e)
        {
            if (SYR_End_date4.Text.Trim() == "99999999")
            {
                SYR_End_date4.Text = "99991231";
                return;
            }
            if (SYRZJHM4.Text.Trim() == "" && (SYR_Beg_date4.Text.Trim() != "" || SYR_End_date4.Text.Trim() != ""))
            {
                ParentPage.TradeAPIs.ShowTip("证件号码为空时，有效期必须为空");
                ParentPage.SetFocus(SYR_Beg_date4);
                return;
            }
            if (SYRZJHM4.Text.Trim() != "")
            {
                if (SYR_Beg_date4.Text.Trim() != "" && SYR_End_date4.Text.Trim() != "")
                {
                    if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(SYR_End_date4.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                        ParentPage.SetFocus(SYR_End_date4);
                        return;
                    }
                    if (ParentPage.Atoi(SYR_End_date4.Text) < ParentPage.Atoi(SYR_Beg_date4.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                        ParentPage.SetFocus(SYR_End_date4);
                        return;
                    }
                }
                else if ((SYR_End_date4.Text.Trim() == "" && SYR_Beg_date4.Text.Trim() != "") || (SYR_End_date4.Text.Trim() != "" && SYR_Beg_date4.Text.Trim() == ""))
                {
                    ParentPage.TradeAPIs.ShowTip("请输入完整的有效期");
                    ParentPage.SetFocus(SYR_End_date4);
                    return;
                }
            }
        }

        private void Beg_date8_LostFocus(object sender, RoutedEventArgs e)
        {
            if (Beg_date8.Text.Trim() != "")
            {
                if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(Beg_date8.Text))
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                    ParentPage.SetFocus(Beg_date8);
                    return;
                }
            }
        }

        private void End_date8_LostFocus(object sender, RoutedEventArgs e)
        {

            if (End_date8.Text == "" || End_date7.Text == "99999999")
            {
                End_date8.Text = "99991231";
            }
            if (ZJHM7.Text.Trim() != "")
            {
                if (End_date8.Text.Trim() != "" && End_date8.Text.Trim() != "")
                {
                    if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(End_date8.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                        ParentPage.SetFocus(End_date8);
                        return;
                    }
                    if (ParentPage.Atoi(End_date8.Text) < ParentPage.Atoi(Beg_date8.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                        //ParentPage.SetFocus(                //End_date);
                        ParentPage.SetFocus(End_date8);
                        return;
                    }
                }
                else if (End_date8.Text.Trim() == "" || Beg_date8.Text.Trim() == "")
                {
                    ParentPage.TradeAPIs.ShowTip("请输入有效期");
                    ParentPage.SetFocus(Beg_date8);
                    return;
                }
            }
        }

        private void SYRZJLX1_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!ParentPage.SetInputOfIdCard(SYRZJHM1, (SYRZJLX1.GetSelectedValue() == "1")))
            {
                ParentPage.SetFocus(SYRZJLX1);
                return;
            }
            else
            {
                ParentPage.SetInputOfIdCard(SYRZJHM1, (SYRZJLX1.GetSelectedValue() == "1"));
            }
            if (SYRZJLX1.GetSelectedKey().Contains("身份证"))
                DeviceManager.SetIdentityCardReader(SYRZJHM1, IdentityCardReaderType.ReadCardOrInput);
            else
                DeviceManager.SetIdentityCardReader(SYRZJHM1, IdentityCardReaderType.Input);
        }

        private void SYRZJHM1_LostFocus(object sender, RoutedEventArgs e)
        {
            //新增加将证件号码字母自动转为大写
            string id_no = SYRZJHM1.Text.Trim().ToUpper();
            SYRZJHM1.Text = id_no;

            //初始化控件
            SYRXM1.IsReadOnly = false;

            if (SYRZJHM1.Text.Trim() != "")
            {
                if (SYRZJLX1.GetSelectedValue() == "1")
                {
                    var IdData = DeviceManager.GetIdentityCardData(SYRZJHM1);
                    if (IdData.Data.IdNumber != null)
                    {
                        SYRZJHM1.Text = IdData.Data.IdNumber;
                    }
                    if (IdData.Data.Name != null)
                    {
                        SYRXM1.Text = IdData.Data.Name;
                    }
                    //检查长度，务必保证18位
                    if (ParentPage.Len(SYRZJHM1.Text) != 18)
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N003));
                        ParentPage.SetFocus(SYRZJHM1);
                        return;
                    }
                    //调用sp8015.c对输入身份证进行验证080315
                    var output = ParentPage.TradeAPIs.TF_Deposit_IDNumberVerification(new IDNumberVerification.Input
                    {
                        ZJLX = "1",
                        ZJHM = SYRZJHM1.Text
                    });
                    if (output.IsFailed)
                    {
                        ParentPage.TradeAPIs.ShowTip(output.FailureCause);
                        ParentPage.SetFocus(SYRZJHM1);
                        return;
                    }
                    if (output.YZTGBZ[0] != '1')
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
                        ParentPage.SetFocus(SYRZJHM1);
                        return;
                    }
                    SYRZJHM1.Text = ParentPage.TradeAPIs.Delspace(output.ZJHM);
                    if (TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("Is_CheckDQSBlackList") == "true" && !string.IsNullOrEmpty(SYRZJHM1.Text))//校验黑名单
                    {
                        //调用8854接口校验灰名单
                        var blacklist = ParentPage.TradeAPIs.TF_Deposit_CheckBlackList(new CheckBlackList.Input()
                        {
                            CXLX = "2",
                            ZJLX = SYRZJLX1.GetSelectedValue(),
                            ZJHM = SYRZJHM1.Text,
                            SFHNKHBCBZ = "6255"
                        });
                        if (blacklist.IsFailed)
                        {
                            ParentPage.TradeAPIs.ShowWarnMessageBox(blacklist.FailureCause);
                            ParentPage.SetFocus();
                            return;
                        }
                        //不涉及到账务转出的：全渠道
                        if (blacklist.allrestrict > 0)
                        {
                            ParentPage.TradeAPIs.ShowWarnMessageBox(blacklist.info);
                            ParentPage.SetFocus();
                            return;
                        }
                    }
                }
                if ((FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") || FLAG == "V8")//阳光出资比例、出资金额不为空
                {
                    Page.TradeAPIs.SetAssertNotEmpty(tb_CZBL1, true);
                    Page.TradeAPIs.SetAssertNotEmpty(tb_CZJE1, true);
                    Page.TradeAPIs.SetAssertNotEmpty(SYR_Beg_date1, true);
                    Page.TradeAPIs.SetAssertNotEmpty(SYR_End_date1, true);
                }
            }
        }

        private void SYRZJLX2_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!ParentPage.SetInputOfIdCard(SYRZJHM2, (SYRZJLX2.GetSelectedValue() == "1")))
            {
                ParentPage.SetFocus(SYRZJLX2);
                return;
            }
            else
            {
                ParentPage.SetInputOfIdCard(SYRZJHM2, (SYRZJLX2.GetSelectedValue() == "1"));
            }
            if (SYRZJLX2.GetSelectedKey().Contains("身份证"))
                DeviceManager.SetIdentityCardReader(SYRZJHM2, IdentityCardReaderType.ReadCardOrInput);
            else
                DeviceManager.SetIdentityCardReader(SYRZJHM2, IdentityCardReaderType.Input);
        }

        private void SYRZJHM2_LostFocus(object sender, RoutedEventArgs e)
        {
            //新增加将证件号码字母自动转为大写
            string id_no = SYRZJHM2.Text.Trim().ToUpper();
            SYRZJHM2.Text = id_no;

            //初始化控件
            SYRXM2.IsReadOnly = false;

            if (SYRZJHM2.Text.Trim() != "")
            {
                if (SYRZJLX2.GetSelectedValue() == "1")
                {
                    var IdData = DeviceManager.GetIdentityCardData(SYRZJHM2);
                    if (IdData.Data.IdNumber != null)
                    {
                        SYRZJHM2.Text = IdData.Data.IdNumber;
                    }
                    if (IdData.Data.Name != null)
                    {
                        SYRXM2.Text = IdData.Data.Name;
                    }
                    //检查长度，务必保证18位
                    if (ParentPage.Len(SYRZJHM2.Text) != 18)
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N003));
                        ParentPage.SetFocus(SYRZJHM2);
                        return;
                    }
                    //调用sp8015.c对输入身份证进行验证080315
                    var output = ParentPage.TradeAPIs.TF_Deposit_IDNumberVerification(new IDNumberVerification.Input
                    {
                        ZJLX = "1",
                        ZJHM = SYRZJHM2.Text
                    });
                    if (output.IsFailed)
                    {
                        ParentPage.TradeAPIs.ShowTip(output.FailureCause);
                        ParentPage.SetFocus(SYRZJHM2);
                        return;
                    }
                    if (output.YZTGBZ[0] != '1')
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
                        ParentPage.SetFocus(SYRZJHM2);
                        return;
                    }
                    SYRZJHM2.Text = ParentPage.TradeAPIs.Delspace(output.ZJHM);
                }
                if (TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("Is_CheckDQSBlackList") == "true")//校验黑名单
                {
                    //调用8854接口校验灰名单
                    var blacklist = ParentPage.TradeAPIs.TF_Deposit_CheckBlackList(new CheckBlackList.Input()
                    {
                        CXLX = "2",
                        ZJLX = SYRZJLX2.GetSelectedValue(),
                        ZJHM = SYRZJHM2.Text,
                        SFHNKHBCBZ = "6255"
                    });
                    if (blacklist.IsFailed)
                    {
                        ParentPage.TradeAPIs.ShowWarnMessageBox(blacklist.FailureCause);
                        ParentPage.SetFocus();
                        return;
                    }
                    //不涉及到账务转出的：全渠道
                    if (blacklist.allrestrict > 0)
                    {
                        ParentPage.TradeAPIs.ShowWarnMessageBox(blacklist.info);
                        ParentPage.SetFocus();
                        return;
                    }
                }
                if ((FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") || FLAG == "V8")//阳光出资比例、出资金额不为空
                {
                    Page.TradeAPIs.SetAssertNotEmpty(tb_CZBL2, true);
                    Page.TradeAPIs.SetAssertNotEmpty(tb_CZJE2, true);
                    Page.TradeAPIs.SetAssertNotEmpty(SYR_Beg_date2, true);
                    Page.TradeAPIs.SetAssertNotEmpty(SYR_End_date2, true);
                }
            }
        }

        private void SYRZJLX3_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!ParentPage.SetInputOfIdCard(SYRZJHM3, (SYRZJLX3.GetSelectedValue() == "1")))
            {
                ParentPage.SetFocus(SYRZJLX3);
                return;
            }
            else
            {
                ParentPage.SetInputOfIdCard(SYRZJHM3, (SYRZJLX3.GetSelectedValue() == "1"));
            }
            if (SYRZJLX2.GetSelectedKey().Contains("身份证"))
                DeviceManager.SetIdentityCardReader(SYRZJHM3, IdentityCardReaderType.ReadCardOrInput);
            else
                DeviceManager.SetIdentityCardReader(SYRZJHM3, IdentityCardReaderType.Input);
        }

        private void SYRZJHM3_LostFocus(object sender, RoutedEventArgs e)
        {
            //新增加将证件号码字母自动转为大写
            string id_no = SYRZJHM3.Text.Trim().ToUpper();
            SYRZJHM3.Text = id_no;

            //初始化控件
            SYRXM3.IsReadOnly = false;

            if (SYRZJHM3.Text.Trim() != "")
            {
                if (SYRZJLX3.GetSelectedValue() == "1")
                {
                    var IdData = DeviceManager.GetIdentityCardData(SYRZJHM3);
                    if (IdData.Data.IdNumber != null)
                    {
                        SYRZJHM3.Text = IdData.Data.IdNumber;
                    }
                    if (IdData.Data.Name != null)
                    {
                        SYRXM3.Text = IdData.Data.Name;
                    }
                    //检查长度，务必保证18位
                    if (ParentPage.Len(SYRZJHM3.Text) != 18)
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N003));
                        ParentPage.SetFocus(SYRZJHM3);
                        return;
                    }
                    //调用sp8015.c对输入身份证进行验证080315
                    var output = ParentPage.TradeAPIs.TF_Deposit_IDNumberVerification(new IDNumberVerification.Input
                    {
                        ZJLX = "1",
                        ZJHM = SYRZJHM3.Text
                    });
                    if (output.IsFailed)
                    {
                        ParentPage.TradeAPIs.ShowTip(output.FailureCause);
                        ParentPage.SetFocus(SYRZJHM3);
                        return;
                    }
                    if (output.YZTGBZ[0] != '1')
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
                        ParentPage.SetFocus(SYRZJHM3);
                        return;
                    }
                    SYRZJHM3.Text = ParentPage.TradeAPIs.Delspace(output.ZJHM);
                }
                if (TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("Is_CheckDQSBlackList") == "true")//校验黑名单
                {
                    //调用8854接口校验灰名单
                    var blacklist = ParentPage.TradeAPIs.TF_Deposit_CheckBlackList(new CheckBlackList.Input()
                    {
                        CXLX = "2",
                        ZJLX = SYRZJLX3.GetSelectedValue(),
                        ZJHM = SYRZJHM3.Text,
                        SFHNKHBCBZ = "6255"
                    });
                    if (blacklist.IsFailed)
                    {
                        ParentPage.TradeAPIs.ShowWarnMessageBox(blacklist.FailureCause);
                        ParentPage.SetFocus();
                        return;
                    }
                    //不涉及到账务转出的：全渠道
                    if (blacklist.allrestrict > 0)
                    {
                        ParentPage.TradeAPIs.ShowWarnMessageBox(blacklist.info);
                        ParentPage.SetFocus();
                        return;
                    }
                }
                if ((FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") || FLAG == "V8")//阳光出资比例、出资金额不为空
                {
                    Page.TradeAPIs.SetAssertNotEmpty(tb_CZBL3, true);
                    Page.TradeAPIs.SetAssertNotEmpty(tb_CZJE3, true);
                    Page.TradeAPIs.SetAssertNotEmpty(SYR_Beg_date3, true);
                    Page.TradeAPIs.SetAssertNotEmpty(SYR_End_date3, true);
                }
            }
        }

        private void SYRZJLX4_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!ParentPage.SetInputOfIdCard(SYRZJHM4, (SYRZJLX4.GetSelectedValue() == "1")))
            {
                ParentPage.SetFocus(SYRZJLX4);
                return;
            }
            else
            {
                ParentPage.SetInputOfIdCard(SYRZJHM4, (SYRZJLX4.GetSelectedValue() == "1"));
            }
            if (SYRZJLX4.GetSelectedKey().Contains("身份证"))
                DeviceManager.SetIdentityCardReader(SYRZJHM4, IdentityCardReaderType.ReadCardOrInput);
            else
                DeviceManager.SetIdentityCardReader(SYRZJHM4, IdentityCardReaderType.Input);
        }
        private void SYRXM1_LostFocus(object sender, RoutedEventArgs e)
        {
            if (FLAG == "V19")
            {
                if (string.IsNullOrEmpty(SYRXM1.Text))
                {
                    SYRZJHM1.Text = SYR_Beg_date1.Text = SYR_End_date1.Text = SYRZJDZ1.Text = tb_CZBL1.Text = tb_CZJE1.Text = string.Empty;
                    SYRXM2.Text = SYRZJHM2.Text = SYR_Beg_date2.Text = SYR_End_date2.Text = SYRZJDZ2.Text = tb_CZBL2.Text = tb_CZJE2.Text = string.Empty;
                    SYRXM3.Text = SYRZJHM3.Text = SYR_Beg_date3.Text = SYR_End_date3.Text = SYRZJDZ3.Text = tb_CZBL3.Text = tb_CZJE3.Text = string.Empty;
                    SYRXM4.Text = SYRZJHM4.Text = SYR_Beg_date4.Text = SYR_End_date4.Text = SYRZJDZ4.Text = tb_CZBL4.Text = tb_CZJE4.Text = string.Empty;
                    SYRXX2.Visibility = SYRXX3.Visibility = SYRXX4.Visibility = Visibility.Collapsed;
                    FocusManagerExt.SetAssertNotEmpty(SYRZJHM1, false);
                    FocusManagerExt.SetAssertNotEmpty(SYR_Beg_date1, false);
                    FocusManagerExt.SetAssertNotEmpty(SYR_End_date1, false);
                    FocusManagerExt.SetAssertNotEmpty(SYRZJDZ1, false);
                }
                else 
                {
                    FocusManagerExt.SetAssertNotEmpty(SYRZJHM1, true);
                    FocusManagerExt.SetAssertNotEmpty(SYR_Beg_date1, true);
                    FocusManagerExt.SetAssertNotEmpty(SYR_End_date1, true);
                    FocusManagerExt.SetAssertNotEmpty(SYRZJDZ1, true);
                    SYRXX2.Visibility = Visibility.Visible;
                    
                }
                
            }
        }
        private void SYRXM2_LostFocus(object sender, RoutedEventArgs e)
        {
            if (FLAG == "V19")
            {
                if (string.IsNullOrEmpty(SYRXM2.Text))
                {
                    SYRZJHM2.Text = SYR_Beg_date2.Text = SYR_End_date2.Text = SYRZJDZ2.Text = tb_CZBL2.Text = tb_CZJE2.Text = string.Empty;
                    SYRXM3.Text = SYRZJHM3.Text = SYR_Beg_date3.Text = SYR_End_date3.Text = SYRZJDZ3.Text = tb_CZBL3.Text = tb_CZJE3.Text = string.Empty;
                    SYRXM4.Text = SYRZJHM4.Text = SYR_Beg_date4.Text = SYR_End_date4.Text = SYRZJDZ4.Text = tb_CZBL4.Text = tb_CZJE4.Text = string.Empty;
                    SYRXX3.Visibility = SYRXX4.Visibility = Visibility.Collapsed;
                    FocusManagerExt.SetAssertNotEmpty(SYRZJHM2, false);
                    FocusManagerExt.SetAssertNotEmpty(SYR_Beg_date2, false);
                    FocusManagerExt.SetAssertNotEmpty(SYR_End_date2, false);
                    FocusManagerExt.SetAssertNotEmpty(SYRZJDZ2, false);
                }
                else 
                {
                    FocusManagerExt.SetAssertNotEmpty(SYRZJHM2, true);
                    FocusManagerExt.SetAssertNotEmpty(SYR_Beg_date2, true);
                    FocusManagerExt.SetAssertNotEmpty(SYR_End_date2, true);
                    FocusManagerExt.SetAssertNotEmpty(SYRZJDZ2, true);
                    SYRXX3.Visibility = Visibility.Visible; 
                }
                
            }
        }
        private void SYRXM3_LostFocus(object sender, RoutedEventArgs e)
        {
            if (FLAG == "V19")
            {
                if (string.IsNullOrEmpty(SYRXM3.Text))
                {
                    SYRZJHM3.Text = SYR_Beg_date3.Text = SYR_End_date3.Text = SYRZJDZ3.Text = tb_CZBL3.Text = tb_CZJE3.Text = string.Empty;
                    SYRXM4.Text = SYRZJHM4.Text = SYR_Beg_date4.Text = SYR_End_date4.Text = SYRZJDZ4.Text = tb_CZBL4.Text = tb_CZJE4.Text = string.Empty;
                    SYRXX4.Visibility = Visibility.Collapsed;
                    FocusManagerExt.SetAssertNotEmpty(SYRZJHM3, false);
                    FocusManagerExt.SetAssertNotEmpty(SYR_Beg_date3, false);
                    FocusManagerExt.SetAssertNotEmpty(SYR_End_date3, false);
                    FocusManagerExt.SetAssertNotEmpty(SYRZJDZ3, false);
                }
                else 
                {
                    FocusManagerExt.SetAssertNotEmpty(SYRZJHM3, true);
                    FocusManagerExt.SetAssertNotEmpty(SYR_Beg_date3, true);
                    FocusManagerExt.SetAssertNotEmpty(SYR_End_date3, true);
                    FocusManagerExt.SetAssertNotEmpty(SYRZJDZ3, true);
                    SYRXX4.Visibility = Visibility.Visible;
                }
                
            }
        }
        private void SYRXM4_LostFocus(object sender, RoutedEventArgs e)
        {
            if (FLAG == "V19")
            {
                if (string.IsNullOrEmpty(SYRXM4.Text))
                {
                    SYRZJHM4.Text = SYR_Beg_date4.Text = SYR_End_date4.Text = SYRZJDZ4.Text = tb_CZBL4.Text = tb_CZJE4.Text = string.Empty;
                    FocusManagerExt.SetAssertNotEmpty(SYRZJHM4, false);
                    FocusManagerExt.SetAssertNotEmpty(SYR_Beg_date4, false);
                    FocusManagerExt.SetAssertNotEmpty(SYR_End_date4, false);
                    FocusManagerExt.SetAssertNotEmpty(SYRZJDZ4, false);
                }
                else
                {
                    FocusManagerExt.SetAssertNotEmpty(SYRZJHM4, true);
                    FocusManagerExt.SetAssertNotEmpty(SYR_Beg_date4, true);
                    FocusManagerExt.SetAssertNotEmpty(SYR_End_date4, true);
                    FocusManagerExt.SetAssertNotEmpty(SYRZJDZ4, true);                
                }
                
            }
        }
        private void SYRZJHM4_LostFocus(object sender, RoutedEventArgs e)
        {
            //新增加将证件号码字母自动转为大写
            string id_no = SYRZJHM4.Text.Trim().ToUpper();
            SYRZJHM4.Text = id_no;

            //初始化控件
            SYRXM4.IsReadOnly = false;

            if (SYRZJHM4.Text.Trim() != "")
            {
                if (SYRZJLX3.GetSelectedValue() == "1")
                {
                    var IdData = DeviceManager.GetIdentityCardData(SYRZJHM4);
                    if (IdData.Data.IdNumber != null)
                    {
                        SYRZJHM4.Text = IdData.Data.IdNumber;
                    }
                    if (IdData.Data.Name != null)
                    {
                        SYRXM4.Text = IdData.Data.Name;
                    }
                    //检查长度，务必保证18位
                    if (ParentPage.Len(SYRZJHM4.Text) != 18)
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N003));
                        ParentPage.SetFocus(SYRZJHM4);
                        return;
                    }
                    //调用sp8015.c对输入身份证进行验证080315
                    var output = ParentPage.TradeAPIs.TF_Deposit_IDNumberVerification(new IDNumberVerification.Input
                    {
                        ZJLX = "1",
                        ZJHM = SYRZJHM4.Text
                    });
                    if (output.IsFailed)
                    {
                        ParentPage.TradeAPIs.ShowTip(output.FailureCause);
                        ParentPage.SetFocus(SYRZJHM4);
                        return;
                    }
                    if (output.YZTGBZ[0] != '1')
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
                        ParentPage.SetFocus(SYRZJHM4);
                        return;
                    }
                    SYRZJHM4.Text = ParentPage.TradeAPIs.Delspace(output.ZJHM);
                }
                if (TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("Is_CheckDQSBlackList") == "true")//校验黑名单
                {
                    //调用8854接口校验灰名单
                    var blacklist = ParentPage.TradeAPIs.TF_Deposit_CheckBlackList(new CheckBlackList.Input()
                    {
                        CXLX = "2",
                        ZJLX = SYRZJLX4.GetSelectedValue(),
                        ZJHM = SYRZJHM4.Text,
                        SFHNKHBCBZ = "6255"
                    });
                    if (blacklist.IsFailed)
                    {
                        ParentPage.TradeAPIs.ShowWarnMessageBox(blacklist.FailureCause);
                        ParentPage.SetFocus();
                        return;
                    }
                    //不涉及到账务转出的：全渠道
                    if (blacklist.allrestrict > 0)
                    {
                        ParentPage.TradeAPIs.ShowWarnMessageBox(blacklist.info);
                        ParentPage.SetFocus();
                        return;
                    }
                }
                if ((FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") || FLAG == "V8")//阳光出资比例、出资金额不为空
                {
                    Page.TradeAPIs.SetAssertNotEmpty(tb_CZBL4, true);
                    Page.TradeAPIs.SetAssertNotEmpty(tb_CZJE4, true);
                    Page.TradeAPIs.SetAssertNotEmpty(SYR_Beg_date4, true);
                    Page.TradeAPIs.SetAssertNotEmpty(SYR_End_date4, true);
                }
            }
        }
        #region 证件号正确性检查 经与毛成龙协商，此功能只给辰州
        /// <summary>
        /// 组织机构代码 校验
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void CheckOrganizationCode(string Code)
        {
            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            if (FLAG == "V9")
            {
                int[] w_i = new int[8] { 3, 7, 9, 10, 5, 8, 4, 2 };
                int[] c_i = new int[8];
                char c;
                char value;
                int s = 0;
                Code = Code.ToUpper();
                if (Code.Length != 10)
                {
                    ParentPage.TradeAPIs.ShowTip("组织机构代码证件必须为10位，请检查！");
                    ParentPage.SetFocus();
                    return;
                }
                if (Code == "00000000-0" || Code.Substring(8, 1) != "-")
                {
                    ParentPage.TradeAPIs.ShowTip("组织机构代码错误，请检查！");
                    ParentPage.SetFocus();
                    return;
                }
                for (int i = 0; i < 10; i++)
                {
                    c = char.Parse(Code.Substring(i, 1));
                    if (c <= 'z' && c >= 'a')
                    {
                        ParentPage.TradeAPIs.ShowTip("组织机构代码错误，请检查！");
                        ParentPage.SetFocus();
                        return;
                    }
                }
                for (int i = 0; i < 8; i++)
                {
                    value = char.Parse(Code.Substring(i, 1));
                    if (value >= char.Parse("A") && value <= char.Parse("Z"))
                    {
                        c_i[i] = value + 32 - 87;
                    }
                    else
                    {
                        if (value >= char.Parse("0") && value <= char.Parse("9"))
                        {
                            c_i[i] = value - char.Parse("0");
                        }
                        else
                        {
                            ParentPage.TradeAPIs.ShowTip("组织机构代码错误，请检查！");
                            ParentPage.SetFocus();
                            return;
                        }
                    }
                    s = s + w_i[i] * c_i[i];
                }
                int c9 = 11 - (s % 11);
                if (!((Code.Substring(9, 1) == "X" && c9 == 10) || ((Code.Substring(9, 1) == "0") || c9 == 11)
                    || (c9 == char.Parse(Code.Substring(9, 1)) - char.Parse("0"))))
                {
                    ParentPage.TradeAPIs.ShowTip("组织机构代码错误，请检查！");
                    ParentPage.SetFocus();
                    return;
                }
            }
        }

        /// <summary>
        /// 营业执照号码 校验
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void CheckBusinessCode(string Code)
        {
            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            //if (FLAG == "V9")
            //{
            //    int[] a = new int[15];
            //    int[] s = new int[16];
            //    int[] p = new int[16];
            //    int m = 10;
            //    p[0] = m;
            //    if (Code.Length != 15)
            //    {
            //        ParentPage.TradeAPIs.ShowTip("营业执照必须为15位，请检查！");
            //        ParentPage.SetFocus();
            //        return;
            //    }
            //    Regex r = new Regex("^[0-9]*$");
            //    if (!r.IsMatch(Code))
            //    {
            //        ParentPage.TradeAPIs.ShowTip("营业执照号码含有错误字符！");
            //        ParentPage.SetFocus();
            //        return;
            //    }
            //    for (int i = 0; i < Code.Length; i++)
            //    {
            //        a[i] = Convert.ToInt32(Code.Substring(i, 1));
            //        s[i] = (p[i] % (m + 1)) + a[i];
            //        if (0 == s[i] % m)
            //        {
            //            p[i + 1] = 10 * 2;
            //        }
            //        else
            //        {
            //            p[i + 1] = (s[i] % m) * 2;
            //        }
            //    }
            //    if (1 != (s[14] % m))
            //    {
            //        ParentPage.TradeAPIs.ShowTip("营业执照证件有误，请检查！");
            //        ParentPage.SetFocus();
            //        return;
            //    }
            //}
        }

        /// <summary>
        /// 统一社会信用代码 校验
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void CheckUniformSocialCode(string Code)
        {
            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            if (FLAG == "V9")
            {
                if (Code.Length != 18)
                {
                    ParentPage.TradeAPIs.ShowTip("社会信用代码必须为18位，请检查！");
                    ParentPage.SetFocus();
                    return;
                }
                Regex r = new Regex("^([0-9ABCDEFGHJKLMNPQRTUWXY]{2})([0-9]{6})([0-9ABCDEFGHJKLMNPQRTUWXY]{9})([0-9ABCDEFGHJKLMNPQRTUWXY])$");
                if (!r.IsMatch(Code))
                {
                    ParentPage.TradeAPIs.ShowTip("社会信用代码含有错误字符，请检查！");
                    ParentPage.SetFocus();
                    return;
                }
                string str = "0123456789ABCDEFGHJKLMNPQRTUWXY";
                int[] ws = new int[] { 1, 3, 9, 27, 19, 26, 16, 17, 20, 29, 25, 13, 8, 24, 10, 30, 28 };
                string[] codes = new string[18];
                codes[0] = Code.Substring(0, Code.Length - 1);
                codes[1] = Code.Substring(Code.Length - 1, 1);
                int sum = 0;
                for (int i = 0; i < 17; i++)
                {
                    sum += str.IndexOf(codes[0].ToString().Substring(i, 1)) * ws[i];
                }
                int c18 = 31 - (sum % 31);
                string s18 = c18.ToString();
                switch (c18)
                {
                    case 10: s18 = "A"; break;
                    case 11: s18 = "B"; break;
                    case 12: s18 = "C"; break;
                    case 13: s18 = "D"; break;
                    case 14: s18 = "E"; break;
                    case 15: s18 = "F"; break;
                    case 16: s18 = "G"; break;
                    case 17: s18 = "H"; break;
                    case 18: s18 = "J"; break;
                    case 19: s18 = "K"; break;
                    case 20: s18 = "L"; break;
                    case 21: s18 = "M"; break;
                    case 22: s18 = "N"; break;
                    case 23: s18 = "P"; break;
                    case 24: s18 = "Q"; break;
                    case 25: s18 = "R"; break;
                    case 26: s18 = "T"; break;
                    case 27: s18 = "U"; break;
                    case 28: s18 = "W"; break;
                    case 29: s18 = "X"; break;
                    case 30: s18 = "Y"; break;
                    case 31: s18 = "0"; break;
                }
                if (s18 != codes[1])
                {
                    ParentPage.TradeAPIs.ShowTip("统一社会信用代码有误，请检查！");
                    ParentPage.SetFocus();
                    return;
                }
            }
        }
        #endregion

        private void cb_dwgs_LostFocus(object sender, RoutedEventArgs e)
        {
            if (cb_dwgs.GetSelectedValue() == "Y")
            {
                //     cb_ssbt.SetItems(new Dictionary<string, string> { { "兵团直属|第一师", "01" }, { "兵团直属|第二师", "02" }, { "兵团直属|第三师", "03" }, { "兵团直属|第四师", "04" },
                // { "兵团直属|第五师", "05" }, { "兵团直属|第六师", "06" }, { "兵团直属|第七师", "07" }, { "兵团直属|第八师", "08" }, { "兵团直属|第九师", "09" },
                //{ "兵团直属|第十师", "10" }, { "兵团直属|第十一师", "11" }, { "兵团直属|第十二师", "12" }, { "兵团直属|第十三师", "13" }, { "兵团直属|第十四师", "14" }});
                Page.TradeAPIs.CallComboBoxData(cb_ssbt, "BTSB");
                tb_ssbt.Visibility = cb_ssbt.Visibility = tb_btbz.Visibility = tb_BTBE.Visibility = Visibility.Visible;
            }
            else
            {
                tb_ssbt.Visibility = cb_ssbt.Visibility = tb_btbz.Visibility = tb_BTBE.Visibility = Visibility.Collapsed;
                if (IsUpdate)
                {
                    cb_ssbt.SetItems(new Dictionary<string, string> { { " ", " " } });
                    tb_BTBE.Text = " ";
                }
                else
                {
                    cb_ssbt.SetItems(new Dictionary<string, string> { { "", "" } });
                    tb_BTBE.Text = "";
                }
            }
        }

        private void Sel_flag_LostFocus(object sender, RoutedEventArgs e)
        {
            FocusManagerExt.SetAssertNotEmpty(AGENT_ID_NO, true);
            FocusManagerExt.SetAssertNotEmpty(AGENT_NAME, true);
            FocusManagerExt.SetAssertNotEmpty(AGENT_Beg_date, true);
            FocusManagerExt.SetAssertNotEmpty(AGENT_End_date, true);
            FocusManagerExt.SetAssertNotEmpty(AGENT_PHONE, true);
            if (Sel_flag.GetSelectedValue() == "Y")
            {
                DLRXX.Height = 240;
                tb_AGENT_ID_TYPE.Visibility = AGENT_ID_TYPE.Visibility = tb_AGENT_ID_NO.Visibility = AGENT_ID_NO.Visibility = tb_AGENT_NAME.Visibility = AGENT_NAME.Visibility = yxq5.Visibility = AGENT_Sdate.Visibility = tb_AGENT_PHONE.Visibility = AGENT_PHONE.Visibility =
                    tb_FZJG2.Visibility = FZJG2.Visibility = tb_HCJG2.Visibility = HCJG2.Visibility = tb_LW_FLG2.Visibility = LW_FLG2.Visibility = tb_ZZZZ2.Visibility = ZZZZ2.Visibility = Visibility.Visible;
            }
            else
            {
                DLRXX.Height = 50;
                tb_AGENT_ID_TYPE.Visibility = AGENT_ID_TYPE.Visibility = tb_AGENT_ID_NO.Visibility = AGENT_ID_NO.Visibility = tb_AGENT_NAME.Visibility = AGENT_NAME.Visibility = yxq5.Visibility = AGENT_Sdate.Visibility = tb_AGENT_PHONE.Visibility = AGENT_PHONE.Visibility =
                    tb_FZJG2.Visibility = FZJG2.Visibility = tb_HCJG2.Visibility = HCJG2.Visibility = tb_LW_FLG2.Visibility = LW_FLG2.Visibility = tb_ZZZZ2.Visibility = ZZZZ2.Visibility = Visibility.Collapsed;
            }
        }

        private void tb_CZBL2_LostFocus(object sender, RoutedEventArgs e)
        {
            if (tb_CZBL1.Text.ToDecimal() + tb_CZBL2.Text.ToDecimal() > 100)
            {
                ParentPage.TradeAPIs.ShowTip("受益人总出资比例不能大于100！");
                ParentPage.SetFocus(tb_CZBL2);
                return;
            }
        }

        private void tb_CZBL3_LostFocus(object sender, RoutedEventArgs e)
        {
            if (tb_CZBL1.Text.ToDecimal() + tb_CZBL2.Text.ToDecimal() + tb_CZBL3.Text.ToDecimal() > 100)
            {
                ParentPage.TradeAPIs.ShowTip("受益人总出资比例不能大于100！");
                ParentPage.SetFocus(tb_CZBL3);
                return;
            }
        }

        private void tb_CZBL4_LostFocus(object sender, RoutedEventArgs e)
        {
            if (tb_CZBL1.Text.ToDecimal() + tb_CZBL2.Text.ToDecimal() + tb_CZBL3.Text.ToDecimal() + tb_CZBL4.Text.ToDecimal() > 100)
            {
                ParentPage.TradeAPIs.ShowTip("受益人总出资比例不能大于100！");
                ParentPage.SetFocus(tb_CZBL4);
                return;
            }
        }
    }

    #region 数据限定
    /// <summary>
    /// 组件数据交互类
    /// </summary>
    public class TBC_ECustomerInfoInput : TBC_ComponentInput
    {
        #region 构造

        #endregion

        #region 控制属性
        /// <summary>
        /// 天山用于是否身份核查标志
        /// </summary>
        public bool isCheckId { get; set; }
        #endregion

        #region 交互方法

        #endregion
    }

    /// <summary>
    /// 组件数据输出类
    /// </summary>
    public class TBC_ECustomerInfoOutput : TBC_ComponentOutput
    {
    }

    #endregion
}
