﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TellerSystem.Contract.ContractBase;
using TellerSystem.Library.Ext.Variables;
using TellerSystem.Communication;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using Platform.Controls.ControlsHelper;
using Platform.Library;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Library.Ext.TradeExtension;
using TellerSystem.Controls.Ext.ControlsHelper;
using Platform.Common.RunningParameters;
using TellerSystem.Devices.Interface;
using TellerSystem.Contract.Function;
using Platform.Presentation.FocusManagers;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;
using TellerSystem.Controls.Ext.ControlsExt;
using TellerSystem.ServiceProxy.Ext;
using System.Text.RegularExpressions;
using System.Data;
using TellerSystem.Communication.MessageHelper;

namespace TellerSystem.Controls.Ext.TradePageComponent
{

    /// <summary>
    /// 代理人业务组件
    /// </summary>
    public partial class TBC_EnterpriseCustomerInfo_NewEcif : TBC_ComponentBase<TBC_ECustomerInfoInput_NewEcif, TBC_ECustomerInfoOutput_NewEcif>
    {
        private EnterpriseCustomerInfoArgs enterpriseCustomerInfoArgs = null;
        Message _msg = new Message();
        int count = 0;
        string zjhm1 = string.Empty;
        string zzjhm = string.Empty;
        /// <summary>
        /// 证件号码 信息交互用
        /// </summary>
        string PrintInfoIDNo = string.Empty;
        #region 属性
        public PageBase ParentPage { get; private set; }
        /// <summary>
        /// 客户类型-企业用户
        /// </summary>
        string CIF_TYPE = "2";

        /// <summary>
        /// 证件信息集合
        /// </summary>
        public List<ZjxxEntity> zjxxList = new List<ZjxxEntity>();

        /// <summary>
        /// 爱好类型:文字显示用
        /// </summary>
        Dictionary<string, string> CMB_ID_TYPES_K = new Dictionary<string, string>();
        private string OP_TYPE = "";

        private string opCode = string.Empty;

        public bool IsUpdate { get; set; }
        public List<object> lxrList { get; set; }

        #region 记录原对公证件类型
        public string OldOrganization = string.Empty;

        public string OldFile = string.Empty;

        public string OldBusinessCard = string.Empty;

        public string OldOther = string.Empty;

        public string OldCreditCard = string.Empty;

        #endregion
        #endregion

        public TBC_EnterpriseCustomerInfo_NewEcif()
        {
            InitializeComponent();

            this.enterpriseCustomerInfoArgs = new EnterpriseCustomerInfoArgs();

            /// <summary>
            /// 公司类型
            /// </summary>
            this.enterpriseCustomerInfoArgs.GSLX = this.QY_TYPE;
            /// <summary>
            /// 客户等级
            /// </summary>
            this.enterpriseCustomerInfoArgs.KHDJ = this.CIF_LVL1;
            /// <summary>
            /// 注册资本
            /// </summary>
            this.enterpriseCustomerInfoArgs.ZCZB = this.ZCZB;
            /// <summary>
            /// 营业收入
            /// </summary>
            this.enterpriseCustomerInfoArgs.YYSR = this.YYSR;
            /// <summary>
            /// 员工数量
            /// </summary>
            this.enterpriseCustomerInfoArgs.YGSL = this.YGSL;
            /// <summary>
            /// 贡 献 度
            /// </summary>
            this.enterpriseCustomerInfoArgs.GXD = this.CIF_CTB1;
            /// <summary>
            /// 证件类型
            /// </summary>
            this.enterpriseCustomerInfoArgs.ZJLX = this.MID_TYPE;
            /// <summary>
            /// 证件号码
            /// </summary>
            this.enterpriseCustomerInfoArgs.ZJHM = this.ZJHM3;
            /// <summary>
            /// 客户名称
            /// </summary>
            this.enterpriseCustomerInfoArgs.KHMC = this.KHXM1;
            ///// <summary>
            ///// 组织机构代码证
            ///// </summary>
            //this.enterpriseCustomerInfoArgs.ZJJGDMZ = this.ZJHM1;
            ///// <summary>
            ///// 组织机构代码证有效期开始
            ///// </summary>
            //this.enterpriseCustomerInfoArgs.YXQKS2 = this.Beg_date1;
            ///// <summary>
            ///// 组织机构代码证有效期结束
            ///// </summary>
            //this.enterpriseCustomerInfoArgs.YXQJS2 = this.End_date1;
            ///// <summary>
            ///// 营业执照
            ///// </summary>
            //this.enterpriseCustomerInfoArgs.YYZZ = this.ZJHM5;
            ///// <summary>
            ///// 营业执照有效期开始
            ///// </summary>
            //this.enterpriseCustomerInfoArgs.YXQKS3 = this.Beg_date5;
            ///// <summary>
            ///// 营业执照有效期结束
            ///// </summary>
            //this.enterpriseCustomerInfoArgs.YXQJS3 = this.End_date5;
            ///// <summary>
            ///// 其他证件号
            ///// </summary>
            //this.enterpriseCustomerInfoArgs.QTZJ = this.ZJHM6;
            ///// <summary>
            ///// 其他证件号有效期开始
            ///// </summary>
            //this.enterpriseCustomerInfoArgs.YXQKS4 = this.Beg_date6;
            ///// <summary>
            ///// 其他证件号有效期结束
            ///// </summary>
            //this.enterpriseCustomerInfoArgs.YXQJS4 = this.End_date6;
            ///// <summary>
            ///// 统一社会信用代码证
            ///// </summary>
            //this.enterpriseCustomerInfoArgs.JGXYDMZ = this.ZJHM7;
            ///// <summary>
            ///// 统一社会信用代码证有效期开始
            ///// </summary>
            //this.enterpriseCustomerInfoArgs.YXQKS5 = this.Beg_date7;
            ///// <summary>
            ///// 统一社会信用代码证有效期结束
            ///// </summary>
            //this.enterpriseCustomerInfoArgs.YXQJS5 = this.End_date7;
            /// <summary>
            /// 国税登记号
            /// </summary>
            this.enterpriseCustomerInfoArgs.GSDJH = this.GSDZH;
            /// <summary>
            /// 地税登记号
            /// </summary>
            this.enterpriseCustomerInfoArgs.DSDJH = this.DSDZH;
            /// <summary>
            /// 企业联系人
            /// </summary>
            this.enterpriseCustomerInfoArgs.QYLXR = this.QY_NAME;
            /// <summary>
            /// 企业联系人电话
            /// </summary>
            this.enterpriseCustomerInfoArgs.LXDH = this.TEL1;
            /// <summary>
            /// 传    真
            /// </summary>
            this.enterpriseCustomerInfoArgs.CZ = this.FAX1;

            /// <summary>
            /// 企业邮编
            /// </summary>
            this.enterpriseCustomerInfoArgs.QYYB = this.QYYB;
            /// <summary>
            /// 行业分类大类
            /// </summary>
            this.enterpriseCustomerInfoArgs.HYFL1 = this.HYFLD;
            /// <summary>
            /// 行业分类小类
            /// </summary>
            this.enterpriseCustomerInfoArgs.HYFL2 = this.HYFL;
            /// <summary>
            /// 国民经济部门
            /// </summary>
            this.enterpriseCustomerInfoArgs.GMJJBM = this.JJBM1;
            /// <summary>
            /// 地    区2
            /// </summary>
            this.enterpriseCustomerInfoArgs.DQ2 = this.diqu2;
            /// <summary>
            /// 出资人经济成分
            /// </summary>
            this.enterpriseCustomerInfoArgs.CZRJJCF = this.JJCF;
            /// <summary>
            /// 企业规模
            /// </summary>
            this.enterpriseCustomerInfoArgs.QYGM = this.QYGM;
            /// <summary>
            /// 公司联系地址
            /// </summary>
            this.enterpriseCustomerInfoArgs.GSLXDZ = this.ADDR1;
            /// <summary>
            /// 法人证件类型
            /// </summary>
            this.enterpriseCustomerInfoArgs.FRZJLX = this.FDDB_ID_TYPE;
            /// <summary>
            /// 法人证件号码
            /// </summary>
            this.enterpriseCustomerInfoArgs.FRZJH = this.FDSF;
            /// <summary>
            /// 法定代表人
            /// </summary>
            this.enterpriseCustomerInfoArgs.FDDBR = this.FDDB;
            /// <summary>
            /// 发证机关-法定代表人
            /// </summary>
            this.enterpriseCustomerInfoArgs.RELA_COUNTRY = this.relNtnty;
            /// <summary>
            /// 核查结果-法定代表人
            /// </summary>
            this.enterpriseCustomerInfoArgs.RELA_VERIFICAION = this.HCJG1;
            /// <summary>
            /// 联网标志-法定代表人
            /// </summary>
            this.enterpriseCustomerInfoArgs.RELA_VERIFICATION_RESULT = this.LW_FLG1;
            /// <summary>
            /// 佐证证件-法定代表人
            /// </summary>
            this.enterpriseCustomerInfoArgs.RELA_PROOF = this.ZZZZ1;
            /// <summary>
            /// 主证件类型
            /// </summary>
            this.enterpriseCustomerInfoArgs.ZZJLX = this.zzj_type;
            /// <summary>
            /// tb主证件类型
            /// </summary>
            this.enterpriseCustomerInfoArgs.tb_zzj_type = this.tb_zzj_type;
        }
        public string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        public void Init_TBC_CustomerInfo()
        {
            if (System.ComponentModel.DesignerProperties.GetIsInDesignMode(this)) return;
            ParentPage = (Platform.Common.BasicFunctions.DependencyObjectExtensions.FindVisualTreeAncestor(this, (x) => { return x is PageBase; })) as PageBase;
            if (ParentPage == null)
                return;
            //对公时，选择的客户等级
            CIF_LVL1.SetItems(UserVariable.GetCustomerLvlComp());
            //Page.TradeAPIs.CallComboBoxData(CIF_LVL1, "C021");
            CIF_LVL1.SelectedIndex = 0;

            CIF_CTB1.SetItems(new Dictionary<string, string> { { "低", "1" }, { "中", "2" }, { "高", "3" } });
            CIF_CTB1.SelectedIndex = 0;
            //FZR_type.SetItems(new Dictionary<string, string> { { "法人", "100" }, { "实际控股股东", "101" }, { "控股股东", "102" }, { "财务人员", "103" }, { "经办人员", "104" }, { "其他人员", "105" }, { "负责人", "106" } });
            //FZR_type.SetItems(new Dictionary<string, string> { { "股东", "01" }, { "上下游关系", "02" }, { "出资组建企业", "03" }, { "亲属关系", "04" }, { "担保关系", "05" }, { "实际控制人", "06" }, { "受同一自然人", "07" }, { "集团成员", "08" }, { "法定代表人", "09" }, { "理事长", "10" }, { "监事长", "11" }, { "总经理", "12" }, { "财务主管", "13" }, { "个人股东", "14" }, { "经办人", "15" }, { "负责人", "16" }, { "其他关联关系", "99" } });
            FZR_type.SetItems(UserVariable.GetFZRType(Page));
            FZR_type.SetSelectedValue("09");


            //核查结果
            //HCJG1.SetItems(UserVariable.GetHcjgType());
            //Page.TradeAPIs.CallComboBoxData(HCJG1, "C031");
            HCJG1.SetItems(new Dictionary<string, string> { { "公民身份号码与姓名一致,且存在照片", "00" }, { "公民身份号码与姓名一致,但不存在照片", "01" }, { "公民身份号码存在，但与姓名不匹配", "02" }, { "公民身份号码不存在", "03" }, { "其他错误", "04" }, { "输入的参数错误", "05" } });
            HCJG1.SelectedIndex = 0;

            //联网标志
            //LW_FLG1.SetItems(UserVariable.GetLwFlgType());
            //Page.TradeAPIs.CallComboBoxData(LW_FLG1, "C032");
            LW_FLG1.SetItems(new Dictionary<string, string> { { "待核实", "01" }, { "真实", "02" }, { "假名", "03" }, { "匿名", "04" }, { "无法核实", "05" } });
            LW_FLG1.SelectedIndex = 0;

            //佐证证件
            ZZZZ1.SetItems(UserVariable.GetZzzzType());
            //Page.TradeAPIs.CallComboBoxData(ZZZZ1, "C033");
            //ZZZZ1.SetItems(new Dictionary<string, string> { { "无", "0" }, { "户口簿", "1" }, { "驾驶证", "2" }, { "公安回执证明", "3" }, { "其他", "4" } });
            ZZZZ1.SelectedIndex = 0;


            //国民经济部门对公
            JJBM1.SetItems(UserVariable.GetJJBMType());
            //Page.TradeAPIs.CallComboBoxData(JJBM1, "C026");
            // JJBM1.SetItems(new Dictionary<string, string> { { "政府部门", "A0000" }, { "中央政府", "A0100" }, { "地方政府", "A0200" }, { "社会保障基金", "A0300" },
            // { "金融机构部门", "B0000" }, { "货币当局", "B0100" }, { "监管当局", "B0200" }, { "银行业存款类金融机构", "B0300" }, { "银行业非存款类金融机构", "B0400" },
            //{ "证券业金融机构", "B0500" }, { "保险业金融机构", "B0600" }, { "交易及结算类金融机构", "B0700" }, { "金融控股公司", "B0800" }, { "特定目的载体", "B0900" },
            //{ "其他", "B9900" },  { "非金融企业部门", "C0000" }, { "公司", "C0100" },{ "非公司企业", "C0200" }, { "其他非金融企业部门", "C9900" }, { "住户部门", "D0000" },
            //{ "住户", "D0100" },{ "为住户服务的非营利机构", "D0200" },{ "非居民部门", "E0000" },{ "国际组织", "E0100" },{ "外国政府", "E0200" },{ "国外金融机构", "E0300" },
            //{ "国外非金融企业", "E0400" },{ "外国居民", "E0500" },{ "未知", "F0900" }});
            JJBM1.SelectedIndex = 0;
            //是否上市公司
            SFSSGS.SetItems(UserVariable.GetSsqybs(Page));
            SFSSGS.SelectedIndex = 0;
            //税收身份
            resIdSts.SetItems(new Dictionary<string, string> { { "中国税收居民", "0" }, { "非居民", "1" }, { "既是中国税收居民又是其他国家税收居民", "2" } });
            resIdSts.SelectedIndex = 0;

            //企业规模QYGM
            QYGM.SetItems(UserVariable.GetQygmType(Page));
            //QYGM.SetItems(new Dictionary<string, string> { { "大型企业", "1" }, { "中型企业", "2" }, { "小型企业", "3" }, { "微型企业", "4" } });
            QYGM.SelectedIndex = 0;

            //经济成分JJCF
            JJCF.SetItems(UserVariable.GetJjcfType());
            //ParentPage.TradeAPIs.CallComboBoxData(JJCF, "C047");
            JJCF.SelectedIndex = 0;

            //经济类型
            JJLX.SetItems(UserVariable.GetJjlxType(Page));
            JJLX.SelectedIndex = 0;

            //控股类型
            KGLX.SetItems(UserVariable.GetKGLXType());
            KGLX.SelectedIndex = 0;
            //是否主证件
            certMainFlag.SetItems(new Dictionary<string, string> { { "是", "Y" }, { "否", "N" } });
            certMainFlag.SelectedIndex = 0;
            //币种
            //ParentPage.TradeAPIs.CallComboBoxData(BZ, "C008");
            BZ.SetItems(new Dictionary<string, string> { { "人民币", "CNY" } });
            //BZ.SelectedIndex = 3;

            //FDDB_ID_TYPE.SetItems(UserVariable.GetPerIdType());
            FDDB_ID_TYPE.SetItems(UserVariable.GetPersonIdType(Page));
            // FDDB_ID_TYPE.SetItems(new Dictionary<string, string>{ { "第一代居民身份证", "100" },{ "第二代居民身份证", "101" }, { "临时身份证", "102" },{ "户口簿", "104" }, 
            // { "护照", "103" }, { "军官证", "107" },{"学生证","106"},
            //  { "士兵证", "113" }, { "港澳通行证", "114" },{ "台湾通行证或有效旅行证件", "116" }, { "外国人永久居留证", "117" },{"外国护照","119"}, { "警官证", "121" },
            //{ "其他对私证件类型", "120" }, { "台湾居民往来大陆通行证", "126" },  { "军官退休证", "109" },
            //{ "文职干部证", "110" },  { "武警身份证", "112" }});
            FDDB_ID_TYPE.SelectedIndex = 0;
            //AGENT_ID_TYPE.SetItems(UserVariable.GetPerIdType());
            // AGENT_ID_TYPE.SetItems(new Dictionary<string, string>{ { "第一代居民身份证", "100" },{ "第二代居民身份证", "101" }, { "临时身份证", "102" },{ "户口簿", "104" }, 
            // { "护照", "103" }, { "军官证", "107" },{"学生证","106"},
            //  { "士兵证", "113" }, { "港澳通行证", "114" },{ "台湾通行证或有效旅行证件", "116" }, { "外国人永久居留证", "117" },{"外国护照","119"}, { "警官证", "121" },
            //{ "其他对私证件类型", "120" }, { "台湾居民往来大陆通行证", "126" },  { "军官退休证", "109" },
            //{ "文职干部证", "110" },  { "武警身份证", "112" }});
            //AGENT_ID_TYPE.SelectedIndex = 1;
            //Page.TradeAPIs.CallComboBoxData(SYRZJLX1, "C004");
            SYRZJLX1.SetItems(UserVariable.GetPersonIdType(Page));
            SYRZJLX1.SelectedIndex = 0;
            // Page.TradeAPIs.CallComboBoxData(SYRZJLX2, "C004");
            SYRZJLX2.SetItems(UserVariable.GetPersonIdType(Page));
            SYRZJLX2.SelectedIndex = 0;
            //  Page.TradeAPIs.CallComboBoxData(SYRZJLX3, "C004");
            SYRZJLX3.SetItems(UserVariable.GetPersonIdType(Page));
            SYRZJLX3.SelectedIndex = 0;
            //  Page.TradeAPIs.CallComboBoxData(SYRZJLX4, "C004");
            SYRZJLX4.SetItems(UserVariable.GetPersonIdType(Page));
            SYRZJLX4.SelectedIndex = 0;

            //HYFLD.SetItems(UserVariable.GetHyflDType());
            HYFLD.SetItems(UserVariable.GetJobTypeOne(Page));
            //HYFLD.SetItems(new Dictionary<string, string> {{"农、林、牧、渔业","A"},{"采矿业","B"},{"制造业","C"},{"电力、热力、燃气及水生产和供应业","D"},{"建筑业","E"},{"批发和零售业","F"},{"交通运输、仓储和邮政业","G"},{"住宿和餐饮业","H"},{"信息传输、软件和信息技术服务业","I"},
            //{"金融业","J"},{"房地产业","K"},{"租赁和商务服务业","L"},{"科学研究和技术服务业","M"},{"水利、环境和公共设施管理业","N"},{"居民服务、修理和其他服务业","O"},{"教育","P"},{"卫生和社会工作","Q"},{"文化、体育和娱乐业","R"},{"公共管理、社会保障和社会组织","S"},{"国际组织","T"},{"其他","U"}});
            HYFLD.SelectedIndex = 0;

            //HYFL.SetItems(UserVariable.GetHyflTypeA());         

            QY_TYPE.SetItems(UserVariable.GetQytype(Page));
            QY_TYPE.SelectedIndex = 0;
            //Page.TradeAPIs.CallComboBoxData(QY_TYPE, "C023");
            QY_TYPE.SelectedIndex = 0;
            // QY_TYPE_YZ.SelectedIndex = 0;

            //国家 blngCtyRgon
            //证件发放国家
            blngCtyRgon.SetItems(UserVariable.GetCountryType(Page));
            blngCtyRgon.SelectedValue = "CHN";
            //法人国籍
            relNtnty.SetItems(new Dictionary<string, string> { { "中国", "CHN" } });

            //MID_TYPE.SetItems(new Dictionary<string, string> { { "组织机构代码证", "201" }, { "营业执照", "211" }, { "文件", "214" }, { "其他证件（对公）", "232" }, { "统一社会信用代码证）", "231" } });
            // Page.TradeAPIs.CallComboBoxData(MID_TYPE, "C003");
            MID_TYPE.SetItems(UserVariable.GetCompanyIdType(Page));
            MID_TYPE.SetSelectedValue("211");

            //设置代理人证件类型
            //AGENT_ID_TYPE.SetItems(UserVariable.GetPerIdType());
            //Page.TradeAPIs.CallComboBoxData(AGENT_ID_TYPE, "C004");
            // AGENT_ID_TYPE.SetItems(new Dictionary<string, string>{ { "第一代居民身份证", "100" },{ "第二代居民身份证", "101" }, { "临时身份证", "102" },{ "户口簿", "104" }, 
            // { "护照", "103" }, { "军官证", "107" },{"学生证","106"},
            //  { "士兵证", "113" }, { "港澳通行证", "114" },{ "台湾通行证或有效旅行证件", "116" }, { "外国人永久居留证", "117" },{"外国护照","119"}, { "警官证", "121" },
            //{ "其他对私证件类型", "120" }, { "台湾居民往来大陆通行证", "126" },  { "军官退休证", "109" },
            //{ "文职干部证", "110" },  { "武警身份证", "112" }});
            //AGENT_ID_TYPE.SelectedIndex = 0;
            FZR_type.SetSelectedValue("09");  //默认负责人类型是企业法人

            //增加主证件类型选项用于判定主证件
            zzj_type.SetItems(new Dictionary<string, string> { { "组织机构代码证", "201" }, { "营业执照", "211" }, { "文件", "214" }, { "其他证件（对公）", "232" }, { "统一社会信用代码证）", "231" } });
            zzj_type.SelectedIndex = 0;
            SYRXX1.Visibility = SYRXX2.Visibility = SYRXX3.Visibility = SYRXX4.Visibility = Visibility.Visible;
            if (string.IsNullOrWhiteSpace(SYRXM2.Text.Trim()))
            {
                SYRXX2.Visibility = SYRXX3.Visibility = SYRXX4.Visibility = Visibility.Collapsed;
            }
            else
            {
                if (string.IsNullOrWhiteSpace(SYRXM3.Text.Trim()))
                {
                    SYRXX3.Visibility = SYRXX4.Visibility = Visibility.Collapsed;
                }
                else
                {
                    if (string.IsNullOrWhiteSpace(SYRXM4.Text.Trim()))
                    {
                        SYRXX4.Visibility = Visibility.Collapsed;
                    }
                    else
                    {
                        SYRXX4.Visibility = Visibility.Visible;
                    }
                }
            }

            fzrlx.Visibility = CW_type.Visibility = cwfzr.Visibility = CW_FZR.Visibility = cwzjlx.Visibility = CW_certType.Visibility =
            cwzjh.Visibility = CW_certNo.Visibility = CW_Sdate.Visibility = date.Visibility = cwtel.Visibility = CW_tel.Visibility = Visibility.Visible;

            //财务负责人
            CW_type.SetItems(new Dictionary<string, string> { { "财务主管", "13" } });
            //Page.TradeAPIs.CallComboBoxData(CW_certType, "C004");
            CW_certType.SetItems(UserVariable.GetPersonIdType(Page));

        }
        //    private void AGENT_ID_TYPE_LostFocus(object sender, RoutedEventArgs e)
        //{
        //    if (!ParentPage.SetInputOfIdCard(AGENT_ID_NO, (AGENT_ID_TYPE.GetSelectedValue() == "B01")))
        //    {
        //        ParentPage.SetFocus(AGENT_ID_TYPE);
        //        return;
        //    }
        //    else
        //    {

        //        ParentPage.SetInputOfIdCard(AGENT_ID_NO, (AGENT_ID_TYPE.GetSelectedValue() == "B01"));
        //    }
        //    if (AGENT_ID_TYPE.GetSelectedKey().Contains("身份证"))
        //        DeviceManager.SetIdentityCardReader(AGENT_ID_NO, IdentityCardReaderType.ReadCardOrInput);
        //    else
        //        DeviceManager.SetIdentityCardReader(AGENT_ID_NO, IdentityCardReaderType.Input);
        //}

        //private void AGENT_ID_NO_LostFocus(object sender, RoutedEventArgs e)
        //{
        //    string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        //    //郏县存在代理人时，代理人证件有效日期必输
        //    if (FLAG == "V1" || FLAG == "V6" || FLAG == "V7" || FLAG == "V0" || (FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") || FLAG == "V2" || FLAG == "V11" || FLAG == "V9" || FLAG == "V8" || FLAG == "V5" || FLAG == "V12" || FLAG == "V3" || ServiceSettings.GetConfig("Temp_CustomerAddressLength", false))
        //    {
        //        if (AGENT_ID_NO.Text.Trim() != "")
        //        {
        //           // FocusManagerExt.SetAssertNotEmpty(AGENT_Beg_date, true);//代理人有效期
        //            FocusManagerExt.SetAssertNotEmpty(AGENT_End_date, true);//代理人有效期
        //        }
        //        else
        //        {
        //          //  FocusManagerExt.SetAssertNotEmpty(AGENT_Beg_date, false);//代理人有效期
        //            FocusManagerExt.SetAssertNotEmpty(AGENT_End_date, false);//代理人有效期
        //        }
        //    }
        //    if (FLAG == "V0") //中牟，如果有代理人信息时，代理人所有信息都改为必输项
        //    {
        //        if (AGENT_ID_NO.Text.Trim() != "")
        //        {
        //            FocusManagerExt.SetAssertNotEmpty(AGENT_NAME, true);
        //            FocusManagerExt.SetAssertNotEmpty(AGENT_PHONE, true);
        //        }
        //        else
        //        {
        //            FocusManagerExt.SetAssertNotEmpty(AGENT_NAME, false);
        //            FocusManagerExt.SetAssertNotEmpty(AGENT_PHONE, false);
        //        }
        //    }
        //    //新增加将证件号码字母自动转为大写
        //    string id_no = AGENT_ID_NO.Text.Trim().ToUpper();
        //    AGENT_ID_NO.Text = id_no;

        //    //初始化控件
        //    HCJG2.IsEnabled = false;
        //    LW_FLG2.IsEnabled = false;
        //    AGENT_NAME.IsReadOnly = false;

        //    if (AGENT_ID_NO.Text.Trim() != "")
        //    {
        //        if (AGENT_ID_TYPE.GetSelectedValue() == "B01")
        //        {
        //            var IdData = DeviceManager.GetIdentityCardData(AGENT_ID_NO);
        //            if (IdData.Data.IdNumber != null)
        //            {
        //                AGENT_ID_NO.Text = IdData.Data.IdNumber;
        //            }
        //            if (IdData.Data.Name != null)
        //            {
        //                AGENT_NAME.Text = IdData.Data.Name;
        //            }
        //            //检查长度，务必保证18位
        //            if (ParentPage.Len(AGENT_ID_NO.Text) != 18)
        //            {
        //                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N003));
        //                ParentPage.SetFocus(AGENT_ID_NO);
        //                return;
        //            }
        //            //调用sp8015.c对输入身份证进行验证080315
        //            var output = ParentPage.TradeAPIs.TF_Deposit_IDNumberVerification(new IDNumberVerification.Input
        //            {
        //                ZJLX = AGENT_ID_TYPE.GetSelectedValue(),
        //                ZJHM = AGENT_ID_NO.Text
        //            });
        //            if (output.IsFailed)
        //            {
        //                ParentPage.TradeAPIs.ShowTip(output.FailureCause);
        //                ParentPage.SetFocus(AGENT_ID_NO);
        //                return;
        //            }
        //            if (output.YZTGBZ[0] != '1')
        //            {
        //                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
        //                ParentPage.SetFocus(AGENT_ID_NO);
        //                return;
        //            }
        //            AGENT_ID_NO.Text = ParentPage.TradeAPIs.Delspace(output.ZJHM);
        //            //执行核查
        //            var result = ParentPage.TradeAPIs.IdCheck(AGENT_ID_NO);
        //            if (result.IsOnline && result.IsComplated)
        //            {
        //                if (result.Result == "00")
        //                {
        //                    HCJG2.SetSelectedValue("00");
        //                }
        //                else
        //                {
        //                    //核查通过
        //                    HCJG2.SetSelectedValue(result.Result);
        //                }
        //                LW_FLG2.SetSelectedValue("02");
        //                AGENT_NAME.Text = result.Name;
        //                // AGENT_NAME.IsReadOnly = true;
        //            }
        //            else
        //            {
        //                //未核查或失败
        //                if (result.IsOnline && ParentPage.ShowQuestionMessageBox("联网身份核查未通过，是否继续？") == MessageBoxResult.No)
        //                {
        //                    ParentPage.SetFocus(AGENT_ID_NO);
        //                    return;
        //                }
        //                HCJG2.IsEnabled = true;
        //                LW_FLG2.SetSelectedValue("01");
        //            }
        //        }
        //    }
        //}

        private void TEL1_LostFocus(object sender, RoutedEventArgs e)
        {
            string tel = string.Empty;
            if (ParentPage.Len(TEL1.Text) < 7)
            {
                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N008));
                //ParentPage.SetFocus(                //TEL1);
                ParentPage.SetFocus(TEL1);
                return;
            }

            RaiseLostFocus();
            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            //if (FLAG == "V7")//都匀  代理人信息不为空时 发证机关必输
            //{
            //    if (!string.IsNullOrEmpty(AGENT_ID_NO.Text) || !string.IsNullOrEmpty(AGENT_NAME.Text) || !string.IsNullOrEmpty(AGENT_PHONE.Text) || !string.IsNullOrEmpty(AGENT_End_date.Text))
            //    {
            //        FocusManagerExt.SetAssertNotEmpty(FZJG2, true);
            //    }
            //    else
            //    {
            //        FocusManagerExt.SetAssertNotEmpty(FZJG2, false);
            //    }
            //}
        }

        private void QY_TYPE_LostFocus(object sender, RoutedEventArgs e)
        {
            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            if (FLAG == "V0") //中牟，公司类型为“企业法人、有字号的个体工商户、非法人企业、民办非企业”时，经营范围改为必输项，剩余则为选输项
            {
                if (QY_TYPE.GetSelectedValue() == "1" || QY_TYPE.GetSelectedValue() == "2" || QY_TYPE.GetSelectedValue() == "232" || QY_TYPE.GetSelectedValue() == "211")
                {
                    FocusManagerExt.SetAssertNotEmpty(JYXM, true);
                }
                else
                {
                    FocusManagerExt.SetAssertNotEmpty(JYXM, false);
                }
            }
        }
        private void zzj_type_GotFocus(object sender, RoutedEventArgs e)
        {
            //Set_empty();

        }

        private void zzj_type_LostFocus(object sender, RoutedEventArgs e)
        {
            //{ "组织机构代码证", "8" }, { "文件", "214" }, { "营业执照", "211" }, { "其他证件", "232" }
            //if (zzj_type.GetSelectedValue() == "8")
            //{
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM1, true);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM1, true);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM2, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM2, false);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM5, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM5, false);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM6, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM6, false);
            //}
            //else if (zzj_type.GetSelectedValue() == "214")
            //{
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM1, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM1, false);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM2, true);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM2, true);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM5, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM5, false);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM6, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM6, false);
            //}
            //else if (zzj_type.GetSelectedValue() == "211")
            //{
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM1, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM1, false);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM2, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM2, false);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM5, true);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM5, true);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM6, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM6, false);
            //}
            //else if (zzj_type.GetSelectedValue() == "232")
            //{
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM1, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM1, false);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM2, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM2, false);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM5, false);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM5, false);
            //    FocusManagerExt.SetAssertNotEmpty(ZJHM6, true);
            //    TextBoxHelper.SetIsRepeatInput(ZJHM6, true);
            //}
            //Set_empty();
            zzjhm = Page.TradeAPIs.GetSelectedValue(zzj_type);
        }


        private void ZJHM3_LostFocus(object sender, RoutedEventArgs e)
        {
            //var black = ParentPage.TradeAPIs.TF_Customer_QueryBlackList(new QueryBlackList.Input { ZJLX = UserVariable.EcifIdTypeChangeToCbs(MID_TYPE.GetSelectedValue(), "2"), ZJHM = ZJHM3.Text });
            //if (black.IsFailed)
            //{
            //    ParentPage.SetFocus(ZJHM3);
            //    ParentPage.ShowInfoMessageBox("查询黑名单出错" + black.FailureCause);
            //    return;
            //}
            //if (!black.IsFailed && black.isBlackList == true)
            //{
            //    ParentPage.SetFocus(ZJHM3);
            //    ParentPage.TradeAPIs.ShowErrorMessageBox("黑名单账户或客户不允许进行交易");
            //    return;
            //}
            //if (!black.IsFailed && black.isGreyList == true)
            //{
            //    ParentPage.TradeAPIs.ShowInfoMessageBox("账户或客户存在灰名单记录，请谨慎交易");

            //}
            if (MID_TYPE.GetSelectedValue() == "201")
            {
                if (!ZJHM3.Text.Trim().Contains("-"))
                {
                    if (ZJHM3.Text.Trim().Length != 9)
                    {
                        ParentPage.TradeAPIs.ShowTip("组织机构代码证为9位");
                        ParentPage.TradeAPIs.SetFocus(ZJHM3);
                        return;
                    }
                }
                else
                {
                    if (ZJHM3.Text.Trim().Length != 10)
                    {
                        ParentPage.TradeAPIs.ShowTip("组织机构代码证为10位");
                        ParentPage.TradeAPIs.SetFocus(ZJHM3);
                        return;
                    }
                }
                var shortTrading = ParentPage.TradeAPIs.TF_Deposit_IDNumberVerification(
                new IDNumberVerification.Input()
                {
                    ZJHM = ZJHM3.Text,
                    ZJLX = "8"//老核心组织机构代码证是8，新ecif是201
                }
                );
                if (shortTrading.IsFailed)
                {
                    ParentPage.TradeAPIs.ShowTip(ZJHM3, shortTrading.FailureCause);
                    ParentPage.SetFocus(ZJHM3);
                    return;
                }
                if (shortTrading.YZTGBZ[0] != '3')
                {
                    ParentPage.TradeAPIs.ShowTip(ZJHM3, ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
                    ParentPage.SetFocus(ZJHM3);
                    return;
                }
            }
            if ("211" == MID_TYPE.GetSelectedValue())
            {
                if (ZJHM3.Text.Trim().Length != 18 && ZJHM3.Text.Trim().Length != 15)
                {
                    ParentPage.SetFocus();
                    ParentPage.TradeAPIs.ShowTip("营业执照长度为15位或18位");

                    return;
                }
            }
            //机构信用代码证
            if (MID_TYPE.GetSelectedValue() == "231")
            {
                if (ZJHM3.Text.Trim().Length != 18)
                {
                    ParentPage.TradeAPIs.ShowTip("机构信用代码证长度为18位！");
                    ParentPage.TradeAPIs.SetFocus(ZJHM3);
                    return;
                }
                else
                {
                    bool check = CheckSocialCreditCode(ZJHM3.Text.ToString());
                    if (check.Equals(true)) { }
                    else
                    {
                        ParentPage.TradeAPIs.ShowTip("不是有效的统一社会信用代码！");
                        ParentPage.TradeAPIs.SetFocus(ZJHM3);
                        return;
                    }
                }
            }
            //新增加将证件号码字母自动转为大写
            string id_no = ZJHM3.Text.Trim().ToUpper();
            ZJHM3.Text = id_no;
            if (!IsUpdate)
            {
                //根据证件类型和号码查询客户是否已登记
                var output1 = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input
                {
                    KHLX = "02",
                    //qryType="1",
                    ZJLX = UserVariable.EcifIdTypeChangeToCbs(MID_TYPE.GetSelectedValue(), "2"),
                    ZJHM = ZJHM3.Text.ToString()
                });
                if (output1.IsFailed)
                {
                    ParentPage.TradeAPIs.ShowTip(output1.FailureCause);
                    ParentPage.SetFocus(ZJHM3);
                    return;
                }

                var data = output1.WJ;
                if (output1.WJData.Count == 0)
                {
                    data = "客户未建立客户信息";
                }
                #region /*V9：客户信息不存在时，系统同样弹出对话框，但无任何记录，因此无需弹窗提示*/
                if (output1.WJData.Count != 0)
                {
                    var selectedData = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, data, new string[] { "客户编号", "客户名称", "证件号码", "客户状态" }, 500, 200);
                    if (selectedData == null)
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N042));
                        ParentPage.SetFocus(ZJHM3);
                        return;
                    }

                    if (selectedData["客户编号"].ToString() != "客户未建立客户信息")
                    {
                        if (selectedData["客户状态"].ToString().Equals("关闭"))
                        {
                            ParentPage.TradeAPIs.ShowTip("该证件已建立客户信息,客户状态为关闭，请进行客户状态维护");
                            ParentPage.SetFocus(ZJHM3);
                            return;
                        }
                        ParentPage.TradeAPIs.ShowTip("该证件已建立客户信息");
                        ParentPage.SetFocus(ZJHM3);
                        return;
                    }
                }
                #endregion
            }
            //如果是组织机构代码证，调用9574进行校验  整合短交易
            if (MID_TYPE.GetSelectedValue() == "201")
            {
                if (!ZJHM3.Text.Trim().Contains("-"))
                {
                    if (ZJHM3.Text.Trim().Length != 9)
                    {
                        Page.TradeAPIs.ShowTip("组织机构代码证为9位");
                        Page.TradeAPIs.SetFocus(ZJHM3);
                        return;
                    }
                }
                else
                {
                    if (ZJHM3.Text.Trim().Length != 10)
                    {
                        Page.TradeAPIs.ShowTip("组织机构代码证为10位");
                        Page.TradeAPIs.SetFocus(ZJHM3);
                        return;
                    }
                }
                var shortTrading = Page.TradeAPIs.TF_Deposit_IDNumberVerification(
                new IDNumberVerification.Input()
                {
                    ZJHM = ZJHM3.Text,
                    ZJLX = "8"//老核心组织机构代码证是8，新ecif是201
                }
                );
                if (shortTrading.IsFailed)
                {
                    Page.TradeAPIs.ShowTip(ZJHM3, shortTrading.FailureCause);
                    Page.SetFocus(ZJHM3);
                    return;
                }
                if (shortTrading.YZTGBZ[0] != '3')
                {
                    Page.TradeAPIs.ShowTip(ZJHM3, Page.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
                    Page.SetFocus(ZJHM3);
                    return;
                }
            }
        }

        private void KHXM1_LostFocus(object sender, RoutedEventArgs e)
        {
            //新增加将姓名转换为全角处理080301
            if (ParentPage.Len(KHXM1.Text.ToString()) < 6)
            {
                ParentPage.TradeAPIs.ShowTip("客户名称小于6个字符，请确认");
                //ParentPage.SetFocus(                //ParentPage.KHXM1);
                ParentPage.SetFocus(KHXM1);
                return;
            }
        }
        //统一社会信用代码校验
        public static bool CheckSocialCreditCode(string code)
        {
            if (code == null || code.Length != 18) return false;

            code = code.ToUpper();

            var factor = new int[] { 1, 3, 9, 27, 19, 26, 16, 17, 20, 29, 25, 13, 8, 24, 10, 30, 28 };
            var str = "0123456789ABCDEFGHJKLMNPQRTUWXY";

            var total = factor.Select((p, i) => p * str.IndexOf(code[i])).Sum();
            var index = total % 31 == 0 ? 0 : (31 - total % 31);

            return str[index] == code.Last();
        }
        //private void ZJHM1_LostFocus(object sender, RoutedEventArgs e)
        //{
        //    count++;
        //    //版本控制定义 
        //    string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        //    if (ZJHM1.Text.Trim() != "")
        //    {
        //        Page.TradeAPIs.SetSelectedValue(zzj_type, "201");
        //        //新增 证件号码与主证件号码一致 20160706 add by WH
        //        if (MID_TYPE.GetSelectedValue() == "201")
        //        {
        //            if (!string.IsNullOrEmpty(ZJHM3.Text.Trim()))
        //            {
        //                if (ZJHM3.Text.Trim() != ZJHM1.Text.Trim())
        //                {
        //                    ParentPage.TradeAPIs.ShowTip("证件号码不一致，请检查！");
        //                    ParentPage.SetFocus(ZJHM1);
        //                }
        //            }
        //        }
        //        if (count == 1)
        //        {
        //            //新增加将证件号码字母自动转为大写
        //            string id_no = ZJHM1.Text.Trim().ToUpper();
        //            ZJHM1.Text = id_no;                    

        //            if (!IsUpdate)
        //            {
        //                //CUSID1.Text = "";
        //                //根据证件类型和号码查询客户是否已登记
        //                var output1 = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { qryType="1",ZJLX="201", ZJHM = ZJHM1.Text });
        //                if (output1.IsFailed)
        //                {
        //                    ParentPage.TradeAPIs.ShowTip(output1.FailureCause);
        //                    //ParentPage.SetFocus(                //ZJHM1);
        //                    ParentPage.SetFocus(ZJHM1);
        //                    count = 0;
        //                    return;
        //                }

        //                var data = output1.WJ;
        //                if (output1.WJData.Count == 0)
        //                {
        //                    data = "客户未建立客户信息";
        //                }
        //                #region /*客户信息不存在时，系统同样弹出对话框，但无任何记录，因此无需弹窗提示*/
        //                if (output1.WJData.Count != 0)
        //                {
        //                    var selectedData = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, data, new string[] { "客户编号", "客户名称", "证件号码" }, 500, 200);
        //                    if (selectedData == null)
        //                    {
        //                        count = 0;
        //                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N042));
        //                        ParentPage.SetFocus(ZJHM1);
        //                        return;
        //                    }

        //                    if (selectedData["客户编号"].ToString() != "客户未建立客户信息")
        //                    {
        //                        ParentPage.TradeAPIs.ShowTip("该证件已建立客户信息");
        //                        ParentPage.SetFocus(ZJHM1);
        //                        count = 0;
        //                        return;
        //                    }
        //                }
        //                #endregion
        //            }
        //            else
        //            {
        //                var output1 = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input {qryType="1",ZJLX="201", ZJHM = ZJHM1.Text });
        //                if (output1.IsFailed)
        //                {
        //                    ParentPage.TradeAPIs.ShowTip(output1.FailureCause);
        //                    ParentPage.SetFocus(ZJHM1);
        //                    count = 0;
        //                    return;
        //                }
        //                if (OldOrganization.Trim() != ZJHM1.Text.Trim() && !string.IsNullOrEmpty(output1.WJ))
        //                {
        //                    ParentPage.TradeAPIs.ShowTip("该证件已经被使用");
        //                    ParentPage.SetFocus(ZJHM1);
        //                    count = 0;
        //                    return;
        //                }
        //            }
        //            Beg_date1.IsEnabled = true;
        //            End_date1.IsEnabled = true;
        //            FocusManagerExt.SetAssertNotEmpty(Beg_date1, true);
        //            FocusManagerExt.SetAssertNotEmpty(End_date1, false);
        //            if (FLAG == "V0")
        //            {
        //                FocusManagerExt.SetAssertNotEmpty(End_date1, true);
        //            }
        //            if (End_date1.Text == "")
        //            {
        //                End_date1.Text = "99991231";
        //            }

        //        }
        //        #region /*update @ 2014年12月9日10:56:49*/
        //        if ((bool)ZJHM1.GetValue(TextBoxHelper.IsRepeatInputProperty) == false)
        //        {
        //            if (count >= 2)
        //            {
        //                if (ZJHM1.Text.Trim().Equals(zjhm1))
        //                {
        //                    count = 0;
        //                    zjhm1 = string.Empty;
        //                    return;
        //                }
        //                else
        //                {
        //                    count = 0;
        //                    zjhm1 = string.Empty;
        //                    ZJHM1.Text = string.Empty;
        //                    ParentPage.TradeAPIs.SetFocus();
        //                    ParentPage.TradeAPIs.ShowTip("两次输入不一致！");
        //                    return;
        //                }
        //            }
        //            else
        //            {

        //                zjhm1 = ZJHM1.Text.Trim();
        //                ZJHM1.Text = string.Empty;
        //                ParentPage.TradeAPIs.SetFocus();
        //                ParentPage.TradeAPIs.ShowTip("请再输入一次！");
        //                return;
        //            }
        //        }
        //        #endregion/*update @ 2014年12月9日10:56:49*/
        //    }
        //    else
        //    {
        //        Beg_date1.IsEnabled = false;
        //        End_date1.IsEnabled = false;
        //        Beg_date1.Clear();
        //        End_date1.Clear();
        //        count = 0;
        //        Page.TradeAPIs.SetSelectedValue(zzj_type, zzjhm);
        //        return;
        //    }
        //}
        private void Beg_date_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(BEG_DATES.Text))
            {
                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                ParentPage.SetFocus();
                return;
            }
        }

        private void End_date_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ZJHM3.Text.Trim() == "" && (END_DATES.Text.Trim() != "" || BEG_DATES.Text.Trim() != ""))
            {
                ParentPage.TradeAPIs.ShowTip("证件号码为空时，有效期必须为空");
                ParentPage.SetFocus(BEG_DATES);
                return;
            }

            if (ZJHM3.Text.Trim() != "")
            {
                if (END_DATES.Text.Trim() != "" && BEG_DATES.Text.Trim() != "")
                {
                    if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(END_DATES.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                        ParentPage.SetFocus(END_DATES);
                        return;
                    }
                    if (ParentPage.Atoi(END_DATES.Text) < ParentPage.Atoi(BEG_DATES.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                        //ParentPage.SetFocus(                //End_date);
                        ParentPage.SetFocus(END_DATES);
                        return;
                    }
                }
                else if ((END_DATES.Text.Trim() == "" && BEG_DATES.Text.Trim() != "") || (END_DATES.Text.Trim() != "" && BEG_DATES.Text.Trim() == ""))
                {
                    ParentPage.TradeAPIs.ShowTip("请输入完整的有效期");
                    ParentPage.SetFocus(END_DATES);
                    return;
                }
            }
        }
        //private void Beg_date1_LostFocus(object sender, RoutedEventArgs e)
        //{
        //    if (Beg_date1.Text.Trim() != "")
        //    {
        //        if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(Beg_date1.Text))
        //        {
        //            ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
        //            ParentPage.SetFocus(Beg_date1);
        //            return;
        //        }
        //    }
        //}

        //private void End_date1_LostFocus(object sender, RoutedEventArgs e)
        //{
        //    if (ZJHM1.Text.Trim() == "" && (End_date1.Text.Trim() != "" || Beg_date1.Text.Trim() != ""))
        //    {
        //        ParentPage.TradeAPIs.ShowTip("组织机构代码证为空时，有效期必须为空");
        //        ParentPage.SetFocus(Beg_date1);
        //        return;
        //    }
        //    if (End_date1.Text == "" || End_date1.Text == "99999999")
        //    {
        //        End_date1.Text = "99991231";
        //    }
        //    if (ZJHM1.Text.Trim() != "")
        //    {
        //        if (End_date1.Text.Trim() != "" && Beg_date1.Text.Trim() != "")
        //        {
        //            if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(End_date1.Text))
        //            {
        //                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
        //                ParentPage.SetFocus(End_date1);
        //                return;
        //            }
        //            if (ParentPage.Atoi(End_date1.Text) < ParentPage.Atoi(Beg_date1.Text))
        //            {
        //                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
        //                //ParentPage.SetFocus(                //End_date);
        //                ParentPage.SetFocus(End_date1);
        //                return;
        //            }
        //        }
        //        else if (End_date1.Text.Trim() == "" || Beg_date1.Text.Trim() == "")
        //        {
        //            ParentPage.TradeAPIs.ShowTip("请输入有效期");
        //            ParentPage.SetFocus(Beg_date1);
        //            return;
        //        }
        //    }
        //}

        //private void ZJHM5_LostFocus(object sender, RoutedEventArgs e)
        //{
        //    //版本控制定义 
        //    string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        //    //根据证件类型和号码查询客户是否已登记
        //    if (ZJHM5.Text.Trim() != "")
        //    {
        //        // 营业执照 不检查 不会重复吗？？？    20150115   diaosq   
        //        //if (string.IsNullOrWhiteSpace(ZJHM1.Text)) //对公开户只以组织机构代码验证是否开客户号，输入营业执照时不再验证也不再提示  modify by lnp 20141125
        //        //新增加将证件号码字母自动转为大写
        //        string id_no = ZJHM5.Text.Trim().ToUpper();
        //        ZJHM5.Text = id_no;
        //        //新增 证件号码与主证件号码一致 20160706 add by WH
        //        if (MID_TYPE.GetSelectedValue() == "211")
        //        {
        //            if (!string.IsNullOrEmpty(ZJHM3.Text.Trim()))
        //            {
        //                if (ZJHM3.Text.Trim() != ZJHM5.Text.Trim())
        //                {
        //                    ParentPage.TradeAPIs.ShowTip("证件号码不一致，请检查！");
        //                    ParentPage.SetFocus(ZJHM5);
        //                }
        //            }
        //        }
        //        if (!IsUpdate)
        //        {
        //            var output = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { qryType="1", ZJLX = "211", ZJHM = ZJHM5.Text.ToString() });
        //            if (output.IsFailed)
        //            {
        //                ParentPage.TradeAPIs.ShowTip(output.FailureCause);
        //                //ParentPage.SetFocus(                //ZJHM2);
        //                ParentPage.SetFocus(ZJHM5);
        //                return;
        //            }

        //            var data = output.WJ;
        //            if (output.WJData.Count == 0)
        //            {
        //                data = "客户未建立客户信息";
        //            }
        //            #region /*客户信息不存在时，系统同样弹出对话框，但无任何记录，因此无需弹窗提示*/
        //            if (output.WJData.Count != 0)
        //            {
        //                var selectedData = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, data, new string[] { "客户编号", "客户名称", "证件号码" }, 500, 200);
        //                if (selectedData == null)
        //                {
        //                    count = 0;
        //                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N042));
        //                    ParentPage.SetFocus(ZJHM5);
        //                    return;
        //                }

        //                if (selectedData["客户编号"].ToString() != "客户未建立客户信息")
        //                {
        //                    ParentPage.TradeAPIs.ShowTip("该证件已建立客户信息");
        //                    ParentPage.SetFocus(ZJHM5);
        //                    count = 0;
        //                    return;
        //                }
        //            }
        //            #endregion
        //        }
        //        else
        //        {
        //            var output1 = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { qryType="1", ZJLX = "211", ZJHM = ZJHM5.Text });
        //            if (output1.IsFailed)
        //            {
        //                ParentPage.TradeAPIs.ShowTip(output1.FailureCause);
        //                ParentPage.SetFocus(ZJHM5);
        //                return;
        //            }
        //            if (OldBusinessCard.Trim() != ZJHM5.Text.Trim() && !string.IsNullOrEmpty(output1.WJ))
        //            {
        //                ParentPage.TradeAPIs.ShowTip("该证件已经被使用");
        //                ParentPage.SetFocus(ZJHM5);
        //                return;
        //            }
        //        }
        //        FocusManagerExt.SetAssertNotEmpty(Beg_date5, true);
        //        FocusManagerExt.SetAssertNotEmpty(End_date5, false);
        //        if (FLAG == "V0")
        //        {
        //            FocusManagerExt.SetAssertNotEmpty(End_date5, true);
        //        }
        //        Beg_date5.IsEnabled = true;
        //        End_date5.IsEnabled = true;
        //        if (End_date5.Text == "")
        //        {
        //            End_date5.Text = "99991231";
        //        }
        //    }
        //    else
        //    {
        //        Beg_date5.IsEnabled = false;
        //        End_date5.IsEnabled = false;
        //        Beg_date5.Clear();
        //        End_date5.Clear();
        //    }
        //}
        //private void Beg_date5_LostFocus(object sender, RoutedEventArgs e)
        //{
        //    if (Beg_date5.Text.Trim() != "")
        //    {
        //        if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(Beg_date5.Text))
        //        {
        //            ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
        //            ParentPage.SetFocus(Beg_date5);
        //            return;
        //        }
        //    }
        //}

        //private void End_date5_LostFocus(object sender, RoutedEventArgs e)
        //{
        //    if (ZJHM5.Text.Trim() == "" && (End_date5.Text.Trim() != "" || Beg_date5.Text.Trim() != ""))
        //    {
        //        ParentPage.TradeAPIs.ShowTip("营业执照为空时，有效期必须为空");
        //        ParentPage.SetFocus(Beg_date5);
        //        return;
        //    }
        //    if (End_date5.Text == "" || End_date5.Text == "99999999")
        //    {
        //        End_date5.Text = "99991231";
        //    }
        //    if (ZJHM5.Text.Trim() != "")
        //    {
        //        if (End_date5.Text.Trim() != "" && Beg_date5.Text.Trim() != "")
        //        {
        //            if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(End_date5.Text))
        //            {
        //                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
        //                ParentPage.SetFocus(End_date5);
        //                return;
        //            }

        //            if (ParentPage.Atoi(End_date5.Text) < ParentPage.Atoi(Beg_date5.Text))
        //            {
        //                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
        //                ParentPage.SetFocus(End_date5);
        //                return;
        //            }
        //        }
        //        else if (End_date5.Text.Trim() == "" || Beg_date5.Text.Trim() == "")
        //        {
        //            ParentPage.TradeAPIs.ShowTip("请输入有效期");
        //            ParentPage.SetFocus(Beg_date5);
        //            return;
        //        }
        //    }
        //}

        //private void ZJHM6_LostFocus(object sender, RoutedEventArgs e)
        //{
        //    //版本控制定义 
        //    string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        //    if (FLAG == "V0")
        //    {
        //        //证件不能全部为空
        //        if (ZJHM6.Text.Trim() == "" && ZJHM5.Text.Trim() == "" &&
        //            ZJHM1.Text.Trim() == "" && ZJHM2.Text.Trim() == "" && ZJHM7.Text.Trim() == "")
        //        {
        //            ParentPage.ShowTip("证件号码不能全部为空！");
        //            ParentPage.SetFocus(ZJHM6);
        //            return;
        //        }
        //        else
        //        {
        //            //新增 证件号码与主证件号码一致 20160706 add by WH
        //            if (MID_TYPE.GetSelectedValue() == "231")
        //            {
        //                if (!string.IsNullOrEmpty(ZJHM3.Text.Trim()))
        //                {
        //                    if (ZJHM3.Text.Trim() != ZJHM7.Text.Trim())
        //                    {
        //                        ParentPage.TradeAPIs.ShowTip("证件号码不一致，请检查！");
        //                        ParentPage.SetFocus(ZJHM7);
        //                    }
        //                }
        //            }
        //            if (ZJHM7.Text.Trim() != "")
        //            {
        //                this.Page.TradeAPIs.SetSelectedValue(zzj_type, "231");
        //                PrintInfoIDNo = ZJHM7.Text;
        //            }
        //            if (ZJHM6.Text.Trim() != "")
        //            {
        //                this.Page.TradeAPIs.SetSelectedValue(zzj_type, "232");
        //                PrintInfoIDNo = ZJHM6.Text;
        //            }
        //            if (ZJHM2.Text.Trim() != "")
        //            {
        //                this.Page.TradeAPIs.SetSelectedValue(zzj_type, "214");
        //                PrintInfoIDNo = ZJHM2.Text;
        //            }
        //            if (ZJHM5.Text.Trim() != "")
        //            {
        //                this.Page.TradeAPIs.SetSelectedValue(zzj_type, "211");
        //                PrintInfoIDNo = ZJHM5.Text;
        //            }
        //            if (ZJHM1.Text.Trim() != "")
        //            {
        //                this.Page.TradeAPIs.SetSelectedValue(zzj_type, "201");
        //                PrintInfoIDNo = ZJHM1.Text;
        //            }
        //        }
        //    }
        //    //根据证件类型和号码查询客户是否已登记
        //    //if (ZJHM5.Text.Trim() == "" && ZJHM6.Text.Trim() == "")
        //    //{
        //    //    ParentPage.ShowMessageBox("营业执照为空时，其他证件号为必输项");
        //    //    ParentPage.SetFocus(ZJHM6);
        //    //    return;
        //    //}

        //    if (ZJHM6.Text.Trim() != "")
        //    {
        //        //新增加将证件号码字母自动转为大写
        //        string id_no = ZJHM6.Text.Trim().ToUpper();
        //        ZJHM6.Text = id_no;
        //        //新增 证件号码与主证件号码一致 20160706 add by WH
        //        if (MID_TYPE.GetSelectedValue() == "232")
        //        {
        //            if (!string.IsNullOrEmpty(ZJHM3.Text.Trim()))
        //            {
        //                if (ZJHM3.Text.Trim() != ZJHM6.Text.Trim())
        //                {
        //                    ParentPage.TradeAPIs.ShowTip("证件号码不一致，请检查！");
        //                    ParentPage.SetFocus(ZJHM6);
        //                }
        //            }
        //        }

        //        if (!IsUpdate)
        //        {
        //            var output = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input {qryType="1", ZJHM = ZJHM6.Text, ZJLX = "232" });
        //            if (output.IsFailed)
        //            {
        //                ParentPage.TradeAPIs.ShowTip(output.FailureCause);
        //                ParentPage.SetFocus(ZJHM6);
        //                return;
        //            }

        //            var data = output.WJ;
        //            if (output.WJData.Count == 0)
        //            {
        //                data = "客户未建立客户信息";
        //            }
        //            #region /*客户信息不存在时，系统同样弹出对话框，但无任何记录，因此无需弹窗提示*/
        //            if (output.WJData.Count != 0)
        //            {
        //                var selectedData = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, data, new string[] { "客户编号", "客户名称", "证件号码" }, 500, 200);
        //                if (selectedData == null)
        //                {
        //                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N042));
        //                    ParentPage.SetFocus(ZJHM6);
        //                    return;
        //                }
        //                if (selectedData["客户编号"].ToString() != "客户未建立客户信息")
        //                {
        //                    ParentPage.TradeAPIs.ShowTip("该证件已建立客户信息");
        //                    ParentPage.SetFocus(ZJHM6);
        //                    return;
        //                }
        //            }
        //            #endregion
        //        }
        //        else
        //        {
        //            var output1 = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { qryType="1", ZJHM = ZJHM6.Text, ZJLX = "232" });
        //            if (output1.IsFailed)
        //            {
        //                ParentPage.TradeAPIs.ShowTip(output1.FailureCause);
        //                ParentPage.SetFocus(ZJHM6);
        //                return;
        //            }
        //            if (OldOther.Trim() != ZJHM6.Text.Trim() && !string.IsNullOrEmpty(output1.WJ))
        //            {
        //                ParentPage.TradeAPIs.ShowTip("该证件已经被使用");
        //                ParentPage.SetFocus(ZJHM6);
        //                return;
        //            }
        //        }
        //        FocusManagerExt.SetAssertNotEmpty(Beg_date6, true);
        //        FocusManagerExt.SetAssertNotEmpty(End_date6, false);
        //        if (FLAG == "V0")
        //        {
        //            FocusManagerExt.SetAssertNotEmpty(End_date6, true);
        //        }
        //        Beg_date6.IsEnabled = true;
        //        End_date6.IsEnabled = true;
        //        if (End_date6.Text == "")
        //        {
        //            End_date6.Text = "99991231";
        //        }
        //    }
        //    else
        //    {
        //        Beg_date6.IsEnabled = false;
        //        End_date6.IsEnabled = false;
        //        Beg_date6.Clear();
        //        End_date6.Clear(); ;
        //    }
        //}

        //private void Beg_date6_LostFocus(object sender, RoutedEventArgs e)
        //{
        //    if (Beg_date6.Text.Trim() != "")
        //    {
        //        if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(Beg_date6.Text))
        //        {
        //            ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
        //            ParentPage.SetFocus(Beg_date6);
        //            return;
        //        }
        //    }
        //}

        //private void End_date6_LostFocus(object sender, RoutedEventArgs e)
        //{
        //    if (ZJHM6.Text.Trim() == "" && (End_date6.Text.Trim() != "" || Beg_date6.Text.Trim() != ""))
        //    {
        //        ParentPage.TradeAPIs.ShowTip("其他证件为空时，有效期必须为空");
        //        ParentPage.SetFocus(Beg_date6);
        //        return;
        //    }
        //    if (End_date6.Text == "" || End_date6.Text == "99999999")
        //    {
        //        End_date6.Text = "99991231";
        //    }
        //    if (ZJHM6.Text.Trim() != "")
        //    {
        //        if (End_date6.Text.Trim() != "" && Beg_date6.Text.Trim() != "")
        //        {
        //            if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(End_date6.Text))
        //            {
        //                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
        //                ParentPage.SetFocus(End_date6);
        //                return;
        //            }

        //            if (ParentPage.Atoi(End_date6.Text) < ParentPage.Atoi(Beg_date6.Text))
        //            {
        //                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
        //                //ParentPage.SetFocus(                //End_date);
        //                ParentPage.SetFocus(End_date6);
        //                return;
        //            }
        //        }
        //        else if (End_date6.Text.Trim() == "" || Beg_date6.Text.Trim() == "")
        //        {
        //            ParentPage.TradeAPIs.ShowTip("请输入有效期");
        //            ParentPage.SetFocus(Beg_date6);
        //            return;
        //        }
        //    }
        //}

        //private void ZJHM7_LostFocus(object sender, RoutedEventArgs e)
        //{
        //    //版本控制定义 
        //    string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        //    if (FLAG != "V0")
        //    {
        //        //证件不能全部为空
        //        if (ZJHM6.Text.Trim() == "" && ZJHM5.Text.Trim() == "" &&
        //            ZJHM1.Text.Trim() == "" && ZJHM2.Text.Trim() == "" && ZJHM7.Text.Trim() == "")
        //        {
        //            ParentPage.ShowTip("证件号码不能全部为空！");
        //            ParentPage.SetFocus(ZJHM7);
        //            return;
        //        }
        //        else
        //        {
        //            //新增 证件号码与主证件号码一致 20160706 add by WH
        //            if (MID_TYPE.GetSelectedValue() == "231")
        //            {
        //                if (!string.IsNullOrEmpty(ZJHM3.Text.Trim()))
        //                {
        //                    if (ZJHM3.Text.Trim() != ZJHM7.Text.Trim())
        //                    {
        //                        ParentPage.TradeAPIs.ShowTip("证件号码不一致，请检查！");
        //                        ParentPage.SetFocus(ZJHM7);
        //                    }
        //                }
        //            }
        //            if (ZJHM7.Text.Trim() != "")
        //            {
        //                this.Page.TradeAPIs.SetSelectedValue(zzj_type, "231");
        //                PrintInfoIDNo = ZJHM7.Text;
        //            }
        //            if (ZJHM6.Text.Trim() != "")
        //            {
        //                this.Page.TradeAPIs.SetSelectedValue(zzj_type, "232");
        //                PrintInfoIDNo = ZJHM6.Text;
        //            }
        //            if (ZJHM2.Text.Trim() != "")
        //            {
        //                this.Page.TradeAPIs.SetSelectedValue(zzj_type, "214");
        //                PrintInfoIDNo = ZJHM2.Text;
        //            }
        //            if (ZJHM5.Text.Trim() != "")
        //            {
        //                this.Page.TradeAPIs.SetSelectedValue(zzj_type, "211");
        //                PrintInfoIDNo = ZJHM5.Text;
        //            }
        //            if (ZJHM1.Text.Trim() != "")
        //            {
        //                this.Page.TradeAPIs.SetSelectedValue(zzj_type, "201");
        //                PrintInfoIDNo = ZJHM1.Text;
        //            }
        //        }
        //    }
        //    //根据证件类型和号码查询客户是否已登记
        //    if (ZJHM7.Text.Trim() != "")
        //    {
        //        //新增加将证件号码字母自动转为大写
        //        string id_no = ZJHM7.Text.Trim().ToUpper();
        //        ZJHM7.Text = id_no;
        //        if (!IsUpdate)
        //        {
        //            var output = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input {qryType="1", ZJLX = "231", ZJHM = ZJHM7.Text });
        //            if (output.IsFailed)
        //            {
        //                ParentPage.TradeAPIs.ShowTip(output.FailureCause);
        //                ParentPage.SetFocus(ZJHM7);
        //                return;
        //            }
        //            var data = output.WJ;
        //            if (output.WJData.Count == 0)
        //            {
        //                data = "客户未建立客户信息";
        //            }
        //            #region /*客户信息不存在时，系统同样弹出对话框，但无任何记录，因此无需弹窗提示*/
        //            if (output.WJData.Count != 0)
        //            {
        //                var selectedData = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, data, new string[] { "客户编号", "客户名称", "证件号码" }, 500, 200);
        //                if (selectedData == null)
        //                {
        //                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N042));
        //                    ParentPage.SetFocus(ZJHM7);
        //                    return;
        //                }

        //                if (selectedData["客户编号"].ToString() != "客户未建立客户信息")
        //                {
        //                    ParentPage.TradeAPIs.ShowTip("该证件已建立客户信息");
        //                    ParentPage.SetFocus(ZJHM7);
        //                    return;
        //                }
        //            }
        //            #endregion
        //        }
        //        else
        //        {
        //            var output1 = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input {qryType="1", ZJLX = "231", ZJHM = ZJHM7.Text });
        //            if (output1.IsFailed)
        //            {
        //                ParentPage.TradeAPIs.ShowTip(output1.FailureCause);
        //                ParentPage.SetFocus(ZJHM7);
        //                return;
        //            }
        //            if (OldCreditCard.Trim() != ZJHM7.Text.Trim() && !string.IsNullOrEmpty(output1.WJ))
        //            {
        //                ParentPage.TradeAPIs.ShowTip("该证件已经被使用");
        //                ParentPage.SetFocus(ZJHM7);
        //                return;
        //            }
        //        }
        //        FocusManagerExt.SetAssertNotEmpty(Beg_date7, true);
        //        FocusManagerExt.SetAssertNotEmpty(End_date7, true);
        //        Beg_date7.IsEnabled = true;
        //        End_date7.IsEnabled = true;
        //    }
        //    else
        //    {
        //        Beg_date7.IsEnabled = false;
        //        End_date7.IsEnabled = false;
        //        Beg_date7.Clear();
        //        End_date7.Clear();
        //    }
        //}

        //private void Beg_date7_LostFocus(object sender, RoutedEventArgs e)
        //{
        //    if (Beg_date7.Text.Trim() != "")
        //    {
        //        if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(Beg_date7.Text))
        //        {
        //            ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
        //            ParentPage.SetFocus(Beg_date7);
        //            return;
        //        }
        //    }
        //}

        //private void End_date7_LostFocus(object sender, RoutedEventArgs e)
        //{
        //    if (ZJHM7.Text.Trim() == "" && (End_date7.Text.Trim() != "" || Beg_date7.Text.Trim() != ""))
        //    {
        //        ParentPage.TradeAPIs.ShowTip("统一社会信用代码证为空时，有效期必须为空");
        //        ParentPage.SetFocus(Beg_date7);
        //        return;
        //    }
        //    if (End_date7.Text == "" || End_date7.Text == "99999999")
        //    {
        //        End_date7.Text = "99991231";
        //    }
        //    if (ZJHM7.Text.Trim() != "")
        //    {
        //        if (End_date7.Text.Trim() != "" && Beg_date7.Text.Trim() != "")
        //        {
        //            if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(End_date7.Text))
        //            {
        //                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
        //                ParentPage.SetFocus(End_date7);
        //                return;
        //            }
        //            if (ParentPage.Atoi(End_date7.Text) < ParentPage.Atoi(Beg_date7.Text))
        //            {
        //                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
        //                //ParentPage.SetFocus(                //End_date);
        //                ParentPage.SetFocus(End_date7);
        //                return;
        //            }
        //        }
        //        else if (End_date7.Text.Trim() == "" || Beg_date7.Text.Trim() == "")
        //        {
        //            ParentPage.TradeAPIs.ShowTip("请输入有效期");
        //            ParentPage.SetFocus(Beg_date7);
        //            return;
        //        }
        //    }
        //}

        private void FDDB_ID_TYPE_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!ParentPage.SetInputOfIdCard(FDSF, (FDDB_ID_TYPE.GetSelectedValue() == "B01")))
            {
                ParentPage.SetFocus(FDDB_ID_TYPE);
                return;
            }
            else
            {
                ParentPage.SetInputOfIdCard(FDSF, (FDDB_ID_TYPE.GetSelectedValue() == "B01"));
            }
        }

        private void blngLclDstc_LostFocus(object sender, RoutedEventArgs e)
        {
            Dictionary<string, string> dic = SystemFunction.GetPPCNameByCode("3");
            if (dic.Count > 0)
            {
                string result = "";
                //如果 前台输入在dic中有值，直接显示该条数据
                try
                {
                    //判断是否是数字，数字代表输入的地址代码
                    bool bo = Regex.IsMatch(blngLclDstc.Text, @"^[+-]?\d*[.]?\d*$");
                    if (!bo)
                    {
                        result = dicKey(dic, blngLclDstc.Text);
                    }
                    else
                    {
                        if (!string.IsNullOrEmpty(blngLclDstc.Text))
                        {
                            foreach (var res in dic)
                            {
                                if (res.Key.Contains(blngLclDstc.Text))
                                {
                                    result += res.Key + "|" + res.Value + "\n";
                                }
                            }
                        }
                    }
                    if (result == "")
                    {
                        ParentPage.SetFocus(blngLclDstc);
                        blngLclDstc.ShowTip("请输入县级行政区！");
                        return;
                    }
                    DataRow selectedrow = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, result, new string[] { "地区代码", "地区名称" });
                    if (selectedrow == null)
                    {
                        this.ShowTip("未选中信息！");
                        ParentPage.SetFocus(blngLclDstc);
                        return;
                    }
                    blngLclDstc.Text = selectedrow["地区名称"].ToString().Trim();
                    diqu2.Text = selectedrow["地区代码"].ToString().Trim();
                }
                catch (Exception ex)
                {
                    blngLclDstc.ShowTip("请输入县级行政区！");
                    ParentPage.SetFocus(blngLclDstc);
                    return;
                }
            }
        }
        /// <summary>
        /// 按照输入中文的地区名称匹配值
        /// </summary>
        /// <param name="AreaCode"></param>
        /// <param name="str"></param>
        /// <returns></returns>
        private string dicKey(Dictionary<string, string> dic, string str)
        {
            string result = string.Empty;
            foreach (var value in dic)
            {
                if (value.Value.Contains(str))
                {
                    result += value.Key + "|" + value.Value + "\n";
                }

            }
            return result;
        }

        /// <summary>
        /// 【增加】
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnAdd_Click(object sender, RoutedEventArgs e)
        {
            OP_TYPE = "ADD";
            zjxxdg.Visibility = Visibility.Visible;
            ZJHM3.IsEnabled = true;
            MID_TYPE.IsEnabled = true;
            if (ZJHM3.Text == "")
            {
                MID_TYPE.SelectedIndex = -1;
                ZJHM3.Text = "";
                BEG_DATES.Text = "";
                END_DATES.Text = "";
                ParentPage.SetFocus(MID_TYPE);
            }
            else if (ZJHM3.Text != "")
            {
                ParentPage.SetFocus(BEG_DATES);
            }
        }

        /// <summary>
        /// 【修改】
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnModify_Click(object sender, RoutedEventArgs e)
        {
            OP_TYPE = "Modify";
            zjxxdg.Visibility = Visibility.Visible;
            DataRow row = dbxzjxxdg.GetSelectSingleRow();
            if (row == null)
            {
                ParentPage.ShowInfoMessageBox("请选择记录!");
                ParentPage.SetFocus(dbxzjxxdg);
                return;
            }
            //list数据抓取到界面上
            MID_TYPE.SetSelectedValue(row["证件类型"].ToString());
            this.ZJHM3.Text = row["证件号码"].ToString();
            this.BEG_DATES.Text = row["起始日期"].ToString();
            this.END_DATES.Text = row["终止日期"].ToString();
            certMainFlag.SetSelectedValue(row["是否主证件"].ToString());
            MID_TYPE.IsEnabled = false;
            ZJHM3.IsEnabled = true;
            ParentPage.SetFocus(BEG_DATES);
        }
        /// <summary>
        /// 【删除】
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnDelete_Click(object sender, RoutedEventArgs e)
        {
            DataRow row = dbxzjxxdg.GetSelectSingleRow();
            if (row == null)
            {
                ParentPage.ShowInfoMessageBox("请选择需要删除的记录!");
                ParentPage.SetFocus(dbxzjxxdg);
                return;
            }

            if (zjxxList == null)
            {
                zjxxList = dataTableToList();
            }

            //不知道为什么加这个限制，去掉
            //if (row.ItemArray[1].Equals(MID_TYPE.GetSelectedValue()))
            //{
            //    ParentPage.ShowInfoMessageBox("该条数据不能删除!");
            //    ParentPage.SetFocus(dbxzjxxdg);
            //    return;
            //}
            //else
            //{
            if (ParentPage.ShowQuestionMessageBox("是否删除该条记录") == MessageBoxResult.Yes)
            {
                //从DataBox选择数据，生成实体类
                ZjxxEntity selZjxxEO = RowToEntityZjxx(row);
                zjxxList.Remove(selZjxxEO);
                selZjxxEO.opCode = "03";
                zjxxList.Add(selZjxxEO);
                //删除数据
                DataRowView drv = dbxzjxxdg.DataBoxHost.SelectedItem as DataRowView;
                if (drv == null) return;
                drv.Row.Delete();
                dbxzjxxdg.DataSource.AcceptChanges();

                if (dbxzjxxdg.DataSource.Rows.Count == 0)
                {
                    zjxxdg.Visibility = Visibility.Visible;
                    MID_TYPE.IsEnabled = true;
                    OP_TYPE = "";
                    opCode = "02";
                    ParentPage.SetFocus(MID_TYPE);
                    return;
                }

                //绑定DataBox数据
                BindData();
                ParentPage.SetFocus(dbxzjxxdg);
            }
            else
            {
                ParentPage.SetFocus(dbxzjxxdg);
            }
        }
        /// <summary>
        /// 【完成】
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnOk_Click(object sender, RoutedEventArgs e)
        {
            DataTable db = dbxzjxxdg.DataSource;
            if (db == null || db.Rows.Count == 0)
            {
                ParentPage.ShowInfoMessageBox("证件信息不能为空！");
                ParentPage.SetFocus(btnAdd);
                return;
            }
            string[] id_type = new string[6];
            int zzjbs = 0;
            for (int i = 0; i < db.Rows.Count; i++)
            {
                id_type[i] = db.Rows[i][0].ToString();
                if (db.Rows[i][6].ToString() == "Y")
                    zzjbs++;
            }
            if (zzjbs != 1)
            {
                ParentPage.ShowInfoMessageBox("是否主证件有且只能有一条为是！");
                ParentPage.SetFocus(btnAdd);
                return;
            }
            //A-营业执照,8-组织机构代码证,V-文件
            //if (id_type.Contains("201") || id_type.Contains("214") || id_type.Contains("211") || id_type.Contains("231"))
            //{
            //    OP_TYPE = "";
            //    ParentPage.SetFocus(blngLclDstc);
            //}
            //else
            //{
            //    zjxxdg.Visibility = Visibility.Visible;
            //    ParentPage.SetFocus(MID_TYPE);
            //    ParentPage.ShowTip("请添加主证件类型，包括统一社会信用代码证、营业执照、组织机构代码证、证明文件");
            //}
            OP_TYPE = "";
            ParentPage.SetFocus(blngLclDstc);
        }
        /// <summary>
        /// 【证件类型】
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ID_TYPES_LostFocus(object sender, RoutedEventArgs e)
        {
            //SetInputOfCard(ZJHM3, true);
            //从页面控件取得数据，生成实体类
            ZjxxEntity zjxxEO = new ZjxxEntity();
            //zjxxList = dataTableToList();
            zjxxEO.IdType = this.MID_TYPE.GetSelectedValue();
            //【证件类型】文字显示
            if (CMB_ID_TYPES_K.ContainsKey(zjxxEO.IdType))
                zjxxEO.IdTypeName = CMB_ID_TYPES_K[zjxxEO.IdType];
            zjxxEO.IdNo = this.ZJHM3.Text.Trim();


            //检查录入数据是否一致
            if (zjxxList == null)
            {
                return;
            }
            foreach (ZjxxEntity eo in zjxxList)
            {

                if (zjxxEO.Equals3(eo) && !eo.opCode.Equals("03"))
                {
                    ParentPage.ShowErrorMessageBox(" 相同类型的证件不能重复添加！");
                    ParentPage.SetFocus(MID_TYPE);
                    return;
                }
            }
        }
        /// <summary>
        /// 完成
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnOk_GotFocus(object sender, RoutedEventArgs e)
        {
            zjxxdg.Visibility = Visibility.Collapsed;
        }

        /// <summary>
        /// 【确定】
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnFinish_Click(object sender, RoutedEventArgs e)
        {
            if (OP_TYPE == "ADD")
            {
                opCode = "01";
                DataTable db = dbxzjxxdg.DataSource;
                if (db == null || db.Rows.Count == 0)
                {
                    ParentPage.ShowInfoMessageBox("证件信息不能为空！");
                    ParentPage.SetFocus(btnAdd);
                    return;
                }
                string[] id_type = new string[6];
                for (int i = 0; i < db.Rows.Count; i++)
                {
                    id_type[i] = db.Rows[i][0].ToString();
                }
                id_type.SetValue(MID_TYPE.GetSelectedValue(), 5);
                //A-营业执照,8-组织机构代码证,V-文件
                //if (id_type.Contains("201") || id_type.Contains("214") || id_type.Contains("211") || id_type.Contains("231"))
                //{
                //    zjxxList = dataTableToList();
                //    //插入数据
                //    InsertData();
                //    ParentPage.TradeAPIs.SetFocus(btnOk);
                //    MID_TYPE.SelectedIndex = 0;
                //    ZJHM3.Text = "";
                //    BEG_DATES.Text = "";
                //    END_DATES.Text = "";
                //    MID_TYPE.IsEnabled = true;
                //    ZJHM3.IsEnabled = true;
                //    OP_TYPE = "";
                //}
                //else
                //{
                //    ParentPage.SetFocus(MID_TYPE);
                //    ParentPage.ShowTip("请添加主证件类型，包括统一社会信用代码证、营业执照、组织机构代码证、证明文件");
                //}
                zjxxList = dataTableToList();
                //插入数据
                InsertData();
                ParentPage.TradeAPIs.SetFocus(btnOk);
                MID_TYPE.SelectedIndex = 0;
                ZJHM3.Text = "";
                BEG_DATES.Text = "";
                END_DATES.Text = "";
                MID_TYPE.IsEnabled = true;
                ZJHM3.IsEnabled = true;
                OP_TYPE = "";
            }
            else if (OP_TYPE == "Modify")
            {
                opCode = "02";
                DataRow row = dbxzjxxdg.GetSelectSingleRow();
                zjxxList = dataTableToList();
                if (row == null)
                {
                    ParentPage.ShowInfoMessageBox("请选择需要修改的记录!");
                    ParentPage.SetFocus(dbxzjxxdg);
                    return;
                }
                //从DataBox选择数据，生成实体类
                ZjxxEntity selZjxxEO = RowToEntityZjxx(row);
                //检查录入数据是否一致
                foreach (ZjxxEntity zjxxEO in zjxxList)
                {
                    if (selZjxxEO.Equals1(zjxxEO))
                    {
                        zjxxEO.IdType = this.MID_TYPE.GetSelectedValue();
                        //【联系人名称】文字显示
                        if (CMB_ID_TYPES_K.ContainsKey(zjxxEO.IdType))
                            zjxxEO.IdTypeName = CMB_ID_TYPES_K[zjxxEO.IdType];
                        zjxxEO.IdNo = this.ZJHM3.Text.Trim();
                        zjxxEO.BegDate = this.BEG_DATES.Text.Trim();
                        zjxxEO.EndDate = this.END_DATES.Text.Trim();
                        zjxxEO.certMainFlag = this.certMainFlag.GetSelectedValue();
                        //检查录入数据是否一致
                        int count = 0;
                        foreach (ZjxxEntity eo in zjxxList)
                        {
                            if (zjxxEO.Equals1(eo) && !eo.opCode.Equals("03"))
                            {
                                count++;
                                if (1 < count)
                                {
                                    ParentPage.ShowErrorMessageBox("该数据已经存在！");
                                    ParentPage.SetFocus(MID_TYPE);
                                    return;
                                }
                            }
                        }
                        break;
                    }
                }
                //绑定DataBox数据
                BindData();
                ParentPage.SetFocus(btnOk);
            }
            else if (OP_TYPE == "")
            {
                opCode = "01";
                //插入数据
                InsertData();
                ParentPage.TradeAPIs.SetFocus(btnOk);
                MID_TYPE.SelectedIndex = 0;
                ZJHM3.Text = "";
                BEG_DATES.Text = "";
                END_DATES.Text = "";
                MID_TYPE.IsEnabled = true;
                ZJHM3.IsEnabled = true;
                OP_TYPE = "";
            }
            else if (OP_TYPE == "Delete")
            {
                ParentPage.ShowInfoMessageBox("数据已删除!");
                ParentPage.SetFocus(btnAdd);
                return;
            }

        }
        /// <summary>
        /// 从DataBox选择数据，生成实体类(爱好信息)
        /// </summary>
        /// <param name="row"></param>
        /// <returns></returns>
        private ZjxxEntity RowToEntityZjxx(DataRow row)
        {
            ZjxxEntity entity = new ZjxxEntity();
            //entity.Seqn = row["SEQN"].ToString();
            entity.IdType = row["证件类型"].ToString();
            entity.IdTypeName = row["证件类型名称"].ToString();
            entity.IdNo = row["证件号码"].ToString();
            entity.BegDate = row["起始日期"].ToString();
            entity.EndDate = row["终止日期"].ToString();
            entity.certMainFlag = row["是否主证件"].ToString();
            entity.opCode = opCode;
            return entity;
        }
        /// <summary>
        /// 插入数据
        /// </summary>
        private void InsertData()
        {
            //从页面控件取得数据，生成实体类
            ZjxxEntity zjxxEO = new ZjxxEntity();
            zjxxEO.IdType = this.MID_TYPE.GetSelectedValue();
            zjxxEO.IdTypeName = this.MID_TYPE.GetSelectedKey();
            zjxxEO.IdNo = this.ZJHM3.Text.Trim();
            zjxxEO.BegDate = this.BEG_DATES.Text.Trim();
            zjxxEO.EndDate = this.END_DATES.Text.Trim();
            zjxxEO.opCode = opCode;
            zjxxEO.certMainFlag = certMainFlag.GetSelectedValue();
            //检查录入数据是否一致
            if (zjxxList != null)
            {
                foreach (ZjxxEntity eo in zjxxList)
                {
                    if (zjxxEO.Equals(eo) && !eo.opCode.Equals("03"))
                    {
                        ParentPage.TradeAPIs.ShowErrorMessageBox("该数据已经存在！");
                        ParentPage.TradeAPIs.SetFocus(MID_TYPE);
                        return;
                    }
                }
            }
            else
            {
                zjxxList = new List<ZjxxEntity>();
            }
            //将页面控件数据，增加到list            
            zjxxList.Add(zjxxEO);
            //绑定DataBox数据
            BindData();
        }
        /// <summary>
        /// 绑定DataBox数据(爱好信息)
        /// </summary>
        /// 

        public List<ZjxxEntity> dataTableToList()
        {
            if (dbxzjxxdg.GetDataForString() == null || dbxzjxxdg.GetDataForDataTable().Rows.Count == 0)
                return null;
            List<ZjxxEntity> list = new List<ZjxxEntity>();
            // dataTable.Columns.Add("SEQN");    
            for (int i = 0; i < dbxzjxxdg.GetDataForDataTable().Rows.Count; i++)
            {
                DataRow row = dbxzjxxdg.GetDataForDataTable().Rows[i];

                ZjxxEntity zjxx = new ZjxxEntity();
                //row["SEQN"] = entity.Seqn;
                zjxx.IdType = row["证件类型"].ToString();
                zjxx.IdTypeName = row["证件类型名称"].ToString();
                zjxx.IdNo = row["证件号码"].ToString();
                zjxx.BegDate = row["起始日期"].ToString();
                zjxx.EndDate = row["终止日期"].ToString();
                zjxx.opCode = row["操作码"].ToString();
                zjxx.certMainFlag = row["是否主证件"].ToString();
                list.Add(zjxx);

            }
            return list;
        }
        void BindData()
        {
            dbxzjxxdg.InitDataBox();
            dbxzjxxdg.BindDataTable(ListToDataTblzjxx());
            dbxzjxxdg.SetColumnsHeader(0, "证件类型");
            //dbxzjxxdg.SetColumnsVisible(0, false);
            //dbxzjxxdg.SetColumnsHeader(1, "证件类型");
            dbxzjxxdg.SetColumnsHeader(1, "证件类型名称");
            dbxzjxxdg.SetColumnsHeader(2, "证件号码");
            dbxzjxxdg.SetColumnsHeader(3, "起始日期");
            dbxzjxxdg.SetColumnsHeader(4, "终止日期");
            dbxzjxxdg.SetColumnsHeader(5, "操作码");
            dbxzjxxdg.SetColumnsHeader(6, "是否主证件");
            //dbxzjxxdg.SetColumnsVisible(5, false);
            dbxzjxxdg.SetSel("操作码", new Dictionary<string, string> { { "新增", "01" }, { "修改", "02" } });
            dbxzjxxdg.SetSel("是否主证件", new Dictionary<string, string> { { "是", "Y" }, { "否", "N" } });
            ParentPage.SetFocus(dbxzjxxdg.DataBoxHost);
        }
        /// 数据从Xml转换成DataTable，并生成list
        /// </summary>
        /// <returns></returns>
        private DataTable ListToDataTblzjxx()
        {
            if (zjxxList == null || zjxxList.Count == 0)
                return null;

            DataTable dataTable = new DataTable();
            // dataTable.Columns.Add("SEQN");    
            dataTable.Columns.Add("证件类型");
            //dataTable.Columns.Add("证件类型Zh");
            dataTable.Columns.Add("证件类型名称");
            dataTable.Columns.Add("证件号码");
            dataTable.Columns.Add("起始日期");
            dataTable.Columns.Add("终止日期");
            dataTable.Columns.Add("操作码");
            dataTable.Columns.Add("是否主证件");
            foreach (var entity in zjxxList)
            {
                if (!entity.opCode.Equals("03"))
                {
                    var row = dataTable.NewRow();
                    //row["SEQN"] = entity.Seqn;
                    row["证件类型"] = entity.IdType;
                    //row["证件类型Zh"] = entity.IdTypeName;
                    row["证件类型名称"] = entity.IdTypeName;
                    row["证件号码"] = entity.IdNo;
                    row["起始日期"] = entity.BegDate;
                    row["终止日期"] = entity.EndDate;
                    row["操作码"] = entity.opCode;
                    row["是否主证件"] = entity.certMainFlag;
                    dataTable.Rows.Add(row);
                }
            }
            return dataTable;
        }

        /// <summary>
        /// 根据参数决定是否按照其他证件要求设置TextBox的输入
        /// </summary>
        /// <param name="element"></param>
        /// <param name="flag"></param>
        /// <returns></returns>
        public static bool SetInputOfCard(TextBox element, bool flag)
        {
            if (element == null) return false;
            element.ClearValue(TextBox.MaxLengthProperty);
            element.ClearValue(Platform.Controls.ControlsHelper.TextBoxHelper.InputTypeProperty);
            //element.ClearValue(DeviceManager.IdentityCardReaderProperty);
            if (flag)
            {
                SetInputOfCard(element);
            }
            return true;
        }

        /// <summary>
        ///  按照其他证件要求设置TextBox的输入，证件号组成，校验位
        /// </summary>
        /// <param name="element"></param>
        /// <returns></returns>
        public static bool SetInputOfCard(TextBox element)
        {
            if (element == null) return false;

            //element.Clear();
            element.SetValue(TextBox.MaxLengthProperty, 20);
            //element.SetValue(Platform.Controls.ControlsHelper.TextBoxHelper.InputTypeProperty, Platform.Controls.ControlsHelper.InputType.IDCard);
            element.SetValue(DeviceManager.IdentityCardReaderProperty, IdentityCardReaderType.Input);

            return true;
        }


        #region  内部类
        /// <summary>
        /// 爱好信息实体类
        /// </summary>
        public class ZjxxEntity : IEquatable<ZjxxEntity>
        {
            private string _idType;
            /// <summary>
            /// 证件类型
            /// </summary>
            public string IdType
            {
                get { return _idType; }
                set { _idType = value; }
            }

            private string _idTypeName;
            /// <summary>
            /// 【证件类型】文字显示
            /// </summary>
            public string IdTypeName
            {
                get { return _idTypeName; }
                set { _idTypeName = value; }
            }
            private string _idNo;
            /// <summary>
            /// 证件号码
            /// </summary>
            public string IdNo
            {
                get { return _idNo; }
                set { _idNo = value; }
            }
            private string _begDate;
            /// <summary>
            /// 起始日期
            /// </summary>
            public string BegDate
            {
                get { return _begDate; }
                set { _begDate = value; }
            }
            private string _endDate;
            /// <summary>
            /// 终止日期
            /// </summary>
            public string EndDate
            {
                get { return _endDate; }
                set { _endDate = value; }
            }
            private string _opCode;
            /// <summary>
            /// 操作码
            /// </summary>
            public string opCode
            {
                get { return _opCode; }
                set { _opCode = value; }
            }
            private string _certMainFlag;
            /// <summary>
            /// 是否主证件
            /// </summary>
            public string certMainFlag
            {
                get { return _certMainFlag; }
                set { _certMainFlag = value; }
            }
            /// <summary>
            /// 构造函数
            /// </summary>
            public ZjxxEntity()
            {

            }
            /// <summary>
            /// 构造函数
            /// </summary>
            /// <param name="MID_TYPE"></param>
            /// <param name="ZJHM3"></param>
            /// <param name="BEG_DATES"></param>
            /// <param name="END_DATES"></param>
            public ZjxxEntity(string MID_TYPE, string ZJHM3, string BEG_DATES, string END_DATES)
            {
                IdType = MID_TYPE;
                IdNo = ZJHM3;
                BegDate = BEG_DATES;
                EndDate = END_DATES;

            }

            /// <summary>
            /// 比较实体类是否相同
            /// </summary>
            /// <param name="other"></param>
            /// <returns></returns>
            public bool Equals3(ZjxxEntity other)
            {
                if (this.IdType == other.IdType)
                {
                    return true;
                }
                if (other.IdType == "B01" && other.IdNo.Length == 18)
                { return true; }
                return false;
            }
            /// <summary>
            /// 比较实体类是否相同
            /// </summary>
            /// <param name="other"></param>
            /// <returns></returns>
            public bool Equals(ZjxxEntity other)
            {
                if (this.IdType == other.IdType)
                {
                    return true;
                }
                return false;
            }
            public bool Equals1(ZjxxEntity other)
            {
                if (this.IdType == other.IdType && this.IdNo == other.IdNo && this.BegDate == other.BegDate && this.EndDate == other.EndDate)
                {
                    return true;
                }
                return false;
            }
        }
        #endregion

        private void FDSF_LostFocus(object sender, RoutedEventArgs e)
        {
            //新增加将证件号码字母自动转为大写
            string id_no = FDSF.Text.Trim().ToUpper();
            FDSF.Text = id_no;

            //控件初始化
            HCJG1.IsEnabled = false;
            LW_FLG1.IsEnabled = false;
            FDDB.IsReadOnly = false;

            if (FDDB_ID_TYPE.GetSelectedValue() == "B01")
            {
                var IdData = DeviceManager.GetIdentityCardData(FDSF);
                if (!string.IsNullOrEmpty(IdData.Data.IdNumber))
                {
                    FDSF.Text = IdData.Data.IdNumber;
                }
                if (!string.IsNullOrEmpty(IdData.Data.Name))
                {
                    FDDB.Text = IdData.Data.Name;
                }
                //检查长度，务必保证18位
                if (ParentPage.Len(FDSF.Text) != 18)
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N003));
                    ParentPage.SetFocus(FDSF);
                    return;
                }
                //数据验证
                //根据证件类型和号码查询客户是否黑名单/灰名单
                //var black = this.Page.TradeAPIs.TF_Customer_QueryBlackList(new QueryBlackList.Input { ZJLX = UserVariable.EcifIdTypeChangeToCbs(FDDB_ID_TYPE.GetSelectedValue(), "2"), ZJHM = FDSF.Text });
                //if (black.IsFailed)
                //{
                //    this.Page.SetFocus(FDSF);
                //    this.Page.ShowInfoMessageBox("查询黑名单出错" + black.FailureCause);
                //    return;
                //}
                //if (!black.IsFailed && black.isBlackList == true)
                //{
                //    this.Page.SetFocus(FDSF);
                //    this.Page.TradeAPIs.ShowErrorMessageBox("黑名单账户或客户不允许进行交易"); ;
                //    return;
                //}
                //if (!black.IsFailed && black.isGreyList == true)
                //{
                //    this.Page.TradeAPIs.ShowInfoMessageBox("账户或客户存在灰名单记录，请谨慎交易");

                //}


                //调用sp8015.c对输入身份证进行验证080315
                var output = ParentPage.TradeAPIs.TF_Deposit_IDNumberVerification(new IDNumberVerification.Input { ZJLX = "1", ZJHM = FDSF.Text });
                if (output.IsFailed)
                {
                    ParentPage.TradeAPIs.ShowTip(output.FailureCause);
                    ParentPage.SetFocus(FDSF);
                    return;
                }
                if (output.YZTGBZ[0] != '1')
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
                    ParentPage.SetFocus(FDSF);
                    return;
                }
                FDSF.Text = ParentPage.TradeAPIs.Delspace(output.ZJHM);

                //执行核查
                var result = ParentPage.TradeAPIs.IdCheck(FDSF);
                if (result.IsOnline && result.IsComplated)
                {
                    //核查通过
                    if (result.Result == "00")
                    {
                        HCJG1.SetSelectedValue("00");
                    }
                    else
                    {
                        HCJG1.SetSelectedValue(result.Result);
                    }
                    LW_FLG1.SetSelectedValue("02");
                    FDDB.Text = result.Name;
                    FDDB.IsReadOnly = true;
                }
                else
                {
                    //未核查或失败
                    if (result.IsOnline && ParentPage.ShowQuestionMessageBox("联网身份核查未通过，是否继续？") == MessageBoxResult.No)
                    {
                        ParentPage.SetFocus(FDSF);
                        return;
                    }
                    //自行手工选择核查结果，联网标志置为未核查
                    HCJG1.IsEnabled = true;
                    LW_FLG1.SetSelectedValue("01");
                }
                HCJG1.IsEnabled = true;
            }
            //根据证件类型、证件号查询客户信息 返回同一证件多个户名的情况
            //客户号|客户名称|证件号码
            var khinfo = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input()
            {
                ZJHM = FDSF.Text.Trim(),
                ZJLX = UserVariable.EcifIdTypeChangeToCbs(FDDB_ID_TYPE.GetSelectedValue(), "2"),
                KHLX = "1"
            });
            if (khinfo.IsFailed)
            {
                ParentPage.TradeAPIs.ShowTip(khinfo.FailureCause);
                ParentPage.SetFocus(FDSF);
                return;
            }
            if (khinfo.WJData.Count == 0)
            {
                ParentPage.TradeAPIs.ShowTip("该客户未建立客户号，请先建立客户号！");
                ParentPage.SetFocus(FDSF);
                return;
            }
            string[] wjdata = khinfo.WJ.Split('\n');
            string KHH = wjdata[1].Split('|')[0];
            //回显法人信息
            Message msg = new Message();
            ParentPage.InitFd(msg);
            ParentPage.CommSend(msg);
            msg.Fd16 = "K054";
            msg.Fd28 = KHH;//客户号
            msg.Fd127 = "1";//客户类型
            ParentPage.CallServer(msg);
            if (msg.Fd12 != "0000")
            {
                ParentPage.TradeAPIs.ShowTip(ParentPage.GetError(msg));
                ParentPage.SetFocus();
                return;
            }
            else
            {
                string[] data = msg.FileData.Split('\n');
                FDDB.Text = data[1].Split('|')[4];//法人姓名
                FRSJHBOX.Text = data[1].Split('|')[19];//法人手机号码
                FR_Beg_date.Text = data[1].Split('|')[7];//有效期
                FR_End_date.Text = data[1].Split('|')[8];//有效期
            }
        }

        private void FDDB_LostFocus(object sender, RoutedEventArgs e)
        {
            //信息交互
            if (TellerSystem.Devices.Config.DeviceConfig.TransInfoEnabled)
            {
                string text = "客户名称：" + KHXM1.Text +
                            "\n注册资本:" + SystemFunction.Delspace(SystemFunction.Comma(ZCZB.Text, 16)) +
                            "\n证件类型：" + zzj_type.GetSelectedKey() +
                            "\n证件号码：" + PrintInfoIDNo +
                            "\n企业联系人:" + QY_NAME.Text +
                            "\n联系电话:" + TEL1.Text +
                            "\n注册地址:" + ZCDZ.Text +
                            "\n法人代表:" + FDDB.Text +
                            "\n法人证件类型：" + FDDB_ID_TYPE.GetSelectedKey() +
                            "\n法人证件号码:" + FDSF.Text;
                var result = TellerSystem.Devices.DeviceHelper.PrintTransInfo(text);
                if (result.HasError)
                {
                    FDDB.ShowTip("信息交互操作有误，请重新调用");
                    this.Page.SetFocus(FDDB);
                    return;
                }
            }
        }

        private void HYFLD_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!string.IsNullOrEmpty(HYFLD.GetSelectedValue()))
            {
                HYFL.SetItems(UserVariable.GetJobTypeTwo(Page, HYFLD.GetSelectedValue()));
            }
        }
        /// <summary>
        /// 国标行业类型（三级）
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void HYFL_LostFoucus(object sender, RoutedEventArgs e)
        {
            if (!string.IsNullOrEmpty(HYFL.GetSelectedValue()))
            {
                industryThree.SetItems(UserVariable.GetJobTypeThree(Page, HYFL.GetSelectedValue()));
            }
        }
        /// <summary>
        /// 国标行业类型（四级）、国标行业类别
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void industryThree_LostFoucus(object sender, RoutedEventArgs e)
        {
            if (!string.IsNullOrEmpty(industryThree.GetSelectedValue()))
            {
                industryFour.SetItems(UserVariable.GetJobTypeFour(Page, industryThree.GetSelectedValue()));
            }
        }
        private void FRSJHBOX_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!string.IsNullOrEmpty(FRSJHBOX.Text) && FRSJHBOX.Text.Length != 11)
            {
                ParentPage.TradeAPIs.ShowTip("手机号位数不正确");
                ParentPage.SetFocus(FRSJHBOX);
                return;
            }
        }

        private void QYYB_LostFocus(object sender, RoutedEventArgs e)
        {
            if (QYYB.Text.Trim() != string.Empty)
            {
                if (ParentPage.Len(QYYB.Text.Trim()) != 6)
                {
                    ParentPage.TradeAPIs.ShowTip("邮编号码无效，请检查");
                    //ParentPage.SetFocus(                //QYYB);
                    ParentPage.SetFocus(QYYB);
                    return;
                }
            }
        }

        public EnterpriseCustomerInfoArgs Controls
        {
            get
            {
                return this.enterpriseCustomerInfoArgs;
            }
        }

        public class EnterpriseCustomerInfoArgs
        {
            /// <summary>
            /// 公司类型
            /// </summary>
            public ComboBox GSLX { get; internal set; }
            /// <summary>
            /// 客户等级
            /// </summary>
            public ComboBox KHDJ { get; internal set; }
            /// <summary>
            /// 注册资本
            /// </summary>
            public TextBox ZCZB { get; internal set; }
            /// <summary>
            /// 营业收入
            /// </summary>
            public TextBox YYSR { get; internal set; }
            /// <summary>
            /// 员工数量
            /// </summary>
            public TextBox YGSL { get; internal set; }
            /// <summary>
            /// 贡 献 度
            /// </summary>
            public ComboBox GXD { get; internal set; }
            /// <summary>
            /// 证件类型
            /// </summary>
            public ComboBox ZJLX { get; internal set; }
            /// <summary>
            /// 证件号码
            /// </summary>
            public TextBox ZJHM { get; internal set; }
            /// <summary>
            /// 客户名称
            /// </summary>
            public TextBox KHMC { get; internal set; }
            /// <summary>
            /// 组织机构代码证
            /// </summary>
            public TextBox ZJJGDMZ { get; internal set; }
            /// <summary>
            /// 组织机构代码证有效期开始
            /// </summary>
            public TextBox YXQKS2 { get; internal set; }
            /// <summary>
            /// 组织机构代码证有效期结束
            /// </summary>
            public TextBox YXQJS2 { get; internal set; }
            /// <summary>
            /// 营业执照
            /// </summary>
            public TextBox YYZZ { get; internal set; }
            /// <summary>
            /// 营业执照有效期开始
            /// </summary>
            public TextBox YXQKS3 { get; internal set; }
            /// <summary>
            /// 营业执照有效期结束
            /// </summary>
            public TextBox YXQJS3 { get; internal set; }
            /// <summary>
            /// 其他证件号
            /// </summary>
            public TextBox QTZJ { get; internal set; }
            /// <summary>
            /// 其他证件号有效期开始
            /// </summary>
            public TextBox YXQKS4 { get; internal set; }
            /// <summary>
            /// 其他证件号有效期结束
            /// </summary>
            public TextBox YXQJS4 { get; internal set; }
            /// <summary>
            /// 统一社会信用代码证
            /// </summary>
            public TextBox JGXYDMZ { get; internal set; }
            /// <summary>
            /// 统一社会信用代码证有效期开始
            /// </summary>
            public TextBox YXQKS5 { get; internal set; }
            /// <summary>
            /// 统一社会信用代码证有效期结束
            /// </summary>
            public TextBox YXQJS5 { get; internal set; }
            /// <summary>
            /// 国税登记号
            /// </summary>
            public TextBox GSDJH { get; internal set; }
            /// <summary>
            /// 地税登记号
            /// </summary>
            public TextBox DSDJH { get; internal set; }
            /// <summary>
            /// 企业联系人
            /// </summary>
            public TextBox QYLXR { get; internal set; }
            /// <summary>
            /// 企业联系人电话
            /// </summary>
            public TextBox LXDH { get; internal set; }
            /// <summary>
            /// 传    真
            /// </summary>
            public TextBox CZ { get; internal set; }
            /// <summary>
            /// 企业邮编
            /// </summary>
            public TextBox QYYB { get; internal set; }
            /// <summary>
            /// 行业分类大类
            /// </summary>
            public ComboBox HYFL1 { get; internal set; }
            /// <summary>
            /// 行业分类小类
            /// </summary>
            public ComboBox HYFL2 { get; internal set; }
            /// <summary>
            /// 国民经济部门
            /// </summary>
            public ComboBox GMJJBM { get; internal set; }
            /// <summary>
            /// 地    区1
            /// </summary>
            public ComboBox DQ1 { get; internal set; }
            /// <summary>
            /// 地    区2
            /// </summary>
            public TextBox DQ2 { get; internal set; }
            /// <summary>
            /// 出资人经济成分
            /// </summary>
            public ComboBox CZRJJCF { get; internal set; }
            /// <summary>
            /// 企业规模
            /// </summary>
            public ComboBox QYGM { get; internal set; }
            /// <summary>
            /// 公司联系地址
            /// </summary>
            public TextBox GSLXDZ { get; internal set; }
            /// <summary>
            /// 法人证件类型
            /// </summary>
            public ComboBox FRZJLX { get; internal set; }
            /// <summary>
            /// 法人证件号码
            /// </summary>
            public TextBox FRZJH { get; internal set; }
            /// <summary>
            /// 法定代表人
            /// </summary>
            public TextBox FDDBR { get; internal set; }
            /// <summary>
            /// 国籍-法定代表人
            /// </summary>
            ///public ComboBox relNtnty { get; internal set; }
            public ComboBox RELA_COUNTRY { get; internal set; }
            /// <summary>
            /// 核查结果-法定代表人
            /// </summary>
            ///public ComboBox HCJG { get; internal set; }
            public ComboBox RELA_VERIFICAION { get; internal set; }
            /// <summary>
            /// 联网标志-法定代表人
            /// </summary>
            ///public ComboBox LWBZ { get; internal set; }
            public ComboBox RELA_VERIFICATION_RESULT { get; internal set; }
            /// <summary>
            /// 佐证证件-法定代表人
            /// </summary>
            ///public ComboBox ZZZJ { get; internal set; }
            public ComboBox RELA_PROOF { get; internal set; }
            /// <summary>
            /// 代理人证件类型
            /// </summary>
            public ComboBox DLRZJLX { get; internal set; }
            /// <summary>
            /// 代理人证件号码
            /// </summary>
            public TextBox DLRZJHM { get; internal set; }
            /// <summary>
            /// 代理人发证机关
            /// </summary>
            public TextBox FZJG1 { get; internal set; }
            /// <summary>
            /// 代理人核查结果
            /// </summary>
            public ComboBox HCJG1 { get; internal set; }
            /// <summary>
            /// 代理人联网标志
            /// </summary>
            public ComboBox LWBZ1 { get; internal set; }
            /// <summary>
            /// 代理人佐证证件
            /// </summary>
            public ComboBox ZZZJ1 { get; internal set; }
            /// <summary>
            /// 代理人姓名
            /// </summary>
            public TextBox DLRXM { get; internal set; }
            /// <summary>
            /// 代理人联系方式
            /// </summary>
            public TextBox DLRLXFS { get; internal set; }
            /// <summary>
            /// 主证件类型
            /// </summary>
            public ComboBox ZZJLX { get; internal set; }
            /// <summary>
            /// tb主证件类型
            /// </summary>
            public TextBlock tb_zzj_type { get; internal set; }
        }

        private void QY_TYPE_GotFocus(object sender, RoutedEventArgs e)
        {
            RaiseGotFocus();
            //Set_empty();

        }

        private void Set_empty()
        {
            ZCZB.Text = string.Empty;
            YYSR.Text = string.Empty;
            YGSL.Text = string.Empty;
            ZJHM3.Text = string.Empty;
            diqu2.Text = string.Empty;
            //ZJHM1.Text = string.Empty;
            //Beg_date1.Text = string.Empty;
            //End_date1.Text = string.Empty;
            //ZJHM2.Text = string.Empty;
            //Beg_date2.Text = string.Empty;
            //End_date2.Text = string.Empty;
            //ZJHM5.Text = string.Empty;
            //Beg_date5.Text = string.Empty;
            //End_date5.Text = string.Empty;
            //ZJHM6.Text = string.Empty;
            //Beg_date6.Text = string.Empty;
            //End_date6.Text = string.Empty;
            //ZJHM7.Text = string.Empty;
            //Beg_date7.Text = string.Empty;
            //End_date7.Text = string.Empty;
            KHXM1.Text = string.Empty;
            GSDZH.Text = string.Empty;
            DSDZH.Text = string.Empty;
            QY_NAME.Text = string.Empty;
            TEL1.Text = string.Empty;
            FAX1.Text = string.Empty;
            FRSJHBOX.Text = string.Empty;
            QYYB.Text = string.Empty;
            JYXM.Text = string.Empty;
            ZCDZ.Text = string.Empty;
            ADDR1.Text = string.Empty;
            FDSF.Text = string.Empty;
            FDDB.Text = string.Empty;
            //AGENT_ID_NO.Text = string.Empty;
            //FZJG2.Text = string.Empty;
            //AGENT_NAME.Text = string.Empty;
            //AGENT_PHONE.Text = string.Empty;
            //FocusManagerExt.SetAssertNotEmpty(Beg_date1, false);
            //FocusManagerExt.SetAssertNotEmpty(End_date1, false);
            //FocusManagerExt.SetAssertNotEmpty(Beg_date2, false);
            //FocusManagerExt.SetAssertNotEmpty(End_date2, false);
            //FocusManagerExt.SetAssertNotEmpty(Beg_date5, false);
            //FocusManagerExt.SetAssertNotEmpty(End_date5, false);
            //FocusManagerExt.SetAssertNotEmpty(Beg_date6, false);
            //FocusManagerExt.SetAssertNotEmpty(End_date6, false);
        }
        private void FZR_type_LostFocus(object sender, RoutedEventArgs e)
        {
            cwfzr.Visibility = CW_FZR.Visibility = cwzjh.Visibility = cwzjlx.Visibility = Visibility.Visible;
            date.Visibility = cwtel.Visibility = CW_certNo.Visibility = CW_certType.Visibility = Visibility.Visible;
            CW_tel.Visibility = fzrlx.Visibility = CW_type.Visibility = CW_Sdate.Visibility = Visibility.Visible;
            if (FZR_type.GetSelectedValue() == "09")
            {
                fzr.Text = "代表人证件类型";
                title_FDSF.Text = "代表人证件号码";
                title_FDDB.Text = "法定代表人";
                FRGJ.Text = "法人国籍";
                FRSJH.Text = "法人手机号码";
            }
            else if (FZR_type.GetSelectedValue().Equals("13"))
            {
                cwfzr.Visibility = CW_FZR.Visibility = cwzjh.Visibility = cwzjlx.Visibility = Visibility.Collapsed;
                date.Visibility = cwtel.Visibility = CW_certNo.Visibility = CW_certType.Visibility = Visibility.Collapsed;
                CW_tel.Visibility = fzrlx.Visibility = CW_type.Visibility = CW_Sdate.Visibility = Visibility.Collapsed;
            }
            else
            {
                fzr.Text = "负责人证件类型";
                title_FDSF.Text = "负责人证件号码";
                title_FDDB.Text = "单位代表人";
                FRGJ.Text = "负责人国籍";
                FRSJH.Text = "负责人手机号码";
            }
            FDSF.Text = "";//证件号码
            FDDB.Text = "";//关系人姓名
            FR_Beg_date.Text = "";//关系人签发日期
            FR_End_date.Text = "";//关系人到期日期           
            FRSJHBOX.Text = "";//关系人 手机号        

            if (lxrList != null && lxrList.Count > 0)
            {
                foreach (Dictionary<string, object> relaDic in lxrList)
                {
                    if (((Dictionary<string, object>)relaDic)["relType"].ToString() == FZR_type.GetSelectedValue())
                    {
                        if (relaDic["relCertType"] != null && relaDic["relCertType"].ToString() != "")
                        {
                            FDDB_ID_TYPE.SetSelectedValue(relaDic["relCertType"]);//法人证件类型
                        }
                        else
                        {
                            FDDB_ID_TYPE.SelectedIndex = -1;
                        }
                        FDSF.Text = (string)relaDic["relCertNo"];//证件号码
                        FDDB.Text = (string)relaDic["relName"];//关系人姓名
                        FR_Beg_date.Text = (string)relaDic["relIssuDate"];//关系人签发日期
                        FR_End_date.Text = (string)relaDic["relMtrDate"];//关系人到期日期
                        if (relaDic["relNtnty"] != null && (string)relaDic["relNtnty"] != "")
                        {
                            relNtnty.SetSelectedValue(relaDic["relNtnty"]);//关系人 国籍
                        }
                        else
                        {
                            relNtnty.SelectedIndex = -1;
                        }
                        FRSJHBOX.Text = (string)relaDic["relKeyTel"];//关系人 手机号
                        if ((string)relaDic["relCertChkFlag"] != "" && relaDic["relCertChkFlag"] != null)
                        {
                            HCJG1.SetSelectedValue(relaDic["relCertChkFlag"]);//关系人核查结果
                        }
                        else
                        {
                            HCJG1.SelectedIndex = -1;
                        }
                        if ((string)relaDic["relVerificationRslt"] != "" && relaDic["relVerificationRslt"] != null)
                        {
                            LW_FLG1.SetSelectedValue(relaDic["relVerificationRslt"]);//联网标志
                        }
                        else
                        {
                            LW_FLG1.SelectedIndex = -1;
                        }
                        if ((string)relaDic["relProof"] != "" && relaDic["relProof"] != null)
                        {
                            ZZZZ1.SetSelectedValue(relaDic["relProof"]);//佐证
                        }
                        else
                        {
                            ZZZZ1.SelectedIndex = -1;
                        }
                    }
                }
            }

        }
        //private void ZJHM2_LostFocus(object sender, RoutedEventArgs e)
        //{
        //    //版本控制定义 
        //    string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        //    if (ZJHM2.Text.Trim() != "")
        //    {
        //        //新增加将证件号码字母自动转为大写
        //        string id_no = ZJHM2.Text.Trim().ToUpper();
        //        ZJHM2.Text = id_no;
        //        //新增 证件号码与主证件号码一致 20160706 add by WH
        //        if (MID_TYPE.GetSelectedValue() == "214")
        //        {
        //            if (!string.IsNullOrEmpty(ZJHM3.Text.Trim()))
        //            {
        //                if (ZJHM3.Text.Trim() != ZJHM2.Text.Trim())
        //                {
        //                    ParentPage.TradeAPIs.ShowTip("证件号码不一致，请检查！");
        //                    ParentPage.SetFocus(ZJHM2);
        //                }
        //            }
        //        }
        //        if (!IsUpdate)
        //        {
        //            var output = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input {qryType="1", ZJHM = ZJHM2.Text, ZJLX = "214" });
        //            if (output.IsFailed)
        //            {
        //                ParentPage.TradeAPIs.ShowTip(output.FailureCause);
        //                ParentPage.SetFocus(ZJHM2);
        //                return;
        //            }

        //            var data = output.WJ;
        //            if (output.WJData.Count == 0)
        //            {
        //                data = "客户未建立客户信息";
        //            }
        //            #region /*客户信息不存在时，系统同样弹出对话框，但无任何记录，因此无需弹窗提示*/
        //            if (output.WJData.Count != 0)
        //            {
        //                var selectedData = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, data, new string[] { "客户编号", "客户名称", "证件号码" }, 500, 200);
        //                if (selectedData == null)
        //                {
        //                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N042));
        //                    ParentPage.SetFocus(ZJHM2);
        //                    return;
        //                }
        //                if (selectedData["客户编号"].ToString() != "客户未建立客户信息")
        //                {
        //                    ParentPage.TradeAPIs.ShowTip("该证件已建立客户信息");
        //                    ParentPage.SetFocus(ZJHM2);
        //                    return;
        //                }
        //            }
        //            #endregion
        //        }
        //        else
        //        {
        //            var output1 = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input {qryType="1", ZJLX = "214", ZJHM = ZJHM2.Text });
        //            if (output1.IsFailed)
        //            {
        //                ParentPage.TradeAPIs.ShowTip(output1.FailureCause);
        //                ParentPage.SetFocus(ZJHM2);
        //                return;
        //            }
        //            if (OldFile.Trim() != ZJHM2.Text.Trim() && !string.IsNullOrEmpty(output1.WJ))
        //            {
        //                ParentPage.TradeAPIs.ShowTip("该证件已经被使用");
        //                ParentPage.SetFocus(ZJHM2);
        //                return;
        //            }
        //        }
        //        FocusManagerExt.SetAssertNotEmpty(Beg_date2, true);
        //        FocusManagerExt.SetAssertNotEmpty(End_date2, false);
        //        if (FLAG == "V0")
        //        {
        //            FocusManagerExt.SetAssertNotEmpty(End_date2, true);
        //        }
        //        Beg_date2.IsEnabled = true;
        //        End_date2.IsEnabled = true;
        //        if (End_date2.Text == "")
        //        {
        //            End_date2.Text = "99991231";
        //        }
        //    }
        //    else
        //    {
        //        Beg_date2.IsEnabled = false;
        //        End_date2.IsEnabled = false;
        //        Beg_date2.Clear();
        //        End_date2.Clear();
        //    }
        //}

        //private void Beg_date2_LostFocus(object sender, RoutedEventArgs e)
        //{
        //    if (Beg_date2.Text.Trim() != "")
        //    {
        //        if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(Beg_date2.Text))
        //        {
        //            ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
        //            ParentPage.SetFocus(Beg_date2);
        //            return;
        //        }
        //    }
        //}

        //private void End_date2_LostFocus(object sender, RoutedEventArgs e)
        //{
        //    if (End_date2.Text == "" || End_date2.Text == "99999999")
        //    {
        //        End_date2.Text = "99991231";
        //    }
        //    if (End_date2.Text.Trim() != "")
        //    {
        //        if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(End_date2.Text))
        //        {
        //            ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
        //            ParentPage.SetFocus(End_date2);
        //            return;
        //        }
        //        if (ParentPage.Atoi(End_date2.Text) < ParentPage.Atoi(Beg_date2.Text))
        //        {
        //            ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
        //            ParentPage.SetFocus(End_date2);
        //            return;
        //        }
        //    }
        //}

        //private void ZJHM5_GotFocus(object sender, RoutedEventArgs e)
        //{
        //    //版本控制定义 
        //    string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        //    if (FLAG == "V0" || FLAG == "V11")
        //    {
        //        ZJHM5.MaxLength = 20;
        //    }
        //    else
        //    {
        //        ZJHM5.MaxLength = 18;
        //    }
        //}

        private void FR_Beg_date_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(FR_Beg_date.Text))
            {
                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                ParentPage.SetFocus(FR_Beg_date);
                return;
            }
        }
        private void FR_End_date_LostFocus(object sender, RoutedEventArgs e)
        {
            if (FR_End_date.Text.Trim() == "99999999")
            {
                FR_End_date.Text = "99991231";
                return;
            }
            if (FDSF.Text.Trim() == "" && (FR_Beg_date.Text.Trim() != "" || FR_End_date.Text.Trim() != ""))
            {
                ParentPage.TradeAPIs.ShowTip("证件号码为空时，有效期必须为空");
                ParentPage.SetFocus(FR_Beg_date);
                return;
            }
            if (FDSF.Text.Trim() != "")
            {
                if (FR_Beg_date.Text.Trim() != "" && FR_End_date.Text.Trim() != "")
                {
                    if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(FR_End_date.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                        ParentPage.SetFocus(FR_End_date);
                        return;
                    }
                    if (ParentPage.Atoi(FR_End_date.Text) < ParentPage.Atoi(FR_Beg_date.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                        ParentPage.SetFocus(FR_End_date);
                        return;
                    }
                }
                else if ((FR_End_date.Text.Trim() == "" && FR_Beg_date.Text.Trim() != "") || (FR_End_date.Text.Trim() != "" && FR_Beg_date.Text.Trim() == ""))
                {
                    ParentPage.TradeAPIs.ShowTip("请输入完整的有效期");
                    ParentPage.SetFocus(FR_End_date);
                    return;
                }
            }
        }

        private void CW_certType_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!ParentPage.SetInputOfIdCard(CW_certNo, (CW_certType.GetSelectedValue() == "B01")))
            {
                ParentPage.SetFocus(CW_certType);
                return;
            }
            else
            {
                ParentPage.SetInputOfIdCard(CW_certNo, (CW_certType.GetSelectedValue() == "B01"));
            }
        }

        //private void AGENT_End_date_LostFocus(object sender, RoutedEventArgs e)
        //{
        //    if (AGENT_End_date.Text.Trim() == "99999999")
        //    {
        //        AGENT_End_date.Text = "99991231";
        //        return;
        //    }
        //    if (AGENT_ID_NO.Text.Trim() == "" && AGENT_End_date.Text.Trim() != "")
        //    {
        //        ParentPage.TradeAPIs.ShowTip("证件号码为空时，有效期必须为空");
        //        ParentPage.SetFocus(FR_Beg_date);
        //        return;
        //    }
        //    if (AGENT_ID_NO.Text.Trim() != "")
        //    {
        //        if ( AGENT_End_date.Text.Trim() != "")
        //        {
        //            if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(AGENT_End_date.Text))
        //            {
        //                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
        //                ParentPage.SetFocus(AGENT_End_date);
        //                return;
        //            }

        //        }
        //    }

        //}
        public void zjxxdgHidde()
        {
            zjxxdg.Visibility = Visibility.Collapsed;
        }

        private void BZ_LostFocus(object sender, RoutedEventArgs e)
        {
        }
        private void ZCZB_GotFocus(object sender, RoutedEventArgs e)
        {
            ParentPage.TradeAPIs.ShowTip(ZCZB, "金额单位为万元，请注意！");
        }
        private void YYSR_GotFocus(object sender, RoutedEventArgs e)
        {
            ParentPage.TradeAPIs.ShowTip(YYSR, "金额单位为万元，请注意！");
        }
        /// <summary>
        /// 初始化域
        /// </summary>
        /// <param name="message"></param>
        protected void InitFd(Message message)
        {
            message.Init();
        }
        ///// <summary>
        ///// 渠道(json)
        ///// </summary>
        ///// <param name="message"></param>
        ///// <returns></returns>
        //protected Message CommSendESB(Message message)
        //{
        //    message.requestHeader.txMode = "SYNC";
        //    message.requestHeader.sourceSysTranDate = message.requestHeader.nearSysTranDate = LoginUserInfo.TradeDate;
        //    message.requestHeader.sourceSysTimeStamp = message.requestHeader.nearSysTimeStamp = DateTime.Now.ToString("HHmmss");
        //    message.requestHeader.sourceSysCode = UserVariable.TLER;
        //    message.requestHeader.glsTraceNo = "";            //全局流水          
        //    message.requestHeader.nearSysId = UserVariable.TLER;            //近端系统编码
        //    message.requestHeader.nearSysTraceNo = "";            //近端流水
        //    message.requestHeader.ttyId = "";//终端标识
        //    message.requestCommParmToESB.timeStamp = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss.sss");//时间戳
        //    message.requestCommParmToESB.sysCode = UserVariable.ECIF;//请求标识
        //    message.requestCommParmToESB.txBrNo = "BOP-202009216900";//机构编码
        //    message.requestCommParmToESB.chnlCode = UserVariable.TLER;//渠道应用编码
        //    message.requestCommParmToESB.version = "1.0.0";//版本
        //    message.requestCommParmToESB.access_token = TradeHandle.GetESBToKen();
        //    return message;
        //}
        ///// <summary>
        ///// Ecif
        ///// </summary>
        ///// <param name="target"></param>
        ///// <param name="message"></param>
        //protected void CommSendECIF(Message message)
        //{

        //    #region ecif
        //    message.requestBusHeadForEsb.pgNo = ""; //页码
        //    message.requestBusHeadForEsb.pgRcdNum = "";//每页记录数
        //    message.requestHeader.txBrNo = "BOP-202009216900";
        //    message.requestBusHeadForEsb.filePath = "";//文件类型 批量开户及名单导入使用
        //    message.requestBusHeadForEsb.emplyNo = LoginUserInfo.TellerNo;//员工编号
        //    message.requestBusHeadForEsb.brNo = LoginUserInfo.KinbrNo;//机构号
        //    message.requestBusHeadForEsb.legalBrNo = LoginUserInfo.LegalBrNo;//法人代码
        //    message.requestCommParmToESB.sysCode = UserVariable.ECIF;//请求标识
        //    CommSendESB(message);
        //    message.requestBusHeadForEsb.trdBrno = LoginUserInfo.KinbrNo;//机构号
        //    message.requestBusHeadForEsb.tellNo = LoginUserInfo.TellerNo;//柜员号
        //    message.requestBusHeadForEsb.eciTime = LoginUserInfo.TradeDate;//交易日期
        //    message.requestBusHeadForEsb.tx_Time = DateTime.Now.ToString("HH:mm:ss");//时间戳
        //    message.requestBusHeadForEsb.termId = LoginUserInfo.TtyName;
        //    #endregion
        //}
        protected bool CallEsb(Message message)
        {
            return message.DoTransit();
        }

        private void SYRZJLX1_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!ParentPage.SetInputOfIdCard(SYRZJHM1, (SYRZJLX1.GetSelectedValue() == "B01")))
            {
                ParentPage.SetFocus(SYRZJLX1);
                return;
            }
            else
            {
                ParentPage.SetInputOfIdCard(SYRZJHM1, (SYRZJLX1.GetSelectedValue() == "B01"));
            }
            if (SYRZJLX1.GetSelectedKey().Contains("身份证"))
                DeviceManager.SetIdentityCardReader(SYRZJHM1, IdentityCardReaderType.ReadCardOrInput);
            else
                DeviceManager.SetIdentityCardReader(SYRZJHM1, IdentityCardReaderType.Input);
        }

        private void SYRZJHM1_LostFocus(object sender, RoutedEventArgs e)
        {
            //新增加将证件号码字母自动转为大写
            string id_no = SYRZJHM1.Text.Trim().ToUpper();
            SYRZJHM1.Text = id_no;

            //初始化控件
            SYRXM1.IsReadOnly = false;

            if (SYRZJHM1.Text.Trim() != "")
            {
                if (SYRZJLX1.GetSelectedValue() == "B01")
                {
                    var IdData = DeviceManager.GetIdentityCardData(SYRZJHM1);
                    if (!string.IsNullOrEmpty(IdData.Data.IdNumber))
                    {
                        SYRZJHM1.Text = IdData.Data.IdNumber;
                    }
                    if (!string.IsNullOrEmpty(IdData.Data.Name))
                    {
                        SYRXM1.Text = IdData.Data.Name;
                    }
                    //检查长度，务必保证18位
                    if (ParentPage.Len(SYRZJHM1.Text) != 18)
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N003));
                        ParentPage.SetFocus(SYRZJHM1);
                        return;
                    }
                    //根据证件类型和号码查询客户是否黑名单/灰名单
                    //var black = ParentPage.TradeAPIs.TF_Customer_QueryBlackList(new QueryBlackList.Input { ZJLX = UserVariable.EcifIdTypeChangeToCbs(SYRZJLX1.GetSelectedValue(), "2"), ZJHM = SYRZJHM1.Text });
                    //if (black.IsFailed)
                    //{
                    //    ParentPage.SetFocus(SYRZJHM1);
                    //    ParentPage.ShowInfoMessageBox("查询黑名单出错" + black.FailureCause);
                    //    return;
                    //}
                    //if (!black.IsFailed && black.isBlackList == true)
                    //{
                    //    ParentPage.SetFocus(SYRZJHM1);
                    //    ParentPage.TradeAPIs.ShowErrorMessageBox("黑名单账户或客户不允许进行交易"); ;
                    //    return;
                    //}
                    //if (!black.IsFailed && black.isGreyList == true)
                    //{
                    //    ParentPage.TradeAPIs.ShowInfoMessageBox("账户或客户存在灰名单记录，请谨慎交易");

                    //}
                    //调用sp8015.c对输入身份证进行验证080315
                    var output = ParentPage.TradeAPIs.TF_Deposit_IDNumberVerification(new IDNumberVerification.Input
                    {
                        ZJLX = "1",
                        ZJHM = SYRZJHM1.Text
                    });
                    if (output.IsFailed)
                    {
                        ParentPage.TradeAPIs.ShowTip(output.FailureCause);
                        ParentPage.SetFocus(SYRZJHM1);
                        return;
                    }
                    if (output.YZTGBZ[0] != '1')
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
                        ParentPage.SetFocus(SYRZJHM1);
                        return;
                    }
                    SYRZJHM1.Text = ParentPage.TradeAPIs.Delspace(output.ZJHM);
                }
            }
        }

        private void SYRZJLX2_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!ParentPage.SetInputOfIdCard(SYRZJHM2, (SYRZJLX2.GetSelectedValue() == "B01")))
            {
                ParentPage.SetFocus(SYRZJLX2);
                return;
            }
            else
            {
                ParentPage.SetInputOfIdCard(SYRZJHM2, (SYRZJLX2.GetSelectedValue() == "B01"));
            }
            if (SYRZJLX2.GetSelectedKey().Contains("身份证"))
                DeviceManager.SetIdentityCardReader(SYRZJHM2, IdentityCardReaderType.ReadCardOrInput);
            else
                DeviceManager.SetIdentityCardReader(SYRZJHM2, IdentityCardReaderType.Input);
        }

        private void SYRZJHM2_LostFocus(object sender, RoutedEventArgs e)
        {
            //新增加将证件号码字母自动转为大写
            string id_no = SYRZJHM2.Text.Trim().ToUpper();
            SYRZJHM2.Text = id_no;

            //初始化控件
            SYRXM2.IsReadOnly = false;

            if (SYRZJHM2.Text.Trim() != "")
            {
                if (SYRZJLX2.GetSelectedValue() == "B01")
                {
                    var IdData = DeviceManager.GetIdentityCardData(SYRZJHM2);
                    if (!string.IsNullOrEmpty(IdData.Data.IdNumber))
                    {
                        SYRZJHM2.Text = IdData.Data.IdNumber;
                    }
                    if (!string.IsNullOrEmpty(IdData.Data.Name))
                    {
                        SYRXM2.Text = IdData.Data.Name;
                    }
                    //检查长度，务必保证18位
                    if (ParentPage.Len(SYRZJHM2.Text) != 18)
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N003));
                        ParentPage.SetFocus(SYRZJHM2);
                        return;
                    }
                    //根据证件类型和号码查询客户是否黑名单/灰名单
                    //var black = ParentPage.TradeAPIs.TF_Customer_QueryBlackList(new QueryBlackList.Input { ZJLX = UserVariable.EcifIdTypeChangeToCbs(SYRZJLX2.GetSelectedValue(), "2"), ZJHM = SYRZJHM2.Text });
                    //if (black.IsFailed)
                    //{
                    //    ParentPage.SetFocus(SYRZJHM2);
                    //    ParentPage.ShowInfoMessageBox("查询黑名单出错" + black.FailureCause);
                    //    return;
                    //}
                    //if (!black.IsFailed && black.isBlackList == true)
                    //{
                    //    ParentPage.SetFocus(SYRZJHM2);
                    //    ParentPage.TradeAPIs.ShowErrorMessageBox("黑名单账户或客户不允许进行交易"); ;
                    //    return;
                    //}
                    //if (!black.IsFailed && black.isGreyList == true)
                    //{
                    //    ParentPage.TradeAPIs.ShowInfoMessageBox("账户或客户存在灰名单记录，请谨慎交易");

                    //}
                    //调用sp8015.c对输入身份证进行验证080315
                    var output = ParentPage.TradeAPIs.TF_Deposit_IDNumberVerification(new IDNumberVerification.Input
                    {
                        ZJLX = "1",
                        ZJHM = SYRZJHM2.Text
                    });
                    if (output.IsFailed)
                    {
                        ParentPage.TradeAPIs.ShowTip(output.FailureCause);
                        ParentPage.SetFocus(SYRZJHM2);
                        return;
                    }
                    if (output.YZTGBZ[0] != '1')
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
                        ParentPage.SetFocus(SYRZJHM2);
                        return;
                    }
                    SYRZJHM2.Text = ParentPage.TradeAPIs.Delspace(output.ZJHM);
                }
            }
        }

        private void SYRZJLX3_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!ParentPage.SetInputOfIdCard(SYRZJHM3, (SYRZJLX3.GetSelectedValue() == "B01")))
            {
                ParentPage.SetFocus(SYRZJLX3);
                return;
            }
            else
            {
                ParentPage.SetInputOfIdCard(SYRZJHM3, (SYRZJLX3.GetSelectedValue() == "B01"));
            }
            if (SYRZJLX2.GetSelectedKey().Contains("身份证"))
                DeviceManager.SetIdentityCardReader(SYRZJHM3, IdentityCardReaderType.ReadCardOrInput);
            else
                DeviceManager.SetIdentityCardReader(SYRZJHM3, IdentityCardReaderType.Input);
        }

        private void SYRZJHM3_LostFocus(object sender, RoutedEventArgs e)
        {
            //新增加将证件号码字母自动转为大写
            string id_no = SYRZJHM3.Text.Trim().ToUpper();
            SYRZJHM3.Text = id_no;

            //初始化控件
            SYRXM3.IsReadOnly = false;

            if (SYRZJHM3.Text.Trim() != "")
            {
                if (SYRZJLX3.GetSelectedValue() == "B01")
                {
                    var IdData = DeviceManager.GetIdentityCardData(SYRZJHM3);
                    if (!string.IsNullOrEmpty(IdData.Data.IdNumber))
                    {
                        SYRZJHM3.Text = IdData.Data.IdNumber;
                    }
                    if (!string.IsNullOrEmpty(IdData.Data.Name))
                    {
                        SYRXM3.Text = IdData.Data.Name;
                    }
                    //检查长度，务必保证18位
                    if (ParentPage.Len(SYRZJHM3.Text) != 18)
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N003));
                        ParentPage.SetFocus(SYRZJHM3);
                        return;
                    }
                    //根据证件类型和号码查询客户是否黑名单/灰名单
                    //var black = ParentPage.TradeAPIs.TF_Customer_QueryBlackList(new QueryBlackList.Input { ZJLX = UserVariable.EcifIdTypeChangeToCbs(SYRZJLX3.GetSelectedValue(), "2"), ZJHM = SYRZJHM3.Text });
                    //if (black.IsFailed)
                    //{
                    //    ParentPage.SetFocus(SYRZJHM3);
                    //    ParentPage.ShowInfoMessageBox("查询黑名单出错" + black.FailureCause);
                    //    return;
                    //}
                    //if (!black.IsFailed && black.isBlackList == true)
                    //{
                    //    ParentPage.SetFocus(SYRZJHM3);
                    //    ParentPage.TradeAPIs.ShowErrorMessageBox("黑名单账户或客户不允许进行交易"); ;
                    //    return;
                    //}
                    //if (!black.IsFailed && black.isGreyList == true)
                    //{
                    //    ParentPage.TradeAPIs.ShowInfoMessageBox("账户或客户存在灰名单记录，请谨慎交易");

                    //}

                    //调用sp8015.c对输入身份证进行验证080315
                    var output = ParentPage.TradeAPIs.TF_Deposit_IDNumberVerification(new IDNumberVerification.Input
                    {
                        ZJLX = "1",
                        ZJHM = SYRZJHM3.Text
                    });
                    if (output.IsFailed)
                    {
                        ParentPage.TradeAPIs.ShowTip(output.FailureCause);
                        ParentPage.SetFocus(SYRZJHM3);
                        return;
                    }
                    if (output.YZTGBZ[0] != '1')
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
                        ParentPage.SetFocus(SYRZJHM3);
                        return;
                    }
                    SYRZJHM3.Text = ParentPage.TradeAPIs.Delspace(output.ZJHM);
                }
            }
        }

        private void SYRZJLX4_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!ParentPage.SetInputOfIdCard(SYRZJHM4, (SYRZJLX4.GetSelectedValue() == "B01")))
            {
                ParentPage.SetFocus(SYRZJLX4);
                return;
            }
            else
            {
                ParentPage.SetInputOfIdCard(SYRZJHM4, (SYRZJLX4.GetSelectedValue() == "B01"));
            }
            if (SYRZJLX4.GetSelectedKey().Contains("身份证"))
                DeviceManager.SetIdentityCardReader(SYRZJHM4, IdentityCardReaderType.ReadCardOrInput);
            else
                DeviceManager.SetIdentityCardReader(SYRZJHM4, IdentityCardReaderType.Input);
        }

        private void SYRZJHM4_LostFocus(object sender, RoutedEventArgs e)
        {
            //新增加将证件号码字母自动转为大写
            string id_no = SYRZJHM4.Text.Trim().ToUpper();
            SYRZJHM4.Text = id_no;

            //初始化控件
            SYRXM4.IsReadOnly = false;

            if (SYRZJHM4.Text.Trim() != "")
            {
                if (SYRZJLX4.GetSelectedValue() == "B01")
                {
                    var IdData = DeviceManager.GetIdentityCardData(SYRZJHM4);
                    if (!string.IsNullOrEmpty(IdData.Data.IdNumber))
                    {
                        SYRZJHM4.Text = IdData.Data.IdNumber;
                    }
                    if (!string.IsNullOrEmpty(IdData.Data.Name))
                    {
                        SYRXM4.Text = IdData.Data.Name;
                    }
                    //根据证件类型和号码查询客户是否黑名单/灰名单
                    //var black = ParentPage.TradeAPIs.TF_Customer_QueryBlackList(new QueryBlackList.Input { ZJLX = UserVariable.EcifIdTypeChangeToCbs(SYRZJLX4.GetSelectedValue(), "2"), ZJHM = SYRZJHM4.Text });
                    //if (black.IsFailed)
                    //{
                    //    ParentPage.SetFocus(SYRZJHM4);
                    //    ParentPage.ShowInfoMessageBox("查询黑名单出错" + black.FailureCause);
                    //    return;
                    //}
                    //if (!black.IsFailed && black.isBlackList == true)
                    //{
                    //    ParentPage.SetFocus(SYRZJHM4);
                    //    ParentPage.TradeAPIs.ShowErrorMessageBox("黑名单账户或客户不允许进行交易"); ;
                    //    return;
                    //}
                    //if (!black.IsFailed && black.isGreyList == true)
                    //{
                    //    ParentPage.TradeAPIs.ShowInfoMessageBox("账户或客户存在灰名单记录，请谨慎交易");

                    //}
                    //检查长度，务必保证18位
                    if (ParentPage.Len(SYRZJHM4.Text) != 18)
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N003));
                        ParentPage.SetFocus(SYRZJHM4);
                        return;
                    }
                    //调用sp8015.c对输入身份证进行验证080315
                    var output = ParentPage.TradeAPIs.TF_Deposit_IDNumberVerification(new IDNumberVerification.Input { ZJLX = "1", ZJHM = SYRZJHM4.Text });

                    if (output.IsFailed)
                    {
                        ParentPage.TradeAPIs.ShowTip(output.FailureCause);
                        ParentPage.SetFocus(SYRZJHM4);
                        return;
                    }
                    if (output.YZTGBZ[0] != '1')
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
                        ParentPage.SetFocus(SYRZJHM4);
                        return;
                    }
                    SYRZJHM4.Text = ParentPage.TradeAPIs.Delspace(output.ZJHM);
                }
            }
        }
        //天山受益人事件
        private void SYR_Beg_date1_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(SYR_Beg_date1.Text))
            {
                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                ParentPage.SetFocus(SYR_Beg_date1);
                return;
            }
        }
        //天山受益人事件
        private void SYR_End_date1_LostFocus(object sender, RoutedEventArgs e)
        {
            if (SYR_End_date1.Text.Trim() == "99999999")
            {
                SYR_End_date1.Text = "99991231";
                return;
            }
            if (SYRZJHM1.Text.Trim() == "" && (SYR_Beg_date1.Text.Trim() != "" || SYR_End_date1.Text.Trim() != ""))
            {
                ParentPage.TradeAPIs.ShowTip("证件号码为空时，有效期必须为空");
                ParentPage.SetFocus(SYR_Beg_date1);
                return;
            }
            if (SYRZJHM1.Text.Trim() != "")
            {
                if (SYR_Beg_date1.Text.Trim() != "" && SYR_End_date1.Text.Trim() != "")
                {
                    if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(SYR_End_date1.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                        ParentPage.SetFocus(SYR_End_date1);
                        return;
                    }
                    if (ParentPage.Atoi(SYR_End_date1.Text) < ParentPage.Atoi(SYR_Beg_date1.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                        ParentPage.SetFocus(SYR_End_date1);
                        return;
                    }
                }
                else if ((SYR_End_date1.Text.Trim() == "" && SYR_Beg_date1.Text.Trim() != "") || (SYR_End_date1.Text.Trim() != "" && SYR_Beg_date1.Text.Trim() == ""))
                {
                    ParentPage.TradeAPIs.ShowTip("请输入完整的有效期");
                    ParentPage.SetFocus(SYR_End_date1);
                    return;
                }
            }
        }

        private void SYR_Beg_date2_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(SYR_Beg_date2.Text))
            {
                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                ParentPage.SetFocus(SYR_Beg_date2);
                return;
            }
        }

        private void SYR_End_date2_LostFocus(object sender, RoutedEventArgs e)
        {
            if (SYR_End_date2.Text.Trim() == "99999999")
            {
                SYR_End_date2.Text = "99991231";
                return;
            }
            if (SYRZJHM2.Text.Trim() == "" && (SYR_Beg_date2.Text.Trim() != "" || SYR_End_date2.Text.Trim() != ""))
            {
                ParentPage.TradeAPIs.ShowTip("证件号码为空时，有效期必须为空");
                ParentPage.SetFocus(SYR_Beg_date2);
                return;
            }
            if (SYRZJHM2.Text.Trim() != "")
            {
                if (SYR_Beg_date2.Text.Trim() != "" && SYR_End_date2.Text.Trim() != "")
                {
                    if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(SYR_End_date2.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                        ParentPage.SetFocus(SYR_End_date2);
                        return;
                    }
                    if (ParentPage.Atoi(SYR_End_date2.Text) < ParentPage.Atoi(SYR_Beg_date2.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                        ParentPage.SetFocus(SYR_End_date2);
                        return;
                    }
                }
                else if ((SYR_End_date2.Text.Trim() == "" && SYR_Beg_date2.Text.Trim() != "") || (SYR_End_date2.Text.Trim() != "" && SYR_Beg_date2.Text.Trim() == ""))
                {
                    ParentPage.TradeAPIs.ShowTip("请输入完整的有效期");
                    ParentPage.SetFocus(SYR_End_date2);
                    return;
                }
            }
        }

        private void SYR_Beg_date3_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(SYR_Beg_date3.Text))
            {
                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                ParentPage.SetFocus(SYR_Beg_date3);
                return;
            }
        }

        private void SYR_End_date3_LostFocus(object sender, RoutedEventArgs e)
        {
            if (SYR_End_date3.Text.Trim() == "99999999")
            {
                SYR_End_date3.Text = "99991231";
                return;
            }
            if (SYRZJHM3.Text.Trim() == "" && (SYR_Beg_date3.Text.Trim() != "" || SYR_End_date3.Text.Trim() != ""))
            {
                ParentPage.TradeAPIs.ShowTip("证件号码为空时，有效期必须为空");
                ParentPage.SetFocus(SYR_Beg_date3);
                return;
            }
            if (SYRZJHM3.Text.Trim() != "")
            {
                if (SYR_Beg_date3.Text.Trim() != "" && SYR_End_date3.Text.Trim() != "")
                {
                    if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(SYR_End_date3.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                        ParentPage.SetFocus(SYR_End_date3);
                        return;
                    }
                    if (ParentPage.Atoi(SYR_End_date3.Text) < ParentPage.Atoi(SYR_Beg_date3.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                        ParentPage.SetFocus(SYR_End_date3);
                        return;
                    }
                }
                else if ((SYR_End_date3.Text.Trim() == "" && SYR_Beg_date3.Text.Trim() != "") || (SYR_End_date3.Text.Trim() != "" && SYR_Beg_date3.Text.Trim() == ""))
                {
                    ParentPage.TradeAPIs.ShowTip("请输入完整的有效期");
                    ParentPage.SetFocus(SYR_End_date3);
                    return;
                }
            }
        }

        private void SYR_Beg_date4_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(SYR_Beg_date4.Text))
            {
                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                ParentPage.SetFocus(SYR_Beg_date4);
                return;
            }
        }

        private void SYR_End_date4_LostFocus(object sender, RoutedEventArgs e)
        {
            if (SYR_End_date4.Text.Trim() == "99999999")
            {
                SYR_End_date4.Text = "99991231";
                return;
            }
            if (SYRZJHM4.Text.Trim() == "" && (SYR_Beg_date4.Text.Trim() != "" || SYR_End_date4.Text.Trim() != ""))
            {
                ParentPage.TradeAPIs.ShowTip("证件号码为空时，有效期必须为空");
                ParentPage.SetFocus(SYR_Beg_date4);
                return;
            }
            if (SYRZJHM4.Text.Trim() != "")
            {
                if (SYR_Beg_date4.Text.Trim() != "" && SYR_End_date4.Text.Trim() != "")
                {
                    if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(SYR_End_date4.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                        ParentPage.SetFocus(SYR_End_date4);
                        return;
                    }
                    if (ParentPage.Atoi(SYR_End_date4.Text) < ParentPage.Atoi(SYR_Beg_date4.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                        ParentPage.SetFocus(SYR_End_date4);
                        return;
                    }
                }
                else if ((SYR_End_date4.Text.Trim() == "" && SYR_Beg_date4.Text.Trim() != "") || (SYR_End_date4.Text.Trim() != "" && SYR_Beg_date4.Text.Trim() == ""))
                {
                    ParentPage.TradeAPIs.ShowTip("请输入完整的有效期");
                    ParentPage.SetFocus(SYR_End_date4);
                    return;
                }
            }
        }

        private void CW_certNo_LostFocus(object sender, RoutedEventArgs e)
        {
            if (string.IsNullOrEmpty(CW_certNo.Text))
                return;
            //新增加将证件号码字母自动转为大写
            string id_no = CW_certNo.Text.Trim().ToUpper();
            CW_certNo.Text = id_no;

            if (CW_certType.GetSelectedValue() == "B01" || CW_certType.GetSelectedValue() == "B08")
            {
                var IdData = DeviceManager.GetIdentityCardData(CW_certNo);
                if (!string.IsNullOrEmpty(IdData.Data.IdNumber))
                {
                    CW_certNo.Text = IdData.Data.IdNumber;
                }
                if (!string.IsNullOrEmpty(IdData.Data.Name))
                {
                    CW_FZR.Text = IdData.Data.Name;
                }
                //检查长度，务必保证18位
                if (ParentPage.Len(CW_certNo.Text) != 18)
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N003));
                    ParentPage.SetFocus(CW_certNo);
                    return;
                }

                //根据证件类型和号码查询客户是否黑名单/灰名单
                //var black = ParentPage.TradeAPIs.TF_Customer_QueryBlackList(new QueryBlackList.Input { ZJLX = UserVariable.EcifIdTypeChangeToCbs(CW_certType.GetSelectedValue(), "2"), ZJHM = CW_certNo.Text });
                //if (black.IsFailed)
                //{
                //    ParentPage.SetFocus(CW_certNo);
                //    ParentPage.ShowInfoMessageBox("查询黑名单出错" + black.FailureCause);
                //    return;
                //}
                //if (!black.IsFailed && black.isBlackList == true)
                //{
                //    ParentPage.SetFocus(CW_certNo);
                //    ParentPage.TradeAPIs.ShowErrorMessageBox("黑名单账户或客户不允许进行交易"); ;
                //    return;
                //}
                //if (!black.IsFailed && black.isGreyList == true)
                //{
                //    ParentPage.TradeAPIs.ShowInfoMessageBox("账户或客户存在灰名单记录，请谨慎交易");

                //}
                //数据验证
                //调用sp8015.c对输入身份证进行验证080315
                var output = ParentPage.TradeAPIs.TF_Deposit_IDNumberVerification(new IDNumberVerification.Input { ZJLX = "1", ZJHM = CW_certNo.Text });
                if (output.IsFailed)
                {
                    ParentPage.TradeAPIs.ShowTip(output.FailureCause);
                    ParentPage.SetFocus(CW_certNo);
                    return;
                }
                if (output.YZTGBZ[0] != '1')
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
                    ParentPage.SetFocus(CW_certNo);
                    return;
                }
                CW_certNo.Text = ParentPage.TradeAPIs.Delspace(output.ZJHM);
            }
        }
        private void CW_Beg_date_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(CW_Beg_date.Text))
            {
                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                ParentPage.SetFocus(CW_Beg_date);
                return;
            }
        }

        private void CW_End_date_LostFocus(object sender, RoutedEventArgs e)
        {
            if (CW_End_date.Text.Trim() == "99999999")
            {
                CW_End_date.Text = "99991231";
                return;
            }
            if (CW_certNo.Text.Trim() == "" && (CW_Beg_date.Text.Trim() != "" || CW_End_date.Text.Trim() != ""))
            {
                ParentPage.TradeAPIs.ShowTip("证件号码为空时，有效期必须为空");
                ParentPage.SetFocus(CW_Beg_date);
                return;
            }
            if (CW_certNo.Text.Trim() != "")
            {
                if (CW_Beg_date.Text.Trim() != "" && CW_End_date.Text.Trim() != "")
                {
                    if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(CW_End_date.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                        ParentPage.SetFocus(CW_End_date);
                        return;
                    }
                    if (ParentPage.Atoi(CW_End_date.Text) < ParentPage.Atoi(CW_Beg_date.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                        ParentPage.SetFocus(CW_End_date);
                        return;
                    }
                }
                else if ((CW_End_date.Text.Trim() == "" && CW_Beg_date.Text.Trim() != "") || (CW_End_date.Text.Trim() != "" && CW_Beg_date.Text.Trim() == ""))
                {
                    ParentPage.TradeAPIs.ShowTip("请输入完整的有效期");
                    ParentPage.SetFocus(CW_End_date);
                    return;
                }
            }
        }
        private void SYRXM1_LostFocus(object sender, RoutedEventArgs e)
        {
            if (string.IsNullOrWhiteSpace(SYRXM1.Text.Trim()))
            {
                SYRZJHM1.Text = SYR_Beg_date1.Text = SYR_End_date1.Text = SYRLXDH1.Text = SYRZJDZ1.Text = string.Empty;
                SYRXM2.Text = SYRZJHM2.Text = SYR_Beg_date2.Text = SYR_End_date2.Text = SYRLXDH2.Text = SYRZJDZ2.Text = string.Empty;
                SYRXM3.Text = SYRZJHM3.Text = SYR_Beg_date3.Text = SYR_End_date3.Text = SYRLXDH3.Text = SYRZJDZ3.Text = string.Empty;
                SYRXM4.Text = SYRZJHM4.Text = SYR_Beg_date4.Text = SYR_End_date4.Text = SYRLXDH4.Text = SYRZJDZ4.Text = string.Empty;
                SYRXX2.Visibility = SYRXX3.Visibility = SYRXX4.Visibility = Visibility.Collapsed;
            }
            else
            {
                SYRXX2.Visibility = Visibility.Visible;
            }
        }
        private void SYRXM2_LostFocus(object sender, RoutedEventArgs e)
        {
            if (string.IsNullOrWhiteSpace(SYRXM2.Text.Trim()))
            {
                SYRZJHM2.Text = SYR_Beg_date2.Text = SYR_End_date2.Text = SYRLXDH2.Text = SYRZJDZ2.Text = string.Empty;
                SYRXM3.Text = SYRZJHM3.Text = SYR_Beg_date3.Text = SYR_End_date3.Text = SYRLXDH3.Text = SYRZJDZ3.Text = string.Empty;
                SYRXM4.Text = SYRZJHM4.Text = SYR_Beg_date4.Text = SYR_End_date4.Text = SYRLXDH4.Text = SYRZJDZ4.Text = string.Empty;
                SYRXX3.Visibility = SYRXX4.Visibility = Visibility.Collapsed;
            }
            else
            {
                SYRXX3.Visibility = Visibility.Visible;
            }
        }
        private void SYRXM3_LostFocus(object sender, RoutedEventArgs e)
        {
            if (string.IsNullOrWhiteSpace(SYRXM3.Text.Trim()))
            {
                SYRZJHM3.Text = SYR_Beg_date3.Text = SYR_End_date3.Text = SYRLXDH3.Text = SYRZJDZ3.Text = string.Empty;
                SYRXM4.Text = SYRZJHM4.Text = SYR_Beg_date4.Text = SYR_End_date4.Text = SYRLXDH4.Text = SYRZJDZ4.Text = string.Empty;
                SYRXX4.Visibility = Visibility.Collapsed;
            }
            else
            {
                SYRXX4.Visibility = Visibility.Visible;
            }
        }
        private void SYRXM4_LostFocus(object sender, RoutedEventArgs e)
        {
            if (string.IsNullOrWhiteSpace(SYRXM4.Text.Trim()))
            {
                SYRZJHM4.Text = SYR_Beg_date4.Text = SYR_End_date4.Text = SYRLXDH4.Text = SYRZJDZ4.Text = string.Empty;
            }
        }

        private void resIdSts_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!string.IsNullOrWhiteSpace(ZCZB.Text.Trim()) && !string.IsNullOrWhiteSpace(YYSR.Text.Trim()) && !string.IsNullOrWhiteSpace(YGSL.Text.Trim()))
            {
                var msg = new Message();
                InitFd(msg);
                //msg["busHead.tradeCode"] = "ECIFA0502001";
                msg["personNum"] = YGSL.Text.Trim();
                msg["busIncome"] = YYSR.Text.Trim();
                msg["assetsTotal"] = ZCZB.Text.Trim();
                msg["industryOne"] = HYFLD.GetSelectedValue();
                msg["industryTwo"] = HYFL.GetSelectedValue();
                msg["industryThree"] = industryThree.GetSelectedValue();

                //msg.TransitNode = TransitType.CallEcif;
                ParentPage.CallEcif(msg, "ECIFA0502001");

                if (!"0000".Equals(msg.Fd12))
                {
                    ParentPage.TradeAPIs.ShowTip("查询企业规模失败" + msg.Fd12);
                    ParentPage.SetFocus(resIdSts);
                    return;
                }
                else
                {
                    if (!string.IsNullOrWhiteSpace(msg["scale"].ToString()))
                    {
                        QYGM.SetSelectedValue(msg["scale"]);
                        QYGM.IsEnabled = true;
                    }
                    else
                    {
                        QYGM.IsEnabled = true;
                    }
                }

            }
        }

        private void ZCZB_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ZCZB.Text.Contains('.') && ZCZB.Text.Split('.')[1].Length > 4) 
            {
                ParentPage.TradeAPIs.ShowTip("注册资本只允许保留小数点后四位!");
                ParentPage.SetFocus(ZCZB);
                return;
            }
        }

        private void YYSR_LostFocus(object sender, RoutedEventArgs e)
        {
            if (YYSR.Text.Contains('.') && YYSR.Text.Split('.')[1].Length > 4)
            {
                ParentPage.TradeAPIs.ShowTip("营业收入只允许保留小数点后四位!");
                ParentPage.SetFocus(ZCZB);
                return;
            }
        }

    }

    #region 数据限定
    /// <summary>
    /// 组件数据交互类
    /// </summary>
    public class TBC_ECustomerInfoInput_NewEcif : TBC_ComponentInput
    {
        #region 构造

        #endregion

        #region 控制属性

        #endregion

        #region 交互方法

        #endregion
    }

    /// <summary>
    /// 组件数据输出类
    /// </summary>
    public class TBC_ECustomerInfoOutput_NewEcif : TBC_ComponentOutput
    {

    }

    #endregion
}
