﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TellerSystem.Contract.ContractBase;
using TellerSystem.Library.Ext.Variables;
using TellerSystem.Communication;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using Platform.Controls.ControlsHelper;
using Platform.Library;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Library.Ext.TradeExtension;
using TellerSystem.Controls.Ext.ControlsHelper;
using Platform.Common.RunningParameters;
using TellerSystem.Devices.Interface;
using TellerSystem.Contract.Function;
using abc = TellerSystem.Contract.ContractBase;
using Platform.Presentation.FocusManagers;
using TellerSystem.Devices;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;
using System.Text.RegularExpressions;
using System.Data;
using System.Xml;
using System.IO;
using TellerSystem.ServiceProxy.Ext;
using TellerSystem.Controls.Ext.ControlsExt;
using TellerSystem.Devices.Config;
using System.Diagnostics;
using TellerSystem.ServiceProxy.Ext.WebAPI.Auth;
using Platform.Common.LogSystem;

namespace TellerSystem.Controls.Ext.TradePageComponent
{
    /// <summary>
    /// 代理人业务组件
    /// </summary>
    public partial class TBC_PersonalCustomerInfo : TBC_ComponentBase<TBC_PCustomerInfoInput, TBC_PCustomerInfoOutput>
    {
        private PersonalCustomerInfoArgs personalCustomerInfoArgs = null;

        #region 属性
        public string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        public PageBase ParentPage { get; private set; }
        /// <summary>
        /// 地区编码文件
        /// </summary>
        private const string StrPath = "DQBM.xml";
        public string Dq = "";
        /// <summary>
        /// 错误信息数据源
        /// </summary>
        private DataSet _dataSource = new DataSet();
        /// <summary>
        /// 是否已建立客户ID
        /// </summary>
        bool isAreadyCreatId = false;
        /// <summary>
        /// 已建立客户ID户名　
        /// </summary>
        string oldName = string.Empty;
        /// <summary>
        /// 原证件类型
        /// </summary>
        public string old_id_no = string.Empty;
        /// <summary>
        /// 短信验证码编号
        /// </summary>
        public string DXYZMBH;
        /// <summary>
        /// 短信验证码
        /// </summary>
        public string DXYZM = string.Empty;
        public bool IsUpdate { get; set; }

        #endregion

        public TBC_PersonalCustomerInfo()
        {
            InitializeComponent();

            if (FLAG == "V19" || FLAG == "V8")
            {
                //天山使用客户信息
                CIF_LVL.Visibility = Visibility.Visible;
                CIF_LVL.IsEnabled = true;
                ID_NO.SetValue(TradePanel.ColumnSpanProperty, 3);
                yxq.AllowLongTerm = true;
                WorkAddress.Visibility = DWDZ.Visibility = Visibility.Collapsed;
                tb_zjdz.Visibility = DSDZ.Visibility = Visibility.Visible;
            }
            else if ((FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") || FLAG == "V4" || FLAG == "V5" || FLAG == "V7" || FLAG == "V10" || FLAG == "V13" || FLAG == "V14" || FLAG == "V16" || FLAG == "V17" || FLAG == "V18" || FLAG == "V23" || FLAG == "V24" || FLAG == "V11" || FLAG == "V12" || FLAG == "V9" || FLAG == "V3" || FLAG == "V2" || FLAG == "V1" || FLAG == "V0")
            {
                CIF_LVL.Visibility = Visibility.Visible;
                CIF_LVL.IsEnabled = true;
                ID_NO.SetValue(TradePanel.ColumnSpanProperty, 3);
                yxq.AllowLongTerm = true;
                tb_zjdz.Visibility = DSDZ.Visibility = Visibility.Visible;
            }
            this.personalCustomerInfoArgs = new PersonalCustomerInfoArgs();
            this.personalCustomerInfoArgs.CYM = this.CIF_RENAME;
            this.personalCustomerInfoArgs.CZ = this.FAX;
            this.personalCustomerInfoArgs.DWDZ = this.DWDZ;
            this.personalCustomerInfoArgs.DZYJ = this.EMAIL;
            this.personalCustomerInfoArgs.FZJG = this.FZJG;
            this.personalCustomerInfoArgs.GJ = this.country;
            this.personalCustomerInfoArgs.GMJJBM = this.JJBM;
            this.personalCustomerInfoArgs.GXD = this.CIF_CTB;
            this.personalCustomerInfoArgs.HCJG = this.HCJG;
            this.personalCustomerInfoArgs.HM = this.CIF_NAME;
            this.personalCustomerInfoArgs.HY = this.HY;
            this.personalCustomerInfoArgs.LWBZ = this.LW_FLG;
            this.personalCustomerInfoArgs.KHDJ = this.CIF_LVL;
            this.personalCustomerInfoArgs.LXDH = this.TEL;
            this.personalCustomerInfoArgs.LXDZ = this.ADDR;
            this.personalCustomerInfoArgs.SJH = this.MPHONE;
            this.personalCustomerInfoArgs.XB = this.SEX;
            this.personalCustomerInfoArgs.YWXM = this.YW_NAME;
            this.personalCustomerInfoArgs.YXRQKS = this.Beg_date2;
            this.personalCustomerInfoArgs.YXRQJS = this.End_date2;
            this.personalCustomerInfoArgs.YZBM = this.YZBM;
            this.personalCustomerInfoArgs.ZJDZ = this.DSDZ;
            this.personalCustomerInfoArgs.ZJHM = this.ID_NO;
            this.personalCustomerInfoArgs.ZJLX = this.ID_TYPE;
            this.personalCustomerInfoArgs.ZZZZ = this.ZZZZ;
            this.personalCustomerInfoArgs.ZYFL = this.JobType;

            //天山新增信息
            this.personalCustomerInfoArgs.MZ = this.MZ;
            this.personalCustomerInfoArgs.HF = this.HF;
            this.personalCustomerInfoArgs.XL = this.XL;
            this.personalCustomerInfoArgs.GZDW = this.GZDW;
            this.personalCustomerInfoArgs.YSR = this.YSR;
            this.personalCustomerInfoArgs.TS_FZJG = this.TS_FZJG;

            this.personalCustomerInfoArgs.SSBS = this.cmb_ssjmsfbs;
            this.personalCustomerInfoArgs.NSR = this.tb_NSR;
            this.personalCustomerInfoArgs.HYPY = this.HYPY;
            //this.personalCustomerInfoArgs.MZ = this.cmb_mz;
            this.personalCustomerInfoArgs.HYZK = this.cmb_hyzk;
            this.personalCustomerInfoArgs.JYSP = this.cmb_jysp;
            this.personalCustomerInfoArgs.HJYB = this.HJYZBM;
        }

        public void Init_TBC_CustomerInfo()
        {
            if (System.ComponentModel.DesignerProperties.GetIsInDesignMode(this)) return;
            ParentPage = (Platform.Common.BasicFunctions.DependencyObjectExtensions.FindVisualTreeAncestor(this, (x) => { return x is PageBase; })) as PageBase;
            if (ParentPage == null)
                return;

            //中牟,大石桥环境,地址扩增字段任务
            //阳光环境,地址扩增字段任务  --20190826  李棚
            if (FLAG == "V9" || FLAG == "V11" || FLAG == "V8" || FLAG == "V5" || FLAG == "V0" || FLAG == "V1" || FLAG == "V6" || FLAG == "V7" || (FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") || FLAG == "V2" || FLAG == "V12" || FLAG == "V3" || FLAG == "V19" || FLAG == "V23" || FLAG == "V24" || FLAG == "V10" || FLAG == "V13" || FLAG == "V14" || FLAG == "V16" || FLAG == "V17" || FLAG == "V18" || FLAG == "V4" || ServiceSettings.GetConfig("Temp_CustomerAddressLength", false))
            {
                this.ADDR.MaxLength = 120;
                this.DWDZ.MaxLength = 120;
            }

            //默认不是外部跳转
            this.ComponentHelper.isOutComing = false;
            this.ComponentHelper.isCheckId = false;
            CIF_CTB.SetItems(new Dictionary<string, string> { { "低", "1" }, { "中", "2" }, { "高", "3" } });
            CIF_CTB.SelectedIndex = 0;

            //佐证证件
            ZZZZ.SetItems(UserVariable.GetZzzzType());
            ZZZZ.SelectedIndex = 0;

            //国民经济部门 对私
            JJBM.SetItems(new Dictionary<string, string> { { "住户", "D01" }, { "外国居民", "E05" } });
            JJBM.SelectedIndex = 0;

            //行业  对私
            HY.SetItems(new Dictionary<string, string> { { "个人", "100" }, { "境外", "200" } });
            HY.SelectedIndex = 0;

            //性别内容
            //SEX.SetItems(UserVariable.GetSexx());
            //ParentPage.TradeAPIs.CallComboBoxData(SEX, "C030");
            //新泰  对私建立客户号将性别的空选项去除
            if (FLAG == "V18" || FLAG == "V3")
            {
                SEX.SetItems(new Dictionary<string, string> { { "女", "F" }, { "男", "M" } });
            }
            else
            {
                SEX.SetItems(new Dictionary<string, string> { { "女", "F" }, { "男", "M" } });
                SEX.AddItems(new Dictionary<string, string> { { " ", " " } });//老系统过度过来数据存在性别为空
            }

            //个人，客户等级内容
            //CIF_LVL.SetItems(UserVariable.GetCustomerLvl());
            //ParentPage.TradeAPIs.CallComboBoxData(CIF_LVL, "C021");
            CIF_LVL.SetItems(new Dictionary<string, string> { { "普通客户", "0" }, { "银级客户", "1" }, { "金级客户", "2" }, { "白金客户", "3" }, { "钻石客户", "4" } });
            CIF_LVL.SelectedIndex = 0;

            //核查结果
            //HCJG.SetItems(UserVariable.GetHcjgType());
            //ParentPage.TradeAPIs.CallComboBoxData(HCJG, "C031");
            HCJG.SetItems(new Dictionary<string, string> { { "公民身份号码与姓名一致，且存在照片", "0" }, { "公民身份号码与姓名一致，但不存在照片", "1" }, { "公民身份号码存在，但与姓名不匹配", "2" }, { "公民身份号码不存在", "3" }, { "其他错误", "4" }, { "输入的参数错误", "5" } });
            HCJG.SelectedIndex = 0;

            //联网标志
            //LW_FLG.SetItems(UserVariable.GetLwFlgType());
            //ParentPage.TradeAPIs.CallComboBoxData(LW_FLG, "C032");
            LW_FLG.SetItems(new Dictionary<string, string> { { "待核实", "0" }, { "已核实", "1" }, { "出具证明", "2" } });
            LW_FLG.SelectedIndex = 0;

            //国籍
            country.SetItems(UserVariable.GetCountryType());
            ParentPage.TradeAPIs.CallComboBoxData(country, "C029");
            //country.SetItems(new Dictionary<string, string> { { "中国", "CHN" } });
            country.SelectedIndex = 0;

            cb_dwgs.SetItems(new Dictionary<string, string> { { "是", "Y" }, { "否", "N" } });
            cb_dwgs.SelectedIndex = 0;
            Page.TradeAPIs.CallComboBoxData(cb_ssbt, "BTSB");
            cb_ssbt.SelectedIndex = 0;
            //职业



            //个人证件类型内容
            //ID_TYPE.SetItems(UserVariable.GetPerIdType());
            //ParentPage.TradeAPIs.CallComboBoxData(ID_TYPE, "C004");
            if (FLAG == "V0")
            {
                ID_TYPE.SetItems(new Dictionary<string, string> { { "身份证", "1" }, { "户口簿", "2" }, { "护照", "3" }, { "军人证", "4" },
            { "非中国籍港澳内地通行证", "5" }, { "士兵证", "6" }, { "港澳居民来往内地通行证", "7" },{"港澳台居民居住证","W"}, { "外国人永久居留身份证", "F" }, { "警官证", "G" },
           { "其他证件（对私）", "H" }, { "台湾居民来往大陆通行证", "I" }, { "军官证", "J" }, { "文职干部证", "K" }, { "军官退休证", "L" },
           { "文职干部退休证", "M" },  { "武警身份证", "N" }, { "武警士兵证", "O" },{ "武警文职干部证", "P" }, { "武警军官退休证", "Q" }, 
            { "武警文职干部退休证", "R" }});
            }
            else
            {
                ID_TYPE.SetItems(new Dictionary<string, string> { { "身份证", "1" }, { "户口簿", "2" }, { "护照", "3" }, { "军人证", "4" },
            { "非中国籍港澳内地通行证", "5" }, { "士兵证", "6" }, { "港澳居民来往内地通行证", "7" },{"港澳台居民居住证","W"}, { "外国人永久居留身份证", "F" }, { "警官证", "G" },
           { "其他证件（对私）", "H" }, { "台湾居民来往大陆通行证", "I" }, { "军官证", "J" }, { "文职干部证", "K" }, { "军官退休证", "L" },
           { "文职干部退休证", "M" },  { "武警身份证", "N" }, { "武警士兵证", "O" },{ "武警文职干部证", "P" }, { "武警军官退休证", "Q" }, 
            { "武警文职干部退休证", "R" }});
                if (FLAG == "V19" || FLAG == "V23")
                {
                    ID_TYPE.AddItems(new Dictionary<string, string> { { "临时身份证", "E" } });
                }
            }
            ID_TYPE.SelectedIndex = 0;

            if (FLAG == "V11")
            {
                JobType.SetItems(new Dictionary<string, string> { { "党政机关、团体组织、企事业单位负责人", "0" }, 
                { "专业技术人员", "1" },{ "办事人员和有关人员", "3" },
                { "社会生产服务和生活服务人员", "4" },{ "农、林、牧、渔业生产及辅助人员", "5" },
                { "生产制造及有关人员", "6" },{ "军人", "X" },{ "不便分类的其他从业人员", "Y" }});
            }
            else if (FLAG == "V13")
            {
                JobType.SetItems(new Dictionary<string, string> { { "党政机关、团体组织、企事业单位负责人", "0" }, 
                { "专业技术人员", "1" },{ "办事人员和有关人员", "3" },
                { "社会生产服务和生活服务人员", "4" },{ "农、林、牧、渔业生产及辅助人员", "5" },
                { "生产制造及有关人员", "6" },{ "军人", "X" },{ "不便分类的其他从业人员", "Y" },{"失业、无业、离退休等","9"}});
            }
            else
            {
                JobType.SetItems(new Dictionary<string, string> { { "党政机关、团体组织、企事业单位负责人", "0" }, 
                { "专业技术人员", "1" },{ "办事人员和有关人员", "3" },
                { "社会生产服务和生活服务人员", "4" },{ "农、林、牧、渔业生产及辅助人员", "5" },
                { "生产制造及有关人员", "6" },{ "军人", "X" },{ "不便分类的其他从业人员", "Y" },{ "未知", "Z" }});
            }
            JobType.SelectedIndex = 7;
            if (FLAG == "V17")
            {
                JobType.SelectedIndex = 0;
            }

            //天山新增
            MZ.SetItems(new Dictionary<string, string> { { "汉族", "1" },{ "蒙古族", "2" },{ "回族", "3" },{ "藏族", "4" },{ "维吾尔族", "5" },{ "苗族", "6" },{ "彝族", "7" },
            { "壮族", "8" },{ "布依族", "9" },{ "朝鲜族", "10" },{ "满族", "11" },{ "侗族", "12" },{ "瑶族", "13" },{ "白族", "14" },{ "土家族", "15" },{ "哈尼族", "16" },{ "哈萨克族", "17" },
            { "傣族", "18" },{ "黎族", "19" },{ "傈傈族", "20" },{ "佤族", "21" },{ "畲族", "22" },{ "高山族", "23" },{ "拉祜族", "24" },{ "水族", "25" },{ "东乡族", "26" },{ "纳西族", "27" },
            { "景颇族", "28" },{ "柯尔克孜族", "29" },{ "土族", "30" },{ "达斡尔族", "31" },{ "仫佬族", "32" },{ "羌族", "33" },{ "布朗族", "34" },{ "撒拉族", "35" },{ "毛南族", "36" },
            { "仡佬族", "37" },{ "锡伯族", "38" },{ "阿昌族", "39" },{ "普米族", "40" },{ "塔吉克族", "41" },{ "怒族", "42" },{ "乌孜别克族", "43" },{ "俄罗斯族", "44" },{ "鄂温克族", "45" },{ "崩龙族", "46" },
            { "保安族", "47" },{ "裕固族", "48" },{ "京族", "49" },{ "塔塔尔族", "50" },{ "独龙族", "51" },{ "鄂伦春族", "52" },{ "赫哲族", "53" },{ "门巴族", "54" },{ "珞巴族", "55" },{ "基诺族", "56" },
            { "柯尔族", "57" },{ "其他", "97" },{ "外国血统中国籍人士", "99" }});
            MZ.SelectedIndex = 0;

            HF.SetItems(new Dictionary<string, string> { { "未婚", "10" },{ "已婚无子女", "20" },{ "已婚且有子女", "21" },{ "离异", "22" },{ "复婚", "23" },{ "丧偶", "30" },{ "离婚", "40" },
            { "未说明", "90" }});
            HF.SelectedIndex = 0;

            XL.SetItems(new Dictionary<string, string> { { "研究生", "10" },{ "大学本科", "20" },{ "大学专科和专科学校", "30" },{ "中等专业学校或中等技术学校", "40" },{ "技术学校", "50" },{ "高中", "60" },{ "初中", "70" },
            { "小学", "80" },{ "文盲或半文盲", "90" },{ "未分类", "99" }});
            XL.SelectedIndex = 0;

            FX_LVL.SetItems(new Dictionary<string, string> { { "低级", "0" }, { "中级", "1" }, { "高级", "2" }, { "中低", "3" }, { "中高", "4" } });
            FX_LVL.SelectedIndex = 0;

            CIF_LB.SetItems(new Dictionary<string, string> { { "自然人", "01" }, { "个体", "02" }, { "小微企业主", "03" }, { "其他", "99" } });
            CIF_LB.SelectedIndex = 0;

            cb_ysr.SetItems(new Dictionary<string, string> { { "0-3000（含）", "3000" }, { "3000-5000（含）", "5000" }, { "5000-7000（含）", "7000" }, { "7000-10000（含）", "10000" }, { "10000-13000（含）", "13000" }, { "13000-15000（含）", "15000" }
            , { "15000-20000（含）", "20000" }, { "20000-30000（含）", "30000" }, { "30000-50000（含）", "50000" }, { "50000-100000（含）", "100000" }, { "100000以上", "100001" }});
            cb_ysr.SelectedIndex = 0;
            //莱山齐丰增加手机号码短信验证 20220601
            if (FLAG == "V10" || FLAG == "V7" || FLAG == "V13")
            {
                btnCheck.Visibility = Visibility.Visible;
                TBYZM.Visibility = Visibility.Visible;
                tbCheckCode.Visibility = Visibility.Visible;
                SPanel.SetValue(TradePanel.ColumnSpanProperty, 3);
            }
            if (FLAG == "V21" || FLAG == "V22")
            {
                TB_FZJG1.Visibility = FZJG.Visibility = Visibility.Visible;
                CMB_ssjmsfbs.Visibility = cmb_ssjmsfbs.Visibility = Visibility.Visible;
                TB_NSR.Visibility = tb_NSR.Visibility = Visibility.Visible;
                TB_khmHYPY.Visibility = HYPY.Visibility = Visibility.Visible;
                CMB_mz.Visibility = cmb_mz.Visibility = Visibility.Visible;
                CMB_hyzk.Visibility = cmb_hyzk.Visibility = Visibility.Visible;
                CMB_jysp.Visibility = cmb_jysp.Visibility = Visibility.Visible;
                TBYZM.Visibility = tbCheckCode.Visibility = Visibility.Visible;
                tb_zjdz.Visibility = DSDZ.Visibility = Visibility.Visible;
                TB_HJYZBM.Visibility = HJYZBM.Visibility = Visibility.Visible;
                CIF_LB.Visibility = CIF_LB_txt.Visibility = Visibility.Visible;
                tb_zjdz.Text = "户籍地址";
                TradePanel.SetColumnSpan(FZJG, 3);
                TradePanel.SetColumnSpan(FAX, 3);
                TradePanel.SetColumnSpan(SPanel, 3);
                FZJG.IsEnabled = true;
                FocusManagerExt.SetAssertNotEmpty(DSDZ, true);
                btnCheck.Visibility = Visibility.Visible;

                cmb_jysp.SetItems(new Dictionary<string, string> { { "博士", "00" }, { "研究生", "10" }, { "大学本科", "20" }, { "大学专科和专科学校", "30" }, { "中等专业学校或中等技术学校", "40" }, { "技术学校", "50" }, { "高中", "60" }, { "初中", "70" }, { "小学", "80" }, { "文盲或半文盲", "90" }, { "未分类", "99" } });
                if (FLAG == "V21")
                {
                    cmb_jysp.SelectedIndex = 6;
                }
                else
                {
                    cmb_jysp.SelectedIndex = 0;
                }
                cmb_mz.SetItems(UserVariable.GetNationalityType());
                cmb_mz.SelectedIndex = 0;
                cmb_hyzk.SetItems(new Dictionary<string, string> { { "未婚", "10" }, { "已婚无子女", "20" }, { "已婚且有子女", "21" }, { "离异", "22" }, { "复婚", "23" }, { "丧偶", "30" }, { "离婚", "40" }, { "未说明", "90" } });
                cmb_hyzk.SelectedIndex = 0;
                cmb_ssjmsfbs.SetItems(new Dictionary<string, string> { { "仅为中国税收居民", "01" }, { "仅为非居民", "02" }, { "既是中国税收居民又是其他国家(地区)税收居民", "03" } });
                cmb_ssjmsfbs.SelectedIndex = 0;

                CIF_LB.SetItems(new Dictionary<string, string> { { "自然人", "01" }, { "个体", "02" }, { "其他", "99" } });
                CIF_LB.SelectedIndex = 0;
                DWDZ.MaxLength = ADDR.MaxLength = DSDZ.MaxLength = 120;//地址扩增至120字符任务
            }
            if (FLAG == "V1")
            {
                FocusManagerExt.SetAssertNotEmpty(birth_date, true);
                FocusManagerExt.SetAssertNotEmpty(DWDZ, true);
                FocusManagerExt.SetAssertNotEmpty(DSDZ, true);
                FocusManagerExt.SetAssertNotEmpty(GZDW, true);
                RegexRuleExtension.SetInputType(TEL, InputRules.TelephoneOrMobilePhone);
                tb_tel.Text = "联系人电话";
            }
            //版本控制 中牟：V0 郏县：V1  鄢陵：V2
            switch (FLAG)
            {
                case "V0":
                    FocusManagerExt.SetAssertNotEmpty(job, true);
                    job.MaxLength = ADDR.MaxLength = DWDZ.MaxLength = 120;//地址扩增至120字符任务                      
                    TB_MZ.Visibility = MZ.Visibility = TB_HF.Visibility = HF.Visibility = TB_XL.Visibility = XL.Visibility = TB_GZDW.Visibility =
                        GZDW.Visibility = TB_YSR.Visibility = YSR.Visibility = TB_FZJG.Visibility =
                        TS_FZJG.Visibility = Visibility.Visible;
                    FocusManagerExt.SetAssertNotEmpty(TS_FZJG, true);
                    break;
                case "V2":
                    CIF_LB.Visibility = Visibility.Visible;
                    CIF_LB_txt.Visibility = Visibility.Visible;
                    ADDR.MaxLength = DWDZ.MaxLength = 120;//地址扩增至120字符任务
                    TB_MZ.Visibility = MZ.Visibility = TB_HF.Visibility = HF.Visibility = TB_XL.Visibility = XL.Visibility = TB_GZDW.Visibility =
                        GZDW.Visibility = TB_YSR.Visibility = YSR.Visibility = TB_FZJG.Visibility =
                        TS_FZJG.Visibility = Visibility.Visible;
                    FocusManagerExt.SetAssertNotEmpty(job, true);
                    if (LoginUserInfo.KinbrNo.Substring(0, 3) == "152")
                    {
                        FocusManagerExt.SetAssertNotEmpty(job, false);
                        job_lf.Text = "二级职业";
                        job_lf.Visibility = cb_job_lf.Visibility = job_lf1.Visibility = cb_job_lf1.Visibility = Visibility.Visible;
                        tb_job.Visibility = job.Visibility = Visibility.Collapsed;
                    }
                    FocusManagerExt.SetAssertNotEmpty(TS_FZJG, true);
                    break;
                case "V3":
                    tb_zjdz.Text = "户籍地址";
                    ADDR.MaxLength = DWDZ.MaxLength = 120;//地址扩增至120字符任务
                    TB_MZ.Visibility = MZ.Visibility = TB_HF.Visibility = HF.Visibility = TB_XL.Visibility = XL.Visibility = TB_GZDW.Visibility =
                        GZDW.Visibility = TB_YSR.Visibility = YSR.Visibility = TB_FZJG.Visibility =
                        TS_FZJG.Visibility = Visibility.Visible;
                    FocusManagerExt.SetAssertNotEmpty(job, true);
                    FocusManagerExt.SetAssertNotEmpty(TS_FZJG, true);
                    XL.SelectedIndex = 10;
                    HF.SelectedIndex = 7;
                    break;
                case "V8":
                    //WorkAddress.Text = "居住地址";
                    FocusManagerExt.SetAssertNotEmpty(DWDZ, true);
                    FocusManagerExt.SetAssertNotEmpty(job, true);//阳光环境,职业为必输项  --20190822  李棚
                    ADDR.MaxLength = DWDZ.MaxLength = 120;//地址扩增至120字符任务
                    TB_MZ.Visibility = MZ.Visibility = TB_HF.Visibility = HF.Visibility = TB_XL.Visibility = XL.Visibility = TB_GZDW.Visibility =
                        GZDW.Visibility = TB_YSR.Visibility = YSR.Visibility = TB_FZJG.Visibility =
                        TS_FZJG.Visibility = Visibility.Visible;
                    FocusManagerExt.SetAssertNotEmpty(TS_FZJG, true);
                    job_lf.Text = "二级职业";
                    job_lf.Visibility = cb_job_lf.Visibility = job_lf1.Visibility = cb_job_lf1.Visibility = Visibility.Visible;
                    tb_job.Visibility = job.Visibility = Visibility.Collapsed;
                    break;
                case "V21":
                case "V22":
                    FocusManagerExt.SetAssertNotEmpty(job, true);
                    FocusManagerExt.SetAssertNotEmpty(YZBM, true);//邮政编码必输
                    break;
                case "V14":
                case "V13":
                case "V10":
                case "V16"://冠县齐丰
                case "V17"://蒙阴齐丰
                case "V18"://新泰齐丰
                    FocusManagerExt.SetAssertNotEmpty(job, true);
                    FocusManagerExt.SetAssertNotEmpty(YZBM, true);//邮政编码必输
                    ADDR.MaxLength = DWDZ.MaxLength = 120;//地址扩增至120字符任务
                    TB_MZ.Visibility = MZ.Visibility = TB_HF.Visibility = HF.Visibility = TB_XL.Visibility = XL.Visibility = TB_GZDW.Visibility =
                        GZDW.Visibility = TB_YSR.Visibility = YSR.Visibility = TB_FZJG.Visibility =
                        TS_FZJG.Visibility = Visibility.Visible;
                    FocusManagerExt.SetAssertNotEmpty(TS_FZJG, true);
                    if (FLAG == "V10")
                    {
                        MZ.SelectedIndex = -1;
                        HF.SelectedIndex = -1;
                        XL.SelectedIndex = -1;
                    }
                    break;
                case "V23"://浚县
                case "V24"://确山
                    FocusManagerExt.SetAssertNotEmpty(job, true);
                    FocusManagerExt.SetAssertNotEmpty(YZBM, true);//邮政编码必输
                    ADDR.MaxLength = DWDZ.MaxLength = 120;//地址扩增至120字符任务
                    TB_MZ.Visibility = MZ.Visibility = TB_HF.Visibility = HF.Visibility = TB_XL.Visibility = XL.Visibility = TB_GZDW.Visibility =
                        GZDW.Visibility = TB_YSR.Visibility = YSR.Visibility = TB_FZJG.Visibility =
                        TS_FZJG.Visibility = Visibility.Visible;
                    FocusManagerExt.SetAssertNotEmpty(job, true);
                    FocusManagerExt.SetAssertNotEmpty(TS_FZJG, true);
                    break;
                case "V11":
                    FocusManagerExt.SetAssertNotEmpty(job, true);
                    FocusManagerExt.SetAssertNotEmpty(YZBM, true);//邮政编码必输
                    ADDR.MaxLength = DWDZ.MaxLength = 120;//地址扩增至120字符任务
                    TB_MZ.Visibility = MZ.Visibility = TB_HF.Visibility = HF.Visibility = TB_XL.Visibility = XL.Visibility = TB_GZDW.Visibility =
                        GZDW.Visibility = tb_ysr.Visibility = cb_ysr.Visibility = TB_FZJG.Visibility =
                        TS_FZJG.Visibility = Visibility.Visible;
                    FocusManagerExt.SetAssertNotEmpty(TS_FZJG, true);
                    FocusManagerExt.SetAssertNotEmpty(DWDZ, true);//工作单位
                    FocusManagerExt.SetAssertNotEmpty(YSR, true);//月收入
                    tb_job.Visibility = job.Visibility = Visibility.Collapsed;
                    job_lf.Visibility = cb_job_lf.Visibility = Visibility.Visible;
                    break;
                case "V1":
                case "V12":
                case "V9":
                case "V4":
                case "V19":
                    ADDR.MaxLength = DWDZ.MaxLength = 120;//地址扩增至120字符任务
                    TB_MZ.Visibility = MZ.Visibility = TB_HF.Visibility = HF.Visibility = TB_XL.Visibility = XL.Visibility = TB_GZDW.Visibility =
                        GZDW.Visibility = TB_YSR.Visibility = YSR.Visibility = TB_FZJG.Visibility =
                        TS_FZJG.Visibility = Visibility.Visible;
                    FocusManagerExt.SetAssertNotEmpty(job, true);
                    FocusManagerExt.SetAssertNotEmpty(TS_FZJG, true);
                    break;
                case "V5": //青隆
                    ADDR.MaxLength = DWDZ.MaxLength = 120;//地址扩增至120字符任务
                    TB_MZ.Visibility = MZ.Visibility = TB_HF.Visibility = HF.Visibility = TB_XL.Visibility = XL.Visibility = TB_GZDW.Visibility =
                        GZDW.Visibility = TB_YSR.Visibility = YSR.Visibility = TB_FZJG.Visibility =
                        TS_FZJG.Visibility = Visibility.Visible;
                    FocusManagerExt.SetAssertNotEmpty(job, true);
                    FocusManagerExt.SetAssertNotEmpty(TS_FZJG, true);
                    break;
                case "V7": //都匀
                    ADDR.MaxLength = DWDZ.MaxLength = DSDZ.MaxLength = 120;//地址扩增至120字符任务
                    TB_MZ.Visibility = MZ.Visibility = TB_HF.Visibility = HF.Visibility = TB_XL.Visibility = XL.Visibility = TB_GZDW.Visibility =
                        GZDW.Visibility = TB_YSR.Visibility = YSR.Visibility = TB_FZJG.Visibility =
                        TS_FZJG.Visibility = Visibility.Visible;
                    FocusManagerExt.SetAssertNotEmpty(job, true);
                    FocusManagerExt.SetAssertNotEmpty(TS_FZJG, true);
                    break;
                default:
                    FocusManagerExt.SetAssertNotEmpty(job, false);
                    break;
            }
            if (FLAG == "V19")
            {
                cb_dwgs.Visibility = tb_dwgs.Visibility = Visibility.Visible;
            }
            if ((FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") || FLAG == "V8")
            {
                //设置职业类型
                var zyinfo = this.ParentPage.TradeAPIs.TF_Deposit_QueryJobTypeList(new QueryJobTypeList.Input()
                {
                    CXLX = "1",//1：查询全部的一级码值信息
                    ZYBM = ""
                });
                if (zyinfo.IsFailed)
                {
                    this.ParentPage.TradeAPIs.ShowTip(zyinfo.FailureCause);
                    this.ParentPage.SetFocus();
                    return;
                }
                if (zyinfo.ZYLBData.Count > 0)
                {
                    var zydic = zyinfo.ZYLBData.ToDictionary(ajzdata => ajzdata.ZYMC, ajzdata => ajzdata.ZYLX);
                    JobType.SetItems(zydic);
                }
            }
        }

        private void Beg_date2_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(Beg_date2.Text))
            {
                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                ParentPage.SetFocus(Beg_date2);
                return;
            }
        }

        private void End_date2_LostFocus(object sender, RoutedEventArgs e)
        {
            if (End_date2.Text.Trim() == "99999999")
            {
                End_date2.Text = "99991231";
                return;
            }

            if (ID_NO.Text.Trim() == "" && (End_date2.Text.Trim() != "" || Beg_date2.Text.Trim() != ""))
            {
                ParentPage.TradeAPIs.ShowTip("证件号码为空时，有效期必须为空");
                ParentPage.SetFocus(Beg_date2);
                return;
            }

            if (ID_NO.Text.Trim() != "")
            {
                if (End_date2.Text.Trim() != "" && Beg_date2.Text.Trim() != "")
                {
                    if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(End_date2.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                        ParentPage.SetFocus(End_date2);
                        return;
                    }
                    if (ParentPage.Atoi(End_date2.Text) < ParentPage.Atoi(Beg_date2.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                        //ParentPage.SetFocus(                //End_date);
                        ParentPage.SetFocus(End_date2);
                        return;
                    }
                }
                else if ((End_date2.Text.Trim() == "" && Beg_date2.Text.Trim() != "") || (End_date2.Text.Trim() != "" && Beg_date2.Text.Trim() == ""))
                {
                    ParentPage.TradeAPIs.ShowTip("请输入完整的有效期");
                    ParentPage.SetFocus(End_date2);
                    return;
                }
            }
        }

        private void CIF_NAME_LostFocus(object sender, RoutedEventArgs e)
        {
            if (FLAG == "V19" || FLAG == "V8" || FLAG == "V5" || FLAG == "V7" || FLAG == "V10" || FLAG == "V13" || FLAG == "V14" || FLAG == "V16" || FLAG == "V17" || FLAG == "V18" || FLAG == "V23" || FLAG == "V24" || FLAG == "V4" || (FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") || FLAG == "V11" || FLAG == "V12" || FLAG == "V9" || FLAG == "V3" || FLAG == "V2" || FLAG == "V1" || FLAG == "V0")
            {
                CIF_NAME.Text = SystemFunction.PointToPoint(CIF_NAME.Text.Trim());
                //户名合法性校验-不能输入数字
                //string reg = @"^[\u4E00-\u9FA5A-Za-z\·]+$";
                string reg = @"^((?![\u3000-\u303F])[\u2E80-\uFE4FA-Za-z\s]|\·)*(?![\u3000-\u303F])[\u2E80-\uFE4FA-Za-z\s](\·)*$";
                if (Regex.IsMatch(CIF_NAME.Text, reg))
                {

                }
                else
                {
                    ParentPage.TradeAPIs.ShowTip("输入格式不符合规范！");
                    ParentPage.SetFocus(CIF_NAME);
                    return;
                }
                if (YW_NAME.Text == "" && FLAG != "V3" && FLAG != "V1" && FLAG != "V0" && FLAG != "V8")
                {
                    YW_NAME.Text = TellerSystem.Library.Ext.TradeExtension.ChineseCodeConverter.ConvertWithBlank(CIF_NAME.Text);
                }
            }
            //检查是否该证件已经登记
            //chenming 注释
            ///张玉锡解注释，为了实现建立客户ID时可以直接恢复原来已销掉的客户。20141106 开始
            var output = ParentPage.TradeAPIs.TF_Customer_QueryCustomerInformation(new QueryCustomerInformation.Input { ZJLX = ID_TYPE.GetSelectedValue(), ZJHM = ID_NO.Text, KHMC = CIF_NAME.Text });
            if (output.IsFailed)
            {
                ParentPage.ShowMessageBox(output.FailureCause);
                ParentPage.SetFocus(ID_NO);
                return;
            }
            if (output.BZ[2] == '2') //客户已经注销,可以选择恢复
            {
                if (ParentPage.TradeAPIs.ShowQuestionMessageBox("该证件户名已销户,是否立即恢复", "确认信息", MessageBoxResult.No, MessageBoxButton.YesNo) == MessageBoxResult.No)
                {
                    return;
                }
                else  //直接提交交易，更改cif_basic_inf的sts状态位
                {
                    Message msg = new Message();
                    ParentPage.TradeAPIs.InitFd(msg);
                    ParentPage.TradeAPIs.CommSend(msg);
                    msg.Fd16 = "1421";   //主交易代码
                    msg.Fd26 = CIF_NAME.Text.Trim();  //客户名称
                    msg.Fd116_4 = ID_TYPE.GetSelectedValue();     //
                    msg.Fd116_5 = ID_NO.Text.Trim();
                    ParentPage.TradeAPIs.CallServer(msg);
                    if (msg.Fd12 != "0000")   //调用核心失败
                    {
                        ParentPage.ShowInfoMessageBox(ParentPage.TradeAPIs.GetError(msg));
                        ParentPage.SetFocus(CIF_NAME);
                        return;
                    }
                    else
                    {
                        ParentPage.TradeAPIs.ShowSuccessMessageBox("业务办理成功!");
                        ParentPage.SetFocus(ID_TYPE);
                        return;
                    }

                }
            }
            //zhangyuxi 20141106结束
            if (isAreadyCreatId) //已经建立客户ID
            {
                //郑州村镇要求 证件类型、证件号唯一        by  diaosq  20150108
                ParentPage.SetFocus(ID_NO);
                ParentPage.TradeAPIs.ShowTip(ID_NO, "该证件已建立过客户信息,请重新输入!");
                return;

                //if (!CIF_NAME.Text.Equals(oldName)) //录入的用户名与原建立客户户名不相符
                //{
                //    //ParentPage.SetFocus(ID_NO);  zhangyuxi 修改,允许同一证件号不同户名的情况,允许建立客户ID
                //    //ParentPage.TradeAPIs.ShowTip(ID_NO, "该证件已建立客户信息，原户名为："+oldName);
                //    if (ParentPage.TradeAPIs.ShowQuestionMessageBox("该证件已建立客户信息\n户名为：" + oldName  + "\n是否继续?", "确认信息", MessageBoxResult.No, MessageBoxButton.YesNo) == MessageBoxResult.No)
                //    {
                //        ParentPage.SetFocus(ID_NO);
                //    }
                //    return;
                //}
                //else
                //{
                //    ParentPage.SetFocus(ID_NO);
                //    ParentPage.TradeAPIs.ShowTip(ID_NO, "该证件已建立同名客户信息,请重新输入!");
                //    return;
                //}
            }
            if (FLAG == "V21" || FLAG == "V22" || FLAG == "V1" || FLAG == "V0" || FLAG == "V8")
            {
                HYPY.Text = UserFunction.GetNamePinyin(CIF_NAME.Text).ToLower();
                if (YW_NAME.Text == "")
                {
                    YW_NAME.Text = UserFunction.GetNamePinyin(CIF_NAME.Text).ToLower();
                }
            }
        }

        private void CIF_RENAME_LostFocus(object sender, RoutedEventArgs e)
        {
            //检查客户名称与别名是否相同
            if (CIF_RENAME.Text == CIF_NAME.Text)
            {
                ParentPage.TradeAPIs.ShowTip("别名不能与姓名相同");
                //ParentPage.SetFocus(                //CIF_RENAME);
                ParentPage.SetFocus(CIF_RENAME);
                return;
            }
            //新增加将姓名转换为全角处理080301
            string tota = string.Empty;
            //int number; //add by wangzhe 20090703
            /**
            int lens = ParentPage.Mod(ParentPage.Len(CIF_RENAME.Text), 2);
            if (lens != 0)
            {
                ParentPage.ShowMessageBox("户名长度不为偶数，请检查!!!");
                //ParentPage.SetFocus(                //CIF_RENAME);
                ParentPage.SetFocus(CIF_RENAME);
                return;
            }**/
        }

        private void TEL_LostFocus(object sender, RoutedEventArgs e)
        {
            string tel = string.Empty;
            string tota = string.Empty;
            if (string.IsNullOrEmpty(TEL.Text.Trim()) && string.IsNullOrEmpty(MPHONE.Text.Trim()))
            {
                ParentPage.SetFocus(MPHONE);
                ParentPage.TradeAPIs.ShowTip(MPHONE, "手机号码或固定号码必需填写一项");
                return;
            }
            if (ParentPage.Len(TEL.Text) < 7 && ParentPage.Len(TEL.Text) > 0)
            {
                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N008));
                //ParentPage.SetFocus(                //TEL);
                ParentPage.SetFocus(TEL);
                return;
            }
            #region 提示电话号码关联
            if (!string.IsNullOrEmpty(TEL.Text.Trim()))
            {
                Message msg = new Message();
                ParentPage.InitFd(msg);
                ParentPage.CommSend(msg);
                msg.Fd16 = "9598";
                string sql = "select a.cif_no,b.name,'" + TEL.Text.Trim() + "' from cif_per_inf a,cif_id_code_rel b where a.cif_no=b.cif_no and (trim(telephone)='"
                    + TEL.Text.Trim() + "' or trim(phone)='" + TEL.Text.Trim() + "')and b.legal_br_no='" + LoginAuthentication.Instance.GroupKinbrNo + "'";
                msg.Fd123 = sql;
                ParentPage.CallServer(msg);
                if (msg.Fd12 != "0000")
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetError(msg));
                    ParentPage.TradeAPIs.SetFocus();
                    return;
                }
                if (msg.FileData != "")
                {
                    var file = msg.FileData;
                    int num = file.Split('\n').Count();//文件条数
                    string[] data = file.Split('\n');//文件内容
                    string name = string.Empty;
                    for (int i = 0; i < num - 1; i++)
                    {
                        name += data[i].Split('|')[1].ToString() + "、";
                        if (i == 2 && num > 3)
                        {
                            name += "等";
                            break;
                        }
                    }
                    ParentPage.TradeAPIs.ShowInfoMessageBox("该联系电话【" + TEL.Text.Trim() + "】已关联过客户号\n关联户名：" + name);
                }
            }
            #endregion 提示电话号码关联
            if (FLAG == "V8")
            {
                if (ParentPage.TradeAPIs.ShowQuestionMessageBox("联系地址是否与证件地址相同", "询问信息", MessageBoxResult.Yes, MessageBoxButton.YesNo) == MessageBoxResult.Yes)
                {
                    ADDR.Text = DSDZ.Text;
                }
            }
        }

        private void ADDR_LostFocus(object sender, RoutedEventArgs e)
        {
            string phone = null;
            string tel = null;
            if (!string.IsNullOrEmpty(MPHONE.Text))
            {
                phone = string.Format("\n手机号码：" + MPHONE.Text);
            }
            if (!string.IsNullOrEmpty(TEL.Text))
            {
                tel = string.Format("\n固定电话：" + TEL.Text);
            }
            //信息交互
            if (TellerSystem.Devices.Config.DeviceConfig.TransInfoEnabled)
            {
                string text = "客户名称：" + CIF_NAME.Text +
                            "\n证件地址:" + ADDR.Text +
                            "\n证件号码：" + ID_NO.Text + phone + tel;
                var result = TellerSystem.Devices.DeviceHelper.PrintTransInfo(text);
                if (result.HasError)
                {
                    ADDR.ShowTip("信息交互操作有误，请重新调用");
                    this.Page.SetFocus(ADDR);
                    return;
                }
            }
        }

        private void YZBM_LostFocus(object sender, RoutedEventArgs e)
        {
            //20140813 对私邮编非必输 对公邮编必输
            if (YZBM.Text.Trim() != string.Empty)
            {
                if (ParentPage.Len(YZBM.Text.Trim()) != 6)
                {
                    ParentPage.TradeAPIs.ShowTip("邮编号码无效，请检查");
                    //ParentPage.SetFocus(                //QYYB);
                    ParentPage.SetFocus(YZBM);
                    return;
                }
            }

        }
        /// <summary>
        /// 将 Stream 转成 byte[]
        /// </summary>
        public byte[] StreamToBytes(Stream stream)
        {
            byte[] bytes = new byte[stream.Length];
            stream.Read(bytes, 0, bytes.Length);
            // 设置当前流的位置为流的开始
            stream.Seek(0, SeekOrigin.Begin);
            return bytes;
        }

        /// <summary>
        /// 将 byte[] 转成 Stream
        /// </summary>
        public Stream BytesToStream(byte[] bytes)
        {
            Stream stream = new MemoryStream(bytes);
            return stream;
        }
        private void dqmc_LostFocus(object sender, RoutedEventArgs e)
        {
            if (FLAG != "V11")
            {
                _dataSource = new DataSet();
                //创建对象
                var xmlDoc = new XmlDocument();
                try
                {
                    //得到服务器错误文件
                    byte[] byteXml = TellerSystem.ServiceProxy.Ext.ServiceHelper.UserManagerHandle.GetConfFile(StrPath);

                    //判断得到的字符串是否为空
                    if (byteXml != null)
                    {
                        _dataSource.ReadXml(BytesToStream(byteXml));
                    }
                    else
                    {
                        ParentPage.TradeAPIs.ShowTip("获取文件失败");
                    }
                }
                catch (System.Exception)
                {
                    ParentPage.TradeAPIs.ShowTip("获取文件失败");
                }
                DataTable dt = new DataTable();
                dt.Columns.Add("地区名称");
                dt.Columns.Add("地区编码");
                string data = string.Empty;
                if (_dataSource.Tables[1].Rows != null && _dataSource.Tables[1].Rows.Count > 1)
                {

                    foreach (DataRow item in _dataSource.Tables[1].Rows)
                    {
                        //if (item["value"].ToString().Contains(dqmc.Text))
                        //{
                        //    dt.Rows.Add(item["value"], item["name"]);
                        //}
                        data += item["value"] + "|" + item["name"] + "\n";
                    }
                }
                var selectedData = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, data, new string[] { "地区名称", "地区编码", }, 600, 400);
                //                var selectedData = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, dt
                //, 500, 200,"");
                if (selectedData == null)
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N042));
                    ParentPage.SetFocus();
                    return;
                }

                dqbm.Text = selectedData["地区编码"].ToString();
                dqmc.Text = selectedData["地区名称"].ToString();
                Dq = selectedData["地区编码"].ToString();
            }
            else //如果是大石桥V11
            {
                if (TS_FZJG.Text != "大石桥市公安局" || dqmc.Text != "大石桥市" || dqbm.Text != "2262")//如果是默认值的话就不调用弹窗
                {
                    _dataSource = new DataSet();
                    //创建对象
                    var xmlDoc = new XmlDocument();
                    try
                    {
                        //得到服务器错误文件
                        byte[] byteXml = TellerSystem.ServiceProxy.Ext.ServiceHelper.UserManagerHandle.GetConfFile(StrPath);

                        //判断得到的字符串是否为空
                        if (byteXml != null)
                        {
                            _dataSource.ReadXml(BytesToStream(byteXml));
                        }
                        else
                        {
                            ParentPage.TradeAPIs.ShowTip("获取文件失败");
                        }
                    }
                    catch (System.Exception)
                    {
                        ParentPage.TradeAPIs.ShowTip("获取文件失败");
                    }
                    DataTable dt = new DataTable();
                    dt.Columns.Add("地区名称");
                    dt.Columns.Add("地区编码");
                    string data = string.Empty;
                    if (_dataSource.Tables[1].Rows != null && _dataSource.Tables[1].Rows.Count > 1)
                    {

                        foreach (DataRow item in _dataSource.Tables[1].Rows)
                        {
                            //if (item["value"].ToString().Contains(dqmc.Text))
                            //{
                            //    dt.Rows.Add(item["value"], item["name"]);
                            //}
                            data += item["value"] + "|" + item["name"] + "|" + item["fzjg"] + "\n";
                        }
                    }
                    var selectedData = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, data, new string[] { "地区名称", "地区编码", "发证机关" }, 600, 400);
                    //                var selectedData = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, dt
                    //, 500, 200,"");
                    if (selectedData == null)
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N042));
                        ParentPage.SetFocus();
                        return;
                    }

                    dqbm.Text = selectedData["地区编码"].ToString();
                    dqmc.Text = selectedData["地区名称"].ToString();
                    TS_FZJG.Text = selectedData["发证机关"].ToString();
                    Dq = selectedData["地区编码"].ToString();
                    ParentPage.SetFocus(dqmc);
                }
            }
        }

        private void ID_TYPE_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ID_TYPE.GetSelectedValue() == "1" || (ID_TYPE.GetSelectedValue() == "2" && (FLAG == "V0" || FLAG == "V19" || FLAG == "V14" || (FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") || (FLAG == "V5" && LoginUserInfo.KinbrNo.Substring(0, 3) == "302") || FLAG == "V22" || FLAG == "V8")))
            {
                Sdate2.Visibility = yxq.Visibility = Visibility.Visible;
            }
            //else 
            //{
            //    Sdate2.Visibility = yxq.Visibility = Visibility.Collapsed;
            //}
            if ("1" == ID_TYPE.GetSelectedValue())
            {
                DeviceManager.SetIdentityCardReader(ID_NO, IdentityCardReaderType.ReadCardOrInput);
            }
            else
            {
                DeviceManager.SetIdentityCardReader(ID_NO, IdentityCardReaderType.Input);
            }
            isAreadyCreatId = false;
            oldName = string.Empty;
            if (!ParentPage.SetInputOfIdCard(ID_NO, (ID_TYPE.GetSelectedValue() == "1")))
            {
                ParentPage.SetFocus(ID_TYPE);
                return;
            }
            else
            {
                ParentPage.SetInputOfIdCard(ID_NO, (ID_TYPE.GetSelectedValue() == "1"));
            }
            if (ID_TYPE.GetSelectedValue() == "3" || ID_TYPE.GetSelectedValue() == "F")
            {
                JJBM.SetSelectedValue("E05");
                HY.SetSelectedValue("200");
                JJBM.IsEnabled = false;
                HY.IsEnabled = false;
            }
            else
            {
                JJBM.SelectedIndex = 0;
                HY.SelectedIndex = 0;
                JJBM.IsEnabled = false;
                HY.IsEnabled = false;
            }
            if (FLAG == "V19" || FLAG == "V8" || FLAG == "V5" || FLAG == "V7" || FLAG == "V10" || FLAG == "V13" || FLAG == "V14" || FLAG == "V16" || FLAG == "V17" || FLAG == "V18" || FLAG == "V23" || FLAG == "V24" || FLAG == "V4" || (FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") || FLAG == "V11" || FLAG == "V12" || FLAG == "V9" || FLAG == "V3" || FLAG == "V2" || FLAG == "V1" || FLAG == "V0")
            {
                if (ID_TYPE.GetSelectedValue() == "1")//身份证
                {
                    dqmc.Visibility = tb2.Visibility = dqbm.Visibility = tb1.Visibility = Visibility.Visible;
                    if (FLAG == "V11" && !IsUpdate)//大石桥想要默认发证机关
                    {
                        TS_FZJG.Text = "大石桥市公安局";
                        dqmc.Text = "大石桥市";
                        dqbm.Text = "2262";
                    }
                }
                else if (ID_TYPE.GetSelectedValue() == "4" || ID_TYPE.GetSelectedValue() == "6" || ID_TYPE.GetSelectedValue() == "J")//军人
                {
                    dqmc.Visibility = tb2.Visibility = dqbm.Visibility = tb1.Visibility = Visibility.Collapsed;
                    dqbm.Text = "1100";
                }
                else if (ID_TYPE.GetSelectedValue() == "G" || ID_TYPE.GetSelectedValue() == "N" || ID_TYPE.GetSelectedValue() == "O" || ID_TYPE.GetSelectedValue() == "P")//武警 
                {
                    dqmc.Visibility = tb2.Visibility = dqbm.Visibility = tb1.Visibility = Visibility.Collapsed;
                    dqbm.Text = "6530";
                }
                else if (ID_TYPE.GetSelectedValue() == "7" || ID_TYPE.GetSelectedValue() == "F" || ID_TYPE.GetSelectedValue() == "I")//港澳台外国人 
                {
                    dqmc.Visibility = tb2.Visibility = dqbm.Visibility = tb1.Visibility = Visibility.Collapsed;
                    dqbm.Text = "1000";
                }
                else if (FLAG == "V19" && (ID_TYPE.GetSelectedValue() == "2" || ID_TYPE.GetSelectedValue() == "E"))
                {
                    dqmc.Visibility = tb2.Visibility = dqbm.Visibility = tb1.Visibility = Visibility.Visible;
                }
                else
                {
                    dqmc.Visibility = tb2.Visibility = dqbm.Visibility = tb1.Visibility = Visibility.Collapsed;
                    dqbm.Text = "9999";
                }
            }
            //天山 要求 1000交易 身份证只刷卡
            if (ID_TYPE.GetSelectedValue() == "1")
            {
                if (FLAG == "V19" && ParentPage.TradeModel.Code == "1000")
                {
                    DeviceManager.SetIdentityCardReader(ID_NO, IdentityCardReaderType.ReadCard);
                }
                else
                {
                    DeviceManager.SetIdentityCardReader(ID_NO, IdentityCardReaderType.ReadCardOrInput);
                }
            }
            else
            {
                DeviceManager.SetIdentityCardReader(ID_NO, IdentityCardReaderType.Input);
            }
        }

        //private void ID_NO_GotFocus(object sender, RoutedEventArgs e)
        //{
        //    if (ID_TYPE.GetSelectedValue() == "1")
        //    {
        //        var record = DeviceHelper.ReadIdentityCard();
        //        IdentityCardEntity data = record.Data;
        //        if (!string.IsNullOrEmpty(data.IdNumber))
        //        {
        //            ID_NO.Text = data.IdNumber.Trim();
        //        }
        //        if (!string.IsNullOrEmpty(data.Sex))
        //        {
        //            SEX.SetSelectedKey(data.Sex);
        //            SEX.IsEnabled = false;
        //        }
        //        Beg_date2.Text = data.ValidDateStart.ToShortDateString().Trim() != "0001/1/1" ? data.ValidDateStart.ToShortDateString() : string.Empty;
        //        End_date2.Text = data.ValidDateEnd.ToShortDateString().Trim() != "0001/1/1" ? data.ValidDateEnd.ToShortDateString() : string.Empty;
        //        birth_date.Text = data.BirthDay.ToShortDateString().Trim() != "0001/1/1" ? data.BirthDay.ToShortDateString() : string.Empty;
        //    }
        //}
        private void ID_NO_LostFocus(object sender, RoutedEventArgs e)
        {
            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            DeviceManager.GetIdentityCardData(ID_NO);
            isAreadyCreatId = false;
            oldName = string.Empty;
            //新增加将证件号码字母自动转为大写
            ID_NO.Text = ID_NO.Text.Trim().ToUpper();

            //初始化控件逻辑
            //FocusManagerExt.SetAssertNotEmpty(Beg_date2, false);
            //FocusManagerExt.SetAssertNotEmpty(End_date2, false);
            HCJG.IsEnabled = false;
            LW_FLG.IsEnabled = false;
            SEX.IsEnabled = true;
            CIF_NAME.IsReadOnly = false;
            //CIF_NAME.Text = string.Empty;  fuhao 20141105 不人为清空cif_name

            //当从设备读取到证件数据情况下，进行默认赋值处理
            if (DeviceManager.GetIdentityCardData(ID_NO) != null && !DeviceManager.GetIdentityCardData(ID_NO).HasError)
            {
                var data = DeviceManager.GetIdentityCardData(ID_NO).Data;

                if (!string.IsNullOrEmpty(data.IdNumber))
                {
                    ID_NO.Text = data.IdNumber.Trim();
                }
                if (!string.IsNullOrEmpty(data.Sex))
                {
                    if (data.Sex == "1" || data.Sex.Substring(0, 1) == "男")
                    {
                        data.Sex = "男";
                    }
                    else if (data.Sex == "2" || data.Sex.Substring(0, 1) == "女")
                    {
                        data.Sex = "女";
                    }
                    SEX.SetSelectedKey(data.Sex);
                    SEX.IsEnabled = false;
                }
                if (data.ValidDateStart.ToString("yyyyMMdd").Trim() != "00010101")
                {
                    Beg_date2.Text = data.ValidDateStart.ToString("yyyyMMdd");
                }
                if (data.ValidDateEnd.ToString("yyyyMMdd").Trim() != "00010101")
                {
                    End_date2.Text = data.ValidDateEnd.ToString("yyyyMMdd").Trim();
                }
                if (!string.IsNullOrEmpty(data.Name))
                {
                    CIF_NAME.Text = data.Name.Trim();
                }
                if (!string.IsNullOrEmpty(data.Address))
                {
                    if (FLAG == "V19")
                    {
                        DSDZ.Text = data.Address.Trim();
                    }
                    else
                    {
                        DSDZ.Text = ADDR.Text = data.Address.Trim();
                    }
                }
                //若外国人，需要核定国籍
                if (data is IdentityCard2ForeignerEntity)
                {
                    var foreigner = data as IdentityCard2ForeignerEntity;
                    country.SetSelectedValue(foreigner.Country); //国籍为GB/T 2659.1的3字符拉丁字母代码
                    YW_NAME.Text = foreigner.OtherName;//英文姓名
                    //如果中文没有自动给上英文名
                    if (string.IsNullOrEmpty(CIF_NAME.Text))
                    {
                        CIF_NAME.Text = foreigner.OtherName;
                    }
                    if (string.IsNullOrEmpty(CIF_NAME.Text))
                    {
                        CIF_NAME.Text = foreigner.OtherName.Replace(" ", "");
                    }
                    //出生日期
                    if (foreigner.BirthDay.ToString("yyyyMMdd").Trim() != "00010101")
                    {
                        birth_date.Text = foreigner.BirthDay.ToString("yyyyMMdd");
                    }
                }
            }
            //身份证逻辑
            if ("1" == ID_TYPE.GetSelectedValue() || "E" == ID_TYPE.GetSelectedValue())
            {
                //长度判定,开客户id务必保持18位身份证号
                if (ParentPage.Len(ID_NO.Text.Trim()) != 18)
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N003));
                    ParentPage.SetFocus(ID_NO);
                    return;
                }
                //验证证件有效性
                // 暂时调用sp8015.c对输入身份证进行验证080222
                var output = ParentPage.TradeAPIs.TF_Deposit_IDNumberVerification(new IDNumberVerification.Input { ZJLX = "1", ZJHM = ID_NO.Text });
                if (output.IsFailed)
                {
                    ParentPage.TradeAPIs.ShowTip(output.FailureCause);
                    ParentPage.SetFocus(ID_NO);
                    return;
                }
                if (output.YZTGBZ[0] != '1')
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
                    ParentPage.SetFocus(ID_NO);
                    return;
                }
                ID_NO.Text = ParentPage.TradeAPIs.Delspace(output.ZJHM);

                #region 身份核查
                if (FLAG == "V1") //郏县 想柜员可选联网标志
                {
                    LW_FLG.IsEnabled = true;
                }
                else
                {
                    LW_FLG.IsEnabled = false;
                }
                //执行身份核查
                if (FLAG == "V8" || (FLAG == "V19" && this.ComponentHelper.isCheckId) || FLAG == "V5")//保留阳光配置、青隆全部嵌入式联网核查
                {
                    var record = ParentPage.TradeAPIs.IdCheck(ID_NO);
                    if (record.IsOnline && record.IsComplated)
                    {
                        //核查通过，返显核查信息
                        if (record.Result == "00")
                        {
                            HCJG.SetSelectedValue("0");
                        }
                        else
                        {
                            HCJG.SetSelectedValue(record.Result.TrimStart('0'));
                        }
                        LW_FLG.SetSelectedValue("1");
                        if (!string.IsNullOrEmpty(record.DeviceInfo.Sex))
                        {
                            SEX.SetSelectedKey(record.DeviceInfo.Sex);
                            SEX.IsEnabled = false;
                        }
                        //某些机器上ToShortDateString()返回0001-01-01，导致逻辑失效 -- wangquan
                        if (record.DeviceInfo.ValidDateStart.Year != 1)//.ToShortDateString() != "0001/1/1")
                        {
                            Beg_date2.Text = record.DeviceInfo.ValidDateStart.ToString("yyyyMMdd");//.ToString();
                            Beg_date2.IsEnabled = false;
                        }
                        if (record.DeviceInfo.ValidDateEnd.Year != 1)//.ToShortDateString() != "0001/1/1")
                        {
                            End_date2.Text = record.DeviceInfo.ValidDateEnd.ToString("yyyyMMdd");//.ToShortDateString();
                            End_date2.IsEnabled = false;
                        }
                        if (record.DeviceInfo.BirthDay.Year != 1)//.ToShortDateString() != "0001/1/1")
                        {
                            birth_date.Text = record.DeviceInfo.BirthDay.ToString("yyyyMMdd");//.ToShortDateString();
                            birth_date.IsEnabled = false;
                        }
                        CIF_NAME.Text = record.Name;
                        CIF_NAME.IsReadOnly = true;
                        TS_FZJG.Text = record.IssuingAuthority;
                    }
                    else
                    {
                        //未核查或失败
                        if (record.IsOnline && ParentPage.ShowQuestionMessageBox("联网身份核查未通过，是否继续？") == MessageBoxResult.No)
                        {
                            ParentPage.SetFocus(ID_NO);
                            return;
                        }
                        //自行手工选择核查结果，联网标志置为未核查
                        HCJG.IsEnabled = true;
                        LW_FLG.SetSelectedValue("0");
                    }
                    //逻辑控制
                    //FocusManagerExt.SetAssertNotEmpty(Beg_date2, true);
                    //FocusManagerExt.SetAssertNotEmpty(End_date2, true); 
                }
                #endregion

            }

            if (!IsUpdate && !this.ComponentHelper.isOutComing)
            {
                //阳关建立客户信息校验
                if (FLAG == "V8")
                {
                    if (ID_TYPE.GetSelectedValue() == "1")
                    {
                        //先校验是否用身份证+身份证号建立过客户信息
                        var output3 = this.ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { KHLX = "1", ZJLX = "1", ZJHM = ID_NO.Text });
                        if (output3.IsFailed)
                        {
                            this.ParentPage.ShowTip(output3.FailureCause);
                            this.ParentPage.SetFocus(ID_NO);
                            return;
                        }
                        if (output3.WJData.Count > 0)
                        {
                            //若之前用身份证+身份证号建立过客户信息   再校验是否用户口簿建立过客户信息
                            var output5 = this.ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { KHLX = "1", ZJLX = "2", ZJHM = ID_NO.Text });
                            if (output5.IsFailed)
                            {
                                this.ParentPage.TradeAPIs.ShowTip(output5.FailureCause);
                                this.ParentPage.SetFocus(ID_NO);
                                return;
                            }
                            if (output5.WJData.Count > 0)
                            {
                                this.ParentPage.TradeAPIs.ShowInfoMessageBox("该客户已用身份证和户口簿均建立过客户信息！");
                                this.ParentPage.SetFocus(ID_NO);
                                return;
                            }
                        }
                        else
                        {
                            //若之前没用身份证+身份证号建立过客户信息 则校验是否用户口簿建立过客户信息
                            var output2 = this.ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { KHLX = "1", ZJLX = "2", ZJHM = ID_NO.Text });
                            if (output2.IsFailed)
                            {
                                this.ParentPage.TradeAPIs.ShowTip(output2.FailureCause);
                                this.ParentPage.SetFocus(ID_NO);
                                return;
                            }
                            var row2 = this.ParentPage.TradeAPIs.ShowDataBoxViewer(output2.WJ, new string[] { });
                            if (output2.WJData.Count > 0)
                            {
                                string msg = "该客户已用户口薄建立客户信息，请修改证件信息？";
                                if (this.ParentPage.ShowMessageBox(msg, "客户信息已存在", MessageBoxButton.OK) == MessageBoxResult.OK)
                                {
                                    //跳转到客户基本信息维护交易
                                    this.ParentPage.OpenTradePage("Trade.CustomerManager.T1002",
                                        TradePageExtension.OpenOptions.Tab,
                                                       new Dictionary<string, object>()
                                                   {
                                                       {"_open_path", "T1000"},
                                                       {"CIF_TYPE","1"},
                                                       {"_ID_TYPE", "2"},
                                                       {"_ID_NO", ID_NO.Text}
                                                   });
                                }
                                return;
                            }
                        }

                    }
                    else if (ID_TYPE.GetSelectedValue() == "2")
                    {
                        //先校验是否用户口簿+身份证号建立过客户信息
                        var output4 = this.ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { KHLX = "1", ZJLX = "2", ZJHM = ID_NO.Text });
                        if (output4.IsFailed)
                        {
                            this.ParentPage.TradeAPIs.ShowTip(output4.FailureCause);
                            this.ParentPage.SetFocus(ID_NO);
                            return;
                        }
                        if (output4.WJData.Count > 0)
                        {
                            //若之前用户口簿+身份证号建立过客户信息   再校验是否用身份证+身份证号建立过客户信息
                            var output6 = this.ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { KHLX = "1", ZJLX = "1", ZJHM = ID_NO.Text });
                            if (output6.IsFailed)
                            {
                                this.ParentPage.TradeAPIs.ShowTip(output6.FailureCause);
                                this.ParentPage.SetFocus(ID_NO);
                                return;
                            }
                            if (output6.WJData.Count > 0)
                            {
                                this.ParentPage.TradeAPIs.ShowInfoMessageBox("该客户已用身份证和户口簿均建立过客户信息！");
                                this.ParentPage.SetFocus(ID_NO);
                                return;
                            }
                        }
                        else
                        {
                            //检验是否用身份证+身份证号建立过客户信息
                            var output2 = this.ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { KHLX = "1", ZJLX = "1", ZJHM = ID_NO.Text });
                            if (output2.IsFailed)
                            {
                                this.ParentPage.TradeAPIs.ShowTip(output2.FailureCause);
                                this.ParentPage.SetFocus(ID_NO);
                                return;
                            }
                            var row2 = this.ParentPage.TradeAPIs.ShowDataBoxViewer(output2.WJ, new string[] { });
                            if (output2.WJData.Count > 0)
                            {
                                this.ParentPage.TradeAPIs.ShowInfoMessageBox("该客户已用身份证建立过客户信息！");
                                this.ParentPage.SetFocus(ID_NO);
                                return;
                            }
                        }
                    }
                }
                if (FLAG == "V0")
                {
                    var output2 = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { ZJHM = ID_NO.Text });
                    if (output2.IsFailed)
                    {
                        ParentPage.TradeAPIs.ShowTip(output2.FailureCause);
                        ParentPage.SetFocus(ID_NO);
                        return;
                    }
                    if (output2.WJData.Count > 0)
                    {
                        if (this.ParentPage.TradeAPIs.ShowQuestionMessageBox("客户已用该证件号建立客户信息，请核实后确认是否继续？", "询问信息", MessageBoxResult.No, MessageBoxButton.YesNo) == MessageBoxResult.No)
                        {
                            ParentPage.SetFocus(ID_NO);
                            return;
                        }
                    }
                    
                }
                var output1 = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { ZJHM = ID_NO.Text, ZJLX = ID_TYPE.GetSelectedValue() });
                if (output1.IsFailed)
                {
                    ParentPage.TradeAPIs.ShowTip(output1.FailureCause);
                    ParentPage.SetFocus(ID_NO);
                    return;
                }
                var data = output1.WJ;
                if (output1.WJData.Count == 0)
                {
                    data = "客户未建立客户信息";
                    if (FLAG == "V19")
                    {
                        if (ID_TYPE.GetSelectedValue() == "1")
                        {
                            var output2 = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { ZJHM = ID_NO.Text, ZJLX = "2" });
                            if (output2.IsFailed)
                            {
                                ParentPage.TradeAPIs.ShowTip(output2.FailureCause);
                                ParentPage.SetFocus(ID_NO);
                                return;
                            }
                            if (output2.WJData.Count != 0)
                            {
                                ParentPage.ShowMessageBox("客户已用户口簿建立客户信息，请查询");
                                ParentPage.SetFocus(ID_NO);
                                return;
                            }
                        }
                        else if (ID_TYPE.GetSelectedValue() == "2")
                        {
                            var output2 = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { ZJHM = ID_NO.Text, ZJLX = "1" });
                            if (output2.IsFailed)
                            {
                                ParentPage.TradeAPIs.ShowTip(output2.FailureCause);
                                ParentPage.SetFocus(ID_NO);
                                return;
                            }
                            if (output2.WJData.Count != 0)
                            {
                                ParentPage.ShowMessageBox("客户已用身份证建立客户信息，请查询");
                                ParentPage.SetFocus(ID_NO);
                                return;
                            }
                        }

                    }
                }
                #region /*V9：客户信息不存在时，系统同样弹出对话框，但无任何记录，因此无需弹窗提示*/
                if (output1.WJData.Count != 0 && FLAG == "V9")
                {
                    var selectedData = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, data, new string[] { "客户编号", "客户名称", "证件号码" }, 500, 200);

                    if (selectedData == null)
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N042));
                        ParentPage.SetFocus(ID_NO);
                        return;
                    }

                    if (selectedData["客户编号"].ToString() != "客户未建立客户信息")
                    {
                        isAreadyCreatId = true;
                        oldName = selectedData["客户名称"].ToString();
                        ParentPage.ShowMessageBox("客户已建立客户信息，请查询");
                        ParentPage.SetFocus(ID_NO);
                        return;
                    }
                }
                else if (FLAG != "V9")
                {
                    var selectedData = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, data, new string[] { "客户编号", "客户名称", "证件号码" }, 500, 200);

                    if (selectedData == null)
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N042));
                        ParentPage.SetFocus(ID_NO);
                        return;
                    }

                    if (selectedData["客户编号"].ToString() != "客户未建立客户信息")
                    {
                        isAreadyCreatId = true;
                        oldName = selectedData["客户名称"].ToString();
                        ParentPage.ShowMessageBox("客户已建立客户信息，请查询");
                        ParentPage.SetFocus(ID_NO);
                        return;
                    }
                }
                #endregion

            }
            if (FLAG != "V19" && !(FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") && !(FLAG == "V5" && LoginUserInfo.KinbrNo.Substring(0, 3) == "302") && FLAG != "V22" && FLAG != "V8" && FLAG != "V0" && FLAG != "V13" && FLAG != "V14")//除了以上银行，其他行户口本有效期隐藏
            {
                if (ID_TYPE.GetSelectedValue() == "2")//户口本 时，有效期隐藏，有效期设置默认值
                {
                    Sdate2.Visibility = yxq.Visibility = Visibility.Collapsed;
                    Beg_date2.Text = LoginUserInfo.TradeDate;
                    End_date2.Text = "99991231";
                }
                else
                {
                    Sdate2.Visibility = yxq.Visibility = Visibility.Visible;
                    //Beg_date2.Text = String.Empty;
                    //End_date2.Text = String.Empty;
                }
            }
            //else
            //{
            //    Sdate2.Visibility = yxq.Visibility = Visibility.Visible;
            //    Beg_date2.Text = String.Empty;
            //    End_date2.Text = String.Empty;
            //}

            //if (FLAG == "V19" && ID_TYPE.GetSelectedValue() == "1")
            //{
            //    string msg = "是否拍照留存客户影像信息？";
            //    if (this.ParentPage.TradeAPIs.ShowQuestionMessageBox(msg, "未建立客户信息", MessageBoxResult.OK, MessageBoxButton.OKCancel) == MessageBoxResult.OK)
            //    {
            //        TellerSystem.Library.Ext.TradeExtension.FtpHandle_TS.photograph(ID_NO.Text.Trim());
            //    }
            //}
            //1002交易 如果输入证件号码和原证件号码不一致 调核心做校验 如果新输入的证件号已存在则报错 不存在 则继续
            if (!string.IsNullOrEmpty(old_id_no) && !old_id_no.Trim().Equals(ID_NO.Text.Trim()))
            {

                //根据证件类型和号码查询客户是否已登记
                var output = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input { KHLX = "1", ZJLX = ID_TYPE.GetSelectedValue(), ZJHM = ID_NO.Text });
                if (output.IsFailed)
                {
                    ParentPage.TradeAPIs.ShowTip(output.FailureCause);
                    ParentPage.SetFocus(ID_NO);
                    return;
                }
                var row = ParentPage.TradeAPIs.ShowDataBoxViewer(output.WJ, new string[] { });
                if (row != null)
                {
                    ParentPage.TradeAPIs.ShowTip("该证件号码已存在！");
                    ParentPage.SetFocus(ID_NO);
                    return;
                }
                if (FLAG == "V5" && LoginUserInfo.KinbrNo.Substring(0, 3) == "305")
                {
                    if (this.ParentPage.TradeAPIs.ShowQuestionMessageBox("原证件号码与现证件号码不一致，是否继续维护？", "询问信息", MessageBoxResult.No, MessageBoxButton.YesNo) == MessageBoxResult.No)
                    {
                        ParentPage.SetFocus(ID_NO);
                        return;
                    }
                }
            }
            if (FLAG == "V21" || FLAG == "V22")
            {
                if ("1" == ID_TYPE.GetSelectedValue())
                {
                    birth_date.IsEnabled = false;
                    birth_date.Text = ID_NO.Text.Substring(6, 8);
                }
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public PersonalCustomerInfoArgs Controls
        {
            get
            {
                return this.personalCustomerInfoArgs;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public class PersonalCustomerInfoArgs
        {
            /// <summary>
            /// 客户等级
            /// </summary>
            public ComboBox KHDJ { get; internal set; }
            /// <summary>
            /// 贡 献 度
            /// </summary>
            public ComboBox GXD { get; internal set; }
            /// <summary>
            /// 证件类型
            /// </summary>
            public ComboBox ZJLX { get; internal set; }
            /// <summary>
            /// 核查结果
            /// </summary>
            public ComboBox HCJG { get; internal set; }
            /// <summary>
            /// 联网标志
            /// </summary>
            public ComboBox LWBZ { get; internal set; }
            /// <summary>
            /// 佐证证件
            /// </summary>
            public ComboBox ZZZZ { get; internal set; }
            /// <summary>
            /// 国民经济部门
            /// </summary>
            public ComboBox GMJJBM { get; internal set; }
            /// <summary>
            /// 行    业
            /// </summary>
            public ComboBox HY { get; internal set; }
            /// <summary>
            /// 性    别
            /// </summary>
            public ComboBox XB { get; internal set; }
            /// <summary>
            /// 国    籍
            /// </summary>
            public ComboBox GJ { get; internal set; }
            /// <summary>
            /// 英文姓名
            /// </summary>
            public TextBox YWXM { get; internal set; }
            /// <summary>
            /// 证件号码
            /// </summary>
            public TextBox ZJHM { get; internal set; }
            /// <summary>
            /// 有效日期-开始
            /// </summary>
            public TextBox YXRQKS { get; internal set; }

            /// <summary>
            /// 有效日期-结束
            /// </summary>
            public TextBox YXRQJS { get; internal set; }
            /// <summary>
            /// 发证机关
            /// </summary>
            public TextBox FZJG { get; internal set; }
            /// <summary>
            /// 户    名
            /// </summary>
            public TextBox HM { get; internal set; }
            /// <summary>
            /// 曾 用 名
            /// </summary>
            public TextBox CYM { get; internal set; }
            /// <summary>
            /// 联系电话
            /// </summary>
            public TextBox LXDH { get; internal set; }
            /// <summary>
            /// 手机号
            /// </summary>
            public TextBox SJH { get; internal set; }
            /// <summary>
            /// 联系地址
            /// </summary>
            public TextBox LXDZ { get; internal set; }
            /// <summary>
            /// 单位地址
            /// </summary>
            public TextBox DWDZ { get; internal set; }
            /// <summary>
            /// 证件地址
            /// </summary>
            public TextBox ZJDZ { get; internal set; }
            /// <summary>
            /// 邮政编码
            /// </summary>
            public TextBox YZBM { get; internal set; }
            /// <summary>
            /// 传    真
            /// </summary>
            public TextBox CZ { get; internal set; }
            /// <summary>
            /// 电子邮件
            /// </summary>
            public TextBox DZYJ { get; internal set; }
            /// <summary>
            /// 职业分类
            /// </summary>
            public ComboBox ZYFL { get; internal set; }

            //天山新增信息
            /// <summary>
            /// 民族
            /// </summary>
            public ComboBox MZ { get; internal set; }
            /// <summary>
            /// 婚否
            /// </summary>
            public ComboBox HF { get; internal set; }
            /// <summary>
            /// 学历
            /// </summary>
            public ComboBox XL { get; internal set; }
            /// <summary>
            /// 工作单位
            /// </summary>
            public TextBox GZDW { get; internal set; }
            /// <summary>
            /// 月收入
            /// </summary>
            public TextBox YSR { get; internal set; }
            /// <summary>
            /// 天山发证机关
            /// </summary>
            public TextBox TS_FZJG { get; internal set; }

            /// <summary>
            /// 税收标识
            /// </summary>
            public ComboBox SSBS { get; internal set; }
            /// <summary>
            /// 年收入
            /// </summary>
            public TextBox NSR { get; internal set; }
            /// <summary>
            /// 汉语拼音
            /// </summary>
            public TextBox HYPY { get; internal set; }
            /// <summary>
            /// 民族
            /// </summary>
            //public ComboBox MZ { get; internal set; }
            /// <summary>
            /// 婚姻状态
            /// </summary>
            public ComboBox HYZK { get; internal set; }
            /// <summary>
            /// 教育水平
            /// </summary>
            public ComboBox JYSP { get; internal set; }
            /// <summary>
            /// 户籍邮编
            /// </summary>
            public TextBox HJYB { get; internal set; }
        }

        private void CIF_LVL_GotFocus(object sender, RoutedEventArgs e)
        {
            RaiseGotFocus();
        }

        private void EMAIL_LostFocus(object sender, RoutedEventArgs e)
        {
            RaiseLostFocus();
        }

        private void MPHONE_LostFocus(object sender, RoutedEventArgs e)
        {
            if (MPHONE.Text.Trim().Length < 11 && MPHONE.Text.Trim().Length >= 1)
            {
                ParentPage.TradeAPIs.ShowTip("手机号码要求不少于11位，请重新输入！");
                ParentPage.TradeAPIs.SetFocus();
                return;
            }
            #region 提示手机号关联
            if (MPHONE.Text != "")
            {
                Message msg = new Message();
                ParentPage.InitFd(msg);
                ParentPage.CommSend(msg);
                msg.Fd16 = "9598";
                string sql = "select a.cif_no,b.name,'" + MPHONE.Text.Trim() + "' from cif_per_inf a,cif_id_code_rel b where a.cif_no=b.cif_no and (trim(telephone)='"
                    + MPHONE.Text.Trim() + "' or trim(phone)='" + MPHONE.Text.Trim() + "')and b.legal_br_no='" + LoginAuthentication.Instance.GroupKinbrNo + "'";
                msg.Fd123 = sql;
                ParentPage.CallServer(msg);
                if (msg.Fd12 != "0000")
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetError(msg));
                    ParentPage.TradeAPIs.SetFocus();
                    return;
                }
                if (msg.FileData != "")
                {
                    var file = msg.FileData;
                    int num = file.Split('\n').Count();
                    string[] data = file.Split('\n');
                    string name = string.Empty;
                    for (int i = 0; i < num - 1; i++)
                    {
                        name += data[i].Split('|')[1].ToString() + "、";
                        if (i == 2 && num > 3)
                        {
                            name += "等";
                            break;
                        }
                    }
                    ParentPage.TradeAPIs.ShowInfoMessageBox("该联系电话【" + MPHONE.Text.Trim() + "】已关联过客户号\n关联户名：" + name);
                }
            }
            #endregion 提示手机号关联
        }

        private void btnCheck_GotFocus(object sender, RoutedEventArgs e)
        {
            if (FLAG == "V10")
            {
                if (this.ParentPage.TradeAPIs.ShowQuestionMessageBox("是否要发送验证码？", "询问信息", MessageBoxResult.Yes, MessageBoxButton.YesNo) == MessageBoxResult.Yes)
                {
                    return;
                }
                else
                {
                    ParentPage.SetFocus(TEL);
                    return;
                }
            }
        }
        private void btnCheck_Click(object sender, RoutedEventArgs e)
        {
            if (!string.IsNullOrEmpty(MPHONE.Text))
            {
                #region 2085接口属于手机银行业务接口，不建议在非手机银行业务中使用，改用渠道7021接口获取验证码
                //Message msg = new Message(Message.BitMap.Agn);
                //ParentPage.InitFd(msg);
                //ParentPage.CommSend(msg);
                //msg.Fd16 = "2085";
                //msg.Fd38 = MPHONE.Text.Trim();
                //ParentPage.CallAgn(msg);
                //if (msg.Fd12 != "0000")
                //{
                //    ParentPage.TradeAPIs.ShowInfoMessageBox(ParentPage.GetError(msg));
                //    ParentPage.SetFocus();
                //    return;
                //}
                //DXYZMBH = msg.Fd61.Trim();
                //DXYZM = msg.Fd60.Trim();
                //if (DeviceConfig.InDeviceDebugMode)
                //{
                //    ParentPage.TradeAPIs.ShowInfoMessageBox("短信验证码已发送到手机，请查收！\n【测试使用】短信验证码为：" + msg.Fd60.Trim());
                //}
                //else
                //{
                //    ParentPage.TradeAPIs.ShowInfoMessageBox("短信验证码已发送到手机，请查收！");
                //}
                #endregion

                //随机数产生6位手机验证码
                Random ra = new Random();
                DXYZM = ra.Next(0, 1000000).ToString();

                Message msg = new Message(Message.BitMap.Agn);
                ParentPage.InitFd(msg);
                ParentPage.CommSend(msg);
                msg.Fd16 = "7021";
                msg.Fd18 = "ECI";
                //msg.Fd30 = CardNo.Text;短信验证码发送交易不用上传卡号也可以的，没帮定手机号之前的手机验证码发送是不关联卡号的
                msg.Fd76 = MPHONE.Text.Trim();//手机号
                string TimeNow = Convert.ToDateTime(TradeHandle.GetServerTime()).ToString("yyyy年MM月dd日 HH:mm:ss");//获取系统当前时间

                #region 获取短信前缀
                Message _mm = new Message();
                ParentPage.InitFd(_mm);
                ParentPage.CommSend(_mm);
                _mm.Fd16 = "9598";
                _mm.Fd123 = string.Format("1,221003,{0},", LoginUserInfo.KinbrNo);
                ParentPage.CallServer(_mm);
                if (_mm.Fd12 != "0000")
                {
                    ParentPage.TradeAPIs.ShowInfoMessageBox(ParentPage.GetError(_mm));
                    ParentPage.SetFocus();
                    return;
                }
                string[] data = _mm.FileData.Split('|');//【xx村镇银行】提醒 中牟 融丰 天山没 提醒二字
                #endregion 获取短信前缀

                if (FLAG == "V0" || FLAG == "V12" || FLAG == "V19")
                {
                    msg.Fd95 = data[0] + "提醒您，您于" + TimeNow + "获得验证码：" + DXYZM;
                }
                else
                {
                    msg.Fd95 = data[0] + "您，您于" + TimeNow + "获得验证码：" + DXYZM;
                }
                //}
                if (DeviceConfig.InDeviceDebugMode)
                {
                    ParentPage.TradeAPIs.ShowInfoMessageBox("短信验证码已发送到手机，请查收！\n【测试使用】短信验证码为：" + DXYZM);
                }
                else
                {
                    ParentPage.CallAgn(msg);
                    if (msg.Fd12 != "0000")
                    {
                        ParentPage.TradeAPIs.ShowInfoMessageBox(ParentPage.GetError(msg));
                        ParentPage.SetFocus();
                        return;
                    }
                    ParentPage.TradeAPIs.ShowInfoMessageBox("短信验证码已发送到手机，请查收！");
                }
            }
            ParentPage.SetFocus(tbCheckCode);
        }

        private void tbCheckCode_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!string.IsNullOrEmpty(MPHONE.Text))
            {
                if (tbCheckCode.Text != DXYZM)
                {
                    ParentPage.TradeAPIs.ShowInfoMessageBox("验证码错误，请重新输入！");
                    ParentPage.SetFocus();
                }
            }
        }

        private void HJYZBM_LostFocus(object sender, RoutedEventArgs e)
        {
            //20140813 对私邮编非必输 对公邮编必输
            if (HJYZBM.Text.Trim() != string.Empty)
            {
                if (ParentPage.Len(HJYZBM.Text.Trim()) != 6)
                {
                    ParentPage.TradeAPIs.ShowTip("户籍邮编号码无效，请检查");
                    //ParentPage.SetFocus(                //QYYB);
                    ParentPage.SetFocus(HJYZBM);
                    return;
                }
            }

        }
        private void TEL_TextChanged(object sender, TextChangedEventArgs e)
        {

        }

        private void Dp_End_date2_LostFocus(object sender, RoutedEventArgs e)
        {

        }
        private void YSR_LostFocus(object sender, RoutedEventArgs e)
        {
            if ((FLAG == "V1" || FLAG == "V11") && YSR.Val.ToDecimal() == 0M)
            {
                ParentPage.TradeAPIs.ShowTip("月收入不能为零，请检查");
                ParentPage.SetFocus(YSR);
            }
        }

        private void ID_NO_GotFocus(object sender, RoutedEventArgs e)
        {
            if (FLAG == "V19" || FLAG == "V8" || FLAG == "V5" || FLAG == "V7" || FLAG == "V10" || FLAG == "V13" || FLAG == "V14" || FLAG == "V16" || FLAG == "V17" || FLAG == "V18" || FLAG == "V23" || FLAG == "V24" || FLAG == "V4" || (FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") || FLAG == "V11" || FLAG == "V12" || FLAG == "V9" || FLAG == "V3" || FLAG == "V2" || FLAG == "V1" || FLAG == "V0")
            {
                if (ID_TYPE.GetSelectedValue() == "1")//身份证
                { dqmc.Visibility = tb2.Visibility = dqbm.Visibility = tb1.Visibility = Visibility.Visible; }
                else if (ID_TYPE.GetSelectedValue() == "4" || ID_TYPE.GetSelectedValue() == "6" || ID_TYPE.GetSelectedValue() == "J")//军人
                {
                    dqmc.Visibility = tb2.Visibility = dqbm.Visibility = tb1.Visibility = Visibility.Collapsed;
                    dqbm.Text = "1100";
                }
                else if (ID_TYPE.GetSelectedValue() == "G" || ID_TYPE.GetSelectedValue() == "N" || ID_TYPE.GetSelectedValue() == "O" || ID_TYPE.GetSelectedValue() == "P")//武警 
                {
                    dqmc.Visibility = tb2.Visibility = dqbm.Visibility = tb1.Visibility = Visibility.Collapsed;
                    dqbm.Text = "6530";
                }
                else if (ID_TYPE.GetSelectedValue() == "7" || ID_TYPE.GetSelectedValue() == "F" || ID_TYPE.GetSelectedValue() == "I")//港澳台外国人 
                {
                    dqmc.Visibility = tb2.Visibility = dqbm.Visibility = tb1.Visibility = Visibility.Collapsed;
                    dqbm.Text = "1000";
                }
                else if (FLAG == "V19" && (ID_TYPE.GetSelectedValue() == "2" || ID_TYPE.GetSelectedValue() == "E"))
                {
                    dqmc.Visibility = tb2.Visibility = dqbm.Visibility = tb1.Visibility = Visibility.Visible;
                }
                else
                {
                    dqmc.Visibility = tb2.Visibility = dqbm.Visibility = tb1.Visibility = Visibility.Collapsed;
                    dqbm.Text = "9999";
                }
            }
            //天山 要求 1000交易 身份证只刷卡
            if (ID_TYPE.GetSelectedValue() == "1")
            {
                if (FLAG == "V19" && ParentPage.TradeModel.Code == "1000")
                {
                    DeviceManager.SetIdentityCardReader(ID_NO, IdentityCardReaderType.ReadCard);
                }
                else
                {
                    DeviceManager.SetIdentityCardReader(ID_NO, IdentityCardReaderType.ReadCardOrInput);
                }
            }
            else
            {
                DeviceManager.SetIdentityCardReader(ID_NO, IdentityCardReaderType.Input);
            }
        }
        int a = 0;
        private void JobType_LostFocus(object sender, RoutedEventArgs e)
        {

            if ((FLAG == "V11" & (this.ComponentHelper.Old_job != JobType.GetSelectedValue())) || a != 0)
            {
                string zyfld = null;
                zyfld = JobType.GetSelectedValue();
                cb_job_lf.SetItems(UserVariable.GetZyflType(zyfld));
                a++;
            }
            if ((FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") || FLAG == "V8")
            {
                if (JobType.GetSelectedValue() == "")
                {
                    ParentPage.TradeAPIs.ShowInfoMessageBox("职业分类不能为空！");
                    ParentPage.SetFocus();
                }
            }
            if (FLAG == "V8" && JobType.GetSelectedValue() == "99999")
            {
                if (IsUpdate && this.ComponentHelper.Old_job == "99999")
                {
                    ParentPage.TradeAPIs.ShowInfoMessageBox("原职业分类为[99999]失业、无业、退休等！请确认是否需要维护");
                }
                else
                {
                    ParentPage.TradeAPIs.ShowInfoMessageBox("职业分类不能[99999]失业、无业、退休等！");
                    ParentPage.SetFocus();
                }
            }
            if ((FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") || FLAG == "V8")
            {
                //设置职业类型
                var zyinfo = this.ParentPage.TradeAPIs.TF_Deposit_QueryJobTypeList(new QueryJobTypeList.Input()
                {
                    CXLX = "2",//2：根据一级码值查询一级码值对应的全部二级码值
                    ZYBM = JobType.GetSelectedValue()
                });
                if (zyinfo.IsFailed)
                {
                    this.ParentPage.TradeAPIs.ShowTip(zyinfo.FailureCause);
                    this.ParentPage.SetFocus();
                    return;
                }
                if (zyinfo.ZYLBData.Count > 0)
                {
                    var zydic = zyinfo.ZYLBData.ToDictionary(ajzdata => ajzdata.ZYMC, ajzdata => ajzdata.ZYLX);
                    cb_job_lf.SetItems(zydic);
                }
            }
        }

        private void cb_job_lf_LostFocus(object sender, RoutedEventArgs e)
        {
            if ((FLAG == "V2" && LoginUserInfo.KinbrNo.Substring(0, 3) == "152") || FLAG == "V8")
            {
                //设置职业类型
                var zyinfo = this.ParentPage.TradeAPIs.TF_Deposit_QueryJobTypeList(new QueryJobTypeList.Input()
                {
                    CXLX = "3",//3：根据二级码值查询二级码值对应的全部三级码值
                    ZYBM = cb_job_lf.GetSelectedValue()
                });
                if (zyinfo.IsFailed)
                {
                    this.ParentPage.TradeAPIs.ShowTip(zyinfo.FailureCause);
                    this.ParentPage.SetFocus();
                    return;
                }
                if (zyinfo.ZYLBData.Count > 0)
                {
                    var zydic = zyinfo.ZYLBData.ToDictionary(ajzdata => ajzdata.ZYMC, ajzdata => ajzdata.ZYLX);
                    cb_job_lf1.SetItems(zydic);
                }
            }
        }

        private void TS_FZJG_GotFocus(object sender, RoutedEventArgs e)
        {

        }
        private void cb_dwgs_LostFocus(object sender, RoutedEventArgs e)
        {
            if (cb_dwgs.GetSelectedValue() == "Y")
            {
                if (ID_TYPE.GetSelectedValue() != "1" && ID_TYPE.GetSelectedValue() != "2")
                {
                    TradePanel.SetColumnSpan(cb_ssbt, 3);
                }
                Page.TradeAPIs.CallComboBoxData(cb_ssbt, "BTSB");
                tb_ssbt.Visibility = cb_ssbt.Visibility = tb_btbz.Visibility = tb_BTBE.Visibility = Visibility.Visible;
            }
            else
            {
                tb_ssbt.Visibility = cb_ssbt.Visibility = tb_btbz.Visibility = tb_BTBE.Visibility = Visibility.Collapsed;
                if (IsUpdate)
                {
                    cb_ssbt.SetItems(new Dictionary<string, string> { { " ", " " } });
                    tb_BTBE.Text = " ";
                }
                else
                {
                    cb_ssbt.SetItems(new Dictionary<string, string> { { "", "" } });
                    tb_BTBE.Text = "";
                }
            }
        }

        private void MZ_LostFocus(object sender, RoutedEventArgs e)
        {
            if (MZ.GetSelectedValue() == "")
            {
                Page.ShowTip("请选择民族!");
                Page.SetFocus();
                return;
            }
        }

        private void HF_LostFocus(object sender, RoutedEventArgs e)
        {
            if (HF.GetSelectedValue() == "")
            {
                Page.ShowTip("请选择婚否!");
                Page.SetFocus();
                return;
            }
        }

        private void XL_LostFocus(object sender, RoutedEventArgs e)
        {
            if (XL.GetSelectedValue() == "")
            {
                Page.ShowTip("请选择学历!");
                Page.SetFocus();
                return;
            }
        }
    }

    #region 数据限定
    /// <summary>
    /// 组件数据交互类
    /// </summary>
    public class TBC_PCustomerInfoInput : TBC_ComponentInput
    {
        #region 构造

        #endregion

        #region 控制属性

        /// <summary>
        /// 外部调整交易标志
        /// </summary>
        public bool isOutComing { get; set; }

        /// <summary>
        /// 天山用于是否身份核查标志
        /// </summary>
        public bool isCheckId { get; set; }

        /// <summary>
        /// 大石桥用于获取原职业类型
        /// </summary>
        public string Old_job { get; set; }

        #endregion

        #region 交互方法

        #endregion
    }

    /// <summary>
    /// 组件数据输出类
    /// </summary>
    public class TBC_PCustomerInfoOutput : TBC_ComponentOutput
    {
    }

    #endregion
}
