﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using TellerSystem.Contract.ContractBase;
using TellerSystem.Library.Ext.Variables;
using TellerSystem.Communication;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using Platform.Controls.ControlsHelper;
using Platform.Library;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Library.Ext.TradeExtension;
using TellerSystem.Controls.Ext.ControlsHelper;
using Platform.Common.RunningParameters;
using TellerSystem.Devices.Interface;
using TellerSystem.Contract.Function;
using abc = TellerSystem.Contract.ContractBase;
using Platform.Presentation.FocusManagers;
using TellerSystem.Devices;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;
using TellerSystem.ServiceProxy.Ext;
using System.Text.RegularExpressions;
using TellerSystem.Controls.Ext.ControlsExt;
using TellerSystem.Devices.Config;

namespace TellerSystem.Controls.Ext.TradePageComponent
{
    /// <summary>
    /// 代理人业务组件
    /// </summary>
    public partial class TBC_PersonalCustomerInfo_NewEcif : TBC_ComponentBase<TBC_PCustomerInfoInput_NewEcif, TBC_PCustomerInfoOutput_NewEcif>
    {
        private PersonalCustomerInfoArgs personalCustomerInfoArgs = null;

        #region 属性

        public PageBase ParentPage { get; private set; }
        /// <summary>
        /// 是否已建立客户ID
        /// </summary>
        bool isAreadyCreatId = false;
        /// <summary>
        /// 已建立客户ID户名　
        /// </summary>
        string oldName = string.Empty;
        /// <summary>
        /// 原证件类型
        /// </summary>
        public string old_id_no = string.Empty;
        /// <summary>
        /// 原电话号码
        /// </summary>
        public string old_phone = string.Empty;
        /// <summary>
        /// 原座机号
        /// </summary>
        public string old_tel = string.Empty;
        public bool IsUpdate { get; set; }
        Dictionary<string, string> AreaCode = SystemFunction.GetPPCNameByCode("3");

        #endregion

        public TBC_PersonalCustomerInfo_NewEcif()
        {
            InitializeComponent();

            this.personalCustomerInfoArgs = new PersonalCustomerInfoArgs();
            this.personalCustomerInfoArgs.CYM = this.CIF_RENAME;
            this.personalCustomerInfoArgs.CZ = this.FAX;
            this.personalCustomerInfoArgs.DWDZ = this.DWDZ;
            this.personalCustomerInfoArgs.DZYJ = this.EMAIL;
            this.personalCustomerInfoArgs.FZJG = this.FZJG;
            this.personalCustomerInfoArgs.GJ = this.country;
            this.personalCustomerInfoArgs.GXD = this.CIF_CTB;
            this.personalCustomerInfoArgs.HCJG = this.HCJG;
            this.personalCustomerInfoArgs.HM = this.CIF_NAME;
            this.personalCustomerInfoArgs.HY = this.HY;
            this.personalCustomerInfoArgs.LWBZ = this.LW_FLG;
            this.personalCustomerInfoArgs.KHDJ = this.CIF_LVL;
            this.personalCustomerInfoArgs.LXDH = this.TEL;
            this.personalCustomerInfoArgs.LXDZ = this.ADDR;
            this.personalCustomerInfoArgs.SJH = this.MPHONE;
            this.personalCustomerInfoArgs.XB = this.SEX;
            this.personalCustomerInfoArgs.YWXM = this.YW_NAME;
            this.personalCustomerInfoArgs.YXRQJS = this.Beg_date2;
            this.personalCustomerInfoArgs.YXRQKS = this.End_date2;
            this.personalCustomerInfoArgs.YZBM = this.YZBM;
            this.personalCustomerInfoArgs.ZJDZ = this.DSDZ;
            this.personalCustomerInfoArgs.ZJHM = this.ID_NO;
            this.personalCustomerInfoArgs.ZJLX = this.ID_TYPE;
            this.personalCustomerInfoArgs.ZZZZ = this.ZZZZ;
            this.personalCustomerInfoArgs.ZYFLOne = this.JobTypeOne;

        }

        public void Init_TBC_CustomerInfo()
        {
            if (System.ComponentModel.DesignerProperties.GetIsInDesignMode(this)) return;
            ParentPage = (Platform.Common.BasicFunctions.DependencyObjectExtensions.FindVisualTreeAncestor(this, (x) => { return x is PageBase; })) as PageBase;
            if (ParentPage == null)
                return;
            //版本控制定义
            string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");

            this.ADDR.MaxLength = 120;
            this.DWDZ.MaxLength = 120;

            //默认不是外部跳转
            this.ComponentHelper.isOutComing = false;

            CIF_CTB.SetItems(new Dictionary<string, string> { { "低", "1" }, { "中", "2" }, { "高", "3" } });
            CIF_CTB.SelectedIndex = 0;

            //佐证证件
            ZZZZ.SetItems(UserVariable.GetZzzzType());
            ZZZZ.SelectedIndex = 0;

            //是否居民 对私
            SFJM.SetItems(new Dictionary<string, string> { { "居民", "Y" }, { "非居民", "N" } });
            SFJM.SelectedIndex = 0;

            //行业  对私
            HY.SetItems(UserVariable.GetIndustry(Page));
            HY.SelectedIndex = -1;

            //教育水平
            education_Level.SetItems(UserVariable.GetEduationLevel(Page));           
            //默认其他90
            education_Level.SelectedIndex = -1;

            //证件发放机关所属地区代码
            certIssuBrBlngRgonCode.SetItems(AreaCode);
            certIssuBrBlngRgonCode.IsEnabled = false;
            certIssuBrBlngRgonCode.SelectedIndex = 0;

            //是否境内居民
            dmstRsdntFlag.SetItems(new Dictionary<string, string> { { "境内", "I" }, { "境外", "O" } });
            dmstRsdntFlag.SelectedIndex = 0;
            //性别内容
            SEX.SetItems(UserVariable.GetSex_ecif());

            //个人，客户等级内容
            CIF_LVL.SetItems(UserVariable.GetCustomerLvlPer(Page));
            //ParentPage.TradeAPIs.CallComboBoxData(CIF_LVL, "C021");
            //CIF_LVL.SetItems(new Dictionary<string, string> { { "大众客户", "1" }, { "普通客户", "2" }, { "黄金客户", "3" }, { "白金客户", "4" }, { "黑金客户", "6" }, { "钻石客户", "6" } });
            CIF_LVL.SelectedIndex = 0;

            //核查结果
            //HCJG.SetItems(UserVariable.GetHcjgType());
            //ParentPage.TradeAPIs.CallComboBoxData(HCJG, "C031");
            HCJG.SetItems(new Dictionary<string, string> { { "公民身份号码与姓名一致,且存在照片", "00" }, { "公民身份号码与姓名一致,但不存在照片", "01" }, { "公民身份号码存在，但与姓名不匹配", "02" }, { "公民身份号码不存在", "03" }, { "其他错误", "04" }, { "输入的参数错误", "05" } });
            HCJG.SelectedIndex = 0;

            //联网标志
            //LW_FLG.SetItems(UserVariable.GetLwFlgType());//新ecif升级
            //ParentPage.TradeAPIs.CallComboBoxData(LW_FLG, "C032");
            LW_FLG.SetItems(new Dictionary<string, string> { { "待核实", "01" }, { "真实", "02" }, { "假名", "03" }, { "匿名", "04" }, { "无法核实", "05" } });
            LW_FLG.SelectedIndex = 0;

            //国籍
            //country.SetItems(UserVariable.GetCountryType());
            country.SetItems(UserVariable.GetCountryType(Page));
            country.SelectedValue = "CHN";
            //证件发放国家
            certIssuDstc.SetItems(UserVariable.GetCountryType(Page));
            certIssuDstc.SelectedValue = "CHN";

            //民族
            ntnCode.SetItems(UserVariable.GetNationType(Page));
            ntnCode.SelectedIndex = -1;
            //税收居民标识
            cmb_ssjmbs.SetItems(UserVariable.GetSsjmbs(Page));
            cmb_ssjmbs.SelectedIndex = 0;
            //婚姻状况
            cmb_hyzk.SetItems(UserVariable.GetHyzk(Page));
            cmb_hyzk.SelectedIndex = 0;
            //个人证件类型内容
            //ID_TYPE.SetItems(UserVariable.GetPerIdType());
            ID_TYPE.SetItems(UserVariable.GetPersonIdType(Page));
            // ID_TYPE.SetItems(new Dictionary<string, string> { { "第一代居民身份证", "100" },{ "第二代居民身份证", "101" }, { "临时身份证", "102" },{ "户口簿", "104" }, 
            // { "护照", "103" }, { "军官证", "107" },{"学生证","106"},
            //  { "士兵证", "113" }, { "港澳通行证", "114" },{ "台湾通行证或有效旅行证件", "116" }, { "外国人永久居留证", "117" },{"外国护照","119"}, { "警官证", "121" },
            //{ "其他对私证件类型", "120" }, { "台湾居民往来大陆通行证", "126" },  { "军官退休证", "109" },
            //{ "文职干部证", "110" },  { "武警身份证", "112" }});
            ID_TYPE.SelectedIndex = 0;
            //关系人证件类型内容
            //ParentPage.TradeAPIs.CallComboBoxData(ctcCertType, "C004");
            ctcCertType.SetItems(UserVariable.GetPersonIdType(Page));
            ctcCertType.SelectedIndex = 0;

            JobTypeOne.SetItems(UserVariable.GetJobTypeOne_per(Page));
            JobTypeOne.SelectedIndex = -1;

            CIF_LB.SetItems(new Dictionary<string, string> { { "自然人", "01" }, { "个体", "02" }, { "小微企业主", "03" }, { "其他", "99" } });
            CIF_LB.SelectedIndex = 0;

            this.tb_relName.Visibility = Visibility.Collapsed;
            this.relName.Visibility = Visibility.Collapsed;
            this.tb_relKeyTel.Visibility = Visibility.Collapsed;
            this.relKeyTel.Visibility = Visibility.Collapsed;
            this.tb_ctcCertType.Visibility = Visibility.Collapsed;
            this.ctcCertType.Visibility = Visibility.Collapsed;
            this.tb_ctcCertNo.Visibility = Visibility.Collapsed;
            this.ctcCertNo.Visibility = Visibility.Collapsed;
            this.Sdate.Visibility = Visibility.Collapsed;
            this.yxrq.Visibility = Visibility.Collapsed;
            if(ParentPage.TradeModel.Code=="1026")
            {
                YSJH.Visibility = TYSJH.Visibility = Visibility.Visible;
            }
        }

        private void Beg_date2_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(Beg_date2.Text))
            {
                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                ParentPage.SetFocus(Beg_date2);
                return;
            }
        }
        private void Beg_date2_GotFocus(object sender, RoutedEventArgs e)
        {
            if (!ID_TYPE.GetSelectedValue().Equals("B01"))
            {
                Beg_date2.ShowTip("无有效证件请输入：当天日期—99991231");
            }
        }
        private void End_date2_LostFocus(object sender, RoutedEventArgs e)
        {
            Beg_date2.RemoveTip();
            if (End_date2.Text.Trim() == "99999999")
            {
                End_date2.Text = "99991231";
                return;
            }

            if (ID_NO.Text.Trim() == "" && (End_date2.Text.Trim() != "" || Beg_date2.Text.Trim() != ""))
            {
                ParentPage.TradeAPIs.ShowTip("证件号码为空时，有效期必须为空");
                ParentPage.SetFocus(Beg_date2);
                return;
            }

            if (ID_NO.Text.Trim() != "")
            {
                if (End_date2.Text.Trim() != "" && Beg_date2.Text.Trim() != "")
                {
                    if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(End_date2.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                        ParentPage.SetFocus(End_date2);
                        return;
                    }
                    if (ParentPage.Atoi(End_date2.Text) < ParentPage.Atoi(Beg_date2.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                        //ParentPage.SetFocus(                //End_date);
                        ParentPage.SetFocus(End_date2);
                        return;
                    }
                }
                else if ((End_date2.Text.Trim() == "" && Beg_date2.Text.Trim() != "") || (End_date2.Text.Trim() != "" && Beg_date2.Text.Trim() == ""))
                {
                    ParentPage.TradeAPIs.ShowTip("请输入完整的有效期");
                    ParentPage.SetFocus(End_date2);
                    return;
                }
            }
        }

        private void Beg_date_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ParentPage.Atoi(LoginUserInfo.TradeDate) < ParentPage.Atoi(Beg_date.Text))
            {
                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                ParentPage.SetFocus(Beg_date);
                return;
            }
        }

        private void End_date_LostFocus(object sender, RoutedEventArgs e)
        {
            if (End_date.Text.Trim() == "99999999")
            {
                End_date.Text = "99991231";
                return;
            }

            if (ctcCertNo.Text.Trim() == "" && (End_date.Text.Trim() != "" || Beg_date.Text.Trim() != ""))
            {
                ParentPage.TradeAPIs.ShowTip("证件号码为空时，有效期必须为空");
                ParentPage.SetFocus(Beg_date);
                return;
            }

            if (ctcCertNo.Text.Trim() != "")
            {
                if (End_date.Text.Trim() != "" && Beg_date.Text.Trim() != "")
                {
                    if (ParentPage.Atoi(LoginUserInfo.TradeDate) > ParentPage.Atoi(End_date.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                        ParentPage.SetFocus(End_date);
                        return;
                    }
                    if (ParentPage.Atoi(End_date.Text) < ParentPage.Atoi(Beg_date.Text))
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                        //ParentPage.SetFocus(                //End_date);
                        ParentPage.SetFocus(End_date);
                        return;
                    }
                }
                else if ((End_date.Text.Trim() == "" && Beg_date.Text.Trim() != "") || (End_date.Text.Trim() != "" && Beg_date.Text.Trim() == ""))
                {
                    ParentPage.TradeAPIs.ShowTip("请输入完整的有效期");
                    ParentPage.SetFocus(End_date);
                    return;
                }
            }
        }

        private void CIF_NAME_LostFocus(object sender, RoutedEventArgs e)
        {
            YW_NAME.Text = TellerSystem.Library.Ext.TradeExtension.ChineseCodeConverter.ConvertWithBlank(CIF_NAME.Text);
        }

        private void CIF_RENAME_LostFocus(object sender, RoutedEventArgs e)
        {
            //检查客户名称与别名是否相同
            if (CIF_RENAME.Text == CIF_NAME.Text)
            {
                ParentPage.TradeAPIs.ShowTip("别名不能与姓名相同");
                //ParentPage.SetFocus(                //CIF_RENAME);
                ParentPage.SetFocus(CIF_RENAME);
                return;
            }
            //新增加将姓名转换为全角处理080301
            string tota = string.Empty;
            //int number; //add by wangzhe 20090703
            /**
            int lens = ParentPage.Mod(ParentPage.Len(CIF_RENAME.Text), 2);
            if (lens != 0)
            {
                ParentPage.ShowMessageBox("户名长度不为偶数，请检查!!!");
                //ParentPage.SetFocus(                //CIF_RENAME);
                ParentPage.SetFocus(CIF_RENAME);
                return;
            }**/
        }
        private void certIssuBrBlngRgon_LostFocus(object sender, RoutedEventArgs e)
        {
            //certIssuBrBlngRgon.Text = "";
            if (AreaCode.Count > 0)
            {
                string result = "";
                //如果 前台输入在dic中有值，直接显示该条数据
                try
                {
                    //判断是否是数字，数字代表输入的地址代码
                    bool bo = Regex.IsMatch(certIssuBrBlngRgon.Text, @"^[+-]?\d*[.]?\d*$");
                    if (!bo)
                    {
                        result = AreaCodeKey(AreaCode, certIssuBrBlngRgon.Text);
                    }
                    else
                    {
                        if (!string.IsNullOrEmpty(certIssuBrBlngRgon.Text))
                        {
                            foreach (var res in AreaCode)
                            {
                                if (res.Key.Contains(certIssuBrBlngRgon.Text))
                                {
                                    result += res.Key + "|" + res.Value + "\n";
                                }
                            }
                        }
                    }
                    if (result == "")
                    {
                        ParentPage.SetFocus(certIssuBrBlngRgon);
                        certIssuBrBlngRgon.ShowTip("身份证前6位，或者县级行政区！");
                        return;
                    }
                    DataRow selectedrow = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, result, new string[] { "地区代码", "地区名称" });
                    if (selectedrow == null)
                    {
                        ParentPage.SetFocus(certIssuBrBlngRgon);
                        certIssuBrBlngRgon.ShowTip("未选中信息！");
                        //this.ShowTip("未选中信息！");
                        return;
                    }
                    certIssuBrBlngRgon.Text = selectedrow["地区代码"].ToString().Trim();
                    String certIssuVal = selectedrow["地区代码"].ToString().Trim();
                    String certIssuKey = selectedrow["地区名称"].ToString().Trim();
                    certIssuBrBlngRgonCode.SetItems(new Dictionary<string, string> { { certIssuKey, certIssuVal } });
                }
                catch (Exception ex)
                {
                    certIssuBrBlngRgon.ShowTip("身份证前6位，或者县级行政区！");
                    ParentPage.SetFocus(certIssuBrBlngRgon);
                    return;
                }
            }
        }

        /// <summary>
        /// 发证机关
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void FZJG_LostFocus(object sender, RoutedEventArgs e)
        {
            string result = "";
            Dictionary<string, string> areaCode = UserVariable.GetAreaCode(Page) as Dictionary<string, string>;
            //string FZJGTemp = System.Text.RegularExpressions.Regex.Replace(FZJG.Text, "公安局", "");
            string[] FZJGArry = FZJG.Text.Split(new string[] { "公安局" }, StringSplitOptions.RemoveEmptyEntries);
            string FZJGTemp = FZJGArry[0];
            //如果 前台输入在dic中有值，直接显示该条数据
            try
            {
                //判断是否是数字，数字代表输入的地址代码
                bool bo = Regex.IsMatch(FZJG.Text, @"^[+-]?\d*[.]?\d*$");
                if (!bo)
                {
                    foreach (var value in areaCode)
                    {
                        if (value.Key.Contains(FZJGTemp))
                        {
                            result += value.Value + "|" + value.Key + "\n";
                        }

                    }
                }
                else
                {
                    if (!string.IsNullOrEmpty(FZJG.Text))
                    {
                        foreach (var value in areaCode)
                        {
                            if (value.Value.Contains(FZJGTemp))
                            {
                                result += value.Value + "|" + value.Key + "\n";
                            }
                        }
                    }
                }
                if (result == "")
                {
                    ParentPage.SetFocus(FZJG);
                    FZJG.ShowTip("请输入正确的地址代码或者地址名称！");
                    return;
                }
                DataRow selectedrow = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, result, new string[] { "发证机关代码", "发证机关名称" });
                if (selectedrow == null)
                {
                    ParentPage.SetFocus(FZJG);
                    FZJG.ShowTip("未选中信息！");
                    //this.ShowTip("未选中信息！");
                    return;
                }
                FZJG.Text = selectedrow["发证机关名称"].ToString().Trim();
                FZJGDM.Text = selectedrow["发证机关代码"].ToString().Trim();
            }
            catch (Exception ex)
            {
                FZJG.ShowTip("未获取到到地区名称！");
                ParentPage.SetFocus(FZJG);
                return;
            }
            FZJGDM.IsEnabled = false;
        }
        /// <summary>
        /// 按照输入中文的地区名称匹配值
        /// </summary>
        /// <param name="AreaCode"></param>
        /// <param name="str"></param>
        /// <returns></returns>
        private string AreaCodeKey(Dictionary<string, string> AreaCode, string str)
        {
            string result = string.Empty;
            foreach (var value in AreaCode)
            {
                if (value.Value.Contains(str))
                {
                    result += value.Key + "|" + value.Value + "\n";
                }

            }
            return result;
        }

        private void TEL_LostFocus(object sender, RoutedEventArgs e)
        {
            string tel = string.Empty;
            string tota = string.Empty;
            if (string.IsNullOrEmpty(TEL.Text.Trim()) && string.IsNullOrEmpty(MPHONE.Text.Trim()))
            {
                if (ParentPage.TradeAPIs.ShowQuestionMessageBox("是否新增联系人？\n是：新增  否：返回") == MessageBoxResult.Yes)
                {
                    this.tb_relName.Visibility = Visibility.Visible;
                    this.relName.Visibility = Visibility.Visible;
                    this.tb_relKeyTel.Visibility = Visibility.Visible;
                    this.relKeyTel.Visibility = Visibility.Visible;
                    this.tb_ctcCertType.Visibility = Visibility.Visible;
                    this.ctcCertType.Visibility = Visibility.Visible;
                    this.tb_ctcCertNo.Visibility = Visibility.Visible;
                    this.ctcCertNo.Visibility = Visibility.Visible;
                    this.Sdate.Visibility = Visibility.Visible;
                    this.yxrq.Visibility = Visibility.Visible;
                    ParentPage.SetFocus(relName);
                    return;
                }
                else
                {
                    ParentPage.SetFocus(MPHONE);
                    ParentPage.TradeAPIs.ShowTip(MPHONE, "手机号码或固定号码必需填写一项");
                    return;
                }
            }
            if (ParentPage.Len(TEL.Text) < 7 && ParentPage.Len(TEL.Text) > 0)
            {
                ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N008));
                //ParentPage.SetFocus(                //TEL);
                ParentPage.SetFocus(TEL);
                return;
            }
            #region 提示电话号码关联
            if (!string.IsNullOrEmpty(TEL.Text))
            {
                Message msg = new Message();
                ParentPage.InitFd(msg);
                //ParentPage.CommSendECIF(msg);
                msg["qryType"] = "3"; //(1_证件类型+证件号+证件发放国家；2_客户号;3_手机号) 必输
                msg["custRsrvMblNo"] = TEL.Text;//客户预留手机号(查询类型=3时必输)
                //TODO:msg.requestCommParmToESB.serviceCode = "ECIFQ05003";
                //msg.requestCommParmToESB.svcSubCode = "01";
                ParentPage.CallEcif(msg, "ECIFQ0500301");
                //esb 返回 ECIF0000
                if (!old_tel.Equals(TEL.Text.Trim()) && (msg.Fd12 == "ECIFM900013" || msg.Fd12 == "0000"))
                {
                    if (ParentPage.TradeAPIs.ShowQuestionMessageBox("该联系电话已关联客户，是否关联为联系人电话？\n是：关联  否：返回") == MessageBoxResult.Yes)
                    {
                        this.tb_relName.Visibility = Visibility.Visible;
                        this.relName.Visibility = Visibility.Visible;
                        this.tb_relKeyTel.Visibility = Visibility.Visible;
                        this.relKeyTel.Visibility = Visibility.Visible;
                        this.tb_ctcCertType.Visibility = Visibility.Visible;
                        this.ctcCertType.Visibility = Visibility.Visible;
                        this.tb_ctcCertNo.Visibility = Visibility.Visible;
                        this.ctcCertNo.Visibility = Visibility.Visible;
                        this.Sdate.Visibility = Visibility.Visible;
                        this.yxrq.Visibility = Visibility.Visible;
                        relKeyTel.Text = TEL.Text.Trim();
                        TEL.Text = "";
                        ParentPage.SetFocus(relName);
                        return;
                    }
                    else
                    {
                        ParentPage.SetFocus(TEL);
                        return;
                    }
                    //ParentPage.TradeAPIs.ShowInfoMessageBox("该联系电话 管理多个客户");
                }
                else
                {
                    this.tb_relName.Visibility = Visibility.Collapsed;
                    this.relName.Visibility = Visibility.Collapsed;
                    this.tb_relKeyTel.Visibility = Visibility.Collapsed;
                    this.relKeyTel.Visibility = Visibility.Collapsed;
                    this.tb_ctcCertType.Visibility = Visibility.Collapsed;
                    this.ctcCertType.Visibility = Visibility.Collapsed;
                    this.tb_ctcCertNo.Visibility = Visibility.Collapsed;
                    this.ctcCertNo.Visibility = Visibility.Collapsed;
                    this.Sdate.Visibility = Visibility.Collapsed;
                    this.yxrq.Visibility = Visibility.Collapsed;
                    this.relName.Text = "";
                    this.relKeyTel.Text = "";
                    this.ctcCertNo.Text = "";
                }
            }
            #endregion 提示电话号码关联
        }

        private void ADDR_LostFocus(object sender, RoutedEventArgs e)
        {
            string phone = null;
            string tel = null;
            if (!string.IsNullOrEmpty(MPHONE.Text))
            {
                phone = string.Format("\n手机号码：" + MPHONE.Text);
            }
            if (!string.IsNullOrEmpty(TEL.Text))
            {
                tel = string.Format("\n固定电话：" + TEL.Text);
            }
            //信息交互
            if (TellerSystem.Devices.Config.DeviceConfig.TransInfoEnabled)
            {
                string text = "客户名称：" + CIF_NAME.Text +
                            "\n证件地址:" + ADDR.Text +
                            "\n证件号码：" + ID_NO.Text + phone + tel;
                var result = TellerSystem.Devices.DeviceHelper.PrintTransInfo(text);
                if (result.HasError)
                {
                    ADDR.ShowTip("信息交互操作有误，请重新调用");
                    this.Page.SetFocus(ADDR);
                    return;
                }
            }
        }

        private void YZBM_LostFocus(object sender, RoutedEventArgs e)
        {
            //20140813 对私邮编非必输 对公邮编必输
            if (YZBM.Text.Trim() != string.Empty)
            {
                if (ParentPage.Len(YZBM.Text.Trim()) != 6)
                {
                    ParentPage.TradeAPIs.ShowTip("邮编号码无效，请检查");
                    //ParentPage.SetFocus(                //QYYB);
                    ParentPage.SetFocus(YZBM);
                    return;
                }
            }

        }

        private void ID_TYPE_LostFocus(object sender, RoutedEventArgs e)
        {
            //if (ID_TYPE.GetSelectedValue() == "B01")
            //{
            Sdate2.Visibility = yxq.Visibility = Visibility.Visible;
            TradePanel.SetColumnSpan(certIssuDstc, 1);
            //}
            //else
            //{
            //    Sdate2.Visibility = yxq.Visibility = Visibility.Collapsed;
            //    TradePanel.SetColumnSpan(certIssuDstc, 3);
            //}
            isAreadyCreatId = false;
            oldName = string.Empty;
            if (!ParentPage.SetInputOfIdCard(ID_NO, (ID_TYPE.GetSelectedValue() == "B01")))
            {
                ParentPage.SetFocus(ID_TYPE);
                return;
            }
            else
            {
                ParentPage.SetInputOfIdCard(ID_NO, (ID_TYPE.GetSelectedValue() == "B01"));
            }
        }

        //private void ID_NO_GotFocus(object sender, RoutedEventArgs e)
        //{
        //    if (ID_TYPE.GetSelectedValue() == "1")
        //    {
        //        var record = DeviceHelper.ReadIdentityCard();
        //        IdentityCardEntity data = record.Data;
        //        if (!string.IsNullOrEmpty(data.IdNumber))
        //        {
        //            ID_NO.Text = data.IdNumber.Trim();
        //        }
        //        if (!string.IsNullOrEmpty(data.Sex))
        //        {
        //            SEX.SetSelectedKey(data.Sex);
        //            SEX.IsEnabled = false;
        //        }
        //        Beg_date2.Text = data.ValidDateStart.ToShortDateString().Trim() != "0001/1/1" ? data.ValidDateStart.ToShortDateString() : string.Empty;
        //        End_date2.Text = data.ValidDateEnd.ToShortDateString().Trim() != "0001/1/1" ? data.ValidDateEnd.ToShortDateString() : string.Empty;
        //        birth_date.Text = data.BirthDay.ToShortDateString().Trim() != "0001/1/1" ? data.BirthDay.ToShortDateString() : string.Empty;
        //    }
        //}
        private void ID_NO_LostFocus(object sender, RoutedEventArgs e)
        {
            DeviceManager.GetIdentityCardData(ID_NO);
            isAreadyCreatId = false;
            oldName = string.Empty;
            //新增加将证件号码字母自动转为大写
            ID_NO.Text = ID_NO.Text.Trim().ToUpper();

            //初始化控件逻辑
            //FocusManagerExt.SetAssertNotEmpty(Beg_date2, false);
            //FocusManagerExt.SetAssertNotEmpty(End_date2, false);
            HCJG.IsEnabled = false;
            LW_FLG.IsEnabled = false;
            SEX.IsEnabled = true;
            CIF_NAME.IsReadOnly = false;
            //CIF_NAME.Text = string.Empty;  fuhao 20141105 不人为清空cif_name

            ////根据证件类型和号码查询客户是否黑名单/灰名单
            //var black = ParentPage.TradeAPIs.TF_Customer_QueryBlackList(new QueryBlackList.Input { ZJLX =UserVariable.EcifIdTypeChangeToCbs(ID_TYPE.GetSelectedValue(),"2") , ZJHM = ID_NO.Text });
            //if (black.IsFailed)
            //{
            //    ParentPage.SetFocus(ID_NO);
            //    ParentPage.ShowInfoMessageBox("查询黑名单出错" + black.FailureCause);
            //    return;
            //}
            //if (!black.IsFailed && black.isBlackList == true)
            //{
            //    ParentPage.SetFocus(ID_NO);
            //    ParentPage.TradeAPIs.ShowErrorMessageBox("黑名单账户或客户不允许进行交易"); ;
            //    return;
            //}
            //if (!black.IsFailed && black.isGreyList == true)
            //{
            //    ParentPage.TradeAPIs.ShowInfoMessageBox("账户或客户存在灰名单记录，请谨慎交易");

            //}
            //身份证逻辑
            if ("B01" == ID_TYPE.GetSelectedValue())
            {
                if (DeviceManager.GetIdentityCardData(ID_NO) != null)
                {
                    var data = DeviceManager.GetIdentityCardData(ID_NO).Data;
                    //证件号码 
                    if (!string.IsNullOrEmpty(data.IdNumber))
                    {
                        ID_NO.Text = data.IdNumber.Trim();
                    }
                    //出生日期
                    //if (!string.IsNullOrEmpty(data.BirthDay.ToString()) && data.BirthDay > ("00010101").ToDateTime())
                    //{
                    //    birth_date.Text = data.BirthDay.ToString("yyyyMMdd");
                    //    birth_date.IsEnabled = false;
                    //}
                    //else
                    //{
                    //    birth_date.Text = data.IdNumber.Substring(6, 8);
                    //    birth_date.IsEnabled = false;
                    //}
                    //出生日期
                    if (!string.IsNullOrEmpty(data.BirthDay.ToString()) && data.BirthDay > ("00010101").ToDateTime())
                    {
                        birth_date.Text = data.BirthDay.ToString("yyyyMMdd");
                        birth_date.IsEnabled = false;
                    }
                    //性别
                    if (!string.IsNullOrEmpty(data.Sex))
                    {
                        SEX.SetSelectedKey(data.Sex);
                    }
                    //有效开始日期
                    if (data.ValidDateStart.ToString("yyyyMMdd").Trim() != "00010101")
                    {
                        Beg_date2.Text = data.ValidDateStart.ToString("yyyyMMdd");
                        Beg_date2.IsEnabled = false;
                    }
                    //有效截至日期
                    if (data.ValidDateEnd.ToString("yyyyMMdd").Trim() != "00010101")
                    {
                        End_date2.Text = data.ValidDateEnd.ToString("yyyyMMdd").Trim();
                        End_date2.IsEnabled = false;
                    }
                    //姓名
                    if (!string.IsNullOrEmpty(data.Name))
                    {
                        CIF_NAME.Text = data.Name.Trim();
                        CIF_NAME.IsEnabled = false;
                    }
                    //地址
                    if (!string.IsNullOrEmpty(data.Address))
                    {
                        DSDZ.Text = data.Address.Trim();
                    }
                    //发证机关  
                    if (!string.IsNullOrEmpty(data.IssuingAuthority))
                    {
                        FZJG.Text = data.IssuingAuthority;
                        //证件所属地区                       
                        // certIssuBrBlngRgon.Text = System.Text.RegularExpressions.Regex.Replace(data.IssuingAuthority, "公安局", "");    
                        string[] FZJGArry = FZJG.Text.Split(new string[] { "公安局" }, StringSplitOptions.RemoveEmptyEntries);
                        string FZJGTemp = FZJGArry[0];
                        FZJGDM.Text = AreaCode.Where(x => x.Value == FZJGTemp).FirstOrDefault().Value;
                    }
                    //民族  
                    if (!string.IsNullOrEmpty(data.Nationality))
                    {
                        //返回的民族 没有族，所以要对比下
                        string code = UserVariable.GetNationType(Page).Where(x => x.Key.Contains(data.Nationality)).FirstOrDefault().Value;
                        if (code != null)
                        {
                            ntnCode.SetSelectedValue(code);
                            FocusManagerExt.SetAssertNotEmpty(ntnCode, false);
                            ntnCode.IsEnabled = false;
                        }
                    }
                }
                //证件所属地区
                certIssuBrBlngRgon.Text = ID_NO.Text.Substring(0, 6);
                //长度判定,开客户id务必保持18位身份证号
                if (ParentPage.Len(ID_NO.Text.Trim()) != 18)
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N003));
                    ParentPage.SetFocus(ID_NO);
                    return;
                }
                //验证证件有效性
                // 暂时调用sp8015.c对输入身份证进行验证080222
                //新ecif升级处理，转码身份证
                var output = ParentPage.TradeAPIs.TF_Deposit_IDNumberVerification(new IDNumberVerification.Input { ZJLX = "1", ZJHM = ID_NO.Text });
                if (output.IsFailed)
                {
                    ParentPage.TradeAPIs.ShowTip(output.FailureCause);
                    ParentPage.SetFocus(ID_NO);
                    return;
                }
                if (output.YZTGBZ[0] != '1')
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
                    ParentPage.SetFocus(ID_NO);
                    return;
                }
                ID_NO.Text = ParentPage.TradeAPIs.Delspace(output.ZJHM);

                #region 身份核查
                //执行身份核查
                var record = ParentPage.TradeAPIs.IdCheck(ID_NO);
                if (record.IsOnline && record.IsComplated)
                {
                    //核查通过，返显核查信息
                    if (record.Result == "00")
                    {
                        HCJG.SetSelectedValue("00");
                    }
                    else
                    {
                        HCJG.SetSelectedValue(record.Result);
                    }
                    LW_FLG.SetSelectedValue("02");
                    if (!string.IsNullOrEmpty(record.DeviceInfo.Sex))
                    {
                        SEX.SetSelectedKey(record.DeviceInfo.Sex);
                        SEX.IsEnabled = false;
                    }
                    //某些机器上ToShortDateString()返回0001-01-01，导致逻辑失效 -- wangquan
                    if (record.DeviceInfo.ValidDateStart.Year != 1)//.ToShortDateString() != "0001/1/1")
                    {
                        Beg_date2.Text = record.DeviceInfo.ValidDateStart.ToString("yyyyMMdd");//.ToString();
                        Beg_date2.IsEnabled = false;
                    }
                    if (record.DeviceInfo.ValidDateEnd.Year != 1)//.ToShortDateString() != "0001/1/1")
                    {
                        End_date2.Text = record.DeviceInfo.ValidDateEnd.ToString("yyyyMMdd");//.ToShortDateString();
                        End_date2.IsEnabled = false;
                    }
                    if (record.DeviceInfo.BirthDay.Year != 1)//.ToShortDateString() != "0001/1/1")
                    {
                        birth_date.Text = record.DeviceInfo.BirthDay.ToString("yyyyMMdd");//.ToShortDateString();
                        birth_date.IsEnabled = false;
                    }
                    CIF_NAME.Text = record.Name;
                    CIF_NAME.IsReadOnly = true;
                }
                else
                {
                    //未核查或失败
                    if (record.IsOnline && ParentPage.ShowQuestionMessageBox("联网身份核查未通过，是否继续？") == MessageBoxResult.No)
                    {
                        ParentPage.SetFocus(ID_NO);
                        return;
                    }
                    //自行手工选择核查结果，联网标志置为未核查
                    if (FLAG != "V21")
                        HCJG.IsEnabled = true;
                    else
                    {
                        if ("B01" == ID_TYPE.GetSelectedValue())
                        {
                            birth_date.IsEnabled = false;
                            birth_date.Text = ID_NO.Text.Substring(6, 8);
                        }
                    }
                    LW_FLG.SetSelectedValue("01");
                }
                //HCJG.IsEnabled = true;
                //逻辑控制
                //FocusManagerExt.SetAssertNotEmpty(Beg_date2, true);
                //FocusManagerExt.SetAssertNotEmpty(End_date2, true); 
                #endregion

            }

            if (!IsUpdate && !this.ComponentHelper.isOutComing)
            {
                var output1 = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input
                {
                    //qryType = "1",
                    ZJHM = ID_NO.Text,
                    ZJLX = UserVariable.EcifIdTypeChangeToCbs(ID_TYPE.GetSelectedValue(), "2")
                });
                if (output1.IsFailed)
                {
                    ParentPage.TradeAPIs.ShowTip(output1.FailureCause);
                    ParentPage.SetFocus(ID_NO);
                    return;
                }
                var data = output1.WJ;
                if (output1.WJData.Count == 0)
                {
                    data = "客户未建立客户信息";
                }

                var selectedData = TellerSystem.Controls.Ext.ControlsHelper.ShowPages.ShowDataBoxViewer(ParentPage, data, new string[] { "客户编号", "客户名称", "证件号码", "客户状态" }, 500, 200);

                if (selectedData == null)
                {
                    ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N042));
                    ParentPage.SetFocus(ID_NO);
                    return;
                }

                if (selectedData["客户编号"].ToString() != "客户未建立客户信息")
                {
                    if (selectedData["客户状态"].ToString().Equals("关闭"))
                    {
                        ParentPage.TradeAPIs.ShowTip("该证件已建立客户信息,客户状态为关闭，请进行客户状态维护");
                        ParentPage.SetFocus(ID_NO);
                        return;
                    }
                    isAreadyCreatId = true;
                    oldName = selectedData["客户名称"].ToString();
                    ParentPage.ShowMessageBox("客户已建立客户信息，请查询");
                    ParentPage.SetFocus(ID_NO);
                    return;
                }
            }
            //1002交易 如果输入证件号码和原证件号码不一致 调核心做校验 如果新输入的证件号已存在则报错 不存在 则继续
            if (!string.IsNullOrEmpty(old_id_no) && !old_id_no.Trim().Equals(ID_NO.Text.Trim()))
            {

                //根据证件类型和号码查询客户是否已登记
                var output = ParentPage.TradeAPIs.TF_Customer_QueryCustomer(new QueryCustomer.Input
                {
                    //qryType = "1",
                    ZJLX = ID_TYPE.GetSelectedValue(),
                    ZJHM = ID_NO.Text
                });
                if (output.IsFailed)
                {
                    ParentPage.TradeAPIs.ShowTip(output.FailureCause);
                    ParentPage.SetFocus(ID_NO);
                    return;
                }
                var row = ParentPage.TradeAPIs.ShowDataBoxViewer(output.WJ, new string[] { });
                if (row != null)
                {
                    if (row[4].ToString().Equals("关闭"))
                    {
                        ParentPage.TradeAPIs.ShowTip("该证件已建立客户信息,客户状态为关闭，请进行客户状态维护");
                        ParentPage.SetFocus(ID_NO);
                        return;
                    }
                    ParentPage.TradeAPIs.ShowTip("该证件号码已存在！");
                    ParentPage.SetFocus(ID_NO);
                    return;
                }
            }
        }
        string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        private string DXYZMBH;
        private string DXYZM;
        /// <summary>
        /// 
        /// </summary>
        public PersonalCustomerInfoArgs Controls
        {
            get
            {
                return this.personalCustomerInfoArgs;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public class PersonalCustomerInfoArgs
        {
            /// <summary>
            /// 客户等级
            /// </summary>
            public ComboBox KHDJ { get; internal set; }
            /// <summary>
            /// 贡 献 度
            /// </summary>
            public ComboBox GXD { get; internal set; }
            /// <summary>
            /// 证件类型
            /// </summary>
            public ComboBox ZJLX { get; internal set; }
            /// <summary>
            /// 核查结果
            /// </summary>
            public ComboBox HCJG { get; internal set; }
            /// <summary>
            /// 联网标志
            /// </summary>
            public ComboBox LWBZ { get; internal set; }
            /// <summary>
            /// 佐证证件
            /// </summary>
            public ComboBox ZZZZ { get; internal set; }
            /// <summary>
            /// 行    业
            /// </summary>
            public ComboBox HY { get; internal set; }
            /// <summary>
            /// 性    别
            /// </summary>
            public ComboBox XB { get; internal set; }
            /// <summary>
            /// 国    籍
            /// </summary>
            public ComboBox GJ { get; internal set; }
            /// <summary>
            /// 英文姓名
            /// </summary>
            public TextBox YWXM { get; internal set; }
            /// <summary>
            /// 证件号码
            /// </summary>
            public TextBox ZJHM { get; internal set; }
            /// <summary>
            /// 有效日期-开始
            /// </summary>
            public TextBox YXRQKS { get; internal set; }

            /// <summary>
            /// 有效日期-结束
            /// </summary>
            public TextBox YXRQJS { get; internal set; }
            /// <summary>
            /// 发证机关
            /// </summary>
            public TextBox FZJG { get; internal set; }
            /// <summary>
            /// 户    名
            /// </summary>
            public TextBox HM { get; internal set; }
            /// <summary>
            /// 曾 用 名
            /// </summary>
            public TextBox CYM { get; internal set; }
            /// <summary>
            /// 联系电话
            /// </summary>
            public TextBox LXDH { get; internal set; }
            /// <summary>
            /// 手机号
            /// </summary>
            public TextBox SJH { get; internal set; }
            /// <summary>
            /// 联系地址
            /// </summary>
            public TextBox LXDZ { get; internal set; }
            /// <summary>
            /// 单位地址
            /// </summary>
            public TextBox DWDZ { get; internal set; }
            /// <summary>
            /// 证件地址
            /// </summary>
            public TextBox ZJDZ { get; internal set; }
            /// <summary>
            /// 邮政编码
            /// </summary>
            public TextBox YZBM { get; internal set; }
            /// <summary>
            /// 传    真
            /// </summary>
            public TextBox CZ { get; internal set; }
            /// <summary>
            /// 电子邮件
            /// </summary>
            public TextBox DZYJ { get; internal set; }
            /// <summary>
            /// 一级职业分类
            /// </summary>
            public ComboBox ZYFLOne { get; internal set; }
            /// <summary>
            /// 二级职业分类
            /// </summary>
            public ComboBox ZYFLTwo { get; internal set; }
            /// <summary>
            /// 三级职业分类
            /// </summary>
            public ComboBox ZYFLThree { get; internal set; }
        }

        private void CIF_LVL_GotFocus(object sender, RoutedEventArgs e)
        {
            RaiseGotFocus();
        }

        private void EMAIL_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!string.IsNullOrEmpty(EMAIL.Text))
            {
                Regex r = new Regex("^\\s*([A-Za-z0-9_-]+(\\.\\w+)*@(\\w+\\.)+\\w{2,5})\\s*$");
                if (!r.IsMatch(EMAIL.Text))
                {
                    ParentPage.TradeAPIs.SetFocus(EMAIL);
                    ParentPage.TradeAPIs.ShowTip("请输入正确格式的邮箱！");

                    return;
                }
            }
            RaiseLostFocus();
        }

        private void MPHONE_LostFocus(object sender, RoutedEventArgs e)
        {
            if (MPHONE.Text.Trim().Length < 11 && MPHONE.Text.Trim().Length >= 1)
            {
                ParentPage.TradeAPIs.ShowTip("手机号码要求不少于11位，请重新输入！");
                ParentPage.TradeAPIs.SetFocus();
                return;
            }
            #region 提示手机号关联
            if (MPHONE.Text != "")
            {
                Message msg = new Message();
                ParentPage.InitFd(msg);
                //ParentPage.CommSendECIF(msg);
                msg["qryType"] = "3"; //(1_证件类型+证件号+证件发放国家；2_客户号;3_手机号) 必输
                msg["custRsrvMblNo"] = MPHONE.Text;//客户预留手机号(查询类型=3时必输)
                //msg.requestCommParmToESB.serviceCode = "ECIFQ05003";
                //msg.requestCommParmToESB.svcSubCode = "01";

                ParentPage.CallEcif(msg, "ECIFQ0500301");
                //esb 返回 ECIF0000
                if (!old_phone.Equals(MPHONE.Text.Trim()) && (msg.Fd12 == "ECIFM900013" || msg.Fd12 == "0000"))
                {
                    if (ParentPage.TradeAPIs.ShowQuestionMessageBox("该联系电话已关联客户，是否关联为联系人电话？\n是：关联  否：返回") == MessageBoxResult.Yes)
                    {
                        this.tb_relName.Visibility = Visibility.Visible;
                        this.relName.Visibility = Visibility.Visible;
                        this.tb_relKeyTel.Visibility = Visibility.Visible;
                        this.relKeyTel.Visibility = Visibility.Visible;
                        this.tb_ctcCertType.Visibility = Visibility.Visible;
                        this.ctcCertType.Visibility = Visibility.Visible;
                        this.tb_ctcCertNo.Visibility = Visibility.Visible;
                        this.ctcCertNo.Visibility = Visibility.Visible;
                        this.Sdate.Visibility = Visibility.Visible;
                        this.yxrq.Visibility = Visibility.Visible;
                        relKeyTel.Text = MPHONE.Text.Trim();
                        //MPHONE.Text = "";
                        ParentPage.SetFocus(btnCheck);
                        return;
                    }
                    else
                    {
                        this.tb_relName.Visibility = Visibility.Collapsed;
                        this.relName.Visibility = Visibility.Collapsed;
                        this.tb_relKeyTel.Visibility = Visibility.Collapsed;
                        this.relKeyTel.Visibility = Visibility.Collapsed;
                        this.tb_ctcCertType.Visibility = Visibility.Collapsed;
                        this.ctcCertType.Visibility = Visibility.Collapsed;
                        this.tb_ctcCertNo.Visibility = Visibility.Collapsed;
                        this.ctcCertNo.Visibility = Visibility.Collapsed;
                        this.Sdate.Visibility = Visibility.Collapsed;
                        this.yxrq.Visibility = Visibility.Collapsed;
                        this.relName.Text = "";
                        this.relKeyTel.Text = "";
                        this.ctcCertNo.Text = "";
                        ParentPage.SetFocus(btnCheck);
                        return;
                    }
                    //ParentPage.TradeAPIs.ShowInfoMessageBox("该联系电话 管理多个客户");
                }
                else
                {
                    this.tb_relName.Visibility = Visibility.Collapsed;
                    this.relName.Visibility = Visibility.Collapsed;
                    this.tb_relKeyTel.Visibility = Visibility.Collapsed;
                    this.relKeyTel.Visibility = Visibility.Collapsed;
                    this.tb_ctcCertType.Visibility = Visibility.Collapsed;
                    this.ctcCertType.Visibility = Visibility.Collapsed;
                    this.tb_ctcCertNo.Visibility = Visibility.Collapsed;
                    this.ctcCertNo.Visibility = Visibility.Collapsed;
                    this.Sdate.Visibility = Visibility.Collapsed;
                    this.yxrq.Visibility = Visibility.Collapsed;
                    this.relName.Text = "";
                    this.relKeyTel.Text = "";
                    this.ctcCertNo.Text = "";
                }
            }
            #endregion 提示手机号关联
        }
        private void btnCheck_Click(object sender, RoutedEventArgs e)
        {
            if (!string.IsNullOrEmpty(MPHONE.Text))
            {
                Message msg = new Message(Message.BitMap.Agn);
                ParentPage.InitFd(msg);
                ParentPage.CommSend(msg);
                msg.Fd16 = "2085";
                msg.Fd38 = MPHONE.Text.Trim();
                ParentPage.CallAgn(msg);
                if (msg.Fd12 != "0000")
                {
                    ParentPage.TradeAPIs.ShowInfoMessageBox(ParentPage.GetError(msg));
                    ParentPage.SetFocus();
                    return;
                }
                DXYZMBH = msg.Fd61.Trim();
                DXYZM = msg.Fd60.Trim();
                if (DeviceConfig.InDeviceDebugMode)
                {
                    ParentPage.TradeAPIs.ShowInfoMessageBox("短信验证码已发送到手机，请查收！\n【测试使用】短信验证码为：" + msg.Fd60.Trim());
                }
                else
                {
                    ParentPage.TradeAPIs.ShowInfoMessageBox("短信验证码已发送到手机，请查收！");
                }
            }
            ParentPage.SetFocus(tbCheckCode);
        }
        private void tbCheckCode_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!string.IsNullOrEmpty(MPHONE.Text))
            {
                if (tbCheckCode.Text != DXYZM)
                {
                    ParentPage.TradeAPIs.ShowInfoMessageBox("验证码错误，请重新输入！");
                    ParentPage.SetFocus();
                }
            }
        }
        /// <summary>
        /// 联系人电话
        /// </summary>
        private void relKeyTel_LostFocus(object sender, RoutedEventArgs e)
        {
            if ((relKeyTel.Text.Trim().Length > 11) || (ParentPage.Len(relKeyTel.Text) < 7 && ParentPage.Len(relKeyTel.Text) > 0))
            {
                ParentPage.TradeAPIs.ShowTip("联系人电话输入有误，请重新输入！");
                ParentPage.TradeAPIs.SetFocus();
                return;
            }
        }
        /// <summary>
        /// 联系人证件类型
        /// </summary>
        private void ctcCertType_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!ParentPage.SetInputOfIdCard(ctcCertNo, (ctcCertType.GetSelectedValue() == "B01")))
            {
                ParentPage.SetFocus(ctcCertType);
                return;
            }
            else
            {
                ParentPage.SetInputOfIdCard(ctcCertNo, (ctcCertType.GetSelectedValue() == "B01"));
            }
        }
        /// <summary>
        /// 联系人证件号码
        /// </summary>
        private void ctcCertNo_LostFocus(object sender, RoutedEventArgs e)
        {
            //根据证件类型和号码查询客户是否黑名单/灰名单
            //var black = this.Page.TradeAPIs.TF_Customer_QueryBlackList(new QueryBlackList.Input { ZJLX = UserVariable.EcifIdTypeChangeToCbs(ctcCertType.GetSelectedValue(), "2"), ZJHM = ctcCertNo.Text });
            //if (black.IsFailed)
            //{
            //    this.Page.SetFocus(ctcCertNo);
            //    this.Page.ShowInfoMessageBox("查询黑名单出错" + black.FailureCause);
            //    return;
            //}
            //if (!black.IsFailed && black.isBlackList == true)
            //{
            //    this.Page.SetFocus(ctcCertNo);
            //    this.Page.TradeAPIs.ShowErrorMessageBox("黑名单账户或客户不允许进行交易");
            //    return;
            //}
            //if (!black.IsFailed && black.isGreyList == true)
            //{
            //    this.Page.TradeAPIs.ShowInfoMessageBox("账户或客户存在灰名单记录，请谨慎交易");

            //}

            if (!string.IsNullOrEmpty(ctcCertNo.Text))
            { //身份证逻辑
                if (ctcCertType.GetSelectedValue().Equals("B01"))
                {
                    DeviceManager.GetIdentityCardData(ctcCertNo);
                    //新增加将证件号码字母自动转为大写
                    ctcCertNo.Text = ctcCertNo.Text.Trim().ToUpper();
                    //长度判定,开客户id务必保持18位身份证号
                    if (ParentPage.Len(ctcCertNo.Text.Trim()) != 18)
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N003));
                        ParentPage.SetFocus(ctcCertNo);
                        return;
                    }
                    //验证证件有效性
                    // 暂时调用sp8015.c对输入身份证进行验证080222
                    var output = ParentPage.TradeAPIs.TF_Deposit_IDNumberVerification(new IDNumberVerification.Input { ZJLX = "1", ZJHM = ctcCertNo.Text });
                    if (output.IsFailed)
                    {
                        ParentPage.TradeAPIs.ShowTip(output.FailureCause);
                        ParentPage.SetFocus(ctcCertNo);
                        return;
                    }
                    if (output.YZTGBZ[0] != '1')
                    {
                        ParentPage.TradeAPIs.ShowTip(ParentPage.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
                        ParentPage.SetFocus(ctcCertNo);
                        return;
                    }
                    ctcCertNo.Text = ParentPage.TradeAPIs.Delspace(output.ZJHM);
                }
            }          
        }

        private void JobTypeOne_LostFocus(object sender, RoutedEventArgs e)
        {
            if (UserVariable.GetJobTypeTwo_per(Page, JobTypeOne.GetSelectedValue()) != null && UserVariable.GetJobTypeTwo_per(Page, JobTypeOne.GetSelectedValue()).Count() >= 1)
            {
                JobTypeTwo.Visibility = Visibility.Visible;
                JobTypeThree.Visibility = Visibility.Visible;
                //如果二级职业分类不为空再获取
                if (string.IsNullOrWhiteSpace(JobTypeTwo.GetSelectedValue()) || !JobTypeTwo.GetSelectedValue().Substring(0, 1).Equals(JobTypeOne.GetSelectedValue().Substring(0, 1)))
                {
                    JobTypeTwo.SetItems(UserVariable.GetJobTypeTwo_per(Page, JobTypeOne.GetSelectedValue()));
                    JobTypeTwo.SelectedIndex = 0;
                }
            }
            else
            {
                JobTypeTwo.Visibility = Visibility.Hidden;
                JobTypeThree.Visibility = Visibility.Hidden;
            }
        }

        private void JobTypeTwo_LostFocus(object sender, RoutedEventArgs e)
        {
            if (UserVariable.GetJobTypeThree_per(Page, JobTypeTwo.GetSelectedValue()) != null && UserVariable.GetJobTypeThree_per(Page, JobTypeTwo.GetSelectedValue()).Count() >= 1)
            {
                JobTypeThree.Visibility = Visibility.Visible;
                //如果三级职业分类不为空再获取
                if (string.IsNullOrWhiteSpace(JobTypeThree.GetSelectedValue()) || !JobTypeThree.GetSelectedValue().Substring(0, 3).Equals(JobTypeTwo.GetSelectedValue().Substring(0, 3)))
                {
                    JobTypeThree.SetItems(UserVariable.GetJobTypeThree_per(Page, JobTypeTwo.GetSelectedValue()));
                    JobTypeThree.SelectedIndex = 0;
                }
            }
            else
            {
                JobTypeThree.Visibility = Visibility.Hidden;
            }
        }

        private void ID_NO_TextChanged(object sender, TextChangedEventArgs e)
        {

        }

        private void birth_date_LostFocus(object sender, RoutedEventArgs e)
        {
            //add by 时间判断 xujizhe begin
            int data = int.Parse(birth_date.Text.Trim().ToString());
            string date = LoginUserInfo.TradeDate.ToDateTime().ToString("yyyyMMdd").ToString();
            if (data > int.Parse(date))
            {
                this.Page.SetFocus(birth_date);
                this.Page.ShowTip("输入日期大于当前日期");
                return;
            }
            //add by 时间判断 xujizhe end
        }

    }

    #region 数据限定
    /// <summary>
    /// 组件数据交互类
    /// </summary>
    public class TBC_PCustomerInfoInput_NewEcif : TBC_ComponentInput
    {
        #region 构造

        #endregion

        #region 控制属性

        /// <summary>
        /// 外部调整交易标志
        /// </summary>
        public bool isOutComing { get; set; }

        #endregion

        #region 交互方法

        #endregion
    }

    /// <summary>
    /// 组件数据输出类
    /// </summary>
    public class TBC_PCustomerInfoOutput_NewEcif : TBC_ComponentOutput
    {
    }

    #endregion
}
