﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TellerSystem.Contract.Function;
using Platform.Controls.ControlsHelper;
using TellerSystem.Library.Ext.Variables;
using TellerSystem.Controls.Ext.TradePageBase;
using TellerSystem.Controls.Ext.ControlsHelper;
using TellerSystem.Library.Ext.Function;
using Platform.Library;

namespace TellerSystem.Controls.Ext.TradePageComponent
{
    /// <summary>
    /// 产品信息组件
    /// </summary>
    public partial class TBC_ProductInfo : TBC_ComponentBase
    {
        private ProductInfoArgs productInfoArgs = null;

        /// <summary>
        /// 构造此组件对象实例
        /// </summary>
        public TBC_ProductInfo()
        {
            InitializeComponent();

            this.productInfoArgs = new ProductInfoArgs();
            this.productInfoArgs.BZ = this.Opn_cur_no;
            this.productInfoArgs.CPDM = this.Dw_prdt_no;
            this.productInfoArgs.CPLX = this.Dw_prdt_term;
            this.productInfoArgs.CQLX = this.Dw_prdt_type;
            this.productInfoArgs.JXLX = this.Opn_intst_type;
            this.productInfoArgs.KHJE = this.Opn_amt;
            this.productInfoArgs.ZDZC = this.Opn_ct_ind;
            this.productInfoArgs.ZHLX = this.Ac_type;
            this.productInfoArgs.ZXBZ = this.Opn_ct_ind;

            //设置币种
            Opn_cur_no.SetItems(UserVariable.GetCurNo()); //修改 by zhangtilei
            Opn_cur_no.SetSelectedValue("01");
        }

        /// <summary>
        /// 给组件赋值
        /// </summary>
        /// <param name="certificateType">证件类型</param>
        /// <param name="certificateNo">证件号</param>
        /// <param name="accountName">开户名</param>
        /// <param name="voucherType">凭证种类</param>
        public void SetValue(string certificateType, string certificateNo, string accountName, string voucherType)
        {

        }

        private void Dw_prdt_type_GotFocus(object sender, RoutedEventArgs e)
        {
            this.OnComponentIsGotFocused();
        }

        private void Opn_amt_LostFocus(object sender, RoutedEventArgs e)
        {
            this.OnComponentIsLostFocused();
        }

        /// <summary>
        /// 本组件内控件集合
        /// </summary>
        public ProductInfoArgs Controls
        {
            get
            {
                return this.productInfoArgs;
            }
        }

        /// <summary>
        /// 组件的状态
        /// </summary>
        public ProductInfoState ComponentState
        {
            set
            {
                switch (value)
                {
                    case ProductInfoState.Default:
                        Opn_intst_type.SelectedIndex = 0; //计息类型:按季计息
                        Opn_intst_type.IsEnabled = true;
                        Dw_prdt_type.IsEnabled = true;
                        Dw_prdt_term.IsEnabled = true;
                        AUTOSVCD.IsEnabled = true;
                        break;
                    case ProductInfoState.State1:
                        Opn_intst_type.SetSelectedValue("4"); //计息类型:按季计息
                        Opn_intst_type.IsEnabled = false;
                        Dw_prdt_type.IsEnabled = false;
                        Dw_prdt_term.IsEnabled = false;
                        AUTOSVCD.IsEnabled = false;
                        break;
                    case ProductInfoState.state2:
                        Opn_intst_type.SetSelectedValue("1"); //计息类型:利随本清
                        Opn_intst_type.IsEnabled = false;
                        Dw_prdt_type.IsEnabled = true;
                        Dw_prdt_term.IsEnabled = true;
                        Dw_prdt_no.IsEnabled = true;
                        AUTOSVCD.IsEnabled = true;
                        break;
                }
            }
        }

        /// <summary>
        /// 本组件可选的状态枚举
        /// </summary>
        public enum ProductInfoState
        {
            /// <summary>
            /// 
            /// </summary>
            Default = 0,
            /// <summary>
            /// 
            /// </summary>
            State1 = 1,
            /// <summary>
            /// 
            /// </summary>
            state2 = 2,
        }

        /// <summary>
        /// 产品组件参数
        /// </summary>
        public class ProductInfoArgs
        {
            /// <summary>
            /// 存期类型
            /// </summary>
            public ComboBox CQLX { get; internal set; }
            /// <summary>
            /// 产品代码
            /// </summary>
            public ComboBox CPDM { get; internal set; }
            /// <summary>
            /// 账户类型
            /// </summary>
            public ComboBox ZHLX { get; internal set; }
            /// <summary>
            /// 现转标志
            /// </summary>
            public ComboBox ZXBZ { get; internal set; }
            /// <summary>
            /// 自动转存
            /// </summary>
            public ComboBox ZDZC { get; internal set; }
            /// <summary>
            /// 产品存期
            /// </summary>
            public ComboBox CPLX { get; internal set; }
            /// <summary>
            /// 币    种
            /// </summary>
            public ComboBox BZ { get; internal set; }
            /// <summary>
            /// 计息类型
            /// </summary>
            public ComboBox JXLX { get; internal set; }
            /// <summary>
            /// 开户金额
            /// </summary>
            public TextBox KHJE { get; internal set; }
        }
    }
}
