﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TellerSystem.Contract.ContractBase;
using TellerSystem.Library.Ext.Variables;
using TellerSystem.Communication;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using Platform.Controls.ControlsHelper;
using Platform.Library;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Library.Ext.TradeExtension;
using TellerSystem.Controls.Ext.ControlsHelper;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Function;
using TellerSystem.Controls.Ext.TradePageBase;
using System.Text.RegularExpressions;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;

namespace TellerSystem.Controls.Ext.TradePageComponent
{
    /// <summary>
    /// 代理人业务组件
    /// </summary>
    public partial class TBC_ProxyInfo : TBC_ComponentBase<TBC_ProxyInfoInput, TBC_ProxyInfoOutput>
    {
        public decimal amt = 0M;
        public bool IsDl = false;
        public string IsZhuan = string.Empty;
        public decimal DrjiAmt = 0M;
        public string MainCode = "";
        /// <summary>
        /// 代理人身份证必输设置   默认为不输
        /// </summary>
        public bool SDBSSZ = false;
        /// <summary>
        /// 本人输入限额标准 默认50000
        /// </summary>
        public decimal BRJEXZ = 50000M;
        /// <summary>
        /// 代理人输入限额标准 默认50000
        /// </summary>
        public decimal DLJEXZ = 50000M;
        /// <summary>
        /// 业务类型
        /// </summary>
        public string YW_TYPE = string.Empty;
        public PageBase ParentPage { get; private set; }

        private string FLAG = TellerSystem.ServiceProxy.Ext.ServiceHelper.TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        /// <summary>
        /// 青隆 根据金额来判断是否代理人需联网核查 默认true 核查
        /// </summary>
        public bool LWHC = true;
        /// <summary>
        /// 联网核查结果
        /// </summary>
        public string LWHCJG = string.Empty;
        
        public string IsSelf
        {
            get;
            set;
        }

        public TBC_ProxyInfo()
        {
            InitializeComponent();
        }
        /// <summary>
        /// 初始化界面
        /// </summary>
        protected override void InitComponent()
        {
            base.InitComponent();
            Sel_flag.SetItems(UserVariable.GetYorN());
            Sel_flag.SetSelectedValue("N");
            ComponentOutput.ProxyInfo = new ProxyPersonInfo()
            {
                DLRMC = string.Empty,
                DLRZJLX = "1",
                SFDLR = "N",
                DLRZJHM = string.Empty,
                DLRMobPhone = string.Empty
            };
            ParentPage = (Platform.Common.BasicFunctions.DependencyObjectExtensions.FindVisualTreeAncestor(this, (x) => { return x is PageBase; })) as PageBase;
            if (ParentPage == null)
                return;
        }

        /// <summary>
        /// 初始化界面
        /// </summary>
        public void InitProxyInfo()
        {
            //private string FLAG =TellerSystem.ServiceProxy.Ext.ServiceHelper.TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            //FLAG = TellerSystem.ServiceProxy.Ext.ServiceHelper.TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            Sel_flag.SetItems(UserVariable.GetYorN());
            Sel_flag.SetSelectedValue("N");
            DL_Id_name.Text = DL_Id_no.Text = DLR_MobPhone.Text = string.Empty;
            ZJLXBOX.Visibility =
            ZJHMBOX.Visibility =
            DL_Id_name.Visibility =
            DL_Id_type.Visibility =
            DL_Id_no.Visibility =
            DLR_MobPhone.Visibility = Visibility.Hidden;
            //tp_host.Height = 60;
            this.Page.TradeAPIs.CallComboBoxData(DL_Id_type, "C004");
            DL_Id_type.SelectedIndex = 0;
            this.Page.TradeAPIs.CallComboBoxData(ZJLXBOX, "C004");
            ZJLXBOX.SelectedIndex = 0;
            ComponentOutput.ProxyInfo = new ProxyPersonInfo()
            {
                SFDLRControl = Sel_flag,
                DLRMC = string.Empty,
                DLRZJLX = "1",
                SFDLR = "N",
                DLRZJHM = string.Empty,
                DLRMobPhone = string.Empty
            };
        }

        /// <summary>
        /// 是否代理事件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Sel_flag_LostFocus(object sender, RoutedEventArgs e)
        {
            //初始化
            Page.TradeAPIs.IsProxyStatus(false);
            //if (Sel_flag.GetSelectedValue() == "Y")
            //{
            //    tp_host.Height = 90;
            //}
            //else
            //{
            //    tp_host.Height = 60;
            //}
            ComponentOutput.ProxyInfo.SFDLR = Sel_flag.GetSelectedValue();

            DL_Id_name.Text = DL_Id_no.Text = DLR_MobPhone.Text = string.Empty;
            DLRMC.Visibility =
            DLRZJHM.Visibility =
            DLRZJLX.Visibility =
            DL_Id_name.Visibility =
            DL_Id_type.Visibility =
            DL_Id_no.Visibility =
            DLRMobPhone.Visibility =
            DLR_MobPhone.Visibility =
            ZJHMB.Visibility =
            ZJLXB.Visibility =
            ZJHMBOX.Visibility =
            ZJLXBOX.Visibility = Visibility.Collapsed;

            #region 必输设置 add by slzh
            //存款，本人默认非必输，如果超过限额在要求输入 add by slzh
            if (this.YW_TYPE == GlobalVariable.YW_TYPE_CX)
            {
                Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(ZJLXBOX, false);
                Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(ZJHMBOX, false);
            }
            //代理人默认非必输，如果超过限额在要求输入 add by slzh

            Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(DL_Id_name, false);
            Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(DL_Id_no, false);
            Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(DL_Id_type, false);
            Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(this.DLR_MobPhone, false);

            //山东对本人存款的身份证的限额进行了修改  新增了 BRJEXZ 本人存款限额字段  默认50000
            if (Sel_flag.GetSelectedValue() == "N" && (amt >= BRJEXZ || DrjiAmt >= BRJEXZ))
            {
                //非代理
                if (this.YW_TYPE != GlobalVariable.YW_TYPE_CX)
                {
                    Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(ZJLXBOX, true);
                    Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(ZJHMBOX, true);
                }
            }
            else if (Sel_flag.GetSelectedValue() == "Y" && (amt >= 50000 || DrjiAmt >= 50000))
            {
                //代理
                Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(DL_Id_name, true);
                Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(DL_Id_no, true);
                Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(DL_Id_type, true);
                Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(this.DLR_MobPhone, true);
            }
            //山东存贷10000输,取款20000必输
            if (SDBSSZ)
            {
                Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(DL_Id_name, true);
                Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(DL_Id_no, true);
                Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(DL_Id_type, true);
                Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(this.DLR_MobPhone, true);
            }
            if (FLAG == "V23" && Sel_flag.GetSelectedValue() == "Y")
            {
                //代理
                Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(DL_Id_name, true);
                Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(DL_Id_no, true);
                Platform.Presentation.FocusManagers.FocusManagerExt.SetAssertNotEmpty(DL_Id_type, true);
            }

            #endregion 必输设置 add by slzh

            if (Sel_flag.GetSelectedValue() == "N" && !IsDl && (amt >= BRJEXZ || DrjiAmt >= BRJEXZ))
            {
                //非代理
                DL_Id_name.Text = DL_Id_no.Text = string.Empty;
                DL_Id_name.Visibility =
                DL_Id_type.Visibility =
                DLRMC.Visibility =
                DLRZJHM.Visibility =
                DLRZJLX.Visibility =
                DL_Id_no.Visibility =
                DLRMobPhone.Visibility =
                DLR_MobPhone.Visibility = Visibility.Collapsed;
                ZJHMB.Visibility =
                ZJLXB.Visibility =
                ZJHMBOX.Visibility =
                ZJLXBOX.Visibility = Visibility.Visible;
                ZJLXBOX.SetSelectedValue("1");

            }
            else if (Sel_flag.GetSelectedValue() == "Y" && IsZhuan != "转账" && (amt >= 50000 || DrjiAmt >= 50000))
            {
                //代理
                DLRMC.Visibility =
                DLRZJHM.Visibility =
                DLRZJLX.Visibility =
                DL_Id_name.Visibility =
                DL_Id_type.Visibility =
                DL_Id_no.Visibility =
                DLRMobPhone.Visibility =
                DLR_MobPhone.Visibility = Visibility.Visible;
                if (FLAG == "V0")
                {
                    DLRMobPhone.Visibility = Visibility.Collapsed;
                    DLR_MobPhone.Visibility = Visibility.Collapsed;
                }
                if (IsSelf.ToUpper() == "Y" && string.IsNullOrEmpty(MainCode))
                {
                    ZJHMB.Visibility = ZJLXB.Visibility = ZJHMBOX.Visibility = ZJLXBOX.Visibility = Visibility.Visible;
                }
                else
                {
                    ZJHMB.Visibility = ZJLXB.Visibility = ZJHMBOX.Visibility = ZJLXBOX.Visibility = Visibility.Collapsed;
                }
                DL_Id_type.SetSelectedValue("1");
                IsZhuan = string.Empty;
            }
            else if (Sel_flag.GetSelectedValue() == "Y" && IsZhuan == "转账" && (amt >= 50000 || DrjiAmt >= 50000))
            {
                if (IsSelf.ToUpper() == "Y")
                {
                    ZJHMB.Visibility = ZJLXB.Visibility = ZJHMBOX.Visibility = ZJLXBOX.Visibility = Visibility.Visible;
                }
                else
                {
                    ZJHMB.Visibility = ZJLXB.Visibility = ZJHMBOX.Visibility = ZJLXBOX.Visibility = Visibility.Collapsed;
                }
                DLRMC.Visibility =
                    DLRZJHM.Visibility =
                    DLRZJLX.Visibility =
                    DL_Id_name.Visibility =
                    DL_Id_type.Visibility =
                    DL_Id_no.Visibility =
                    DLRMobPhone.Visibility =
                    DLR_MobPhone.Visibility = Visibility.Visible;
                if (FLAG == "V0")
                {
                    DLRMobPhone.Visibility = Visibility.Collapsed;
                    DLR_MobPhone.Visibility = Visibility.Collapsed;
                }
                DL_Id_type.SetSelectedValue("1");
                IsZhuan = string.Empty;
            }
            else if (Sel_flag.GetSelectedValue() == "Y")
            {

                DLRMC.Visibility =

                    DLRZJHM.Visibility =
                    DLRZJLX.Visibility =
                    DL_Id_name.Visibility =
                    DL_Id_type.Visibility =
                    DL_Id_no.Visibility =
                    DLRMobPhone.Visibility =
                    DLR_MobPhone.Visibility = Visibility.Visible;
                if (FLAG == "V0")
                {
                    DLRMobPhone.Visibility = Visibility.Collapsed;
                    DLR_MobPhone.Visibility = Visibility.Collapsed;
                }
                DL_Id_type.SetSelectedValue("1");
            }
            if (ComponentHelper.PreProxySFDLControl != null)
            {
                if (!ComponentHelper.PreProxySFDLControl(Sel_flag.GetSelectedValue()))
                {
                    //验证不通过
                    this.Page.SetFocus();
                    return;
                }
            }
            this.Page.TradeAPIs.CallComboBoxData(DL_Id_type, "C004");
            DL_Id_type.SelectedIndex = 0;
            this.Page.TradeAPIs.CallComboBoxData(ZJLXBOX, "C004");
            ZJLXBOX.SelectedIndex = 0;

        }

        /// <summary>
        /// 校验身份证及身份核查
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void DL_Id_no_LostFocus(object sender, RoutedEventArgs e)
        {

            var IdData = DeviceManager.GetIdentityCardData(DL_Id_no);
            if (IdData != null)
            {
                DL_Id_name.Text = IdData.Data.Name;
                //DL_Id_no.Text = IdData.Data.IdNumber;
                if (FLAG == "V11" || FLAG == "V23")
                {
                    if (IdData.Data.ValidDateStart.ToString("yyyyMMdd").Trim() != "00010101")
                    {
                        Beg_date2.Text = IdData.Data.ValidDateStart.ToString("yyyyMMdd");
                    }
                    if (IdData.Data.ValidDateEnd.ToString("yyyyMMdd").Trim() != "00010101")
                    {
                        End_date2.Text = IdData.Data.ValidDateEnd.ToString("yyyyMMdd").Trim();
                    }
                }
            }
            ComponentOutput.ProxyInfo.DLRZJHM = DL_Id_no.Text.Trim();

            if (ComponentHelper.PreProxyIdnoControl != null)
            {
                if (!ComponentHelper.PreProxyIdnoControl(DL_Id_no.Text.Trim()))
                {
                    //验证不通过
                    this.Page.SetFocus();
                    return;
                }
            }

            //是身份证,需要核查
            if (DL_Id_type.GetSelectedValue() == "1" && !string.IsNullOrEmpty(DL_Id_no.Text))
            {
                if (this.Page.Len(DL_Id_no.Text.Trim()) != 15 && this.Page.Len(DL_Id_no.Text.Trim()) != 18)
                {
                    this.Page.TradeAPIs.ShowTip(this.Page.TradeAPIs.GetNotifyMessage(NotifyMessage.N003));
                    this.Page.TradeAPIs.SetFocus(DL_Id_no);
                    return;
                }


                //新增加将证件号码字母自动转为大写
                string id_no = DL_Id_no.Text.Trim().ToUpper();
                DL_Id_no.Text = id_no;

                //调用短交易进行身份证校验
                var outEntity = this.Page.TradeAPIs.TF_Deposit_IDNumberVerification(new IDNumberVerification.Input
                {
                    ZJLX = "1",
                    ZJHM = DL_Id_no.Text
                });
                if (outEntity.IsFailed)
                {
                    this.Page.TradeAPIs.ShowTip(outEntity.FailureCause);
                    this.Page.TradeAPIs.SetFocus();
                    return;
                }
                if (outEntity.YZTGBZ[0] != '1')
                {
                    this.Page.TradeAPIs.ShowTip(this.Page.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
                    this.Page.SetFocus();
                    return;
                }

                DL_Id_no.Text = this.Page.TradeAPIs.Delspace(outEntity.ZJHM);
                DL_Id_name.IsEnabled = true;
                //身份证核查                
                var info = DeviceManager.GetIdentityCardData(DL_Id_no).Data;
                //var result = this.Page.IdCheck(info);
                string flag = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
                if (flag == "V8" || flag == "V19" || (flag == "V5" && LWHC))//保留阳光配置、青隆此处不需要嵌入式联网核查
                {
                    var result = this.Page.TradeAPIs.IdCheck(DL_Id_no, DL_Id_name.Text);
                    if (result.IsOnline && result.IsComplated)
                    {
                        // modify by hulei 20181219  如果当交易不在核查列表中的话，使用代理人控件的话代理人不会弹窗核查然而还是会返回核查通过，可能没有姓名，可能会导致空引用
                        if (!string.IsNullOrEmpty(result.Name))
                        {
                            DL_Id_name.Text = result.Name.ToString();
                            DL_Id_name.IsEnabled = false;
                        }
                        if (LoginUserInfo.KinbrNo.Substring(0, 3) == "302")
                        {
                            LWHCJG = result.ResultKey;
                        }
                    }
                    else if (result.IsOnline && this.Page.TradeAPIs.ShowQuestionMessageBox("联网身份核查未通过，是否继续？") == MessageBoxResult.No)
                    {
                        this.Page.TradeAPIs.SetFocus(DL_Id_no);
                        return;
                    }
                    if (flag == "V5" && result.IsOnline && result.Reject2RLSB)
                    {
                        this.Page.TradeAPIs.SetFocus(DL_Id_no);
                        return;
                    }
                }
                //设置代理人标识
                Page.TradeAPIs.IsProxyStatus(true);
            }
            if (TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("Is_CheckDQSBlackList") == "true" && !string.IsNullOrEmpty(DL_Id_no.Text))//校验黑名单
            {
                //调用8854接口校验灰名单
                var blacklist = Page.TradeAPIs.TF_Deposit_CheckBlackList(new CheckBlackList.Input()
                {
                    CXLX = "2",
                    ZJLX = DL_Id_type.GetSelectedValue(),
                    ZJHM = DL_Id_no.Text,
                    SFHNKHBCBZ = "6255"
                });
                if (blacklist.IsFailed)
                {
                    Page.TradeAPIs.ShowWarnMessageBox(blacklist.FailureCause);
                    Page.SetFocus();
                    return;
                }
                //不涉及到账务转出的：全渠道
                if (blacklist.allrestrict > 0)
                {
                    Page.TradeAPIs.ShowWarnMessageBox(blacklist.info);
                    Page.SetFocus();
                    return;
                }
            }
        }

        /// <summary>
        /// 代理组件参数
        /// </summary>
        public class ProxyPersonInfo
        {
            /// <summary>
            /// 是否代理人控件
            /// </summary>
            public ComboBox SFDLRControl { get; internal set; }
            /// <summary>
            /// 是否代理人
            /// </summary>
            public string SFDLR { get; internal set; }
            /// <summary>
            /// 代理人名称
            /// </summary>
            public string DLRMC { get; internal set; }
            /// <summary>
            /// 代理人证件类型
            /// </summary>
            public string DLRZJLX { get; internal set; }
            /// <summary>
            /// 代理人证件号码
            /// </summary>
            public string DLRZJHM { get; internal set; }
            /// <summary>
            /// 代理人手机号码
            /// </summary>
            public string DLRMobPhone { get; internal set; }
        }
        private void DLR_MobPhone_LostFocus(object sender, RoutedEventArgs e)
        {
            FLAG = TellerSystem.ServiceProxy.Ext.ServiceHelper.TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            //代理人身份证号走联网核查，核查结果返回姓名，姓名置灰不可改，不走方法DL_Id_name_LostFocus，未给DLRMC赋值使打印缺失代理人姓名。             
            ComponentOutput.ProxyInfo.DLRMC = DL_Id_name.Text.Trim();
            ComponentOutput.ProxyInfo.DLRMobPhone = DLR_MobPhone.Text.Trim();
            if (string.IsNullOrEmpty(DL_Id_no.Text) && string.IsNullOrEmpty(DL_Id_name.Text) && string.IsNullOrEmpty(DLR_MobPhone.Text))
            {
                this.Page.TradeAPIs.ShowQuestionMessageBox("代理人信息录入全部为空，请注意检查！");
            }
            if (FLAG == "V0")
            {
                if (DLR_MobPhone.Text.Trim().Length < 11 && DLR_MobPhone.Text.Trim().Length >= 1)
                {
                    ParentPage.TradeAPIs.ShowTip("手机号码要求不少于11位，请重新输入！");
                    ParentPage.TradeAPIs.SetFocus();
                    return;
                }
            }

            if (FLAG == "V23" && !string.IsNullOrEmpty(DLR_MobPhone.Text.Trim()))
            {
                //RegexRuleExtension.SetInputType(DLR_MobPhone, InputRules.MobilePhone);//此方法第一次离开事件未能校验
                Regex r = new Regex("^1[0-9]{10}$");
                if (!r.IsMatch(DLR_MobPhone.Text.Trim()))
                {
                    ParentPage.TradeAPIs.ShowTip("联系方式输入错误，请检查！");
                    ParentPage.SetFocus();
                    return;
                }
            }
        }
        private void DL_Id_name_LostFocus(object sender, RoutedEventArgs e)
        {
            ComponentOutput.ProxyInfo.DLRMC = DL_Id_name.Text.Trim();

            if (ComponentHelper.PreProxyIdnoNameControl != null)
            {
                if (!ComponentHelper.PreProxyIdnoNameControl(DL_Id_name.Text.Trim()))
                {
                    //验证不通过
                    this.Page.SetFocus();
                    return;
                }
            }

        }

        private void DL_Id_type_LostFocus(object sender, RoutedEventArgs e)
        {
            FLAG = TellerSystem.ServiceProxy.Ext.ServiceHelper.TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            ComponentOutput.ProxyInfo.DLRZJLX = DL_Id_type.GetSelectedValue();

            if (ComponentHelper.PreProxyIdnoTypeControl != null)
            {
                if (!ComponentHelper.PreProxyIdnoTypeControl(DL_Id_type.GetSelectedValue()))
                {
                    //验证不通过
                    this.Page.SetFocus();
                    return;
                }
            }
            if (DL_Id_type.GetSelectedValue() == "1")
            {
                //天山 要求 1000、2000交易 身份证只刷卡
                string codes = "1000|2000";
                if (FLAG == "V19" && codes.Contains(ParentPage.TradeModel.Code))
                {
                    DeviceManager.SetIdentityCardReader(DL_Id_no, IdentityCardReaderType.ReadCard);
                }
                else
                {
                    DeviceManager.SetIdentityCardReader(DL_Id_no, IdentityCardReaderType.ReadCardOrInput);
                }
            }
            else
                DeviceManager.SetIdentityCardReader(DL_Id_no, IdentityCardReaderType.Input);

        }

        /// <summary>
        /// 设置是否代理值
        /// </summary>
        /// <param name="sfdl">是否代理</param>
        /// <param name="isEnabled">是否可编辑</param>
        public void SetSFDLValue(bool sfdl, bool isEnabled)
        {
            DL_Id_name.Text = DL_Id_no.Text = DLR_MobPhone.Text = string.Empty;
            if (sfdl)
            {
                Sel_flag.SetSelectedValue("Y");
                //DL_Id_name.Visibility =
                //DL_Id_type.Visibility =
                //DL_Id_no.Visibility =
                //DLR_MobPhone.Visibility = Visibility.Visible;
                if (FLAG == "V0")
                {
                    DLRMobPhone.Visibility = Visibility.Collapsed;
                    DLR_MobPhone.Visibility = Visibility.Collapsed;
                }
                DL_Id_type.SetSelectedValue("1");
                //tp_host.Height = 90;
            }
            else
            {
                Sel_flag.SetSelectedValue("N");
                DL_Id_name.Text = DL_Id_no.Text = string.Empty;
                DL_Id_name.Visibility =
                DL_Id_type.Visibility =
                DL_Id_no.Visibility =
                DLR_MobPhone.Visibility =
                DLRZJLX.Visibility =
                DLRZJHM.Visibility =
                DLRMC.Visibility =
                DLRMobPhone.Visibility =
                Sdate2.Visibility = yxq.Visibility = Visibility.Hidden;
                //tp_host.Height = 60;
            }
            /* 将判断条件上移 
            if (Sel_flag.GetSelectedValue() == "N")
            {
                DL_Id_name.Text = DL_Id_no.Text = string.Empty;
                DL_Id_name.Visibility =
                DL_Id_type.Visibility =
                DL_Id_no.Visibility = Visibility.Hidden;
                tp_host.Height = 60;
            }
            else
            {
                DL_Id_name.Visibility =
                DL_Id_type.Visibility =
                DL_Id_no.Visibility = Visibility.Visible;
                DL_Id_type.SetSelectedValue("1");
                tp_host.Height = 90;
            }*/
            Sel_flag.IsEnabled = isEnabled;
        }

        private void ZJHMBOX_LostFocus(object sender, RoutedEventArgs e)
        {
            if (ComponentHelper.IdnoControl != null)
            {
                if (!ComponentHelper.IdnoControl(ZJHMBOX.Text.Trim()))
                {
                    //验证不通过
                    this.Page.SetFocus();
                    return;
                }
            }
            if (!string.IsNullOrEmpty(DL_Id_no.Text) && ZJHMBOX.Text == DL_Id_no.Text)
            {
                this.Page.TradeAPIs.ShowTip("号码与代理人号码一致，请检查");
                this.Page.TradeAPIs.SetFocus(ZJHMBOX);
                return;
            }
            //是身份证,需要核查
            if (ZJLXBOX.GetSelectedValue() == "1")
            {
                if (this.Page.Len(ZJHMBOX.Text) != 15 && this.Page.Len(ZJHMBOX.Text) != 18)
                {
                    this.Page.TradeAPIs.ShowTip(this.Page.TradeAPIs.GetNotifyMessage(NotifyMessage.N003));
                    this.Page.TradeAPIs.SetFocus(ZJHMBOX);
                    return;
                }

                //新增加将证件号码字母自动转为大写
                string id_no = ZJHMBOX.Text.Trim().ToUpper();
                ZJHMBOX.Text = id_no;

                //调用短交易进行身份证校验
                var outEntity = this.Page.TradeAPIs.TF_Deposit_IDNumberVerification(new IDNumberVerification.Input
                {
                    ZJLX = "1",
                    ZJHM = ZJHMBOX.Text
                });
                if (outEntity.IsFailed)
                {
                    this.Page.TradeAPIs.ShowTip(outEntity.FailureCause);
                    this.Page.TradeAPIs.SetFocus();
                    return;
                }
                if (outEntity.YZTGBZ[0] != '1')
                {
                    this.Page.TradeAPIs.ShowTip(this.Page.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
                    this.Page.SetFocus();
                    return;
                }

                ZJHMBOX.Text = this.Page.TradeAPIs.Delspace(outEntity.ZJHM);
                //身份证核查                
                //var info = DeviceManager.GetIdentityCardData(DL_Id_no).Data;
                //var result = this.Page.IdCheck(info);
                var result = this.Page.TradeAPIs.IdCheck(ZJHMBOX);
                if (result.IsOnline && result.IsComplated)
                {
                    if (FLAG=="V5" && LoginUserInfo.KinbrNo.Substring(0, 3) == "302")
                    {
                        LWHCJG = result.ResultKey;
                    }
                }
                else if (result.IsOnline && this.Page.TradeAPIs.ShowQuestionMessageBox("联网身份核查未通过，是否继续？") == MessageBoxResult.No)
                {
                    this.Page.TradeAPIs.SetFocus(ZJHMBOX);
                    return;
                }

            }
        }
        /// <summary>
        /// 本人证件类型失去焦点之后事件  2016 陈小建
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ZJLXBOX_OnLostFocus(object sender, RoutedEventArgs e)
        {
            if (ComponentHelper.PreProxyJBRTypeControl != null)
            {
                if (!ComponentHelper.PreProxyJBRTypeControl(ZJLXBOX.GetSelectedValue()))
                {
                    //验证不通过
                    this.Page.SetFocus();
                    return;
                }
            }
            //if (ZJLXBOX.GetSelectedKey().Contains("身份证"))
            //    DeviceManager.SetIdentityCardReader(ZJHMBOX, IdentityCardReaderType.ReadCardOrInput);
            //else
            //    DeviceManager.SetIdentityCardReader(ZJHMBOX, IdentityCardReaderType.Input);
        }
        /// <summary>
        /// 代理人有效期开始失去焦点
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Beg_date2_LostFocus(object sender, RoutedEventArgs e)
        {
            if (this.Page.Atoi(LoginUserInfo.TradeDate) < this.Page.Atoi(Beg_date2.Text))
            {
                this.Page.TradeAPIs.ShowTip(this.Page.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                this.Page.SetFocus(Beg_date2);
                return;
            }
        }
        /// <summary>
        /// 代理人证件失效日期 使用长期的 给核心传递时需要注意 长期转换
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void End_date2_LostFocus(object sender, RoutedEventArgs e)
        {
            if (End_date2.Text.Trim() != "")
            {
                string reg = @"(^长期$)|(^99999999$)|(^(?:(?:(?:(?:(?:1[6-9]|[2-9]\d)(?:0[48]|[2468][048]|[13579][26])|(?:(?:16|[2468][048]|[3579][26])00)))(?:0229))|(?:(?:(?:1[6-9]|[2-9]\d)\d{2})(?:(?:(?:0[13578]|1[02])31)|(?:(?:0[13-9]|1[0-2])(?:29|30))|(?:(?:0[1-9])|(?:1[0-2]))(?:0[1-9]|1\d|2[0-8]))))$)";
                if (Regex.IsMatch(End_date2.Text, reg))
                {
                    if (End_date2.Text.Contains("长") || End_date2.Text.Contains("期"))
                    {
                        if (End_date2.Text != "长期")
                        {
                            this.Page.TradeAPIs.ShowTip("输入格式不符合规范！");
                            this.Page.SetFocus(End_date2);
                            return;
                        }
                    }
                }
                else
                {
                    this.Page.TradeAPIs.ShowTip("输入格式不符合规范！");
                    this.Page.SetFocus(End_date2);
                    return;
                }
            }
            if (End_date2.Text.Trim() == "99999999")
            {
                End_date2.Text = "99991231";
                return;
            }
            if (End_date2.Text.Trim() != "" && Beg_date2.Text.Trim() != "" && End_date2.Text != "长期")
            {
                if (this.Page.Atoi(LoginUserInfo.TradeDate) > this.Page.Atoi(End_date2.Text))
                {
                    this.Page.TradeAPIs.ShowTip(this.Page.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                    this.Page.SetFocus(End_date2);
                    return;
                }
                if (this.Page.Atoi(End_date2.Text) < this.Page.Atoi(Beg_date2.Text))
                {
                    this.Page.TradeAPIs.ShowTip(this.Page.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                    this.Page.SetFocus(End_date2);
                    return;
                }
            }

        }
        /// <summary>
        /// 设置代理人证件有效期
        /// </summary>
        /// <param name="sfdlDate"></param>
        /// <param name="ENabled"></param>
        public void SetSFDLDate(bool sfdlDate, bool ENabled)
        {
            Beg_date2.Text = End_date2.Text = string.Empty;
            if (sfdlDate)
            {

                Sdate2.Visibility =
                yxq.Visibility = Visibility.Visible;
            }
            else
            {
                Sdate2.Visibility =
                yxq.Visibility = Visibility.Hidden;
            }
        }
    }


    #region 数据限定
    /// <summary>
    /// 组件数据交互类
    /// </summary>
    public class TBC_ProxyInfoInput : TBC_ComponentInput
    {
        #region 构造
        #endregion

        #region 控制属性

        /// <summary>
        /// 是否代理特别控制
        /// </summary>
        public Predicate<string> PreProxySFDLControl { get; set; }

        /// <summary>
        /// 代理证件号码特别控制
        /// </summary>
        public Predicate<string> PreProxyIdnoControl { get; set; }

        /// <summary>
        /// 代理证件类型特别控制
        /// </summary>
        public Predicate<string> PreProxyIdnoTypeControl { get; set; }

        /// <summary>
        /// 代理证件名称特别控制
        /// </summary>
        public Predicate<string> PreProxyIdnoNameControl { get; set; }
        /// <summary>
        /// 代理人手机号
        /// </summary>
        public Predicate<string> PreProxyMobPhoneControl { get; set; }
        /// <summary>
        /// 本人证件号码特别控制
        /// </summary>
        public Predicate<string> IdnoControl { get; set; }

        /// <summary>
        /// 经办人证件类型特别控制 20160106 陈小建
        /// </summary>
        public Predicate<string> PreProxyJBRTypeControl { get; set; }

        /// <summary>
        /// 山东求默认代理人证件号吗必输
        /// </summary>
        public Predicate<string> PredicateIdnoInput { get; set; }

        #endregion

        #region 交互方法

        #endregion
    }

    /// <summary>
    /// 组件数据输出类
    /// </summary>
    public class TBC_ProxyInfoOutput : TBC_ComponentOutput
    {
        /// <summary>
        /// 输出账户信息
        /// </summary>
        public TBC_ProxyInfo.ProxyPersonInfo ProxyInfo { get; internal set; }

    }
    #endregion
}
