﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TellerSystem.Contract.ContractBase;
using TellerSystem.Library.Ext.Variables;
using TellerSystem.Communication;
using TellerSystem.Contract.Contracts;
using TellerSystem.Contract.Entry;
using Platform.Controls.ControlsHelper;
using Platform.Library;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Library.Ext.TradeExtension;
using TellerSystem.Controls.Ext.ControlsHelper;
using Platform.Common.RunningParameters;
using TellerSystem.Contract.Function;
using TellerSystem.Controls.Ext.TradePageBase;
using System.ComponentModel;
using System.Windows.Controls.Primitives;
using System.Collections;
using System.Text.RegularExpressions;

namespace TellerSystem.Controls.Ext.TradePageComponent
{
    /// <summary>
    /// 代理人业务组件(带联系人电话、联系地址)
    /// </summary>
    public partial class TBC_ProxyInfoLink : TBC_ComponentBase<TBC_ProxyInfoLinkInput, TBC_ProxyInfoLinkOutput>
    {

        public decimal amt = 0M;
        public bool IsDl = false;
        public string IsZhuan = string.Empty;
        public decimal DrjiAmt = 0M;
        public string JYM = string.Empty;
        public string ZHHM = string.Empty;
        public string IsSelf
        {
            get;
            set;
        }

        public TBC_ProxyInfoLink()
        {
            InitializeComponent();
        }

        /// <summary>
        /// 初始化界面
        /// </summary>
        protected override void InitComponent()
        {
            base.InitComponent();
            if (!DesignerProperties.GetIsInDesignMode(this))
            {
                Sel_flag.SetItems(UserVariable.GetYorN());
                Sel_flag.SetSelectedValue("N");
                ComponentOutput.ProxyInfoLink = new ProxyPersonInfoLink()
                {
                    DLRMC = string.Empty,               //DLRMC
                    DLRZJLX = "B01",
                    SFDLR = "N",
                    DLRZJHM = string.Empty,             //代理人证件号码
                    BRZJHM = string.Empty,              //本人证件号码
                    LXDH = string.Empty,                //联系电话
                    LXDZ = string.Empty                //联系地址
                };
                //this.CallComboBoxData(DL_Id_type, "C004");
                DL_Id_type.SetItems(UserVariable.GetPersonIdType(Page));
                DL_Id_type.SelectedIndex = 0;
                //this.CallComboBoxData(ZJLXBOX, "C004");                
                agCountry.SetItems(UserVariable.GetCountryType(Page));
                agCountry.SetSelectedValue("CHN");
                DLRMC.Visibility =
                DLRZJHM.Visibility =
                DLRZJLX.Visibility =
                DL_Id_name.Visibility =
                DL_Id_type.Visibility =
                DL_Id_no.Visibility =
                Sdate.Visibility =
                yxq.Visibility =
                LXDHB.Visibility =
                LXDHBOX.Visibility =
                LXDZB.Visibility =
                LXDZBOX.Visibility =
                agCountry.Visibility = DLCountry.Visibility = Visibility.Collapsed;
                //DL_Id_name.Visibility =
                //DL_Id_type.Visibility =
                //DL_Id_no.Visibility = Visibility.Collapsed;
            }
        }

        /// <summary>
        /// 初始化界面
        /// </summary>
        public void InitProxyInfoLink()
        {

            Sel_flag.SetItems(UserVariable.GetYorN());
            Sel_flag.SetSelectedValue("N");
            DLRMC.Visibility =
            DLRZJHM.Visibility =
            DLRZJLX.Visibility =
            DL_Id_name.Visibility =
            DL_Id_type.Visibility =
            DL_Id_no.Visibility =
            Sdate.Visibility =
            yxq.Visibility =
            LXDHB.Visibility =
            LXDHBOX.Visibility =
            LXDZB.Visibility =
            LXDZBOX.Visibility =
            agCountry.Visibility = DLCountry.Visibility = Visibility.Collapsed;

            DL_Id_name.Text = DL_Id_no.Text = LXDHBOX.Text = LXDZBOX.Text = string.Empty;
            // this.Page.TradeAPIs.CallComboBoxData(DL_Id_type, "C004");
            DL_Id_type.SetItems(UserVariable.GetPersonIdType(Page));
            DL_Id_type.SelectedIndex = 0;
            // this.Page.TradeAPIs.CallComboBoxData(ZJLXBOX, "C004");         
            ComponentOutput.ProxyInfoLink = new ProxyPersonInfoLink()
            {
                SFDLRControl = Sel_flag,
                DLRMC = string.Empty,
                DLRZJLX = "1",
                SFDLR = "N",
                DLRZJHM = string.Empty,             //代理人证件号码
                BRZJHM = string.Empty,              //本人证件号码
                LXDH = string.Empty,                //联系电话
                LXDZ = string.Empty                 //联系地址
            };
        }

        /// <summary>
        /// 是否代理事件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Sel_flag_LostFocus(object sender, RoutedEventArgs e)
        {
            ComponentOutput.ProxyInfoLink = new ProxyPersonInfoLink()
            {
                SFDLRControl = Sel_flag,
                DLRMC = string.Empty,
                DLRZJLX = string.Empty,
                SFDLR = Sel_flag.GetSelectedValue(),
                DLRZJHM = string.Empty,             //代理人证件号码
                BRZJHM = string.Empty,              //本人证件号码
                LXDH = string.Empty,                //联系电话
                LXDZ = string.Empty,                //联系地址
                AIDCC = string.Empty,
                IDCCR = string.Empty,
                IA = string.Empty,
                DLBeg_date = string.Empty,
                DLEnd_date = string.Empty
            };

            DL_Id_name.Text = DL_Id_no.Text = LXDHBOX.Text = LXDZBOX.Text = string.Empty;

            //本人
            if (Sel_flag.GetSelectedValue() == "N")
            {
                DLRMC.Visibility =
                DLRZJHM.Visibility =
                DLRZJLX.Visibility =
                DL_Id_name.Visibility =
                DL_Id_type.Visibility =
                DL_Id_no.Visibility =
                Sdate.Visibility =
                yxq.Visibility =
                LXDHB.Visibility =
                LXDHBOX.Visibility =
                LXDZB.Visibility =
                LXDZBOX.Visibility =
                agCountry.Visibility = DLCountry.Visibility = Visibility.Collapsed;
            }
            //代理
            else
            {
                DLRMC.Visibility =
                DLRZJHM.Visibility =
                DLRZJLX.Visibility =
                DL_Id_name.Visibility =
                DL_Id_type.Visibility =
                DL_Id_no.Visibility =
                Sdate.Visibility =
                yxq.Visibility =
                LXDHB.Visibility =
                LXDHBOX.Visibility =
                LXDZB.Visibility =
                LXDZBOX.Visibility =
                agCountry.Visibility = DLCountry.Visibility = Visibility.Visible;

            }

        }

        /// <summary>
        /// 校验身份证及身份核查
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void DL_Id_no_LostFocus(object sender, RoutedEventArgs e)
        {
            ComponentOutput.ProxyInfoLink.DLRZJHM = DL_Id_no.Text.Trim();
            if (string.IsNullOrEmpty(DL_Id_no.Text))
            {
                this.Page.TradeAPIs.ShowInfoMessageBox("证件号码不能为空");
                this.Page.SetFocus();
                return;
            }
            var IdData = DeviceManager.GetIdentityCardData(DL_Id_no);
            if (IdData != null)
            {
                if (!string.IsNullOrWhiteSpace(IdData.Data.Name))
                {
                    DL_Id_name.Text = IdData.Data.Name;

                }
                //有效开始日期
                if (IdData.Data.ValidDateStart.ToString("yyyyMMdd").Trim() != "00010101")
                {
                    Beg_date.Text = IdData.Data.ValidDateStart.ToString("yyyyMMdd");
                    Sdate.Visibility = yxq.Visibility = Visibility.Visible;
                }
                //有效截至日期
                if (IdData.Data.ValidDateEnd.ToString("yyyyMMdd").Trim() != "00010101")
                {
                    End_date.Text = IdData.Data.ValidDateEnd.ToString("yyyyMMdd").Trim();
                }
                //地址
                if (!string.IsNullOrEmpty(IdData.Data.Address))
                {
                    LXDZBOX.Text = IdData.Data.Address.Trim();
                    LXDZBOX.Visibility = LXDZB.Visibility = Visibility.Visible;
                }
                //发证机关  
                if (!string.IsNullOrEmpty(IdData.Data.IssuingAuthority))
                {
                    IssuingAuthority.Text = IdData.Data.IssuingAuthority;
                    _IssuingAuthority.Visibility = IssuingAuthority.Visibility = Visibility.Visible;
                }
            }

            if (ComponentHelper.PreProxyIdnoControl != null)
            {
                if (!ComponentHelper.PreProxyIdnoControl(DL_Id_no.Text.Trim()))
                {
                    //验证不通过
                    this.Page.SetFocus();
                    return;
                }
            }

            //是身份证,需要核查
            if ((DL_Id_type.GetSelectedValue() == "B01" && !string.IsNullOrEmpty(DL_Id_no.Text)))
            {
                if (this.Page.Len(DL_Id_no.Text.Trim()) != 15 && this.Page.Len(DL_Id_no.Text.Trim()) != 18)
                {
                    this.Page.TradeAPIs.ShowTip(this.Page.TradeAPIs.GetNotifyMessage(NotifyMessage.N003));
                    this.Page.TradeAPIs.SetFocus(DL_Id_no);
                    return;
                }


                //新增加将证件号码字母自动转为大写
                string id_no = DL_Id_no.Text.Trim().ToUpper();
                DL_Id_no.Text = id_no;

                //调用短交易进行身份证校验
                var outEntity = this.Page.TradeAPIs.TF_Deposit_IDNumberVerification(new IDNumberVerification.Input
                {
                    ZJLX = "1",
                    ZJHM = DL_Id_no.Text
                });
                if (outEntity.IsFailed)
                {
                    this.Page.TradeAPIs.ShowTip(outEntity.FailureCause);
                    this.Page.TradeAPIs.SetFocus();
                    return;
                }
                if (outEntity.YZTGBZ[0] != '1')
                {
                    this.Page.TradeAPIs.ShowTip(this.Page.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
                    this.Page.SetFocus();
                    return;
                }

                DL_Id_no.Text = this.Page.TradeAPIs.Delspace(outEntity.ZJHM);
                DL_Id_name.IsEnabled = true;
                //身份证核查                
                // var info = DeviceManager.GetIdentityCardData(DL_Id_no).Data;
                //var result = this.Page.IdCheck(info);
                var result = this.Page.TradeAPIs.IdCheck(DL_Id_no, DL_Id_name.Text);
                if (result.IsOnline && result.IsComplated)
                {
                    // modify by hulei 20181219  如果当交易不在核查列表中的话，使用代理人控件的话代理人不会弹窗核查然而还是会返回核查通过，可能没有姓名，可能会导致空引用
                    if (!string.IsNullOrEmpty(result.Name))
                    {
                        DL_Id_name.Text = result.Name.ToString();
                        DL_Id_name.IsEnabled = false;
                        ComponentOutput.ProxyInfoLink.DLRMC = DL_Id_name.Text.Trim();
                    }
                }
                else if (result.IsOnline && this.Page.TradeAPIs.ShowQuestionMessageBox("联网身份核查未通过，是否继续？") == MessageBoxResult.No)
                {
                    this.Page.TradeAPIs.SetFocus(DL_Id_no);
                    return;
                }

            }
            //当前柜员给作为代理人办理业务
            if (TellerSystem.Library.Ext.TradeExtension.SystemSettingsHelper.Instance.IsTellerCustomer)
            {
                var idCarNO = TellerSystem.Library.Ext.TradeExtension.LoginAuthentication.Instance.IdCarNO;
                if (!string.IsNullOrEmpty(idCarNO) && DL_Id_no.Text.Trim() == idCarNO.Trim())
                {
                    this.Page.TradeAPIs.ShowTip("当前柜员不能为作为代理人办理业务！");
                    this.Page.SetFocus();
                    return;
                }
            }

        }
        /// <summary>
        /// 开始日期
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Beg_date_LostFocus(object sender, RoutedEventArgs e)
        {
            if (this.Page.Atoi(LoginUserInfo.TradeDate) < this.Page.Atoi(Beg_date.Text))
            {
                this.Page.TradeAPIs.ShowTip(this.Page.TradeAPIs.GetNotifyMessage(NotifyMessage.N040));
                this.Page.SetFocus(Beg_date);
                return;
            }
        }
        /// <summary>
        /// 截止日期
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void End_date_LostFocus(object sender, RoutedEventArgs e)
        {
            string reg = @"(^长期$)|(^99999999$)|(^(?:(?:(?:(?:(?:1[6-9]|[2-9]\d)(?:0[48]|[2468][048]|[13579][26])|(?:(?:16|[2468][048]|[3579][26])00)))(?:0229))|(?:(?:(?:1[6-9]|[2-9]\d)\d{2})(?:(?:(?:0[13578]|1[02])31)|(?:(?:0[13-9]|1[0-2])(?:29|30))|(?:(?:0[1-9])|(?:1[0-2]))(?:0[1-9]|1\d|2[0-8]))))$)";
            if (Regex.IsMatch(End_date.Text, reg))
            {
                if (End_date.Text.Contains("长") || End_date.Text.Contains("期"))
                {
                    if (End_date.Text != "长期")
                    {
                        this.Page.TradeAPIs.ShowTip("输入格式不符合规范！");
                        this.Page.SetFocus(End_date);
                        return;
                    }
                }
            }
            else
            {
                this.Page.TradeAPIs.ShowTip("输入格式不符合规范！");
                this.Page.SetFocus(End_date);
                return;
            }
            if (End_date.Text.Trim() == "99999999")
            {
                End_date.Text = "99991231";
                return;
            }
            if (End_date.Text.Trim() != "" && Beg_date.Text.Trim() != "" && End_date.Text != "长期")
            {
                if (this.Page.Atoi(LoginUserInfo.TradeDate) > this.Page.Atoi(End_date.Text))
                {
                    this.Page.TradeAPIs.ShowTip(this.Page.TradeAPIs.GetNotifyMessage(NotifyMessage.N018));
                    this.Page.SetFocus(End_date);
                    return;
                }
                if (this.Page.Atoi(End_date.Text) < this.Page.Atoi(Beg_date.Text))
                {
                    this.Page.TradeAPIs.ShowTip(this.Page.TradeAPIs.GetNotifyMessage(NotifyMessage.N041));
                    this.Page.SetFocus(End_date);
                    return;
                }
            }
            ComponentOutput.ProxyInfoLink.DLBeg_date = Beg_date.Text;
            ComponentOutput.ProxyInfoLink.DLEnd_date = End_date.Text;

        }
        /// <summary>
        /// 代理组件参数
        /// </summary>
        public class ProxyPersonInfoLink
        {
            /// <summary>
            /// 是否代理人控件
            /// </summary>
            public ComboBox SFDLRControl { get; internal set; }
            /// <summary>
            /// 是否代理人
            /// </summary>
            public string SFDLR { get; internal set; }
            /// <summary>
            /// 代理人名称
            /// </summary>
            public string DLRMC { get; internal set; }
            /// <summary>
            /// 代理人证件类型
            /// </summary>
            public string DLRZJLX { get; internal set; }
            /// <summary>
            /// 代理人证件类型中文描述
            /// </summary>
            public string DLRZJLXZh { get; internal set; }
            /// <summary>
            /// 代理人证件号码
            /// </summary>
            public string DLRZJHM { get; internal set; }
            /// <summary>
            /// 本人证件类型
            /// </summary>
            public string BRZJLX { get; internal set; }
            /// <summary>
            /// 本人证件号码
            /// </summary>
            public string BRZJHM { get; internal set; }
            /// <summary>
            /// 联系电话
            /// </summary>
            public string LXDH { get; internal set; }
            /// <summary>
            /// 联系地址
            /// </summary>
            public string LXDZ { get; internal set; }
            /// <summary>
            /// 是否进行身份证联网核查
            /// </summary>
            public string AIDCC { get; internal set; }
            /// <summary>
            /// 核查结果
            /// </summary>
            public string IDCCR { get; internal set; }
            /// <summary>
            /// 发证机关
            /// </summary>
            public string IA { get; internal set; }
            /// <summary>
            /// 代理人有效期
            /// </summary>
            public string DLBeg_date { get; internal set; }
            /// <summary>
            /// 代理人有效截止日期
            /// </summary>
            public string DLEnd_date { get; internal set; }
        }

        private void DL_Id_name_LostFocus(object sender, RoutedEventArgs e)
        {
            if (string.IsNullOrEmpty(DL_Id_name.Text))
            {
                this.Page.TradeAPIs.ShowInfoMessageBox("代理人名称不能为空");
                this.Page.SetFocus();
                return;
            }
            ComponentOutput.ProxyInfoLink.DLRMC = DL_Id_name.Text.Trim();

            //if (ComponentHelper.PreProxyIdnoNameControl != null)
            //{
            //    if (!ComponentHelper.PreProxyIdnoNameControl(DL_Id_name.Text.Trim()))
            //    {
            //        //验证不通过
            //        this.Page.SetFocus();
            //        return;
            //    }
            //}

        }

        private void DL_Id_type_LostFocus(object sender, RoutedEventArgs e)
        {
            ComponentOutput.ProxyInfoLink.DLRZJLX = DL_Id_type.GetSelectedValue();
            ComponentOutput.ProxyInfoLink.DLRZJLXZh = DL_Id_type.GetSelectedKey();
            DL_Id_no.Text = null;
            if (ComponentHelper.PreProxyIdnoTypeControl != null)
            {
                if (!ComponentHelper.PreProxyIdnoTypeControl(DL_Id_type.GetSelectedValue()))
                {
                    //验证不通过
                    this.Page.SetFocus();
                    return;
                }
            }
            this.Page.SetInputOfIdCard(DL_Id_no, (DL_Id_type.GetSelectedValue() == "B01"));
            //this.Page.SetInputOfIdCard(DL_Id_no, (DL_Id_type.GetSelectedValue() == "1"));
        }

        //添加该方法主要是因为原先在InitComponet方法中通过Page对象调用，这可能会产生Page是空引用的问题
        private bool CallComboBoxData(Selector selector, string code, Dictionary<string, string> arguments = null)
        {
            if (selector == null) return false;
            selector.Items.Clear();
            IEnumerable dict;
            dict = SelectionManager.Instance.PullSelection(code, arguments);
            if (dict == null) return false;
            selector.SetItems(dict);
            return true;
        }


        /// <summary>
        /// 11位电话验证
        /// </summary>
        /// <param name="phone"></param>
        private void telephone_validation(TextBox phone)
        {
            if (phone.Text.Trim().Length < 11 && phone.Text.Trim().Length >= 1)
            {
                Page.TradeAPIs.ShowTip("手机号码要求不少于11位，请重新输入！");
                Page.SetFocus(phone);
                return;
            }
        }

        /// <summary>
        /// 【联系电话】焦点离开事件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void LXDHBOX_LostFocus(object sender, RoutedEventArgs e)//移动电话
        {
            //11位电话验证
            telephone_validation(LXDHBOX);
            ComponentOutput.ProxyInfoLink.LXDH = LXDHBOX.Text.Trim();
        }

        /// <summary>
        /// 【联系地址】焦点离开事件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void LXDZBOX_LostFocus(object sender, RoutedEventArgs e)
        {
            ComponentOutput.ProxyInfoLink.LXDZ = LXDZBOX.Text.Trim();
        }

        /// <summary>
        /// 控制单位代理人信息必输 lp20191107
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Sel_flag_GotFocus(object sender, RoutedEventArgs e)
        {
            if (ComponentHelper.check != null && "1".Equals(ComponentHelper.check))
            {
                Sel_flag.SetItems(new Dictionary<string, string> { { "是", "Y" } });
            }
            else
            {
                Sel_flag.SetItems(UserVariable.GetYorN());
                Sel_flag.SetSelectedValue("N");
            }
            return;
        }

    }


    #region 数据限定
    /// <summary>
    /// 组件数据交互类
    /// </summary>
    public class TBC_ProxyInfoLinkInput : TBC_ComponentInput
    {
        #region 构造
        #endregion

        #region 控制属性

        /// <summary>
        /// 是否代理特别控制
        /// </summary>
        public Predicate<string> PreProxySFDLControl { get; set; }

        /// <summary>
        /// 代理证件号码特别控制
        /// </summary>
        public Predicate<string> PreProxyIdnoControl { get; set; }

        /// <summary>
        /// 代理证件类型特别控制
        /// </summary>
        public Predicate<string> PreProxyIdnoTypeControl { get; set; }

        /// <summary>
        /// 代理证件名称特别控制
        /// </summary>
        public Predicate<string> PreProxyIdnoNameControl { get; set; }
        /// <summary>
        /// 控制单位代理人 必输
        /// </summary>
        public string check { get; set; }

        #endregion

        #region 交互方法

        #endregion
    }

    /// <summary>
    /// 组件数据输出类
    /// </summary>
    public class TBC_ProxyInfoLinkOutput : TBC_ComponentOutput
    {
        /// <summary>
        /// 输出账户信息
        /// </summary>
        public TBC_ProxyInfoLink.ProxyPersonInfoLink ProxyInfoLink { get; internal set; }

    }
    #endregion
}
