﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Markup.Localizer;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Platform.Common.RunningParameters;
using Platform.Controls.ControlsHelper;
using Platform.Controls.NumericContainer;
using Platform.Library;
using TellerSystem.Contract.Function;
using TellerSystem.Controls.Ext.ControlsExt;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Library.Ext.Variables;
using TellerSystem.Controls.Ext.Controls;
using TellerSystem.Library.Ext.TradeExtension;
using TellerSystem.Controls.Ext.ControlsHelper;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;

namespace TellerSystem.Controls.Ext.TradePageComponent
{
    /// <summary>
    /// 取款账户控制信息
    /// </summary>
    public partial class TBC_QkAcControl : TBC_ComponentBase<TBC_QkAcControlInput, TBC_QkAcControlOutput>
    {
        public TBC_QkAcControl()
        {
            InitializeComponent();
        }
        public decimal DrjiAmt = 0M;
        /// <summary>
        /// 联网核查结果
        /// </summary>
        public string LWHCJG = string.Empty;
        #region  属性
        private string flag ;
        /// <summary>
        /// 标题信息
        /// </summary>
        public string Header
        {
            get { return (string)GetValue(HeaderProperty); }
            set { SetValue(HeaderProperty, value); }
        }


        public static readonly DependencyProperty HeaderProperty =
            DependencyProperty.Register("Header", typeof(string), typeof(TBC_QkAcControl), new FrameworkPropertyMetadata("账户验证信息", new PropertyChangedCallback((sender, e) =>
            {
                var tmpcontrol = sender as TBC_QkAcControl;
                if (tmpcontrol == null)
                    return;
                tmpcontrol.tradepanel.Header = e.NewValue.ToString();
            })));

        /// <summary>
        /// 控制显示部分
        /// </summary>
        public EnDisplaySection DisplaySection
        {
            get { return (EnDisplaySection)GetValue(DisplaySectionProperty); }
            set { SetValue(DisplaySectionProperty, value); }
        }

        private static readonly DependencyProperty DisplaySectionProperty =
            DependencyProperty.Register("DisplaySection", typeof(EnDisplaySection), typeof(TBC_QkAcControl),
                                        new FrameworkPropertyMetadata(EnDisplaySection.QkCheck,
                                                                      new PropertyChangedCallback(DisplaySectionChanged)));

        private static void DisplaySectionChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            var tmpvalue = (EnDisplaySection)e.NewValue;
            var tmpControl = d as TBC_QkAcControl;
            if (tmpControl == null)
                return;

            switch (tmpvalue)
            {
                //转账校验 显示金额;支取标志、支取密码;证件类型、证件号;
                case EnDisplaySection.ZzCheck:
                    //不显示现转标志、显示金额
                    tmpControl.Height = 154;
                    TradePanel.SetColumnSpan(tmpControl.tb_Amt, 3);
                    tmpControl.tb_LbCashFlag.Visibility = Visibility.Collapsed;
                    tmpControl.cmb_CashFlag.Visibility = Visibility.Collapsed;
                    tmpControl.tb_LbAmt.Visibility = Visibility.Visible;
                    tmpControl.tb_Amt.Visibility = Visibility.Visible;
                    break;
                //普通校验 显示支取标志、支取密码;证件类型、证件号;
                case EnDisplaySection.ComCheck:
                    //不显示现转、金额
                    tmpControl.Height = 124;
                    tmpControl.tb_LbCashFlag.Visibility = Visibility.Collapsed;
                    tmpControl.cmb_CashFlag.Visibility = Visibility.Collapsed;
                    tmpControl.tb_LbAmt.Visibility = Visibility.Collapsed;
                    tmpControl.tb_Amt.Visibility = Visibility.Collapsed;
                    break;
                //取款校验 显示现转、金额;支取标志、支取密码;证件类型、证件号;
                case EnDisplaySection.QkCheck:
                default:
                    //显示现转标志、显示金额
                    TradePanel.SetColumnSpan(tmpControl.tb_Amt, 1);
                    tmpControl.Height = 154;
                    tmpControl.tb_LbCashFlag.Visibility = Visibility.Visible;
                    tmpControl.cmb_CashFlag.Visibility = Visibility.Visible;
                    tmpControl.tb_LbAmt.Visibility = Visibility.Visible;
                    tmpControl.tb_Amt.Visibility = Visibility.Visible;
                    break;
            }
        }

        #endregion

        #region 变量

        //支取方式
        private string _zqfs = string.Empty;

        #endregion

        #region   对外方法

        /// <summary>
        /// 初始化界面
        /// </summary>
        /// <param name="acInfo"></param>
        public void InitQkAcControl(QueryDepositAccount acInfo)
        {
            //初始化支取方式
            this.Page.TradeAPIs.SetItems(cmb_CashFlag, UserVariable.Getcashflag());
            this.Page.TradeAPIs.SetSelectedValue(cmb_CashFlag, "1");
            flag = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            //if (flag == "V12")
            //{
            //    TextBoxHelper.SetIsRepeatInput(tb_Amt, false);
            //}
            //else
            //{
            //    TextBoxHelper.SetIsRepeatInput(tb_Amt, true);
            //}
            ComponentOutput.AccountInfo = acInfo;
            if (acInfo == null)
            {
                tb_Amt.Text = tb_Idno.Text = pb_Password.Password = string.Empty;
                this.Page.TradeAPIs.SetSelectedValue(cmb_CashFlag, "1");
                return;
            }
            //设置支取标志
            if (acInfo.SFPM.Trim().Equals("Y"))
            {
                if (acInfo.SFPZJZQ.Equals("Y"))
                {
                    _zqfs = "MMZJ";
                }
                else
                {
                    _zqfs = "Y";
                }
            }
            else
            {
                if (acInfo.SFPZJZQ.Equals("Y"))
                {
                    _zqfs = "ZJ";
                }
                else
                {
                    //核心数据问题
                    _zqfs = "NZJ";
                    this.Page.TradeAPIs.ShowInfoMessageBox("该账户是无密且不凭证件支取户");
                }
            }
            //正常数据
            this.Page.TradeAPIs.SetItems(cmb_Pwdflag, UserVariable.GetPerPwdflag().Where(x => x.Value.Equals(_zqfs)));
            //设置证件类型 
            this.Page.TradeAPIs.SetItems(cmb_Idtype, UserVariable.GetPerIdType().Where(x => x.Value.Equals(acInfo.ZJLX.Trim())));
            this.Page.SetInputOfIdCard(tb_Idno, (cmb_Idtype.GetSelectedValue() == "1"));
            //由于存在老数据身份证不合格，故无需格式验证
            tb_Idno.ClearValue(Platform.Controls.ControlsHelper.TextBoxHelper.InputTypeProperty);

        }
        /// <summary>
        /// 设置金额控件是否输入两次
        /// </summary>
        /// <param name="isRepeat"></param>
        public void SetAmtIsRepeat(bool isRepeat)
        {
            TextBoxHelper.SetIsRepeatInput(tb_Amt, isRepeat);
        }
        /// <summary>
        /// 设置交易金额
        /// </summary>
        /// <param name="amt">金额</param>
        /// <param name="isReadonly">是否只读</param>
        /// <param name="isEnabled"></param>
        public void SetTxAmt(string amt, bool isReadonly, bool isEnabled = true)
        {
            tb_Amt.Text = amt;
            tb_Amt.IsReadOnly = isReadonly;
            tb_Amt.IsEnabled = isEnabled;
            //更新输出金额
            ComponentOutput.TxAmt = amt;
            if(!string.IsNullOrEmpty(amt)){
                 tb_AmtD.Text = this.Page.TradeAPIs.ChangeToCNY(tb_Amt.Text.ToDecimal());
            }    
        }
        /// <summary>
        /// 设置币种类型
        /// </summary>
        /// <param name="val">币种类型</param>
        public void SetAmtSymbol(string val)
        {
            tb_Amt.ChangeMoneySymbol(val);
        }
        /// <summary>
        /// 设置现转标志
        /// </summary>
        /// <param name="xzSection"></param>
        public void SetXZBZ(EnXZSection xzSection)
        {

            switch (xzSection)
            {
                case EnXZSection.Cash:
                    //现金
                    this.Page.TradeAPIs.SetItems(cmb_CashFlag, UserVariable.Getcashflag().Where(x => x.Value.Equals("1")));
                    cmb_CashFlag.SelectedIndex = 0;
                    break;
                case EnXZSection.Transfer:
                    //转账
                    this.Page.TradeAPIs.SetItems(cmb_CashFlag, UserVariable.Getcashflag().Where(x => x.Value.Equals("2")));
                    cmb_CashFlag.SelectedIndex = 0;
                    break;
                case EnXZSection.All:
                default:
                    //支取方式
                    this.Page.TradeAPIs.SetItems(cmb_CashFlag, UserVariable.Getcashflag());
                    this.Page.TradeAPIs.SetSelectedValue(cmb_CashFlag, "1");
                    break;
            }
        }

        /// <summary>
        /// 控制是否可输入密码
        /// </summary>
        /// <param name="isEnabled">是否可操作</param>
        public void SetMmState(bool isEnabled = true)
        {
            cmb_Pwdflag.IsEnabled = isEnabled;
            pb_Password.IsEnabled = isEnabled;
        }

        #endregion

        #region  内部逻辑

        /// <summary>
        /// 现转标志
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void cmb_CashFlag_LostFocus(object sender, RoutedEventArgs e)
        {
            ComponentOutput.XZBZ = cmb_CashFlag.GetSelectedValue();
            if (ComponentHelper.XzSelected != null)
            {
                //选择现转后触发事件
                ComponentHelper.XzSelected(ComponentOutput.XZBZ);
            }
        }

        /// <summary>
        /// 设置是否输入密码
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void cmb_Pwdflag_LostFocus(object sender, RoutedEventArgs e)
        {
            //无密码无证件
            if (_zqfs.Equals("NZJ"))
            {
                pb_Password.Password = string.Empty;
                pb_Password.IsEnabled = false;
                return;
            }

            if (cmb_Pwdflag.GetSelectedValue().Equals("Y") || cmb_Pwdflag.GetSelectedValue().Equals("MMZJ"))
            {
                //凭密码支取
                pb_Password.IsEnabled = true;
            }
            else
            {
                //无密码
                pb_Password.Password = string.Empty;
                pb_Password.IsEnabled = false;
            }
        }

        /// <summary>
        /// 清空密码
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void pb_Password_GotFocus(object sender, RoutedEventArgs e)
        {
            pb_Password.Password = string.Empty;
            Encrypte.AccountNo = ComponentOutput.AccountInfo.CLJZH.Trim();
        }

        private int _pawdnum = 1;
        /// <summary>
        /// 密码检验
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void pb_Password_LostFocus(object sender, RoutedEventArgs e)
        {
            //if (_pawdnum > 2)
            //{
            //    //此操作是为了避免调用外设时窗体关闭，但外设弹窗提示依然存在的问题
            //    DeviceManager.SetPassWordKeyBoardReader(pb_Password, PassWordKeyBoardReaderType.Input);
            //    this.Page.Close();
            //    return;
            //}
            //密码验证
            var mmcheck = this.Page.TradeAPIs.TF_Deposit_PasswordAuthentication(new PasswordAuthentication.Input()
            {
                MM = pb_Password.Password,
                ZH = ComponentOutput.AccountInfo.CLJZH.Trim()
            });
            if (mmcheck.IsFailed)
            {
                if (mmcheck.FailureCause.Contains("PWD1"))
                { 
                    DeviceManager.SetPassWordKeyBoardReader(pb_Password, PassWordKeyBoardReaderType.Input);
                    this.Page.TradeAPIs.ShowInfoMessageBox("本日密码输入次数超限，请明日再试或进行密码解锁。");
                    this.Page.Close(); 
                    return; 
                }
                _pawdnum++;
                pb_Password.Password = string.Empty;
                Encrypte.AccountNo = ComponentOutput.AccountInfo.CLJZH.Trim();
                this.Page.TradeAPIs.ShowTip(mmcheck.FailureCause);
                this.Page.SetFocus();
                return;
            }
            ComponentOutput.AcPassword = pb_Password.Password;
            if (ComponentHelper.MmChecked != null)
            {
                //密码验证通过处理事件
                ComponentHelper.MmChecked(ComponentOutput.AccountInfo);
            }
        }

        /// <summary>
        /// 控制身份证输入方式
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void cmb_Idtype_LostFocus(object sender, RoutedEventArgs e)
        {
            //todo:控制身份证输入方式 ZJLXPassed
            if (ComponentHelper.ZJLXPassed != null)
            {
                ComponentHelper.ZJLXPassed(ComponentOutput.AccountInfo.ZJHM);  
            }
        }

        /// <summary>
        /// 身份证校验
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void tb_Idno_LostFocus(object sender, RoutedEventArgs e)
        {
            if (!string.IsNullOrEmpty(tb_Idno.Text.Trim()))
            {
                if (this.Page.TradeAPIs.Delspace(ComponentOutput.AccountInfo.ZJHM) != this.Page.TradeAPIs.Delspace(tb_Idno.Text) ||
              cmb_Idtype.GetSelectedValue() != ComponentOutput.AccountInfo.ZJLX.Trim())
                {
                    tb_Idno.ShowTip("与开户时证件信息不符!");
                    this.Page.TradeAPIs.SetFocus();
                    return;
                }
                //if (ComponentHelper.MainCode == "2201") 注释掉此行代码，开启证件号码校验和转换，进行身份证号联网核查，在IdCheck里面控制是否展示联网核查界面
                //{
                    //新增加将证件号码字母自动转为大写
                    tb_Idno.Text = tb_Idno.Text.Trim().ToUpper();

                    //身份证逻辑
                    if ("1" == cmb_Idtype.GetSelectedValue())
                    {
                        //长度判定,开客户id务必保持18位身份证号
                        if (Page.Len(tb_Idno.Text.Trim()) != 18 && Page.Len(tb_Idno.Text.Trim()) != 15)
                        {
                            Page.TradeAPIs.ShowTip(Page.TradeAPIs.GetNotifyMessage(NotifyMessage.N003));
                            this.Page.TradeAPIs.SetFocus();
                            return;
                        }
                        var output = Page.TradeAPIs.TF_Deposit_IDNumberVerification(new IDNumberVerification.Input { ZJLX = "1", ZJHM = tb_Idno.Text });
                        if (output.IsFailed)
                        {
                            Page.TradeAPIs.ShowTip(output.FailureCause);
                            Page.SetFocus();
                            return;
                        }
                        if (output.YZTGBZ[0] != '1')
                        {
                            Page.TradeAPIs.ShowTip(Page.TradeAPIs.GetNotifyMessage(NotifyMessage.N002));
                            Page.SetFocus();
                            return;
                        }
                        tb_Idno.Text = Page.TradeAPIs.Delspace(output.ZJHM);
                        if (flag != "V5")//青隆暂时不需要
                        {
                            //执行身份核查
                            var result = this.Page.TradeAPIs.IdCheck(tb_Idno);
                            if (result.IsOnline && result.IsComplated)
                            {
                            }
                            else if (result.IsOnline && this.Page.TradeAPIs.ShowQuestionMessageBox("联网身份核查未通过，是否继续？") == MessageBoxResult.No)
                            {
                                this.Page.TradeAPIs.SetFocus(tb_Idno);
                                return;
                            }
                        }
                        if (flag == "V5" && this.Page.TradeModel.Code == "2003")//&& !ComponentOutput.IsProxy
                        {
                            this.Page.TradeAPIs.IsSkipFaceComp(ComponentOutput.IsProxy || tb_Amt.Text.ToDecimal() < 50000);
                            //执行身份核查
                            var result = this.Page.TradeAPIs.IdCheck(tb_Idno);
                            if (result.IsOnline && result.IsComplated)
                            {
                                if (LoginUserInfo.KinbrNo.Substring(0, 3) == "302")
                                {
                                    LWHCJG = result.ResultKey;
                                }
                            }
                            else if (result.IsOnline && this.Page.TradeAPIs.ShowQuestionMessageBox("联网身份核查未通过，是否继续？") == MessageBoxResult.No)
                            {
                                this.Page.TradeAPIs.SetFocus(tb_Idno);
                                return;
                            }
                            if (result.IsOnline && result.Reject2RLSB)
                            {
                                this.Page.TradeAPIs.SetFocus(tb_Idno);
                                return;
                            }
                            this.Page.TradeAPIs.IsSkipFaceComp(tb_Amt.Text.ToDecimal() < 50000);
                        }
                    }
                //}
                if (ComponentHelper.ZJHMPassed != null)
                {
                    //选择现转后触发事件
                    ComponentHelper.ZJHMPassed(ComponentOutput.AccountInfo.ZJHM);
                }
            }
        }

        /// <summary>
        /// 取款金额检查
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void tb_Amt_LostFocus(object sender, RoutedEventArgs e)
        {
            tb_AmtD.Text = this.Page.TradeAPIs.ChangeToCNY(tb_Amt.Text.ToDecimal());
            //更新输出金额
            ComponentOutput.TxAmt = tb_Amt.Text;
            //输入交易金额
            decimal amt = tb_Amt.Text.ToDecimal();
            //当前账户可用余额
            //decimal avaibleamt = this.Page.Val(ComponentOutput.AccountInfo.KYYE, 1);
            decimal avaibleamt = 0;
            if ((flag == "V21" || flag == "V22") && ComponentOutput.AccountInfo.BZW.Substring(66, 1).Equals("Y"))//天骄，当前账户可用余额包括七日盈可用余额
            {
                avaibleamt = this.Page.Val(ComponentOutput.AccountInfo.KYYE, 1) + this.Page.Val(ComponentOutput.AccountInfo.JTQYDRTZED, 1) + this.Page.Val(ComponentOutput.AccountInfo.QRYYE, 1);
            }
            else
            {
                avaibleamt = this.Page.Val(ComponentOutput.AccountInfo.KYYE, 1) + this.Page.Val(ComponentOutput.AccountInfo.JTQYDRTZED, 1);
            }
            //金额不能为0
            if (amt <= 0)
            {
                tb_Amt.ShowTip("交易金额不能为0，请检查!");
                this.Page.SetFocus();
                return;
            }
            //金额可输入时需要校验交易金额不能超过账户可用余额，不可输情况一般不用校验 比如受托支付
            if (tb_Amt.IsEnabled && !tb_Amt.IsReadOnly)
            {
                if (amt > avaibleamt)
                {
                    tb_Amt.ShowTip("交易金额超过账户可用余额，请检查!");
                    this.Page.SetFocus();
                    return;
                }
            }

            //检查金额是否超限
            var jeyz = this.Page.TradeAPIs.TF_Deposit_CheckTradeRule(new CheckTradeRule.Input()
            {
                ZH = ComponentOutput.AccountInfo.CLJZH.Trim(),
                ZHXH = ComponentOutput.AccountInfo.XH.Trim(),
                JYJE = amt.ToString(),
                YWLX = cmb_CashFlag.GetSelectedValue().Equals("1") ? GlobalVariable.YW_TYPE_QX : GlobalVariable.YW_TYPE_ZC,
                QDLX = "0100"
            });
            if (jeyz.IsFailed)
            {
                tb_Amt.ShowTip(jeyz.FailureCause);
                this.Page.SetFocus();
                return;
            }

            //以“单账户”下当日累计或单笔超过5万元（含）以上需要录入证件号码并提示累计金额
            //调用短交易统计客户当天所有账户取现/转账总额 超过5W需录入证件类型和证件号码
            //账户交易统计信息
            var tjinfo = this.Page.TradeAPIs.TF_Deposit_StatisticsSingleCustomerOraccountDayturnover(new StatisticsSingleCustomerOraccountDayturnover.Input()
            {
                ZH = ComponentOutput.AccountInfo.CLJZH.Trim(),
                ZQLX = "1",
                ZQZ = "1",
                CXLX = "0",
                TJLX = "1",
                //统计当天取现及转账总发生额
                JYLX = "3100",
                QDLXLBDM = "0010"

            });
            if (tjinfo.IsFailed)
            {
                tb_Amt.ShowTip(tjinfo.FailureCause);
                this.Page.SetFocus(tb_Amt);
                return;
            }

            //判断该账户当日累计取款/转账超5W,需验证开户证件
            decimal dTot_amt = tjinfo.DRJYZE.ToDecimal() + amt;
            //if (tjinfo.DRJYZE.ToDecimal() >= "50000.00".ToDecimal())
            //{
            //    this.Page.TradeAPIs.ShowInfoMessageBox("截止至该笔交易之前，该账户当日累计交易金额为:" + tjinfo.DRJYZE.ToDecimal());
            //}
            tb_Idno.Text = string.Empty;
            if (flag == "V12")
            {
                cmb_Idtype.IsEnabled = tb_Idno.IsEnabled = (tb_Amt.Text.ToDecimal() >= 50000 || dTot_amt >= 50000 || ComponentOutput.AccountInfo.SFPZJZQ.Equals("Y")) ? true : false;
            }
            else
            {
                if (cmb_CashFlag.GetSelectedValue() == "1")
                {
                    cmb_Idtype.IsEnabled = tb_Idno.IsEnabled = (tb_Amt.Text.ToDecimal() >= 50000 || dTot_amt >= 50000 || ComponentOutput.AccountInfo.SFPZJZQ.Equals("Y")) ? true : false;
                }
                else
                {
                    cmb_Idtype.IsEnabled = tb_Idno.IsEnabled = (tb_Amt.Text.ToDecimal() >= 200000 || dTot_amt >= 200000 || ComponentOutput.AccountInfo.SFPZJZQ.Equals("Y")) ? true : false;
                }
            }
           
            //cmb_Idtype.IsEnabled = dTot_amt >= 50000 ? true : false;
            DrjiAmt = tjinfo.DRJYZE.ToDecimal();
            //部提必须证件验证
            if (ComponentHelper.IsPreview)
                cmb_Idtype.IsEnabled = tb_Idno.IsEnabled = true;

            //证件支取
            if (_zqfs.Equals("ZJ") || _zqfs.Equals("MMZJ"))
            {
                cmb_Idtype.IsEnabled = tb_Idno.IsEnabled = true;
            }
            else if (_zqfs.Equals("NZJ"))
            {
                //无证据无密码时，不需要输入证件号码
                tb_Idno.Text = string.Empty;
                cmb_Idtype.IsEnabled = tb_Idno.IsEnabled = false;
            }

            //定期提前支取需输入证件号码
            if (ComponentOutput.AccountInfo.ZHLX == "2")
            {
                //定期账户时判断是否提前支取
                if (LoginUserInfo.TradeDate.ToDecimal() < ComponentOutput.AccountInfo.DQRQ.ToDecimal() && ComponentOutput.AccountInfo.DQCKLX!="G")
                {
                    //定期提前支取标志
                    tb_Idno.IsEnabled = true;
                    cmb_Idtype.IsEnabled = true;
                }
            }

            if (ComponentHelper.AmtSpecialControling != null)
            {
                if (!ComponentHelper.AmtSpecialControling(tb_Amt.Text.Trim()))
                {
                    //验证不通过
                    this.Page.SetFocus();
                    return;
                }
            }

            if (this.Page.TradeAPIs.GetSelectedValue(cmb_CashFlag) == "1" && cmb_CashFlag.Visibility == Visibility.Visible)
            {
                bool IsCheckAmt = false;
                bool.TryParse(ConfigManager.GetInstance().GetConfigValue("IsCheckAmt", ConfigType.System), out IsCheckAmt);
                if (IsCheckAmt)
                {
                    CheckMoney check = new CheckMoney(tb_Amt.Text);
                    this.Page.ShowPage(check);
                    if (!check.jieguo)
                    {
                        this.Page.TradeAPIs.ShowTip("请校验金额!");
                        this.Page.SetFocus(tb_Amt);
                        return;
                    }
                }
            }
            if (flag == "V5" && this.Page.TradeAPIs.ShowQuestionMessageBox("是否代理人取款？") == MessageBoxResult.Yes)
            {
                ComponentOutput.IsProxy = true;
            }
            else
            {
                ComponentOutput.IsProxy = false;
            }
            //信息交互
            //if (TellerSystem.Devices.Config.DeviceConfig.TransInfoEnabled)
            //{
            //    string text = "交易类型：取款\n账号：" + ComponentOutput.AccountInfo.ZH + "\n户名：" + ComponentOutput.AccountInfo.HM + "\n金额：" + SystemFunction.Delspace(SystemFunction.Comma(tb_Amt.Val, 16));
            //    var result = TellerSystem.Devices.DeviceHelper.PrintTransInfo(text);
            //    if (result.HasError)
            //    {
            //        tb_Amt.ShowTip("信息交互操作有误，请重新调用");
            //        this.Page.SetFocus(tb_Amt);
            //        return;
            //    }
            //}
        }

        #endregion

        /// <summary>
        /// 取款组件显示枚举
        /// </summary>
        public enum EnDisplaySection
        {
            //取款校验 显示现转、金额;支取标志、支取密码;证件类型、证件号;
            QkCheck,
            //转账校验 显示金额;支取标志、支取密码;证件类型、证件号;
            ZzCheck,
            //普通校验 显示支取标志、支取密码;证件类型、证件号;
            ComCheck
        }
        /// <summary>
        /// 现转展示枚举
        /// </summary>
        public enum EnXZSection
        {
            //现金
            Cash,
            //转账
            Transfer,
            //所有
            All
        }
    }

    #region 数据限定
    /// <summary>
    /// 组件数据交互类
    /// </summary>
    public class TBC_QkAcControlInput : TBC_ComponentInput
    {
        #region 构造

        #endregion

        #region 控制属性

        /// <summary>
        /// 是否部提
        /// </summary>
        public bool IsPreview { get; set; }

        public string MainCode { get; set; }

        /// <summary>
        /// 密码校验通过结果后处理
        /// </summary>
        public Action<QueryDepositAccount> MmChecked { get; set; }

        /// <summary>
        /// 现转选择变化时
        /// </summary>
        public Action<string> XzSelected { get; set; }

        /// <summary>
        /// 交易金额特别控制
        /// </summary>
        public Predicate<string> AmtSpecialControling { get; set; }

        /// <summary>
        /// 证件号码验证后
        /// </summary>
        public Predicate<string> ZJHMPassed { get; set; }
        /// <summary>
        /// 证件号类型后
        /// </summary>
        public Predicate<string>  ZJLXPassed { get; set; }



        #endregion
    }

    /// <summary>
    /// 组件数据输出类
    /// </summary>
    public class TBC_QkAcControlOutput : TBC_ComponentOutput
    {
        /// <summary>
        /// 输出账户信息
        /// </summary>
        public QueryDepositAccount AccountInfo { get; internal set; }

        /// <summary>
        /// 账户密码
        /// </summary>
        public string AcPassword { get; internal set; }


        /// <summary>
        /// 现转标志 1：现金 2：转账
        /// </summary>
        public string XZBZ { get; internal set; }


        /// <summary>
        /// 交易金额
        /// </summary>
        public string TxAmt { get; internal set; }
        /// <summary>
        /// 交易金额
        /// </summary>
        public string DrjyAmt { get; internal set; }

        /// <summary>
        /// 是否代理人
        /// </summary>
        public bool IsProxy { get; internal set; }
    }
    #endregion
}
