﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Platform.Common.RunningParameters;
using Platform.Controls.ControlsHelper;
using Platform.Controls.NumericContainer;
using Platform.Library;
using TellerSystem.Contract.Function;
using TellerSystem.Controls.Ext.ControlsExt;
using TellerSystem.Library.Ext.Function;
using TellerSystem.Library.Ext.Variables;
using TellerSystem.Controls.Ext.ControlsHelper;
using TellerSystem.Library.Ext.TradeExtension;
using TellerSystem.Devices.Interface;
using TellerSystem.Devices.Config;

namespace TellerSystem.Controls.Ext.TradePageComponent
{
    /// <summary>
    /// 输入账户组件
    /// </summary>
    public partial class TBC_TransInAccountInfo : TBC_ComponentBase<TBC_TransInAccountInfoInput, TBC_TransInAccountInfoOutput>
    {
        #region 构造
        /// <summary>
        /// 构造函数
        /// </summary>
        public TBC_TransInAccountInfo()
        {
            InitializeComponent();
        }
        #endregion

        #region 内部逻辑
        private void DFNO_LostFocus(object sender, RoutedEventArgs e)
        {
            //5开头的科目不准在此交易记帐 
            if (this.Page.TradeAPIs.Len(this.DFNO.Text) <= 7 && this.Page.TradeAPIs.SubStr(this.DFNO.Text, 0, 1) == "5")
            {
                this.Page.TradeAPIs.ShowTip("不可记此科目！");
                this.Page.TradeAPIs.SetFocus();
                return;
            }
            //支行不允许通过内部记帐方式记408科目帐
            if (this.Page.TradeAPIs.SubStr(this.DFNO.Text, 1, 3) == "408")
            {
                this.Page.TradeAPIs.ShowTip("不可记此帐户！");
                this.Page.TradeAPIs.SetFocus();
                return;
            }
            if (this.Page.TradeAPIs.SubStr(this.DFNO.Text, 1, 3) == "407" || this.DFNO.Text == "41600")
            {
                this.Page.TradeAPIs.ShowTip("不可记此科目！");
                this.Page.TradeAPIs.SetFocus();
                return;
            }
            if (this.Page.TradeAPIs.SubStr(this.DFNO.Text, 0, 3) == "101" && this.Page.TradeAPIs.Len(this.DFNO.Text) <= 7)
            {
                this.Page.TradeAPIs.ShowTip("不可以用现金科目的记帐！");
                this.Page.TradeAPIs.SetFocus();
                return;
            }
            if (this.DFNO.Text == "6020102")
            {
                this.Page.TradeAPIs.ShowTip("不可记此科目！");
                this.Page.TradeAPIs.SetFocus();
                return;
            }
            if (this.Page.TradeAPIs.SubStr(this.DFNO.Text, 0, 6) == "622936" || this.Page.TradeAPIs.SubStr(this.DFNO.Text, 0, 6) == "623060")
            {
                NZY_ACSEQ101.Visibility = Visibility.Visible;
                ZY_ACSEQ101.Visibility = Visibility.Visible;
                //将活期帐号信息显示出来
                //this._msg.Fd16 = "9655";
                var zzh = this.Page.TradeAPIs.TF_Deposit_QueryChildAccountList(new QueryChildAccountList.Input { ZH = DFNO.Text, });
                if (zzh.IsFailed)
                {
                    this.Page.TradeAPIs.ShowTip(zzh.FailureCause);
                    this.Page.TradeAPIs.SetFocus();
                    return;
                }
                if (string.IsNullOrEmpty(zzh.ZZHXX))
                {
                    this.Page.TradeAPIs.ShowTip("没有得到分帐户信息！");
                    this.Page.TradeAPIs.SetFocus();
                    return;
                }

                string[] lists = { "账户序号", "开户日期", "产品名称", "账户余额", "账户状态", "冻结状态", "止付状态" };
                var selsectData = ShowPages.ShowDataBoxViewer(this.Page, zzh.ZZHXX, lists, 690, 400, "代理银行信息");
                if (selsectData != null)
                {
                    ZY_ACSEQ101.Text = selsectData["账户序号"].ToString();
                }
                #region 获取账号信息
                var khxx = this.Page.TradeAPIs.TF_Deposit_QueryDepositAccount(new QueryDepositAccount.Input
                {
                    XH = ZY_ACSEQ101.Text,
                    ZH = DFNO.Text,
                });
                if (khxx.IsFailed)
                {
                    this.Page.TradeAPIs.ShowTip(khxx.FailureCause);
                    this.Page.TradeAPIs.SetFocus();
                    return;
                }
                if (this.Page.TradeAPIs.SubStr(khxx.CPH, 0, 1) == "2")
                {
                    this.Page.TradeAPIs.ShowErrorMessageBox("此交易不支持对公向定期转入!");
                    this.Page.TradeAPIs.SetFocus();
                    return;
                }
                this.ZY_ACSEQ101.Text = khxx.XH;
                this.Page.TradeAPIs.SetSelectedValue(ZY_101VOCTYPE, khxx.PZZL);
                this.ZY_101CNAME.Text = khxx.HM;
                this.ZY_101AVBAL.Text = this.Page.TradeAPIs.Itoa(khxx.YE.ToDecimal(), "%17.2f");
                this.ZY_101PNAME.Text = khxx.CPMC;
                #endregion
            }
            else
            {
                NZY_ACSEQ101.Visibility = Visibility.Hidden;
                ZY_ACSEQ101.Visibility = Visibility.Hidden;
                //._msg.Fd16 = "9730";
                var ckxx = this.Page.TradeAPIs.TF_Deposit_QueryDepositAccount(new QueryDepositAccount.Input { ZH = DFNO.Text });
                if (ckxx.IsFailed)
                {
                    this.Page.TradeAPIs.ShowTip(ckxx.FailureCause);
                    this.Page.TradeAPIs.SetFocus();
                    return;
                }
                string prdt_no = ckxx.CPH;

                if (this.Page.TradeAPIs.SubStr(prdt_no, 0, 1) == "2")
                {
                    this.Page.TradeAPIs.ShowTip("对公活期在此不支持向定期户上转账！");
                    this.Page.TradeAPIs.SetFocus();
                    return;
                }
                this.ZY_ACSEQ101.Text = ckxx.XH; 
                this.ZY_101CNAME.Text = ckxx.HM;
                this.ZY_101AVBAL.Text = ckxx.YE;
                this.ZY_101PNAME.Text = ckxx.CPMC;
                KHLX = ckxx.KHLX;
                if (KHLX == "1")
                {
                    //储蓄户
                    NZY_101VOCTYPE.Visibility = Visibility.Collapsed;
                    ZY_101VOCTYPE.Visibility = Visibility.Collapsed;
                    NZY_TP.Visibility = Visibility.Collapsed;
                    ZY_TP.Visibility = Visibility.Collapsed;
                }
                else if (KHLX == "2")
                {
                    //对公户
                    var list = this.Page.TradeAPIs.TF_Public_QueryComboBoxData(new QueryComboBoxData.Input { LBBM = "0002", });
                    ZY_TP.SetItems(list.CDXXData.Select(x => new KeyValuePair<string, string>(x.MS, x.LXZ)));
                    var pzlx = this.Page.TradeAPIs.TF_Public_QueryComboBoxData(new QueryComboBoxData.Input { LBBM = "0069", });
                    ZY_101VOCTYPE.SetItems(pzlx.CDXXData.Select(x => new KeyValuePair<string, string>(x.MS, x.LXZ)));
                    NZY_101VOCTYPE.Visibility = Visibility.Visible;
                    ZY_101VOCTYPE.Visibility = Visibility.Visible;
                    NZY_TP.Visibility = Visibility.Visible;
                    ZY_TP.Visibility = Visibility.Visible;
                    this.Page.TradeAPIs.SetSelectedValue(ZY_101VOCTYPE, ckxx.PZZL);
                }
                else
                {
                    this.Page.TradeAPIs.ShowTip("帐户类型错误！");
                    this.Page.TradeAPIs.SetFocus();
                    return;
                }
                //增加一个内部帐帐户的标志,另也作为科目的标志
                if (this.Page.TradeAPIs.SubStr(this.DFNO.Text, 0, 1) == "9" || this.Page.TradeAPIs.Len(this.DFNO.Text) <= 7)
                {
                    KHLX = "3";
                }

            }
        }

        private void ZY_TP_LostFocus(object sender, RoutedEventArgs e)
        {
            if (this.Page.TradeAPIs.GetSelectedValue(ZY_TP) != "31")
            {
                this.CZY_TP.Text = this.Page.TradeAPIs.GetSelectedKey(ZY_TP);
                this.CZY_TP.IsEnabled = false;
            }
            else
            {
                this.CZY_TP.Text = "";
                this.CZY_TP.IsEnabled = true;
            }
        }
        #endregion

        #region 属性
        /// <summary>
        /// 开户类型
        /// </summary>
        public string KHLX { get; private set; }
        /// <summary>
        /// 开户行号
        /// </summary> 
        public string OPN_BR_NO { get; private set; }
        /// <summary>
        /// 转出金额
        /// </summary> 
        public string TANSAMT { set { TRAN_AMT.Text = value; } }
        /// <summary>
        /// 账号
        /// </summary>
        public TextBox TansAcno { get { return DFNO; } }
        /// <summary>
        /// 账号序号
        /// </summary>
        public string TansAcseq { get { return this.Page.TradeAPIs.Delspace(ZY_ACSEQ101.Text); } }
        /// <summary>
        /// 产品名称
        /// </summary>
        public string TansPdname { get { return this.Page.TradeAPIs.Delspace(ZY_101PNAME.Text); } }
        /// <summary>
        /// 账号户名
        /// </summary>
        public string TansName { get { return this.Page.TradeAPIs.Delspace(ZY_101CNAME.Text); } }
        /// <summary>
        /// 余额
        /// </summary>
        public string TansBal { get { return this.Page.TradeAPIs.Delspace(ZY_101AVBAL.Val); } }
        /// <summary>
        /// 凭证类型
        /// </summary>
        public ComboBox TansPtype { get { return ZY_101VOCTYPE; } }

        /// <summary>
        /// 摘要选项
        /// </summary>
        public ComboBox TansZYtype { get { return ZY_TP; } }
        /// <summary>
        /// 摘要
        /// </summary>
        public string TansZY { get { return this.Page.TradeAPIs.Delspace(CZY_TP.Text); } }

        #endregion
    }

    #region 数据限定
    /// <summary>
    /// 组件数据交互类
    /// </summary>
    public class TBC_TransInAccountInfoInput : TBC_ComponentInput
    {

    }

    /// <summary>
    /// 组件数据输出类
    /// </summary>
    public class TBC_TransInAccountInfoOutput : TBC_ComponentOutput
    {

        /// <summary>
        /// 输出账户磁道信息
        /// </summary>
        public SwipeCardReaderEntity AccMsrInfo { get; internal set; }
    }
    #endregion
}
