﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TellerSystem.Controls.Ext.TradePageInterface
{
    /// <summary>
    /// 
    /// </summary>
    /// <typeparam name="T"></typeparam>
    public interface TGI_BusinessEntity<T> where T : BusinessEntity, new()
    {
        /// <summary>
        /// 检查业务实体
        /// </summary>
        /// <param name="businessEntity"></param>
        void CheckBusinessEntity(T businessEntity);

        /// <summary>
        /// 初始化业务流程
        /// </summary>
        /// <param name="businessEntity"></param>
        void LoadBusinessEntity(T businessEntity);

        event EventHandler<BusinessCallbackEventArgs> BusinessCallback;
    }

    /// <summary>
    /// 业务实体抽象类
    /// </summary>
    public abstract class BusinessEntity
    {
        public bool CheckResult { get; set; }
        public string FailureCause { get; set; }
    }

    public class BusinessCallbackEventArgs : EventArgs
    {
        public bool Result { get; set; }
        public string FailureCause { get; set; }
    }
}
