// // 窗口样式常量
// export const WS_VSCROLL = 0x00200000;
// export const SWP_NOOWNERZORDER = 0x200;
// export const SWP_NOREDRAW = 0x8;
// export const SWP_NOZORDER = 0x4;
// export const SWP_SHOWWINDOW = 0x0040;
// export const WS_EX_MDICHILD = 0x40;
// export const SWP_FRAMECHANGED = 0x20;
// export const SWP_NOACTIVATE = 0x10;
// export const SWP_ASYNCWINDOWPOS = 0x4000;
// export const SWP_NOMOVE = 0x2;
// export const SWP_NOSIZE = 0x1;
// export const GWL_STYLE = -16;
// export const WS_VISIBLE = 0x10000000;
// export const WM_CLOSE = 0x10;
// export const WS_CHILD = 0x40000000;
// export const WM_CHAR = 0x102;
// export const WM_KEYDOWN = 0x100;
// export const WM_KEYUP = 0x101;
// export const WM_SYSKEYUP = 0x105;
// export const WM_SYSKEYDOWN = 0x104;
// export const SW_SHOWMINIMIZED = 2;
// export const WM_SYSCOMMAND = 0x0112;
// export const SC_MAXIMIZE = 0xF030;
// export const INSERT = 0x2D;
// export const WM_SETFOCUS = 0x0007;
export const WM_ACTIVATE = 0x0006;

// 使用ffi-napi调用Windows API hulei-s 尝试装过这些库但是版本有冲突暂时注掉
// import ffi from 'ffi-napi';
// import ref from 'ref-napi';
// import StructType from 'ref-struct-di';

// 定义NativeRECT结构体
// const NativeRECT = StructType({
//     left: 'int',
//     top: 'int',
//     right: 'int',
//     bottom: 'int'
// });

// 定义鼠标事件标志
export enum MouseEventFlag {
    MOUSEEVENTF_LEFTDOWN = 0x0002,
    MOUSEEVENTF_LEFTUP = 0x0004,
    MOUSEEVENTF_RIGHTDOWN = 0x0008,
    MOUSEEVENTF_RIGHTUP = 0x0010,
    MOUSEEVENTF_MIDDLEDOWN = 0x0020,
    MOUSEEVENTF_MIDDLEUP = 0x0040,
    MOUSEEVENTF_MOVE = 0x0001,
    MOUSEEVENTF_ABSOLUTE = 0x8000
}

// 加载user32.dll
// const user32 = new ffi.Library('user32', {
//     SendMessageA: ['long', ['long', 'int', 'long', 'long']],
//     SendMessageW: ['long', ['long', 'int', 'long', 'string']],
//     SetWindowLongA: ['long', ['long', 'int', 'long']],
//     SetParent: ['long', ['long', 'long']],
//     SetFocus: ['long', ['long']],
//     SetActiveWindow: ['long', ['long']],
//     GetWindowRect: ['bool', ['long', ref.refType(NativeRECT)]],
//     SetCursorPos: ['bool', ['int', 'int']],
//     mouse_event: ['void', ['uint', 'int', 'int', 'uint', 'ulong']]
// });

export default class Win32API {
    // 窗口样式常量
    static WS_VSCROLL = 0x00200000;
    static SWP_NOOWNERZORDER = 0x200;
    static SWP_NOREDRAW = 0x8;
    static SWP_NOZORDER = 0x4;
    static SWP_SHOWWINDOW = 0x0040;
    static WS_EX_MDICHILD = 0x40;
    static SWP_FRAMECHANGED = 0x20;
    static SWP_NOACTIVATE = 0x10;
    static SWP_ASYNCWINDOWPOS = 0x4000;
    static SWP_NOMOVE = 0x2;
    static SWP_NOSIZE = 0x1;
    static GWL_STYLE = -16;
    static WS_VISIBLE = 0x10000000;
    static WM_CLOSE = 0x10;
    static WS_CHILD = 0x40000000;
    static WM_CHAR = 0x102;
    static WM_KEYDOWN = 0x100;
    static WM_KEYUP = 0x101;
    static WM_SYSKEYUP = 0x105;
    static WM_SYSKEYDOWN = 0x104;
    static SW_SHOWMINIMIZED = 2;
    static WM_SYSCOMMAND = 0x0112;
    static SC_MAXIMIZE = 0xF030;
    static INSERT = 0x2D;
    static WM_SETFOCUS = 0x0007;
    static WM_ACTIVATE = 0x0006;
    //tatic WM_SYSCOMMAND: number;

    // 使用ffi-napi调用Windows API hulei-s 尝试装过这些库但是版本有冲突暂时注掉
    // import ffi from 'ffi-napi';
    // import ref from 'ref-napi';
    // import StructType from 'ref-struct-di';

    // 定义NativeRECT结构体
    // const NativeRECT = StructType({
    //     left: 'int',
    //     top: 'int',
    //     right: 'int',
    //     bottom: 'int'
    // });


    // 发送消息(整数参数)
    static SendMessage(hWnd: number, Msg: number, wParam: number, lParam: number): number {
        return 10;//user32.SendMessageA(hWnd, Msg, wParam, lParam);
    }

    // 发送消息(字符串参数)
    static SendMessageStr(hWnd: number, Msg: number, wParam: number, lParam: string): number {
        return 10;//user32.SendMessageW(hWnd, Msg, wParam, lParam);
    }

    // 设置窗口样式
    static SetWindowLong(hwnd: number, nIndex: number, dwNewLong: number): number {
        return 10;//user32.SetWindowLongA(hwnd, nIndex, dwNewLong);
    }

    // 设置父窗口
    static SetParent(hWndChild: number, hWndNewParent: number): number {
        return 10;//user32.SetParent(hWndChild, hWndNewParent);
    }

    // 设置焦点
    static SetFocus(winHandl: number): number {
        return 10;//user32.SetFocus(winHandl);
    }

    // 激活窗口
    static SetActiveWindow(hWnd: number): number {
        return 10;//user32.SetActiveWindow(hWnd);
    }

    // 获取窗口矩形
    static GetWindowRect(hwnd: number): { left: number, top: number, right: number, bottom: number } {
        // const rect = new NativeRECT();
        // user32.GetWindowRect(hwnd, rect.ref());
        return {
            left: 100,// rect.left,
            top: 100,//rect.top,
            right: 100,//rect.right,
            bottom: 10,//rect.bottom
        };
    }

    // 设置鼠标位置
    static SetCursorPos(X: number, Y: number): boolean {
        return false;// user32.SetCursorPos(X, Y);
    }

    // 执行鼠标事件
    static mouse_event(flags: MouseEventFlag, dx: number, dy: number, data: number = 0): void {
        // user32.mouse_event(flags, dx, dy, data, 0);
    }
}
