﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Interop;
using System.Runtime.InteropServices;

namespace TellerSystem.Library.Ext.ExternalSystem
{
    /// <summary>
    /// win32应用程序宿主窗口，
    /// </summary>
    public class Win32AppHost : HwndHost
    {
        /// <summary>
        /// 寄宿的win32应用程序
        /// </summary>
        private Win32App win32App { get; set; }

        protected override System.Runtime.InteropServices.HandleRef BuildWindowCore(System.Runtime.InteropServices.HandleRef hwndParent)
        {
            win32App.HostInTo(hwndParent.Handle);
            return new HandleRef(this, win32App.AppMainFormHandle);
        }

        protected override void DestroyWindowCore(System.Runtime.InteropServices.HandleRef hwnd)
        {
            this.win32App.DestroyWindow();
        }

        protected override void OnLostKeyboardFocus(System.Windows.Input.KeyboardFocusChangedEventArgs e)
        {
            win32App.SetFocus();
            e.Handled = true;
            base.OnLostKeyboardFocus(e);
        }
    }
}
