import { Win32App } from './Win32App';

export class Win32AppHost {
    private win32App: Win32App;

    constructor(win32App: Win32App) {
        this.win32App = win32App;
    }

    /**
     * 构建宿主窗口核心功能
     * @param hwndParent 父窗口句柄
     * @returns 返回宿主窗口的引用
     */
    public BuildWindowCore(hwndParent: number): { ref: any, handle: number } {
        this.win32App.HostInTo(hwndParent);
        return {
            ref: this,
            handle: this.win32App.AppMainFormHandle
        };
    }

    /**
     * 销毁宿主窗口
     * @param hwnd 窗口引用
     */
    public DestroyWindowCore(hwnd: { ref: any, handle: number }): void {
        this.win32App.DestroyWindow();
    }

    /**
     * 键盘焦点丢失事件处理
     */
    public OnLostKeyboardFocus(): void {
        this.win32App.SetFocus();
    }
}