// namespace ExcelFuntion {
//     // 模拟GetWindowThreadProcessId函数
//     function GetWindowThreadProcessId(hWnd: number, lpdwProcessId: { value: number }): number {
//         // 这里只是模拟，实际需要根据具体情况实现
//         lpdwProcessId.value = 0;
//         return 0;
//     }

//     // 杀死Excel进程
//     function KillSpecialExcel(mObjExcel: Application): void {
//         try {
//             if (!mObjExcel) return;
//             const lpdwProcessId = { value: 0 };
//             GetWindowThreadProcessId(mObjExcel.Hwnd, lpdwProcessId);
//             Process.getProcessById(lpdwProcessId.value).kill();
//         } catch (ex) {
//             // Console.WriteLine("Delete Excel Process Error:" + ex.Message);
//         }
//     }

//     // 简单导出Excel文件
//     function ExportSimpleExcel(dt: DataTable, outputFile: string, groupColumn: string, sheetPrefixName: string): void {
//         if (!dt || dt.rows.length === 0) return;
//         const xlApp = new Application();
//         xlApp.Visible = false;
//         xlApp.DisplayAlerts = false;
//         const workbooks = xlApp.Workbooks;
//         const workbook = workbooks.Add(XlWBATemplate.xlWBATWorksheet);
//         if (groupColumn && dt.columns.includes(groupColumn)) {
//             const result = dt.rows.reduce((acc, dr) => {
//                 const key = dr[groupColumn].toString();
//                 if (!acc[key]) {
//                     acc[key] = [];
//                 }
//                 acc[key].push(dr);
//                 return acc;
//             }, {} as { [key: string]: any[] });
//             for (const key in result) {
//                 const rows = result[key];
//                 const rowCount = rows.length;
//                 const colCount = dt.columns.length;
//                 const worksheet = workbook.Worksheets.Add();
//                 worksheet.Name = key;
//                 for (let i = 0; i < dt.columns.length; i++) {
//                     worksheet.Cells[1][i + 1] = dt.columns[i].ColumnName;
//                 }
//                 for (let j = 0; j < rowCount; j++) {
//                     for (let k = 0; k < colCount; k++) {
//                         worksheet.Cells[j + 2][k + 1] = rows[j][k].toString();
//                     }
//                 }
//             }
//         } else {
//             const worksheet = workbook.Worksheets.Add();
//             worksheet.Name = sheetPrefixName;
//             for (let i = 0; i < dt.columns.length; i++) {
//                 worksheet.Cells[1][i + 1] = dt.columns[i].ColumnName;
//             }
//             for (let r = 0; r < dt.rows.length; r++) {
//                 for (let i = 0; i < dt.columns.length; i++) {
//                     // 前加单引号设置单元格格式为文本
//                     worksheet.Cells[r + 2][i + 1] = "'" + dt.rows[r][i].toString();
//                 }
//             }
//         }
//         try {
//             workbook.Saved = true;
//             workbook.SaveAs(outputFile, null, null, null, null, null, XlSaveAsAccessMode.xlExclusive, null, null, null, null);
//         } catch (e) {
//             throw e;
//         } finally {
//             try {
//                 workbook.Close(true, null, null);
//                 xlApp.Workbooks.Close();
//                 xlApp.Application.Quit();
//                 xlApp.Quit();
//                 KillSpecialExcel(xlApp);
//             } catch { }
//             // 模拟GC.Collect()
//             // 在TypeScript中，垃圾回收由JavaScript引擎自动处理
//         }
//     }

//     // DataBox数据导出Excel文档
//     function ExportSimpleExcelDataBox(databox: DataBox, groupColumn: string = null, sheetPrefixName: string = "sheet"): void {
//         const saveDialog = new SaveFileDialog();
//         saveDialog.FileName = "DataBoxToExcel";
//         saveDialog.showDialog();
//         const outputFile = saveDialog.FileName;
//         if (outputFile.indexOf(":") < 0) return; // 被点了取消
//         ExportSimpleExcel(databox.DataSource, outputFile, groupColumn, sheetPrefixName);
//     }

//     // 根据DataTable导出Excel
//     function ExportExcelByDataTable(table: DataTable, outputFile: string, groupColumn: string = null, sheetPrefixName: string = "sheet"): void {
//         if (table) {
//             const a = () => {
//                 ExportSimpleExcel(table, outputFile, groupColumn, sheetPrefixName);
//             };
//             a();
//             // 这里C#的异步调用在TypeScript中可以使用异步函数和Promise替代
//             // 原代码中异步调用处理比较简单，这里直接同步执行
//         }
//     }

//     // 导出到excel（NPOI版）
//     function ExportToExcel(dataAll: DataTable, outputFile: string): void {
//         const filePath = outputFile;
//         const last = filePath.lastIndexOf(".");
//         const ExcelType = filePath.substring(last + 1);
//         const fs = new FileStream(filePath, "create", "write");
//         const fc = NPOIHelper.CreateFactory(ExcelType);
//         const source = fc.CreateExcel().DataTableToExcel(dataAll);
//         if (source && source.length > 0) {
//             fs.write(source, 0, source.length);
//             fs.flush();
//             return;
//         }
//     }

//     // 以弹出框的形式将DataTable倒入Excel（NPOI版）
//     function ExportToExcelDataTable(dt: DataTable): boolean {
//         let IsFild = true;
//         if (!dt) {
//             return false;
//         }
//         const saveDialog = new SaveFileDialog();
//         saveDialog.DefaultExt = "xlsx";
//         saveDialog.Filter = "Excel文件(*.xlsx,*.xls)|*.xlsx;*.xls";
//         saveDialog.FileName = "Excel";
//         saveDialog.onFileOk = (s, a) => {
//             const fs = new FileStream(saveDialog.FileName, "create", "write");
//             const arry = saveDialog.FileName.split('.');
//             const source = NPOIHelper.CreateFactory(arry[arry.length - 1]).CreateExcel().DataTableToExcel(dt);
//             if (source && source.length > 0) {
//                 fs.write(source, 0, source.length);
//                 fs.flush();
//                 IsFild = true;
//                 return;
//             }
//         };
//         saveDialog.showDialog();
//         return IsFild;
//     }

//     // 以路径的形式将DataSet倒入Excel（NPOI版）
//     function DataSetToExcle(ds: DataSet, filePath: string): boolean {
//         if (!ds || ds.tables.length <= 0) {
//             return false;
//         }
//         const arryOther = filePath.split('\\');
//         if (!arryOther[arryOther.length - 1]) {
//             filePath = filePath + "Excel";
//         }
//         let ExcelType = "xlsx";
//         const arry = filePath.split('.');
//         if (arry[arry.length - 1] === "xlsx" || arry[arry.length - 1] === "xls") {
//             ExcelType = arry[arry.length - 1];
//         } else {
//             filePath = filePath + ".xlsx";
//         }
//         if (!filePath) {
//             return false;
//         }
//         if (File.exists(filePath)) {
//             if (MessageBox.show("文件保存位置已存在该文件，是否覆盖？", "警告", "YesNo") === "No") {
//                 return false;
//             }
//         }
//         const fs = new FileStream(filePath, "create", "write");
//         const source = NPOIHelper.CreateFactory(ExcelType).CreateExcel().DataSetToExcel(ds);
//         if (source && source.length > 0) {
//             fs.write(source, 0, source.length);
//             fs.flush();
//             return true;
//         }
//         return false;
//     }

//     // 以弹出框的形式将DataSet倒入Excel（NPOI版）
//     function DataSetToExcleDataSet(ds: DataSet): boolean {
//         let IsFild = true;
//         if (!ds || ds.tables.length <= 0) {
//             return false;
//         }
//         const saveDialog = new SaveFileDialog();
//         saveDialog.DefaultExt = "xlsx";
//         saveDialog.Filter = "Excel文件(*.xlsx,*.xls)|*.xlsx;*.xls";
//         saveDialog.FileName = "Excel";
//         saveDialog.onFileOk = (s, a) => {
//             const fs = new FileStream(saveDialog.FileName, "create", "write");
//             const arry = saveDialog.FileName.split('.');
//             const source = NPOIHelper.CreateFactory(arry[arry.length - 1]).CreateExcel().DataSetToExcel(ds);
//             if (source && source.length > 0) {
//                 fs.write(source, 0, source.length);
//                 fs.flush();
//                 IsFild = true;
//                 return;
//             }
//         };
//         saveDialog.showDialog();
//         return IsFild;
//     }

//     // 读取模板文件导出Excel文件
//     function ExportTemplateExcel(databox: DataBox, top: number, left: number, groupColumn: string = null, sheetPrefixName: string = "Sheet"): void {
//         const open = new OpenFileDialog();
//         open.Filter = "xls files (*.xls)|*.xls|xlsx files (*.xlsx)|*.xlsx";
//         open.showDialog();
//         const openFileName = open.FileName;
//         if (openFileName.indexOf(":") < 0) return;
//         const saveDialog = new SaveFileDialog();
//         saveDialog.FileName = "DataBoxToExcel";
//         saveDialog.showDialog();
//         const saveFileName = saveDialog.FileName;
//         if (saveFileName.indexOf(":") < 0) return;
//         DataTableToExcel(databox.DataSource, top, left, openFileName, saveFileName, groupColumn, sheetPrefixName);
//     }

//     // 从DataTable导出到Excel
//     function DataTableToExcel(dt: DataTable, top: number, left: number, templetFile: string, outputFile: string, groupColumn: string, sheetPrefixName: string): void {
//         if (!dt || dt.rows.length === 0) return;
//         const app = new Application();
//         app.Visible = false;
//         app.DisplayAlerts = false;
//         const workBook = app.Workbooks.Open(templetFile, null, null, null, null, null, null, null, null, null, null, null, null);
//         const workSheet = workBook.Sheets[1] as Worksheet;
//         if (groupColumn && dt.columns.includes(groupColumn)) {
//             const result = dt.rows.reduce((acc, dr) => {
//                 const key = dr[groupColumn].toString();
//                 if (!acc[key]) {
//                     acc[key] = [];
//                 }
//                 acc[key].push(dr);
//                 return acc;
//             }, {} as { [key: string]: any[] });
//             const enumerable = Object.keys(result).map(key => ({ key, rows: result[key] }));
//             for (let i = 0; i < enumerable.length - 1; i++) {
//                 for (let j = 1; j < workBook.Sheets.length + 1; j++) {
//                     workBook.Sheets[j].Name = j.toString();
//                 }
//                 workSheet.Copy(null, workBook.Sheets[workBook.Sheets.length]);
//             }
//             for (let i = 0; i < enumerable.length; i++) {
//                 const rowCount = enumerable[i].rows.length;
//                 const rows = enumerable[i].rows;
//                 const colCount = dt.columns.length;
//                 const newworksheet = workBook.Sheets[i + 1] as Worksheet;
//                 newworksheet.Name = enumerable[i].key;
//                 for (let j = 0; j < rowCount; j++) {
//                     for (let k = 0; k < colCount; k++) {
//                         newworksheet.Cells[top + j][left + k] = rows[j][k].toString();
//                     }
//                 }
//             }
//         } else {
//             const sheet = workBook.Worksheets[1] as Worksheet;
//             sheet.Name = sheetPrefixName;
//             for (let j = 0; j < dt.rows.length; j++) {
//                 for (let k = 0; k < dt.columns.length; k++) {
//                     sheet.Cells[top + j][left + k] = dt.rows[j][k].toString();
//                 }
//             }
//         }
//         try {
//             workBook.SaveAs(outputFile, null, null, null, null, null, XlSaveAsAccessMode.xlExclusive, null, null, null, null);
//         } catch (e) {
//             throw e;
//         } finally {
//             try {
//                 workBook.Close(null, null, null);
//                 app.Workbooks.Close();
//                 app.Application.Quit();
//                 app.Quit();
//                 KillSpecialExcel(app);
//             } catch { }
//             // 模拟GC.Collect()
//             // 在TypeScript中，垃圾回收由JavaScript引擎自动处理
//         }
//     }

//     // 自定义单元格样式导出Excel文件
//     function DataTableToExcelDataBox(databox: DataBox, selectForm: any): void {
//         if (databox.DataSource) {
//             let fileSaved = false;
//             const saveDialog = new SaveFileDialog();
//             saveDialog.DefaultExt = "xls";
//             saveDialog.Filter = "Excel文件|*.xls";
//             saveDialog.FileName = "Excel";
//             saveDialog.showDialog();
//             const saveFileName = saveDialog.FileName;
//             if (saveFileName.indexOf(":") < 0) return; // 被点了取消
//             const xlApp = new Application();
//             if (!xlApp) {
//                 MessageBox.show("无法启动Excel，可能您未安装Excel");
//                 return;
//             }
//             const workbook = xlApp.Workbooks.Add(true);
//             const worksheet = workbook.Worksheets[1] as Worksheet;
//             let range: Range;
//             let rangeCon: Range;
//             let colIndex = 0;
//             let RowIndex = 0;
//             const colCount = databox.DataSource.columns.length;
//             const RowCount = databox.DataSource.rows.length;
//             worksheet.Name = selectForm.SheetName.Text === "" ? "sheet" : selectForm.SheetName.Text;
//             const objData = new Array(RowCount + 1).fill(0).map(() => new Array(colCount).fill(0));
//             for (RowIndex = 0; RowIndex < RowCount; RowIndex++) {
//                 for (colIndex = 0; colIndex < colCount; colIndex++) {
//                     objData[RowIndex][colIndex] = databox.DataSource.rows[RowIndex][colIndex];
//                 }
//             }
//             range = worksheet.Range(worksheet.Cells[1][1], worksheet.Cells[1][colCount]);
//             range.MergeCells = true;
//             range.RowHeight = 38;
//             range.Font.Bold = selectForm.TitBold.GetSelectedValue();
//             range.Font.Size = selectForm.TitFontSize.GetSelectedKey();
//             range.Font.Name = selectForm.TitFontStyle.GetSelectedValue();
//             range.Font.ColorIndex = selectForm.TitFontColor.GetSelectedValue();
//             xlApp.ActiveCell.FormulaR1C1 = selectForm.TitelName.Text;
//             xlApp.Cells.HorizontalAlignment = "xlCenter";
//             range = worksheet.Range(worksheet.Cells[2][1], worksheet.Cells[2][colCount]);
//             range.MergeCells = true;
//             range.Value2 = "日期范围：" + selectForm.StartDate.Text + " 到 " + selectForm.EndDate.Text + "，查询条件：" + selectForm.SelectTerm.Text;
//             range.Cells.HorizontalAlignment = "xlLeft";
//             for (let i = 0; i < databox.DataSource.columns.length; i++) {
//                 range = worksheet.Range(worksheet.Cells[3][i + 1], worksheet.Cells[3][i + 1]);
//                 range.Font.Bold = selectForm.TopBold.GetSelectedValue();
//                 range.Font.Size = selectForm.TopFontSize.GetSelectedKey();
//                 range.Font.Name = selectForm.TopFontStyle.GetSelectedValue();
//                 range.Font.ColorIndex = selectForm.TopFontColor.GetSelectedValue();
//                 range.AroundBorders();
//                 range.Value2 = databox.DataSource.columns[i].Caption;
//             }
//             for (let i = 4; i < RowCount + 3; i++) {
//                 for (let j = 0; j < databox.DataSource.columns.length; j++) {
//                     range = worksheet.Range(worksheet.Cells[i][j + 1], worksheet.Cells[i][j + 1]);
//                     if (j === 0 && i === 4) {
//                         range.Value2 = "合计(人数：" + (RowCount - 2) + ")";
//                         range.Font.Bold = true;
//                         range.Font.ColorIndex = 3;
//                     }
//                     range.Cells.HorizontalAlignment = "xlLeft";
//                     range.AroundBorders();
//                 }
//             }
//             range = worksheet.Range(worksheet.Cells[5][1], worksheet.Cells[RowCount + 2][colCount]);
//             range.Value2 = objData;
//             let startRow = selectForm.StartRow.Text.GetStringToNum() < 5 ? 5 : selectForm.StartRow.Text.GetStringToNum();
//             let startCol = selectForm.StartCol.Text.GetStringToNum() === 0 ? 1 : selectForm.StartCol.Text.GetStringToNum();
//             let endRow = selectForm.EndRow.Text.GetStringToNum() === 0 ? RowCount + 3 : selectForm.EndRow.Text.GetStringToNum();
//             let endCol = selectForm.EndCol.Text.GetStringToNum() === 0 ? databox.DataSource.columns.length : selectForm.EndCol.Text.GetStringToNum();
//             rangeCon = worksheet.Range(worksheet.Cells[startRow][startCol], worksheet.Cells[endRow][endCol]);
//             rangeCon.Font.Bold = selectForm.ConBold.GetSelectedValue();
//             rangeCon.Font.Size = selectForm.ConFontSize.GetSelectedKey();
//             rangeCon.Font.Name = selectForm.ConFontStyle.GetSelectedValue();
//             rangeCon.Font.ColorIndex = selectForm.ConFontColor.GetSelectedValue();
//             worksheet.Columns.EntireColumn.AutoFit();
//             if (saveFileName) {
//                 try {
//                     workbook.Saved = true;
//                     workbook.SaveCopyAs(saveFileName);
//                     fileSaved = true;
//                 } catch (ex) {
//                     fileSaved = false;
//                     MessageBox.show("导出文件时出错,文件可能正被打开！\n" + ex.Message);
//                 }
//             } else {
//                 fileSaved = false;
//             }
//             xlApp.Quit();
//             // 模拟GC.Collect()
//             // 在TypeScript中，垃圾回收由JavaScript引擎自动处理
//             const dateEnd = new Date();
//             MessageBox.show("导出成功");
//             if (fileSaved && File.exists(saveFileName)) {
//                 Process.start(saveFileName);
//             }
//         } else {
//             MessageBox.show("没有数据需要导出");
//             return;
//         }
//     }

//     // Databox分组导出Excel
//     function DataboxToExcelGroupBy(databox: DataBox): void {
//         if (databox.DataSource) {
//             const SelectForm = new SelectFrm();
//             SelectForm.showDialog();
//             if (SelectForm.Flag.Text !== "1") {
//                 return;
//             }
//             if (SelectForm.DataSave.GetSelectedValue() === "0") {
//                 databox.DataTableToExcel(SelectForm);
//                 return;
//             }
//             let fileSaved = false;
//             const saveDialog = new SaveFileDialog();
//             saveDialog.DefaultExt = "xls";
//             saveDialog.Filter = "Excel文件|*.xls";
//             saveDialog.FileName = "Excel";
//             saveDialog.showDialog();
//             const saveFileName = saveDialog.FileName;
//             if (saveFileName.indexOf(":") < 0) return; // 被点了取消
//             const xlApp = new Application();
//             const workbook = xlApp.Workbooks.Add(true);
//             let worksheet: Worksheet;
//             let range: Range;
//             let rangeCoun: Range;
//             let rownum = 0;
//             const byGroup = SelectForm.SheetName.Text === "" ? 0 : SelectForm.SheetName.Text.GetStringToNum();
//             const result = databox.DataSource.rows.reduce((acc, dr) => {
//                 const key = dr[byGroup].toString();
//                 if (!acc[key]) {
//                     acc[key] = [];
//                 }
//                 acc[key].push(dr);
//                 return acc;
//             }, {} as { [key: string]: any[] });
//             for (const key in result) {
//                 const ig = { key, rows: result[key] };
//                 rownum = 3;
//                 worksheet = xlApp.Worksheets.Add();
//                 worksheet.Name = ig.key;
//                 range = worksheet.Range(worksheet.Cells[1][1], worksheet.Cells[1][databox.DataSource.columns.length]);
//                 range.MergeCells = true;
//                 range.RowHeight = 38;
//                 range.Font.Bold = SelectForm.TitBold.GetSelectedValue();
//                 range.Font.Size = SelectForm.TitFontSize.GetSelectedKey();
//                 range.Font.Name = SelectForm.TitFontStyle.GetSelectedValue();
//                 range.Font.ColorIndex = SelectForm.TitFontColor.GetSelectedValue();
//                 xlApp.ActiveCell.FormulaR1C1 = SelectForm.TitelName.Text;
//                 xlApp.Cells.HorizontalAlignment = "xlCenter";
//                 range = worksheet.Range(worksheet.Cells[2][1], worksheet.Cells[2][databox.DataSource.columns.length]);
//                 range.MergeCells = true;
//                 range.Value2 = "日期范围：" + SelectForm.StartDate.Text + " 到 " + SelectForm.EndDate.Text + "，查询条件：" + SelectForm.SelectTerm.Text;
//                 range.Cells.HorizontalAlignment = "xlLeft";
//                 for (let i = 0; i < databox.DataSource.columns.length; i++) {
//                     range = worksheet.Range(worksheet.Cells[3][i + 1], worksheet.Cells[3][i + 1]);
//                     range.Font.Bold = SelectForm.TopBold.GetSelectedValue();
//                     range.Font.Size = SelectForm.TopFontSize.GetSelectedKey();
//                     range.Font.Name = SelectForm.TopFontStyle.GetSelectedValue();
//                     range.Font.ColorIndex = SelectForm.TopFontColor.GetSelectedValue();
//                     range.AroundBorders();
//                     range.Value2 = databox.DataSource.columns[i].Caption;
//                 }
//                 let startRow = SelectForm.StartRow.Text.GetStringToNum() < 5 ? 5 : SelectForm.StartRow.Text.GetStringToNum();
//                 let startCol = SelectForm.StartCol.Text.GetStringToNum() === 0 ? 1 : SelectForm.StartCol.Text.GetStringToNum();
//                 let endRow = 0;
//                 let endCol = 0;
//                 for (const drr of ig.rows) {
//                     rownum++;
//                     for (let j = 0; j < drr.ItemArray.length; j++) {
//                         range = worksheet.Range(worksheet.Cells[rownum + 1][j + 1], worksheet.Cells[rownum + 1][j + 1]);
//                         range.Value2 = drr.ItemArray[j].toString();
//                         range.Cells.HorizontalAlignment = "xlLeft";
//                         range.AroundBorders();
//                     }
//                     endRow = SelectForm.EndRow.Text.GetStringToNum() === 0 ? rownum + 1 : SelectForm.EndRow.Text.GetStringToNum();
//                     endCol = SelectForm.EndCol.Text.GetStringToNum() === 0 ? drr.ItemArray.length : SelectForm.EndCol.Text.GetStringToNum();
//                 }
//                 rangeCoun = worksheet.Range(worksheet.Cells[startRow][startCol], worksheet.Cells[endRow][endCol]);
//                 rangeCoun.Font.Bold = SelectForm.ConBold.GetSelectedValue();
//                 rangeCoun.Font.Size = SelectForm.ConFontSize.GetSelectedKey();
//                 rangeCoun.Font.Name = SelectForm.ConFontStyle.GetSelectedValue();
//                 rangeCoun.Font.ColorIndex = SelectForm.ConFontColor.GetSelectedValue();
//                 for (let i = 0; i < databox.DataSource.columns.length; i++) {
//                     range = worksheet.Range(worksheet.Cells[4][i + 1], worksheet.Cells[4][i + 1]);
//                     if (i === 0) {
//                         range.Value2 = "合计(人数：" + (rownum - 3) + ")";
//                         range.Font.Bold = true;
//                         range.Font.ColorIndex = 3;
//                     }
//                     range.Cells.HorizontalAlignment = "xlLeft";
//                     range.AroundBorders();
//                 }
//                 worksheet.Columns.EntireColumn.AutoFit();
//             }
//             if (saveFileName) {
//                 try {
//                     workbook.Saved = true;
//                     workbook.SaveCopyAs(saveFileName);
//                     fileSaved = true;
//                     xlApp.Workbooks.Close();
//                     xlApp.Application.Quit();
//                     // 释放资源
//                     // 在TypeScript中，对象的释放由JavaScript引擎自动处理
//                 } catch (ex) {
//                     fileSaved = false;
//                     MessageBox.show("导出文件时出错,文件可能正被打开！\n" + ex.Message);
//                     return;
//                 }
//             } else {
//                 fileSaved = false;
//             }
//             // 模拟GC.Collect()
//             // 在TypeScript中，垃圾回收由JavaScript引擎自动处理
//             MessageBox.show("导出成功");
//             if (fileSaved && File.exists(saveFileName)) {
//                 Process.start(saveFileName);
//             }
//         } else {
//             MessageBox.show("没有数据需要导出");
//             return;
//         }
//     }

//     // 为Excel范围添加外边框
//     function AroundBorders(range: Range): void {
//         range.Borders[XlBordersIndex.xlEdgeTop].LineStyle = XlLineStyle.xlContinuous;
//         range.Borders[XlBordersIndex.xlEdgeLeft].LineStyle = XlLineStyle.xlContinuous;
//         range.Borders[XlBordersIndex.xlEdgeRight].LineStyle = XlLineStyle.xlContinuous;
//         range.Borders[XlBordersIndex.xlEdgeBottom].LineStyle = XlLineStyle.xlContinuous;
//     }

//     // 导入Excel文件
//     function ImportSimpleExcel(databox: DataBox, columnNames: string[], startRow: number = 0): void {
//         const ofd = new OpenFileDialog();
//         ofd.Title = "Excel文件";
//         ofd.FileName = "";
//         ofd.InitialDirectory = Environment.getFolderPath(Environment.SpecialFolder.MyDocuments);
//         ofd.Filter = "Excel文件(*.xls)|*.xls|Excel文件(*.xlsx)|*.xlsx|所有文件(*.*)|*.*";
//         ofd.ValidateNames = true;
//         ofd.CheckFileExists = true;
//         ofd.CheckPathExists = true;
//         ofd.Multiselect = true;
//         const result = ofd.showDialog();
//         if (!result) return;
//         const datastr = ImportSimpleExcel(ofd.FileNames, columnNames.length, startRow);
//         databox.DataBinding(datastr, columnNames);
//     }

//     // 导入Excel文件辅助方法
//     function ImportSimpleExcel(filePaths: string[], columnsCount: number, startRow: number): string {
//         let stringData = "";
//         for (const filePath of filePaths) {
//             const ds = EcxelToDataSet(filePath);
//             for (let i = 0; i < ds.tables.length; i++) {
//                 if (startRow >= ds.tables[i].rows.length) continue;
//                 const sb = [];
//                 sb.push("|");
//                 if (columnsCount <= ds.tables[i].columns.length) {
//                     for (let t = startRow; t < ds.tables[i].rows.length; t++) {
//                         for (let j = 0; j < columnsCount; j++) {
//                             sb.push(ds.tables[i].rows[t][j]);
//                             sb.push("|");
//                         }
//                         sb.push("\n|");
//                     }
//                 } else {
//                     for (let t = startRow; t < ds.tables[i].rows.length; t++) {
//                         for (let j = 0; j < ds.tables[i].columns.length; j++) {
//                             sb.push(ds.tables[i].rows[t][j]);
//                             sb.push("|");
//                         }
//                         for (let j = 0; j < columnsCount - ds.tables[i].columns.length; j++) {
//                             sb.push("|");
//                         }
//                         sb.push("\n|");
//                     }
//                 }
//                 stringData = sb.join("");
//             }
//         }
//         return stringData;
//     }

//     // Excel文件转DataSet
//     function EcxelToDataSet(filePath: string): DataSet {
//         const extension = Path.extname(filePath);
//         let strConn = "";
//         if (extension === ".xls") {
//             strConn = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source = " + filePath + ";Extended Properties ='Excel 8.0;HDR=NO;IMEX=1'";
//         } else if (extension === ".xlsx") {
//             strConn = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source = " + filePath + ";Extended Properties ='Excel 12.0;HDR=NO;IMEX=1'";
//         } else {
//             MessageBox.show("不支持所选的数据格式！");
//         }
//         const conn = new OleDbConnection(strConn);
//         conn.open();
//         const dt = conn.getOleDbSchemaTable(OleDbSchemaGuid.Tables, null);
//         const ds = new DataSet();
//         for (const row of dt.rows) {
//             const strExcel = "select  * from   [" + row["TABLE_NAME"].toString() + "]";
//             const myCommand = new OleDbDataAdapter(strExcel, strConn);
//             myCommand.fill(ds);
//         }
//         return ds;
//     }

//     // 以路径的形式将Excel转为DataTable（NPOI版本）
//     function ExcelToDataTable(filePath: string, sheetIndex: number = 0): DataTable {
//         if (!File.exists(filePath)) {
//             MessageBox.show("文件不存在！");
//             return null;
//         }
//         const arry = filePath.split('.');
//         if (arry[arry.length - 1]!== "xls" && arry[arry.length - 1]!== "xlsx") {
//             MessageBox.show("文件类型需要为xls或xlsx！");
//             return null;
//         }
//         const dt = new DataTable();
//         return NPOIHelper.CreateFactory(arry[arry.length - 1]).CreateExcel().ExcelToTable(filePath, sheetIndex);
//     }

//     // 以选择文件的形式将Excel转为DataTable（NPOI版本）
//     function ExcelToDataTableSelect(sheetIndex: number = 0): DataTable {
//         const dt = new DataTable();
//         const opd = new OpenFileDialog();
//         opd.Title = "Excel文件";
//         opd.FileName = "";
//         opd.InitialDirectory = Environment.getFolderPath(Environment.SpecialFolder.MyDocuments);
//         opd.Filter = "Excel文件(*.xlsx,*.xls)|*.xlsx;*.xls";
//         opd.ValidateNames = true;
//         opd.CheckFileExists = true;
//         opd.CheckPathExists = true;
//         opd.onFileOk = (s, a) => {
//             const arry = opd.FileName.split('.');
//             dt = NPOIHelper.CreateFactory(arry[arry.length - 1]).CreateExcel().ExcelToTable(opd.FileName, sheetIndex);
//             dt.TableName = opd.FileName;
//             return;
//         };
//         opd.showDialog();
//         return dt;
//     }

//     // 导出txt文本
//     function ExportTxt(databox: DataBox): void {
//         const dialogOpenFile = new SaveFileDialog();
//         dialogOpenFile.DefaultExt = "txt";
//         dialogOpenFile.AddExtension = true;
//         dialogOpenFile.Filter = "文本文档(*.txt)|.txt|所有文件 (*.*)|*.*";
//         dialogOpenFile.OverwritePrompt = true;
//         dialogOpenFile.FileName = "txt1";
//         dialogOpenFile.CheckPathExists = true;
//         dialogOpenFile.Title = "数据保存为*.txt";
//         if (!dialogOpenFile.showDialog()) return;
//         const fileName = dialogOpenFile.FileName;
//         ExportTxt(databox.DataSource, fileName);
//     }

//     // 导出txt文本辅助方法
//     function ExportTxt(dt: DataTable, fileName: string): void {
//         try {
//             const sb = [];
//             for (const row of dt.rows) {
//                 for (const item of row.ItemArray) {
//                     sb.push(item);
//                     sb.push(" ");
//                 }
//                 sb.push("\n");
//             }
//             const stream = File.openWrite(fileName);
//             const writer = new StreamWriter(stream);
//             writer.write(sb.join(""));
//             writer.close();
//         } catch (ex) {
//             MessageBox.show(ex.Message, "Simple Edeitor", "OK", "Exclamation");
//         }
//     }

//     // 字符串转化为数字
//     function GetStringToNum(str: string): number {
//         let intResult = 0;
//         const r = /^[0-9]*$/;
//         if (str.trim().length!== 0) {
//             if (!r.test(str)) {
//                 return -1;
//             }
//             return parseInt(str);
//         }
//         return intResult;
//     }
// }

// export default ExcelFuntion;
