// 这里假设 Message、IPage、ComboBox 等类型已经在其他文件中定义
// 并且已经通过 import 导入
// 由于缺少具体类型定义，下面部分类型使用 any 代替
import Message from "@/views/front/develop/Communication/Message";
import LoginUserInfo from "@/views/front/platfrom/common/RunningParameters/LoginUserInfo";
import UserVariable from "../Variables/UserVariable";
import { LoginUserInfoExt } from "../Variables/LoginUserInfoExt";
import { TradeManagerHandle } from "../../ServiceProxy.Ext/ServiceHelper/TradeManagerHandle";
import { MainPageManager } from "../TradeInterface/MainPage/MainPageManager";
import { PlatformManagerHandle } from "../../ServiceProxy.Ext/ServiceHelper/PlatformManagerHandle";
// 将数字串转换成中文数字串
const NumChineseCharacter = ["零", "壹", "贰", "叁", "肆", "伍", "陆", "柒", "捌", "玖"];
const SimpleNumChineseCharacter = ["零", "一", "二", "三", "四", "五", "六", "七", "八", "九"];
const surnameDict = {
    "艾": "AI", "爱新觉罗": "AIXINJUELUO", "安": "AN", "敖": "AO", "巴": "BA", "白": "BAI", "百里": "BAILI", "柏": "BO", "班": "BAN", "包": "BAO", "鲍": "BAO", "暴": "BAO", "贝": "BEI", "贲": "BEN", "毕": "BI", "碧鲁": "BILU", "边": "BIAN", "卞": "BIAN", "别": "BIE", "邴": "BING", "伯赏": "BOSHANG", "博尔济锦": "BOERJIJIN", "薄": "BO", "卜": "BU", "步": "BU", "蔡": "CAI", "苍": "CANG", "藏": "ZANG", "操": "CAO", "曹": "CAO", "岑": "CEN", "查": "ZHA", "柴": "CHAI", "昌": "CHANG", "长孙": "ZHANGSUN", "常": "CHANG", "畅": "CHANG", "晁": "CHAO", "巢": "CHAO", "车": "CHE", "陈": "CHEN", "谌": "CHEN", "成": "CHENG", "承": "CHENG", "程": "CHENG", "池": "CHI", "充": "CHONG", "仇": "QIU", "初": "CHU", "储": "CHU", "楚": "CHU", "褚": "CHU", "淳于": "CHUNYU", "从": "CONG", "崔": "CUI", "戴": "DAI", "单": "SHAN", "单于": "CHANYU", "澹台": "TANTAI", "党": "DANG", "刀": "DAO", "道": "DAO", "邓": "DENG", "狄": "DI", "第五": "DIWU", "刁": "DIAO", "丁": "DING", "东": "DONG", "东方": "DONGFANG", "东郭": "DONGGUO", "东门": "DONGMEN", "董": "DONG", "都": "DU", "钭": "TOU", "窦": "DOU", "独孤": "DUGU", "堵": "DU", "杜": "DU", "端木": "DUANMU", "段": "DUAN", "段干": "DUAN4GAN", "多": "DUO", "额尔德雨": "EERDEYU", "鄂": "E", "法": "FA", "藩": "FAN", "樊": "FAN", "范": "FAN", "方": "FANG", "房": "FANG", "费": "FEI", "丰": "FENG", "封": "FENG", "酆": "FENG", "冯": "FENG", "逢": "FENG", "凤": "FENG", "伏": "FU", "扶": "FU", "洑": "FU", "浮": "FU", "符": "FU", "傅": "FU", "富": "FU4", "富察": "FUCHA", "盖": "GAI", "干": "GAN", "甘": "GAN", "刚": "GANG", "高": "GAO", "郜": "GAO", "戈": "GE", "葛": "GE", "庚": "GENG", "耿": "GENG", "弓": "GONG", "公": "GONG", "公良": "GONGLIANG", "公孙": "GONGSUN", "公西": "GONGXI", "公羊": "GONGYANG", "公冶": "GONGYE", "宫": "GONG", "龚": "GONG", "巩": "GONG", "贡": "GONG", "勾": "GOU", "缑亢": "GOUKANG", "苟": "GOU", "辜": "GU", "古": "GU3", "谷": "GU3", "谷粱": "GULIANG", "顾": "GU", "关": "GUAN", "官": "GUAN", "冠": "GUAN", "管": "GUAN", "光": "GUANG", "广": "AN", "归": "GUI", "归海": "GUIHAI", "妫": "GUI", "桂": "GUI", "郭": "GUO", "国": "GUO", "过": "GUO", "海": "HAI", "韩": "HAN", "杭": "HANG", "郝": "HAO", "何": "HE", "和": "HE", "贺": "HE", "赫": "HE4", "赫连": "HELIAN", "赫舍里": "HESHELI", "衡": "HENG", "弘": "HONG", "红": "HONG", "洪": "HONG", "侯": "HOU", "后": "HOU", "後": "HOU", "呼延": "HUYAN", "胡": "HU", "户": "HU", "扈": "HU", "花": "HUA", "华": "HUA", "滑": "HUA", "怀": "HUAI", "桓": "HUAN", "宦": "HUAN", "皇甫": "HUANGFU", "黄": "HUANG", "惠": "HUI", "荤": "HUN", "霍": "HUO", "姬": "JI", "基": "JI", "嵇": "JI", "吉": "JI", "汲": "JI", "籍": "JI", "计": "JI", "纪": "JI", "季": "JI", "蓟": "JI", "暨": "JI", "冀": "JI", "夹谷": "JIAGU", "家": "JIA", "郏": "JIA", "贾": "JIA", "剪": "JIAN", "简": "JIAN", "蹇": "JIAN", "江": "JIANG", "姜": "JIANG", "蒋": "JIANG", "焦": "JIAO", "矫": "JIAO", "揭": "JIE", "解": "XIE", "金": "JIN", "晋": "JIN", "晋楚": "JINCHU", "靳": "JIN", "经": "JING", "荆": "JING", "井": "JING", "景": "JING", "咎": "JIU", "居": "JU", "鞠": "JU", "瞿": "QU", "觉尔察": "JUEERCHA", "卡": "KA", "堪": "KAN", "阚": "KAN", "康": "KANG", "柯": "KE", "空": "KONG", "孔": "KONG", "寇": "KOU", "库雅喇": "KUYALA", "蒯": "KUAI", "匡": "KUANG", "邝": "KUANG", "况": "KUANG", "况后": "KUANGHOU", "旷": "KUANG", "夔": "KUI", "来": "LAI", "赖": "LAI", "蓝": "LAN", "郎": "LANG", "劳": "LAO", "乐": "YUE", "乐正": "YUEZHENG", "雷": "LEI", "冷": "LENG", "黎": "LI", "李": "LI", "厉": "LI", "利": "LI", "励": "LI", "郦": "LI", "连": "LIAN", "廉": "LIAN", "梁": "LIANG", "梁丘": "LIANGQIU", "粱": "LIANG", "廖": "LIAO", "林": "LIN", "蔺": "LIN", "凌": "LING", "令狐": "LINGHU", "刘": "LIU", "留": "LIU", "柳": "LIU", "龙": "LONG", "隆": "LONG", "娄": "LOU", "楼": "LOU", "卢": "LU", "鲁": "LU", "陆": "LU", "逯": "LU", "鹿": "LU", "禄": "LU", "路": "LU", "闾丘": "LVQIU", "吕": "LV", "栾": "LUAN", "罗": "LUO", "骆": "LUO", "麻": "MA", "马": "MA", "麦": "MAI", "满": "MAN", "毛": "MAO", "茅": "MAO", "冒": "MAO", "梅": "MEI", "门": "MEN", "蒙": "MENG", "孟": "MENG", "糜": "MI", "米": "MI", "芈": "MI", "宓": "MI", "苗": "MIAO", "乜": "NIE", "闵": "MIN", "明": "MING", "谬": "MIU", "缪": "MIU", "莫": "MO", "墨哈": "MOHA", "牧": "MU", "睦": "MU", "慕": "MU", "慕容": "MURONG", "穆": "MU", "那": "NA", "那拉": "NALA", "纳喇": "NALA", "南": "NAN", "南宫": "NANGONG", "南门": "NANMEN", "讷殷富察": "NEYINFUCHA", "能": "NENG", "倪": "NI", "年爱": "NIANAI", "聂": "NIE", "宁": "NING", "牛": "NIU", "钮": "NIU", "钮祜禄": "NIUHULU", "农": "NONG", "欧": "OU", "欧阳": "OUYANG", "殴": "OU", "潘": "PAN", "庞": "PANG", "逄": "PANG", "裴": "PEI", "朋": "PENG", "彭": "PENG", "蓬": "PENG", "皮": "PI", "平": "PING", "蒲": "PU", "濮": "PU", "濮阳": "PUYANG", "朴": "PIAO", "浦": "PU", "戚": "QI", "漆": "QI", "漆雕": "QIDIAO", "亓官": "QIGUAN", "祁": "QI", "齐": "QI", "钱": "QIAN", "强": "QIANG", "乔": "QIAO", "谯笪": "QIAODA", "钦": "QIN", "秦": "QIN", "青": "QING", "卿": "QING", "清": "QING", "庆": "QING", "邛": "QIONG", "丘": "QIU", "邱": "QIU", "秋": "QIU", "求": "QIU", "裘": "QIU", "区": "OU", "曲": "QU", "屈": "QU", "麴": "QU", "璩": "QU", "全": "QUAN", "权": "QUAN2", "卻": "QUE", "阙": "QUE", "冉": "RAN", "壤驷": "RANGSI", "让": "RANG", "饶": "RAO", "任": "REN", "戎": "RONG", "荣": "RONG", "容": "RONG", "融": "RONG", "茹": "RU", "汝鄢": "RUYAN", "阮": "RUAN", "芮": "RUI", "撒哈拉": "SAHALA", "萨": "SA", "萨克达": "SAKEDA", "萨嘛喇": "SAMALA", "赛": "SAI", "桑": "SANG", "沙": "SHA", "山": "SHAN", "商": "SHANG1", "商牟": "SHANGMOU", "上官": "SHANGGUAN", "尚": "SHANG", "韶": "SHAO", "邵": "SHAO", "佘": "SHE", "佘佴": "SHEER", "厍": "SHE", "申": "SHEN", "申屠": "SHEN1TU", "沈": "SHEN", "慎": "SHEN", "生": "SHENG", "盛": "SHENG", "师": "SHI", "施": "SHI", "石": "SHI", "时": "SHI", "史": "SHI", "是": "SHI", "释": "SHI", "首": "SHOU", "寿": "SHOU", "殳": "SHU", "疏束": "SHUSHU", "舒": "SHU", "束": "SHU", "帅": "SHUAI", "双": "SHUANG", "水": "SHUI", "司": "SI", "司空": "SIKONG", "司寇": "SIKOU", "司马": "SIMA", "司徒": "SITU", "斯": "SI", "松": "SONG", "宋": "SONG", "苏": "SU", "宿": "SU", "粟": "SU", "隋": "SUI", "孙": "SUN", "索": "SUO", "他塔喇": "TATALA", "台": "TAI", "邰": "TAI", "太叔": "TAISHU", "泰": "TAI", "谈": "TAN", "覃": "QIN", "谭": "TAN", "汤": "TANG", "唐": "TANG", "陶": "TAO", "腾": "TENG", "滕": "TENG", "田": "TIAN", "通": "TONG", "同": "TONG", "佟": "TONG", "童": "TONG", "图门": "TUMEN", "涂": "TU", "涂钦": "TUQIN", "屠": "TU", "拓拔": "TUO4BA", "万": "WAN", "万俟": "MO4QI", "汪": "WANG", "王": "WANG", "危": "WEI", "微生": "WEISHENG", "韦": "WEI", "隗": "WEI", "卫": "WEI", "尉": "YU", "尉迟": "YU4CHI", "蔚": "WEI", "魏": "WEI", "温": "WEN", "文": "WEN", "闻": "WEN", "闻人": "WENREN", "问": "WEN", "翁": "WENG", "沃": "WO", "乌": "WU", "乌雅": "WUYA", "邬": "WU", "巫": "WU", "巫马": "WUMA", "毋": "WU", "吴": "WU", "吾": "WU", "伍": "WU", "武": "WU", "西门": "XIMEN", "郗": "XI", "奚": "XI", "习": "XI", "席": "XI", "喜塔腊": "XITALA", "郤": "XI", "夏": "XIA", "夏侯": "XIAHOU", "鲜": "XIAN", "鲜于": "XIANYU", "咸": "XIAN", "冼": "XIAN", "相": "XIANG", "相里": "XIANGLI", "向": "XIANG", "项": "XIANG", "萧": "XIAO", "肖": "XIAO", "谢": "XIE", "忻": "XIN", "辛": "XIN", "莘": "SHEN", "邢": "XING", "幸": "XING", "熊": "XIONG", "胥": "XU", "须": "XU", "徐": "XU", "许": "XU", "轩辕": "XUANYUAN", "宣": "XUAN", "薛": "XUE", "寻": "XUN", "荀": "XUN", "鄢": "YAN", "闫法": "YANFA", "严": "YAN", "言": "YAN", "言福": "YANFU", "阎": "YAN", "颜": "YAN", "晏": "YAN", "燕": "YAN", "羊": "YANG", "羊舌": "YANGSHE", "阳佟": "YANGTONG", "杨": "YANG", "仰": "YANG", "养": "YANG", "姚": "YAO", "业": "YE", "叶": "YE", "叶赫那拉": "YEHENALA", "叶赫那兰": "YEHENALAN", "伊": "YI", "伊雨根觉罗": "YIYUGENJUELUO", "衣": "YI", "依尔觉悟罗": "YIERJUELUO", "义": "YI", "易": "YI", "奕": "YI", "羿": "YI", "益": "YI", "阴": "YIN", "殷": "YIN", "银": "YIN", "尹": "YIN", "印": "YIN", "应": "YING", "英": "YING", "雍": "YONG", "尤": "YOU", "游": "YOU", "有": "YOU", "有琴": "YOUQIN", "酉": "YOU", "于": "YU", "余": "YU", "於": "YU", "鱼": "YU", "俞": "YU", "虞": "YU", "宇文": "YUWEN", "羽": "YU", "禹": "YU", "庾": "YU", "郁": "YU", "喻": "YU", "愈": "YU", "元": "YUAN", "袁": "YUAN", "岳": "YUE", "岳帅": "YUESHUAI", "越": "YUE", "云": "YUN", "恽": "YUN", "宰": "ZAI", "宰父": "ZAIFU", "昝": "ZAN", "臧": "ZANG", "迮": "ZE", "曾": "ZENG", "翟": "ZHAI", "詹": "ZHAN", "展": "ZHAN", "占": "ZHAN", "湛": "ZHAN", "张": "ZHANG", "章": "ZHANG", "章佳": "ZHANGJIA", "仉": "ZHANG", "仉督": "ZHANGDU", "招": "ZHAO", "赵": "ZHAO", "真": "ZHEN", "甄": "ZHEN", "郑": "ZHENG", "支": "ZHI", "植": "ZHI", "终": "ZHONG", "钟": "ZHONG", "钟离": "ZHONGLI", "仲": "ZHONG", "仲长": "ZHONGCHANG", "仲孙": "ZHONGSUN", "周": "ZHOU", "朱": "ZHU", "诸": "ZHU", "诸葛": "ZHUGE", "竹": "ZHU", "竺": "ZHU", "祝": "ZHU", "爪雨佳": "ZHUAYUJIA", "颛孙": "ZHUANSUN", "庄": "ZHUANG", "卓": "ZHUO", "禚": "ZHUO", "子车": "ZICHE", "訾": "ZI", "宗": "ZONG", "宗政": "ZONGZHENG", "邹": "ZOU", "祖": "ZU", "左": "ZUO", "左丘": "ZUOQIU"
};
const BUFFER_SIZE = 128 * 1024;
const FC_TAG = 0xFC010203040506CF;
// 由于 TypeScript 没有直接的静态类概念，我们使用命名空间来模拟
export default class UserFunction {
    // static IsSamplePassword(arg0: null, arg1: any, num: string) {
    //     return true;
    // }
    // 静态变量
    static HasJZ: boolean = false;
    static AccNo: string = '';
    static msg104_1: string | null = null;
    static msg104_2: string | null = null;
    static ClearingKinbrno: string[] = [];

    // 在子元素中，查找指名字的控件
    static FindChildByName(d: any, eleName: string, resElement: any): void {
        for (let i = 0; i < (d.children?.length || 0); i++) {
            const el = d.children[i];
            if (el && el.name === eleName) {
                resElement = el;
                return;
            }
            UserFunction.FindChildByName(el, eleName, resElement);
        }
    }

    // 对应 commsend_96
    static CommSend96(target: any, message: any): void {
        message.Fd96_7 = "0";
        message.Fd96_8 = "0";
        message.Fd96_C = "0100"; // 本行柜面
        message.Fd96_9 = "0100"; // 本行柜面
        message.Fd96_D = LoginUserInfo.TradeDate;
        message.Fd96_E = message.Fd6;
    }

    // ComboBox 获得的 SelectValue 扩展
    static GetSelectedValue(combo: any): string {
        return combo.selectedValue || '';
    }

    // ComboBox 赋值的 SelectValue 扩展
    static SetSelectedValue(combo: any, val: any): void {
        if (combo.items.length <= 0 || val === null) return;
        const b = combo.items.some((item: { value: string }) => item.value.trim() === val.toString().trim());
        if (b) {
            combo.selectedValue = val;
        } else {
            if (val !== null && val.toString().trim() !== '') {
                throw new Error(`[${combo.name}]设置了超出范围的选择项Value:[${val}]`);
            }
        }
    }

    // 根据 Key 值为 combo 赋值
    static SetSelectedKey(combo: any, key: string): void {
        if (combo.items.length <= 0) return;
        let index = 0;
        let bo = false;
        for (const item of combo.items) {
            if (item.key.trim() === key.trim()) {
                combo.selectedIndex = index;
                bo = true;
                break;
            }
            index++;
        }
        if (!bo) {
            throw new Error(`[${combo.name}]设置了超出范围的选择项Key:[${key}]`);
        }
    }

    // 字符串转换成 decimal 对象
    static ToDecimal(src: string): number {
        if (src.trim() === '') return 0;
        let d = 0;
        if (!Number.isNaN(parseFloat(src))) {
            d = parseFloat(src);
        } else if (!Number.isNaN(parseFloat(src.replace(/,|，/g, '')))) {
            d = parseFloat(src.replace(/,|，/g, ''));
        } else {
            throw new Error(`无法将[${src}]转换成有效的数字对象`);
        }
        return d;
    }

    // 将 yyyyMMdd 格式的字符串转换成对应的 DateTime 对象
    static ToDateTime(src: string): Date {
        if (src === "99999999") src = "99991230";
        if (src.length === 8) {
            const year = parseInt(src.substring(0, 4), 10);
            const month = parseInt(src.substring(4, 2), 10);
            const day = parseInt(src.substring(6, 2), 10);
            return new Date(year, month - 1, day);
        }
        throw new Error(`无法将[${src}]转换成有效的日期对象`);
    }

    // 日期转换，按格式约定处理
    static ToDateTimeWithFormat(src: string, format: string): Date | null {
        const dt = new Date(src);
        if (!isNaN(dt.getTime())) {
            return dt;
        }
        // 这里没有像 C# 那样直接的 TryParseExact 方法，简单处理，可根据实际需求扩展
        console.error(`无法将[${src}]转换成有效的[${format}]对象`);
        return null;
    }

    // 检查账号是否是卡，是，返回 true；否，返回 false
    static CheckCardBin(target: any, acno: string): boolean {
        const cabin = UserVariable.GetCardBin(target);
        for (const item of cabin) {
            if (acno.startsWith(item)) {
                return true;
            }
        }
        return false;
    }

    // 设置打印的 TextBlock
    static PRINT_ATT = "：";
    static SetPrintTextBlock(target: any, ...args: string[]): void {
        if (args.length === 1) {
            if (target.text.includes(":") || target.text.includes("：")) {
                target.text = target.text.replace(/\{0\}/g, args[0]);
            } else {
                target.text = target.text.replace(/\{0\}/g, UserFunction.PRINT_ATT + args[0]);
            }
        } else if (args.length === 2) {
            if (target.text.includes(":") || target.text.includes("：")) {
                target.text = target.text.replace(/\{0\}/g, args[0]).replace(/\{1\}/g, args[1]);
            } else {
                target.text = target.text.replace(/\{0\}/g, UserFunction.PRINT_ATT + args[0]).replace(/\{1\}/g, args[1]);
            }
        } else if (args.length === 3) {
            if (target.text.includes(":") || target.text.includes("：")) {
                target.text = target.text.replace(/\{0\}/g, args[0]).replace(/\{1\}/g, args[1]).replace(/\{2\}/g, args[2]);
            } else {
                target.text = target.text.replace(/\{0\}/g, UserFunction.PRINT_ATT + args[0]).replace(/\{1\}/g, args[1]).replace(/\{2\}/g, args[2]);
            }
        } else {
            target.text = target.text.replace(/{(\d+)}/g, (match: string, p1: string) => args[parseInt(p1, 10)]);
        }
    }

    static SetPrintMultiText(target: any, resp: string): void {
        const lable = resp.replace(/\{\d\}/g, "");
        const count = lable.length + UserFunction.PRINT_ATT.length;
        const empText = " ".repeat(count);
        target.inlines = [];
        target.inlines.push(lable + UserFunction.PRINT_ATT);
        const strs = resp.split(/\r?\n/).filter(s => s !== '');
        for (let i = 0; i < strs.length; i++) {
            target.inlines.push(strs[i]);
            if (i !== strs.length - 1) {
                target.inlines.push("\n");
                target.inlines.push(empText);
            }
        }
    }

    // 检查参数指定机构是否为清算机构
    static CheckQsBrno(target: any, brno: string): boolean {
        if (UserFunction.ClearingKinbrno.length <= 0) {
            UserFunction.ClearingKinbrno = TradeManagerHandle.GetClearingKinbrno();
        }
        return UserFunction.ClearingKinbrno.includes(brno);
    }

    // 检查参数指定机构是否为会计结算部
    static CheckJsBrno(target: any, brno: string): boolean {
        const js_list = ["78888"];
        return js_list.includes(brno);
    }

    // 截取卡号中凭证号 slzh
    static NoteNoOfCard(target: any, acno: string): string | null {
        if (acno.length < 18) {
            return null;
        }
        return UserFunction.ToDecimal(acno.substring(6, 12)).toString().padStart(16, '0');
    }

    // 获取系统当前日期时间
    static GetCurrentDateTime(target: any): Date {
        const now = new Date();
        let year = now.getFullYear();
        let month = now.getMonth() + 1;
        let day = now.getDate();
        let hour = now.getHours();
        let minute = now.getMinutes();
        let second = now.getSeconds();
        if (LoginUserInfo.TradeDate && LoginUserInfo.TradeDate.length === 8) {
            year = parseInt(LoginUserInfo.TradeDate.substring(0, 4), 10);
            month = parseInt(LoginUserInfo.TradeDate.substring(4, 2), 10);
            day = parseInt(LoginUserInfo.TradeDate.substring(6, 2), 10);
        }
        if (LoginUserInfoExt.TradeTime && LoginUserInfoExt.TradeTime.length === 6) {
            hour = parseInt(LoginUserInfoExt.TradeTime.substring(0, 2), 10);
            minute = parseInt(LoginUserInfoExt.TradeTime.substring(2, 2), 10);
            second = parseInt(LoginUserInfoExt.TradeTime.substring(4, 2), 10);
        }
        return new Date(year, month - 1, day, hour, minute, second);
    }

    // 将字符串拆成 byte[] 后，按字节截取，按照域的要求左对齐,空格补全
    static GetFdStrBytes(str: string, leng: number): string {
        const strFd = str.padEnd(leng);
        // 这里简单用字符串代替字节处理，实际可能需要更复杂的处理
        return strFd.slice(0, leng);
    }

    // 将字符串拆成 byte[] 后，按字节截取
    static GetStrBytes(str: string, index: number, count: number): string {
        // 这里简单用字符串代替字节处理，实际可能需要更复杂的处理
        return str.slice(index, index + count);
    }

    // 半角字符串转换成全角字符串
    static ChangeToSBC(target: any, input: string): string {
        const c = input.split('');
        for (let i = 0; i < c.length; i++) {
            if (c[i] === ' ') {
                c[i] = '　';
            } else if (c[i].charCodeAt(0) < 127) {
                c[i] = String.fromCharCode(c[i].charCodeAt(0) + 65248);
            }
        }
        return c.join('');
    }

    // 是否为简单密码
    static IsSamplePassword(target: any, password: string, id_no: string = ''): boolean {
        const simple_pwds = [
            "000000", "111111", "222222", "333333", "444444", "555555", "666666", "777777", "888888", "999999",
            "123456", "234567", "345678", "456789", "567890", "987654", "876543", "765432", "654321", "543210"
        ];
        if (simple_pwds.includes(password)) {
            return true;
        }
        const flag = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        if (flag !== "V13" && flag !== "V14" && flag !== "V21" && flag !== "V22") {
            let birthday = "";
            if (id_no.length === 15) {
                birthday = id_no.substring(6, 6);
            } else if (id_no.length === 18) {
                birthday = id_no.substring(8, 6);
            }
            if (birthday.includes(password)) {
                return true;
            }
        }
        return false;
    }

    // 下拉框作为账号选择控件时，使用此扩展方法填充数据
    static SetActItems(target: any, fileData: string): void {
        target.style = target.findResource("ActComboBoxStyle");
        const dict: { [key: string]: string } = {};
        const items = fileData.split('\n');
        for (let i = 0; i < items.length; i++) {
            if (items[i].trim() !== '') {
                const array = items[i].split('|');
                if (array.length !== 6) {
                    throw new Error("给定的账户列表的源数据错误");
                }
                let text = "";
                const key = array[0].trim();
                text += array[0].trim().padEnd(20);
                text += array[1].trim().padEnd(20);
                text += array[2].trim().padEnd(20);
                text += array[3].trim().padEnd(20);
                text += array[4].trim().padEnd(20);
                dict[text] = key;
            }
        }
        target.setItems(dict);
    }

    // 将日期转换成大写
    static DateToBig(target: any, date: string): string[] {
        const year = date.substring(0, 4);
        const month = date.substring(4, 2);
        const day = date.substring(6, 2);
        let byear = "";
        for (let i = 0; i < 4; i++) {
            switch (year[i]) {
                case "0": byear += '零'; break;
                case "1": byear += "壹"; break;
                case "2": byear += "贰"; break;
                case "3": byear += "叁"; break;
                case "4": byear += "肆"; break;
                case "5": byear += "伍"; break;
                case "6": byear += "陆"; break;
                case "7": byear += "柒"; break;
                case "8": byear += "捌"; break;
                case "9": byear += "玖"; break;
            }
        }
        let bmonth = "";
        switch (month) {
            case "01": bmonth = "  零壹"; break;
            case "02": bmonth = "  零贰"; break;
            case "03": bmonth = "  零叁"; break;
            case "04": bmonth = "  零肆"; break;
            case "05": bmonth = "  零伍"; break;
            case "06": bmonth = "  零陆"; break;
            case "07": bmonth = "  零柒"; break;
            case "08": bmonth = "  零捌"; break;
            case "09": bmonth = "  零玖"; break;
            case "10": bmonth = "零壹拾"; break;
            case "11": bmonth = "壹拾壹"; break;
            case "12": bmonth = "壹拾贰"; break;
        }
        let bday = "";
        switch (day) {
            case "01": bday = "  零壹"; break;
            case "02": bday = "  零贰"; break;
            case "03": bday = "  零叁"; break;
            case "04": bday = "  零肆"; break;
            case "05": bday = "  零伍"; break;
            case "06": bday = "  零陆"; break;
            case "07": bday = "  零柒"; break;
            case "08": bday = "  零捌"; break;
            case "09": bday = "  零玖"; break;
            case "10": bday = "零壹拾"; break;
            case "11": bday = "壹拾壹"; break;
            case "12": bday = "壹拾贰"; break;
            case "13": bday = "壹拾叁"; break;
            case "14": bday = "壹拾肆"; break;
            case "15": bday = "壹拾伍"; break;
            case "16": bday = "壹拾陆"; break;
            case "17": bday = "壹拾柒"; break;
            case "18": bday = "壹拾捌"; break;
            case "19": bday = "壹拾玖"; break;
            case "20": bday = "零贰拾"; break;
            case "21": bday = "贰拾壹"; break;
            case "22": bday = "贰拾贰"; break;
            case "23": bday = "贰拾叁"; break;
            case "24": bday = "贰拾肆"; break;
            case "25": bday = "贰拾伍"; break;
            case "26": bday = "贰拾陆"; break;
            case "27": bday = "贰拾柒"; break;
            case "28": bday = "贰拾捌"; break;
            case "29": bday = "贰拾玖"; break;
            case "30": bday = "零叁拾"; break;
            case "31": bday = "叁拾壹"; break;
        }
        return [byear, bmonth, bday];
    }

    // 查找系统定义的常量是否存在
    static ConstantIsExist(target: any, Constant: string): number {
        const list = ["10010", "10011"];
        return list.includes(Constant) ? 1 : 0;
    }

    // 批量业务中构建转换后的 txt 文件名称
    static GetTxtFileName(target: any, msg: any): string {
        return `FRNT${msg.Fd16}_${msg.Fd5}${msg.Fd7}${msg.Fd4}${Math.floor(Math.random() * (999999999 - 100000000 + 1)) + 100000000}S.txt`;
    }

    // 转换日期格式 2012-2-2/2012/2/2 转化为 20120202
    static SwitchDateFormat(shortDateString: string): string {
        const date = shortDateString.split(/[\/\\ -]/);
        let formatedDate = "";
        formatedDate += date[2];
        formatedDate += date[0].length === 1 ? `0${date[0]}` : date[0];
        formatedDate += date[1].length === 1 ? `0${date[1]}` : date[1];
        return formatedDate;
    }

    // 20120202232323 转换日期格式 2012-02-02 23:23:23
    static ChangeToDateString(numberString: string): string {
        if (numberString.length !== 14) return numberString;
        return `${numberString.slice(0, 4)}-${numberString.slice(4, 6)}-${numberString.slice(6, 8)} ${numberString.slice(8, 10)}:${numberString.slice(10, 12)}:${numberString.slice(12, 14)}`;
    }



    static FloatString(num: string, isSimple: boolean = true): string {
        let cc = "";
        let bb = UserFunction.ConvertString(num, isSimple);
        const len = bb.indexOf("零");
        if (len !== 0) {
            bb = bb.replace(/零/g, "");
            if (bb.length === 1) {
                cc = bb.substring(0, 1);
            } else {
                cc = bb.substring(0, 1);
                cc += bb.substring(1, 1);
            }
        } else {
            cc = bb;
        }
        return cc;
    }

    static NumberString(num: string, isSimple: boolean = true): string {
        let bb = "";
        if (num.length <= 4) {
            bb = UserFunction.Convert4(num, isSimple);
        } else if (num.length > 4 && num.length <= 8) {
            bb = UserFunction.Convert4(num.substring(0, num.length - 4), isSimple) + "万";
            bb += UserFunction.Convert4(num.substring(num.length - 4, 4), isSimple);
        } else if (num.length > 8 && num.length <= 12) {
            bb = UserFunction.Convert4(num.substring(0, num.length - 8), isSimple) + "亿";
            if (UserFunction.Convert4(num.substring(num.length - 8, 4), isSimple) === "") {
                if (UserFunction.Convert4(num.substring(num.length - 4, 4), isSimple) !== "") {
                    bb += "零";
                }
            } else {
                bb += UserFunction.Convert4(num.substring(num.length - 8, 4), isSimple) + "万";
            }
            bb += UserFunction.Convert4(num.substring(num.length - 4, 4), isSimple);
        }
        return bb;
    }

    static Convert4(num: string, isSimple: boolean = true): string {
        let bb = "";
        if (num.length === 1) {
            bb = UserFunction.ConvertString(num, isSimple);
        } else if (num.length === 2) {
            bb = UserFunction.ConvertString(num, isSimple);
            bb = UserFunction.Convert2(bb, isSimple);
        } else if (num.length === 3) {
            bb = UserFunction.ConvertString(num, isSimple);
            bb = UserFunction.Convert3(bb, isSimple);
        } else {
            bb = UserFunction.ConvertString(num, isSimple);
            const len = bb.substring(0, 4);
            if (len !== "零零零零") {
                const len3 = bb.substring(0, 3);
                if (len3 !== "零零零") {
                    bb = bb.replace(/零零零/g, "");
                    if (bb.length === 1) {
                        bb = isSimple ? `${bb}千` : `${bb}仟`;
                    } else {
                        let cc = "";
                        if (bb.substring(0, 1) !== "零" && bb.substring(0, 2) !== "零") {
                            cc = isSimple ? `${bb.substring(0, 1)}千` : `${bb.substring(0, 1)}仟`;
                        } else {
                            cc = bb.substring(0, 1);
                        }
                        bb = cc + UserFunction.Convert3(bb.substring(1, 3), isSimple);
                    }
                } else {
                    bb = bb.replace(/零零零/g, "零");
                }
            } else {
                bb = bb.replace(/零零零零/g, "");
            }
        }
        return bb;
    }

    static ConvertString(num: string, isSimple: boolean = true): string {
        let bb = "";
        for (let i = 0; i < num.length; i++) {
            bb += isSimple ? SimpleNumChineseCharacter[parseInt(num[i], 10)] : NumChineseCharacter[parseInt(num[i], 10)];
        }
        return bb;
    }

    static Convert2(num: string, isSimple: boolean = true): string {
        let cc = "";
        const len = num.substring(0, 1);
        if (len !== "零") {
            let bb = num.replace(/零/g, "");
            if (bb.length === 1) {
                cc = isSimple ? `${bb}十` : `${bb}拾`;
                if (cc === "一十") {
                    cc = "十";
                }
            } else {
                cc = isSimple ? `${bb.substring(0, 1)}十` : `${bb.substring(0, 1)}拾`;
                if (cc === "一十") {
                    cc = "十";
                }
                cc += bb.substring(1, 1);
            }
        } else {
            cc = num;
        }
        return cc;
    }

    static Convert3(num: string, isSimple: boolean = true): string {
        let bb = "";
        const len = num.substring(0, 2);
        if (len !== "零零") {
            bb = num.replace(/零零/g, "");
            if (bb.length === 1) {
                bb = isSimple ? `${bb}百` : `${bb}佰`;
            } else {
                let cc = "";
                if (bb.substring(0, 1) !== "零") {
                    cc = isSimple ? `${bb.substring(0, 1)}百` : `${bb.substring(0, 1)}佰`;
                } else {
                    cc = bb.substring(0, 1);
                }
                bb = cc + UserFunction.Convert2(bb.substring(1, 2), isSimple);
            }
        } else {
            bb = num.replace(/零零/g, "零");
        }
        return bb;
    }

    static ChagedNumberString(target: any, number: string, isSimple: boolean = true): string {
        let dnum = parseInt(number, 10);
        if (!isNaN(dnum) && dnum >= 0) {
            number = UserFunction.NumberString(dnum.toString(), isSimple);
            number = number.replace(/零零/g, "零");
        }
        return number;
    }

    // 转化大于 12 个月的单位为年(存期单位转成年)
    static ChagedMonthsToYearsString(target: any, months: string): string {
        switch (months) {
            case "12": return "一";
            case "24": return "二";
            case "36": return "三";
            case "48": return "四";
            case "60": return "五";
            case "72": return "六";
            case "84": return "七";
            case "96": return "八";
            case "108": return "九";
            case "120": return "十";
            default:
                let dnum = parseInt(months, 10);
                if (!isNaN(dnum) && dnum >= 0) {
                    dnum = Math.floor(dnum / 12);
                    let number = UserFunction.NumberString(dnum.toString());
                    number = number.replace(/零零/g, "零");
                    return number;
                }
                return months;
        }
    }

    // 转化大于 12 个月的单位为年(存期单位转成年)，带单位
    static ChagedMonthsToYearsUnitString(target: any, months: string, unint: string): string {
        let dnum = parseInt(months, 10);
        if (!isNaN(dnum) && dnum >= 12 && unint === "个月") {
            dnum = Math.floor(dnum / 12);
            let number = UserFunction.NumberString(dnum.toString());
            number = number.replace(/零零/g, "零");
            return `${number}年`;
        } else if (!isNaN(dnum) && dnum >= 0 && unint === "天") {
            let number = UserFunction.NumberString(dnum.toString());
            number = number.replace(/零零/g, "零");
            return `${number}${unint}`;
        }
        return `${UserFunction.NumberString(months)}${unint}`;
    }

    // 货币符号转换
    static ChangeMoneySymbol(currencyEditorControl: any, SymbolType: string): void {
        currencyEditorControl.CurrencySymbolType = "UserSetting";
        currencyEditorControl.CurrencySymbol = UserFunction.ChangeMoneySymbolInternal(SymbolType);
    }

    static ChangeMoneySymbolInternal(val: string): string {
        switch (val) {
            case "01": return "¥";
            case "12": return "￡";
            case "13": return "HK$";
            case "14": return "US$";
            case "15": return "SF";
            case "18": return "S$";
            case "27": return "J￥";
            case "28": return "CAN$";
            case "29": return "A$";
            case "38": return "€";
            case "": return "¥";
            case null: return "¥";
            default: return val;
        }
    }

    // 获取系统时间
    static GetSystemTime(target: any, message: any): string {
        return message.Fd6.replace(/(\d{2})/g, "$1:").replace(/:$/, "");
    }

    // 获取日期加时分秒
    static GetSystemDateAndTime(target: any, message: any): string {
        return `${LoginUserInfo.TradeDate} ${UserFunction.GetSystemTime(target, message)}`;
    }

    // 获取指定柜员拥有的角色列表
    static GetGroupCodeByUserCode(target: any, userCode: string): string[] {
        return TradeManagerHandle.Query_GroupCodeByUserCode(userCode);
    }

    // 菜单栏搜索的拓展方法
    static SeachMemuTree(targetTreeView: any, str: string): void {
        for (const treeItem of targetTreeView.items) {
            treeItem.isExpanded = false;
            UserFunction.getTreeViewItem(treeItem, str);
        }
    }

    static getTreeViewItem(itemParent: any, str: string): void {
        if (itemParent.items && itemParent.items.length > 0) {
            for (const item of itemParent.items) {
                item.isExpanded = false;
                if (item.header.toString().includes(str)) {
                    UserFunction.ExpandedItem(item);
                    item.isSelected = true;
                }
                UserFunction.getTreeViewItem(item, str);
            }
        }
    }

    static ExpandedItem(tvTtem: any): void {
        if (tvTtem.parent) {
            const parent = tvTtem.parent;
            parent.isExpanded = true;
            UserFunction.ExpandedItem(parent);
        }
    }

    // 添加强制推送消息
    static AddForceNotifyMessage(target: any): void {
        const mainpage = MainPageManager.GetMainPage();
        mainpage.AddForceNotifyPlan(target);
    }

    // 格式化日期时间
    static FormatDateTime(dateTime: string): string[] {
        const ret = ["", ""];
        if (dateTime) {
            const date = new Date(dateTime);
            if (!isNaN(date.getTime())) {
                ret[0] = date.toLocaleDateString("zh-CN", { year: 'numeric', month: '2-digit', day: '2-digit' }).replace(/\//g, "年") + "日";
                ret[1] = date.toLocaleTimeString("zh-CN", { hour: '2-digit', minute: '2-digit', second: '2-digit' }).replace(/:/g, "时") + "秒";
            }
        }
        return ret;
    }

    // 二代支付授权检查
    static AuthCheckAgnCnasp2(target: any, message: any): boolean {
        const bakFd18 = message.Fd18;
        const bakFd16 = message.Fd16;
        const bakFd34 = message.Fd34;
        const bakFd79 = message.Fd79;
        const bakFd92 = message.Fd92;

        message.Fd16 = "9996";
        message.Fd18 = "CBS";
        message.Fd34 = bakFd16;
        target.CallAgnCnaps2(message);
        if (message.Fd12 !== "0000") {
            target.ShowErrorMessageBox(target.GetError(message));
            return false;
        }
        if (message.Fd34 === "Z003") {
            const dictionary = target.ShowPage("Trade.TwoPayment.T0001", "授权", { message: message });
            if (dictionary) {
                if (dictionary.hasOwnProperty("ReturnValue")) {
                    if (dictionary.ReturnValue.toString() !== "True") {
                        target.ShowInfoMessageBox("已取消授权操作");
                        return false;
                    }
                } else {
                    target.ShowInfoMessageBox("界面已关闭，未执行授权");
                    return false;
                }
            } else {
                target.ShowErrorMessageBox("授权异常，请联系管理员");
                return false;
            }
        }
        message.Fd18 = bakFd18;
        message.Fd16 = bakFd16;
        message.Fd34 = bakFd34;
        message.Fd79 = bakFd79;
        message.Fd92 = bakFd92;
        return true;
    }

    // 二代支付复核检查
    static WaitSuperAgnCnasp2(target: any, message: any) {
        const bakFd78 = message.Fd78;
        const bakFd16 = message.Fd16;
        const bakFd72 = message.Fd72;
        const bakFd77 = message.Fd77;
        const bakFd9 = message.getFdVaule(9);

        message.Fd77 = message.Fd16;
        message.Fd16 = "9997";
        message.Fd72 = "1";
        message.Fd78 = "00000000";
        target.CallAgnCnaps2(message);
        message.setFdValue(9, bakFd9);
        if (message.Fd12 !== "0000") {
            target.ShowErrorMessageBox(target.GetError(message));
            message.Fd78 = bakFd78;
            message.Fd16 = bakFd16;
            message.Fd72 = bakFd72;
            message.Fd77 = bakFd77;
            return false;
        }
        while (true) {
            const result = target.ShowQuestionMessageBox(`请监督柜员监督[${message.Fd78.trim()}],监督完成后请按确定`);
            if (result === "Yes") {
                message.Fd72 = "0";
                target.CallAgnCnaps2(message);
                if (message.Fd12 !== "0000") {
                    target.ShowErrorMessageBox(target.GetError(message));
                    message.Fd78 = bakFd78;
                    message.Fd16 = bakFd16;
                    message.Fd72 = bakFd72;
                    message.Fd77 = bakFd77;
                    return false;
                }
                if (message.Fd72 !== "2") {
                    target.ShowInfoMessageBox("原交易未监督完成,不能提交！");
                } else {
                    break;
                }
            } else {
                // 选择否，删除监督记录跳出循环
                message.Fd72 = "8";
                target.CallAgnCnaps2(message);
                if (message.Fd12 !== "0000") {
                    target.ShowErrorMessageBox(target.GetError(message));
                    message.Fd78 = bakFd78;
                    message.Fd16 = bakFd16;
                    message.Fd72 = bakFd72;
                    message.Fd77 = bakFd77;
                    return false;
                }
                break;
            }
        }

        message.setFdValue(9, bakFd9);
        message.Fd78 = bakFd78;
        message.Fd16 = bakFd16;
        message.Fd77 = bakFd77;
        if (message.Fd72 === "2") {
            message.Fd72 = bakFd72;
            return true;
        } else {
            message.Fd72 = bakFd72;
            return false;
        }
    }

    // 二代支付手续费
    static async FeeCheckAgnCnasp2(target: any, type: string, flag: string, amt: string): Promise<{ feeFlag: string; toAmt: string }> {
        const message = new Message();//hulei 这里应该传二代的节点
        target.InitFd(message);
        target.CommSend(message);
        message.Fd16 = "9044";
        message.Fd18 = "CBS";
        message.Fd58 = type;
        message.Fd98 = flag;
        message.Fd42 = amt;
        await target.CallAgnCnaps2(message);
        if (message.Fd12 !== "0000") {
            target.ShowInfoMessageBox("此业务暂不收取手续费！");
            return { feeFlag: "3", toAmt: "0" };
        } else {
            const dictionary = await target.ShowPage("Trade.TwoPayment.FEE_CNAPS", "收费", { Flag: message.Fd98, Amt: message.Fd43 });
            if (dictionary && dictionary.hasOwnProperty("FeeFlag") && dictionary.hasOwnProperty("Amt")) {
                return { feeFlag: dictionary.FeeFlag.toString(), toAmt: dictionary.Amt.toString() };
            } else {
                return { feeFlag: "", toAmt: "" };
            }
        }
    }

    // 填充占位符
    static FillingPlaceholder(target: any, str: string): string {
        const tmp = str.trimStart();
        return tmp === '' ? "---" : tmp;
    }

    // 系统检查,call9000 交易
    static async SystemstatuscheckCnasp2(target: any, message: any, fd48Str: string): Promise<boolean> {
        target.InitFd(message);
        target.CommSend(message);
        message.Fd16 = "9000";
        message.Fd18 = "CBS";
        message.Fd48 = fd48Str;
        await target.CallAgnCnaps2(message);
        return message.Fd12 === "0000";
    }

    // 系统检查,call9000 交易
    static async SystemstatuscheckCnasp2WithFd34(target: any, message: any, fd34Str: string, fd48Str: string): Promise<boolean> {
        target.InitFd(message);
        target.CommSend(message);
        message.Fd16 = "9000";
        message.Fd18 = "CBS";
        message.Fd34 = fd34Str;
        message.Fd48 = fd48Str;
        await target.CallAgnCnaps2(message);
        return message.Fd12 === "0000";
    }

    // 姓名转拼音

    static GetSurname(fname: string): string {
        return surnameDict[fname] || '';
    }

    static GetNamePinyin(name: string): string {
        if (name.length < 2) return '';
        let fname = '';
        let fSurname = '';
        for (let i = 1; i < name.length; i++) {
            if (fSurname) break;
            fname = name.substring(0, i);
            fSurname = UserFunction.GetSurname(fname);
        }
        if (!fSurname) fname = '';
        const FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        let sSurname = '';
        if (FLAG === "V21" || FLAG === "V22" || FLAG === "V1" || FLAG === "V0" || FLAG === "V8") {
            // 这里假设 NPinyin.Pinyin.GetPinyin 有对应的实现
            // sSurname = NPinyin.Pinyin.GetPinyin(name.substring(fname.length)); hulei-s 这里获取到拼音
        } else {
            // 这里假设 TellerSystem.Library.Ext.TradeExtension.ChineseCodeConverter.Convert 有对应的实现
            // sSurname = Convert(name.substring(fname.length));
        }
        return (fSurname + sSurname).toUpperCase();
    }

    // 代付业务解密文件的方法


    static async CreateRijndael(password: string, salt: Uint8Array): Promise<CryptoKey> {
        const encoder = new TextEncoder();
        const keyMaterial = await crypto.subtle.importKey(
            "raw",
            encoder.encode(password),
            { name: "PBKDF2" },
            false,
            ["deriveBits", "deriveKey"]
        );
        return await crypto.subtle.deriveKey(
            {
                name: "PBKDF2",
                salt: salt,
                iterations: 1000,
                hash: "SHA-256"
            },
            keyMaterial,
            { name: "AES-CBC", length: 256 },
            true,
            ["encrypt", "decrypt"]
        );
    }

    static CheckByteArrays(b1: Uint8Array, b2: Uint8Array): boolean {
        if (b1.length !== b2.length) return false;
        for (let i = 0; i < b1.length; i++) {
            if (b1[i] !== b2[i]) return false;
        }
        return true;
    }

    static async DecryptFile(password: string): Promise<boolean> {
        const input = document.createElement('input');
        input.type = 'file';
        input.accept = '*.dhc';
        const result = await new Promise<File | null>((resolve) => {
            input.onchange = () => {
                resolve(input.files && input.files[0] || null);
            };
            input.click();
        });
        if (!result) return false;
        const inFile = result;
        const outFile = inFile.name.substring(0, inFile.name.length - 3);
        const fileStream = await inFile.arrayBuffer();
        const fileData = new Uint8Array(fileStream);
        const IV = fileData.slice(0, 16);
        const salt = fileData.slice(16, 32);
        const key = await UserFunction.CreateRijndael(password, salt);
        const ciphertext = fileData.slice(32);
        const decipher = await crypto.subtle.decrypt(
            { name: "AES-CBC", iv: IV },
            key,
            ciphertext
        );
        const decipherData = new Uint8Array(decipher);
        const lSize = new DataView(decipherData.buffer, 0, 8).getBigInt64(0, true);
        const tag = new DataView(decipherData.buffer, 8, 8).getBigUint64(0, true);
        //  if (tag !== FC_TAG) return false;//hulei 此比较似乎是无意的，因为类型“bigint”和“number”没有重叠
        const hasher = await crypto.subtle.digest("SHA-256", decipherData.slice(16, 16 + Number(lSize)));
        const curHash = new Uint8Array(hasher);
        const oldHash = decipherData.slice(16 + Number(lSize));
        if (!UserFunction.CheckByteArrays(oldHash, curHash)) return false;
        const blob = new Blob([decipherData.slice(16, 16 + Number(lSize))], { type: 'application/octet-stream' });
        const url = URL.createObjectURL(blob);
        const a = document.createElement('a');
        a.href = url;
        a.download = outFile;
        a.click();
        URL.revokeObjectURL(url);
        return true;
    }

    // 根据终端注册设置机构的logo
    static async SetKinbrLogo(jhm: string): Promise<void> {
        try {
            const kinbrno = await PlatformManagerHandle.TerminalNumber_GetKinbrNO(jhm);
            if (!kinbrno) {
                alert("根据激活码获取机构失败！联系科技人员!");
            } else {
                const bitmap = await UserFunction.GetImageResourse(kinbrno);
                if (bitmap) {
                    document.documentElement.style.setProperty('--main-logo', `url(${bitmap})`);
                }
            }
        } catch (e) {
            alert("设置机构logo失败！请联系科技人员");
        }
    }

    static GetImageResourse(kinbrno: string): Promise<string | null> {
        // try {
        //     const source =  TradeManagerHandle.GetKinbrLogo(kinbrno);
        //     const blob = new Blob([source], { type: 'image/png' });
        //     return URL.createObjectURL(blob);
        // } catch (e) {
        //     return null;
        // }
        return null;
    }

    // DataTableToXML
    static ConvertDataTableToXML(xmlDS: any, dic: { [key: string]: string }, noLoopElements: { [key: string]: string } | null = null): string {
        let result = '<Body>';
        result += `<LoopNo>${xmlDS.rows.length}</LoopNo>`;
        if (noLoopElements) {
            for (const [key, value] of Object.entries(noLoopElements)) {
                result += `<${key}>${value}</${key}>`;
            }
        }
        for (const row of xmlDS.rows) {
            result += '<List>';
            for (const column of xmlDS.columns) {
                if (dic[column.name]) {
                    result += `<${dic[column.name]}>${row[column.name]}</${dic[column.name]}>`;
                }
            }
            result += '</List>';
        }
        result += '</Body>';
        return result;
    }

    // DataTableToXML
    static ConvertDictionaryToXML(dic: { [key: string]: string }): string {
        let result = '<Body>';
        for (const [key, value] of Object.entries(dic)) {
            result += `<${key}>${value}</${key}>`;
        }
        result += '</Body>';
        return result;
    }

    // XMLToDataTable
    static ConvertXMLToDataTable(xmlStr: string, dic: { [key: string]: string } | null = null): any {
        try {
            const parser = new DOMParser();
            const doc = parser.parseFromString(xmlStr, 'text/xml');
            const nodes = doc.querySelectorAll('/Body/List');
            const dt = { columns: [], rows: [] };
            if (nodes.length > 0) {
                const firstRow = nodes[0];
                // for (const child of firstRow.children) {
                //     dt.columns.push(dic? dic[child.tagName] || child.tagName : child.tagName);
                // }
            }
            // for (const node of nodes) {
            //     const row = [];
            //     for (const child of node.children) {
            //         row.push(child.textContent);
            //     }
            //     dt.rows.push(row);
            // }
            //hulei 处理表格
            return dt;
        } catch (ex) {
            console.error("解析平台XML报文失败", ex);
            return null;
        }
    }

    // 字符串中含汉字的个数
    static ContainChineseLetterNumber(input: string): number {
        let result = 0;
        const chfrom = parseInt("4e00", 16);
        const chend = parseInt("9fff", 16);
        for (const char of input) {
            const code = char.codePointAt(0);
            if (code !== undefined && code >= chfrom && code <= chend) {
                result++;
            }
        }
        return result;
    }

    // 字符串中是否包含汉字
    static IsContainChineseLetter(input: string): boolean {
        const chfrom = parseInt("4e00", 16);
        const chend = parseInt("9fff", 16);
        for (const char of input) {
            const code = char.codePointAt(0);
            if (code !== undefined && code >= chfrom && code <= chend) {
                return true;
            }
        }
        return false;
    }

    // 组装日期格式
    static ChangeDate(date: string): string {
        if (date && !date.includes('-')) {
            return `${date.substring(0, 4)}-${date.substring(4, 6)}-${date.substring(6, 8)}`;
        }
        return date;
    }

    // 拆解日期格式
    static DateUpdate(date: string): string {
        if (date.includes('-')) {
            return date.replace(/-/g, '');
        }
        return date;
    }

    // DT转成字符串DataTableToString
    static DataTableToString(dt: any): string {
        let result = '~';
        for (const col of dt.columns) {
            result += `${col.name}|`;
        }
        result += '\n';
        for (const row of dt.rows) {
            for (let i = 0; i < dt.columns.length; i++) {
                result += `${row[i]}|`;
            }
            result += '\n';
        }
        return result;
    }

    // 货币编号->货币符号
    static ChangeMoneySymbolForCurrency2(currencyEditorControl: any, SymbolType: string): void {
        currencyEditorControl.CurrencySymbolType = "UserSetting";
        currencyEditorControl.CurrencySymbol = UserFunction.ChangeMoneySymbolInternal(SymbolType);
    }
}


// 假设这些全局对象和类型已经在其他地方定义
// declare const LoginUserInfo: { TradeDate: string };
// declare const LoginUserInfoExt: { TradeTime: string };
// declare const UserVariable: { GetCardBin: (target: any) => string[] };
// declare const TradeManagerHandle: {
//     GetClearingKinbrno: () => string[];
//     TT_SYSCONFIG_GetConfigValueByConfigID: (id: string) => string;
//     Query_GroupCodeByUserCode: (userCode: string) => string[];
//     GetKinbrLogo: (kinbrno: string) => Promise<ArrayBuffer>;
// };
// declare const PlatformManagerHandle: { TerminalNumber_GetKinbrNO: (jhm: string) => Promise<string> };
// declare const MainPageManager: { GetMainPage: () => any };
// // setFdValue: (index: number, value: string) => void (){ };

// declare class PageBase {
//     tradeInfo: { mainCode: string };
//     previewSubmitting: () => Promise<Message>;
//     showInfoMessageBox: (message: string) => void;
//     showErrorMessageBox: (message: string) => void;
//     showQuestionMessageBox: (message: string) => Promise<string>;
//     showPage: (pageName: string, title: string, data: any) => Promise<any>;
//     initFd: (message: Message) => void;
//     commSend: (message: Message) => void;
//     callAgnCnaps2: (message: Message) => Promise<void>;
//     getError: (message: Message) => string;
//     getPrintAttributes: () => any;
//     printCertificate: (pl: any[]) => void;
// }
// declare const NPinyin: {
//     Pinyin: {
//         GetPinyin: (input: string) => string;
//     };
// };
// declare const TellerSystem: {
//     Library: {
//         Ext: {
//             TradeExtension: {
//                 ChineseCodeConverter: {
//                     Convert: (input: string) => string;
//                 };
//             };
//         };
//     };
// };
