﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using TellerSystem.ServiceProxy.Ext.Annotations;
using TellerSystem.ServiceProxy.Ext.TradeBusinessEntitys;

namespace TellerSystem.Library.Ext
{
    public class RuleInfoPSet : INotifyPropertyChanged
    {
        public RuleInfoPSet(string ruleId, string rulePId, string ruleNo, string ruleName, string ruleRemark, string ruleTypeCode, string ruleType, string extId, string ruleComment)
        {
            _ruleId = ruleId;
            _rulePId = rulePId;
            _ruleNo = ruleNo;
            _ruleName = ruleName;
            _ruleRemark = ruleRemark;
            _ruleTypeCode = ruleTypeCode;
            _ruleType = ruleType;
            _extId = extId;
            _ruleComment = ruleComment;
        }
        public RuleInfoPSet(string ruleId, string rulePId, string ruleNo, string ruleName, string ruleRemark, string ruleTypeCode, string ruleType, string extId, string ruleComment, List<TT_RuleInfo> list)
        {
            _ruleId = ruleId;
            _rulePId = rulePId;
            _ruleNo = ruleNo;
            _ruleName = ruleName;
            _ruleRemark = ruleRemark;
            _ruleTypeCode = ruleTypeCode;
            _ruleType = ruleType;
            _extId = extId;
            _ruleComment = ruleComment;

            list.ForEach(drElement =>
            {

                if (drElement.RulePId == ruleId && drElement.RuleId != ruleId)
                {
                    this.Children.Add(new RuleInfoPSet(drElement.RuleId, drElement.RulePId, drElement.RuleNo, drElement.RuleName, drElement.RuleRemark, drElement.RuleTypeCode, drElement.RuleType, drElement.ExtId, drElement.RuleComment, list));
                }

            });

        }
        public RuleInfoPSet(string ruleId, string rulePId, string ruleNo, string ruleName, string ruleRemark, string ruleTypeCode, string ruleType, string extId, string ruleComment, List<TT_RuleInfo> list, List<TT_RuleInfo> powerlist)
        {
            _ruleId = ruleId;
            _rulePId = rulePId;
            _ruleNo = ruleNo;
            _ruleName = ruleName;
            _ruleRemark = ruleRemark;
            _ruleTypeCode = ruleTypeCode;
            _ruleType = ruleType;
            _extId = extId;
            _ruleComment = ruleComment;

            list.ForEach(drElement =>
            {

                if (drElement.RulePId == ruleId && drElement.RuleId != ruleId)
                {
                    this.Children.Add(new RuleInfoPSet(drElement.RuleId, drElement.RulePId, drElement.RuleNo, drElement.RuleName, drElement.RuleRemark, drElement.RuleTypeCode, drElement.RuleType, drElement.ExtId, drElement.RuleComment, list, powerlist) { IsEnabled = false, IsChecked = powerlist.Any(x => x.RuleId == drElement.RuleId), Parent = this });
                }

            });

        }
        public RuleInfoPSet(string ruleId, string rulePId, string ruleNo, string ruleName, string ruleRemark, string ruleTypeCode, string ruleType, string extId, string ruleComment, List<TT_RuleInfo> list, List<TT_RuleInfo> powerlist, List<TT_RuleInfo> grouppowerdeleteentitys, List<TT_RuleInfo> grouppowerentitys)
        {
            _ruleId = ruleId;
            _rulePId = rulePId;
            _ruleNo = ruleNo;
            _ruleName = ruleName;
            _ruleRemark = ruleRemark;
            _ruleTypeCode = ruleTypeCode;
            _ruleType = ruleType;
            _extId = extId;
            _ruleComment = ruleComment;

            list.ForEach(drElement =>
            {

                if (drElement.RulePId == ruleId && drElement.RuleId != ruleId)
                {
                    
                    var ruleInfoPSet = new RuleInfoPSet(drElement.RuleId, drElement.RulePId, drElement.RuleNo, drElement.RuleName,
                                                drElement.RuleRemark, drElement.RuleTypeCode, drElement.RuleType,
                                                drElement.ExtId, drElement.RuleComment, list, powerlist, grouppowerdeleteentitys, grouppowerentitys)
                    {
                        IsEnabled = false,
                        Parent = this
                    };
                    if (powerlist.Any(x => x.RuleId == drElement.RuleId)
                           || (!(grouppowerdeleteentitys.Any(x => x.RuleId == drElement.RuleId))
                              && grouppowerentitys.Any(x => x.RuleId == drElement.RuleId)))
                    {
                        ruleInfoPSet.IsChecked = true;
                    }

                    this.Children.Add(ruleInfoPSet);
                }

            });

        }
        private string _ruleId;
        private string _rulePId;
        private string _ruleNo;
        private string _ruleName;
        private string _ruleRemark;
        private string _ruleTypeCode;
        private string _ruleType;
        private string _extId;
        private string _ruleComment;
        private bool? _ischecked = false;
        private bool _isenable = false;
        /// <summary>
        /// 功能ID
        /// </summary>
        public string RuleId
        {
            get { return _ruleId; }
            set
            {
                _ruleId = value;
                OnPropertyChanged("RuleId");
            }
        }
        /// <summary>
        /// 上级功能ID
        /// </summary>
        public string RulePId
        {
            get { return _rulePId; }
            set
            {
                _rulePId = value;
                OnPropertyChanged("RulePId");
            }
        }
        /// <summary>
        /// 交易(功能)编号
        /// </summary>
        public string RuleNo
        {
            get { return _ruleNo; }
            set
            {
                _ruleNo = value;
                OnPropertyChanged("RuleNo");
            }
        }
        /// <summary>
        /// 功能名称
        /// </summary>
        public string RuleName
        {
            get { return _ruleName; }
            set
            {
                _ruleName = value;
                OnPropertyChanged("RuleName");
            }
        }
        /// <summary>
        /// 功能描述
        /// </summary>
        public string RuleRemark
        {
            get { return _ruleRemark; }
            set
            {
                _ruleRemark = value;
                OnPropertyChanged("RuleRemark");
            }
        }
        /// <summary>
        /// 功能类型号
        /// </summary>
        public string RuleTypeCode
        {
            get { return _ruleTypeCode; }
            set
            {
                _ruleTypeCode = value;
                OnPropertyChanged("RuleTypeCode");
            }
        }
        /// <summary>
        /// 功能类型
        /// </summary>
        public string RuleType
        {
            get { return _ruleType; }
            set
            {
                _ruleType = value;
                OnPropertyChanged("RuleType");
            }
        }
        /// <summary>
        /// 外接系统ID
        /// </summary>
        public string ExtId
        {
            get { return _extId; }
            set
            {
                _extId = value;
                OnPropertyChanged("ExtId");
            }
        }
        /// <summary>
        /// 备注
        /// </summary>
        public string RuleComment
        {
            get { return _ruleComment; }
            set
            {
                _ruleComment = value;
                OnPropertyChanged("RuleComment");
            }
        }

        /// <summary>
        /// 是否选中
        /// </summary>
        public bool? IsChecked
        {
            get { return _ischecked; }
            set
            {
                _ischecked = value;
                OnPropertyChanged("IsChecked");
            }
        }

        /// <summary>
        /// 是否可选
        /// </summary>
        public bool IsEnabled
        {
            get { return _isenable; }
            set
            {
                _isenable = value;
                OnPropertyChanged("IsEnabled");
            }
        }

        private RuleInfoPSet _parent;
        public RuleInfoPSet Parent
        {
            get { return _parent; }
            set
            {
                _parent = value;
                OnPropertyChanged("Parent");
            }
        }

        private readonly ObservableCollection<RuleInfoPSet> _children = new ObservableCollection<RuleInfoPSet>();
        public ObservableCollection<RuleInfoPSet> Children
        {
            get { return _children; }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
        }
    }
    //public class TreeViewListList : INotifyPropertyChanged
    //{
    //    public event PropertyChangedEventHandler PropertyChanged;

    //    [NotifyPropertyChangedInvocator]
    //    protected virtual void OnPropertyChanged(string propertyName)
    //    {
    //        PropertyChangedEventHandler handler = PropertyChanged;
    //        if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
    //    }
    //}
    //public class TreeViewListList<T> : INotifyPropertyChanged
    //{
    //    private T _itemInfo;

    //    public T ItemInfo
    //    {
    //        get { return _itemInfo; }
    //        set
    //        {
    //            _itemInfo = value;
    //            OnPropertyChanged("ItemInfo");
    //        }
    //    }

    //    private ObservableCollection<T> _children;

    //    public ObservableCollection<T> Children
    //    {
    //        get { return _children; }
    //    }

    //    public event PropertyChangedEventHandler PropertyChanged;

    //    [NotifyPropertyChangedInvocator]
    //    protected virtual void OnPropertyChanged(string propertyName)
    //    {
    //        PropertyChangedEventHandler handler = PropertyChanged;
    //        if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
    //    }
    //}
}
