﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Documents;
using System.Windows;
using System.Windows.Media;
using System.Windows.Controls;
using System.Globalization;
using Platform.Presentation.FocusManagers;
using System.Windows.Input;
using System.Data;
using Platform.Controls.TableContainer;
using System.Collections;

namespace TellerSystem.Library.Ext.TradeExtension
{
    public static class ComboBoxDataGridExtension
    {
        #region Extension
        /// <summary>
        /// 获取当前选择行
        /// </summary>
        /// <param name="cbxDataGrid">ComboBoxDataGrid</param>
        /// <returns>当前行(CurrentRow)</returns>
        public static DataRow GetSelectRow(this ComboBoxDataGrid cbxDataGrid)
        {
            DataRowView drv = cbxDataGrid.SelectedItem as DataRowView;
            if (drv == null) return null;

            return drv.Row;
        }

        /// <summary>
        /// 获取当前选择行的值
        /// </summary>
        /// <param name="cbxDataGrid">ComboBoxDataGrid</param>
        /// <returns>DataRow.ItemArray</returns>
        public static string[] GetSelectRowValue(this ComboBoxDataGrid cbxDataGrid)
        {
            DataRow row = GetSelectRow(cbxDataGrid);
            if (row == null) return null;

            return row.ItemArray.Select(obj => obj.ToString()).ToArray();
        }
        #endregion

    }
}