﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Input;

namespace TellerSystem.Library.Ext.TradeExtension
{
    /// <summary>
    /// 影像控件
    /// </summary>
    /// <author>jiying</author>
    /// <date>2012/8/28 11:24:17</date>
    public static class Commands
    {
        #region Constructor & destructor
        static Commands()
        {
            // Capture Image
            CaptureImage = new RoutedUICommand("Capture image", "CaptureImage", typeof(Commands));

            // Remove Image
            RemoveImage = new RoutedUICommand("Remove image", "RemoveImage", typeof(Commands));

            // Clear All Images
            ClearAllImages = new RoutedUICommand("Clear all images", "ClearAllImages", typeof(Commands));

            //click Image
            ClickImage = new RoutedUICommand("Click Image", "ClickImage", typeof(Commands));
        }
        #endregion

        /// <summary>
        /// Captures an image
        /// </summary>
        public static RoutedUICommand CaptureImage { get; private set; }

        /// <summary>
        /// Removes an image
        /// </summary>
        public static RoutedUICommand RemoveImage { get; private set; }

        /// <summary>
        /// Clears all images
        /// </summary>
        public static RoutedUICommand ClearAllImages { get; private set; }
        /// <summary>
        /// Click Image _brcapture will get source
        /// </summary>
        public static RoutedUICommand ClickImage { get; private set; }
    }
}
