// 模拟 RoutedUICommand 类
class RoutedUICommand {
    constructor(
        public text: string,
        public name: string,
        public ownerType: any
    ) {}
}

// 定义 Commands 类
export class Commands {
    static CaptureImage: RoutedUICommand;
    static RemoveImage: RoutedUICommand;
    static ClearAllImages: RoutedUICommand;
    static ClickImage: RoutedUICommand;

    // 静态初始化块模拟静态构造函数
    static {
        // Capture Image
        Commands.CaptureImage = new RoutedUICommand("Capture image", "CaptureImage", Commands);

        // Remove Image
        Commands.RemoveImage = new RoutedUICommand("Remove image", "RemoveImage", Commands);

        // Clear All Images
        Commands.ClearAllImages = new RoutedUICommand("Clear all images", "ClearAllImages", Commands);

        // click Image
        Commands.ClickImage = new RoutedUICommand("Click Image", "ClickImage", Commands);
    }
}