import Message from "../../Communication/Message";
import { TransitType } from "../../Communication/MessageHelper/TransitType";


namespace SystemFunction {
    export function InitFd(_: any, message: Message) { }
    export function CommSend(_: any, message: Message) { }
}

namespace UserFunction {
    export function ConvertDictionaryToXML(_: { [key: string]: string }): string {
        return '';
    }
    export function ConvertXMLToDataTable(xml: string): { rows: { [key: string]: string }[] } {
        return { rows: [] };
    }
}

namespace TellerSystem {
    export namespace Communication {
        export namespace MessageHelper {
            export const TransitType = {
                CallNoFileSys: 'CallNoFileSys'
            };
        }
    }
}

namespace TradeManagerHandle {
    export function GetAllKinbrInfo(kinbrNo: string) {
        return [];
    }
}

class LoginUserInfo {
    static get KinbrNo() {
        return '';
    }
}

class Currency2DicManager {
    private static _instance: Currency2DicManager;
    private _dicCurrency: { [key: string]: string } = {};
    private _dicTicketDistinct: { [key: string]: string } = {};
    private _dicKinbr: { [key: string]: string } = {};

    private constructor() {
        this._dicCurrency = {};
        this._dicTicketDistinct = {};
        this._dicKinbr = {};
    }

    static get Instance(): Currency2DicManager {
        if (!this._instance) {
            this._instance = new Currency2DicManager();
        }
        return this._instance;
    }

    public GetDicCurrency(): { [key: string]: string } {
        if (Object.keys(this._dicCurrency).length === 0) {
            const message = new Message();
            SystemFunction.InitFd(null, message);
            SystemFunction.CommSend(null, message);
            message.Fd16 = '2016';
            const dic: { [key: string]: string } = {};
            message.fileData = UserFunction.ConvertDictionaryToXML(dic);
            message.TransitNode = TransitType.CallNoFileSys;
            if (message.DoTransit() && message.Fd12 === '0000') {
                const dt = UserFunction.ConvertXMLToDataTable(message.fileData);
                dt.rows.forEach((row) => {
                    this._dicCurrency[row['CurrencyNo']] = row['CurrencyName'];
                });
            }
        }
        return this._dicCurrency;
    }

    public GetDicTicketDistinct(): { [key: string]: string } {
        if (Object.keys(this._dicTicketDistinct).length === 0) {
            const message = new Message();
            SystemFunction.InitFd(null, message);
            SystemFunction.CommSend(null, message);
            message.Fd16 = '2015';
            const dic: { [key: string]: string } = {};
            message.fileData = UserFunction.ConvertDictionaryToXML(dic);
            message.TransitNode = TransitType.CallNoFileSys;
            if (message.DoTransit() && message.Fd12 === '0000') {
                const dt = UserFunction.ConvertXMLToDataTable(message.fileData);
                dt.rows.forEach((row) => {
                    this._dicTicketDistinct[row['CouponsNo']] = row['CouponsName'];
                });
            }
        }
        return this._dicTicketDistinct;
    }

    public GetDicKinbr(): { [key: string]: string } {
        if (Object.keys(this._dicKinbr).length === 0) {
            const entitys = TradeManagerHandle.GetAllKinbrInfo(LoginUserInfo.KinbrNo);
            entitys.forEach((entity) => {
                this._dicKinbr[entity.KinbrName] = entity.KinbrNo;
            });
        }
        return this._dicKinbr;
    }
}

export default Currency2DicManager;
