// 模拟 DependencyObject 类
class DependencyObject {
    private properties: { [key: string]: any } = {};

    getValue(property: string): any {
        return this.properties[property];
    }

    setValue(property: string, value: any): void {
        this.properties[property] = value;
    }
}

// 模拟 TabItem 类
class TabItem {}

// 模拟 UIPropertyMetadata 类
class UIPropertyMetadata {
    constructor(public defaultValue: any) {}
}

// 模拟 DependencyProperty 类
class DependencyProperty {
    constructor(
        public name: string,
        public type: any,
        public ownerType: any,
        public metadata: UIPropertyMetadata
    ) {}

    static registerAttached(name: string, type: any, ownerType: any, metadata: UIPropertyMetadata): DependencyProperty {
        return new DependencyProperty(name, type, ownerType, metadata);
    }
}

// 定义 IPageExtension 类
class IPageExtension {
    static readonly CurrentTabItemProperty: DependencyProperty =
        DependencyProperty.registerAttached("CurrentTabItem", TabItem, IPageExtension, new UIPropertyMetadata(null));

    static GetCurrentTabItem(obj: DependencyObject): TabItem {
        return obj.getValue(IPageExtension.CurrentTabItemProperty.name) as TabItem;
    }

    static SetCurrentTabItem(obj: DependencyObject, value: TabItem): void {
        obj.setValue(IPageExtension.CurrentTabItemProperty.name, value);
    }
}

export { IPageExtension };