﻿using System.Xml;

namespace TellerSystem.Library.Ext.TradeExtension
{
    /// <summary>
    /// 报文数据
    /// </summary>
    public class MessageData
    {
        public MessageData()
        {
                
        }

        public MessageData(XmlNode xnRoot)
        {
            XmlNode node = xnRoot.SelectSingleNode("Message");
            Type = node.Attributes["type"].Value;
            XmlNode nodeItem = node.SelectSingleNode("info");
            Key = nodeItem.Attributes["Key"].Value;
            Sender = nodeItem.Attributes["Sender"].Value;
            Time = nodeItem.Attributes["Time"].Value;
            Title = nodeItem.Attributes["Title"].Value;
            Trade = nodeItem.Attributes["Trade"].Value;
            Other = nodeItem.Attributes["Other"].Value;
        }

        /// <summary>
        ///     0-表示公告消息;
        ///     1-表示任务推送;
        ///     2-表示任务消息
        /// </summary>
        public string Type { get; set; }

        /// <summary>
        ///     发起人
        /// </summary>
        public string Sender { get; set; }

        /// <summary>
        ///     发起时间
        /// </summary>
        public string Time { get; set; }

        /// <summary>
        ///     标题
        /// </summary>
        public string Title { get; set; }

        /// <summary>
        ///     交易名称
        /// </summary>
        public string Trade { get; set; }

        /// <summary>
        ///     关键key
        /// </summary>
        public string Key { get; set; }

        /// <summary>
        ///     其他
        /// </summary>
        public string Other { get; set; }
    }
}