// 假设 NotificationAttribute 是一个装饰器，这里简单模拟其定义
function NotificationAttribute(code: string, description: string) {
    return function (target: Function) {
        // 可以在这里添加更多逻辑，目前仅做标记
        target.prototype.notificationCode = code;
        target.prototype.notificationDescription = description;
    };
}

// 假设 MessageBase 和 MessageData 类型定义如下
class MessageBase {
    // 可以根据实际情况添加 MessageBase 的属性和方法
}

class MessageData {
    Sender: string;
    Time: string;
    Key: string;
    Title: string;

    constructor(sender: string, time: string, key: string, title: string) {
        this.Sender = sender;
        this.Time = time;
        this.Key = key;
        this.Title = title;
    }
}

@NotificationAttribute("0", "公告消息")
class NotificationMessage extends MessageBase {
    Sender: string;
    Time: string;
    Key: string;
    Title: string;

    constructor(data: MessageData) {
        super();
        this.Sender = data.Sender;
        this.Time = data.Time;
        this.Key = data.Key;
        this.Title = data.Title;
    }
}

export { NotificationMessage };