﻿using System;
using TellerSystem.Library.Ext.TradeInterfaces;

namespace TellerSystem.Library.Ext.TradeExtension
{
    [Notification("1", "任务消息")]
    internal class TaskMessage : MessageBase
    {
        #region Field

        private readonly dynamic _mainPage;

        #endregion

        public TaskMessage(MessageData data)
        {
            string[] des = data.Title.Split(new[] {"||"}, StringSplitOptions.None);
            string tradeNo = des[0];
            string state = des[1];
            string taskdes;
            switch (state)
            {
                case "Super":
                    taskdes = "等待复核";
                    break;
                case "Auth":
                    taskdes = "等待授权";
                    break;
                case "Submit":
                    taskdes = "等待确认";
                    break;
                default:
                    taskdes = "其他";
                    break;
            }


            if (_mainPage == null)
            {
                _mainPage = MainPageManager.GetMainPage();
            }

            StartTeller = data.Sender;
            StartTime = FormatDateTime(data.Time);
            TradeDes = tradeNo + "  " + _mainPage.GetTradeName(tradeNo);
            TaskDes = taskdes;
            Key = data.Key;
            Other = data.Other;
            Trade = data.Trade;
        }


        public string StartTeller { get; set; }

        public string StartTime { get; set; }

        public string TradeDes { get; set; }

        public string TaskDes { get; set; }

        public string Key { get; set; }

        public string Other { get; set; }

        public string Trade { get; set; }
    }
}