// 假设 Notification 装饰器可以用一个函数模拟
function Notification(id: string, name: string) {
    return function (target: Function) {
        // 这里可以添加装饰器的逻辑，暂时只是占位
    };
}

// 假设 MessageBase 类在某个地方定义，这里先做一个空类
class MessageBase { }

// 假设 MessageData 接口定义如下
interface MessageData {
    Title: string;
    Sender: string;
    Time: string;
    Key: string;
    Other: string;
    Trade: string;
}

// 假设 MainPageManager 类定义如下
class MainPageManager {
    static getMainPage() {
        // 这里返回一个动态对象，在 TypeScript 里用 any 类型
        return {} as any;
    }
}

// 模拟 FormatDateTime 函数
function FormatDateTime(time: string): string {
    return time;
}

@Notification("1", "任务消息")
class TaskMessage extends MessageBase {
    private _mainPage: any;

    StartTeller: string;
    StartTime: string;
    TradeDes: string;
    TaskDes: string;
    Key: string;
    Other: string;
    Trade: string;

    constructor(data: MessageData) {
        super();
        const des = data.Title.split("||");
        const tradeNo = des[0];
        const state = des[1];
        let taskdes: string;
        switch (state) {
            case "Super":
                taskdes = "等待复核";
                break;
            case "Auth":
                taskdes = "等待授权";
                break;
            case "Submit":
                taskdes = "等待确认";
                break;
            default:
                taskdes = "其他";
                break;
        }

        if (!this._mainPage) {
            this._mainPage = MainPageManager.getMainPage();
        }

        this.StartTeller = data.Sender;
        this.StartTime = FormatDateTime(data.Time);
        this.TradeDes = `${tradeNo}  ${this._mainPage.GetTradeName(tradeNo)}`;
        this.TaskDes = taskdes;
        this.Key = data.Key;
        this.Other = data.Other;
        this.Trade = data.Trade;
    }
}

export { TaskMessage };