﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.IO;

namespace TellerSystem.Library.Ext.TradeExtension
{
    /// <summary>
    /// 省市区信息管理类
    /// </summary>
    public class ProvinceCityCountyManager
    {
        /// <summary>
        /// 
        /// </summary>
        public ProvinceCityCountyManager()
        {
            _provinces = new List<Province>();
        }
        private static ProvinceCityCountyManager _instance;
        /// <summary>
        /// 
        /// </summary>
        public static ProvinceCityCountyManager Instance
        {
            get
            {
                if (_instance == null)
                    _instance = new ProvinceCityCountyManager();
                return _instance;
            }
        }
        private List<Province> _provinces;

        public List<Province> GetProvinces()
        {
            if (_provinces != null && _provinces.Count > 0)
                return _provinces;
            else
            {
                if (System.ComponentModel.DesignerProperties.GetIsInDesignMode(new System.Windows.DependencyObject()))
                    return new List<Province>();
                List<Province> provinces = new List<Province>();
                XmlDocument doc = new XmlDocument();
                doc.Load(@"Config/PCC.xml");
                foreach (XmlNode item in doc.SelectNodes("/Root/Province"))
                {
                    Province p = new Province { Value = item.Attributes["Code"].Value.ToString(), Key = item.Attributes["Text"].Value.ToString(), Child = new List<City>() };
                    foreach (XmlNode item1 in item.SelectNodes("City"))
                    {
                        City c = new City { Value = item1.Attributes["Code"].Value.ToString(), Key = item1.Attributes["Text"].Value.ToString(), Child = new List<County>() };
                        foreach (XmlNode item2 in item1.SelectNodes("County"))
                        {
                            c.Child.Add(new County { Value = item2.Attributes["Code"].Value.ToString(), Key = item2.Attributes["Text"].Value.ToString() });
                        }
                        p.Child.Add(c);
                    }
                    provinces.Add(p);
                }
                if (provinces != null && provinces.Count > 0)
                    _provinces = provinces;
                return provinces;
            }
        }
    }
}
