﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Microsoft.Reporting.WinForms;
using System.Data;
using Platform.Controls.ComponentContainer;
using Platform.Controls.ControlsHelper;
using TellerSystem.Library.Ext.TradeExtension;
using TellerSystem.Library.Ext.Function;
using System.Diagnostics;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;

namespace TellerSystem.Library.Ext.TradeExtension
{

    /// <summary>
    /// ReportWindow.xaml 的交互逻辑
    /// </summary>
    public partial class ReportWindow : Window
    {
        #region 属性
        public DataBox Source { get; set; }
        #endregion

        public ReportWindow()
        {
            InitializeComponent();
        }

        private void btnPrint_Click(object sender, RoutedEventArgs e)
        {
            Process[] processes = Process.GetProcessesByName("Platform.PrintService");
            if (processes.Length > 0)
            {
                foreach (Process process in processes)
                {
                    if (!process.HasExited)
                        process.Kill();
                }
            }
            Report.PrintDialog();
            processes = Process.GetProcessesByName("Platform.PrintService");
            if (processes.Length > 0)
            {
                foreach (Process process in processes)
                {
                    if (!process.HasExited)
                        process.Kill();
                }
            }
        }

        private void btnExcel_Click(object sender, RoutedEventArgs e)
        {
            //Report.ExportDialog(new RenderingExtension());
            if (Source != null)
            {

                DataTable table = Source.GetDataTableForPrint();
                if (table != null)
                {
                    System.Windows.Forms.SaveFileDialog saveDialog = new System.Windows.Forms.SaveFileDialog { FileName = "fileName" };
                    saveDialog.Filter = "Excel Files|*.xlsx;*.xls;";
                    saveDialog.ShowDialog();
                    var outputFile = saveDialog.FileName;
                    if (outputFile.IndexOf(":", System.StringComparison.Ordinal) < 0)
                        return; //被点了取消 
                    var isByNPOI = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("IsByNPOI");
                    if (isByNPOI != null && isByNPOI.ToUpper() == "TRUE")
                    {
                        ExcelFuntion.ExportToExcel(table, outputFile);
                    }
                    else
                    {
                        ExcelFuntion.ExportExcelByDataTable(table, outputFile);
                    }
                }
            }
        }

        private void btnRefresh_Click(object sender, RoutedEventArgs e)
        {
            Report.RefreshReport();
        }
    }
}
