﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Windows;
using System.Windows.Data;

namespace TellerSystem.Library.Ext.TradeExtension
{
    /// <summary>
    /// 界面双向绑定定义实体
    /// </summary>
    public class BatSysInfoUI : INotifyPropertyChanged
    {
        #region 变量
        public string sysname;
        public string batinfoname;
        public string batcode;
        public string batname;   
        public string batdesp; 
        public string syscode;    
        public string mainseqn;   
        public string stat;       
        public string bat_ind;   
        public string content;
        public string txdate;       
        public bool startEnabled;
        public bool lookEnabled;
        public string timespan;
        public string filler1;
        public string autoRefreshTime;
        public string batcheck;
        #endregion

        #region 属性
        /// <summary>
        /// 系统名称
        /// </summary>
        public string SysName
        {
            get { return sysname; }
            set
            {
                sysname = value;
                if (this.PropertyChanged != null)
                {
                    this.PropertyChanged.Invoke(this, new PropertyChangedEventArgs("SysName"));
                }

            }
        }
        /// <summary>
        /// 批量名称
        /// </summary>
        public string BatInfoName
        {
            get { return batinfoname; }
            set
            {
                batinfoname = value;
                if (this.PropertyChanged != null)
                {
                    this.PropertyChanged.Invoke(this, new PropertyChangedEventArgs("BatInfoName"));
                }

            }
        }
        /// <summary>
        /// 批量编码
        /// </summary>
        public string BatCode
        {
            get { return batcode; }
            set
            {
                batcode = value;
                if (this.PropertyChanged != null)
                {
                    this.PropertyChanged.Invoke(this, new PropertyChangedEventArgs("BatCode"));
                }

            }
        }
        /// <summary>
        /// 批量名称
        /// </summary>
        public string BatName
        {
            get { return batname; }
            set
            {
                batname = value;
                if (this.PropertyChanged != null)
                {
                    this.PropertyChanged.Invoke(this, new PropertyChangedEventArgs("BatName"));
                }

            }
        }
        /// <summary>
        /// 批量说明
        /// </summary>
        public string BatDesp
        {
            get { return batdesp; }
            set
            {
                batdesp = value;
                if (this.PropertyChanged != null)
                {
                    this.PropertyChanged.Invoke(this, new PropertyChangedEventArgs("BatDesp"));
                }

            }
        }
        /// <summary>
        /// 启动日期
        /// </summary>
        public string TxDate
        {
            get { return txdate; }
            set
            {
                txdate = value;
                if (this.PropertyChanged != null)
                {
                    this.PropertyChanged.Invoke(this, new PropertyChangedEventArgs("TxDate"));
                }

            }
        }
        /// <summary>
        /// 系统编号
        /// </summary>
        public string SysCode
        {
            get { return syscode; }
            set
            {
                syscode = value;
                if (this.PropertyChanged != null)
                {
                    this.PropertyChanged.Invoke(this, new PropertyChangedEventArgs("SysCode"));
                }

            }
        }
        /// <summary>
        /// 主顺序号
        /// </summary>
        public string MainSeqn
        {
            get { return mainseqn; }
            set
            {
                mainseqn = value;
                if (this.PropertyChanged != null)
                {
                    this.PropertyChanged.Invoke(this, new PropertyChangedEventArgs("MainSeqn"));
                }

            }
        }
        /// <summary>
        /// 批量处理状态  0:未处理  1:正在处理  2:已成功  3:批量失败
        /// </summary>
        public string Stat
        {
            get { return stat; }
            set
            {
                stat = value;
                if (this.PropertyChanged != null)
                {
                    this.PropertyChanged.Invoke(this, new PropertyChangedEventArgs("Stat"));
                }

            }
        }
        /// <summary>
        /// 是否自动批量  0:不参与自动跑批  1:参与自动跑批
        /// </summary>
        public string Bat_Ind
        {
            get { return bat_ind; }
            set
            {
                bat_ind = value;
                if (this.PropertyChanged != null)
                {
                    this.PropertyChanged.Invoke(this, new PropertyChangedEventArgs("Bat_Ind"));
                }

            }
        }
        /// <summary>
        /// 批量启动间隔  0:按天递增  1:按月递增
        /// </summary>
        public string Time_Span
        {
            get { return timespan; }
            set
            {
                timespan = value;
                if (this.PropertyChanged != null)
                {
                    this.PropertyChanged.Invoke(this, new PropertyChangedEventArgs("Time_Span"));
                }

            }
        }
        /// <summary>
        /// 按钮显示内容
        /// </summary>
        public string BatContent
        {
            get { return content; }
            set
            {
                content = value;
                if (this.PropertyChanged != null)
                {
                    this.PropertyChanged.Invoke(this, new PropertyChangedEventArgs("BatContent"));
                }

            }
        }
        /// <summary>
        /// 系统名称
        /// </summary>
        public string Filler1
        {
            get { return filler1; }
            set
            {
                filler1 = value;
                if (this.PropertyChanged != null)
                {
                    this.PropertyChanged.Invoke(this, new PropertyChangedEventArgs("Filler1"));
                }

            }
        }
        /// <summary>
        /// 当前实体
        /// </summary>
        public BatSysInfoUI BatSysInfo
        {
            get;
            set;
        }
        /// <summary>
        /// 启动按钮
        /// </summary>
        public bool StartEnabled
        {
            get { return startEnabled; }
            set
            {
                startEnabled = value;
                if (this.PropertyChanged != null)
                {
                    this.PropertyChanged.Invoke(this, new PropertyChangedEventArgs("StartEnabled"));
                }

            }
        }
        /// <summary>
        /// 启动前是否校验
        /// </summary>
        public string BatCheck
        {
            get { return batcheck; }
            set
            {
                batcheck = value;
                if (this.PropertyChanged != null)
                {
                    this.PropertyChanged.Invoke(this, new PropertyChangedEventArgs("BatCheck"));
                }

            }
        }
        /// <summary>
        /// 查看详情
        /// </summary>
        public bool LookEnabled
        {
            get { return lookEnabled; }
            set
            {
                lookEnabled = value;
                if (this.PropertyChanged != null)
                {
                    this.PropertyChanged.Invoke(this, new PropertyChangedEventArgs("LookEnabled"));
                }

            }
        }

        /// <summary>
        /// 自动刷新的时间间隔(按秒计)
        /// </summary>
        public string AutoRefreshTime
        {
            get { return autoRefreshTime; }
            set
            {
                autoRefreshTime = value;
                if (this.PropertyChanged != null)
                {
                    this.PropertyChanged.Invoke(this, new PropertyChangedEventArgs("AutoRefreshTime"));
                }

            }
        }     
        #endregion
      
        public event PropertyChangedEventHandler PropertyChanged;
    }
    [ValueConversion(typeof(bool), typeof(string))]
    public class BatCheckConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            string strValue = value as string;
            if (strValue == "1")
            {
                return true;
            }
            if (strValue == "0")
            {
                return false;
            }
            return DependencyProperty.UnsetValue;
           
        }       
        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            bool blcheck = (bool)value;
            if (blcheck)
            {
                return "1";
            }
            else
            {
                return "0";
            }
        }
    }
  
    
}
