// 假设这些类型在其他文件中定义，这里先使用 any 占位

import { BatSysInfo } from "@/views/front/develop/ServiceProxy.Ext/ServiceEntitys/BatSysInfo";


// 假设这些函数在其他文件中定义
namespace SysBatchHandle {
    export function GetBatSysInfos(condition: string): BatSysInfo[] | null {
        // 这里只是占位实现，实际需要填充逻辑
        return null;
    }

    export function UpDateBatSysInfo(info: BatSysInfo): boolean {
        // 这里只是占位实现，实际需要填充逻辑
        return false;
    }
}

/**
 * 根据系统编号、批量编号判断该编号批量现在能否执行
 * @param syscode 系统编号
 * @param batcode 批量编号
 * @returns 是否允许执行
 */
export function IsAllowRun(syscode: string, batcode: string): boolean {
    // 查询批量顺序执行表数据
    const data = SysBatchHandle.GetBatSysInfos("1=1");
    if (data === null || data.length === 0) {
        return false;
    }

    // 查询是否存在该调记录
    const result = data.filter((batSysInfo) => {
        return batSysInfo.syscode === syscode && batSysInfo.batcode === batcode;
    });
    if (result.length === 0) {
        return false;
    }

    // 查到的目标批量实例
    const currentItem = result[0];
    // 批量状态：0:未处理  1:正在处理  2:已成功  3:结账失败
    for (const batSysInfo of data) {
        // 查询到目标批量实例(未处理状态)
        if (batSysInfo.syscode === syscode && batSysInfo.batcode === batcode) {
            const temp = data.find((x) => {
                return parseInt(currentItem.mainseqn) > parseInt(x.mainseqn) && parseInt(currentItem.mainseqn) - parseInt(x.mainseqn) < 2;
            });
            if (temp === undefined) {
                return true; // 说明是第一个元素
            }
            if (temp.stat !== "2") {
                return false;
            } else {
                if (batSysInfo.stat === "0" || batSysInfo.stat === "3") {
                    return true;
                }
            }
        }

        if (batSysInfo.stat === "2") {
            // 已成功执行
            continue;
        }
        if (batSysInfo.stat === "1") {
            // 正在处理  同级顺序
            if (batSysInfo.mainseqn === currentItem.mainseqn) {
                continue;
            }
            // return false;
        }
    }
    return false;
}

/**
 * 更新指定批量状态
 * @param syscode 系统编号
 * @param batcode 批量编号
 * @param stat 状态 0:未处理  1:正在处理  2:已成功  3:批量失败
 * @returns 是否更新成功
 */
export function UpdateBatchStat(syscode: string, batcode: string, stat: string): boolean {
    const data = SysBatchHandle.GetBatSysInfos(`syscode='${syscode}' and batcode='${batcode}'`);
    if (data === null || data.length === 0) {
        return false;
    }
    data[0].stat = stat;
    return SysBatchHandle.UpDateBatSysInfo(data[0]);
}
