// 模拟 EventAggregator 类
class EventAggregator {
    // 这里可以添加 EventAggregator 的具体实现
    constructor() {}
}

// 定义 TellerSystemEventAggregator 类
class TellerSystemEventAggregator extends EventAggregator {
    private static _instance: TellerSystemEventAggregator;

    // 私有构造函数，防止外部实例化
    private constructor() {
        super();
    }

    // 静态方法，用于获取单例实例
    public static get Instance(): TellerSystemEventAggregator {
        if (!this._instance) {
            this._instance = new TellerSystemEventAggregator();
        }
        return this._instance;
    }
}

export { TellerSystemEventAggregator };