﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Security.Cryptography;
using System.Windows;
using System.Windows.Controls;
using Platform.Presentation.FocusManagers;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;
using Platform.Common.RunningParameters;
using TellerSystem.Library.Ext.Function;
using Platform.Controls.ControlsHelper;
using Platform.Presentation.FocusCheck;
namespace TellerSystem.Library.Ext.TradeExtension
{
    public class Encrypte : System.Windows.DependencyObject
    {
        private const string key = "33333333333333333333333333333333";

        public static string AccountNo = string.Empty;

        /// <summary>
        /// 使用服务端的算法加密mac数据
        /// </summary>
        /// <param name="macdata"></param>
        /// <returns></returns>
        public static string GetServerMac(string macdata)
        {
            string mac = EncrypteHandle.GetMac(macdata, macdata.Length.ToString());
            return mac;
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="strKey"></param>
        /// <param name="macdata"></param>
        /// <returns></returns>
        public static string GetMac(string strKey, string macdata)
        {
            byte[] ba = System.Text.ASCIIEncoding.Default.GetBytes(macdata);
            string ascii = "";

            foreach (byte b in ba)
                ascii += b.ToString("x");

            string zakl = strKey.Substring(0, 16);
            string zakr = strKey.Substring(16, 16);

            string des = DES_1(ascii, zakl, 0);
            string xor = xOr(des, "3900000000000000");
            string des1 = DES_1(xor, zakl, 0);
            string des2 = DES_1(des1, zakr, 1);
            string des3 = DES_1(des2, zakl, 0);
            return des3;
        }
        public static string GetPinBlock(string account, string pin)
        {
            string result_acount = string.Empty;
            string str = "0" + pin.Length.ToString() + pin;
            //处理密码，以一位的0、PIN的长度、PIN和填充字符（十六进制的“F”）组成一个十六位的块
            string pinblock = str.PadRight(16, 'F');
            //对帐号的处理，帐号分为13位和19位以及无帐号3种情况。
            if (account.Length == 19)
            {
                result_acount = account.Substring(6, 12);
            }
            else if (account.Length == 13)
            {
                result_acount = account.Substring(0, 12);
            }
            else
            {
                result_acount = "0000000000000000";
            }
            string accountblock = result_acount.PadLeft(16, '0');
            //最终的PIN是第一个和第二个PIN块异或的结果
            string resultPin = (Convert.ToInt64(pinblock, 16) ^ Convert.ToInt64(accountblock, 16)).ToString("X2");
            if (resultPin.Length % 2 != 0)
            {
                resultPin = resultPin.PadLeft(16, '0');
            }

            return resultPin;
        }

        /// <summary>
        /// mac加密前的处理
        /// </summary>
        /// <param name="pin"></param>
        /// <returns></returns>
        public static string DePinBlock(string pin)
        {
            //pin = pin.Substring(1, pin.Length - 1);
            string pin1 = pin.Replace("F", "");
            int n = pin.Length - pin1.Length - 1;
            if (n >= 4)
                pin1 = pin1.Substring(2, pin1.Length - 2);
            else
                pin1 = pin1.Substring(3, pin1.Length - 3);
            return pin1;
        }

        public static string GetAcctountElementName(DependencyObject obj)
        {
            return (string)obj.GetValue(AcctountElementNameProperty);
        }

        public static void SetAcctountElementName(DependencyObject obj, string value)
        {
            obj.SetValue(AcctountElementNameProperty, value);
        }

        // Using a DependencyProperty as the backing store for AcctountElementName.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty AcctountElementNameProperty =
            DependencyProperty.RegisterAttached("AcctountElementName", typeof(string), typeof(Encrypte), new UIPropertyMetadata(null));

        public static bool GetIsEncrypte(DependencyObject obj)
        {
            return (bool)obj.GetValue(IsEncrypteProperty);
        }

        public static void SetIsEncrypte(DependencyObject obj, bool value)
        {
            obj.SetValue(IsEncrypteProperty, value);
        }

        // Using a DependencyProperty as the backing store for IsEncrypte.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty IsEncrypteProperty =
            DependencyProperty.RegisterAttached("IsEncrypte", typeof(bool), typeof(Encrypte), new PropertyMetadata(false, new PropertyChangedCallback(OnIsEncrypteChanged)));

        private static void OnIsEncrypteChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            //PasswordBox pwdbox = (PasswordBox)d;

            FocusManager.RemovePreviewLostFocusHandler(d, new RoutedEventHandler(PreviewPasswordBox_LostFocus));
            FocusManager.AddPreviewLostFocusHandler(d, new RoutedEventHandler(PreviewPasswordBox_LostFocus));
        }

        /// <summary>
        /// 是否是第三方加密
        /// </summary>
        public static readonly DependencyProperty IsChannelProperty =
            DependencyProperty.RegisterAttached("IsChannel", typeof(bool), typeof(Encrypte), new UIPropertyMetadata(false));

        public static bool GetIsChannel(DependencyObject obj)
        {
            return (bool)obj.GetValue(IsChannelProperty);
        }

        public static void SetIsChannel(DependencyObject obj, bool value)
        {
            obj.SetValue(IsChannelProperty, value);
        }
        /// <summary>
        /// 银联渠道加密
        /// </summary>
        public static readonly DependencyProperty IsChannel_SecProperty =
            DependencyProperty.RegisterAttached("IsChannel_Sec", typeof(bool), typeof(Encrypte), new UIPropertyMetadata(false));

        public static bool GetIsChannel_Sec(DependencyObject obj)
        {
            return (bool)obj.GetValue(IsChannel_SecProperty);
        }

        public static void SetIsChannel_Sec(DependencyObject obj, bool value)
        {
            obj.SetValue(IsChannel_SecProperty, value);
        }



        /// <summary>
        /// 
        /// </summary>
        /// <param name="obj"></param>
        /// <returns></returns>
        public static string GetIdentityNo(DependencyObject obj)
        {
            return (string)obj.GetValue(IdentityNoProperty);
        }

        public static void SetIdentityNo(DependencyObject obj, string value)
        {
            obj.SetValue(IdentityNoProperty, value);
        }

        // Using a DependencyProperty as the backing store for IdentityNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty IdentityNoProperty =
            DependencyProperty.RegisterAttached("IdentityNo", typeof(string), typeof(Encrypte), new UIPropertyMetadata(null));


        /// <summary>
        /// 加密方式 国密/国际,默认国际 --Add lipeng by 20210609
        /// EncrypteType=true 表示国密形式,没有默认国际
        /// </summary>
        /// <param name="obj"></param>
        /// <returns></returns>
        public static bool GetEncrypteType(DependencyObject obj)
        {
            return (bool)obj.GetValue(EncrypteTypeProperty);
        }

        public static void SetEncrypteType(DependencyObject obj, bool value)
        {
            obj.SetValue(EncrypteTypeProperty, value);
        }

        // Using a DependencyProperty as the backing store for IdentityNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty EncrypteTypeProperty =
            DependencyProperty.RegisterAttached("EncrypteType", typeof(bool), typeof(Encrypte), new UIPropertyMetadata(false));


        /// <summary>
        /// 是否校验简单密码
        /// </summary>
        /// <param name="obj"></param>
        /// <returns></returns>
        public static bool GetIsCheckPassword(DependencyObject obj)
        {
            return (bool)obj.GetValue(IsCheckPasswordProperty);
        }

        public static void SetIsCheckPassword(DependencyObject obj, bool value)
        {
            obj.SetValue(IsCheckPasswordProperty, value);
        }

        // Using a DependencyProperty as the backing store for IsCheckPassword.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty IsCheckPasswordProperty =
            DependencyProperty.RegisterAttached("IsCheckPassword", typeof(bool), typeof(Encrypte), new UIPropertyMetadata(false));


        private static void GetAcctount(string elementName, DependencyObject element, ref string acctount)
        {
            if (element is TextBox && ((TextBox)element).Name == elementName)
            {
                acctount = ((TextBox)element).Text;
            }

            int count = System.Windows.Media.VisualTreeHelper.GetChildrenCount(element);

            for (int i = 0; i < count; i++)
            {
                DependencyObject child = System.Windows.Media.VisualTreeHelper.GetChild(element, i);

                GetAcctount(elementName, child, ref acctount);
            }
        }
        /// <summary>
        /// 密码控件失去焦点的时候，请求加密
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private static void PreviewPasswordBox_LostFocus(object sender, RoutedEventArgs e)
        {
            // 海南银行一机一密的工作秘钥（命名格式暂定：pinpad.终端号.zpk）
            // 其中的终端号需要从密码键盘获取

            string workKeyName = null;
            // 海南银行一机一密的工作秘钥（命名格式暂定：pinpad.终端号.zmk）
            string proKeyName = null;
            PasswordBox pbox = (PasswordBox)sender;
            if (SystemFunction.Len(pbox.Password) != 6)
            {
                pbox.ShowTip("请输入6位密码!");
                pbox.Password = "";
                var focus = Platform.Presentation.FocusManagers.FocusManager.GetManagerInstance(pbox);
                focus.SetFocus(pbox);
                focus.IsFocusContinue = false;
                e.Handled = true;
                return;
            }
            if (Encrypte.GetIsCheckPassword(pbox))
            {
                string identityno = Encrypte.GetIdentityNo(pbox);
                string num = "";
                if (!string.IsNullOrEmpty(identityno))
                {
                    // 先找到最顶层的元素，再往下找所有子元素
                    DependencyObject parent = pbox;

                    while (parent != null && !(parent is Platform.Presentation.PageFunctions.TradePage))
                        parent = System.Windows.Media.VisualTreeHelper.GetParent(parent);

                    GetAcctount(identityno, parent, ref num);
                }

                if (UserFunction.IsSamplePassword(null, pbox.Password.Trim(), num))
                {
                    pbox.ShowTip("新密码过于简单!");
                    pbox.Password = "";
                    var focus = Platform.Presentation.FocusManagers.FocusManager.GetManagerInstance(pbox);
                    focus.SetFocus(pbox);
                    focus.IsFocusContinue = false;
                    e.Handled = true;
                    return;
                }
            }
            if (!string.IsNullOrWhiteSpace(pbox.Password))
            {
                string acctountElementName = Encrypte.GetAcctountElementName(pbox);


                if (!string.IsNullOrEmpty(acctountElementName))
                {
                    // 先找到最顶层的元素，再往下找所有子元素
                    DependencyObject parent = pbox;

                    while (parent != null && !(parent is Platform.Presentation.PageFunctions.TradePage))
                        parent = System.Windows.Media.VisualTreeHelper.GetParent(parent);

                    GetAcctount(acctountElementName, parent, ref AccountNo);
                }
                if (string.IsNullOrWhiteSpace(AccountNo))
                {
                    AccountNo = "0000000000000000";
                }
                AccountNo = AccountNo.Trim();

                PasswordBox pwdbox = (PasswordBox)sender;

                //多法人调用银联加密
                string legal_pwd_key = LoginAuthentication.Instance.GroupKinbrNo;

                /// <summary>
                /// 版本标志
                /// </summary>
                string flag = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
                string res = string.Empty;
                switch (flag)
                {
                    case "V5":
                        if (TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("EncrypteGM") == "true")
                        {
                            //国密改造
                            string encrypteType = Encrypte.GetEncrypteType(pbox).ToString().ToLower();
                            if (Encrypte.GetEncrypteType(pbox))
                            {
                                res = EncrypteHandle.EncrypteUnion_GM(AccountNo, pwdbox.Password.Trim(), legal_pwd_key, encrypteType);
                            }
                            else
                            {
                                res = EncrypteHandle.EncrypteUnion(AccountNo, pwdbox.Password.Trim(), legal_pwd_key); //多法人调用银联加密多传一个参数
                            }
                        }
                        else
                        {
                            res = EncrypteHandle.EncrypteUnion(AccountNo, pwdbox.Password.Trim(), legal_pwd_key); //多法人调用银联加密多传一个参数
                        }
                        //res = EncrypteHandle.EncrypteUnion(AccountNo, pwdbox.Password.Trim(), legal_pwd_key); //多法人调用银联加密多传一个参数
                        break;
                    case "V6":
                        res = EncrypteHandle.EncrypteUnion(AccountNo, pwdbox.Password.Trim(), legal_pwd_key); //多法人调用银联加密多传一个参数
                        break;
                    default:
                        if (TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("EncrypteGM") == "true")
                        {
                            //国密改造
                            string encrypteType = Encrypte.GetEncrypteType(pbox).ToString().ToLower();
                            if (Encrypte.GetEncrypteType(pbox))
                            {
                                res = EncrypteHandle.EncrypteUnion_GM(AccountNo, pwdbox.Password.Trim(), legal_pwd_key, encrypteType);
                            }
                            else
                            {
                                res = EncrypteHandle.EncrypteUnion(AccountNo, pwdbox.Password.Trim());
                            }
                        }
                        else
                        {
                            res = EncrypteHandle.EncrypteUnion(AccountNo, pwdbox.Password.Trim());
                        }
                        break;
                }
                //var res = EncrypteHandle.EncrypteUnion(AccountNo, pwdbox.Password.Trim(),legal_pwd_key);
                //var res = EncrypteHandle.EncrypteUnion(AccountNo, pwdbox.Password.Trim());
                pwdbox.Password = res;
                AccountNo = string.Empty;
            }


        }

        /**
        * @author liyan

        *

        */

        private static int[][] s1 = new int[][]{
          new int[]{14,4, 13,1, 2, 15,11,8, 3, 10,6, 12,5, 9, 0, 7},

          new int[]{0, 15,7, 4, 14,2, 13,1, 10,6, 12,11,9, 5, 3, 8},

          new int[]{4, 1, 14,8, 13,6, 2, 11,15,12,9, 7, 3, 10,5, 0},

          new int[]{15,12,8, 2, 4, 9, 1, 7, 5, 11,3, 14,10,0, 6, 13}};



        private static int[][] s2 = new int[][]{
          new int[]{15,1, 8, 14,6, 11,3, 4, 9, 7, 2, 13,12,0, 5, 10},

          new int[]{3, 13,4, 7, 15,2, 8, 14,12,0, 1, 10,6, 9, 11,5},

          new int[]{0, 14,7, 11,10,4, 13,1, 5, 8, 12,6, 9, 3, 2, 15},

          new int[]{13,8, 10,1, 3, 15,4, 2, 11,6, 7, 12,0, 5, 14,9}};



        private static int[][] s3 = new int[][]{
          new int[]{10,0, 9, 14,6, 3, 15,5, 1, 13,12,7, 11,4, 2, 8},

          new int[]{13,7, 0, 9, 3, 4, 6, 10,2, 8, 5, 14,12,11,15,1},

          new int[]{13,6, 4, 9, 8, 15,3, 0, 11,1, 2, 12,5, 10,14,7},

          new int[]{1, 10,13,0, 6, 9, 8, 7, 4, 15,14,3, 11,5, 2, 12}};



        private static int[][] s4 = new int[][]{
          new int[]{7, 13,14,3, 0, 6, 9, 10,1, 2, 8, 5, 11,12,4, 15},

          new int[]    {13,8, 11,5, 6, 15,0, 3, 4, 7, 2, 12,1, 10,14,9},//erorr

          new int[]{10,6, 9, 0, 12,11,7, 13,15,1, 3, 14,5, 2, 8, 4},

          new int[]{3, 15,0, 6, 10,1, 13,8, 9, 4, 5, 11,12,7, 2, 14}};



        private static int[][] s5 = new int[][]{
          new int[]{2, 12,4, 1, 7, 10,11,6, 8, 5, 3, 15,13,0, 14,9},

          new int[]{14,11,2, 12,4, 7, 13,1, 5, 0, 15,10,3, 9, 8, 6},

          new int[]{4, 2, 1, 11,10,13,7, 8, 15,9, 12,5, 6, 3, 0, 14},

          new int[]{11,8, 12,7, 1, 14,2, 13,6, 15,0, 9, 10,4, 5, 3}};



        private static int[][] s6 = new int[][]{
            new int[]{12, 1, 10, 15, 9, 2, 6, 8, 0, 13, 3, 4, 14, 7, 5, 11},

            new int[]{10, 15, 4, 2, 7, 12, 9, 5, 6, 1, 13, 14, 0, 11, 3, 8},

            new int[]{9, 14, 15, 5, 2, 8, 12, 3, 7, 0, 4, 10, 1, 13, 11, 6},

            new int[]{4, 3, 2, 12, 9, 5, 15, 10, 11, 14, 1, 7, 6, 0, 8, 13}};



        private static int[][] s7 = new int[][]{
            new int[]{4, 11, 2, 14, 15, 0, 8, 13, 3, 12, 9, 7, 5, 10, 6, 1},

            new int[]{13, 0, 11, 7, 4, 9, 1, 10, 14, 3, 5, 12, 2, 15, 8, 6},

            new int[]{1, 4, 11, 13, 12, 3, 7, 14, 10, 15, 6, 8, 0, 5, 9, 2},

            new int[]{6, 11, 13, 8, 1, 4, 10, 7, 9, 5, 0, 15, 14, 2, 3, 12}};



        private static int[][] s8 = new int[][]{
            new int[]{13, 2, 8, 4, 6, 15, 11, 1, 10, 9, 3, 14, 5, 0, 12, 7},

            new int[]{1, 15, 13, 8, 10, 3, 7, 4, 12, 5, 6, 11, 0, 14, 9, 2},

            new int[]{7, 11, 4, 1, 9, 12, 14, 2, 0, 6, 10, 13, 15, 3, 5, 8},

            new int[]{2, 1, 14, 7, 4, 10, 8, 13, 15, 12, 9, 0, 3, 5, 6, 11}};



        private static int[] ip = new int[]{58, 50, 42, 34, 26, 18, 10, 2,

        60, 52, 44, 36, 28, 20, 12, 4,

        62, 54, 46, 38, 30, 22, 14, 6,

        64, 56, 48, 40, 32, 24, 16, 8,

        57, 49, 41, 33, 25, 17, 9, 1,

        59, 51, 43, 35, 27, 19, 11, 3,

        61, 53, 45, 37, 29, 21, 13, 5,

        63, 55, 47, 39, 31, 23, 15, 7};



        private static int[] _ip = new int[]{40, 8, 48, 16, 56, 24, 64, 32,

        39, 7, 47, 15, 55, 23, 63, 31,

        38, 6, 46, 14, 54, 22, 62, 30,

        37, 5, 45, 13, 53, 21, 61, 29,

        36, 4, 44, 12, 52, 20, 60, 28,

        35, 3, 43, 11, 51, 19, 59, 27,

        34, 2, 42, 10, 50, 18, 58, 26,

        33, 1, 41, 9, 49, 17, 57, 25};



        //每次密钥循环左移位数

        private static int[] LS = new int[] { 1, 1, 2, 2, 2, 2, 2, 2, 1, 2, 2, 2, 2, 2, 2, 1 };



        private static int[,] subKey = new int[16, 48];



        private static int HEX = 0;

        private static int ASC = 1;



        /**


         * @param ch

         * @return

         * @throws Exception 

         */

        public static int getIntByChar(char ch)
        {

            char t = ch.ToString().ToUpper()[0];

            int i = 0;

            switch (t)
            {

                case '0':

                case '1':

                case '2':

                case '3':

                case '4':

                case '5':

                case '6':

                case '7':

                case '8':

                case '9':

                    i = int.Parse(t.ToString());

                    break;

                case 'A':

                    i = 10;

                    break;

                case 'B':

                    i = 11;

                    break;

                case 'C':

                    i = 12;

                    break;

                case 'D':

                    i = 13;

                    break;

                case 'E':

                    i = 14;

                    break;

                case 'F':

                    i = 15;

                    break;

                default:

                    throw new Exception("getIntByChar was wrong");

            }

            return i;

        }



        /**

         * 将字符串转换成二进制数组

         * @param source : 16字节

         * @return

         */

        public static int[] string2Binary(String source)
        {

            int len = source.Length;

            int[] dest = new int[len * 4];

            char[] arr = source.ToCharArray();

            for (int i = 0; i < len; i++)
            {

                int t = 0;

                try
                {

                    t = getIntByChar(arr[i]);

                    //System.out.println(arr[i]);

                }
                catch (Exception e)
                {

                    throw e;

                }

                //String[] str = Integer.toBinaryString(t).split("");
                String[] str = Convert.ToString(t, 2).ToCharArray().Select(x => { return x.ToString(); }).ToArray();    // Integer.toBinaryString(t).split("");

                int k = i * 4 + 3;

                //for (int j = str.Length - 1; j > 0; j--)
                for (int j = str.Length - 1; j >= 0; j--)
                {

                    dest[k] = int.Parse(str[j]);

                    k--;

                }

            }

            return dest;

        }



        /**

         * 返回x的y次方

         * @param x

         * @param y

         * @return

         */

        public static int getXY(int x, int y)
        {

            int temp = x;

            if (y == 0) x = 1;

            for (int i = 2; i <= y; i++)
            {

                x *= temp;

            }

            return x;

        }



        /**


         * @param s

         * @return

         */

        public static String binary2Hex(String s)
        {

            int len = s.Length;

            int result = 0;

            int k = 0;

            if (len > 4) return null;

            for (int i = len; i > 0; i--)
            {
                result += int.Parse(s.Substring(i - 1, 1)) * getXY(2, k);

                k++;
            }

            switch (result)
            {

                case 0:

                case 1:

                case 2:

                case 3:

                case 4:

                case 5:

                case 6:

                case 7:

                case 8:

                case 9:

                    return "" + result;

                case 10:

                    return "A";

                case 11:

                    return "B";

                case 12:

                    return "C";

                case 13:

                    return "D";

                case 14:

                    return "E";

                case 15:

                    return "F";

                default:

                    return null;

            }

        }



        /**

         * 将int转换成Hex

         * @param i

         * @return

         * @throws Exception 

         */

        public static String int2Hex(int i)
        {

            switch (i)
            {

                case 0:

                case 1:

                case 2:

                case 3:

                case 4:

                case 5:

                case 6:

                case 7:

                case 8:

                case 9:

                    return "" + i;

                case 10:

                    return "A";

                case 11:

                    return "B";

                case 12:

                    return "C";

                case 13:

                    return "D";

                case 14:

                    return "E";

                case 15:

                    return "F";

                default:

                    return null;

            }

        }



        /**


         * @param s

         * @return

         */

        public static String binary2ASC(String s)
        {

            String str = "";

            int ii = 0;

            int len = s.Length;

            //不够4bit左补0

            if (len % 4 != 0)
            {

                while (ii < 4 - len % 4)
                {

                    s = "0" + s;

                }

            }

            for (int i = 0; i < len / 4; i++)
            {

                str += binary2Hex(s.Substring(i * 4, 4));

            }

            return str;

        }



        /**

         * IP初始置换

         * @param source

         * @return

         */

        public static int[] changeIP(int[] source)
        {

            int[] dest = new int[64];

            for (int i = 0; i < 64; i++)
            {

                dest[i] = source[ip[i] - 1];

            }

            return dest;

        }



        /**


         * @param source

         * @return

         */

        public static int[] changeInverseIP(int[] source)
        {

            int[] dest = new int[64];

            for (int i = 0; i < 64; i++)
            {

                dest[i] = source[_ip[i] - 1];

            }

            return dest;

        }



        /**


         * @param source

         * @return

         */

        public static int[] expend(int[] source)
        {

            int[] ret = new int[48];

            int[] temp = {32, 1, 2, 3, 4, 5,

            4, 5, 6, 7, 8, 9,

            8, 9, 10, 11, 12, 13,

            12, 13, 14, 15, 16, 17,

            16, 17, 18, 19, 20, 21,

            20, 21, 22, 23, 24, 25,

            24, 25, 26, 27, 28, 29,

            28, 29, 30, 31, 32, 1};

            for (int i = 0; i < 48; i++)
            {

                ret[i] = source[temp[i] - 1];

            }

            return ret;

        }



        /**


         * @param source(48bit)

         * @return R(32bit)


         */

        public static int[] press(int[] source)
        {

            int[] ret = new int[32];

            int[,] temp = new int[8, 6];

            int[][][] s = { s1, s2, s3, s4, s5, s6, s7, s8 };

            StringBuilder str = new StringBuilder();

            for (int i = 0; i < 8; i++)
            {

                for (int j = 0; j < 6; j++)
                {

                    temp[i, j] = source[i * 6 + j];

                }

            }

            for (int i = 0; i < 8; i++)
            {

                //(16)

                int x = temp[i, 0] * 2 + temp[i, 5];

                //(2345)

                int y = temp[i, 1] * 8 + temp[i, 2] * 4 + temp[i, 3] * 2 + temp[i, 4];

                int val = s[i][x][y];

                String ch = int2Hex(val);

                //	System.out.println("x=" + x + ",y=" + y + "-->" + ch);

                //String ch = Integer.toBinaryString(val);

                str.Append(ch);

            }

            //System.out.println(str.toString());

            ret = string2Binary(str.ToString());

            //	printArr(ret);

            //置换P

            ret = dataP(ret);

            return ret;

        }



        /**

         * 置换P(32bit)

         * @param source

         * @return

         */

        public static int[] dataP(int[] source)
        {

            int[] dest = new int[32];

            int[] temp = {16, 7, 20, 21,

              29, 12, 28, 17,

              1, 15, 23, 26,

              5, 18, 31, 10,

              2, 8, 24, 14,

              32, 27, 3, 9,

              19, 13, 30, 6,

              22, 11, 4, 25};

            int len = source.Length;

            for (int i = 0; i < len; i++)
            {

                dest[i] = source[temp[i] - 1];

            }

            return dest;

        }



        /**



         * @return 32bit

         */

        public static int[] f(int[] R, int[] K)
        {

            int[] dest = new int[32];

            int[] temp = new int[48];


            int[] expendR = expend(R);//48bit


            temp = diffOr(expendR, K);


            dest = press(temp);

            //System.out.println("need press data----->");

            //printArr(temp);

            return dest;

        }



        /**

         * 两个等长的数组做异或

         * @param source1

         * @param source2

         * @return

         */

        public static int[] diffOr(int[] source1, int[] source2)
        {

            int len = source1.Length;

            int[] dest = new int[len];

            for (int i = 0; i < len; i++)
            {

                dest[i] = source1[i] ^ source2[i];

            }

            return dest;

        }



        /**

         * DES加密--->对称密钥

         * D = Ln(32bit)+Rn(32bit)


         * @param D(16byte)明文

         * @param K(16byte)轮子密钥

         * @return (16byte)密文

         */

        public static String encryption(String D, String K)
        {

            String str = "";

            int[] temp = new int[64];

            int[] data = string2Binary(D);

            //	printArr(data);


            data = changeIP(data);

            //	printArr(data);

            int[,] left = new int[17, 32];

            int[,] right = new int[17, 32];

            for (int j = 0; j < 32; j++)
            {

                left[0, j] = data[j];

                right[0, j] = data[j + 32];

            }

            //	printArr(left[0]);

            //	printArr(right[0]);

            setKey(K);//sub key ok

            for (int i = 1; i < 17; i++)
            {


                int[] key = GetArray(subKey, i - 1);

                //L1 = R0 
                // left[i] = GetArray(right,i - 1);
                SetArray(i, left, GetArray(right, i - 1));

                //R1 = L0 ^ f(R0,K1)

                int[] fTemp = f(GetArray(right, i - 1), key);//32bit

                //right[i] = diffOr(GetArray(left,i - 1), fTemp);
                SetArray(i, right, diffOr(GetArray(left, i - 1), fTemp));

            }

            for (int i = 0; i < 32; i++)
            {

                temp[i] = GetArray(right, 16)[i];

                temp[32 + i] = GetArray(left, 16)[i];

            }

            temp = changeInverseIP(temp);

            str = binary2ASC(intArr2Str(temp));

            return str;

        }



        /**

         * DES解密--->对称密钥

         * 解密算法与加密算法基本相同，不同之处仅在于轮子密钥的使用顺序逆序，即解密的第1 



         * @param source密文

         * @param key密钥

         * @return

         */

        public static String discryption(String source, String key)
        {

            String str = "";

            int[] data = string2Binary(source);//64bit


            data = changeIP(data);

            int[] left = new int[32];

            int[] right = new int[32];

            int[] tmp = new int[32];

            for (int j = 0; j < 32; j++)
            {

                left[j] = data[j];

                right[j] = data[j + 32];

            }

            setKey(key);//sub key ok

            for (int i = 16; i > 0; i--)
            {



                /*********不同之处**********/

                int[] sKey = GetArray(subKey, i - 1);

                tmp = left;

                //R1 = L0 

                left = right;

                //L1 = R0 ^ f(L0,K1)

                int[] fTemp = f(right, sKey);//32bit

                right = diffOr(tmp, fTemp);

            }



            for (int i = 0; i < 32; i++)
            {

                data[i] = right[i];

                data[32 + i] = left[i];

            }

            data = changeInverseIP(data);

            for (int i = 0; i < data.Length; i++)
            {

                str += data[i];

            }

            str = binary2ASC(str);

            return str;

        }



        /**

 

         * @param source

         * @param key

         * @param type 0:encrypt 1:discrypt

         * @return

         */

        public static String DES_1(String source, String key, int type)
        {

            if (source.Length != 16 || key.Length != 16) return null;

            if (type == 0)
            {

                return encryption(source, key);

            }

            if (type == 1)
            {

                return discryption(source, key);

            }

            return null;

        }



        /**

         * 

         * @param source

         * @param key

         * @param type 0:encrypt 1:discrypt

         * @return

         */

        public static String DES_2(String source, String key, int type)
        {

            return null;

        }



        /**

 

         * @param source

         * @param key

         * @param type 0:encrypt 1:discrypt

         * @return

         */

        public static String DES_3(String source, String key, int type)
        {

            //if (key.Length != 32 || source.Length != 16) return null;

            String temp = null;

            String K1 = key.Substring(0, key.Length / 2);

            // String K2 = key.Substring(key.Length / 2);
            String K2 = key.Substring(key.Length / 2, key.Length / 2);//.Replace(K1,"");//.Substring(key.Length / 2);


            if (type == 0)
            {

                temp = encryption(source, K1);

                //System.out.println("step1--->" + temp);

                temp = discryption(temp, K2);

                //System.out.println("step2--->" + temp);

                return encryption(temp, K1);

            }

            if (type == 1)
            {

                temp = discryption(source, K1);

                temp = encryption(temp, K2);

                return discryption(temp, K1);

            }

            return null;

        }



        /************************************48bit的轮子密钥的生成**********************************************************/

        /**

 

         * @param source

         * @return

         */

        public static int[] keyPC_1(int[] source)
        {

            int[] dest = new int[56];

            int[] temp = {57, 49, 41, 33, 25, 17, 9,

  1, 58, 50, 42, 34, 26, 18,

  10, 2, 59, 51, 43, 35, 27,

  19, 11, 3, 60, 52, 44, 36,

  63, 55, 47, 39, 31, 23, 15,

  7, 62, 54, 46, 38, 30, 22,

  14, 6, 61, 53, 45, 37, 29,

  21, 13, 5, 28, 20, 12, 4};

            for (int i = 0; i < 56; i++)
            {

                dest[i] = source[temp[i] - 1];

            }

            return dest;

        }



        /**



 

         * @param i 循环左移位数

         * @return

         */

        public static int[] keyLeftMove(int[] source, int i)
        {

            int temp = 0;

            int len = source.Length;

            int ls = LS[i];

            //	System.out.println("len" + len + ",LS[" + i + "]=" + ls);

            for (int k = 0; k < ls; k++)
            {

                temp = source[0];

                for (int j = 0; j < len - 1; j++)
                {

                    source[j] = source[j + 1];

                }

                source[len - 1] = temp;

            }

            return source;

        }



        /**

 

         * @param source

         * @return

         */

        public static int[] keyPC_2(int[] source)
        {

            int[] dest = new int[48];

            int[] temp = {14, 17, 11, 24, 1, 5,

  3, 28, 15, 6, 21, 10,

  23, 19, 12, 4, 26, 8,

  16, 7, 27, 20, 13, 2,

  41, 52, 31, 37, 47, 55,

  30, 40, 51, 45, 33, 48,

  44, 49, 39, 56, 34, 53,

  46, 42, 50, 36, 29, 32};

            for (int i = 0; i < 48; i++)
            {

                dest[i] = source[temp[i] - 1];

            }

            return dest;

        }



        /**

         * 获取轮子密钥(48bit)

         * @param source

         * @return

         */

        public static void setKey(String source)
        {

            if (subKey.Length > 0) subKey = new int[16, 48];



            int[] temp = string2Binary(source);



            int[] left = new int[28];

            int[] right = new int[28];



            int[] temp1 = new int[56];

            temp1 = keyPC_1(temp);

            //printArr(temp1);

            //将经过转换的temp1均分成两部分

            for (int i = 0; i < 28; i++)
            {

                left[i] = temp1[i];

                right[i] = temp1[i + 28];

            }

            //经过16次循环左移，然后PC-2置换

            for (int i = 0; i < 16; i++)
            {

                left = keyLeftMove(left, LS[i]);

                right = keyLeftMove(right, LS[i]);

                for (int j = 0; j < 28; j++)
                {

                    temp1[j] = left[j];

                    temp1[j + 28] = right[j];

                }

                //printArr(temp1);

                //subKey[i] = keyPC_2(temp1);
                SetArray(i, subKey, keyPC_2(temp1));

            }

        }



        public static void printArr(int[] source)
        {

            int len = source.Length;

            for (int i = 0; i < len; i++)
            {

                //System.out.print(source[i]);

            }

            //System.out.println();

        }



        /**

  

         * @param asc

         * @return

         */

        public static String ASC_2_HEX(String asc)
        {

            StringBuilder hex = new StringBuilder();

            try
            {

                byte[] bs = System.Text.ASCIIEncoding.GetEncoding("UTF-8").GetBytes(asc.ToUpper());

                foreach (byte b in bs)
                {

                    //hex.Append(Integer.toHexString(new Byte(b).intValue()));
                    hex.Append(b.ToString("x"));
                }

            }
            catch (Exception e)
            {

                throw e;

            }

            return hex.ToString();

        }



        /**

         4546)-->(0123456789ABCDEF)

         * @param hex

         * @return

         */

        public static String HEX_2_ASC(String hex)
        {
            String asc = null;

            int len = hex.Length;

            byte[] bs = new byte[len / 2];

            for (int i = 0; i < len / 2; i++)
            {
                bs[i] = byte.Parse(hex.Substring(i * 2, 2), System.Globalization.NumberStyles.HexNumber);
            }

            try
            {
                asc = System.Text.ASCIIEncoding.GetEncoding("UTF-8").GetString(bs);
            }
            catch (Exception e)
            {
                throw e;
            }

            return asc;
        }



        /**

         * 计算MAC(hex)
 

         * @param key密钥(16byte)

         * @param vector初始向量0000000000000000

         * @param data数据

         * @return mac

         */

        public static String MAC(String key, String vector, String data, int type)
        {

            if (type == ASC)
            {

                data = ASC_2_HEX(data);

            }

            int len = data.Length;

            int arrLen = len / 16 + 1;

            String[] D = new String[arrLen];

            if (vector == null) vector = "0000000000000000";

            if (len % 16 == 0)
            {

                data += "8000000000000000";

            }
            else
            {

                data += "80";

                for (int i = 0; i < 15 - len % 16; i++)
                {

                    data += "00";

                }

            }

            for (int i = 0; i < arrLen; i++)
            {

                D[i] = data.Substring(i * 16, 16);

                //System.out.println("D[" + i + "]=" + D[i]);

            }



            //D0 Xor Vector

            String I = xOr(D[0], vector);

            String O = null;



            for (int i = 1; i < arrLen; i++)
            {

                //	System.out.println(i + "**************");

                //	System.out.println("I=" + I);

                O = DES_1(I, key, 0);

                //	System.out.println("O=" + O);

                I = xOr(D[i], O);

                //	System.out.println("I=" + I);

            }



            I = DES_1(I, key, 0);



            return I;

        }



        /**

         * 将s1和s2做异或，然后返回

         * @param s1

         * @param s2

         * @return

         */

        public static String xOr(String s1, String s2)
        {

            int[] iArr = diffOr(string2Binary(s1), string2Binary(s2));

            return binary2ASC(intArr2Str(iArr));

        }



        /**

         * 将int类型数组拼接成字符串

         * @param arr

         * @return

         */

        public static String intArr2Str(int[] arr)
        {

            StringBuilder sb = new StringBuilder();

            for (int i = 0; i < arr.Length; i++)
            {

                sb.Append(arr[i]);

            }

            return sb.ToString();

        }



        /**

         * 将data分散

         * @param data

         * @param key

         * @param type

         * @return

         */

        public static String divData(String data, String key, int type)
        {

            String left = null;

            String right = null;

            if (type == HEX)
            {

                left = key.Substring(0, 16);

                right = key.Substring(16, 16);

            }

            if (type == ASC)
            {

                left = ASC_2_HEX(key.Substring(0, 8));

                right = ASC_2_HEX(key.Substring(8, 8));

            }

            //加密

            data = DES_1(data, left, 0);

            //解密

            data = DES_1(data, right, 1);

            //加密

            data = DES_1(data, left, 0);

            return data;

        }



        /**

         * 取反(10001)--->(01110)

         * @param source

         * @return

         */

        public static String reverse(String source)
        {

            int[] data = string2Binary(source);

            int j = 0;

            for (int i = 0; i < data.Length; i++)
            {

                data[j++] = 1 - i;

            }

            return binary2ASC(intArr2Str(data));

        }



        /**

         * 主密钥需要经过两次分散获得IC卡中的子密钥

         * @param issuerFlag发卡方标识符

         * @param appNo应用序列号即卡号

         * @param mpk主密钥

         * @return

         */

        public static String getDPK(String issuerFlag, String appNo, String mpk)
        {

            //第一次分散

            StringBuilder issuerMPK = new StringBuilder();

            //获取Issuer MPK左半边

            issuerMPK.Append(divData(issuerFlag, mpk, 0));

            //获取Issuer MPK右半边

            issuerMPK.Append(divData(reverse(issuerFlag), mpk, 0));

            //第二次分散

            StringBuilder dpk = new StringBuilder();

            //获取DPK左半边

            dpk.Append(divData(appNo, issuerMPK.ToString(), 0));

            //获取DPK右半边

            dpk.Append(divData(reverse(appNo), issuerMPK.ToString(), 0));

            return dpk.ToString();

        }

        private static int[] GetArray(int[,] source, int index)
        {
            List<int> list = new List<int>();
            int count = source.GetLength(1);

            for (int i = 0; i < count; i++)
                list.Add(source[index, i]);

            return list.ToArray();
        }

        private static void SetArray(int index, int[,] target, int[] source)
        {
            int count = target.GetLength(1);

            for (int i = 0; i < count; i++)
                target[index, i] = source[i];
        }


    }

}

