import { EncrypteHandle } from "../../../ServiceProxy.Ext/ServiceHelper/EncrypteHandle";
import { TradeManagerHandle } from "../../../ServiceProxy.Ext/ServiceHelper/TradeManagerHandle";
import SystemFunction from "../../Function/SystemFunction";
import { LoginAuthentication } from "../SSO/LoginAuthentication";
import UserFunction from "@/views/front/develop/Library.Ext/Function/UserFunction";
// import TradeManagerHandle from "@/views/front/develop/ServiceProxy.Ext/ServiceHelper/";
TellerSystem.ServiceProxy.Ext.ServiceHelper
class Encrypte {
    private static readonly key = "33333333333333333333333333333333";
    public static AccountNo: string = "";

    public static GetServerMac(macdata: string): string {
        const mac = EncrypteHandle.GetMac(macdata, macdata.length.toString());
        return mac;
    }

    public static GetMac(strKey: string, macdata: string): string {
        const ba = new TextEncoder().encode(macdata);
        let ascii = "";
        ba.forEach(b => ascii += b.toString(16));

        const zakl = strKey.substring(0, 16);
        const zakr = strKey.substring(16, 32);

        const des = this.DES_1(ascii, zakl, 0);
        const xor = this.xOr(des, "3900000000000000");
        const des1 = this.DES_1(xor, zakl, 0);
        const des2 = this.DES_1(des1, zakr, 1);
        const des3 = this.DES_1(des2, zakl, 0);
        return des3;
    }

    public static GetPinBlock(account: string, pin: string): string {
        let resultAccount = "";
        const str = "0" + pin.length.toString() + pin;
        let pinblock = str.padEnd(16, 'F');

        if (account.length === 19) {
            resultAccount = account.substring(6, 18);
        } else if (account.length === 13) {
            resultAccount = account.substring(0, 12);
        } else {
            resultAccount = "0000000000000000";
        }

        const accountblock = resultAccount.padStart(16, '0');
        const resultPin = (parseInt(pinblock, 16) ^ parseInt(accountblock, 16)).toString(16).toUpperCase();
        return resultPin.length % 2 !== 0 ? resultPin.padStart(16, '0') : resultPin;
    }

    public static DePinBlock(pin: string): string {
        const pin1 = pin.replace(/F/g, "");
        const n = pin.length - pin1.length - 1;
        return n >= 4 ? pin1.substring(2) : pin1.substring(3);
    }

    // 附加属性定义
    private static AcctountElementNameProperty: any;
    private static IsEncrypteProperty: any;
    private static IsChannelProperty: any;
    private static IsChannel_SecProperty: any;
    private static IdentityNoProperty: any;
    private static EncrypteTypeProperty: any;
    private static IsCheckPasswordProperty: any;

    public static GetAcctountElementName(obj: DependencyObject): string {
        return obj.getValue(Encrypte.AcctountElementNameProperty);
    }

    public static SetAcctountElementName(obj: DependencyObject, value: string): void {
        obj.setValue(Encrypte.AcctountElementNameProperty, value);
    }

    public static GetIsEncrypte(obj: DependencyObject): boolean {
        return obj.getValue(Encrypte.IsEncrypteProperty);
    }

    public static SetIsEncrypte(obj: DependencyObject, value: boolean): void {
        obj.setValue(Encrypte.IsEncrypteProperty, value);
    }

    public static GetIsChannel(obj: DependencyObject): boolean {
        return obj.getValue(Encrypte.IsChannelProperty);
    }

    public static SetIsChannel(obj: DependencyObject, value: boolean): void {
        obj.setValue(Encrypte.IsChannelProperty, value);
    }

    public static GetIsChannel_Sec(obj: DependencyObject): boolean {
        return obj.getValue(Encrypte.IsChannel_SecProperty);
    }

    public static SetIsChannel_Sec(obj: DependencyObject, value: boolean): void {
        obj.setValue(Encrypte.IsChannel_SecProperty, value);
    }

    public static GetIdentityNo(obj: DependencyObject): string {
        return obj.getValue(Encrypte.IdentityNoProperty);
    }

    public static SetIdentityNo(obj: DependencyObject, value: string): void {
        obj.setValue(Encrypte.IdentityNoProperty, value);
    }

    public static GetEncrypteType(obj: DependencyObject): boolean {
        return obj.getValue(Encrypte.EncrypteTypeProperty);
    }

    public static SetEncrypteType(obj: DependencyObject, value: boolean): void {
        obj.setValue(Encrypte.EncrypteTypeProperty, value);
    }

    public static GetIsCheckPassword(obj: DependencyObject): boolean {
        return obj.getValue(Encrypte.IsCheckPasswordProperty);
    }

    public static SetIsCheckPassword(obj: DependencyObject, value: boolean): void {
        obj.setValue(Encrypte.IsCheckPasswordProperty, value);
    }

    private static GetAcctount(elementName: string, element: DependencyObject, acctount: { value: string }): void {
        if ('Text' in element && 'Name' in element && element.Name === elementName) {
            acctount.value = "";//(element as TextBox).Text;//hulei-r VUE中没有TextBox
        }

        // hulei-r 这里简化了 VisualTreeHelper 的逻辑，实际需要实现递归查找子元素
    }

    private static PreviewPasswordBox_LostFocus(sender: any, e: any): void {//hulei-s 密码控件处理需要重写
        if (SystemFunction.Len(sender.Password) !== 6) {
            sender.ShowTip("请输入6位密码!");
            sender.Password = "";
            // 简化了焦点管理逻辑
            e.Handled = true;
            return;
        }

        if (Encrypte.GetIsCheckPassword(sender)) {
            const identityno = Encrypte.GetIdentityNo(sender);
            let num = "";
            if (identityno) {
                // 简化了查找父元素的逻辑
                this.GetAcctount(identityno, sender, { value: num });
            }

            if (UserFunction.IsSamplePassword(null, sender.Password.trim(), num)) {
                sender.ShowTip("新密码过于简单!");
                sender.Password = "";
                // 简化了焦点管理逻辑
                e.Handled = true;
                return;
            }
        }

        if (sender.Password.trim()) {
            const acctountElementName = Encrypte.GetAcctountElementName(sender);
            let accountNo = "";
            if (acctountElementName) {
                // 简化了查找父元素的逻辑
                this.GetAcctount(acctountElementName, sender, { value: accountNo });
            }
            if (!accountNo.trim()) {
                accountNo = "0000000000000000";
            }
            accountNo = accountNo.trim();

            const legalPwdKey = LoginAuthentication.Instance.GroupKinbrNo;
            const flag = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
            let res = "";

            switch (flag) {
                case "V5":
                    if (TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("EncrypteGM") === "true") {
                        const encrypteType = Encrypte.GetEncrypteType(sender).toString().toLowerCase();
                        if (Encrypte.GetEncrypteType(sender)) {
                            res = EncrypteHandle.EncrypteUnion_GM(accountNo, sender.Password.trim(), legalPwdKey, encrypteType);
                        } else {
                            res = EncrypteHandle.EncrypteUnion(accountNo, sender.Password.trim(), legalPwdKey);
                        }
                    } else {
                        res = EncrypteHandle.EncrypteUnion(accountNo, sender.Password.trim(), legalPwdKey);
                    }
                    break;
                case "V6":
                    res = EncrypteHandle.EncrypteUnion(accountNo, sender.Password.trim(), legalPwdKey);
                    break;
                default:
                    if (TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("EncrypteGM") === "true") {
                        const encrypteType = Encrypte.GetEncrypteType(sender).toString().toLowerCase();
                        if (Encrypte.GetEncrypteType(sender)) {
                            res = EncrypteHandle.EncrypteUnion_GM(accountNo, sender.Password.trim(), legalPwdKey, encrypteType);
                        } else {
                            res = EncrypteHandle.EncrypteUnion(accountNo, sender.Password.trim(), "");
                        }
                    } else {
                        res = EncrypteHandle.EncrypteUnion(accountNo, sender.Password.trim(), "");
                    }
                    break;
            }

            sender.Password = res;
            Encrypte.AccountNo = "";
        }
    }

    private static DES_1(input: string, key: string, mode: number): string {
        // 这里需要实现 DES 加密逻辑
        return "";
    }

    private static xOr(str1: string, str2: string): string {
        let result = "";
        for (let i = 0; i < str1.length; i++) {
            const num1 = parseInt(str1[i], 16);
            const num2 = parseInt(str2[i], 16);
            result += (num1 ^ num2).toString(16);
        }
        return result;
    }

    public static getIntByChar(ch: string): number {
        const t = ch.toUpperCase();
        switch (t) {
            case '0': case '1': case '2': case '3': case '4':
            case '5': case '6': case '7': case '8': case '9':
                return parseInt(t);
            case 'A': return 10;
            case 'B': return 11;
            case 'C': return 12;
            case 'D': return 13;
            case 'E': return 14;
            case 'F': return 15;
            default: return 0;
        }
    }
}

export default Encrypte;
