// 假设这些类型和类在其他地方定义

import { ConfigManager } from "@/views/front/platfrom/common/RunningParameters/ConfigManager";


interface ExamObject {
    IsExamModel: boolean;
    QuestionKey?: string;
    QuestionName?: string;
    TimeNow?: string;
    StartTime?: string;
    ExamLast?: string;
    LeftTotalSeconds?: string;
}

interface MessageObject {
    SendMessage(data: string[], flag: any): boolean;
    ReceiveMessage?: (flag: any, receiveString: string[]) => void;
}

interface BaseCommand {
    (obj: any): void;
}

enum CommniucationFlag {
    A,
    B
}

class ExamSystem {
    private static _instance: ExamSystem;
    private constructor() {
        // this.InExamMode = ConfigManager.GetInstance().GetConfigValue("InExamMode", 'System').toLowerCase() === 'true';
        // this.ExamEntity = { IsExamModel: this.InExamMode };hulei-/考试系统相关暂时也不改动
    }

    public static get Instance(): ExamSystem {
        if (!this._instance) {
            this._instance = new ExamSystem();
        }
        return this._instance;
    }

    public InExamMode: boolean;
    public ExamEntity: ExamObject;
    public CommunicationObject: MessageObject | null = null;

    private _submitExamCommand: BaseCommand | null = null;
    public get SubmitExamCommand(): BaseCommand {
        return this._submitExamCommand ?? (this._submitExamCommand = (obj) => {
            if (!this.InExamMode) return;
            // 模拟 Process.GetProcessesByName
            const isProcessRunning = false;
            if (!isProcessRunning) {
                try {
                    // 模拟文件操作
                    console.log('创建并执行 bat 脚本');
                } catch (error) { }
                return;
            }
            if (this.ExamEntity.QuestionKey) {
                const message = this.CommunicationObject;
                if (message) {
                    const s = [this.ExamEntity.QuestionKey];
                    const istrue = message.SendMessage(s, CommniucationFlag.B);
                    if (!istrue) {
                        console.log('向考试系统发送信息失败!');
                        return;
                    }
                    // 模拟窗口操作
                    console.log('隐藏主窗口');
                }
            }
        });
    }

    public Init(): boolean {
        if (this.InExamMode) {
            this.CommunicationObject = {
                SendMessage: (data, flag) => { return true; },
                ReceiveMessage: (flag, receiveString) => {
                    if (flag === CommniucationFlag.A) {
                        try {
                            if (receiveString.length !== 6) {
                                console.log('获取参数错误。');
                                return;
                            }
                            this.ExamEntity.QuestionKey = receiveString[0];
                            this.ExamEntity.QuestionName = receiveString[1];
                            this.ExamEntity.TimeNow = receiveString[2];
                            this.ExamEntity.StartTime = receiveString[3];
                            this.ExamEntity.ExamLast = receiveString[4];
                            this.ExamEntity.LeftTotalSeconds = receiveString[5];
                            // 模拟窗口操作
                            console.log('显示主窗口');
                        } catch (error) { }
                    }
                }
            };
        }
        return true;
    }

    public SendExamData(SendMsg: string, RecevieMsg: string, tradeCode: string, serialNumber: string): void {
        if (!this.InExamMode) return;
        const msgObject = this.CommunicationObject;
        if (msgObject && this.ExamEntity.IsExamModel && this.ExamEntity.QuestionKey) {
            const dl = [
                this.ExamEntity.QuestionKey,
                tradeCode === "" ? "0000" : tradeCode,
                serialNumber,
                SendMsg,
                RecevieMsg
            ];
            const istrue = msgObject.SendMessage(dl, CommniucationFlag.A);
            if (!istrue) {
                console.log('向考试系统发送信息失败!');
                return;
            }
        }
    }

    public KGetMessageString(msg: any, flag: string): string {
        if (!this.InExamMode) return '';
        const info = Object.getOwnPropertyDescriptors(msg);
        let s = '';
        let msginfo = `\r\n${flag}_域值\r\n`;
        for (const key in info) {
            if (key.startsWith('Fd')) {
                const tempstr = String(info[key].value).trim().replace(/\r|\n/g, '');
                if (tempstr) {
                    msginfo += `${key}=${info[key].value}\r\n`;
                    s += `${key}=${tempstr}`;
                    s += key === Object.keys(info).pop() ? '' : ']';
                }
            }
        }
        s += `@KSXT#${msg.FileData}`;
        msginfo += `\r\n${flag}_附件\r\n`;
        const file = msg.FileData.split('|');
        file.forEach((item, index) => {
            msginfo += `${index}#${item}\r\n`;
        });
        // 模拟日志记录
        console.log(msginfo);
        return s;
    }
}

export default ExamSystem;
