// 模拟 TradeManagerHandle 类
class TradeManagerHandle {
    static GetSysconfigList(_: any) {
        // 这里需要根据实际情况实现获取配置列表的逻辑
        return [];
    }
}

// 模拟配置项对象
interface ConfigItem {
    Configname: string;
    Configvalue: string;
}

class SystemSettingsHelper {
    private static _instance: SystemSettingsHelper;
    private _dict: { [key: string]: string } = {};

    private constructor() {
        const list = TradeManagerHandle.GetSysconfigList(null) as ConfigItem[];
        list.forEach(item => {
            this._dict[item.Configname] = item.Configvalue;
        });
    }

    static get Instance(): SystemSettingsHelper {
        if (!this._instance) {
            this._instance = new SystemSettingsHelper();
        }
        return this._instance;
    }

    get IsCheckUpdate(): boolean {
        let flag = true;
        if (this._dict.hasOwnProperty('自动更新')) {
            flag = this.parseBoolean(this._dict['自动更新']);
        }
        return flag;
    }

    get IsIdCheck(): boolean {
        let flag = true;
        if (this._dict.hasOwnProperty('联网核查')) {
            flag = this.parseBoolean(this._dict['联网核查']);
        }
        return flag;
    }

    get LoginBackgroundFile(): string {
        let ret = '';
        if (this._dict.hasOwnProperty('登陆背景')) {
            ret = this._dict['登陆背景'];
        }
        return ret;
    }

    get IsTellerCustomer(): boolean {
        let flag = true;
        if (this._dict.hasOwnProperty('客户是否是柜员')) {
            flag = this.parseBoolean(this._dict['客户是否是柜员']);
        }
        return flag;
    }

    private parseBoolean(value: string): boolean {
        return value.toLowerCase() === 'true';
    }
}

export default SystemSettingsHelper;