// 模拟 TellerSystem.Upgrade 模块
interface TellerSystemUpgrade {
    CheckUpdate(): boolean;
    ShowDialog(): void;
    UpdateTradeDll(actionName: string): boolean;
}

class UpgradeClass {
    private window: TellerSystemUpgrade;

    constructor() {
        // 模拟加载 TellerSystem.Upgrade 模块
        // 这里需要根据实际情况替换为真实的加载逻辑
        this.window = {
            CheckUpdate: () => false,
            ShowDialog: () => { console.log('Upgrade window shown'); },
            UpdateTradeDll: (actionName: string) => false
        };
    }

    get CheckUpgrade(): boolean {
        return this.window.CheckUpdate();
    }

    BeginUpdating(): void {
        this.window.ShowDialog();
    }

    UpdateTradeDll(actionName: string): boolean {
        return this.window.UpdateTradeDll(actionName);
    }
}

export { UpgradeClass };