﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Platform.Presentation.Interfaces;
using System.Windows;

namespace TellerSystem.Library.Ext.TradeExtension
{
   public class WorkFlowDataHelper
    {
       public WorkFlowDataHelper(IPage page)
       {

           if (page != null)
               _tradeBusData = TradeInfoData.GetTradeInfo((DependencyObject)page).TradeBus;
       }
       private TradeBusData _tradeBusData;
       public TradeBusData tradeBusData
       {
           get
           {
               return _tradeBusData;
           }
       }
        #region 工作流相关总线数据
       //是否走工作流：true 是;false 否
       public string IsWorkFlow
       {
           get
           {
               return _tradeBusData["IsWorkFlow"];
           }
           set
           {
               _tradeBusData["IsWorkFlow"] = value;
           }
       }
       //工作流流程实例ID
       public string ProcessId
       {
           get
           {
               return _tradeBusData["ProcessId"];
           }
           set
           {
               _tradeBusData["ProcessId"] = value;
           }
       }
       //授权复核检查结果
       public string CheckFlag
       {
           get
           {
               return _tradeBusData["CheckFlag"];
           }
           set
           {
               _tradeBusData["CheckFlag"] = value;
           }
       }
       //复件ID集合(以|线分隔)
       public string ImageId
       {
           get
           {
               return _tradeBusData["ImageId"];
           }
           set
           {
               _tradeBusData["ImageId"] = value;
           }
       }
       //工作流任务ID
       public string WorkItemId
       {
           get
           {
               return _tradeBusData["WorkItemId"];
           }
           set
           {
               _tradeBusData["WorkItemId"] = value;
           }
       }
       //授权(复合)级别
       public string Lvl
       {
           get
           {
               return tradeBusData["lvl"];
           }
           set
           {
               tradeBusData["lvl"] = value;
           }
       }
       //授权(复合)柜员机构
       public string Branch
       {
           get
           {
               return tradeBusData["Branch"];
           }
           set
           {
               tradeBusData["Branch"] = value;
           }
       }
       //清理总线中工作流相关数据
       public void ClearWorkFlowData()
       {      
           _tradeBusData.Remove("IsWorkFlow");
           _tradeBusData.Remove("ProcessId");
           _tradeBusData.Remove("CheckFlag");
           _tradeBusData.Remove("ImageId");
           _tradeBusData.Remove("WorkItemId");
           tradeBusData.Remove("lvl");
           tradeBusData.Remove("Branch");
       }
        #endregion
    }
}
