﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Runtime.InteropServices;
using System.Diagnostics;

namespace TellerSystem.Library.Ext.TradeExtension
{
    public class ExamObject : DependencyObject
    {
        /// <summary>
        /// 是否考试模式
        /// </summary>
        public bool IsExamModel
        {
            get { return (bool)GetValue(IsExamModelProperty); }
            set { SetValue(IsExamModelProperty, value); }
        }

        // Using a DependencyProperty as the backing store for IsExamModel.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty IsExamModelProperty =
            DependencyProperty.Register("IsExamModel", typeof(bool), typeof(ExamObject), new UIPropertyMetadata(false));

        /// <summary>
        /// 题号
        /// </summary>
        public string QuestionKey
        {
            get { return (string)GetValue(QuestionKeyProperty); }
            set { SetValue(QuestionKeyProperty, value); }
        }

        // Using a DependencyProperty as the backing store for QuestionKey.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty QuestionKeyProperty =
            DependencyProperty.Register("QuestionKey", typeof(string), typeof(ExamObject), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 题干
        /// </summary>
        public string QuestionName
        {
            get { return (string)GetValue(QuestionNameProperty); }
            set { SetValue(QuestionNameProperty, value); }
        }

        // Using a DependencyProperty as the backing store for QuestionName.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty QuestionNameProperty =
            DependencyProperty.Register("QuestionName", typeof(string), typeof(ExamObject), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 当前时间
        /// </summary>
        public string TimeNow
        {
            get { return (string)GetValue(TimeNowProperty); }
            set { SetValue(TimeNowProperty, value); }
        }

        // Using a DependencyProperty as the backing store for QuestionName.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty TimeNowProperty =
            DependencyProperty.Register("TimeNow", typeof(string), typeof(ExamObject), new UIPropertyMetadata(string.Empty));



        /// <summary>
        /// 开始时间
        /// </summary>
        public string StartTime
        {
            get { return (string)GetValue(StartTimeProperty); }
            set { SetValue(StartTimeProperty, value); }
        }

        // Using a DependencyProperty as the backing store for QuestionName.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty StartTimeProperty =
            DependencyProperty.Register("StartTime", typeof(string), typeof(ExamObject), new UIPropertyMetadata(string.Empty));


        /// <summary>
        /// 考试时长
        /// </summary>
        public string ExamLast
        {
            get { return (string)GetValue(ExamLastProperty); }
            set { SetValue(ExamLastProperty, value); }
        }

        // Using a DependencyProperty as the backing store for QuestionName.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ExamLastProperty =
            DependencyProperty.Register("ExamLast", typeof(string), typeof(ExamObject), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 剩余时长，单位秒
        /// </summary>
        public string LeftTotalSeconds
        {
            get { return (string)GetValue(LeftTotalSecondsProperty); }
            set { SetValue(LeftTotalSecondsProperty, value); }
        }

        // Using a DependencyProperty as the backing store for QuestionName.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty LeftTotalSecondsProperty =
            DependencyProperty.Register("LeftTotalSeconds", typeof(string), typeof(ExamObject), new UIPropertyMetadata(string.Empty));

        
        public static ExamObject GetExamObject(DependencyObject obj)
        {
            return (ExamObject)obj.GetValue(ExamObjectProperty);
        }

        public static void SetExamObject(DependencyObject obj, ExamObject value)
        {
            obj.SetValue(ExamObjectProperty, value);
        }

        // Using a DependencyProperty as the backing store for ExamObject.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ExamObjectProperty =
            DependencyProperty.RegisterAttached("ExamObject", typeof(ExamObject), typeof(ExamObject), new UIPropertyMetadata(null));
    }
}
