// 模拟 IMainPage 接口
interface IMainPage {
    AddForceNotifyPlan(target: any): unknown;
    // 这里可以根据实际情况添加接口方法
}

// 定义 MainPageManager 类
class MainPageManager {
    private static _mainPage: IMainPage | null = null;

    /**
     * 注册主交易
     * @param mainPage 主交易页面实例
     */
    public static Regist(mainPage: IMainPage): void {
        if (this._mainPage !== null) {
            throw new Error('MainPage is Already Registed!');
        }
        this._mainPage = mainPage;
    }

    /**
     * 取消注册
     */
    public static UnRegist(): void {
        this._mainPage = null;
    }

    /**
     * 获取主交易页面实例
     * @returns 主交易页面实例或 null
     */
    public static GetMainPage(): IMainPage | null {
        return this._mainPage;
    }
}

export { MainPageManager, IMainPage };
