/**
 * 项目层运行参数
 */
export class ClientSettings {
    /**
     * 当前客户端文件的版本信息
     */
    private static _currentVersionInfo: PFUsedFileInfo[] = [];

    //#region 基础运行配置
    
    /**
     * 配置文件目录
     */
    public static get ConfigPath(): string {
        return "Config";
    }

    public static get MenuFileName(): string {
        return "Menu.xml";
    }

    public static get TaskMenuFileName(): string {
        return "TaskMenu.xml";
    }

    /**
     * 获取或设置当前客户端文件的版本信息
     */
    public static get CurrentVersionInfo(): PFUsedFileInfo[] {
        return this._currentVersionInfo;
    }

    public static set CurrentVersionInfo(value: PFUsedFileInfo[]) {
        this._currentVersionInfo = value;
    }
    
    //#endregion
}

/**
 * 使用的文件信息接口
 */
export interface PFUsedFileInfo {
    // 根据实际需要定义文件信息属性
    fileName: string;
    version: string;
    lastModified: Date;
}