/**
 * 全局宏定义变量集合
 */
export class GlobalVariable {
    // 数据长度
    /**
     * 柜员号长度       6位
     */
    static readonly Len_TelNo = 6;
    /**
     * 日期长度
     */
    static readonly Len_Date = 8;
    /**
     * 金额
     */
    static readonly Len_Tx = 17;
    /**
     * 利率
     */
    static readonly Len_RATE = 9;
    /**
     * 账户序号
     */
    static readonly Len_AcSeqn = 4;
    /**
     * 柜员名称长度       6位
     */
    static readonly Len_TelName = 60;
    /**
     *  机构号长度       5位
     */
    static readonly Len_BrNo = 10;
    /**
     * 户名长度         60位
     */
    static readonly Len_AcName = 100;
    /**
     * 机构名长度       60位
     */
    static readonly Len_BrName = 60;
    /**
     * 地址长度         60位
     */
    static readonly Len_Addr = 60;
    /**
     * 摘要长度         20位
     */
    static readonly Len_Brf = 60;
    /**
     * 账号长度         24位  --- 大小额系统要求账号长度为32
     */
    static readonly Len_AcNo = 32;
    /**
     * 卡号长度
     */
    static readonly Len_CardNo = 19;
    /**
     * 凭证号长度       16位
     */
    static readonly Len_NoteNo = 16;
    /**
     * 证件号长度       20位
     */
    static readonly Len_IdNo = 20;
    /**
     * 支付行号长度     12位
     */
    static readonly Len_OrBrNo = 12;
    /**
     * 贷款的借据号长度 20位
     */
    static readonly Len_PactNo = 20;
    /**
     * 承兑汇票号码长度 16位
     */
    static readonly Len_PoNo = 16;
    /**
     * 密码长度         6位
     */
    static readonly Len_Pwd = 6;
    /**
     * 密码
     */
    static readonly MAXLen_Pwd = 16;
    /**
     * 客户号长度         8位
     */
    static readonly Len_CifNo = 11;
    /**
     * 科目号长度         8位
     */
    static readonly Len_AccNo = 8;
    /**
     * 汇票号码长度         8位
     */
    static readonly Len_HpNo = 16;
    /**
     * 本票号码长度         12位
     */
    static readonly Len_BpNo = 12;
    /**
     * 科目名称长度
     */
    static readonly Len_AccName = 60;
    /**
     * 产品名称长度
     */
    static readonly Len_ProdName = 100;
    /**
     * 备注长度
     */
    static readonly Len_Etc = 60;
    /**
     * 合同号
     */
    static readonly Len_ContactNo = 20;
    /**
     * 科目号
     */
    static readonly Len_SubjectNo = 8;
    /**
     * 菜单编号
     */
    static readonly Len_MenuNo = 4;
    /**
     * 存在老账号的银行老账号最大长度为24位，如长春经开融丰、长春融泰
     */
    static readonly Len_OldAccountMaxLength = 24;

    // 业务数据
    /**
     * 清算行号313141052422
     */
    static readonly Qs_No = "313141052422";
    /**
     * 库存现金 科目号  100101
     */
    static readonly CASH_ACC_NO = "100101";
    /**
     * 存现
     */
    static readonly YW_TYPE_CX = "1100";
    /**
     * 取现
     */
    static readonly YW_TYPE_QX = "2100";
    /**
     * 一般转出
     */
    static readonly YW_TYPE_ZC = "3100";
    /**
     * 转账消费 （如：pos消费）
     */
    static readonly YW_TYPE_ZZXF = "3200";
    /**
     * 转账代扣
     */
    static readonly YW_TYPE_ZZDK = "3400";
    /**
     * 外币转账
     */
    static readonly YW_TYPE_ZZWB = "3500";
    /**
     * 转账还贷
     */
    static readonly YW_TYPE_ZZHD = "3600";
    /**
     * 扣划转出
     */
    static readonly YW_TYPE_KHZC = "3700";
    /**
     * 汇出
     */
    static readonly YW_TYPE_HC = "3800";
    /**
     * 部提转出
     */
    static readonly YW_TYPE_BTZC = "3a00";
    /**
     * 销户转出
     */
    static readonly YW_TYPE_XHZC = "3b00";
    /**
     * 开定期转出
     */
    static readonly YW_TYPE_TDZC = "3c00";
    /**
     * 一般转入
     */
    static readonly YW_TYPE_ZR = "4100";
    /**
     * 代发转入
     */
    static readonly YW_TYPE_DFZR = "4300";
    /**
     * 汇入
     */
    static readonly YW_TYPE_HR = "4800";
    /**
     * 放贷转入
     */
    static readonly YW_TYPE_FDZR = "4900";
    /**
     * 部提转入
     */
    static readonly YW_TYPE_BTZR = "4a00";
    /**
     * 销户转入
     */
    static readonly YW_TYPE_XHZR = "4b00";
    /**
     * 开定期转入
     */
    static readonly YW_TYPE_TDZR = "4c00";
    /**
     * 普通查询
     */
    static readonly YW_TYPE_PTCX = "5100";
    /**
     * 境外查询
     */
    static readonly YW_TYPE_JWXX = "6100";
    /**
     * 验密
     */
    static readonly CHK_PWD_Y = "1";
    /**
     * 不验密
     */
    static readonly CHK_PWD_N = "0";
    /**
     * 由核心系统决定验密标志
     */
    static readonly CHK_PWD_O = "2";
    /**
     * 验磁
     */
    static readonly CHK_MSR_Y = "1";
    /**
     * 不验磁
     */
    static readonly CHK_MSR_N = "0";
    /**
     * 由核心系统决定验磁标志
     */
    static readonly CHK_MSR_O = "2";
    /**
     * 清算中心
     */
    static readonly QS_Center = "301002";
    /**
     * 老总部
     */
    static readonly old_Center = "461999";
    /**
     * 科技部
     */
    static readonly Tec_Center = "461900";
    /**
     * 存折对应的凭证类型值
     */
    static readonly BankBookType = "0010";

    /**
     * 支付系统行号
     */
    static Zfxthh: string;
}