// 假设 LoginUserInfo 是一个全局对象或者有对应的模块导出
// 这里简单模拟 LoginUserInfo 对象
interface LoginUserInfo {
    GetUserInfo(key: string): string;
    SetUserInfo(key: string, value: string): void;
}

declare const LoginUserInfo: LoginUserInfo;

/**
 * 登陆柜员的属性——扩展
 */
class LoginUserInfoExt {
    private constructor() {
        // 私有构造函数，防止外部实例化
    }

    /**
     * 交易时间，从核心通讯中FD6域进行更新，不一定实时
     */
    static get TradeTime(): string {
        return LoginUserInfo.GetUserInfo("TradeTime");
    }

    static set TradeTime(value: string) {
        LoginUserInfo.SetUserInfo("TradeTime", value);
    }

    /**
     * 单点登录系统 - 启动令牌
     */
    static get Token_SSO(): string {
        return LoginUserInfo.GetUserInfo("Token_SSO");
    }

    static set Token_SSO(value: string) {
        LoginUserInfo.SetUserInfo("Token_SSO", value);
    }
}

export { LoginUserInfoExt };