import { List } from "ant-design-vue";

// 定义 KeyValuePair 类型
type KeyValuePair = { key: string; value: string };

// 定义 IPage 接口
interface IPage {
    // 这里可以根据实际情况添加 IPage 接口的属性和方法
}

// 定义 Message 类
class Message {
    Fd16: string = "";
    Fd66: string = "";
    FileData: string = "";
}

// 定义 SystemFunction 类
class SystemFunction {
    static InitFd(page: IPage, msg: Message) {
        // 实现初始化逻辑
    }
    static CommSend(page: IPage, msg: Message) {
        // 实现通信发送逻辑
    }
    static CallServer(page: IPage, msg: Message) {
        // 实现调用服务器逻辑
    }
}

// 定义 SelectionManager 类
class SelectionManager {
    static Instance: SelectionManager = new SelectionManager();
    PullSelection(key: string, value: any): KeyValuePair[] {
        // 实现拉取选择项的逻辑
        return [];
    }
}

// 定义 UserVariable 类
class UserVariable {
    static GetCardBin(target: any) {
        return null;
    }
    static GetYorN(): KeyValuePair[] {
        return [
            { key: "是", value: "Y" },
            { key: "否", value: "N" }
        ];
    }

    static GetY0N1(): KeyValuePair[] {
        return [
            { key: "是", value: "1" },
            { key: "否", value: "0" }
        ];
    }

    static GetY1N0(): KeyValuePair[] {
        return [
            { key: "是", value: "1" },
            { key: "否", value: "0" }
        ];
    }

    static GetNorY(): KeyValuePair[] {
        return [
            { key: "否", value: "N" },
            { key: "是", value: "Y" }
        ];
    }

    static Getcertflag(): KeyValuePair[] {
        return [
            { key: "否", value: "N" },
            { key: "是", value: "Y" }
        ];
    }

    static Getpwdflag(): KeyValuePair[] {
        return [
            { key: "密码支取", value: "Y" },
            { key: "非密码支取", value: "N" }
        ];
    }

    static GetPerPwdflag(): KeyValuePair[] {
        return [
            { key: "密码支取", value: "Y" },
            { key: "证件支取", value: "ZJ" },
            { key: "密码证件支取", value: "MMZJ" },
            { key: "不可用证件", value: "NZJ" }
        ];
    }

    static Getpswdcd(): KeyValuePair[] {
        return [
            { key: "是", value: "Y" },
            { key: "否", value: "N" }
        ];
    }

    static Getatmk(): KeyValuePair[] {
        return [
            { key: "否", value: "0" },
            { key: "是", value: "1" }
        ];
    }

    static GetTctd(): KeyValuePair[] {
        return [
            { key: "关闭", value: "0" },
            { key: "通存通兑", value: "1" }
        ];
    }

    static Getcash(): KeyValuePair[] {
        return [
            { key: "开通", value: "1" },
            { key: "关闭", value: "0" }
        ];
    }

    static GetSex(): KeyValuePair[] {
        return [
            { key: "男", value: "0" },
            { key: "女", value: "1" }
        ];
    }

    static GetSexx(): KeyValuePair[] {
        return [
            { key: "男", value: "M" },
            { key: "女", value: "F" }
        ];
    }

    static GetCifRel(): KeyValuePair[] {
        return [
            { key: "本人", value: "0" },
            { key: "直系亲属", value: "1" },
            { key: "他人", value: "3" }
        ];
    }

    static Getbz(): KeyValuePair[] {
        return [
            { key: "人民币", value: "01" },
            { key: "美元", value: "02" }
        ];
    }

    // static GetCurNo(): KeyValuePair[] {
    //     return [
    //         { key: "人民币", value: "01" }
    //     ];
    // }hulei-/

    static GetCurNo_WB(): KeyValuePair[] {
        return SelectionManager.Instance.PullSelection("CUR_NO", null);
    }

    static GetCurNo(page: IPage): KeyValuePair[] {
        const msg = new Message();
        SystemFunction.InitFd(page, msg);
        SystemFunction.CommSend(page, msg);
        msg.Fd16 = "1729";
        msg.Fd66 = "0";
        SystemFunction.CallServer(page, msg);
        if (msg.FileData === "") {
            return [];
        }
        const result: KeyValuePair[] = [];
        const str = msg.FileData.split('\n');
        if (str && str.length > 0) {
            for (let i = 0; i < str.length; i++) {
                if (str[i].length > 0) {
                    const parts = str[i].split('|');
                    const key = parts[1].trim();
                    const value = parts[2].trim();
                    result.push({ key, value });
                }
            }
        }
        return result;
    }

    static GetCardPrdtNo(): KeyValuePair[] {
        return [
            { key: "人民币借记卡", value: "101" },
            { key: "美元借记卡", value: "104" }
        ];
    }

    static GetBZType(): KeyValuePair[] {
        return [
            { key: "人民币", value: "1" }
        ];
    }

    static Getbz_RMB(): KeyValuePair[] {
        return SelectionManager.Instance.PullSelection("CUR_NO", null);
    }
}

// 导出 UserVariable 类
export default UserVariable;
