﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TellerSystem.PrintTemplate.Bankbook.Interface;
using TellerSystem.PrintTemplate.Bankbook;

namespace TellerSystem.PrintTemplate
{
    public static class BankbookFactory
    {
        internal static IBankbook GetBankbook(BankBookKind kind)
        {
            IBankbook bankbook = null;
            switch (kind) 
            {
                //储蓄存折
                case BankBookKind.CXCZ:
                    bankbook = new CXCZBankbook();
                    break;
                default:
                    break;
            }
            return bankbook;
        }
    }

    /// <summary>
    /// 存折种类枚举
    /// </summary>
    public enum BankBookKind
    {
        /// <summary>
        /// 储蓄存折
        /// </summary>
        CXCZ,
        /// <summary>
        /// 零整存折
        /// </summary>
        LZCZ
    }
}
