﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TellerSystem.PrintTemplate.Bankbook
{
    /// <summary>
    /// Interaction logic for CXCZEndPage.xaml
    /// </summary>
    public partial class CXCZEndPage
    {
        public CXCZEndPage()
        {
            InitializeComponent();
        }

        #region   自定义属性
       

       public static readonly DependencyProperty AcNoProperty =
            DependencyProperty.Register("AcNo", typeof (string), typeof (CXCZEndPage), new PropertyMetadata(default(string)));
        /// <summary>
        /// 账号
        /// </summary>
        public string AcNo
        {
            get { return (string) GetValue(AcNoProperty); }
            set { SetValue(AcNoProperty, value); }
        }

        public static readonly DependencyProperty AcNameProperty =
            DependencyProperty.Register("AcName", typeof (string), typeof (CXCZEndPage), new PropertyMetadata(default(string)));
        /// <summary>
        /// 户名
        /// </summary>
        public string AcName
        {
            get { return (string)GetValue(AcNameProperty); }
            set { SetValue(AcNameProperty, value); }
        }

        public static readonly DependencyProperty XHDateProperty =
            DependencyProperty.Register("XHDate", typeof (string), typeof (CXCZEndPage), new PropertyMetadata(Platform.Common.RunningParameters.LoginUserInfo.TradeDate));
        /// <summary>
        /// 销户日
        /// </summary>
        public string XHDate
        {
            get { return (string)GetValue(XHDateProperty); }
            set { SetValue(XHDateProperty, value); }
        }

        public static readonly DependencyProperty BenJinProperty =
            DependencyProperty.Register("BenJin", typeof (string), typeof (CXCZEndPage), new PropertyMetadata(default(string)));
        /// <summary>
        /// 本金
        /// </summary>
        public string BenJin
        {
            get { return (string) GetValue(BenJinProperty); }
            set { SetValue(BenJinProperty, value); }
        }

        public static readonly DependencyProperty LiXiProperty =
            DependencyProperty.Register("LiXi", typeof(string), typeof(CXCZEndPage), new PropertyMetadata(default(string)));
        /// <summary>
        /// 利息
        /// </summary>
        public string LiXi
        {
            get { return (string)GetValue(LiXiProperty); }
            set { SetValue(LiXiProperty, value); }
        }

        public static readonly DependencyProperty ShuiJinProperty =
            DependencyProperty.Register("ShuiJin", typeof(string), typeof(CXCZEndPage), new PropertyMetadata(default(string)));
        /// <summary>
        /// 税金
        /// </summary>
        public string ShuiJin
        {
            get { return (string)GetValue(ShuiJinProperty); }
            set { SetValue(ShuiJinProperty, value); }
        }

        public static readonly DependencyProperty BenXiHeJiProperty =
            DependencyProperty.Register("BenXiHeJi", typeof(string), typeof(CXCZEndPage), new PropertyMetadata(default(string)));

        /// <summary>
        /// 本金利息合计
        /// </summary>
        public string BenXiHeJi
        {
            get { return (string)GetValue(BenXiHeJiProperty); }
            set { SetValue(BenXiHeJiProperty, value); }
        }

        public static readonly DependencyProperty TellerProperty =
            DependencyProperty.Register("Teller", typeof (string), typeof (CXCZEndPage), new PropertyMetadata(Platform.Common.RunningParameters.LoginUserInfo.TellerNo));

        /// <summary>
        /// 操作员
        /// </summary>
        public string Teller
        {
            get { return (string)GetValue(TellerProperty); }
            set { SetValue(TellerProperty, value); }
        }

        #endregion
    }
}
