﻿using System.Collections.Generic;
using Platform.Print;
using System;
using System.Linq;

namespace TellerSystem.PrintTemplate.Bankbook
{
    /// <summary>
    /// 定期存折
    /// </summary>
    public class DQCZBankbook
    {
        private static DQCZBankbook _instance;

        public static DQCZBankbook GetInstance()
        {
            if (_instance == null) 
            {
                _instance = new DQCZBankbook();
            }
            return _instance;
        }

        private const int PrintPageNum = 7;

        /// <summary>
        /// 首页数据
        /// </summary>
        public DQCZFirstPageEntity FirstPageData { get; set; }

        /// <summary>
        /// 子账户头数据
        /// </summary>
        public List<DQCZSubAcTitleEntity> SubAcTitleList { get; set; }

        /// <summary>
        /// 打印定期首页
        /// </summary>
        /// <returns></returns>
        //public List<PrintContainer> PrintFirstPage()
        //{
        //    var retData = new List<PrintContainer>();  
        //    if(FirstPageData == null)
        //        return retData;

        //    DQCZFirstPage aFirstPage = new DQCZFirstPage();
        //    aFirstPage.Description = "请打印第1页！";
        //    aFirstPage.AcNo = FirstPageData.AcNo;
        //    aFirstPage.AccountName = FirstPageData.AcName;
        //    aFirstPage.CzNo = FirstPageData.CzNum;
        //    aFirstPage.DrawType = FirstPageData.DrawMode;
        //    aFirstPage.OpnBrno = FirstPageData.OpnBr;
        //    aFirstPage.DepartDate = FirstPageData.OpnDate;
        //    aFirstPage.TellerNo = FirstPageData.Teller;
        //    var SubAcTitle = SubAcTitleList.Where(p => p.AcNoSeqn == 200).ToList();
        //    if (SubAcTitle.Count != 0)
        //    {
        //        aFirstPage.AccountName1 = SubAcTitle[0].AcName;
        //        aFirstPage.AcSeqn1 = SubAcTitle[0].AcNoSeqn.ToString();
        //        aFirstPage.Amt1 = SubAcTitle[0].AcAmt;
        //        aFirstPage.AutoFlag1 = SubAcTitle[0].AutoDeposit;
        //        aFirstPage.DualDate1 = SubAcTitle[0].DualDate;
        //        aFirstPage.Rate1 = SubAcTitle[0].Rate;
        //        aFirstPage.Term1 = SubAcTitle[0].Term;
        //        aFirstPage.OpnDate1 = SubAcTitle[0].TxDate;

        //    }

        //    var tmpFpPage = new List<DQCZSubAcEntity>();
        //    tmpFpPage.AddRange(SubAcData);
        //    aFirstPage.lsvData.ItemsSource = tmpFpPage;
        //    retData.Add(aFirstPage);
        //    return retData;
        //}

        /// <summary>
        /// 打印子账户头
        /// </summary>
        /// <returns></returns>
        //public List<PrintContainer> PrintSubAcTitle()
        //{
        //    var retData = new List<PrintContainer>();
        //    int pageNo = AcNoSeqn;

        //    int curLine = Convert.ToInt32(SubAcData[0].Seqn);
        //    pageNo = Convert.ToInt32(curLine / 7);
        //    curLine = curLine - pageNo * 7;

        //    //第一个账号
        //    if (pageNo == 0)
        //    {
        //        if(SubAcTitle != null)
        //        {
        //            DQCZFirstPage aFirstPage = new DQCZFirstPage();
        //            aFirstPage.Description = "请打印第1页！";
        //            aFirstPage.AccountName1 = SubAcTitle.AcName;
        //            aFirstPage.AcSeqn1 = SubAcTitle.AcSeqn;
        //            aFirstPage.Amt1 = SubAcTitle.AcAmt;
        //            aFirstPage.OpnDate1 = SubAcTitle.TxDate;
        //            aFirstPage.DualDate1 = SubAcTitle.DualDate;
        //            aFirstPage.Term1 = SubAcTitle.Term;
        //            aFirstPage.Rate1 = SubAcTitle.Rate;
        //            aFirstPage.AutoFlag1 = SubAcTitle.AutoDeposit;

        //            var tmpFpPage = new List<DQCZSubAcEntity>();
        //            tmpFpPage.AddRange(SubAcData);
        //            aFirstPage.lsvData.ItemsSource = tmpFpPage;

        //            retData.Add(aFirstPage);
        //        }
        //    }
        //    else
        //    {
        //        //偶数序号账号
        //        if (pageNo % 2 == 0)
        //        {
        //            if (SubAcTitle != null)
        //            {
        //                DQCZPage aPage = new DQCZPage();
        //                aPage.Description = string.Format("请打印第{0}页！", (pageNo / 2 + 1).ToString());
        //                aPage.AccountName1 = SubAcTitle.AcName;
        //                aPage.AcSeqn1 = SubAcTitle.AcSeqn;
        //                aPage.Amt1 = SubAcTitle.AcAmt;
        //                aPage.OpnDate1 = SubAcTitle.TxDate;
        //                aPage.DualDate1 = SubAcTitle.DualDate;
        //                aPage.Term1 = SubAcTitle.Term;
        //                aPage.Rate1 = SubAcTitle.Rate;
        //                aPage.AutoFlag1 = SubAcTitle.AutoDeposit;

        //                var tmpFpPage = new List<DQCZSubAcEntity>();
        //                tmpFpPage.AddRange(SubAcData);
        //                aPage.lsvData1.ItemsSource = tmpFpPage;

        //                retData.Add(aPage);
        //            }
        //        }else if (SubAcTitle != null)
        //        {
        //            //奇数序号账号
        //            DQCZPage aPage = new DQCZPage();
        //            aPage.Description = string.Format("请打印第{0}页！", ((pageNo + 1) / 2 + 1).ToString());
        //            aPage.AccountName = SubAcTitle.AcName;
        //            aPage.AcSeqn = SubAcTitle.AcSeqn;
        //            aPage.Amt = SubAcTitle.AcAmt;
        //            aPage.OpnDate = SubAcTitle.TxDate;
        //            aPage.DualDate = SubAcTitle.DualDate;
        //            aPage.Term = SubAcTitle.Term;
        //            aPage.Rate = SubAcTitle.Rate;
        //            aPage.AutoFlag = SubAcTitle.AutoDeposit;

        //            var tmpFpPage = new List<DQCZSubAcEntity>();
        //            tmpFpPage.AddRange(SubAcData);
        //            aPage.lsvData.ItemsSource = tmpFpPage;

        //            retData.Add(aPage);
        //        }
        //    }
        //    return retData;
        //}

        /// <summary>
        /// 打印子账户数据
        /// </summary>
        /// <returns></returns>
        //public List<PrintContainer> PrintSubAcPage()
        //{
        //    var retData = new List<PrintContainer>();
        //    List<DQCZSubAcEntity> initRows = null;
        //    var allRows = new List<DQCZSubAcEntity>();
        //    int pageNo = 0;
        //    int curLine = 0;

        //    if (SubAcData == null)
        //        return retData;

        //    curLine = Convert.ToInt32(SubAcData[0].Seqn);
        //    initRows = new List<DQCZSubAcEntity>();

        //    pageNo = Convert.ToInt32(curLine / 7);
        //    curLine = curLine - pageNo * 7;
        //    for (int j = 0; j < curLine - 1; j++)
        //    {
        //        initRows.Add(new DQCZSubAcEntity());
        //    }


        //    allRows.AddRange(initRows);
        //    allRows.AddRange(SubAcData);

        //    //第一个账号
        //    if(pageNo ==0)
        //    {
        //        var aFirstPage = new DQCZFirstPage();
        //        aFirstPage.Description = "请打印第1页！";
        //        aFirstPage.lsvData.ItemsSource = allRows;
        //        retData.Add(aFirstPage);
        //    }
        //    else
        //    {
        //        //偶数序号账号
        //        if (pageNo % 2 == 0)
        //        {
        //            var aPage = new DQCZPage();
        //            aPage.lsvData1.ItemsSource = allRows;
        //            aPage.Description = string.Format("请打印第{0}页！", (pageNo/2 + 1).ToString());
        //            retData.Add(aPage);
        //        }
        //        else
        //        {
        //            //奇数序号账号
        //            var aPage = new DQCZPage();
        //            aPage.Description = string.Format("请打印第{0}页！", ((pageNo+1)/2 + 1).ToString());
        //            aPage.lsvData.ItemsSource = allRows;
        //            retData.Add(aPage);
        //        }

        //    }
        //    return retData;
        //}

        public List<PrintContainer> PrintDQCZ()
        {
            var PrintList = new List<PrintContainer>();
            var dqcdPageList = new List<DQCZPage>();
            var SubAcTitle = SubAcTitleList.Where(p => p.PrintPageNo == 1).ToList();
            //打印第一页
            if (FirstPageData != null)
            {
                DQCZFirstPage aFirstPage = new DQCZFirstPage();
                aFirstPage.Description = "请打印第1页！";
                aFirstPage.AcNo = FirstPageData.AcNo;
                aFirstPage.AccountName = FirstPageData.AcName;
                aFirstPage.CzNo = FirstPageData.CzNum;
                aFirstPage.DrawType = FirstPageData.DrawMode;
                aFirstPage.OpnBrno = FirstPageData.OpnBr;
                aFirstPage.DepartDate = FirstPageData.OpnDate;
                aFirstPage.TellerNo = FirstPageData.Teller;

                if (SubAcTitle.Count != 0)
                {
                    aFirstPage.AccountName1 = SubAcTitle[0].AcName;
                    aFirstPage.AcSeqn1 = SubAcTitle[0].AcNoSeqn.ToString();
                    aFirstPage.CurNo1 = SubAcTitle[0].CurNo;
                    aFirstPage.Amt1 = SubAcTitle[0].AcAmt;
                    aFirstPage.AutoFlag1 = SubAcTitle[0].AutoDeposit;
                    aFirstPage.DualDate1 = SubAcTitle[0].DualDate;
                    aFirstPage.Rate1 = SubAcTitle[0].Rate;
                    aFirstPage.Term1 = SubAcTitle[0].Term;
                    aFirstPage.OpnDate1 = SubAcTitle[0].TxDate;
                    aFirstPage.ChangePageStr = SubAcTitle[0].ChangePageStr;
                    aFirstPage.SubAcData = SubAcTitle[0].SubAcData;
                    aFirstPage.Setvalue();
                    // aFirstPage.lsvData.ItemsSource = SubAcTitle[0].SubAcData;
                }
                PrintList.Add(aFirstPage);
            }
            else
            {
                if (SubAcTitle.Count != 0)
                {
                    DQCZFirstPage aFirstPage = new DQCZFirstPage();
                    aFirstPage.AccountName1 = SubAcTitle[0].AcName;
                    aFirstPage.AcSeqn1 = SubAcTitle[0].AcNoSeqn == 0 ? "" : SubAcTitle[0].AcNoSeqn.ToString();
                    aFirstPage.CurNo1 = SubAcTitle[0].CurNo;
                    aFirstPage.Amt1 = SubAcTitle[0].AcAmt;
                    aFirstPage.AutoFlag1 = SubAcTitle[0].AutoDeposit;
                    aFirstPage.DualDate1 = SubAcTitle[0].DualDate;
                    aFirstPage.Rate1 = SubAcTitle[0].Rate;
                    aFirstPage.Term1 = SubAcTitle[0].Term;
                    aFirstPage.OpnDate1 = SubAcTitle[0].TxDate;
                    aFirstPage.ChangePageStr = SubAcTitle[0].ChangePageStr;
                    aFirstPage.SubAcData = SubAcTitle[0].SubAcData;
                    aFirstPage.Setvalue();
                    // aFirstPage.lsvData.ItemsSource = SubAcTitle[0].SubAcData;
                    PrintList.Add(aFirstPage);
                }
            }
            SubAcTitle = SubAcTitleList.Where(p => p.PrintPageNo != 1).ToList();
            foreach (var item in SubAcTitle)
            {
                var dqcdpage = dqcdPageList.Where(p => p.PageNo == item.PrintPageNo).ToList();
                if (dqcdpage.Count == 0)
                {
                    DQCZPage NewPage = new DQCZPage();
                    NewPage.PageNo = item.PrintPageNo;
                    dqcdPageList.Add(NewPage);
                }
                dqcdpage = dqcdPageList.Where(p => p.PageNo == item.PrintPageNo).ToList();

                if (item.PrintPageNo % 2 == 0)
                {
                    dqcdpage[0].Description = string.Format("请打印第{0}页！", item.PrintPageNo);
                    dqcdpage[0].AccountName = item.AcName;
                    dqcdpage[0].AcSeqn = item.AcNoSeqn == 0 ? "" : item.AcNoSeqn.ToString();
                    dqcdpage[0].CurNo = item.CurNo;
                    dqcdpage[0].Amt = item.AcAmt;
                    dqcdpage[0].OpnDate = item.TxDate;
                    dqcdpage[0].DualDate = item.DualDate;
                    dqcdpage[0].Term = item.Term;
                    dqcdpage[0].Rate = item.Rate;
                    dqcdpage[0].AutoFlag = item.AutoDeposit;
                    dqcdpage[0].ChangePageStr = item.ChangePageStr;
                    dqcdpage[0].PageSubAcData1 = item.SubAcData;
                    dqcdpage[0].Setvalueup();
                    //dqcdpage[0].lsvData.ItemsSource = item.SubAcData;
                }
                else
                {
                    dqcdpage[0].Description = string.Format("请打印第{0}页！", item.PrintPageNo);
                    dqcdpage[0].AccountName1 = item.AcName;
                    dqcdpage[0].AcSeqn1 = item.AcNoSeqn == 0 ? "" : item.AcNoSeqn.ToString();
                    dqcdpage[0].CurNo1 = item.CurNo;
                    dqcdpage[0].Amt1 = item.AcAmt;
                    dqcdpage[0].OpnDate1 = item.TxDate;
                    dqcdpage[0].DualDate1 = item.DualDate;
                    dqcdpage[0].Term1 = item.Term;
                    dqcdpage[0].Rate1 = item.Rate;
                    dqcdpage[0].AutoFlag1 = item.AutoDeposit;
                    dqcdpage[0].ChangePageStr1 = item.ChangePageStr;
                    dqcdpage[0].PageSubAcData2 = item.SubAcData;
                    dqcdpage[0].Setvaluedown();
                    //dqcdpage[0].lsvData1.ItemsSource = item.SubAcData;
                }
            }
            PrintList.AddRange(dqcdPageList);
            return PrintList;
        }
    }
}
