﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Media;
using System.Windows;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;
using System.IO;

namespace TellerSystem.PrintTemplate.Base
{
    /// <summary>
    /// 打印模板类型
    /// </summary>
    public enum PrintTypes
    {
        /// <summary>
        /// 无
        /// </summary>
        None,
        /// <summary>
        /// A4
        /// </summary>
        A4,
        /// <summary>
        /// 单位定期证实书（郑州修改）
        /// </summary>
        EnterpriseRegularlyConfirmation,
        EnterpriseRegularlyConfirmationQF,
        /// <summary>
        /// 单位定期存单
        /// </summary>
        EnterpriseRegularlyCDs,
        /// <summary>
        /// 担保公司特种存款凭证
        /// 郑州村镇没有
        /// </summary>
        //GuaranteeSpecialCDs,
        /// <summary>
        /// 储蓄存折首页（郑州修改）
        /// </summary>
        BankBookFirstPage,
        BankBookFirstPageQF,
        ///// <summary>
        ///// 对账折首页
        ///// 郑州村镇没有
        ///// </summary>
        //BankBookFirstPage1,
        ///// <summary>
        ///// 储蓄存折
        ///// </summary>
        BankBookPage,
        BankBookPageQF,
        ///// <summary>
        ///// 储蓄存折尾页
        ///// </summary>
        BankBookLastPage,
        BankBookLastPageQF,
        #region 添加焦作存折打印 add by liunianpeng start
        /// <summary>
        /// 储蓄存折首页
        /// </summary>
        JZDQBankBookFirstPage,
        /// <summary>
        /// 储蓄存折
        /// </summary>
        JZDQBankBookPage,
        /// <summary>
        /// 储蓄存折尾页
        /// </summary>
        JZDQBankBookLastPage,
        /// <summary>
        /// 储蓄活期存折首页
        /// </summary>
        JZHQBankBookFirstPage,
        /// <summary>
        /// 储蓄活期存折
        /// </summary>
        JZHQBankBookPage,
        /// <summary>
        /// 储蓄活期存折尾页
        /// </summary>
        JZHQBankBookLastPage,
        #endregion  添加焦作存折打印 add by liunianpeng end
        /// <summary>
        /// 储蓄存单(郑州修改)
        /// </summary>
        PersonalRegularlyCDs,
        PersonalRegularlyCDsQF,
        /// <summary>
        /// 银行本票
        /// </summary>
        PromissoryNote,
        ///// <summary>
        ///// 银行汇票
        ///// </summary>
        //BillOfExchange,
        /// <summary>
        /// 个人存款证明书
        /// </summary>
        PersonalCDsRecord,
        /// <summary>
        /// 个人存款证明书齐丰
        /// </summary>
        PersonalCDsRecordQF,
        /// <summary>
        /// 个人存款证明书扶沟
        /// </summary>
        PersonalCDsRecordFG,
        /// <summary>
        /// 小额支付系统专用凭证
        /// </summary>
        Micropayment,
        /// <summary>
        /// 大额支付系统专用凭证
        /// </summary>
        Largepayment,
        /// <summary>
        /// 承德银行个人（）凭证
        /// </summary>
        PersonalAccountingVoucher,
        /// <summary>
        /// 现金交款单
        /// </summary>
        CashPaymentNote,
        /// <summary>
        /// 现金缴款单（郑州修改）
        /// </summary>
        CashPaymentNote3,
        /// <summary>
        /// 淇县现金缴款单（201611201郑州新增）
        /// </summary>
        CashPaymentNoteQX,
        /// <summary>
        /// 业务凭条
        /// </summary>
        BusinessVoucher,
        /// <summary>
        /// 税务发票
        /// </summary>
        TaxInvoice,
        /// <summary>
        /// 假币收缴凭条
        /// </summary>
        CounterfeitMoneyVoucher,
        CounterfeitMoneyVoucherQF,
        /// <summary>
        /// 一本通存折首页
        /// </summary>
        BankOneBookFirstPage,
        /// <summary>
        /// 一本通存折
        /// </summary>
        BankOneBookPage,
        /// <summary>
        /// 一本通存折尾页
        /// </summary>
        BankOneBookLastPage,
        #region 村镇没有密码信封
        /// <summary>
        /// 广电收费收据
        /// </summary>
        //TelevisionFeeReceipt,
        /// <summary>
        /// 密码信封
        /// </summary>
        //PwdEnvelope,
        ///// <summary>
        ///// 密码信封-电子支付
        ///// </summary>
        //PwdEnvelopeOfElectronicPayment,
        /// <summary>
        /// 密码信封-网上银行
        /// </summary>
        //PwdEnvelopeOfCyberBank,
        /// <summary>
        /// 市区维修基金凭据
        /// </summary>
        //SQWXJJ,
        /// <summary>
        /// 兴业热力收据
        /// </summary>
        //XYRL,
        #endregion

        #region 郑州新加
        ///// <summary>
        ///// 电汇凭证（郑州新加）
        ///// </summary>
        //TelegraphicTransferPage,
        /// <summary>
        /// 挂失申请书（郑州新加）
        /// </summary>
        LostPage,
        /// <summary>
        /// 挂失申请书（濮阳新加）
        /// </summary>
        LossForm_PuYang,
        /// <summary>
        /// 挂失申请书（汇通新加）
        /// </summary>
        LossForm_HT,
        /// <summary>
        /// 个人特殊业务申请书（淇县新加）
        /// </summary>
        PensonSpecialPage_QiXian,
        /// <summary>
        /// 挂失申请书（淇县新加）
        /// </summary>
        LossForm_QiXian,   //BackgroundBrush_Print_GSSQSQX
        ///// <summary>
        ///// 进账单（郑州新加）
        ///// </summary>
        //IncomePage,
        /// <summary>
        /// 取款凭条正面（郑州新加）
        /// </summary>
        TakeMoneyFront,
        TakeMoneyFront_LSQF,
        ///// <summary>
        ///// 收费凭条
        ///// </summary>
        //ChargePage,
        /// <summary>
        /// 现金支票
        /// </summary>
        CashCheck,
        /// <summary>
        /// 证实书
        /// </summary>
        ProvePage,
        /// <summary>
        /// 转账支票
        /// </summary>
        TransferCheck,
        /// <summary>
        /// 存款凭条
        /// </summary>
        SavePage,
        SavePage_LSQF,
        /// <summary>
        /// 业务凭条（小）
        /// </summary>
        SmallBusinessPage,
        /// <summary>
        /// 支行预留印鉴卡
        /// </summary>
        //BranchLeavePage,
        /// <summary>
        /// 贷方传票
        /// </summary>
        //LoanCitation,
        /// <summary>
        /// 借方传票
        /// </summary>
        //BorrowCitation,
        /// <summary>
        /// 承兑汇票
        /// </summary>
        AcceptanceDraft,
        /// <summary>
        /// 个人转账汇款凭证
        /// </summary>
        PersonTransferDraft,
        /// <summary>
        /// 印鉴卡
        /// </summary>
        SignatureCard,
        /// <summary>
        /// 齐丰印鉴卡
        /// </summary>
        SignatureCardQF,
        /// <summary>
        /// 新郑印鉴卡 (新郑郑银新增)
        /// </summary>
        SignatureCardXZ,
        /// <summary>
        /// 开户申请书
        /// </summary>
        AccountApplication,
        /// <summary>
        /// 鄢陵存款凭条
        /// </summary>
        SavePage_YL,
        /// <summary>
        /// 鄢陵取款凭条
        /// </summary>
        TakeMoneyFront_YL,

        #region 新密郑银新加
        /// <summary>
        /// 印鉴卡1_新密
        /// </summary>
        SignatureCard1_XM,
        /// <summary>
        /// 印鉴卡2_新密
        /// </summary>
        SignatureCard2_XM,
        #endregion

        #region 长春融丰新加
        /// <summary>
        /// 挂失申请书_长春融丰
        /// </summary>
        LostPage_CCRF,
        /// <summary>
        /// 假币收缴凭证_长春融丰
        /// </summary>
        CounterfeitMoneyVoucher_CCRF,
        /// <summary>
        /// 印鉴卡1_长春融丰
        /// </summary>
        SignatureCard1_CCRF,
        /// <summary>
        /// 印鉴卡2_长春融丰
        /// </summary>
        SignatureCard2_CCRF,


        #endregion

        #region 山东新加模板
        /// <summary>
        /// 开户申请书-扶沟
        /// </summary>
        AccountApplicationFG,
        /// <summary>
        /// 山东开户申请书
        /// </summary>
        AccountApplicationSD,
        /// <summary>
        /// 山东挂失申请书
        /// </summary>
        LostPageSD,
        ///// <summary>
        ///// 山东个人网银申请表
        ///// </summary>
        //AccountApplicationInternetSD,
        ///// <summary>
        ///// 山东个人网银短信验证码申请表
        ///// </summary>
        //AccountInternetSMSSD,
        /// <summary>
        /// 结算取款凭条山东
        /// </summary>
        ClearingwithdrawalSD,
        /// <summary>
        /// 结算转账凭条山东
        /// </summary>
        SettlementdepositsSD,
        ///// <summary>
        ///// 山东对公网银开户申请书
        ///// </summary>
        //ContraryApplicationSD,
        /// <summary>
        /// /贷款证首页
        /// </summary>
        LoanCardHome,
        /// <summary>
        /// 贷款证第二页
        /// </summary>
        LoanCardMiddle,
        /// <summary>
        /// 贷款证尾页
        /// </summary>
        LoanCardBack,
        /// <summary>
        /// 个人存款证明书山东
        /// </summary>
        PersonalCDsRecordSD,
        /// <summary>
        /// 交存凭证-山东
        /// </summary>
        PayRecordsSD,
        #endregion

        #region 都匀新加模板
        /// <summary>
        /// 开户申请书-都匀
        /// </summary>
        AccountApplicationDY,
        /// <summary>
        /// 都匀印鉴卡
        /// </summary>
        SignatureCardDY,
        /// <summary>
        /// 挂失申请书-都匀
        /// </summary>
        LostPageDY,
        /// <summary>
        /// 储蓄存单DY(都匀新增)
        /// </summary>
        PersonalRegularlyCDs_DY,
        /// <summary>
        /// 储蓄存折首页（都匀新增）
        /// </summary>
        BankBookFirstPageDY,
        /// <summary>
        /// 储蓄存折尾页
        /// </summary>
        BankBookLastPageDY,
        #endregion

        #region 阳光新加模板
        /// <summary>
        /// 存取款凭证
        /// </summary>
        AccessMoneyVoucherYG,
        /// <summary>
        /// 个人存款证明
        /// </summary>
        PersonalCDsRecordYG,
        #endregion

        #region 汇通新加模板
        /// <summary>
        /// 储蓄存单（汇通）
        /// </summary>
        PersonalRegularlyCDs_HT,
        /// <summary>
        /// 现金缴款单（汇通）
        /// </summary>
        CashPaymentNote_HT,
        /// <summary>
        /// 单位定期证实书（汇通）
        /// </summary>
        EnterpriseRegularlyConfirmation_HT,
        /// <summary>
        /// 单位定期存单（汇通）
        /// </summary>
        EnterpriseRegularlyCDs_HT,
        #endregion

        #region 隆丰新加模板
        /// <summary>
        /// 储蓄存单（隆丰）
        /// </summary>
        PersonalRegularlyCDsLF,
        /// <summary>
        /// 印鉴卡（隆丰）
        /// </summary>
        SignatureCardLF,
        /// <summary>
        /// 单位定期证实书（隆丰）
        /// </summary>
        EnterpriseRegularlyConfirmationLF,
        /// <summary>
        /// 个人存款证明（隆丰）
        /// </summary>
        PersonalCDsRecordLF,
        #endregion

        #region 确山浚县新加模板
        /// <summary>
        /// 储蓄存单（浚县）
        /// </summary>
        PersonalRegularlyCDs_XX,
        /// <summary>
        /// 储蓄存单（确山）
        /// </summary>
        PersonalRegularlyCDs_QS,
        #endregion
        /// <summary>
        /// 齐丰预约开户申请书
        /// </summary>
        Print_KHSQS_QF,
        #endregion

        #region 二代货币
        /// <summary>
        /// 假币调运清单
        /// </summary>
        Print_JBDYQD,
        /// <summary>
        /// 假币收缴凭证第一页
        /// </summary>
        Print_JBSJPZ_1,
        /// <summary>
        /// 假币收缴凭证第二页
        /// </summary>
        Print_JBSJPZ_2,
        /// <summary>
        /// 假币减损清单
        /// </summary>
        Print_JBJSQD,
        /// <summary>
        /// 假币解缴清单
        /// </summary>
        Print_JBJJQD,
        /// <summary>
        /// 假币调运接收凭证
        /// </summary>
        Print_JBDYJSPZ,
        /// <summary>
        /// 假人民币没收收据（个人）第一页
        /// </summary>
        Print_JRMBMSSJ_GR_1,
        /// <summary>
        /// 假人民币没收收据（个人）第二页
        /// </summary>
        Print_JRMBMSSJ_GR_2,
        /// <summary>
        /// 假人民币没收收据（单位）第一页
        /// </summary>
        Print_JRMBMSSJ_DW_1,
        /// <summary>
        /// 假人民币没收收据（单位）第二页
        /// </summary>
        Print_JRMBMSSJ_DW_2,
        /// <summary>
        /// 假币鉴定出库清单
        /// </summary>
        Print_JBJDCKQD,
        /// <summary>
        /// 真币误收差错单
        /// </summary>
        Print_ZBWSCCD,
        /// <summary>
        /// 天山个人开户申请书
        /// </summary>
        AccountApplicationTS,
        /// <summary>
        /// 天山印鉴卡
        /// </summary>
        SignatureCardTS,
        /// <summary>
        /// 天山存款证明书
        /// </summary>
        PersonalCDsRecordTS,
        /// <summary>
        /// 天山单位存款开户证实书
        /// </summary>
        EnterpriseRegularlyConfirmationTS,
        /// <summary>
        /// 转账支票
        /// </summary>
        TransferCheckTS,
        /// <summary>
        /// 天山对公挂失申请书
        /// </summary>
        LossForm_TS,
        #endregion
        #region 浚县
        /// <summary>
        /// 储蓄存折首页
        /// </summary>
        BankBookFirstPageXX,
        /// <summary>
        /// 储蓄存折尾页
        /// </summary>
        BankBookLastPageXX,
        /// <summary>
        /// 储蓄存折
        /// </summary>
        BankBookPageXX,
        /// <summary>
        /// 定期一本通存折首页
        /// </summary>
        BankBookFirstPageXX_DQYBT,
        /// <summary>
        /// 定期一本通存折尾页
        /// </summary>
        BankBookLastPageXX_DQYBT,
        /// <summary>
        /// 定期一本通存折
        /// </summary>
        BankBookPageXX_DQYBT,
        /// <summary>
        /// 印鉴卡
        /// </summary>
        SignatureCardXX,
        #endregion
        /// <summary>
        /// 现金支票正面-天山
        /// </summary>
        CashCheckTS,
        #region 天骄
        /// <summary>
        /// 贷款本息收回凭证，天骄
        /// </summary>
        LoanRecovery,
        /// <summary>
        /// 乳山天骄，印鉴卡底层预览图
        /// </summary>
        SignatureCard1_CCRF_TJ,
        /// <summary>
        /// 个人定期存单
        /// </summary>
        PersonalRegularlyCDsTJ,
        /// <summary>
        /// 单位定期证实书
        /// </summary>
        EnterpriseRegularlyConfirmationTJ,
        /// <summary>
        /// 单位定期存单
        /// </summary>
        EnterpriseRegularlyCDs_TJ,
        /// <summary>
        /// 存款证明书
        /// </summary>
        PersonalCDsRecordTJ,
        /// <summary>
        /// 行内转帐凭条
        /// </summary>
        TakeMoneyFront_LSQFZZ,
        #endregion
        /// <summary>
        /// 假币收缴凭条-新
        /// </summary>
        CounterfeitMoneyVoucherNew,
        /// <summary>
        /// 大石桥存款凭条
        /// </summary>
        SavePage_LF,
        /// <summary>
        /// 大石桥取款凭条
        /// </summary>
        TakeMoneyFront_LF,
        /// <summary>
        /// 浚县单位定期证实书
        /// </summary>
        EnterpriseRegularlyConfirmationXX,
        /// <summary>
        /// 新郑 农信银通存通兑凭条
        /// </summary>
        NXY_SavePage_XZ,
        /// 辰州存款凭条
        /// </summary>
        SavePage_CZ,
        /// <summary>
        /// 辰州取款凭条
        /// </summary>
        TakeMoneyFront_CZ,
        /// 鄢陵对公存款证明书
        /// </summary>
        PersonalCDsRecordYL_DG,
        /// <summary>
        /// 山东青隆现金缴款单
        /// </summary>
        CashPaymentNote_QL,
        /// <summary>
        /// 固始 农信银通存通兑凭条
        /// </summary>
        NXY_SavePage_GS,
        /// 鄢陵印鉴卡
        /// </summary>
        SignatureCardYL,
        /// 青隆-新存单
        /// </summary>
        PersonalRegularlyCDs_QL,
    }

    internal class PrintTypeArguments
    {
        #region ctor
        private Dictionary<string, PrintTypeArgument> _dict = new Dictionary<string, PrintTypeArgument>();
        private PrintTypeArguments()
        {
            //读取打印配置文件
            var g = RES.GetUri("Print/_config", false);
            LoadConfig(g);
            var v = RES.GetUri("Print/_config", true);
            if (!g.Equals(v))
                LoadConfig(v);
        }

        private static PrintTypeArguments _instance;

        public static PrintTypeArguments Instance
        {
            get
            {
                if (_instance == null)
                    _instance = new PrintTypeArguments();
                return _instance;
            }
        }
        #endregion

        #region Data
        private void LoadConfig(Uri config)
        {
            string log = string.Empty;
            try
            {
                if (config != null && config.IsFile && File.Exists(config.LocalPath))
                {
                    log = config.LocalPath;
                    File.ReadAllLines(config.LocalPath).ToList().ForEach(line =>
                    {
                        log = line;
                        var tmp = line.Split('|');
                        if (tmp.Length > 2)
                        {
                            _dict[tmp[0]] = new PrintTypeArgument(double.Parse(tmp[1]), double.Parse(tmp[2]), "Print/" + tmp[0]);
                        }
                    });
                }
            }
            catch
            {
                throw new FileFormatException("Print配置文件格式异常！" + log);
            }
        }
        #endregion

        #region Method
        /// <summary>
        /// 获取打印类型参数
        /// </summary>
        /// <param name="pt"></param>
        /// <returns></returns>
        public PrintTypeArgument GetPTArg(string pt)
        {
            PrintTypeArgument pta = null;
            if (_dict.ContainsKey(pt))
                pta = _dict[pt];
            return pta;
        }
        #endregion
    }

    internal class PrintTypeArgument
    {
        public PrintTypeArgument(double width, double height, string res)
        {
            Width = width * 0.3937 * 96;
            Height = height * 0.3937 * 96;
            Res = res;
        }

        /// <summary>
        /// 打印宽度
        /// </summary>
        public double Width { get; private set; }
        /// <summary>
        /// 打印高度
        /// </summary>
        public double Height { get; private set; }
        /// <summary>
        /// 资源
        /// </summary>
        public string Res { get; private set; }
        private Brush _printBackground;
        /// <summary>
        /// 打印背景
        /// </summary>
        public Brush PrintBackground
        {
            get
            {
                //懒加载
                if (_printBackground == null)
                    _printBackground = RES.GetBrush(Res);
                return _printBackground;
            }
        }
    }
}
