// 文本域类
class FieldBean {
    private fieldId: string;
    private fieldName: string;
    private fieldValue: string;
    private fieldValueHash: string;
    private fieldType: string;
    private templateIndex: number;

    // 获取 fieldId
    public getFieldId(): string {
        return this.fieldId;
    }

    // 设置 fieldId
    public setFieldId(fieldId: string): void {
        this.fieldId = fieldId;
    }

    // 获取 fieldName
    public getFieldName(): string {
        return this.fieldName;
    }

    // 设置 fieldName
    public setFieldName(fieldName: string): void {
        this.fieldName = fieldName;
    }

    // 获取 fieldValue
    public getFieldValue(): string {
        return this.fieldValue;
    }

    // 设置 fieldValue
    public setFieldValue(fieldValue: string): void {
        this.fieldValue = fieldValue;
    }

    // 获取 fieldValueHash
    public getFieldValueHash(): string {
        return this.fieldValueHash;
    }

    // 设置 fieldValueHash
    public setFieldValueHash(fieldValueHash: string): void {
        this.fieldValueHash = fieldValueHash;
    }

    // 获取 fieldType
    public getFieldType(): string {
        return this.fieldType;
    }

    // 设置 fieldType
    public setFieldType(fieldType: string): void {
        this.fieldType = fieldType;
    }

    // 获取 templateIndex
    public getTemplateIndex(): number {
        return this.templateIndex;
    }

    // 设置 templateIndex
    public setTemplateIndex(templateIndex: number): void {
        this.templateIndex = templateIndex;
    }

    // 构造函数
    constructor(fieldId: string, fieldValue: string, fieldValueHash: string, fieldType: string);
    constructor(fieldId: string, fieldValue: string, fieldValueHash: string, fieldType: string, templateIndex: number);
    constructor(fieldId: string, fieldName: string, fieldValue: string, fieldValueHash: string, fieldType: string);
    constructor(...args: any[]) {
        if (args.length === 4) {
            this.fieldId = args[0];
            this.fieldValue = args[1];
            this.fieldValueHash = args[2];
            this.fieldType = args[3];
            this.templateIndex = 0;
        } else if (args.length === 5) {
            if (typeof args[4] === 'number') {
                this.fieldId = args[0];
                this.fieldValue = args[1];
                this.fieldValueHash = args[2];
                this.fieldType = args[3];
                this.templateIndex = args[4];
            } else {
                this.fieldId = args[0];
                this.fieldName = args[1];
                this.fieldValue = args[2];
                this.fieldValueHash = args[3];
                this.fieldType = args[4];
                this.templateIndex = 0;
            }
        }
    }
}

export default FieldBean;