/**
 * 图片bean类
 */
class ImageBean {
    private imageWidth: string;
    private imageHeight: string;
    private pageNo: number = 1;
    private lx: string;
    private ly: string;
    private value: string;
    private hash: string;
    private type: string;
    private keyword: string;
    private locationStyle: string;
    private offsetX: number;
    private offsetY: number;
    private templateIndex: number;

    constructor();
    constructor(imageWidth: string, imageHeight: string, pageNo: number, lx: string, ly: string, value: string);
    constructor(imageWidth: string, imageHeight: string, pageNo: number, lx: string, ly: string, value: string, templateIndex: number);
    constructor(imageWidth: string, imageHeight: string, keyword: string, locationStyle: string, offsetX: number, offsetY: number, value: string);
    constructor(imageWidth: string, imageHeight: string, keyword: string, locationStyle: string, offsetX: number, offsetY: number, value: string, templateIndex: number);
    constructor(...args: any[]) {
        if (args.length === 6) {
            const [imageWidth, imageHeight, pageNo, lx, ly, value] = args;
            this.imageWidth = imageWidth;
            this.imageHeight = imageHeight;
            this.pageNo = pageNo;
            this.lx = lx;
            this.ly = ly;
            this.value = value;
            this.type = "2";
            this.templateIndex = 0;
        } else if (args.length === 7) {
            const [imageWidth, imageHeight, pageNo, lx, ly, value, templateIndex] = args;
            this.imageWidth = imageWidth;
            this.imageHeight = imageHeight;
            this.pageNo = pageNo;
            this.lx = lx;
            this.ly = ly;
            this.value = value;
            this.type = "2";
            this.templateIndex = templateIndex;
        } else if (args.length === 7) {
            const [imageWidth, imageHeight, keyword, locationStyle, offsetX, offsetY, value] = args;
            this.imageHeight = imageHeight;
            this.imageWidth = imageWidth;
            this.keyword = keyword;
            this.locationStyle = locationStyle;
            this.offsetX = offsetX;
            this.offsetY = offsetY;
            this.value = value;
            this.type = "3";
            this.templateIndex = 0;
        } else if (args.length === 8) {
            const [imageWidth, imageHeight, keyword, locationStyle, offsetX, offsetY, value, templateIndex] = args;
            this.imageHeight = imageHeight;
            this.imageWidth = imageWidth;
            this.keyword = keyword;
            this.locationStyle = locationStyle;
            this.offsetX = offsetX;
            this.offsetY = offsetY;
            this.value = value;
            this.type = "3";
            this.templateIndex = templateIndex;
        }
    }

    getImageWidth(): string {
        return this.imageWidth;
    }

    setImageWidth(imageWidth: string): void {
        this.imageWidth = imageWidth;
    }

    getImageHeight(): string {
        return this.imageHeight;
    }

    setImageHeight(imageHeight: string): void {
        this.imageHeight = imageHeight;
    }

    getLx(): string {
        return this.lx;
    }

    setLx(lx: string): void {
        this.lx = lx;
    }

    getLy(): string {
        return this.ly;
    }

    setLy(ly: string): void {
        this.ly = ly;
    }

    getValue(): string {
        return this.value;
    }

    setValue(value: string): void {
        this.value = value;
    }

    getHash(): string {
        return this.hash;
    }

    setHash(hash: string): void {
        this.hash = hash;
    }

    getPageNo(): number {
        return this.pageNo;
    }

    setPageNo(pageNo: number): void {
        this.pageNo = pageNo;
    }

    getType(): string {
        return this.type;
    }

    setType(type: string): void {
        this.type = type;
    }

    getKeyword(): string {
        return this.keyword;
    }

    setKeyword(keyword: string): void {
        this.keyword = keyword;
    }

    getLocationStyle(): string {
        return this.locationStyle;
    }

    setLocationStyle(locationStyle: string): void {
        this.locationStyle = locationStyle;
    }

    getOffsetX(): number {
        return this.offsetX;
    }

    setOffsetX(offsetX: number): void {
        this.offsetX = offsetX;
    }

    getOffsetY(): number {
        return this.offsetY;
    }

    setOffsetY(offsetY: number): void {
        this.offsetY = offsetY;
    }

    getTemplateIndex(): number {
        return this.templateIndex;
    }

    setTemplateIndex(templateIndex: number): void {
        this.templateIndex = templateIndex;
    }
}

export default ImageBean;