// 假设 Image 类型在某个地方定义，这里先使用 any 替代，实际使用时需要替换为正确的类型
type Image = any;

export class ImageLocationBean {
    private type: string;
    private pageNo: number;
    private lx: number;
    private ly: number;
    private keyword: string;
    private locationStyle: string;
    private offsetX: number;
    private offsetY: number;
    private templateIndex: number;
    private image: Image;

    constructor();
    constructor(image: Image);
    constructor(image: Image, keyword: string, locationStyle: string, offsetX: number, offsetY: number);
    constructor(image: Image, lx: number, ly: number, pageNo: number);
    constructor(...args: any[]) {
        if (args.length === 0) {
            // 无参构造函数
        } else if (args.length === 1) {
            const [image] = args;
            this.image = image;
        } else if (args.length === 5) {
            const [image, keyword, locationStyle, offsetX, offsetY] = args;
            this.image = image;
            this.keyword = keyword;
            this.locationStyle = locationStyle;
            this.offsetX = offsetX;
            this.offsetY = offsetY;
            this.type = "3";
        } else if (args.length === 4) {
            const [image, lx, ly, pageNo] = args;
            this.image = image;
            this.lx = lx;
            this.ly = ly;
            this.pageNo = pageNo;
            this.type = "2";
        }
    }

    get Type(): string {
        return this.type;
    }

    set Type(value: string) {
        this.type = value;
    }

    get PageNo(): number {
        return this.pageNo;
    }

    set PageNo(value: number) {
        this.pageNo = value;
    }

    get Lx(): number {
        return this.lx;
    }

    set Lx(value: number) {
        this.lx = value;
    }

    get Ly(): number {
        return this.ly;
    }

    set Ly(value: number) {
        this.ly = value;
    }

    get Keyword(): string {
        return this.keyword;
    }

    set Keyword(value: string) {
        this.keyword = value;
    }

    get LocationStyle(): string {
        return this.locationStyle;
    }

    set LocationStyle(value: string) {
        this.locationStyle = value;
    }

    get OffsetX(): number {
        return this.offsetX;
    }

    set OffsetX(value: number) {
        this.offsetX = value;
    }

    get OffsetY(): number {
        return this.offsetY;
    }

    set OffsetY(value: number) {
        this.offsetY = value;
    }

    get TemplateIndex(): number {
        return this.templateIndex;
    }

    set TemplateIndex(value: number) {
        this.templateIndex = value;
    }

    get Image(): Image {
        return this.image;
    }

    set Image(value: Image) {
        this.image = value;
    }
}