namespace TellerSystem.PrintTemplate.ElecSeal.Cfca {
    /**
     * Pdf类
     */
    export class PdfBean {
        private pdf: string;
        private pdfId: string;
        private savedPdfId: string;
        private bizSerialNo: string;
        private bizTypeCode: string;
        private outputFilePath: string;
        private cardNo: string;
        private reserved1: string;
        private reserved2: string;
        private reserved3: string;

        constructor(pdf: string);
        constructor(pdf: string, bizTypeCode: string);
        constructor(pdfId: string, bizSerialNo: string, bizTypeCode: string);
        constructor(pdf: string, bizSerialNo: string, bizTypeCode: string, outputFilePath: string, cardNo: string);
        constructor(pdf: string, savedPdfId: string, bizSerialNo: string, bizTypeCode: string, outputFilePath: string, cardNo: string);
        constructor(pdf: string, bizSerialNo?: string, bizTypeCode?: string, outputFilePath?: string, cardNo?: string, savedPdfId?: string) {
            this.pdf = pdf;
            if (bizTypeCode && typeof bizSerialNo === 'string') {
                this.bizTypeCode = bizTypeCode;
                this.bizSerialNo = bizSerialNo;
            }
            if (outputFilePath) {
                this.outputFilePath = outputFilePath;
            }
            if (cardNo) {
                this.cardNo = cardNo;
            }
            if (savedPdfId) {
                this.savedPdfId = savedPdfId;
            }
            this.pdfId = this.pdfId || "";
            this.savedPdfId = this.savedPdfId || "";
            this.bizSerialNo = this.bizSerialNo || "";
            this.bizTypeCode = this.bizTypeCode || "";
            this.outputFilePath = this.outputFilePath || "";
            this.cardNo = this.cardNo || "";
            this.reserved1 = "";
            this.reserved2 = "";
            this.reserved3 = "";
        }

        /**
         * 获取 pdf 内容
         */
        public GetPdf(): string {
            return this.pdf;
        }

        /**
         * 设置 pdf 内容
         * @param pdf - 要设置的 pdf 内容
         */
        public SetPdf(pdf: string): void {
            this.pdf = pdf;
        }

        /**
         * 获取保存的 pdf ID
         */
        public GetSavedPdfId(): string {
            return this.savedPdfId;
        }

        /**
         * 设置保存的 pdf ID
         * @param savedPdfId - 要设置的保存的 pdf ID
         */
        public SetSavedPdfId(savedPdfId: string): void {
            this.savedPdfId = savedPdfId;
        }

        /**
         * 获取业务流水号
         */
        public GetBizSerialNo(): string {
            return this.bizSerialNo;
        }

        /**
         * 设置 pdf ID
         * @param pdfId - 要设置的 pdf ID
         */
        public SetPdfId(pdfId: string): void {
            this.pdfId = pdfId;
        }

        /**
         * 获取 pdf ID
         */
        public GetPdfId(): string {
            return this.pdfId;
        }

        /**
         * 设置业务流水号
         * @param bizSerialNo - 要设置的业务流水号
         */
        public SetBizSerialNo(bizSerialNo: string): void {
            this.bizSerialNo = bizSerialNo;
        }

        /**
         * 获取业务类型代码
         */
        public GetBizTypeCode(): string {
            return this.bizTypeCode;
        }

        /**
         * 设置业务类型代码
         * @param bizTypeCode - 要设置的业务类型代码
         */
        public SetBizTypeCode(bizTypeCode: string): void {
            this.bizTypeCode = bizTypeCode;
        }

        /**
         * 获取输出文件路径
         */
        public GetOutputFilePath(): string {
            return this.outputFilePath;
        }

        /**
         * 设置输出文件路径
         * @param outputFilePath - 要设置的输出文件路径
         */
        public SetOutputFilePath(outputFilePath: string): void {
            this.outputFilePath = outputFilePath;
        }

        /**
         * 获取卡号
         */
        public GetCardNo(): string {
            return this.cardNo;
        }

        /**
         * 设置卡号
         * @param cardNo - 要设置的卡号
         */
        public SetCardNo(cardNo: string): void {
            this.cardNo = cardNo;
        }

        /**
         * 获取预留字段 1
         */
        public GetReserved1(): string {
            return this.reserved1;
        }

        /**
         * 设置预留字段 1
         * @param reserved1 - 要设置的预留字段 1
         */
        public SetReserved1(reserved1: string): void {
            this.reserved1 = reserved1;
        }

        /**
         * 获取预留字段 2
         */
        public GetReserved2(): string {
            return this.reserved2;
        }

        /**
         * 设置预留字段 2
         * @param reserved2 - 要设置的预留字段 2
         */
        public SetReserved2(reserved2: string): void {
            this.reserved2 = reserved2;
        }

        /**
         * 获取预留字段 3
         */
        public GetReserved3(): string {
            return this.reserved3;
        }

        /**
         * 设置预留字段 3
         * @param reserved3 - 要设置的预留字段 3
         */
        public SetReserved3(reserved3: string): void {
            this.reserved3 = reserved3;
        }
    }
}