/**
 * 二维码Bean类
 */
class QRCodeBean {
    private qrCodeContent: string;
    private width: string;
    private height: string;
    private pageNo: number = 1;
    private lx: string;
    private ly: string;
    private templateIndex: number;

    /**
     * 获取二维码内容
     */
    public GetQrCodeContent(): string {
        return this.qrCodeContent;
    }

    /**
     * 设置二维码内容
     * @param qrCodeContent 二维码内容
     */
    public SetQrCodeContent(qrCodeContent: string): void {
        this.qrCodeContent = qrCodeContent;
    }

    /**
     * 获取宽度
     */
    public GetWidth(): string {
        return this.width;
    }

    /**
     * 设置宽度
     * @param width 宽度
     */
    public SetWidth(width: string): void {
        this.width = width;
    }

    /**
     * 获取高度
     */
    public GetHeight(): string {
        return this.height;
    }

    /**
     * 设置高度
     * @param height 高度
     */
    public SetHeight(height: string): void {
        this.height = height;
    }

    /**
     * 获取页码
     */
    public GetPageNo(): number {
        return this.pageNo;
    }

    /**
     * 设置页码
     * @param pageNo 页码
     */
    public SetPageNo(pageNo: number): void {
        this.pageNo = pageNo;
    }

    /**
     * 获取 lx 值
     */
    public GetLx(): string {
        return this.lx;
    }

    /**
     * 设置 lx 值
     * @param lx lx 值
     */
    public SetLx(lx: string): void {
        this.lx = lx;
    }

    /**
     * 获取 ly 值
     */
    public GetLy(): string {
        return this.ly;
    }

    /**
     * 设置 ly 值
     * @param ly ly 值
     */
    public SetLy(ly: string): void {
        this.ly = ly;
    }

    /**
     * 获取模板索引
     */
    public GetTemplateIndex(): number {
        return this.templateIndex;
    }

    /**
     * 设置模板索引
     * @param templateIndex 模板索引
     */
    public SetTemplateIndex(templateIndex: number): void {
        this.templateIndex = templateIndex;
    }

    /**
     * 构造函数
     * @param width 宽度
     * @param height 高度
     * @param pageNo 页码
     * @param lx lx 值
     * @param ly ly 值
     */
    constructor(width: string, height: string, pageNo: number, lx: string, ly: string);
    /**
     * 构造函数
     * @param qrCodeContent 二维码内容
     * @param width 宽度
     * @param height 高度
     * @param pageNo 页码
     * @param lx lx 值
     * @param ly ly 值
     */
    constructor(qrCodeContent: string, width: string, height: string, pageNo: number, lx: string, ly: string);
    /**
     * 构造函数
     * @param qrCodeContent 二维码内容
     * @param width 宽度
     * @param height 高度
     * @param pageNo 页码
     * @param lx lx 值
     * @param ly ly 值
     * @param templateIndex 模板索引
     */
    constructor(qrCodeContent: string, width: string, height: string, pageNo: number, lx: string, ly: string, templateIndex: number);
    constructor(...args: any[]) {
        if (args.length === 5) {
            const [width, height, pageNo, lx, ly] = args;
            this.width = width;
            this.height = height;
            this.pageNo = pageNo;
            this.lx = lx;
            this.ly = ly;
        } else if (args.length === 6) {
            const [qrCodeContent, width, height, pageNo, lx, ly] = args;
            this.qrCodeContent = qrCodeContent;
            this.width = width;
            this.height = height;
            this.pageNo = pageNo;
            this.lx = lx;
            this.ly = ly;
        } else if (args.length === 7) {
            const [qrCodeContent, width, height, pageNo, lx, ly, templateIndex] = args;
            this.qrCodeContent = qrCodeContent;
            this.width = width;
            this.height = height;
            this.pageNo = pageNo;
            this.lx = lx;
            this.ly = ly;
            this.templateIndex = templateIndex;
        }
    }
}

export default QRCodeBean;