// 印章用户信息类
class SealUserInfo {
    private userName: string;
    private identificationType: string;
    private identificationNo: string;
    private phoneNo: string;
    private sealLocation: string;
    private sealReason: string;

    // 全参数构造函数
    constructor(userName: string, identificationType?: string, identificationNo?: string, phoneNo?: string, sealLocation?: string, sealReason?: string);
    // 部分参数构造函数
    constructor(userName: string, sealLocation?: string, sealReason?: string);
    // 构造函数实现
    constructor(...args: string[]) {
        if (args.length >= 6) {
            this.userName = args[0];
            this.identificationType = args[1];
            this.identificationNo = args[2];
            this.phoneNo = args[3];
            this.sealLocation = args[4];
            this.sealReason = args[5];
        } else if (args.length >= 3) {
            this.userName = args[0];
            this.sealLocation = args[1];
            this.sealReason = args[2];
        }
    }

    // 获取用户名
    public GetUserName(): string {
        return this.userName;
    }

    // 设置用户名
    public SetUserName(userName: string): void {
        this.userName = userName;
    }

    // 获取证件类型
    public GetIdentificationType(): string {
        return this.identificationType;
    }

    // 设置证件类型
    public SetIdentificationType(identificationType: string): void {
        this.identificationType = identificationType;
    }

    // 获取证件号码
    public GetIdentificationNo(): string {
        return this.identificationNo;
    }

    // 设置证件号码
    public SetIdentificationNo(identificationNo: string): void {
        this.identificationNo = identificationNo;
    }

    // 获取电话号码
    public GetPhoneNo(): string {
        return this.phoneNo;
    }

    // 设置电话号码
    public SetPhoneNo(phoneNo: string): void {
        this.phoneNo = phoneNo;
    }

    // 获取印章位置
    public GetSealLocation(): string {
        return this.sealLocation;
    }

    // 设置印章位置
    public SetSealLocation(sealLocation: string): void {
        this.sealLocation = sealLocation;
    }

    // 获取盖章原因
    public GetSealReason(): string {
        return this.sealReason;
    }

    // 设置盖章原因
    public SetSealReason(sealReason: string): void {
        this.sealReason = sealReason;
    }
}

export default SealUserInfo;