﻿using System;

namespace TellerSystem.PrintTemplate.ElecSeal.Cfca
{
    /// <summary>
    /// 位置信息类
    /// </summary>
    public class SignLocation
    {
        String type;

        int pdfIndex;
        String keyword;
        String LocationStyle;
        int offsetX;
        int offsetY;

        int page;
        int lx;
        int ly;

        int fromPage;
        int toPage;

        public SignLocation(int pdfIndex, String keyword, String locationStyle, int offsetX, int offsetY)
        {
            this.type = "3";
            this.pdfIndex = pdfIndex;
            this.keyword = keyword;
            LocationStyle = locationStyle;
            this.offsetX = offsetX;
            this.offsetY = offsetY;
        }

        public SignLocation(String keyword, String locationStyle, int offsetX, int offsetY)
        {
            this.type = "3";
            this.keyword = keyword;
            LocationStyle = locationStyle;
            this.offsetX = offsetX;
            this.offsetY = offsetY;
        }

        public SignLocation(int pdfIndex, int page, int lx, int ly)
        {
            this.type = "2";
            this.pdfIndex = pdfIndex;
            this.page = page;
            this.lx = lx;
            this.ly = ly;
        }

        public SignLocation(int page, int lx, int ly)
        {
            this.type = "2";
            this.page = page;
            this.lx = lx;
            this.ly = ly;
        }

        public SignLocation(int fromPage, int toPage)
        {
            this.fromPage = fromPage;
            this.toPage = toPage;
        }

        public String GetType()
        {
            return type;
        }

        public int GetPdfIndex()
        {
            return pdfIndex;
        }

        public String GetKeyword()
        {
            return keyword;
        }

        public String GetLocationStyle()
        {
            return LocationStyle;
        }

        public int GetOffsetX()
        {
            return offsetX;
        }

        public int GetOffsetY()
        {
            return offsetY;
        }

        public int GetPage()
        {
            return page;
        }

        public int GetLx()
        {
            return lx;
        }

        public int GetLy()
        {
            return ly;
        }

        public int GetFromPage()
        {
            return fromPage;
        }

        public int GetToPage()
        {
            return toPage;
        }
    }
}
