// 位置信息类
class SignLocation {
    type: string;
    pdfIndex: number;
    keyword: string;
    LocationStyle: string;
    offsetX: number;
    offsetY: number;
    page: number;
    lx: number;
    ly: number;
    fromPage: number;
    toPage: number;

    // 构造函数重载 1
    constructor(pdfIndex: number, keyword: string, locationStyle: string, offsetX: number, offsetY: number);
    // 构造函数重载 2
    constructor(keyword: string, locationStyle: string, offsetX: number, offsetY: number);
    // 构造函数重载 3
    constructor(pdfIndex: number, page: number, lx: number, ly: number);
    // 构造函数重载 4
    constructor(page: number, lx: number, ly: number);
    // 构造函数重载 5
    constructor(fromPage: number, toPage: number);
    // 实际构造函数实现
    constructor(...args: any[]) {
        if (args.length === 5) {
            if (typeof args[0] === 'number') {
                this.type = "3";
                this.pdfIndex = args[0];
                this.keyword = args[1];
                this.LocationStyle = args[2];
                this.offsetX = args[3];
                this.offsetY = args[4];
            }
        } else if (args.length === 4) {
            this.type = "3";
            this.keyword = args[0];
            this.LocationStyle = args[1];
            this.offsetX = args[2];
            this.offsetY = args[3];
        } else if (args.length === 4 && typeof args[1] === 'number') {
            this.type = "2";
            this.pdfIndex = args[0];
            this.page = args[1];
            this.lx = args[2];
            this.ly = args[3];
        } else if (args.length === 3) {
            this.type = "2";
            this.page = args[0];
            this.lx = args[1];
            this.ly = args[2];
        } else if (args.length === 2) {
            this.fromPage = args[0];
            this.toPage = args[1];
        }
    }

    // 获取类型
    GetType(): string {
        return this.type;
    }

    // 获取 PDF 索引
    GetPdfIndex(): number {
        return this.pdfIndex;
    }

    // 获取关键字
    GetKeyword(): string {
        return this.keyword;
    }

    // 获取位置样式
    GetLocationStyle(): string {
        return this.LocationStyle;
    }

    // 获取 X 偏移量
    GetOffsetX(): number {
        return this.offsetX;
    }

    // 获取 Y 偏移量
    GetOffsetY(): number {
        return this.offsetY;
    }

    // 获取页面
    GetPage(): number {
        return this.page;
    }

    // 获取 lx 值
    GetLx(): number {
        return this.lx;
    }

    // 获取 ly 值
    GetLy(): number {
        return this.ly;
    }

    // 获取起始页面
    GetFromPage(): number {
        return this.fromPage;
    }

    // 获取结束页面
    GetToPage(): number {
        return this.toPage;
    }
}

export default SignLocation;