﻿using System;

namespace TellerSystem.PrintTemplate.ElecSeal.Cfca
{
    /// <summary>
    /// 生成到PDF内容里的信息类
    /// </summary>
    public class TextBean
    {

        private String textValue;
        private String textValueHash;
        private String textFontSize;
        private String textColor;
        private String type;
        private int pageNo = 1;
        private int lx;
        private int ly;
        private String keyword;
        private String locationStyle;
        private int offsetX;
        private int offsetY;
        private int templateIndex;

        public TextBean(String textValue, String textValueHash, int pageNo, int lx, int ly)
        {
            this.textValue = textValue;
            this.textValueHash = textValueHash;
            this.type = "2";
            this.pageNo = pageNo;
            this.lx = lx;
            this.ly = ly;
            this.templateIndex = 0;
        }

        public TextBean(String textValue, String textValueHash, int pageNo, int lx, int ly, int templateIndex)
        {
            this.textValue = textValue;
            this.textValueHash = textValueHash;
            this.type = "2";
            this.pageNo = pageNo;
            this.lx = lx;
            this.ly = ly;
            this.templateIndex = templateIndex;
        }

        public TextBean(String textValue, String textValueHash, String keyword, String locationStyle, int offsetX, int offsetY)
        {
            this.textValue = textValue;
            this.textValueHash = textValueHash;
            this.type = "3";
            this.keyword = keyword;
            this.locationStyle = locationStyle;
            this.offsetX = offsetX;
            this.offsetY = offsetY;
            this.templateIndex = 0;
        }

        public TextBean(String textValue, String textValueHash, String keyword, String locationStyle, int offsetX, int offsetY, int templateIndex)
        {
            this.textValue = textValue;
            this.textValueHash = textValueHash;
            this.type = "3";
            this.keyword = keyword;
            this.locationStyle = locationStyle;
            this.offsetX = offsetX;
            this.offsetY = offsetY;
            this.templateIndex = templateIndex;
        }

        public String GetTextValue()
        {
            return textValue;
        }

        public void SetTextValue(String textValue)
        {
            this.textValue = textValue;
        }

        public String GetTextValueHash()
        {
            return textValueHash;
        }

        public void SetTextValueHash(String textValueHash)
        {
            this.textValueHash = textValueHash;
        }

        public String GetType()
        {
            return type;
        }

        public void SetType(String type)
        {
            this.type = type;
        }

        public int GetPageNo()
        {
            return pageNo;
        }

        public void SetPageNo(int pageNo)
        {
            this.pageNo = pageNo;
        }

        public int GetLx()
        {
            return lx;
        }

        public void SetLx(int lx)
        {
            this.lx = lx;
        }

        public int GetLy()
        {
            return ly;
        }

        public void SetLy(int ly)
        {
            this.ly = ly;
        }

        public String GetKeyword()
        {
            return keyword;
        }

        public void SetKeyword(String keyword)
        {
            this.keyword = keyword;
        }

        public String GetLocationStyle()
        {
            return locationStyle;
        }

        public void SetLocationStyle(String locationStyle)
        {
            this.locationStyle = locationStyle;
        }

        public int GetOffsetX()
        {
            return offsetX;
        }

        public void SetOffsetX(int offsetX)
        {
            this.offsetX = offsetX;
        }

        public int GetOffsetY()
        {
            return offsetY;
        }

        public void SetOffsetY(int offsetY)
        {
            this.offsetY = offsetY;
        }

        public String GetTextFontSize()
        {
            return textFontSize;
        }

        public void SetTextFontSize(String textFontSize)
        {
            this.textFontSize = textFontSize;
        }

        public String GetTextColor()
        {
            return textColor;
        }

        public void SetTextColor(String textColor)
        {
            this.textColor = textColor;
        }

        public int GetTemplateIndex()
        {
            return templateIndex;
        }

        public void SetTemplateIndex(int templateIndex)
        {
            this.templateIndex = templateIndex;
        }

    }
}
