// 模拟 PrintAttributes 类型，需根据实际情况补充
type PrintAttributes = any;
// 模拟 PrintContainer 类型，需根据实际情况补充
type PrintContainer = any;
// 模拟 ServiceSettings 类，需根据实际情况补充
class ServiceSettings {
    static GetConfig(key: string, parser: (value: string) => number): number {
        // 这里只是示例实现，需根据实际情况完善
        return parser('0.5'); 
    }
}
// 模拟 TextBlock 类型，需根据实际情况补充
class TextBlock {
    text: string = '';
    visibility: 'Visible' | 'Hidden' | 'Collapsed' = 'Visible';
    textWrapping: 'NoWrap' | 'Wrap' | 'WrapWithOverflow' = 'NoWrap';
    fontFamily: string = '';
    fontStyle: string = '';
    fontWeight: string = '';
    fontStretch: string = '';
    fontSize: number = 12;
    foreground: any;
    flowDirection: any;
    parent: any;
    desiredSize: { width: number } = { width: 0 };
    renderSize: { width: number } = { width: 0 };
    textEffects: any[] = [];
    isLoaded: boolean = false;
    loadedHandlers: ((sender: any, e: any) => void)[] = [];

    addLoadedHandler(handler: (sender: any, e: any) => void) {
        this.loadedHandlers.push(handler);
    }

    triggerLoaded() {
        this.isLoaded = true;
        this.loadedHandlers.forEach(handler => handler(this, null));
    }
}
// 模拟 PrintStringElement 类型，需根据实际情况补充
class PrintStringElement {
    value: string = '';
    loadedHandlers: ((sender: any, e: any) => void)[] = [];

    addLoadedHandler(handler: (sender: any, e: any) => void) {
        this.loadedHandlers.push(handler);
    }

    triggerLoaded() {
        this.loadedHandlers.forEach(handler => handler(this, null));
    }
}
// 模拟 Canvas 类型，需根据实际情况补充
class Canvas {
    children: TextBlock[] = [];
    width: number = 0;
    renderSize: { width: number } = { width: 0 };

    static GetLeft(element: TextBlock): number {
        // 这里只是示例实现，需根据实际情况完善
        return 0; 
    }

    clearChildren() {
        this.children = [];
    }

    addChild(child: TextBlock) {
        this.children.push(child);
    }
}
// 模拟 FormattedText 类，需根据实际情况补充
class FormattedText {
    width: number;

    constructor(
        text: string,
        culture: any,
        flowDirection: any,
        typeface: any,
        fontSize: number,
        foreground: any
    ) {
        // 这里只是示例实现，需根据实际情况完善
        this.width = text.length * fontSize; 
    }
}
// 模拟 TextEffect 类，需根据实际情况补充
class TextEffect {
    positionCount: number;
    transform: any;

    constructor() {
        this.positionCount = Number.MAX_SAFE_INTEGER;
        this.transform = { scaleX: 1 };
    }
}
// 模拟 ScaleTransform 类，需根据实际情况补充
class ScaleTransform {
    scaleX: number;

    constructor() {
        this.scaleX = 1;
    }
}
// 模拟 PropertyChangedCallback 类型
type PropertyChangedCallback = (sender: any, e: any) => void;

// 模拟 DependencyProperty 类
class DependencyProperty {
    static RegisterAttached(name: string, type: any, ownerType: any, metadata: any): DependencyProperty {
        return new DependencyProperty();
    }
}

// 模拟 UIPropertyMetadata 类
class UIPropertyMetadata {
    constructor(defaultValue: any, callback?: PropertyChangedCallback) {}
}

// 定义 FormartMode 枚举
enum FormartMode {
    String = 0,
    Date,
    Time,
    Money
}

// 模拟 DependencyPropertyDescriptor 类
class DependencyPropertyDescriptor {
    static FromProperty(property: any, type: any): DependencyPropertyDescriptor {
        return new DependencyPropertyDescriptor();
    }

    addValueChanged(target: any, callback: (sender: any, e: any) => void) {}

    removeValueChanged(target: any, callback: (sender: any, e: any) => void) {}
}

class PrintContainerExt {
    // 打印附加属性部分
    static GetPrintAttributes(obj: any): PrintAttributes {
        // 这里只是示例实现，需根据实际情况完善
        return null; 
    }

    static SetPrintAttributes(obj: any, value: PrintAttributes) {
        // 这里只是示例实现，需根据实际情况完善
    }

    static readonly PrintAttributesProperty = DependencyProperty.RegisterAttached(
        'PrintAttributes',
        Object,
        PrintContainerExt,
        new UIPropertyMetadata(null)
    );

    static GetCreatePrintNum(obj: any): boolean {
        // 这里只是示例实现，需根据实际情况完善
        return true; 
    }

    static SetCreatePrintNum(obj: any, value: boolean) {
        // 这里只是示例实现，需根据实际情况完善
    }

    static readonly CreatePrintNumProperty = DependencyProperty.RegisterAttached(
        'CreatePrintNum',
        Boolean,
        PrintContainerExt,
        new UIPropertyMetadata(true)
    );

    static GetPrintElement(obj: any): PrintAttributes {
        // 这里只是示例实现，需根据实际情况完善
        return null; 
    }

    static SetPrintElement(obj: any, value: PrintAttributes) {
        // 这里只是示例实现，需根据实际情况完善
    }

    static readonly PrintElementProperty = DependencyProperty.RegisterAttached(
        'PrintElement',
        Object,
        PrintContainerExt,
        new UIPropertyMetadata(null)
    );

    static GetIsChoosePrinter(obj: PrintContainer): boolean {
        // 这里只是示例实现，需根据实际情况完善
        return false; 
    }

    static SetIsChoosePrinter(obj: PrintContainer, value: boolean) {
        // 这里只是示例实现，需根据实际情况完善
    }

    static readonly IsChoosePrinterProperty = DependencyProperty.RegisterAttached(
        'IsChoosePrinter',
        Boolean,
        PrintContainerExt,
        new UIPropertyMetadata(false)
    );

    // TextBlock 文本溢出缩放效果部分
    static descriptor2TextBlock = DependencyPropertyDescriptor.FromProperty(
        'Text',
        TextBlock
    );

    static IsTextNoWrap2Scale_TextEffect: TextEffect | null = null;

    static GetIsTextNoWrap2Scale(obj: any): boolean {
        // 这里只是示例实现，需根据实际情况完善
        return false; 
    }

    static SetIsTextNoWrap2Scale(obj: any, value: boolean) {
        // 这里只是示例实现，需根据实际情况完善
        if (obj instanceof TextBlock) {
            const textBlock = obj;
            const metadata = new UIPropertyMetadata(false, (d: any, e: any) => {
                if (textBlock === null || false) return; 
                const scale = ServiceSettings.GetConfig('TextNoWrap2Scale', (x) => {
                    const v = parseFloat(x);
                    return isNaN(v) ? 0.5 : v;
                });
                if (scale === 1) return;
                if (PrintContainerExt.IsTextNoWrap2Scale_TextEffect === null) {
                    PrintContainerExt.IsTextNoWrap2Scale_TextEffect = new TextEffect();
                    PrintContainerExt.IsTextNoWrap2Scale_TextEffect.transform = new ScaleTransform();
                    PrintContainerExt.IsTextNoWrap2Scale_TextEffect.transform.scaleX = scale;
                }
                PrintContainerExt.descriptor2TextBlock.removeValueChanged(textBlock, PrintContainerExt.IsTextNoWrap2Scale_TextChanged);
                if (e.newValue === true) {
                    PrintContainerExt.IsTextNoWrap2Scale_TextChanged(textBlock, null);
                    PrintContainerExt.descriptor2TextBlock.addValueChanged(textBlock, PrintContainerExt.IsTextNoWrap2Scale_TextChanged);
                }
            });
        }
    }

    static readonly IsTextNoWrap2ScaleProperty = DependencyProperty.RegisterAttached(
        'IsTextNoWrap2Scale',
        Boolean,
        PrintContainerExt,
        new UIPropertyMetadata(false, (d: any, e: any) => {
            const textBlock = d as TextBlock;
            if (textBlock === null || false) return; 
            const scale = ServiceSettings.GetConfig('TextNoWrap2Scale', (x) => {
                const v = parseFloat(x);
                return isNaN(v) ? 0.5 : v;
            });
            if (scale === 1) return;
            if (PrintContainerExt.IsTextNoWrap2Scale_TextEffect === null) {
                PrintContainerExt.IsTextNoWrap2Scale_TextEffect = new TextEffect();
                PrintContainerExt.IsTextNoWrap2Scale_TextEffect.transform = new ScaleTransform();
                PrintContainerExt.IsTextNoWrap2Scale_TextEffect.transform.scaleX = scale;
            }
            PrintContainerExt.descriptor2TextBlock.removeValueChanged(textBlock, PrintContainerExt.IsTextNoWrap2Scale_TextChanged);
            if (e.newValue === true) {
                PrintContainerExt.IsTextNoWrap2Scale_TextChanged(textBlock, null);
                PrintContainerExt.descriptor2TextBlock.addValueChanged(textBlock, PrintContainerExt.IsTextNoWrap2Scale_TextChanged);
            }
        })
    );

    static IsTextNoWrap2Scale_Loaded(sender: any, e: any) {
        const textBlock = sender as TextBlock;
        if (textBlock === null) return;
        // 移除加载事件处理程序
        textBlock.loadedHandlers = textBlock.loadedHandlers.filter(
            (handler) => handler !== PrintContainerExt.IsTextNoWrap2Scale_Loaded
        );
        if (
            textBlock.visibility !== 'Visible' ||
            textBlock.text === '' ||
            textBlock.textWrapping !== 'NoWrap'
        )
            return;
        // 移除文本效果
        textBlock.textEffects = textBlock.textEffects.filter(
            (effect) => effect !== PrintContainerExt.IsTextNoWrap2Scale_TextEffect
        );
        const formattedText = new FormattedText(
            textBlock.text,
            null,
            textBlock.flowDirection,
            {
                fontFamily: textBlock.fontFamily,
                fontStyle: textBlock.fontStyle,
                fontWeight: textBlock.fontWeight,
                fontStretch: textBlock.fontStretch
            },
            textBlock.fontSize,
            textBlock.foreground
        );
        let isTrimmed = formattedText.width > textBlock.desiredSize.width;
        if (!isTrimmed && textBlock.parent instanceof Canvas) {
            const left = Canvas.GetLeft(textBlock);
            isTrimmed =
                textBlock.desiredSize.width >
                (textBlock.parent.renderSize.width - (isNaN(left) ? 0 : left));
        }
        if (isTrimmed && PrintContainerExt.IsTextNoWrap2Scale_TextEffect) {
            textBlock.textEffects.push(PrintContainerExt.IsTextNoWrap2Scale_TextEffect);
        }
    }

    static IsTextNoWrap2Scale_TextChanged(sender: any, e: any) {
        const textBlock = sender as TextBlock;
        if (textBlock === null) return;
        if (textBlock.isLoaded) {
            PrintContainerExt.IsTextNoWrap2Scale_Loaded(textBlock, null);
        } else {
            textBlock.addLoadedHandler(PrintContainerExt.IsTextNoWrap2Scale_Loaded);
        }
    }

    // 文本格式化部分
    static GetTextBlockFormart(obj: any): FormartMode {
        // 这里只是示例实现，需根据实际情况完善
        return FormartMode.String; 
    }

    static SetTextBlockFormart(obj: any, value: FormartMode) {
        // 这里只是示例实现，需根据实际情况完善
    }

    static readonly TextBlockFormartProperty = DependencyProperty.RegisterAttached(
        'TextBlockFormart',
        FormartMode,
        PrintContainerExt,
        new UIPropertyMetadata(FormartMode.String, PrintContainerExt.FormartTextBlockText)
    );

    static FormartTextBlockText(sender: any, e: any) {
        if (sender instanceof TextBlock) {
            sender.addLoadedHandler(PrintContainerExt.TextFormartHelper_TextChanged);
        } else if (sender instanceof PrintStringElement) {
            sender.addLoadedHandler(PrintContainerExt.TextFormartHelper_PrintStringElementTextChanged);
        }
    }

    static TextFormartHelper_TextChanged(sender: any, e: any) {
        const textBlock = sender as TextBlock;
        const txt = textBlock.text;
        const formart = PrintContainerExt.GetTextBlockFormart(textBlock);
        // 移除加载事件处理程序
        textBlock.loadedHandlers = textBlock.loadedHandlers.filter(
            (handler) => handler !== PrintContainerExt.TextFormartHelper_TextChanged
        );
        switch (formart) {
            case FormartMode.Time:
                let dtNow = new Date();
                if (!isNaN(Date.parse(txt))) {
                    dtNow = new Date(txt);
                    textBlock.text = dtNow.toLocaleTimeString([], {
                        hour: '2-digit',
                        minute: '2-digit',
                        second: '2-digit'
                    });
                } else if (txt.length === 6) {
                    textBlock.text = `${txt.substring(0, 2)}:${txt.substring(2, 4)}:${txt.substring(4, 6)}`;
                } else {
                    const d = parseFloat(txt);
                    if (!isNaN(d)) {
                        dtNow = new Date(d * 86400000); 
                        textBlock.text = dtNow.toLocaleTimeString([], {
                            hour: '2-digit',
                            minute: '2-digit',
                            second: '2-digit'
                        });
                    }
                }
                break;
            case FormartMode.Date:
                let dt = new Date();
                if (!isNaN(Date.parse(txt))) {
                    dt = new Date(txt);
                    textBlock.text = dt.toISOString().split('T')[0].replace(/-/g, '');
                } else if (txt.length === 8) {
                    textBlock.text = `${txt.substring(0, 4)}-${txt.substring(4, 6)}-${txt.substring(6, 8)}`;
                } else {
                    const d = parseFloat(txt);
                    if (!isNaN(d)) {
                        dt = new Date(d * 86400000); 
                        textBlock.text = dt.toISOString().split('T')[0].replace(/-/g, '');
                    }
                }
                break;
            case FormartMode.Money:
                const dec = parseFloat(txt);
                if (!isNaN(dec)) {
                    textBlock.text = `¥${dec.toFixed(2)}`;
                }
                break;
            default:
                break;
        }
        // 重新添加加载事件处理程序
        textBlock.addLoadedHandler(PrintContainerExt.TextFormartHelper_TextChanged);
    }

    static TextFormartHelper_PrintStringElementTextChanged(sender: any, e: any) {
        const printStringElement = sender as PrintStringElement;
        const txt = printStringElement.value;
        const formart = PrintContainerExt.GetTextBlockFormart(printStringElement);
        // 移除加载事件处理程序
        printStringElement.loadedHandlers = printStringElement.loadedHandlers.filter(
            (handler) => handler !== PrintContainerExt.TextFormartHelper_PrintStringElementTextChanged
        );
        switch (formart) {
            case FormartMode.Time:
                let dtNow = new Date();
                if (!isNaN(Date.parse(txt))) {
                    dtNow = new Date(txt);
                    printStringElement.value = dtNow.toLocaleTimeString([], {
                        hour: '2-digit',
                        minute: '2-digit',
                        second: '2-digit'
                    });
                } else if (txt.length === 6) {
                    printStringElement.value = `${txt.substring(0, 2)}:${txt.substring(2, 4)}:${txt.substring(4, 6)}`;
                } else {
                    const d = parseFloat(txt);
                    if (!isNaN(d)) {
                        dtNow = new Date(d * 86400000); 
                        printStringElement.value = dtNow.toLocaleTimeString([], {
                            hour: '2-digit',
                            minute: '2-digit',
                            second: '2-digit'
                        });
                    }
                }
                break;
            case FormartMode.Date:
                let dt = new Date();
                if (!isNaN(Date.parse(txt))) {
                    dt = new Date(txt);
                    printStringElement.value = dt.toISOString().split('T')[0];
                } else if (txt.length === 8) {
                    printStringElement.value = `${txt.substring(0, 4)}-${txt.substring(4, 6)}-${txt.substring(6, 8)}`;
                } else {
                    const d = parseFloat(txt);
                    if (!isNaN(d)) {
                        dt = new Date(d * 86400000); 
                        printStringElement.value = dt.toISOString().split('T')[0];
                    }
                }
                break;
            case FormartMode.Money:
                const dec = parseFloat(txt);
                if (!isNaN(dec)) {
                    printStringElement.value = dec.toFixed(2);
                }
                break;
            default:
                break;
        }
        // 重新添加加载事件处理程序
        printStringElement.addLoadedHandler(PrintContainerExt.TextFormartHelper_PrintStringElementTextChanged);
    }

    // 设置 Canvas 部分
    static SetCanvas(can: Canvas, curString: string) {
        can.clearChildren();
        let str = curString.replace(/,/g, '').replace(/ /g, '');
        if (str.includes('.')) {
            const parts = str.split('.');
            const Decimalpoint = parts[1].substring(0, 2);
            str = parts[0] + Decimalpoint;
        } else {
            str += '00';
        }
        str = `¥${str}`;
        const width = can.width;
        const newWidth = width / 11;
        for (let i = 0; i < 11; i++) {
            const newT = new TextBlock();
            newT.text = '';
            newT.desiredSize.width = newWidth;
            can.addChild(newT);
        }
        for (let i = 0; i < str.length; i++) {
            const index = 11 - str.length + i;
            if (index >= 0 && index < can.children.length) {
                can.children[index].text = str[i];
            }
        }
    }

    static PrintCurString(str: string): string {
        return str;
    }
}

export { PrintContainerExt, FormartMode };