﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TellerSystem.PrintTemplate.Common
{
    /// <summary>
    /// Print_AuthOrCheck.xaml 的交互逻辑
    /// </summary>
    public partial class Print_AuthOrCheck:TellerSystem.PrintTemplate.Template.Print_Old
    {
        /// <summary>
        /// 复核/授权时打印的凭证
        /// </summary>
        public Print_AuthOrCheck()
        {
            InitializeComponent();
        }

        #region 自定义属性

        /// <summary>
        /// 申请复核时（第一节点）需要打印的内容
        /// </summary>
        public string AskDescription
        {
            get { return (string)GetValue(AskDescriptionProperty); }
            set { SetValue(AskDescriptionProperty, value); }
        }

        // Using a DependencyProperty as the backing store for AskTellerDescription.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty AskDescriptionProperty =
            DependencyProperty.Register("AskDescription", typeof(string), typeof(Print_AuthOrCheck), new UIPropertyMetadata(null));

        /// <summary>
        /// 复核岗（第二节点）需要打印的内容
        /// </summary>
        public string CheckDescription
        {
            get { return (string)GetValue(CheckOrAuthDescriptionProperty); }
            set { SetValue(CheckTellerDescriptionProperty, value); }
        }

        // Using a DependencyProperty as the backing store for CheckOrAuthTellerDescription.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty CheckTellerDescriptionProperty =
            DependencyProperty.Register("CheckDescription", typeof(string), typeof(Print_AuthOrCheck), new UIPropertyMetadata(null));

        /// <summary>
        /// 复核结束后（第三节点）需要打印的内容
        /// </summary>
        public string ResultDescription
        {
            get { return (string)GetValue(ResultDescriptionProperty); }
            set { SetValue(ResultDescriptionProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ResultDescription.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ResultDescriptionProperty =
            DependencyProperty.Register("ResultDescription", typeof(string), typeof(Print_AuthOrCheck), new UIPropertyMetadata(null));

        /// <summary>
        /// 机构号
        /// </summary>
        public string BranchNo
        {
            get { return (string)GetValue(BranchNoProperty); }
            set { SetValue(BranchNoProperty, value); }
        }

        // Using a DependencyProperty as the backing store for BranchNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty BranchNoProperty =
            DependencyProperty.Register("BranchNo", typeof(string), typeof(Print_AuthOrCheck), new UIPropertyMetadata(null));

        /// <summary>
        /// 交易名称
        /// </summary>
        public string TradeName
        {
            get { return (string)GetValue(TradeNameProperty); }
            set { SetValue(TradeNameProperty, value); }
        }

        // Using a DependencyProperty as the backing store for TradeName.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty TradeNameProperty =
            DependencyProperty.Register("TradeName", typeof(string), typeof(Print_AuthOrCheck), new UIPropertyMetadata(null));

        /// <summary>
        /// 凭证号
        /// </summary>
        public string VoucherNo
        {
            get { return (string)GetValue(VoucherNoProperty); }
            set { SetValue(VoucherNoProperty, value); }
        }

        // Using a DependencyProperty as the backing store for VoucherNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty VoucherNoProperty =
            DependencyProperty.Register("VoucherNo", typeof(string), typeof(Print_AuthOrCheck), new UIPropertyMetadata(null));

        /// <summary>
        /// 流水号
        /// </summary>
        public string SerialNo
        {
            get { return (string)GetValue(SerialNoProperty); }
            set { SetValue(SerialNoProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SerialNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty SerialNoProperty =
            DependencyProperty.Register("SerialNo", typeof(string), typeof(Print_AuthOrCheck), new UIPropertyMetadata(null));

        #endregion

        public DependencyProperty CheckOrAuthDescriptionProperty { get; set; }
    }
}
