﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Platform.Common.RunningParameters;
using TellerSystem.PrintTemplate.Common;

namespace TellerSystem.PrintTemplate.Common
{
    /// <summary>
    /// Print_Blank.xaml 的交互逻辑
    /// </summary>
    public partial class Print_Blank
    {
        public Print_Blank()
        {
            InitializeComponent();
        }

        #region 附加属性
        /// <summary>
        /// 行号
        /// </summary>
        public string BranchNo
        {
            get { return (string)GetValue(BranchNoProperty); }
            set { SetValue(BranchNoProperty, value); }
        }

        // Using a DependencyProperty as the backing store for BranchNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty BranchNoProperty =
            DependencyProperty.Register("BranchNo", typeof(string), typeof(Print_Blank), new UIPropertyMetadata(LoginUserInfo.KinbrNo));

        /// <summary>
        /// 交易名称
        /// </summary>
        public string TradeName
        {
            get { return (string)GetValue(TradeNameProperty); }
            set { SetValue(TradeNameProperty, value); }
        }

        // Using a DependencyProperty as the backing store for TradeName.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty TradeNameProperty =
            DependencyProperty.Register("TradeName", typeof(string), typeof(Print_Blank), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 凭证号码
        /// </summary>
        public string VoucherNo
        {
            get { return (string)GetValue(VoucherNoProperty); }
            set { SetValue(VoucherNoProperty, value); }
        }

        // Using a DependencyProperty as the backing store for VoucherNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty VoucherNoProperty =
            DependencyProperty.Register("VoucherNo", typeof(string), typeof(Print_Blank), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 流水号
        /// </summary>
        public string SerialNo
        {
            get { return (string)GetValue(SerialNoProperty); }
            set { SetValue(SerialNoProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SerialNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty SerialNoProperty =
            DependencyProperty.Register("SerialNo", typeof(string), typeof(Print_Blank), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 附件张数
        /// </summary>
        public string AttachmentCount
        {
            get { return (string)GetValue(AttachmentCountProperty); }
            set { SetValue(AttachmentCountProperty, value); }
        }

        // Using a DependencyProperty as the backing store for AttachmentCount.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty AttachmentCountProperty =
            DependencyProperty.Register("AttachmentCount", typeof(string), typeof(Print_Blank), new UIPropertyMetadata(string.Empty));
               
        /// <summary>
        /// 事后监督
        /// </summary>
        public string SupervisionAfterwards
        {
            get { return (string)GetValue(SupervisionAfterwardsProperty); }
            set { SetValue(SupervisionAfterwardsProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SupervisionAfterwards.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty SupervisionAfterwardsProperty =
            DependencyProperty.Register("SupervisionAfterwards", typeof(string), typeof(Print_Blank), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 复核
        /// </summary>
        public string Review
        {
            get { return (string)GetValue(ReviewProperty); }
            set { SetValue(ReviewProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Review.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ReviewProperty =
            DependencyProperty.Register("Review", typeof(string), typeof(Print_Blank), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 经办
        /// </summary>
        public string Handling
        {
            get { return (string)GetValue(HandlingProperty); }
            set { SetValue(HandlingProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Handling.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty HandlingProperty =
            DependencyProperty.Register("Handling", typeof(string), typeof(Print_Blank), new UIPropertyMetadata(LoginUserInfo.TellerNo));

        public static readonly DependencyProperty PrintNumberProperty =
            DependencyProperty.Register("PrintNumber", typeof(string), typeof(Print_Blank),
                                new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 票号
        /// </summary>
        public string PrintNumber
        {
            get { return (string)GetValue(PrintNumberProperty); }
            set { SetValue(PrintNumberProperty, value); }
        }
        #endregion
    }
}
