﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TellerSystem.PrintTemplate.Common
{
    /// <summary>
    /// UserControl1.xaml 的交互逻辑
    /// </summary>
    public partial class Print_Cash 
    {
        public Print_Cash()
        {
            InitializeComponent();
        }

        public static readonly DependencyProperty UseProperty =
    DependencyProperty.Register("Use", typeof(string), typeof(Print_Cash),
                                new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty PTradeNoProperty =
            DependencyProperty.Register("PTradeNo", typeof(string),
            typeof(Print_Cash), new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty T_JYMCProperty =
            DependencyProperty.Register("T_JYMC", typeof(string),
            typeof(Print_Cash), new UIPropertyMetadata("交易名称:"));

        public static readonly DependencyProperty PTradeNameProperty =
            DependencyProperty.Register("PTradeName", typeof(string),
            typeof(Print_Cash), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 业务流水
        /// </summary>
        public string HostSerialNumber
        {
            get { return (string)GetValue(HostSerialNumberProperty); }
            set { SetValue(HostSerialNumberProperty, value); }
        }
        public static readonly DependencyProperty HostSerialNumberProperty =
         DependencyProperty.Register("HostSerialNumber", typeof(string), typeof(Print_Cash),
         new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 用途
        /// </summary>
        public string Use
        {
            get { return (string)GetValue(UseProperty); }
            set { SetValue(UseProperty, value); }
        }
         /// <summary>
        /// 交易号
        /// </summary>
        public string PTradeNo
        {
            get { return (string)GetValue(PTradeNoProperty); }
            set { SetValue(PTradeNoProperty, value); }
        }

       /// <summary>
       /// 交易名称
       /// </summary>
        public string T_JYMC
        {
            get { return (string)GetValue(T_JYMCProperty); }
            set { SetValue(T_JYMCProperty, value); }
        }
        
       /// <summary>
       /// 交易名称
       /// </summary>
        public string PTradeName
        {
            get { return (string)GetValue(PTradeNameProperty); }
            set { SetValue(PTradeNameProperty, value); }
        }

        /// <summary>
        /// 柜员号
        /// </summary>
        public string TellerNo
        {
            get { return (string)GetValue(TellerNoProperty); }
            set { SetValue(TellerNoProperty, value); }
        }

        public static readonly DependencyProperty TellerNoProperty =
            DependencyProperty.Register("TellerNo", typeof(string), typeof(Print_Cash), new UIPropertyMetadata(string.Empty));

        public string TellerNoStr
        {
            get { return (string)GetValue(TellerNoStrProperty); }
            set { SetValue(TellerNoStrProperty, value); }
        }

        public static readonly DependencyProperty TellerNoStrProperty =
            DependencyProperty.Register("TellerNoStr", typeof(string), typeof(Print_Cash), new UIPropertyMetadata("操作员:"));
        public string SerialNumberStr
        {
            get { return (string)GetValue(SerialNumberStrProperty); }
            set { SetValue(SerialNumberStrProperty, value); }
        }

        public static readonly DependencyProperty SerialNumberStrProperty =
            DependencyProperty.Register("SerialNumberStr", typeof(string), typeof(Print_Cash), new UIPropertyMetadata("流水号:"));


        #region 账号
        public string PTranOutActNo
        {
            get { return (string)GetValue(PTranOutActNoProperty); }
            set { SetValue(PTranOutActNoProperty, value); }
        }

        public static readonly DependencyProperty PTranOutActNoProperty =
            DependencyProperty.Register("PTranOutActNo", typeof(string), typeof(Print_Cash), new UIPropertyMetadata(string.Empty));



        public string PTranOutActNoStr
        {
            get { return (string)GetValue(PTranOutActNoStrProperty); }
            set { SetValue(PTranOutActNoStrProperty, value); }
        }

        public static readonly DependencyProperty PTranOutActNoStrProperty =
            DependencyProperty.Register("PTranOutActNoStr", typeof(string), typeof(Print_Cash), new UIPropertyMetadata("账号:"));
        #endregion
        public string T_HM
        {
            get { return (string)GetValue(T_HMProperty); }
            set { SetValue(T_HMProperty, value); }
        }

        public static readonly DependencyProperty T_HMProperty =
            DependencyProperty.Register("T_HM", typeof(string),
            typeof(Print_Cash), new UIPropertyMetadata("户名:"));
        #region 对方账户
        public string TranOutActName
        {
            get { return (string)GetValue(TranOutActNameProperty); }
            set { SetValue(TranOutActNameProperty, value); }
        }

        public static readonly DependencyProperty TranOutActNameProperty =
            DependencyProperty.Register("TranOutActName", typeof(string), typeof(Print_Cash), new UIPropertyMetadata(string.Empty));



        public string TranOutActNameStr
        {
            get { return (string)GetValue(TranOutActNameStrProperty); }
            set { SetValue(TranOutActNameStrProperty, value); }
        }

        public static readonly DependencyProperty TranOutActNameStrProperty =
            DependencyProperty.Register("TranOutActNameStr", typeof(string), typeof(Print_Cash), new UIPropertyMetadata("对方户名:"));
        #endregion
        public string T_JE
        {
            get { return (string)GetValue(T_JEProperty); }
            set { SetValue(T_JEProperty, value); }
        }

        public static readonly DependencyProperty T_JEProperty =
            DependencyProperty.Register("T_JE", typeof(string),
            typeof(Print_Cash), new UIPropertyMetadata("金额:"));
        /// <summary>
        /// 金额
        /// </summary>
        public string Currency
        {
            get { return (string)GetValue(CurrencyProperty); }
            set { SetValue(CurrencyProperty, value); }
        }
        public static readonly DependencyProperty CurrencyProperty =
    DependencyProperty.Register("Currency", typeof(string), typeof(Print_Cash),
                                new UIPropertyMetadata(string.Empty));
    }
}
