﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Platform.Common.RunningParameters;

namespace TellerSystem.PrintTemplate.Common
{
    /// <summary>
    /// 银行承兑汇票
    /// </summary>
    public partial class Print_Commitment
    {
        public Print_Commitment()
        {
            InitializeComponent();
        }
        #region 自定义属性
        /// <summary>
        /// 日期
        /// </summary>
        public DateTime DateInfo
        {
            get { return (DateTime)GetValue(DateInfoProperty); }
            set { SetValue(DateInfoProperty, value); }
        }
        public static readonly DependencyProperty DateInfoProperty =
           DependencyProperty.Register("DateInfo", typeof(DateTime), typeof(Print_Commitment), new UIPropertyMetadata(DateTime.ParseExact(LoginUserInfo.TradeDate, "yyyyMMdd", System.Globalization.CultureInfo.CurrentCulture)));
        /// <summary>
        /// 出票人全称
        /// </summary>
        public string Ticket_Name
        {
            get { return (string)GetValue(Ticket_NameProperty); }
            set { SetValue(Ticket_NameProperty, value); }
        }
        public static readonly DependencyProperty Ticket_NameProperty =
         DependencyProperty.Register("Ticket_Name", typeof(string), typeof(Print_Commitment), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 出票人账号
        /// </summary>
        public string Ticket_AccountNo
        {
            get { return (string)GetValue(Ticket_AccountNoProperty); }
            set { SetValue(Ticket_AccountNoProperty, value); }
        }
        public static readonly DependencyProperty Ticket_AccountNoProperty =
         DependencyProperty.Register("Ticket_AccountNo", typeof(string), typeof(Print_Commitment), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 付款行名称
        /// </summary>
        public string PayBankName
        {
            get { return (string)GetValue(PayBankNameProperty); }
            set { SetValue(PayBankNameProperty, value); }
        }
        public static readonly DependencyProperty PayBankNameProperty =
            DependencyProperty.Register("PayBankName", typeof(string), typeof(Print_Commitment), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 收款人
        /// </summary>
        public string Payee_Name
        {
            get { return (string)GetValue(Payee_NameProperty); }
            set { SetValue(Payee_NameProperty, value); }
        }
        public static readonly DependencyProperty Payee_NameProperty =
            DependencyProperty.Register("Payee_Name", typeof(string), typeof(Print_Commitment), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 收款人账号
        /// </summary>
        public string Payee_Actno
        {
            get { return (string)GetValue(Payee_ActnoProperty); }
            set { SetValue(Payee_ActnoProperty, value); }
        }
        public static readonly DependencyProperty Payee_ActnoProperty =
           DependencyProperty.Register("Payee_Actno", typeof(string), typeof(Print_Commitment), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 收款开户行
        /// </summary>
        public string PayeeBankName
        {
            get { return (string)GetValue(PayeeBankNameProperty); }
            set { SetValue(PayeeBankNameProperty, value); }
        }
        public static readonly DependencyProperty PayeeBankNameProperty =
            DependencyProperty.Register("PayeeBankName", typeof(string), typeof(Print_Commitment), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 结算金额大写
        /// </summary>
        public string Settlement_AmtMax
        {
            get { return (string)GetValue(Settlement_AmtMaxProperty); }
            set { SetValue(Settlement_AmtMaxProperty, value); }
        }
        public static readonly DependencyProperty Settlement_AmtMaxProperty =
            DependencyProperty.Register("Settlement_AmtMax", typeof(string), typeof(Print_Commitment), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 结算金额小写
        /// </summary>
        public string Settlement_AmtMin
        {
            get { return (string)GetValue(Settlement_AmtMinProperty); }
            set
            {
                SetValue(Settlement_AmtMinProperty, value);
                Extension.PrintContainerExt.SetCanvas(Currency, value);
            }
        }
        public static readonly DependencyProperty Settlement_AmtMinProperty =
            DependencyProperty.Register("Settlement_AmtMin", typeof(string), typeof(Print_Commitment), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 设置金额显示方式
        /// </summary>
        /// <param name="str"></param>
        /// <returns></returns>
        public void SetsumdisplayMode(string str)
        {
            textBlock8.Text = textBlock9.Text = PrintTemplate.Extension.PrintContainerExt.PrintCurString(str);
            //return Newsum;
        }

        /// <summary>
        /// 汇票到期日
        /// </summary>
        public string Maturity
        {
            get { return (string)GetValue(MaturityProperty); }
            set { SetValue(MaturityProperty, value); }
        }
        public static readonly DependencyProperty MaturityProperty =
            DependencyProperty.Register("Maturity", typeof(string), typeof(Print_Commitment), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 协议编号
        /// </summary>
        public string AgreementNo
        {
            get { return (string)GetValue(AgreementNoProperty); }
            set { SetValue(AgreementNoProperty, value); }
        }
        public static readonly DependencyProperty AgreementNoProperty =
          DependencyProperty.Register("AgreementNo", typeof(string), typeof(Print_Commitment), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 付款行号
        /// </summary>
        public string PayBankNo
        {
            get { return (string)GetValue(PayBankNoProperty); }
            set { SetValue(PayBankNoProperty, value); }
        }
        public static readonly DependencyProperty PayBankNoProperty =
          DependencyProperty.Register("PayBankNo", typeof(string), typeof(Print_Commitment), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 付款行地址
        /// </summary>
        public string PayBankAddress
        {
            get { return (string)GetValue(PayBankAddressProperty); }
            set { SetValue(PayBankAddressProperty, value); }
        }
        public static readonly DependencyProperty PayBankAddressProperty =
          DependencyProperty.Register("PayBankAddress", typeof(string), typeof(Print_Commitment), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 出票人盖章
        /// </summary>
        public string TicketNameStamp
        {
            get { return (string)GetValue(TicketNameStampProperty); }
            set { SetValue(TicketNameStampProperty, value); }
        }
        public static readonly DependencyProperty TicketNameStampProperty =
            DependencyProperty.Register("TicketNameStamp", typeof(string), typeof(Print_Commitment), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 备注
        /// </summary>
        public string Remark
        {
            get { return (string)GetValue(RemarkProperty); }
            set { SetValue(RemarkProperty, value); }
        }
        public static readonly DependencyProperty RemarkProperty =
          DependencyProperty.Register("Remark", typeof(string), typeof(Print_Commitment), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 复核
        /// </summary>
        public string Review
        {
            get { return (string)GetValue(ReviewProperty); }
            set { SetValue(ReviewProperty, value); }
        }
        public static readonly DependencyProperty ReviewProperty =
            DependencyProperty.Register("Review", typeof(string), typeof(Print_Commitment), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 记账
        /// </summary>
        public string Handling
        {
            get { return (string)GetValue(HandlingProperty); }
            set { SetValue(HandlingProperty, value); }
        }
        public static readonly DependencyProperty HandlingProperty =
            DependencyProperty.Register("Handling", typeof(string), typeof(Print_Commitment), new UIPropertyMetadata(LoginUserInfo.TellerNo));
        #endregion
    }

}
