﻿using System;
using System.Windows;
using Platform.Common.RunningParameters;

namespace TellerSystem.PrintTemplate.Common
{
    /// <summary>
    /// 存款证明
    /// </summary>
    public partial class Print_DepositProof
    {
        public Print_DepositProof()
        {
            InitializeComponent();
        }

        #region 自定义属性

        public static readonly DependencyProperty DateInfoProperty =
            DependencyProperty.Register("DateInfo", typeof (string), typeof (Print_DepositProof),
                                        new UIPropertyMetadata(LoginUserInfo.TradeDate));

        public static readonly DependencyProperty ClientNameProperty =
            DependencyProperty.Register("ClientName", typeof (string), typeof (Print_DepositProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty ClientName1Property =
            DependencyProperty.Register("ClientName1", typeof(string), typeof(Print_DepositProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty MaturityProperty =
            DependencyProperty.Register("Maturity", typeof (DateTime), typeof (Print_DepositProof),
                                        new UIPropertyMetadata(DateTime.Now));

        public static readonly DependencyProperty Maturity1Property =
            DependencyProperty.Register("Maturity1", typeof(string), typeof(Print_DepositProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty AccountProperty =
            DependencyProperty.Register("Account", typeof (string), typeof (Print_DepositProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty SumProperty =
            DependencyProperty.Register("Sum", typeof (string), typeof (Print_DepositProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty StartDateProperty =
            DependencyProperty.Register("StartDate", typeof (string), typeof (Print_DepositProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty EndDateProperty =
            DependencyProperty.Register("EndDate", typeof (string), typeof (Print_DepositProof),
                                        new UIPropertyMetadata(string.Empty));
        //---1------
        public static readonly DependencyProperty Account1Property =
           DependencyProperty.Register("Account1", typeof(string), typeof(Print_DepositProof),
                                       new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Sum1Property =
            DependencyProperty.Register("Sum1", typeof(string), typeof(Print_DepositProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty StartDate1Property =
            DependencyProperty.Register("StartDate1", typeof(string), typeof(Print_DepositProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty EndDate1Property =
            DependencyProperty.Register("EndDate1", typeof(string), typeof(Print_DepositProof),
                                        new UIPropertyMetadata(string.Empty));

        //---2-----
        public static readonly DependencyProperty Account2Property =
           DependencyProperty.Register("Account2", typeof(string), typeof(Print_DepositProof),
                                       new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Sum2Property =
            DependencyProperty.Register("Sum2", typeof(string), typeof(Print_DepositProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty StartDate2Property =
            DependencyProperty.Register("StartDate2", typeof(string), typeof(Print_DepositProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty EndDate2Property =
            DependencyProperty.Register("EndDate2", typeof(string), typeof(Print_DepositProof),
                                        new UIPropertyMetadata(string.Empty));
        //---3---
        public static readonly DependencyProperty Account3Property =
           DependencyProperty.Register("Account3", typeof(string), typeof(Print_DepositProof),
                                       new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Sum3Property =
            DependencyProperty.Register("Sum3", typeof(string), typeof(Print_DepositProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty StartDate3Property =
            DependencyProperty.Register("StartDate3", typeof(string), typeof(Print_DepositProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty EndDate3Property =
            DependencyProperty.Register("EndDate3", typeof(string), typeof(Print_DepositProof),
                                        new UIPropertyMetadata(string.Empty));
        //----4--

        public static readonly DependencyProperty Account4Property =
          DependencyProperty.Register("Account4", typeof(string), typeof(Print_DepositProof),
                                      new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Sum4Property =
            DependencyProperty.Register("Sum4", typeof(string), typeof(Print_DepositProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty StartDate4Property =
            DependencyProperty.Register("StartDate4", typeof(string), typeof(Print_DepositProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty EndDate4Property =
            DependencyProperty.Register("EndDate4", typeof(string), typeof(Print_DepositProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty IssuedNameProperty =
            DependencyProperty.Register("IssuedName", typeof(string), typeof(Print_DepositProof),
                                        new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 日期
        /// </summary>
        public string DateInfo
        {
            get { return (string) GetValue(DateInfoProperty); }
            set { SetValue(DateInfoProperty, value); }
        }

        /// <summary>
        /// 客户名称
        /// </summary>
        public string ClientName
        {
            get { return (string) GetValue(ClientNameProperty); }
            set { SetValue(ClientNameProperty, value); }
        }

        public string ClientName1
        {
            get { return (string)GetValue(ClientName1Property); }
            set { SetValue(ClientName1Property, value); }
        }

        /// <summary>
        /// 到期日
        /// </summary>
        public DateTime Maturity
        {
            get { return (DateTime) GetValue(MaturityProperty); }
            set { SetValue(MaturityProperty, value); }
        }

        public string Maturity1
        {
            get { return (string)GetValue(Maturity1Property); }
            set { SetValue(Maturity1Property, value); }
        }
//---0--
        /// <summary>
        /// 账号
        /// </summary>
        public string Account
        {
            get { return (string) GetValue(AccountProperty); }
            set { SetValue(AccountProperty, value); }
        }

        /// <summary>
        /// 金额
        /// </summary>
        public string Sum
        {
            get { return (string) GetValue(SumProperty); }
            set { SetValue(SumProperty, value); }
        }

        /// <summary>
        /// 开始日
        /// </summary>
        public string StartDate
        {
            get { return (string) GetValue(StartDateProperty); }
            set { SetValue(StartDateProperty, value); }
        }

        /// <summary>
        /// 结束日
        /// </summary>
        public string EndDate
        {
            get { return (string) GetValue(EndDateProperty); }
            set { SetValue(EndDateProperty, value); }
        }

        //---1--
        /// <summary>
        /// 账号1
        /// </summary>
        public string Account1
        {
            get { return (string)GetValue(Account1Property); }
            set { SetValue(Account1Property, value); }
        }

        /// <summary>
        /// 金额1
        /// </summary>
        public string Sum1
        {
            get { return (string)GetValue(Sum1Property); }
            set { SetValue(Sum1Property, value); }
        }

        /// <summary>
        /// 开始日1
        /// </summary>
        public string StartDate1
        {
            get { return (string)GetValue(StartDate1Property); }
            set { SetValue(StartDate1Property, value); }
        }

        /// <summary>
        /// 结束日1
        /// </summary>
        public string EndDate1
        {
            get { return (string)GetValue(EndDate1Property); }
            set { SetValue(EndDate1Property, value); }
        }

        //---2--
        /// <summary>
        /// 账号
        /// </summary>
        public string Account2
        {
            get { return (string)GetValue(Account2Property); }
            set { SetValue(Account2Property, value); }
        }

        /// <summary>
        /// 金额2
        /// </summary>
        public string Sum2
        {
            get { return (string)GetValue(Sum2Property); }
            set { SetValue(Sum2Property, value); }
        }

        /// <summary>
        /// 开始日2
        /// </summary>
        public string StartDate2
        {
            get { return (string)GetValue(StartDate2Property); }
            set { SetValue(StartDate2Property, value); }
        }

        /// <summary>
        /// 结束日2
        /// </summary>
        public string EndDate2
        {
            get { return (string)GetValue(EndDate2Property); }
            set { SetValue(EndDate2Property, value); }
        }

        //---3--
        /// <summary>
        /// 账号3
        /// </summary>
        public string Account3
        {
            get { return (string)GetValue(Account3Property); }
            set { SetValue(Account3Property, value); }
        }

        /// <summary>
        /// 金额3
        /// </summary>
        public string Sum3
        {
            get { return (string)GetValue(Sum3Property); }
            set { SetValue(Sum3Property, value); }
        }

        /// <summary>
        /// 开始日3
        /// </summary>
        public string StartDate3
        {
            get { return (string)GetValue(StartDate3Property); }
            set { SetValue(StartDate3Property, value); }
        }

        /// <summary>
        /// 结束日3
        /// </summary>3
        public string EndDate3
        {
            get { return (string)GetValue(EndDate3Property); }
            set { SetValue(EndDate3Property, value); }
        }

        //---4--
        /// <summary>
        /// 账号4
        /// </summary>
        public string Account4
        {
            get { return (string)GetValue(Account4Property); }
            set { SetValue(Account4Property, value); }
        }

        /// <summary>
        /// 金额4
        /// </summary>
        public string Sum4
        {
            get { return (string)GetValue(Sum4Property); }
            set { SetValue(Sum4Property, value); }
        }

        /// <summary>
        /// 开始日4
        /// </summary>
        public string StartDate4
        {
            get { return (string)GetValue(StartDate4Property); }
            set { SetValue(StartDate4Property, value); }
        }

        /// <summary>
        /// 结束日4
        /// </summary>
        public string EndDate4
        {
            get { return (string)GetValue(EndDate4Property); }
            set { SetValue(EndDate4Property, value); }
        }


        /// <summary>
        /// 签发人
        /// </summary>
        public string IssuedName
        {
            get { return (string) GetValue(IssuedNameProperty); }
            set { SetValue(IssuedNameProperty, value); }
        }

        #endregion 自定义属性
    }
}