﻿using System;
using System.Globalization;
using System.Linq;
using System.Windows;
using Platform.Common.RunningParameters;

namespace TellerSystem.PrintTemplate.Common
{
    /// <summary>
    /// 通存通兑业务凭证.png
    /// </summary>
    public partial class Print_DepositandProof
    {
        public Print_DepositandProof()
        {
            InitializeComponent();
        }

        #region 自定义属性

        public static readonly DependencyProperty DepositandProperty =
            DependencyProperty.Register("Depositand", typeof (bool), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(false));

        public static readonly DependencyProperty TongduiProperty =
            DependencyProperty.Register("Tongdui", typeof (bool), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(false));

        public static readonly DependencyProperty AccountinfoProperty =
            DependencyProperty.Register("Accountinfo", typeof (bool), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(false));

        public static readonly DependencyProperty CashProperty =
            DependencyProperty.Register("Cash", typeof (bool), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(false));

        public static readonly DependencyProperty TransferProperty =
            DependencyProperty.Register("Transfer", typeof (bool), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(false));

        public static readonly DependencyProperty DateInfoProperty =
            DependencyProperty.Register("DateInfo", typeof (DateTime), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(DateTime.ParseExact(LoginUserInfo.TradeDate, "yyyyMMdd",
                                                                                   CultureInfo.CurrentCulture)));

        public static readonly DependencyProperty PayNameProperty =
            DependencyProperty.Register("PayName", typeof (string), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Pay_ActnoProperty =
            DependencyProperty.Register("Pay_Actno", typeof (string), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty PayBankNameProperty =
            DependencyProperty.Register("PayBankName", typeof (string), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Payee_NameProperty =
            DependencyProperty.Register("Payee_Name", typeof (string), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Payee_ActnoProperty =
            DependencyProperty.Register("Payee_Actno", typeof (string), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty PayeeBankNameProperty =
            DependencyProperty.Register("PayeeBankName", typeof (string), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty CredentialsTypeProperty =
            DependencyProperty.Register("CredentialsType", typeof (string), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty CredentialsNoProperty =
            DependencyProperty.Register("CredentialsNo", typeof (string), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty ProxyCredentialsTypeProperty =
            DependencyProperty.Register("ProxyCredentialsType", typeof (string), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty ProxyCredentialsNoProperty =
            DependencyProperty.Register("ProxyCredentialsNo", typeof (string), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty ClientNameProperty =
            DependencyProperty.Register("ClientName", typeof (string), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty ProxyNameProperty =
            DependencyProperty.Register("ProxyName", typeof (string), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Settlement_AmtMaxProperty =
            DependencyProperty.Register("Settlement_AmtMax", typeof (string), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Settlement_AmtMinProperty =
            DependencyProperty.Register("Settlement_AmtMin", typeof (string), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty BarkConfirmProperty =
            DependencyProperty.Register("BarkConfirm", typeof (string), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty ReviewProperty =
            DependencyProperty.Register("Review", typeof (string), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty HandlingProperty =
            DependencyProperty.Register("Handling", typeof (string), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(LoginUserInfo.TellerNo));

        public static readonly DependencyProperty ClientAddresssProperty =
            DependencyProperty.Register("ClientAddresss", typeof (string), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty PhoneProperty =
            DependencyProperty.Register("Phone", typeof (string), typeof (Print_DepositandProof),
                                        new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 通存业务
        /// </summary>
        public bool Depositand
        {
            get { return (bool) GetValue(DepositandProperty); }
            set { SetValue(DepositandProperty, value); }
        }

        /// <summary>
        /// 通兑
        /// </summary>
        public bool Tongdui
        {
            get { return (bool) GetValue(TongduiProperty); }
            set { SetValue(TongduiProperty, value); }
        }

        /// <summary>
        /// 账号信息
        /// </summary>
        public bool Accountinfo
        {
            get { return (bool) GetValue(AccountinfoProperty); }
            set { SetValue(AccountinfoProperty, value); }
        }

        /// <summary>
        /// 现金Cash
        /// </summary>
        public bool Cash
        {
            get { return (bool) GetValue(CashProperty); }
            set { SetValue(CashProperty, value); }
        }

        /// <summary>
        /// 转账
        /// </summary>
        public bool Transfer
        {
            get { return (bool) GetValue(TransferProperty); }
            set { SetValue(TransferProperty, value); }
        }

        /// <summary>
        /// 日期
        /// </summary>
        public DateTime DateInfo
        {
            get { return (DateTime) GetValue(DateInfoProperty); }
            set { SetValue(DateInfoProperty, value); }
        }

        /// <summary>
        /// 付款人
        /// </summary>
        public string PayName
        {
            get { return (string) GetValue(PayNameProperty); }
            set { SetValue(PayNameProperty, value); }
        }

        /// <summary>
        /// 付款人账号
        /// </summary>
        public string Pay_Actno
        {
            get { return (string) GetValue(Pay_ActnoProperty); }
            set { SetValue(Pay_ActnoProperty, value); }
        }

        /// <summary>
        /// 付款开户行
        /// </summary>
        public string PayBankName
        {
            get { return (string) GetValue(PayBankNameProperty); }
            set { SetValue(PayBankNameProperty, value); }
        }

        /// <summary>
        /// 收款人
        /// </summary>
        public string Payee_Name
        {
            get { return (string) GetValue(Payee_NameProperty); }
            set { SetValue(Payee_NameProperty, value); }
        }

        /// <summary>
        /// 收款人账号
        /// </summary>
        public string Payee_Actno
        {
            get { return (string) GetValue(Payee_ActnoProperty); }
            set { SetValue(Payee_ActnoProperty, value); }
        }

        /// <summary>
        /// 收款开户行
        /// </summary>
        public string PayeeBankName
        {
            get { return (string) GetValue(PayeeBankNameProperty); }
            set { SetValue(PayeeBankNameProperty, value); }
        }

        /// <summary>
        /// 证件类型Credentials
        /// </summary>
        public string CredentialsType
        {
            get { return (string) GetValue(CredentialsTypeProperty); }
            set { SetValue(CredentialsTypeProperty, value); }
        }

        /// <summary>
        /// 证件号
        /// </summary>
        public string CredentialsNo
        {
            get { return (string) GetValue(CredentialsNoProperty); }
            set { SetValue(CredentialsNoProperty, value); }
        }

        /// <summary>
        /// 代理人证件类型
        /// </summary>
        public string ProxyCredentialsType
        {
            get { return (string) GetValue(ProxyCredentialsTypeProperty); }
            set { SetValue(ProxyCredentialsTypeProperty, value); }
        }

        /// <summary>
        /// 代理人证件号
        /// </summary>
        public string ProxyCredentialsNo
        {
            get { return (string) GetValue(ProxyCredentialsNoProperty); }
            set { SetValue(ProxyCredentialsNoProperty, value); }
        }

        /// <summary>
        /// 客户签名
        /// </summary>
        public string ClientName
        {
            get { return (string) GetValue(ClientNameProperty); }
            set { SetValue(ClientNameProperty, value); }
        }

        /// <summary>
        /// 代理人签名
        /// </summary>
        public string ProxyName
        {
            get { return (string) GetValue(ProxyNameProperty); }
            set { SetValue(ProxyNameProperty, value); }
        }

        /// <summary>
        /// 结算金额大写
        /// </summary>
        public string Settlement_AmtMax
        {
            get { return (string) GetValue(Settlement_AmtMaxProperty); }
            set { SetValue(Settlement_AmtMaxProperty, value); }
        }

        /// <summary>
        /// 结算金额小写
        /// </summary>
        public string Settlement_AmtMin
        {
            get { return (string) GetValue(Settlement_AmtMinProperty); }
            set
            {
                SetValue(Settlement_AmtMinProperty, value);
                Extension.PrintContainerExt.SetCanvas(stackPanel1, value);
            }
        }

        /// <summary>
        /// 银行确认
        /// </summary>
        public string BarkConfirm
        {
            get { return (string) GetValue(BarkConfirmProperty); }
            set { SetValue(BarkConfirmProperty, value); }
        }

        /// <summary>
        /// 复核
        /// </summary>
        public string Review
        {
            get { return (string) GetValue(ReviewProperty); }
            set { SetValue(ReviewProperty, value); }
        }

        /// <summary>
        ///记账
        /// </summary>
        public string Handling
        {
            get { return (string) GetValue(HandlingProperty); }
            set { SetValue(HandlingProperty, value); }
        }

        /// <summary>
        /// 客户地址Phone
        /// </summary>
        public string ClientAddresss
        {
            get { return (string) GetValue(ClientAddresssProperty); }
            set { SetValue(ClientAddresssProperty, value); }
        }

        /// <summary>
        /// 联系电话
        /// </summary>
        public string Phone
        {
            get { return (string) GetValue(PhoneProperty); }
            set { SetValue(PhoneProperty, value); }
        }

        /// <summary>
        /// 设置金额显示方式
        /// </summary>
        /// <param name="str"></param>
        /// <returns></returns>
        public void SetsumdisplayMode(string str)
        {
            textBlock9.Text = PrintTemplate.Extension.PrintContainerExt.PrintCurString(str);
            //return Newsum;
        }


        #endregion 自定义属性
    }
}