﻿using System;
using System.Globalization;
using System.Windows;
using Platform.Common.RunningParameters;

namespace TellerSystem.PrintTemplate.Common
{
    /// <summary>
    /// 跨行通存通兑业务申请书
    /// </summary>
    public partial class Print_DepositandTable
    {
        public Print_DepositandTable()
        {
            InitializeComponent();
        }

        #region 自定义属性

        public static readonly DependencyProperty ClientNameProperty =
            DependencyProperty.Register("ClientName", typeof(string), typeof(Print_DepositandTable),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty IDcardProperty =
            DependencyProperty.Register("IDcard", typeof(string), typeof(Print_DepositandTable),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty AccountProperty =
            DependencyProperty.Register("Account", typeof(string), typeof(Print_DepositandTable),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty SumProperty =
            DependencyProperty.Register("Sum", typeof(string), typeof(Print_DepositandTable),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty DateInfoProperty =
            DependencyProperty.Register("DateInfo", typeof(DateTime), typeof(Print_DepositandTable),
                                        new UIPropertyMetadata(DateTime.ParseExact(LoginUserInfo.TradeDate, "yyyyMMdd",
                                                                                   CultureInfo.CurrentCulture)));

        /// <summary>
        /// 客户名称ID card
        /// </summary>
        public string ClientName
        {
            get { return (string)GetValue(ClientNameProperty); }
            set { SetValue(ClientNameProperty, value); }
        }

        /// <summary>
        /// 身份证Account
        /// </summary>
        public string IDcard
        {
            get { return (string)GetValue(IDcardProperty); }
            set { SetValue(IDcardProperty, value); }
        }

        /// <summary>
        /// 账号
        /// </summary>
        public string Account
        {
            get { return (string)GetValue(AccountProperty); }
            set { SetValue(AccountProperty, value); }
        }

        /// <summary>
        /// 金额
        /// </summary>
        public string Sum
        {
            get { return (string)GetValue(SumProperty); }
            set { SetValue(SumProperty, value); }
        }

        /// <summary>
        /// 日期
        /// </summary>
        public DateTime DateInfo
        {
            get { return (DateTime)GetValue(DateInfoProperty); }
            set { SetValue(DateInfoProperty, value); }
        }

        #endregion 自定义属性
    }
}