﻿using System;
using System.Globalization;
using System.Linq;
using System.Windows;
using Platform.Common.RunningParameters;

namespace TellerSystem.PrintTemplate.Common
{
    /// <summary>
    ///电汇凭证
    /// </summary>
    public partial class Print_Electricity
    {
        public Print_Electricity()
        {
            InitializeComponent();
            TradeDate.Text = LoginUserInfo.TradeDate;
        }

        #region 自定义属性

        /// <summary>
        /// 日期
        /// </summary>
        public String DateInfo
        {
            set { TradeDate.Text = value; }
        }
        public static readonly DependencyProperty DateInfoProperty =
        DependencyProperty.Register("DateInfo", typeof(DateTime), typeof(Print_Electricity),
                                    new UIPropertyMetadata(DateTime.ParseExact(LoginUserInfo.TradeDate, "yyyyMMdd",
                                                                               CultureInfo.CurrentCulture)));
        public static readonly DependencyProperty RemittanceNameProperty =
            DependencyProperty.Register("RemittanceName", typeof(string), typeof(Print_Electricity),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty RemittanceActnoProperty =
            DependencyProperty.Register("RemittanceActno", typeof(string), typeof(Print_Electricity),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty RemittanceBankNoProperty =
            DependencyProperty.Register("RemittanceBankNo", typeof(string), typeof(Print_Electricity),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty PayNameProperty =
            DependencyProperty.Register("PayeeName", typeof(string), typeof(Print_Electricity),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Payee_ActnoProperty =
            DependencyProperty.Register("Payee_Actno", typeof(string), typeof(Print_Electricity),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Payee_BankNoProperty =
            DependencyProperty.Register("Payee_BankNo", typeof(string), typeof(Print_Electricity),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty OutBankNameNameProperty =
            DependencyProperty.Register("OutBankName", typeof(string), typeof(Print_Electricity),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty PutBankNameProperty =
            DependencyProperty.Register("PutBankName", typeof(string), typeof(Print_Electricity),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Settlement_AmtMaxProperty =
            DependencyProperty.Register("Settlement_AmtMax", typeof(string), typeof(Print_Electricity),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Settlement_AmtMinProperty =
            DependencyProperty.Register("Settlement_AmtMin", typeof(string), typeof(Print_Electricity),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty UseProperty =
            DependencyProperty.Register("Use", typeof(string), typeof(Print_Electricity),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty BankConfirmProperty =
            DependencyProperty.Register("BankConfirm", typeof(string), typeof(Print_Electricity),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty ReviewProperty =
            DependencyProperty.Register("Review", typeof(string), typeof(Print_Electricity),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty HandlingProperty =
            DependencyProperty.Register("Handling", typeof(string), typeof(Print_Electricity),
                                        new UIPropertyMetadata(LoginUserInfo.TellerNo));

        public static readonly DependencyProperty StampProperty =
            DependencyProperty.Register("Stamp", typeof(string), typeof(Print_Electricity),
                                        new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty CurrencyProperty =
            DependencyProperty.Register("Currency", typeof(string), typeof(Print_Electricity),
            new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty HostSerialNumberProperty =
            DependencyProperty.Register("HostSerialNumber", typeof(string), typeof(Print_Electricity), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 主机流水值
        /// </summary>
        public string HostSerialNumber
        {
            get { return (string)GetValue(HostSerialNumberProperty); }
            set { SetValue(HostSerialNumberProperty, value); }
        }

       
        /// <summary>
        /// 业务种类
        /// </summary>
        public string RemittanceName
        {
            get { return (string)GetValue(RemittanceNameProperty); }
            set { SetValue(RemittanceNameProperty, value); }
        }

        /// <summary>
        /// 交易序号
        /// </summary>
        public string RemittanceActno
        {
            get { return (string)GetValue(RemittanceActnoProperty); }
            set { SetValue(RemittanceActnoProperty, value); }
        }

        /// <summary>
        /// 汇款人行号
        /// </summary>
        public string RemittanceBankNo
        {
            get { return (string)GetValue(RemittanceBankNoProperty); }
            set { SetValue(RemittanceBankNoProperty, value); }
        }

        /// <summary>
        /// 收款人
        /// </summary>
        public string PayeeName
        {
            get { return (string)GetValue(PayNameProperty); }
            set { SetValue(PayNameProperty, value); }
        }

        /// <summary>
        /// 收款人账号
        /// </summary>
        public string Payee_Actno
        {
            get { return (string)GetValue(Payee_ActnoProperty); }
            set { SetValue(Payee_ActnoProperty, value); }
        }

        /// <summary>
        /// 收款人行号
        /// </summary>
        public string Payee_BankNo
        {
            get { return (string)GetValue(Payee_BankNoProperty); }
            set { SetValue(Payee_BankNoProperty, value); }
        }

        /// <summary>
        /// 汇出银行名称
        /// </summary>
        public string OutBankName
        {
            get { return (string)GetValue(OutBankNameNameProperty); }
            set { SetValue(OutBankNameNameProperty, value); }
        }

        /// <summary>
        /// 汇入银行名称
        /// </summary>
        public string PutBankName
        {
            get { return (string)GetValue(PutBankNameProperty); }
            set { SetValue(PutBankNameProperty, value); }
        }

        /// <summary>
        /// 结算金额大写
        /// </summary>
        public string Settlement_AmtMax
        {
            get { return (string)GetValue(Settlement_AmtMaxProperty); }
            set { SetValue(Settlement_AmtMaxProperty, value); }
        }

        /// <summary>
        /// 金额
        /// </summary>
        public string Currency
        {
            get { return (string)GetValue(CurrencyProperty); }
            set { SetValue(CurrencyProperty, value); }
        }

        /// <summary>
        /// 用途
        /// </summary>
        public string Use
        {
            get { return (string)GetValue(UseProperty); }
            set { SetValue(UseProperty, value); }
        }

        /// <summary>
        /// 银行确认
        /// </summary>
        public string BankConfirm
        {
            get { return (string)GetValue(BankConfirmProperty); }
            set { SetValue(BankConfirmProperty, value); }
        }

        /// <summary>
        /// 复核
        /// </summary>
        public string Review
        {
            get { return (string)GetValue(ReviewProperty); }
            set { SetValue(ReviewProperty, value); }
        }

        /// <summary>
        /// 记账
        /// </summary>
        public string Handling
        {
            get { return (string)GetValue(HandlingProperty); }
            set { SetValue(HandlingProperty, value); }
        }

        /// <summary>
        /// 盖章
        /// </summary>
        public string Stamp
        {
            get { return (string)GetValue(StampProperty); }
            set { SetValue(StampProperty, value); }
        }

        /// <summary>
        /// 结算金额小写
        /// </summary>
        public string Settlement_AmtMin
        {
            get { return (string)GetValue(Settlement_AmtMinProperty); }
            set
            {
                SetValue(Settlement_AmtMinProperty, value);
                //Extension.PrintContainerExt.SetCanvas(stackPanel1, value);
            }
        }

        #endregion 自定义属性
    }
}