﻿using System;
using System.Globalization;
using System.Windows;
using Platform.Common.RunningParameters;

namespace TellerSystem.PrintTemplate.Common
{
    /// <summary>
    /// Print_Fakemoney.xaml 的交互逻辑
    /// </summary>
    public partial class Print_Fakemoney
    {
        public Print_Fakemoney()
        {
            InitializeComponent();
        }

        #region 自定义属性

        public static readonly DependencyProperty StampProperty =
            DependencyProperty.Register("Stamp", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty DateInfoProperty =
            DependencyProperty.Register("DateInfo", typeof(DateTime), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(DateTime.ParseExact(LoginUserInfo.TradeDate, "yyyyMMdd",
                                                                                   CultureInfo.CurrentCulture)));
        public static readonly DependencyProperty NumberProperty =
            DependencyProperty.Register("Number", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty HolderProperty =
            DependencyProperty.Register("Holder", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty CredentialsNumberProperty =
            DependencyProperty.Register("CredentialsNumber", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty CurrencyProperty =
            DependencyProperty.Register("Currency", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty DenominationProperty =
            DependencyProperty.Register("Denomination", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty ScicsProperty =
            DependencyProperty.Register("Scics", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Counterfeitnumber1Property =
            DependencyProperty.Register("Counterfeitnumber1", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty Counterfeitnumber2Property =
            DependencyProperty.Register("Counterfeitnumber2", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty Counterfeitnumber3Property =
            DependencyProperty.Register("Counterfeitnumber3", typeof(string), typeof(Print_Fakemoney),
                                new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty Counterfeitnumber4Property =
            DependencyProperty.Register("Counterfeitnumber4", typeof(string), typeof(Print_Fakemoney),
                                new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty Counterfeitnumber5Property =
            DependencyProperty.Register("Counterfeitnumber5", typeof(string), typeof(Print_Fakemoney),
                                new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty Nnumber1Property =
            DependencyProperty.Register("Nnumber1", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty Nnumber2Property =
            DependencyProperty.Register("Nnumber2", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty Nnumber3Property =
            DependencyProperty.Register("Nnumber3", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty Nnumber4Property =
            DependencyProperty.Register("Nnumber4", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty Nnumber5Property =
            DependencyProperty.Register("Nnumber5", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty Facevalue1Property =
            DependencyProperty.Register("Facevalue1", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty Facevalue2Property =
            DependencyProperty.Register("Facevalue2", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty Facevalue3Property =
            DependencyProperty.Register("Facevalue3", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty Facevalue4Property =
            DependencyProperty.Register("Facevalue4", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty Facevalue5Property =
            DependencyProperty.Register("Facevalue5", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty AmountProperty =
            DependencyProperty.Register("Amount", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty SheetProperty =
            DependencyProperty.Register("Sheet", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty TotalfacevalueProperty =
            DependencyProperty.Register("Totalfacevalue", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty ProductionmethodsProperty =
            DependencyProperty.Register("Productionmethods", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty CashierProperty =
            DependencyProperty.Register("Cashier", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(LoginUserInfo.TellerNo));

        public static readonly DependencyProperty ReviewProperty =
            DependencyProperty.Register("Review", typeof(string), typeof(Print_Fakemoney),
                                        new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 盖章
        /// </summary>
        public string Stamp
        {
            get { return (string)GetValue(StampProperty); }
            set { SetValue(StampProperty, value); }
        }

        /// <summary>
        /// 日期
        /// </summary>
        public DateTime DateInfo
        {
            get { return (DateTime)GetValue(DateInfoProperty); }
            set { SetValue(DateInfoProperty, value); }
        }
        /// <summary>
        /// 编号
        /// </summary>
        public string Number
        {
            get { return (string)GetValue(NumberProperty); }
            set { SetValue(NumberProperty, value); }
        }

        /// <summary>
        /// 持有人
        /// </summary>
        public string Holder
        {
            get { return (string)GetValue(HolderProperty); }
            set { SetValue(HolderProperty, value); }
        }

        /// <summary>
        /// 证件号码
        /// </summary>
        public string CredentialsNumber
        {
            get { return (string)GetValue(CredentialsNumberProperty); }
            set { SetValue(CredentialsNumberProperty, value); }
        }

        /// <summary>
        /// 币种
        /// </summary>
        public string Currency
        {
            get { return (string)GetValue(CurrencyProperty); }
            set { SetValue(CurrencyProperty, value); }
        }

        /// <summary>
        ///卷别
        /// </summary>
        public string Denomination
        {
            get { return (string)GetValue(DenominationProperty); }
            set { SetValue(DenominationProperty, value); }
        }

        /// <summary>
        /// 版别
        /// </summary>
        public string Scics
        {
            get { return (string)GetValue(ScicsProperty); }
            set { SetValue(ScicsProperty, value); }
        }

        /// <summary>
        /// 冠字号码1
        /// </summary>
        public string Counterfeitnumber1
        {
            get { return (string)GetValue(Counterfeitnumber1Property); }
            set { SetValue(Counterfeitnumber1Property, value); }
        }

        /// <summary>
        /// 冠字号码2
        /// </summary>
        public string Counterfeitnumber2
        {
            get { return (string)GetValue(Counterfeitnumber2Property); }
            set { SetValue(Counterfeitnumber2Property, value); }
        }

        /// <summary>
        /// 冠字号码3
        /// </summary>
        public string Counterfeitnumber3
        {
            get { return (string)GetValue(Counterfeitnumber3Property); }
            set { SetValue(Counterfeitnumber3Property, value); }
        }

        /// <summary>
        /// 冠字号码4
        /// </summary>
        public string Counterfeitnumber4
        {
            get { return (string)GetValue(Counterfeitnumber4Property); }
            set { SetValue(Counterfeitnumber4Property, value); }
        }

        /// <summary>
        /// 冠字号码5
        /// </summary>
        public string Counterfeitnumber5
        {
            get { return (string)GetValue(Counterfeitnumber5Property); }
            set { SetValue(Counterfeitnumber5Property, value); }
        }
        /// <summary>
        /// 张数1
        /// </summary>
        public string Nnumber1
        {
            get { return (string)GetValue(Nnumber1Property); }
            set { SetValue(Nnumber1Property, value); }
        }
        /// <summary>
        /// 张数2
        /// </summary>
        public string Nnumber2
        {
            get { return (string)GetValue(Nnumber2Property); }
            set { SetValue(Nnumber2Property, value); }
        }
        /// <summary>
        /// 张数3
        /// </summary>
        public string Nnumber3
        {
            get { return (string)GetValue(Nnumber3Property); }
            set { SetValue(Nnumber3Property, value); }
        }
        /// <summary>
        /// 张数4
        /// </summary>
        public string Nnumber4
        {
            get { return (string)GetValue(Nnumber4Property); }
            set { SetValue(Nnumber4Property, value); }
        }
        /// <summary>
        /// 张数5
        /// </summary>
        public string Nnumber5
        {
            get { return (string)GetValue(Nnumber5Property); }
            set { SetValue(Nnumber5Property, value); }
        }
        /// <summary>
        /// 面额1
        /// </summary>
        public string Facevalue1
        {
            get { return (string)GetValue(Facevalue1Property); }
            set { SetValue(Facevalue1Property, value); }
        }
        /// <summary>
        /// 面额2
        /// </summary>
        public string Facevalue2
        {
            get { return (string)GetValue(Facevalue2Property); }
            set { SetValue(Facevalue2Property, value); }
        }
        /// <summary>
        /// 面额3
        /// </summary>
        public string Facevalue3
        {
            get { return (string)GetValue(Facevalue3Property); }
            set { SetValue(Facevalue3Property, value); }
        }
        /// <summary>
        /// 面额4
        /// </summary>
        public string Facevalue4
        {
            get { return (string)GetValue(Facevalue4Property); }
            set { SetValue(Facevalue4Property, value); }
        }
        /// <summary>
        /// 面额5
        /// </summary>
        public string Facevalue5
        {
            get { return (string)GetValue(Facevalue5Property); }
            set { SetValue(Facevalue5Property, value); }
        }
        /// <summary>
        /// 数量
        /// </summary>
        public string Amount
        {
            get { return (string)GetValue(AmountProperty); }
            set { SetValue(AmountProperty, value); }
        }

        /// <summary>
        /// 张、枚
        /// </summary>
        public string Sheet
        {
            get { return (string)GetValue(SheetProperty); }
            set { SetValue(SheetProperty, value); }
        }

        /// <summary>
        /// 合计面额
        /// </summary>
        public string Totalfacevalue
        {
            get { return (string)GetValue(TotalfacevalueProperty); }
            set { SetValue(TotalfacevalueProperty, value); }
        }

        /// <summary>
        /// 制作方法
        /// </summary>
        public string Productionmethods
        {
            get { return (string)GetValue(ProductionmethodsProperty); }
            set { SetValue(ProductionmethodsProperty, value); }
        }

        /// <summary>
        /// 经办
        /// </summary>
        public string Cashier
        {
            get { return (string)GetValue(CashierProperty); }
            set { SetValue(CashierProperty, value); }
        }

        /// <summary>
        /// 复核
        /// </summary>
        public string Review
        {
            get { return (string)GetValue(ReviewProperty); }
            set { SetValue(ReviewProperty, value); }
        }

        #endregion 自定义属性
    }
}