﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Platform.Common.RunningParameters;

namespace TellerSystem.PrintTemplate.Common
{
    /// <summary>
    /// Print_FinancePay.xaml 的交互逻辑
    /// </summary>
    public partial class Print_FinancePay
    {
        /// <summary>
        /// 复核/授权时打印的凭证
        /// </summary>
        public Print_FinancePay()
        {
            InitializeComponent();
            sTellerNo.Text= LoginUserInfo.TellerNo;
        }

        #region 自定义属性

        /// <summary>
        /// 申请复核时（第一节点）需要打印的内容
        /// </summary>
        public string AskDescription
        {
            get { return (string)GetValue(AskDescriptionProperty); }
            set { SetValue(AskDescriptionProperty, value); }
        }

        // Using a DependencyProperty as the backing store for AskTellerDescription.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty AskDescriptionProperty =
            DependencyProperty.Register("AskDescription", typeof(string), typeof(Print_FinancePay), new UIPropertyMetadata(null));

        /// <summary>
        /// 复核岗（第二节点）需要打印的内容
        /// </summary>
        public string CheckDescription
        {
            get { return (string)GetValue(CheckOrAuthDescriptionProperty); }
            set { SetValue(CheckTellerDescriptionProperty, value); }
        }

        // Using a DependencyProperty as the backing store for CheckOrAuthTellerDescription.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty CheckTellerDescriptionProperty =
            DependencyProperty.Register("CheckDescription", typeof(string), typeof(Print_FinancePay), new UIPropertyMetadata(null));

        /// <summary>
        /// 复核结束后（第三节点）需要打印的内容
        /// </summary>
        public string ResultDescription
        {
            get { return (string)GetValue(ResultDescriptionProperty); }
            set { SetValue(ResultDescriptionProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ResultDescription.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ResultDescriptionProperty =
            DependencyProperty.Register("ResultDescription", typeof(string), typeof(Print_FinancePay), new UIPropertyMetadata(null));

        /// <summary>
        /// 机构号
        /// </summary>
        public string BranchNo
        {
            get { return (string)GetValue(BranchNoProperty); }
            set { SetValue(BranchNoProperty, value); }
        }

        // Using a DependencyProperty as the backing store for BranchNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty BranchNoProperty =
            DependencyProperty.Register("BranchNo", typeof(string), typeof(Print_FinancePay), new UIPropertyMetadata(null));

        /// <summary>
        /// 交易名称
        /// </summary>
        public string TradeName
        {
            get { return (string)GetValue(TradeNameProperty); }
            set { SetValue(TradeNameProperty, value); }
        }

        // Using a DependencyProperty as the backing store for TradeName.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty TradeNameProperty =
            DependencyProperty.Register("TradeName", typeof(string), typeof(Print_FinancePay), new UIPropertyMetadata(null));

        /// <summary>
        /// 凭证号
        /// </summary>
        public string VoucherNo
        {
            get { return (string)GetValue(VoucherNoProperty); }
            set { SetValue(VoucherNoProperty, value); }
        }

        // Using a DependencyProperty as the backing store for VoucherNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty VoucherNoProperty =
            DependencyProperty.Register("VoucherNo", typeof(string), typeof(Print_FinancePay), new UIPropertyMetadata(null));

        /// <summary>
        /// 流水号
        /// </summary>
        public string SerialNo
        {
            get { return (string)GetValue(SerialNoProperty); }
            set { SetValue(SerialNoProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SerialNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty SerialNoProperty =
            DependencyProperty.Register("SerialNo", typeof(string), typeof(Print_FinancePay), new UIPropertyMetadata(null));
        /// <summary>
        /// 付款账号
        /// </summary>
        public string FKZH
        {
            get { return (string)GetValue(FKZHProperty); }
            set { SetValue(FKZHProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SerialNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty FKZHProperty =
            DependencyProperty.Register("FKZH", typeof(string), typeof(Print_FinancePay), new UIPropertyMetadata(null));

        /// <summary>
        /// 预算单位
        /// </summary>
        public string YSDW
        {
            get { return (string)GetValue(YSDWProperty); }
            set { SetValue(YSDWProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SerialNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty YSDWProperty =
            DependencyProperty.Register("YSDW", typeof(string), typeof(Print_FinancePay), new UIPropertyMetadata(null));

        /// <summary>
        /// 发生额
        /// </summary>
        public string FSE
        {
            get { return (string)GetValue(FSEProperty); }
            set { SetValue(FSEProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SerialNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty FSEProperty =
            DependencyProperty.Register("FSE", typeof(string), typeof(Print_FinancePay), new UIPropertyMetadata(null));

        /// <summary>
        /// 财政凭证号
        /// </summary>
        public string CZPZH
        {
            get { return (string)GetValue(CZPZHProperty); }
            set { SetValue(CZPZHProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SerialNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty CZPZHProperty =
            DependencyProperty.Register("CZPZH", typeof(string), typeof(Print_FinancePay), new UIPropertyMetadata(null));

        /// <summary>
        /// 资金性质
        /// </summary>
        public string ZJXZ
        {
            get { return (string)GetValue(ZJXZProperty); }
            set { SetValue(ZJXZProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SerialNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ZJXZProperty =
            DependencyProperty.Register("ZJXZ", typeof(string), typeof(Print_FinancePay), new UIPropertyMetadata(null));

        /// <summary>
        /// 凭证号
        /// </summary>
        public string PZH
        {
            get { return (string)GetValue(PZHProperty); }
            set { SetValue(PZHProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SerialNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty PZHProperty =
            DependencyProperty.Register("PZH", typeof(string), typeof(Print_FinancePay), new UIPropertyMetadata(null));

        #endregion

        public DependencyProperty CheckOrAuthDescriptionProperty { get; set; }

        /// <summary>
        /// 摘要
        /// </summary>
        public string Remark
        {
            get { return (string)GetValue(RemarkProperty); }
            set { SetValue(RemarkProperty, value); }
        }
        public static readonly DependencyProperty RemarkProperty =
           DependencyProperty.Register("Remark", typeof(string), typeof(Print_FinancePay), new UIPropertyMetadata(string.Empty));

        public String TellerNo
        {
            set
            {
                @this.sTellerNo.Text = value;
            }
        }


        #region 流水
        public string SerialNumberStr
        {
            get { return (string)GetValue(SerialNumberStrProperty); }
            set { SetValue(SerialNumberStrProperty, value); }
        }

        public static readonly DependencyProperty SerialNumberStrProperty =
            DependencyProperty.Register("SerialNumberStr", typeof(string), typeof(Print_FinancePay), new UIPropertyMetadata("流水号:"));
        /// <summary>
        /// 业务流水
        /// </summary>
        public string HostSerialNumber
        {
            get { return (string)GetValue(HostSerialNumberProperty); }
            set { SetValue(HostSerialNumberProperty, value); }
        }
        public static readonly DependencyProperty HostSerialNumberProperty =
         DependencyProperty.Register("HostSerialNumber", typeof(string), typeof(Print_FinancePay),
         new UIPropertyMetadata(string.Empty));
        #endregion
    }
}
