﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Platform.Common.RunningParameters;

namespace TellerSystem.PrintTemplate.Common
{
    /// <summary>
    /// Print_Withdraw.xaml 的交互逻辑
    /// </summary>
    public partial class Print_IncomeBill
    {
        public Print_IncomeBill()
        {
            InitializeComponent();
            //设置默认值

        }

        /// <summary>
        /// 标题日期
        /// </summary>
        public DateTime HeaderDateInfo
        {
            get { return (DateTime)GetValue(HeaderDateInfoProperty); }
            set { SetValue(HeaderDateInfoProperty, value); }
        }

        // Using a DependencyProperty as the backing store for HeaderDateInfo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty HeaderDateInfoProperty =
            DependencyProperty.Register("HeaderDateInfo", typeof(DateTime), typeof(Print_IncomeBill), new UIPropertyMetadata(string.Empty));



        /// <summary>
        /// 付款人全称
        /// </summary>
        public string OutName
        {
            get { return (string)GetValue(OutNameProperty); }
            set { SetValue(OutNameProperty, value); }
        }

        // Using a DependencyProperty as the backing store for OutName.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty OutNameProperty =
            DependencyProperty.Register("OutName", typeof(string), typeof(Print_IncomeBill), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 付款人账号
        /// </summary>
        public string OutNum
        {
            get { return (string)GetValue(OutNumProperty); }
            set { SetValue(OutNumProperty, value); }
        }

        // Using a DependencyProperty as the backing store for OutName.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty OutNumProperty =
            DependencyProperty.Register("OutNum", typeof(string), typeof(Print_IncomeBill), new UIPropertyMetadata(string.Empty));


        /// <summary>
        /// 付款人开户行
        /// </summary>
        public string OutOpenBank
        {
            get { return (string)GetValue(OutOpenBankProperty); }
            set { SetValue(OutOpenBankProperty, value); }
        }

        // Using a DependencyProperty as the backing store for OutOpenBank.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty OutOpenBankProperty =
            DependencyProperty.Register("OutOpenBank", typeof(string), typeof(Print_IncomeBill), new UIPropertyMetadata(string.Empty));


        /// <summary>
        /// 收款人姓名
        /// </summary>
        public string InName
        {
            get { return (string)GetValue(InNameProperty); }
            set { SetValue(InNameProperty, value); }
        }

        // Using a DependencyProperty as the backing store for InName.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty InNameProperty =
            DependencyProperty.Register("InName", typeof(string), typeof(Print_IncomeBill), new UIPropertyMetadata(string.Empty));


        /// <summary>
        /// 收款人账号
        /// </summary>
        public string InNum
        {
            get { return (string)GetValue(InNumProperty); }
            set { SetValue(InNumProperty, value); }
        }

        // Using a DependencyProperty as the backing store for InNum.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty InNumProperty =
            DependencyProperty.Register("InNum", typeof(string), typeof(Print_IncomeBill), new UIPropertyMetadata(string.Empty));


        /// <summary>
        /// 收款人开户行
        /// </summary>
        public string InOpenBank
        {
            get { return (string)GetValue(InOpenBankProperty); }
            set { SetValue(InOpenBankProperty, value); }
        }

        // Using a DependencyProperty as the backing store for InOpenBank.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty InOpenBankProperty =
            DependencyProperty.Register("InOpenBank", typeof(string), typeof(Print_IncomeBill), new UIPropertyMetadata(string.Empty));


        /// <summary>
        /// 大写金额
        /// </summary>
        public string AtmMax
        {
            get { return (string)GetValue(AtmMaxProperty); }
            set { SetValue(AtmMaxProperty, value); }
        }

        // Using a DependencyProperty as the backing store for AtmMax.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty AtmMaxProperty =
            DependencyProperty.Register("AtmMax", typeof(string), typeof(Print_IncomeBill), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 金额小写
        /// </summary>
        public string AtmMin
        {
            get { return (string)GetValue(AtmMinProperty); }
            set
            {
                SetValue(AtmMinProperty, value);
                Extension.PrintContainerExt.SetCanvas(Currency, value);
            }
        }
        public static readonly DependencyProperty AtmMinProperty =
            DependencyProperty.Register("AtmMinMin", typeof(string), typeof(Print_IncomeBill), new UIPropertyMetadata(string.Empty));


        /// <summary>
        /// 票据种类
        /// </summary>
        public string TicketType
        {
            get { return (string)GetValue(TicketTypeProperty); }
            set { SetValue(TicketTypeProperty, value); }
        }

        // Using a DependencyProperty as the backing store for TicketType.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty TicketTypeProperty =
            DependencyProperty.Register("TicketType", typeof(string), typeof(Print_IncomeBill), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 票号
        /// </summary>
        public string TicketId
        {
            get { return (string)GetValue(TicketIdProperty); }
            set { SetValue(TicketIdProperty, value); }
        }

        // Using a DependencyProperty as the backing store for TicketId.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty TicketIdProperty =
            DependencyProperty.Register("TicketId", typeof(string), typeof(Print_IncomeBill), new UIPropertyMetadata(string.Empty));


        /// <summary>
        /// 票据张数
        /// </summary>
        public string TicketNum
        {
            get { return (string)GetValue(TicketNumProperty); }
            set { SetValue(TicketNumProperty, value); }
        }

        // Using a DependencyProperty as the backing store for TicketNum.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty TicketNumProperty =
            DependencyProperty.Register("TicketNum", typeof(string), typeof(Print_IncomeBill), new UIPropertyMetadata(string.Empty));


        /// <summary>
        /// 备注
        /// </summary>
        public string Filler
        {
            get { return (string)GetValue(FillerProperty); }
            set { SetValue(FillerProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Filler.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty FillerProperty =
            DependencyProperty.Register("Filler", typeof(string), typeof(Print_IncomeBill), new UIPropertyMetadata(string.Empty));


        /// <summary>
        /// 转账日期
        /// </summary>
        public DateTime TransferDateInfo
        {
            get { return (DateTime)GetValue(TransferDateInfoProperty); }
            set { SetValue(TransferDateInfoProperty, value); }
        }

        // Using a DependencyProperty as the backing store for TransferDateInfo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty TransferDateInfoProperty =
            DependencyProperty.Register("TransferDateInfo", typeof(DateTime), typeof(Print_IncomeBill), new UIPropertyMetadata(string.Empty));


        /// <summary>
        /// 银行确认
        /// </summary>
        public string BankEnsure
        {
            get { return (string)GetValue(BankEnsureProperty); }
            set { SetValue(BankEnsureProperty, value); }
        }

        // Using a DependencyProperty as the backing store for BankEnsure.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty BankEnsureProperty =
            DependencyProperty.Register("BankEnsure", typeof(string), typeof(Print_IncomeBill), new UIPropertyMetadata(string.Empty));



        /// <summary>
        /// 复核
        /// </summary>
        public string Review
        {
            get { return (string)GetValue(ReviewProperty); }
            set { SetValue(ReviewProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Review.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ReviewProperty =
            DependencyProperty.Register("Review", typeof(string), typeof(Print_IncomeBill), new UIPropertyMetadata(string.Empty));



        /// <summary>
        /// 记账
        /// </summary>
        public string Charge
        {
            get { return (string)GetValue(ChargeProperty); }
            set { SetValue(ChargeProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Charge.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ChargeProperty =
            DependencyProperty.Register("Charge", typeof(string), typeof(Print_IncomeBill), new UIPropertyMetadata(string.Empty));

                                
    }
}
