﻿using System;
using System.Globalization;
using System.Linq;
using System.Windows;
using Platform.Common.RunningParameters;

namespace TellerSystem.PrintTemplate.Common
{
    /// <summary>
    /// 借记业务凭证
    /// </summary>
    public partial class Print_LendBusiness
    {
        public Print_LendBusiness()
        {
            InitializeComponent();
        }

        #region 自定义属性

        public static readonly DependencyProperty DateInfoProperty =
            DependencyProperty.Register("DateInfo", typeof(DateTime), typeof(Print_LendBusiness),
                                        new UIPropertyMetadata(DateTime.ParseExact(LoginUserInfo.TradeDate, "yyyyMMdd",
                                                                                   CultureInfo.CurrentCulture)));

        public static readonly DependencyProperty PaymentNameProperty =
            DependencyProperty.Register("PaymentName", typeof(string), typeof(Print_LendBusiness),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty PaymentActnoProperty =
            DependencyProperty.Register("PaymentActno", typeof(string), typeof(Print_LendBusiness),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty PaymentBankNoProperty =
            DependencyProperty.Register("PaymentBankNo", typeof(string), typeof(Print_LendBusiness),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty PayNameProperty =
            DependencyProperty.Register("PayName", typeof(string), typeof(Print_LendBusiness),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Payee_ActnoProperty =
            DependencyProperty.Register("Payee_Actno", typeof(string), typeof(Print_LendBusiness),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Payee_BankNoProperty =
            DependencyProperty.Register("Payee_BankNo", typeof(string), typeof(Print_LendBusiness),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty PayeeBankNameProperty =
            DependencyProperty.Register("PayeeBankName", typeof(string), typeof(Print_LendBusiness),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty PaymentBankNameProperty =
            DependencyProperty.Register("PaymentBankName", typeof(string), typeof(Print_LendBusiness),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Settlement_AmtMaxProperty =
            DependencyProperty.Register("Settlement_AmtMax", typeof(string), typeof(Print_LendBusiness),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Settlement_AmtMinProperty =
            DependencyProperty.Register("Settlement_AmtMin", typeof(string), typeof(Print_LendBusiness),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty SummaryProperty =
            DependencyProperty.Register("Summary", typeof(string), typeof(Print_LendBusiness),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty BankConfirmProperty =
            DependencyProperty.Register("BankConfirm", typeof(string), typeof(Print_LendBusiness),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty StampProperty =
            DependencyProperty.Register("Stamp", typeof(string), typeof(Print_LendBusiness),
                                        new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 日期
        /// </summary>
        public DateTime DateInfo
        {
            get { return (DateTime)GetValue(DateInfoProperty); }
            set { SetValue(DateInfoProperty, value); }
        }

        /// <summary>
        /// 付款人
        /// </summary>
        public string PaymentName
        {
            get { return (string)GetValue(PaymentNameProperty); }
            set { SetValue(PaymentNameProperty, value); }
        }

        /// <summary>
        /// 付款人账号
        /// </summary>
        public string PaymentActno
        {
            get { return (string)GetValue(PaymentActnoProperty); }
            set { SetValue(PaymentActnoProperty, value); }
        }

        /// <summary>
        /// 付款人行号
        /// </summary>
        public string PaymentBankNo
        {
            get { return (string)GetValue(PaymentBankNoProperty); }
            set { SetValue(PaymentBankNoProperty, value); }
        }

        /// <summary>
        /// 收款人
        /// </summary>
        public string PayeeName
        {
            get { return (string)GetValue(PayNameProperty); }
            set { SetValue(PayNameProperty, value); }
        }

        /// <summary>
        /// 收款人账号
        /// </summary>
        public string Payee_Actno
        {
            get { return (string)GetValue(Payee_ActnoProperty); }
            set { SetValue(Payee_ActnoProperty, value); }
        }

        /// <summary>
        /// 收款人行号
        /// </summary>
        public string Payee_BankNo
        {
            get { return (string)GetValue(Payee_BankNoProperty); }
            set { SetValue(Payee_BankNoProperty, value); }
        }

        /// <summary>
        /// 收款银行名称
        /// </summary>
        public string PayeeBankName
        {
            get { return (string)GetValue(PayeeBankNameProperty); }
            set { SetValue(PayeeBankNameProperty, value); }
        }

        /// <summary>
        /// 付款银行名称
        /// </summary>
        public string PaymentBankName
        {
            get { return (string)GetValue(PaymentBankNameProperty); }
            set { SetValue(PaymentBankNameProperty, value); }
        }

        /// <summary>
        /// 结算金额大写
        /// </summary>
        public string Settlement_AmtMax
        {
            get { return (string)GetValue(Settlement_AmtMaxProperty); }
            set { SetValue(Settlement_AmtMaxProperty, value); }
        }

        /// <summary>
        /// 结算金额小写
        /// </summary>
        public string Settlement_AmtMin
        {
            get { return (string)GetValue(Settlement_AmtMinProperty); }
            set
            {
                SetValue(Settlement_AmtMinProperty, value);
                
            }
        }

        /// <summary>
        /// 摘要
        /// </summary>
        public string Summary
        {
            get { return (string)GetValue(SummaryProperty); }
            set { SetValue(SummaryProperty, value); }
        }

        /// <summary>
        /// 银行确认
        /// </summary>
        public string BankConfirm
        {
            get { return (string)GetValue(BankConfirmProperty); }
            set { SetValue(BankConfirmProperty, value); }
        }

        /// <summary>
        /// 盖章
        /// </summary>
        public string Stamp
        {
            get { return (string)GetValue(StampProperty); }
            set { SetValue(StampProperty, value); }
        }

        /// <summary>
        /// 设置金额显示方式
        /// </summary>
        /// <param name="str"></param>
        /// <returns></returns>
        public void SetsumdisplayMode(string str)
        {
            textBlock9.Text = PrintTemplate.Extension.PrintContainerExt.PrintCurString(str);
        }

        #endregion 自定义属性
    }
}