﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Platform.Common.RunningParameters;

namespace TellerSystem.PrintTemplate.Common
{
    /// <summary>
    /// 同城资金清算贷方补充报单
    /// </summary>
    public partial class Print_LenderForm 
    {
        public Print_LenderForm()
        {
            InitializeComponent();
            PrintTime.Text = DateTime.Now.ToString("yyyyMMdd");
        }
        #region 自定义属性
        /// <summary>
        /// 日期
        /// </summary>
        public DateTime DateInfo
        {
            get { return (DateTime)GetValue(DateInfoProperty); }
            set { SetValue(DateInfoProperty, value); }
        }
        public static readonly DependencyProperty DateInfoProperty =
           DependencyProperty.Register("DateInfo", typeof(DateTime), typeof(Print_LenderForm), new UIPropertyMetadata(DateTime.ParseExact(LoginUserInfo.TradeDate, "yyyyMMdd", System.Globalization.CultureInfo.CurrentCulture)));

                #region 柜员
        /// <summary>
        /// 柜员号
        /// </summary>
        public string TellerNo
        {
            get { return (string)GetValue(TellerNoProperty); }
            set { SetValue(TellerNoProperty, value); }
        }

        public static readonly DependencyProperty TellerNoProperty =
            DependencyProperty.Register("TellerNo", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(LoginUserInfo.TellerNo));
        /// <summary>
        /// 业务种类
        /// </summary>
        public string BusinessType
        {
            get { return (string)GetValue(BusinessTypeProperty); }
            set { SetValue(BusinessTypeProperty, value); }
        }
        public static readonly DependencyProperty BusinessTypeProperty =
            DependencyProperty.Register("BusinessType", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(string.Empty));
          /// <summary>
        /// 流水号
        /// </summary>
        public string Serialnumber
        {
            get { return (string)GetValue(SerialnumberProperty); }
            set { SetValue(SerialnumberProperty, value); }
        }
        public static readonly DependencyProperty SerialnumberProperty =
            DependencyProperty.Register("Serialnumber", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 提出行代号
        /// </summary>
        public string OutBankCode
        {
            get { return (string)GetValue(OutBankCodeProperty); }
            set { SetValue(OutBankCodeProperty, value); }
        }
        public static readonly DependencyProperty OutBankCodeProperty =
            DependencyProperty.Register("OutBankCode", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 提出行名称
        /// </summary>
        public string OutBankName
        {
            get { return (string)GetValue(OutBankNameProperty); }
            set { SetValue(OutBankNameProperty, value); }
        }
        public static readonly DependencyProperty OutBankNameProperty =
            DependencyProperty.Register("OutBankName", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 提入行代号
        /// </summary>
        public string PutBankCode
        {
            get { return (string)GetValue(PutBankCodeProperty); }
            set { SetValue(PutBankCodeProperty, value); }
        }
        public static readonly DependencyProperty PutBankCodeProperty =
            DependencyProperty.Register("PutBankCode", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(string.Empty));
        ///<summary>
        /// 凭证号
        /// </summary>
        public string Certificatenumber
        {
            get { return (string)GetValue(CertificatenumberProperty); }
            set { SetValue(CertificatenumberProperty, value); }
        }
        public static readonly DependencyProperty CertificatenumberProperty =
            DependencyProperty.Register("Certificatenumber", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(string.Empty));
        ///<summary>
        /// 凭证日期
        /// </summary>
        public string Certificatedate
        {
            get { return (string)GetValue(CertificatedateProperty); }
            set { SetValue(CertificatedateProperty, value); }
        }
        public static readonly DependencyProperty CertificatedateProperty =
            DependencyProperty.Register("Certificatedate", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(string.Empty));


        /// <summary>
        /// 付款人
        /// </summary>
        public string PaymentName
        {
            get { return (string)GetValue(PaymentNameProperty); }
            set { SetValue(PaymentNameProperty, value); }
        }
        public static readonly DependencyProperty PaymentNameProperty =
            DependencyProperty.Register("PaymentName", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 付款人账号
        /// </summary>
        public string PaymentActno
        {
            get { return (string)GetValue(PaymentActnoProperty); }
            set { SetValue(PaymentActnoProperty, value); }
        }
        public static readonly DependencyProperty PaymentActnoProperty =
           DependencyProperty.Register("PaymentActno", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 收款人
        /// </summary>
        public string PayeeName
        {
            get { return (string)GetValue(PayNameProperty); }
            set { SetValue(PayNameProperty, value); }
        }
        public static readonly DependencyProperty PayNameProperty =
            DependencyProperty.Register("PayName", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 收款人账号
        /// </summary>
        public string Payee_Actno
        {
            get { return (string)GetValue(Payee_ActnoProperty); }
            set { SetValue(Payee_ActnoProperty, value); }
        }
        public static readonly DependencyProperty Payee_ActnoProperty =
           DependencyProperty.Register("Payee_Actno", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 结算金额大写
        /// </summary>
        public string Settlement_AmtMax
        {
            get { return (string)GetValue(Settlement_AmtMaxProperty); }
            set { SetValue(Settlement_AmtMaxProperty, value); }
        }
        public static readonly DependencyProperty Settlement_AmtMaxProperty =
            DependencyProperty.Register("Settlement_AmtMax", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 结算金额小写
        /// </summary>
        public string Settlement_AmtMin
        {

            get { return (string)GetValue(Settlement_AmtMinProperty); }
            set { SetValue(Settlement_AmtMinProperty, value); }
        }
        public static readonly DependencyProperty Settlement_AmtMinProperty =
            DependencyProperty.Register("Settlement_AmtMin", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 事由
        /// </summary>
        public string Subjectmatter
        {
            get { return (string)GetValue(SubjectmatterProperty); }
            set { SetValue(SubjectmatterProperty, value); }
        }
        public static readonly DependencyProperty SubjectmatterProperty =
           DependencyProperty.Register("Subjectmatter", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 备注
        /// </summary>
        public string Remark
        {
            get { return (string)GetValue(RemarkProperty); }
            set { SetValue(RemarkProperty, value); }
        }
        public static readonly DependencyProperty RemarkProperty =
           DependencyProperty.Register("Remark", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 科目
        /// </summary>
        public string Subject
        {
            get { return (string)GetValue(SubjectProperty); }
            set { SetValue(SubjectProperty, value); }
        }
        public static readonly DependencyProperty SubjectProperty =
           DependencyProperty.Register("Subject", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(string.Empty));
         /// <summary>
        /// 对方科目
        /// </summary>
        public string Othersidesubject
        {
            get { return (string)GetValue(OthersidesubjectProperty); }
            set { SetValue(OthersidesubjectProperty, value); }
        }
        public static readonly DependencyProperty OthersidesubjectProperty =
           DependencyProperty.Register("Othersidesubject", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 场次
        /// </summary>
        public string Screenings
        {
            get { return (string)GetValue(ScreeningsProperty); }
            set { SetValue(ScreeningsProperty, value); }
        }
        public static readonly DependencyProperty ScreeningsProperty =
           DependencyProperty.Register("Screenings", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 打印时间
        /// </summary>
        public string PrintDate
        {
            get { return (string)GetValue(PrintDateProperty); }
            set { SetValue(PrintDateProperty, value); }
        }
        public static readonly DependencyProperty PrintDateProperty =
           DependencyProperty.Register("PrintDate", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(DateTime.Now.ToString()));
        /// <summary>
        /// 复核
        /// </summary>
        public string Review
        {
            get { return (string)GetValue(ReviewProperty); }
            set { SetValue(ReviewProperty, value); }
        }
        public static readonly DependencyProperty ReviewProperty =
            DependencyProperty.Register("Review", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 记账
        /// </summary>
        public string Handling
        {
            get { return (string)GetValue(HandlingProperty); }
            set { SetValue(HandlingProperty, value); }
        }
        public static readonly DependencyProperty HandlingProperty =
            DependencyProperty.Register("Handling", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 借贷方向
        /// </summary>
        public string Way
        {
            get { return (string)GetValue(WayProperty); }
            set { SetValue(WayProperty, value); }
        }
        public static readonly DependencyProperty WayProperty =
            DependencyProperty.Register("Way", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata(string.Empty));


        /// <summary>
        /// 打印次数
        /// </summary>
        public string Printnumber
        {
            get { return (string)GetValue(PrintnumberProperty); }
            set { SetValue(PrintnumberProperty, value); }
        }
        public static readonly DependencyProperty PrintnumberProperty =
            DependencyProperty.Register("Printnumber", typeof(string), typeof(Print_LenderForm), new UIPropertyMetadata("1"));
        /// <summary>
        /// 业务流水
        /// </summary>
        public string HostSerialNumber
        {
            get { return (string)GetValue(HostSerialNumberProperty); }
            set { SetValue(HostSerialNumberProperty, value); }
        }
        public static readonly DependencyProperty HostSerialNumberProperty =
         DependencyProperty.Register("HostSerialNumber", typeof(string), typeof(Print_LenderForm),
         new UIPropertyMetadata(string.Empty));
        #endregion
    }
}
#endregion