﻿using System;
using System.Globalization;
using System.Linq;
using System.Windows;
using Platform.Common.RunningParameters;

namespace TellerSystem.PrintTemplate.Common
{
    /// <summary>
    /// 581廉政专户交款证实书
    /// </summary>
    public partial class Print_PaymentBook
    {
        public Print_PaymentBook()
        {
            InitializeComponent();
        }

        #region 自定义属性

        public static readonly DependencyProperty DateInfoProperty =
            DependencyProperty.Register("DateInfo", typeof(DateTime), typeof(Print_PaymentBook),
                                        new UIPropertyMetadata(DateTime.ParseExact(LoginUserInfo.TradeDate, "yyyyMMdd",
                                                                                   CultureInfo.CurrentCulture)));

        public static readonly DependencyProperty AccountNameProperty =
            DependencyProperty.Register("AccountName", typeof(string), typeof(Print_PaymentBook),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty SaveNameAccountProperty =
            DependencyProperty.Register("SaveNameaccount", typeof(string), typeof(Print_PaymentBook),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty AccountingaccountProperty =
            DependencyProperty.Register("Accountingaccount", typeof(string), typeof(Print_PaymentBook),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Settlement_AmtMaxProperty =
            DependencyProperty.Register("Settlement_AmtMax", typeof(string), typeof(Print_PaymentBook),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Settlement_AmtMinProperty =
            DependencyProperty.Register("Settlement_AmtMin", typeof(string), typeof(Print_PaymentBook),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty SignatureProperty =
            DependencyProperty.Register("Signature", typeof(string), typeof(Print_PaymentBook),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty AccountingProperty =
            DependencyProperty.Register("Accounting", typeof(string), typeof(Print_PaymentBook),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty ReviewProperty =
            DependencyProperty.Register("Review", typeof(string), typeof(Print_PaymentBook),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty HandlingProperty =
            DependencyProperty.Register("Handling", typeof(string), typeof(Print_PaymentBook),
                                        new UIPropertyMetadata(LoginUserInfo.TellerNo));

        /// <summary>
        /// 日期
        /// </summary>
        public DateTime DateInfo
        {
            get { return (DateTime)GetValue(DateInfoProperty); }
            set { SetValue(DateInfoProperty, value); }
        }

        /// <summary>
        /// 专户名称
        /// </summary>
        public string AccountName
        {
            get { return (string)GetValue(AccountNameProperty); }
            set { SetValue(AccountNameProperty, value); }
        }

        /// <summary>
        /// 储蓄账号
        /// </summary>
        public string SaveNameaccount
        {
            get { return (string)GetValue(SaveNameAccountProperty); }
            set { SetValue(SaveNameAccountProperty, value); }
        }

        /// <summary>
        /// 会记账号
        /// </summary>
        public string Accountingaccount
        {
            get { return (string)GetValue(AccountingaccountProperty); }
            set { SetValue(AccountingaccountProperty, value); }
        }

        /// <summary>
        /// 结算金额大写
        /// </summary>
        public string Settlement_AmtMax
        {
            get { return (string)GetValue(Settlement_AmtMaxProperty); }
            set { SetValue(Settlement_AmtMaxProperty, value); }
        }

        /// <summary>
        /// 结算金额小写
        /// </summary>
        public string Settlement_AmtMin
        {
            get { return (string)GetValue(Settlement_AmtMinProperty); }
            set
            {
                SetValue(Settlement_AmtMinProperty, value);
                
            }
        }

        /// <summary>
        /// 签章
        /// </summary>
        public string Signature
        {
            get { return (string)GetValue(SignatureProperty); }
            set { SetValue(SignatureProperty, value); }
        }

        /// <summary>
        ///会计
        /// </summary>
        public string Accounting
        {
            get { return (string)GetValue(AccountingProperty); }
            set { SetValue(AccountingProperty, value); }
        }

        /// <summary>
        /// 复核
        /// </summary>
        public string Review
        {
            get { return (string)GetValue(ReviewProperty); }
            set { SetValue(ReviewProperty, value); }
        }

        /// <summary>
        ///记账
        /// </summary>
        public string Handling
        {
            get { return (string)GetValue(HandlingProperty); }
            set { SetValue(HandlingProperty, value); }
        }

        /// <summary>
        /// 设置金额显示方式
        /// </summary>
        /// <param name="str"></param>
        /// <returns></returns>
        public void SetsumdisplayMode(string str)
        {
            textBlock29.Text = PrintTemplate.Extension.PrintContainerExt.PrintCurString(str);
        }

        #endregion 自定义属性
    }
}