﻿using System;
using System.Globalization;
using System.Linq;
using System.Windows;
using Platform.Common.RunningParameters;
using TellerSystem.PrintTemplate.Extension;

namespace TellerSystem.PrintTemplate.Common
{
    /// <summary>
    /// Print_Person.xaml 的交互逻辑
    /// </summary>
    public partial class Print_Person
    {
        public static readonly DependencyProperty PrintNumberProperty =
          DependencyProperty.Register("PrintNumber", typeof(string), typeof(Print_Person),
                                      new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty DateInfoProperty =
            DependencyProperty.Register("DateInfo", typeof(DateTime), typeof(Print_Person),
                                        new UIPropertyMetadata(DateTime.ParseExact(LoginUserInfo.TradeDate, "yyyyMMdd",
                                                                                   CultureInfo.CurrentCulture)));

        public static readonly DependencyProperty BelCatProperty =
            DependencyProperty.Register("BelCat", typeof(string), typeof(Print_Person),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty BelNoProperty =
            DependencyProperty.Register("BelNo", typeof(string), typeof(Print_Person),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty BasCatProperty =
            DependencyProperty.Register("BasCat", typeof(string), typeof(Print_Person),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty TradSumProperty =
            DependencyProperty.Register("TradSum", typeof(string), typeof(Print_Person),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty IncAccNameProperty =
            DependencyProperty.Register("IncAccName", typeof(string), typeof(Print_Person),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty PoundageProperty =
            DependencyProperty.Register("Poundage", typeof(string), typeof(Print_Person),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty IncAccNoProperty =
            DependencyProperty.Register("IncAccNo", typeof(string), typeof(Print_Person),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty CurNameProperty =
            DependencyProperty.Register("CurName", typeof(string), typeof(Print_Person),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty PayAccNameProperty =
            DependencyProperty.Register("PayAccName", typeof(string), typeof(Print_Person),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty PayAccNoProperty =
            DependencyProperty.Register("PayAccNo", typeof(string), typeof(Print_Person),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty CommentProperty =
            DependencyProperty.Register("Comment", typeof(string), typeof(Print_Person),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty InstNoProperty =
            DependencyProperty.Register("InstNo", typeof(string), typeof(Print_Person),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty TradNoProperty =
            DependencyProperty.Register("TradNo", typeof(string), typeof(Print_Person),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty AuthAgentProperty =
            DependencyProperty.Register("AuthAgent", typeof(string), typeof(Print_Person),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty AgentProperty =
            DependencyProperty.Register("Agent", typeof(string), typeof(Print_Person),
                                        new UIPropertyMetadata(string.Empty));
       
        
        
        //代码修改区间
        public static readonly DependencyProperty LiLvTBlockProperty =
           DependencyProperty.Register("TBlockLilv", typeof(string), typeof(Print_Person),
                                       new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty LiLvProperty =
          DependencyProperty.Register("Lilv", typeof(string), typeof(Print_Person),
                                      new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty TBlockCunQiProperty =
         DependencyProperty.Register("TBlockCunQi", typeof(string), typeof(Print_Person),
                                     new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty CunQiProperty =
        DependencyProperty.Register("CunQi", typeof(string), typeof(Print_Person),
                                   new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty TBlockYuEProperty =
        DependencyProperty.Register("TBlockYuE", typeof(string), typeof(Print_Person),
                                   new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty YuEProperty =
         DependencyProperty.Register("YuE", typeof(string), typeof(Print_Person),
                                  new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty TBlockJiaoYHProperty =
         DependencyProperty.Register("TBlockJiaoYH", typeof(string), typeof(Print_Person),
                                  new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty JiaoYHProperty =
         DependencyProperty.Register("JiaoYH", typeof(string), typeof(Print_Person),
                                  new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty TBlockPingZHProperty =
         DependencyProperty.Register("TBlockPingZH", typeof(string), typeof(Print_Person),
                                  new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty PingZHProperty =
         DependencyProperty.Register("PingZH", typeof(string), typeof(Print_Person),
                                  new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty TBlockKaiHHProperty =
        DependencyProperty.Register("TBlockKaiHH", typeof(string), typeof(Print_Person),
                                 new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty KaiHHProperty =
            DependencyProperty.Register("KaiHH", typeof(string), typeof(Print_Person),
                                 new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty TBlockChuZProperty =
      DependencyProperty.Register("TBlockChuZ", typeof(string), typeof(Print_Person),
                               new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty ChuZProperty =
            DependencyProperty.Register("ChuZ", typeof(string), typeof(Print_Person),
                                 new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty TBlockGongBFProperty =
          DependencyProperty.Register("TBlockGongBF", typeof(string), typeof(Print_Person),
                               new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty GongBFProperty =
          DependencyProperty.Register("GongBF", typeof(string), typeof(Print_Person),
                               new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty TBlockHostSerNumProperty =
          DependencyProperty.Register("TBlockHostSerNum", typeof(string), typeof(Print_Person),
                               new UIPropertyMetadata("主机流水"));
        
        public static readonly DependencyProperty HostSerialNumberProperty =
         DependencyProperty.Register("HostSerialNumber", typeof(string), typeof(Print_Person),
                              new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty T_ZDZCProperty =
          DependencyProperty.Register("T_ZDZC", typeof(string), typeof(Print_Person),
                               new UIPropertyMetadata("主机流水"));
        public static readonly DependencyProperty ZDZCProperty =
         DependencyProperty.Register("ZDZC", typeof(string), typeof(Print_Person),
                              new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty T_MYProperty =
          DependencyProperty.Register("T_MY", typeof(string), typeof(Print_Person),
                               new UIPropertyMetadata("主机流水"));
        public static readonly DependencyProperty MYProperty =
         DependencyProperty.Register("MY", typeof(string), typeof(Print_Person),
                              new UIPropertyMetadata(string.Empty));
        

        //*代码修改区间

        public Print_Person()
        {
            InitializeComponent();
            InstNo = LoginUserInfo.KinbrNo;
            Agent = LoginUserInfo.TellerNo;
            TBlockJiaoYH = "交易行";
            TBlockKaiHH = "开户行";
            JiaoYH = LoginUserInfo.KinbrName.Trim() + "(" + InstNo+")";
           
            
        }
        //秘印
        public String MY
        {
            get { return (string)GetValue(MYProperty); }
            set { SetValue(MYProperty, value); }
        }
        //自动转存
        public String ZDZC
        {
            get { return (string)GetValue(ZDZCProperty); }
            set { SetValue(ZDZCProperty, value); }
        }

        public String IncAccNo
        {
            get { return (string)GetValue(IncAccNoProperty); }
            set { SetValue(IncAccNoProperty, value); }
        }
        /// <summary>
        /// 日期
        /// </summary>
        public DateTime DateInfo
        {
            get { return (DateTime)GetValue(DateInfoProperty); }
            set { SetValue(DateInfoProperty, value); }
        }

        /// <summary>
        /// 账单类型
        /// </summary>
        public string BelCat
        {
            get { return (string)GetValue(BelCatProperty); }
            set { SetValue(BelCatProperty, value); }
        }
        /// <summary>
        /// 账单类型
        /// </summary>
        public string PrintNumber
        {
            get { return (string)GetValue(PrintNumberProperty); }
            set { SetValue(PrintNumberProperty, value); }
        }
        /// <summary>
        /// 账单号
        /// </summary>
        public string BelNo
        {
            get { return (string)GetValue(BelNoProperty); }
            set { SetValue(BelNoProperty, value); }
        }

        /// <summary>
        /// 业务种类
        /// </summary>
        public string BasCat
        {
            get { return (string)GetValue(BasCatProperty); }
            set { SetValue(BasCatProperty, value); }
        }

        /// <summary>
        /// 交易金额
        /// </summary>
        public string TradSum
        {
            get { return (string)GetValue(TradSumProperty); }
            set
            {
                //Extension.PrintContainerExt.SetCanvas(Currency, value);
                SetValue(TradSumProperty, SetsumdisplayJiaoY(value));
            }
        }

        /// <summary>
        /// 收款人户名
        /// </summary>
        public string IncAccName
        {
            get { return (string)GetValue(IncAccNameProperty); }
            set { SetValue(IncAccNameProperty, value); }
        }

        /// <summary>
        /// 手续费
        /// </summary>
        public string Poundage
        {
            get { return (string)GetValue(PoundageProperty); }
            set { SetValue(PoundageProperty, value); }
        }

        /// <summary>
        /// 收款人账号卡号
        /// </summary>
        public string IncPNo
        {
            get { return (string)GetValue(IncAccNoProperty); }
            set { SetValue(IncAccNoProperty, value); }
        }

        /// <summary>
        /// 币种
        /// </summary>
        public string CurName
        {
            get { return (string)GetValue(CurNameProperty); }
            set { SetValue(CurNameProperty, value); }
        }

        /// <summary>
        /// 付款人户名
        /// </summary>
        public string PayAccName
        {
            get { return (string)GetValue(PayAccNameProperty); }
            set { SetValue(PayAccNameProperty, value); }
        }

        /// <summary>
        /// 付款人卡号账号
        /// </summary>
        public string PayAccNo
        {
            get { return (string)GetValue(PayAccNoProperty); }
            set { SetValue(PayAccNoProperty, value); }
        }

        /// <summary>
        /// 备注
        /// </summary>
        public string Comment
        {
            get { return (string)GetValue(CommentProperty); }
            set { SetValue(CommentProperty, value); }
        }

        /// <summary>
        /// 机构号
        /// </summary>
        public string InstNo
        {
            get { return (string)GetValue(InstNoProperty); }
            set { SetValue(InstNoProperty, value); }
        }

        /// <summary>
        /// 交易代码
        /// </summary>
        public string TradNo
        {
            get { return (string)GetValue(TradNoProperty); }
            set { SetValue(TradNoProperty, value); }
        }

        /// <summary>
        /// 授权员
        /// </summary>
        public string AuthAgent
        {
            get { return (string)GetValue(AuthAgentProperty); }
            set { SetValue(AuthAgentProperty, value); }
        }

        /// <summary>
        /// 经办人
        /// </summary>
        public string Agent
        {
            get { return (string)GetValue(AgentProperty); }
            set { SetValue(AgentProperty, value); }
        }


        //代码修改区间
        /// <summary>
        /// 利率
        /// </summary>
        public string TBlockLilv
        {
            get { return (string)GetValue(LiLvTBlockProperty); }
            set { SetValue(LiLvTBlockProperty, value); }
            
        }

        public string Lilv
        {
            get { return (string)GetValue(LiLvProperty); }
            set { SetValue(LiLvProperty, value); }

        }

        /// <summary>
        /// 存期
        /// </summary>
        public string TBlockCunQi
        {
            get { return (string)GetValue(TBlockCunQiProperty); }
            set { SetValue(TBlockCunQiProperty, value); }
        }

        public string CunQi
        {
            get { return (string)GetValue(CunQiProperty); }
            set { SetValue(CunQiProperty, value); }
        }

        /// <summary>
        /// 余额
        /// </summary>
        public string TBlockYuE
        {
            get { return (string)GetValue(TBlockYuEProperty); }
            set { SetValue(TBlockYuEProperty, value); }
        }

        public string YuE
        { 
            get{return (string)GetValue(YuEProperty);}
            set { SetValue(YuEProperty, SetsumdisplayJiaoY(value)); }
        
        }
        /// <summary>
        /// 交易行
        /// </summary>
        public string TBlockJiaoYH
        {
            get { return (string)GetValue(TBlockJiaoYHProperty); }
            set { SetValue(TBlockJiaoYHProperty, value); }
        }

        public string JiaoYH
        {
            get { return (string)GetValue(JiaoYHProperty); }
            set { SetValue(JiaoYHProperty, value); }

        }

        /// <summary>
        /// 凭证
        /// </summary>
        public string TBlockPingZH
        {
            get { return (string)GetValue(TBlockPingZHProperty); }
            set { SetValue(TBlockPingZHProperty, value); }
        }

        public string PingZH
        {
            get { return (string)GetValue(PingZHProperty); }
            set { SetValue(PingZHProperty, value); }
        }
       
        public string TBlockKaiHH
        {
            get { return (string)GetValue(TBlockKaiHHProperty); }
            set { SetValue(TBlockKaiHHProperty, value); }
        }
        /// <summary>
        /// 开户行
        /// </summary>
        public string KaiHH
        {
            get { return (string)GetValue(KaiHHProperty); }
            set { SetValue(KaiHHProperty, value ); }
        }

        /// <summary>
        /// 开户行机构号
        /// </summary>
      public string KaiHNo
        {
            set;
            get;
        }


        /// <summary>
        /// 储种
        /// </summary>
        public string TBlockChuZ
        {
            get { return (string)GetValue(TBlockChuZProperty); }
            set { SetValue(TBlockChuZProperty, value); }
        }
        public string ChuZ
        {
            get { return (string)GetValue(ChuZProperty); }
            set { SetValue(ChuZProperty, value); }
        }
        /// <summary>
        /// 工本费
        /// </summary>
        public string TBlockGongBF
        {
            get { return (string)GetValue(TBlockGongBFProperty); }
            set { SetValue(TBlockGongBFProperty, value); }
        }

        public string GongBF
        {
            get { return (string)GetValue(GongBFProperty); }
            set { SetValue(GongBFProperty, value); }
        }
        /// <summary>
        /// 主机流水TextBlock
        /// </summary>
        public string TBlockHostSerNum
        {
            get { return (string)GetValue(TBlockHostSerNumProperty); }
            set { SetValue(TBlockHostSerNumProperty, value); }
        }
        /// <summary>
        /// 主机流水号值
        /// </summary>
        public string HostSerialNumber
        {
            get { return (string)GetValue(HostSerialNumberProperty); }
            set { SetValue(HostSerialNumberProperty, value); }
        }
        //*代码修改区间,

        /// <summary>
        /// 设置金额显示方式
        /// </summary>
        /// <param name="str"></param>
        /// <returns></returns>
        public void SetsumdisplayMode(string str)
        {
            //textBlock9.Text = PrintTemplate.Extension.PrintContainerExt.PrintCurString(str);
        }

         /// <summary>
        /// 设置开户行和机构号方法
        /// </summary>
        /// <param name="str"></param>
        /// <returns></returns>
       
        /// <summary>
        /// 设置交易金额显示方式
        /// </summary>
        /// <param name="str"></param>
        /// <returns></returns>
        public string SetsumdisplayJiaoY(string str)
        {
            string Newsum = ""; //新金额
            string Decimalpoint; //小数点

            if (str.Contains(".") == true)
            {
                
                Decimalpoint = str.Split('.')[1];
                if (Decimalpoint.Length > 2) Decimalpoint = Decimalpoint.Substring(0, 2);
                str = str.Split('.')[0];
                Newsum = str+"."+Decimalpoint;
                return Newsum;
            }

            return str;
        }
      



        /// <summary>
        /// 小数点后两位四舍五入该金额，因为输入的TextBox有相应的功能，所以此方法可以不予以调用
        /// </summary>
        /// <param name="str"></param>
        /// <param name="Decimalpoint"></param>
        /// <returns></returns>
        //private string RoundOff(string str,string Decimalpoint)
        //{
        //    double money = double.Parse(str);
        //    if (Decimalpoint.Length > 2 && Decimalpoint[2] >= 5 && Decimalpoint[2] <= 9)
        //    {
        //        money += 0.01;
        //    }
        //    str = money.ToString();
        //    return str;
        //}
    }
}