﻿using System;
using System.Globalization;
using System.Linq;
using System.Windows;
using Platform.Common.RunningParameters;

namespace TellerSystem.PrintTemplate.Common
{
    /// <summary>
    /// 现金支票
    /// </summary>
    public partial class Print_ProofCheck
    {
        public Print_ProofCheck()
        {
            InitializeComponent();
            TradeDate.Text = LoginUserInfo.TradeDate;
        }

        #region 自定义属性


        public static readonly DependencyProperty DateInfoProperty =
            DependencyProperty.Register("DateInfo", typeof(DateTime), typeof(Print_ProofCheck),
                                        new UIPropertyMetadata(DateTime.ParseExact(LoginUserInfo.TradeDate, "yyyyMMdd",
                                                                                   CultureInfo.CurrentCulture)));

        public static readonly DependencyProperty PayNameProperty =
            DependencyProperty.Register("PayName", typeof(string), typeof(Print_ProofCheck),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty PaymentBankNameProperty =
            DependencyProperty.Register("PaymentBankName", typeof(string), typeof(Print_ProofCheck),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty AccountProperty =
            DependencyProperty.Register("Account", typeof(string), typeof(Print_ProofCheck),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Settlement_AmtMaxProperty =
            DependencyProperty.Register("Settlement_AmtMax", typeof(string), typeof(Print_ProofCheck),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Settlement_AmtMinProperty =
            DependencyProperty.Register("Settlement_AmtMin", typeof(string), typeof(Print_ProofCheck),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty UseProperty =
            DependencyProperty.Register("Use", typeof(string), typeof(Print_ProofCheck),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty PasswordProperty =
            DependencyProperty.Register("Password", typeof(string), typeof(Print_ProofCheck),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty FundsProperty =
            DependencyProperty.Register("Funds", typeof(string), typeof(Print_ProofCheck),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty PaymentProperty =
            DependencyProperty.Register("Payment", typeof(string), typeof(Print_ProofCheck),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty SignatureProperty =
            DependencyProperty.Register("Signature", typeof(string), typeof(Print_ProofCheck),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty ReviewProperty =
            DependencyProperty.Register("Review", typeof(string), typeof(Print_ProofCheck),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty HandlingProperty =
            DependencyProperty.Register("Handling", typeof(string), typeof(Print_ProofCheck),
                                        new UIPropertyMetadata(LoginUserInfo.TellerNo));
        public string HostSerialNumber
        {
            get { return (string)GetValue(HostSerialNumberProperty); }
            set { SetValue(HostSerialNumberProperty, value); }
        }
        public static readonly DependencyProperty HostSerialNumberProperty =
         DependencyProperty.Register("HostSerialNumber", typeof(string), typeof(Print_ProofCheck),
         new UIPropertyMetadata(string.Empty));
        public string T_YT
        {
            get { return (string)GetValue(T_YTProperty); }
            set { SetValue(T_YTProperty, value); }
        }

        public static readonly DependencyProperty T_YTProperty =
            DependencyProperty.Register("T_YT", typeof(string),
            typeof(Print_ProofCheck), new UIPropertyMetadata("用途:"));


        public string T_JE
        {
            get { return (string)GetValue(T_JEProperty); }
            set { SetValue(T_JEProperty, value); }
        }
        public static readonly DependencyProperty T_JEProperty =
            DependencyProperty.Register("T_JE", typeof(string),
            typeof(Print_ProofCheck), new UIPropertyMetadata("金额:"));

        public string T_JYMC
        {
            get { return (string)GetValue(T_JYMCProperty); }
            set { SetValue(T_JYMCProperty, value); }
        }

        public static readonly DependencyProperty T_JYMCProperty =
            DependencyProperty.Register("T_JYMC", typeof(string),
            typeof(Print_ProofCheck), new UIPropertyMetadata("交易名称:"));
        /// <summary>
        /// 金额
        /// </summary>
        public string Currency
        {
            get { return (string)GetValue(CurrencyProperty); }
            set { SetValue(CurrencyProperty, value); }
        }
        public static readonly DependencyProperty CurrencyProperty =
            DependencyProperty.Register("Currency", typeof(string), typeof(Print_ProofCheck),
                                        new UIPropertyMetadata(string.Empty));

        #region 对方账号
        public string PTranOutActNo
        {
            get { return (string)GetValue(PTranOutActNoProperty); }
            set { SetValue(PTranOutActNoProperty, value); }
        }

        public static readonly DependencyProperty PTranOutActNoProperty =
            DependencyProperty.Register("PTranOutActNo", typeof(string), typeof(Print_ProofCheck), new UIPropertyMetadata(string.Empty));



        public string PTranOutActNoStr
        {
            get { return (string)GetValue(PTranOutActNoStrProperty); }
            set { SetValue(PTranOutActNoStrProperty, value); }
        }

        public static readonly DependencyProperty PTranOutActNoStrProperty =
            DependencyProperty.Register("PTranOutActNoStr", typeof(string), typeof(Print_ProofCheck), new UIPropertyMetadata("对方账号:"));
        #endregion

        #region 对方账户
        public string TranOutActName
        {
            get { return (string)GetValue(TranOutActNameProperty); }
            set { SetValue(TranOutActNameProperty, value); }
        }

        public static readonly DependencyProperty TranOutActNameProperty =
            DependencyProperty.Register("TranOutActName", typeof(string), typeof(Print_ProofCheck), new UIPropertyMetadata(string.Empty));



        public string TranOutActNameStr
        {
            get { return (string)GetValue(TranOutActNameStrProperty); }
            set { SetValue(TranOutActNameStrProperty, value); }
        }

        public static readonly DependencyProperty TranOutActNameStrProperty =
            DependencyProperty.Register("TranOutActNameStr", typeof(string), typeof(Print_ProofCheck), new UIPropertyMetadata("对方户名:"));
        #endregion

        #region 柜员
        /// <summary>
        /// 柜员号
        /// </summary>
        public string TellerNo
        {
            get { return (string)GetValue(TellerNoProperty); }
            set { SetValue(TellerNoProperty, value); }
        }

        public static readonly DependencyProperty TellerNoProperty =
            DependencyProperty.Register("TellerNo", typeof(string), typeof(Print_ProofCheck), new UIPropertyMetadata(string.Empty));

        public string TellerNoStr
        {
            get { return (string)GetValue(TellerNoStrProperty); }
            set { SetValue(TellerNoStrProperty, value); }
        }

        public static readonly DependencyProperty TellerNoStrProperty =
            DependencyProperty.Register("TellerNoStr", typeof(string), typeof(Print_ProofCheck), new UIPropertyMetadata("操作员号:"));
        #endregion

        #region 凭证号
        public string Pzh
        {
            get
            {
                return (string)GetValue(PzhProperty);
            }
            set
            {
                SetValue(PzhProperty,value);
            }
        }

        public static readonly DependencyProperty PzhProperty =
            DependencyProperty.Register("Pzh",typeof(string),typeof(Print_ProofCheck),new UIPropertyMetadata(string.Empty));

        public string PzhStr
        {
            get
            {
                return (string)GetValue(PzhStrProperty);
            }
            set
            {
                SetValue(PzhStrProperty,value);
            }
        }

        public static readonly DependencyProperty PzhStrProperty =
            DependencyProperty.Register("PzhStr",typeof(string),typeof(Print_ProofCheck),new UIPropertyMetadata("凭证号:"));
        #endregion 凭证号


        #region 流水
        public string SerialNumberStr
        {
            get { return (string)GetValue(SerialNumberStrProperty); }
            set { SetValue(SerialNumberStrProperty, value); }
        }

        public static readonly DependencyProperty SerialNumberStrProperty =
            DependencyProperty.Register("SerialNumberStr", typeof(string), typeof(Print_ProofCheck), new UIPropertyMetadata("流水号:"));
        #endregion

        #region 时间
        public string DataTime
        {
            get { return (string)GetValue(DataTimeProperty); }
            set { SetValue(DataTimeProperty, value); }
        }

        public static readonly DependencyProperty DataTimeProperty =
            DependencyProperty.Register("DataTime", typeof(string), typeof(Print_ProofCheck), new UIPropertyMetadata(DateTime.Now.Hour + ":" + DateTime.Now.Minute + ":" + DateTime.Now.Second));

        public string DataTimeStr
        {
            get { return (string)GetValue(DataTimeStrProperty); }
            set { SetValue(DataTimeStrProperty, value); }
        }

        public static readonly DependencyProperty DataTimeStrProperty =
           DependencyProperty.Register("DataTimeStr", typeof(string), typeof(Print_ProofCheck), new UIPropertyMetadata("交易时间:"));
        #endregion

        /// <summary>
        /// 日期
        /// </summary>
        public String DateInfo
        {
            set { TradeDate.Text = value; }
        }

        /// <summary>
        /// 收款人
        /// </summary>
        public string PayName
        {
            get { return (string)GetValue(PayNameProperty); }
            set { SetValue(PayNameProperty, value); }
        }

        /// <summary>
        /// 付款银行名称
        /// </summary>
        public string PaymentBankName
        {
            get { return (string)GetValue(PaymentBankNameProperty); }
            set { SetValue(PaymentBankNameProperty, value); }
        }

        /// <summary>
        /// 账号
        /// </summary>
        public string Account
        {
            get { return (string)GetValue(AccountProperty); }
            set { SetValue(AccountProperty, value); }
        }

        /// <summary>
        /// 结算金额大写
        /// </summary>
        public string Settlement_AmtMax
        {
            get { return (string)GetValue(Settlement_AmtMaxProperty); }
            set { SetValue(Settlement_AmtMaxProperty, value); }
        }

        /// <summary>
        /// 结算金额小写
        /// </summary>
        public string Settlement_AmtMin
        {
            get { return (string)GetValue(Settlement_AmtMinProperty); }
            set
            {
                SetValue(Settlement_AmtMinProperty, value);
                //Extension.PrintContainerExt.SetCanvas(stackPanel1, value);
            }
        }

        /// <summary>
        /// 用途
        /// </summary>
        public string Use
        {
            get { return (string)GetValue(UseProperty); }
            set { SetValue(UseProperty, value); }
        }

        /// <summary>
        /// 密码
        /// </summary>
        public string Password
        {
            get { return (string)GetValue(PasswordProperty); }
            set { SetValue(PasswordProperty, value); }
        }

        /// <summary>
        /// 款项
        /// </summary>
        public string Funds
        {
            get { return (string)GetValue(FundsProperty); }
            set { SetValue(FundsProperty, value); }
        }

        /// <summary>
        /// 支付
        /// </summary>
        public string Payment
        {
            get { return (string)GetValue(PaymentProperty); }
            set { SetValue(PaymentProperty, value); }
        }

        /// <summary>
        /// 签章
        /// </summary>
        public string Signature
        {
            get { return (string)GetValue(SignatureProperty); }
            set { SetValue(SignatureProperty, value); }
        }

        /// <summary>
        /// 复核
        /// </summary>
        public string Review
        {
            get { return (string)GetValue(ReviewProperty); }
            set { SetValue(ReviewProperty, value); }
        }

        /// <summary>
        /// 记账
        /// </summary>
        public string Handling
        {
            get { return (string)GetValue(HandlingProperty); }
            set { SetValue(HandlingProperty, value); }
        }

        public string T_FKZH
        {
            get { return (string)GetValue(T_FKZHProperty); }
            set { SetValue(T_FKZHProperty, value); }
        }

        public static readonly DependencyProperty T_FKZHProperty =
            DependencyProperty.Register("T_FKZH", typeof(string),
            typeof(Print_ProofCheck), new UIPropertyMetadata("付款账号:"));

        public string T_HM
        {
            get { return (string)GetValue(T_HMProperty); }
            set { SetValue(T_HMProperty, value); }
        }

        public static readonly DependencyProperty T_HMProperty =
            DependencyProperty.Register("T_HM", typeof(string),
            typeof(Print_ProofCheck), new UIPropertyMetadata("户名:"));


        /// <summary>
        /// 设置金额显示方式
        /// </summary>
        /// <param name="str"></param>
        /// <returns></returns>
        public void SetsumdisplayMode(string str)
        {
            //textBlock9.Text = PrintTemplate.Extension.PrintContainerExt.PrintCurString(str);
            //return Newsum;
        }


        #endregion 自定义属性
    }
}