﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Platform.Common.RunningParameters;

namespace TellerSystem.PrintTemplate.Common
{
    /// <summary>
    /// 单位定期存单
    /// </summary>
    public partial class Print_Regularly
    {
        public Print_Regularly()
        {
            InitializeComponent();
        }
        #region 自定义属性
        /// <summary>
        /// 存入日期
        /// </summary>
        public DateTime DateInfo
        {
            get { return (DateTime)GetValue(DateInfoProperty); }
            set { SetValue(DateInfoProperty, value); }
        }
        public static readonly DependencyProperty DateInfoProperty =
           DependencyProperty.Register("DateInfo", typeof(DateTime), typeof(Print_Regularly), new UIPropertyMetadata(DateTime.ParseExact(LoginUserInfo.TradeDate, "yyyyMMdd", System.Globalization.CultureInfo.CurrentCulture)));
        /// <summary>
        /// 账号
        /// </summary>
        public string Account
        {
            get { return (string)GetValue(AccountProperty); }
            set { SetValue(AccountProperty, value); }
        }
        public static readonly DependencyProperty AccountProperty =
            DependencyProperty.Register("Account", typeof(string), typeof(Print_Regularly), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 户名
        /// </summary>
        public string Username
        {
            get { return (string)GetValue(UsernameProperty); }
            set { SetValue(UsernameProperty, value); }
        }
        public static readonly DependencyProperty UsernameProperty =
            DependencyProperty.Register("Username", typeof(string), typeof(Print_Regularly), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 存期
        /// </summary>
        public string Depositperiod
        {
            get { return (string)GetValue(DepositperiodProperty); }
            set { SetValue(DepositperiodProperty, value); }
        }
        public static readonly DependencyProperty DepositperiodProperty =
           DependencyProperty.Register("Depositperiod", typeof(string), typeof(Print_Regularly), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 利率
        /// </summary>
        public string Interestrate
        {
            get { return (string)GetValue(InterestrateProperty); }
            set { SetValue(InterestrateProperty, value); }
        }
        public static readonly DependencyProperty InterestrateProperty =
           DependencyProperty.Register("Interestrate", typeof(string), typeof(Print_Regularly), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 到期日
        /// </summary>
        public DateTime? Maturity
        {
            get { return (DateTime?)GetValue(MaturityProperty); }
            set { SetValue(MaturityProperty, value); }
        }
        public static readonly DependencyProperty MaturityProperty =
            DependencyProperty.Register("Maturity", typeof(DateTime?), typeof(Print_Regularly), new UIPropertyMetadata(null));
        /// <summary>
        /// 金额大写
        /// </summary>
        public string Settlement_AmtMax
        {
            get { return (string)GetValue(Settlement_AmtMaxProperty); }
            set { SetValue(Settlement_AmtMaxProperty, value); }
        }
        public static readonly DependencyProperty Settlement_AmtMaxProperty =
            DependencyProperty.Register("Settlement_AmtMax", typeof(string), typeof(Print_Regularly), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 金额小写
        /// </summary>
        public string Settlement_AmtMin
        {

            get { return (string)GetValue(Settlement_AmtMinProperty); }
            set
            {
                SetValue(Settlement_AmtMinProperty, value);
                Extension.PrintContainerExt.SetCanvas(Currency, value);
            }
        }
        public static readonly DependencyProperty Settlement_AmtMinProperty =
            DependencyProperty.Register("Settlement_AmtMin", typeof(string), typeof(Print_Regularly), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 设置金额显示方式
        /// </summary>
        /// <param name="str"></param>
        /// <returns></returns>
        /// <summary>
        /// 印签
        /// </summary>
        public string Indiasigned
        {
            get { return (string)GetValue(IndiasignedProperty); }
            set { SetValue(IndiasignedProperty, value); }
        }
        public static readonly DependencyProperty IndiasignedProperty =
           DependencyProperty.Register("Indiasigned", typeof(string), typeof(Print_Regularly), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 签章
        /// </summary>
        public string Signature
        {
            get { return (string)GetValue(SignatureProperty); }
            set { SetValue(SignatureProperty, value); }
        }
        public static readonly DependencyProperty SignatureProperty =
           DependencyProperty.Register("Signature", typeof(string), typeof(Print_Regularly), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 备注
        /// </summary>
        public string Remark
        {
            get { return (string)GetValue(RemarkProperty); }
            set { SetValue(RemarkProperty, value); }
        }
        public static readonly DependencyProperty RemarkProperty =
          DependencyProperty.Register("Remark", typeof(string), typeof(Print_Regularly), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 事后监督
        /// </summary>
        public string SupervisionAfterwards
        {
            get { return (string)GetValue(SupervisionAfterwardsProperty); }
            set { SetValue(SupervisionAfterwardsProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SupervisionAfterwards.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty SupervisionAfterwardsProperty =
            DependencyProperty.Register("SupervisionAfterwards", typeof(string), typeof(Print_Regularly), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 会计
        /// </summary>
        public string Accounting
        {
            get { return (string)GetValue(AccountingProperty); }
            set { SetValue(AccountingProperty, value); }
        }
        public static readonly DependencyProperty AccountingProperty =
            DependencyProperty.Register("Accounting", typeof(string), typeof(Print_Regularly), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 复核
        /// </summary>
        public string Review
        {
            get { return (string)GetValue(ReviewProperty); }
            set { SetValue(ReviewProperty, value); }
        }
        public static readonly DependencyProperty ReviewProperty =
            DependencyProperty.Register("Review", typeof(string), typeof(Print_Regularly), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 经办
        /// </summary>
        public string Handling
        {
            get { return (string)GetValue(HandlingProperty); }
            set { SetValue(HandlingProperty, value); }
        }
        public static readonly DependencyProperty HandlingProperty =
            DependencyProperty.Register("Handling", typeof(string), typeof(Print_Regularly), new UIPropertyMetadata(LoginUserInfo.TellerNo));

        /// <summary>
        /// 第几号
        /// </summary>
        public string Number
        {
            get { return (string)GetValue(NumberProperty); }
            set { SetValue(NumberProperty, value); }
        }
        public static readonly DependencyProperty NumberProperty =
            DependencyProperty.Register("Number", typeof(string), typeof(Print_Regularly), new UIPropertyMetadata(string.Empty));
        #endregion
    }
}
