﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Platform.Common.RunningParameters;

namespace TellerSystem.PrintTemplate.Common
{
    /// <summary>
    /// Print_SaveForm.xaml 的交互逻辑
    /// </summary>
    public partial class Print_SaveForm 
    {
        public Print_SaveForm()
        {
            InitializeComponent();
        }
        #region 自定义属性
        /// <summary>
        /// 机构号
        /// </summary>
        public string InstitutionalNo
        {
            get { return (string)GetValue(InstitutionalNoProperty); }
            set { SetValue(InstitutionalNoProperty, value); }
        }
        public static readonly DependencyProperty InstitutionalNoProperty =
            DependencyProperty.Register("InstitutionalNo", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 账号
        /// </summary>
        public string Account
        {
            get { return (string)GetValue(AccountProperty); }
            set { SetValue(AccountProperty, value); }
        }
        public static readonly DependencyProperty AccountProperty =
            DependencyProperty.Register("Account", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 开户日期
        /// </summary>
        public string AccountDate
        {
            get { return (string)GetValue(AccountDateProperty); }
            set { SetValue(AccountDateProperty, value); }
        }
        public static readonly DependencyProperty AccountDateProperty =
         DependencyProperty.Register("AccountDate", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 起息日期
        /// </summary>
        public string StartDateForInterest
        {
            get { return (string)GetValue(StartDateForInterestProperty); }
            set { SetValue(StartDateForInterestProperty, value); }
        }

        // Using a DependencyProperty as the backing store for StartDateForInterest.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty StartDateForInterestProperty =
            DependencyProperty.Register("StartDateForInterest", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 到期日
        /// </summary>
        public string Maturity
        {
            get { return (string)GetValue(MaturityProperty); }
            set { SetValue(MaturityProperty, value); }
        }
        public static readonly DependencyProperty MaturityProperty =
            DependencyProperty.Register("Maturity", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 存期
        /// </summary>
        public string Depositperiod
        {
            get { return (string)GetValue(DepositperiodProperty); }
            set { SetValue(DepositperiodProperty, value); }
        }
        public static readonly DependencyProperty DepositperiodProperty =
           DependencyProperty.Register("Depositperiod", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 利率
        /// </summary>
        public string InterestRate
        {
            get { return (string)GetValue(InterestRateProperty); }
            set { SetValue(InterestRateProperty, value); }
        }

        // Using a DependencyProperty as the backing store for InterestRate.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty InterestRateProperty =
            DependencyProperty.Register("InterestRate", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 流水号
        /// </summary>
        public string SerialNo
        {
            get { return (string)GetValue(SerialNoProperty); }
            set { SetValue(SerialNoProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SerialNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty SerialNoProperty =
            DependencyProperty.Register("SerialNo", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 户名
        /// </summary>
        public string AccountName
        {
            get { return (string)GetValue(AccountNameProperty); }
            set { SetValue(AccountNameProperty, value); }
        }
        public static readonly DependencyProperty AccountNameProperty =
          DependencyProperty.Register("AccountName", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 金额
        /// </summary>
        public string Sum
        {
            get { return (string)GetValue(SumProperty); }
            set { SetValue(SumProperty, value); }
        }
        public static readonly DependencyProperty SumProperty =
            DependencyProperty.Register("Sum", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 操作员
        /// </summary>
        public string TellerNo
        {
            get { return (string)GetValue(TellerNoProperty); }
            set { SetValue(TellerNoProperty, value); }
        }

        // Using a DependencyProperty as the backing store for TellerNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty TellerNoProperty =
            DependencyProperty.Register("TellerNo", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 结算金额大写
        /// </summary>
        public string Settlement_AmtMax
        {
            get { return (string)GetValue(Settlement_AmtMaxProperty); }
            set { SetValue(Settlement_AmtMaxProperty, value); }
        }
        public static readonly DependencyProperty Settlement_AmtMaxProperty =
            DependencyProperty.Register("Settlement_AmtMax", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 密/印
        /// </summary>
        public string PasswordOrSeal
        {
            get { return (string)GetValue(PasswordOrSealProperty); }
            set { SetValue(PasswordOrSealProperty, value); }
        }
        // Using a DependencyProperty as the backing store for PasswordOrSeal.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty PasswordOrSealProperty =
            DependencyProperty.Register("PasswordOrSeal", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        ///<summary>
        ///产品类型
        ///</summary>
        public string Productname
        {
            get { return (string)GetValue(ProductnameProperty); }
            set { SetValue(ProductnameProperty, value); }
        }
        public static readonly DependencyProperty ProductnameProperty =
           DependencyProperty.Register("Productname", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        
        ///<summary>
        ///自动转存标志
        ///</summary>
        public string Autotrflag
        {
            get { return (string)GetValue(AutotrflagProperty); }
            set { SetValue(AutotrflagProperty, value); }
        }
        public static readonly DependencyProperty AutotrflagProperty =
           DependencyProperty.Register("Autotrflag", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 支取日
        /// </summary>
        public string Withdrawaldate
        {
            get { return (string)GetValue(WithdrawaldateProperty); }
            set { SetValue(WithdrawaldateProperty, value); }
        }

        // Using a DependencyProperty as the backing store for PasswordOrSeal.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty WithdrawaldateProperty =
            DependencyProperty.Register("Withdrawaldate", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 支取金额
        /// </summary>
        public string Withdrawalsum
        {
            get { return (string)GetValue(WithdrawalsumProperty); }
            set { SetValue(WithdrawalsumProperty, value); }
        }

        // Using a DependencyProperty as the backing store for PasswordOrSeal.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty WithdrawalsumProperty =
            DependencyProperty.Register("Withdrawalsum", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 应付利息
        /// </summary>
        public string InterestBeforeTax
        {
            get { return (string)GetValue(InterestBeforeTaxProperty); }
            set { SetValue(InterestBeforeTaxProperty, value); }
        }

        // Using a DependencyProperty as the backing store for InterestForTax.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty InterestBeforeTaxProperty =
            DependencyProperty.Register("InterestBeforeTax", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 税金
        /// </summary>
        public string Tax
        {
            get { return (string)GetValue(TaxProperty); }
            set { SetValue(TaxProperty, value); }
        }
        // Using a DependencyProperty as the backing store for Tax.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty TaxProperty =
            DependencyProperty.Register("Tax", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 实付利息
        /// </summary>
        public string InterestAfterTax
        {
            get { return (string)GetValue(InterestAfterTaxProperty); }
            set { SetValue(InterestAfterTaxProperty, value); }
        }

        // Using a DependencyProperty as the backing store for InterestAfterTax.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty InterestAfterTaxProperty =
            DependencyProperty.Register("InterestAfterTax", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 转账帐号
        /// </summary>
        public string TransferAccount
        {
            get { return (string)GetValue(TransferAccountProperty); }
            set { SetValue(TransferAccountProperty, value); }
        }

        // Using a DependencyProperty as the backing store for TransferAccount.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty TransferAccountProperty =
            DependencyProperty.Register("TransferAccount", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 经办
        /// </summary>
        public string Handling
        {
            get { return (string)GetValue(HandlingProperty); }
            set { SetValue(HandlingProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Handling.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty HandlingProperty =
            DependencyProperty.Register("Handling", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 流水
        /// </summary>
        public string Serial
        {
            get { return (string)GetValue(SerialProperty); }
            set { SetValue(SerialProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SerialNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty SerialProperty =
            DependencyProperty.Register("Serial", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 支取复核
        /// </summary>
        public string WithdrawalReview
        {
            get { return (string)GetValue(WithdrawalReviewProperty); }
            set { SetValue(WithdrawalReviewProperty, value); }
        }
        public static readonly DependencyProperty WithdrawalReviewProperty =
            DependencyProperty.Register("WithdrawalReview", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 支取记账
        /// </summary>
        public string WithdrawalAccounting
        {
            get { return (string)GetValue(WithdrawalAccountingProperty); }
            set { SetValue(WithdrawalAccountingProperty, value); }
        }
        public static readonly DependencyProperty WithdrawalAccountingProperty =
            DependencyProperty.Register("WithdrawalAccounting", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 存入复核
        /// </summary>
        public string DepositedReview
        {
            get { return (string)GetValue(DepositedReviewProperty); }
            set { SetValue(DepositedReviewProperty, value); }
        }
        public static readonly DependencyProperty DepositedReviewProperty =
            DependencyProperty.Register("DepositedReview", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 存入记账
        /// </summary>
        public string DepositedAccounting
        {
            get { return (string)GetValue(DepositedAccountingProperty); }
            set { SetValue(DepositedAccountingProperty, value); }
        }
        public static readonly DependencyProperty DepositedAccountingProperty =
            DependencyProperty.Register("DepositedAccounting", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));

        
        public static readonly DependencyProperty TBlockStateProperty =
           DependencyProperty.Register("TBlockState", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));

        /// <summary>
        ///  状态文本
        /// </summary>
        public string TBlockState
        {
            get { return (string)GetValue(TBlockStateProperty); }
            set { SetValue(TBlockStateProperty, value); }
        }

        public static readonly DependencyProperty StateProperty =
         DependencyProperty.Register("State", typeof(string), typeof(Print_SaveForm), new UIPropertyMetadata(string.Empty));

        /// <summary>
        ///  状态值
        /// </summary>
        public string State
        {
            get { return (string)GetValue(StateProperty); }
            set { SetValue(StateProperty, value); }
        }

        /// <summary>
        /// 设置金额显示方式
        /// </summary>
        /// <param name="str"></param>
        /// <returns></returns>
        public void SetsumdisplayMode(string str)
        {
            textBlock9.Text = PrintTemplate.Extension.PrintContainerExt.PrintCurString(str);
        }

            #endregion
    }
}
