﻿using System;
using System.Globalization;
using System.Windows;
using Platform.Common.RunningParameters;

namespace TellerSystem.PrintTemplate.Common
{
    /// <summary>
    /// Print_Ticket.xaml 的交互逻辑
    /// </summary>
    public partial class Print_Ticket
    {
        public Print_Ticket()
        {
            InitializeComponent();
        }


        /// <summary>
        /// 将日期转换成大写
        /// add shangyongchao 20121024
        /// </summary>
        /// <param name="date">8位日期</param>
        /// <param name="type">y-年 m-月 d-日</param>
        /// <returns>bDate大写日期</returns>
        public static string DateToBig( string date, string type)
        {
            string year; //年
            string month; //月
            string day; //日
            string byear = ""; //大写年
            string bmonth = ""; //大写月
            string bday = ""; //大写日
            int i = 0;
            year =  date.Substring (0, 4);
            month = date.Substring(4, 2);
            day =   date.Substring(6, 2);

            if (type == "y")
            {
                while (i < 4)
                {
                    switch (year.Substring(i, 1)) //判断年如何取大写
                    {
                        case "0":
                            byear = byear + '零';
                            break;

                        case "1":
                            byear = byear + "壹";
                            break;

                        case "2":
                            byear = byear + "贰";
                            break;

                        case "3":
                            byear = byear + "叁";
                            break;

                        case "4":
                            byear = byear + "肆";
                            break;

                        case "5":
                            byear = byear + "伍";
                            break;

                        case "6":
                            byear = byear + "陆";
                            break;

                        case "7":
                            byear = byear + "柒";
                            break;

                        case "8":
                            byear = byear + "捌";
                            break;

                        case "9":
                            byear = byear + "玖";
                            break;
                    }
                    i = i + 1;
                }
                return byear;
            }
            else if (type == "m")
            {
                switch (month) //判断月如何取大写
                {
                    case "01":
                        bmonth = "  零壹";
                        break;

                    case "02":
                        bmonth = "  零贰";
                        break;

                    case "03":
                        bmonth = "  零叁";
                        break;

                    case "04":
                        bmonth = "  零肆";
                        break;

                    case "05":
                        bmonth = "  零伍";
                        break;

                    case "06":
                        bmonth = "  零陆";
                        break;

                    case "07":
                        bmonth = "  零柒";
                        break;

                    case "08":
                        bmonth = "  零捌";
                        break;

                    case "09":
                        bmonth = "  零玖";
                        break;

                    case "10":
                        bmonth = "零壹拾";
                        break;

                    case "11":
                        bmonth = "壹拾壹";
                        break;

                    case "12":
                        bmonth = "壹拾贰";
                        break;
                }
                return bmonth;
            }
            else if (type == "d")
            {
                switch (day) //判断日如何取大写
                {
                    case "01":
                        bday = "  零壹";
                        break;

                    case "02":
                        bday = "  零贰";
                        break;

                    case "03":
                        bday = "  零叁";
                        break;

                    case "04":
                        bday = "  零肆";
                        break;

                    case "05":
                        bday = "  零伍";
                        break;

                    case "06":
                        bday = "  零陆";
                        break;

                    case "07":
                        bday = "  零柒";
                        break;

                    case "08":
                        bday = "  零捌";
                        break;

                    case "09":
                        bday = "  零玖";
                        break;

                    case "10":
                        bday = "零壹拾";
                        break;

                    case "11":
                        bday = "壹拾壹";
                        break;

                    case "12":
                        bday = "壹拾贰";
                        break;

                    case "13":
                        bday = "壹拾叁";
                        break;

                    case "14":
                        bday = "壹拾肆";
                        break;

                    case "15":
                        bday = "壹拾伍";
                        break;

                    case "16":
                        bday = "壹拾陆";
                        break;

                    case "17":
                        bday = "壹拾柒";
                        break;

                    case "18":
                        bday = "壹拾捌";
                        break;

                    case "19":
                        bday = "壹拾玖";
                        break;

                    case "20":
                        bday = "零贰拾";
                        break;

                    case "21":
                        bday = "贰拾壹";
                        break;

                    case "22":
                        bday = "贰拾贰";
                        break;

                    case "23":
                        bday = "贰拾叁";
                        break;

                    case "24":
                        bday = "贰拾肆";
                        break;

                    case "25":
                        bday = "贰拾伍";
                        break;

                    case "26":
                        bday = "贰拾陆";
                        break;

                    case "27":
                        bday = "贰拾柒";
                        break;

                    case "28":
                        bday = "贰拾捌";
                        break;

                    case "29":
                        bday = "贰拾玖";
                        break;

                    case "30":
                        bday = "零叁拾";
                        break;

                    case "31":
                        bday = "叁拾壹";
                        break;
                }
                return bday;
            }
            else
            {
                return "";
            }
           
        }


        #region 自定义属性

        public static readonly DependencyProperty DateInfoProperty =
            DependencyProperty.Register("DateInfo", typeof (DateTime), typeof (Print_Ticket),
                                        new UIPropertyMetadata(DateTime.ParseExact(LoginUserInfo.TradeDate, "yyyyMMdd",
                                                                                   CultureInfo.CurrentCulture)));

        public static readonly DependencyProperty PayNameProperty =
            DependencyProperty.Register("PayName", typeof (string), typeof (Print_Ticket),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty AppNameProperty =
            DependencyProperty.Register("AppName", typeof (string), typeof (Print_Ticket),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Settlement_AmtMaxProperty =
            DependencyProperty.Register("Settlement_AmtMax", typeof (string), typeof (Print_Ticket),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty RemarkProperty =
            DependencyProperty.Register("Remark", typeof (string), typeof (Print_Ticket),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty CashierProperty =
            DependencyProperty.Register("Cashier", typeof (string), typeof (Print_Ticket),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty ReviewProperty =
            DependencyProperty.Register("Review", typeof (string), typeof (Print_Ticket),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty HandlingProperty =
            DependencyProperty.Register("Handling", typeof (string), typeof (Print_Ticket),
                                        new UIPropertyMetadata(LoginUserInfo.TellerNo));

        public static readonly DependencyProperty DateInfo_YearProperty =
    DependencyProperty.Register("DateInfo_Year", typeof(string), typeof(Print_Ticket),
                                new UIPropertyMetadata(DateToBig(LoginUserInfo.TradeDate,"y")));

        public static readonly DependencyProperty DateInfo_MonProperty =
    DependencyProperty.Register("DateInfo_Mon", typeof(string), typeof(Print_Ticket),
                                new UIPropertyMetadata(DateToBig(LoginUserInfo.TradeDate, "m")));

        public static readonly DependencyProperty DateInfo_DayProperty =
    DependencyProperty.Register("DateInfo_Day", typeof(string), typeof(Print_Ticket),
                                new UIPropertyMetadata(DateToBig(LoginUserInfo.TradeDate, "d")));

        /// <summary>
        /// 日期
        /// </summary>
        public DateTime DateInfo
        {
            get { return (DateTime) GetValue(DateInfoProperty); }
            set { SetValue(DateInfoProperty, value); }
        }

        /// <summary>
        /// 日期-年
        /// </summary>
        public string DateInfo_Year
        {
            get {return (string) GetValue(DateInfo_YearProperty); }
            set { SetValue(DateInfo_YearProperty, value); }
        }

        /// <summary>
        /// 日期-月
        /// </summary>
        public string DateInfo_Mon
        {
            get { return (string)GetValue(DateInfo_MonProperty); }
            set { SetValue(DateInfo_MonProperty, value); }
        }

        /// <summary>
        /// 日期-日
        /// </summary>
        public string DateInfo_Day
        {
            get { return (string)GetValue(DateInfo_DayProperty); }
            set { SetValue(DateInfo_DayProperty, value); }
        }

        /// <summary>
        /// 收款人
        /// </summary>
        public string PayName
        {
            get { return (string) GetValue(PayNameProperty); }
            set { SetValue(PayNameProperty, value); }
        }

        /// <summary>
        /// 申请人
        /// </summary>
        public string AppName
        {
            get { return (string) GetValue(AppNameProperty); }
            set { SetValue(AppNameProperty, value); }
        }

        /// <summary>
        /// 金额大写
        /// </summary>
        public string Settlement_AmtMax
        {
            get { return (string) GetValue(Settlement_AmtMaxProperty); }
            set { SetValue(Settlement_AmtMaxProperty, value); }
        }

        /// <summary>
        /// 备注
        /// </summary>
        public string Remark
        {
            get { return (string) GetValue(RemarkProperty); }
            set { SetValue(RemarkProperty, value); }
        }

        /// <summary>
        /// 出纳
        /// </summary>
        public string Cashier
        {
            get { return (string) GetValue(CashierProperty); }
            set { SetValue(CashierProperty, value); }
        }

        /// <summary>
        /// 复核
        /// </summary>
        public string Review
        {
            get { return (string) GetValue(ReviewProperty); }
            set { SetValue(ReviewProperty, value); }
        }

        /// <summary>
        /// 经办
        /// </summary>
        public string Handling
        {
            get { return (string) GetValue(HandlingProperty); }
            set { SetValue(HandlingProperty, value); }
        }

        #endregion 自定义属性
    }
}