﻿using System;
using System.Globalization;
using System.Linq;
using System.Windows;
using Platform.Common.RunningParameters;
using TellerSystem.PrintTemplate.Template;

namespace TellerSystem.PrintTemplate.Common
{
    /// <summary>
    /// Print_Transfercheck.xaml 的交互逻辑
    /// </summary>
    public partial class Print_Transfercheck
    {
        public Print_Transfercheck()
        {
            InitializeComponent();
            TellerNo = LoginUserInfo.TellerNo;
            TradeDate.Text = LoginUserInfo.TradeDate;
            IsShowDitail = true;
        }

        public bool IsShowDitail
        {
            set
            {
                if (!value) tXLXAMT1.Visibility = Visibility.Collapsed;
                else tXLXAMT1.Visibility = Visibility.Visible;
            }
        }
        #region 自定义属性

        public static readonly DependencyProperty DateInfoProperty =
            DependencyProperty.Register("DateInfo", typeof(DateTime), typeof(Print_Transfercheck),
                                        new UIPropertyMetadata(DateTime.ParseExact(LoginUserInfo.TradeDate, "yyyyMMdd",
                                                                                   CultureInfo.CurrentCulture)));

        public static readonly DependencyProperty PayNameProperty =
            DependencyProperty.Register("PayName", typeof(string), typeof(Print_Transfercheck),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty PaymentBankNameProperty =
            DependencyProperty.Register("PaymentBankName", typeof(string), typeof(Print_Transfercheck),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty AccountProperty =
            DependencyProperty.Register("Account", typeof(string), typeof(Print_Transfercheck),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Settlement_AmtMaxProperty =
            DependencyProperty.Register("Settlement_AmtMax", typeof(string), typeof(Print_Transfercheck),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty Settlement_AmtMinProperty =
            DependencyProperty.Register("Settlement_AmtMin", typeof(string), typeof(Print_Transfercheck),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty UseProperty =
            DependencyProperty.Register("Use", typeof(string), typeof(Print_Transfercheck),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty PasswordProperty =
            DependencyProperty.Register("Password", typeof(string), typeof(Print_Transfercheck),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty FundsProperty =
            DependencyProperty.Register("Funds", typeof(string), typeof(Print_Transfercheck),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty PaymentProperty =
            DependencyProperty.Register("Payment", typeof(string), typeof(Print_Transfercheck),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty SignatureProperty =
            DependencyProperty.Register("Signature", typeof(string), typeof(Print_Transfercheck),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty ReviewProperty =
            DependencyProperty.Register("Review", typeof(string), typeof(Print_Transfercheck),
                                        new UIPropertyMetadata(string.Empty));

        public static readonly DependencyProperty HandlingProperty =
            DependencyProperty.Register("Handling", typeof(string), typeof(Print_Transfercheck),
                                        new UIPropertyMetadata(LoginUserInfo.TellerNo));

        public static readonly DependencyProperty RownumberProperty =
            DependencyProperty.Register("Rownumber", typeof(string), typeof(Print_Transfercheck),
                                        new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty TCurrencyProperty =
            DependencyProperty.Register("TCurrency", typeof(string), typeof(Print_Transfercheck),
                                        new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty TradeNameProperty =
            DependencyProperty.Register("TradeName", typeof(string), typeof(Print_Transfercheck),
                                        new UIPropertyMetadata(string.Empty));
        public static readonly DependencyProperty BTicNameProperty =
            DependencyProperty.Register("BTicName", typeof(string), typeof(Print_Transfercheck),
                                        new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 业务流水
        /// </summary>
        public string HostSerialNumber
        {
            get { return (string)GetValue(HostSerialNumberProperty); }
            set { SetValue(HostSerialNumberProperty, value); }
        }
        public static readonly DependencyProperty HostSerialNumberProperty =
         DependencyProperty.Register("HostSerialNumber", typeof(string), typeof(Print_Transfercheck),
         new UIPropertyMetadata(string.Empty));

        #region 凭证号
        public string Pzh
        {
            get
            {
                return (string)GetValue(PzhProperty);
            }
            set
            {
                SetValue(PzhProperty, value);
            }
        }

        public static readonly DependencyProperty PzhProperty =
            DependencyProperty.Register("Pzh", typeof(string), typeof(Print_Transfercheck), new UIPropertyMetadata(string.Empty));

        public string PzhStr
        {
            get
            {
                return (string)GetValue(PzhStrProperty);
            }
            set
            {
                SetValue(PzhStrProperty, value);
            }
        }

        public static readonly DependencyProperty PzhStrProperty =
            DependencyProperty.Register("PzhStr", typeof(string), typeof(Print_Transfercheck), new UIPropertyMetadata("凭证号:"));
        #endregion 凭证号

        #region 对方账号
        public string TranOutActNo
        {
            get { return (string)GetValue(TranOutActNoProperty); }
            set { SetValue(TranOutActNoProperty, value); }
        }

        public static readonly DependencyProperty TranOutActNoProperty =
            DependencyProperty.Register("TranOutActNo", typeof(string), typeof(Print_Transfercheck), new UIPropertyMetadata(string.Empty));



        public string TranOutActNoStr
        {
            get { return (string)GetValue(TranOutActNoStrProperty); }
            set { SetValue(TranOutActNoStrProperty, value); }
        }

        public static readonly DependencyProperty TranOutActNoStrProperty =
            DependencyProperty.Register("TranOutActNoStr", typeof(string), typeof(Print_Transfercheck), new UIPropertyMetadata("对方账号:"));
        #endregion

        #region 对方账户
        public string TranOutActName
        {
            get { return (string)GetValue(TranOutActNameProperty); }
            set { SetValue(TranOutActNameProperty, value); }
        }

        public static readonly DependencyProperty TranOutActNameProperty =
            DependencyProperty.Register("TranOutActName", typeof(string), typeof(Print_Transfercheck), new UIPropertyMetadata(string.Empty));



        public string TranOutActNameStr
        {
            get { return (string)GetValue(TranOutActNameStrProperty); }
            set { SetValue(TranOutActNameStrProperty, value); }
        }

        public static readonly DependencyProperty TranOutActNameStrProperty =
            DependencyProperty.Register("TranOutActNameStr", typeof(string), typeof(Print_Transfercheck), new UIPropertyMetadata("对方户名:"));
        #endregion

        #region 柜员
        /// <summary>
        /// 柜员号
        /// </summary>
        public string TellerNo
        {
            get { return (string)GetValue(TellerNoProperty); }
            set { SetValue(TellerNoProperty, value); }
        }

        public static readonly DependencyProperty TellerNoProperty =
            DependencyProperty.Register("TellerNo", typeof(string), typeof(Print_Transfercheck), new UIPropertyMetadata(string.Empty));

        public string TellerNoStr
        {
            get { return (string)GetValue(TellerNoStrProperty); }
            set { SetValue(TellerNoStrProperty, value); }
        }

        public static readonly DependencyProperty TellerNoStrProperty =
            DependencyProperty.Register("TellerNoStr", typeof(string), typeof(Print_Transfercheck), new UIPropertyMetadata("操作员号:"));
        #endregion

        #region 流水
        public string SerialNumberStr
        {
            get { return (string)GetValue(SerialNumberStrProperty); }
            set { SetValue(SerialNumberStrProperty, value); }
        }

        public static readonly DependencyProperty SerialNumberStrProperty =
            DependencyProperty.Register("SerialNumberStr", typeof(string), typeof(Print_Transfercheck), new UIPropertyMetadata("流水号:"));
        #endregion

        #region 时间
        public string DataTime
        {
            get { return (string)GetValue(DataTimeProperty); }
            set { SetValue(DataTimeProperty, value); }
        }

        public static readonly DependencyProperty DataTimeProperty =
            DependencyProperty.Register("DataTime", typeof(string), typeof(Print_Transfercheck), new UIPropertyMetadata(DateTime.Now.Hour + ":" + DateTime.Now.Minute + ":" + DateTime.Now.Second));

        public string DataTimeStr
        {
            get { return (string)GetValue(DataTimeStrProperty); }
            set { SetValue(DataTimeStrProperty, value); }
        }

        public static readonly DependencyProperty DataTimeStrProperty =
           DependencyProperty.Register("DataTimeStr", typeof(string), typeof(Print_Transfercheck), new UIPropertyMetadata("交易时间:"));
        #endregion




        /// <summary>
        /// 出票户名
        /// </summary>
        public string BTicName
        {
            get { return (string)GetValue(BTicNameProperty); }
            set { SetValue(BTicNameProperty, value); }
        }
        /// <summary>
        /// 金额
        /// </summary>
        public string TCurrency
        {
            get { return (string)GetValue(TCurrencyProperty); }
            set { SetValue(TCurrencyProperty, value); }
        }
        /// <summary>
        /// 交易名称
        /// </summary>
        public string TradeName
        {
            get { return (string)GetValue(TradeNameProperty); }
            set { SetValue(TradeNameProperty, value); }
        }
        /// <summary>
        /// 日期
        /// </summary>
        public String DateInfo
        {
            set { TradeDate.Text = value; }
        }

        /// <summary>
        /// 收款人
        /// </summary>
        public string PayName
        {
            get { return (string)GetValue(PayNameProperty); }
            set { SetValue(PayNameProperty, value); }
        }

        /// <summary>
        /// 付款银行名称
        /// </summary>
        public string PaymentBankName
        {
            get { return (string)GetValue(PaymentBankNameProperty); }
            set { SetValue(PaymentBankNameProperty, value); }
        }

        /// <summary>
        /// 账号
        /// </summary>
        public string Account
        {
            get { return (string)GetValue(AccountProperty); }
            set { SetValue(AccountProperty, value); }
        }

        /// <summary>
        /// 结算金额大写
        /// </summary>
        public string Settlement_AmtMax
        {
            get { return (string)GetValue(Settlement_AmtMaxProperty); }
            set { SetValue(Settlement_AmtMaxProperty, value); }
        }

        /// <summary>
        /// 结算金额小写
        /// </summary>
        public string Settlement_AmtMin
        {
            get { return (string)GetValue(Settlement_AmtMinProperty); }
            set
            {
                SetValue(Settlement_AmtMinProperty, value);
                //Extension.PrintContainerExt.SetCanvas(stackPanel1, value);
            }
        }

        /// <summary>
        /// 用途
        /// </summary>
        public string Use
        {
            get { return (string)GetValue(UseProperty); }
            set { SetValue(UseProperty, value); }
        }

        /// <summary>
        /// 密码
        /// </summary>
        public string Password
        {
            get { return (string)GetValue(PasswordProperty); }
            set { SetValue(PasswordProperty, value); }
        }

        /// <summary>
        /// 款项
        /// </summary>
        public string Funds
        {
            get { return (string)GetValue(FundsProperty); }
            set { SetValue(FundsProperty, value); }
        }

        /// <summary>
        /// 支付
        /// </summary>
        public string Payment
        {
            get { return (string)GetValue(PaymentProperty); }
            set { SetValue(PaymentProperty, value); }
        }

        /// <summary>
        /// 签章
        /// </summary>
        public string Signature
        {
            get { return (string)GetValue(SignatureProperty); }
            set { SetValue(SignatureProperty, value); }
        }

        /// <summary>
        /// 复核
        /// </summary>
        public string Review
        {
            get { return (string)GetValue(ReviewProperty); }
            set { SetValue(ReviewProperty, value); }
        }

        /// <summary>
        /// 记账
        /// </summary>
        public string Handling
        {
            get { return (string)GetValue(HandlingProperty); }
            set { SetValue(HandlingProperty, value); }
        }

        /// <summary>
        /// 行号
        /// </summary>
        public string Rownumber
        {
            get { return (string)GetValue(RownumberProperty); }
            set { SetValue(RownumberProperty, value); }
        }
        public string T_JYMC
        {
            get { return (string)GetValue(T_JYMCProperty); }
            set { SetValue(T_JYMCProperty, value); }
        }

        public static readonly DependencyProperty T_JYMCProperty =
            DependencyProperty.Register("T_JYMC", typeof(string),
            typeof(Print_Transfercheck), new UIPropertyMetadata("交易名称:"));

        public string T_XH
        {
            get { return (string)GetValue(T_XHProperty); }
            set { SetValue(T_XHProperty, value); }
        }

        public static readonly DependencyProperty T_XHProperty =
            DependencyProperty.Register("T_XH", typeof(string),
            typeof(Print_Transfercheck), new UIPropertyMetadata("序号:"));
        public string T_CPZH
        {
            get { return (string)GetValue(T_CPZHProperty); }
            set { SetValue(T_CPZHProperty, value); }
        }

        public static readonly DependencyProperty T_CPZHProperty =
            DependencyProperty.Register("T_CPZH", typeof(string),
            typeof(Print_Transfercheck), new UIPropertyMetadata("出票账号:"));
        public string T_CPHM
        {
            get { return (string)GetValue(T_CPHMProperty); }
            set { SetValue(T_CPHMProperty, value); }
        }

        public static readonly DependencyProperty T_CPHMProperty =
            DependencyProperty.Register("T_CPHM", typeof(string),
            typeof(Print_Transfercheck), new UIPropertyMetadata("出票户名:"));
        public string T_DFZH
        {
            get { return (string)GetValue(T_DFZHProperty); }
            set { SetValue(T_DFZHProperty, value); }
        }

        public static readonly DependencyProperty T_DFZHProperty =
            DependencyProperty.Register("T_DFZH", typeof(string),
            typeof(Print_Transfercheck), new UIPropertyMetadata("对方账号:"));
        public string T_DFHM
        {
            get { return (string)GetValue(T_DFHMProperty); }
            set { SetValue(T_DFHMProperty, value); }
        }

        public static readonly DependencyProperty T_DFHMProperty =
            DependencyProperty.Register("T_DFHM", typeof(string),
            typeof(Print_Transfercheck), new UIPropertyMetadata("对方户名:"));
        public string T_YT
        {
            get { return (string)GetValue(T_YTProperty); }
            set { SetValue(T_YTProperty, value); }
        }

        public static readonly DependencyProperty T_YTProperty =
            DependencyProperty.Register("T_YT", typeof(string),
            typeof(Print_Transfercheck), new UIPropertyMetadata("用途:"));
        public string T_JE
        {
            get { return (string)GetValue(T_JEProperty); }
            set { SetValue(T_JEProperty, value); }
        }

        public static readonly DependencyProperty T_JEProperty =
            DependencyProperty.Register("T_JE", typeof(string),
            typeof(Print_Transfercheck), new UIPropertyMetadata("金额:"));
        public string T_PZH
        {
            get { return (string)GetValue(T_PZHProperty); }
            set { SetValue(T_PZHProperty, value); }
        }

        public static readonly DependencyProperty T_PZHProperty =
            DependencyProperty.Register("T_PZH", typeof(string),
            typeof(Print_Transfercheck), new UIPropertyMetadata("凭 证 号:"));
        public string T_JYSH
        {
            get { return (string)GetValue(T_JYSHProperty); }
            set { SetValue(T_JYSHProperty, value); }
        }

        public static readonly DependencyProperty T_JYSHProperty =
            DependencyProperty.Register("T_JYSH", typeof(string),
            typeof(Print_Transfercheck), new UIPropertyMetadata("交易时间:"));
        //public String IsShowDitail
        //{
        //    get { return (String)GetValue(IsShowDitailProperty); }
        //    set { SetValue(IsShowDitailProperty, value); }
        //}

        //public static readonly DependencyProperty IsShowDitailProperty =
        //    DependencyProperty.Register("IsShowDitail", typeof(string), typeof(Print_Transfercheck), new UIPropertyMetadata("True"));
        /// <summary>
        /// 设置金额显示方式
        /// </summary>
        /// <param name="str"></param>
        /// <returns></returns>
        public void SetsumdisplayMode(string str)
        {
            //textBlock9.Text = PrintTemplate.Extension.PrintContainerExt.PrintCurString(str);
        }
        #endregion 自定义属性
    }
}