﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Platform.Common.RunningParameters;

namespace TellerSystem.PrintTemplate.Common
{
    /// <summary>
    /// Print_Withdraw.xaml 的交互逻辑
    /// </summary>
    public partial class Print_Withdraw
    {
        public Print_Withdraw()
        {
            InitializeComponent();
            //设置默认值

        }

        #region 附加属性
        /// <summary>
        /// 行号
        /// </summary>
        public string BranchNo
        {
            get { return (string)GetValue(BranchNoProperty); }
            set { SetValue(BranchNoProperty, value); }
        }

        // Using a DependencyProperty as the backing store for BranchNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty BranchNoProperty =
            DependencyProperty.Register("BranchNo", typeof(string), typeof(Print_Withdraw), new UIPropertyMetadata(LoginUserInfo.KinbrNo));

        /// <summary>
        /// 日期
        /// </summary>
        public DateTime DateInfo
        {
            get { return (DateTime)GetValue(DateInfoProperty); }
            set { SetValue(DateInfoProperty, value); }
        }

        // Using a DependencyProperty as the backing store for DateInfo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty DateInfoProperty =
            DependencyProperty.Register("DateInfo", typeof(DateTime), typeof(Print_Withdraw), new UIPropertyMetadata(DateTime.ParseExact(LoginUserInfo.TradeDate, "yyyyMMdd", System.Globalization.CultureInfo.CurrentCulture)));

        /// <summary>
        /// 流水号
        /// </summary>
        public string SerialNo
        {
            get { return (string)GetValue(SerialNoProperty); }
            set { SetValue(SerialNoProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SerialNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty SerialNoProperty =
            DependencyProperty.Register("SerialNo", typeof(string), typeof(Print_Withdraw), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 帐号/卡号
        /// </summary>
        public string AccountNo
        {
            get { return (string)GetValue(AccountNoProperty); }
            set { SetValue(AccountNoProperty, value); }
        }

        // Using a DependencyProperty as the backing store for AccountNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty AccountNoProperty =
            DependencyProperty.Register("AccountNo", typeof(string), typeof(Print_Withdraw), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 子帐号
        /// </summary>
        public string ChildAccountNo
        {
            get { return (string)GetValue(ChildAccountNoProperty); }
            set { SetValue(ChildAccountNoProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ChildAccountNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ChildAccountNoProperty =
            DependencyProperty.Register("ChildAccountNo", typeof(string), typeof(Print_Withdraw), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 户名
        /// </summary>
        public string AccountName
        {
            get { return (string)GetValue(AccountNameProperty); }
            set { SetValue(AccountNameProperty, value); }
        }

        // Using a DependencyProperty as the backing store for AccountName.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty AccountNameProperty =
            DependencyProperty.Register("AccountName", typeof(string), typeof(Print_Withdraw), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 现转标志
        /// </summary>
        public string CashOrTransfer
        {
            get { return (string)GetValue(CashOrTransferProperty); }
            set { SetValue(CashOrTransferProperty, value); }
        }

        // Using a DependencyProperty as the backing store for CashOrTransfer.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty CashOrTransferProperty =
            DependencyProperty.Register("CashOrTransfer", typeof(string), typeof(Print_Withdraw), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 帐户类型
        /// </summary>
        public string AccountType
        {
            get { return (string)GetValue(AccountTypeProperty); }
            set { SetValue(AccountTypeProperty, value); }
        }

        // Using a DependencyProperty as the backing store for AccountType.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty AccountTypeProperty =
            DependencyProperty.Register("AccountType", typeof(string), typeof(Print_Withdraw), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 起息日期
        /// </summary>
        public string StartDateForInterest
        {
            get { return (string)GetValue(StartDateForInterestProperty); }
            set { SetValue(StartDateForInterestProperty, value); }
        }

        // Using a DependencyProperty as the backing store for StartDateForInterest.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty StartDateForInterestProperty =
            DependencyProperty.Register("StartDateForInterest", typeof(string), typeof(Print_Withdraw), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 种类/存期
        /// </summary>
        public string DepositType
        {
            get { return (string)GetValue(DepositTypeProperty); }
            set { SetValue(DepositTypeProperty, value); }
        }

        // Using a DependencyProperty as the backing store for DepositType.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty DepositTypeProperty =
            DependencyProperty.Register("DepositType", typeof(string), typeof(Print_Withdraw), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 利率
        /// </summary>
        public string InterestRate
        {
            get { return (string)GetValue(InterestRateProperty); }
            set { SetValue(InterestRateProperty, value); }
        }

        // Using a DependencyProperty as the backing store for InterestRate.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty InterestRateProperty =
            DependencyProperty.Register("InterestRate", typeof(string), typeof(Print_Withdraw), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 币种/发生额
        /// </summary>
        public string Amount
        {
            get { return (string)GetValue(AmountProperty); }
            set { SetValue(AmountProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Amount.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty AmountProperty =
            DependencyProperty.Register("Amount", typeof(string), typeof(Print_Withdraw), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 帐户余额
        /// </summary>
        public string Balance
        {
            get { return (string)GetValue(BalanceProperty); }
            set { SetValue(BalanceProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Balance.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty BalanceProperty =
            DependencyProperty.Register("Balance", typeof(string), typeof(Print_Withdraw), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 应税利息
        /// </summary>
        public string InterestBeforeTax
        {
            get { return (string)GetValue(InterestBeforeTaxProperty); }
            set { SetValue(InterestBeforeTaxProperty, value); }
        }

        // Using a DependencyProperty as the backing store for InterestForTax.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty InterestBeforeTaxProperty =
            DependencyProperty.Register("InterestBeforeTax", typeof(string), typeof(Print_Withdraw), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 税金
        /// </summary>
        public string Tax
        {
            get { return (string)GetValue(TaxProperty); }
            set { SetValue(TaxProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Tax.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty TaxProperty =
            DependencyProperty.Register("Tax", typeof(string), typeof(Print_Withdraw), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 税后利息
        /// </summary>
        public string InterestAfterTax
        {
            get { return (string)GetValue(InterestAfterTaxProperty); }
            set { SetValue(InterestAfterTaxProperty, value); }
        }

        // Using a DependencyProperty as the backing store for InterestAfterTax.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty InterestAfterTaxProperty =
            DependencyProperty.Register("InterestAfterTax", typeof(string), typeof(Print_Withdraw), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 税后本息合计
        /// </summary>
        public string TotalAmt
        {
            get { return (string)GetValue(TotalAmtProperty); }
            set { SetValue(TotalAmtProperty, value); }
        }

        // Using a DependencyProperty as the backing store for TotalAmt.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty TotalAmtProperty =
            DependencyProperty.Register("TotalAmt", typeof(string), typeof(Print_Withdraw), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 转入帐号
        /// </summary>
        public string TransferAccount
        {
            get { return (string)GetValue(TransferAccountProperty); }
            set { SetValue(TransferAccountProperty, value); }
        }

        // Using a DependencyProperty as the backing store for TransferAccount.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty TransferAccountProperty =
            DependencyProperty.Register("TransferAccount", typeof(string), typeof(Print_Withdraw), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 操作员
        /// </summary>
        public string TellerNo
        {
            get { return (string)GetValue(TellerNoProperty); }
            set { SetValue(TellerNoProperty, value); }
        }

        // Using a DependencyProperty as the backing store for TellerNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty TellerNoProperty =
            DependencyProperty.Register("TellerNo", typeof(string), typeof(Print_Withdraw), new UIPropertyMetadata(LoginUserInfo.TellerNo));

        /// <summary>
        /// 事后监督
        /// </summary>
        public string SupervisionAfterwards
        {
            get { return (string)GetValue(SupervisionAfterwardsProperty); }
            set { SetValue(SupervisionAfterwardsProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SupervisionAfterwards.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty SupervisionAfterwardsProperty =
            DependencyProperty.Register("SupervisionAfterwards", typeof(string), typeof(Print_Withdraw), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 复核
        /// </summary>
        public string Review
        {
            get { return (string)GetValue(ReviewProperty); }
            set { SetValue(ReviewProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Review.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ReviewProperty =
            DependencyProperty.Register("Review", typeof(string), typeof(Print_Withdraw), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 经办
        /// </summary>
        public string Handling
        {
            get { return (string)GetValue(HandlingProperty); }
            set { SetValue(HandlingProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Handling.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty HandlingProperty =
            DependencyProperty.Register("Handling", typeof(string), typeof(Print_Withdraw), new UIPropertyMetadata(LoginUserInfo.TellerNo));
        #endregion
    }
}
