﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Windows;
using Platform.Common;
using System.Windows.Media;
using System.Windows.Input;
using System.ComponentModel;
using Platform.Print;

namespace TellerSystem.PrintTemplate.Template
{
    /// <summary>
    /// 大额支付凭证
    /// </summary>
    public class Print_Large : PrintContainer
    {
        static Print_Large()
        {
            DefaultStyleKeyProperty.OverrideMetadata(typeof(Print_Large), new FrameworkPropertyMetadata(typeof(Print_Large)));
        }
        #region 附加属性
        /// <summary>
        /// 银行转账传票
        /// </summary>
        public string Summons
        {
            get { return (string)GetValue(SummonsProperty); }
            set { SetValue(SummonsProperty, value); }
        }
        public static readonly DependencyProperty SummonsProperty =
                DependencyProperty.Register("Summons", typeof(string), typeof(Print_Large), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 会计
        /// </summary>
        public string Financial
        {
            get { return (string)GetValue(FinancialProperty); }
            set { SetValue(FinancialProperty, value); }
        }
        public static readonly DependencyProperty FinancialProperty =
                    DependencyProperty.Register("Financial", typeof(string), typeof(Print_Large), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 复核
        /// </summary>
        public string Review
        {
            get { return (string)GetValue(ReviewProperty); }
            set { SetValue(ReviewProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Review.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ReviewProperty =
            DependencyProperty.Register("Review", typeof(string), typeof(Print_Large), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 记账
        /// </summary>
        public string Accounting 
        {
            get { return (string)GetValue(AccountingProperty); }
            set { SetValue(AccountingProperty, value); }
        }
        public static readonly DependencyProperty AccountingProperty =
            DependencyProperty.Register("Accounting", typeof(string), typeof(Print_Large), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 主机流水值
        /// </summary>
        public string HostSerialNumber
        {
            get { return (string)GetValue(HostSerialNumberProperty); }
            set { SetValue(HostSerialNumberProperty, value); }
        }
        public static readonly DependencyProperty HostSerialNumberProperty =
            DependencyProperty.Register("HostSerialNumber", typeof(string), typeof(Print_Large), new UIPropertyMetadata(string.Empty));
        #endregion
    }

}
