﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Windows;
using Platform.Common;
using System.Windows.Media;
using System.Windows.Input;
using System.ComponentModel;
using Platform.Print;
using TellerSystem.PrintTemplate.Extension;

namespace TellerSystem.PrintTemplate.Template
{
    /// <summary>
    /// 小额支付凭证
    /// </summary>
    public class Print_Micro : PrintContainer
    {
        static Print_Micro()
        {
            DefaultStyleKeyProperty.OverrideMetadata(typeof(Print_Micro), new FrameworkPropertyMetadata(typeof(Print_Micro)));
        }
        #region 附加属性
        /// <summary>
        /// 会计留存
        /// </summary>
        public string FinancialRetained
        {
            get { return (string)GetValue(FinancialRetainedProperty); }
            set { SetValue(FinancialRetainedProperty, value); }
        }
        public static readonly DependencyProperty FinancialRetainedProperty =
                DependencyProperty.Register("FinancialRetained", typeof(string), typeof(Print_Micro), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 会计
        /// </summary>
        public string Financial
        {
            get { return (string)GetValue(FinancialProperty); }
            set { SetValue(FinancialProperty, value); }
        }
        public static readonly DependencyProperty FinancialProperty =
                    DependencyProperty.Register("Financial", typeof(string), typeof(Print_Micro), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 复核
        /// </summary>
        public string Review
        {
            get { return (string)GetValue(ReviewProperty); }
            set { SetValue(ReviewProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Review.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ReviewProperty =
            DependencyProperty.Register("Review", typeof(string), typeof(Print_Micro), new UIPropertyMetadata(string.Empty));
        /// <summary>
        /// 记账
        /// </summary>
        public string Accounting
        {
            get { return (string)GetValue(AccountingProperty); }
            set { SetValue(AccountingProperty, value); }
        }
        public static readonly DependencyProperty AccountingProperty =
            DependencyProperty.Register("Accounting", typeof(string), typeof(Print_Micro), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 主机流水值
        /// </summary>
        public string HostSerialNumber
        {
            get { return (string)GetValue(HostSerialNumberProperty); }
            set { SetValue(HostSerialNumberProperty, value); }
        }
        public static readonly DependencyProperty HostSerialNumberProperty =
            DependencyProperty.Register("HostSerialNumber", typeof(string), typeof(Print_Micro), new UIPropertyMetadata(string.Empty));
        #endregion
    }
}
