﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;
using Platform.Common;
using Platform.Common.RunningParameters;
using Platform.Print;
using TellerSystem.PrintTemplate.Extension;
using TellerSystem.PrintTemplate.OldPrint;
using TellerSystem.PrintTemplate.PrintTemplateData;
using TellerSystem.PrintTemplate.Base;

namespace TellerSystem.PrintTemplate.Template
{
    /// <summary>
    /// 空白凭证基类
    /// </summary>
    public class Print_Old : Print_业务凭证
    {
        public string IsShowTellerNo { get; set; }

        public string IsShowHostSerialNumber { get; set; }

        public string TradeName { get; set; }

        public string FormDataName { get; set; }

        public int FormRoleCount { get; set; }

        public string HostSerialNumber { get; set; }

        public string TradeTime { get; set; }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="top"></param>
        /// <param name="left"></param>
        /// <param name="printValue"></param>
        /// <param name="fontSize"></param>
        /// <param name="isBold"></param>
        /// <param name="fontFamily"></param>
        /// <returns></returns>
        public bool AddPrintLine(double top, double left, string printValue, double fontSize = double.NaN, bool isBold = false, FontFamily fontFamily = null)
        {
            var panel = this.Content as Canvas;
            //若Content不存在，则给默认数据
            //if (panel == null) return false;
            if (panel == null)
            {
                panel = new Canvas();
                this.Content = panel;
            }
            var element = new PrintStringElement();
            Canvas.SetTop(element, top);
            Canvas.SetLeft(element, left);
            element.Value = printValue;

            if (!double.IsNaN(fontSize))
                element.FontSize = fontSize;
            if (isBold)
                element.FontWeight = System.Windows.FontWeights.Bold;
            if (fontFamily != null)
                element.FontFamily = fontFamily;
            panel.Children.Add(element);
            return true;
        }
    }

    /// <summary>
    /// 电汇凭证
    /// </summary>
    public class Print_Etc : Print_业务凭证
    {
        public bool IsForSeach { get; set; }

        public string HostSerialNumber { get; set; }

        public string TradeTime { get; set; }
    }

    /// <summary>
    /// 大额
    /// </summary>
    public class Print_Large : Print_Largepayment
    {
        public Print_Large()
        {
            //this.PrintType = PrintTypes.Largepayment;
            this.Loaded += (sender, e) =>
            {
                var element = this.Content as FrameworkElement;
                element.Margin = new Thickness(element.Margin.Left, element.Margin.Top + 40, element.Margin.Right, element.Margin.Bottom);
            };
        }

        public string HostSerialNumber { get; set; }

        public string TradeTime { get; set; }
    }

    /// <summary>
    /// 小额
    /// </summary>
    public class Print_Micro : Print_Micropayment
    {
        public Print_Micro()
        {
            //this.PrintType = PrintTypes.Micropayment;
            this.Loaded += (sender, e) =>
            {
                var element = this.Content as FrameworkElement;
                element.Margin = new Thickness(element.Margin.Left, element.Margin.Top + 40, element.Margin.Right, element.Margin.Bottom);
            };
        }

        public string HostSerialNumber { get; set; }

        public string TradeTime { get; set; }
    }
}