﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Windows;
using Platform.Common;
using System.Windows.Media;
using System.Windows.Input;
using System.ComponentModel;
using Platform.Print;
using TellerSystem.PrintTemplate.Base;
using Platform.Common.RunningParameters;
using TellerSystem.ServiceProxy.Ext.ServiceHelper;

namespace TellerSystem.PrintTemplate.PrintTemplateData
{
    /// <summary>
    ///电汇凭证
    /// </summary>
    public class Print_Largepayment : TemplateBase
    {
        public Print_Largepayment()
        {
            this.PrintType = PrintTypes.Largepayment;
        }
        private string FLAG = TradeManagerHandle.TT_SYSCONFIG_GetConfigValueByConfigID("2ea3a7e6cfa04f89a335bf1e363295de");
        protected override void DrawingCommonLayer(Extension.PrintAttributes attr)
        {
            base.DrawingCommonLayer(attr);
            #region
            if (!string.IsNullOrEmpty(LoginUserInfo.KinbrNo))
            {
                if (LoginUserInfo.KinbrNo.Substring(0, 3) == "801")
                {
                    //芝罘打印印章
                    this.E_Seal_Location = new Point(550, 323);
                }
                else if (LoginUserInfo.KinbrNo.Substring(0, 3) == "807")
                {
                    //莱山打印印章
                    this.E_Seal_Location = new Point(550, 323);
                }
                else if (LoginUserInfo.KinbrNo.Substring(0, 3) == "803")
                {
                    //新泰打印印章
                    this.E_Seal_Location = new Point(550, 323);
                }
                else if (LoginUserInfo.KinbrNo.Substring(0, 3) == "805")
                {
                    //冠县打印印章
                    this.E_Seal_Location = new Point(550, 323);
                }
                else if (LoginUserInfo.KinbrNo.Substring(0, 3) == "820")
                {
                    //大石桥打印印章
                    this.E_Seal_Location = new Point(550, 323);
                }
                else if (LoginUserInfo.KinbrNo.Substring(0, 3) == "108")
                {
                    //固始天骄打印印章
                    this.E_Seal_Location = new Point(550, 323);
                }
                else if (LoginUserInfo.KinbrNo.Substring(0, 3) == "118")
                {
                    //乳山天骄打印印章
                    this.E_Seal_Location = new Point(550, 323);
                }
                else if (FLAG == "V5")
                {
                    //青隆不要业务章
                    if (LoginUserInfo.KinbrNo.Substring(0, 3) == "302")
                    {
                        this.ElecSealHelper.Sign2Point(new Point(550, 323), TellerSystem.PrintTemplate.ElecSeal.SealKind.Biz);
                    }
                }
                else if (LoginUserInfo.KinbrNo.Substring(0, 3) == "802")
                {
                    //泗水打印印章
                    this.E_Seal_Location = new Point(550, 323);
                }
                else if (LoginUserInfo.KinbrNo.Substring(0, 3) == "806")
                {
                    //蒙阴打印印章
                    this.E_Seal_Location = new Point(550, 323);
                }
                else
                {
                    //阳光打印印章
                    this.E_Seal_Location = new Point(580, 358);
                }
            }
            #endregion
            if (DesignerProperties.GetIsInDesignMode(this))
            {
                this.DrawingText(195, 33, "机构名称:[XXX支行]");
                this.DrawingText(550, 33, "日期:[2010 年 10 月 23 日]");
                this.DrawingText(195, 54, "交易名称:[个人储蓄存款]（[2000]）");
                this.DrawingText(550, 54, "业务流水:[000010121]");
                this.DrawingText(428, 477, "[会计]");
                this.DrawingText(569, 477, "[复核]");
                this.DrawingText(711, 477, "[记账]");
                //this.DrawingText(180, 490, "流水号:[19801898299299181]");
            }
            else
            {
                //解析日期
                var date = DateTime.ParseExact(LoginUserInfo.TradeDate, "yyyyMMdd", null);
                this.DrawingText(195, 33, "机构名称:" + LoginUserInfo.KinbrName);
                if (LoginUserInfo.KinbrNo.Substring(0, 3) == "108")//固始
                {
                    var time = DateTime.ParseExact(LoginUserInfo.GetUserInfo("TradeTime"), "HHmmss", null);
                    this.DrawingText(550, 33, "日期:" + date.ToString("yyyy 年 MM 月 dd 日") + time.ToString("HH 时 mm 分 ss 秒"));
                }
                else
                {
                    this.DrawingText(550, 33, "日期:" + date.ToString("yyyy 年 MM 月 dd 日"));
                }
                this.DrawingText(195, 54, "交易名称:" + attr.TradeModel.Name + "（" + attr.TradeModel.Code + "）");
                this.DrawingText(550, 54, "业务流水:" + attr.BusinessTransaction);
                //this.DrawingText(428, 490, LoginUserInfo.TellerName);
                //this.DrawingText(569, 490, attr.Review);
                //this.DrawingText(711, 490, string.Format("{0}({1})", LoginUserInfo.TellerName, LoginUserInfo.TellerNo));
                //this.DrawingText(180, 490, "柜员流水:" + attr.SerialNumber);
            }
        }

    }
}
