﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Windows;
using Platform.Common;
using System.Windows.Media;
using System.Windows.Input;
using System.ComponentModel;
using Platform.Print;
using TellerSystem.PrintTemplate.Base;
using Platform.Common.RunningParameters;

namespace TellerSystem.PrintTemplate.PrintTemplateData
{
    /// <summary>
    ///电汇凭证
    /// </summary>
    public class Print_PersonalAccountingVoucher : TemplateBase
    {
        public Print_PersonalAccountingVoucher()
        {
            this.PrintType = PrintTypes.PersonalAccountingVoucher;
        }

        protected override void DrawingCommonLayer(Extension.PrintAttributes attr)
        {
            base.DrawingCommonLayer(attr);
            if (DesignerProperties.GetIsInDesignMode(this))
            {
                //this.DrawingText(550, 60, "票    号:[123456]");
                this.DrawingUIElement(396, 51, new TextBlock { Text = "[业务]", FontSize = 20, Width = 75, TextAlignment = TextAlignment.Center });
                this.DrawingUIElement(790, 65, new TextBlock { Text = "[业务]", FontSize = 12, Width = 44, TextAlignment = TextAlignment.Center });
                this.DrawingText(132, 80, "[交易名称（交易码）]");
                this.DrawingText(290, 80, "[yyyy]");
                this.DrawingText(343, 80, "[MM]");
                this.DrawingText(380, 80, "[dd]");
                this.DrawingText(512, 80, "[业务流水]");
                this.DrawingText(750, 83, "[yyyy]");
                this.DrawingText(805, 83, "[MM]");
                this.DrawingText(840, 83, "[dd]");
                this.DrawingText(177, 475, "[事后（xxxxxx）]");
                this.DrawingText(119, 495, "柜员流水（xxxxxx）");
                this.DrawingText(320, 475, "[授权（xxxxxx）]");
                this.DrawingText(450, 475, "[复核（xxxxxx）]");
                this.DrawingText(580, 475, "[经办（xxxxxx）]");
                this.DrawingText(805, 475, "[业务流水]");
            }
            else
            {
                //解析日期
                var date = DateTime.ParseExact(LoginUserInfo.TradeDate, "yyyyMMdd", null);
                this.DrawingUIElement(396, 51, new TextBlock { Text = BusinessType, FontSize = 20, Width = 75, TextAlignment = TextAlignment.Center });
                this.DrawingUIElement(790, 65, new TextBlock { Text = BusinessType, FontSize = 12, Width = 44, TextAlignment = TextAlignment.Center });
                //this.DrawingText(550, 60, "票    号:" + attr.PrintNumber);
                this.DrawingText(132, 80, attr.TradeModel.Name + "（" + attr.TradeModel.Code + "）");
                this.DrawingText(290, 80, date.Year.ToString());
                this.DrawingText(343, 80, date.Month.ToString());
                this.DrawingText(380, 80, date.Day.ToString());
                this.DrawingText(512, 80, attr.BusinessTransaction);
                this.DrawingText(750, 83, date.Year.ToString());
                this.DrawingText(805, 83, date.Month.ToString());
                this.DrawingText(840, 83, date.Day.ToString());
                //需求：隐藏柜面流水的打印
                //this.DrawingText(177, 475, attr.SystemSerialNumber);
                this.DrawingText(119, 495, "柜员流水 " + attr.SerialNumber);
                this.DrawingText(320, 475, attr.Authentic);
                this.DrawingText(450, 475, attr.Review);
                this.DrawingText(580, 475, string.Format("{0}（{1}）", LoginUserInfo.TellerName, LoginUserInfo.TellerNo));
                this.DrawingText(805, 475, attr.BusinessTransaction);
            }
        }

        /// <summary>
        /// 业务类型
        /// </summary>
        public string BusinessType { get; set; }
    }
}
