﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Windows;
using Platform.Common;
using System.Windows.Media;
using System.Windows.Input;
using System.ComponentModel;
using Platform.Print;
using TellerSystem.PrintTemplate.Base;
using Platform.Common.RunningParameters;

namespace TellerSystem.PrintTemplate.PrintTemplateData
{
    /// <summary>
    ///电汇凭证
    /// </summary>
    public class Print_PersonalAccountingVoucher_DepositD : TemplateBase
    {
        public Print_PersonalAccountingVoucher_DepositD()
        {
            this.PrintType = PrintTypes.SavePage;
        }

        protected override void DrawingCommonLayer(Extension.PrintAttributes attr)
        {
            base.DrawingCommonLayer(attr);
            if (DesignerProperties.GetIsInDesignMode(this))
            {
                this.DrawingText(257, 72, "[交易名称（交易码）]");
                this.DrawingText(642, 72, "[交易名称（交易码）]");
                this.DrawingText(237, 55, "[柜员流水:xxxxxx]");
                this.DrawingText(93, 288, "[授权（xxxxxx）]");
                this.DrawingText(380, 288, "[经办（xxxxxx）]");
                this.DrawingText(79, 55, "[业务流水：xxxxxx]");
            }
            else
            {
                this.DrawingText(257, 72, attr.TradeModel.Name + "（" + attr.TradeModel.Code + "）");
                this.DrawingText(642, 72, attr.TradeModel.Name + "（" + attr.TradeModel.Code + "）");
                this.DrawingText(237, 55, "柜员流水 " + attr.SerialNumber);
                this.DrawingText(93, 288, attr.Authentic);
                this.DrawingText(380, 288, string.Format("{0}（{1}）", LoginUserInfo.TellerName, LoginUserInfo.TellerNo));
                this.DrawingText(79, 55, "业务流水：" + attr.BusinessTransaction);
            }
        }

        /// <summary>
        /// 业务类型
        /// </summary>
        public string BusinessType { get; set; }
    }
}
