﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Windows;
using Platform.Common;
using System.Windows.Media;
using System.Windows.Input;
using System.ComponentModel;
using Platform.Print;
using TellerSystem.PrintTemplate.Base;
using Platform.Common.RunningParameters;

namespace TellerSystem.PrintTemplate.PrintTemplateData
{
    /// <summary>
    ///电汇凭证
    /// </summary>
    public class Print_PersonalSpeicalPage : TemplateBase
    {
        public Print_PersonalSpeicalPage()
        {
            this.PrintType = PrintTypes.PensonSpecialPage_QiXian;
        }

        protected override void DrawingCommonLayer(Extension.PrintAttributes attr)
        {
            base.DrawingCommonLayer(attr);
            if (DesignerProperties.GetIsInDesignMode(this))
            {
                this.DrawingText(500, 270, "[交易名称（交易码）]");
                this.DrawingText(340, 270, "[柜员流水:xxxxxx]");
                this.DrawingText(130, 430, "[授权:（xxxxxx）]");
                this.DrawingText(310, 430, "[经办:（xxxxxx）]");
                this.DrawingText(120, 270, "[业务流水:xxxxxx]");
            }
            else
            {
                this.DrawingText(500, 270, attr.TradeModel.Name + "（" + attr.TradeModel.Code + "）");
                this.DrawingText(340, 270, "柜员流水: " + attr.SerialNumber);
                this.DrawingText(130, 430, "授权:" + attr.Authentic);
                this.DrawingText(310, 430, "经办:" + string.Format("{0}（{1}）", LoginUserInfo.TellerName, LoginUserInfo.TellerNo));
                this.DrawingText(120, 270, "业务流水:" + attr.BusinessTransaction);
            }
        }

        /// <summary>
        /// 业务类型
        /// </summary>
        public string BusinessType { get; set; }
    }
}
