﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Windows;
using Platform.Common;
using System.Windows.Media;
using System.Windows.Input;
using System.ComponentModel;
using Platform.Print;
using TellerSystem.PrintTemplate.Base;
using Platform.Common.RunningParameters;

namespace TellerSystem.PrintTemplate.PrintTemplateData
{
    /// <summary>
    /// 税务发票
    /// </summary>
    public class Print_TaxInvoice : TemplateBase
    {
        public Print_TaxInvoice()
        {
            this.PrintType = PrintTypes.TaxInvoice;
        }
        protected override void DrawingCommonLayer(Extension.PrintAttributes attr)
        {
            base.DrawingCommonLayer(attr);
            if (DesignerProperties.GetIsInDesignMode(this))
            {
                this.DrawingText(139, 109, "[开票日期]");
                this.DrawingText(363, 109, "[行业分类]");
            }
            else
            {
                var date = DateTime.ParseExact(LoginUserInfo.TradeDate, "yyyyMMdd", null);
                this.DrawingText(139, 109, date.ToString("yyyy 年 MM 月 dd 日"));
                this.DrawingText(363, 109, Industry);
            }
        }

        /// <summary>
        /// 行业分类
        /// </summary>
        public string Industry { get; set; }
    }
}
