﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Windows;
using Platform.Common;
using System.Windows.Media;
using System.Windows.Input;
using System.ComponentModel;
using Platform.Common.RunningParameters;
using Platform.Print;
using TellerSystem.PrintTemplate.Base;

namespace TellerSystem.PrintTemplate.PrintTemplateData
{
    /// <summary>
    /// 个人凭条正面
    /// </summary>
    public class Print_个人凭条 : TemplateBase
    {
        #region 构造器
        public Print_个人凭条()
        {
            this.PrintType = PrintTypes.PersonalAccountingVoucher;

            if (DesignerProperties.GetIsInDesignMode(this))
            {
                KinbrNo = "00101";
                TellerNo = "000100";
                KinbrName = "xx支行";
                TradeTime = "TradeTime";
                HostSerialNumber = "000012223";
                PrintNumber = "02";
                TradeCode = "2005";
                SerialNumber = "000012";
            }
            else
            {
                //获取营业日期
                DateInfo = DateTime.ParseExact(LoginUserInfo.TradeDate, "yyyyMMdd", null);
                TradeDate = DateInfo.ToString("yyyy/MM/dd");//LoginUserInfo.TradeDate;
                KinbrNo = LoginUserInfo.KinbrNo;
                TellerNo = LoginUserInfo.TellerNo;
                KinbrName = LoginUserInfo.KinbrName + "(" + LoginUserInfo.KinbrNo + ")";
                TradeTime = System.DateTime.Now.ToString("HH:mm:dd");

            }
        }

        protected override void DrawingCommonLayer(Extension.PrintAttributes attr)
        {
            base.DrawingCommonLayer(attr);


        }

        #endregion

        #region 属性
        /// <summary>
        /// 交易类型
        /// </summary>
        public string TradeType { get; set; }

        /// <summary>
        /// 科目
        /// </summary>
        public string Subject { get; set; }

        /// <summary>
        /// 日期
        /// </summary>
        public DateTime DateInfo { get; set; }

        /// <summary>
        /// 付款人姓名
        /// </summary>
        public string PayerName { get; set; }

        /// <summary>
        /// 付款人账号
        /// </summary>
        public string PayerAccount { get; set; }

        /// <summary>
        /// 收款人姓名
        /// </summary>
        public string PayeeName { get; set; }

        /// <summary>
        /// 收款人账号
        /// </summary>
        public string PayeeAccount { get; set; }
        /// <summary>
        /// 转入银行名称
        /// </summary>
        public string IntoBankName { get; set; }

        /// <summary>
        /// 用途
        /// </summary>
        public string Purpose { get; set; }

        /// <summary>
        /// 金额
        /// </summary>
        public string Amount { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        public string Note { get; set; }

        /// <summary>
        /// 事后监督
        /// </summary>
        public string Post_Supervision { get; set; }
        /// <summary>
        /// 复核
        /// </summary>
        public string Review { get; set; }
        /// <summary>
        /// 经办
        /// </summary>
        public string Handling { get; set; }
        /// <summary>
        /// 交易日期
        /// </summary>
        public string TradeDate { get; set; }
        /// <summary>
        /// 机构号
        /// </summary>
        public string KinbrNo { get; set; }

        /// <summary>
        /// 柜员号
        /// </summary>
        public string TellerNo { get; set; }

        /// <summary>
        /// 序号
        /// </summary>
        public string PrintNumber { get; set; }

        /// <summary>
        /// 柜员流水号
        /// </summary>
        public string SerialNumber { get; set; }

        /// <summary>
        /// 交易号
        /// </summary>
        public string TradeCode { get; set; }

        /// <summary>
        /// 机构名称
        /// </summary>
        public string KinbrName { get; set; }

        /// <summary>
        /// 交易时间
        /// </summary>
        public string TradeTime { get; set; }

        /// <summary>
        /// 主机流水值
        /// </summary>
        public string HostSerialNumber { get; set; }
        #endregion
    }
}
