﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;
using Platform.Common;
using Platform.Common.RunningParameters;
using Platform.Print;
using TellerSystem.PrintTemplate.Extension;
using TellerSystem.PrintTemplate.Base;

namespace TellerSystem.PrintTemplate.PrintTemplateData
{
    /// <summary>
    /// 存款证明书1
    /// </summary>
    public class Print_个人存款证明书 : TemplateBase
    {
        public Print_个人存款证明书()
        {
            this.PrintType = PrintTypes.PersonalCDsRecord;
        }

        #region 属性
        /// <summary>
        /// 凭证号码
        /// </summary>
        public string CertificateNum
        {
            get ;
            set ;
        }
      /// <summary>
      /// 日期
      /// </summary>
        public DateTime DateInfo
        {
            get ;
            set;
        }
/// <summary>
/// 存款人姓名
/// </summary>
        public string CustomName
        {
            get ;
            set ;
        }
/// <summary>
/// 签发人
/// </summary>
        public string IssuedName
        {
            get ;
            set ;
        }
/// <summary>
/// 证件类型
/// </summary>
        public string DocumentType
        {
            get ;
            set ;
        }
/// <summary>
/// 证件号码
/// </summary>
        public string IDNum
        {
            get ;
            set ;
        }
/// <summary>
/// 起始年
/// </summary>
        public string StartYear
        {
            get;
            set ;
        }
 /// <summary>
 /// 起始月
 /// </summary>
        public string StartMonth
        {
            get;
            set ;
        }
/// <summary>
/// 起始日
/// </summary>
        public string StartDay
        {
            get;
            set ;
        }
        /// <summary>
        /// 终止年
        /// </summary>
        public string ExpiryYear
        {
            get;
            set ;
        }
/// <summary>
/// 终止月
/// </summary>
        public string ExpiryMonth
        {
            get;
            set;
        }
/// <summary>
/// 终止日
/// </summary>
        public string ExpiryDay
        {
            get ;
            set ;
        }
 /// <summary>
 /// 金额大写
 /// </summary>
        public string DepositAmount_AmtMax
        {
            get ;
            set;
        }
        /// <summary>
        /// 账户号码1
        /// </summary>
        public string AccountNum1
        {
            get;
            set;
        }
/// <summary>
/// 种类1
/// </summary>
        public string Category1
        {
            get;
            set ;
        }
 
        #endregion

        #region 币种1

        public string Currency1
        {
            get { return (string)GetValue(Currency1Property); }
            set { SetValue(Currency1Property, value); }
        }

        // Using a DependencyProperty as the backing store for Currency.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty Currency1Property =
            DependencyProperty.Register("Currency1", typeof(string), typeof(Print_个人存款证明书), new UIPropertyMetadata("币种1"));

        #endregion

        #region 金额1

        public string Amount1
        {
            get { return (string)GetValue(Amount1Property); }
            set { SetValue(Amount1Property, value); }
        }

        // Using a DependencyProperty as the backing store for Amount.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty Amount1Property =
            DependencyProperty.Register("Amount1", typeof(string), typeof(Print_个人存款证明书), new UIPropertyMetadata("金额1"));

        #endregion

        #region 存入日1

        public string DepositData1
        {
            get { return (string)GetValue(DepositData1Property); }
            set { SetValue(DepositData1Property, value); }
        }

        // Using a DependencyProperty as the backing store for DepositData.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty DepositData1Property =
            DependencyProperty.Register("DepositData1", typeof(string), typeof(Print_个人存款证明书), new UIPropertyMetadata("存入日1"));

        #endregion

        #region 到期日1

        public string ExpiryDate1
        {
            get { return (string)GetValue(ExpiryDate1Property); }
            set { SetValue(ExpiryDate1Property, value); }
        }

        // Using a DependencyProperty as the backing store for ExpiryDate.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ExpiryDate1Property =
            DependencyProperty.Register("ExpiryDate1", typeof(string), typeof(Print_个人存款证明书), new UIPropertyMetadata("到期日1"));

        #endregion



        #region 账户号码2

        public string AccountNum2
        {
            get { return (string)GetValue(AccountNum2Property); }
            set { SetValue(AccountNum2Property, value); }
        }

        // Using a DependencyProperty as the backing store for AccountNum.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty AccountNum2Property =
            DependencyProperty.Register("AccountNum2", typeof(string), typeof(Print_个人存款证明书), new UIPropertyMetadata("账户号码2"));

        #endregion

        #region 种类2

        public string Category2
        {
            get { return (string)GetValue(Category2Property); }
            set { SetValue(Category2Property, value); }
        }

        // Using a DependencyProperty as the backing store for Category.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty Category2Property =
            DependencyProperty.Register("Category2", typeof(string), typeof(Print_个人存款证明书), new UIPropertyMetadata("种类2"));

        #endregion

        #region 币种2

        public string Currency2
        {
            get { return (string)GetValue(Currency2Property); }
            set { SetValue(Currency2Property, value); }
        }

        // Using a DependencyProperty as the backing store for Currency.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty Currency2Property =
            DependencyProperty.Register("Currency2", typeof(string), typeof(Print_个人存款证明书), new UIPropertyMetadata("币种2"));

        #endregion

        #region 金额2

        public string Amount2
        {
            get { return (string)GetValue(Amount2Property); }
            set { SetValue(Amount2Property, value); }
        }

        // Using a DependencyProperty as the backing store for Amount.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty Amount2Property =
            DependencyProperty.Register("Amount2", typeof(string), typeof(Print_个人存款证明书), new UIPropertyMetadata("金额2"));

        #endregion

        #region 存入日2

        public string DepositData2
        {
            get { return (string)GetValue(DepositData2Property); }
            set { SetValue(DepositData2Property, value); }
        }

        // Using a DependencyProperty as the backing store for DepositData.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty DepositData2Property =
            DependencyProperty.Register("DepositData2", typeof(string), typeof(Print_个人存款证明书), new UIPropertyMetadata("存入日2"));

        #endregion

        #region 到期日2

        public string ExpiryDate2
        {
            get { return (string)GetValue(ExpiryDate2Property); }
            set { SetValue(ExpiryDate2Property, value); }
        }

        // Using a DependencyProperty as the backing store for ExpiryDate.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ExpiryDate2Property =
            DependencyProperty.Register("ExpiryDate2", typeof(string), typeof(Print_个人存款证明书), new UIPropertyMetadata("到期日2"));

        #endregion

        #region 账户号码3

        public string AccountNum3
        {
            get { return (string)GetValue(AccountNum3Property); }
            set { SetValue(AccountNum3Property, value); }
        }

        // Using a DependencyProperty as the backing store for AccountNum.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty AccountNum3Property =
            DependencyProperty.Register("AccountNum3", typeof(string), typeof(Print_个人存款证明书), new UIPropertyMetadata("账户号码3"));

        #endregion

        #region 种类3

        public string Category3
        {
            get { return (string)GetValue(Category3Property); }
            set { SetValue(Category3Property, value); }
        }

        // Using a DependencyProperty as the backing store for Category.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty Category3Property =
            DependencyProperty.Register("Category3", typeof(string), typeof(Print_个人存款证明书), new UIPropertyMetadata("种类3"));

        #endregion

        #region 币种3

        public string Currency3
        {
            get { return (string)GetValue(Currency3Property); }
            set { SetValue(Currency3Property, value); }
        }

        // Using a DependencyProperty as the backing store for Currency.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty Currency3Property =
            DependencyProperty.Register("Currency3", typeof(string), typeof(Print_个人存款证明书), new UIPropertyMetadata("币种3"));

        #endregion

        #region 金额3

        public string Amount3
        {
            get { return (string)GetValue(Amount3Property); }
            set { SetValue(Amount3Property, value); }
        }

        // Using a DependencyProperty as the backing store for Amount.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty Amount3Property =
            DependencyProperty.Register("Amount3", typeof(string), typeof(Print_个人存款证明书), new UIPropertyMetadata("金额3"));

        #endregion

        #region 存入日3

        public string DepositData3
        {
            get { return (string)GetValue(DepositData3Property); }
            set { SetValue(DepositData3Property, value); }
        }

        // Using a DependencyProperty as the backing store for DepositData.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty DepositData3Property =
            DependencyProperty.Register("DepositData3", typeof(string), typeof(Print_个人存款证明书), new UIPropertyMetadata("存入日3"));

        #endregion

        #region 到期日3

        public string ExpiryDate3
        {
            get { return (string)GetValue(ExpiryDate3Property); }
            set { SetValue(ExpiryDate3Property, value); }
        }

        // Using a DependencyProperty as the backing store for ExpiryDate.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ExpiryDate3Property =
            DependencyProperty.Register("ExpiryDate3", typeof(string), typeof(Print_个人存款证明书), new UIPropertyMetadata("到期日3"));

        #endregion

        #region 账户号码4

        public string AccountNum4
        {
            get { return (string)GetValue(AccountNum4Property); }
            set { SetValue(AccountNum4Property, value); }
        }

        // Using a DependencyProperty as the backing store for AccountNum.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty AccountNum4Property =
            DependencyProperty.Register("AccountNum4", typeof(string), typeof(Print_个人存款证明书), new UIPropertyMetadata("账户号码4"));

        #endregion

        #region 种类4

        public string Category4
        {
            get { return (string)GetValue(Category4Property); }
            set { SetValue(Category4Property, value); }
        }

        // Using a DependencyProperty as the backing store for Category.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty Category4Property =
            DependencyProperty.Register("Category4", typeof(string), typeof(Print_个人存款证明书), new UIPropertyMetadata("种类4"));

        #endregion

        #region 币种4

        public string Currency4
        {
            get { return (string)GetValue(Currency4Property); }
            set { SetValue(Currency4Property, value); }
        }

        // Using a DependencyProperty as the backing store for Currency.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty Currency4Property =
            DependencyProperty.Register("Currency4", typeof(string), typeof(Print_个人存款证明书), new UIPropertyMetadata("币种4"));

        #endregion

        #region 金额4

        public string Amount4
        {
            get { return (string)GetValue(Amount4Property); }
            set { SetValue(Amount4Property, value); }
        }

        // Using a DependencyProperty as the backing store for Amount.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty Amount4Property =
            DependencyProperty.Register("Amount4", typeof(string), typeof(Print_个人存款证明书), new UIPropertyMetadata("金额4"));

        #endregion

        #region 存入日4

        public string DepositData4
        {
            get { return (string)GetValue(DepositData4Property); }
            set { SetValue(DepositData4Property, value); }
        }

        // Using a DependencyProperty as the backing store for DepositData.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty DepositData4Property =
            DependencyProperty.Register("DepositData4", typeof(string), typeof(Print_个人存款证明书), new UIPropertyMetadata("存入日4"));

        #endregion

        #region 到期日4

        public string ExpiryDate4
        {
            get { return (string)GetValue(ExpiryDate4Property); }
            set { SetValue(ExpiryDate4Property, value); }
        }

        // Using a DependencyProperty as the backing store for ExpiryDate.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ExpiryDate4Property =
            DependencyProperty.Register("ExpiryDate4", typeof(string), typeof(Print_个人存款证明书), new UIPropertyMetadata("到期日4"));

        #endregion
    }
}