﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Windows;
using Platform.Common;
using System.Windows.Media;
using System.Windows.Input;
using System.ComponentModel;
using Platform.Print;
using TellerSystem.PrintTemplate.Extension;
using Platform.Common.RunningParameters;
using TellerSystem.PrintTemplate.Bankbook;
using TellerSystem.PrintTemplate.Base;

namespace TellerSystem.PrintTemplate.PrintTemplateData
{
    public class Print_储蓄存折首页 : TemplateBase
    {

        public Print_储蓄存折首页()
        {
            this.PrintType = PrintTypes.BankBookFirstPage;
        }

        protected override void DrawingCommonLayer(PrintAttributes attr)
        {
            base.DrawingCommonLayer(attr);
        }

        #region 打印属性
        /// <summary>
        /// 户名
        /// </summary>
        public string AccountName
        {
            get { return (string)GetValue(AccountNameProperty); }
            set { SetValue(AccountNameProperty, value); }
        }
        public static readonly DependencyProperty AccountNameProperty =
          DependencyProperty.Register("AccountName", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 币种
        /// </summary>
        public string Currency
        {
            get { return (string)GetValue(CurrencyProperty); }
            set { SetValue(CurrencyProperty, value); }
        }
        public static readonly DependencyProperty CurrencyProperty =
         DependencyProperty.Register("Currency", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 账号
        /// </summary>
        public string AccountNo
        {
            get { return (string)GetValue(AccountNoProperty); }
            set { SetValue(AccountNoProperty, value); }
        }
        public static readonly DependencyProperty AccountNoProperty =
            DependencyProperty.Register("AccountNo", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 存款类别
        /// </summary>
        public string DepositType
        {
            get { return (string)GetValue(DepositTypeProperty); }
            set { SetValue(DepositTypeProperty, value); }
        }
        public static readonly DependencyProperty DepositTypeProperty =
         DependencyProperty.Register("DepositType", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 开户日期
        /// </summary>
        public string AccountDate
        {
            get { return (string)GetValue(AccountDateProperty); }
            set { SetValue(AccountDateProperty, value); }
        }
        public static readonly DependencyProperty AccountDateProperty =
         DependencyProperty.Register("AccountDate", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 印密
        /// </summary>
        public string PasswordOrSeal
        {
            get { return (string)GetValue(PasswordOrSealProperty); }
            set { SetValue(PasswordOrSealProperty, value); }
        }
        public static readonly DependencyProperty PasswordOrSealProperty =
        DependencyProperty.Register("PasswordOrSeal", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 开户银行
        /// </summary>
        public string AccountBank
        {
            get { return (string)GetValue(AccountBankProperty); }
            set { SetValue(AccountBankProperty, value); }
        }

        public static readonly DependencyProperty AccountBankProperty =
         DependencyProperty.Register("AccountBank", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 存折编号
        /// </summary>
        public string Number
        {
            get { return (string)GetValue(NumberProperty); }
            set { SetValue(NumberProperty, value); }
        }
        public static readonly DependencyProperty NumberProperty =
            DependencyProperty.Register("Number", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 支付行号
        /// </summary>
        public string PaySysCode
        {
            get { return (string)GetValue(PaySysCodeProperty); }
            set { SetValue(PaySysCodeProperty, value); }
        }
        public static readonly DependencyProperty PaySysCodeProperty =
            DependencyProperty.Register("PaySysCode", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));


        /// <summary>
        /// 备注
        /// </summary>
        public string Summary
        {
            get { return (string)GetValue(SummaryProperty); }
            set { SetValue(SummaryProperty, value); }
        }

        public static readonly DependencyProperty SummaryProperty =
            DependencyProperty.Register("Summary", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));

        /// <summary>
        /// 办卡标志
        /// </summary>
        public string CardFlag
        {
            get { return (string)GetValue(CardFlagProperty); }
            set { SetValue(CardFlagProperty, value); }
        }

        public static readonly DependencyProperty CardFlagProperty =
            DependencyProperty.Register("CardFlag", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));


        /// <summary>
        /// 通存通兑
        /// </summary>
        public string TCTD
        {
            get { return (string)GetValue(TCTDProperty); }
            set { SetValue(TCTDProperty, value); }
        }

        public static readonly DependencyProperty TCTDProperty =
            DependencyProperty.Register("TCTD", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        #endregion

        #region 打印数据
        /// <summary>
        /// 子账户数据
        /// </summary>
        public List<CXCZPageEntity> PageData;

        #region 第一行
        public string PageData_1_1
        {
            get { return (string)GetValue(PageData_1_1Property); }
            //get { return _PageData[0].TxDate; }
            set { SetValue(PageData_1_1Property, value); }
        }

        public static readonly DependencyProperty PageData_1_1Property =
            DependencyProperty.Register("PageData_1_1", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_1_2
        {
            get { return (string)GetValue(PageData_1_2Property); }
            // get { return _PageData[0].CurNo; }
            set { SetValue(PageData_1_2Property, value); }
        }

        public static readonly DependencyProperty PageData_1_2Property =
            DependencyProperty.Register("PageData_1_2", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_1_3
        {
            get { return (string)GetValue(PageData_1_3Property); }
            //get { return _PageData[0].DespInfo; }
            set { SetValue(PageData_1_3Property, value); }
        }

        public static readonly DependencyProperty PageData_1_3Property =
            DependencyProperty.Register("PageData_1_3", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_1_4
        {
            get { return (string)GetValue(PageData_1_4Property); }
            // get { return _PageData[0].BegDate; }
            set { SetValue(PageData_1_4Property, value); }
        }

        public static readonly DependencyProperty PageData_1_4Property =
            DependencyProperty.Register("PageData_1_4", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_1_5
        {
            get { return (string)GetValue(PageData_1_5Property); }
            //get { return _PageData[0].DepoistType; }
            set { SetValue(PageData_1_5Property, value); }
        }

        public static readonly DependencyProperty PageData_1_5Property =
            DependencyProperty.Register("PageData_1_5", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_1_6
        {
            get { return (string)GetValue(PageData_1_6Property); }
            // get { return _PageData[0].Term; }
            set { SetValue(PageData_1_6Property, value); }
        }

        public static readonly DependencyProperty PageData_1_6Property =
            DependencyProperty.Register("PageData_1_6", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));

        #endregion

        #region 第二行
        public string PageData_2_1
        {
            get { return (string)GetValue(PageData_2_1Property); }
            //get { return _PageData[0].TxDate; }
            set { SetValue(PageData_2_1Property, value); }
        }

        public static readonly DependencyProperty PageData_2_1Property =
            DependencyProperty.Register("PageData_2_1", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_2_2
        {
            get { return (string)GetValue(PageData_2_2Property); }
            // get { return _PageData[0].CurNo; }
            set { SetValue(PageData_2_2Property, value); }
        }

        public static readonly DependencyProperty PageData_2_2Property =
            DependencyProperty.Register("PageData_2_2", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_2_3
        {
            get { return (string)GetValue(PageData_2_3Property); }
            //get { return _PageData[0].DespInfo; }
            set { SetValue(PageData_2_3Property, value); }
        }

        public static readonly DependencyProperty PageData_2_3Property =
            DependencyProperty.Register("PageData_2_3", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_2_4
        {
            get { return (string)GetValue(PageData_2_4Property); }
            // get { return _PageData[0].BegDate; }
            set { SetValue(PageData_2_4Property, value); }
        }

        public static readonly DependencyProperty PageData_2_4Property =
            DependencyProperty.Register("PageData_2_4", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_2_5
        {
            get { return (string)GetValue(PageData_2_5Property); }
            //get { return _PageData[0].DepoistType; }
            set { SetValue(PageData_2_5Property, value); }
        }

        public static readonly DependencyProperty PageData_2_5Property =
            DependencyProperty.Register("PageData_2_5", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_2_6
        {
            get { return (string)GetValue(PageData_2_6Property); }
            // get { return _PageData[0].Term; }
            set { SetValue(PageData_2_6Property, value); }
        }

        public static readonly DependencyProperty PageData_2_6Property =
            DependencyProperty.Register("PageData_2_6", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));

        #endregion

        #region 第三行
        public string PageData_3_1
        {
            get { return (string)GetValue(PageData_3_1Property); }
            //get { return _PageData[0].TxDate; }
            set { SetValue(PageData_3_1Property, value); }
        }

        public static readonly DependencyProperty PageData_3_1Property =
            DependencyProperty.Register("PageData_3_1", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_3_2
        {
            get { return (string)GetValue(PageData_3_2Property); }
            // get { return _PageData[0].CurNo; }
            set { SetValue(PageData_3_2Property, value); }
        }

        public static readonly DependencyProperty PageData_3_2Property =
            DependencyProperty.Register("PageData_3_2", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_3_3
        {
            get { return (string)GetValue(PageData_3_3Property); }
            //get { return _PageData[0].DespInfo; }
            set { SetValue(PageData_3_3Property, value); }
        }

        public static readonly DependencyProperty PageData_3_3Property =
            DependencyProperty.Register("PageData_3_3", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_3_4
        {
            get { return (string)GetValue(PageData_3_4Property); }
            // get { return _PageData[0].BegDate; }
            set { SetValue(PageData_3_4Property, value); }
        }

        public static readonly DependencyProperty PageData_3_4Property =
            DependencyProperty.Register("PageData_3_4", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_3_5
        {
            get { return (string)GetValue(PageData_3_5Property); }
            //get { return _PageData[0].DepoistType; }
            set { SetValue(PageData_3_5Property, value); }
        }

        public static readonly DependencyProperty PageData_3_5Property =
            DependencyProperty.Register("PageData_3_5", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_3_6
        {
            get { return (string)GetValue(PageData_3_6Property); }
            // get { return _PageData[0].Term; }
            set { SetValue(PageData_3_6Property, value); }
        }

        public static readonly DependencyProperty PageData_3_6Property =
            DependencyProperty.Register("PageData_3_6", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));

        #endregion

        #region 第四行
        public string PageData_4_1
        {
            get { return (string)GetValue(PageData_4_1Property); }
            //get { return _PageData[0].TxDate; }
            set { SetValue(PageData_4_1Property, value); }
        }

        public static readonly DependencyProperty PageData_4_1Property =
            DependencyProperty.Register("PageData_4_1", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_4_2
        {
            get { return (string)GetValue(PageData_4_2Property); }
            // get { return _PageData[0].CurNo; }
            set { SetValue(PageData_4_2Property, value); }
        }

        public static readonly DependencyProperty PageData_4_2Property =
            DependencyProperty.Register("PageData_4_2", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_4_3
        {
            get { return (string)GetValue(PageData_4_3Property); }
            //get { return _PageData[0].DespInfo; }
            set { SetValue(PageData_4_3Property, value); }
        }

        public static readonly DependencyProperty PageData_4_3Property =
            DependencyProperty.Register("PageData_4_3", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_4_4
        {
            get { return (string)GetValue(PageData_4_4Property); }
            // get { return _PageData[0].BegDate; }
            set { SetValue(PageData_4_4Property, value); }
        }

        public static readonly DependencyProperty PageData_4_4Property =
            DependencyProperty.Register("PageData_4_4", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_4_5
        {
            get { return (string)GetValue(PageData_4_5Property); }
            //get { return _PageData[0].DepoistType; }
            set { SetValue(PageData_4_5Property, value); }
        }

        public static readonly DependencyProperty PageData_4_5Property =
            DependencyProperty.Register("PageData_4_5", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_4_6
        {
            get { return (string)GetValue(PageData_4_6Property); }
            // get { return _PageData[0].Term; }
            set { SetValue(PageData_4_6Property, value); }
        }

        public static readonly DependencyProperty PageData_4_6Property =
            DependencyProperty.Register("PageData_4_6", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));

        #endregion

        #region 第五行
        public string PageData_5_1
        {
            get { return (string)GetValue(PageData_5_1Property); }
            //get { return _PageData[0].TxDate; }
            set { SetValue(PageData_5_1Property, value); }
        }

        public static readonly DependencyProperty PageData_5_1Property =
            DependencyProperty.Register("PageData_5_1", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_5_2
        {
            get { return (string)GetValue(PageData_5_2Property); }
            // get { return _PageData[0].CurNo; }
            set { SetValue(PageData_5_2Property, value); }
        }

        public static readonly DependencyProperty PageData_5_2Property =
            DependencyProperty.Register("PageData_5_2", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_5_3
        {
            get { return (string)GetValue(PageData_5_3Property); }
            //get { return _PageData[0].DespInfo; }
            set { SetValue(PageData_5_3Property, value); }
        }

        public static readonly DependencyProperty PageData_5_3Property =
            DependencyProperty.Register("PageData_5_3", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_5_4
        {
            get { return (string)GetValue(PageData_5_4Property); }
            // get { return _PageData[0].BegDate; }
            set { SetValue(PageData_5_4Property, value); }
        }

        public static readonly DependencyProperty PageData_5_4Property =
            DependencyProperty.Register("PageData_5_4", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_5_5
        {
            get { return (string)GetValue(PageData_5_5Property); }
            //get { return _PageData[0].DepoistType; }
            set { SetValue(PageData_5_5Property, value); }
        }

        public static readonly DependencyProperty PageData_5_5Property =
            DependencyProperty.Register("PageData_5_5", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_5_6
        {
            get { return (string)GetValue(PageData_5_6Property); }
            // get { return _PageData[0].Term; }
            set { SetValue(PageData_5_6Property, value); }
        }

        public static readonly DependencyProperty PageData_5_6Property =
            DependencyProperty.Register("PageData_5_6", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));

        #endregion

        #region 第六行
        public string PageData_6_1
        {
            get { return (string)GetValue(PageData_6_1Property); }
            //get { return _PageData[0].TxDate; }
            set { SetValue(PageData_6_1Property, value); }
        }

        public static readonly DependencyProperty PageData_6_1Property =
            DependencyProperty.Register("PageData_6_1", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_6_2
        {
            get { return (string)GetValue(PageData_6_2Property); }
            // get { return _PageData[0].CurNo; }
            set { SetValue(PageData_6_2Property, value); }
        }

        public static readonly DependencyProperty PageData_6_2Property =
            DependencyProperty.Register("PageData_6_2", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_6_3
        {
            get { return (string)GetValue(PageData_6_3Property); }
            //get { return _PageData[0].DespInfo; }
            set { SetValue(PageData_6_3Property, value); }
        }

        public static readonly DependencyProperty PageData_6_3Property =
            DependencyProperty.Register("PageData_6_3", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_6_4
        {
            get { return (string)GetValue(PageData_6_4Property); }
            // get { return _PageData[0].BegDate; }
            set { SetValue(PageData_6_4Property, value); }
        }

        public static readonly DependencyProperty PageData_6_4Property =
            DependencyProperty.Register("PageData_6_4", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_6_5
        {
            get { return (string)GetValue(PageData_6_5Property); }
            //get { return _PageData[0].DepoistType; }
            set { SetValue(PageData_6_5Property, value); }
        }

        public static readonly DependencyProperty PageData_6_5Property =
            DependencyProperty.Register("PageData_6_5", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_6_6
        {
            get { return (string)GetValue(PageData_6_6Property); }
            // get { return _PageData[0].Term; }
            set { SetValue(PageData_6_6Property, value); }
        }

        public static readonly DependencyProperty PageData_6_6Property =
            DependencyProperty.Register("PageData_6_6", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));

        #endregion

        #region 第七行
        public string PageData_7_1
        {
            get { return (string)GetValue(PageData_7_1Property); }
            //get { return _PageData[0].TxDate; }
            set { SetValue(PageData_7_1Property, value); }
        }

        public static readonly DependencyProperty PageData_7_1Property =
            DependencyProperty.Register("PageData_7_1", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_7_2
        {
            get { return (string)GetValue(PageData_7_2Property); }
            // get { return _PageData[0].CurNo; }
            set { SetValue(PageData_7_2Property, value); }
        }

        public static readonly DependencyProperty PageData_7_2Property =
            DependencyProperty.Register("PageData_7_2", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_7_3
        {
            get { return (string)GetValue(PageData_7_3Property); }
            //get { return _PageData[0].DespInfo; }
            set { SetValue(PageData_7_3Property, value); }
        }

        public static readonly DependencyProperty PageData_7_3Property =
            DependencyProperty.Register("PageData_7_3", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_7_4
        {
            get { return (string)GetValue(PageData_7_4Property); }
            // get { return _PageData[0].BegDate; }
            set { SetValue(PageData_7_4Property, value); }
        }

        public static readonly DependencyProperty PageData_7_4Property =
            DependencyProperty.Register("PageData_7_4", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_7_5
        {
            get { return (string)GetValue(PageData_7_5Property); }
            //get { return _PageData[0].DepoistType; }
            set { SetValue(PageData_7_5Property, value); }
        }

        public static readonly DependencyProperty PageData_7_5Property =
            DependencyProperty.Register("PageData_7_5", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_7_6
        {
            get { return (string)GetValue(PageData_7_6Property); }
            // get { return _PageData[0].Term; }
            set { SetValue(PageData_7_6Property, value); }
        }

        public static readonly DependencyProperty PageData_7_6Property =
            DependencyProperty.Register("PageData_7_6", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));

        #endregion

        #region 第八行
        public string PageData_8_1
        {
            get { return (string)GetValue(PageData_8_1Property); }
            //get { return _PageData[0].TxDate; }
            set { SetValue(PageData_8_1Property, value); }
        }

        public static readonly DependencyProperty PageData_8_1Property =
            DependencyProperty.Register("PageData_8_1", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_8_2
        {
            get { return (string)GetValue(PageData_8_2Property); }
            // get { return _PageData[0].CurNo; }
            set { SetValue(PageData_8_2Property, value); }
        }

        public static readonly DependencyProperty PageData_8_2Property =
            DependencyProperty.Register("PageData_8_2", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_8_3
        {
            get { return (string)GetValue(PageData_8_3Property); }
            //get { return _PageData[0].DespInfo; }
            set { SetValue(PageData_8_3Property, value); }
        }

        public static readonly DependencyProperty PageData_8_3Property =
            DependencyProperty.Register("PageData_8_3", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_8_4
        {
            get { return (string)GetValue(PageData_8_4Property); }
            // get { return _PageData[0].BegDate; }
            set { SetValue(PageData_8_4Property, value); }
        }

        public static readonly DependencyProperty PageData_8_4Property =
            DependencyProperty.Register("PageData_8_4", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_8_5
        {
            get { return (string)GetValue(PageData_8_5Property); }
            //get { return _PageData[0].DepoistType; }
            set { SetValue(PageData_8_5Property, value); }
        }

        public static readonly DependencyProperty PageData_8_5Property =
            DependencyProperty.Register("PageData_8_5", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_8_6
        {
            get { return (string)GetValue(PageData_8_6Property); }
            // get { return _PageData[0].Term; }
            set { SetValue(PageData_8_6Property, value); }
        }

        public static readonly DependencyProperty PageData_8_6Property =
            DependencyProperty.Register("PageData_8_6", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));

        #endregion

        #region 第九行
        public string PageData_9_1
        {
            get { return (string)GetValue(PageData_9_1Property); }
            //get { return _PageData[0].TxDate; }
            set { SetValue(PageData_9_1Property, value); }
        }

        public static readonly DependencyProperty PageData_9_1Property =
            DependencyProperty.Register("PageData_9_1", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_9_2
        {
            get { return (string)GetValue(PageData_9_2Property); }
            // get { return _PageData[0].CurNo; }
            set { SetValue(PageData_9_2Property, value); }
        }

        public static readonly DependencyProperty PageData_9_2Property =
            DependencyProperty.Register("PageData_9_2", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_9_3
        {
            get { return (string)GetValue(PageData_9_3Property); }
            //get { return _PageData[0].DespInfo; }
            set { SetValue(PageData_9_3Property, value); }
        }

        public static readonly DependencyProperty PageData_9_3Property =
            DependencyProperty.Register("PageData_9_3", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_9_4
        {
            get { return (string)GetValue(PageData_9_4Property); }
            // get { return _PageData[0].BegDate; }
            set { SetValue(PageData_9_4Property, value); }
        }

        public static readonly DependencyProperty PageData_9_4Property =
            DependencyProperty.Register("PageData_9_4", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_9_5
        {
            get { return (string)GetValue(PageData_9_5Property); }
            //get { return _PageData[0].DepoistType; }
            set { SetValue(PageData_9_5Property, value); }
        }

        public static readonly DependencyProperty PageData_9_5Property =
            DependencyProperty.Register("PageData_9_5", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_9_6
        {
            get { return (string)GetValue(PageData_9_6Property); }
            // get { return _PageData[0].Term; }
            set { SetValue(PageData_9_6Property, value); }
        }

        public static readonly DependencyProperty PageData_9_6Property =
            DependencyProperty.Register("PageData_9_6", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));

        #endregion

        #region 第十行
        public string PageData_10_1
        {
            get { return (string)GetValue(PageData_10_1Property); }
            //get { return _PageData[0].TxDate; }
            set { SetValue(PageData_10_1Property, value); }
        }

        public static readonly DependencyProperty PageData_10_1Property =
            DependencyProperty.Register("PageData_10_1", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_10_2
        {
            get { return (string)GetValue(PageData_10_2Property); }
            // get { return _PageData[0].CurNo; }
            set { SetValue(PageData_10_2Property, value); }
        }

        public static readonly DependencyProperty PageData_10_2Property =
            DependencyProperty.Register("PageData_10_2", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_10_3
        {
            get { return (string)GetValue(PageData_10_3Property); }
            //get { return _PageData[0].DespInfo; }
            set { SetValue(PageData_10_3Property, value); }
        }

        public static readonly DependencyProperty PageData_10_3Property =
            DependencyProperty.Register("PageData_10_3", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_10_4
        {
            get { return (string)GetValue(PageData_10_4Property); }
            // get { return _PageData[0].BegDate; }
            set { SetValue(PageData_10_4Property, value); }
        }

        public static readonly DependencyProperty PageData_10_4Property =
            DependencyProperty.Register("PageData_10_4", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_10_5
        {
            get { return (string)GetValue(PageData_10_5Property); }
            //get { return _PageData[0].DepoistType; }
            set { SetValue(PageData_10_5Property, value); }
        }

        public static readonly DependencyProperty PageData_10_5Property =
            DependencyProperty.Register("PageData_10_5", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_10_6
        {
            get { return (string)GetValue(PageData_10_6Property); }
            // get { return _PageData[0].Term; }
            set { SetValue(PageData_10_6Property, value); }
        }

        public static readonly DependencyProperty PageData_10_6Property =
            DependencyProperty.Register("PageData_10_6", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        #endregion

        #region 第十一行
        public string PageData_11_1
        {
            get { return (string)GetValue(PageData_11_1Property); }
            set { SetValue(PageData_11_1Property, value); }
        }

        public static readonly DependencyProperty PageData_11_1Property =
            DependencyProperty.Register("PageData_11_1", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_11_2
        {
            get { return (string)GetValue(PageData_11_2Property); }
            set { SetValue(PageData_11_2Property, value); }
        }

        public static readonly DependencyProperty PageData_11_2Property =
            DependencyProperty.Register("PageData_11_2", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_11_3
        {
            get { return (string)GetValue(PageData_11_3Property); }
            set { SetValue(PageData_11_3Property, value); }
        }

        public static readonly DependencyProperty PageData_11_3Property =
            DependencyProperty.Register("PageData_11_3", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_11_4
        {
            get { return (string)GetValue(PageData_11_4Property); }
            set { SetValue(PageData_11_4Property, value); }
        }

        public static readonly DependencyProperty PageData_11_4Property =
            DependencyProperty.Register("PageData_11_4", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_11_5
        {
            get { return (string)GetValue(PageData_11_5Property); }
            set { SetValue(PageData_11_5Property, value); }
        }

        public static readonly DependencyProperty PageData_11_5Property =
            DependencyProperty.Register("PageData_11_5", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_11_6
        {
            get { return (string)GetValue(PageData_11_6Property); }
            set { SetValue(PageData_11_6Property, value); }
        }

        public static readonly DependencyProperty PageData_11_6Property =
            DependencyProperty.Register("PageData_11_6", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));

        #endregion

        #region 第十二行
        public string PageData_12_1
        {
            get { return (string)GetValue(PageData_12_1Property); }
            set { SetValue(PageData_12_1Property, value); }
        }

        public static readonly DependencyProperty PageData_12_1Property =
            DependencyProperty.Register("PageData_12_1", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_12_2
        {
            get { return (string)GetValue(PageData_12_2Property); }

            set { SetValue(PageData_12_2Property, value); }
        }

        public static readonly DependencyProperty PageData_12_2Property =
            DependencyProperty.Register("PageData_12_2", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_12_3
        {
            get { return (string)GetValue(PageData_12_3Property); }
            set { SetValue(PageData_12_3Property, value); }
        }

        public static readonly DependencyProperty PageData_12_3Property =
            DependencyProperty.Register("PageData_12_3", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_12_4
        {
            get { return (string)GetValue(PageData_12_4Property); }
            set { SetValue(PageData_12_4Property, value); }
        }

        public static readonly DependencyProperty PageData_12_4Property =
            DependencyProperty.Register("PageData_12_4", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_12_5
        {
            get { return (string)GetValue(PageData_12_5Property); }
            set { SetValue(PageData_12_5Property, value); }
        }

        public static readonly DependencyProperty PageData_12_5Property =
            DependencyProperty.Register("PageData_12_5", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        public string PageData_12_6
        {
            get { return (string)GetValue(PageData_12_6Property); }
            set { SetValue(PageData_12_6Property, value); }
        }

        public static readonly DependencyProperty PageData_12_6Property =
            DependencyProperty.Register("PageData_12_6", typeof(string), typeof(Print_储蓄存折首页), new UIPropertyMetadata(string.Empty));
        #endregion
        #endregion
    }
}
