﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;
using Platform.Common;
using Platform.Common.RunningParameters;
using Platform.Print;
using TellerSystem.PrintTemplate.Extension;
using TellerSystem.PrintTemplate.Base;

namespace TellerSystem.PrintTemplate.PrintTemplateData
{
    /// <summary>
    /// 定期存单
    /// </summary>
    public class Print_单位定期存单 : TemplateBase
    {
       
        public Print_单位定期存单()
        {
            this.PrintType = PrintTypes.EnterpriseRegularlyCDs;
        }
        #region 打印属性
        #region 存入日期
        /// <summary>
        /// 存入日期
        /// </summary>
        public DateTime DateInfo
        {
            get { return (DateTime)GetValue(DateInfoProperty); }
            set { SetValue(DateInfoProperty, value); }
        }
        public static readonly DependencyProperty DateInfoProperty =
           DependencyProperty.Register("DateInfo", typeof(DateTime), typeof(Print_单位定期存单), new UIPropertyMetadata(DateTime.Now));
        #endregion

        #region 账号
        /// <summary>
        /// 账号
        /// </summary>
        public string Account
        {
            get { return (string)GetValue(AccountProperty); }
            set { SetValue(AccountProperty, value); }
        }
        public static readonly DependencyProperty AccountProperty =
            DependencyProperty.Register("Account", typeof(string), typeof(Print_单位定期存单), new UIPropertyMetadata("账号"));
        #endregion

        #region 户名
        /// <summary>
        /// 户名
        /// </summary>
        public string Username
        {
            get { return (string)GetValue(UsernameProperty); }
            set { SetValue(UsernameProperty, value); }
        }
        public static readonly DependencyProperty UsernameProperty =
            DependencyProperty.Register("Username", typeof(string), typeof(Print_单位定期存单), new UIPropertyMetadata("户名"));
        #endregion

        #region 存期
        /// <summary>
        /// 存期
        /// </summary>
        public string Depositperiod
        {
            get { return (string)GetValue(DepositperiodProperty); }
            set { SetValue(DepositperiodProperty, value); }
        }
        public static readonly DependencyProperty DepositperiodProperty =
           DependencyProperty.Register("Depositperiod", typeof(string), typeof(Print_单位定期存单), new UIPropertyMetadata("存期"));
        #endregion

        #region 利率
        /// <summary>
        /// 利率
        /// </summary>
        public string Interestrate
        {
            get { return (string)GetValue(InterestrateProperty); }
            set { SetValue(InterestrateProperty, value); }
        }
        public static readonly DependencyProperty InterestrateProperty =
           DependencyProperty.Register("Interestrate", typeof(string), typeof(Print_单位定期存单), new UIPropertyMetadata("利率"));
        #endregion

        #region 到期日
        /// <summary>
        /// 到期日
        /// </summary>
        public DateTime? Maturity
        {
            get { return (DateTime?)GetValue(MaturityProperty); }
            set { SetValue(MaturityProperty, value); }
        }
        public static readonly DependencyProperty MaturityProperty =
            DependencyProperty.Register("Maturity", typeof(DateTime?), typeof(Print_单位定期存单), new UIPropertyMetadata(default(DateTime)));
        #endregion

        #region 金额大写
        /// <summary>
        /// 金额大写
        /// </summary>
        public string Settlement_AmtMax
        {
            get { return (string)GetValue(Settlement_AmtMaxProperty); }
            set { SetValue(Settlement_AmtMaxProperty, value); }
        }
        public static readonly DependencyProperty Settlement_AmtMaxProperty =
            DependencyProperty.Register("Settlement_AmtMax", typeof(string), typeof(Print_单位定期存单), new UIPropertyMetadata("金额大写"));
        #endregion

        #region 金额小写
        /// <summary>
        /// 金额小写
        /// </summary>
        public string Settlement_AmtMin
        {

            get { return (string)GetValue(Settlement_AmtMinProperty); }
            set
            {
                SetValue(Settlement_AmtMinProperty, value);
            }
        }
        public static readonly DependencyProperty Settlement_AmtMinProperty =
            DependencyProperty.Register("Settlement_AmtMin", typeof(string), typeof(Print_单位定期存单), new UIPropertyMetadata("金额小写"));
        #endregion         
    
        #region 证实书号
        public string Confirm_number
        {
            get { return (string)GetValue(Confirm_numberProperty); }
            set { SetValue(Confirm_numberProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Confirm_number.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty Confirm_numberProperty =
            DependencyProperty.Register("Confirm_number", typeof(string), typeof(Print_单位定期存单), new UIPropertyMetadata("证实书号"));
        #endregion
        #region 操作
        public string Operator
        {
            get { return (string)GetValue(OperatorProperty); }
            set { SetValue(OperatorProperty, value); }
        }
        public static readonly DependencyProperty OperatorProperty =
            DependencyProperty.Register("Operator", typeof(string), typeof(Print_单位定期存单), new UIPropertyMetadata("操作"));
        #endregion

        #region 签章
        /// <summary>
        /// 签章
        /// </summary>
        public string Signature
        {
            get { return (string)GetValue(SignatureProperty); }
            set { SetValue(SignatureProperty, value); }
        }
        public static readonly DependencyProperty SignatureProperty =
           DependencyProperty.Register("Signature", typeof(string), typeof(Print_单位定期存单), new UIPropertyMetadata("签章"));
        #endregion
        
        #region 事后监督
        /// <summary>
        /// 事后监督
        /// </summary>
        public string SupervisionAfterwards
        {
            get { return (string)GetValue(SupervisionAfterwardsProperty); }
            set { SetValue(SupervisionAfterwardsProperty, value); }
        }
        public static readonly DependencyProperty SupervisionAfterwardsProperty =
            DependencyProperty.Register("SupervisionAfterwards", typeof(string), typeof(Print_单位定期存单), new UIPropertyMetadata("事后监督"));
        #endregion
       
        #region 复核
         /// <summary>
        /// 复核
        /// </summary>
        public string Review
        {
            get { return (string)GetValue(ReviewProperty); }
            set { SetValue(ReviewProperty, value); }
        }
        public static readonly DependencyProperty ReviewProperty =
            DependencyProperty.Register("Review", typeof(string), typeof(Print_单位定期存单), new UIPropertyMetadata("复核"));
        #endregion
     
        #region 经办
        /// <summary>
        /// 经办
        /// </summary>
        public string Handling
        {
            get { return (string)GetValue(HandlingProperty); }
            set { SetValue(HandlingProperty, value); }
        }
        public static readonly DependencyProperty HandlingProperty =
            DependencyProperty.Register("Handling", typeof(string), typeof(Print_单位定期存单), new UIPropertyMetadata(LoginUserInfo.TellerNo));
        #endregion
        #endregion
    }
}
