﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Windows;
using Platform.Common;
using System.Windows.Media;
using System.Windows.Input;
using System.ComponentModel;
using Platform.Common.RunningParameters;
using Platform.Print;
using TellerSystem.PrintTemplate.Base;

namespace TellerSystem.PrintTemplate.PrintTemplateData
{
    /// <summary>
    /// 单位定期存款开户证实书
    /// </summary>
    public class Print_单位定期存款开户证实书 : TemplateBase
    {
        public Print_单位定期存款开户证实书()
        {
            this.PrintType = PrintTypes.EnterpriseRegularlyConfirmation;
            if (!DesignerProperties.GetIsInDesignMode(this))
            {
                Handling = LoginUserInfo.TellerNo;
            }
        }
        #region 打印属性
        #region
        /// <summary>
        /// 科目
        /// </summary>
        public string Subject
        {
            get { return (string)GetValue(SubjectProperty); }
            set { SetValue(SubjectProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Subject.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty SubjectProperty =
            DependencyProperty.Register("Subject", typeof(string), typeof(Print_单位定期存款开户证实书), new UIPropertyMetadata("科目"));
        #endregion
        #region 存入日
        /// <summary>
        /// 存入日
        /// </summary>
        public string DepositDate
        {
            get { return (string)GetValue(DepositDateProperty); }
            set { SetValue(DepositDateProperty, value); }
        }
        public static readonly DependencyProperty DepositDateProperty =
            DependencyProperty.Register("DepositDate", typeof(string), typeof(Print_单位定期存款开户证实书), new UIPropertyMetadata("存入日"));
        #endregion

        #region 起息日
        /// <summary>
        /// 起息日
        /// </summary>
        public string ValueDate
        {
            get { return (string)GetValue(ValueDateProperty); }
            set { SetValue(ValueDateProperty, value); }
        }
        public static readonly DependencyProperty ValueDateProperty =
            DependencyProperty.Register("ValueDate", typeof(string), typeof(Print_单位定期存款开户证实书), new UIPropertyMetadata("起息日"));
        #endregion

        #region 储种
        /// <summary>
        /// 储种
        /// </summary>
        public string Type
        {
            get { return (string)GetValue(TypeProperty); }
            set { SetValue(TypeProperty, value); }
        }

        public static readonly DependencyProperty TypeProperty =
            DependencyProperty.Register("Type", typeof(string), typeof(Print_单位定期存款开户证实书), new UIPropertyMetadata("储种"));
        #endregion

        #region 存期
        /// <summary>
        /// 存期
        /// </summary>
        public string Period
        {
            get { return (string)GetValue(PeriodProperty); }
            set { SetValue(PeriodProperty, value); }
        }
        public static readonly DependencyProperty PeriodProperty =
            DependencyProperty.Register("Period", typeof(string), typeof(Print_单位定期存款开户证实书), new UIPropertyMetadata("存期"));
        #endregion

        #region 利率
        /// <summary>
        /// 利率
        /// </summary>
        public string InterestRate
        {
            get { return (string)GetValue(MaturityDateProperty); }
            set { SetValue(MaturityDateProperty, value); }
        }
        public static readonly DependencyProperty InterestRateProperty =
           DependencyProperty.Register("InterestRate", typeof(string), typeof(Print_单位定期存款开户证实书), new UIPropertyMetadata("利率"));
        #endregion

        #region 到期日
        /// <summary>
        /// 到期日
        /// </summary>
        public string MaturityDate
        {
            get { return (string)GetValue(MaturityDateProperty); }
            set { SetValue(MaturityDateProperty, value); }
        }

        public static readonly DependencyProperty MaturityDateProperty =
            DependencyProperty.Register("MaturityDate", typeof(string), typeof(Print_单位定期存款开户证实书), new UIPropertyMetadata("到期日"));
        #endregion

        #region 操作
        /// <summary>
        /// 操作
        /// </summary>
        public string Operate
        {
            get { return (string)GetValue(OperateProperty); }
            set { SetValue(OperateProperty, value); }
        }

        public static readonly DependencyProperty OperateProperty =
            DependencyProperty.Register("Operate", typeof(string), typeof(Print_单位定期存款开户证实书), new UIPropertyMetadata("操作"));
        #endregion

        #region 账号

        public string AccountNo
        {
            get { return (string)GetValue(AccountNoProperty); }
            set { SetValue(AccountNoProperty, value); }
        }

        // Using a DependencyProperty as the backing store for AccountNo.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty AccountNoProperty =
            DependencyProperty.Register("AccountNo", typeof(string), typeof(Print_单位定期存款开户证实书), new UIPropertyMetadata("账号"));

        #endregion


        #region 户名
        /// <summary>
        /// 户名
        /// </summary>
        public string AccountName
        {
            get { return (string)GetValue(AccountNameProperty); }
            set { SetValue(AccountNameProperty, value); }
        }
        public static readonly DependencyProperty AccountNameProperty =
          DependencyProperty.Register("AccountName", typeof(string), typeof(Print_单位定期存款开户证实书), new UIPropertyMetadata("户名"));
        #endregion

        #region 存入金额
        /// <summary>
        /// 存入金额
        /// </summary>
        public string DepositAmount
        {
            get { return (string)GetValue(DepositAmountProperty); }
            set { SetValue(DepositAmountProperty, value); }
        }
        public static readonly DependencyProperty DepositAmountProperty =
            DependencyProperty.Register("DepositAmount", typeof(string), typeof(Print_单位定期存款开户证实书), new UIPropertyMetadata("存入金额"));
        #endregion

        #region 存入金额大写
        /// <summary>
        /// 存入金额大写
        /// </summary>
        public string DepositAmount_AmtMax
        {
            get { return (string)GetValue(DepositAmount_AmtMaxProperty); }
            set { SetValue(DepositAmount_AmtMaxProperty, value); }
        }
        public static readonly DependencyProperty DepositAmount_AmtMaxProperty =
            DependencyProperty.Register("DepositAmount_AmtMax", typeof(string), typeof(Print_单位定期存款开户证实书), new UIPropertyMetadata("存入金额大写"));
        #endregion

        #region 密/印
        /// <summary>
        /// 密/印
        /// </summary>
        public string PasswordOrSeal
        {
            get { return (string)GetValue(PasswordOrSealProperty); }
            set { SetValue(PasswordOrSealProperty, value); }
        }
        public static readonly DependencyProperty PasswordOrSealProperty =
            DependencyProperty.Register("PasswordOrSeal", typeof(string), typeof(Print_单位定期存款开户证实书), new UIPropertyMetadata("密/印"));
        #endregion

        #region 事后监督
        /// <summary>
        /// 事后监督
        /// </summary>
        public string Post_Supervision
        {
            get { return (string)GetValue(Post_SupervisionProperty); }
            set { SetValue(Post_SupervisionProperty, value); }
        }
        public static readonly DependencyProperty Post_SupervisionProperty =
            DependencyProperty.Register("Post_Supervision", typeof(string), typeof(Print_单位定期存款开户证实书), new UIPropertyMetadata("事后监督"));
        #endregion

        #region 经办
        /// <summary>
        /// 经办
        /// </summary>
        public string Handling
        {
            get { return (string)GetValue(HandlingProperty); }
            set { SetValue(HandlingProperty, value); }
        }
        public static readonly DependencyProperty HandlingProperty =
            DependencyProperty.Register("Handling", typeof(string), typeof(Print_单位定期存款开户证实书), new UIPropertyMetadata("经办"));
        #endregion

        #region 支取复核
        /// <summary>
        /// 支取复核
        /// </summary>
        public string WithdrawalReview
        {
            get { return (string)GetValue(WithdrawalReviewProperty); }
            set { SetValue(WithdrawalReviewProperty, value); }
        }
        public static readonly DependencyProperty WithdrawalReviewProperty =
            DependencyProperty.Register("WithdrawalReview", typeof(string), typeof(Print_单位定期存款开户证实书), new UIPropertyMetadata("支取复核"));
        #endregion

        #endregion 及定义属性
    }
}
