﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Windows;
using Platform.Common;
using System.Windows.Media;
using System.Windows.Input;
using System.ComponentModel;
using Platform.Print;
using TellerSystem.PrintTemplate.Extension;
using Platform.Common.RunningParameters;
using TellerSystem.PrintTemplate.Base;

namespace TellerSystem.PrintTemplate.PrintTemplateData
{
    /// <summary>
    /// 银行本票基础模板
    /// </summary>
    public class Print_本票 : TemplateBase
    {
     
        public Print_本票()
        {
            this.PrintType = PrintTypes.PromissoryNote;
        }
        #region 打印属性
        #region 日期
        public static readonly DependencyProperty DateInfoProperty =
                        DependencyProperty.Register("DateInfo", typeof(DateTime), typeof(Print_本票),
                                        new UIPropertyMetadata(DateTime.Now));
        /// <summary>
        /// 日期
        /// </summary>
        public DateTime DateInfo
        {
            get { return (DateTime)GetValue(DateInfoProperty); }
            set { SetValue(DateInfoProperty, value); }
        }
        #endregion

        #region 收款人
        public static readonly DependencyProperty PayNameProperty =
                        DependencyProperty.Register("PayName", typeof(string), typeof(Print_本票),
                                        new UIPropertyMetadata("收款人"));
        /// <summary>
        /// 收款人
        /// </summary>
        public string PayName
        {
            get { return (string)GetValue(PayNameProperty); }
            set { SetValue(PayNameProperty, value); }
        }
        #endregion

        #region 申请人
        public static readonly DependencyProperty AppNameProperty =
         DependencyProperty.Register("AppName", typeof(string), typeof(Print_本票),
                                     new UIPropertyMetadata("申请人"));
        /// <summary>
        /// 申请人
        /// </summary>
        public string AppName
        {
            get { return (string)GetValue(AppNameProperty); }
            set { SetValue(AppNameProperty, value); }
        }
        #endregion

        #region 金额大写
        public static readonly DependencyProperty Settlement_AmtMaxProperty =
            DependencyProperty.Register("Settlement_AmtMax", typeof(string), typeof(Print_本票),
                                        new UIPropertyMetadata("金额大写"));
        /// <summary>
        /// 金额大写
        /// </summary>
        public string Settlement_AmtMax
        {
            get { return (string)GetValue(Settlement_AmtMaxProperty); }
            set { SetValue(Settlement_AmtMaxProperty, value); }
        }
        #endregion

        #region 备注
        public static readonly DependencyProperty RemarkProperty =
          DependencyProperty.Register("Remark", typeof(string), typeof(Print_本票),
                                      new UIPropertyMetadata("备注"));
        /// <summary>
        /// 备注
        /// </summary>
        public string Remark
        {
            get { return (string)GetValue(RemarkProperty); }
            set { SetValue(RemarkProperty, value); }
        }
        #endregion

        #region 出纳
        public static readonly DependencyProperty CashierProperty =
         DependencyProperty.Register("Cashier", typeof(string), typeof(Print_本票),
                                     new UIPropertyMetadata("出纳"));
        /// <summary>
        /// 出纳
        /// </summary>
        public string Cashier
        {
            get { return (string)GetValue(CashierProperty); }
            set { SetValue(CashierProperty, value); }
        }
        #endregion

        #region 密押
        /// <summary>
        /// 密押
        /// </summary>
        public string PasswordOrSeal
        {
            get { return (string)GetValue(PasswordOrSealProperty); }
            set { SetValue(PasswordOrSealProperty, value); }
        }

        // Using a DependencyProperty as the backing store for PasswordOrSeal.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty PasswordOrSealProperty =
            DependencyProperty.Register("PasswordOrSeal", typeof(string), typeof(Print_本票), new UIPropertyMetadata("密押"));
        #endregion

        #region  行号
        /// <summary>
        /// 行号
        /// </summary>
        public string SerialNum
        {
            get { return (string)GetValue(SerialNumProperty); }
            set { SetValue(SerialNumProperty, value); }
        }

        // Using a DependencyProperty as the backing store for SerialNum.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty SerialNumProperty =
            DependencyProperty.Register("SerialNum", typeof(string), typeof(Print_本票), new UIPropertyMetadata("行号"));

        #region 金额（格式）


        public string Amount
        {
            get { return (string)GetValue(AmountProperty); }
            set { SetValue(AmountProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Amount.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty AmountProperty =
            DependencyProperty.Register("Amount", typeof(string), typeof(Print_本票), new UIPropertyMetadata("0 0 0 0 0 0 0 0"));

        
        #endregion
        #endregion

        #region 复核
        public static readonly DependencyProperty ReviewProperty =
          DependencyProperty.Register("Review", typeof(string), typeof(Print_本票),
                                      new UIPropertyMetadata("复核"));
        /// <summary>
        /// 复核
        /// </summary>
        public string Review
        {
            get { return (string)GetValue(ReviewProperty); }
            set { SetValue(ReviewProperty, value); }
        }
        #endregion

        #region 经办
        public static readonly DependencyProperty HandlingProperty =
         DependencyProperty.Register("Handling", typeof(string), typeof(Print_本票),
                                     new UIPropertyMetadata(LoginUserInfo.TellerNo));
        /// <summary>
        /// 经办
        /// </summary>
        public string Handling
        {
            get { return (string)GetValue(HandlingProperty); }
            set { SetValue(HandlingProperty, value); }
        }
        #endregion
        #endregion

    }
}
