﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Windows;
using Platform.Common;
using System.Windows.Media;
using System.Windows.Input;
using System.ComponentModel;
using Platform.Print;
using Platform.Common.RunningParameters;
using System.Globalization;
using TellerSystem.PrintTemplate.Extension;
using TellerSystem.PrintTemplate.Base;

namespace TellerSystem.PrintTemplate.PrintTemplateData
{
    /// <summary>
    /// 银行汇票
    /// </summary>
    public class Print_汇票 : TemplateBase
    {
        public Print_汇票()
        {
            this.PrintType = PrintTypes.BillOfExchange;

            if (DesignerProperties.GetIsInDesignMode(this))
            {
                DateInfo_Year = "2014";
                DateInfo_Mon = "01";
                DateInfo_Day = "01";
                PayBankName = "付款行名称";
                PayBankNo = "付款行号";
                Payee_Name = "收款人";
                Settlement_AmtMax = "出票金额";
                Settlement_AmtMin = "结算金额小写";
                Actno = "账号";
                ApplyName = "申请人";
                AccountNo = "帐号";
                BrankNo = "出票行";
                BrankNonum = "出票行号";
                Remark = "备注";
                Review = "复核";
                Handling = "经办";
                Accounting = "记账";
                Handling = "记账";
            }
            else
            {
                if (LoginUserInfo.GetUserInfo("TradeDate").Length == 8)
                {
                    DateInfo_Year = LoginUserInfo.GetUserInfo("TradeDate").Substring(0, 4);
                    DateInfo_Mon = LoginUserInfo.GetUserInfo("TradeDate").Substring(4, 2);
                    DateInfo_Day = LoginUserInfo.GetUserInfo("TradeDate").Substring(6, 2);
                }
            }
        }

        protected override void DrawingCommonLayer(PrintAttributes attr)
        {
            base.DrawingCommonLayer(attr);
            this.DrawingText(90, 90, DateInfo_Year);
            this.DrawingText(160, 90, DateInfo_Mon);
            this.DrawingText(220, 90, DateInfo_Day);
            this.DrawingText(354, 103, PayBankName);
            this.DrawingText(509, 103, PayBankNo);
            this.DrawingText(71, 136, Payee_Name);
            this.DrawingText(136, 166, Settlement_AmtMax);
            this.DrawingText(142, 201, Settlement_AmtMin);
            this.DrawingText(72, 233, ApplyName);
            this.DrawingText(356, 232, AccountNo);
            this.DrawingText(72, 255, BrankNo);
            this.DrawingText(227, 255, BrankNonum);
            this.DrawingText(72, 276, Remark);
            this.DrawingText(478, 330, Review);
            this.DrawingText(133, 330, Handling);
            this.DrawingText(53, 330, Review);
            this.DrawingText(545, 330, Accounting);
        }


        #region 属性包装
        /// <summary>
        /// 日期-年
        /// </summary>
        public string DateInfo_Year { get; set; }

        /// <summary>
        /// 日期-月
        /// </summary>
        public string DateInfo_Mon { get; set; }

        /// <summary>
        /// 日期-日
        /// </summary>
        public string DateInfo_Day { get; set; }
        /// <summary>
        /// 付款行名称
        /// </summary>
        public string PayBankName { get; set; }

        /// <summary>
        /// 付款行号
        /// </summary>
        public string PayBankNo { get; set; }

        /// <summary>
        /// 收款人
        /// </summary>
        public string Payee_Name { get; set; }

        /// <summary>
        /// 账号
        /// </summary>
        public string Actno { get; set; }

        /// <summary>
        /// 出票金额
        /// </summary>
        public string Settlement_AmtMax { get; set; }

        /// <summary>
        /// 结算金额小写
        /// </summary>
        public string Settlement_AmtMin { get; set; }

        /// <summary>
        /// 申请人
        /// </summary>
        public string ApplyName { get; set; }

        /// <summary>
        /// 帐号
        /// </summary>
        public string AccountNo { get; set; }

        /// <summary>
        /// 出票行
        /// </summary>
        public string BrankNo { get; set; }

        /// <summary>
        /// 出票行号
        /// </summary>
        public string BrankNonum { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        public string Remark { get; set; }

        /// <summary>
        /// 复核
        /// </summary>
        public string Review { get; set; }

        /// <summary>
        /// 经办
        /// </summary>
        public string Handling { get; set; }

        /// <summary>
        /// 记账
        /// </summary>
        public string Accounting { get; set; }
        #endregion
    }
}
