// 定义 IEntity 接口，对应 C# 中的 IEntity 接口，这里只是占位，可根据实际情况补充
interface IEntity {}

// 定义 AfterRecordInfo 类，对应 C# 中的 AfterRecordInfo 类
class AfterRecordInfo implements IEntity {
    // 交易日期
    public date: string;
    // 机构号
    public kinbrno: string;
    // 机构名
    public kinbrname: string;
    // 交易类型
    public worktype: string;
    // 金额
    public money: number;
    // 柜员号
    public tellerno: string;
    // 票号
    public printno: string;
    // 监督状态
    public stat: string;

    constructor() {
        this.date = "";
        this.kinbrno = "";
        this.kinbrname = "";
        this.worktype = "";
        this.money = 0;
        this.tellerno = "";
        this.printno = "";
        this.stat = "";
    }

    // 将对象属性转换为字符串数组
    public ChangeToTable(): string[] {
        return [this.date, this.kinbrno, this.kinbrname, this.worktype, this.money.toString(), this.tellerno, this.printno, this.stat];
    }

    // 从对象数组中读取数据并赋值给当前对象的属性
    public ChangeFromTable(parms: any[]): void {
        this.date = parms[0].toString();
        this.kinbrno = parms[1].toString();
        this.kinbrname = parms[2].toString();
        this.worktype = parms[3].toString();
        this.money = parseFloat(parms[4]);
        this.tellerno = parms[5].toString();
        this.printno = parms[6].toString();
        this.stat = parms[7].toString();
    }
}

export { AfterRecordInfo };