// 定义 IEntity 接口，对应 C# 中的接口
interface IEntity {}

/**
 * 事后监督记录表
 */
class AfterRecords implements IEntity {
    // 定义类的属性，对应 C# 中的属性
    public id: string;
    public serialno: string;
    public businessdate: string;
    public supertel: string;
    public superdate: string;
    public superstat: string;
    public brno: string;
    public ext1: string;
    public ext2: string;

    constructor() {
        // 初始化属性
        this.id = "";
        this.serialno = "";
        this.businessdate = "";
        this.supertel = "";
        this.superdate = "";
        this.superstat = "";
        this.brno = "";
        this.ext1 = "";
        this.ext2 = "";
    }

    /**
     * 将对象属性转换为字符串数组
     * @returns 包含对象属性值的字符串数组
     */
    public ChangeToTable(): string[] {
        return [this.id, this.serialno, this.businessdate, this.supertel, this.superdate, this.superstat, this.brno, this.ext1, this.ext2];
    }

    /**
     * 从对象数组中读取数据并赋值给当前对象的属性
     * @param parms 包含数据的对象数组
     */
    public ChangeFromTable(parms: any[]): void {
        this.id = parms[0].toString();
        this.serialno = parms[1].toString();
        this.businessdate = parms[2].toString();
        this.supertel = parms[3].toString();
        this.superdate = parms[4].toString();
        this.superstat = parms[5].toString();
        this.brno = parms[6].toString();
        this.ext1 = parms[7].toString();
        this.ext2 = parms[8].toString();
    }
}

export { AfterRecords };