// 假设 IEntity 接口的定义如下，如果实际有不同定义，需要根据实际情况修改
interface IEntity {
    // 这里可以根据实际 IEntity 接口的定义添加方法或属性
}

class AfterShip implements IEntity {
    // 机构号
    kinbrno: string;
    // 机构名称
    kinbrname: string;
    // 柜员号
    tellerno: string;
    // 柜员名
    tellername: string;

    constructor() {
        this.kinbrno = '';
        this.kinbrname = '';
        this.tellerno = '';
        this.tellername = '';
    }

    /**
     * 将实体属性转换为字符串数组
     * @returns 包含实体属性值的字符串数组
     */
    ChangeToTable(): string[] {
        return [this.kinbrno, this.kinbrname, this.tellerno, this.tellername];
    }

    /**
     * 从对象数组中读取数据并赋值给实体属性
     * @param parms 包含数据的对象数组
     */
    ChangeFromTable(parms: any[]): void {
        this.kinbrno = parms[0].toString();
        this.kinbrname = parms[1].toString();
        this.tellerno = parms[2].toString();
        this.tellername = parms[3].toString();
    }
}

export { AfterShip };