// 导入必要的类型定义，在 TypeScript 中一般不需要像 C# 那样导入基础库
// 这里假设 IEntity 是一个接口，需要在其他文件中定义

// 定义 IEntity 接口，如果已经在其他文件定义，可忽略此定义
export interface IEntity {
    // 这里可以根据实际情况添加 IEntity 接口的属性或方法
}

/**
 * 事后监督状态实体类
 */
export class AfterStat implements IEntity {
    // 交易日期
    public datetime: string;
    // 机构号
    public kinbrno: string;
    // 机构名称
    public kinbrname: string;
    // 开始时间
    public starttime: string;
    // 结束时间
    public endtime: string;
    // 状态
    public stat: string;

    constructor() {
        this.datetime = '';
        this.kinbrno = '';
        this.kinbrname = '';
        this.starttime = '';
        this.endtime = '';
        this.stat = '';
    }

    /**
     * 将实体属性转换为字符串数组
     * @returns 包含实体属性的字符串数组
     */
    public ChangeToTable(): string[] {
        return [this.datetime, this.kinbrno, this.kinbrname, this.stat, this.starttime, this.endtime];
    }

    /**
     * 从对象数组中获取值并赋值给实体属性
     * @param parms 对象数组，包含要赋值给实体属性的值
     */
    public ChangeFromTable(parms: any[]): void {
        this.datetime = parms[0].toString();
        this.kinbrno = parms[1].toString();
        this.kinbrname = parms[2].toString();
        this.stat = parms[3].toString();
        this.starttime = parms[4].toString();
        this.endtime = parms[5].toString();
    }
}