// 假设 IEntity 接口定义在某个地方，这里先简单定义一个空接口作为示例
interface IEntity {}

/**
 * 用来审批操作
 */
class AppRecordInfo implements IEntity {
    /**
     * 总流水
     */
    serialid: string;
    /**
     * 柜员流水
     */
    serialno: string;
    /**
     * 所属名称
     */
    belongname: string;
    /**
     * 用户编号
     */
    teller: string;
    /**
     * 机构编号
     */
    branch: string;
    /**
     * 申请时间
     */
    apptime: string;
    /**
     * 申请状态 1.待审核 2.已通过。3。拒绝
     */
    status: string;
    /**
     * 维护类型 1.增加 2.修改
     */
    maintaintype: string;
    /**
     * 申请描述
     */
    passremark: string;
    /**
     * 拒绝描述
     */
    refuseremark: string;
    /**
     * 审核人员
     */
    examineteller: string;
    /**
     * 审核时间
     */
    examinedate: string;

    constructor() {
        // 初始化属性
        this.serialid = '';
        this.serialno = '';
        this.belongname = '';
        this.teller = '';
        this.branch = '';
        this.apptime = '';
        this.status = '';
        this.maintaintype = '';
        this.passremark = '';
        this.refuseremark = '';
        this.examineteller = '';
        this.examinedate = '';
    }

    /**
     * 从数组参数中更改实体属性值
     * @param parms 参数数组
     */
    ChangeFromTable(parms: any[]): void {
        this.serialid = parms[0].toString();
        this.serialno = parms[1].toString();
        this.belongname = parms[2].toString();
        this.teller = parms[3].toString();
        this.branch = parms[4].toString();
        this.apptime = parms[5].toString();
        this.status = parms[6].toString();
        this.maintaintype = parms[7].toString();
        this.passremark = parms[8].toString();
        this.refuseremark = parms[9].toString();
        this.examineteller = parms[10].toString();
        this.examinedate = parms[11].toString();
    }

    /**
     * 将实体属性值转换为字符串数组
     * @returns 包含实体属性值的字符串数组
     */
    ChangeToTable(): string[] {
        return [
            this.serialid,
            this.serialno,
            this.belongname,
            this.teller,
            this.branch,
            this.apptime,
            this.status,
            this.maintaintype,
            this.passremark,
            this.refuseremark,
            this.examineteller,
            this.examinedate
        ];
    }
}

export default AppRecordInfo;