// 定义 IEntity 接口，这里假设其为空，可根据实际情况补充
interface IEntity {}

/**
 * 询问授权信息的类
 * @author Administrator
 * @date 2013-5-27 9:05:21
 */
class AskAuthInfo implements IEntity {
    // 序列号
    public serialID: string;
    // 工作流 ID
    public WorkFlowID: string;
    // 模式
    public model: number;
    // 描述
    public des: string;
    // 账号
    public accountno: string;
    // 客户姓名
    public custname: string;
    // 金额
    public amount: string;
    // 柜员号
    public TellerNo: string;

    constructor() {
        this.serialID = "";
        this.WorkFlowID = "";
        this.model = 0;
        this.des = "";
        this.accountno = "";
        this.custname = "";
        this.amount = "";
        this.TellerNo = "";
    }

    /**
     * 将对象属性转换为字符串数组
     * @returns 包含对象属性值的字符串数组
     */
    public ChangeToTable(): string[] {
        return [
            this.serialID,
            this.WorkFlowID,
            this.model.toString(),
            this.des,
            this.accountno,
            this.custname,
            this.amount,
            this.TellerNo
        ];
    }

    /**
     * 从对象数组中读取数据填充当前对象的属性
     * @param parms 包含数据的对象数组
     */
    public ChangeFromTable(parms: any[]): void {
        this.serialID = parms[0].toString();
        this.WorkFlowID = parms[1].toString();
        this.model = parseInt(parms[2].toString(), 10);
        this.des = parms[3].toString();
        this.accountno = parms[4].toString();
        this.custname = parms[5].toString();
        this.amount = parms[6].toString();
        this.TellerNo = parms[7].toString();
    }
}

export { AskAuthInfo };