// 定义 IEntity 接口，对应 C# 中的接口
interface IEntity {
    // 这里可以根据实际需求添加接口方法，原 C# 中未体现接口方法，暂时为空
}

// 定义 AskSuperInfo 类，实现 IEntity 接口
class AskSuperInfo implements IEntity {
    // 定义类的属性，和 C# 中属性保持一致
    serialID: string;
    WorkFlowID: string;
    des: string;
    accountno: string;
    custname: string;
    amount: number;
    TellerNo: string;

    // 构造函数，用于初始化类的属性
    constructor(
        serialID: string = '',
        WorkFlowID: string = '',
        des: string = '',
        accountno: string = '',
        custname: string = '',
        amount: number = 0,
        TellerNo: string = ''
    ) {
        this.serialID = serialID;
        this.WorkFlowID = WorkFlowID;
        this.des = des;
        this.accountno = accountno;
        this.custname = custname;
        this.amount = amount;
        this.TellerNo = TellerNo;
    }

    // 实现 ChangeToTable 方法，将对象属性转换为字符串数组
    ChangeToTable(): string[] {
        return [
            this.serialID,
            this.WorkFlowID,
            this.des,
            this.accountno,
            this.custname,
            this.amount.toString(),
            this.TellerNo
        ];
    }

    // 实现 ChangeFromTable 方法，从对象数组中读取数据并赋值给类的属性
    ChangeFromTable(parms: any[]): void {
        this.serialID = parms[0].toString();
        this.WorkFlowID = parms[1].toString();
        this.des = parms[2].toString();
        this.accountno = parms[3].toString();
        this.custname = parms[4].toString();
        this.amount = parseFloat(parms[5].toString());
        this.TellerNo = parms[6].toString();
    }
}

// 导出 AskSuperInfo 类，方便其他文件使用
export { AskSuperInfo };