// 定义接口 IEntity，这里因为原 C# 中 IEntity 为空，TypeScript 中用空接口表示
interface IEntity {}

// 定义 BatSysConfig 类，实现 IEntity 接口
class BatSysConfig implements IEntity {
    // 外围系统编码
    public code: string;
    // 外围系统名称
    public sys_name: string;
    // 外围系统关系
    public relation: string;

    constructor() {
        this.code = '';
        this.sys_name = '';
        this.relation = '';
    }

    // 从数组参数中更新类的属性
    public ChangeFromTable(parms: any[]): void {
        this.code = parms[0].toString();
        this.sys_name = parms[1].toString();
        this.relation = parms[2].toString();
    }

    // 将类的属性转换为字符串数组
    public ChangeToTable(): string[] {
        return [this.code, this.sys_name, this.relation];
    }
}

export { BatSysConfig };