// 引入必要的命名空间（在 TypeScript 中通常不需要引入像 C# 那样的命名空间，这里是概念对应）
// 这里没有实际对应的 TypeScript 命名空间引入，因为 TS 没有完全一样的机制

// 定义接口 IEntity（由于原 C# 中 IEntity 为空，这里也先空着）
interface IEntity {}

/**
 * 检查信息类
 * 
 * @author Administrator
 * @date 2013-5-17 15:12:22
 */
class CheckInfo implements IEntity {
    // 定义类的属性
    public tx_code: string;
    public element: string;
    public funcnum: string;
    public flag: number;

    // 构造函数，用于初始化对象
    constructor(tx_code: string = '', element: string = '', funcnum: string = '', flag: number = 0) {
        this.tx_code = tx_code;
        this.element = element;
        this.funcnum = funcnum;
        this.flag = flag;
    }

    /**
     * 将对象属性转换为字符串数组
     * @returns 包含对象属性值的字符串数组
     */
    public ChangeToTable(): string[] {
        return [this.tx_code, this.element, this.funcnum, this.flag.toString()];
    }

    /**
     * 从对象数组中提取数据并赋值给当前对象的属性
     * @param parms 包含数据的对象数组
     */
    public ChangeFromTable(parms: any[]): void {
        this.tx_code = parms[0].toString();
        this.element = parms[1].toString();
        this.funcnum = parms[2].toString();
        this.flag = parseInt(parms[3].toString(), 10);
    }
}

// 导出类，方便其他文件使用
export { CheckInfo };