// 导入必要的类型定义（虽然这里没有实际用到其他模块，但为了保持结构一致列出）
import { IEntity } from '../../../platfrom/serviceproxy/ServiceFunction/Interfaces/IEntity'; // 请根据实际情况替换路径

/**
 * 检查结果实体类
 * 
 * @author Administrator
 * @date 2013-5-17 15:29:46
 */
class CheckResult implements IEntity {
    // 定义类的属性
    mode: string;
    lvl: string;
    brno: string;
    checkresult: boolean;
    des: string;
    personnum: string;

    // 构造函数，用于初始化对象属性
    constructor() {
        this.mode = '';
        this.lvl = '';
        this.brno = '';
        this.checkresult = false;
        this.des = '';
        this.personnum = '';
    }

    /**
     * 将对象属性转换为字符串数组
     * @returns 包含对象属性值的字符串数组
     */
    ChangeToTable(): string[] {
        return [this.mode, this.lvl, this.brno, this.checkresult.toString(), this.des, this.personnum];
    }

    /**
     * 从对象数组中读取数据并赋值给当前对象的属性
     * @param parms 包含属性值的对象数组
     */
    ChangeFromTable(parms: any[]): void {
        this.mode = parms[0].toString();
        this.lvl = parms[1].toString();
        this.brno = parms[2].toString();
        this.checkresult = Boolean(parms[3].toString());
        this.des = parms[4].toString();
        this.personnum = parms[5].toString();
    }
}

// 导出类，以便其他模块可以使用
export { CheckResult };
