import { IEntity } from '../../../platfrom/serviceproxy/ServiceFunction/Interfaces/IEntity'; // 请根据实际情况替换路径


// 定义 IdCheckRecords 类，实现 IEntity 接口
class IdCheckRecords implements IEntity {
    // 主键
    public ID: string;
    // 流水号
    public Serialid: string;
    // 姓名
    public Name: string;
    // 身份证号
    public Idno: string;
    // 标识
    // 0 未核实
    // 1 已核实
    public Marking: string;
    // 核查原因
    public Checkcasuse: string;
    // 核查结果
    // 0 公民身份号码与姓名一致，且存在照片
    // 1 公民身份号码与姓名一致，但不存在照片
    // 2 公民身份号码存在，但与姓名不匹配
    // 3 公民身份号码不存在
    // 4 其他错误
    // 5 输入的参数错误,或其他错误
    public Checkresult: string;
    // 业务种类
    // 0 银行账户业务
    // 1 信贷和征信业务
    // 2 支付结算业务
    // 3 反洗钱业务
    // 4 其他业务
    public Type: string;
    // 佐证证件
    // 00:
    // 01:户口薄
    // 02:驾驶证
    // 03:公安回执证明
    // 04其他
    public Proof: string;
    // 备注
    public Filler: string;
    // 营业日期
    public Businessdate: string;
    // 机构号
    public Branch: string;
    // 柜员号
    public Teller: string;
    // 确认状态
    public Stat: string;

    // 从数组参数中获取数据并赋值给类的属性
    public ChangeFromTable(parms: any[]): void {
        this.Name = parms[0].toString();
        this.Idno = parms[1].toString();
        this.Marking = parms[2].toString();
        this.Checkcasuse = parms[3].toString();
        this.Checkresult = parms[4].toString();
        this.Proof = parms[5].toString();
        this.Teller = parms[6].toString();
        this.Businessdate = parms[7].toString();
        this.Branch = parms[8].toString();
        this.Filler = parms[9].toString();
        this.Type = parms[10].toString();
        this.Serialid = parms[11].toString();
        this.ID = parms[12].toString();
        this.Stat = parms[13].toString();
    }

    // 将类的属性值按特定顺序收集到数组中并返回
    public ChangeToTable(): string[] {
        return [
            this.ID,
            this.Serialid,
            this.Name,
            this.Idno,
            this.Marking,
            this.Checkcasuse,
            this.Checkresult,
            this.Type,
            this.Proof,
            this.Filler,
            this.Businessdate,
            this.Branch,
            this.Teller,
            this.Stat
        ];
    }
}

// 导出 IdCheckRecords 类，方便其他模块使用
export { IdCheckRecords };
