// 定义 IEntity 接口，由于原 C# 中未给出定义，这里先简单占位
import { IEntity } from '../../../platfrom/serviceproxy/ServiceFunction/Interfaces/IEntity'; // 请根据实际情况替换路径

/**
 * 授权结果类，实现 IEntity 接口
 */
class IsAuthResult implements IEntity {
    /**
     * 授权模式: 
     * 1、本地授权
     * 2、远程授权
     * 3、即可本地又可远程授权
     */
    Mode: number;

    /**
     * 授权级别
     */
    Lvl: string;

    /**
     * 是否需要授权
     */
    Isauth: boolean;

    /**
     * 授权流水
     */
    Records: string;

    constructor() {
        this.Mode = 0;
        this.Lvl = "";
        this.Isauth = false;
        this.Records = "";
    }

    /**
     * 将授权结果转换为字符串数组
     * @returns 包含授权模式、授权级别、是否授权、授权流水的字符串数组
     */
    ChangeToTable(): string[] {
        return [this.Mode.toString(), this.Lvl, this.Isauth.toString(), this.Records];
    }

    /**
     * 从对象数组中解析数据并填充到当前实例
     * @param parms 包含授权信息的对象数组
     */
    ChangeFromTable(parms: any[]): void {
        this.Mode = parseInt(parms[0].toString(), 10);
        this.Lvl = parms[1].toString();
        this.Isauth = Boolean(parms[2]);
        this.Records = parms[3].toString();
    }
}

export { IsAuthResult };
