// 假设 IEntity 接口定义如下，若有实际定义请替换
import { IEntity } from '../../../platfrom/serviceproxy/ServiceFunction/Interfaces/IEntity'; // 请根据实际情况替换路径

/**
 * 
 * @author Administrator
 * @date 2013-5-26 15:37:34
 */
class PageData implements IEntity {
    /**
     * 交易页面数据索引(多个交易页面展现顺序)
     */
    index: number;

    /**
     * 1序列化后的交易页面
     */
    datas: Uint8Array;

    dataslength: number;

    constructor(index: number = 0, datas: Uint8Array = new Uint8Array(), dataslength: number = 0) {
        this.index = index;
        this.datas = datas;
        this.dataslength = dataslength;
    }

    /**
     * 将数据转换为字符串数组
     */
    ChangeToTable(): string[] {
        return [this.index.toString(), this.datas.length.toString()];
    }

    /**
     * 从对象数组转换数据
     * @param parms - 包含数据的对象数组
     */
    ChangeFromTable(parms: any[]): void {
        this.index = parseInt(parms[0].toString(), 10);
        this.dataslength = parseInt(parms[1].toString(), 10);
    }
}

export { PageData };
