// 假设 IEntity 是一个空接口，若有实际定义需补充完整
import { IEntity } from '../../../platfrom/serviceproxy/ServiceFunction/Interfaces/IEntity'; // 请根据实际情况替换路径


class PayBusinessKeyInfo implements IEntity {
    id: string;
    // 单位编号（10）
    compayNo: string;
    // 签约日期（8）
    signDate: string;
    // 申请类型（1）
    applyType: number;
    // 手机号（11）
    phoneNumber: string;
    // 秘钥（16）
    secretKey: string;
    // 备用
    ext: string;

    constructor() {
        this.id = "";
        this.compayNo = "";
        this.signDate = "";
        this.applyType = 0;
        this.phoneNumber = "";
        this.secretKey = "";
        this.ext = "";
    }

    ChangeToTable(): string[] {
        return [this.id, this.compayNo, this.signDate, this.applyType.toString(), this.phoneNumber, this.secretKey, this.ext];
    }

    ChangeFromTable(parms: any[]): void {
        this.id = parms[0].toString();
        this.compayNo = parms[1].toString();
        this.signDate = parms[2].toString();
        this.applyType = parseInt(parms[3].toString(), 10);
        this.phoneNumber = parms[4].toString();
        this.secretKey = parms[5].toString();
        this.ext = parms[6].toString();
    }
}

export { PayBusinessKeyInfo };
