// 定义 IEntity 接口，对应 C# 里的接口
interface IEntity {
    ChangeFromTable(parms: any[]): void;
    ChangeToTable(): string[];
}

// 预授权实体类
export class PreAuthInfo implements IEntity {
    // 交易号(预授权的交易)
    private tradeNo: string;
    // 交易流水号
    private serialId: string;
    // 账号
    private accountNum: string;
    // 金额
    private amount: string;
    // 户名
    private custname: string;
    // 积数
    private count: string;
    // 描述
    private des: string;
    // 有效天数
    private askDays: number;
    // 申请柜员
    private askTeller: string;
    // 申请机构号
    private askKinbrno: string;
    // 审批时间
    private inspTime: string;
    // 审批后有效天数
    private inspDays: number;
    // 上浮金额
    private upAmount: number;
    // 下浮金额
    private downAmount: number;
    // 交易页面
    private pageData: Uint8Array;
    // 标志位
    private downIssued: boolean;
    // 法人类型
    private legalPerson: string;
    // 当日借方累计金额
    private sumAddAmt: string;

    // 交易号属性
    get TradeNo(): string {
        return this.tradeNo;
    }
    set TradeNo(value: string) {
        this.tradeNo = value;
    }

    // 交易流水号属性
    get SerialId(): string {
        return this.serialId;
    }
    set SerialId(value: string) {
        this.serialId = value;
    }

    // 账号属性
    get AccountNum(): string {
        return this.accountNum;
    }
    set AccountNum(value: string) {
        this.accountNum = value;
    }

    // 金额属性
    get Amount(): string {
        return this.amount;
    }
    set Amount(value: string) {
        this.amount = value;
    }

    // 户名属性
    get Custname(): string {
        return this.custname;
    }
    set Custname(value: string) {
        this.custname = value;
    }

    // 积数属性
    get Count(): string {
        return this.count;
    }
    set Count(value: string) {
        this.count = value;
    }

    // 描述属性
    get Des(): string {
        return this.des;
    }
    set Des(value: string) {
        this.des = value;
    }

    // 有效天数属性
    get AskDays(): number {
        return this.askDays;
    }
    set AskDays(value: number) {
        this.askDays = value;
    }

    // 申请柜员属性
    get AskTeller(): string {
        return this.askTeller;
    }
    set AskTeller(value: string) {
        this.askTeller = value;
    }

    // 申请机构号属性
    get AskKinbrno(): string {
        return this.askKinbrno;
    }
    set AskKinbrno(value: string) {
        this.askKinbrno = value;
    }

    // 审批时间属性
    get InspTime(): string {
        return this.inspTime;
    }
    set InspTime(value: string) {
        this.inspTime = value;
    }

    // 审批后有效天数属性
    get InspDays(): number {
        return this.inspDays;
    }
    set InspDays(value: number) {
        this.inspDays = value;
    }

    // 上浮金额属性
    get UpAmount(): number {
        return this.upAmount;
    }
    set UpAmount(value: number) {
        this.upAmount = value;
    }

    // 下浮金额属性
    get DownAmount(): number {
        return this.downAmount;
    }
    set DownAmount(value: number) {
        this.downAmount = value;
    }

    // 交易页面属性
    get PageData(): Uint8Array {
        return this.pageData;
    }
    set PageData(value: Uint8Array) {
        this.pageData = value;
    }

    // 标志位属性
    get DownIssued(): boolean {
        return this.downIssued;
    }
    set DownIssued(value: boolean) {
        this.downIssued = value;
    }

    // 法人类型属性
    get LegalPerson(): string {
        return this.legalPerson;
    }
    set LegalPerson(value: string) {
        this.legalPerson = value;
    }

    // 当日借方累计金额属性
    get SumAddAmt(): string {
        return this.sumAddAmt;
    }
    set SumAddAmt(value: string) {
        this.sumAddAmt = value;
    }

    // 从数组中转换数据
    ChangeFromTable(parms: any[]): void {
        if (parms && parms.length === 14) {
            this.tradeNo = parms[0].toString();
            this.accountNum = parms[1].toString();
            this.amount = parms[2].toString();
            this.custname = parms[3].toString();
            this.count = parms[4].toString();
            this.des = parms[5].toString();
            this.askDays = parseInt(parms[6].toString(), 10);
            this.askTeller = parms[7].toString();
            this.askKinbrno = parms[8].toString();
            this.upAmount = parseFloat(parms[9].toString());
            this.downAmount = parseFloat(parms[10].toString());
            this.inspDays = parseInt(parms[11].toString(), 10);
            this.serialId = parms[12].toString();
            this.downIssued = Boolean(parms[13].toString());
        }
    }

    // 转换为字符串数组
    ChangeToTable(): string[] {
        return [
            this.tradeNo,
            this.accountNum,
            this.amount,
            this.custname,
            this.count,
            this.des,
            this.askDays.toString(),
            this.askTeller,
            this.askKinbrno,
            this.upAmount.toString(),
            this.downAmount.toString(),
            this.inspDays.toString(),
            this.serialId,
            this.downIssued.toString()
        ];
    }
}