// 由于 TypeScript 没有像 C# 那样的命名空间概念，这里使用接口模拟命名空间的结构
namespace TellerSystem.ServiceProxy.Ext.ServiceEntitys {
    // 模拟 IEntity 接口，由于没有具体定义，这里先留空
    interface IEntity {}

    export class TatmDbpnr implements IEntity {
        f_id: string;               // ID
        f_date: string;           // 日期
        f_atm_money1: string;       // ATM机结账余额
        f_atm_money2: string;      // ATM机清机金额
        f_cashbox_money: string;    // 钞箱实有库存
        f_atm_increment: string;   // ATM机加钞金额
        f_test50: string;           // 测试取款50元张数
        f_test100: string;            // 测试取款100元张数
        f_last_money: string;       // 测试后终端余额
        f_teller: string;           // 经办人
        f_confim_teller: string;
        f_atm_no: string;             // ATM编号
        f_long_cur: string;          // 长款金额
        f_short_cur: string;         // 短款金额
        f_test_in100: string;        // 测试存款100
        f_test_in50: string;         // 测试存款50
        f_comment: string;           // 备注
        f_Mechanism_No: string;           // 备注

        constructor() {
            // 初始化属性，可根据实际情况修改
            this.f_id = '';
            this.f_date = '';
            this.f_atm_money1 = '';
            this.f_atm_money2 = '';
            this.f_cashbox_money = '';
            this.f_atm_increment = '';
            this.f_test50 = '';
            this.f_test100 = '';
            this.f_last_money = '';
            this.f_teller = '';
            this.f_confim_teller = '';
            this.f_atm_no = '';
            this.f_long_cur = '';
            this.f_short_cur = '';
            this.f_test_in100 = '';
            this.f_test_in50 = '';
            this.f_comment = '';
            this.f_Mechanism_No = '';
        }

        ChangeToTable(): string[] {
            return [
                this.f_id, 
                this.f_date, 
                this.f_atm_money1, 
                this.f_atm_money2, 
                this.f_cashbox_money, 
                this.f_atm_increment,
                this.f_test50, 
                this.f_test100, 
                this.f_last_money,
                this.f_teller, 
                this.f_confim_teller,
                this.f_Mechanism_No
            ];
        }

        ChangeFromTable(parms: any[]): void {
            this.f_id = parms[0].toString();
            this.f_date = parms[1].toString();
            this.f_atm_money1 = parms[2].toString();
            this.f_atm_money2 = parms[3].toString();
            this.f_cashbox_money = parms[4].toString();
            this.f_atm_increment = parms[5].toString();
            this.f_test50 = parms[6].toString();
            this.f_test100 = parms[7].toString();
            this.f_last_money = parms[8].toString();
            this.f_teller = parms[9].toString();
            this.f_confim_teller = parms[10].toString();
            this.f_Mechanism_No = parms[11].toString();
        }
    }
}

// 导出类方便使用
export default TellerSystem.ServiceProxy.Ext.ServiceEntitys.TatmDbpnr;