// 定义 IEntity 接口，由于原 C# 未给出定义，这里先空着，可按需补充
interface IEntity {}

// 定义 TcheckMachine 类
class TcheckMachine implements IEntity {
    // ID
    f_id: string;
    // 日期
    f_date: string;
    // 清分机
    f_machine1: string;
    // 点钞机
    f_machine2: string;
    // 假币检定仪
    f_machine3: string;
    // 防伪机具发现问题
    f_problem1: string;
    // ATM 机运行记录
    f_log1: string;
    // ATM 机运行发现问题
    f_problem2: string;
    // 监控检查运行记录
    f_log2: string;
    // 监控检查发现问题
    f_problem3: string;
    // 故障维修记录
    f_svr_action_Log: string;
    // 责任人
    f_confim_teller: string;
    // 备注
    f_description: string;
    // 机构号
    f_Mechanism_No: string;

    constructor() {
        this.f_id = '';
        this.f_date = '';
        this.f_machine1 = '';
        this.f_machine2 = '';
        this.f_machine3 = '';
        this.f_problem1 = '';
        this.f_log1 = '';
        this.f_problem2 = '';
        this.f_log2 = '';
        this.f_problem3 = '';
        this.f_svr_action_Log = '';
        this.f_confim_teller = '';
        this.f_description = '';
        this.f_Mechanism_No = '';
    }

    /**
     * 将对象属性转换为字符串数组
     * @returns 包含对象属性值的字符串数组
     */
    ChangeToTable(): string[] {
        return [
            this.f_id,
            this.f_date,
            this.f_machine1,
            this.f_machine2,
            this.f_machine3,
            this.f_problem1,
            this.f_log1,
            this.f_problem2,
            this.f_log2,
            this.f_problem3,
            this.f_svr_action_Log,
            this.f_confim_teller,
            this.f_description,
            this.f_Mechanism_No
        ];
    }

    /**
     * 从对象数组中更新当前对象的属性值
     * @param parms 包含属性值的对象数组
     */
    ChangeFromTable(parms: any[]): void {
        this.f_id = parms[0].toString();
        this.f_date = parms[1].toString();
        this.f_machine1 = parms[2].toString();
        this.f_machine2 = parms[3].toString();
        this.f_machine3 = parms[4].toString();
        this.f_problem1 = parms[5].toString();
        this.f_log1 = parms[6].toString();
        this.f_problem2 = parms[7].toString();
        this.f_log2 = parms[8].toString();
        this.f_problem3 = parms[9].toString();
        this.f_svr_action_Log = parms[10].toString();
        this.f_confim_teller = parms[11].toString();
        this.f_description = parms[12].toString();
        this.f_Mechanism_No = parms[13].toString();
    }
}

export { TcheckMachine };