// 定义 IEntity 接口，这里先简单定义，实际可按需补充
interface IEntity {}

/**
 * 交易号
 */
export class TellerInfo implements IEntity {
    public TradeNo: string;
    /**
     * 柜员号
     */
    public TellerNo: string;
    /**
     * 柜员权限
     */
    public Tlrlvl: string;
    /**
     * 机构号
     */
    public BrNo: string;

    public TradeFileName: string;
    /**
     * 流程状态：0：未完成 ；1:正常完成；2：非正常完成
     */
    public Status: number;
    /**
     * 后台流水号
     */
    public BlackSerialNo: string;
    /**
     * 后台流水号2
     */
    public BlackSerialNo2: string;
    /**
     * 营业日期
     */
    public BusinessDate: string;

    constructor() {
        this.TradeNo = '';
        this.TellerNo = '';
        this.Tlrlvl = '';
        this.BrNo = '';
        this.TradeFileName = '';
        this.Status = 0;
        this.BlackSerialNo = '';
        this.BlackSerialNo2 = '';
        this.BusinessDate = '';
    }

    /**
     * 将对象属性转换为字符串数组
     * @returns 包含对象属性值的字符串数组
     */
    public ChangeToTable(): string[] {
        return [
            this.TradeNo,
            this.TellerNo,
            this.Tlrlvl,
            this.BrNo,
            this.TradeFileName,
            this.Status.toString(),
            this.BlackSerialNo,
            this.BlackSerialNo2,
            this.BusinessDate
        ];
    }

    /**
     * 从对象数组中获取值并赋值给当前对象的属性
     * @param parms 包含属性值的对象数组
     */
    public ChangeFromTable(parms: any[]): void {
        if (parms !== null && parms.length === 9) {
            this.TradeNo = parms[0].toString();
            this.TellerNo = parms[1].toString();
            this.Tlrlvl = parms[2].toString();
            this.BrNo = parms[3].toString();
            this.TradeFileName = parms[4].toString();
            this.Status = parseInt(parms[5].toString(), 10);
            this.BlackSerialNo = parms[6].toString();
            this.BlackSerialNo2 = parms[7].toString();
            this.BusinessDate = parms[8].toString();
        }
    }
}