// 由于 IEntity 接口在 C# 中未给出具体内容，这里先留空，可按需补充
interface IEntity {}

class TradeInfo implements IEntity {
    // 交易号
    public TxCode: string;
    // 操作员
    public Tel: string;
    // 交易机构
    public TxBrNo: string;
    // 授权要素信息
    public AuthElement: string;
    // 方法序号
    public FuncNum: string;

    constructor() {
        this.TxCode = "";
        this.Tel = "";
        this.TxBrNo = "";
        this.AuthElement = "";
        this.FuncNum = "";
    }

    /**
     * 将 TradeInfo 实例的属性转换为字符串数组
     * @returns 包含属性值的字符串数组
     */
    public ChangeToTable(): string[] {
        return [this.TxCode, this.Tel, this.TxBrNo, this.AuthElement, this.FuncNum];
    }

    /**
     * 从对象数组中读取值并赋值给 TradeInfo 实例的属性
     * @param parms 包含属性值的对象数组
     */
    public ChangeFromTable(parms: any[]): void {
        this.TxCode = parms[0].toString();
        this.Tel = parms[1].toString();
        this.TxBrNo = parms[2].toString();
        this.AuthElement = parms[3].toString();
        this.FuncNum = parms[4].toString();
    }
}

export { TradeInfo };