// 由于 TypeScript 没有直接对应的 IEntity 接口，这里假设它是一个空接口
interface IEntity {}

/**
 * 交易流水记录类
 */
class TwftTradeRecords implements IEntity {
    /**
     * 流水ID
     */
    private SERIALID: string | null = null;
    /**
     * 前台流水号
     */
    public SERIALNO: string | null = null;
    /**
     * 交易号
     */
    public TRADENO: string | null = null;
    /**
     * 发起柜员
     */
    private TELLER: string | null = null;
    /**
     * 发起机构号
     */
    private BRANCH: string | null = null;
    /**
     * 营业日期
     */
    private BUSINESSDATE: string | null = null;
    /**
     * 开始时间
     */
    private STARTTIME: string | null = null;
    /**
     * 结束时间
     */
    public ENDTIME: string | null = null;
    /**
     * 业务状态 0:正在执行;1:正常结束;2:非正常结束(中途被拒绝或撤销)
     */
    private STATUS: number = 0;
    /**
     * 打印票号
     */
    private PRINTNUM: number = 0;
    /**
     * 第三方流水
     */
    public THIRDSERIALNO: string | null = null;
    /**
     * 第三方服务类型
     */
    private SERVICETYPE: number = 0;
    /**
     * 发送报文
     */
    private SENDMSG: Uint8Array | null = null;
    /**
     * 接收报文
     */
    private RECMSG: Uint8Array | null = null;
    /**
     * 交易返回码
     */
    private RETCODE: string | null = null;
    /**
     * 扩展字段一
     */
    private ext1: string | null = null;
    /**
     * 扩展字段二
     */
    private ext2: string | null = null;
    /**
     * 扩展字段三
     */
    public exts3: string | null = null;
    private comments: string | null = null;

    /**
     * 从数组参数中更新对象属性
     * @param parms - 包含数据的对象数组
     */
    public ChangeFromTable(parms: any[]): void {
        this.SERIALID = parms[0]?.toString() || null;
        this.SERIALNO = parms[1]?.toString() || null;
        this.TRADENO = parms[2]?.toString() || null;
        this.TELLER = parms[3]?.toString() || null;
        this.BRANCH = parms[4]?.toString() || null;
        this.BUSINESSDATE = parms[5]?.toString() || null;
        this.STARTTIME = parms[6]?.toString() || null;
        this.ENDTIME = parms[7]?.toString() || null;
        this.THIRDSERIALNO = parms[8]?.toString() || null;
        this.RETCODE = parms[9]?.toString() || null;
        this.exts3 = parms[10]?.toString() || null; 
    }

    /**
     * 将对象属性转换为字符串数组
     * @returns 包含对象属性值的字符串数组
     */
    public ChangeToTable(): string[] {
        return [
            this.SERIALID || '',
            this.SERIALNO || '',
            this.TRADENO || '',
            this.TELLER || '',
            this.BRANCH || '',
            this.BUSINESSDATE || '',
            this.STARTTIME || '',
            this.ENDTIME || '',
            this.THIRDSERIALNO || '',
            this.RETCODE || '',
            this.exts3 || ''
        ];
    }
}

export { TwftTradeRecords };