// 假设这些类型在其他文件中定义，需要按需导入
interface TransitEntity {
    ServiceName: string;
    FuncName: string;
}

interface AttachFile {
    AttachValue: any;
}

interface ServiceManager {
    static GetInstance(): ServiceManager;
    Commit(entity: TransitEntity): AttachFile[];
}

export class FingerConfigHandle {
    /**
     * 获取服务端指纹服务器配置地址
     * @returns 服务端指纹服务器配置地址
     */
    public static GetFingerService(): string {
        let service: string = '';
        try {
            const entity: TransitEntity = {
                ServiceName: "UtilService",
                FuncName: "getFingerIp"
            };
            const list: AttachFile[] = ServiceManager.GetInstance().Commit(entity);
            if (list.length > 0) {
                service = list[0].AttachValue.toString();
            }
        } catch (ex) {
            throw ex;
        }
        return service;
    }
}