// 定义 IEntity 接口，若有具体内容需补充
interface IEntity {}

/**
 * 登录数据类，包含柜员登录相关的各种信息
 */
class LoginData implements IEntity {
    // 柜员ID
    UserId: string;
    // 柜员号
    UserCode: string;
    // 柜员名称
    UserName: string;
    // 当前登陆状态
    IsPiont: string;
    // 启用标志
    IsLogin: string;
    // 所属机构
    KinbrId: string;
    // ATM管理柜员
    MngatmUser: string;
    // 用户密码
    UserPsw: string;
    // IC卡id
    CardId: string;
    // IC卡管理级别
    CardLevel: string;
    // 上次密码修改日期
    PwdChgDate: string;
    // 上次登录IP
    LoginIp: string;
    // 上次登录端口
    PortNo: string;
    // 上次登录时间
    BeforeDate: string;
    // 当前系统日期
    Date: string;
    // 登陆验证方式
    PswLevel: string;
    // 上次验证方式修改日期
    LevelChgDate: string;
    // 登陆验证方式有效期
    LevelDate: string;
    // 登陆修改密码
    IsChangePsw: string;
    // 密码连续错误次数
    PswErrCount: string;
    // 上次密码错误时间
    PswTime: string;
    // 当前登陆状态
    ChenkSign: string;
    // 最大密码修改周期
    MaxPswCycle: string;
    // 是否允许强制登陆
    CanForceLogin: boolean;
    // 机构编号
    KinbrNo: string;
    // 是否跨终端登录
    IsAcross: string;
    // 是否允许多角色登录
    CanGroupsLogin: boolean;
    // 凭证管理上级机构
    UpNoteKinbrno: string;
    // 现金管理上级机构
    UpCashKinbrno: string;
    // 上级机构凭证管理员
    upnoteteller: string;
    // 上级机构现金管理员
    upcashteller: string;
    // 机构类型
    kinbrtype: string;
    // 柜员表备用字段--旧柜员号
    usercomment: string;
    // 机构表备用字段--旧机构号
    kinbrcomment: string;
    // 身份证号
    idCarNo: string;
    // 汇总机构
    GroupKinbrNo: string;
    // 是否移动端
    IsMobile: boolean;

    constructor() {
        // 初始化属性，可根据实际情况修改默认值
        this.UserId = "";
        this.UserCode = "";
        this.UserName = "";
        this.IsPiont = "";
        this.IsLogin = "";
        this.KinbrId = "";
        this.MngatmUser = "";
        this.UserPsw = "";
        this.CardId = "";
        this.CardLevel = "";
        this.PwdChgDate = "";
        this.LoginIp = "";
        this.PortNo = "";
        this.BeforeDate = "";
        this.Date = "";
        this.PswLevel = "";
        this.LevelChgDate = "";
        this.LevelDate = "";
        this.IsChangePsw = "";
        this.PswErrCount = "";
        this.PswTime = "";
        this.ChenkSign = "";
        this.MaxPswCycle = "";
        this.CanForceLogin = false;
        this.KinbrNo = "";
        this.IsAcross = "";
        this.CanGroupsLogin = false;
        this.UpNoteKinbrno = "";
        this.UpCashKinbrno = "";
        this.upnoteteller = "";
        this.upcashteller = "";
        this.kinbrtype = "";
        this.usercomment = "";
        this.kinbrcomment = "";
        this.idCarNo = "";
        this.GroupKinbrNo = "";
        this.IsMobile = false;
    }

    /**
     * 将登录数据转换为字符串数组
     * @returns 包含所有登录数据的字符串数组
     */
    ChangeToTable(): string[] {
        return [
            this.UserId, this.UserCode, this.UserName, this.IsPiont, this.IsLogin,
            this.KinbrId, this.MngatmUser, this.UserPsw, this.CardId, this.CardLevel,
            this.PwdChgDate, this.LoginIp, this.PortNo, this.BeforeDate, this.Date,
            this.PswLevel, this.LevelChgDate, this.LevelDate, this.IsChangePsw,
            this.PswErrCount, this.PswTime, this.ChenkSign, this.MaxPswCycle,
            this.CanForceLogin.toString(), this.KinbrNo, this.IsAcross,
            this.CanGroupsLogin.toString(), this.UpNoteKinbrno, this.UpCashKinbrno,
            this.upnoteteller, this.upcashteller, this.kinbrtype, this.usercomment,
            this.kinbrcomment, this.idCarNo, this.GroupKinbrNo, this.IsMobile.toString()
        ];
    }

    /**
     * 从对象数组中填充登录数据
     * @param parms 包含登录数据的对象数组
     */
    ChangeFromTable(parms: any[]): void {
        this.UserId = parms[0].toString();
        this.UserCode = parms[1].toString();
        this.UserName = parms[2].toString();
        this.IsPiont = parms[3].toString();
        this.IsLogin = parms[4].toString();
        this.KinbrId = parms[5].toString();
        this.MngatmUser = parms[6].toString();
        this.UserPsw = parms[7].toString();
        this.CardId = parms[8].toString();
        this.CardLevel = parms[9].toString();
        this.PwdChgDate = parms[10].toString();
        this.LoginIp = parms[11].toString();
        this.PortNo = parms[12].toString();
        this.BeforeDate = parms[13].toString();
        this.Date = parms[14].toString();
        this.PswLevel = parms[15].toString();
        this.LevelChgDate = parms[16].toString();
        this.LevelDate = parms[17].toString();
        this.IsChangePsw = parms[18].toString();
        this.PswErrCount = parms[19].toString();
        this.PswTime = parms[20].toString();
        this.ChenkSign = parms[21].toString();
        this.MaxPswCycle = parms[22].toString();
        this.CanForceLogin = Boolean(parms[23]);
        this.KinbrNo = parms[24].toString();
        this.IsAcross = parms[25].toString();
        this.CanGroupsLogin = Boolean(parms[26]);
        this.UpNoteKinbrno = parms[27].toString();
        this.UpCashKinbrno = parms[28].toString();
        this.upnoteteller = parms[29].toString();
        this.upcashteller = parms[30].toString();
        this.kinbrtype = parms[31].toString();
        this.usercomment = parms[32].toString();
        this.kinbrcomment = parms[33].toString();
        this.idCarNo = parms[34].toString();
        this.GroupKinbrNo = parms[35].toString();
        this.IsMobile = parms[36] === "1";
    }
}

export default LoginData;