// 假设 IEntity 接口定义如下，如果有实际定义需要替换
interface IEntity {
    // 这里可以根据实际情况补充接口的成员
}

class PrintExtData implements IEntity {
    /**
     * 系统流水号
     */
    SerialId: string;
    /**
     * 
     */
    TradeAction: string;
    /**
     * 打印类全名
     */
    ClassFullName: string;
    /**
     * 报文类型
     */
    MsgType: string;
    /**
     * 属性
     */
    Attributes: string;
    /**
     * 总线
     */
    TradeBus: string;
    /**
     * 报文
     */
    Message: Uint8Array;
    /**
     * 报文附件
     */
    MsgFile: Uint8Array;

    constructor() {
        this.SerialId = "";
        this.TradeAction = "";
        this.ClassFullName = "";
        this.MsgType = "";
        this.Attributes = "";
        this.TradeBus = "";
        this.Message = new Uint8Array();
        this.MsgFile = new Uint8Array();
    }

    /**
     * 从对象数组中填充属性值
     * @param parms 对象数组
     */
    ChangeFromTable(parms: any[]): void {
        this.SerialId = parms[0].toString();
        this.TradeAction = parms[1].toString();
        this.ClassFullName = parms[2].toString();
        this.MsgType = parms[3].toString();
    }

    /**
     * 将部分属性转换为字符串数组
     * @returns 包含部分属性值的字符串数组
     */
    ChangeToTable(): string[] {
        return [this.SerialId, this.TradeAction, this.ClassFullName, this.MsgType];
    }
}

export { PrintExtData };