// 假设 IEntity 接口在其他地方定义，这里先简单定义占位
interface IEntity {}

/**
 * 通知下发信息实体表
 */
class TBL_Sys_NotifyMessage implements IEntity {
    /**
     * 信息ID
     */
    Info_Id: string;
    /**
     * 标题
     */
    Info_Title: string;
    /**
     * 发送人编号
     */
    Info_SendCode: string;
    /**
     * 发送人
     */
    Info_SendName: string;
    /**
     * 开始时间
     */
    Info_StartTime: string;
    /**
     * 结束时间
     */
    Info_EndTime: string;
    /**
     * 附件名
     */
    Info_Annex: string;
    /**
     * 日期
     */
    Info_Date: string;

    constructor() {
        this.Info_Id = "";
        this.Info_Title = "";
        this.Info_SendCode = "";
        this.Info_SendName = "";
        this.Info_StartTime = "";
        this.Info_EndTime = "";
        this.Info_Annex = "";
        this.Info_Date = "";
    }

    /**
     * 从数组参数初始化对象属性
     * @param parms - 包含属性值的数组
     */
    ChangeFromTable(parms: any[]): void {
        this.Info_Id = parms[0].toString();
        this.Info_Title = parms[1].toString();
        this.Info_SendCode = parms[2].toString();
        this.Info_SendName = parms[3].toString();
        this.Info_StartTime = parms[4].toString();
        this.Info_EndTime = parms[5].toString();
        this.Info_Annex = parms[6].toString();
        this.Info_Date = parms[7].toString();
    }

    /**
     * 将对象属性转换为字符串数组
     * @returns 包含对象属性值的字符串数组
     */
    ChangeToTable(): string[] {
        return [
            this.Info_Id,
            this.Info_Title,
            this.Info_SendCode,
            this.Info_SendName,
            this.Info_StartTime,
            this.Info_EndTime,
            this.Info_Annex,
            this.Info_Date
        ];
    }
}

export { TBL_Sys_NotifyMessage };