// 假设 IEntity 是一个空接口，因为原代码未给出其定义
interface IEntity {}

/**
 * 柜员发送的机构和角色实体
 */
class TBL_Sys_SendGroupRole implements IEntity {
    /**
     * 信息ID
     */
    Info_Id: string;

    /**
     * 机构和角色编号
     */
    Info_GroupRole: string;

    /**
     * 类别
     */
    Info_Type: string;

    /**
     * 机构名称
     */
    Info_GroupName: string;

    /**
     * 角色名称
     */
    Info_RoleName: string;

    constructor() {
        this.Info_Id = "";
        this.Info_GroupRole = "";
        this.Info_Type = "";
        this.Info_GroupName = "";
        this.Info_RoleName = "";
    }

    /**
     * 从对象数组填充属性值
     * @param parms - 对象数组
     */
    ChangeFromTable(parms: any[]): void {
        this.Info_Id = parms[0].toString();
        this.Info_GroupRole = parms[1].toString();
        this.Info_Type = parms[2].toString();
        this.Info_GroupName = parms[3].toString();
        this.Info_RoleName = parms[4].toString();
    }

    /**
     * 将属性值转换为字符串数组
     * @returns 包含属性值的字符串数组
     */
    ChangeToTable(): string[] {
        // 原代码此处可能存在笔误，重复使用了 Info_GroupRole，按原代码逻辑保留
        return [this.Info_Id, this.Info_GroupRole, this.Info_Type, this.Info_GroupName, this.Info_GroupRole];
    }
}

export { TBL_Sys_SendGroupRole };