// 假设 IEntity 是一个接口，这里先简单定义，实际需要根据项目情况调整
interface IEntity {}

/**
 * 终端号管理实体
 */
class TBL_Sys_TerminalNumber implements IEntity {
    /**
     * 机构号
     */
    KinbrNo: string;
    /**
     * 机构名称
     */
    KinbrName: string;
    /**
     * 终端号
     */
    TerminalNumber: string;
    /**
     * 注册柜员号
     */
    TellerNumber: string;
    /**
     * 注册时间
     */
    RegisterTime: string;
    /**
     * 激活码
     */
    ActivationCode: string;
    /**
     * 未接设备
     */
    DeviceNumber: string;
    /**
     * 状态
     */
    Status: string;

    constructor() {
        this.KinbrNo = '';
        this.KinbrName = '';
        this.TerminalNumber = '';
        this.TellerNumber = '';
        this.RegisterTime = '';
        this.ActivationCode = '';
        this.DeviceNumber = '';
        this.Status = '';
    }

    /**
     * 从数组参数中更新实体属性
     * @param parms - 包含属性值的数组
     */
    ChangeFromTable(parms: any[]): void {
        this.KinbrNo = parms[0].toString();
        this.KinbrName = parms[1].toString();
        this.TerminalNumber = parms[2].toString();
        this.TellerNumber = parms[3].toString();
        this.RegisterTime = parms[4].toString();
        this.ActivationCode = parms[5].toString();
        this.DeviceNumber = parms[6].toString();
        this.Status = parms[7].toString();
    }

    /**
     * 将实体属性转换为字符串数组
     * @returns 包含实体属性值的字符串数组
     */
    ChangeToTable(): string[] {
        return [
            this.KinbrNo,
            this.KinbrName,
            this.TerminalNumber,
            this.TellerNumber,
            this.RegisterTime,
            this.ActivationCode,
            this.DeviceNumber,
            this.Status
        ];
    }
}

export { TBL_Sys_TerminalNumber };