// 定义 IEntity 接口，由于原 C# 中未给出定义，这里简单定义一个空接口
interface IEntity {}

/**
 * 外接系统实体
 */
class TT_ExtSys implements IEntity {
    /**
     * 外接系统ID
     */
    Extid: string;

    /**
     * 外接系统名称
     */
    Extname: string;

    /**
     * 外接类型
     */
    Exttype: string;

    /**
     * IP地址/路径
     */
    Ipadd: string;

    /**
     * 开发方式
     */
    Devtypy: string;

    /**
     * 附加键
     */
    Appendkey: string;

    /**
     * 操作代码段
     */
    Devdata: string;

    /**
     * 密码键入方式
     */
    Pswpresstype: string;

    /**
     * 调用方式
     */
    Modeshow: string;

    /**
     * 调用参数声明
     */
    Inparasign: string;

    /**
     * 调用参数数据
     */
    Inparadata: string;

    /**
     * 被调用参数声明
     */
    Outparasign: string;

    /**
     * 被调用参数数据
     */
    Outparadata: string;

    /**
     * 功能ID
     */
    Ruleid: string;

    /**
     * 功能编号
     */
    Ruleno: string;

    constructor() {
        // 初始化属性
        this.Extid = '';
        this.Extname = '';
        this.Exttype = '';
        this.Ipadd = '';
        this.Devtypy = '';
        this.Appendkey = '';
        this.Devdata = '';
        this.Pswpresstype = '';
        this.Modeshow = '';
        this.Inparasign = '';
        this.Inparadata = '';
        this.Outparasign = '';
        this.Outparadata = '';
        this.Ruleid = '';
        this.Ruleno = '';
    }

    /**
     * 从数组参数中更新实体属性值
     * @param parms - 包含外接系统信息的数组
     */
    ChangeFromTable(parms: any[]): void {
        this.Extid = parms[0].toString();
        this.Extname = parms[1].toString();
        this.Exttype = parms[2].toString();
        this.Ipadd = parms[3].toString();
        this.Devtypy = parms[4].toString();
        this.Appendkey = parms[5].toString();
        this.Devdata = parms[6].toString();
        this.Pswpresstype = parms[7].toString();
        this.Modeshow = parms[8].toString();
        this.Inparasign = parms[9].toString();
        this.Inparadata = parms[10].toString();
        this.Outparasign = parms[11].toString();
        this.Outparadata = parms[12].toString();
        this.Ruleid = parms[13].toString();
        this.Ruleno = parms[14].toString();
    }

    /**
     * 将实体属性值转换为字符串数组
     * @returns 包含外接系统信息的字符串数组
     */
    ChangeToTable(): string[] {
        return [
            this.Extid,
            this.Extname,
            this.Exttype,
            this.Ipadd,
            this.Devtypy,
            this.Appendkey,
            this.Devdata,
            this.Pswpresstype,
            this.Modeshow,
            this.Inparasign,
            this.Inparadata,
            this.Outparasign,
            this.Outparadata,
            this.Ruleid,
            this.Ruleno
        ];
    }
}

export default TT_ExtSys;