// 定义 IEntity 接口，由于原 C# 代码未给出其定义，这里简单留空
interface IEntity {}

/**
 * 外接系统用户 【根据角色】实体
 */
class TT_Extsys_ExtuserFromByGroup implements IEntity {
    /**
     * 功能ID
     */
    RuleId: string;

    /**
     * 外接系统id
     */
    ExtId: string;

    /**
     * 交易(功能)编号
     */
    RuleNo: string;

    /**
     * 外接系统名称
     */
    ExtName: string;

    /**
     * 外接用户ID(外系统登录账号)
     */
    ExtUserId: string;

    /**
     * 外接用户密码
     */
    ExtPsw: string;

    /**
     * 外接机构
     */
    ExtKinbr: string;

    /**
     * 系统地址，ip（web系统），绝对路径（exe）
     */
    ExtAddress: string;

    /**
     * 外接系统类型，exe或者web
     */
    ExtType: string;

    /**
     * 系统参数脚本，
     */
    ArgStript: string;

    constructor() {
        this.RuleId = "";
        this.ExtId = "";
        this.RuleNo = "";
        this.ExtName = "";
        this.ExtUserId = "";
        this.ExtPsw = "";
        this.ExtKinbr = "";
        this.ExtAddress = "";
        this.ExtType = "";
        this.ArgStript = "";
    }

    /**
     * 将实体属性转换为字符串数组
     */
    ChangeToTable(): string[] {
        return [
            this.RuleId,
            this.ExtId,
            this.RuleNo,
            this.ExtName,
            this.ExtUserId,
            this.ExtPsw,
            this.ExtKinbr,
            this.ExtAddress,
            this.ExtType,
            this.ArgStript
        ];
    }

    /**
     * 从对象数组中读取数据并赋值给实体属性
     * @param parms - 包含数据的对象数组
     */
    ChangeFromTable(parms: any[]): void {
        this.RuleId = parms[0].toString();
        this.ExtId = parms[1].toString();
        this.RuleNo = parms[2].toString();
        this.ExtName = parms[3].toString();
        this.ExtUserId = parms[4].toString();
        this.ExtPsw = parms[5].toString();
        this.ExtKinbr = parms[6].toString();
        this.ExtAddress = parms[7].toString();
        this.ExtType = parms[8].toString();
        this.ArgStript = parms[9].toString();
    }
}

export { TT_Extsys_ExtuserFromByGroup };