// 定义 PropertyChangedEventHandler 类型
type PropertyChangedEventHandler = (sender: any, args: { propertyName: string }) => void;

// 模拟 IEntity 接口，这里暂时为空，可根据实际情况补充
interface IEntity {}

// 定义 TT_Form 类
class TT_Form implements IEntity {
    private _propertyChanged: PropertyChangedEventHandler[] = [];

    // 定义 PropertyChanged 事件，使用数组存储回调函数
    public get PropertyChanged(): {
        add: (handler: PropertyChangedEventHandler) => void;
        remove: (handler: PropertyChangedEventHandler) => void;
    } {
        return {
            add: (handler) => {
                this._propertyChanged.push(handler);
            },
            remove: (handler) => {
                const index = this._propertyChanged.indexOf(handler);
                if (index !== -1) {
                    this._propertyChanged.splice(index, 1);
                }
            }
        };
    }

    private id: string;
    private formId: string;
    private formName: string;
    private description: string;

    public get Id(): string {
        return this.id;
    }

    public set Id(value: string) {
        this.id = value;
        this._propertyChanged.forEach(handler => handler(this, { propertyName: 'Id' }));
    }

    public get FormId(): string {
        return this.formId;
    }

    public set FormId(value: string) {
        this.formId = value;
        this._propertyChanged.forEach(handler => handler(this, { propertyName: 'FormId' }));
    }

    public get FormName(): string {
        return this.formName;
    }

    public set FormName(value: string) {
        this.formName = value;
        this._propertyChanged.forEach(handler => handler(this, { propertyName: 'FormName' }));
    }

    public get Description(): string {
        return this.description;
    }

    public set Description(value: string) {
        this.description = value;
        this._propertyChanged.forEach(handler => handler(this, { propertyName: 'Description' }));
    }

    public ChangeFromTable(parms: any[]): void {
        this.Id = parms[0] === null ? '' : String(parms[0]);
        this.FormId = parms[1] === null ? '' : String(parms[1]);
        this.FormName = parms[2] === null ? '' : String(parms[2]);
        this.Description = parms[3] === null ? '' : String(parms[3]);
    }

    public ChangeToTable(): string[] {
        return [this.Id, this.FormId, this.FormName, this.Description];
    }
}

export { TT_Form };