// 定义 PropertyChangedEventHandler 类型
type PropertyChangedEventHandler = (sender: any, args: { propertyName: string }) => void;

// 定义 IEntity 接口，由于原代码未给出其定义，这里先留空
interface IEntity {}

// 定义 TT_FormKind 类
class TT_FormKind implements IEntity {
    // 定义 PropertyChanged 事件
    private _propertyChanged?: PropertyChangedEventHandler;

    get PropertyChanged(): PropertyChangedEventHandler | undefined {
        return this._propertyChanged;
    }

    set PropertyChanged(value: PropertyChangedEventHandler | undefined) {
        this._propertyChanged = value;
    }

    private id: string;
    private formKindName: string;
    private printFlag: string;

    get Id(): string {
        return this.id;
    }

    set Id(value: string) {
        this.id = value;
        if (this._propertyChanged) {
            this._propertyChanged(this, { propertyName: 'Id' });
        }
    }

    get FormKindName(): string {
        return this.formKindName;
    }

    set FormKindName(value: string) {
        this.formKindName = value;
        if (this._propertyChanged) {
            this._propertyChanged(this, { propertyName: 'FormKindName' });
        }
    }

    get PrintFlag(): string {
        return this.printFlag;
    }

    set PrintFlag(value: string) {
        this.printFlag = value;
        if (this._propertyChanged) {
            this._propertyChanged(this, { propertyName: 'PrintFlag' });
        }
    }

    // 从数组中更新对象属性
    public ChangeFromTable(parms: any[]): void {
        this.Id = parms[0].toString();
        this.FormKindName = parms[1].toString();
        this.PrintFlag = parms[2].toString();
    }

    // 将对象属性转换为数组
    public ChangeToTable(): string[] {
        return [this.Id, this.FormKindName, this.PrintFlag];
    }
}

export { TT_FormKind };