// 假设 IEntity 是一个空接口，因为原代码未给出其定义
interface IEntity {}

/**
 * 角色与功能关系实体
 */
class TT_GroupRule implements IEntity { 
    /**
     * 角色ID
     */
    GroupId: string;
    /**
     * 角色编号
     */
    GroupCode: string;
    /**
     * 角色名称
     */
    GroupName: string;

    constructor() {
        this.GroupId = "";
        this.GroupCode = "";
        this.GroupName = "";
    }

    /**
     * 从数组中转换数据到实体
     * @param parms - 包含角色信息的数组
     */
    ChangeFromTable(parms: any[]): void {
        this.GroupId = parms[0].toString();
        this.GroupCode = parms[1].toString();
        this.GroupName = parms[2].toString();
    }

    /**
     * 将实体数据转换为数组
     * @returns 包含角色信息的字符串数组
     */
    ChangeToTable(): string[] {
        return [this.GroupId, this.GroupCode, this.GroupName];
    }
}

export { TT_GroupRule };