// 定义 IEntity 接口，这里由于原 C# 代码未给出其定义，先简单占位
interface IEntity {}

/**
 * 机构实体
 */
class TT_KinbrInfo implements IEntity {
    /**
     * 机构id
     */
    KinbrId: string;
    /**
     * 机构编号
     */
    KinbrNo: string;
    /**
     * 机构名称
     */
    KinbrName: string;
    /**
     * 机构描述
     */
    KinbrRemark: string;
    /**
     * 机构类型
     */
    KinbrType: string;
    /**
     * 电话号码
     */
    KinbrTel: string;
    /**
     * 机构地址
     */
    KinbrAdd: string;
    /**
     * 联系人
     */
    Contact: string;
    /**
     * 备注
     */
    KinbrComment: string;
    /**
     * 现金上级机构
     */
    CASHUPKINBRNO: string;
    /**
     * 凭证上级机构
     */
    VOUCHERUPKINBRNO: string;
    /**
     * 机构关系类型
     */
    Reltype: string;
    /**
     * 行政管理类型
     */
    XZGLUPBACKNO: string;

    constructor() {
        this.KinbrId = "";
        this.KinbrNo = "";
        this.KinbrName = "";
        this.KinbrRemark = "";
        this.KinbrType = "";
        this.KinbrTel = "";
        this.KinbrAdd = "";
        this.Contact = "";
        this.KinbrComment = "";
        this.CASHUPKINBRNO = "";
        this.VOUCHERUPKINBRNO = "";
        this.Reltype = "";
        this.XZGLUPBACKNO = "";
    }

    /**
     * 从数组参数中更新实体属性
     * @param parms - 包含机构信息的数组
     */
    ChangeFromTable(parms: any[]): void {
        this.KinbrId = parms[0].toString();
        this.KinbrNo = parms[1].toString();
        this.KinbrName = parms[2].toString();
        this.KinbrRemark = parms[3].toString();
        this.KinbrType = parms[4].toString();
        this.KinbrTel = parms[5].toString();
        this.KinbrAdd = parms[6].toString();
        this.Contact = parms[7].toString();
        this.KinbrComment = parms[8].toString();
        this.Reltype = parms[9].toString();
        this.CASHUPKINBRNO = parms[10].toString();
        this.VOUCHERUPKINBRNO = parms[11].toString();
        this.XZGLUPBACKNO = parms[12].toString();
    }

    /**
     * 将实体属性转换为字符串数组
     * @returns 包含机构信息的字符串数组
     */
    ChangeToTable(): string[] {
        return [
            this.KinbrId,
            this.KinbrNo,
            this.KinbrName,
            this.KinbrRemark,
            this.KinbrType,
            this.KinbrTel,
            this.KinbrAdd,
            this.Contact,
            this.KinbrComment,
            this.Reltype,
            this.CASHUPKINBRNO,
            this.VOUCHERUPKINBRNO,
            this.XZGLUPBACKNO
        ];
    }
}

export default TT_KinbrInfo;