// 定义 PropertyChangedEventHandler 类型
type PropertyChangedEventHandler = (sender: any, args: { propertyName: string }) => void;

/**
 * 登录状态验证实体
 */
class TT_LoginSign {
    // 字段
    private _userid: string;
    private _usercode: string;
    private _chenksign: string;
    private _loginip: string;
    private _portno: string;
    private _loginmarc: string;
    private _logintime: string;
    private _logingroups: string;

    // 事件
    public PropertyChanged: PropertyChangedEventHandler | null = null;

    constructor() {
        this._userid = '';
        this._usercode = '';
        this._chenksign = '';
        this._loginip = '';
        this._portno = '';
        this._loginmarc = '';
        this._logintime = '';
        this._logingroups = '';
    }

    /**
     * 用户ID
     */
    get UserID(): string {
        return this._userid;
    }

    set UserID(value: string) {
        this._userid = value;
        this.RaisePropertyChanged('UserID');
    }

    get UserCode(): string {
        return this._usercode;
    }

    set UserCode(value: string) {
        this._usercode = value;
        this.RaisePropertyChanged('UserCode');
    }

    /**
     * 签到签退状态
     */
    get ChenkSign(): string {
        return this._chenksign;
    }

    set ChenkSign(value: string) {
        this._chenksign = value;
        this.RaisePropertyChanged('ChenkSign');
    }

    /**
     * 登陆IP地址
     */
    get LoginIp(): string {
        return this._loginip;
    }

    set LoginIp(value: string) {
        this._loginip = value;
        this.RaisePropertyChanged('LoginIp');
    }

    /**
     * 登陆端口号
     */
    get PortNo(): string {
        return this._portno;
    }

    set PortNo(value: string) {
        this._portno = value;
        this.RaisePropertyChanged('PortNo');
    }

    /**
     * 登陆MARC地址
     */
    get LoginMarc(): string {
        return this._loginmarc;
    }

    set LoginMarc(value: string) {
        this._loginmarc = value;
        this.RaisePropertyChanged('LoginMarc');
    }

    /**
     * 登陆时间
     */
    get LoginTime(): string {
        return this._logintime;
    }

    set LoginTime(value: string) {
        this._logintime = value;
        this.RaisePropertyChanged('LoginTime');
    }

    get LoginGroups(): string {
        return this._logingroups;
    }

    set LoginGroups(value: string) {
        this._logingroups = value;
        // 原 C# 代码这里有拼写错误，修正为 'LoginGroups'
        this.RaisePropertyChanged('LoginGroups'); 
    }

    /**
     * 从数组参数更新实体属性
     * @param parms - 包含属性值的数组
     */
    public ChangeFromTable(parms: any[]): void {
        this.UserID = parms[0].toString();
        this.UserCode = parms[1].toString();
        this.ChenkSign = parms[2].toString();
        this.LoginIp = parms[3].toString();
        this.PortNo = parms[4].toString();
        this.LoginMarc = parms[5].toString();
        this.LoginTime = parms[6].toString();
        this.LoginGroups = parms[7].toString();
    }

    /**
     * 将实体属性转换为字符串数组
     * @returns 包含属性值的字符串数组
     */
    public ChangeToTable(): string[] {
        return [this.UserID, this.UserCode, this.ChenkSign, this.LoginIp, this.PortNo, this.LoginMarc, this.LoginTime, this.LoginGroups];
    }

    /**
     * 触发属性变更事件
     * @param propertyName - 发生变更的属性名
     */
    public RaisePropertyChanged(propertyName: string): void {
        if (this.PropertyChanged) {
            this.PropertyChanged(this, { propertyName });
        }
    }
}

export default TT_LoginSign;