// 定义 PropertyChangedEventHandler 类型
type PropertyChangedEventHandler = (sender: any, args: PropertyChangedEventArgs) => void;

// 定义 PropertyChangedEventArgs 类
class PropertyChangedEventArgs {
    constructor(public propertyName: string) {}
}

// 定义 IEntity 接口（这里只是占位，具体实现根据实际情况补充）
interface IEntity {}

// 定义 INotifyPropertyChanged 接口
interface INotifyPropertyChanged {
    PropertyChanged: PropertyChangedEventHandler | null;
    RaisePropertyChanged(propertyName: string): void;
}

// 用户信息实体类
class TT_LoginUser implements IEntity, INotifyPropertyChanged {
    private _userid: string;
    private _usercode: string;
    private _username: string;
    private _kinbrid: string;
    private _kinbrno: string;
    private _userDescription: string;
    private _docId: string;
    private _isPiont: string;
    private _isLogin: string;
    private _isAtm: string;
    private _telephone: string;
    private _userComment: string;
    private _mngatmuser: string;
    private _isAcross: string;
    private _authlvldes: string;
    private _ismobile: string;

    public PropertyChanged: PropertyChangedEventHandler | null = null;

    constructor() {
        this._userid = '';
        this._usercode = '';
        this._username = '';
        this._kinbrid = '';
        this._kinbrno = '';
        this._userDescription = '';
        this._docId = '';
        this._isPiont = '';
        this._isLogin = '';
        this._isAtm = '';
        this._telephone = '';
        this._userComment = '';
        this._mngatmuser = '';
        this._isAcross = '';
        this._authlvldes = '';
        this._ismobile = '';
    }

    // 用户ID
    get UserId(): string {
        return this._userid;
    }
    set UserId(value: string) {
        this._userid = value;
        this.RaisePropertyChanged('UserId');
    }

    // 用户登录账号
    get UserCode(): string {
        return this._usercode;
    }
    set UserCode(value: string) {
        this._usercode = value;
        this.RaisePropertyChanged('UserCode');
    }

    // 姓名
    get UserName(): string {
        return this._username;
    }
    set UserName(value: string) {
        this._username = value;
        this.RaisePropertyChanged('UserName');
    }

    // 所属机构
    get KinbrId(): string {
        return this._kinbrid;
    }
    set KinbrId(value: string) {
        this._kinbrid = value;
        this.RaisePropertyChanged('KinbrId');
    }

    // 机构号
    get KinBrno(): string {
        return this._kinbrno;
    }
    set KinBrno(value: string) {
        this._kinbrno = value;
        this.RaisePropertyChanged('KinBrno');
    }

    // 用户描述
    get UserDescription(): string {
        return this._userDescription;
    }
    set UserDescription(value: string) {
        this._userDescription = value;
        this.RaisePropertyChanged('UserDescription');
    }

    // 身份证号
    get DocId(): string {
        return this._docId;
    }
    set DocId(value: string) {
        this._docId = value;
        this.RaisePropertyChanged('DocId');
    }

    // 是否单客户端
    get IsPiont(): string {
        return this._isPiont;
    }
    set IsPiont(value: string) {
        this._isPiont = value;
        this.RaisePropertyChanged('IsPiont');
    }

    // 锁定标志
    get IsLogin(): string {
        return this._isLogin;
    }
    set IsLogin(value: string) {
        this._isLogin = value;
        this.RaisePropertyChanged('IsLogin');
    }

    // 是否ATM柜员
    get IsAtm(): string {
        return this._isAtm;
    }
    set IsAtm(value: string) {
        this._isAtm = value;
        this.RaisePropertyChanged('IsAtm');
    }

    // 电话号码
    get Telephone(): string {
        return this._telephone;
    }
    set Telephone(value: string) {
        this._telephone = value;
        this.RaisePropertyChanged('Telephone');
    }

    // 备注
    get UserComment(): string {
        return this._userComment;
    }
    set UserComment(value: string) {
        this._userComment = value;
        this.RaisePropertyChanged('UserComment');
    }

    // ATM管理柜员
    get Mngatmuser(): string {
        return this._mngatmuser;
    }
    set Mngatmuser(value: string) {
        this._mngatmuser = value;
        this.RaisePropertyChanged('Mngatmuser');
    }

    // 是否跨终端登录
    get IsAcross(): string {
        return this._isAcross;
    }
    set IsAcross(value: string) {
        this._isAcross = value;
        this.RaisePropertyChanged('IsAcross');
    }

    // 授权级别
    get AuthLvlDdes(): string {
        return this._authlvldes;
    }
    set AuthLvlDdes(value: string) {
        this._authlvldes = value;
        this.RaisePropertyChanged('AuthLvlDdes');
    }

    // 是否移动端
    get IsMobile(): string {
        return this._ismobile;
    }
    set IsMobile(value: string) {
        this._ismobile = value;
        this.RaisePropertyChanged('IsMobile');
    }

    // 转换为数组
    public ChangeToTable(): string[] {
        return [
            this.UserId,
            this.UserCode,
            this.UserName,
            this.KinbrId,
            this.KinBrno,
            this.UserDescription,
            this.DocId,
            this.IsPiont,
            this.IsLogin,
            this.IsAtm,
            this.Telephone,
            this.UserComment,
            this.Mngatmuser,
            this.IsAcross,
            this.AuthLvlDdes,
            this.IsMobile
        ];
    }

    // 从数组转换
    public ChangeFromTable(parms: any[]): void {
        this.UserId = parms[0].toString();
        this.UserCode = parms[1].toString();
        this.UserName = parms[2].toString();
        this.KinbrId = parms[3].toString();
        this.KinBrno = parms[4].toString();
        this.UserDescription = parms[5].toString();
        this.DocId = parms[6].toString();
        this.IsPiont = parms[7].toString();
        this.IsLogin = parms[8].toString();
        this.IsAtm = parms[9].toString();
        this.Telephone = parms[10].toString();
        this.UserComment = parms[11].toString();
        this.Mngatmuser = parms[12].toString();
        this.IsAcross = parms[13].toString();
        this.AuthLvlDdes = parms[14].toString();
        this.IsMobile = parms[15].toString();
    }

    // 触发属性变更事件
    public RaisePropertyChanged(propertyName: string): void {
        if (this.PropertyChanged) {
            this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }

    // 复制新实例
    public Clone(): TT_LoginUser {
        const instance = new TT_LoginUser();
        instance.UserId = this.UserId;
        instance.UserCode = this.UserCode;
        instance.UserName = this.UserName;
        instance.KinbrId = this.KinbrId;
        instance.KinBrno = this.KinBrno;
        instance.UserDescription = this.UserDescription;
        instance.DocId = this.DocId;
        instance.IsPiont = this.IsPiont;
        instance.IsLogin = this.IsLogin;
        instance.IsAtm = this.IsAtm;
        instance.Telephone = this.Telephone;
        instance.UserComment = this.UserComment;
        instance.Mngatmuser = this.Mngatmuser;
        instance.IsAcross = this.IsAcross;
        instance.AuthLvlDdes = this.AuthLvlDdes;
        instance.IsMobile = this.IsMobile;
        return instance;
    }
}

export { TT_LoginUser };