// 定义 PropertyChangedEventHandler 类型
type PropertyChangedEventHandler = (sender: any, args: PropertyChangedEventArgs) => void;

// 定义 PropertyChangedEventArgs 类
class PropertyChangedEventArgs {
    constructor(public propertyName: string) {}
}

// 定义 IEntity 接口（这里由于无具体内容，先留空）
interface IEntity {}

// 定义 INotifyPropertyChanged 接口
interface INotifyPropertyChanged {
    PropertyChanged: PropertyChangedEventHandler | null;
}

// 定义 TT_PrintDataDetail 类
class TT_PrintDataDetail implements IEntity, INotifyPropertyChanged {
    public PropertyChanged: PropertyChangedEventHandler | null = null;

    private id: string = '';
    private formId: string = '';
    private date: string = '';
    private tellerNo: string = '';
    private authTellerNo: string = '';
    private description: string = '';

    get Id(): string {
        return this.id;
    }

    set Id(value: string) {
        this.id = value;
        if (this.PropertyChanged) {
            this.PropertyChanged(this, new PropertyChangedEventArgs('Id'));
        }
    }

    get FormId(): string {
        return this.formId;
    }

    set FormId(value: string) {
        this.formId = value;
        if (this.PropertyChanged) {
            this.PropertyChanged(this, new PropertyChangedEventArgs('FormId'));
        }
    }

    get Date(): string {
        return this.date;
    }

    set Date(value: string) {
        this.date = value;
        if (this.PropertyChanged) {
            this.PropertyChanged(this, new PropertyChangedEventArgs('Date'));
        }
    }

    get TellerNo(): string {
        return this.tellerNo;
    }

    set TellerNo(value: string) {
        this.tellerNo = value;
        if (this.PropertyChanged) {
            this.PropertyChanged(this, new PropertyChangedEventArgs('TellerNo'));
        }
    }

    get AuthTellerNo(): string {
        return this.authTellerNo;
    }

    set AuthTellerNo(value: string) {
        this.authTellerNo = value;
        if (this.PropertyChanged) {
            this.PropertyChanged(this, new PropertyChangedEventArgs('AuthTellerNo'));
        }
    }

    get Description(): string {
        return this.description;
    }

    set Description(value: string) {
        this.description = value;
        if (this.PropertyChanged) {
            this.PropertyChanged(this, new PropertyChangedEventArgs('Description'));
        }
    }

    public ChangeFromTable(parms: any[]): void {
        this.Id = parms[0].toString();
        this.FormId = parms[1].toString();
        this.Date = parms[2].toString();
        this.TellerNo = parms[3].toString();
        this.AuthTellerNo = parms[4].toString();
        this.Description = parms[5].toString();
    }

    public ChangeToTable(): string[] {
        return [this.Id, this.FormId, this.Date, this.TellerNo, this.AuthTellerNo, this.Description];
    }
}

export { TT_PrintDataDetail };