// 模拟依赖对象，在实际项目中可能需要根据具体情况实现
class DependencyObject {}

// 模拟 IEntity 接口，在实际项目中可能需要根据具体情况实现
interface IEntity {}

// 定义 PropertyChangedEventHandler 类型
type PropertyChangedEventHandler = (sender: any, args: { propertyName: string }) => void;

// 定义 INotifyPropertyChanged 接口
interface INotifyPropertyChanged {
    PropertyChanged: PropertyChangedEventHandler[];
}

// 定义 TT_PrintDataDetail2 类
class TT_PrintDataDetail2 extends DependencyObject implements IEntity, INotifyPropertyChanged {
    private id: string;
    private count: string;
    private description: string;
    private isreprint: string;
    private formid: string;

    public PropertyChanged: PropertyChangedEventHandler[] = [];

    constructor() {
        super();
        this.id = '';
        this.count = '';
        this.description = '';
        this.isreprint = '';
        this.formid = '';
    }

    get Id(): string {
        return this.id;
    }

    set Id(value: string) {
        this.id = value;
        this.PropertyChanged.forEach(handler => handler(this, { propertyName: 'Id' }));
    }

    get Count(): string {
        return this.count;
    }

    set Count(value: string) {
        this.count = value;
        this.PropertyChanged.forEach(handler => handler(this, { propertyName: 'Count' }));
    }

    get Description(): string {
        return this.description;
    }

    set Description(value: string) {
        this.description = value;
        this.PropertyChanged.forEach(handler => handler(this, { propertyName: 'Description' }));
    }

    get Isreprint(): string {
        return this.isreprint;
    }

    set Isreprint(value: string) {
        this.isreprint = value;
        this.PropertyChanged.forEach(handler => handler(this, { propertyName: 'Isreprint' }));
    }

    get FormId(): string {
        return this.formid;
    }

    set FormId(value: string) {
        this.formid = value;
        this.PropertyChanged.forEach(handler => handler(this, { propertyName: 'FormId' }));
    }

    public ChangeFromTable(parms: any[]): void {
        this.Id = parms[0].toString();
        this.Count = parms[1].toString();
        this.Description = parms[2].toString();
        this.Isreprint = parms[3].toString();
        this.FormId = parms[4].toString();
    }

    public ChangeToTable(): string[] {
        return [this.Id, this.Count, this.Description, this.Isreprint, this.FormId];
    }
}

export { TT_PrintDataDetail2 };