// 假设 IEntity 是一个空接口，因为原代码未给出其定义
interface IEntity {}

/**
 * 角色实体
 */
class TT_RoleGroup implements IEntity {
    /**
     * 角色ID
     */
    GroupId: string;

    /**
     * 角色编号(显示用)
     */
    GroupCode: string;

    /**
     * 角色名称
     */
    GroupName: string;

    /**
     * 角色描述
     */
    GroupRemark: string;

    /**
     * 副角色标志
     */
    IssysGroup: string;

    /**
     * 密码修改周期(天)
     */
    Pswcycle: string;

    /**
     * 备注
     */
    GroupComment: string;

    constructor() {
        this.GroupId = '';
        this.GroupCode = '';
        this.GroupName = '';
        this.GroupRemark = '';
        this.IssysGroup = '';
        this.Pswcycle = '';
        this.GroupComment = '';
    }

    /**
     * 将实体属性转换为字符串数组
     */
    ChangeToTable(): string[] {
        return [this.GroupId, this.GroupCode, this.GroupName, this.GroupRemark, this.IssysGroup, this.Pswcycle, this.GroupComment];
    }

    /**
     * 从对象数组中读取数据并赋值给实体属性
     * @param parms - 包含数据的对象数组
     */
    ChangeFromTable(parms: any[]): void {
        this.GroupId = parms[0].toString();
        this.GroupCode = parms[1].toString();
        this.GroupName = parms[2].toString();
        this.GroupRemark = parms[3].toString();
        this.IssysGroup = parms[4].toString();
        this.Pswcycle = parms[5].toString();
        this.GroupComment = parms[6].toString();
    }
}

export { TT_RoleGroup };