// 假设 IEntity 是一个空接口，因为原代码未给出其定义
interface IEntity {}

/**
 * 功能信息
 */
class TT_RuleInfo implements IEntity {
    /**
     * 功能ID
     */
    RuleId: string;

    /**
     * 上级功能ID
     */
    RulePId: string;

    /**
     * 交易(功能)编号
     */
    RuleNo: string;

    /**
     * 功能名称
     */
    RuleName: string;

    /**
     * 功能描述
     */
    RuleRemark: string;

    /**
     * 功能类型号
     */
    RuleTypeCode: string;

    /**
     * 功能类型
     */
    RuleType: string;

    /**
     * 外接系统ID
     */
    ExtId: string;

    /**
     * 备注
     */
    RuleComment: string;

    constructor() {
        this.RuleId = "";
        this.RulePId = "";
        this.RuleNo = "";
        this.RuleName = "";
        this.RuleRemark = "";
        this.RuleTypeCode = "";
        this.RuleType = "";
        this.ExtId = "";
        this.RuleComment = "";
    }

    /**
     * 将对象属性转换为字符串数组
     */
    ChangeToTable(): string[] {
        return [this.RuleId, this.RulePId, this.RuleNo, this.RuleName, this.RuleRemark, this.RuleTypeCode, this.RuleType, this.ExtId, this.RuleComment];
    }

    /**
     * 从对象数组中读取数据并赋值给对象属性
     * @param parms - 包含数据的对象数组
     */
    ChangeFromTable(parms: any[]): void {
        this.RuleId = parms[0].toString();
        this.RulePId = parms[1].toString();
        this.RuleNo = parms[2].toString();
        this.RuleName = parms[3].toString();
        this.RuleRemark = parms[4].toString();
        this.RuleTypeCode = parms[5].toString();
        this.RuleType = parms[6].toString();
        this.ExtId = parms[7].toString();
        this.RuleComment = parms[8].toString();
    }
}

export { TT_RuleInfo };