// 假设 IEntity 是一个空接口，因为原代码未展示其具体内容
interface IEntity {}

/**
 * 系统配置实体
 */
class TT_SysConfig implements IEntity {
    /**
     * 配置ID
     */
    Configid: string;
    /**
     * 配置组
     */
    Configgroup: string;
    /**
     * 配置名称
     */
    Configname: string;
    /**
     * 配置值
     */
    Configvalue: string;
    /**
     * 备注
     */
    Remark: string;

    constructor() {
        this.Configid = "";
        this.Configgroup = "";
        this.Configname = "";
        this.Configvalue = "";
        this.Remark = "";
    }

    /**
     * 将实体属性转换为字符串数组
     * @returns 包含实体属性值的字符串数组
     */
    ChangeToTable(): string[] {
        return [this.Configid, this.Configgroup, this.Configname, this.Configvalue, this.Remark];
    }

    /**
     * 从对象数组中读取数据并设置到实体属性
     * @param parms 对象数组，包含要设置的数据
     */
    ChangeFromTable(parms: any[]): void {
        this.Configid = parms[0].toString();
        this.Configgroup = parms[1].toString();
        this.Configname = parms[2].toString();
        this.Configvalue = parms[3].toString();
        this.Remark = parms[4].toString();
    }
}

export { TT_SysConfig };