// 定义 ImageListItem 接口
export interface ImageListItem {
    /**
     * 图片地址
     */
    imageUrl: string;
    /**
     * 图片顺序号
     */
    imageRemark: string;
}

// 定义 ImageResultListItem 接口
export interface ImageResultListItem {
    /**
     * 图片类型：Trade交易、Teller柜员、Client客户、Voucher凭证、Flaw瑕疵
     */
    imageRemark: string;
    /**
     * 图片列表（同一类型）
     */
    imageList: ImageListItem[];
}

// 定义 AuthHistoryInfoResult 接口
export interface AuthHistoryInfoResult {
    /**
     * 交易编号
     */
    tradeId: string;
    /**
     * 授权记录编号
     */
    recordCode: string;
    /**
     * 授权申请时间
     */
    recordApplyTime: string;
    /**
     * 申请用户编号
     */
    applyUserCode: string;
    /**
     * 申请用户姓名
     */
    applyUserName: string;
    /**
     * 申请机构编号
     */
    applyBranchCode: string;
    /**
     * 申请机构名称
     */
    applyBranchName: string;
    /**
     * 授权级别
     */
    applyLevel: string;
    /**
     * 授权名称
     */
    baseName: string;
    /**
     * 菜单编号
     */
    menuCode: string;
    /**
     * 详情描述
     */
    baseRemark: string;
    /**
     * 授权要素列表
     */
    elementList: string[];
    /**
     * 图片列表（只有url）
     */
    imageUrlList: string[];
    /**
     * 授权图片列表
     */
    imageResultList: ImageResultListItem[];
    /**
     * 是否通过
     */
    isPass: string;
    /**
     * 通过原因
     */
    reason: string;
}