// 定义泛型类 Result，与 C# 中的类结构对应
class Result<T> {
    // 错误码，类型为 number
    errcode: number;
    // 错误信息，类型为 string
    errmsg: string;
    // 数据，类型为泛型 T
    data: T;

    // 构造函数，用于初始化类的属性
    constructor(errcode: number, errmsg: string, data: T) {
        this.errcode = errcode;
        this.errmsg = errmsg;
        this.data = data;
    }
}

// 导出 Result 类，方便其他文件使用
export { Result };