// 定义 CommonParames 命名空间，用于存储平台运行参数
namespace Platform.Common.RunningParameters {
    // 定义 CommonParames 类，用于存储各种参数
    export class CommonParames {
        // 字符编码
        public static Coding: string = "gb2312";
        // 交易日志配置节点名称
        public static readonly TradeLog: string = "TradeLogger";
        // 错误日志配置节点名称
        public static readonly ErrLog: string = "ErrLogger";
        // 系统名称
        public static SysName: string = "东华商业银行核心业务系统";
        // 更新程序名
        public static readonly UpdateAppName: string = "TellerSys.Update.exe";
        // 更新进程名
        public static readonly UpdateProcName: string = "TellerSys.Update";
        // 客户端程序名
        public static readonly ClientAppName: string = "TellerSys.Client.exe";
        // 客户端进程名
        public static readonly ClientProcName: string = "TellerSys.Client";
        // 主程序目录
        public static MainDir: string = "TradeDll/";
        // 服务端---交易Dll文件存放目录
        public static TradeInfoPath: string = "pages";
        // 服务端---客户端更新文件所在路径
        public static UpdatedClientPath: string = "updatedfile";
        // 服务端---配置文件所在目录
        public static ConfigFilePath: string = "serverconfig";
        // 帮助文件目录
        public static TellerSysHelp: string = "TellerSysHelp";
        // 服务端---临时文件所在目录
        public static TempFilePath: string = "tmp";
        // 与核心通讯方法名
        public static CallServerName: string = "callserver";
        // 与支付平台通讯方法名
        public static CallAgnName: string = "callserver";
        // 与财税库银通讯方法名
        public static CallTipsName: string = "callserver";
        // 菜单配置文件名称
        public static MenuFileName: string = "Menu.xml";
        // 任务菜单配置文件名称
        public static TaskMenuFileName: string = "TaskMenu.xml";
        // 服务器端存放交易文件附件的默认路径
        public static TradeFilePath: string = "tmp";
        // 错误码/错误信息映射关系Map
        public static MsgErrorMap: { [key: string]: string } = {};
        // 登录界面标题
        public static LoginTitle: string = "商业银行核心业务系统登录界面";
        // 系统采用的默认字体，用于交易和打印项的设计时与运行时呈现
        public static DefaultFontFamily: string = "Microsoft YaHei";
        // 系统采用的默认字体大小，用于交易和打印项的设计时与运行时呈现
        public static DefaultFontSize: number = 14;
        // 系统设计和打印表单采用的字体
        public static DefaultPrintFontFamily: string = "宋体";
        // 系统设计和打印表单采用的字体大小
        public static DefaultPrintFontSize: number = 12;
    }
}

// 导出 CommonParames 类，方便在其他地方使用
export default Platform.Common.RunningParameters.CommonParames;