// 定义命令类型
type Command = {
  name: string;
  displayText: string;
  execute: () => void;
};

// 定义 CaptureImageCommands 类
export class CaptureImageCommands {
  static CaptureImage: Command = {
    name: "CaptureImage",
    displayText: "Capture image",
    execute: () => {
      // 这里可以实现捕获图像的具体逻辑
      console.log("Capturing image...");
    },
  };

  static RemoveImage: Command = {
    name: "RemoveImage",
    displayText: "Remove image",
    execute: () => {
      // 这里可以实现移除图像的具体逻辑
      console.log("Removing image...");
    },
  };

  static ClearAllImages: Command = {
    name: "ClearAllImages",
    displayText: "Clear all images",
    execute: () => {
      // 这里可以实现清除所有图像的具体逻辑
      console.log("Clearing all images...");
    },
  };

  static ClickImage: Command = {
    name: "ClickImage",
    displayText: "Click Image",
    execute: () => {
      // 这里可以实现点击图像的具体逻辑
      console.log("Clicking image...");
    },
  };
}