// 定义 TextAlignment 枚举
enum TextAlignment {
    Left = 'left',
    Right = 'right',
    Center = 'center'
}

namespace Platform.Controls.TableContainer {
    export class TreeViewListColumn {
        // 列宽度
        public Width: number;
        // 列标题
        public Header: string;
        // 绑定的属性名
        public BindPropertyName: string;
        // 文本对齐方式
        public TextAlignment: TextAlignment;

        constructor();
        constructor(header: string, bindPropertyName: string, width?: number, textAlignment?: TextAlignment);
        constructor(header?: string, bindPropertyName?: string, width: number = 100, textAlignment: TextAlignment = TextAlignment.Left) {
            if (header && bindPropertyName) {
                this.Header = header;
                this.BindPropertyName = bindPropertyName;
                this.Width = width;
                this.TextAlignment = textAlignment;
            }
        }
    }
}