// 定义 Disposable 接口，模拟 C# 的 IDisposable
// interface Disposable {
//     dispose(): void;hulei-swindows系统的东西
// }

import { PageContainer } from "../PageFunctions/PageContainer";

// // 假设 PageContainer 类型定义
// class PageContainer { }

// 定义 IPage 接口
export interface IPage extends Disposable {
    GetTradeInfoData(): unknown;
    /**
     * 实例化ID
     */
    readonly InstanceId: string;
    /**
     * 设置ID
     * @param guid 要设置的实例化 ID
     */
    SetInstanceId(guid: string): void;
    /**
     * 视图状态数据集合
     */
    readonly ViewStateData: { [key: string]: any };
    /**
     * 设置视图状态数据集合
     * @param viewStateData 要设置的视图状态数据集合
     */
    SetViewStateData(viewStateData: { [key: string]: any }): void;
    /**
     * 交易父容器
     */
    readonly OwnerContainer: PageContainer;
    /**
     * 设置交易父容器
     * @param pageContainer 要设置的交易父容器
     */
    SetOwnerContainer(pageContainer: PageContainer): void;
    /**
     * 释放资源
     */
    dispose(): void;
}
