import TradeModel from "../../common/BasicFunctions/PageFunctions/TradeModel";
import { IPage } from "../Interfaces/Ipage";
import { PageContainerHelper } from "../PagesHelper/PageContainerHelper";
import { PageHelper } from "../PagesHelper/PageHelper";
import { PageContainer } from "./PageContainer";



class TradePage implements IPage {
    // private _ready: EventHandler | null = null;
    // private _propertyChanged: PropertyChangedEventHandler | null = null;//hulei-s 微软自带

    constructor() {
        // 模拟加载事件
        this.triggerLoad();
    }
    GetTradeInfoData(): unknown {
        throw new Error("Method not implemented.");
    }
    dispose(): void {
        throw new Error("Method not implemented.");
    }
    [Symbol.dispose](): void {
        throw new Error("Method not implemented.");
    }

    get TradeModel(): TradeModel {
        return PageHelper.GetTradeModel(this);
    }

    set TradeModel(value: TradeModel) {
        PageHelper.SetTradeModel(this, value);
    }

    get Ready() {
        return {
            add: (handler: EventHandler) => {
                this._ready = handler;
            },
            remove: (handler: EventHandler) => {
                if (this._ready === handler) {
                    this._ready = null;
                }
            },
        };
    }

    private triggerLoad() {
        PageHelper.SetOwnerPage(this, this);
        if (this._ready) {
            this._ready(this, {});
        }
        this.onTradePageLoaded();
    }

    protected onTradePageLoaded() { }

    Dispose() { }

    get OwnerContainer(): PageContainer {
        return PageContainerHelper.GetOwnerContainer(this);
    }

    SetOwnerContainer(pageContainer: PageContainer) {
        PageContainerHelper.SetOwnerContainer(this, pageContainer);
    }

    get InstanceId(): string {
        return PageContainerHelper.GetInstanceId(this);
    }

    SetInstanceId(guid: string) {
        PageContainerHelper.SetInstanceId(this, guid);
    }

    get ViewStateData(): { [key: string]: any } {
        return PageHelper.GetViewStateData(this);
    }

    SetViewStateData(viewStateData: { [key: string]: any }) {
        if (!viewStateData) {
            viewStateData = {};
        }
        PageHelper.SetViewStateData(this, viewStateData);
    }

    get PropertyChanged() {
        return {
            add: (handler: PropertyChangedEventHandler) => {
                this._propertyChanged = handler;
            },
            remove: () => {
                if (this._propertyChanged === handler) {
                    this._propertyChanged = null;
                }
            },
        };
    }

    protected raisePropertyChanged(propertyName: string) {
        if (this._propertyChanged) {
            this._propertyChanged(this, { propertyName });
        }
    }
}

export default TradePage;
