export interface ProcessInfo {
    /**
     * 流程实例的唯一标识符
     */
    ProcessInstanceId: string;
    /**
     * 流水号
     */
    SerialNo: string;
    /**
     * 流程的创建时间
     */
    StartTime: string;
    /**
     * 流程的结束时间
     */
    EndTime: string;
    /**
     * 当前流程节点的相关信息
     */
    ActivitiInfo: string;
    /**
     * 表示流程的状态，0 代表未结束，1 代表已结束
     */
    IsActive: string;
    /**
     * 负责办理该流程的柜员
     */
    Assignee: string;
    /**
     * 流程结束的原因
     */
    EndReason: string;
    /**
     * 发起该流程的交易号
     */
    TradeNo: string;
}