/**
 * 交易信息类，用于存储交易相关的信息。
 */
export class TradeInfo {
    /**
     * 交易号
     */
    public TxCode: string;
    /**
     * 操作员
     */
    public Tel: string;
    /**
     * 交易机构
     */
    public TxBrNo: string;
    /**
     * 授权要素信息
     */
    public AuthElement: string;
    /**
     * 方法序号
     */
    public FuncNum: string;

    /**
     * 构造函数，用于初始化交易信息对象。
     * @param txCode 交易号
     * @param tel 操作员
     * @param txBrNo 交易机构
     * @param authElement 授权要素信息
     * @param funcNum 方法序号
     */
    constructor(txCode: string, tel: string, txBrNo: string, authElement: string, funcNum: string) {
        this.TxCode = txCode;
        this.Tel = tel;
        this.TxBrNo = txBrNo;
        this.AuthElement = authElement;
        this.FuncNum = funcNum;
    }
}