// 假设 AttachFile 类的定义如下，实际使用时需要根据具体情况修改
// class AttachFile {
//     // 这里可以添加 AttachFile 类的具体属性和方法
// }

export default class TransitEntity {
    // 服务方法名
    public FuncName: string;
    // 服务类名
    public ServiceName: string;
    // 方法参数(以Dictionary方式，key为参数在方法中的位置，value为参数值)
    public Parameters: { [key: string]: string };
    // 附件列表，特殊结构(转换成table结构)与大数据byte[]参数做为附件传递
    public AttachFiles: AttachFile[];
    // 超时设置，单位ms
    public Timeout?: number;

    constructor() {
        this.Parameters = {};
        this.AttachFiles = [];
    }
}
